! Copyright (C) GemTalk Systems 1986-2021.  All Rights Reserved.
! Class Declarations
! Generated file, do not Edit

doit
(AbstractCollisionBucket
	_newKernelSubclass:'CanonStringBucket'
	instVarNames: #( keyValueDictionary )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #'disallowGciStore'  #logCreation )
	reservedOop: 119041
)
		category: nil;
		comment: 'A CanonStringBucket is an Array that is used in a 
 CanonSymbolsDictionary .  It contains keys which have the same String
 hash value , and is sorted by value comparision of the keys.
 The comparision is done using binary comparison of the bytes of the keys.
 The hash value must be computed by using CanonStringDict >> hashFunction:
';
		immediateInvariant.
true.
%

removeallmethods CanonStringBucket
removeallclassmethods CanonStringBucket

doit
(AbstractDictionary
	_newKernelSubclass:'CanonStringDict'
	instVarNames: #( numElements tableSize )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
	reservedOop: 119297
)
		category: nil;
		comment: 'A CanonStringDict is a dictionary that provides
 protocol that is similar to Set in addition to its dictionary protocol.
 It uses sorted collision buckets, and stores only keys. Each slot in
 the dictionary object contains a references to a bucket, or nil  

Constraints:
	numElements: SmallInteger
	tableSize: SmallInteger
	[elements]: CanonStringBucket';
		immediateInvariant.
true.
%

removeallmethods CanonStringDict
removeallclassmethods CanonStringDict

doit
(CanonStringDict
	_newKernelSubclass:'CanonSymbolDict'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
	reservedOop: 119553
)
		category: nil;
		comment: 'CanonicalSymbolDict is the class of AllSymbols. Instances may
 only be modified by SystemUser, or the SymbolCreation session.

Constraints:
	numElements: SmallInteger
	tableSize: SmallInteger';
		immediateInvariant.
true.
%

removeallmethods CanonSymbolDict
removeallclassmethods CanonSymbolDict

doit
(AbstractExternalSession
	subclass: 'GsExternalSession'
	instVarNames: #( parameters gciSessionId stoneSessionId stoneSessionSerial gemProcessId gciErrSType nbResult logger )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'External Sessions';
		comment: 'GsExternalSession is a legacy implementation of AbstractExternalSession
that loads $GEMSTONE/lib/librpc*.so  and uses FFI to call Gci functions in
that libgcirpc library.

New code should use GsTsExternalSession.

GsExternalSession is not green-thread-safe, so use of more than one instance 
of GsExternalSession in a session with multiple GsProcesses active can be 
unreliable.

GsExternalSession is not supported on AIX; on AIX, use GsLegacyExternalSession.

Example:

| sess |
sess := GsExternalSession
	gemNRS: GsNetworkResourceString defaultGemNRSFromCurrent
	stoneNRS: GsNetworkResourceString defaultStoneNRSFromCurrent
	username: ''DataCurator''
	password: ''swordfish''.
sess login.
sess executeString: ''System stoneName''.
sess executeBlock: [2 + 5].
sess logout.';
		immediateInvariant.
true.
%

removeallmethods GsExternalSession
removeallclassmethods GsExternalSession

doit
(GsExternalSession
	subclass: 'GsLegacyExternalSession'
	instVarNames: #( gciInterface traversalBuffer )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'External Sessions';
		comment: 'GsLegacyExternalSession is a variant of GsExternalSession which is used in
environments where the FFI GciLibrary cannot be used. It uses the GCI Interface
which is based on system primitives rather than FFI calls.

At this time, AIX is the only known environment where this class must be used.
';
		immediateInvariant.
true.
%

removeallmethods GsLegacyExternalSession
removeallclassmethods GsLegacyExternalSession

doit
(GsExternalSession
	subclass: 'GsX509ExternalSession'
	instVarNames: #( username )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'X509';
		comment: 'GsX509ExternalSession is a variant of GsExternalSession which uses an X509 certificate as
login credentials rather than a user id and password.

Example:

| p s |
p := GemStoneX509Parameters
      newFromPemFilesWithNetldiPort: ''54321''
      netldiHost: ''localhost''
      certificate: ''DataCurator.chain.pem''
      caCertificate: ''stoneCA-gs64stone.cert.pem''
      privateKey: ''DataCurator.privkey.pem'' .
s := GsX509ExternalSession newWithX509Parameters: p.
s login .

';
		immediateInvariant.
true.
%

removeallmethods GsX509ExternalSession
removeallclassmethods GsX509ExternalSession

doit
(Array
	_newKernelSubclass:'ErrorDescription'
	instVarNames: #( categoryOop number contextOop message fatal gciInterface )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
	reservedOop: 117761
)
		category: nil;
		comment: 'ErrorDescription is used by the class GciInterface. 
Instances describe errors returned from a remote VM.

Constraints:
	categoryOop: Integer
	number: Integer
	contextOop: Object
	message: String
	fatal: Boolean
	gciInterface: Object';
		immediateInvariant.
true.
%

removeallmethods ErrorDescription
removeallclassmethods ErrorDescription

doit
(Array
	subclass: 'GsX509CertificateChain'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'X509';
		comment: 'GsX509CertificateChain encapsulates a TLS/SSL certificate chain. ';
		immediateInvariant.
true.
%

removeallmethods GsX509CertificateChain
removeallclassmethods GsX509CertificateChain

doit
(Array
	_newKernelSubclass:'MappingInfo'
	instVarNames: #( object pathTerm dependencyList ivOffset )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
	reservedOop: 90113
)
		category: nil;
		comment: 'The class MappingInfo implements GemStone internals. It is not intended for 
customer use, by creating instances or by subclassing.

Constraints:
	object: Object
	pathTerm: PathTerm
	dependencyList: DependencyList
	ivOffset: Integer';
		immediateInvariant.
true.
%

removeallmethods MappingInfo
removeallclassmethods MappingInfo

doit
(Array
	subclass: 'NonPersistentArray'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #'instancesNonPersistent'  #logCreation )
)
		category: nil;
		comment: 'NonPersistentArray is a kind of Array with the instancesNonPersistent option. ';
		immediateInvariant.
true.
%

removeallmethods NonPersistentArray
removeallclassmethods NonPersistentArray

doit
(BtreeLeafNode
	subclass: 'SortBlockNode'
	instVarNames: #( blockSorter totalElements )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'SortBlockNode is a concrete class that along with the class BlockSorter implements the 
 behavior used to sort collections efficiently. It is an interface to an algorithm based 
 on an efficient merge-sort.

Constraints:
	numElements: SmallInteger
	blockSorter: Object
	totalElements: Object';
		immediateInvariant.
true.
%

removeallmethods SortBlockNode
removeallclassmethods SortBlockNode

doit
(SortBlockNode
	subclass: 'SortBlockUnicodeNode'
	instVarNames: #( collator )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'SortBlockUnicodeNode is a concrete class that along with the class BlockSorter implements the 
 behavior used to sort collections efficiently. It is an interface to an algorithm based 
 on an efficient merge-sort.

Constraints:
	numElements: SmallInteger
	blockSorter: Object
	totalElements: Object';
		immediateInvariant.
true.
%

removeallmethods SortBlockUnicodeNode
removeallclassmethods SortBlockUnicodeNode

doit
(CollisionBucket
	_newKernelSubclass:'SoftCollisionBucket'
	instVarNames: #( lastCleanupCount )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #'disallowGciStore' #'instancesNonPersistent'  #logCreation )
	reservedOop: 120833
)
		category: nil;
		comment: 'A SoftCollisionBucket is a CollisionBucket intended to
 store key/SoftReference pairs .
 key/SoftReference pairs whose SoftReferences have been cleared by 
 the in-memory garbage collector will be removed from a SoftCollisionBucket 
 during the next at:put: operation following a garbage collection which cleared
 the references.  
 
 Cleared SoftReferences will also be removed when their key matches
 the argument key for a lookup operation .  The lookup code will
 not remove cleared SoftReferences for non-matching keys.

 Instances of SoftCollisionBucket are non-persistent and may
 not be committed to the repository.

Constraints:
	numElements: SmallInteger
	keyValueDictionary: Object
	lastCleanupCount: SmallInteger

lastCleanupCount is private to the implementation of SoftCollisionBucket, 
 used to manage removal of SoftReferences.';
		immediateInvariant.
true.
%

removeallmethods SoftCollisionBucket
removeallclassmethods SoftCollisionBucket

doit
(Error
	subclass: 'ChildError'
	instVarNames: #( status stderr )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: ' ChildError is used by GsHostProcess when the child process returns a non-zero
 exit status.';
		immediateInvariant.
true.
%

removeallmethods ChildError
removeallclassmethods ChildError

doit
(Error
	subclass: 'GciError'
	instVarNames: #( gciErrSType externalSession originalNumber )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'External Sessions';
		comment: 'This class is part of the External Sessions implementation and 
represents an execution Error from the GCI interface to the external session.

Constraints:
	gsResumable: Boolean
	gsTrappable: Object
	gsNumber: SmallInteger
	currGsHandler: GsExceptionHandler
	gsStack: Object
	gsReason: String
	gsDetails: Object
	tag: Object
	messageText: Object
	gsArgs: Object
	gciErrSType: Object
	externalSession: Object
	originalNumber: Object
';
		immediateInvariant.
true.
%

removeallmethods GciError
removeallclassmethods GciError

doit
(Error
	subclass: 'GciLegacyError'
	instVarNames: #( errorDescription externalSession originalNumber )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'External Sessions';
		comment: 'This class is part of the External Sessions implementation and represents
an execution Error from the GCI interface to the legacy external session.

Constraints:
	gsResumable: Boolean
	gsTrappable: Object
	gsNumber: SmallInteger
	currGsHandler: GsExceptionHandler
	gsStack: Object
	gsReason: String
	gsDetails: Object
	tag: Object
	messageText: Object
	gsArgs: Object
	errorDescription: Object
	externalSession: Object
	originalNumber: Object
';
		immediateInvariant.
true.
%

removeallmethods GciLegacyError
removeallclassmethods GciLegacyError

doit
(GsSignalingSocket
	_newKernelSubclass:'GsSecureSocket'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
	reservedOop: 248833
)
		category: nil;
		comment: 'GsSecureSocket provides the means for creating and binding TLS TCP sockets
 through the operating system of the machine that is running the session''s Gem process, and
 for communicating across those sockets.  Methods that block GemStone Smalltalk
 until the socket operation completes are interruptable by a hard break.  (You
 can get a hard break in Topaz by pressing the control-C key twice.  You can get
 a hard break in GemBuilder for C by calling the GciHardBreak function, and in
 GemBuilder for Smalltalk by calling the corresponding hard break method.)

 Like instances of GsSocket, instances of GsSecureSocket automatically have
 their C state closed when the instance is garbage collected or 
 when a persistent instance drops out of memory.

 SSLv2 and SSLv3 connections are not supported because such connections are known to 
 be insecure. Only and TLSv1.x connections are currently supported.

 To create a secure connection, a regular socket connection must first be established.
 Use the methods inherited from GsSocket to establish a socket connection.

                              Warning:
    Do not retain an instance of GsSecureSocket from one session to another.
    Instances of GsSecureSocket are intended to exist only within a given GemStone
    session.  GsSecureSockets that are used across sessions always generate an error.

 All instVars of GsSecureSocket are private, for use by the implementation
 of socket methods, and for use by the ProcessorScheduler only.

Constraints:
	fileDescriptor: SmallInteger
	lineNumber: SmallInteger
	readWaiters: Object
	writeWaiters: Object
	readyEvents: SmallInteger
	pollArrayOfs: SmallInteger
	selectWaiters: Object';
		immediateInvariant.
true.
%

removeallmethods GsSecureSocket
removeallclassmethods GsSecureSocket

doit
(IdentityCollisionBucket
	_newKernelSubclass:'IdentitySoftCollisionBucket'
	instVarNames: #( lastCleanupCount )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #'disallowGciStore' #'instancesNonPersistent'  #logCreation )
	reservedOop: 121089
)
		category: nil;
		comment: 'A IdentitySoftCollisionBucket is an IdentityCollisionBucket intended to
 store key/SoftReference pairs .
 key/SoftReference pairs whose SoftReferences have been cleared by 
 the in-memory garbage collector will be removed from a 
 IdentitySoftCollisionBucket during the next at:put: operation 
 following a garbage collection which cleared the references.  
 
 Cleared SoftReferences will also be removed when their key matches
 the argument key for a lookup operation .  The lookup code will
 not remove cleared SoftReferences for non-matching keys.

 Instances of IdentitySoftCollisionBucket are non-persistent and may
 not be committed to the repository.

Constraints:
	numElements: SmallInteger
	keyValueDictionary: Object
	lastCleanupCount: SmallInteger

instVar lastCleanupCount -- Private to the implementation of IdentitySoftCollisionBucket, used to manage
 removal of SoftReferences.';
		immediateInvariant.
true.
%

removeallmethods IdentitySoftCollisionBucket
removeallclassmethods IdentitySoftCollisionBucket

doit
(IdentitySet
	_newKernelSubclass:'UserProfileGroup'
	instVarNames: #( groupName )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
	reservedOop: 157441
)
		category: nil;
		comment: 'This class is the logical representation of a group of UserProfiles.
 It contains the following instance variable:
   groupName         - A symbol representing the name of the group.
';
		immediateInvariant.
true.
%

removeallmethods UserProfileGroup
removeallclassmethods UserProfileGroup

doit
(KeyValueDictionary
	_newKernelSubclass:'KeySoftValueDictionary'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #'instancesNonPersistent'  #logCreation )
	reservedOop: 120321
)
		category: nil;
		comment: 'KeySoftValueDictionary is a subclass of KeyValueDictionary.
 Instances of KeySoftValueDictionary are non-persistent and may not be
 committed ot the repository.

 All values in KeySoftValueDictionary are instances of SoftReference .

 Various instance methods in KeySoftValueDictionary will automatically
 remove from a KeySoftValueDictionary any SoftReferences whose value
 instVar has been cleared by the in-memory garbage collector.

 See comments on GC behavior in $GEMSTONE/bin/initial.config under
 GEM_SOFTREF_CLEANUP_PERCENT_MEM and GEM_KEEP_MIN_SOFTREFS. 

Constraints:
	numElements: SmallInteger
	numCollisions: SmallInteger
	collisionLimit: SmallInteger
	tableSize: SmallInteger';
		immediateInvariant.
true.
%

removeallmethods KeySoftValueDictionary
removeallclassmethods KeySoftValueDictionary

doit
(KeySoftValueDictionary
	_newKernelSubclass:'IdentityKeySoftValueDictionary'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
	reservedOop: 120577
)
		category: nil;
		comment: 'IdentityKeySoftValueDictionary is a subclass of KeySoftValueDictionary
 which uses identity comparision on keys.

Constraints:
	numElements: SmallInteger
	numCollisions: SmallInteger
	collisionLimit: SmallInteger
	tableSize: SmallInteger';
		immediateInvariant.
true.
%

removeallmethods IdentityKeySoftValueDictionary
removeallclassmethods IdentityKeySoftValueDictionary

doit
(Magnitude
	subclass: 'DateAndTimeANSI'
	instVarNames: #( seconds offset )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #'selfCanBeSpecial'  #logCreation )
)
		category: nil;
		comment: 'This protocol describes the behavior that is common to date
time objects. Date time objects represent individual points
in Coordinated Universal Time (UTC) as represented in an
implementation defined local time, with a default resolution
of seconds.

The exact properties of local times are unspecified. Local
times may differ in their offset from UTC. A given local time
may have different offsets from UTC at different points in time.

All dates and times in the UTC local time are in the Gregorian
calendar. Date times prior to the adoption of the Gregorian
calendar are given in the retrospective astronomical Gregorian
calendar. The year 1 B.C. is astronomical Gregorian year 0.
The year 2 B.C. is astronomical Gregorian year-1. The year 1 A.D.
is astronomical Gregorian year 1. The offset of the UTC local
time is zero.';
		immediateInvariant.
true.
%

doit
(DateAndTimeANSI
	subclass: 'DateAndTime'
	instVarNames: #(  )
	classVars: #( DefaultScale )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #'selfCanBeSpecial'  #logCreation )
)
		category: nil;
		comment: 'DateAndTime is a GemStone specific implementation of the
DateAndTimeANSI standard. 

DateAndTime objects represent individual points in Coordinated 
Universal Time (UTC) as represented in local time with an offset. 
The offset of the UTC local time is zero.  

The default resolution for DateAndTime instances is microseconds. 
The class variable DefaultScale is no longer used.

DateAndTimes are in the Gregorian calendar. (the common calendar
adpoted in Europe in 1582). Date times prior to the adoption of this 
calendar are given in the retrospective astronomical Gregorian
calendar. The year 1 B.C. is astronomical Gregorian year 0.
The year 2 B.C. is astronomical Gregorian year -1. The year 1 A.D.
is astronomical Gregorian year 1.';
		immediateInvariant.
true.
%

doit
(Object
	_newKernelSubclass:'CBuffer'
	instVarNames: #( offset )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #'disallowGciStore'  #logCreation )
	reservedOop: 118017
)
		category: nil;
		comment: 'CBuffer represents a an instance of some C or C++ type allocated in C heap
 memory.

Constraints:
	offset: SmallInteger';
		immediateInvariant.
true.
%

removeallmethods CBuffer
removeallclassmethods CBuffer

doit
(CBuffer
	subclass: 'TraversalBuffer'
	instVarNames: #( travResultOop resultIsSpecial clampOop retrievalFlags level )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #'noInheritOptions'  #logCreation )
)
		category: nil;
		comment: 'TraversalBuffer represents an instance of the C type GciTravBufType, which is
 defined in $GEMSTONE/include/gcicmn.ht .  Various traversal functions defined
 in $GEMSTONE/include/gci.hf  take a pointer to a GciTravBufType as an argument.

Constraints:
	offset: SmallInteger
	travResultOop: Object
	resultIsSpecial: Object
	clampOop: Object
	retrievalFlags: Object
	level: Object';
		immediateInvariant.
true.
%

removeallmethods TraversalBuffer
removeallclassmethods TraversalBuffer

doit
(Object
	subclass: 'CDeclaration'
	instVarNames: #( header name storage linkageSpec type count pointer fields parameters enumTag isConstant includesCode isVaryingArgCount bitCount source file line )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'FFI';
		comment: 'This class is internal to the FFI implementation and 
represents a declaration from a C header file.';
		immediateInvariant.
true.
%

removeallmethods CDeclaration
removeallclassmethods CDeclaration

doit
(Object
	subclass: 'CHeader'
	instVarNames: #( stream types structs unions functions enums enumTags storage declarations preprocessor source )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'FFI';
		comment: 'This class is part of the FFI implementation and represents a C header file. 
It is typically used to generate a Smalltalk class that wraps a function or structure.
Usage examples can be found in the following instance methods:
	#wrapperForLibraryAt:
	#wrapperNamed:forLibraryAt:select:
	#wrapperForTypeNamed:
	#wrapperNamed:forStruct:
';
		immediateInvariant.
true.
%

removeallmethods CHeader
removeallclassmethods CHeader

doit
(Object
	_newKernelSubclass:'ClampSpecification'
	instVarNames: #( idClamps classClamps instVarLevels addSubleafHeaders instVarLevelsSelector traversalCallBackSelector valueClamps environmentId )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
	reservedOop: 135681
)
		category: nil;
		comment: 'A ClampSpecification represents a set of clamps to be applied to operations
 that traverse object structures.  ClampSpecification objects are required
 during clamped object traversal.

Constraints:
	idClamps: IdentitySet
	classClamps: ClassSet
	instVarLevels: FastIdentityKeyValueDictionary
	addSubleafHeaders: Boolean
	instVarLevelsSelector: Symbol 
	traversalCallBackSelector: Symbol
	valueClamps: IdentitySet
	environmentId: SmallInteger

--- instVar addSubleafHeaders
A Boolean that denotes whether or not subleaf headers should be collected
 in the traversal.  If true, then the object report header of objects that
 are one level below the cut off line will be put in the traversal buffer.

--- instVar classClamps
A ClassSet of class objects whose instances are to be clamped during object
 traversal.  Such instances will have header-only reports in the traversal
result. 

--- instVar environmentId
environmentId specifies the environment for message sends of the
traversalCallBackSelector and instVarLevelsSelector.  Default environment
is zero .  If non-nil this environmentId must be a SmallInteger.

--- instVar idClamps
An IdentitySet of objects to be clamped by identity (OOP).

--- instVar instVarLevels
A FastIdentityKeyValueDictionary whose keys are Classes. The value for a
 given key may be an Array of SmallInteger, false, or nil.  
 A value of nil is equivalent to the key not being present. (new
 semantics in Gs64 v3.2.2).
 A value of false is equivalent to the key being in the classClamps set (new
 semantics in Gs64 v3.2.2).
 The Array value for a given key has an element
 for every named instance variable of that class and has one additional element
 for any unnamed instance variables.  The value of each Array element is nil if
 the variable for that element does not have an instance variable level.  
 Otherwise, it is a SmallInteger or false.  If it is a SmallInteger, then its 
 absolute value is the number of instance variable levels.  If the SmallInteger
 is negative, it represents a min operation; if it is positive, it represents a
 max operation.  The SmallInteger zero represents a max operation; there is no
 representation for a min operation of zero.  If it is false then this is like
 max 0 with the exception that a subleaf header will not be included.

--- instVar instVarLevelsSelector
A Symbol or nil.  If non-nil, a zero argument selector that is sent to the object
 if the class of the object is not found in the instVarLevels dictionary.
 Result of that message send must conform to the values expected to be
 in the instVarLevels dictionary.  (New semantics as of Gs64 v3.2.1).

--- instVar traversalCallBackSelector
A Symbol or nil.  If non-nil, a zero argument selector that is used to place 
alternative value buffer contents
for objects whose format indicates that they should use the callback.
This selector is used in conjunction with environmentId.

--- instVar valueClamps
An IdentitySet that contains objects that have been value-clamped during
traversal calls.
';
		immediateInvariant.
true.
%

removeallmethods ClampSpecification
removeallclassmethods ClampSpecification

doit
(Object
	subclass: 'CPreprocessor'
	instVarNames: #( definitions header line path readStream searchPaths tokens tmpFnames cppArchMType systemSearchPaths )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'FFI';
		comment: 'This class is internal to the FFI implementation and 
implements a preprocessor for a C header file.';
		immediateInvariant.
true.
%

removeallmethods CPreprocessor
removeallclassmethods CPreprocessor

doit
(Object
	subclass: 'CPreprocessorToken'
	instVarNames: #( file line source type value peek cppMType startCommentOffset startOffset endOffset debugBytes stream )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'FFI';
		comment: 'This class is internal to the FFI implementation and 
represents a preprocessor token from a C header file.
The instVars startCommentOffset,startOffset,endOffset,stream
are for debugging the CPreprocessor .
Note also CPreprocessorToken >> _filePosition .';
		immediateInvariant.
true.
%

removeallmethods CPreprocessorToken
removeallclassmethods CPreprocessorToken

doit
(Object
	_newKernelSubclass:'CriticalSection'
	instVarNames: #( owner semaphore )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
	reservedOop: 117249
)
		category: nil;
		comment: 'CriticalSection is a class from the Blue Book API that
provides one way of using semaphores.

Constraints:
	owner: GsProcess
	semaphore: Semaphore';
		immediateInvariant.
true.
%

removeallmethods CriticalSection
removeallclassmethods CriticalSection

doit
(Object
	subclass: 'DeletedUserProfile'
	instVarNames: #( userId symbolList whenDeleted )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'DeletedUserProfile holds the key information about a UserProfile that was deleted from AllUsers.  
An instance is created and added to AllDeletedUsers when methods such as UserProfileSet>>removeAndCleanup:, 
removeAndCleanupUserWithId:ifAbsent:, etc., are executed.

A DeletedUserProfile refers to the SymbolList of the deleted user, since that is needed to reach data that 
was referred to by the deleted user.  After a UserProfile is removed, the DeletedUserProfile should be examined
for references to data that may need to be cleaned up so they can be garbage collected.';
		immediateInvariant.
true.
%

removeallmethods DeletedUserProfile
removeallclassmethods DeletedUserProfile

doit
(Object
	_newKernelSubclass:'GciInterface'
	instVarNames: #( sessionId lastResult resultIsSpecial lastError trace log errorClass )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #'instancesNonPersistent'  #logCreation )
	reservedOop: 118273
)
		category: nil;
		comment: 'GciInterface is obsolete. 
New code should use GsExternalSession or GciTsExternalSession .

GciInterface is a Smalltalk representation for the functions defined
in $GEMSTONE/include/gci.hf .  Using GciInteface a session may
execute GCI functions in another session. 

The other session may be on the same repository or a 
different repository.  The other session is only valid
within the session which created the instance of GciInterface,
and while that instance remains in memory.

Beginning with Gs64 v3.0, instances of GciInterface automatically have
their other session closed when the instance is garbage collected or
when a persistent instance drops out of memory.

The lastResult instVar contains the result of the most recent 
message send or execution, and is set by a various primitives
and is cleared (i.e. set to _remoteNil) by logout and by errors.
The resultIsSpecial instVars is set by the same code which 
sets lastResult .

Operations other than message send or execute return the
receiver if successful, or nil if there was an error.

Constraints:
	sessionId: SmallInteger
	lastResult: Object
	resultIsSpecial: Boolean
	lastError: ErrorDescription
	trace: Boolean
	log: GsFile
	errorClass: Behavior
';
		immediateInvariant.
true.
%

removeallmethods GciInterface
removeallclassmethods GciInterface

doit
(Object
	_newKernelSubclass:'GemStoneParameters'
	instVarNames: #( gemStoneName username password hostUsername hostPassword gemService )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
	reservedOop: 117505
)
		category: nil;
		comment: 'GemStoneParameters is used by the class GciInterface.
Instances are used as arguments to the login methods in
GciInterface.

Constraints:
	gemStoneName: String
	username: String
	password: String
	hostUsername: String
	hostPassword: String
	gemService: String';
		immediateInvariant.
true.
%

removeallmethods GemStoneParameters
removeallclassmethods GemStoneParameters

doit
(Object
	_newKernelSubclass:'GemStoneX509Parameters'
	instVarNames: #( netldiPort netldiHost certificate caCertificate privateKey loginFlags extraGemArgs dirArg logArg )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #'instancesNonPersistent'  #logCreation )
	reservedOop: 250113
)
		category: 'X509';
		comment: 'GemStoneX509Parameters is used by the class GsX509ExternalSession.
Instances are used as arguments to the login methods in class
GsX509ExternalSession. Instnaces of this class contain transient
state and may not be committed to the database.

Instance variables:

netldiPort    - SmallInteger or String - listening port of the netldi
netldiHost    - String - hostname or IP address of the netldi
certificate   - GsX509Certificate or GsX509CertificateChain - certificate or
                chain of certificates to be used for login.
caCertificate - GsX509Certificate or GsX509CertificateChain - trust anchor
                certificate(s) used to verify certificates presented by the
		netldi.
privateKey    - GsTlsPrivateKey - private key which matches certificate.
loginFlags    - SmallInteger - bit flags for login. See gci.ht for latest
                bit field definitions.
extraGemArgs  - String - extra arguments to be passed to gem executable.
dirArg        - String - working directory for the gem
logArg        - String - name of the log file for the gem.

';
		immediateInvariant.
true.
%

removeallmethods GemStoneX509Parameters
removeallclassmethods GemStoneX509Parameters

doit
(Object
	_newKernelSubclass:'GsBitmap'
	instVarNames: #( hiddenSetId )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #'instancesNonPersistent'  #logCreation )
	reservedOop: 249345
)
		category: nil;
		comment: 'GsBitmap is a class that implements an in memory bitmap, i.e. a transient
 bitmap that cannot be made persistent. A bitmap is a sparse data structure
 that logically implements a bit array. Each bit in the bitmap represents
 a committed non-special object.  

 Objects that are added to a GsBitmap are stored as a bit number which is a 
 numeric conversion of the oop of the object. This is done transparently;
 GsBitmap methods add and retrieve objects without manually converting to oops. 

 When working with the raw GsBitmap data, conversions between objects and oops 
 is via: 
   GsBitmap class >> bitToOop:
   GsBitmap class >> oopToBit:
   Object >> asOop
   Object class >> objectForOop:

 Access to the hiddenSets in the system is implemented by creating 
 a GsBitmap that references a particular hiddenSet (see newForHiddenSet:).  

 Most of the hiddenSets in the system are read only and generate an error
 if the operation is not allowed.  See the code for the hiddenSetSpecifiers 
 method and note the last mutable hiddenSet.  HiddenSets after this point in 
 the  array generate errors if an attempt is made to modify them and the user 
 is not SystemUser.  The NotifySet, PureExportSet, and GciTrackedObjs
 have interfaces defined in System class (categories are NotifySet and
 GcISets) and these interfaces should be used to guarantee correct behavior.
 Updates to these 3 sets generate errors when attempted from GsBitmap.

 An instance of GsBitmap uses C Heap memory to store the bit array. 
 The C Heap memory use is minium of 16KBytes per instance of GsBitmap,
 For an instance with more than 2K elements, worst case memory usage is 
 approximately 8 bytes per element up to 1/64th of the objects in the repository. 
 An instance containing all of the objects in the
 repository will use approximately (System _oopHighWaterMark // 8) bytes of 
 C heap memory.
 The C Heap memory associated with an instance of GsBitmap is automatically 
 freed when the instance is garbage collected.
 Extensive use of large GsBitmaps in a session may require use
 of  ( System _vmMarkSweep )  to force garbage collection of the
 instances sooner than memory pressure on temporary object memory 
 would cause them to be garbage collected, to prevent running out of C heap
 memory.

 Do not retain an instance of GsBitmap from one session to another.
 Instances of GsBitmap are intended to exist only within a given GemStone
 session. 

 Instances may not be committed.

 The objects referenced in a GsBitmap are not protected from garbage collection.
';
		immediateInvariant.
true.
%

removeallmethods GsBitmap
removeallclassmethods GsBitmap

doit
(Object
	_newKernelSubclass:'GsDigitalEnvelope'
	instVarNames: #( publicEncryptionKey encryptedKey cipherText initVector cipherId tag messageClassName digitalSignature )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
	reservedOop: 250369
)
		category: nil;
		comment: 'A GsDigitalEnvelope is a class used to encrypt data with one or more public 
 encryption keys such that the data may only be decrypted with one of the 
 matching private keys. Only RSA encryption key pairs are supported. 

 GsDigitalEnvelopes are also protected by a cryptographic signature which
 is generated using the sender''s signing key. The signature allows the
 receiver to guarantee the envelope was created by someone with access to
 the sender''s private signing key. For signing algorithms that require
 a message digest algorithm, the SHA2-256 message digest is used.
 Signatures generated with RSA keys are padded using the
 RSA_PKCS1_PSS_PADDING scheme. The following signing key types are supported:

 -DSA
 -ECDSA
 -RSA
 -EC
 -Ed25519
 -Ed448

 Using different key pairs for signing and encrypting is strongly recommended.
 
 A GsDigitalEnvelope has the following security features:
 
  -Confidentiality - the message is encrypted using a randomly generated
                     AES encryption session key and initialization vector.
		     The session key is then encrypted with the provided
		     public encryption key.
		     
  -Integrity -       authenticated encryption guarantees the cipher text
                     has not been alter. The digital signature
                     guarantees the encrypted key, initialization vector
		     and tag have not been altered.
	       
  -Authentication -  the receiver of the envelope is assured the sender
                     signed the envelope with the private key matching
		     the public key used to successfully verify the
		     signature.
		    
 IMPORTANT - in order to guarantee authentication, the receiver must confirm
             the public verification key actually belongs to the sender.
	     Normally confirmation is done by verifying an X509 certificate
	     containing the sender''s public key has been signed by a
	     reputable certificate authority. GsDigitalEnvelope does NOT
	     do this public key/certificate signature verification. It is
	     up to the envelope recipient to ensure the public key or
	     X509 certificate used to verify the signature is trustworthy.

 The message to be encrypted and must be a byte collection. Byte 
 collections with a character size greater than one are accepted and will
 be converted to big endian format if necessary before encryption.

 If the message is intended for more than one recipient, multiple instances
 of GsDigitalEnvelope may be created by a single encryption operation by
 supplying multiple public encryption keys, one for each recipient. A maximum
 of 16 GsDigitalEnvelopes may be created by a single encryption operation.
  
 cipherId determines which AEAD (Authenticated Encryption with Additional
 Data) cipher to use from the following list:
 
 ================================
                        Key Size    
 opCode Cipher   Mode  bits/Bytes
 ================================
   4     AES     OCB     128/16  
   5     AES     OCB     192/24  
   6     AES     OCB     256/32  
   7     AES     GCM     128/16  
   8     AES     GCM     192/24  
   9     AES     GCM     256/32  
  10   CHACHA20 Poly1305 256/32  
 ================================

 AEAD guarantees the cipher text has not been altered. Modes 6 and 10 are
 thought to be the most secure and are recommended for most applications. 

 Constraints:
	publicEncryptionKey:	  GsTlsPublicKey or GsX509Certificate
	encryptedKey:   	  ByteArray
	cipherText:	  	  ByteArray
	initVector:	  	  ByteArray
	cipherId:	  	  SmallInteger
	tag:		  	  ByteArray
	messageClassName: 	  String
	digitalSignature:	  ByteArray or nil
';
		immediateInvariant.
true.
%

removeallmethods GsDigitalEnvelope
removeallclassmethods GsDigitalEnvelope

doit
(Object
	subclass: 'GsFileIn'
	instVarNames: #( session fileStream line lineNum currentClass category compileEnvironment )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Kernel';
		comment: 'GsFileIn supports filing in from topaz-format GemStone source files into the image, without the use of topaz.
	
	To use, send one of the from* methods.  This also performs the file in.
	  for example,
	     GsFileIn fromServerPath: ''mySourceCode.gs''
	
	Only a subset of topaz commands is supported:
	   doit , printit , run , nbrun, send
	   input
	   category:
	   classmethod , classmethod:
	   method , method:
	   removeallmethods , removeallclassmethods
	   env N
	   set compile_env N , set class
	     (other set commands are ignored)
Following can be read but are ignored:
	   expectvalue, expecterror, iferr, iferr_clear, iferr_list, errorcount
	   fileformat, fileout, output
	   display, omit, level, limit
	   time, remark, status';
		immediateInvariant.
true.
%

removeallmethods GsFileIn
removeallclassmethods GsFileIn

doit
(Object
	_newKernelSubclass:'GsHostProcess'
	instVarNames: #( cmd in out err childPid childStatus )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #'instancesNonPersistent'  #logCreation )
	reservedOop: 155137
)
		category: nil;
		comment: 'GsHostProcess represents a forked child process whose stdin, stdout, and
stderr are accessable via instances of GsSocket.

Lookup in the PATH environment variable is not performed. The argument
to fork:  must specify a complete path to an executable or script.
Instances may not be committed.

The GsSocket instance variables stdin, stdout, and stderr hold GsSockets
representing  the parent process''s ends of the pipe.   The forked child
process has the other end of the pipe.  The child accepts input on the
stdin and puts output on  stdout and stderr.  For the parent end, stdin
is write-only and  stdout and stderr are read only.

When an instance is garbage collected, and the child has not yet been
reaped,  the child process represented by that instance is killed with
kill -TERM, and waitpid is called to reap the child.

For stdout or stderr of a GsHostProcess, if the child writes data while
it is running then the corresponding GsSocket can read that data. Use
GsSocket>>readWillNotBlock or GsSocket>>readWillNotBlockWithin:
to determine whether data is ready to read.

GsSocket>>read:into:startingAt: will yield to other GsProcess(s) as for
reading from a GsSocket represending an AF_INET or AF_INET6 socket .
If the child has exited and there is no more data to read, this read
method will wait forever.

When GsHostProcess>>status returns non-nil, then any data not yet read
from stdout/stderr is still available to read. The parent end of the
pipe is not closed until the corresponding GsSocket is garbage collected
or explicitly sent GsSocket>>close

If the child tries to read from stdin it will block until data is
written by the parent to the stdin of the GsHostProcess. If the child 
tries to write a lot of data to stdout or stderr, the child may block
until the parent reads enough data from the respective GsSocket to 
unblock the pipe. 

For example,
  GsHostProcess fork: ''$GEMSTONE/bin/topaz -r''
will fork a topaz process which will do blocking reads on stdin and
execute each command that is written to the stdin of the GsHostProcess 
instance.
';
		immediateInvariant.
true.
%

removeallmethods GsHostProcess
removeallclassmethods GsHostProcess

doit
(Object
	subclass: 'GsNetworkResourceString'
	instVarNames: #( protocol node authorization encrypted netldi dir log resource body )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'External Sessions';
		comment: 'This class is part of the External Sessions implementation and 
represents a Network Resource String (NRS). It is typically used 
to construct an NRS from parts, helping ensure correct syntax.

Class methods provide a variety of "sample" ways to create instances.
Instance methods provide getters and setters for the various NRS attributes,
as well as formatting methods for providing a valid string representation.
';
		immediateInvariant.
true.
%

removeallmethods GsNetworkResourceString
removeallclassmethods GsNetworkResourceString

doit
(Object
	_newKernelSubclass:'GsObjectInventory'
	instVarNames: #( entriesByCount entriesByBytes includeHiddenClasses )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
	reservedOop: 145409
)
		category: nil;
		comment: 'GsObjectInventory provides methods for counting instances of
classes in a repository.';
		immediateInvariant.
true.
%

removeallmethods GsObjectInventory
removeallclassmethods GsObjectInventory

doit
(Object
	_newKernelSubclass:'GsObjectInventoryEntry'
	instVarNames: #( theClass instanceCount byteCount )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
	reservedOop: 145665
)
		category: nil;
		comment: 'A GsObjectInventoryEntry represents statistics for one Class,
generated by a GsObjectInventory.';
		immediateInvariant.
true.
%

removeallmethods GsObjectInventoryEntry
removeallclassmethods GsObjectInventoryEntry

doit
(Object
	subclass: 'GsPackageLibrary'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		immediateInvariant.
true.
%

removeallmethods GsPackageLibrary
removeallclassmethods GsPackageLibrary

doit
(Object
	subclass: 'GsReferencePath'
	instVarNames: #( target inSearchOops status numParents moreParents path )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'GsReferencePath holds the result returned from Repository>>#_refPathForObject:limits:.

Instance Variables
   target        <Object>  The object whose path being sought.
   inSearchOops  <Boolean> true if the target was in the searchOops for the last scan.
   status        <Symbol>  Returns #complete if the path starts with an object in the limit set.
                           Returns #cycle if an object occurs more than once in the path.
                           Returns #notConnected if the head of the path has no parents.
                           Returns #noInfo if the RefPathState is not available or a
                             complete path cannot be found.
   moreParents   <Boolean> true if it is known that there are more objects returned than the 
                           numParents value.  This should always be false for objects in the searchOops.
                           If it is true, the other parents can be found by performing another scan
                           with the target in the searchOops.
   numParents    <Integer> The number of parents found for the target.   If the target was NOT
                           in the searchOops for the scan then this value is 0 or 1 (only one
                           parent can be returned for an object not in the searchOops).
   path          <Array>   The objects in the path, starting with an object in the limits,
                           ending with the target object.  An empty array if no path was found.
                           The maximum path returned is 10000.
';
		immediateInvariant.
true.
%

removeallmethods GsReferencePath
removeallclassmethods GsReferencePath

doit
(Object
	subclass: 'GsReferencePathParentsInfo'
	instVarNames: #( target targetFoundInSearch additionalParentsAvailable parentOops parentClassOops parentClassCounts parentSizesInBytes )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'GsReferencePathParentsInfo holds the result returned from 
    GsReferencePathParentsInfo class>>#refPathParentsOf:.

Instance Variables
   target                  <Object>  The object whose parent references are being sought.
   targetFoundInSearch     <Boolean> Indicates whether the target is found in the search objects passed
                                     to GsSingleRefPathFinder>>
                                       #_refPathDoScanForParents:excludeParentRefs:onlySearchObjs:.
   additionalParentsAvailable  <Boolean> If the target object was in the search set for the last
                                     scanForParentsOf: operation, then this should always be false 
                                     and the parentOops returned contains all of the parents.
                                     If the target object was not in the search set, then it indicates
                                     whether there are more parentReferences than the one returned.
                                     Add the object to the search set for another scan to get all
                                     of the parents.
   parentOops              <GsBitmap>           The oops of each referencing (parent) object. If the target 
                                                is not found in the searchArray, only a single parent 
                                                reference can be returned.
   parentClassOops         <Array of: Integer>	An empty array if the target object was not in the 
                                                searchArray.  Otherwise, it contains the oops of the 
                                                parent objects classes.
   parentClassCounts       <Array of: Integer>  An empty array if the target object was not in the 
                                                searchArray.  Otherwise, each entry in the array is a 
                                                count of the number of parent instances of the class 
                                                with the corresponding index in the parentClassOops array.
   parentSizesInBytes	   <Array of: Integer>	An empty array if the target object was not in the 
                                                searchArray.  Otherwise, each entry is the sum of the parent 
                                                objects size in bytes for the parent instances of the class 
                                                with the corresponding index in the parentClassOops array.
';
		immediateInvariant.
true.
%

removeallmethods GsReferencePathParentsInfo
removeallclassmethods GsReferencePathParentsInfo

doit
(Object
	subclass: 'GsSysLog'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'GsSysLog is a class used to write entries to the system log via syslogd.
 It has class-side behavior only.';
		immediateInvariant.
true.
%

removeallmethods GsSysLog
removeallclassmethods GsSysLog

doit
(Object
	_newKernelSubclass:'GsTlsCredential'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #'instancesNonPersistent'  #logCreation )
	reservedOop: 249857
)
		category: 'X509';
		comment: 'GsTlsCredential is a class that encapsulates TLS private keys, public keys,
  and X509 certificates. Instances contain a hidden reference to C pointer
  to the OpenSSL representation of the TLS object.';
		immediateInvariant.
true.
%

removeallmethods GsTlsCredential
removeallclassmethods GsTlsCredential

doit
(GsTlsCredential
	subclass: 'GsTlsPrivateKey'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'X509';
		comment: 'GsTlsPrivateKey encapsulates a TLS/SSL private key.';
		immediateInvariant.
true.
%

removeallmethods GsTlsPrivateKey
removeallclassmethods GsTlsPrivateKey

doit
(GsTlsCredential
	subclass: 'GsTlsPublicKey'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'X509';
		comment: 'GsTlsPublicKey encapsulates a TLS/SSL public key.';
		immediateInvariant.
true.
%

removeallmethods GsTlsPublicKey
removeallclassmethods GsTlsPublicKey

doit
(GsTlsCredential
	subclass: 'GsX509Certificate'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'X509';
		comment: 'GsX509Certificate encapsulates a TLS/SSL CA certificate per X.509.';
		immediateInvariant.
true.
%

removeallmethods GsX509Certificate
removeallclassmethods GsX509Certificate

doit
(Object
	byteSubclass: 'GsUuidV4'
	classVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #'instancesInvariant'  #logCreation )
)
		category: nil;
		comment: 'GsUuidV4 is an implementation of a version 4 UUID as specified in RFC 4122,
 A Universally Unique IDentifier (UUID) URN Namespace. UUIDs are generated
 randomly using the secure OpenSSL random number generator.

 Instances of GsUuidV4 are invariant and therefore cannot be modified.';
		immediateInvariant.
true.
%

removeallmethods GsUuidV4
removeallclassmethods GsUuidV4

doit
(Object
	_newKernelSubclass:'KerberosPrincipal'
	instVarNames: #( name loginUserProfile loginUserProfileGroups loginAsAnyoneEnabled )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
	reservedOop: 157697
)
		category: nil;
		comment: 'This class is the logical representation of a Kerberos principal.
 It contains the following instance variables:
   name - A symbol representing the Kerberos name of the principal, including the realm.
          Example: #''alice@GEMTALKSYSTEMS.COM''
			    
   loginUserProfile - a UserProfile that corresponds to the Kerberos principal, 
             or nil if the principal does not map to a single UserProfile.  
             The named Kerberos user principal may login to this UserProfile without 
             specifying a password.
			    
   loginUserProfileGroups - anIdentitySet of UserProfileGroups.  The named Kerberos user 
             principal may login as any UserProfile in any of these groups without 
             specifying a password.

   loginAsAnyoneEnabled - a Boolean indicating if the named Kerberos principal has 
             permission to login as any UserProfile except for SystemUser.
';
		immediateInvariant.
true.
%

removeallmethods KerberosPrincipal
removeallclassmethods KerberosPrincipal

doit
(Object
	_newKernelSubclass:'LdapDirectoryServer'
	instVarNames: #( uri bindDN bindPW baseDN tlsCaCert tlsCaCertDir tlsCert tlsKey tlsReqCert )
	classVars: #( AllLdapDirectoryServers )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
	reservedOop: 156673
)
		category: nil;
		comment: 'This class is the logical representation of an LDAP Directory Server to
 GemStone.  It contains the following instance variables which must be Strings
 unless otherwise noted:
   uri               - A Uniform Resource Identifier for LDAP conforming to
                       RFC 4516.
 Optional Arguments (may be nil):		       
   bindDN            - A string which is the distinguished name (DN) used to
                       bind to the server to perform lookups, or nil if anonymous
		       binds are to be used (no bindDN required).
   bindPW            - a ByteArray, which is the encrypted password for bindDN,
                       or nil if anonymous binds are to be used.
   baseDN            - Specifies the default base DN to use when performing ldap
                       operations.  The baseDN must be specified as a Distinguished
		       Name in LDAP format.
   tlsCaCert         - Specifies the file that contains certificates for all of
                       the Certificate Authorities the client will recognize.
   tlsCaCertDir      - Specifies the path of a directory that contains Certificate
                       Authority certificates in separate individual files. tlsCaCert is
		       always used before tlsCaCertDir.
   tlsCert           - Specifies the file that contains the client certificate.
   tlsKey            - Specifies the file that contains the private key
                       that matches the certificate stored in the tlsCert
		       instance variable. The private key must not have a passphrase.
   tlsReqCert        - A symbol which specifies what checks to perform on server certificates
                       in a TLS session, if any. The following symbols are recognized:
                         #never -   The client will not request or check any server certificate.
                         #allow -   The  server certificate is requested. If no certificate is provided,
			            the session proceeds normally. If a bad certificate is provided,
				    it will be ignored and the session proceeds normally.
                         #try -     The server certificate is requested. If no certificate is provided,
			            the session proceeds normally. If a bad certificate is provided,
				    the session is immediately terminated.
                         #demand -  The server certificate is requested. If no certificate is provided,
			            or a bad certificate is provided, the session is immediately
                                    terminated. This is the default setting.
				    
setuid WARNING: OpenLDAP does not read most environment variables nor home directory files
(such as $HOME/ldaprc) if the process is running in setuid mode. A process runs in setuid mode
if the real UNIX user id and the effective UNIX user id are not the same. If running in setuid
mode, the tls* inst vars should be set so that LDAP can locate the correct TLS credentials.';
		immediateInvariant.
true.
%

removeallmethods LdapDirectoryServer
removeallclassmethods LdapDirectoryServer

doit
(Object
	_newKernelSubclass:'PassiveObject'
	instVarNames: #( contents str classes objects ivStrings nextClassNo nextObjectNo exitBlock nextIVNo ivName ivVal file epos ivNames version oldClassMap mapCache )
	classVars: #( ClassNames41dict )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
	reservedOop: 113153
)
		category: nil;
		comment: 'PassiveObject provides a means for transferring data from one GemStone
 repository to another that is similar to VisualWorks'' Binary Object Streaming
 Service (BOSS). The repositories are expected to be running on the same version
 of GemStone.

 An instance of PassiveObject converts the form of a given GemStone object from
 active to passive or from passive to active.  A GemStone object is called
 active because it can respond to messages.  The object''s passive form cannot
 respond to messages, but it can be written to a text file in a standard file
 system outside of GemStone.  A text file is the normal intermediary storage for
 objects that are being transferred between GemStone repositories.
 PassiveObjects themselves need never be transferred or committed, and are
 intended to exist only within a given GemStone session.

                              Note:
    This class provides useful protocols, but it does not represent a full 
    or complete inter-repository data transfer facility.  Not all GemStone
    objects can be converted into passive form.  Please see the GemStone
    Programming Guide for more background information.

			      Note:
    Objects referenced by the user defined tags (tagAt:1, tagAt:2) of
    an object are not included in the default passivation of an object.

 Data transfers are ordinarily accomplished by gathering all objects to be
 transferred into one collection, which is then passivated and reactivated.
 If data is transferred piecemeal, the new repository may lose information about
 the connectivity of objects and produce multiple copies of an object where the
 original repository had only one.

 Finally, class Object includes two methods, writeTo: and loadFrom:, that
 convert an object to and from its passive form.  These methods can be
 reimplemented to tailor the form for any given class.  The first thing any
 writeTo: method must do is to identify the class of the passivated object.  It
 does so by sending the writeClass: message to the passive object that stores
 it.  The loadFrom: method must send the hasRead: message to the passive object
 that loads it.  It then must create a new instance of the class it finds and
 must read all information that was written by the writeTo: method.

 The following discussion describes some limitations of PassiveObject in
 detail.

 Although certain atomic objects have the same OOP in any GemStone repository,
 most objects do not.  The special case that relates some atomic objects to
 their OOPs will be ignored hereafter.

 Now, the identity of a GemStone object depends upon its OOP.  However, when you
 transfer an object from one GemStone repository to another, it is not possible
 to guarantee that it will have the same OOP; its OOP in the original repository
 may already be used by another object in the new repository.  In general, an
 object''s OOP is lost during transfer.

 But the interconnectivity of objects in GemStone depends upon their OOPs.
 Objects identify their relationships to each other by their OOP.  To preserve
 interconnectivity, when aPassiveObject passivates a GemStone object, it also
 passivates all the other objects to which it refers, and the ones to which they
 refer, and so on (the transitive closure of the object).  It also encodes the
 relationships among the objects in the transitive closure so that those
 relationships can be restored when the object is activated in the new
 repository.

 However, each PassiveObject can passivate (the transitive closure of) only one
 object at a time.  If two objects are passivated, and some objects in the
 transitive closure of one refer to objects in the transitive closure of the
 other, PassiveObject has no way to capture or encode those relationships.  Upon
 activation, the lost interrelations between the two objects may not be
 evident at first because duplicate objects are created in the new repository
 and the same values are present.  Only subsequent updates in the duplicated
 objects will reveal their new independence of each other.  Such independence
 may well be unintended, a semantic anomaly in the data.

 To avoid difficulties, gather all data to be transferred into one collection.
 Passivate the collection from the original repository, then activate it in the
 new repository.  Connect the data to the new repository as appropriate, then
 remove the collection used for passivation and commit.  If you must passivate
 two or more objects, passivate only one object in any file; two objects in a
 file virtually guarantee data transfer errors.

 The following Characters are reserved for special use within passive objects.
 The special meanings do not apply within the byte contents of Strings, 
 ByteArrays or DoubleByteStrings within a passive object:

    $*   denotes true
    $~   denotes false
    $$   next byte is an instance of Character with value 0..255
    $!   next two bytes are instance of Character with value 0..65535,
            most significant byte is first.
    $.   denotes  nil
    $#   denotes _remoteNil
    $/   end of named instance variables within a Bag 
    $"   prefix/suffix Character used to identify instance variable names
    $?   class prefix
    $:   object identifier prefix
    $@   global reference prefix
    $%   denotes metaclass reference
    $    terminates a global name or string representation of an integer
    $(   terminates a class name
    $^   begins/ends the GemStone version header
    $&   next 4 bytes are a 32bit Character value, most significant byte first.
    $)   reserved for future use by GemTalk Systems
    $=   reserved for future use by GemTalk Systems
    $_   reserved for customer use

Expected classes of instance variables:
	contents: Object
	str: Object
	classes: Object
	objects: Object
	ivStrings: Object
	nextClassNo: SmallInteger
	nextObjectNo: SmallInteger
	exitBlock: Object
	nextIVNo: SmallInteger
	ivName: CharacterCollection
	ivVal: Object
	file: Object
	epos: Object
	ivNames: Object
	version: SmallInteger
	oldClassMap: SymbolDictionary
	mapCache: SmallInteger  (serial number of a passive object map)
';
		immediateInvariant.
true.
%

removeallmethods PassiveObject
removeallclassmethods PassiveObject

doit
(Object
	subclass: 'Pragma'
	instVarNames: #( method keyword arguments )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'A Pragma represents an occurrence of a pragma in a compiled method.  
A pragma is a literal message pattern that occurs between angle brackets at the 
start of a method after any temporaries.  An example:
	<foo: 123 >

In GemStone, the <primitive: nnn> directive looks like a pragma, but is not a pragma,
primitive: inside the first pragma is a reserved word.

Pragmas show up in the Symbol literals for a method; however they are not
message sends.   ClassOrganizer>>literalsReport:  and
ClassOrganizer>>referencesToLiteral: can be used to search for pragmas.
One can query a method for its pragmas by sendng it the pragmas message, 
which answers an Array of instances of me, one for each pragma in the method.

A Pragma can provide information about the defining class, method, its selector, 
as well as the information about the pragma keyword and its arguments. 
See the two ''accessing'' protocols for details. 
''accessing-method'' provides information about the method the pragma is found in, 
while ''accessing-pragma'' is about the pragma itself.

Instances are retrieved using one of the pragma search methods of 
the ''finding'' protocol on the class side.';
		immediateInvariant.
true.
%

removeallmethods Pragma
removeallclassmethods Pragma

doit
(Object
	_newKernelSubclass:'Processor'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
	reservedOop: 116225
)
		category: nil;
		comment: '
 Processor provides the Smalltalk Blue Book API for the processor scheduler.
 See also class ProcessorScheduler .';
		immediateInvariant.
true.
%

removeallmethods Processor
removeallclassmethods Processor

doit
(Object
	_newKernelSubclass:'ProfMonitor'
	instVarNames: #( file interval results sampleDepth startTime endTime traceObjCreation numSamples )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
	reservedOop: 93441
)
		category: nil;
		comment: 'ProfMonitor is a tool for taking snapshots of the execution stack
 at designated moments.  When done monitoring, the results are collected
 and formed into a report showing classes, method selectors, and hit rates.
 Execution stack snapshots can be gathered at either regular time intervals
 or programmatically by using System profMonSample.  Snapshots can also
 be taken during object creation by setting traceObjectCreation to true.
 If traceObjectCreation is true, the number of samples may be dominated
 by object creation samples rather interval based samples.
 
 The interval is the number of nanoseconds between sample points, which 
 must be either zero (for programmatic tracking) or >= 1000 nanoseconds. 
 Methods are provided to specify interval in milliseconds 
 (interval: variants) or in nanoseconds (intervalNs: variants) .

 See the classmethod  computeInterval:  for determining the argument 
 to pass to the intervalNs: keyword.

 Intervals less than 10 milliseconds use high resolution sampling
 and are implemented by reading a high resolution clock at each
 point where interrupts would be checked, (entries to non-trivial 
 non-primitive method, backward branches, and each CALL_PRIMITIVE bytecode).
 For the CALL_PRIMITIVE bytecodes , each CALL_PRIMITIVE in a loaded
 method is transformed to a PROFILING_CALL_PRIMITIVE (or to equivalent
 native code) at start of profiling and the transformation reversed 
 at end of profiling.  Methods loaded during profiling will have the
 transformation done at method load time.
 When using high resolution sampling, code executes at about 10%
 of normal execution speed.

 Intervals >= 10 milliseconds use the legacy timer interrupt implementation
 which has much less effect on execution performance.

 When the interval is zero, samples are not gathered based on clock time,
 but whenever System profMonSample is called.  Developers can use this
 to generate profiling information on specific methods of interest by
 adding calls to System profMonSample to these methods.
 
 The sampleDepth is the number of levels from the top of the stack to
 sample. This controls the depth of the stack for both method calls and
 object creation; it should be at least 20.
 
 The results are recorded in an instance of GsFile for the gem session,
 in binary machine dependent form.  The file is created with a name of 
 gem<processId>.log in one of the following locations:
   1.  The directory referenced by the environment variable $GEMSTONE_CHILD_LOG.
   2.  The current directory.
   3.  /tmp

 For 100000 samples, GEM_TEMPOBJ_CACHE_SIZE should be set to at least 300MB 
 to avoid AlmostOutOfMemory errors during the analysis phase.

 Instances of ProfMonitor can be committed to save the result of runBlock:
 for later analysis. An instance of ProfMonitor embeds a GsFile reference
 to the file of profiling data which can be reopened later for analysis.

 An instances of ProfMonitor which has been sent gatherResults 
 can occupy many MB or GB of memory and committing lots of them could
 cause significant repository growth.  Send removeResults to an instance
 before committing and then reexecute gatherResults to avoid that growth.


Instance Variables
------------------

file
  An instance of GsFile used to record sampling information while profiling
  is active.  The file contains binary data in machine dependent form.

interval
  The interval between sample points, in nanoseconds of CPU time.
  Must be either zero for programmatic sample gathering or >= 1000.

traceObjCreation 
  A SmallInteger with the following bits that control the profiling
    16r1  1=trace object creation enabled
    16r2  1=elapsed time sampling , 0= cpu time sampling(the default)
    16r4  for elapsed time sampling, tally object faults
    16r8  for elapsed time sampling, tally page faults
    16r10  for elapsed time sampling, tally eden bytes used
    16r20  for elapsed time sampling, tally temp obj memory gc time
    16r40  for elapsed time sampling, tally user defined stat 1 (not implemented)
    16r80  for elapsed time sampling, tally user defined stat 2 (not implemented)

numSamples 
  The total number of samples taken

results
  Holds collected, processed snapshot information in instances of a
  class that is private to ProfMonitor.

sampleDepth 
  The number of levels from top of stack to sample.

startTime 
  Starting Real or CPU time in milliseconds.

endTime
  Ending Real or CPU time in milliseconds.
';
		immediateInvariant.
true.
%

removeallmethods ProfMonitor
removeallclassmethods ProfMonitor

doit
(ProfMonitor
	subclass: 'ProfMonitorTree'
	instVarNames: #( rawArray rootPME objRootPMEDict )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'ProfMonitorTree is an enhancement of ProfMonitor, adding a tree based
display of the profiling results.';
		immediateInvariant.
true.
%

removeallmethods ProfMonitorTree
removeallclassmethods ProfMonitorTree

doit
(Object
	subclass: 'ProfMonitorEntry'
	instVarNames: #( cmethod cclass tally parents children total rcvrClass recursed root childTallies parentTallies )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: '
 A ProfMonitorEntry represents a stack frame from one or more samples
 taken by a ProfMonitor instance.';
		immediateInvariant.
true.
%

removeallmethods ProfMonitorEntry
removeallclassmethods ProfMonitorEntry

doit
(Object
	_newKernelSubclass:'SharedQueue'
	instVarNames: #( valueAvailable contents )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
	reservedOop: 116993
)
		category: nil;
		comment: 'A SharedQueue is a thread-safe queue.  An instance may have 
one or more GsProcesses as producers and one or more GsProcesses
as consumers.

Constraints:
	valueAvailable: Semaphore
	contents: Array';
		immediateInvariant.
true.
%

removeallmethods SharedQueue
removeallclassmethods SharedQueue

doit
(PPCompositeParser
	subclass: 'JsonParser'
	instVarNames: #( array character element elements escape exp frac int json member members number object sign string value )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'Kernel';
		comment: 'https://www.json.org/

json
    element

value
    object
    array
    string
    number
    "true"
    "false"
    "null"

object
    ''{'' ws ''}''
    ''{'' members ''}''

members
    member
    member '','' members

member
    ws string ws '':'' element

array
    ''['' ws '']''
    ''['' elements '']''

elements
    element
    element '','' elements

element
    ws value ws

string
    ''"'' characters ''"''

characters
    ""
    character characters

character
    ''0020'' . ''10ffff'' - ''"'' - ''\''
    ''\'' escape

escape
    ''"''
    ''\''
    ''/''
    ''b''
    ''n''
    ''r''
    ''t''
    ''u'' hex hex hex hex

hex
    digit
    ''A'' . ''F''
    ''a'' . ''f''

number
    int frac exp

int
    digit
    onenine digits
    ''-'' digit
    ''-'' onenine digits

digits
    digit
    digit digits

digit
    ''0''
    onenine

onenine
    ''1'' . ''9''

frac
    ""
    ''.'' digits

exp
    ""
    ''E'' sign digits
    ''e'' sign digits

sign
    ""
    ''+''
    ''-''

ws
    ""
    ''0009'' ws
    ''000a'' ws
    ''000d'' ws
    ''0020'' ws';
		immediateInvariant.
true.
%

removeallmethods JsonParser
removeallclassmethods JsonParser

doit
(ReadStreamPortable
	subclass: 'CPreprocessorStream'
	instVarNames: #( file line cppArchMType debug )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'FFI';
		comment: 'This class is internal to the FFI implementation and 
implements a stream that can track file names and line numbers from 
debug info emitted by /usr/bin/cpp, and parsed by a CPreprocessor.
Instance variables
  file  a String,  path to a file.
  line  a SmallInteger , a line number .
  cppArchMType  nil or a SmallInteger .
  debug  used to enable debugging info in CPreprocessorToken .';
		immediateInvariant.
true.
%

removeallmethods CPreprocessorStream
removeallclassmethods CPreprocessorStream

doit
(ReadStreamPortable
	subclass: 'PPStream'
	instVarNames: #( newlines )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: 'PetitParser-Core';
		comment: 'A positional stream implementation used for parsing. It overrides some methods for optimization reasons.';
		immediateInvariant.
true.
%

removeallmethods PPStream
removeallclassmethods PPStream

doit
(String
	subclass: 'AppendableString'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'AppendableString is intended for streams that are are created empty,  
appended to , and then the contents are retrieved for writing to a socket.
There is no stream-specific support for reading, write limit, nor 
position logic.
Takes advantage of the fact that Strings in GemStone are variable size. 

Instance creation is inherited from   String class >> new .

The contents of a AppendableString are 
Characters with codePoints in range 0 to 255, or UTF8 encoded data .
Attempts to append codePoints above 255 with nextPut methods 
will signal an error.';
		immediateInvariant.
true.
%

removeallmethods AppendableString
removeallclassmethods AppendableString

doit
(String
	_newKernelSubclass:'ISOLatin'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
	reservedOop: 96769
)
		category: nil;
		comment: 'ISOLatin is a subclass of String which provides means for GemStone Smalltalk
 applications to extend the behavior of String with native-language-specific
 sorting or other behavior.

 ISOLatin inherits all of its behavior from String, and thus inherits the
 the English ASCII defaults for character set interpretation, as provided
 by the C runtime library and by Unix.

 It is the user''s responsibility to create a subclass of ISOLatin and
 implement appropriate comparison methods in the subclass if an application
 requires language-specific sorting or comparison semantics.';
		immediateInvariant.
true.
%

removeallmethods ISOLatin
removeallclassmethods ISOLatin

doit
(TestCase
	subclass: 'GsTestCase'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'GsTestCase is the GemStone-specific refinement of the SUnit TestCase class.';
		immediateInvariant.
true.
%

removeallmethods GsTestCase
removeallclassmethods GsTestCase

doit
(TestResult
	subclass: 'GsTestResult'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #'instancesNonPersistent'  #logCreation )
)
		category: nil;
		comment: 'GsTestResult is the GemStone-specific refinement of the SUnit TestResult class.';
		immediateInvariant.
true.
%

removeallmethods GsTestResult
removeallclassmethods GsTestResult

doit
(TestSuite
	subclass: 'GsTestSuite'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'GsTestSuite is the GemStone-specific refinement of the SUnit TestSuite class.';
		immediateInvariant.
true.
%

removeallmethods GsTestSuite
removeallclassmethods GsTestSuite

doit
(Warning
	subclass: 'CompileWarning'
	instVarNames: #(  )
	classVars: #(  )
	classInstVars: #(  )
	poolDictionaries: #()
	inDictionary: Globals
	options: #( #logCreation )
)
		category: nil;
		comment: 'CompileWarning is a Warning (Notification) signaled when a warning
is found during the compiling of a method or expression. Developer
tools might handle this Exception and report the warning to the user.

Constraints:
	gsResumable: Boolean
	gsTrappable: Object
	gsNumber: SmallInteger
	currGsHandler: GsExceptionHandler
	gsStack: Object
	gsReason: String
	gsDetails: Object
	tag: Object
	messageText: Object
	gsArgs: Object';
		immediateInvariant.
true.
%

! Class implementation for 'CanonStringBucket'

!		Instance methods for 'CanonStringBucket'

category: 'Enumerating'
method: CanonStringBucket
accompaniedBy: anObj keysAndValuesDo: aBlock

"Evaluates aBlock with each of the receiver's key/value pairs as the
 2nd and 3rd arguments.
 aBlock must be a 3 argument block, with arguments anObj, key value ."

1 to: numElements do:[:idx | | aSym |
   aSym := self _at: idx  .
   aBlock value: anObj value: aSym value: aSym
].
%

category: 'Adding'
method: CanonStringBucket
add: anAssociation

"Disallowed, CanonStringBucket does not contain associations"

self shouldNotImplement: #add:
%

category: 'Updating'
method: CanonStringBucket
addKey: aKey

"All additions should be done via methods in the parent dictionary."

^ self shouldNotImplement: #addKey:
%

category: 'Updating'
method: CanonStringBucket
at: aKey put: aValue keyValDict_coll: aKeyValDict

"key-value pairs are not supported"

^ self shouldNotImplement: #at:put:keyValDict_coll:
%

category: 'Updating'
method: CanonStringBucket
at: anIndex putKey: aKey

"Disallowed, must use addKey:  or removeKey:"

self shouldNotImplement: #at:putKey: .
%

category: 'Updating'
method: CanonStringBucket
at: anIndex putValue: aValue

"Disallowed, must use addKey:  or removeKey:"

self shouldNotImplement: #at:putValue: .
%

category: 'Accessing'
method: CanonStringBucket
keyAt: index

"Returns the key at the specified index."

^ self _at: index
%

category: 'Enumerating'
method: CanonStringBucket
keysAndValuesDo: aBlock

"For each key/value pair in the receiver, evaluates the two-argument block
 aBlock with the arguments key, value.  Returns the receiver."

1 to: numElements do:[:idx | | aSym |
   aSym := self _at: idx  .
   aBlock value: aSym value: aSym
].
%

category: 'Enumerating'
method: CanonStringBucket
keysDo: aBlock

"For each key/value pair in the receiver, evaluates the one-argument block
 aBlock with the key as the argument.  Returns the receiver."

1 to: numElements do:[:idx | aBlock value: ( self _at: idx )  ] .
%

category: 'Accessing'
method: CanonStringBucket
keyValueDictionary

"Returns the value of the instance variable."

^keyValueDictionary
%

category: 'Updating'
method: CanonStringBucket
keyValueDictionary: aDict

"Updates the value of the keyValueDictionary instance variable."

keyValueDictionary := aDict
%

category: 'Private'
method: CanonStringBucket
objectSecurityPolicy: anObjectSecurityPolicy
"Assigns the receiver and all its components to the given security policy.
 Returns the receiver."

self validateSystemUser .
^ super objectSecurityPolicy: anObjectSecurityPolicy
%

category: 'Private'
method: CanonStringBucket
removeKey: aKey ifAbsent: aBlock

"Removes the specified key and returns aKey . If aKey is not found,
 returns the result of evaluating the zero-argument block aBlock."

 | keyIndex |
 keyIndex := self searchForKey: aKey.
 keyIndex == nil
 ifFalse: [
    numElements := numElements - 1.
    self _deleteNoShrinkFrom: keyIndex to: keyIndex .
    ^ aKey
    ]
 ifTrue: [ ^ self _reportKeyNotFound: aKey with: aBlock ]
%

category: 'Searching'
method: CanonStringBucket
searchForKey: aKey

"Returns the index of aKey, or if not found, nil."

<primitive: 471>
aKey _validateClass: String  .
self _primitiveFailed: #searchForKey: args: { aKey }.
self _uncontinuableError
%

category: 'Accessing'
method: CanonStringBucket
tableSize

"Returns the number of keys in the capacity of the receiver."

^self _basicSize
%

category: 'Accessing'
method: CanonStringBucket
valueAt: index

"not supported, instances hold only keys"

self shouldNotImplement: #valueAt:
%

category: 'Enumerating'
method: CanonStringBucket
valuesDo: aBlock

"For each key/value pair in the receiver, evaluates the one-argument block
 aBlock with the value as the argument.  Returns the receiver."

 self keysDo: aBlock
%

category: 'Private'
method: CanonStringBucket
_audit
| bsz extra nSize |
extra := (bsz := self basicSize) - (nSize := self class instSize) - numElements .
extra < 0 ifTrue:[ Error signal:'bad size'].
0 to: extra - 1 do:[:n |
  (self basicAt:(bsz - n - nSize)) ifNotNil:[ Error signal:'bad element'].
].
%

category: 'Private'
method: CanonStringBucket
_removeAll

"Dereferences the receiver from its parent and shrinks the receiver.
 Used while rebuilding a dictionary."

keyValueDictionary := nil.
numElements := 0.
"gs64 v3.0 don't send  size: 0"
%

! Class implementation for 'CanonStringDict'

!		Class methods for 'CanonStringDict'

category: 'Instance Creation'
classmethod: CanonStringDict
new

"Creates an instance of CanonStringDict with a default table size."

^ self new: 20
%

category: 'Instance Creation'
classmethod: CanonStringDict
new: tableSize

"Creates an instance of CanonStringDict with the specified table size."

| aPrime |
aPrime := self _tableSizeFor: tableSize.
^ self _new: aPrime
%

category: 'Instance Creation'
classmethod: CanonStringDict
_new: aPrime

"Private"

| newDict |
newDict := super _basicNew: aPrime .
newDict _initializeWithoutClear: aPrime .
^ newDict .
%

!		Instance methods for 'CanonStringDict'

category: 'Comparing'
method: CanonStringDict
= anCanonStringDict

"Returns true if all of the following conditions are true:

 1.  The receiver and anCanonStringDict are of the same class.
 2.  The two dictionaries are of the same size.
 3.  The corresponding keys and values of the receiver and anCanonStringDict
     are equal."

(self == anCanonStringDict)
  ifTrue: [ ^ true ].

(self class == anCanonStringDict class)
  ifFalse: [ ^ false ].

(self size == anCanonStringDict size)
  ifFalse: [ ^ false ].

self keysDo: [ :aKey |
  (aKey = (anCanonStringDict at: aKey otherwise: nil))
    ifFalse: [ ^ false ]
  ].

^ true.
%

category: 'Enumerating'
method: CanonStringDict
accompaniedBy: anObj keysAndValuesDo: aBlock

"Evaluates aBlock with each of the receiver's key/value pairs as the
 2nd and 3rd arguments.
 aBlock must be a 3 argument block, with arguments anObj, key value ."

1 to: tableSize do:[ :tableIndex | | collisionBkt |
  collisionBkt := self _at: tableIndex .
  collisionBkt ~~ nil ifTrue:[
      collisionBkt accompaniedBy: anObj keysAndValuesDo: aBlock
  ].
].
%

category: 'Adding'
method: CanonStringDict
add: aString

"Adds aString if it is not already present in the receiver, and returns
 either aString or the canonical string already present."

<primitive: 478>
aString _validateClass: String .
self _primitiveFailed: #add: args: { aString }.
self _uncontinuableError
%

category: 'Adding'
method: CanonStringDict
addAll: aCollection

"Adds elements of aCollection to the receiver. If aCollection is
 a Dictionary, adds only the keys to the receiver .
 Returns aCollection."

aCollection == self ifTrue:[ ^ aCollection ].
(aCollection isKindOf: AbstractDictionary)
  ifTrue:[ ^ aCollection keysDo:[:aKey | self add: aKey ] ].
aCollection accompaniedBy: self do:[ :me :aString | me add: aString ].
^ aCollection
%

category: 'Adding'
method: CanonStringDict
addKey: aString

"Adds aString if it is not already present in the receiver, and returns
 either aString or the canonical string already present."

^ self add: aString
%

category: 'Printing'
method: CanonStringDict
asReportString

"Returns a String that lists the keys, one on each line."

| result |
result := String new.
self keysDo: [ :key |
  result add: key printString;
    add: Character lf
  ].
^ result
%

category: 'Enumerating'
method: CanonStringDict
associationsDetect: aBlock ifNone: exceptionBlock

"CanonStringDict's do not hold assocations"

^ self shouldNotImplement: #associationsDetect:ifNone:
%

category: 'Enumerating'
method: CanonStringDict
associationsDo: aBlock
  ^ self shouldNotImplement: #associationsDo: 
%

category: 'Accessing'
method: CanonStringDict
at: aKey ifAbsent: aBlock

"Returns the value that corresponds to aKey.  If no such key
 exists, returns the result of evaluating the zero-argument block aBlock."

<primitive: 481>
aBlock _isExecBlock ifFalse:[ aBlock _validateClass: ExecBlock] .
^ aBlock value
%

category: 'Accessing'
method: CanonStringDict
at: aKey ifAbsentPut: aBlock

"not implemented, key-value pairs not supported "

^ self shouldNotImplement: #at:ifAbsentPut:
%

category: 'Accessing'
method: CanonStringDict
at: aString otherwise: value

"Returns the key that corresponds to aString.  If no such key
 exists, returns the given alternate value."

<primitive: 481>
aString _validateClass: String .
^ value
%

category: 'Updating'
method: CanonStringDict
at: aKey put: aValue

"CanonStringDict's do not hold key-value pairs, use add: or addKey: "

^ self shouldNotImplement: #at:put:
%

category: 'Updating'
method: CanonStringDict
become: anObject

self ~~ anObject ifTrue:[
  super become: anObject .
  self _resetParentRef .
  anObject _resetParentRef .
]
%

category: 'Enumerating'
method: CanonStringDict
collectAssociations: aBlock

"CanonStringDict's do not hold key-value pairs."

^ self shouldNotImplement: #collectAssociations:
%

category: 'Enumerating'
method: CanonStringDict
do: aBlock
"Iteratively evaluates the one argument block, aBlock, using each key of
 the receiver as the argument to the block. Returns the receiver."

^ self keysDo: aBlock
%

category: 'Hashing'
method: CanonStringDict
hashFunction: aString

^ ((self _basicHash: aString) \\ self tableSize) + 1

%

category: 'Searching'
method: CanonStringDict
includes: aString

"Returns true if the receiver contains aString as a key, false otherwise."

| aValue |
aValue := self at: aString otherwise: nil .
^ aValue ~~ nil
%

category: 'Searching'
method: CanonStringDict
includesAssociation: anAssociation

"CanonStringDict's do not hold assocations"

^ self shouldNotImplement: #includesAssociation:
%

category: 'Searching'
method: CanonStringDict
includesIdentical: aString

"Returns true if the receiver contains an a String identical to the
 argument, false otherwise."

| elem |
elem := self at: aString otherwise: nil .
elem == nil ifFalse:[ ^ aString == elem ].
^ false .
%

category: 'Searching'
method: CanonStringDict
includesIdenticalAssociation: anAssociation

"CanonStringDict's do not hold assocations"

^ self shouldNotImplement: #includesIdenticalAssociation:
%

category: 'Searching'
method: CanonStringDict
includesKey: aKey

"Returns true if the receiver contains an Association or a key-value pair whose
 key is equal to aKey.  Returns false otherwise."

^ self includes: aKey
%

category: 'Initializing'
method: CanonStringDict
initialize: itsSize

"Initializes the instance variables of the receiver to be an empty
 dictionary of the specified size."

| newSize |

newSize := itsSize .

(newSize <= 0)
  ifTrue: [
    newSize _error: #rtErrArgNotPositive.
    newSize := 3
    ].

self _basicSize: 0.  "Set size to 0 and restore to nil any entries"
self _basicSize: newSize .
self _initializeWithoutClear: newSize.
^self
%

category: 'Accessing'
method: CanonStringDict
keyAtValue: anObject ifAbsent: aBlock

"not implemented, CanonStringDict's do not hold key-value pairs."

^ self shouldNotImplement: #keyAtValue:ifAbsent:
%

category: 'Accessing'
method: CanonStringDict
keys

"Returns a Set containing the receiver's keys."

| aSet |

aSet := IdentitySet new.
self keysDo: [ :key | aSet add: key ].
^ aSet
%

category: 'Enumerating'
method: CanonStringDict
keysAndValuesDo: aBlock

"Evaluates aBlock with each of the receiver's key/value pairs as the
 arguments.  The argument aBlock must be a two-argument block.  The
 first argument is the key and the second argument is the value of
 each key/value pair."

1 to: tableSize do:[ :tableIndex | | collisionBkt |
  collisionBkt := self _at: tableIndex .
  collisionBkt ~~ nil ifTrue:[ collisionBkt keysAndValuesDo: aBlock ].
  ]
%

category: 'Enumerating'
method: CanonStringDict
keysDo: aBlock

"Iteratively evaluates the one argument block, aBlock, using each key of
 the receiver as the argument to the block. Returns the receiver."

| aBucket |
1 to: tableSize do:[:k |
  aBucket := self _at: k .
  aBucket ~~ nil ifTrue:[ aBucket keysDo: aBlock ].
  ].
%

category: 'Searching'
method: CanonStringDict
occurrencesOf: aValue

"key value pairs are not supported"

^ self shouldNotImplement: #occurrencesOf:
%

category: 'Searching'
method: CanonStringDict
occurrencesOfIdentical: aValue

"key value pairs are not supported"

^ self shouldNotImplement: #occurrencesOfIdentical:
%

category: 'Formatting'
method: CanonStringDict
printOn: aStream

"Puts a displayable representation of the receiver on the given stream."

| count sz myCls |

myCls := self class .
aStream nextPutAll: myCls name describeClassName .
aStream nextPutAll: '( ' .
count := 1 .
sz := self size .
self keysDo:[:aKey |
  aStream position > 700 ifTrue:[
    "prevent infinite recursion when printing cyclic structures, and
     limit the size of result when printing large collections."
    aStream nextPutAll: '...)' .
    ^ self
    ] .
  aKey printOn: aStream .
  count < sz ifTrue:[ aStream nextPutAll: ', ' ].
  count := count + 1 .
  ].
aStream nextPut: $) .
%

category: 'Hashing'
method: CanonStringDict
rehash
	"Re-establish any hash invariants of the receiver.
	 Rebuilds the hash table by saving the current state, initializing and
	 changing the size of the table, and adding the key values saved
	 back to the hash dictionary."

	| saveTable |
	saveTable := Array new.
	self keysDo: [:aKey | saveTable add: aKey].
	self initialize: self size.
	self addAll: saveTable.
%

category: 'Removing'
method: CanonStringDict
remove: aString

"Removes aString if present in the receiver and returns the removed value.  If
 aString is not present, generates an error."

^ self removeKey: aString
%

category: 'Removing'
method: CanonStringDict
remove: aString ifAbsent: aBlock

"Removes aString if present in the receiver and returns the removed value.  If
 aString is not present, returns the result of evaluating the zero
 argument Block aBlock."

^ self removeKey: aString ifAbsent: aBlock
%

category: 'Removing'
method: CanonStringDict
removeKey: aKey ifAbsent: aBlock

| elem hash aBucket |
elem := self at: aKey otherwise: nil .
elem ifNotNil:[
  hash := self hashFunction: aKey .
  aBucket := self _at:  hash .
  aBucket removeKey: aKey ifAbsent: [ self _error:'inconsistent bucket'].
  numElements := numElements - 1 .
  ^ elem
] .
^ aBlock value
%

category: 'Accessing'
method: CanonStringDict
size

"Returns the number of elements contained in the receiver."

^ numElements
%

category: 'Class Membership'
method: CanonStringDict
species

"Returns a class, an instance of which should be used as the result of
 select: or other projections applied to the receiver."

^ StringKeyValueDictionary
%

category: 'Private'
method: CanonStringDict
tableSize

"Returns the size of hash table used for storing the entries."

^ tableSize
%

category: 'Enumerating'
method: CanonStringDict
valuesDo: aBlock
  ^ self shouldNotImplement: #valuesDo: 
%

category: 'Private'
method: CanonStringDict
_audit
| cnt |
cnt := 0 .
1 to: tableSize do:[:n |  | bkt |
  bkt := self basicAt: n .
  bkt _audit .
  cnt := cnt + bkt numElements .
].
cnt == numElements ifFalse:[ Error signal: 'bad size']
%

category: 'Hashing'
method: CanonStringDict
_basicHash: aString

"Private. The hash value is a case-sensitive hash value of the bytes of a
 string without regard to whether the string contains single or
 double byte characters.  The strings are canonicalized so that
 a DoubleByteString with all-ascii characters is converted to
 a String before computing the hash."
<primitive: 519>
aString _validateClass: String .
self _primitiveFailed: #_basicHash: args: { aString }.
self _uncontinuableError
%

category: 'Private'
method: CanonStringDict
_collisionBucketsDo: aBlock
"Private.  Executes the given one-argument block for each collision bucket
 in the receiver."

| aBucket |
1 to: tableSize do:[:k |
  aBucket := self _at: k .
  aBucket ifNotNil:[ aBlock value: aBucket ].
  ].
%

category: 'Private'
method: CanonStringDict
_initializeWithoutClear: newSize

"Private. Initializes the instance variables of the receiver to be an empty
 KeyValueDictionary of the specified size. Does not clear the contents
 of the receiver - assumes they are all nil."

tableSize := newSize.
numElements := 0.

^self
%

category: 'Private'
method: CanonStringDict
_nodesObjectSecurityPolicy: anObjectSecurityPolicy
  "Assigns receiver's components to the given security policy."

self _collisionBucketsDo:[ :aBucket |
   aBucket objectSecurityPolicy: anObjectSecurityPolicy
].
%

category: 'Private'
method: CanonStringDict
_resetParentRef

"Private. After a become:, the parent refs of the collisionBuckets must
 be reset to point to the correct parent."

self _collisionBucketsDo: [:collisionBkt |
  collisionBkt keyValueDictionary: self].
%

! Class implementation for 'CanonSymbolDict'

!		Instance methods for 'CanonSymbolDict'

category: 'Adding'
method: CanonSymbolDict
add: aString

"Disallowed, only the Virtual machine's creation of a Symbol
 should add elements to AllSymbols."

^ self shouldNotImplement: #add:

%

category: 'Adding'
method: CanonSymbolDict
addAll: aCollection

"Disallowed, only the Virtual machine's creation of a Symbol
 should add elements to AllSymbols."

^ self shouldNotImplement: #addAll:
%

category: 'Adding'
method: CanonSymbolDict
addKey: aSymbol

"Only used during repository conversion."

self validateSystemUser .
"We expect that AllSymbols is not yet an instance of this class."
(Globals at:#AllSymbols) class == CanonSymbolDict ifTrue:[
  ^ self error:'Illegal use for other than repository conversion' .
].
aSymbol class == Symbol ifFalse:[
  aSymbol class == DoubleByteSymbol ifFalse:[
    ^ self error:'bad argument class ' , aSymbol class name
  ].
].
^ super add: aSymbol .
%

category: 'Updating'
method: CanonSymbolDict
become: aCanonSymbolDict

^ self shouldNotImplement: #become:
%

category: 'Initializing'
method: CanonSymbolDict
initialize: itsSize

"Initializes the instance variables of the receiver to be an empty
 dictionary of the specified size."

self validateSystemUser .
super initialize: itsSize
%

category: 'Private'
method: CanonSymbolDict
objectSecurityPolicy: anObjectSecurityPolicy

"Assigns the receiver and all its components to the given security policy.
 Returns the receiver."

self validateSystemUser .
^ super objectSecurityPolicy: anObjectSecurityPolicy
%

category: 'Removing'
method: CanonSymbolDict
remove: aString

^ self shouldNotImplement: #remove:
%

category: 'Removing'
method: CanonSymbolDict
remove: aString ifAbsent: aBlock

^ self shouldNotImplement: #remove:ifAbsent:
%

category: 'Removing'
method: CanonSymbolDict
removeKey: aKey ifAbsent: aBlock

"Removing Symbols from AllSymbols is not supported.
 If you want to remove Symbols from AllSymbols anyway:
   1. You must logged in as SystemUser, and edit this method to remove
      the line with
         shouldNotImplement
      and uncomment the line with
         removeKey:
      And commit these changes.
   2. Stop the Symbol Creation Session, and all other user sessions
        System stopSymbolCreationSession.
        System stopUserSessions.
   3. The Symbols to be removed from AllSymbols must be referenced ONLY
      from AllSymbols, as confirmed by SystemRepository listReferences:.
      OTHERWISE message sends may fail to lookup the proper method
      and you may get other INCORRECT EXECUTION.
   4. execute removals from AllSymbols using this method, and commit.
   5. Start Symbol Creation session using
        System startSymbolCreationSession.

 Use this process at your own risk.
"

self validateSystemUser .
self shouldNotImplement: #removeKey:ifAbsent: .
"^ super removeKey: aKey ifAbsent: aBlock"
%

category: 'Private'
method: CanonSymbolDict
validateSystemUser

"validate that the current session is SystemUser."

System myUserProfile userId = 'SystemUser' ifFalse:[
  self error:'instance only modifiable by SystemUser'.
  self _uncontinuableError .
  ^ nil
  ].
^ self
%

category: 'Private'
method: CanonSymbolDict
_initializeWithoutClear: newSize

"Private. Initializes the instance variables of the receiver to be an empty
 KeyValueDictionary of the specified size. Does not clear the contents
 of the receiver - assumes they are all nil."

self validateSystemUser .
super _initializeWithoutClear: newSize .
^self
%

category: 'Private'
method: CanonSymbolDict
_resetParentRef

"Private. After a become:, the parent refs of the collisionBuckets must
 be reset to point to the correct parent."

self validateSystemUser .
^ super _resetParentRef
%

! Class implementation for 'GsExternalSession'

!		Class methods for 'GsExternalSession'

category: 'GciLibrary'
classmethod: GsExternalSession
gciErrSTypeClass

	^GciErrSType.
%

category: 'GciLibrary'
classmethod: GsExternalSession
gciLibrary

	^SessionTemps current
		at: #'gciLibrary'
		ifAbsentPut: [
			GciLibrary new
				GciInit;
				yourself.
		].
%

category: 'Instance Creation'
classmethod: GsExternalSession
gemNRS: gemNRS stoneNRS: stoneNRS username: aUsername password: aPassword
  | res |
	(res := self new)
		gemNRS: gemNRS;
		stoneNRS: stoneNRS;
		username: aUsername;
		password: aPassword.
  res class gciLibrary .
  ^ res .
%

category: 'Instance Creation'
classmethod: GsExternalSession
gemNRS: gemNRS stoneNRS: stoneNRS username: gsUsername password: gsPassword hostUsername: hostUsername hostPassword: hostPassword
  | res |
	(res := self new)
		gemNRS: gemNRS;
		stoneNRS: stoneNRS;
		username: gsUsername;
		password: gsPassword;
		hostUsername: hostUsername;
		hostPassword: hostPassword .
  res class gciLibrary .
  ^ res
%

category: 'Instance Creation'
classmethod: GsExternalSession
new
  | res |
  (res := self sessionClass basicNew)
      initialize .
  res class gciLibrary .
  ^ res
%

category: 'Instance Creation'
classmethod: GsExternalSession
newDefault
  "This creates an external session that is set to the user, host, and 
  stone of the current gem with the password 'swordfish'. You may update 
  any of these parameters before login for more complex environments."

	 | res |
	 (res := self new)
		  initializeDefaultResources .
   res class gciLibrary .
   ^ res
%

category: 'Private'
classmethod: GsExternalSession
sessionClass
	^(System gemVersionAt: 'osName') = 'AIX'
		ifTrue: [GsLegacyExternalSession]
		ifFalse: [ self "change to GsLegacyExternalSession to not use FFI"]
%

!		Instance methods for 'GsExternalSession'

category: 'Public'
method: GsExternalSession
abort
  "Abort the current transaction in the external Gem."

  | lib |
  lib := self _gciLibrary .
	self _errorIfCallInProgress: lib .
	lib GciNbAbort.
	self waitForResult .
	nbResult ~~ 0 ifTrue: [self error: 'Unexpected result!'].
%

category: 'Public'
method: GsExternalSession
begin 
  "Abort current transaction and begin a transaction"
	self _errorIfCallInProgress.
	self _gciLibrary GciNbBegin .
	self waitForResult.
	nbResult ~~ 0 ifTrue: [self error: 'Unexpected result!'].
%

category: 'Error handling'
method: GsExternalSession
clearStackFor: anError

	| contextOop lib |
	(contextOop := anError context) == 20"nil asOop" ifTrue: [^self].
  lib := self _gciLibrary .
	self _errorIfCallInProgress: lib .
	lib GciClearStack_: contextOop.
	self _signalIfError: lib .
%

category: 'Public'
method: GsExternalSession
commit
  "Commit the current transaction in the external Gem."

  | result lib |
  lib := self _gciLibrary .
  self _errorIfCallInProgress: lib .
  result := lib GciCommit.
  result == 1 ifFalse:[
      self _signalIfError: lib .
  ].
  ^ result == 1.
%

category: 'Public'
method: GsExternalSession
commitOrError
   "Commit the current transaction in the external Gem and return true 
   if success or signal an error."

  | result |
  self _errorIfCallInProgress.
  result := self _gciLibrary GciCommit.
  self _signalIfError.
  result == 1 ifFalse:[ 
    TransactionError new reason: 'commitConflicts' ; signal:'commit conflicts'
    ].
 ^ result == 1
%

category: 'Error handling'
method: GsExternalSession
continue: contextOop replacingTopOfStackWithOop: valueOop
	"Continue execution in the external Gem following an exception,
	 replacing the top of the stack with the specified object.
	 It is an error to specify an oop not visible to the remote Gem."
  | lib |
	lib := self _gciLibrary .
	self _errorIfCallInProgress: lib .
	lib GciNbContinueWith_: contextOop
		_: valueOop
		_: 16r10"GCI_PERFORM_noClientUseraction"  
		_: nil.
	^self
		waitForResult;
		_lastResult: lib .
%

category: 'Public'
method: GsExternalSession
executeString: aString
	"Execute the string expression in the external Gem and answer the result.
	 The best values to return are specials.
	 Strings and other byte objects are copied to the local Gem.
	 All other responses are returned as a Array containing a single OOP."

  | lib |
  aString _isOneByteString ifFalse:[ ArgumentError signal:'arg is not a String' ].
  lib := self _gciLibrary .
	self _errorIfCallInProgress: lib .
	lib GciNbExecuteStr_: aString _: 20"nil asOop". 
  self waitForResult .
  ^ self _lastResult: lib
%

category: 'Public'
method: GsExternalSession
forceLogout

	stoneSessionId ifNil: [^self].
	[self hardBreak] onException: Error do: [:ex | ].
	self _logout.
%

category: 'Public'
method: GsExternalSession
forkString: aString
	"Execute the string expression in the external Gem and do not wait for
	 a result.  At some later point, you would check for a result. Otherwise you cannot
	 issue another call, as the current call would remain in progress.
	 Refer to #executeString: for an example of the complete send, wait, response sequence."
  | lib |
  aString _isOneByteString ifFalse:[ ArgumentError signal:'arg is not a String' ].
  lib := self _gciLibrary .
	self _errorIfCallInProgress: lib .
	lib GciNbExecuteStr_: aString _: 20"nil asOop".  
%

category: 'Parameters'
method: GsExternalSession
gemNRS
   ^ parameters ifNotNil:[:p | p gemService ].
%

category: 'Parameters'
method: GsExternalSession
gemNRS: anNRS
	"Set the GemService parameters for the logon to the value
	 of anNRS, which may be a String or a GsNetworkResourceString instance."

	parameters gemService: anNRS asString .
  (anNRS isKindOf: GsNetworkResourceString) ifTrue:[
    self dynamicInstVarAt: #gemHost put: anNRS node .
  ].
%

category: 'Accessors'
method: GsExternalSession
gemProcessId

  ^gemProcessId.
%

category: 'Public'
method: GsExternalSession
hardBreak
	"Interrupt the external Gem and abort the current transaction."
  | lib |
  lib := self _gciLibrary .
	self _setSessionId: lib .
	lib GciHardBreak.
	self _signalIfError: lib .
%

category: 'Parameters'
method: GsExternalSession
hostPassword: aString

	parameters hostPassword: aString copy.
%

category: 'Parameters'
method: GsExternalSession
hostUsername: aString

	parameters hostUsername: aString copy.
%

category: 'Private'
method: GsExternalSession
initialize

	gciErrSType := self class gciErrSTypeClass new.
	parameters := GemStoneParameters new.
	self loggingToServer.
%

category: 'Private'
method: GsExternalSession
initializeDefaultResources
  parameters ifNil:[ parameters := GemStoneParameters new].
	self
		gemNRS: GsNetworkResourceString defaultGemNRSFromCurrent;
		stoneNRS: GsNetworkResourceString defaultStoneNRSFromCurrent;
		username: System myUserProfile userId;
		password: 'swordfish' .
%

category: 'Public'
method: GsExternalSession
isCallInProgress
	"Answer whether there is currently a call in progress to
	 the external Gem.

	 The following calls are OK during a nonblocking call:
		GciCallInProgress
		GciErr
		GciGetSessionId
		GciHardBreak
		GciNbEnd
		GciSetSessionId
		GciShutdown
		GciSoftBreak"

	self isLoggedIn ifFalse:[ ^ false "not logged in"].
  ^ self _isCallInProgress: self _gciLibrary .
%

category: 'Accessors'
method: GsExternalSession
isLoggedIn
 ^ gciSessionId ~~ nil and:[ gciSessionId > 0].
%

category: 'Public'
method: GsExternalSession
isRemoteServerBigEndian

	^self _gciLibrary GciServerIsBigEndian ~~ 0
%

category: 'Public'
method: GsExternalSession
isResultAvailable

	"Check whether the current call in progress has finished
	 and save the result if it has. Most operations cannot be
	 started while another is in progress. You must call this
	 method and receive a true result before starting another
	 remote operation."

  ^ self _isResultAvailable: (CByteArray gcMalloc: 8)
%

category: 'Public'
method: GsExternalSession
lastResult
  ^ nbResult ifNotNil:[:r |
     "r is an Integer, the value of a remote OopType"
     self resolveResult: r
  ]
%

category: 'Logging'
method: GsExternalSession
log: aString

	logger value: aString
%

category: 'Logging'
method: GsExternalSession
logger: aOneArgBlock
	"Use the specified one-argument Block for logging messages.
	 The argument to the Block is the message to log."

	logger := aOneArgBlock
%

category: 'Logging'
method: GsExternalSession
loggingToClient

	self logger: [:message | GsFile gciLogClient: message]
%

category: 'Logging'
method: GsExternalSession
loggingToServer

	self logger: [:message | GsFile gciLogServer: message]
%

category: 'Public'
method: GsExternalSession
login
	| result lib sid |
	stoneSessionId ifNotNil: [
		ImproperOperation signal: 'Stone session ' , stoneSessionId printString ,
			' already associated with this GsExternalSession!'.
	].
  lib := self _gciLibrary .
	result := lib
    GciSetNetEx_: parameters gemStoneName
		_: parameters hostUsername
		_: parameters hostPassword
		_: parameters gemService
		_: parameters passwordIsEncryptedAsIntegerBoolean.	"1 or 0: GCI_LOGIN_PW_ENCRYPTED"
        result == 0 ifTrue:[ self error:'GciSetNetEx_ failed'].
	result := lib
		GciLoginEx_: parameters username
		_: parameters password
		_: parameters loginFlags
		_: 0. "haltOnErrNum"
  sid := lib GciGetSessionId.
  sid > 0 ifTrue:[ gciSessionId := sid ].
	0 == result ifTrue: [
	  self _signalIfError: lib arg: 'Using ', parameters printString .
	  self error: 'Login failed for unknown reason!'.
	].
  self _postLogin: lib  .
	((self dynamicInstVarAt: #quiet) ifNil:[ 0 ]) < 2 ifTrue:[
	  self log: 'GsExternalSession login: ' , self _describe.
  ].
%

category: 'Public'
method: GsExternalSession
loginSolo
  "login as a Solo session using  GCI_LOGIN_SOLO flag.
   Requires an appropriate GEM_SOLO_EXTENT value in the config file
   used by the gem process for the new session.
   See GsSession(C)>>isSolo for details of a Solo session."

	stoneSessionId ifNotNil: [
		ImproperOperation signal: 'Stone session ' , stoneSessionId printString ,
			' already associated with this GsExternalSession!'.
	].
  parameters loginFlags: (parameters loginFlags bitOr: parameters soloLoginFlag).
  ^ self login
%

category: 'Public'
method: GsExternalSession
logout
	stoneSessionId ifNil: [^self].
	self isCallInProgress ifTrue: [
		[
			self waitForResult.
		] onException: Error do: [:ex |
			ex return.
		].
	].
	self _logout.
%

category: 'Private'
method: GsExternalSession
nbLogout
  "Private.
   Should be followed by a send of _waitForLogout ."

	stoneSessionId ifNil: [^self].
	self isCallInProgress ifTrue: [
		[
			self waitForResult.
		] onException: Error do: [:ex |
			ex return.
		].
	].
	self _nbLogout .
%

category: 'Public'
method: GsExternalSession
nbResult
  | result lib cByteArray |
  nbResult := nil.
  lib := self _gciLibrary .
  (self _isCallInProgress: lib) ifFalse: [self error: 'no call in progress'].
  cByteArray := CByteArray gcMalloc: 8 .
  result := lib GciNbEnd_: cByteArray .
  result < 2 ifTrue: [ self error:'result not ready'].
  self _signalIfError: lib .
  nbResult := (cByteArray pointerAt: 0 resultClass: CByteArray) uint64At: 0.
  ^ nbResult ifNotNil:[:r |
    "r is an Integer, the value of a remote OopType"
    self resolveResult: r
  ]
%

category: 'Public'
method: GsExternalSession
parameters
  "Return the instance of GemStoneParameters"

  ^ parameters
%

category: 'Parameters'
method: GsExternalSession
password: aString

	parameters password: aString copy.
%

category: 'Public'
method: GsExternalSession
printOn: aStream

	aStream
		nextPutAll: 'a';
		nextPutAll: self class name;
		nextPutAll: '(';
		nextPutAll: stoneSessionId printString;
		nextPutAll: '/';
		nextPutAll: stoneSessionSerial printString;
		nextPutAll: ')' .
%

category: 'Logging'
method: GsExternalSession
quiet
  "By default login and logout are logged using GsFile >> gciLogServer: .
   This disables logging of login and logout."
   self dynamicInstVarAt: #quiet put: 2 .
%

category: 'Logging'
method: GsExternalSession
quietLogout
  "By default login and logout are logged using GsFile >> gciLogServer:.
   This disables logging of logout."
   self dynamicInstVarAt: #quiet put: 1 .
%

category: 'Public'
method: GsExternalSession
resolveResult: anOop
	"Answer the object, or Array containing the OOP, of the result
	received when the last #isResultAvailable answered true.
	Specials can be fully resolved in the current session, and are the
	preferred return type.
	Results that are byte objects will be copied into a String or ByteArray
	and that will be returned, but the OOP of the byte object will remain
	in the remote Gem's export set.
	For objects of all other types, return a result as an Array containing
	the object's OOP in the remote gem, which is also recorded in the remote
	Gem's export set."

  ^ self _resolveResult: anOop lib: self _gciLibrary .
%

category: 'Public'
method: GsExternalSession
resolveResult: anOop toLevel: anInteger
	"Similar to resolveResult:, but this recognizes more classes.
	If the class is not recognized, then return a CByteArray
	with the OOP"

	| lib object oop cByteArray |
	lib := self _gciLibrary.
	object := self _resolveResult: anOop lib: lib .
	(object _isArray) ifFalse: [^object].	"a special or a byte object"
	oop := lib GciFetchClass_: anOop.
	(oop == 66817"Array asOop" and: [0 < anInteger]) ifTrue: [
		| size array |
		size := lib GciFetchSize__: anOop.
		array := Array new.
		1 to: size do: [:i |
			oop := lib GciFetchOop_: anOop _: i.
			array add: (self resolveResult: oop toLevel: anInteger - 1).
		].
		^array.
	].
	"Not a recognized object"
	cByteArray := CByteArray gcMalloc: 8.
	cByteArray uint64At: 0 put: anOop.
	^cByteArray.
%

category: 'Public'
method: GsExternalSession
send: selector to: anOop withArguments: someValues
	"Answer the result of having the specified remote object
	 sent the message with the specified selector and arguments.
	 Argument values are passed by OOP; beware of inconsistent views
	 between the local Gem and the external Gem.
	 The best values to return are specials.
	 Strings and other byte objects are copied to the local Gem.
	 All other responses are returned as a Array containing a single OOP."

	| nArgs args lib |
	lib := self _gciLibrary .
	self _errorIfCallInProgress: lib .
	(someValues == nil or: [ (nArgs := someValues size) == 0])
		ifFalse: [ | ofs |
        ofs := 0 .
			  args := CByteArray gcMalloc: 8 * nArgs .
			  1 to: nArgs do: [:index | | each |
          each := someValues at: index .
					args uint64At: ofs put: each asOop.
          ofs := ofs + 8 .
        ]
     ].
	lib
		GciNbPerform_: anOop  
		_: selector
		_: args
		_: someValues size.
	^self
		waitForResult;
		_lastResult: lib
%

category: 'Accessors'
method: GsExternalSession
sessionId
	"0 => not logged in"

	^gciSessionId.
%

category: 'Public'
method: GsExternalSession
softBreak
	"Interrupt the external Gem, but permit it to be restarted."
  | lib |
  lib := self _gciLibrary .
	self _setSessionId: lib .
	lib GciSoftBreak.
	self _signalIfError: lib .
%

category: 'Parameters'
method: GsExternalSession
stoneNRS: anNRS
	"Set the Stone parameters for the logon to the value
	 of anNRS, which may be a String or a GsNetworkResourceString instance."

	parameters gemStoneName: anNRS asString
%

category: 'Accessors'
method: GsExternalSession
stoneSessionId

	^stoneSessionId.
%

category: 'Accessors'
method: GsExternalSession
stoneSessionSerial

	^stoneSessionSerial.
%

category: 'Logging'
method: GsExternalSession
suppressLogging

	self logger: [:message | ]
%

category: 'Parameters'
method: GsExternalSession
username
  ^ parameters username
%

category: 'Parameters'
method: GsExternalSession
username: aString

	parameters username: aString.
%

category: 'Public'
method: GsExternalSession
waitForReadReady
  "Use the ProcessorScheduler to wait for this session's socket to
   be ready to read, allowing other GsProcess to run while we are waiting."
  (self dynamicInstVarAt: #_socket) _waitForReadReady
%

category: 'Public'
method: GsExternalSession
waitForResult
	"Wait as long as it takes for the external Gem to complete
	 the current operation.
   Does not allow other GsProcess to run. "

	self waitForResultForSeconds: 1000000000000
%

category: 'Public'
method: GsExternalSession
waitForResultForSeconds: aNumber
	"Wait as long as the specified seconds for the external Gem
	 to complete the current operation.
   Does not allow other GsProcess to run. "

	self
		waitForResultForSeconds: aNumber
		otherwise: [self error:
			'Wait time of ' , aNumber printString ,
			' exceeded for session ' , stoneSessionId printString , '/' , stoneSessionSerial printString ,
			' (PID ' , gemProcessId printString , ')']
%

category: 'Public'
method: GsExternalSession
waitForResultForSeconds: aNumber otherwise: aBlock
	"Wait as long as the specified seconds for the external Gem
	 to complete the current operation. If the operation does not
	 complete within that time, answer the result of evaluating aBlock.
   Does not allow other GsProcess to run. "

	| cByteArray lib res msLeft |
  lib := self _gciLibrary .
  cByteArray := CByteArray gcMalloc: 8 .
  msLeft := aNumber asInteger * 1000 .
  [ msLeft > 0 ] whileTrue:[ | tMs |
    tMs := msLeft min: 2000000000 .
    self _setSessionId: lib .
    res := lib GciNbEndPoll_: cByteArray _: tMs .
    res >= 2 ifTrue:[
      self _signalIfError: lib .
      nbResult := cByteArray uint64At: 0 .
      ^ self
    ].
    msLeft := msLeft - tMs .
  ].
  ^ aBlock value
%

category: 'Private'
method: GsExternalSession
_describe
  | str |
	(str := 'stone session ID ' copy )
     add: stoneSessionId asString ;
     add: ' gem processId '; add: gemProcessId asString .
  self _gemHost ifNotNil:[ :host |
     str add: ' on host ' , host asString.
  ].
  str add: ' stone serialNumber ' ; add: stoneSessionSerial asString.
  ^ str
%

category: 'Private'
method: GsExternalSession
_errorIfCallInProgress

	self isCallInProgress ifTrue: [self error: 'call in progress'].
%

category: 'Private'
method: GsExternalSession
_errorIfCallInProgress: lib

	(self _isCallInProgress: lib) ifTrue: [self error: 'call in progress'].
%

category: 'Private'
method: GsExternalSession
_gciLibrary
  "This entry in SessionTemps initialized by instance creation paths."
	^ SessionTemps current at: #'gciLibrary'
%

category: 'Private'
method: GsExternalSession
_gemHost
  ^ self dynamicInstVarAt: #gemHost
%

category: 'Private'
method: GsExternalSession
_getBytes: anOop

	| size bytes fetchedSize classOop |
	classOop := self _gciLibrary GciFetchClass_: anOop.
	self _signalIfError.
	size := self _gciLibrary GciFetchSize__: anOop.
	self _signalIfError.
	bytes := CByteArray gcMalloc: size.
	fetchedSize := self _gciLibrary
		GciFetchBytes__: anOop
		_: 1
		_: bytes
		_: bytes size.
	self _signalIfError.
	fetchedSize ~~ size ifTrue: [self error: 'Unexpected size!'].
	classOop == String asOop ifTrue: [
		^bytes
			stringFrom: 0
			to: size - 1.
	].
	classOop == Symbol asOop ifTrue: [
		^ Symbol withAll: (bytes
			stringFrom: 0
			to: size - 1).
	].
	^bytes
		byteArrayFrom: 0
		to: size - 1.
%

category: 'Private'
method: GsExternalSession
_getBytes: anOop lib: lib
	| size bytes numRet classOop |
	classOop := lib GciFetchClass_: anOop.
  classOop == 20"nil asOop" ifTrue:[
	  self _signalIfError: lib .
  ].
	size := lib GciFetchSize__: anOop.
  size == 0 ifTrue:[
    self _signalIfError: lib
  ].
	bytes := CByteArray gcMalloc: size.
	numRet := lib GciFetchBytes__: anOop _: 1 _: bytes _: bytes size.
  numRet == 0 ifTrue:[
	  self _signalIfError: lib .
  ].
	numRet ~~ size ifTrue: [self error: 'Unexpected size!'].
	classOop == 74753"String asOop" ifTrue: [
		^bytes
			stringFrom: 0
			to: size - 1.
	].
	classOop == 110849"Symbol asOop" ifTrue: [
		^ Symbol withAll: (bytes
			stringFrom: 0
			to: size - 1).
	].
	^bytes
		byteArrayFrom: 0
		to: size - 1.
%

category: 'Private'
method: GsExternalSession
_getStackForOop: gcierrContextOop
  | str start cByteArray |
  nbResult := nil .
  str := 'AbstractExternalSession _stackReport: ' , gcierrContextOop asString .
  self forkString: str .
  start := System timeGmt .
  cByteArray := CByteArray gcMalloc: 8 .
  [ | result lib |
    lib := self _gciLibrary .
    (self _isCallInProgress: lib) ifFalse:[ ^ 'NO STACK, ERROR no call in progress'].
    result := lib GciNbEnd_: cByteArray.
    result >= 2 ifTrue:[
      (self _gciLibrary GciErr_: gciErrSType) == 1 ifTrue:[
        (gciErrSType number  between: 4000 and: 4999) ifTrue: [gciSessionId := 0].
        ^ GciError new _error: gciErrSType in: self .
      ].
      nbResult := (cByteArray pointerAt: 0 resultClass: CByteArray) uint64At: 0.
      ^ self _lastResult: lib .
    ].
    Delay waitForMilliseconds: 20 .
    (System timeGmt - start) > 20 ifTrue:[ ^ 'NO STACK, getStack timedout'].
  ] repeat
%

category: 'Private'
method: GsExternalSession
_isCallInProgress: lib
  | result |
	self _setSessionId: lib .
	result := lib GciCallInProgress. "no Gci error possible"
	^ result == 1
%

category: 'Private'
method: GsExternalSession
_isOnMyHost
  (self dynamicInstVarAt: #_isOnMyHost) ifNotNil:[ :x | ^ x ].
  ^ false
%

category: 'Private'
method: GsExternalSession
_isOnMyStone
  | val |
  (val := self dynamicInstVarAt: #_isOnMyStone) ifNil:[
    (GsSession currentSession isSolo) ifTrue:[
      val := false .
      self dynamicInstVarAt: #_isOnMyStone put: val .
    ].
  ].
  ^ val
%

category: 'Private'
method: GsExternalSession
_isResultAvailable: cByteArray
  "cByteArray is allocated by the caller to avoid a gcMalloc: in each
   invocation of this method."
	| result lib |
	nbResult := nil.
  lib := self _gciLibrary .
	(self _isCallInProgress: lib) ifFalse: [self error: 'no call in progress'].
	result := lib GciNbEnd_: cByteArray.
	result < 2 ifTrue: [ ^ false].
	self _signalIfError: lib .
	nbResult := (cByteArray pointerAt: 0 resultClass: CByteArray) uint64At: 0.
	^ true.
%

category: 'Private'
method: GsExternalSession
_lastResult: lib
  ^ nbResult ifNotNil:[:r |
     "r is an Integer, the value of a remote OopType"
     self _resolveResult: r lib: lib
  ]
%

category: 'Private'
method: GsExternalSession
_logout
	| descr |
	descr := self _describe.
	self isLoggedIn ifTrue:[
		self _nbLogout: descr .
		self _waitForLogout.
		gciSessionId := 0.
	].
	stoneSessionId := nil.
	stoneSessionSerial := nil.
	((self dynamicInstVarAt: #quiet) ifNil:[ 0 ]) < 1 ifTrue:[
		self log: 'GsExternalSession logout: ' , descr.
	].
%

category: 'Private'
method: GsExternalSession
_nbLogout
  | descr |
  descr := self _describe.
	((self dynamicInstVarAt: #quiet) ifNil:[ 0 ]) < 1 ifTrue:[
	  self log: 'GsExternalSession nbLogout: ' , descr.
  ].
  ^ self _nbLogout: descr
%

category: 'Private'
method: GsExternalSession
_nbLogout: descr
  self isLoggedIn ifTrue:[ | lib |
    lib := self _gciLibrary .
		self _setSessionId: lib .
		lib GciLogout__: 0 .
		[ [ self _signalIfError: lib
			] onException: GciError do:[:ex |
				 ex originalNumber == 4100
					 ifTrue:[ "ignore invalid session error from GciError"]
					ifFalse:[ ex pass ].
			].
		] onException: Error do: [:ex | | msg |
			(msg := '---(During GsExternalSession logout:') , descr lf .
			msg := msg , '    ', ex description , ')---'.
			self log: msg lf .
		].
  ].
%

category: 'Private'
method: GsExternalSession
_postLogin: lib
	| onMyStn onMyHost gemHostIdStr oopSystem fd sock |
  oopSystem := 76033 "System asOop".
	stoneSessionId := Object _objectForOop: (lib GciPerform_: oopSystem _: 'session' _: nil _: 0).
	self _signalIfError: lib .
  gemProcessId := Object _objectForOop: (lib GciPerform_: oopSystem _: 'gemProcessId' _: nil _: 0).
	self _signalIfError: lib .

  gemHostIdStr := self executeString:'System hostId asString' .
  onMyHost :=   gemHostIdStr = System hostId asString .

  GsSession isSolo ifTrue:[
    onMyStn := false .
  ] ifFalse:[ | stoneStartupStr |
    stoneStartupStr := self executeString:'System stoneStartupId asString'.
    onMyStn :=  stoneStartupStr = System stoneStartupId asString .
	  stoneSessionSerial := onMyStn ifTrue:[ GsSession serialOfSession: stoneSessionId ]
                              ifFalse:[ self executeString: 'GsSession currentSession serialNumber'].
  ].
  self dynamicInstVarAt: #_isOnMyStone put: onMyStn .
  self dynamicInstVarAt: #_isOnMyHost put:  onMyHost .
  fd := lib GciNbGetNotifyHandle .
  sock := GsSocket fromFileHandle: fd .
  self dynamicInstVarAt: #_socket put: sock
%

category: 'Private'
method: GsExternalSession
_resolveResult: anOop lib: lib
	| type |
	self _setSessionId: lib .
	type := lib GciFetchObjImpl_: anOop.
	type == 3 ifTrue: [^Object _objectForOop: anOop]. "result is a special"
	type == 1 ifTrue: [^self _getBytes: anOop lib: lib ].	  "result is a byte object"
  type < 0 ifTrue:[
	  self _signalIfError: lib .
  ].
	^ { anOop } .
%

category: 'Private'
method: GsExternalSession
_setSessionId

  self isLoggedIn ifFalse:[
     ^ Error signal:'invalid sessionId (session not logged in)'
  ].
  self _gciLibrary GciSetSessionId_: gciSessionId .
  self _signalIfError.
%

category: 'Private'
method: GsExternalSession
_setSessionId: lib

  self isLoggedIn ifFalse:[
     ^ Error signal:'invalid sessionId (session not logged in)'
  ].
  lib GciSetSessionId_: gciSessionId .
  self _signalIfError: lib .
%

category: 'Private'
method: GsExternalSession
_signalIfError
	(self _gciLibrary GciErr_: gciErrSType) == 1 ifFalse: [^self].
	(gciErrSType number  between: 4000 and: 4999) ifTrue: [gciSessionId := 0].
	GciError
		signal: gciErrSType
		in: self
%

category: 'Private'
method: GsExternalSession
_signalIfError: lib
	(lib GciErr_: gciErrSType) == 1 ifFalse: [^self].
	(gciErrSType number  between: 4000 and: 4999) ifTrue: [gciSessionId := 0].
	GciError
		signal: gciErrSType
		in: self
%

category: 'Private'
method: GsExternalSession
_signalIfError: lib arg: detailString
	(lib GciErr_: gciErrSType) == 1 ifFalse: [^self].
	(gciErrSType number  between: 4000 and: 4999) ifTrue: [gciSessionId := 0].
	GciError
		signal: gciErrSType
		in: self details: detailString
%

category: 'Private'
method: GsExternalSession
_waitForLogout
  | onMyStn onMyHost |
	stoneSessionId ifNil:[ ^ self].
  onMyStn := self _isOnMyStone .
  onMyHost := self _isOnMyHost .
  (onMyStn or:[ onMyHost]) ifFalse:[  ^ self "no way to wait reliably"].
	1 to: 2000 do:[ :j |
		onMyStn ifTrue: [
			(GsSession serialOfSession: stoneSessionId) = stoneSessionSerial ifFalse:[
         ^self
      ].
		].
    onMyHost ifTrue:[
      (System _hostProcessExists: gemProcessId) ifFalse:[
        ^ self
      ].
    ].
		(Delay forMilliseconds: 10) wait.
	].
  self error: 'session with stone session ID of ' , stoneSessionId printString ,
              ' gemProcessId = ' , gemProcessId printString,
              ' still present 20 seconds after logout'.
%

! Class implementation for 'GsLegacyExternalSession'

!		Class methods for 'GsLegacyExternalSession'

category: 'Instance Creation'
classmethod: GsLegacyExternalSession
gciErrSTypeClass
  ^ GciError
%

category: 'Instance Creation'
classmethod: GsLegacyExternalSession
gciLibrary
  "No shared library loaded with GsLegacyExternalSession"
  ^ self
%

category: 'Instance Creation'
classmethod: GsLegacyExternalSession
newDefault
  ^ self basicNew initialize ; initializeDefaultResources 
%

!		Instance methods for 'GsLegacyExternalSession'

category: 'Public'
method: GsLegacyExternalSession
abort

	self _errorIfCallInProgress.
	gciInterface nbAbort.
	self waitForResult.
%

category: 'Error handling'
method: GsLegacyExternalSession
clearStackFor: anError

	| contextOop |
	gciInterface sessionId == 0 ifTrue: [^self].
	(contextOop := anError context) == nil asOop ifTrue: [^self].
	self _errorIfCallInProgress.
	gciInterface clearStack: contextOop.
	self _signalIfError.
%

category: 'Public'
method: GsLegacyExternalSession
commit

	self _errorIfCallInProgress.
	^ gciInterface commit.
%

category: 'Public'
method: GsLegacyExternalSession
commitOrError
  | res |
  res := self commit .
  res ~~ true ifTrue:[
    TransactionError new signal: 'GciInterface>>commit failed'
  ].
  ^ res .
%

category: 'Error handling'
method: GsLegacyExternalSession
continue: contextOop replacingTopOfStackWithOop: valueOop
	"Continue execution in the external Gem following an exception,
	 replacing the top of the stack with the specified object.
	 It is an error to specify an oop not visible to the remote Gem."

	self _errorIfCallInProgress.
	^ gciInterface
		continueWith: contextOop
		replaceTopOfStackWith: valueOop
		isSpecial: false
		flags: 0.
%

category: 'Public'
method: GsLegacyExternalSession
executeString: aString
        "Execute the string expression in the external Gem and answer the result.
         The best values to return are specials.
         Strings and other byte objects are copied to the local Gem.
         All other responses are returned as a Array containing a single OOP."

        ^self
                forkString: aString;
                waitForResult;
                lastResult.
%

category: 'Public'
method: GsLegacyExternalSession
forceLogout

	self hardBreak.
	self _logout.
%

category: 'Public'
method: GsLegacyExternalSession
forkString: aString

	self _errorIfCallInProgress.
 gciInterface nbRemoteExecute: aString.
%

category: 'Private'
method: GsLegacyExternalSession
getAndClearLastError

	^ gciInterface getAndClearLastError.
%

category: 'Public'
method: GsLegacyExternalSession
hardBreak

	gciInterface hardBreak.
%

category: 'Private'
method: GsLegacyExternalSession
initialize

	super initialize.
	gciInterface := GciInterface new.
%

category: 'Public'
method: GsLegacyExternalSession
isCallInProgress
	"The following calls are OK during a nonblocking call:
	GciCallInProgress
	GciErr
	GciGetSessionId
	GciHardBreak
	GciNbEnd
	GciSetSessionId
	GciShutdown
	GciSoftBreak"

	self lastError notNil ifTrue: [self error: self lastError].
	gciInterface sessionId == 0 ifTrue: [^false].
	gciInterface callInProgress == true ifTrue: [^true].
	self getAndClearLastError.
	^false.
%

category: 'Public'
method: GsLegacyExternalSession
isLoggedIn
  | sid |
  gciInterface ifNil:[ ^ false ].
  sid := gciInterface sessionId  .
  ^ sid ~~ nil and:[ sid > 0 ].
%

category: 'Public'
method: GsLegacyExternalSession
isResultAvailable

	| status |
	self isCallInProgress ifFalse: [self error: 'no call in progress'].
	status := gciInterface nbEndOop.
	status ifNil: [self _signalIfError].
	^ status == 1.
%

category: 'Private'
method: GsLegacyExternalSession
lastError

	^ gciInterface lastError.
%

category: 'Public'
method: GsLegacyExternalSession
lastResult

	| result error1 error2 |
	gciInterface resultIsSpecial ifTrue: [^ gciInterface lastResult].
	error1 := gciInterface getAndClearLastError.
	self traversalBuffer initTraversalBuffer.
	result := gciInterface
		traverseObjects:  { gciInterface lastResult }
		buffer: traversalBuffer.
	(error2 := gciInterface getAndClearLastError) notNil ifTrue: [ | txt |
		txt := error2 message.
		(txt == nil or: [txt trimBlanks isEmpty])
			ifTrue: [(Exception _new: error2 number args:  {} ) signal]
			ifFalse:[self error: txt]
	].
	traversalBuffer currentObjectIsSpecial ifTrue: [^traversalBuffer objId].
	traversalBuffer currentObjectIsByte ifTrue: [^traversalBuffer getByteObject].
	^ { traversalBuffer objId }
%

category: 'Public'
method: GsLegacyExternalSession
login

	| result onMyStn onMyHost gemHostIdStr |
	stoneSessionId ifNotNil: [
		ImproperOperation signal: 'Stone session ' , stoneSessionId printString ,
			' already associated with this GsExternalSession!'.
	].
	self _errorIfCallInProgress.
	result := gciInterface login: parameters execute: 'System session'.
	self _signalIfError.
	stoneSessionId := result.

  "inline _postLogin"
  result := gciInterface remotePerform: System asOop selector: 'gemProcessId' args: #()  .
  self _signalIfError.
  gemProcessId := result .
  gemHostIdStr := self executeString:'System hostId asString'.
  self _signalIfError.
  onMyHost :=   gemHostIdStr = System hostId asString .

  GsSession isSolo ifTrue:[
    onMyStn := false .
  ] ifFalse:[ | stoneStartupStr |
    stoneStartupStr := self executeString:'System stoneStartupId asString'.
    self _signalIfError.
    onMyStn :=  stoneStartupStr = System stoneStartupId asString .
    stoneSessionSerial := onMyStn ifTrue:[ GsSession serialOfSession: stoneSessionId ]
                 ifFalse:[ self executeString: 'GsSession currentSession serialNumber'].
  ].
  gciSessionId := gciInterface sessionId.

  self dynamicInstVarAt: #_isOnMyStone put: onMyStn .
  self dynamicInstVarAt: #_isOnMyHost put:  onMyHost .

	self log: 'GsLegacyExternalSession login: ', self _describe .
%

category: 'Public'
method: GsLegacyExternalSession
logout

	self isCallInProgress ifTrue: [
		[
			self waitForResult.
		] on: Error do: [:ex |
			ex return.
		].
	].
	self _logout.
%

category: 'Private'
method: GsLegacyExternalSession
nbLogout

  ^ self forceLogout
%

category: 'Public'
method: GsLegacyExternalSession
nbResult
  | status |
  status := gciInterface nbEndOop .
  status == 1 ifFalse:[ Error signal:' result not ready'].
  ^ self lastResult 
%

category: 'Public'
method: GsLegacyExternalSession
send: selector to: remoteOop withArguments: someValues

  | args |
  (someValues == nil or: [someValues isEmpty]) ifTrue: [
     args := #( )
  ] ifFalse: [
    args := { } .
    someValues do: [:each | args add: each asOop ; add: each isSpecial ].
  ].
  gciInterface remotePerform: remoteOop selector: selector args: args.
  self _signalIfError.
  gciInterface resultIsSpecial ifTrue: [^ gciInterface lastResult].
  ^ { gciInterface lastResult }
%

category: 'Accessors'
method: GsLegacyExternalSession
sessionId

	^ gciInterface sessionId.
%

category: 'Public'
method: GsLegacyExternalSession
softBreak

	gciInterface softBreak.
%

category: 'Public'
method: GsLegacyExternalSession
traversalBuffer

	traversalBuffer ifNil: [
		(traversalBuffer := TraversalBuffer new: 8000)
			level: 1;
			initTraversalBuffer.
	].
	^traversalBuffer.
%

category: 'Public'
method: GsLegacyExternalSession
waitForResultForSeconds: aNumber otherwise: aBlock
  "Wait as long as the specified seconds for the external Gem
  to complete the current operation. If the operation does not
  complete within that time, answer the result of evaluating aBlock."

  | start |
  start := System timeGmt.
  [ self isResultAvailable ] whileFalse:
    [ Delay waitForMilliseconds: 20.
      aNumber < (System timeGmt - start) ifTrue:[ ^aBlock value]]
%

category: 'Private'
method: GsLegacyExternalSession
_errorIfCallInProgress

  self isCallInProgress ifTrue: [self error: 'call in progress'].
%

category: 'Private'
method: GsLegacyExternalSession
_freeTraversalBuffer

	traversalBuffer ifNil: [^self].
	traversalBuffer free.
	traversalBuffer := nil.
%

category: 'Private'
method: GsLegacyExternalSession
_gciInterface

	^gciInterface
%

category: 'Private'
method: GsLegacyExternalSession
_gciLibrary
   "Not usable in GsLegacyExternalSession"
   self shouldNotImplement: #_gciLibrary
%

category: 'Private'
method: GsLegacyExternalSession
_getStackForOop: gcierrContextOop
  | str |
  self isCallInProgress ifTrue:[ ^ 'call in progress, stack not available' ]. 
  str := 'AbstractExternalSession _stackReport: ' , gcierrContextOop asString .
  self forkString: str .
  self waitForResultForSeconds: 120 .
  ^ self nbResult .
%

category: 'Private'
method: GsLegacyExternalSession
_isOnMyStone
  "value is an approximation, not guaranteed to be accurate"
  | val |
  (val := self dynamicInstVarAt: #_isOnMyStone) ifNil:[
    (GsSession currentSession isSolo) ifTrue:[
      val := false
    ] ifFalse:[
      val := parameters gemStoneName = System stoneName.
    ].
    self dynamicInstVarAt: #_isOnMyStone put: val .
  ].
  ^ val
%

category: 'Private'
method: GsLegacyExternalSession
_logout

	| descr |
	descr := self _describe.
	self _freeTraversalBuffer.
	gciInterface logout.
	self _waitForLogout.
	self getAndClearLastError.
	stoneSessionId := nil.
	stoneSessionSerial := nil.
	self log: 'GsLegacyExternalSession logout: ' , descr.
%

category: 'Private'
method: GsLegacyExternalSession
_signalIfError

	| error |
	(error :=  gciInterface getAndClearLastError) ifNil: [^self].
	GciLegacyError
		signal: error
		in: self.
%

! Class implementation for 'GsX509ExternalSession'

!		Class methods for 'GsX509ExternalSession'

category: 'Instance Creation'
classmethod: GsX509ExternalSession
gemNRS: gemNRS stoneNRS: stoneNRS username: aUsername password: aPassword

"Disallowed"

self shouldNotImplement: #gemNRS:stoneNRS:username:password:
%

category: 'Instance Creation'
classmethod: GsX509ExternalSession
gemNRS: gemNRS stoneNRS: stoneNRS username: gsUsername password: gsPassword hostUsername: hostUsername hostPassword: hostPassword

"Disallowed"

self shouldNotImplement: #gemNRS:stoneNRS:username:password:hostUsername:hostPassword:
%

category: 'Instance Creation'
classmethod: GsX509ExternalSession
newDefault

self shouldNotImplement: #newDefault
%

category: 'Instance Creation'
classmethod: GsX509ExternalSession
newWithX509Parameters: aGemStoneX509Parameters

self gciLibrary .
^ self new initializeWithX509Parameters: aGemStoneX509Parameters
%

!		Instance methods for 'GsX509ExternalSession'

category: 'Parameters'
method: GsX509ExternalSession
gemNRS: anNRS

  self shouldNotImplement: #gemNRS:
%

category: 'Parameters'
method: GsX509ExternalSession
hostPassword: aString

  self shouldNotImplement: #hostPassword:
%

category: 'Parameters'
method: GsX509ExternalSession
hostUsername: aString

  self shouldNotImplement: #hostUsername:
%

category: 'Private'
method: GsX509ExternalSession
initialize

^ self initializeWithX509Parameters: GemStoneX509Parameters new
%

category: 'Private'
method: GsX509ExternalSession
initializeDefaultResources

self shouldNotImplement: #initializeDefaultResources
%

category: 'Private'
method: GsX509ExternalSession
initializeWithX509Parameters: aGemStoneX509Parameters

	gciErrSType := self class gciErrSTypeClass new.
	parameters := aGemStoneX509Parameters .
	self loggingToServer.
%

category: 'Public'
method: GsX509ExternalSession
login

	| result lib |
	stoneSessionId ifNotNil: [
		ImproperOperation signal: 'Stone session ' , stoneSessionId printString ,
			' already associated with this GsX509ExternalSession!'.
	].

  lib := self _gciLibrary .
       result := lib GciX509Login_: parameters asGciX509LoginArg .
	0 == result ifTrue: [
    self _signalIfError: lib .
		self error: 'Login failed for unknown reason!'.
	].
	gciSessionId := self _gciLibrary GciGetSessionId.
  self _postLogin: lib  .
  username := self executeString:'System myUserProfile userId' .
	self log: 'GsX509ExternalSession login: ' , self _describe.
%

category: 'Parameters'
method: GsX509ExternalSession
password: aString
  self shouldNotImplement: #password:
%

category: 'Parameters'
method: GsX509ExternalSession
stoneNRS: anNRS

  self shouldNotImplement: #stoneNRS:
%

category: 'Parameters'
method: GsX509ExternalSession
username
  ^ username
%

category: 'Parameters'
method: GsX509ExternalSession
username: aString

 self shouldNotImplement: #username:
%

category: 'Private'
method: GsX509ExternalSession
_gemHost

^ parameters netldiHost
%

! Class implementation for 'ErrorDescription'

!		Instance methods for 'ErrorDescription'

category: 'Accessing'
method: ErrorDescription
asString
  ^ self printString
%

category: 'Accessing'
method: ErrorDescription
category

   "To match GciErrSType."
   ^categoryOop
%

category: 'Accessing'
method: ErrorDescription
categoryOop

   "Return the value of the instance variable 'categoryOop'."
   ^categoryOop
%

category: 'Accessing'
method: ErrorDescription
context

   "To match GciErrSType."
   ^contextOop
%

category: 'Accessing'
method: ErrorDescription
contextOop

   "Return the value of the instance variable 'contextOop'."
   ^contextOop
%

category: 'Accessing'
method: ErrorDescription
fatal

   "Return the value of the instance variable 'fatal'."
   ^fatal
%

category: 'Testing'
method: ErrorDescription
isBreakPoint

"Return whether the error is due to a breakpoint."

categoryOop ifNil: [^false].
GemStoneError asOop == categoryOop
  ifFalse: [^false].
^ (number == (ErrorSymbols at: #rtErrStackBreakpoint) or:
  [number == (ErrorSymbols at: #rtErrStep) or:
  [number == (ErrorSymbols at: #rtErrCodeBreakpoint)]])
%

category: 'Testing'
method: ErrorDescription
isPause

"Return whether the error is due to a soft break."

categoryOop == nil
  ifTrue: [^false].
GemStoneError asOop == categoryOop
  ifFalse: [^false].
^ number == (ErrorSymbols at: #rtErrPause)
%

category: 'Testing'
method: ErrorDescription
isSoftBreak

"Return whether the error is due to a soft break."

categoryOop == nil
  ifTrue: [^false].
GemStoneError asOop == categoryOop
  ifFalse: [^false].
^ number == (ErrorSymbols at: #rtErrSoftBreak)
%

category: 'Accessing'
method: ErrorDescription
message

   "Return the value of the instance variable 'message'."
   ^message
%

category: 'Accessing'
method: ErrorDescription
number

   "Return the value of the instance variable 'number'."
   ^number
%

category: 'Accessing'
method: ErrorDescription
printString
  "Display the receiver"

| s |

s := String new.
s add: self class name.
s add: '('.

s add: 'category=' ; add: categoryOop printString ; add: ', '.
s add: 'number=' ; add: number printString ; add: ', '.
s add: 'context=' ; add: contextOop printString ; add: ', '.

message == nil ifTrue:[s add: 'message=none' ]
	ifFalse: [s add: 'message="' ; add: message printString ; add: '", '].
s add: 'fatal=' ; add: fatal printString.

s add: ')'.
^s
%

! Class implementation for 'GsX509CertificateChain'

!		Class methods for 'GsX509CertificateChain'

category: 'Class Membership'
classmethod: GsX509CertificateChain
certificateSpecies

^ GsX509Certificate
%

category: 'Instance Creation'
classmethod: GsX509CertificateChain
newFromPemFile: fileNameString
"Reads data from the given file name in PEM format and creates a new instance
 of the receiver. All certificates in the given file are loaded in same order
 as they appear in the PEM file.

 Raises an exception if the file is not in PEM format."

^ self tls3ArgPrim: 2 with: fileNameString with: self certificateSpecies with: 3
%

category: 'Instance Creation'
classmethod: GsX509CertificateChain
newFromPemString: aPemString
"Creates a new instance of the receiver based on the PEM string.
 All certificates in the given file are loaded in same order
 as they appear in the PEM string.

 Raises an exception if the string is not in PEM format."

^ self tls3ArgPrim: 3 with: aPemString with:  self certificateSpecies with: 3
%

category: 'Private'
classmethod: GsX509CertificateChain
tls3ArgPrim: opCode with: aString with: pfArg with: type

"
  OpCode   Function
=========================================================================
     0      New GsTlsCredential from PEM file, pfArg is the passphrase
     1      New GsTlsCredential from PEM string, pfArg is the passphrase
     2      New GsX509CertificateChain from PEM file
     3      New GsX509CertificateChain from PEM file
     4      New GsTlsPublicKey from a GsX509Certificate
     5      New GsTlsCredential from PEM file, pfArg is a file name
     6      New GsTlsCredential from PEM string, pfArg is a file name
=========================================================================

  Type      Kind
============================
    1       Private Key
    2       Public Key
    3       X509 Certificate
============================
"

<primitive: 1056>
^ self _primitiveFailed: #tls3ArgPrim:with:with:with: args: { opCode . aString . pfArg . type }
%

!		Instance methods for 'GsX509CertificateChain'

category: 'Converting'
method: GsX509CertificateChain
asPemString

|sz result|
sz := self size.
(sz == 1)
  ifTrue:[ ^ (self at: 1) asPemString] .

result := String new.
1 to: sz do:[:n| result addAll: (self at: n) asPemString ].
^ result
%

! Class implementation for 'MappingInfo'

!		Instance methods for 'MappingInfo'

category: 'Accessing'
method: MappingInfo
dependencyList

"Returns the value of the instance variable 'dependencyList'."

^dependencyList
%

category: 'Updating'
method: MappingInfo
dependencyList: newValue

"Modify the value of the instance variable 'dependencyList'."

dependencyList := newValue
%

category: 'Accessing'
method: MappingInfo
ivOffset

"Returns the value of the instance variable 'ivOffset'."

^ivOffset
%

category: 'Updating'
method: MappingInfo
ivOffset: newValue

"Modify the value of the instance variable 'ivOffset'."

ivOffset := newValue
%

category: 'Accessing'
method: MappingInfo
object

"Returns the value of the instance variable 'object'."

^object
%

category: 'Updating'
method: MappingInfo
object: newValue

"Modify the value of the instance variable 'object'."

object := newValue
%

category: 'Accessing'
method: MappingInfo
pathTerm

"Returns the value of the instance variable 'pathTerm'."

^pathTerm
%

category: 'Updating'
method: MappingInfo
pathTerm: newValue

"Modify the value of the instance variable 'pathTerm'."

pathTerm := newValue
%

! Class implementation for 'SortBlockNode'

!		Class methods for 'SortBlockNode'

category: 'Constants'
classmethod: SortBlockNode
initialNumberOfElements

"Returns the number of entries that are allocated when a node is created."
^ 100
%

category: 'Instance Creation'
classmethod: SortBlockNode
new

"Returns a new initialized instance with the correct size."

| newOne |
newOne := self basicNew: (self entrySize * self initialNumberOfElements).
newOne numElements: 0.
newOne totalElements: 0.
^ newOne

%

category: 'Instance Creation'
classmethod: SortBlockNode
new: size

"Returns a new initialized instance with the correct size."

| newOne |
newOne := self basicNew: self entrySize * (size min: self maxNumberOfElements).
newOne numElements: 0.
newOne totalElements: 0.
^ newOne
%

category: 'Sorting Support'
classmethod: SortBlockNode
recalculateSelectionTree: sortNodeArray for: node offsets: offsets

"Recalculate the selection tree based on a change of the minimum entry
 in the given node."

| parent lChild rChild offset1 offset2 newOffset i j currNode |
currNode := node.

[ true ] whileTrue: [
    " get the parent of the node that has changed "
    parent := currNode at: 2.

    lChild := parent at: 3.
    rChild := parent at: 4.
    " get the offset in the receiver of the corresponding run "
    offset1 := lChild at: 1.
    offset2 := rChild at: 1.

    " check if either of the runs are now empty "
    i := offsets at: offset1.
    j := offsets at: offset2.
    i == nil
        ifTrue: [ newOffset := offset2 ]
        ifFalse: [
             j == nil
                 ifTrue: [ newOffset := offset1 ]
                 ifFalse: [
                     ( (sortNodeArray at: offset1)
                         _compareEntryAt: i
                         lessThanNode: (sortNodeArray at: offset2)
                         entryAt: j
                         useValue: true)
                         ifTrue: [ newOffset := offset1 ]
                         ifFalse: [ newOffset := offset2 ]
                 ]
        ].
    parent at: 1 put: newOffset.

    " if no parent, then this is the root "
    (parent at: 2) == nil
        ifTrue: [ ^ self ].

    currNode := parent
]
%

!		Instance methods for 'SortBlockNode'

category: 'Updating'
method: SortBlockNode
at: aKey put: aValue

"Adds the key/value pair to the node.  Sender must verify that the node is not
 full."

| index |
numElements == 0
  ifTrue: [ index := 1 ]
  ifFalse: [ index := self _binarySearchCoveringKey: aKey totalOrder: false ].

self _insertKey: aKey
  value: aValue
  atIndex: index.

totalElements := totalElements + 1
%

category: 'Accessing'
method: SortBlockNode
blockSorter

"Returns the value of the instance variable 'pathSorter'."

^blockSorter
%

category: 'Updating'
method: SortBlockNode
blockSorter: aBlockSorter

blockSorter := aBlockSorter
%

category: 'Constants'
method: SortBlockNode
entrySize

"Returns the size of an entry with no encryption."

^ 2
%

category: 'Testing'
method: SortBlockNode
isFull

"Returns if the node is full."

^ numElements == self class maxNumberOfElements
%

category: 'Sorting'
method: SortBlockNode
sortInto: anArray startingAt: index

"Insert the values of the receiver into the given Array starting at the
 given index in sorted order.  Returns the number inserted. "

| j obj snarray |
snarray := SortNodeArray.
        j := index.
        " for each value in the receiver ... "
        1 to: (numElements * self entrySize) by: self entrySize do: [ :i |
            " if it is an Array of nodes, then a merge sort is needed "
            (obj := self _at: i) class == snarray
                ifTrue: [
                    obj sortInto: anArray startingAt: j.
                    j := j + obj totalElements
                ]
                ifFalse: [
                    anArray at: j put: obj.
                    j := j + 1
                ].
        ].
        ^ j - index

%

category: 'Accessing'
method: SortBlockNode
totalElements

"Returns the value of the instance variable 'totalElements'."

^totalElements
%

category: 'Updating'
method: SortBlockNode
totalElements: anInteger

totalElements := anInteger
%

category: 'Updating'
method: SortBlockNode
_at: aKey put: aValue forBtree: aBool

"Adds the key/value pair to the node.  Sender must verify that the node is not
 full.  aBool should always be false."

^ self at: aKey put: aValue
%

category: 'Searching'
method: SortBlockNode
_binarySearchCoveringKey: aKey totalOrder: aBoolean

"Returns the index for the first entry in which aKey is found utilizing a
 binary search.  This is the first entry whose key >= aKey."

| lowPt midPt highPt entrySize index |

entrySize := self entrySize.
lowPt := 1.
highPt := numElements.
[ lowPt <= highPt ] whileTrue: [
    midPt := (lowPt + highPt) quo: 2.
    index := midPt - 1 * entrySize + 2.

    (self _compareKey: aKey lessThanEntryAt: index)
        ifTrue: [ highPt := midPt - 1 ]
        ifFalse: [ lowPt := midPt + 1 ]
].

(self _compareKey: aKey lessThanEntryAt: index)
    ifFalse: [ ^ index + entrySize - 1 ].

^ index - 1
%

category: 'Comparison Operators'
method: SortBlockNode
_compareEntryAt: index1
lessThanNode: aNode
entryAt: index2
useValue: aBoolean

"Perform a < comparison between the entries at the given indexes.
 The default implementation uses no encryption."

| o1 o2 blk |
" first compare the keys "
((blk := blockSorter sortBlock) value: (o1 := self _at: index1)
                               value: (o2 := aNode _at: index2))
   ifTrue: [ ^ true ]
   ifFalse: [
      " if using the values and keys are equal, use the OOP of the value "
      (blk value: o2  value: o1)
         ifFalse:[ ^ (self _at: index1 - 1) identityHash < (aNode _at: index2 - 1) identityHash ]
         ifTrue: [ ^ false ]
    ]
%

category: 'Comparison Operators'
method: SortBlockNode
_compareKey: aKey equalToEntryAt: index

^ ((self _compareKey: aKey lessThanEntryAt: index) == false )
    and:[ (self _compareKey: aKey greaterThanEntryAt: index) == false ]
%

category: 'Comparison Operators'
method: SortBlockNode
_compareKey: aKey greaterThanEntryAt: index

  ^ blockSorter sortBlock value: (self _at: index) value: aKey
%

category: 'Comparison Operators'
method: SortBlockNode
_compareKey: aKey lessThanEntryAt: index

  ^ blockSorter sortBlock value: aKey value: (self _at: index)
%

category: 'Updating'
method: SortBlockNode
_insertDuplicateKey: aKey value: aValue atIndex: insertionIndex
  "The given key is already present in the receiver, so insert the entry
 in a secondary sort node (creating it if necessary)."

  | val newNode sortArray |
  " get the existing value "
  val := self _at: insertionIndex.
  val class == SortNodeArray
    ifTrue: [
      " value is already sort nodes on the secondary sort path "
      blockSorter _addObject: aValue inNodes: val ]
    ifFalse: [
      " create sort node for the secondary sort path and put it in a sort Array "
      newNode := blockSorter sortNodeClassForSort
        new: self sizeForSecondarySorts.
      newNode blockSorter: blockSorter.
      sortArray := SortNodeArray with: newNode.
      self _basicAt: insertionIndex put: sortArray.
      blockSorter _addObject: aValue inNodes: sortArray.
      blockSorter _addObject: val inNodes: sortArray ]
%

category: 'Updating'
method: SortBlockNode
_insertKey: aKey
value: aValue
atIndex: insertionIndex

"Insert the key/value pair in the receiver.  The sender of this
 message must verify that the entry will fit in the receiver and
 provide the insertion index."

| lastIndex eSize |
lastIndex := self _lastIndex.
" see if there is more than one sort path remaining and if the given key
is already present in the receiver."
( insertionIndex < lastIndex and:
[ self _compareKey: aKey equalToEntryAt: insertionIndex + 1 ])
    ifTrue: [ " duplicate keys "
        ^ self _insertDuplicateKey: aKey value: aValue atIndex: insertionIndex
    ].

eSize := self entrySize .

"move entries down to make room for a new entry, or add room at the end"
self _insertAt: insertionIndex
     from: nil "insert nils" fromStart: 1 fromEnd: eSize
     numToMoveDown: (numElements * eSize) - insertionIndex + 1 .

" add the new entry "
super _basicAt: insertionIndex put: aValue.
super _basicAt: (insertionIndex + 1) put: aKey.

self _insertEncryptionFor: aKey value: aValue startingAt: (insertionIndex + 2).

numElements := numElements + 1
%

! Class implementation for 'SortBlockUnicodeNode'

!		Instance methods for 'SortBlockUnicodeNode'

category: 'Updating'
method: SortBlockUnicodeNode
blockSorter: aBlockSorter collator: anIcuCollator

blockSorter := aBlockSorter .
collator := anIcuCollator
%

category: 'Comparison Operators'
method: SortBlockUnicodeNode
_compareEntryAt: index1
lessThanNode: aNode
entryAt: index2
useValue: aBoolean

"Perform a < comparison between the entries at the given indexes.
 The default implementation uses no encryption."

| o1 o2 blk |
" first compare the keys "
((blk := blockSorter sortBlock) value: (o1 := self _at: index1)
                               value: (o2 := aNode _at: index2) value: collator)
   ifTrue: [ ^ true ]
   ifFalse: [
      " if using the values and keys are equal, use the OOP of the value "
      (blk value: o2  value: o1 value: collator )
        ifFalse: [ ^ (self _at: index1 - 1) identityHash < (aNode _at: index2 - 1) identityHash ]
        ifTrue: [ ^ false ]
     ]
%

category: 'Comparison Operators'
method: SortBlockUnicodeNode
_compareKey: aKey greaterThanEntryAt: index

  ^ blockSorter sortBlock value: (self _at: index) value: aKey value: collator
%

category: 'Comparison Operators'
method: SortBlockUnicodeNode
_compareKey: aKey lessThanEntryAt: index

  ^ blockSorter sortBlock value: aKey value: (self _at: index) value: collator
%

category: 'Updating'
method: SortBlockUnicodeNode
_insertDuplicateKey: aKey value: aValue atIndex: insertionIndex
  "The given key is already present in the receiver, so insert the entry
 in a secondary sort node (creating it if necessary)."

  | val newNode sortArray |
  " get the existing value "
  val := self _at: insertionIndex.
  val class == SortNodeArray
    ifTrue: [
      " value is already sort nodes on the secondary sort path "
      blockSorter _addObject: aValue inNodes: val ]
    ifFalse: [
      " create sort node for the secondary sort path and put it in a sort Array "
      newNode := blockSorter sortNodeClassForSort new: self sizeForSecondarySorts.
      newNode blockSorter: blockSorter collator: collator .
      sortArray := SortNodeArray with: newNode .
      self _basicAt: insertionIndex put: sortArray.
      blockSorter _addObject: aValue inNodes: sortArray.
      blockSorter _addObject: val inNodes: sortArray ]
%

! Class implementation for 'SoftCollisionBucket'

!		Class methods for 'SoftCollisionBucket'

category: 'Instance creation'
classmethod: SoftCollisionBucket
new

^ super new _initializeCleanup
%

!		Instance methods for 'SoftCollisionBucket'

category: 'Updating'
method: SoftCollisionBucket
at: aKey put: aValue

"disallowed, should use  at:put:keyValDict_coll:  "

self shouldNotImplement: #at:put:
%

category: 'Updating'
method: SoftCollisionBucket
at: aKey put: aValue keyValDict_coll: aKeyValDict

"Stores the aKey/aValue pair in the receiver.
 Returns self size if this at:put: added a new key, 0 if this at:put:
 replaced a SoftReference for an existing  key .

 aValue is expected to be a SoftReference.

 Also removes key/SoftReference pairs whose SoftReference has been
 cleared by the garbage collector."

| startElem nElem |
self _cleanupReferences: false .
startElem := numElements .
super at: aKey put: aValue keyValDict_coll: aKeyValDict .
startElem < (nElem := numElements) ifTrue:[ ^ nElem ] ifFalse:[ ^ 0 ].
%

category: 'Cleanup'
method: SoftCollisionBucket
cleanupReferences
  ^ self _cleanupReferences: true
%

category: 'Accessing'
method: SoftCollisionBucket
referenceAt: aKey ifAbsent: aBlock

"Returns the non-cleared SoftReference that corresponds to aKey.
 If no such key/SoftRef pair exists,
 returns the result of evaluating the zero-argument block aBlock."

  | keyIndex index aSoftRef |
  keyIndex := self searchForKey: aKey.
  keyIndex ifNotNil: [
    index := (keyIndex + keyIndex) - 1 .
    aSoftRef:=  self _referenceAt: index .
    aSoftRef ifNil:[ ^ self _reportKeyNotFound: aKey with: aBlock ] .
    ^ aSoftRef
  ].
  ^ self _reportKeyNotFound: aKey with: aBlock
%

category: 'Accessing'
method: SoftCollisionBucket
referenceAt: aKey otherwise: aValue

"Returns the non-cleared SoftReference that corresponds to aKey.
 If no such key/SoftRef pair exists, returns aValue ."

  | index keyIndex aSoftRef |
  keyIndex := self searchForKey: aKey.
  keyIndex ifNotNil:[
    index := (keyIndex + keyIndex) - 1 .
    aSoftRef :=  self _referenceAt: index .
    aSoftRef ifNil:[ ^ aValue ].
    ^ aSoftRef
  ].
  ^ aValue
%

category: 'Removing'
method: SoftCollisionBucket
removeKey: aKey ifAbsent: aBlock

"Removes the key/value pair having the key aKey.  If aKey is not found,
 returns the result of evaluating the zero-argument block aBlock.

 Also removes key/SoftReference pairs whose SoftReference has been
 cleared by the garbage collector."

| res |
res := super removeKey: aKey ifAbsent: aBlock .
self _cleanupReferences: true .
^ res
%

category: 'Removing'
method: SoftCollisionBucket
removeKey: aKey otherwise: notFoundValue

"Removes the key/value pair having the key aKey.  If aKey is not found,
 returns the notFoundValue .

 Also removes key/SoftReference pairs whose SoftReference has been
 cleared by the garbage collector."

| res |
res := super removeKey: aKey otherwise: notFoundValue  .
self _cleanupReferences: true .
^ res
%

category: 'Cleanup'
method: SoftCollisionBucket
_cleanupReferences: okToRemoveBucket

"remove key/SoftReference pairs whose SoftReferences have
 been cleared by the garbage collector."
| currCount |
currCount := self _markSweepsThatClearedSoftRefsCount .
currCount == lastCleanupCount ifFalse:[ | nElem firstKey startNumElem |
  startNumElem := (nElem := numElements) .
  1 to: self tableSize do: [:keyIdx | | aRef idx aKey |
    idx := (keyIdx + keyIdx) - 1 .
    aKey := self _at: idx .
    aKey ifNotNil:[
      aRef := self _at: idx + 1 .
      aRef _value ifNil:[
        firstKey ifNil:[ firstKey := aKey ].
        self _at: idx     put: nil . "remove key"
        self _at: idx + 1 put: nil . "remove SoftRef"
        nElem := nElem - 1 .
        nElem < 0 ifTrue:[ nil error:'underflow1' ].
        numElements := nElem .
      ].
    ].
  ].
  lastCleanupCount := currCount .
  nElem == startNumElem ifFalse:[
    firstKey ifNil:[ self error:'nil firstKey in cleanupReferences' ].
    keyValueDictionary _bucketSizeChangeFrom: startNumElem to: nElem
			key: firstKey bucket: self remove: okToRemoveBucket
  ].
].
%

category: 'Private'
method: SoftCollisionBucket
_initializeCleanup

  lastCleanupCount := 0
%

category: 'Private'
method: SoftCollisionBucket
_markSweepsThatClearedSoftRefsCount

"Returns OM.markSweepsThatClearedSoftRefsCount as a positive SmallInteger"

<primitive: 553>

self _primitiveFailed: #_markSweepsThatClearedSoftRefsCount
%

category: 'Private'
method: SoftCollisionBucket
_referenceAt: idx

" for the key stored at offset idx ,
  return the SofReference if softRef.value non-nil, otherwise
  remove the soft reference and associated key .
"
| aSoftRef val |
aSoftRef := self _at: idx + 1 .
aSoftRef ifNotNil:[
  val := aSoftRef _value .
  val ifNil:[ | oldN n aKey |
    aKey := self _at: idx .
    self _at: idx     put: nil . "remove key"
    self _at: idx + 1 put: nil . "remove SoftRef"
    oldN := numElements.
    n := oldN - 1 .
    n < 0 ifTrue:[ nil error:'numElements underflow in a SoftCollisionBucket'].
    numElements := n .
    keyValueDictionary _bucketSizeChangeFrom: oldN to: n key: aKey
		bucket: self remove: false .
    ^ nil .
  ].
  ^ aSoftRef
].
^ nil
%

! Class implementation for 'ChildError'

!		Instance methods for 'ChildError'

category: 'Private'
method: ChildError
buildMessageText
  self details: 'status ', status asString,', ', stderr asString .
  super buildMessageText
%

category: 'Instance initialization'
method: ChildError
initialize
  super initialize .
  gsResumable := true.
%

category: 'Accessing'
method: ChildError
status
  ^ status
%

category: 'Accessing'
method: ChildError
status: anInteger
  status := anInteger
%

category: 'Accessing'
method: ChildError
stderr
  ^ stderr
%

category: 'Accessing'
method: ChildError
stderr: aString
  stderr := aString
%

! Class implementation for 'GciError'

!		Class methods for 'GciError'

category: 'signalling'
classmethod: GciError
signal: aGciErrSType in: anExternalSession
	self new
		signal: aGciErrSType
		in: anExternalSession
    details: nil
%

category: 'signalling'
classmethod: GciError
signal: aGciErrSType in: anExternalSession details: aString
	self new
		signal: aGciErrSType
		in: anExternalSession
    details: aString
%

!		Instance methods for 'GciError'

category: 'accessing'
method: GciError
actualExceptionClassOr: aBlock
	"Answer the class of the actual exception if there is one,
	 or the result of evaluating aBlock if not."

	| actualCls |
	actualCls := (LegacyErrNumMap atOrNil: self number ) ifNotNil: [ :a | a atOrNil: 1].
	^actualCls ifNil: aBlock
%

category: 'accessing'
method: GciError
category

	^gciErrSType category.
%

category: 'updating'
method: GciError
clearStack
  (originalNumber ~~ nil and:[ originalNumber < 4000]) ifTrue:[
         externalSession clearStackFor: gciErrSType.
  ].
%

category: 'accessing'
method: GciError
context

	^gciErrSType context.
%

category: 'updating'
method: GciError
continue
	"Continue code execution in GemStone after an error.
	See GciContinue() in the GemBuilder for C manual for details."

	^externalSession continue: gciErrSType context.
%

category: 'updating'
method: GciError
continueWith: anObject
	"This function is a variant of the continue method, except
	that it allows you to modify the call stack before attempting
	to continue the suspended Smalltalk execution.
	See GciContinueWith() in the GemBuilder for C manual for details."

	^externalSession
		continue: gciErrSType context
		with: anObject.
%

category: 'signalling'
method: GciError
error: aGciErrSType in: anExternalSession details: aString
  self _error: aGciErrSType in: anExternalSession .
  aGciErrSType ifNotNil:[
    aGciErrSType number ~~ 2203"GCI_ERR_OP_IN_PROGRESS" ifTrue:[
	    self stack ifNotNil: [:stack | messageText lf ; add: stack].
    ].
  ].
  aString ifNotNil:[ messageText add:', '; add: aString asString].
  self details: messageText.
%

category: 'accessing'
method: GciError
externalErrorNumber

	^gciErrSType number.
%

category: 'accessing'
method: GciError
gciErrSType

	^gciErrSType
%

category: 'testing'
method: GciError
matchesClasses: expClass
	"expClass is either a Class or an Array of Classes"

	| actualCls |
	actualCls := self actualExceptionClassOr: [^false].
	expClass _isArray
		ifTrue: [^expClass anySatisfy: [:aCls | actualCls isSubclassOf: aCls]]
		ifFalse: [^actualCls isSubclassOf: expClass]
%

category: 'accessing'
method: GciError
originalNumber
  ^ originalNumber
%

category: 'signalling'
method: GciError
signal: aGciErrSType in: anExternalSession
  ^ self signal: aGciErrSType in: anExternalSession details: nil
%

category: 'signalling'
method: GciError
signal: aGciErrSType in: anExternalSession details: aString
  self error: aGciErrSType in: anExternalSession details: aString ;
     signal .
%

category: 'signalling'
method: GciError
signalCompileError

	| delimiter |
	self details: gciErrSType message.
	gsArgs := gciErrSType args.
	gsArgs size: gciErrSType argCount.
	gsArgs := gsArgs collect: [:each |
		externalSession resolveResult: each toLevel: 4.
	].
	messageText := String withAll: 'Compile error(s): '.
	delimiter := ''.
	gsArgs first do: [:each |
		messageText
			addAll: delimiter;
			addAll: (each at: 3);
			addAll: ' (error #';
			addAll: (each at: 1) printString;
			addAll: ') at offset ';
			addAll: (each at: 2) printString.
		delimiter := '; '.
	].
	self signal.
%

category: 'accessing'
method: GciError
stack
  gciErrSType ifNil:[ ^ nil ].
	gciErrSType context == nil asOop ifTrue: [^nil].	"NO CALL IN PROGRESS"
	self externalErrorNumber >= 4000 ifTrue: [^nil].	"NOT A RUNTIME ERROR"
  ^ externalSession _getStackForOop: gciErrSType context .
%

category: 'signalling'
method: GciError
_error: aGciErrSType in: anExternalSession
	gciErrSType := aGciErrSType.
	externalSession := anExternalSession.
  aGciErrSType ifNil:[
    originalNumber := 4100 "GCI_ERR_BAD_SESSION_ID".
    messageText := 'invalid session' copy .
  ] ifNotNil:[
         (originalNumber := gciErrSType number) == 1001 ifTrue: [^self signalCompileError].
         messageText := gciErrSType message.
  ].
	"avoid killing current session with fatal errors"
	(originalNumber between: 4000 and: 4999) ifTrue: [
		messageText add: ' original number: ' , originalNumber asString.
		"and self number is inherited value 2710"
	] ifFalse: [
		self _number: originalNumber.
	].
%

! Class implementation for 'GciLegacyError'

!		Class methods for 'GciLegacyError'

category: 'signalling'
classmethod: GciLegacyError
signal: anErrorDescription in: aLegacyExternalSession

	self new
		signal: anErrorDescription
		in: aLegacyExternalSession.
%

!		Instance methods for 'GciLegacyError'

category: 'accessing'
method: GciLegacyError
actualExceptionClassOr: aBlock
	"Answer the class of the actual exception if there is one,
	 or the result of evaluating aBlock if not."

	| actualCls |
	actualCls := (LegacyErrNumMap atOrNil: self number ) ifNotNil: [ :a | a atOrNil: 1].
	^actualCls ifNil: aBlock
%

category: 'accessing'
method: GciLegacyError
category

	^errorDescription category.
%

category: 'other'
method: GciLegacyError
clearStack

	externalSession clearStackFor: errorDescription.
%

category: 'accessing'
method: GciLegacyError
context

	^errorDescription context.
%

category: 'other'
method: GciLegacyError
continue
	"Continue code execution in GemStone after an error.
	See GciContinue() in the GemBuilder for C manual for details."

	^externalSession
		continue: errorDescription context
		replacingTopOfStackWithOop: nil.
%

category: 'other'
method: GciLegacyError
continueWith: anObject
	"This function is a variant of the continue method, except
	that it allows you to modify the call stack before attempting
	to continue the suspended Smalltalk execution.
	See GciContinueWith() in the GemBuilder for C manual for details."

	^externalSession
		continue: errorDescription context
		replacingTopOfStackWithOop: anObject asOop.
%

category: 'accessing'
method: GciLegacyError
externalErrorNumber

	^errorDescription number.
%

category: 'accessing'
method: GciLegacyError
externalSession

	^externalSession.
%

category: 'testing'
method: GciLegacyError
matchesClasses: expClass
	"expClass is either a Class or an Array of Classes"

	| actualCls |
	actualCls := self actualExceptionClassOr: [^false].
	expClass _isArray
		ifTrue: [^expClass anySatisfy: [:aCls | actualCls isSubclassOf: aCls]]
		ifFalse: [^actualCls isSubclassOf: expClass]
%

category: 'accessing'
method: GciLegacyError
originalNumber
  ^ originalNumber
%

category: 'signalling'
method: GciLegacyError
signal: anErrorDescription in: aLegacyExternalSession

	errorDescription := anErrorDescription.
	externalSession := aLegacyExternalSession.
	(originalNumber := errorDescription number) == 1001 ifTrue: [^self signalCompileError].
	messageText := errorDescription message.
	"avoid killing current session with fatal errors"
	(originalNumber between: 4000 and: 4999) ifTrue: [
		messageText add: ' original number: ' , originalNumber asString.
		"and self number is inherited value 2710"
	] ifFalse: [
		self _number: originalNumber.
	].
	"self stack ifNotNil: [:stack | messageText lf ; add: stack]."
	self details: messageText.
	self signal.
%

category: 'signalling'
method: GciLegacyError
signalCompileError

	gsArgs := errorDescription asArray.
	"gsArgs size: gciErrSType argCount.
	gsArgs := gsArgs collect: [:each |
		externalSession valueOfOop: each toLevel: 4.
	]."
	messageText := errorDescription message.
	self details: messageText.
	self signal.
%

category: 'accessing'
method: GciLegacyError
stack
  errorDescription ifNil:[ ^ nil ].
  errorDescription contextOop == nil asOop ifTrue: [^nil].
  originalNumber >= 4000 ifTrue:[ ^ nil ].
  ^ [ externalSession _getStackForOop: errorDescription contextOop 
    ] on: Error do:[ 'stack not available' ].
%

! Class implementation for 'GsSecureSocket'

!		Class methods for 'GsSecureSocket'

category: 'Instance Creation'
classmethod: GsSecureSocket
basicNew

"disallowed"

self shouldNotImplement: #basicNew
%

category: 'Querying'
classmethod: GsSecureSocket
certificateVerificationEnabledOnClient

"Answer true if certificate verification is enabled for client sockets.
 Otherwise answer false."

^ self _zeroArgSslPrim: 22
%

category: 'Querying'
classmethod: GsSecureSocket
certificateVerificationEnabledOnServer

"Answer true if certificate verification is enabled for server sockets.
 Otherwise answer false."

^ self _zeroArgSslPrim: 23
%

category: 'Error Handling'
classmethod: GsSecureSocket
clearErrorQueue

"Clears all errors from the error queue for all GsSecureSocket instances.
 Returns the receiver."

^ self _zeroArgSslPrim: 7
%

category: 'Examples'
classmethod: GsSecureSocket
clientExample

"Setup socket using class methods"
^ self clientExample: true usingPort: 57785 on: 'localhost'
%

category: 'Examples'
classmethod: GsSecureSocket
clientExample2

"Setup socket using instances methods"
^ self clientExample2: true usingPort: 57785 on: 'localhost'
%

category: 'Examples'
classmethod: GsSecureSocket
clientExample2: logToGciClient usingPort: portNum on: host

"This version uses GsSecureSocket instance methods for setup rather
 than class methods."

| sslClient data dataBuffer |


"Create an new SSL client socket"
sslClient:= self newClient.

[ | failBlock bytesRead dataLength gotEof |

  failBlock := [:sock :shouldLog| | err arr |
    err := sock fetchLastIoErrorString .
    err ifNotNil: [GsFile gciLog: err onClient: shouldLog].
    arr := sock class fetchErrorStringArray .
    1 to: arr size do:[:n| GsFile gciLog: (arr at: n) onClient: shouldLog ].
    sock close.
    SocketError signal: err asString.
  ].

  "Specify the file which contains a list of trusted CA certificates.
   These will be used to validate the certificate presented by the peer
   during the SSL handshake.  The file must be in PEM format.
   Currently, there is no easy way to specify the CA list from a String.
   This must be done before creating the instance of GsSecureSocket! "
  GsSecureSocket useCACertificateFileForClients:
        '$GEMSTONE/examples/openssl/certs/cacert.pem'.

  "Connect to the server to get a normal socket connection.
   On error, close the socket and pass to the next exception handler."
  (sslClient connectTo: portNum on: host timeoutMs: 3000)
    ifTrue:[ GsFile gciLog: 'regular socket connect completed OK.'
                    onClient: logToGciClient ] .

  "uncomment next line to put the socket in blocking mode."
  "sslClient makeBlocking."

  "Tell SSL that this SSL client is to drop the connection unless
   the certificate presented by the server is authenticated."
  sslClient enableCertificateVerification .

  "Set the cipher list for this SSL socket only.
   Use all ciphers except NULL ciphers and anonymous Diffie-Hellman
   and sort by strength."
  sslClient setCipherListFromString: 'ALL:!ADH:@STRENGTH'.

  "Attempt to establish a secure connection to the SSL server..."
  ([sslClient secureConnect]
    on: SocketError
    do:[:ex| |certError|
      GsFile gciLog: 'secureConnect failed' onClient: logToGciClient.
      certError := GsSecureSocket fetchLastCertificateVerificationErrorForClient .
      certError ifNil: [
         GsFile gciLog: 'nil result from fetchLastCertificateVerificationErrorForClient'
                onClient: logToGciClient
          ] ifNotNil: [
          GsFile gciLog: ('Cert error: =>' , certError) onClient: logToGciClient].
      ex pass.
    ])
    ifTrue:[ GsFile gciLog: 'Secure connection established'
                    onClient: logToGciClient].

  "We have a secure connection to the server if we get here."
  GsFile gciLog: ('Current cipher in use is: ', sslClient fetchCipherDescription)
         onClient: logToGciClient.

  "Read length from the client"
  GsFile gciLog: 'Starting read' onClient: logToGciClient.

  dataLength := sslClient read: 8.
  (dataLength == nil or: [dataLength size < 8])
       ifTrue: [GsFile gciLog: 'read of 8 bytes of length failed'
  				onClient: logToGciClient .
  	     		failBlock value: sslClient value: logToGciClient]
       ifFalse: [GsFile gciLog: 'read 8 bytes of length, encoded ', dataLength
  				onClient: logToGciClient].
  dataLength := Integer fromHexString: dataLength.
  GsFile gciLog: 'Data length should be ', dataLength asString
  	onClient: logToGciClient.

  dataBuffer := String new.
  gotEof := false .
  [(dataBuffer size < (dataLength + 10)) and:[ gotEof not]] whileTrue: [
     bytesRead := sslClient read: 16384 into: dataBuffer startingAt: dataBuffer size + 1.
     bytesRead ifNil:[
       GsFile gciLog: 'read failed' onClient: logToGciClient .
              failBlock value: sslClient  value: logToGciClient
     ] ifNotNil:[
        bytesRead == 0 ifTrue:[ gotEof := true ]
          ifFalse:[ GsFile gciLog: 'Read ', bytesRead asString, ' bytes from peer.'
                    onClient: logToGciClient ].
     ].
  ].
  gotEof ifFalse:[
    GsFile gciLog: 'did not get EOF' onClient: logToGciClient.
    failBlock value: sslClient value: logToGciClient.
  ].
  dataBuffer size ~= dataLength ifTrue: [
    GsFile gciLog: 'Read failed ' onClient: logToGciClient.
    failBlock value: sslClient value: logToGciClient.
  ].
  GsFile gciLog: 'Finished reading, read ', dataBuffer size asString, ' bytes from peer'
  	onClient: logToGciClient .

] on: SocketError do:[:ex| sslClient close. ex pass ].

sslClient close.

data := (PassiveObject newWithContents: dataBuffer) activate.
GsFile gciLog: 'Result is ', data class asString, ' of size ', data size asString
     onClient: logToGciClient.
^true
%

category: 'Examples'
classmethod: GsSecureSocket
clientExample: logToGciClient usingPort: portNum on: host

| sslClient data dataBuffer |

"Setup a normal socket connection first."

"Create an new SSL client socket"
sslClient:= self newClient.

[ | failBlock bytesRead dataLength gotEof |

  failBlock := [:sock :shouldLog| | err arr |
    err := sock fetchLastIoErrorString .
    err ifNotNil: [GsFile gciLog: err onClient: shouldLog].
    arr := sock class fetchErrorStringArray .
    1 to: arr size do:[:n| GsFile gciLog: (arr at: n) onClient: shouldLog ].
    sock close.
    SocketError signal: err asString.
  ].

  "Now connect to the server to get a normal socket connection.
   On error, close the socket and pass to the next exception handler."
  (sslClient connectTo: portNum on: host timeoutMs: 3000)
    ifTrue:[ GsFile gciLog: 'regular socket connect completed OK.'
                    onClient: logToGciClient ] .

  "uncomment next line to put the socket in blocking mode."
  "sslClient makeBlocking."

  "Specify the file which contains a list of trusted CA certificates.
   These will be used to validate the certificate presented by the peer
   during the SSL handshake.  The file must be in PEM format."
  GsSecureSocket useCACertificateFileForClients:
        '$GEMSTONE/examples/openssl/certs/cacert.pem'.

  "Tell SSL that all clients are to drop the connection unless
   the certificate presented by the server is authenticated."
  GsSecureSocket enableCertificateVerificationOnClient .

  "Set the cipher list for client SSL sockets.
   Use all ciphers except NULL ciphers and anonymous Diffie-Hellman
   and sort by strength."
  (GsSecureSocket setClientCipherListFromString: 'ALL:!ADH:@STRENGTH')
    ifFalse:[ GsFile gciLog: 'setClientCipherListFromString: failed'
                    onClient: logToGciClient
    ].

  "Attempt to establish a secure connection to the SSL server..."
  ([sslClient secureConnect]
    on: SocketError
    do:[:ex| |certError|
      GsFile gciLog: 'secureConnect failed' onClient: logToGciClient.
      certError := GsSecureSocket fetchLastCertificateVerificationErrorForClient .
      certError ifNil: [
         GsFile gciLog: 'nil result from fetchLastCertificateVerificationErrorForClient'
                onClient: logToGciClient
          ] ifNotNil: [
          GsFile gciLog: ('Cert error: =>' , certError) onClient: logToGciClient].
	  ex pass.
    ])
    ifTrue:[ GsFile gciLog: 'Secure connection established'
                    onClient: logToGciClient].


  "We have a secure connection to the server if we get here."
  GsFile gciLog: ('Current cipher in use is: ', sslClient fetchCipherDescription)
         onClient: logToGciClient.

  "Read length from the client"
  GsFile gciLog: 'Starting read' onClient: logToGciClient.

  dataLength := sslClient read: 8.
  (dataLength == nil or: [dataLength size < 8])
       ifTrue: [GsFile gciLog: 'read of 8 bytes of length failed'
  				onClient: logToGciClient .
  	     		failBlock value: sslClient value: logToGciClient]
       ifFalse: [GsFile gciLog: 'read 8 bytes of length, encoded ', dataLength
  				onClient: logToGciClient].
  dataLength := Integer fromHexString: dataLength.
  GsFile gciLog: 'Data length should be ', dataLength asString
  	onClient: logToGciClient.

  dataBuffer := String new.
  gotEof := false .
  [(dataBuffer size < (dataLength + 10)) and:[ gotEof not]] whileTrue: [
     bytesRead := sslClient read: 16384 into: dataBuffer startingAt: dataBuffer size + 1.
     bytesRead ifNil:[
       GsFile gciLog: 'read failed' onClient: logToGciClient .
              failBlock value: sslClient  value: logToGciClient
     ] ifNotNil:[
        bytesRead == 0 ifTrue:[ gotEof := true ]
          ifFalse:[ GsFile gciLog: 'Read ', bytesRead asString, ' bytes from peer.'
                    onClient: logToGciClient ].
     ].
  ].
  gotEof ifFalse:[
    GsFile gciLog: 'did not get EOF' onClient: logToGciClient.
    failBlock value: sslClient value: logToGciClient.
  ].
  dataBuffer size ~= dataLength ifTrue: [
    GsFile gciLog: 'Read failed ' onClient: logToGciClient.
    failBlock value: sslClient value: logToGciClient.
  ].
  GsFile gciLog: 'Finished reading, read ', dataBuffer size asString, ' bytes from peer'
  	onClient: logToGciClient .

] on: SocketError do:[:ex| sslClient close. ex pass ].

sslClient close.

data := (PassiveObject newWithContents: dataBuffer) activate.
GsFile gciLog: 'Result is ', data class asString, ' of size ', data size asString
     onClient: logToGciClient.
^true
%

category: 'Peer Authentication'
classmethod: GsSecureSocket
disableCertificateVerificationOnClient
"Directs new client sockets ignore invalid server certificates.  The connection
 will not fail if the server certificate is found to be invalid.

 The client always requests a certificate from the server.  By default,
 the connection will fail if the certificate from the server is invalid.

 The effect is valid for the current session only;
 the affected SSL state is not committed to the repository.

 Has no effect on instances created before the method was called.

 Returns the receiver."

^ self _zeroArgSslPrim: 8
%

category: 'Peer Authentication'
classmethod: GsSecureSocket
disableCertificateVerificationOnServer
"Directs server sockets to not request a certificate from the client.
 This is the default mode for server sockets.

 The effect is valid for the current session only;
 the affected SSL state is not committed to the repository.

 Has no effect on instances created before the method was called.

 Returns the receiver."

^ self _zeroArgSslPrim: 10
%

category: 'Peer Authentication'
classmethod: GsSecureSocket
enableCertificateVerificationOnClient
"Directs client sockets to verify the certificate from the server.
 The connection will fail if the server does not provide a valid
 certificate to the client.

 The client always requests a certificate from the server.

 This is the default mode for client sockets.

 The effect is valid for the current session only;
 the affected SSL state is not committed to the repository.

 Has no effect on instances created before the method was called.

 Returns the receiver."

^ self _zeroArgSslPrim: 9
%

category: 'Peer Authentication'
classmethod: GsSecureSocket
enableCertificateVerificationOnServer
"Directs server sockets to request and verify a certificate from the client.
 The connection will fail if the client does not provide a certificate or
 the certificate is found to be invalid.

 The effect is valid for the current session only;
 the affected SSL state is not committed to the repository.

 Has no effect on instances created before the method was called.

 By default, servers do not request certificates from clients.

 Returns the receiver."

^ self _zeroArgSslPrim: 11
%

category: 'Querying'
classmethod: GsSecureSocket
fetchCertificateVerificationOptionsForServer

"Answers an Array of Symbols which represent the certificate verification
 options used by server sockets.

 The supported server options are:

 #SSL_VERIFY_FAIL_IF_NO_PEER_CERT
    if the client did not return a certificate, the TLS/SSL handshake is
    immediately terminated with a 'handshake failure' alert.

 #SSL_VERIFY_CLIENT_ONCE
    only request a client certificate on the initial TLS/SSL handshake.
    Do not ask for a client certificate again in case of a renegotiation.

 Refer to the OpenSSL documentation for more information about these options."

^ self _zeroArgSslPrim: 25
%

category: 'Error Handling'
classmethod: GsSecureSocket
fetchErrorStringArray

"Returns an Array of error strings generated by the OpenSSL package.
 The errors returned are cleared from the SSL error queue.  The array
 is ordered from oldest to newest error."

^ self _zeroArgSslPrim: 6
%

category: 'Error Handling'
classmethod: GsSecureSocket
fetchLastCertificateVerificationErrorForClient

"Fetches and clears a string representing the last certificate verification
 error logged by a client SSL socket.  Returns nil if no such error has
 occurred."

^ self _zeroArgSslPrim: 15
%

category: 'Error Handling'
classmethod: GsSecureSocket
fetchLastCertificateVerificationErrorForServer

"Fetches and clears a string representing the last certificate verification
 error logged by a server SSL socket.  Returns nil if no such error has
 occurred."

^ self _zeroArgSslPrim: 14
%

category: 'Examples'
classmethod: GsSecureSocket
getPasswordFromFile: aString
| gsf result |

gsf := GsFile openReadOnServer: aString .
gsf ifNil:[ SocketError signal: ('Could not open password file ', aString) ] .
result := gsf nextLine trimWhiteSpace .
gsf close.
 ^ result
%

category: 'Examples'
classmethod: GsSecureSocket
httpsClientExample

"Connect to the google https web server on port 443 at the given host and
 perform a simple GET request.  Full verification of the server certificate
 is performed.  Returns true on success"

^ self httpsClientExampleForHost: 'www.google.com'
       certificateDirectory: '/etc/ssl/certs'
       withSniName: 'google.com'
%

category: 'Examples'
classmethod: GsSecureSocket
httpsClientExampleForHost: hostName certificateDirectory: aDirectory withSniName: sniName

"Connect to an https web server on port 443 at the given host and
 perform a simple GET request.  Full verification of the server certificate
 is performed.  Self-signed certificates will fail verification."

| sslClient sni |

[
  | failBlock portNum logToGciClient request bytesSent responseString |
  
  portNum := 443. "https port"
  logToGciClient := true.
  failBlock := [:sock :shouldLog| | err arr |
    err := sock fetchLastIoErrorString .
    err ifNotNil: [GsFile gciLog: err onClient: shouldLog].
    arr := sock class fetchErrorStringArray .
    1 to: arr size do:[:n| GsFile gciLog: (arr at: n) onClient: shouldLog ].
    sock close.
    SocketError signal: err asString.
  ].
  
  "Specify the directory which contains a list of trusted CA certificates.
   These will be used to validate the certificate presented by the peer
   during the SSL handshake.  The files in the directory must be in PEM
   format and the file names must be the hash value of the CA subject name.
   See https://www.openssl.org/docs/man1.0.2/ssl/SSL_CTX_load_verify_locations.html
   for more information.
  
   The directory must be specified before creating the instance of GsSecureSocket.
  
   On Ubuntu Linux, the certificate directory is /etc/ssl/certs  "
  
  GsSecureSocket useCACertificateDirectoryForClients: aDirectory .
  
  "Create an new SSL client socket"
  sslClient:= self newClient.
  
  "Now connect to the server to get a normal socket connection."
  sslClient connectTo: portNum on: hostName timeoutMs: 3000 .
  
  "Put the socket in blocking mode."
  sslClient makeBlocking.
  
  "Tell SSL that this SSL client is to drop the connection unless
   the certificate presented by the server is authenticated."
  sslClient enableCertificateVerification .
  
  "Set the cipher list for this SSL socket only.
   Use all ciphers except NULL ciphers and anonymous Diffie-Hellman
   and sort by strength."
  sslClient setCipherListFromString: 'ALL:!ADH:@STRENGTH' .
  
  "If we have an SNI hostname, set it now"
  sniName ifNotNil:[ (sslClient setServerNameIndication: sniName)
                        ifFalse:[sslClient signalError: 'Error setting SNI hostname']
  	] .
  sni := sslClient getServerNameIndication .
  GsFile gciLog: ('sni name returned by getServerNameIndication is ', sni asString)
         onClient: false .
  
  "Attempt to establish a secure connection to the SSL server..."
  ([sslClient secureConnect]
    on: SocketError
    do:[:ex| |certError|
      GsFile gciLog: 'secureConnect failed' onClient: logToGciClient.
      certError := GsSecureSocket fetchLastCertificateVerificationErrorForClient .
      certError ifNil: [  
         GsFile gciLog: 'nil result from fetchLastCertificateVerificationErrorForClient' 
                onClient: logToGciClient
          ] ifNotNil: [
          GsFile gciLog: ('Cert error: =>' , certError) onClient: logToGciClient].
	  ex pass.
    ])
    ifTrue:[ GsFile gciLog: 'Secure connection established'
                    onClient: logToGciClient].

  "We have a secure connection to the server if we get here."
  
  "Get the cipher used and print it"
  GsFile gciLog: ('Current cipher in use is: ', sslClient fetchCipherDescription)
         onClient: logToGciClient.
  
  "Build a simple http 1.1 GET request string.  Terminate with a blank line"
  request := String withAll: 'GET / HTTP/1.1'.
  request add: Character cr ;
          add: Character lf ;
  	addAll: 'Host: ';
  	addAll: hostName ;
          add: Character cr ;
          add: Character lf ;
          add: Character cr ;
  	add: Character lf.
  
  GsFile gciLog: 'Sending a ', request size asString, ' byte request to client: '
       onClient: logToGciClient.
  GsFile gciLog: request onClient: logToGciClient.
  
  "Send the GET request to the web server"
  bytesSent := sslClient write: request.
  bytesSent == request size
    ifTrue: [ GsFile gciLog: 'Finished sending request to peer' 
  		onClient: logToGciClient ]
    ifFalse: [ GsFile gciLog: 'write of request failed, result was ', bytesSent asString,
    ' expected ', request size asString
                  onClient: logToGciClient .
              failBlock value: sslClient value: logToGciClient.
  ].
  
  "Get the response from the web server and print it"
  GsFile gciLog: 'Waiting for response from server...' onClient: logToGciClient.
  responseString := sslClient read: 2048 .
  GsFile gciLog: 'Finished reading ', responseString size asString, ' bytes from server.'
  		onClient: logToGciClient.
  GsFile gciLog: responseString onClient: logToGciClient.

] on: SocketError do:[:ex|
   sslClient ifNotNil:[ sslClient close ].
   ex pass
].   
"All done! Close the connection and return"
sslClient close.
^true
%

category: 'Examples'
classmethod: GsSecureSocket
httpsSniClientExample

"Example to connect to a webserver that requires SNI. Not using SNI
 (server name == nil) will fail to connect.

 Returns true on success"

^ self httpsClientExampleForHost: 'chrismeller.com'
       certificateDirectory: '/etc/ssl/certs'
       withSniName: 'chrismeller.com'
%

category: 'Error Handling'
classmethod: GsSecureSocket
lastErrorString

  "Provided for compatibility with GsSocket.
   Returns a string describing the elements in the SSL error queue,
   and clears that queue.  Returns nil if no error is available"

| arr str |
arr := self fetchErrorStringArray .
arr size > 0 ifTrue:[
  str := String new .
  1 to: arr size do:[:j | str add: (arr at: j); add: '; ' ].
] ifFalse:[
  str := super lastErrorString .
].
^ str
%

category: 'Instance Creation'
classmethod: GsSecureSocket
new
  self shouldNotImplement: #new
%

category: 'Instance Creation'
classmethod: GsSecureSocket
new: aSize
  self shouldNotImplement: #new:
%

category: 'Instance Creation'
classmethod: GsSecureSocket
newClient

"Creates a new instance and initializes it to act as a AF_INET client socket.
 No connection is made."

^ super new initializeAsClient
%

category: 'Instance Creation'
classmethod: GsSecureSocket
newClientFromGsSocket: aGsSocket

"Creates a new instance and initializes it to act as an SSL client socket.
 Any existing (non-SSL) connection owned by aGsSocket is transferred to the
 new instance and aGsSocket is effectively closed. No SSL connection is made."

^ super new initializeAsClientFromGsSocket: aGsSocket
%

category: 'Instance Creation'
classmethod: GsSecureSocket
newClientIpv6

"Creates a new instance and initializes it to act as a AF_INET6 client socket.
 No connection is made."

^ super newIpv6 initializeAsClient
%

category: 'Instance Creation'
classmethod: GsSecureSocket
newClientIpv6FromGsSocket: aGsSocket

"Creates a new IPv6 instance and initializes it to act as an SSL client socket.
 Any existing (non-SSL) connection owned by a GsSocket is transferred to the
 new instance and aGsSocket is effectively closed. No SSL connection is made."

^ super newIpv6 initializeAsClientFromGsSocket: aGsSocket
%

category: 'Instance Creation'
classmethod: GsSecureSocket
newServer

"Creates a new instance and initializes it to act as a AF_INET server socket.
 No connection is made."

^ super new initializeAsServer
%

category: 'Instance Creation'
classmethod: GsSecureSocket
newServerFromGsSocket: aGsSocket

"Creates a new instance and initializes it to act as an SSL server socket.
 Any existing (non-SSL) connection owned by aGsSocket is transferred to the
 new instance and aGsSocket is effectively closed. No SSL connection is made."

^ super new initializeAsServerFromGsSocket: aGsSocket
%

category: 'Instance Creation'
classmethod: GsSecureSocket
newServerIpv6

"Creates a new instance and initializes it to act as a AF_INET6 server socket.
 No connection is made."

^ super newIpv6 initializeAsServer
%

category: 'Instance Creation'
classmethod: GsSecureSocket
newServerIpv6FromGsSocket: aGsSocket

"Creates a new IPv6 instance and initializes it to act as an SSL server socket.
 Any existing (non-SSL) connection owned by a GsSocket is transferred to the
 new instance and aGsSocket is effectively closed. No SSL connection is made."

^ super newIpv6 initializeAsServerFromGsSocket: aGsSocket
%

category: 'Examples'
classmethod: GsSecureSocket
serverExample

^ self serverExample: true usingPort: 57785 on: 'localhost'
%

category: 'Examples'
classmethod: GsSecureSocket
serverExample2

^ self serverExample2: true usingPort: 57785 on: 'localhost'
%

category: 'Examples'
classmethod: GsSecureSocket
serverExample2: logToGciClient usingPort: portNum on: host

"This version uses GsSecureSocket instance methods for setup rather
 than class methods."

| listener sslServer pw |

[
  | failBlock bigStr result data dataSizeString |

  failBlock := [:sock :shouldLog | | err arr |
    err := sock fetchLastIoErrorString .
    err ifNotNil: [GsFile gciLog: err onClient: shouldLog].
    arr := sock class fetchErrorStringArray .
    1 to: arr size do: [:n| GsFile gciLog: (arr at: n) onClient: shouldLog ].
    sock close.
    SocketError signal: err asString.
  ].

  "Create a new SSL server socket."
  listener := self newServer.

  "Make it listen for the client."
  (listener makeServerAtPort: portNum) ifNil: [ | err |
  	err := listener lastErrorString.
  	listener close.
  	SocketError signal: 'makeServerAtPort failed, ', err asString.
   ].

  listener port == portNum ifFalse:[ SocketError signal: 'bad port number ', listener port asString ] .

  GsFile gciLog: 'Waiting for GsSecureSocket clientExample to connect...'
  	onClient: logToGciClient .
  [listener readWillNotBlockWithin: 5000] whileFalse: [
  	GsFile gciLog: 'waiting...' onClient: logToGciClient
    	].

  GsFile gciLog: 'Client connected.' onClient: logToGciClient .

  "Do the normal accept to establish a standard socket connection."
  "sslServer is our connection to the client."
  sslServer := listener accept .

  GsFile gciLog: 'Normal accept completed OK.' onClient: logToGciClient .

  "uncomment next to put the socket in blocking mode."
  "sslServer makeBlocking."

  "Don't request a certificate from the client.  This is typical."
  sslServer disableCertificateVerification.

  "sslServer has only a normal connection to the peer.  If will have a secure
   connection if secureAccept succeeds."

  "Example of using an encrypted private key that requires a passphrase."
   pw := self getPasswordFromFile: '$GEMSTONE/examples/openssl/private/server_1_server_passwd.txt' .
   sslServer useCertificateFile: '$GEMSTONE/examples/openssl/certs/server_1_servercert.pem'
    withPrivateKeyFile: '$GEMSTONE/examples/openssl/private/server_1_serverkey.pem'
    privateKeyPassphrase: pw.

  "Use all ciphers except NULL ciphers and anonymous Diffie-Hellman
   and sort by strength."
  sslServer setCipherListFromString: 'ALL:!ADH:@STRENGTH' .

  ([sslServer secureAccept] on: SocketError do:[:ex| | certError |
    GsFile gciLog: 'secureAccept failed.'  onClient: logToGciClient.
    certError := sslServer class fetchLastCertificateVerificationErrorForServer .
    certError ifNil: [
        GsFile gciLog: 'nil result from fetchLastCertificateVerificationErrorForServer'
           onClient: logToGciClient
    ] ifNotNil:[
        GsFile gciLog: ('Cert error: =>' , certError)
           onClient: logToGciClient.].
	ex pass
    ])
      ifTrue:[ GsFile gciLog: 'Secure connection established.'
                      onClient: logToGciClient ].

  "If we get here, we have a secure connection to the client."

  GsFile gciLog: ('Current cipher in use is: ', sslServer fetchCipherDescription)
         onClient: logToGciClient.

  "Build data to send"
  data := Array new.
  4096 timesRepeat: [ data add: (String withAll: '0123456789ABCDEF') ].
  bigStr := String new .
  PassiveObject passivate: data toStream: (WriteStream on: bigStr).
  dataSizeString := bigStr size asHexStringWithLength: 8.
  dataSizeString size > 8 ifTrue:
      [UserDefinedError signal: 'Protocol Error, attempt to send more than 4294967295 bytes'].

  GsFile gciLog: 'Sending data length to client: ', bigStr size asString,
      ' bytes, encoded as ', dataSizeString onClient: logToGciClient.

  result := sslServer write: dataSizeString.
  result == dataSizeString size
    ifTrue: [ GsFile gciLog: 'Finished sending length to peer'
  		onClient: logToGciClient ]
    ifFalse: [ GsFile gciLog: 'write of length bytes failed, result was ', result asString
                  onClient: logToGciClient .
              failBlock value: sslServer value: logToGciClient.
  		].

  GsFile gciLog: 'Sending ', bigStr size asString, ' bytes to client'
         onClient: logToGciClient.
  result := sslServer write: bigStr .
  result == bigStr size
    ifTrue:[ GsFile gciLog: ('Finished sending ', bigStr size asString, ' bytes to peer')
                     onClient: logToGciClient ]
    ifFalse:[ GsFile gciLog: ('write failed, result was ', result asString)
                     onClient: logToGciClient .
              failBlock value: sslServer value: logToGciClient.
              ].
] on: SocketError do:[:ex|
        sslServer ifNotNil:[ sslServer close ].
        listener ifNotNil:[ listener close ].
        ex pass
].

"close method will close the SSL connection and underlying socket."
sslServer close.
listener close .
^ true
%

category: 'Examples'
classmethod: GsSecureSocket
serverExample: logToGciClient usingPort: portNum on: host

| listener sslServer pw |

[ | failBlock bigStr result data dataSizeString |
  failBlock := [:sock :shouldLog | | err arr |
    err := sock fetchLastIoErrorString .
    err ifNotNil: [GsFile gciLog: err onClient: shouldLog].
    arr := sock class fetchErrorStringArray .
    1 to: arr size do: [:n| GsFile gciLog: (arr at: n) onClient: shouldLog ].
    sock close.
    SocketError signal: err asString.
  ].

  "Specify the certificate and private key to use for all server connections in
   this gem.  Both must be in PEM format.  Private key and certificate may be
   contained in the same PEM file or in different files as we show here."

   pw := self getPasswordFromFile: '$GEMSTONE/examples/openssl/private/server_1_server_passwd.txt' .

   GsSecureSocket useServerCertificateFile: '$GEMSTONE/examples/openssl/certs/server_1_servercert.pem'
    withPrivateKeyFile: '$GEMSTONE/examples/openssl/private/server_1_serverkey.pem'
    privateKeyPassphrase: pw .

  "Don't request a certificate from the client.  This is typical."
  GsSecureSocket disableCertificateVerificationOnServer .

  "Use all ciphers except NULL ciphers and anonymous Diffie-Hellman
   and sort by strength."
  GsSecureSocket setServerCipherListFromString: 'ALL:!ADH:@STRENGTH' .

  "All class methods have been executed, so now we can create the instance.
   Class methods executed AFTER the instance is created will NOT APPLY to
   the instance!"

  "Create a new SSL server socket."
  listener := self newServer.

  "Make it listen for the client."
  (listener makeServerAtPort: portNum) ifNil: [ | err |
  	err := listener lastErrorString.
  	listener close.
  	SocketError signal: 'makeServerAtPort failed, ', err asString.
          ].

  listener port == portNum ifFalse:[ Error signal: 'bad port number' ] .

  GsFile gciLog: 'Waiting for GsSecureSocket clientExample to connect...'
  	onClient: logToGciClient .
  [listener readWillNotBlockWithin: 5000] whileFalse: [
  	GsFile gciLog: 'waiting...' onClient: logToGciClient
    	].

  GsFile gciLog: 'Client connected.' onClient: logToGciClient .

  "Do the normal accept to establish a standard socket connection."
  "sslServer is our connection to the client."
  sslServer := listener accept .
  sslServer ifNil: [| err |
          err := listener lastErrorString.
          listener close.
  	SocketError signal: 'accept failed, ', err asString.
  	].

  GsFile gciLog: 'Normal accept completed OK.' onClient: logToGciClient .

  "uncomment next to put the socket in blocking mode."
  "sslServer makeBlocking."

  "sslServer has only a normal connection to the peer.  If will have a secure
    connection if secureAccept succeeds."

  ([sslServer secureAccept] on: SocketError do:[:ex| | certError |
    GsFile gciLog: 'secureAccept failed.'  onClient: logToGciClient.
    certError := sslServer class fetchLastCertificateVerificationErrorForServer .
    certError ifNil: [
        GsFile gciLog: 'nil result from fetchLastCertificateVerificationErrorForServer'
           onClient: logToGciClient
    ] ifNotNil:[
        GsFile gciLog: ('Cert error: =>' , certError)
           onClient: logToGciClient.].
	ex pass
    ])
      ifTrue:[ GsFile gciLog: 'Secure connection established.'
                      onClient: logToGciClient ].

  "If we get here, we have a secure connection to the client."

  GsFile gciLog: ('Current cipher in use is: ', sslServer fetchCipherDescription)
         onClient: logToGciClient.

  "Build data to send"
  data := Array new.
  4096 timesRepeat: [ data add: (String withAll: '0123456789ABCDEF') ].
  bigStr := String new .
  PassiveObject passivate: data toStream: (WriteStream on: bigStr).
  dataSizeString := bigStr size asHexStringWithLength: 8.
  dataSizeString size > 8 ifTrue:
      [UserDefinedError signal: 'Protocol Error, attempt to send more than 4294967295 bytes'].

  GsFile gciLog: 'Sending data length to client: ', bigStr size asString,
      ' bytes, encoded as ', dataSizeString onClient: logToGciClient.

  result := sslServer write: dataSizeString.
  result == dataSizeString size
    ifTrue: [ GsFile gciLog: 'Finished sending length to peer'
  		onClient: logToGciClient ]
    ifFalse: [ GsFile gciLog: 'write of length bytes failed, result was ', result asString
                  onClient: logToGciClient .
              failBlock value: sslServer value: logToGciClient.
  		].

  GsFile gciLog: 'Sending ', bigStr size asString, ' bytes to client'
         onClient: logToGciClient.
  result := sslServer write: bigStr .
  result == bigStr size
    ifTrue:[ GsFile gciLog: ('Finished sending ', bigStr size asString, ' bytes to peer')
                     onClient: logToGciClient ]
    ifFalse:[ GsFile gciLog: ('write failed, result was ', result asString)
                     onClient: logToGciClient .
              failBlock value: sslServer value: logToGciClient.
              ].
  "close method will close the SSL connection and underlying socket."
] on: SocketError do:[:ex|
        sslServer ifNotNil:[ sslServer close ].
        listener ifNotNil:[ listener close ].
        ex pass
].

sslServer close.
listener close .
^ true
%

category: 'Peer Authentication'
classmethod: GsSecureSocket
setCertificateVerificationOptionsForServer: anArray

"Sets the certificate verification options for server sockets using an Array of
 Symbols.  The supported server options are:

 #SSL_VERIFY_FAIL_IF_NO_PEER_CERT
    if the client did not return a certificate, the TLS/SSL handshake is
    immediately terminated with a 'handshake failure' alert.

 #SSL_VERIFY_CLIENT_ONCE
    only request a client certificate on the initial TLS/SSL handshake.
    Do not ask for a client certificate again in case of a renegotiation.

 Refer to the OpenSSL documentation for more information about these options.

 If anArray is empty then any previously set options are cleared.

 Has no effect on instances created before the method was called.

 Raises an error if the array contains any elements besides the above symbols.

 Certificate verification for server sockets must be enabled before executing this
 method, otherwise an error is raised.  Use the #enableCertificateVerificationOnServer
 method to enable certification verification.

 Returns true of success or raises an exception on error."

^ (self _oneArgSslPrim: 6 with: anArray)
    ifTrue:[ true ]
    ifFalse:[ self signalError ]
%

category: 'Ciphers'
classmethod: GsSecureSocket
setClientCipherListFromString: aString

"Specify the cipher list to be used by all client connections.  aString must be an
 instance of String in the format described in the man page for ciphers(1). See
   http://www.openssl.org/docs/apps/ciphers.html

 The ciphers loaded into the internal SSL state are valid for the
 current session only; that SSL state is not committed to the repository.

 Returns true if one or more of the specified ciphers are usable or raises
 an exception if an error occurs."

^ (self _oneArgSslPrim: 3 with: aString)
     ifTrue:[ true ]
     ifFalse:[ self signalError ]
%

category: 'Ciphers'
classmethod: GsSecureSocket
setServerCipherListFromString: aString

"Specify the cipher list to be used by all server connections.  aString must be an
 instance of String in the format described in the man page for ciphers(1).  See
   http://www.openssl.org/docs/apps/ciphers.html

 The ciphers loaded into the internal SSL state are valid for the
 current session only; that SSL state is not committed to the repository.

 Returns true if one or more of the specified ciphers are usable or raises an error
 if an error occurs."

^ (self _oneArgSslPrim: 4 with: aString)
     ifTrue:[ true ]
     ifFalse:[ self signalError ]
%

category: 'Error Reporting'
classmethod: GsSecureSocket
signalError
  ^ SecureSocketError signal: (self lastErrorString ifNil:[ 'no details' ]).
%

category: 'Error Reporting'
classmethod: GsSecureSocket
signalError: aString
  ^ SecureSocketError signal:
      (self lastErrorString ifNotNil:[:s | aString , ', ' , s]  ifNil:[ aString ]).
%

category: 'Querying'
classmethod: GsSecureSocket
sslLibraryVersionString

"Answer an instance of String which describes the version of OpenSSL library loaded by this session."

^ self _zeroArgSslPrim: 19
%

category: 'Examples'
classmethod: GsSecureSocket
startTlsClientExample: logToGciClient usingPort: portNum address: serverAddress

"logToGciClient is a Boolean, true if GsFile-based logging is to be done to
 the RPC Gci client, false if to the server process's log file. Use false if
 executing via topaz 'nbrun'  .

 This client will connect to a server created with serverStartTlsExample.
 Then it will send 4 strings to the server and string 'OK' back to indicate
 the data was received.  Then the client will send the string 'STARTTLS' to
 tell the server to switch to encrypted communication. Once it receives back
 the 'OK' string, it will create a GsSecureSocket from the GsSocket and call
 secureConnect to establish a TLS connection. It will then print the cipher
 being used and close the connection.

 All strings sent and received are expected to be NULL-terminated.

 The server should already be listening for connections when this method is
 invoked. Start the server before starting the client."

| sslClient |

[
  | socket dataString chunk sleepCount outString failBlock |

  socket := GsSocket new.
  (socket connectTo: portNum on: serverAddress) ifFalse:[
    socket close .
    Error signal: 'Unable to connect to port ' , portNum asString ,
      '. Wait 30 seconds or so, then ensure startTlsServerExample is started first.'
    ].
  dataString := String new .
  outString := String new.

  "Exchange some unencrypted data messages"
  1 to: 5 do:[:n| | numWritten|
    sleepCount := 0.
    [ socket writeWillNotBlockWithin: 5000] whileFalse: [
      GsFile gciLog: 'Waiting to write to server...' onClient: logToGciClient .
      sleepCount := sleepCount + 1.
      sleepCount > 200 ifTrue:[
        GsFile gciLog: 'Not ready to write after 20 sec' onClient: logToGciClient.
        Error signal: 'Not ready to read after 20 sec' .
      ].
      System _sleepMs: 100 . "sleep 100 ms then retry"
    ].

    outString size: 0.
    n == 5
      ifTrue:[ outString addAll: 'STARTTLS']
      ifFalse:[ outString addAll: DateTime now asString] .
    outString add: (Character withValue: 0).

    numWritten := socket write: outString.
    GsFile gciLog: 'wrote ', numWritten asString, ' bytes'  onClient: logToGciClient .
    numWritten == outString size ifFalse:[ Error signal: 'error writing to socket'].
    [ socket readWillNotBlockWithin: 10000] whileFalse: [
        GsFile gciLog: 'Waiting for server to write...' onClient: logToGciClient .
    ].

    GsFile gciLog: 'Got something from the server to read.' onClient: logToGciClient .
    dataString size: 0.
    [
      chunk := socket readString: 4000.
      chunk ifNil:[ Error signal: 'Error in reading from socket' ].
      dataString addAll: chunk .
      (chunk at: chunk size) == (Character withValue: 0)  "read until null terminator"
    ] untilTrue .
    n == 5 ifFalse:[ System _sleepMs: 250 ].
  ].

  failBlock := [:sock :shouldLog| | err arr |
    err := sock fetchLastIoErrorString .
    err ifNotNil: [GsFile gciLog: err onClient: shouldLog].
    arr := sock class fetchErrorStringArray .
    1 to: arr size do:[:n| GsFile gciLog: (arr at: n) onClient: shouldLog ].
    sock close.
    SocketError signal: err asString.
  ].

  "Specify the file which contains a list of trusted CA certificates.
   These will be used to validate the certificate presented by the peer
   during the SSL handshake.  The file must be in PEM format.
   Currently, there is no easy way to specify the CA list from a String.
   This must be done before creating the instance of GsSecureSocket! "
  GsSecureSocket useCACertificateFileForClients:
        '$GEMSTONE/examples/openssl/certs/cacert.pem'.


  "Transfer connection from socket to a new SSL socket."
  sslClient:= GsSecureSocket newClientFromGsSocket: socket .
  sslClient ifNil:[ Error signal: 'Error: newClientFromGsSocket: method failed'].
  "close the old one. This will NOT close the file descriptor."
  socket close.

  "Request a cert from the server"
  sslClient enableCertificateVerification .

  "Set the cipher list for this SSL socket only.
   Use all ciphers except NULL ciphers and anonymous Diffie-Hellman
   and sort by strength."
  (sslClient setCipherListFromString: 'ALL:!ADH:@STRENGTH')
    ifFalse:[ GsFile gciLog: 'setCipherListFromString: failed'
                    onClient: logToGciClient
    ].

  "Attempt to establish a secure connection to the SSL server..."
  ([sslClient secureConnect]
    on: SocketError
    do:[:ex| |certError|
      GsFile gciLog: 'secureConnect failed' onClient: logToGciClient.
      certError := GsSecureSocket fetchLastCertificateVerificationErrorForClient .
      certError ifNil: [
         GsFile gciLog: 'nil result from fetchLastCertificateVerificationErrorForClient'
                onClient: logToGciClient
          ] ifNotNil: [
          GsFile gciLog: ('Cert error: =>' , certError) onClient: logToGciClient].
      ex pass.
    ])
    ifTrue:[ GsFile gciLog: 'Secure connection established'
                    onClient: logToGciClient].

  "We have a secure connection to the server if we get here."
  GsFile gciLog: ('Current cipher in use is: ', sslClient fetchCipherDescription)
         onClient: logToGciClient.
] on: SocketError do:[:ex| sslClient close. ex pass ].
sslClient close.
^ true.
%

category: 'Examples'
classmethod: GsSecureSocket
startTlsServerExample: logToGciClient usingPort: portNum address: listeningAddress

"logToGciClient is a Boolean, true if GsFile-based logging is to be done to
 the RPC Gci client, false if to the server process's log file.  Use false if
 executing via topaz 'nbrun'.

 Creates a GsSocket, binds it to port portNum, and waits for a connection.
 When a connection is established, waits for unencrypted data from the client.
 Sends OK back to the client to indicate unencrypted data was received.
 If the unencrypted data contains the string STARTTLS, then a GsSecureSocket
 is created from the GsSocket and secureAccept: is called to negotiate an
 encrypted connection. Once the encrypted connection is established, the
 cipher in use is printed and the connection is closed.

 All strings sent and received are expected to be NULL-terminated.

 You will need two GemStone sessions running from two independent
 interface processes to run both this and the startTlsClientExample.

 Warning: This method will cause your current session to hang until a
 connection is established."

| server client sslServer |
[
  | numWritten errStr sleepTime starttls resultString
    chunk failBlock dataString pw |

  server := GsSocket new.
  (server makeServer: 5 atPort: portNum atAddress: listeningAddress) ifNil: [
    errStr := server lastErrorString.
    server close.
    server := nil.
    Error signal: errStr.
    ].

  server port == portNum ifFalse:[ Error signal: 'bad port number' ] .
  GsFile gciLog: 'Waiting for GsSecureSocket startTlsClientExample to connect...'
  	onClient: logToGciClient .
  [server readWillNotBlockWithin: 10000] whileFalse: [
    GsFile gciLog: 'waiting...' onClient: logToGciClient
  ].

  GsFile gciLog: 'Client connected, starting accept.' onClient: logToGciClient .
  client := server accept .
  GsFile gciLog: 'accept finished. client = ', client asString  onClient: logToGciClient .
  client ifNil: [
    errStr := server lastErrorString.
    server close.
    server := nil .
    GsFile gciLog: 'error from accept, ', errStr onClient: logToGciClient .
    Error signal: errStr.
  ].
  server close.
  server := nil.
  client linger: true length: 10.  "wait after closing until data is processed"
  dataString := String new.
  resultString := String withAll: 'OK'.
  resultString add: (Character withValue: 0).
  starttls := false.

  "Keep receiving normal data and sending OK back until we see STARTTLS"
  [starttls] whileFalse:[
    [ client readWillNotBlockWithin: 10000] whileFalse: [
      GsFile gciLog: 'Waiting for client to write...' onClient: logToGciClient .
    ].
    dataString size: 0.
    GsFile gciLog: 'Got something from the client to read.' onClient: logToGciClient .
    [
      chunk := client readString: 4000 "max bytes".
      chunk ifNil:[ Error signal: 'Error in reading from socket' ].
      dataString addAll: chunk .
      (chunk at: chunk size) == (Character withValue: 0)  "until null terminator"
    ] untilTrue .

    sleepTime := 0 .
    [ client writeWillNotBlock ] whileFalse:[
      sleepTime == 0 ifTrue:[
         GsFile gciLog: 'waiting because write to client would block' onClient: logToGciClient.
      ].
      sleepTime > 5000 ifTrue:[
        GsFile gciLog: 'ERROR, client would block' onClient: logToGciClient .
        Error signal: 'socket write will block'
      ].
      System _sleepMs: 20 .
      sleepTime := sleepTime + 20 .
    ].
    "Got all the data, send back OK"
    numWritten := client write: resultString .
    GsFile gciLog: 'wrote ', numWritten asString, ' bytes'  onClient: logToGciClient .
    numWritten == resultString size ifFalse:[ Error signal: 'error writing to socket'].
    starttls := (dataString findString: 'STARTTLS' startingAt: 1) ~~ 0 .
  ].

  "Client has sent STARTTLS. Create new SSL server socket using existing client
   connection.  Socket file descriptor is transferred to sslServer."
  sslServer := GsSecureSocket newServerFromGsSocket: client .
  sslServer ifNil:[ Error signal: 'Failed to create GsSecureSocket from GsSocket'].
  client close. "will not close the underlyding file descriptor"
  client := nil .
  "do not request a certificate from the client"
  sslServer disableCertificateVerification.

  failBlock := [:sock :shouldLog| | err arr |
    err := sock fetchLastIoErrorString .
    err ifNotNil: [GsFile gciLog: err onClient: shouldLog].
    arr := sock class fetchErrorStringArray .
    1 to: arr size do:[:n| GsFile gciLog: (arr at: n) onClient: shouldLog ].
    sock close.
    SocketError signal: err asString.
  ].

  "Example of using an encrypted private key that requires a passphrase."
   pw := self getPasswordFromFile: '$GEMSTONE/examples/openssl/private/server_1_server_passwd.txt' .
   sslServer useCertificateFile: '$GEMSTONE/examples/openssl/certs/server_1_servercert.pem'
             withPrivateKeyFile: '$GEMSTONE/examples/openssl/private/server_1_serverkey.pem'
             privateKeyPassphrase: pw .

  "Use all ciphers except NULL ciphers and anonymous Diffie-Hellman and sort by strength."
  sslServer setCipherListFromString: 'ALL:!ADH:@STRENGTH' .

  GsFile gciLog: 'Waiting for client to secureConnect: ...' onClient: logToGciClient .

  ([sslServer secureAccept] on: SocketError do:[:ex| | certError |
    GsFile gciLog: 'secureAccept failed.'  onClient: logToGciClient.
    certError := sslServer class fetchLastCertificateVerificationErrorForServer .
    certError ifNil: [
        GsFile gciLog: 'nil result from fetchLastCertificateVerificationErrorForServer'
           onClient: logToGciClient
    ] ifNotNil:[
        GsFile gciLog: ('Cert error: =>' , certError) onClient: logToGciClient.].
  	ex pass
      ])
      ifTrue:[ GsFile gciLog: 'Secure connection established.'
                      onClient: logToGciClient ].

  "If we get here, we have a secure connection to the client."

  GsFile gciLog: ('Current cipher in use is: ', sslServer fetchCipherDescription)
         onClient: logToGciClient.
] on: SocketError do:[:ex|
        sslServer ifNotNil:[ sslServer close ].
        server ifNotNil:[ server close ].
	client ifNotNil:[ client close ].
        ex pass
].

sslServer close .
^ true
%

category: 'Certificate Authorities'
classmethod: GsSecureSocket
useCACertificateDirectoryForClients: aDirectoryString

"Specifies a directory where trusted certificate authority (CA) certificates in
 PEM format are located. The certificates in this directory will be used to
 authenticate certificates provided by servers during the SSL handshake. The
 directory may contain more than one certificate.

 Certificates are loaded into the internal SSL state which is valid for the
 current session only; the SSL state is not committed to the repository.

 Has no effect on instances created before the method was called or server
 instances of GsSecureSocket.

 If successful, this method also enables certificate verification for client
 sockets as if the #enableCertificateVerificationOnClient method had been called
 immediately following this method.

 Returns true on success or false if an error occurs.  Raises an
 exception if the directory does not exist."

^ (self _oneArgSslPrim: 8 with: aDirectoryString)
    ifTrue:[ true ]
    ifFalse:[ self signalError ]
%

category: 'Certificate Authorities'
classmethod: GsSecureSocket
useCACertificateDirectoryForServers: aDirectoryString

"Specifies a directory where trusted certificate authority (CA) certificates in
 PEM format are located. The certificates in this directory will be used to
 authenticate certificates provided by client during the SSL handshake. The
 directory may contain more than one certificate.

 Certificates are loaded into the internal SSL state which is valid for the
 current session only; the SSL state is not committed to the repository.

 Has no effect on instances created before the method was called or client
 instances of GsSecureSocket.

 If successful, this method also enables certificate verification for server
 sockets as if the #enableCertificateVerificationOnServer method had been called
 immediately following this method.

 Returns true on success or false if an error occurs.  Raises an
 exception if the directory does not exist."

^ (self _oneArgSslPrim: 9 with: aDirectoryString)
    ifTrue:[ true ]
    ifFalse:[ self signalError ]
%

category: 'Certificate Authorities'
classmethod: GsSecureSocket
useCACertificateFileForClients: aFileNameString

"Attempt to load given CA Certificate file which must be in PEM format.
 The file may contain more than one certificate.  If the file is loaded
 successfully, it will be used by SSL clients to validate all certificates
 presented by SSL servers during the SSL handshake.

 The certificates loaded into the internal SSL state are valid for the
 current session only; that SSL state is not committed to the repository.

 Has no effect on instances created before the method was called.

 Also enables certificate verification for client sockets as if
 the #enableCertificateVerificationOnClient method had been called
 immediately following this method.

 Returns true on success raises an exception if an error occurs or the
 file does not exist."

 ^ (self _oneArgSslPrim: 1 with: aFileNameString)
     ifTrue:[ true ]
     ifFalse:[ self signalError: 'useCACertificateFileForClients: failed' ]
%

category: 'Certificate Authorities'
classmethod: GsSecureSocket
useCACertificateFileForServers: aFileNameString

"Attempt to load given CA Certificate file which must be in PEM format.
 The file may contain more than one certificate.  The certificates
 are considered to be trusted and will be used to validate certificates
 presented by SSL clients.  Note that authentication of clients is disabled
 by default and must be enabled in order for this method to have any effect.

 The certificates loaded into the internal SSL state are valid for the
 current session only; that SSL state is not committed to the repository.

 Has no effect on instances created before the method was called.

 Also enables certificate verification for server sockets as if
 the #enableCertificateVerificationOnServer method had been called
 immediately following this method.

 Returns true on success or raises an exception if an error occurs or
 the file does not exist."

 ^ (self _oneArgSslPrim: 2 with: aFileNameString)
     ifTrue:[ true ]
     ifFalse:[ self signalError: 'useCACertificateFileForServers: failed' ]
%

category: 'Certificates and Keys'
classmethod: GsSecureSocket
useClientCertificate: aString withPrivateKey: anotherString privateKeyPassphrase: passPhrase

"Specifies the certificate string and private key string to be used by all
 client connections.  The private key must match the certificate.

 The certificates loaded into the internal SSL state are valid for the
 current session only; that SSL state is not committed to the repository.

 Both strings must be in PEM format.  If the private key requires a passphrase,
 it is specified in the passPhrase argument as a String.  If no passphrase is
 required, then the passPhrase argument is expected to be nil.

 Both strings must exactly match the contents of the corresponding certificate files
 (including white-space characters) or the strings will not be accepted.

 Returns true on success or raises an exception if an error occurs."

^ (self _threeArgSslPrim: 4 with: aString with: anotherString with: passPhrase)
     ifTrue:[ true ]
     ifFalse:[ self signalError ]
%

category: 'Certificates and Keys'
classmethod: GsSecureSocket
useClientCertificateFile: certFile withPrivateKeyFile: keyFile privateKeyPassphrase: pass

"Specifies the certificate file and private key file to be used by all
 client connections.  The private key must match the certificate.

 The certificates loaded into the internal SSL state are valid for the
 current session only; that SSL state is not committed to the repository.

 Both files must be in PEM format.

 The certificate file may contain a certificate chain or a single certificate.

 If the private key requires a passphrase, it is to be specified as String
 passed in using the pass argument.  If the private key does not require a
 passphrase, then the pass argument is expected to be nil.

 Both file arguments must be instances of String.

 Returns true on success or raises an exception if an error occurs or
 the file does not exist."

^ (self _threeArgSslPrim: 7 with: certFile with: keyFile with: pass)
     ifTrue:[ true ]
     ifFalse:[ self signalError ]
%

category: 'Certificates and Keys'
classmethod: GsSecureSocket
useServerCertificate: aString withPrivateKey: anotherString privateKeyPassphrase: passPhrase

"Specifies the certificate string and private key string to be used by all
 server connections.  The private key must match the certificate.

 The certificates loaded into the internal SSL state are valid for the
 current session only; that SSL state is not committed to the repository.

 Both strings must be in PEM format.  If the private key requires a passphrase,
 it is specified in the passPhrase argument as a String.  If no passphrase is
 required, then the passPhrase argument is expected to be nil.

 Both strings must exactly match the contents of the corresponding certificate files
 (including white-space characters) or the strings will not be accepted.

 Returns true on success or raises an exception if an error occurs."

^ (self _threeArgSslPrim: 3 with: aString with: anotherString with: passPhrase)
     ifTrue:[ true ]
     ifFalse:[ self signalError ]
%

category: 'Certificates and Keys'
classmethod: GsSecureSocket
useServerCertificateFile: certFile withPrivateKeyFile: keyFile privateKeyPassphrase: pass

"Specifies the certificate file and private key file to be used by all
 server connections.  The private key must match the certificate.

 Both files must be in PEM format.

 The certificate file may contain a certificate chain or a single certificate.

 If the private key requires a passphrase, it is to be specified as String
 passed in using the pass argument.  If the private key does not require a
 passphrase, then the pass argument is expected to be nil.

 Both file arguments must be instances of String.

 The certificates loaded into the internal SSL state are valid for the
 current session only; that SSL state is not committed to the repository.

 Returns true on success or raises an exception if an error occurs or
 the file does not exist."

^ (self _threeArgSslPrim: 6 with: certFile with: keyFile with: pass)
     ifTrue:[ true ]
     ifFalse:[ self signalError ]
%

category: 'Private'
classmethod: GsSecureSocket
_newClientNoSslState

"Used in hostagent code.
 Creates a new instance with no connection and no ssl state and a AF_INET client socket."

^ super new 
%

category: 'Private'
classmethod: GsSecureSocket
_oneArgSslPrim: opcode with: arg

"opcode  function
   1        class method: useCACertificateFileForClients:
   2        class method: useCACertificateFileForServers:
   3        class method: setClientCipherListFromString:
   4        class method: setServerCipherListFromString:
   5     instance method: setCipherListFromString:
   6        class method: setCertificateVerificationOptionsForServer:
   7     instance method: setCertificateVerificationOptions:
   8        class method: useCACertificateDirectoryForClients:
   9        class method: useCACertificateDirectoryForServers:
  10     instance method: initializeAsServerFromGsSocket:
  11     instance method: initializeAsClientFromGsSocket:
  12     instance method: _installSsl:
  13     instance method: setServerNameIndication:
"

<primitive: 910>
^ self _primitiveFailed: #_oneArgSslPrim:with: args: { opcode . arg }
%

category: 'Private'
classmethod: GsSecureSocket
_threeArgSslPrim: opcode with: arg1 with: arg2 with: arg3

"opcode  function
   1     instance method: _write:startingAt:ofSize:
   2     instance method: _readInto:startingAt:maxBytes:
   3        class method: useServerCertificate: withPrivateKey: privateKeyPassphrase:
   4        class method: useClientCertificate: withPrivateKey: privateKeyPassphrase:
   5     instance method: useCertificate: withPrivateKey: privateKeyPassphrase:
   6:       class method: useServerCertificateFile:withPrivateKeyFile:privateKeyPassphrase:
   7:       class method: useClientCertificateFile:withPrivateKeyFile:privateKeyPassphrase:
   8:    instance method: useCertificateFile:withPrivateKeyFile::privateKeyPassphrase:
"
<primitive: 909>
^ self _primitiveFailed: #_threeArgSslPrim:with:with:with:
  args: { opcode . arg1 . arg2 . arg3 }
%

category: 'Private'
classmethod: GsSecureSocket
_zeroArgSslPrim: opcode

"opcode  function
   1     instance method: secureConnect
   2     instance method: secureAccept
   3     instance method: hasSecureConnection
   4     instance method: secureClose
   5     instance method: fetchLastIoErrorString
   6        class method: fetchErrorStringArray
   7        class method: clearErrorQueue
   8        class method: disableCertificateVerificationOnClient
   9        class method: enableCertificateVerificationOnClient
  10        class method: disableCertificateVerificationOnServer
  11        class method: enableCertificateVerificationOnServer
  12     instance method: initializeAsClient
  13     instance method: initializeAsServer
  14        class method: fetchLastCertificateVerificationErrorForServer
  15        class method: fetchLastCertificateVerificationErrorForClient
  16     instance method: fetchCipherDescription
  17     instance method: disableCertificateVerification
  18     instance method: enableCertificateVerification
  19        class method: sslLibraryVersionString
  20     instance method: _peek
  21     instance method: certificateVerificationEnabled
  22        class method: certificateVerificationEnabledOnClient
  23        class method: certificateVerificationEnabledOnServer
  24     instance method: fetchCertificateVerificationOptions
  25        class method: fetchCertificateVerificationOptionsForServer
  26     instance method:  _noFreeSslOnGc
  27     instance method: getServerNameIndication
"

<primitive: 908>
^ self _primitiveFailed: #_zeroArgSslPrim: args: { opcode }
%

!		Instance methods for 'GsSecureSocket'

category: 'Server Operations'
method: GsSecureSocket
accept

"Causes the receiver to perform a normal socket accept operation (see the
 accept method in GsSocket for more information).  If the accept is
 successful, then it also initializes the newly created socket as an SSL
 server socket.

 Returns the new socket raises and exception if an error occurs."

| newServer |
newServer := super accept .
newServer ifNil:[ ^ super signalError: 'accept failed' ]. "Normal accept failed"
newServer initializeAsServer . "SSL init as a server socket"
^ newServer
%

category: 'Server Operations'
method: GsSecureSocket
acceptTimeoutMs: timeoutMs

  | newServer |
  newServer := super acceptTimeoutMs: timeoutMs .
  newServer ifNil:[ ^ super signalError: 'acceptTimeoutMs: failed' ]. "Normal accept failed"
  newServer initializeAsServer . "SSL init as a server socket"
  ^ newServer
%

category: 'Querying'
method: GsSecureSocket
certificateVerificationEnabled

"Answer true if certificate verification is enabled on the receiver.
 Otherwise answer false."

^ self _zeroArgSslPrim: 21
%

category: 'Socket Operations'
method: GsSecureSocket
close

"Closes the secure connection and releases memory used by the receiver's
 SSL connection if it exists.  Then closes the underlying socket connection.

 Returns self if the socket was closed successfully or nil if an error occurs."

self hasSecureConnection
  ifTrue: [ self secureClose ].
^ super close
%

category: 'Peer Authentication'
method: GsSecureSocket
disableCertificateVerification
"Directs the receiver to not request a certificate from its peer.
 This is the default mode for server sockets.

 Returns true on success or raises an exception on error."

^ self _zeroArgSslPrim: 17
%

category: 'Peer Authentication'
method: GsSecureSocket
enableCertificateVerification
"Directs the receiver to request and verify a certificate from its peer.
 This is the default mode for client sockets.

 Returns true on success or raises an exception on error."

^ self _zeroArgSslPrim: 18
%

category: 'Querying'
method: GsSecureSocket
fetchCertificateVerificationOptions

"Answers an Array of Symbols which represent the certificate verification
 options used by the receiver.  Certificate verification options are only
 supported by server sockets.  Client sockets always return an empty Array.

 The supported server options are:

 #SSL_VERIFY_FAIL_IF_NO_PEER_CERT
    if the client did not return a certificate, the TLS/SSL handshake is
    immediately terminated with a 'handshake failure' alert.

 #SSL_VERIFY_CLIENT_ONCE
    only request a client certificate on the initial TLS/SSL handshake.
    Do not ask for a client certificate again in case of a renegotiation.

 Refer to the OpenSSL documentation for more information about these options."

^ self _zeroArgSslPrim: 24
%

category: 'Querying'
method: GsSecureSocket
fetchCipherDescription

"If the receiver has a secure connection with its peer, this method answers a string which
 describes the cipher currently in use.  Otherwise returns nil to indicate
 the receiver does not have a secure connection with its peer."

^ self _zeroArgSslPrim: 16
%

category: 'Error Handling'
method: GsSecureSocket
fetchLastIoErrorString

"Fetches a string describing the last I/O error encountered by a call to any
 of the following SSL functions:

   SSL_connect
   SSL_accept
   SSL_do_handshake
   SSL_read
   SSL_peek
   SSL_write

 Note that a result containing the substring
   SSL_write:uninitialized
 means that SSL_write was attempted before completing all of the
 handshakes of the sslConnect / sslAccept pair .

 The error is also cleared.  Returns nil if no I/O error has occurred
 on the receiver."

^ self _zeroArgSslPrim: 5
%

category: 'Querying'
method: GsSecureSocket
getServerNameIndication

"Answer a string indicating the server name indication (SNI) name 
 assigned to the receiver, or nil if no SNI name has been assigned."

^ self _zeroArgSslPrim: 27
%

category: 'Querying'
method: GsSecureSocket
hasSecureConnection

"Answer true if the receiver has established a secure connection
 with its peer.  Otherwise answer false."

^ self _zeroArgSslPrim: 3
%

category: 'Initialization'
method: GsSecureSocket
initializeAsClient

"Returns the receiver"
^ self _zeroArgSslPrim: 12
%

category: 'Initialization'
method: GsSecureSocket
initializeAsClientFromGsSocket: aGsSocket

"Returns the receiver on success"
^ self _oneArgSslPrim: 11 with: aGsSocket
%

category: 'Initialization'
method: GsSecureSocket
initializeAsServer

"Returns the receiver"
^ self _zeroArgSslPrim: 13
%

category: 'Initialization'
method: GsSecureSocket
initializeAsServerFromGsSocket: aGsSocket

"Returns the receiver on success"
^ self _oneArgSslPrim: 10 with: aGsSocket
%

category: 'Error Handling'
method: GsSecureSocket
lastErrorString
  "Provided for compatibility with GsSocket.
   See comments in fetchLastIoErrorString"

  ^ self fetchLastIoErrorString ifNil:[ super lastErrorString]
%

category: 'Testing'
method: GsSecureSocket
readWillNotBlock

"Returns true if the socket is currently ready to receive input without
 blocking.  Returns false if it is not currently ready.  Returns nil if an error
 occurs.

 The receiver must already be connected for this method to work properly.  If it
 is not connected, then the value that this method returns is indeterminate.
 Use the peerName method to determine if the receiver is connected.

 Call this method to prevent subsequent read or accept operations from hanging.
 If it returns true for a connected socket, then the input operation will not
 hang.  However, a return value of true is no guarantee that the operation
 itself will succeed."

 self _peek ifNotNil:[ ^ true ].
 ^ super readWillNotBlock
%

category: 'Testing'
method: GsSecureSocket
readWillNotBlockWithin: msToWait

"Returns true if the socket is ready to receive input without blocking within
 msToWait milliseconds from the time that this method is called.  Returns false
 if it is not ready after msToWait milliseconds.  Returns nil if an error
 occurs.

 If msToWait is 0, then this method reports the current readiness of the
 receiver.  If msToWait is -1, then this method never returns false, but waits
 until the receiver is ready to receive input without blocking, and then returns
 true.

 The receiver must already be connected for this method to work properly.  If it
 is not connected, then the value that this method returns is indeterminate.
 Use the peerName method to determine if the receiver is connected.

 Call this method to prevent subsequent read or accept operations from hanging.
 If it returns true for a connected socket, then the input operation will not
 hang.  However, a return value of true is no guarantee that the operation
 itself will succeed."

 self _peek ifNotNil:[ ^ true ].
 ^ super readWillNotBlockWithin: msToWait
%

category: 'Server Operations'
method: GsSecureSocket
secureAccept

"Establishes a secure connection using the receiver as the server  The receiver
 must have already established a regular (non-secure) connection with its
 client.  No certificate management is performed by this method.  A certificate
 and private key must be installed before calling this method.

 This method makes the following OpenSSL calls:

   SSL_new
   SSL_set_fd
   SSL_accept

 Waits up to 30 seconds for completion.

 Returns true to indicate the operation was successful.  Raises an exception
 if an error or timeout occurred."

^ self secureAcceptTimeoutMs: 30000"milliseconds"
%

category: 'Server Operations'
method: GsSecureSocket
secureAcceptTimeoutMs: timeoutMs

"Establishes a secure connection using the receiver as the server  The receiver
 must have already established a regular (non-secure) connection with its
 client.  No certificate management is performed by this method.  A certificate
 and private key must be installed before calling this method.

 This method makes the following OpenSSL calls:
   SSL_new (if not already done on the receiver).
   SSL_set_fd (if not already done on the receiver).
   SSL_accept
 Waits up to the specified time for completion.
 The timeoutMs arugment must be a SmallInteger.

 Returns true to indicate the operation was successful.  Raises an exception
 if an error or timeout occurred."

 ^ self secureAcceptTimeoutMs: timeoutMs errorOnTimeout: true
%

category: 'Server Operations'
method: GsSecureSocket
secureAcceptTimeoutMs: timeoutMs errorOnTimeout: aBoolean

"Establishes a secure connection using the receiver as the server  The receiver
 must have already established a regular (non-secure) connection with its
 client.  No certificate management is performed by this method.  A certificate
 and private key must be installed before calling this method.

 This method makes the following OpenSSL calls:
   SSL_new (if not already done on the receiver).
   SSL_set_fd (if not already done on the receiver).
   SSL_accept
 Waits up to the specified time for completion.
 The timeoutMs arugment must be a SmallInteger.

 Returns true to indicate the operation was successful.
 Raises an exception if an error occurred.
 On timeout, if aBoolean == true, raises an exception otherwise returns false."

 | res |
 res := self _secureAcceptTimeoutMs: timeoutMs  .
 res == true ifTrue:[ ^ true "success" ].
 res == false ifTrue:[
   aBoolean ifFalse:[ ^ false ].
   self signalError: 'secure accept timed out'.
 ].
 self signalError: res asString .
%

category: 'Private'
method: GsSecureSocket
secureClose

"Closes the secure connection and releases memory used by the receiver's
 SSL connection.  Does not close the underlying socket connection.  Customers
 should use the #close method instead of this one unless the underlying
 (insecure) socket connection is to be retained.

 Returns the receiver."

^ self _zeroArgSslPrim: 4
%

category: 'Client Operations'
method: GsSecureSocket
secureConnect

"Establishes a secure connection using the receiver as the client  The receiver
 must have already established a regular (non-secure) connection with its
 server.  No certificate management is performed by this method.

 This method makes the following OpenSSL calls:

   SSL_new
   SSL_set_fd
   SSL_connect

 Waits up to 30 seconds for completion.

 Returns true to indicate the operation was successful.  Raises an exception if
 an error or timeout occurred.
"

^ self secureConnectTimeoutMs: 30000"milliseconds"
%

category: 'Client Operations'
method: GsSecureSocket
secureConnectTimeoutMs: timeoutMs

"Establishes a secure connection using the receiver as the client  The receiver
 must have already established a regular (non-secure) connection with its
 server.  No certificate management is performed by this method.

 This method makes the following OpenSSL calls:

   SSL_new
   SSL_set_fd
   SSL_connect

 Waits up to the specified time for completion.
 The timeoutMs arugment must be a SmallInteger.

 Returns true to indicate the operation was successful.  Raises an exception if
 an error or timeout occurred.  "

| waitedMs |
waitedMs := 0 .
timeoutMs _isSmallInteger
   ifFalse:[ timeoutMs _validateClass: SmallInteger ].
[
  | res |
  "Note: args must be the same each time if -1 is returned"
  res := self _zeroArgSslPrim: 1 .
  ((res == nil) or:[res == false]) ifTrue:[ ^ self signalError: 'secureConnect failed'] .
  res == -1 ifTrue:[ Delay waitForMilliseconds: 20 . waitedMs := waitedMs + 20 ]
           ifFalse:[ res == true ifTrue:[^ res "done" ] .
                     self signalError: 'secureConnect failed with ' , res asString
                  ].
  waitedMs < timeoutMs
] whileTrue .
self signalError: 'secureConnect timed out' .
%

category: 'Peer Authentication'
method: GsSecureSocket
setCertificateVerificationOptions: anArray

"Sets the certificate verification options for the receiver using an Array of
 Symbols.

 The supported server socket options are:

 #SSL_VERIFY_FAIL_IF_NO_PEER_CERT
    if the client did not return a certificate, the TLS/SSL handshake is
    immediately terminated with a 'handshake failure' alert.

 #SSL_VERIFY_CLIENT_ONCE
    only request a client certificate on the initial TLS/SSL handshake.
    Do not ask for a client certificate again in case of a renegotiation.

 Refer to the OpenSSL documentation for more information about these options.

 Raises an error if the array contains any elements besides the above symbols.

 Currently there are no supported options for client sockets. Using this method
 with a client socket raises an error.

 If anArray is empty then any previously set options are cleared.

 The receiver must enable certificate verification before this method is
 executed, otherwise an error is raised.  Use the #enableCertificateVerification
 method to enable certificate verification.

 This method must be used before the receiver attempts a connection with its peer.
 Using this method with a connected socket raises an error.

 Returns true on success or raises an exception on error."

^ (self _oneArgSslPrim: 7 with: anArray)
    ifTrue:[ true ]
    ifFalse:[ self signalError ]
%

category: 'Ciphers'
method: GsSecureSocket
setCipherListFromString: aString

"Specify the cipher list to be used by the receiver only.  aString must be an
 instance of String in the format described in the man page for ciphers(1).  See
   http://www.openssl.org/docs/apps/ciphers.html

 Must be executed before the receiver is in a connected state (i.e., before
 the #secureConnect or #secureAccept method has been executed).

 Returns true if one or more of the specified ciphers are usable, raises an
 exception if no specified ciphers are usable.  Raises and exception if the operation would
 have no effect because the receiver is already in a connected state."

^ (self _oneArgSslPrim: 5 with: aString)
    ifTrue:[ true ]
    ifFalse:[ self signalError ]
%

category: 'Client Operations'
method: GsSecureSocket
setServerNameIndication: aString

"Sets the server name indication (SNI) name for the receiver to be
 aString.

 This method is only valid for client sockets which have not yet
 securly connected to a peer.

 Raises an exception if the receiver is not a client socket or if 
 the receiver is already securly connected to its peer.

 Returns true on success, false if an error occurred setting the SNI
 name."

^ self _oneArgSslPrim: 13 with: aString
%

category: 'Error Reporting'
method: GsSecureSocket
signalError
  ^ SecureSocketError signal: (self lastErrorString ifNil:[ 'no details' ]).
%

category: 'Error Reporting'
method: GsSecureSocket
signalError: aString
  ^ SecureSocketError signal:
     (self lastErrorString ifNotNil:[:s | aString , ', ' , s]  ifNil:[ aString ]).
%

category: 'Certificates and Keys'
method: GsSecureSocket
useCertificate: aString withPrivateKey: anotherString privateKeyPassphrase: passPhrase

"Specifies the certificate and private key to be used by
 the receiver only.  The private key must match the certificate.

 The certificates loaded into the internal SSL state are valid for the
 current session only; that SSL state is not committed to the repository.

 Both strings must be in PEM format.  If the private key requires a passphrase,
 it is specified in the passPhrase argument as a String.  If no passphrase is
 required, then the passPhrase argument is expected to be nil.

 Both strings must exactly match the contents of the corresponding certificate files
 (including white-space characters) or the strings will not be accepted.

 Returns true on success or raises an exception if an error occurs."

^ (self _threeArgSslPrim: 5 with: aString with: anotherString with: passPhrase)
     ifTrue:[ true ]
     ifFalse:[ self signalError ]
%

category: 'Certificates and Keys'
method: GsSecureSocket
useCertificateFile: certFile withPrivateKeyFile: keyFile privateKeyPassphrase: pass

"Specifies the certificate file and private key file to be used by
 the receiver only.  The private key must match the certificate.

 This method must be run before the #secureAccept (server case)
 or the #secureConnect (client case) methods.
 The certificates loaded into the internal SSL state are valid for the
 current session only; that SSL state is not committed to the repository.

 If the private key requires a passphrase, it is to be specified as String
 passed in using the pass argument.  If the private key does not require a
 passphrase, then the pass argument is expected to be nil.

 Both files must be in PEM format.

 Both arguments must be instances of String.

 Returns true on success or raises an exception if an error occurs or
 the file does not exist."

^ (self _threeArgSslPrim: 8 with: certFile with: keyFile with: pass)
     ifTrue:[ true ]
     ifFalse:[ self signalError ]
%

category: 'Private'
method: GsSecureSocket
_installSsl: aCpointer

"Used in hostagent.  aCpointer must encapsulate a SSL* .
 After this method executes,
  the SSL* will be auto-freed on GC of the receiver."

^ self _oneArgSslPrim: 12 with: aCpointer
%

category: 'Private'
method: GsSecureSocket
_maxReadWaits
  "The wait loop in GsSocket>>read:into:startingAt can
   get repeated read-ready of the underlying socket
   followed by SSL read apparently peeking
   on the socket and returning EWOULDBLOCK because there is not
   yet enough data to do a decryption cycle."
  ^ SmallInteger maximumValue
%

category: 'Private'
method: GsSecureSocket
_noFreeSslOnGc
"Used in hostagent code after sslState and fileDescriptor have
 become owned by a pgsvr thread .
 Cancels the effect of _installSsl:   .
 All subsequent ssl read/write operations must be done from the C code
 that now owns the socket.
 Sets C state in the receiver so that GC of the instance
 will neither free the SSL state, nor close the file descriptor.
"

^ self _zeroArgSslPrim: 26
%

category: 'Private'
method: GsSecureSocket
_nonSslWrite: aByteObject startingAt: anOffset ofSize: numBytes

"GsSocket >> _write:startingAt:ofSize  semantics.
 Returns nil if an error occurred,
   false if non-blocking receiver would block,
   true if EINTR occurred,
   a SmallInteger number of bytes written.
 Generates an error if aByteObject is not a String or ByteArray.
 Clears bits 16r4 from self.readyEvents if no error generated."

<primitive: 882>
self _primitiveFailed: #_write:startingAt:ofSize:
     args: { aByteObject . anOffset . numBytes }
%

category: 'Private'
method: GsSecureSocket
_oneArgSslPrim: opcode with: arg

"opcode  function
   1        class method: useCACertificateFileForClients:
   2        class method: useCACertificateFileForServers:
   3        class method: setClientCipherListFromString:
   4        class method: setServerCipherListFromString:
   5     instance method: setCipherListFromString:
   6        class method: setCertificateVerificationOptionsForServer:
   7     instance method: setCertificateVerificationOptions:
   8        class method: useCACertificateDirectoryForClients:
   9        class method: useCACertificateDirectoryForServers:
  10     instance method: initializeAsServerFromGsSocket:
  11     instance method: initializeAsClientFromGsSocket:
  12     instance method: _installSsl:
  13     instance method: setServerNameIndication:
"

<primitive: 910>
^ self _primitiveFailed: #_oneArgSslPrim:with: args: { opcode . arg }
%

category: 'Private'
method: GsSecureSocket
_peek
  "Returns a SmallInteger in the range 0..255 if there is a byte available
   from the underlying SSL buffer for the socket, otherwise returns nil."

  ^ self _zeroArgSslPrim: 20
%

category: 'Private'
method: GsSecureSocket
_primBlockingReadInto: aByteObject startingAt: anOffset maxBytes: numBytes

"Returns a SmallInteger indicating how many bytes were read or
 nil if an error occurs.
 Returns 0 if EOF occurs on the socket.
 numBytes must be a SmallInteger > 0 .

 Automatically handles conditions which require waiting for a read-ready
 or write-ready condition."

[ true ] whileTrue:[
  | res |
  "Note: args must be the same each time if -1 or -2 is returned"
  res := self _threeArgSslPrim: 2 with: aByteObject with: anOffset with: numBytes .
  res == -1 ifTrue:[self _waitForReadReady ] "Normal case"
            ifFalse:[ res == -2
                      ifTrue:[ self _waitForWriteReady ] "can happen due to SSL renegotiation"
                      ifFalse:[ ^ res ]. "done or error"
            ].
].
%

category: 'Private'
method: GsSecureSocket
_primNonBlockingReadInto: aByteObject startingAt: anOffset maxBytes: numBytes

"Returns a SmallInteger indicating how many bytes were read or
 nil if an error occurs.
 Returns 0 if EOF occurs on the socket.
 numBytes must be a SmallInteger > 0 .

 Automatically handles conditions which require waiting for a read-ready
 or write-ready condition."

[ true ] whileTrue:[
  | res |
  "Note: args must be the same each time if -1 or -2 is returned"
  res := self _threeArgSslPrim: 2 with: aByteObject with: anOffset with: numBytes .
  res == -1 ifTrue:[^ false "would block" ]
            ifFalse:[ res == -2
                      ifTrue:[ self _waitForWriteReady ] "can happen due to SSL renegotiation"
                      ifFalse:[ ^ res ]. "done or error"
            ].
].
%

category: 'Private'
method: GsSecureSocket
_rawNbWrite: numBytes from: aByteObject startingAt: anOffset
 "Does a non-SSL write to the underlying socket .
  Returns false if non-blocking receiver would block,
  or a SmallInteger number of bytes written.
  Retrys if EINTR occurs. "
 | res |
 [ res := self _nonSslWrite: aByteObject startingAt: anOffset ofSize: numBytes  .
   res == true "EINTR ocurred"
 ] whileTrue .
 res ifNil:[ self signalError ].
 ^ res
%

category: 'Private'
method: GsSecureSocket
_rawRead: maxBytes into: byteObj startingAt: index

"Reads up to the given number of bytes into the given byte object (for
 example, a String).  The first byte read will go into the position
 indicated by index.
 Returns the number of bytes read, or nil if an error,
 or 0 if EOF on the receiver.

 maxBytes must be a SmallInteger > 0 and <= 500000000 .

 An error will be raised if index is greater than the size of byteObj.
 Note that index can be equal to the size of byteObj plus 1 in which
 case any bytes read will be appended to byteObj.

 If no data is available for reading, this returns false .
 This method retrys for EINTR .
 The readWillNotBlock or readWillNotBlockWithin: methods may be used to
 determine whether or not data is ready for reading before calling this method.
 Used in hostagent. "

| status |
[
  "primitive will wait until data available if C socket is blocking."
  status := super _readInto: byteObj startingAt: index maxBytes: maxBytes.
  "status==true from _readInto means got EINTR and must retry"
  (status == false) ifTrue: [
    ^ false
  ] .
  status == true
] whileTrue .
^ status
%

category: 'Private'
method: GsSecureSocket
_rawReadWillNotBlockWithin: msToWait

^ super readWillNotBlockWithin: msToWait
%

category: 'Private'
method: GsSecureSocket
_readInto: aByteObject startingAt: anOffset maxBytes: numBytes

"Read up to numBytes of data from the receiver into aByteObject starting at anOffset.
 numBytes must be a SmallInteger > 0 .
 Returns a SmallInteger indicating how many bytes were read,
 or returns 0 if EOF occurs on the socket,
 or signals an error."

| res |
res := self isNonBlocking
   ifTrue:[ self _primNonBlockingReadInto: aByteObject startingAt: anOffset maxBytes: numBytes ]
  ifFalse:[ self _primBlockingReadInto: aByteObject startingAt: anOffset maxBytes: numBytes ].
res ifNil:[
  SocketError signal: self fetchLastIoErrorString
].
^ res
%

category: 'Private'
method: GsSecureSocket
_readLine: maxSize maxWaitMs: waitLimitMs

"Returns nil or a String .
 Waits up to waitLimitMs milliseconds to receive up to
 maxSize bytes.
 Returns when a linefeed is found at end of data or if max size is reached.
 Used in hostagent.
"
| status waitedMs sz aString |
aString := String new .
waitedMs := 0 .
sz := 0 .
[
  "primitive will wait until data available if C socket is blocking."
  status := self _readInto: aString startingAt: sz + 1 maxBytes: maxSize - sz.
  "status==true from _readInto means got EINTR and must retry"
  status == false ifTrue: [
    "socket is non-blocking and would have blocked"
  ] ifFalse:[
    status == 0 ifTrue:[ ^ nil "EOF"].
    sz := sz + status"num bytes read".
    (aString codePointAt: sz) == 10 ifTrue:[ ^ aString ].
    sz >= maxSize ifTrue:[ ^ aString ].
  ].
  waitedMs < waitLimitMs ifTrue:[
    waitedMs := waitedMs + 1 .
    Delay waitForMilliseconds: 1.
  ] ifFalse:[
    ^ nil "waited too long"
  ].
  true
] whileTrue .
%

category: 'Server Operations'
method: GsSecureSocket
_secureAcceptTimeoutMs: timeoutMs

"Establishes a secure connection using the receiver as the server  The receiver
 must have already established a regular (non-secure) connection with its
 client.  No certificate management is performed by this method.  A certificate
 and private key must be installed before calling this method.

 This method makes the following OpenSSL calls:
   SSL_new (if not already done on the receiver).
   SSL_set_fd (if not already done on the receiver).
   SSL_accept

 Waits up to the specified time for completion.
 The timeoutMs arugment must be a SmallInteger.

 Returns true to indicate the operation was successful,
 false to indicate timeout, or a String describing an error."

| waitedMs |
waitedMs := 0 .
timeoutMs _isSmallInteger ifFalse:[ timeoutMs _validateClass: SmallInteger ].
[
  | res |
  "Note: args must be the same each time if -1 is returned"
  res := self _zeroArgSslPrim: 2 .
  ((res == nil) or:[res == false]) ifTrue:[ ^ 'secureAccept failed'] .
  res == -1 ifTrue:[ Delay waitForMilliseconds: 2 . waitedMs := waitedMs + 2 ]
           ifFalse:[ res == true ifTrue:[ ^ res "done" ] .
                     ^ 'secureAccept failed with ' , res asString
                   ].
  waitedMs < timeoutMs
] whileTrue .
^ false "timeout"
%

category: 'Server Operations'
method: GsSecureSocket
_secureConnectTimeoutMs: timeoutMs

"Establishes a secure connection using the receiver as the server  The receiver
 must have already established a regular (non-secure) connection with its
 client.  No certificate management is performed by this method.  A certificate
 and private key must be installed before calling this method.

 This method makes the following OpenSSL calls:
   SSL_new (if not already done on the receiver).
   SSL_set_fd (if not already done on the receiver).
   SSL_connect

 Waits up to the specified time for completion.
 The timeoutMs arugment must be a SmallInteger.

 Returns true to indicate the operation was successful,
 false to indicate timeout, or a String describing an error."

| waitedMs |
waitedMs := 0 .
timeoutMs _isSmallInteger ifFalse:[ timeoutMs _validateClass: SmallInteger ].
[
  | res |
  "Note: args must be the same each time if -1 is returned"
  res := self _zeroArgSslPrim: 1 .
  ((res == nil) or:[res == false]) ifTrue:[ ^ 'secureConnect failed'] .
  res == -1 ifTrue:[ Delay waitForMilliseconds: 1 . waitedMs := waitedMs + 1 ]
           ifFalse:[ res == true ifTrue:[ ^ res "done" ] .
                     ^ 'secureConnect failed with ' , res asString
                   ].
  waitedMs < timeoutMs
] whileTrue .
^ false "timeout"
%

category: 'Private'
method: GsSecureSocket
_threeArgSslPrim: opcode with: arg1 with: arg2 with: arg3

"opcode  function
   1     instance method: _write:startingAt:ofSize:
   2     instance method: _readInto:startingAt:maxBytes:
   3        class method: useServerCertificate: withPrivateKey: privateKeyPassphrase:
   4        class method: useClientCertificate: withPrivateKey: privateKeyPassphrase:
   5     instance method: useCertificate: withPrivateKey: privateKeyPassphrase:
   6:       class method: useServerCertificateFile:withPrivateKeyFile:privateKeyPassphrase:
   7:       class method: useClientCertificateFile:withPrivateKeyFile:privateKeyPassphrase:
   8:    instance method: useCertificateFile:withPrivateKeyFile::privateKeyPassphrase:
"
<primitive: 909>
^ self _primitiveFailed: #_threeArgSslPrim:with:with:with:
  args: { opcode . arg1 . arg2 . arg3 }
%

category: 'Private'
method: GsSecureSocket
_write: aByteObject startingAt: anOffset ofSize: numBytes

"Does not conform exactly to GsSocket >> _write:startingAt:ofSize:
 due to semantics of SSL renegotiation and socket buffering.

 Returns nil if a socket error occurred ,
 or a SmallInteger the number of bytes written which will
 normally be equal to numBytes."

[ true ] whileTrue:[
  | res |
  "Note: args must be the same each time if -1 or -2 is returned"
  res := self _threeArgSslPrim: 1 with: aByteObject with: anOffset with: numBytes .
  res == -2 ifTrue:[
    ^ false
  ] ifFalse:[
    res == -1 ifTrue:[ self _waitForReadReady ] "can happen due to SSL renegotiation"
              ifFalse:[ ^ res ].
  ].
].
%

category: 'Private'
method: GsSecureSocket
_zeroArgSslPrim: opcode

"opcode  function
   1     instance method: secureConnect
   2     instance method: secureAccept
   3     instance method: hasSecureConnection
   4     instance method: secureClose
   5     instance method: fetchLastIoErrorString
   6        class method: fetchErrorStringArray
   7        class method: clearErrorQueue
   8        class method: disableCertificateVerificationOnClient
   9        class method: enableCertificateVerificationOnClient
  10        class method: disableCertificateVerificationOnServer
  11        class method: enableCertificateVerificationOnServer
  12     instance method: initializeAsClient
  13     instance method: initializeAsServer
  14        class method: fetchLastCertificateVerificationErrorForServer
  15        class method: fetchLastCertificateVerificationErrorForClient
  16     instance method: fetchCipherDescription
  17     instance method: disableCertificateVerification
  18     instance method: enableCertificateVerification
  19        class method: sslLibraryVersionString
  20     instance method: _peek
  21     instance method: certificateVerificationEnabled
  22        class method: certificateVerificationEnabledOnClient
  23        class method: certificateVerificationEnabledOnServer
  24     instance method: fetchCertificateVerificationOptions
  25        class method: fetchCertificateVerificationOptionsForServer
  26     instance method:  _noFreeSslOnGc
  27     instance method: getServerNameIndication
"
<primitive: 908>
^ self _primitiveFailed: #_zeroArgSslPrim: args: { opcode }
%

! Class implementation for 'IdentitySoftCollisionBucket'

!		Class methods for 'IdentitySoftCollisionBucket'

category: 'Instance creation'
classmethod: IdentitySoftCollisionBucket
new

^ super new _initializeCleanup
%

!		Instance methods for 'IdentitySoftCollisionBucket'

category: 'Updating'
method: IdentitySoftCollisionBucket
at: aKey put: aValue

"disallowed, should use  at:put:keyValDict_coll:  "

self shouldNotImplement: #at:put:
%

category: 'Updating'
method: IdentitySoftCollisionBucket
at: aKey put: aValue keyValDict_coll: aKeyValDict

"Stores the aKey/aValue pair in the receiver.
 Returns self size if this at:put: added a new key, 0 if this at:put:
 replaced a SoftReference for an existing  key .

 aValue is expected to be a SoftReference.

 Also removes key/SoftReference pairs whose SoftReference has been
 cleared by the garbage collector."

self _cleanupReferences: false .
^ super at: aKey put: aValue keyValDict_coll: aKeyValDict
%

category: 'Cleanup'
method: IdentitySoftCollisionBucket
cleanupReferences
  ^ self _cleanupReferences: true
%

category: 'Accessing'
method: IdentitySoftCollisionBucket
referenceAt: aKey ifAbsent: aBlock

"Returns the non-cleared SoftReference that corresponds to aKey.
 If no such key/SoftRef pair exists,
 returns the result of evaluating the zero-argument block aBlock."

  | index keyIndex aSoftRef |
  keyIndex := self searchForKey: aKey.
  keyIndex ~~ nil ifTrue: [
    index := (keyIndex + keyIndex) - 1 .
    aSoftRef:=  self _referenceAt: index .
    aSoftRef == nil ifTrue:[ ^ self _reportKeyNotFound: aKey with: aBlock ] .
    ^ aSoftRef
  ].
  ^ self _reportKeyNotFound: aKey with: aBlock
%

category: 'Accessing'
method: IdentitySoftCollisionBucket
referenceAt: aKey otherwise: aValue

"Returns the non-cleared SoftReference that corresponds to aKey.
 If no such key/SoftRef pair exists, returns aValue ."

  | keyIndex index aSoftRef |
  keyIndex := self searchForKey: aKey.
  keyIndex ~~ nil ifTrue:[
    index := (keyIndex + keyIndex) - 1 .
    aSoftRef :=  self _referenceAt: index .
    aSoftRef == nil ifTrue:[ ^ aValue ].
    ^ aSoftRef
  ].
  ^ aValue
%

category: 'Removing'
method: IdentitySoftCollisionBucket
removeKey: aKey ifAbsent: aBlock

"Removes the key/value pair having the key aKey.  If aKey is not found,
 returns the result of evaluating the zero-argument block aBlock.

 Also removes key/SoftReference pairs whose SoftReference has been
 cleared by the garbage collector."

| res |
res := super removeKey: aKey ifAbsent: aBlock  .
self _cleanupReferences: true .
^ res
%

category: 'Removing'
method: IdentitySoftCollisionBucket
removeKey: aKey otherwise: notFoundValue

"Removes the key/value pair having the key aKey.  If aKey is not found,
 returns the notFoundValue .

 Also removes key/SoftReference pairs whose SoftReference has been
 cleared by the garbage collector."

| res |
res := super removeKey: aKey otherwise: notFoundValue .
self _cleanupReferences: true .
^ res
%

category: 'Cleanup'
method: IdentitySoftCollisionBucket
_cleanupReferences: okToRemoveBucket
| currCount |
currCount := self _markSweepsThatClearedSoftRefsCount .
currCount = lastCleanupCount ifFalse:[ | lastKeyIdx startNumElem aKey |
  startNumElem := numElements .
  lastKeyIdx := (startNumElem + startNumElem) - 1 .
  lastKeyIdx _downTo: 1 by: 2 do:[ :idx | | aRef aVal |
    aRef := self _at: idx + 1.
    aVal := aRef _value  .
    aVal ifNil:[
      aKey ifNil:[ aKey := self _at: idx ].
      self removeFrom: idx  to: idx+ 1 . "remove key/softRef pair"
      numElements := numElements - 1 .
    ].
  ].
  lastCleanupCount := currCount .
  numElements == startNumElem ifFalse:[
    keyValueDictionary _bucketSizeChangeFrom: startNumElem to: numElements
		key: aKey bucket: self remove: okToRemoveBucket
  ].
].
%

category: 'Private'
method: IdentitySoftCollisionBucket
_initializeCleanup

  lastCleanupCount := 0
%

category: 'Private'
method: IdentitySoftCollisionBucket
_markSweepsThatClearedSoftRefsCount

"Returns OM.markSweepsThatClearedSoftRefsCount as a positive SmallInteger"

<primitive: 553>

self _primitiveFailed: #_markSweepsThatClearedSoftRefsCount
%

category: 'Private'
method: IdentitySoftCollisionBucket
_referenceAt: idx

" for the key stored at offset idx ,
  return the SofReference if softRef.value non-nil, otherwise
  remove the soft reference and associated key .
  Does not increment the use count of softRef .
"
| aSoftRef val |
aSoftRef := self _at: idx + 1 .
aSoftRef ~~ nil ifTrue:[
  val := aSoftRef _value .
  val == nil ifTrue:[ | oldN n aKey |
    aKey := self _at: idx .
    self removeFrom: idx to: idx + 1 . "remove key and SoftRef"
    oldN := numElements .
    n := oldN - 1 .
    n < 0 ifTrue:[ nil error:'numElements underflow in a SoftCollisionBucket'].
    numElements := n .
    keyValueDictionary _bucketSizeChangeFrom: oldN to: n key: aKey
                bucket: self remove: false .
    ^ nil .
  ] .
  ^ aSoftRef
].
^ nil
%

! Class implementation for 'UserProfileGroup'

!		Class methods for 'UserProfileGroup'

category: 'Accessing'
classmethod: UserProfileGroup
allGroups
  ^ AllGroups
%

category: 'Audit'
classmethod: UserProfileGroup
auditGroups
  self allGroups do: [:aGroup |
     (aGroup auditGroup) ifFalse: [^false]].
  ^true
%

category: 'Private'
classmethod: UserProfileGroup
basicNewWithName: aStringOrSymbol
"Creates a new instance of the receiver, but does not add the new instance
 to the list to AllGroups.  It is an error if a group with the same name
 already exists."

((self groupWithName: aStringOrSymbol otherwise: nil) notNil)
  ifTrue:[ ^ self _error: #rtErrGroupAlreadyExists args: { aStringOrSymbol } ] .

^ self _primNewWithName: aStringOrSymbol
%

category: 'Deleting'
classmethod: UserProfileGroup
deleteGroup: aGroup
"Remove the group from the following places:
  -The groups instance variable of any UserProfile.
  -The loginUserProfileGroups instance variable of any KerberosPrincipal.
  -The global collection AllGroups.

aGroup must be in AllGroups. Returns the receiver."

| gName |
gName := aGroup groupName .
self allGroups at: gName .  "ensure group exists."
SystemRepository do:[:securityPolicy | securityPolicy group: aGroup authorization: #none].
AllUsers removeGroup: gName . "AllUsers needs the group name"
KerberosPrincipal removeGroup: aGroup  . "KerberosPrincipal needs the group object."
self allGroups removeKey: gName .
^ self
%

category: 'Deleting'
classmethod: UserProfileGroup
deleteGroupWithName: aStringOrSymbol
"Remove the group with name aStringOrSymbol from the following places:
  -The groups instance variable of any UserProfile.
  -The loginUserProfileGroups instance variable of any KerberosPrincipal.
  -The global collection AllGroups.

It is an error if the group named aStringOrSymbol does not exists.  It is not an error
if the group is not present in one or more UserProfiles or KeberosPrincipals.
Returns the receiver."

^ self deleteGroup: (self groupWithName: aStringOrSymbol)
%

category: 'Deleting'
classmethod: UserProfileGroup
deleteGroupWithName: aStringOrSymbol ifAbsent: aBlock
"Remove the group with name aStringOrSymbol from the following places:
  -The groups instance variable of any UserProfile.
  -The loginUserProfileGroups instance variable of any KerberosPrincipal.
  -The global collection AllGroups.

Execute aBlock if the group does not exist.  It is not an error
if the group is not present in one or more UserProfiles or KeberosPrincipals.
Returns the receiver."

| nam |
nam := self groupWithName: aStringOrSymbol otherwise: nil .
nam ifNotNil:[ self deleteGroup: nam ]
    ifNil:[ aBlock value ]
%

category: 'Accessing'
classmethod: UserProfileGroup
groupWithName: aStringOrSymbol
"Answer the UserProfileGroup that has the given name.  Raises an exception if no
 such UserProfileGroup exists."

  ^ self allGroups at: aStringOrSymbol ifAbsent:[ aStringOrSymbol  _error: #segErrBadGroup. ^ nil ]
%

category: 'Accessing'
classmethod: UserProfileGroup
groupWithName: aStringOrSymbol ifAbsent: aBlock
"Answer the UserProfileGroup that has the given name or evaluate aBlock if it does
 not exist."

  ^ self allGroups at: aStringOrSymbol ifAbsent: aBlock
%

category: 'Accessing'
classmethod: UserProfileGroup
groupWithName: aStringOrSymbol otherwise: aValue
"Answer the UserProfileGroup that has the given name or answer aValue if it does
 not exist."

  ^ self allGroups at: aStringOrSymbol otherwise: aValue
%

category: 'Illegal Operations'
classmethod: UserProfileGroup
new

"Disallowed.  To create a new UserProfileGroup, use newWithName: instead "

self shouldNotImplement: #new
%

category: 'Illegal Operations'
classmethod: UserProfileGroup
new: anInt

"Disallowed.  To create a new UserProfileGroup, use newWithName: instead."
self shouldNotImplement: #new:
%

category: 'Updating'
classmethod: UserProfileGroup
newGroupWithName: aStringOrSymbol
"Creates a new instance of UserProfileGroup and adds it to the AllGroups collection.
 It is an error if a group with the same name already exits.

 Requires write access to the GsObjectSecurityPolicy for DataCurator."

| result |
result := self basicNewWithName: aStringOrSymbol .
self allGroups at: result groupName put: result .  "fix 48234"
^ result
%

category: 'Private'
classmethod: UserProfileGroup
_primNewWithName: aStringOrSymbol
"Creates a new instance of the receiver, but does not add the new instance
 to the list to AllGroups and does not check for duplicate names."

| result |
result := super new .
result _groupName: aStringOrSymbol .
^ result
%

category: 'Private'
classmethod: UserProfileGroup
_validateGroupString: aString

"Look up the group with name aString and raise an exception if it does not
 exist."
^ self groupWithName: aString
%

!		Instance methods for 'UserProfileGroup'

category: 'Comparison'
method: UserProfileGroup
<= aUserProfileGroup
  ^ groupName <= aUserProfileGroup groupName
%

category: 'Managing'
method: UserProfileGroup
addUser: aUserProfile
"Add the given UserProfile to the receiver.
 It is an error if the current user does not have the appropriate privilege.
 If <aUserProfile> is already in this group, there is no change.
 return the receiver."

aUserProfile addToUserProfileGroup: self.
^self
%

category: 'Accessing'
method: UserProfileGroup
asString
  ^ groupName asString
%

category: 'Audit'
method: UserProfileGroup
auditGroup
  self users do: [:aUser |
    (aUser groups includes: self)
	ifFalse: [self error: 'mismatch in group membership'.  ^false].
    ].
  ^true
%

category: 'Accessing'
method: UserProfileGroup
groupName
  ^ groupName
%

category: 'Formatting'
method: UserProfileGroup
printOn: aStream

aStream nextPutAll: self printString
%

category: 'Formatting'
method: UserProfileGroup
printString
|s|
s := String withAll: 'a'  .
s addAll: self class name asString ;
  addAll: ' (' ;
  addAll: groupName asString;
  add: $).
^ s
%

category: 'Managing'
method: UserProfileGroup
removeUser: aUserProfile
"Remove the given UserProfile from the receiver.
 It is an error if the current user does not have the appropriate privilege.
 If <aUserProfile> is not in this group, there is no change.
 return the receiver."
aUserProfile removeFromUserProfileGroup: self.
^self
%

category: 'Audit'
method: UserProfileGroup
species
  ^ IdentitySet
%

category: 'Audit'
method: UserProfileGroup
speciesForCollect
 ^ Array
%

category: 'Accessing'
method: UserProfileGroup
userIds
"Answer an IdentitySet of User Ids which are all members of the receiver."
| result |
result := IdentitySet new .
self do:[:e| result add: e userId ] .
^ result
%

category: 'Accessing'
method: UserProfileGroup
users
"Answer an IdentitySet of UserProfiles which are all members of the receiver."

  ^ IdentitySet withAll: self
%

category: 'Private'
method: UserProfileGroup
_groupName: aStringOrSymbol
"Private.  Sets the name of the receiver. Used only at instance creation time."

groupName := aStringOrSymbol asSymbol .
^ self
%

! Class implementation for 'KeySoftValueDictionary'

!		Instance methods for 'KeySoftValueDictionary'

category: 'Enumerating'
method: KeySoftValueDictionary
accompaniedBy: anObj keysAndValuesDo: aBlock

"Evaluates aBlock with each of the receiver's key/value pairs as the
 2nd and 3rd arguments.
 aBlock must be a 3 argument block, with arguments anObj, key value .

 SoftReferences which have been cleared by the garbage collector
 are removed from the dictionary during enumeration of the dictionary.
 The useCount of each non-cleared SoftReference will be incremented.
"

| tableLimit |
tableLimit := tableSize * 2 .
1 to: tableLimit by: 2 do: [ :tableIndex | | aKey |
  aKey := self _at: tableIndex .
  aKey ifNil: [ | collisionBkt |
    collisionBkt := self _at: (tableIndex + 1).
    collisionBkt ifNotNil:[  | bktSize bktIdx |
      bktIdx := 1 .
      bktSize := collisionBkt _basicSize .
      [ bktIdx <= bktSize] whileTrue:[  | bKey |
        bKey := collisionBkt _at: bktIdx .
        bKey ifNotNil:[  | oldSize bRef |
          oldSize := bktSize .
          bRef := collisionBkt _referenceAt: bktIdx . "possible removal"
          bRef ifNotNil:[ | val |
            val := bRef value .
            val ifNotNil:[
              aBlock value: anObj value: bKey value: val
            ].
          ] .
          "advance bktIdx only if no removal done "
          bktSize := collisionBkt _basicSize .
          bktSize = oldSize ifTrue:[ bktIdx := bktIdx + 2 ].
        ] ifNil:[
          bktIdx := bktIdx + 2.
        ]
      ]
    ].
  ] ifNotNil: [ | aRef |
    aRef := self _referenceAt: tableIndex .
    aRef ifNotNil:[ | val |
      val := aRef value .
      val ifNotNil:[
        aBlock value: anObj value: aKey value: val
      ].
    ].
  ].
].

%

category: 'Accessing'
method: KeySoftValueDictionary
at: aKey ifAbsent: aBlock

"Returns the value of the SoftReference that corresponds to aKey.
 If no such key/SoftRef pair exists, returns the result of
 evaluating the zero-argument block aBlock.

 Does not send setInUse to matching SoftReference.
 The useCount of the matching SoftReference is incremented, if the
 returned value is not special ."

| ref |

ref := self referenceAt: aKey otherwise: nil .
ref ifNil:[
  ^self _reportKeyNotFound: aKey with: aBlock
].
^ ref value
%

category: 'Accessing'
method: KeySoftValueDictionary
at: aKey ifAbsentPut: aBlock

"disallowed"
^ self shouldNotImplement: #at:ifAbsentPut:
%

category: 'Accessing'
method: KeySoftValueDictionary
at: aKey otherwise: aValue

"Returns the value of the SoftReference that corresponds to aKey.
 If no such key/softRef pair exists, returns the given alternate value.
 Does not send setInUse to the matching SoftReference.
 The useCount of the matching SoftReference is incremented, if the
 returned value is not special ."

| ref |
ref := self referenceAt: aKey otherwise: nil .
ref ifNotNil:[ ^ ref value ].
^ aValue
%

category: 'Updating'
method: KeySoftValueDictionary
at: aKey put: aValue

"Creates a SoftReference referencing aValue and
 inserts the key/softRef pair into the receiver .

 Rebuilds the hash table
 if the addition caused the number of collisions to exceed the limit allowed.

 Returns aValue.
"
| ref validRef |
ref := SoftReference new .
ref setValue: aValue .
validRef := self at: aKey putReference: ref .
" should always get the ref back because we have a strong ref to value
  on the stack"
validRef == ref ifFalse:[ self error:'inconsistent softref state' ].
^ aValue
%

category: 'Updating'
method: KeySoftValueDictionary
at: aKey putReference: aSoftReference

"Stores the aKey/SoftRef pair in the hash dictionary.  Rebuilds the hash table
 if the addition caused the number of collisions to exceed the limit allowed.

 aSoftReference must be a instance of SoftReference , else an error is
 generated .
 The useCount of aSoftReference is incremented.

 Returns aSoftReference, or nil if the addition could not be completed.
 Returns nil if aSoftReference was cleared by the garbage collector
 before the addition could be completed."

| val |
aSoftReference class == SoftReference ifFalse:[
  aSoftReference _validateInstanceOf: SoftReference .
].
val := aSoftReference value  .  "increment useCount and keep val alive on stack"
val ifNil:[ ^ nil ].

super at: aKey put: aSoftReference .
^ aSoftReference
%

category: 'Clustering'
method: KeySoftValueDictionary
clusterDepthFirst

"Instances are non-persistent so this has no effect"

^ true
%

category: 'Private'
method: KeySoftValueDictionary
collisionBucketClass

"Returns the class of object to create when keys collide."

^ SoftCollisionBucket
%

category: 'Accessing'
method: KeySoftValueDictionary
keyAtValue: anObject ifAbsent: aBlock

"Returns the key of the first SoftRef equal to the given object, anObject.
 If no match is found, evaluates and returns the result of the block aBlock."

| tableLimit |
tableLimit := tableSize * 2 .
1 to: tableLimit by: 2 do: [ :tableIndex | | aKey |
  aKey := self _at: tableIndex .
  aKey ifNil: [ | collisionBkt |
    collisionBkt := self _at: tableIndex + 1.
    collisionBkt ifNotNil:[  | bktSize bktIdx |
      bktIdx := 1 .
      bktSize := collisionBkt _basicSize .
      [ bktIdx <= bktSize] whileTrue:[  | bKey |
        bKey := collisionBkt _at: bktIdx .
        bKey ifNotNil:[ | oldSize bRef |
          oldSize := bktSize .
          bRef := collisionBkt _referenceAt: bktIdx .  "possible removal"
          bRef ifNotNil:[
            anObject = bRef _value ifTrue: [
              ^bKey
            ].
          ].
          "advance bktIdx only if no removal done "
          bktSize := collisionBkt _basicSize .
          bktSize = oldSize ifTrue:[ bktIdx := bktIdx + 2 ].
        ] ifNil:[
          bktIdx := bktIdx + 2.
        ].
      ].
    ].
  ] ifNotNil: [ | aSoftRef |
    aSoftRef := self _referenceAt: tableIndex .
    aSoftRef ifNotNil:[
      anObject = aSoftRef _value ifTrue:[
        ^aKey
      ].
    ].
  ].
].
^aBlock value.
%

category: 'Enumerating'
method: KeySoftValueDictionary
keysAndReferencesDo: aBlock

"Evaluates aBlock with each of the receiver's key/softRef pairs as the
 arguments.  The argument aBlock must be a two-argument block,
 first argument is the key and the second argument is
 the SoftReference for each non-cleared key/softRef pair in the dictionary.

 SoftReferences which have been cleared by the garbage collector
 are removed from the dictionary during enumeration of the dictionary.
 The useCount of each non-cleared SoftReference will NOT be incremented.
"

| tableLimit |
tableLimit := tableSize * 2 .
1 to: tableLimit by: 2 do: [ :tableIndex | | aKey |
  aKey := self _at: tableIndex .
  aKey ifNil:[ | collisionBkt |
    collisionBkt := self _at: (tableIndex + 1) .
    collisionBkt ifNotNil:[  | bktSize bktIdx |
      bktIdx := 1 .
      bktSize := collisionBkt _basicSize .
      [ bktIdx <= bktSize] whileTrue:[  | bKey |
        bKey := collisionBkt _at: bktIdx .
        bKey ifNotNil:[  | oldSize bRef |
          oldSize := bktSize .
          bRef := collisionBkt _referenceAt: bktIdx  . "possible removal"
          bRef ifNotNil:[
            aBlock value: bKey value: bRef
	  ].
          "advance bktIdx only if no removal done "
          bktSize := collisionBkt _basicSize .
          bktSize = oldSize ifTrue:[ bktIdx := bktIdx + 2 ].
        ] ifNil:[
          bktIdx := bktIdx + 2.
        ]
      ].
    ].
  ] ifNotNil: [ | aRef |
    aRef := self _referenceAt: tableIndex .
    aRef ifNotNil:[
      aBlock value: aKey value: aRef
    ].
  ].
].
%

category: 'Enumerating'
method: KeySoftValueDictionary
keysAndValuesDo: aBlock

"Evaluates aBlock with each of the receiver's key/value pairs as the
 arguments.  The argument aBlock must be a two-argument block,
 first argument is the key and the second argument is the value of
 the SoftReference for each non-cleared key/softRef pair in the dictionary.

 SoftReferences which have been cleared by the garbage collector
 are removed from the dictionary during enumeration of the dictionary.
 The useCount of each non-cleared SoftReference will be incremented.
"

| tableLimit |
tableLimit := tableSize * 2 .
1 to: tableLimit by: 2 do: [ :tableIndex | | aKey |
  aKey := self _at: tableIndex .
  aKey ifNil:[ | collisionBkt |
    collisionBkt := self _at: (tableIndex + 1).
    collisionBkt ifNotNil:[  | bktSize bktIdx |
      bktIdx := 1 .
      bktSize := collisionBkt _basicSize .
      [ bktIdx <= bktSize] whileTrue:[  | bKey |
        bKey := collisionBkt _at: bktIdx .
        bKey ifNotNil:[  | oldSize bRef |
          oldSize := bktSize .
          bRef := collisionBkt _referenceAt: bktIdx . "possible removal"
          bRef ifNotNil:[ | val |
            val := bRef value .
            val ifNotNil:[
              aBlock value: bKey value: val
            ].
          ] .
          "advance bktIdx only if no removal done "
          bktSize := collisionBkt _basicSize .
          bktSize = oldSize ifTrue:[ bktIdx := bktIdx + 2 ].
        ] ifNil:[
          bktIdx := bktIdx + 2.
        ]
      ]
    ].
  ] ifNotNil: [ | aRef |
    aRef := self _referenceAt: tableIndex .
    aRef ifNotNil:[ | val |
      val := aRef value .
      val ifNotNil:[
        aBlock value: aKey value: val
      ].
    ].
  ].
].
%

category: 'Enumerating'
method: KeySoftValueDictionary
keysDo: aBlock

"Evaluates aBlock with each of the receiver's keys as the
 argument.  The argument aBlock must be a one-argument block .

 SoftReferences which have been cleared by the garbage collector
 are removed from the dictionary during enumeration of the dictionary,
 and their keys will not be passed to aBlock .

 The useCount of each non-cleared SoftReference is NOT incremented.
"

| tableLimit |
tableLimit := tableSize * 2 .
1 to: tableLimit by: 2 do: [ :tableIndex | | aKey |
  aKey := self _at: tableIndex .
  aKey ifNil:[ | collisionBkt |
    collisionBkt := self _at: (tableIndex + 1).
    collisionBkt ifNotNil:[  | bktSize bktIdx |
      bktIdx := 1 .
      bktSize := collisionBkt _basicSize .
      [ bktIdx <= bktSize] whileTrue:[  | bKey |
        bKey := collisionBkt _at: bktIdx .
        bKey ifNotNil:[  | oldSize bRef |
          oldSize := bktSize .
          bRef := collisionBkt _referenceAt: bktIdx . "possible removal"
          bRef ifNotNil:[ | val |
            val := bRef _value .
            val ifNotNil:[
              aBlock value: bKey .
            ].
          ] .
          "advance bktIdx only if no removal done "
          bktSize := collisionBkt _basicSize .
          bktSize = oldSize ifTrue:[ bktIdx := bktIdx + 2 ].
        ] ifNil:[
          bktIdx := bktIdx + 2.
        ]
      ]
    ].
  ] ifNotNil: [ | aRef |
    aRef := self _referenceAt: tableIndex .
    aRef ifNotNil:[ | val |
      val := aRef _value .
      val ifNotNil:[
        aBlock value: aKey
      ].
    ].
  ].
].
%

category: 'Hashing'
method: KeySoftValueDictionary
rebuildTable: newSize

"Rebuilds the hash table by saving the current state, initializing and
 changing the size of the table, and adding the key value pairs saved
 back to the hash dictionary.

 During the 'saving the current state' phase, cleared SoftReferences
 will be removed from the dictionary.  After 'saving the current state',
 if numCollisions is below the collisionLimit, the rebuild will be skipped.

 If explicit rebuildTable is desired, you need to set the collisionLimit
 lower than the number of collisions before sending rebuildTable: .
 rebuildTable: will then install a new collision limit based on the
 newSize .  "

| startNc nc saveTable saveIdx saveCollLimit |

collisionLimit == 536870911 ifTrue:[
  ^ self  "prevent recursive rebuild"
  ].
saveTable := Array new: (self size * 3).
saveIdx := 0.
startNc := numCollisions .
self keysAndReferencesDo: [ :aKey :aSoftRef |
  saveTable at: saveIdx + 1 put: aKey.
  saveTable at: saveIdx + 2 put: aSoftRef.

  "keep values mostly alive"
  saveTable at: (saveIdx := saveIdx + 3) put: (aSoftRef _value)   "avoid incrementing useCount"
  ].
"enumeration of soft dictionaries may return less than total size"
saveTable size: saveIdx  .
((nc := numCollisions) < collisionLimit and:[ nc >= startNc]) ifTrue:[
  "rebuild not needed after removals from soft dictionary during enumeration"
  "GsFile gciLogServer:'--- rebuild not needed for newSize ' , newSize asString
		, '--------------- ' . ===debugging code not used"
  ^ self
  ].
self tableSize: newSize.  "installs new collision limit"
saveCollLimit := collisionLimit .
collisionLimit := 536870911 . "prevent recursive rebuild"
1 to: saveIdx by: 3 do: [ :j | | aSoftRef |
  aSoftRef := saveTable at: j + 1 "value" .
  aSoftRef _value ifNotNil:[     "avoid incrementing useCount"
    super at: (saveTable at: j "key") put: aSoftRef
    ].
  ].
collisionLimit := saveCollLimit .
"GsFile gciLogServer:'--- rebuild for newSize ' , newSize asString
                , '--------------- ' .   ===debugging code not used"
^self
%

category: 'Accessing'
method: KeySoftValueDictionary
referenceAt: aKey

"Returns the SoftReference corresponding to aKey.
 Generates an error if no such key exists."

| ref |
ref := self referenceAt: aKey otherwise: nil .
ref ifNotNil:[ ^ ref ].
^ self _errorKeyNotFound: aKey
%

category: 'Accessing'
method: KeySoftValueDictionary
referenceAt: aKey otherwise: aValue

" Return the SoftReference corresponding to aKey ,
  or return aValue if aKey not found."

| hash hashKey collisionBkt ref |

aKey ifNil:[ ^ aValue ].
hash := self hashFunction: aKey.
hashKey := self keyAt: hash.
hashKey ifNil: [
  (collisionBkt := self valueAt: hash) ifNotNil: [
    ref := collisionBkt referenceAt: aKey  otherwise: nil .
  ]
] ifNotNil: [
  (self compareKey: aKey with: hashKey) ifTrue: [
     ref := self _referenceAt: ( hash + hash - 1) .
   ]
].
ref ifNotNil:[ ^ ref ].
^ aValue
%

category: 'Private'
method: KeySoftValueDictionary
_bucketSizeChangeFrom: oldNumElem to: newNum key: aKey bucket: aBucket
    remove: okToRemoveBucket

  "a bucket has removed some key/softRef pairs , now update
   dictionary size information."

| elemDelta collDelta |
elemDelta := oldNumElem - newNum .
elemDelta < 1 ifTrue:[ self error:'elemDelta underflow in a KeySoftValueDictionary' ].
collDelta := elemDelta .
newNum <= 0 ifTrue:[
  newNum < 0 ifTrue:[ self error:'numElem underflow in a KeySoftValueDictionary' ].
  collDelta := elemDelta - 1 .
  collDelta < 0 ifTrue:[ self error:'collDelta underflow in a KeySoftValueDictionary' ].
].
numElements := numElements - elemDelta .
numCollisions := numCollisions - collDelta .
(okToRemoveBucket and:[ newNum <= 1 ]) ifTrue:[ | hash |
  "remove the bucket."
  aKey ifNil:[ self error:'nil key in _bucketSizeChangeFrom:'].
  hash := self hashFunction: aKey.
  (self valueAtHash: hash ) ~~ aBucket ifTrue:[
    self error:'inconsistent bucket in a KeySoftValueDictionary'
  ].
  newNum == 1 ifTrue:[ | pair pkey |
    pair := aBucket firstPair .
    (self hashFunction: (pkey := pair at:1)) == hash ifFalse:[
      self error:'inconsistent hash in _bucketSizeChangeFrom:'
    ].
    self atHash: hash putKey: pkey value: (pair at: 2) .
  ] ifFalse:[
    self atHash: hash putKey: nil value: nil
  ].
]
%

category: 'Private'
method: KeySoftValueDictionary
_numValues
  "Return the number of SoftReferences in receiver which have non-nil values,
   without removing any SoftReferences  from the receiver."
  | count |
  count := 0 .
  self keysAndReferencesDo:[:k :ref |
    ref _value ifNotNil:[ count := count + 1 ].
  ].
  ^ count
%

category: 'Private'
method: KeySoftValueDictionary
_referenceAt: tableIdx

" for the key stored in the hash table at tableIdx ,
  return the softRef if softRef.value non-nil, otherwise
  remove the soft reference and associated key .
"
| aSoftRef val |
aSoftRef := self _at: tableIdx + 1 .
aSoftRef ifNotNil:[
  val := aSoftRef _value .
  val ifNil:[
    self _basicAt: tableIdx     put: nil . "remove key"
    self _basicAt: tableIdx + 1 put: nil . "remove SoftRef"
    numElements := numElements - 1 .
    ^ nil .
  ].
  ^ aSoftRef
].
^ nil
%

! Class implementation for 'IdentityKeySoftValueDictionary'

!		Instance methods for 'IdentityKeySoftValueDictionary'

category: 'Private'
method: IdentityKeySoftValueDictionary
collisionBucketClass

"Returns the class of object to create when keys collide."

^ IdentitySoftCollisionBucket
%

category: 'Updating'
method: IdentityKeySoftValueDictionary
collisionLimit: aLimit
| limit tlim |
(limit := aLimit ) _isSmallInteger ifFalse:[  "gemstone64 explicit constraint check"
  ^ limit _error: #rtErrBadArgKind args: { SmallInteger }
].
(limit ~~ 536870911 and:[ limit > (tlim := tableSize * 500)]) ifTrue:[
  limit := tlim "prevent infinite recursion on bucket overflows, fix  "
] .
^ super collisionLimit: limit
%

category: 'Private'
method: IdentityKeySoftValueDictionary
compareKey: key1 with: key2

"Returns true if key1 is identical to key2; returns false otherwise."

^ key1 == key2
%

category: 'Comparing'
method: IdentityKeySoftValueDictionary
hash

"Returns a numeric hash key for the receiver."

| hashValue |

hashValue := 97633 bitXor: (self size).
"For large dictionaries, the hash value is just a function of its size"
(self size > 64) ifTrue: [ ^ hashValue abs ].
self keysDo: [ :aKey |
   "Skip if the key is a dictionary."
   (aKey isKindOf: AbstractDictionary)
     ifFalse: [
       hashValue := hashValue bitXor: aKey identityHash
       ]
     ].
^ hashValue abs
%

category: 'Hashing'
method: IdentityKeySoftValueDictionary
hashFunction: aKey

"The hash function should perform some operation on the value of the key aKey
 which returns a value in the range 1..tableSize."

^(aKey identityHash \\ tableSize) + 1
%

category: 'Hashing'
method: IdentityKeySoftValueDictionary
rebuildTable: newSize

| oldTs newTs |
oldTs := tableSize .
super rebuildTable: newSize .
(newTs := tableSize) > oldTs ifTrue:[
  self collisionLimit: newTs * 500 . "differs from KeySoftValueDictionary"
].
%

category: 'Hashing'
method: IdentityKeySoftValueDictionary
rehash
	"Re-establish any hash invariants of the receiver.
	 Identity hashes cannot change."
%

category: 'Private'
method: IdentityKeySoftValueDictionary
_initializeWithoutClear: newSize

"Private. Initializes the instance variables of the receiver to be an empty
 KeyValueDictionary of the specified size. Does not clear the contents
 of the receiver - assumes they are all nil."

tableSize := newSize.
numElements := 0.
numCollisions := 0.
collisionLimit := newSize * 500 . "differs from KeySoftValueDictionary"
^self
%

! Class implementation for 'CBuffer'

!		Class methods for 'CBuffer'

category: 'Instance Creation'
classmethod: CBuffer
new
"create an instance registered with VM for finalization of cData"

<primitive: 674>
self _primitiveFailed: #new
%

category: 'Instance Creation'
classmethod: CBuffer
new: size

"Create a new instance and allocate the given number of bytes in the heap."

| newOne status |
newOne := self new initialize.
status := newOne allocate: size.

status == 1 ifTrue: [^newOne].
status == 0 ifTrue: [ self _errorMallocFailed ].

^ self _halt: 'Unknown error when allocating CBuffer:' , status asString
%

category: 'Error Handling'
classmethod: CBuffer
_errorMallocFailed

"Raise an error because a call to malloc failed in the user action library."

self _error: #hostErrMemoryAlloc args: #()
%

category: 'Testing'
classmethod: CBuffer
_isBufferAvailable

"Return whether there is a buffer available that can be allocated."

^ true
%

category: 'Constants'
classmethod: CBuffer
_numAvailableBuffers

"Return the number of available buffers that can allocated on the heap."

^ 1
%

!		Instance methods for 'CBuffer'

category: 'Allocation'
method: CBuffer
allocate: size

"
 Frees receiver's previous C memory if any.
 Allocate C heap memory and set the receiver to point to it.
 Return a SmallInteger which indicates the status of the allocation:

-1 = not enought C buffers
0 = malloc failed
1 = allocation succeeded
"

^ self _oneArgPrim: 0 arg: size.
%

category: 'Allocation'
method: CBuffer
allocatedSize

"Return the amount of heap memory allocated, in bytes."

^ self _zeroArgPrim: 0.
%

category: 'Allocation'
method: CBuffer
free

"Free previously allocated C heap memory.
 The memory will also be freed automatically if the
 instance is garbage collected by in-memory GC, or
 is committed and faults out of temporary object memory."

^ self _zeroArgPrim: 1.
%

category: 'Initialization'
method: CBuffer
initialize

"Initialize a new instance."

%

category: 'Primitives'
method: CBuffer
_oneArgPrim: opcode arg: arg

"Execute the one arg primitive according to the given opcodes.
	0 = allocate:
	1 = setObjId:
	2 = setOclass:
	3 = setObjectSecurityPolicyId:
	4 = setIsInvariant:
	5 = setNamedSize:
	6 = setObjSize:
	7 = setIdxSize:
	8 = setValueBuffSize:
	9 = setFirstOffset:
	10 = setFormat:
	11 = incrementActualBufferSize:
	12 = getByteObjectInto:
	13 = copyObjectReportInto:
	14 = valueBufferPutOverlayAt:
	15 = setComplete:
        26 = setByteSwizzle:
"

<primitive: 198>
self _primitiveFailed: #_oneArgPrim:arg: args: { opcode . arg }.
self _uncontinuableError
%

category: 'Primitives'
method: CBuffer
_twoArgPrim: opcode arg: arg1 arg: arg2

"Execute the two arg primitive according to the given opcodes.
	0 = setBytes:startingAt:
	1 = valueBufferAt:put:
"

<primitive: 199>
self _primitiveFailed: #_twoArgPrim:arg:arg: args: { opcode . arg1 . arg2 }.
self _uncontinuableError
%

category: 'Primitives'
method: CBuffer
_zeroArgPrim: opcode

"Execute the zero arg primitive according to the given opcodes.

	0 = allocatedSize
	1 = free
	2 = complete
	3 = objId
	4 = oclass
	5 = objectSecurityPolicy (obsolete)
	6 = currentObjectIsInvariant
	7 = namedSize
	8 = objSize
	9 = idxSize
	10 = valueBuffSize
	11 = firstOffset
	12 = currentObjectIsSpecial
	13 = currentObjectIsOop
	14 = currentObjectIsByte
	15 = currentObjectIsNsc
	16 = actualBufferSize
	17 = nextObjectReport
	18 = setNextObjectReport
	19 = setFirstObjectReport
	20 = nextValueBufferOop
	21 = getByteObject
	22 = initTraversalBuffer
	23 = objectReportHeaderSize
	24 = bytesToEnd
	26 = isPartial
	27 = setNextObjectReport
	29 = advanceValueBufferOop
	30 = currentValueBufferOopIsSpecial
	31 = valueBufferSpecialOop
"

<primitive: 197>
self _primitiveFailed: #_zeroArgPrim: args: { opcode }.
self _uncontinuableError
%

! Class implementation for 'TraversalBuffer'

!		Instance methods for 'TraversalBuffer'

category: 'Accessing - Traversal'
method: TraversalBuffer
actualBufferSize

"Return the actual size of the traversal buffer.
 The result is value of the field GciTravBufType.usedBytes in receiver.
 Deprecated"

self deprecated: 'TraversalBuffer>>actualBufferSize deprecated in v3.2. Use usedBytes instead'.
^ self _zeroArgPrim: 16.
%

category: 'Updating - Traversal'
method: TraversalBuffer
advanceValueBufferOop

"Advance to the next oop in the value buffer, if that advance
 would not go beyond the end of the value buffer.
 Returns true if the internal pointer was advanced.
 Returns false if the internal pointer is already pointing to
 the last oop in the value buffer, in which case the pointer
 is unchanged."

^ self _zeroArgPrim: 29.
%

category: 'Accessing - Traversal'
method: TraversalBuffer
bytesToEnd

"Return the number of bytes from the current pointer to the end of the buffer."

^ self _zeroArgPrim: 24.
%

category: 'Accessing'
method: TraversalBuffer
clampOop

   "Return the value of the instance variable 'clampOop'."
   ^clampOop
%

category: 'Updating'
method: TraversalBuffer
clampOop: newValue

   "Modify the value of the instance variable 'clampOop'."
   clampOop := newValue
%

category: 'Testing - Traversal'
method: TraversalBuffer
complete

"Return buffHdr.complete"

^ self _zeroArgPrim: 2.
%

category: 'Copying'
method: TraversalBuffer
copyObjectReportInto: aTBuffer

"Copy the current object report into the given TraversalBuffer.
Return whether the copy was successful."

^ self _oneArgPrim: 13 arg: aTBuffer.
%

category: 'Testing - Traversal'
method: TraversalBuffer
currentObjectIsByte

"Return ((GciObjRepHdrSType *)buffHdr.current)->objImpl == GC_FORMAT_BYTE"

^ self _zeroArgPrim: 14.
%

category: 'Testing'
method: TraversalBuffer
currentObjectIsClampedFromCallback

"Return whether the current object report is clamped by having the
traversal callback place a _remoteNil in the value buffer."

^ self objSize == 1 and:
[ self currentValueBufferOopIsSpecial and:
[ self valueBufferSpecialOop == _remoteNil ] ]
%

category: 'Testing - Traversal'
method: TraversalBuffer
currentObjectIsInvariant

"Return ((GciObjRepHdrSType *)buffHdr.current)->isInvariant"

^ self _zeroArgPrim: 6.
%

category: 'Testing - Traversal'
method: TraversalBuffer
currentObjectIsNsc

"Return ((GciObjRepHdrSType *)buffHdr.current)->objImpl == GC_FORMAT_NSC"

^ self _zeroArgPrim: 15.
%

category: 'Testing - Traversal'
method: TraversalBuffer
currentObjectIsOop

"Return ((GciObjRepHdrSType *)buffHdr.current)->objImpl == GC_FORMAT_OOP"

^ self _zeroArgPrim: 13.
%

category: 'Testing - Traversal'
method: TraversalBuffer
currentObjectIsSpecial

"Return ((GciObjRepHdrSType *)buffHdr.current)->objImpl == GC_FORMAT_SPECIAL"

^ self _zeroArgPrim: 12.
%

category: 'Testing - Traversal'
method: TraversalBuffer
currentValueBufferOopIsSpecial

"Return whether the current oop in the value buffer stream is special format."

^ self _zeroArgPrim: 30.
%

category: 'Accessing - Traversal'
method: TraversalBuffer
firstOffset

"Return ((GciObjRepHdrSType *)buffHdr.current)->firstOffset"

^ self _zeroArgPrim: 11.
%

category: 'Accessing - Traversal'
method: TraversalBuffer
getByteObject

"The current report must be for a class with byte indexed instance variables.
 Answer a new object of the report's class, containing only the bytes that are in
 the current report. Note that if the firstOffset is not 1, the indices of bytes
 in the resulting object will not be the same as in the object partially described
 by the report."

^ self _zeroArgPrim: 21.
%

category: 'Accessing - Traversal'
method: TraversalBuffer
getByteObjectInto: byteObj

"If necessary, resize the given byteObj to the size of the object described by
 the current object report (which should be for an object of a byte class).
 Put the bytes contained in the current object report into the given byteObj.
 If this is a subset of all of the bytes in the object described by the report,
 those bytes will be put at their proper indices, and bytes at other indices
 will remain unchanged (contrast with the behavior of #getByteObject)."

^ self _oneArgPrim: 12 arg: byteObj.
%

category: 'Accessing - Traversal'
method: TraversalBuffer
idxSize

"Return ((GciObjRepHdrSType *)buffHdr.current)->idxSize"

^ self _zeroArgPrim: 9.
%

category: 'Updating - Traversal'
method: TraversalBuffer
incrementActualSize: value

"Increment GciTravBufType.usedBytes of the receiver. Deprecated"

self deprecated: 'TraversalBuffer>>incrementActualSize: deprecated in v3.2. Use incrementUsedBytes: instead.'.
^ self _oneArgPrim: 11 arg: value.
%

category: 'Updating - Traversal'
method: TraversalBuffer
incrementUsedBytes: value

"Increment GciTravBufType.usedBytes of the receiver.
 The new value of GciTravBufType.usedBytes is limited to
 a maximum of GciTravBufType.allocatedBytes ."

^ self _oneArgPrim: 11 arg: value.
%

category: 'Initialization'
method: TraversalBuffer
initialize

"Initialize a new instance."

travResultOop := nil.
resultIsSpecial := true.
clampOop := nil.
level := 0.
retrievalFlags := 0.
%

category: 'Updating - Traversal'
method: TraversalBuffer
initTraversalBuffer

"Initialize the receiver to look like an empty traversal buffer.
 The first object report header is memset to zero ."

^ self _zeroArgPrim: 22.
%

category: 'Testing'
method: TraversalBuffer
isCompleteObjectReport

"Return whether the current object report contains the last byte or oop of the object.
 If this method answers true, and #firstOffset answers 1, the object report
 contains all bytes or oops of the object."

^ self currentObjectIsByte
  ifTrue: [ (self firstOffset + self valueBuffSize) > self objSize ]
  ifFalse: [ (self firstOffset + self numberOfValueBuffOops) > self objSize ]
%

category: 'Testing'
method: TraversalBuffer
isEmptyObjectReport

"Return whether the current object report is empty."

^ ( self valueBuffSize == 0 and: [ self objSize > 0 ] )
%

category: 'Testing'
method: TraversalBuffer
isLastObjectInBuffer

"Return whether the current object report is for the last object in the logical buffer
(which includes buffers returned from moreTraversal).
For use when reading a buffer."

^ self complete and: [ self isLastObjectReport ]
%

category: 'Testing - Traversal'
method: TraversalBuffer
isLastObjectReport

"Return whether the current object report is the last report in the buffer
  for reading the buffer."

^ self _zeroArgPrim: 18.
%

category: 'Testing - Traversal'
method: TraversalBuffer
isPartial

"Return whether the current object report is a partial report."

^ self _zeroArgPrim: 26.
%

category: 'Accessing'
method: TraversalBuffer
level

   "Return the value of the instance variable 'level'."
   ^level
%

category: 'Updating'
method: TraversalBuffer
level: newValue

   "Modify the value of the instance variable 'level'."
   level := newValue
%

category: 'Updating - Traversal'
method: TraversalBuffer
makeObjectReportOverlayed

"Return ((GciObjRepHdrSType *)buffHdr.current)->isOverlayed = TRUE"
^ self _zeroArgPrim: 25.
%

category: 'Accessing - Traversal'
method: TraversalBuffer
namedSize

"Return ((GciObjRepHdrSType *)buffHdr.current)->namedSize"

^ self _zeroArgPrim: 7.
%

category: 'Updating - Traversal'
method: TraversalBuffer
nextObjectReport

"Advance to the next object report for reading from the buffer.
 Return whether there is another."

^ self _zeroArgPrim: 17.
%

category: 'Accessing - Traversal'
method: TraversalBuffer
numberOfValueBuffOops

"Return number of oops contained in the value buffer."

^ self valueBuffSize // 4
%

category: 'Accessing - Traversal'
method: TraversalBuffer
objectReportHeaderSize

"Return sizeof(GciObjRepHdrSType)."

^ self _zeroArgPrim: 23.
%

category: 'Accessing - Traversal'
method: TraversalBuffer
objectSecurityPolicy

"Return ((GciObjRepHdrSType *)buffHdr.current)->objectSecurityPolicy"

^ self _zeroArgPrim: 5.
%

category: 'Accessing - Traversal'
method: TraversalBuffer
objId

"Return ((GciObjRepHdrSType *)buffHdr.current)->objId"

^ self _zeroArgPrim: 3.
%

category: 'Accessing - Traversal'
method: TraversalBuffer
objSize

"Return ((GciObjRepHdrSType *)buffHdr.current)->objSize"

^ self _zeroArgPrim: 8.
%

category: 'Accessing - Traversal'
method: TraversalBuffer
oclass

"Return ((GciObjRepHdrSType *)buffHdr.current)->oclass"

^ self _zeroArgPrim: 4.
%

category: 'Accessing'
method: TraversalBuffer
resultIsSpecial

   "Return the value of the instance variable 'resultIsSpecial'."
   ^resultIsSpecial
%

category: 'Updating'
method: TraversalBuffer
resultIsSpecial: newValue

   "Modify the value of the instance variable 'resultIsSpecial'."
   resultIsSpecial := newValue
%

category: 'Accessing'
method: TraversalBuffer
retrievalFlags

   "Return the value of the instance variable 'retrievalFlags'."
   ^retrievalFlags
%

category: 'Updating'
method: TraversalBuffer
retrievalFlags: newValue

   "Modify the value of the instance variable 'retrievalFlags'."
   retrievalFlags := newValue
%

category: 'Deprecated'
method: TraversalBuffer
segment
	self deprecated: 'TraversalBuffer>>segment deprecated in v3.0 and above; use objectSecurityPolicy'.
	^self objectSecurityPolicy.
%

category: 'Updating - Traversal'
method: TraversalBuffer
setBytes: byteObj startingAt: index

"Populate the current object report ((GciObjRepSType *)buffHdr.current)
 from the given byte object. u.bytes is populated with bytes from byteObj
 starting at the given index and ending with the last byte of byteObj. If
 that many bytes will not fit in the receiver, as many bytes as will fit are
 populated and false is answered. If all fit, true is answered.
 In any case, the report's firstOffset is set to index, and the
 valueBuffSize is set to the number of bytes in the report.
 If false is answered, you may send #valueBuffSize to help determine
 the start offset to use in the next buffer."

^ self _twoArgPrim: 0 arg: byteObj arg: index.
%

category: 'Updating - Traversal'
method: TraversalBuffer
setByteSwizzle: value
 "value is a SmallInteger, 0..3 per GciByteSwizEType in gci.ht,
    gci_byte_swiz_none = 0,
    gci_byte_swiz_2_bytes = 1,
    gci_byte_swiz_4_bytes = 2,
    gci_byte_swiz_8_bytes = 3

  On a fetch traversal, the server fills in the bits specified by
   swiz_kind_mask in GciObjRepHdrSType (in gci.ht), and the
  transport layer swizzles accordingly.

  On a store traveral the client is responsible for filling in the
  swiz_kind_mask  bits as follows, for each object report whose
  object's class is a subclass of one of the following classes .
     server class    swizzle bits
     -------------   -----------
     LargeInteger    gci_byte_swiz_4_bytes
     SmallFloat      gci_byte_swiz_4_bytes
     Float           gci_byte_swiz_8_bytes
     DoubleByteString  gci_byte_swiz_2_bytes
     QuadByteString  gci_byte_swiz_4_bytes
     BitSet          gci_byte_swiz_4_bytes
  All other reports should have the swiz_kind_mask  bits == 0.
"
^  self _oneArgPrim: 26 arg: value
%

category: 'Updating - Traversal'
method: TraversalBuffer
setComplete: value

"Set buffHdr->complete."

^ self _oneArgPrim: 15 arg: value.
%

category: 'Updating - Traversal'
method: TraversalBuffer
setFirstObjectReport

"Set the pointer to the first object report."

^ self _zeroArgPrim: 19.
%

category: 'Updating - Traversal'
method: TraversalBuffer
setFirstOffset: value

"Set ((GciObjRepHdrSType *)buffHdr.current)->firstOffset"

^ self _oneArgPrim: 9 arg: value.
%

category: 'Updating - Traversal'
method: TraversalBuffer
setFormat: value

"Set ((GciObjRepHdrSType *)buffHdr.current)->objImpl where

-1 indicates GC_FORMAT_SPECIAL
0 indicates GC_FORMAT_OOP
1 indicates GC_FORMAT_BYTE
2 indicates GC_FORMAT_NSC
"

^ self _oneArgPrim: 10 arg: value.
%

category: 'Updating - Traversal'
method: TraversalBuffer
setIdxSize: value

"Set ((GciObjRepHdrSType *)buffHdr.current)->idxSize"

^ self _oneArgPrim: 7 arg: value.
%

category: 'Updating - Traversal'
method: TraversalBuffer
setIsInvariant: value

"Set ((GciObjRepHdrSType *)buffHdr.current)->isInvariant."

^ self _oneArgPrim: 4 arg: value.
%

category: 'Updating - Traversal'
method: TraversalBuffer
setNamedSize: value

"Set ((GciObjRepHdrSType *)buffHdr.current)->namedSize"

^ self _oneArgPrim: 5 arg: value.
%

category: 'Updating - Traversal'
method: TraversalBuffer
setNextObjectReport

"Advance to the next object report for writing to the buffer.
The next object report header is memset to zero .
 You must send this message after you complete writing
 each object to the buffer, including the last object.
 Answers false if there is not enough room in the buffer
 for another object header, true otherwise."

^ self _zeroArgPrim: 27.
%

category: 'Updating - Traversal'
method: TraversalBuffer
setObjectSecurityPolicyId: value

"value must be a legal objectSecurityPolicyId, a SmallInt in range 0..16rFFFF"

^ self _oneArgPrim: 3 arg: value.
%

category: 'Updating - Traversal'
method: TraversalBuffer
setObjId: value

"Set ((GciObjRepHdrSType *)buffHdr.current)->objId"

^ self _oneArgPrim: 1 arg: value.
%

category: 'Updating - Traversal'
method: TraversalBuffer
setOclass: value

"Set ((GciObjRepHdrSType *)buffHdr.current)->oclass"

^ self _oneArgPrim: 2 arg: value.
%

category: 'Deprecated'
method: TraversalBuffer
setSegmentId: value
self deprecated: 'TraversalBuffer>>setSegmentId: deprecated v3.0, use setObjectSecurityPolicyId:'.
^ self setObjectSecurityPolicyId: value
%

category: 'Updating - Traversal'
method: TraversalBuffer
setValueBuffSize: value

"Set ((GciObjRepHdrSType *)buffHdr.current)->valueBuffSize.
 Not needed after setBytes:startingAt: ."

^ self _oneArgPrim: 8 arg: value.
%

category: 'Accessing'
method: TraversalBuffer
travResultOop

   "Return the value of the instance variable 'travResultOop'."
   ^travResultOop
%

category: 'Updating'
method: TraversalBuffer
travResultOop: newValue

   "Modify the value of the instance variable 'travResultOop'."
   travResultOop := newValue
%

category: 'Accessing - Traversal'
method: TraversalBuffer
usedBytes
"Return the actual size of the traversal buffer.
 The result is value of the field GciTravBufType.usedBytes in receiver."

^ self _zeroArgPrim: 16.
%

category: 'Updating - Traversal'
method: TraversalBuffer
valueBufferAt: i putRemoteOop: value

"Set ((GciObjRepSType *)buffHdr.current)->u.oops[offset] = value.  Return whether
the insertion was allowed."

^ self _twoArgPrim: 2 arg: i arg: value.
%

category: 'Updating - Traversal'
method: TraversalBuffer
valueBufferAt: i putSpecial: value

"Set ((GciObjRepSType *)buffHdr.current)->u.oops[offset] = value.  Return whether
the insertion was allowed."

^ self _twoArgPrim: 1 arg: i arg: value.
%

category: 'Updating - Traversal'
method: TraversalBuffer
valueBufferPutOverlayAt: i

"Set ((GciObjRepSType *)buffHdr.current)->u.oops[offset] = OOP_OVERLAY.
Return whether the insertion was allowed."

self makeObjectReportOverlayed.
^ self _oneArgPrim: 14 arg: i.
%

category: 'Accessing - Traversal'
method: TraversalBuffer
valueBufferRemoteOop

"Return the next remote oop in the value buffer, which is non-special."

^ self _zeroArgPrim: 20.
%

category: 'Accessing - Traversal'
method: TraversalBuffer
valueBufferSpecialOop

"Return the next oop, which is special format, in the value buffer."

^ self _zeroArgPrim: 31.
%

category: 'Accessing - Traversal'
method: TraversalBuffer
valueBuffSize

"Return ((GciObjRepHdrSType *)buffHdr.current)->valueBuffSize"

^ self _zeroArgPrim: 10.
%

category: 'Accessing'
method: TraversalBuffer
varyingEndOffset

"Return the end point for updating the varying portion of the receiver."

^ self numberOfValueBuffOops - self namedSize + self firstOffset - 1
%

category: 'Accessing'
method: TraversalBuffer
varyingStartOffset

"Return the starting point for updating the varying portion of the receiver."

| start firstOffset namedSize |

firstOffset := self firstOffset.
namedSize := self namedSize.

start := 1.
( firstOffset > 1 and: [ firstOffset > namedSize ] )
  ifTrue: [ start := firstOffset - namedSize ].
^ start
%

! Class implementation for 'CDeclaration'

!		Class methods for 'CDeclaration'

category: 'other'
classmethod: CDeclaration
header: aHeader
	"Return a CDeclaration (might not be self)"

	^(self readTypeFrom: aHeader) readDeclaration
%

category: 'other'
classmethod: CDeclaration
readInitializer
	"Since we don't have a real expression parser, we will go till we reach
	a comma, semicolon, or close parenthesis not in a nesting"

	| token parenthesisCount curlyBracketCount |
	(token := self peek) ifNil: [^self].
	token value = '__attribute__' ifTrue: [
		self next.
		self readAttributes.
		^self readInitializer
	].
	token isEqualsToken ifFalse: [^self].
	self next.
	parenthesisCount := 0.
	curlyBracketCount := 0.
	[true] whileTrue: [ | pkk |
		(pkk := self peek) ifNil: [ token error:'next token is empty' ].
    token := pkk .
		(parenthesisCount == 0 and: [curlyBracketCount == 0]) ifTrue: [
			token isCommaToken ifTrue: [^self].
			token isSemicolonToken ifTrue: [^self].
			token isCloseParenthesisToken ifTrue: [^self].
		].
		token isOpenParenthesisToken ifTrue: [parenthesisCount := parenthesisCount + 1] ifFalse: [
		token isCloseParenthesisToken ifTrue: [parenthesisCount := parenthesisCount - 1] ifFalse: [
		token isOpenCurlyBracketToken ifTrue: [curlyBracketCount := curlyBracketCount + 1] ifFalse: [
		token isCloseCurlyBracketToken ifTrue: [curlyBracketCount := curlyBracketCount - 1]]]].
		self next.
	].
%

category: 'other'
classmethod: CDeclaration
readTypeFrom: aHeader
	"Return a CDeclaration (might not be self)"

	^self basicNew readTypeFrom: aHeader
%

!		Instance methods for 'CDeclaration'

category: 'CByteArray get'
method: CDeclaration
accessorForOffset: anInteger

	1 < count size ifTrue: [ self error: 'Multi-dimensional arrays not supported']. 
	0 == pointer ifTrue: [
		type == #'class' ifTrue: [^self structAccessorForOffset: anInteger].
		(type isKindOf: CDeclaration) ifTrue: [^self structAccessorForOffset: anInteger].
		count == nil ifTrue: [^self simpleAccessorForOffset: anInteger].
		type == #'uint8' ifTrue: [^self stringAccessorForOffset: anInteger].
		^self arrayAccessorForOffset: anInteger.
	].
	1 < pointer ifTrue: [self error: 'Multi-level pointers not supported'].
	count == nil ifTrue: [^self singlePointerAccessorForOffset: anInteger].
	type == #'uint8' ifTrue: [^self stringPointerAccessorForOffset: anInteger].
	^self arrayPointersAccessorForOffset: anInteger.
%

category: 'CCallout'
method: CDeclaration
addSourceTo: aStream
  | fn |
  file ifNil:[ 
    fn := 'test'
  ] ifNotNil:[ 
    fn := file .
    fn size > 0 ifTrue:[ | gsIncl exp |
      gsIncl := GsFile _expandEnvVariable:'GEMSTONE' isClient: false .
      gsIncl := GsFile _expandFilename: gsIncl isClient: false . "follow symlinks"
      (gsIncl at: 1 equals: (exp := '/export')) ifTrue:[
         gsIncl := gsIncl copyFrom: exp size + 1  to: gsIncl size .
      ].
      gsIncl ifNotNil:[  | ofs |
        ofs := 1 .
        gsIncl last == $/ ifFalse:[ gsIncl add: $/ ].
        gsIncl add: 'include' .
        (fn at: 1 equals: exp) ifTrue:[ ofs := ofs + exp size ].
        (fn at: ofs  equals: gsIncl) ifTrue:[ 
          fn := '$GEMSTONE/include' , (fn copyFrom: gsIncl size + ofs  to: fn size)
        ].
        (System gemVersionReport at: 'gsBuildArchitecture') = 'Darwin (macOS)' ifTrue:[
          (fn at: 1 equals: '/Volumes') ifTrue:[ "Darwin"
            fn := fn copyFrom: '/Volumes' size + 1 to: fn size .
            (fn at: 1 equals: gsIncl) ifTrue:[ 
              fn := '$GEMSTONE/include' , (fn copyFrom: gsIncl size + 1 to: fn size)
            ].
          ].
        ]
      ].
    ].
  ].
	aStream 
		lf; tab; nextPut: $";
		nextPutAll: fn ;
		nextPutAll: ' line ';
		nextPutAll: line printString;
		lf;
		yourself.
	source trimSeparators do: [:char | aStream nextPut: char. char == $" ifTrue: [aStream nextPut: char]].
	aStream nextPut: $"; lf.
%

category: 'CCallout'
method: CDeclaration
argumentType

	(self isSimple and: [self knownArgumentTypes includesIdentical: type]) ifTrue: [^type].
	type == #'enum' ifTrue: [^#'int32'].
	(type == #'uint8' and: [isConstant]) ifTrue: [
		(count size == 1 and: [pointer == 0]) ifTrue: [^#'const char*'].		"const char foo[]"
		(count == nil and: [pointer == 1]) ifTrue: [^#'const char*'].			"const char * foo"
	].
	^#'ptr'.
%

category: 'CByteArray get'
method: CDeclaration
arrayAccessorForOffset: anInteger

	^(AppendStream on: String new)
		nextPutAll: name; lf; lf; tab;
		nextPutAll: '| array offset |'; lf; tab;
		nextPutAll: 'array := Array new: ';
		nextPutAll: count first printString;
		nextPut: $.; lf; tab;
		nextPutAll: 'offset := ';
		nextPutAll: anInteger printString;
		nextPut: $.; lf; tab;
		nextPutAll: '1 to: array size do: [:i | '; lf; tab; tab;
		nextPutAll: 'array at: i put: (self ';
		nextPutAll: self getSelector;
		nextPutAll: ' offset).'; lf; tab; tab;
		nextPutAll: 'offset := offset + ';
		nextPutAll: self baseByteSize printString;
		nextPut: $.; lf; tab;
		nextPutAll: '].'; lf; tab;
		nextPutAll: '^array.'; lf;
		contents.
%

category: 'CByteArray get'
method: CDeclaration
arrayPointersAccessorForOffset: anInteger

	^(AppendStream on: String new)
		nextPutAll: name; lf; lf; tab;
		nextPutAll: '| array offset |'; lf; tab;
		nextPutAll: 'array := Array new: ';
		nextPutAll: count first printString;
		nextPut: $.; lf; tab;
		nextPutAll: 'offset := ';
		nextPutAll: anInteger printString;
		nextPut: $.; lf; tab;
		nextPutAll: '1 to: array size do: [:i | '; lf; tab; tab;
		nextPutAll: 'array at: i put: (self pointerAt: offset resultClass: ';
		nextPutAll: header cByteArraySpecies name asString;
		nextPutAll: ').'; lf; tab; tab;
		nextPutAll: 'offset := offset + 8.'; lf; tab;
		nextPutAll: '].'; lf; tab;
		nextPutAll: '^array.'; lf;
		contents.
%

category: 'CByteArray put'
method: CDeclaration
arrayPointersUpdatorForOffset: anInteger

	^(AppendStream on: String new)
		nextPutAll: name;
		nextPutAll: ': anArrayOfCByteArrayInstances'; lf; lf; tab;
		nextPutAll: '| offset |'; lf; tab;
		nextPutAll: 'offset := ';
		nextPutAll: anInteger printString;
		nextPut: $.; lf; tab;
		nextPutAll: '1 to: anArrayOfCByteArrayInstances size do: [:i | '; lf; tab; tab;
		nextPutAll: 'self'; lf; tab; tab; tab;
		nextPutAll: 'pointerAt: offset'; lf; tab; tab; tab; 
		nextPutAll: 'put: (anArrayOfCByteArrayInstances at: i).'; lf; tab; tab;
		nextPutAll: 'offset := offset + 8.'; lf; tab;
		nextPutAll: '].'; lf;
		contents.
%

category: 'CByteArray put'
method: CDeclaration
arrayUpdatorForOffset: anInteger

	^(AppendStream on: String new)
		nextPutAll: name;
		nextPutAll: ': aSequenceableCollection'; lf; lf; tab;
		nextPutAll: '| offset |'; lf; tab;
		nextPutAll: 'offset := ';
		nextPutAll: anInteger printString;
		nextPut: $.; lf; tab;
		nextPutAll: '1 to: aSequenceableCollection size do: [:i | '; lf; tab; tab;
		nextPutAll: 'self '; lf; tab; tab; tab;
		nextPutAll: self getSelector; space;
		nextPutAll: 'offset'; lf; tab; tab; tab;
		nextPutAll: 'put: (aSequenceableCollection at: i).'; lf; tab; tab;
		nextPutAll: 'offset := offset + ';
		nextPutAll: self baseByteSize printString;
		nextPut: $.; lf; tab;
		nextPutAll: '].'; lf;
		contents.
%

category: 'CCallout'
method: CDeclaration
asClassVarName

	^'Function' , name.
%

category: 'other'
method: CDeclaration
atEnd

	^header atEnd.
%

category: 'CByteArray get'
method: CDeclaration
baseAccessorForOffset: anInteger

	^'self ' , self getSelector , ' ' , anInteger printString.
%

category: 'size'
method: CDeclaration
baseByteSize

	0 < pointer ifTrue: [^8].
	bitCount ifNotNil: [^bitCount].
	(type == #'int8' or: [type == #'uint8']) ifTrue: [^1].
	(type == #'int16' or: [type == #'uint16']) ifTrue: [^2].
	(type == #'int32' or: [type == #'uint32']) ifTrue: [^4].
	(type == #'int64' or: [type == #'uint64']) ifTrue: [^8].
	(type == #'void' and: [0 < pointer]) ifTrue: [^8].
	type == #'class' ifTrue: [^self baseStructByteSize].
	type == #'struct' ifTrue: [^self baseStructByteSize].
	type == #'union' ifTrue: [^self baseUnionByteSize].
	type == #'enum' ifTrue: [^4].
	type == #'function' ifTrue: [^8].
	type == #'double' ifTrue: [^8].
	(type isKindOf: CDeclaration) ifTrue: [^type baseByteSize].
  self error:'in baseByteSize, unknown type ', type printString	.
%

category: 'size'
method: CDeclaration
baseStructByteSize

	| bits |
	bits := 0.
	fields do: [:each |  
		each bitCount ifNil: [
			bits := bits + (each byteSize * 8).
		] ifNotNil: [
			each count ifNotNil: [self error: 'Array of bits!?'].
			bits := bits + each bitCount.
		].
	].
	^(bits / 8) ceiling.
%

category: 'size'
method: CDeclaration
baseUnionByteSize

	^fields 
		inject: 0
		into: [:max :each | max max: each baseByteSize].
%

category: 'other'
method: CDeclaration
beExternStorage

	storage := #'extern'.
%

category: 'accessors'
method: CDeclaration
bitCount

	^bitCount.
%

category: 'size'
method: CDeclaration
byteSize

	| x |
	x := self baseByteSize.
	count ifNil: [^x].
	count do: [:y | x := x * y].
	^x.
%

category: 'size'
method: CDeclaration
byteSizeRounded
  "Return a size aligned on an 8 byte boundary, like a C compiler would do"
  | x pad rem | 
  x := self byteSize .
  pad := 0 .
  (rem := x \\ 8) ~~ 0 ifTrue:[
    pad := 8 - rem
  ].
  ^ x + pad
%

category: 'querying'
method: CDeclaration
canStorageBeMadeExternal

	^(#(#auto #inline #static) includesIdentical: storage)
		or: [storage = #extern and: [linkageSpec == nil ]]
%

category: 'CCallout'
method: CDeclaration
cCalloutForLibrary: aCLibrary

	^self cCalloutSpecies
		library: aCLibrary 
		name: name 
		result: self resultType 
		args: (parameters collect: [:each | each argumentType])
		varArgsAfter: (isVaryingArgCount ifTrue: [parameters size] ifFalse: [-1]).
%

category: 'Class Membership'
method: CDeclaration
cCalloutSpecies
"Answer the class to be used for CCallout objects. Subclasses may
 overload this method as needed."
^ CCallout
%

category: 'Class Membership'
method: CDeclaration
cDeclarationSpecies
"Answer the class to be used for CDeclaration objects. Subclasses may
 overload this method as needed."
^ CDeclaration
%

category: 'accessors'
method: CDeclaration
count

	^count.
%

category: 'Class Membership'
method: CDeclaration
cPreprocessorSpecies
"Answer the class to be used for CPreprocessor objects. Subclasses may
 overload this method as needed."
^ CPreprocessor
%

category: 'CCallout'
method: CDeclaration
createFunctionInitializerCode

	| stream space |
	stream := AppendStream on: String new.
	stream
		nextPutAll: self initializerFunctionName;
		nextPutAll: ' cLibrary'; lf; lf; tab;
		nextPutAll: self asClassVarName;
		nextPutAll: ' := ';
		nextPutAll: self cCalloutSpecies name asString; lf; tab; tab;
		nextPutAll: 'library: cLibrary'; lf; tab; tab;
		nextPutAll: 'name: ''';
		nextPutAll: name; 
		nextPut: $'; lf; tab; tab;
		nextPutAll: 'result: #''';
		nextPutAll: self resultType;
		nextPutAll: ''''; lf; tab; tab;
		nextPutAll: 'args: #(';
		yourself.
	space := ''.
	parameters do: [:each | 
		stream 
			nextPutAll: space;
			nextPutAll: each argumentType printString;
			yourself.
		space := ' '.
	].
	^stream
		nextPutAll: ')'; lf; tab; tab;
		nextPutAll: 'varArgsAfter: ';
		nextPutAll: self varArgsAfter printString;
		nextPut: $.; lf;
		contents.
%

category: 'querying'
method: CDeclaration
derivedType

	storage == #'typedef' ifFalse: [^self].
	type == #'class' ifTrue: [^self].
	self isFunction ifTrue: [^self].
	^type
%

category: 'accessors'
method: CDeclaration
enumList

	^type == #'enum'
		ifTrue: [fields]
		ifFalse: [nil].
%

category: 'accessors'
method: CDeclaration
enumTag

	^enumTag.
%

category: 'Errors'
method: CDeclaration
error: aString

  Error signal: aString , ' near line ' , line asString , ' in file ' , file asString
%

category: 'other'
method: CDeclaration
expectCloseParenthesisCount: anInteger

	anInteger timesRepeat: [
		| token |
		(token := self next) isCloseParenthesisToken ifFalse: [token error: 'Expected '')'' '].
	].
%

category: 'accessors'
method: CDeclaration
fields

	^type == #'struct'
		ifTrue: [fields]
		ifFalse: [nil].
%

category: 'accessors'
method: CDeclaration
file

	^file.
%

category: 'CByteArray get'
method: CDeclaration
getSelector

	(#(
		#'int8' #'int16' #'int32' #'int64'
		#'uint8' #'uint16' #'uint32' #'uint64'
	) includesIdentical: type) ifTrue: [^type , 'At:'].
	type == #'enum' ifTrue: [^'int32At:'].
	type == #'function' ifTrue: [^'uint64At:'].
  self error:'in getSelector, unknown type ', type printString	.
%

category: 'accessors'
method: CDeclaration
header

	^header.
%

category: 'accessors'
method: CDeclaration
includesCode

	^includesCode.
%

category: 'type'
method: CDeclaration
initializeAsStructOrUnion

	| token |
	storage := #'auto'.
	(token := self peek) isOpenCurlyBracketToken ifFalse: [^self].
	self next.
	fields ifNotNil: [self error: 'Fields already defined!'].
	fields := { }.
	[
		(token := self peek) isCloseCurlyBracketToken .
	] whileFalse: [
		| field |
		field := self class header: header.
		field storage == #'auto' ifFalse: [ token error: 'storage is not #auto'].
		[
			fields add: field.
			(token := self next) isCommaToken.
		] whileTrue: [
			field := field copy.
			field readDeclaration.
		].
		token isSemicolonToken ifFalse: [ token error: 'expected '';'' '].
	].
	self next.
%

category: 'CCallout'
method: CDeclaration
initializerFunctionName
	^'initializeFunction_', name, '_inLibrary:'
%

category: 'type'
method: CDeclaration
interpretTypeSpecifier

	type class == Array ifFalse: [^self].
	(type size == 1 and:[
   #(#'class' #'enum' #'float' #'float128' #'void') includesIdentical: type first]) 
     ifTrue: [type := type first. ^self].

	"https://en.cppreference.com/w/c/language/arithmetic_types#Complex_floating_types
	https://gcc.gnu.org/onlinedocs/gcc-4.8.0/gcc/Complex.html"
	(type includesIdentical: #'complex') ifTrue: [
		| string |
		type removeIdentical: #'complex'.
		self interpretTypeSpecifier.
		(type isKindOf: Symbol) ifFalse: [self error: 'Expected to be simplified to a single type'].
		string := String withAll: type.
		string at: 1 put: string first asUppercase.
		type := ('complex' , string) asSymbol.
		^self
	].

	(type includesIdentical: #'char') ifTrue: [
		type removeIdentical: #'char'.
		type = #(#'signed') ifTrue: [type := #'int8'. ^self].
		(type isEmpty or: [type = #(#'unsigned')]) ifTrue: [type := #'uint8'. ^self].
    self error:'for a char type , unknown type ', type printString	.
	].
	(type includesIdentical: #'double') ifTrue: [
		type removeIdentical: #'double'.
		type isEmpty ifTrue: [type := #'double'. ^self].
		type = #(#'long') ifTrue: [type := #'longDouble'. ^self].
    self error:'for a double type, unknown type ', type printString	.
	].
	(type isEmpty or: [#(#'int' #'unsigned' #'long' #'signed' #'short') 
                     anySatisfy: [:each | type includesIdentical: each]]) ifTrue: [
		| isUnsigned |
		(type includesIdentical: #'int') ifTrue: [type removeIdentical: #'int'].
		(isUnsigned := type includesIdentical: #'unsigned') ifTrue: [type removeIdentical: #'unsigned'].
		(type includesIdentical: #'signed') ifTrue: [type removeIdentical: #'signed'].
		type = #(#'long') ifTrue: [
			type := isUnsigned ifTrue: [#'uint64'] ifFalse: [#'int64'].
			^self.
		].
		type = #(#'long' #'long') ifTrue: [
			type := isUnsigned ifTrue: [#'uint64'] ifFalse: [#'int64'].
			^self.
		].
		type = #(#'short') ifTrue: [
			type := isUnsigned ifTrue: [#'uint16'] ifFalse: [#'int16'].
			^self.
		].
		type isEmpty ifTrue: [
			type := isUnsigned ifTrue: [#'uint32'] ifFalse: [#'int32'].
			^self.
		].
		self error:'unrecognized integer type: ', type printString .
	].
	(type size == 1 and:[
     #(#'uint64' #'int64' #'uint32' #'int32' #'uint16' #'int16' #'uint8' #'int8') 
         includesIdentical: type first]) ifTrue: [
		type := type first.
		^self.
	].
	(type size == 1 and: [type first isKindOf: CDeclaration]) ifTrue: [type := type first. ^self].
	self error:'unrecognized type: ', type printString .
%

category: 'CCallout'
method: CDeclaration
invokeFunctionCode

	| args stream delimiter |
	args := parameters collect: [:each | each name].
	1 to: args size do: [:i | 
		(args at: i) ifNil: [args at: i put: 'arg' , i printString].
	].
	stream := (AppendStream on: String new)
		nextPutAll: name;
		yourself.
	args do: [:each | 
		stream 
			nextPutAll: '_: ';
			nextPutAll: each;
			space;
			yourself.
	].
	self addSourceTo: stream.
	stream
		lf; tab; 
		nextPutAll: '"Interpreted as #';
		nextPutAll: self resultType;
		nextPutAll: ' from #(';
		yourself.
	parameters do: [:each | stream space. each argumentType printOn: stream].
	stream 
		nextPutAll: ' )';
		nextPut: $"; lf; lf; 
		tab; nextPut: $^;
		nextPutAll: self asClassVarName;
		nextPutAll: ' callWith: { ';
		yourself.
	delimiter := ''.
	args do: [:each | 
		stream 
			nextPutAll: delimiter;
			nextPutAll: each;
			yourself.
		delimiter := '. '.
	].
	isVaryingArgCount ifTrue: [stream nextPutAll: '"varArgs array should be appended to this array"'].
	^stream 
		nextPutAll: ' }'; lf;
		contents.
%

category: 'accessors'
method: CDeclaration
isConstant

	^isConstant.
%

category: 'querying'
method: CDeclaration
isEmptyExternalLinkage
	"Answer whether the receiver is the introduction of:
		extern ''C'' { ... }
	 Note that we also end up with this after reading the entire { ... } block."

	^self storage = #extern
		and: [linkageSpec ~~ nil 
		and: [self name == nil 
		and: [self type == nil ]]]
%

category: 'querying'
method: CDeclaration
isEmptyVoid

	^name == nil and: [
		storage == #'auto' and: [
		type == #'void' and: [
		count == nil and: [
		pointer == 0 and: [
		fields == nil and: [
		isConstant == false and: [
		self isFunction == false and: [
		bitCount == nil]]]]]]]].
%

category: 'querying'
method: CDeclaration
isFunction

	^parameters ~~ nil .
%

category: 'CCallout'
method: CDeclaration
isSimple

	^count == nil  and: [pointer = 0].
%

category: 'accessors'
method: CDeclaration
isVaryingArgCount

	^isVaryingArgCount.
%

category: 'CCallout'
method: CDeclaration
knownArgumentTypes

	^#( #int64 #uint64 #int32 #uint32 #int16 #uint16 #int8 #uint8 #bool #double #float #ptr #'char*' "#'&ptr'" #'const char*' ).
%

category: 'CCallout'
method: CDeclaration
knownResultTypes

	^#( #int64 #uint64 #int32 #uint32 #int16 #uint16 #int8 #uint8 #bool #double #float #ptr #'char*' #void ).
%

category: 'accessors'
method: CDeclaration
line

	^line.
%

category: 'accessors'
method: CDeclaration
linkageSpec

	^linkageSpec.
%

category: 'declarator'
method: CDeclaration
mayHaveCode

	storage == #'static' 	ifTrue: [^true].
	storage == #'inline' 	ifTrue: [^true].
	type == #'class'		ifTrue: [^true].
	((type isKindOf: CDeclaration) and: [type type == #'class']) ifTrue: [^true].
	^false
%

category: 'accessors'
method: CDeclaration
members

	^type == #'union'
		ifTrue: [fields]
		ifFalse: [nil].
%

category: 'accessors'
method: CDeclaration
name

	^name.
%

category: 'other'
method: CDeclaration
next
  | res |
	res := self peek ; _next .
  ^ res
%

category: 'accessors'
method: CDeclaration
parameters

	^parameters.
%

category: 'other'
method: CDeclaration
peek

	| next wasIdentifierInSystemNamespace |
	wasIdentifierInSystemNamespace := false.
	[
		| wasEmpty |
		next := header peek.
		next ifNil:[ ^ nil ].
		wasEmpty := next isEmptyToken.
		wasEmpty ifFalse: [
			| value |
			(wasIdentifierInSystemNamespace and: [next isOpenParenthesisToken]) ifTrue: [
				self skipFunction.
				^self peek.
			] ifFalse: [
				wasIdentifierInSystemNamespace := next isIdentifierToken and: [2 < (value := next value) size and: 
					[(value at: 1) == $_ and: [(value at: 2) == $~]]].
			].
		].
		wasEmpty or: [wasIdentifierInSystemNamespace].
	] whileTrue: [
		self _next.
	].
	^ next
%

category: 'accessors'
method: CDeclaration
pointer

	^pointer.
%

category: 'other'
method: CDeclaration
printFunctionParametersOn: aStream

	| comma |
	(name == nil  or: [name last ~~ $(]) ifTrue: [
		aStream nextPut: $(.
	].
	(parameters == nil  or: [parameters isEmpty]) ifTrue: [aStream nextPutAll: 'void)'. ^self].
	comma := ''.
	parameters do: [:each | 
		aStream nextPutAll: comma.
		each printOn: aStream.
		comma := ', '.
	].
	aStream nextPut: $).
%

category: 'other'
method: CDeclaration
printOn: aStream

	storage ifNotNil: [
		(storage == #'auto' or: [storage == #'typedef' and: [type == #'class']]) ifFalse: [aStream nextPutAll: storage; space].
		linkageSpec ifNotNil:[ aStream nextPut: $"; nextPutAll: linkageSpec; nextPut: $"; space].
	].
	isConstant ifTrue: [aStream nextPutAll: 'const '].
	((type isKindOf: CDeclaration) and: [type isFunction]) ifTrue: [
		type printOn: aStream from: self.
		^self.
	].
	type ~= #() ifTrue: [
		(type isKindOf: Symbol)
			ifTrue: [aStream nextPutAll: type]
			ifFalse: [type printOn: aStream]. 
		aStream space.
	].
	pointer timesRepeat: [aStream nextPut: $*].
	enumTag ifNotNil: [aStream nextPutAll: enumTag; space].
	(storage == #'typedef' and: [self isFunction and: [0 < pointer]]) ifTrue: [aStream nextPut: $(].
	name ifNotNil: [aStream nextPutAll: name].
	count ifNotNil: [
		count do: [:each | 
			aStream nextPut: $[.
			0 < each ifTrue: [each printOn: aStream].
			aStream nextPut: $].
		].
	].
	(storage == #'typedef' and: [self isFunction and: [0 < pointer]]) ifTrue: [aStream nextPut: $)].
	self isFunction ifTrue: [self printFunctionParametersOn: aStream].
%

category: 'other'
method: CDeclaration
printOn: aStream from: aCDeclaration

	| open close |
	(type isKindOf: Symbol) ifTrue: [
		aStream nextPutAll: type.
	] ifFalse: [
		aStream nextPutAll: '<???>'.
	].
	aStream space.
	0 == aCDeclaration pointer ifTrue: [
		open := ''.
		close := ''.
	] ifFalse: [
		open := '('. 
		close := ')'.
	].
	pointer timesRepeat: [aStream nextPut: $*].
	aStream nextPutAll: open.
	aCDeclaration pointer timesRepeat: [aStream nextPut: $*].
	(name ~~ nil  and: [storage ~~ #'typedef']) ifTrue: [aStream nextPutAll: name].
	aStream nextPutAll: close.
	self printFunctionParametersOn: aStream.
%

category: 'accessors'
method: CDeclaration
properties

	^type == #'class'
		ifTrue: [fields]
		ifFalse: [nil].
%

category: 'attributes'
method: CDeclaration
readAttributes
"
	http://tigcc.ticalc.org/doc/gnuexts.html
"
	| parenthesisCount token |
	(token := self next) isOpenParenthesisToken ifFalse: [token error: 'Expected ''('' '].
	(token := self next) isOpenParenthesisToken ifFalse: [token error: 'Expected ''('' '].
	parenthesisCount := 2.
	[
		0 < parenthesisCount.
	] whileTrue: [
		token := self next.
		token isOpenParenthesisToken ifTrue: [
			parenthesisCount := parenthesisCount + 1.
		] ifFalse: [
			token isCloseParenthesisToken ifTrue: [
				parenthesisCount := parenthesisCount - 1.
			] ifFalse: [
				(token isIdentifierToken and: [token value = '__mode__']) ifTrue: [^self readModeAttributes].
			].
		].
	].
%

category: 'other'
method: CDeclaration
readBitFields
	"We parse bit fields, but we don't handle them properly!"

	bitCount := self cPreprocessorSpecies evaluateHeader: header.
	(bitCount isKindOf: SmallInteger) ifFalse: [ self error: 'Expected a SmallInteger in readBitFields'].
%

category: 'type'
method: CDeclaration
readComplexType
"
>>--+--struct--+--+-----identifier---------------------------+--><
      |              |   |                        .----------------.     |
      '--union----'    |                       V                   |     |
                          '--+----------+--{----member--;--+--}-'
                             '-identifier-'
"
	self peek isIdentifierToken ifTrue: [
		| dictionary |
		name := self next value.
    "  self trapName ."
		dictionary := type == #'struct'
			ifTrue: [header structs]
			ifFalse: [header unions].
		type := dictionary
			at: name
			ifAbsentPut: [self copy].
	] ifFalse: [
		type := self copy.
	].
	type fields ifNil: [type initializeAsStructOrUnion].
	name := nil.
%

category: 'declarator'
method: CDeclaration
readConstantExpression

	| token x |
	[
		(x := self peek) ~~ nil and: [x isOpenSquareBracketToken].
	] whileTrue: [
		| value tok |
		self next.
		count ifNil: [count := { } ].
		value := (tok := self peek) isCloseSquareBracketToken 
			ifTrue: [0]
			ifFalse: [self cPreprocessorSpecies evaluateHeader: header].
		value _isSmallInteger  ifFalse: [ tok error: 'Expected a SmallInteger'].
		count add: value.  
		(token := self next) isCloseSquareBracketToken ifFalse:[ token error:'expected '']'' '].
	].
%

category: 'declarator'
method: CDeclaration
readDeclaration
	"Return a CDeclaration (might not be self)
	   .-,------------------------------.
	  V                                      |
	----declarator--+-------------+-+--;--><
						  '--initializer--'

	We handle only one declarator; the caller (in CHeader>>#'readOne') handles the comma.
"
	| declaration token1 token2 |
	token1 := self peek.	"for debugging"
	(declaration := self readDeclarator) ifNil: [
		^self.
	].
	declaration includesCode ifTrue: [^declaration].
	token2 := self peek.	"for debugging"
	^declaration 
		readInitializer;
		readPostlude;
		yourself
%

category: 'declarator'
method: CDeclaration
readDeclarator
	"Return a CDeclaration (might not be self)
	>>--+-------------------------+--directDeclarator--><
	      |  .---------------------.  |
	      |  V                        |  |
	      '----pointerOperator--+-'
"
	| declaration token1 token2 |
	token1 := self peek.	"for debugging"
	(declaration := self readPointerOperator) ifNotNil: [
		token2 := self peek.	"for debugging"
		^declaration readDeclarator.
	].
	^self readDirectDeclarator.
%

category: 'declarator'
method: CDeclaration
readDirectDeclarator
	"Return a CDeclaration (might not be self)
	>>--+-----------------------------------------------------------------------------------------------------------------+-><
	      +--declaratorName---------------------------------------------------------------------------------------------+
	      +--directDeclarator--(--parameterDeclarationList--)--+----------------+---+----------------------------+--+
	      |                                                                       '--cvQualifiers--'     '--exceptionSpecification--'    |
	      +--directDeclarator--[--+-----------------------+--]-----------------------------------------------------------+
	      |                                '-constantExpression-'                                                                           |
	      '--(--declarator--)-----------------------------------------------------------------------------------------------'
"
	| token declarator |
	(token := self peek) ifNil: [^self].
	token isIdentifierToken ifTrue: [
		name := token value.
    "  self trapName ."
		(token := self next; peek) ifNil: [^self].
	] ifFalse: [ 
		(((type isKindOf: CDeclaration) and: [type type == #'class']) == false  
          and: [token isOpenParenthesisToken]) ifTrue: [ 
			self next.	"skip the open parenthesis token"
			declarator := self cDeclarationSpecies header: header.
			(token := self next) isUpArrowToken ifTrue: [	"Block argument, not pointer to function"
				storage := #'block'. 
				(token := self next) isIdentifierToken ifTrue: [token := self next].
			].
			token isCloseParenthesisToken ifFalse: [self error: 'expected '')'''].
			(token := self peek) ifNil: [self error: 'next token is empty'].
		].
	].
	token isOpenParenthesisToken ifTrue: [
		self readParameterDeclarationList.
		declarator ifNil: [^self].
		declarator 
			setStorage: storage
			type: self.
		storage := #'auto'.
		^declarator
	].
	token isOpenSquareBracketToken ifTrue: [
		declarator ifNotNil: [ token error:'unexpected declarator after ''['' ' ].
		self readConstantExpression.
		^self
	].
	declarator ifNil: [^self].
	"this is a specialized check for a function argument of the form 'struct dirent *(*[])'."
	(declarator storage == #'auto' and: [
		declarator type == #'int32' and: [
		declarator name == nil  and: [
		declarator count = #(0)]]]) ifTrue: [
			pointer := pointer + declarator pointer + 1.
		].
	^self
%

category: 'type'
method: CDeclaration
readEnumeration
       "
       'enum' [ identifier ] '{' enumerator-list '}' [ variable-list ]
       or
       'enum' identifier variable-list 
       or
       'enum' identifier function-definition // #48859
       "

	| token integralConstant |
	token := self peek.
	token isIdentifierToken ifTrue: [
		enumTag := self next value.
		token := self peek.
	].
       token isOpenCurlyBracketToken ifTrue: [
               fields := Dictionary new.       "this allows us to tell if the enum included an enumerator-list"
               self next.
               integralConstant := -1.
               [
                       (token := self next) isCloseCurlyBracketToken.
               ] whileFalse: [
                       | identifier |
                       token isIdentifierToken ifFalse: [token error: 'expected an identifier' ].
                       identifier := token value.
                       integralConstant := self peek isEqualsToken ifTrue: [ | tok |
                               tok := self next.
                               integralConstant := self cPreprocessorSpecies evaluateHeader: header.
                               (integralConstant _isSmallInteger) ifFalse: [ tok error: 'Expected a SmallInteger'].
                               integralConstant.
                       ] ifFalse: [
                               integralConstant + 1.
                       ].
                       (header enums includesKey: identifier) ifTrue: [ token error: 'Duplicate enum definition!'].
                       header enums at: identifier put: integralConstant.
                       fields at: identifier put: integralConstant.
                       self peek isCommaToken ifTrue: [self next].
                ].

		].
%

category: 'declarator'
method: CDeclaration
readInitializer
	"Since we don't have a real expression parser, we will go till we reach
	a comma, semicolon, or close parenthesis not in a nesting"

	| token parenthesisCount curlyBracketCount |
	(token := self peek) ifNil: [^self].
	token value = '__attribute__' ifTrue: [
		self next.
		self readAttributes.
		^self readInitializer
	].
	token isEqualsToken ifFalse: [^self].
	self next.
	parenthesisCount := 0.
	curlyBracketCount := 0.
	[true] whileTrue: [ | pkk |
		(pkk := self peek) ifNil: [ token error:'next token is empty' ].
    token := pkk .
		(parenthesisCount == 0 and: [curlyBracketCount == 0]) ifTrue: [
			token isCommaToken ifTrue: [^self].
			token isSemicolonToken ifTrue: [^self].
			token isCloseParenthesisToken ifTrue: [^self].
		].
		token isOpenParenthesisToken ifTrue: [parenthesisCount := parenthesisCount + 1] ifFalse: [
		token isCloseParenthesisToken ifTrue: [parenthesisCount := parenthesisCount - 1] ifFalse: [
		token isOpenCurlyBracketToken ifTrue: [curlyBracketCount := curlyBracketCount + 1] ifFalse: [
		token isCloseCurlyBracketToken ifTrue: [curlyBracketCount := curlyBracketCount - 1]]]].
		self next.
	].
%

category: 'attributes'
method: CDeclaration
readModeAttributes
"
	http://tigcc.ticalc.org/doc/gnuexts.html#SEC91_mode
	http://www.linuxtopia.org/online_books/programming_tool_guides/linux_using_gnu_compiler_collection/vector-extensions.html
		QI = 8-bit integer, HI = 16-bit integer, SI = 32-bit integer, DI = 64-bit integer, SF = 32-bit float, DF = 64-bit float, TC = 128-bit complex
		byte = 8-bit integer, word = 64-bit integer, pointer = 64-bit integer

	typedef int int8_t __attribute__ ( ( __mode__ ( __QI__ ) ) ) ;
"
	| token mode |
	(token := self peek) isOpenParenthesisToken ifFalse: [ token error: 'expected ''('' '].
	self next.
	(token := self next) key == #'identifier' ifFalse: [token error: 'Expected an identifier'].
	mode := token value.
	type := 
		mode = '__QI__' ifTrue: [type first == $u ifTrue: [#'uint8'] ifFalse: [#'int8']] ifFalse: [
		mode = '__HI__' ifTrue: [type first == $u ifTrue: [#'uint16'] ifFalse: [#'int16']] ifFalse: [
		mode = '__SI__' ifTrue: [type first == $u ifTrue: [#'uint32'] ifFalse: [#'int32']] ifFalse: [
		mode = '__DI__' ifTrue: [type first == $u ifTrue: [#'uint64'] ifFalse: [#'int64']] ifFalse: [
		mode = '__byte__' ifTrue: [type first == $u ifTrue: [#'uint8'] ifFalse: [#'int8']] ifFalse: [
		mode = '__word__' ifTrue: [type first == $u ifTrue: [#'uint64'] ifFalse: [#'int64']] ifFalse: [
		mode = '__pointer__' ifTrue: [type first == $u ifTrue: [#'uint64'] ifFalse: [#'int64']] 
      ifFalse: [
		mode = '__TC__' ifTrue: [#'complexDouble'] ifFalse: [
		self error: 'unrecognized __mode__: ' , mode printString .
  ]]]]]]]].
	self expectCloseParenthesisCount: 3.
%

category: 'declarator'
method: CDeclaration
readParameterDeclarationList
  | token |
  self next.  "open parenthesis token"
  parameters := { } .
  "self trapName ."
  [
    (token := self peek ) isCloseParenthesisToken 
  ] whileFalse: [
    self peek isDotToken ifTrue: [
      self next.
      2 timesRepeat: [(token := self next) isDotToken ifFalse: [ token error:'expected ''.'' ']].
      isVaryingArgCount := true.
      (token := self peek) isCloseParenthesisToken ifFalse: [ token error:'expected '')'' '].
    ] ifFalse: [
      parameters add: (self cDeclarationSpecies header: header).
      (token := self peek) isCommaToken ifTrue: [self next].
    ].
  ].
  self next.  "close parenthesis token"
  (parameters size = 1 and: [parameters first isEmptyVoid]) ifTrue: [
    parameters := #().
  ].
  self mayHaveCode ifFalse:[ ^self].
  [
    (token := self peek) ifNil: [^self].
    token isSemicolonToken ifTrue: [^self].
    token isOpenCurlyBracketToken
  ] whileFalse: [
    self next.
  ].
  self next.
  self skipToEndOfCodeBlock.
%

category: 'declarator'
method: CDeclaration
readPointerOperator
	"Return a CDeclaration (might not be self)
	>>--*--+----------------+--><
	          '-typeQualifiers-' 
"
	| token |
	(token := self peek) ifNil: [^nil].
	token isStarToken ifFalse: [^nil].
	pointer := pointer + 1.
	(token := self next; peek) ifNil: [^self].
	token isIdentifierToken ifFalse: [^self].
	(#('const' 'volatile') includes: token value) ifFalse: [^self].
	self next.
	"we don't keep track of const pointers, only the data"
%

category: 'declarator'
method: CDeclaration
readPostlude

	| token1 token2 |
	(token1 := self peek) ifNil: [^self].
	token1 isIdentifierToken ifTrue: [
		(2 < token1 value size and: [(token1 value at: 1) == $_ and: [(token1 value at: 2) == $_]]) ifTrue: [
			(token2 := self next; peek) ifNil: [self next. ^self].	"Ignore trailing tokens beginning with double-underscore"
			token2 isOpenParenthesisToken ifTrue: [
				token1 value = '__attribute__' ifTrue: [
					self readAttributes.
				] ifFalse: [
					self skipFunction.
				].
			].
			^self readPostlude.
		].
		self error: 'unexpected token: ', token1 printString.
	].
	token1 isColonToken ifTrue: [
		self next. 
		self readBitFields. 
		^self readPostlude.
	].
	token1 isOpenCurlyBracketToken ifTrue: [
		((type isKindOf: CDeclaration) and: [type type == #'class']) ifTrue: [
			self skipToEndOfCodeBlock.
			^self.
		].
		self isFunction ifTrue: [		"Functions might have code (bugs #43426 & 43782)"
			self next.
			self skipToEndOfCodeBlock.
			^self
		].
	].
	token1 isEqualsToken ifTrue: [	"Check for an initialization"
		[
			(token2 := self next; peek) ~~ nil  and: [token2 isSemicolonToken].
		] whileFalse.
		^self
	].
%

category: 'type'
method: CDeclaration
readStorageClassSpecifier
	"Return a CDeclaration (might not be self)
	( 'auto' | 'extern' | 'register' | 'static' | 'typedef' | 'inline' )
"
	| token value |
	(token := self peek) ifNil: [^nil].
	token isTildeToken ifTrue: [token := self next; peek].	"indicates a class destructor function, which we can ignore"
	[token isExtensionIdentifierToken] whileTrue: [token := self next; peek].	"safe to ignore"
	token  isIdentifierToken ifFalse: [^nil].
	token value = 'inline' ifTrue: [
		self next.
		storage := #'inline'.
		^self.
	].
	(#('auto' 'extern' 'register' 'static' 'typedef') includes: token value) ifTrue: [
		(storage ~~ nil  and: [storage ~= token value asSymbol])
			ifTrue: [ token error: 'We support only one storage specifier'].
		storage := self next value asSymbol.
		(token := self peek) ifNil: [^nil].
		value := token value.
		(storage = #'extern' and: [token type = #'string']) ifTrue: [
			linkageSpec := value.
			(token := self next; peek) isOpenCurlyBracketToken
				ifTrue: [type := nil].
		].
		^self.
	].
	^nil.
%

category: 'type'
method: CDeclaration
readType
	"Return a CDeclaration (might not be self)
"
	| declaration |
	declaration := self readTypeA.
	storage ifNil: [storage := #'auto'].
	self interpretTypeSpecifier.
	^self.
%

category: 'type'
method: CDeclaration
readTypeA
	"Return a CDeclaration (might not be self)
	        .-----------------------------.  
	        V                                 |
	>>---+----------------------------+--><
           +--storageClassSpecifier--+			( 'auto' | 'extern' | 'register' | 'static' | 'typedef' | 'inline' )
           +--typeSpecifier-----------+			( 'void' | 'char' | 'short' | 'int' | 'long' | 'float' | 'double' | ... )
           '--typeQualifier-------------'				( 'const' | 'volatile' )
"
	| declaration token |
	(token := self peek) isAttributeIdentifierToken ifTrue: [self next; readAttributes. ^self readTypeA].
	(declaration := self readStorageClassSpecifier) ifNotNil: [^declaration readTypeA].
	(declaration := self readTypeSpecifier) ifNotNil: [^declaration readTypeA].
	(declaration := self readTypeQualifier) ifNotNil: [^declaration readTypeA].
	^self.
%

category: 'type'
method: CDeclaration
readTypeFrom: aHeader
	"Return a CDeclaration (might not be self)"

	header := aHeader.
	[self peek isEmptyToken] whileTrue: [self next].
	type := { } .
	pointer := 0.
	isConstant := false.
	includesCode := false.
	isVaryingArgCount := false.
	^self readType.
%

category: 'type'
method: CDeclaration
readTypeQualifier
 	"Return a CDeclaration (might not be self)
	( 'const' | 'volatile' )
"
	| token value |
	(token := self peek) 	ifNil: [^nil].
	token isIdentifierToken 	ifFalse: [^nil].
	value := token value.
	value = 'const' 	ifTrue: [self next. isConstant := true. ^self].
	value = 'volatile' 	ifTrue: [self next. ^self].
	^nil.
%

category: 'type'
method: CDeclaration
readTypeSpecifier
 	"Return a CDeclaration (might not be self)
		( 'void' | 'char' | 'short' | 'int' | 'long' | 'float' | 'double' | 'signed' | 'unsigned' 
       | '_Complex' | struct_or_union_spec | enum_spec | typedef_name )
	"
	| token value declaration |
	(token := self peek) ifNil: [^nil].
	token isIdentifierToken ifFalse: [^nil].
	value := token value.
	( #('void' 'char' 'short' 'int' 'long' 'float' 'double' 'signed' 'unsigned') 
        includes: value) ifTrue: [
		type add: value asSymbol.
		self next.
		^ self.
	].
	value = '__float128'	ifTrue: [type := #'float128'.		self next. ^self].
	value = '_Complex'	ifTrue: [type add: #'complex'.	self next. ^self].		"this means that there are two of something else (e.g., double)"
	value = 'ptr'			ifTrue: [type := #'ptr'.				self next. ^self].
	value = 'enum'			ifTrue: [type := #'enum'.			self next. self readEnumeration. 	^self].
	value = 'struct'		ifTrue: [type := #'struct'.			self next. self readComplexType. ^self].
	value = 'union' 		ifTrue: [type := #'union'.			self next. self readComplexType. ^self].
	value = 'class' 		ifTrue: [type := #'class'.			self next. storage := #'typedef'.	^self].
	type = #() ifTrue: [
		declaration :=
			header types at: value ifAbsent: [
			header structs at: value ifAbsent: [
			header unions at: value ifAbsent: [
			header enums at: value ifAbsent: [nil]]]].
		declaration ifNotNil:[ 
      type := declaration derivedType. 
      type == declaration ifFalse:[ pointer := declaration pointer ].  "fix 48748"
      self next. 
      ^self
    ].
	].
	"These are a bit troubling. Sometimes the are expected to be built-in, and other times they are typedefs!"
	(value = '__builtin_va_list' 	and: [type = #()])	ifTrue: [type := #'ptr'. 		self next. ^self].
	(value = '__gnuc_va_list' 	and: [type = #()])	ifTrue: [type := #'ptr'. 		self next. ^self].
	^nil.
%

category: 'CCallout'
method: CDeclaration
resultType

	self isFunction ifFalse: [ self error: 'Not a function!'].
	(self isSimple and: [self knownResultTypes includesIdentical: type]) ifTrue: [^type].
	type == #'enum' ifTrue: [^#'int32'].
	type == #'uint8' ifTrue: [
		(count size == 1 and: [pointer == 0]) ifTrue: [^#'char*'].		"const char foo[]"
		(count == nil and: [pointer == 1]) ifTrue: [^#'char*'].			"const char * foo"
	].
	^#'ptr'.
%

category: 'other'
method: CDeclaration
setClassProperties: anArray

	fields := anArray.
%

category: 'Updating'
method: CDeclaration
setStorage: aSymbol type: aCDeclaration

	storage := aSymbol.
	type := aCDeclaration.
%

category: 'CByteArray get'
method: CDeclaration
simpleAccessorForOffset: anInteger

	^(AppendStream on: String new)
		nextPutAll: name; lf; lf; tab;
		nextPutAll: '^self ';
		nextPutAll: self getSelector; space;
		nextPutAll: anInteger printString;
		nextPut: $.; lf;
		contents.
%

category: 'CByteArray put'
method: CDeclaration
simpleUpdatorForOffset: anInteger

	^(AppendStream on: String new)
		nextPutAll: name;
		nextPutAll: ': anObject'; lf; lf; tab;
		nextPutAll: 'self '; lf; tab; tab;
		nextPutAll: self getSelector; space;
		nextPutAll: anInteger printString; lf; tab; tab;
		nextPutAll: 'put: anObject.'; lf;
		contents.
%

category: 'CByteArray get'
method: CDeclaration
singlePointerAccessorForOffset: anInteger

	^(AppendStream on: String new)
		nextPutAll: name; lf; lf; tab;
		nextPutAll: '^self'; lf; tab; tab;
		nextPutAll: 'pointerAt: ';
		nextPutAll: anInteger printString; lf; tab; tab;
		nextPutAll: 'resultClass: ';
		nextPutAll: header cByteArraySpecies name asString;
		nextPut: $. ; lf;
		contents.
%

category: 'CByteArray put'
method: CDeclaration
singlePointerUpdatorForOffset: anInteger

	^(AppendStream on: String new)
		nextPutAll: name; 
		nextPutAll: ': aCByteArray'; lf; lf; tab;
		nextPutAll: 'self'; lf; tab; tab;
		nextPutAll: 'pointerAt: ';
		nextPutAll: anInteger printString; lf; tab; tab;
		nextPutAll: 'put: aCByteArray.'; lf;
		contents.
%

category: 'other'
method: CDeclaration
skipFunction

	| parenthesisCount |
	parenthesisCount := 1.
	self next.
	[
		0 < parenthesisCount.
	] whileTrue: [
		| token |
		token := self next.
		token isCloseParenthesisToken ifTrue: [parenthesisCount := parenthesisCount - 1] ifFalse: [
		(token isIdentifierToken and: [token value last == $(]) ifTrue: [parenthesisCount := parenthesisCount + 1] ifFalse: [
		token isOpenParenthesisToken ifTrue: [parenthesisCount := parenthesisCount + 1]]].
	].
%

category: 'declarator'
method: CDeclaration
skipToEndOfCodeBlock

	| depth |
	includesCode := true.
	depth := 1.
	[
		0 < depth.
	] whileTrue: [
		| token |
		token := self next.
		token isOpenCurlyBracketToken ifTrue: [depth := depth + 1].
		token isCloseCurlyBracketToken ifTrue: [depth := depth - 1].
	].
%

category: 'accessors'
method: CDeclaration
source
	^ source
%

category: 'Updating'
method: CDeclaration
source: aString

	source ifNotNil: [^self].
	source := aString.
	(type isKindOf: CDeclaration) ifTrue: [type source: aString].
	fields ifNotNil: [
		type ~~ #'enum' ifTrue: [
			fields do: [:each | 
				each source ifNil: [
					each source: aString.
				].
			].
		].
	].
	parameters ifNotNil: [
		parameters do: [:each | 
			each source ifNil: [
				each source: aString.
			].
		].
	].
%

category: 'CByteArray get'
method: CDeclaration
sourceStringsForAccessors

	| list offset |
	list := OrderedCollection new.
	offset := 0.
	fields do: [:each | 
		list add: (each accessorForOffset: offset).
		offset := offset + each byteSize.
	].
	^list.
%

category: 'CByteArray put'
method: CDeclaration
sourceStringsForUpdators

	| list offset |
	list := OrderedCollection new.
	offset := 0.
	fields do: [:each | 
		list add: (each updatorForOffset: offset).
		offset := offset + each byteSize.
	].
	^list.
%

category: 'accessors'
method: CDeclaration
storage

	^storage.
%

category: 'Updating'
method: CDeclaration
storage: aSymbol linkageSpec: optionalString

	storage := aSymbol.
	linkageSpec := optionalString.
%

category: 'other'
method: CDeclaration
stream

	^header stream.
%

category: 'CByteArray get'
method: CDeclaration
stringAccessorForOffset: anInteger

	^(AppendStream on: String new)
		nextPutAll: name; lf; lf; tab;
		nextPutAll: '^self _stringFromBytes: (self '; lf; tab; tab;
		nextPutAll: 'byteArrayFrom: ';
		nextPutAll: anInteger printString; lf; tab; tab;
		nextPutAll: 'to: ';
		nextPutAll: (anInteger + count first - 1) printString;
		nextPutAll: ').'; lf;
		contents.
%

category: 'CByteArray get'
method: CDeclaration
stringPointerAccessorForOffset: anInteger

	1 == count ifTrue: [
		^(AppendStream on: String new)
			nextPutAll: name; lf; lf; tab;
			nextPutAll: '^self stringFromCharStarAt: ';
			nextPutAll: anInteger printString; 
			nextPut: $.; lf; tab;
			nextPutAll: '"^self'; lf; tab; tab;
			nextPutAll: 'pointerAt: ';
			nextPutAll: anInteger printString; lf; tab; tab;
			nextPutAll: 'resultClass: ';
			nextPutAll: header cByteArraySpecies name asString;
			nextPutAll: '."'; lf;
			contents.
	] ifFalse: [
		^(AppendStream on: String new)
			nextPutAll: name; lf; lf; tab;
			nextPutAll: '| array offset |'; lf; tab;
			nextPutAll: 'array := Array new: ';
			nextPutAll: count first printString;
			nextPut: $.; lf; tab;
			nextPutAll: 'offset := ';
			nextPutAll: anInteger printString;
			nextPut: $.; lf; tab;
			nextPutAll: '1 to: array size do: [:i | '; lf; tab; tab;
			nextPutAll: 'array at: i put: (self stringFromCharStarAt: offset).'; lf; tab; tab;
			nextPutAll: '"array at: i put: (self pointerAt: offset resultClass: ';
			nextPutAll: header cByteArraySpecies name asString;
			nextPutAll: ')."'; lf; tab; tab;
			nextPutAll: 'offset := offset + 8.'; lf; tab;
			nextPutAll: '].'; lf; tab;
			nextPutAll: '^array.'; lf;
			contents.
	].
%

category: 'CByteArray put'
method: CDeclaration
stringPointerUpdatorForOffset: anInteger

	1 == count ifTrue: [
		^(AppendStream on: String new)
			nextPutAll: name;
			nextPutAll: ': aCByteArray'; lf; lf; tab;
			nextPutAll: '"self'; lf; tab; tab;
			nextPutAll: 'pointerAt: ';
			nextPutAll: anInteger printString; lf; tab; tab;
			nextPutAll: 'put: aCByteArray."'; lf;
			contents.
	] ifFalse: [
		^self arrayPointersUpdatorForOffset: anInteger.
	].
%

category: 'CByteArray put'
method: CDeclaration
stringUpdatorForOffset: anInteger

	^(AppendStream on: String new)
		nextPutAll: name;
		nextPutAll: ': aByteArray'; lf; lf; tab;
		nextPutAll: 'self'; lf; tab; tab; 
		nextPutAll: 'replaceFrom: ';
		nextPutAll: anInteger printString; lf; tab; tab;
		nextPutAll: 'to: ';
		nextPutAll: (anInteger - 1) printString;
		nextPutAll: ' + (';
		nextPutAll: count first printString;
		nextPutAll: ' min: aByteArray size)'; lf; tab; tab; 
		nextPutAll: 'with: aByteArray'; lf; tab; tab;
		nextPutAll: 'startingAt: 1.'; lf;
		contents.
%

category: 'CByteArray get'
method: CDeclaration
structAccessorForOffset: anInteger

	^(AppendStream on: String new)
		nextPutAll: name; lf; lf; tab;
		nextPutAll: '^self'; lf; tab; tab;
		nextPutAll: 'newFrom: ';
		nextPutAll: anInteger printString; lf; tab; tab;
		nextPutAll: 'numBytes: ';
		nextPutAll: self baseByteSize printString;
		nextPut: $.; lf;
		contents.
%

category: 'CByteArray put'
method: CDeclaration
structUpdatorForOffset: anInteger

	^(AppendStream on: String new)
		nextPutAll: name;
		nextPutAll: ': aByteArray'; lf; lf; tab;
		nextPutAll: 'self'; lf; tab; tab; 
		nextPutAll: 'replaceFrom: ';
		nextPutAll: anInteger printString; lf; tab; tab;
		nextPutAll: 'to: ';
		nextPutAll: (anInteger - 1) printString;
		nextPutAll: ' + (';
		nextPutAll: self baseByteSize printString;
		nextPutAll: ' min: aByteArray size)'; lf; tab; tab; 
		nextPutAll: 'with: aByteArray'; lf; tab; tab;
		nextPutAll: 'startingAt: 1.'; lf;
		contents.
%

category: 'Debugging'
method: CDeclaration
trapFile
  "uncomment this and senders for debugging
    file ifNotNil:[:f |
      (f includesString:'t.hf') ifTrue:[ nil pause ].
    ].
  "
%

category: 'Debugging'
method: CDeclaration
trapLine
  "uncomment this and senders for debugging 
  file ifNotNil:[:f |
    (f includesString:'t.hf') ifTrue:[ 
       line = 26 ifTrue:[ nil pause ].
    ]. 
  ]
  "
%

category: 'Debugging'
method: CDeclaration
trapName
  "uncomment this and senders for debugging
   name = 'GciTsFetchX' ifTrue:[ nil pause ].
  "
%

category: 'accessors'
method: CDeclaration
type
	"For many types, the value is a Symbol (e.g., #'uint64' or #'struct').
	For other types, the value is a CDeclaration for a function or a class"
  "name = 'IPtr' ifTrue:[ nil pause ]."
	^type.
%

category: 'CByteArray put'
method: CDeclaration
updatorForOffset: anInteger

	0 == pointer ifTrue: [
		type == #'class' ifTrue: [^self structUpdatorForOffset: anInteger].
		(type isKindOf: CDeclaration) ifTrue: [^self structUpdatorForOffset: anInteger].
		count == nil ifTrue: [^self simpleUpdatorForOffset: anInteger].
		1 < count size ifTrue: [self error: 'Multi-dimensional arrays not supported!'].
		type == #'uint8' ifTrue: [^self stringUpdatorForOffset: anInteger].
		^self arrayUpdatorForOffset: anInteger.
	].
	1 < pointer ifTrue: [self error: 'Multi-level pointers not supported!'].
	count == nil ifTrue: [^self singlePointerUpdatorForOffset: anInteger].
	type == #'uint8' ifTrue: [^self stringPointerUpdatorForOffset: anInteger].
	^self arrayPointersUpdatorForOffset: anInteger.
%

category: 'CCallout'
method: CDeclaration
varArgsAfter

	^ isVaryingArgCount ifTrue: [parameters size] ifFalse: [-1].
%

category: 'Reporting'
method: CDeclaration
_addToReport: rpt
  | brace |
  (name ~~ nil ) ifTrue:[ rpt add: (brace := '{') ].
  name ifNotNil:[:n | rpt add: n ; add: ' ' ; add: self byteSize asString ; add: ' '].
  fields ifNotNil:[:f | f do:[ :aField | aField _addToReport: rpt ]].
  (pointer = 0 and:[ type isKindOf: CDeclaration]) ifTrue:[ type _addToReport: rpt ].
  brace ifNotNil:[ rpt add:'}' . ]
%

category: 'accessors'
method: CDeclaration
_fields

	^fields.
%

category: 'other'
method: CDeclaration
_next
	| next |
	(next := header next) ifNil: [^nil].
	file ifNil: [
		file := next file.
		line := next line. 
    "self trapLine ."
	].
	^next.
%

! Class implementation for 'CHeader'

!		Class methods for 'CHeader'

category: 'Class Membership'
classmethod: CHeader
cPreprocessorSpecies
"Answer the class to be used for CPreprocessor objects. Subclasses may
 overload this method as needed."
^ CPreprocessor
%

category: 'other'
classmethod: CHeader
fetchGciLinkedLibraryName

"Answer a String containing a path to the linked GCI shared library
 in a GemStone product tree, relative to the value of the GEMSTONE
 environment variable."

| result |
result := String withAll: '$GEMSTONE/lib/' .
result addAll: System fetchLinkedGciLibraryName .
^ result
%

category: 'other'
classmethod: CHeader
fetchGciRpcLibraryName

"Answer a String containing a path to the 64-bit RPC GCI shared library
 in a GemStone product tree, relative to the value of the GEMSTONE
 environment variable."

| result |
result := String withAll: '$GEMSTONE/lib/' .
result addAll: System fetchRpcGciLibraryName .
^ result
%

category: 'other'
classmethod: CHeader
path: aString
  ^ self path: aString searchPaths: { }
%

category: 'other'
classmethod: CHeader
path: aString searchPath: searchPath
	"Parse the given file path aString, searching the absolute path searchPath before the system include directories.
	Example:
	CHeader path: 'openssl/ssl.h' searchPath: '/home/me/where/i/put/private/builds/include/'.
	This will find /home/me/where/i/put/private/builds/include/openssl/ssl.h, and includes within
	that file of the form
	#include <openssl/someFile.h>
	will be found in /home/me/where/i/put/private/builds/include/openssl."

	^self path: aString searchPaths: {searchPath}
%

category: 'other'
classmethod: CHeader
path: aString searchPaths: anArray
	"Parse the given file path aString, searching the absolute paths in anArray before the system include directories.
	Example:
	CHeader path: 'openssl/ssl.h' searchPaths: #('/home/me/where/i/put/private/builds/include/').
	This will find /home/me/where/i/put/private/builds/include/openssl/ssl.h, and includes within
	that file of the form
	#include <openssl/someFile.h>
	will be found in /home/me/where/i/put/private/builds/include/openssl."

	| preprocessor fullPath |
	preprocessor := self cPreprocessorSpecies new.
	anArray reverseDo: [:path | preprocessor insertSearchPath: path].
	fullPath := preprocessor searchForInclude: aString excluding: nil.
	fullPath
		ifNil: [^UserDefinedError signal: 'Include file ' , aString , ' not found!'].
	preprocessor includePath: fullPath.
	^self preprocessor: preprocessor
%

category: 'other'
classmethod: CHeader
preprocessor: aCPreprocessor

	^self new
		initialize: aCPreprocessor;
		yourself.
%

category: 'other'
classmethod: CHeader
string: aString
	^ self preprocessor: (self cPreprocessorSpecies parseString: aString).
%

category: 'other'
classmethod: CHeader
string: aString ignoreWarnings: aBoolean
	^ self preprocessor: (self cPreprocessorSpecies parseString: aString ignoreWarnings: aBoolean).
%

category: 'Reporting'
classmethod: CHeader
_gciStructReport
^ self _gciStructsReport: '$GEMSTONE/include/gci.hf' for:
  {  "gcilegacy.ht" 'GciObjInfoSType' . 'GciFetchObjInfoArgsSType' . 'GciJmpBufSType' .
     "gci.ht" 'GciErrSType' .  'GciObjRepHdrSType' .  'GciObjRepSType' . 'GciX509LoginArg' .
     "gci.hf" 'GciCTimeStringType' .
     "gcicmn.ht" 'GciTravBufType' .  'GciTravBufHolder' .  'GciClampedTravArgsSType' .
         'GciStoreTravDoArgsSType' .  'GciDateTimeSType' }
%

category: 'Reporting'
classmethod: CHeader
_gciStructsReport: headerPath for: typeNames
  | h rpt |
  h := CHeader path: headerPath .
  rpt := String new .
  typeNames do:[ :tName | (h _typeAt: tName ) _addToReport: rpt .  rpt lf ].
  ^ rpt
%

category: 'Reporting'
classmethod: CHeader
_gciTsStructReport
 ^ self _gciStructsReport: '$GEMSTONE/include/gcits.hf' for:
   { "gci.ht" 'GciErrSType' .  'GciObjRepHdrSType' .  'GciObjRepSType' . "Add with TS x509 support is done: 'GciX509LoginArg' . "
     "gcicmn.ht" 'GciTravBufType' .  'GciTravBufHolder' .  'GciClampedTravArgsSType' .
         'GciStoreTravDoArgsSType' .  'GciDateTimeSType' .
     "gcits.hf"  'GciTsObjInfo' }
%

!		Instance methods for 'CHeader'

category: 'CLibrary'
method: CHeader
add: aCDeclaration to: aClass

	aClass addClassVarName: aCDeclaration asClassVarName.
	aClass class
		compileMethod: aCDeclaration createFunctionInitializerCode
		dictionaries: GsCurrentSession currentSession symbolList
		category: 'Initializing - private' environmentId: 0 .
	aClass
		compileMethod: aCDeclaration invokeFunctionCode
		dictionaries: SymbolList new
		category: 'Functions' environmentId: 0.
%

category: 'Accessing'
method: CHeader
atEnd

	^preprocessor atEnd.
%

category: 'Class Membership'
method: CHeader
cByteArraySpecies
"Answer the class to be used for CByteArray objects. Subclasses may
 overload this method as needed."
^ CByteArray
%

category: 'Class Membership'
method: CHeader
cDeclarationSpecies
"Answer the class to be used for C Declarations. Subclasses may
 overload this method as needed."
^ CDeclaration
%

category: 'CLibrary'
method: CHeader
createDefinesInClass: aClass
	"preprocessor createDefinesInClass: aClass"
%

category: 'CLibrary'
method: CHeader
createFunctionsInClass: newClass libraryPathExpressionString: aString select: aBlock

	| localFunctions |
	localFunctions := aBlock
		ifNil: [functions]
		ifNotNil: [functions select: aBlock].
	localFunctions do: [:each |
		self
			add: each
			to: newClass.
	].
	self
		createInitializerInClass: newClass
		forFunctions: localFunctions
		libraryPathExpressionString: aString.
%

category: 'CLibrary'
method: CHeader
createInitializerInClass: aClass forFunctions: someFunctions libraryPathExpressionString: aString

	aClass class
		compileMethod: (self initializeFunctionsCodeForFunctions: someFunctions libraryPathExpressionString: aString)
		dictionaries: GsCurrentSession currentSession symbolList
		category: 'Initializing - private' environmentId: 0 .
%

category: 'Accessing'
method: CHeader
declarations

   ^declarations
%

category: 'Accessing'
method: CHeader
definitions

	^preprocessor definitions.
%

category: 'Accessing'
method: CHeader
enums

   ^enums
%

category: 'Accessing'
method: CHeader
enumTags

   ^enumTags
%

category: 'Accessing'
method: CHeader
fieldsForStruct: aString

   ^(structs at: aString) fields.
%

category: 'Accessing'
method: CHeader
fullPath
  "If not at completion of parsing, the filename may be a nested include file."
  ^ preprocessor path
%

category: 'Accessing'
method: CHeader
functions

   ^functions
%

category: 'other'
method: CHeader
initialize: aCPreprocessor

	preprocessor := aCPreprocessor.
	types := KeyValueDictionary new.
	structs := KeyValueDictionary new.
	unions := KeyValueDictionary new.
	functions := KeyValueDictionary new.
	enums := KeyValueDictionary new.
	enumTags := KeyValueDictionary new.
	storage := KeyValueDictionary new.
	declarations := { } .

	source := String new.
	[
		self skipEmpty.
		self atEnd .
	] whileFalse: [
		self readOne.
		source := String new.
	].
	preprocessor clearTokens.
%

category: 'CLibrary'
method: CHeader
initializeFunctionsCodeForFunctions: someFunctions libraryPathExpressionString: aString

	| myStream |
	myStream := AppendStream on: String new.
	myStream
		nextPutAll: 'initializeFunctions

	| library |
	library := CLibrary named: ';
		nextPutAll: aString;
		nextPutAll: '.'; lf; tab;
		nextPutAll: 'self'; lf; tab; tab;
		yourself.
	(someFunctions asSortedCollection: [:a :b | a name <= b name]) do: [:aFunction |
		myStream
			nextPutAll: aFunction initializerFunctionName;
			nextPutAll: ' library;'; lf; tab; tab;
			yourself.
	].
	^myStream
		nextPutAll: 'yourself.'; lf;
		contents.
%

category: 'CLibrary'
method: CHeader
newClassNamed: aString

	^self
		newClassNamed: aString
		instVarNames: #().
%

category: 'CLibrary'
method: CHeader
newClassNamed: aString instVarNames: anArray

	^Object
		subclass: aString
		instVarNames: anArray
		classVars: #()
		classInstVars: #()
		poolDictionaries: #()
		inDictionary: nil
		options: #().
%

category: 'Accessing'
method: CHeader
next
	| token src |
	preprocessor atEnd ifTrue:[ ^ nil].
	token := preprocessor next.
	source ifNotNil:[ | tkSrc |
     src := source .
     tkSrc := token source .
     (source size > 0 and:[ source last isAlphaNumeric ]) ifTrue:[
       tkSrc size > 0 ifTrue:[ | tC |
         tC := tkSrc at: 1.
         tC isAlphaNumeric ifTrue:[ source add:$  ]
       ]
     ].
     source add: token source
  ].
	^ token.
%

category: 'Accessing'
method: CHeader
peek

	^preprocessor peek.
%

category: 'other'
method: CHeader
readClass
"                                    .----------------.
                                    V                   |
>>--+--class--identifier--{----member--;--+--}---><
"

	| token classDeclaration oldTypes oldStructs oldUnions oldFunctions oldEnums oldStorage newStorage |
	classDeclaration := declarations last.
	(token := self next) isSemicolonToken ifTrue: [
		classDeclaration source add: source.
		source := nil.
		^self.
	].
	token isOpenCurlyBracketToken ifFalse: [token error: 'syntax error, expected ''{'' '].
	types
		at: classDeclaration name
		put: classDeclaration.
	oldTypes := types copy.
	oldStructs := structs copy.
	oldUnions := unions copy.
	oldFunctions := functions copy.
	oldEnums := enums copy.
	oldStorage := storage copy.
	[
		self skipEmpty.
		(token := self peek) isCloseCurlyBracketToken 
	] whileFalse: [
		(token type == #'identifier' and: [token value = 'public' or: [token value = 'private']]) ifTrue: [
			(token := self next; next) isColonToken ifFalse: [token error: 'Unexpected token'].
		].
		self readOne.
	].
	self next.
	types := oldTypes.
	structs := oldStructs.
	unions := oldUnions.
	functions := oldFunctions.
	enums := oldEnums.
	newStorage := storage.
	storage := oldStorage.
	storage keys do: [:each | newStorage removeKey: each].
	newStorage := newStorage asArray collect: [:each |
		(declarations indexOf: each) -> each.
	].
	newStorage := newStorage asSortedCollection asArray collect: [:each | each value].
	classDeclaration setClassProperties: newStorage.
	self atEnd ifFalse: [
		(token := self next) isSemicolonToken ifFalse: [token error: 'expected '';'' '].
	].
	classDeclaration source: source.
%

category: 'other'
method: CHeader
readExternLinkageDeclarationsUnderStorageRegimeFrom: aCDeclaration
	"Process declarations of the form:
		extern <linkage_specification> { ... }
	Typically:
		extern 'C' { }
	"

	| priorDeclaration priorSource token |
	(token := self next) isOpenCurlyBracketToken ifFalse: [ token error: 'expected ''{'' '].
	source := String new.
	[
		self skipEmpty.
		self atEnd .
	] whileFalse: [
		self peek isCloseCurlyBracketToken ifTrue: [
			self next.
			^self
		].
		self readOneUnderStorageHandler: [:declaration |
			priorDeclaration := declaration.	"to help with debugging"
			(declaration isEmptyExternalLinkage and: [self peek isOpenCurlyBracketToken]) ifTrue: [
				self readExternLinkageDeclarationsUnderStorageRegimeFrom: declaration.
			] ifFalse: [
				declaration canStorageBeMadeExternal ifTrue: [
					declaration
						storage: aCDeclaration storage
						linkageSpec: aCDeclaration linkageSpec.
				].
			].
		].
		priorSource := source.	"to help with debugging"
		source := String new.
	].
	token error: 'could not find end of ''extern <linkage_specification> {'' '
%

category: 'other'
method: CHeader
readOne

	self readOneUnderStorageHandler:
			[:declaration |
			(declaration isEmptyExternalLinkage and: [self peek isOpenCurlyBracketToken])
				ifTrue:
					[^self readExternLinkageDeclarationsUnderStorageRegimeFrom: declaration]]
%

category: 'other'
method: CHeader
readOneUnderStorageHandler: aMonadicBlock
	"Read a declaration and process its storage specification using the
	 specified monadic Block. The Block takes the new declaration as
	 an argument."

	| type declaration token |
	type := self cDeclarationSpecies readTypeFrom: self.
	type source: source.
	declaration := type copy readDeclaration.

	aMonadicBlock value: declaration.

	declaration isEmptyExternalLinkage
		ifFalse:
			[declarations add: declaration.
			declaration includesCode ifTrue: [^self].
			(declaration storage == #typedef and: [declaration type == #class])
				ifTrue: [^self readClass].

			[self saveDeclaration: declaration.
			self atEnd ifTrue: [^self].
			(token := self next) isSemicolonToken ifTrue: [^self].
			token isCommaToken ifFalse: [token error: 'Expected comma or semicolon'].
			true]
					whileTrue:
						[declaration := type copy readDeclaration.
						declarations add: declaration]]
%

category: 'other'
method: CHeader
saveDeclaration: aDeclaration

	| dictionary |
	aDeclaration type == #'enum' ifTrue: [
		 aDeclaration enumTag ifNotNil: [
			 aDeclaration enumList ifNil: [
         (enumTags includesKey: aDeclaration enumTag) ifFalse: [
            self error: 'Missing definition of enum ' , aDeclaration enumTag.
         ].
         aDeclaration name ifNil: [
           self error: 'enum type should declare a variable or function'.
         ].
       ] ifNotNil: [
         aDeclaration enumList isEmpty ifTrue: [
           self error: 'enum should define some values'.
         ].
         (enumTags includesKey: aDeclaration enumTag) ifTrue: [
           self error: 'Duplicate definition of enum ' , aDeclaration enumTag.
         ].
         enumTags at: aDeclaration enumTag put: aDeclaration.
       ].
    ].
	].
	aDeclaration name ifNil: [^self].
	dictionary :=
		aDeclaration storage == #'typedef' 
     ifTrue:[ types ] 
     ifFalse:[ aDeclaration isFunction ifTrue: [	functions] ifFalse: [ storage]].
	dictionary
		at: aDeclaration name
		put: aDeclaration.
%

category: 'other'
method: CHeader
skipEmpty
	[
		self atEnd == false and: [self peek isEmptyToken].
	] whileTrue: [
		| token |
		token := self next.
		"source ifNotNil: [source add: token source]."
	].
%

category: 'Accessing'
method: CHeader
storage

   ^storage
%

category: 'Accessing'
method: CHeader
structs

   ^structs
%

category: 'Accessing'
method: CHeader
types

   ^types
%

category: 'Accessing'
method: CHeader
unions
   ^unions
%

category: 'CLibrary'
method: CHeader
wrapperForLibraryAt: aString
"
| header class |
header := CHeader path: '$GEMSTONE/include/gci.hf'.
class := header wrapperForLibraryAt: CHeader fetchGciRpcLibraryName .
UserGlobals at: class name put: class.
"
	| name |
	name := (((aString subStrings: $/) last subStrings: $.) first subStrings: $-) first.
	(3 < name size and: [(name copyFrom: 1 to: 3) = 'lib']) ifTrue: [name := name copyFrom: 4 to: name size].
	name first isLowercase ifTrue: [name at: 1 put: name first asUppercase].
	^self
		wrapperNamed: name
		libraryPathExpressionString: aString printString
		select: nil.
%

category: 'CByteArray'
method: CHeader
wrapperForType: aCDeclaration

	^self
		wrapperNamed: aCDeclaration name
		forType: aCDeclaration.
%

category: 'CByteArray'
method: CHeader
wrapperForTypeNamed: aString
"
| header class |
UserGlobals removeKey: #'GciErrSType' ifAbsent: [].
header := CHeader path: '$GEMSTONE/include/gci.hf'.
class := header wrapperForTypeNamed: 'GciErrSType'.
UserGlobals at: class name put: class.
"
	^self
		wrapperNamed: aString
		forType: (types at: aString).
%

category: 'CLibrary'
method: CHeader
wrapperNamed: nameString forLibraryAt: pathString select: aBlock
"
| header class |
UserGlobals removeKey: #'GciLibrary' ifAbsent: [].
header := CHeader path: '$GEMSTONE/include/gci.hf'.
class := header
	wrapperNamed: 'GciLibrary'
	forLibraryAt: self class fetchGciRpcLibraryName
	select: [:each | each name first == $G ].
UserGlobals at: class name put: class.
"
	^self
		wrapperNamed: nameString
		libraryPathExpressionString: pathString printString
		select: aBlock
%

category: 'CByteArray'
method: CHeader
wrapperNamed: nameString forStruct: aCDeclaration
"
| header class |
UserGlobals removeKey: #'GciErrSType' ifAbsent: [].
header := CHeader path: '$GEMSTONE/include/gci.hf'.
class := header
	wrapperNamed: 'GciErrSType'
	forType: (header _typeAt:'GciErrSType').
UserGlobals at: class name put: class.
"
	| class symbolList string writeStream |
	symbolList := GsCurrentSession currentSession symbolList.
	class := (self cByteArraySpecies)
		subclass: nameString
		instVarNames: #()
		classVars: #()
		classInstVars: #()
		poolDictionaries: #()
		inDictionary: nil
		options: #().
	aCDeclaration addSourceTo: (writeStream := AppendStream on: String new).
	class comment: writeStream contents.
	string := 'on: aCByteArray

	^self withAll: aCByteArray.
'.
	class class
		compileMethod: string  "may signal CompileError or CompileWarning"
		dictionaries: symbolList
		category: 'Instance Creation'
		environmentId: 0.
	string := 'new

	^self gcMalloc: ' , aCDeclaration byteSizeRounded printString , '.
'.
	class class
		compileMethod: string  "may signal CompileError or CompileWarning"
		dictionaries: symbolList
		category: 'Instance Creation'
		environmentId: 0.
	string := 'initialize
'.
	class
		compileMethod: string  "may signal CompileError or CompileWarning"
		dictionaries: symbolList
		category: 'Initialization'
		environmentId: 0.
	string := 'initialize: aCByteArray

	1 to: (self size min: aCByteArray size) do: [:i |
		self uint8At: i put: (aCByteArray uint8At: i).
	].
'.
	class
		compileMethod: string  "may signal CompileError or CompileWarning"
		dictionaries: symbolList
		category: 'Initialization'
		environmentId: 0.
	string := '_stringFromBytes: aByteArray

	| index |
	index := aByteArray indexOf: 0.
	^aByteArray
		at: 1
		sizeBytes: 1
		stringSize: (0 == index ifTrue: [aByteArray size] ifFalse: [index - 1]).
'.
	class
		compileMethod: string  "may signal CompileError or CompileWarning"
		dictionaries: symbolList
		category: 'Conversion'
		environmentId: 0.
	aCDeclaration sourceStringsForAccessors do: [:each |
		class
			compileMethod: each  "may signal CompileError or CompileWarning"
			dictionaries: symbolList
			category: 'Accessing' environmentId: 0 .
	].
	aCDeclaration sourceStringsForUpdators do: [:each |
		class
			compileMethod: each  "may signal CompileError or CompileWarning"
			dictionaries: symbolList
			category: 'Updating'
			environmentId: 0.
	].
	^class.
%

category: 'CByteArray'
method: CHeader
wrapperNamed: nameString forType: aCDeclaration
	| struct |
	aCDeclaration type == #'class' ifTrue: [
		^self
			wrapperNamed: nameString
			forStruct: aCDeclaration.
	].
	(((struct := aCDeclaration type) isKindOf: CDeclaration) and: [struct type == #'struct']) ifFalse:[
     Error signal: 'Should be a struct'
  ].
	^self
		wrapperNamed: nameString
		forStruct: struct.
%

category: 'CLibrary'
method: CHeader
wrapperNamed: nameString libraryPathExpressionString: aString select: aBlock

	| newClass |
	newClass := self newClassNamed: nameString.
	self
		createFunctionsInClass: newClass libraryPathExpressionString: aString select: aBlock;
		createDefinesInClass: newClass.
	newClass initializeFunctions.
	^newClass.
%

category: 'Reporting'
method: CHeader
_typeAt: aName

^ (types at: aName otherwise: nil) ifNil:[
     (structs at: aName otherwise: nil) ifNil:[
       (unions at: aName otherwise: nil) ifNil:[ Error signal: aName , '  not found' ]]].
%

! Class implementation for 'ClampSpecification'

!		Class methods for 'ClampSpecification'

category: 'Examples'
classmethod: ClampSpecification
example1

"Creates and returns a ClampSpecification object with identity clamps for
 Globals and AllUsers, class clamps for GsObjectSecurityPolicy, Repository and UserProfile, and
 instance variable levels on the value parts of Associations and
 SymbolAssociations."

^ClampSpecification newWithIdClamps: { Globals . AllUsers }
  classClamps: { GsObjectSecurityPolicy . Repository . UserProfile }
  instVarLevels: {
      { Association . #( #value 0 ) } .
      { SymbolAssociation . #( #value 0 ) }
      }
%

category: 'Examples'
classmethod: ClampSpecification
example2

"Same as example1, but the clamps are added piecemeal."

| inst |
inst := ClampSpecification new.
inst addAllIdClamps: { Globals . AllUsers }.
inst addAllClassClamps: { GsObjectSecurityPolicy . Repository . UserProfile }.
inst addAllInstVarLevels: {
    { Association . #( #value 0 ) } .
    { SymbolAssociation . #( #value 0 ) }
    }.
^inst
%

category: 'Instance Creation'
classmethod: ClampSpecification
new

"Returns a new instance of ClampSpecification.  Note that you may also use
 structural access calls through GemBuilder for either C or Smalltalk
 (for example, GciNewOop()) to create new instances of ClampSpecification."

^super new
%

category: 'Instance Creation'
classmethod: ClampSpecification
new: anInteger

"Disallowed.  You may not use this method to create new instances of
 ClampSpecification."

^self shouldNotImplement: #new:
%

category: 'Instance Creation'
classmethod: ClampSpecification
newWithIdClamps: idClamps
classClamps: classClamps
instVarLevels: instVarLevels

"Creates and returns a new instance of ClampSpecification with the given clamps.
 If a creation error is encountered, generates an error but does not return the
 new ClampSpecification."

| inst |

inst := self new.
inst environmentId: 0 ;
    addAllIdClamps: idClamps;
     addAllClassClamps: classClamps;
     addAllInstVarLevels: instVarLevels.
^inst
%

category: 'Instance Creation'
classmethod: ClampSpecification
newWithIdClamps: idClamps
classClamps: classClamps
instVarLevels: instVarLevels
subleafHeaders: subleafHeadersBool

"Creates and returns a new instance of ClampSpecification with the given clamps.
 If subleafHeadersBool is true, a traversal using this clamp supplies object
 headers for objects that are children of the leaf nodes of the traversal.
 If a creation error is encountered, generates an error but does not return the
 new ClampSpecification."

| inst |

inst := self
   newWithIdClamps: idClamps
   classClamps: classClamps
   instVarLevels: instVarLevels.
inst addSubleafHeaders: subleafHeadersBool.

^inst
%

category: 'Instance Creation'
classmethod: ClampSpecification
newWithIdClampsHolder: idClamps
classClamps: classClamps
instVarLevels: instVarLevels
subleafHeaders: subleafHeadersBool
traversalCallbackSelector: callbackSelector

"Creates and returns a new instance of ClampSpecification with the given clamps.
 The argument idClamps is the actual IdentitySet used to hold the identity
 clamps, so it must be an instance of IdentitySet.  If subleafHeadersBool
 is true, a traversal using this clamp supplies object headers for objects that
 are children of the leaf nodes of the traversal.  The callbackSelector is
 either nil or a unary selector symbol that is used by the traversal mechanism
 to send to instances of classes that require a traversal callback."

| inst |

inst := self basicNew
   _initIdClampsHolder: idClamps
   classClamps: classClamps
   instVarLevels: instVarLevels
   addSubleafHeaders: subleafHeadersBool
   traversalCallbackSelector: callbackSelector.

^inst
%

!		Instance methods for 'ClampSpecification'

category: 'Class Clamps'
method: ClampSpecification
addAllClassClamps: aCollection

"Adds a class clamp to the receiver for each class object in aCollection.
 The instances of each class in aCollection will be clamped during
 object traversal."

aCollection _validateClass: Collection .
classClamps == nil ifTrue: [self _initializeClassClamps].
(aCollection class isBytes) ifTrue:[
  aCollection _error: #clampErrBadArg args:  #()  .
  ^ self
].
classClamps addAll: aCollection.
%

category: 'Identity Clamps'
method: ClampSpecification
addAllIdClamps: aCollection

"Adds an identity clamp to the receiver for each object in aCollection.
 Returns the receiver."

aCollection _validateClass: Collection .
idClamps == nil ifTrue: [self _initializeIdClamps].
idClamps addAll: aCollection.
%

category: 'Instance Variable Levels'
method: ClampSpecification
addAllInstVarLevels: aCollection

"Adds the given instance variable levels to the receiver.  The argument
 aCollection may be either (1) an Array of two-element Arrays, in which the
 first element of each Array is a Class object and the second element is
 a collection of instance variable levels in the format expected by
 addInstVarLevels:forClass:,
 or (2) a Dictionary whose keys are Class objects and whose values are
 collections of instance variable levels in the format expected by
 addInstVarLevels:forClass:.  Returns the receiver."

aCollection _validateClass: Collection .
(aCollection isKindOf: Dictionary)
  ifTrue: [
    aCollection associationsDo: [:each |
      self addInstVarLevels: (each value) forClass: (each key)
    ]
  ]
  ifFalse: [
    aCollection do: [:each |
      (each size == 2) ifFalse:[
        each _error: #clampErrBadArg args:  #()  .  ^ self
      ].
      ((each at:2) class isBytes) ifTrue:[
         (each at:2) _error: #clampErrBadArg args:  #()  .  ^ self
      ].
      self addInstVarLevels: (each at: 2) forClass: (each at: 1)
    ]
  ].
%

category: 'Class Clamps'
method: ClampSpecification
addClassClampFor: aClass

"Adds a class clamp to the receiver for aClass.  Returns the receiver."

classClamps == nil ifTrue: [self _initializeClassClamps].
classClamps add: aClass.
%

category: 'Identity Clamps'
method: ClampSpecification
addIdClampFor: anObject

"Adds an identity clamp to the receiver for anObject.  Returns the receiver."

anObject isSpecial ifTrue: [ ^ anObject _error: #clampErrBadArg args: #() ].
idClamps == nil ifTrue: [self _initializeIdClamps].
idClamps add: anObject.
%

category: 'Instance Variable Levels'
method: ClampSpecification
addInstVarLevels: aCollectionOfIVarLevels forClass: aClass

"Adds an instance variable level on each of the instance variable names
 contained in aCollectionIVarLevels for the specified class aClass.  The levels
 must be an OrderedCollection in the following format:

 1. A Symbol specifying the named instance variable to level or nil to level all
    unnamed instance variables.
 2. A SmallInteger that specifies the level, or false.  If false, then treat it
    as a max 0 but never include a subleaf header.  If this value is less than
    zero then it is a min operation.  Otherwise it is a max operation."

| allivs   "the list of all the instance variable for aClass"
  ivlArray "the instance variable level Array"
|

aCollectionOfIVarLevels _validateClass: Collection .
(aCollectionOfIVarLevels class isBytes) ifTrue:[
  aCollectionOfIVarLevels _error: #clampErrBadArg args:  #()  .
  ^ self
].

aClass class isMeta ifFalse: [
    aClass _error: #clampErrNotAClass args:  #().
    ^ self
].

instVarLevels == nil ifTrue: [self _initializeInstVarLevels].

allivs := aClass _instVarNames.

ivlArray := { } .
ivlArray size: (allivs size) + 1.

1 to: (aCollectionOfIVarLevels size) by: 2 do: [ :i | | varname level idx |
  varname := aCollectionOfIVarLevels at: i.
  level := aCollectionOfIVarLevels at: i+1.
  varname == nil ifTrue: [idx := allivs size + 1]
                ifFalse: [
    idx := allivs indexOf: varname.
    idx == 0 ifTrue: [
      ^aClass _error: #clampErrNoSuchInstvar args: { varname }.
    ].
  ].
  ivlArray at: idx put: level.
].
instVarLevels at: aClass put: ivlArray.
%

category: 'Testing'
method: ClampSpecification
addSubleafHeaders

"Returns true if the receiver will add subleaf headers to the traversal buffer.
 Returns false otherwise."

addSubleafHeaders == nil ifTrue:  [^false]
                        ifFalse: [^addSubleafHeaders]
%

category: 'Configuration'
method: ClampSpecification
addSubleafHeaders: aBoolean

"Sets the addSubleafHeaders instance variable to aBoolean.  Returns the
 receiver."

aBoolean  _validateClass: Boolean .
addSubleafHeaders := aBoolean.

^self
%

category: 'Configuration'
method: ClampSpecification
environmentId: envId

"Sets the enviroment used for method lookup by sends of the
 traversalCallBackSelector.
 envId must be a SmallInteger >= 0 and <= 255  "

envId _isSmallInteger ifFalse:[ envId _validateClass: SmallInteger ].
(envId < 0 or:[ envId > 255]) ifTrue:[
   envId _error: #rtErrArgOutOfRange args:{ 0 . 255 } .
].
environmentId := envId .
%

category: 'Class Clamps'
method: ClampSpecification
includesClassClampFor: aClass

"Returns true if the receiver has a class clamp on aClass.  Returns false
 otherwise."

classClamps == nil ifTrue:  [^false]
                  ifFalse: [^classClamps includesIdentical: aClass]
%

category: 'Identity Clamps'
method: ClampSpecification
includesIdClampFor: anObject

"Returns true if the receiver has an identity clamp on anObject.
 Returns false otherwise."

idClamps == nil ifTrue:  [^false]
               ifFalse: [^idClamps includesIdentical: anObject]
%

category: 'Instance Variable Levels'
method: ClampSpecification
includesInstVarLevelsFor: aClass

"Returns true if the receiver has an instance variable level on aClass.
 Returns false otherwise."

instVarLevels == nil ifTrue:  [^false]
                    ifFalse: [^instVarLevels includesKey: aClass]
%

category: 'Value Clamps'
method: ClampSpecification
includesValueClampFor: anObject

"Returns true if the receiver has value-clamped the given object.
 Returns false otherwise."

valueClamps == nil
  ifTrue:  [ ^ false ]
  ifFalse: [ ^ valueClamps includesIdentical: anObject ]
%

category: 'Initialization'
method: ClampSpecification
initialize

"Reset the state of the ClampSpecification to its initial state.
 Returns the receiver."

self nilFields ;
  environmentId: 0 .
^self
%

category: 'Accessing'
method: ClampSpecification
instVarLevelsSelector

 ^ instVarLevelsSelector
%

category: 'Configuration'
method: ClampSpecification
instVarLevelsSelector: aSelector
 "Sets the instVarLevelsSelector instance variable to aSelector.
  aSelector must be a Symbol, DoubleByteSymbol, or QuadByteSymbol.  Returns the receiver."

 instVarLevelsSelector := aSelector
%

category: 'Identity Clamps'
method: ClampSpecification
removeAllIdClamps: aCollection

"Removes an identity clamp from the receiver for each object in aCollection.
 Does not generate an error if there is no identity clamp for any of the objects
 in aCollection."

idClamps ~~ nil
  ifTrue: [ idClamps _removeAll: aCollection errIfAbsent: false ]
%

category: 'Class Clamps'
method: ClampSpecification
removeClassClampFor: aClass

"Removes the class clamp from the receiver for aClass.  Generates an error if
 there is no class clamp on aClass."

classClamps == nil ifTrue:  [self _errorNotFound: aClass. ^self]
                  ifFalse: [^classClamps remove: aClass]
%

category: 'Identity Clamps'
method: ClampSpecification
removeIdClampFor: anObject

"Removes an identity clamp from the receiver for anObject.  Generates an error
 if there is no identity clamp on anObject."

idClamps == nil ifTrue: [self _errorNotFound: anObject. ^self]
               ifFalse: [^idClamps remove: anObject]
%

category: 'Instance Variable Levels'
method: ClampSpecification
removeInstVarLevelsFor: aClass

"Removes any existing instance variable levels for aClass.  Generates an error
 if there is no instance variable level on aClass."

instVarLevels == nil ifTrue:  [self _errorKeyNotFound: aClass. ^self]
                    ifFalse: [^instVarLevels removeKey: aClass]
%

category: 'Accessing'
method: ClampSpecification
traversalCallBackSelector

"Returns the value of the instance variable traversalCallBackSelector."

^ traversalCallBackSelector
%

category: 'Configuration'
method: ClampSpecification
traversalCallBackSelector: aSelector

"Sets the traversalCallBackSelector instance variable to aSelector.
 aSelector must be a Symbol, DoubleByteSymbol, or QuadByteSymbol.  Returns the receiver."

aSelector _isSymbol ifFalse:[
  ArgumentError signal:'arg to traversalCallBackSelector:  must be a Symbol'.
].
traversalCallBackSelector := aSelector
%

category: 'Private'
method: ClampSpecification
_initializeClassClamps

"Initializes the class clamps variable.  Returns the receiver."

classClamps := ClassSet new.
%

category: 'Private'
method: ClampSpecification
_initializeIdClamps

"Initializes the identity clamps variable.  Returns the receiver."

idClamps := IdentitySet new.
%

category: 'Private'
method: ClampSpecification
_initializeInstVarLevels

"Initializes the instance variable levels variable.  Returns the receiver."

instVarLevels := FastIdentityKeyValueDictionary new.
instVarLevels keyConstraint: Class.
instVarLevels valueConstraint: Array.
%

category: 'Initialization'
method: ClampSpecification
_initializeValueClamps

"Create a new value clamps set."

valueClamps := IdentitySet new.
%

category: 'Private'
method: ClampSpecification
_initIdClampsHolder: idc
classClamps: cc
instVarLevels: ivl
addSubleafHeaders: ash
traversalCallbackSelector: tcb

"Private."

idc _validateClass: IdentitySet .
idClamps := idc.
self
  addAllClassClamps: cc;
  addAllInstVarLevels: ivl;
  addSubleafHeaders: ash;
  traversalCallBackSelector: tcb ;
  environmentId: 0 .
%

! Class implementation for 'CPreprocessor'

!		Class methods for 'CPreprocessor'

category: 'other'
classmethod: CPreprocessor
evaluateHeader: aCHeader

	^self basicNew evaluateHeader: aCHeader.
%

category: 'other'
classmethod: CPreprocessor
new

	^self basicNew
		initialize;
		yourself.
%

category: 'other'
classmethod: CPreprocessor
parseFileAt: aString

	^self new
		includePath: aString;
		yourself.
%

category: 'other'
classmethod: CPreprocessor
parseString: aString
	^ self new
	  	parseString: aString ignoreWarnings: false ;
	  	yourself.
%

category: 'other'
classmethod: CPreprocessor
parseString: aString ignoreWarnings: aBoolean
	^ self new
	  	parseString: aString ignoreWarnings: aBoolean ;
	  	yourself.
%

category: 'other'
classmethod: CPreprocessor
references

^'
	http://www.acm.uiuc.edu/webmonkeys/book/c_guide/index.html
	http://gcc.gnu.org/onlinedocs/gcc-3.0.1/cpp_1.html#SEC1
'.
%

!		Instance methods for 'CPreprocessor'

category: 'directives'
method: CPreprocessor
addRestOfLineTo: aCollection
  | lf |
  lf := Character lf.
	[
		readStream atEnd or: [readStream peek == lf].
	] whileFalse: [
		aCollection add: self nextToken.
	].
%

category: 'accessors'
method: CPreprocessor
allSearchPaths
  "Return the list of directories used to search for a file that
   is the argument of a #include directive."
  | res |
  (res := searchPaths copy) addAll: systemSearchPaths .
  ^ res
%

category: 'other'
method: CPreprocessor
applyConcatenationToken: aToken

	| left right list |
	left := tokens last.
	right := self nextToken.
	list := { left . aToken . right }.
	self applyToken: right.
	left
		collectOriginalFrom: list;
		concatenate: tokens last.
	tokens size: tokens size - 1.
%

category: 'directives'
method: CPreprocessor
applyDirectiveToken: aToken

	| directive |
	directive := aToken value.
	directive = 'define' 			ifTrue: [^self define: 	aToken].
	directive = 'undef' 			ifTrue: [^self undef: 	aToken].
	directive = 'ifdef' 				ifTrue: [^self ifdef: 		aToken defined: true].
	directive = 'ifndef' 			ifTrue: [^self ifdef: 		aToken defined: false].
	directive = 'if'					ifTrue: [^self if:			aToken].
	directive = 'include'			ifTrue: [^self include: 	aToken afterMe: false].
	directive = 'include_next'	ifTrue: [^self include: 	aToken afterMe: true].
	directive = 'pragma'			ifTrue: [^self ignoreRestOfLine].
	directive = 'warning'			ifTrue: [^self ignoreRestOfLine].
	self error: 'Unrecognized directive token: ' , aToken printString.
%

category: 'other'
method: CPreprocessor
applyFunctionMacroToken: aToken

	| char name arguments1 arguments2 definition oldLine oldStream string oldSize |
	"http://gcc.gnu.org/onlinedocs/cpp/Function_002dlike-Macros.html specifies to ignore if no parenthesis"
	(char := readStream peek) == $(
		ifFalse:
			[tokens add: aToken.
			^self].
	name := aToken value.
	arguments1 := self macroFunctionArgumentsFor: aToken.
	arguments2 := self expandMacroFunctionArguments: arguments1.
	definition := definitions at: name.
	string := definition expandArguments: arguments2.
	string isEmpty ifTrue: [^self].

	oldLine := line.
	oldSize := tokens size.
	oldStream := readStream.
	readStream := CPreprocessorStream on: string.
	self readTillEnd.
	readStream := oldStream.
	oldSize == tokens size ifTrue: [tokens add: self cPreprocessorTokenSpecies empty].
	(tokens at: oldSize + 1) replaceFirst: aToken.
	oldSize + 2 to: tokens size do: [:i | (tokens at: i) replaceOther: aToken].
	line := oldLine	"Multi-line definitions would confuse the subsequent line numbers"
%

category: 'other'
method: CPreprocessor
applyIdentifierToken: aToken

	| name definition oldTokens list |
	(1 <= tokens size and: [
		tokens last isDefinedIdentifierToken]) ifTrue: [tokens add: aToken. ^self].
	(2 <= tokens size and: [
		tokens last isOpenParenthesisToken and: [
		(tokens at: tokens size - 1) isDefinedIdentifierToken]]) ifTrue: [tokens add: aToken. ^self].
	name := aToken value.
	definition := definitions
		at: name
		ifAbsent: [tokens add: aToken. ^self].
	oldTokens := tokens.
	tokens := list := Array new.
	definition isFunctionLikeMacroDefinition ifTrue: [
		self applyFunctionMacroToken: aToken.
	] ifFalse: [
		self applySimpleMacroToken: aToken.
	].
	tokens := oldTokens.
	definitions removeKey: name.
	list do: [:each | self applyToken: each].
	self definitionsAt: name put: definition.
%

category: 'other'
method: CPreprocessor
applySimpleMacroToken: aToken

	| definition oldLine oldSize oldStream |
	definition := definitions removeKey: aToken value.
	oldLine := line.
	oldSize := tokens size.
	oldStream := readStream.
	readStream := CPreprocessorStream on: definition value.
	self readTillEnd.
	readStream := oldStream.
	oldSize == tokens size ifTrue: [tokens add: self cPreprocessorTokenSpecies empty].
	(tokens at: oldSize + 1) replaceFirst: aToken.
	oldSize + 2 to: tokens size do: [:i | (tokens at: i) replaceOther: aToken].
	line := oldLine.		"Multi-line definitions would confuse the subsequent line numbers"
	self definitionsAt: aToken value put: definition.
%

category: 'other'
method: CPreprocessor
applyToken: aToken
  "GsFile gciLogServer:'applyToken  ' , aToken printString ." "uncomment to debug"
	aToken isDirectiveToken ifTrue: [^self applyDirectiveToken: aToken].
	aToken isConcatenationToken ifTrue: [^self applyConcatenationToken: aToken].
	aToken isIdentifierToken ifTrue: [^self applyIdentifierToken: aToken].
	tokens add: aToken.
%

category: 'other'
method: CPreprocessor
atEnd

	^tokens isEmpty.
%

category: 'Class Membership'
method: CPreprocessor
cDeclarationSpecies
"Answer the class to be used for CDeclaration objects. Subclasses may
 overload this method as needed."
^ CDeclaration
%

category: 'other'
method: CPreprocessor
clearTokens
  tokens := nil.
  tmpFnames ifNotNil:[:fNames |
    fNames do:[:f | GsFile removeServerFile: f ].
    tmpFnames := nil .
  ].
%

category: 'Class Membership'
method: CPreprocessor
cPreprocessorTokenSpecies
"Answer the class to be used for CPreprocessorToken objects. Subclasses may
 overload this method as needed."
^ CPreprocessorToken
%

category: 'default definitions'
method: CPreprocessor
defaultAix71Definitions
  self nativeCppCmd ifNotNil:[ ^ self defaultNativeCppDefinitions ].
  ^ self _defaultAix71DefinitionsOld
%

category: 'default definitions'
method: CPreprocessor
defaultAix72Definitions
  self nativeCppCmd ifNotNil:[ ^ self defaultNativeCppDefinitions ].
  ^ self _defaultAix72DefinitionsOld
%

category: 'default definitions'
method: CPreprocessor
defaultDarwinDefinitions
self nativeCppCmd ifNotNil:[
  "We are running the OS's preprocessor first"
  ^ self defaultNativeCppDefinitions ,
'#define __compar
#define _close
#define _read
#define _seek
#define _write
#define availability(x)
#define _Nonnull
'
].
^ self _defaultDarwinDefinitionsOld
%

category: 'default definitions'
method: CPreprocessor
defaultLinuxDefinitions

self nativeCppCmd ifNotNil:[
  "We are running the OS's preprocessor first"
  ^ self defaultNativeCppDefinitions
].
^ System performOnServer: 'cpp -dM /dev/null'
%

category: 'default definitions'
method: CPreprocessor
defaultNativeCppDefinitions
^
'#define __inline inline
#define __inline__ inline
#define __restrict_arr
#define __restrict
#define restrict
#define __const const
#define __signed signed
#define __extension__
#define __volatile
#define __signed__ signed
#define __uint128_t unsigned long long
#define throw()
'

"  __signed__, __uint128_t added for Linux on ARM 64bit"
%

category: 'default definitions'
method: CPreprocessor
defaultSparcSolarisDefinitions
	"echo '' | cpp -dM
"
	^'
#define __GCC_NEW_VARARGS__ 1
#define __sparc 1
#define __svr4__ 1
#define __sun 1
#define sparc 1
#define __sun__ 1
#define __unix 1
#define __unix__ 1
#define __SVR4 1
#define sun 1
#define __sparc__ 1
#define unix 1
' ,
	"additional definitions"
'
#define ptrdiff_t long
#define restrict
#define throw()
#define __const const
#define __inline inline
#define __inline__ inline
#define __restrict
#define __signed signed
#define __STDC__
#define __volatile
'.
%

category: 'default definitions'
method: CPreprocessor
defaultX86SolarisDefinitions
  "echo '' | cpp -dM"

^ '
#define __DBL_MIN_EXP__ (-1021)
#define __FLT_MIN__ 1.17549435e-38F
#define __CHAR_BIT__ 8
#define __WCHAR_MAX__ 2147483647
#define __DBL_DENORM_MIN__ 4.9406564584124654e-324
#define __FLT_EVAL_METHOD__ 2
#define __DBL_MIN_10_EXP__ (-307)
#define __FINITE_MATH_ONLY__ 0
#define __GNUC_PATCHLEVEL__ 2
#define __SHRT_MAX__ 32767
#define __LDBL_MAX__ 1.18973149535723176502e+4932L
#define __unix 1
#define __LDBL_MAX_EXP__ 16384
#define __SCHAR_MAX__ 127
#define __USER_LABEL_PREFIX__
#define __STDC_HOSTED__ 1
#define __LDBL_HAS_INFINITY__ 1
#define __DBL_DIG__ 15
#define __FLT_EPSILON__ 1.19209290e-7F
#define __LDBL_MIN__ 3.36210314311209350626e-4932L
#define __unix__ 1
#define __DECIMAL_DIG__ 21
#define __LDBL_HAS_QUIET_NAN__ 1
#define __GNUC__ 3
#define __DBL_MAX__ 1.7976931348623157e+308
#define __DBL_HAS_INFINITY__ 1
#define __SVR4 1
#define __DBL_MAX_EXP__ 1024
#define __LONG_LONG_MAX__ 9223372036854775807LL
#define __GXX_ABI_VERSION 1002
#define __FLT_MIN_EXP__ (-125)
#define __DBL_MIN__ 2.2250738585072014e-308
#define __DBL_HAS_QUIET_NAN__ 1
#define __tune_i386__ 1
#define __sun 1
#define __REGISTER_PREFIX__
#define __NO_INLINE__ 1
#define __i386 1
#define __FLT_MANT_DIG__ 24
#define __VERSION__ "3.4.2"
#define i386 1
#define sun 1
#define unix 1
#define __i386__ 1
#define __SIZE_TYPE__ unsigned int
#define __ELF__ 1
#define __FLT_RADIX__ 2
#define __LDBL_EPSILON__ 1.08420217248550443401e-19L
#define __FLT_HAS_QUIET_NAN__ 1
#define __FLT_MAX_10_EXP__ 38
#define __LONG_MAX__ 2147483647L
#define __FLT_HAS_INFINITY__ 1
#define __PRAGMA_REDEFINE_EXTNAME 1
#define __LDBL_MANT_DIG__ 64
#define __WCHAR_TYPE__ long int
#define __FLT_DIG__ 6
#define __INT_MAX__ 2147483647
#define __FLT_MAX_EXP__ 128
#define __DBL_MANT_DIG__ 53
#define __WINT_TYPE__ long int
#define __LDBL_MIN_EXP__ (-16381)
#define __LDBL_MAX_10_EXP__ 4932
#define __DBL_EPSILON__ 2.2204460492503131e-16
#define __sun__ 1
#define __svr4__ 1
#define __FLT_DENORM_MIN__ 1.40129846e-45F
#define __FLT_MAX__ 3.40282347e+38F
#define __FLT_MIN_10_EXP__ (-37)
#define __GNUC_MINOR__ 4
#define __DBL_MAX_10_EXP__ 308
#define __LDBL_DENORM_MIN__ 3.64519953188247460253e-4951L
#define __PTRDIFF_TYPE__ int
#define __LDBL_MIN_10_EXP__ (-4931)
#define __LDBL_DIG__ 18
' ,
	"additional definitions"
'
#define ptrdiff_t long
#define restrict
#define throw()
#define __const const
#define __inline inline
#define __inline__ inline
#define __restrict
#define __signed signed
#define __STDC__
#define __volatile
'.
%

category: 'directives'
method: CPreprocessor
define: defineToken

	| expansionTokens nameToken name parameters list string token |
	readStream peek == Character lf ifTrue: [ defineToken error: 'unexpected end of line' ].
	(nameToken := self nextToken) isIdentifierToken ifFalse: [ nameToken error: 'expected an identifier'].
	name := nameToken value.
	self definitionsAt: name put: defineToken.
	list := { defineToken . nameToken }.	"collect the tokens so we can extract the source"
	nameToken peek == $( ifTrue: [			"capture parameters"
		list add: self nextToken.
		parameters := Array new.
		token := list add: self nextToken.
		[
			token isCloseParenthesisToken.
		] whileFalse: [
			token isIdentifierToken ifTrue: [
				parameters add: token value.
				(token := list add: self nextToken) isCommaToken ifTrue: [
					token := list add: self nextToken.
				].
			] ifFalse: [
				3 timesRepeat: [
					token isDotToken ifFalse: [self error: 'Expected identifier or dots'].
					token := list add: self nextToken.
				].
			].
		].
	].
	string := String new.
	expansionTokens := {}.
	[
		(token := self nextTokenOnLine) ~~ nil.
	] whileTrue: [
		expansionTokens add: token.
		string add: token source.
	].
	defineToken collectOriginalFrom: list.
	defineToken source add: string.
	defineToken
		defineParameters: parameters
		expansionTokens: expansionTokens.
%

category: 'accessors'
method: CPreprocessor
definitions

	^definitions.
%

category: 'other'
method: CPreprocessor
definitionsAt: name put: definition
  "in a seperate method for easier set breakpoint."
  ^ definitions at: name put: definition
%

category: 'other'
method: CPreprocessor
directory

	path ifNil: [^''].
	path size to: 1 by: -1 do: [:i |
		(path at: i) == $/ ifTrue: [
			^path copyFrom: 1 to: i.
		].
	].
	^''.
%

category: 'directives'
method: CPreprocessor
doIf: aBoolean

	| inTrueBlock anyWereTrue token ifDepth lf |
	inTrueBlock := aBoolean.
	anyWereTrue := false.
  lf := Character lf .
	[true] whileTrue: [
		inTrueBlock ifTrue: [
			anyWereTrue := true.
			[
				(token := self nextToken) isConditionalEndDirective.
			] whileFalse: [
				self applyToken: token.
			].
			(readStream atEnd or: [readStream peek == lf or: [token value = 'elif']]) ifFalse: [
         token error:'expected ''elif'' or end of line '
      ].
			token value = 'endif' ifTrue: [
				self ignoreRestOfLine.
				^self.
			].
			token value = 'else' ifTrue: [
				self ignoreRestOfLine.
				inTrueBlock := false.
			] ifFalse: [
				self ignoreRestOfLine.
				(anyWereTrue and: [token value = 'elif']) ifTrue: [
					inTrueBlock := false.
				] ifFalse: [
					token error:'Expected ''else'' or ''endif''  '.
				].
			].
		] ifFalse: [		"not inTrueBlock"
			ifDepth := 0.
			token := self skipWhile: [:each |
				each isConditionalBeginDirective ifTrue: [ifDepth := ifDepth + 1].
				0 < ifDepth ifTrue: [
					each isEndifDirective ifTrue: [ifDepth := ifDepth - 1].
					true.
				] ifFalse: [
					each isConditionalEndDirective not.
				].
			].
			(readStream atEnd or: [readStream peek == lf or: [token value = 'if' or: [token value = 'elif']]]) ifFalse: [ token error:'expected ''if'' or ''elif'' or end of line' ].
			token value = 'endif' ifTrue: [^self].
			token value = 'else' ifTrue: [
				inTrueBlock := anyWereTrue not.
			] ifFalse: [
				token value = 'if' ifTrue: [
					self skipWhile: [:each | each isEndifDirective not].
					readStream peek == lf ifFalse: [token error: 'missing end of line' ].
				] ifFalse: [
					token value = 'elif' ifTrue: [
						inTrueBlock := self evaluateIfOrElif: token.
					] ifFalse: [
						token error:'Expected ''if'' or ''elif'' '
					].
				].
			].
		].
	].
%

category: 'expression evaluation'
method: CPreprocessor
evaluate: aStream
	"Returns an Integer from a stream of tokens"

	| expr value |
	expr := self parse: aStream.
	value := self valueOf: expr.
	^value.
%

category: 'expression evaluation'
method: CPreprocessor
evaluateHeader: aCHeader

	header := aCHeader.
	definitions := aCHeader types.
	^self evaluate: header.
%

category: 'directives'
method: CPreprocessor
evaluateIfOrElif: aToken

	| oldTokens stream expression value lf |
	oldTokens := tokens.
	tokens := { aToken } .
  lf := Character lf .
	[
		readStream atEnd or: [readStream peek == lf ].
	] whileFalse: [
		self applyToken: self nextToken.
	].
	stream := CPreprocessorStream on: tokens.
	tokens := oldTokens.
	stream next.
	expression := self parse: stream.
	value := self valueOf: expression.
	^value ~= 0.
%

category: 'other'
method: CPreprocessor
expandMacroFunctionArguments: aList

	| list |
	list := aList collect: [:eachArray |
		| string |
		string := String new.
		eachArray do: [:each | string add: each source].
		string.
	].
	^list select: [:each | each notEmpty].
%

category: 'directives'
method: CPreprocessor
if: aToken

	self doIf: (self evaluateIfOrElif: aToken).
%

category: 'directives'
method: CPreprocessor
ifdef: aToken defined: aBoolean

	| nameToken name lf |
	readStream peek == (lf := Character lf) ifTrue: [ aToken error:'unexpected end of line' ].
	(nameToken := self nextToken) isIdentifierToken ifFalse: [ nameToken error:'expected an identifier'].
	name := nameToken value.
	readStream peek == lf ifFalse: [ nameToken error:'missing end of line' ].
	self doIf: (definitions includesKey: name) == aBoolean.
%

category: 'directives'
method: CPreprocessor
ignoreRestOfLine

	self addRestOfLineTo: { }
%

category: 'directives'
method: CPreprocessor
include: aToken afterMe: aBoolean
	| token string existingPath fullPath |
	aBoolean ifTrue: [| index |
			index := path indexOfLastByte: $/ codePoint startingAt: path size.
			existingPath := path copyFrom: 1 to: index].
	token := self nextToken.
	aToken source add: token source.
	token isStringToken ifTrue: [
     "If including a name in double quotes, first try getting the file from the same
      directory as the file containing the include."
			string := self directory , token value.
			(GsFile existsOnServer: string) ifTrue: [^self includePath: string].
			string := token value
  ] ifFalse: [
    token isOpenAngleBracketToken ifFalse: [token error: 'expected ''<'' '].
		string := String new.
		[(token := self nextToken) isCloseAngleBracketToken] whileFalse:[
      "we want the source rather than the valueString since 'gnu/stubs-64.h'
          ends up with an integer token of '64.h'!"
			string add: token source.
			aToken source add: token source]
  ].
	fullPath := self searchForInclude: string excluding: existingPath.
	fullPath ifNotNil: [^self includePath: fullPath]
		ifNil: [
      string = 'stdarg.h' ifTrue: [^self].	"This appears to be missing from some systems and can be ignored without problem!"
		  UserDefinedError signal: 'Include file ' , string , ' not found!']
%

category: 'directives'
method: CPreprocessor
includePath: aString
  "Start a CPreprocessor using file specified by aString
    or recurse to process argument of an #include  "
	| oldPath oldLine oldStream fName f |
	oldPath := path.
	oldLine := line.
	oldStream := readStream.
	path := aString.
	line := 1.
  fName := GsFile _expandFilename: aString isClient: false .
    (f := GsFile openReadOnServer: fName) ifNil: [
 	    Error signal: 'cannot open file ', fName , '; ', GsFile serverErrorString.
  ].
  [ self nativeCppCmd ifNotNil:[:cmd|  | cppOut |
      f close .
      cppOut := GsHostProcess execute: ( cmd  , fName) encodeAsUTF8 .
		  (cppOut at: 1 equals:'WARNING') ifTrue:[
         Error signal: 'non-empty stderr from ', cmd, ', ' , cppOut
      ].
      readStream := self _streamOnCppOutput: cppOut .
      false ifTrue:[ "uncomment (change false to true) to facilitate debugging CPreprocessor"
        (GsFile openWriteOnServer: 'cppOut.txt') nextPutAll: cppOut ; close  .
        readStream debug: true . 
      ]. 
      path := aString "file name to associate with error numbers"
    ] ifNil:[
      readStream := CPreprocessorStream on: f contents .
      f close .
      readStream file: path ; line: 1 .
    ] .
		self readTillEnd.
	] ensure: [
		readStream close.
		readStream := oldStream.
		line := oldLine.
    oldPath ifNotNil:[ path := oldPath ].
	].
%

category: 'other'
method: CPreprocessor
initialize
	tokens := { } .
	self _initializePaths .
	self initializeDefinitions .
%

category: 'default definitions'
method: CPreprocessor
initializeDefinitions
	| defs tmpsKey |
  "Do not cache definitions in the repository ; sessions could be executing on
   hosts from a mix of architectures."
  defs := SessionTemps current at: (tmpsKey := #GemStone_CPreprocessorInitialDefinitions)
                               otherwise: nil.
  defs ifNil:[ | arch string |
	  arch := System gemVersionReport at: 'gsBuildArchitecture'.
    string :=
      arch = 'x86-64 (Linux)' ifTrue: [self defaultLinuxDefinitions] ifFalse: [
      arch = 'arm64 (Linux)' ifTrue: [self defaultLinuxDefinitions] ifFalse: [
		  arch = 'Darwin (macOS)' ifTrue: [self defaultDarwinDefinitions] ifFalse: [
		  arch = 'SPARC (Solaris)' ifTrue: [self defaultSparcSolarisDefinitions] ifFalse: [
		  arch = 'x86-64 (Solaris i386)' ifTrue: [self defaultX86SolarisDefinitions] ifFalse: [
		  arch = 'RISC 6000 (AIX 7.2)' ifTrue: [self defaultAix72Definitions] ifFalse: [
		  arch = 'RISC 6000 (AIX 7.1)' ifTrue: [self defaultAix71Definitions] ifFalse: [
		    Error signal: arch asString , ' build type is not (yet?) supported']]]]]]
      ].
    definitions := KeyValueDictionary new .
    self _parseStringNoCpp: string. "fill in definitions"
    defs := definitions .
    SessionTemps current at: tmpsKey put: defs .
  ].
  definitions := defs copy.
%

category: 'other'
method: CPreprocessor
insertSearchPath: aString
  "Install the given path at the front of the list of search paths."

  searchPaths insertObject: aString at: 1
%

category: 'expression evaluation'
method: CPreprocessor
integerFromBoolean: aBoolean

	^aBoolean
		ifTrue: [1]
		ifFalse: [0].
%

category: 'other'
method: CPreprocessor
macroFunctionArgumentsFor: aToken

	| arguments index parenthesisCount list token |
	(token := self nextToken) isOpenParenthesisToken ifFalse: [ token error: 'expected ''('' ' ].
	list := { aToken . token }.
	arguments := { } .
	parenthesisCount := 1.
	index := 3.
	[
		token := self nextToken.
		(parenthesisCount == 1 and: [token isCommaToken]) ifTrue: [
			arguments add: (list copyFrom: index to: list size).
			index := list size + 2.
		] ifFalse: [
			token isOpenParenthesisToken ifTrue: [
				parenthesisCount := parenthesisCount + 1.
			] ifFalse: [
				token isCloseParenthesisToken ifTrue: [parenthesisCount := parenthesisCount - 1].
			].
		].
		list add: token.
		0 < parenthesisCount.
	] whileTrue: [].
	arguments add: (list copyFrom: index to: list size - 1).
	aToken collectOriginalFrom: list.
	^arguments.
%

category: 'expression evaluation'
method: CPreprocessor
mergeLastTwoElementsIn: stack

	| x y token |
	y := stack removeLast.
	x := stack last.
	token := (y at: 2) ->  {  (x at: 3) . (y at: 3)} .
	x at: 3 put: token.
%

category: 'directives'
method: CPreprocessor
nativeCppCmd
  | arch cmd archInt verRpt |
  "Returns a String, the native C preprocessor command ,
   or nil if the native C preprocessor is not used on the platform running the session."

  "false ifTrue:[ ^ nil ]." "uncomment to not use native cpp ."

  archInt := 0 .
  arch := (verRpt := System gemVersionReport) at: 'gsBuildArchitecture' .
  arch = 'x86-64 (Linux)' ifTrue:[
    cmd := '/usr/bin/cpp' .
    (GsFile existsOnServer: cmd ) ifFalse:[
       Error signal: cmd , ' not found,  package cpp must be installed on host running the gem or topaz -l process'.
    ].
    cmd := cmd , ' ' .
    archInt := 50.
  ] ifFalse:[
  arch = 'arm64 (Linux)' ifTrue:[
    cmd := '/usr/bin/cpp' .
    (GsFile existsOnServer: cmd ) ifFalse:[
       Error signal: cmd , ' not found,  package cpp must be installed on host running the gem or topaz -l process'.
    ].
    cmd := cmd , ' ' .
    archInt := 52.
  ] ifFalse:[
  arch = 'Darwin (macOS)' ifTrue:[
    cmd := '/usr/bin/clang'.
    (GsFile existsOnServer: cmd ) ifFalse:[
       Error signal: cmd , ' not found,  clang must be installed on host running the gem or topaz -l process'.
    ].
    "Need to define _ANSI_SOURCE so we don't get enumerator_attributes feature that causes
     trouble for us in /usr/include/time.h on __CLOCK_AVAILABILITY on Darwin 17."
    cmd := cmd , ' -D_ANSI_SOURCE=1 -E -x c ' .
    archInt := 42 .
  ] ifFalse:[
  (arch at: 1 equals: 'RISC 6000 (AIX' ) ifTrue:[
    "NOTE:  AIX cpp does not allow C++ style comments beginning with //  .
      /usr/bin/cpp is not the preprocessor built into xlc . 
     Also note: installing gcc on AIX hijacks /usr/bin/cpp and points it to
     /opt/freeware/bin/cpp, which does not work. I've fixed the symlink on rain
     for this but we really need to call /usr/ccs/lib/cpp directly to avoid this
     headache. -- Norm G, 12/24/2020"
    cmd := '/usr/ccs/lib/cpp' .
    (GsFile existsOnServer: cmd ) ifFalse:[
       Error signal: cmd , ' not found,  /usr/ccs/lib/cpp must be installed on host running the gem or topaz -l process'.
    ].
    archInt := 9 .
    cmd := cmd , ' -DAIX=1 '. "amazingly cpp does not predefine 'AIX' "
    (verRpt at: 'osVersion') = '6' ifTrue:[ cmd addAll: ' -DFLG_AIX_VERSION=61 -D__STDC__=1 ']
                  ifFalse:[ cmd addAll: ' -DFLG_AIX_VERSION=71 ' ].
  ]]]].
  cmd ifNotNil:[
    tmpFnames := { } .
    cppArchMType := archInt .
    searchPaths ifNotNil:[:paths | paths do:[:str |
       cmd addAll: ' -I';
           addAll: (str size == 0 ifTrue:[ '.' ] ifFalse:[str]);
            add: $  ""]].
  ].
  ^ cmd
%

category: 'other'
method: CPreprocessor
next

	tokens isEmpty ifTrue: [^nil].
	^tokens removeFirst.
%

category: 'other'
method: CPreprocessor
nextToken
		"This can return nil if there are no more tokens.
		The stream might not be atEnd because of trailing comments."

	| token |
	token := self cPreprocessorTokenSpecies
		nextFrom: readStream
		filename: path
		line: line.
	token ifNotNil: [line := token line].
	^token.
%

category: 'other'
method: CPreprocessor
nextTokenOnLine
		"This can return nil if there are no more tokens.
		The stream might not be atEnd because of trailing comments."

	| token |
	token := self cPreprocessorTokenSpecies
		nextOnCurrentLineFrom: readStream
		filename: path
		line: line.
	token ifNotNil: [line := token line].
	^token.
%

category: 'expression evaluation'
method: CPreprocessor
numberFrom: aString
	"Returns an number literal token"

	| string value isLong isUnsigned |
	isLong := false.
	isUnsigned := false.
	(2 < aString size and: [(aString at: 1) == $0 and: [(aString at: 2) = $x]]) ifTrue: [
		string := '16r' , (aString copyFrom: 3 to: aString size).
	] ifFalse: [
		aString first == $0 ifTrue: [
			string := '8r' , aString.
		] ifFalse: [
			string := aString.
		].
	].
	('lL' includes: string last) ifTrue: [
		isLong := true.
		string := string copyFrom: 1 to: string size - 1.
	].
	('uU' includes: string last) ifTrue: [
		isUnsigned := true.
		string := string copyFrom: 1 to: string size - 1.
		('lL' includes: string last) ifTrue: [
			isLong := true.
			string := string copyFrom: 1 to: string size - 1.
		].
	].
	value := Integer fromString: string.
	(value class ~~ SmallInteger and: [16rFFFFFFFFFFFFFFFF < value]) ifTrue: [
    self error:'problem parsing an Integer near line ', line asString .
  ].
	(isLong or: [16rFFFFFFFF < value]) ifTrue: [
		(isUnsigned or: [16r7FFFFFFFFFFFFFFF < value])
			ifTrue: [^self cPreprocessorTokenSpecies uint64: value]
			ifFalse: [^self cPreprocessorTokenSpecies int64: value].
	].
	16rFFFF < value ifTrue: [
		(isUnsigned or: [16r7FFFFFFF < value])
			ifTrue: [^self cPreprocessorTokenSpecies uint32: value]
			ifFalse: [^self cPreprocessorTokenSpecies int32: value].
	].
	^(isUnsigned or: [16r7FFF < value])
		ifTrue: [self cPreprocessorTokenSpecies uint16: value]
		ifFalse: [self cPreprocessorTokenSpecies int16: value].
%

category: 'expression evaluation'
method: CPreprocessor
numberLiteralKeys

	^#(
		#'int8' #'uint8' #'int16' #'uint16' #'int32' #'uint32' #'int64' #'uint64'
	).
%

category: 'expression evaluation'
method: CPreprocessor
operandFrom: aStream
	"Returns a token"

	| token |
	token := aStream next.
	token key = #'integer' ifTrue: [^token].
	token key = #'number' ifTrue: [^self numberFrom: token value].
	token key = #'defined' ifTrue: [^#'integer' -> (self integerFromBoolean: (definitions includesKey: token value))].
	token key = #'punctuator' ifTrue: [
		token value = '!' ifTrue: [
			token := self operandFrom: aStream.
			token value: (token value == 1 ifTrue: [0] ifFalse: [1]).
			^token.
		].
		token value = '(' ifTrue: [
			| value |
			value := self evaluate: aStream.
			token := aStream next.
			(token key = #'punctuator' and: [token value = ')']) ifTrue:[ ^ #'integer' -> value].
		].
    token error:'Invalid punctuator'.
	].
	token key == #'identifier' ifTrue: [
		| definition |
		definition := definitions
			at: token value
			ifAbsent: [^#'integer' -> 0].
		definition key ifNil: [
			^#'integer' -> (self evaluate: (CPreprocessorStream on: definition value)).
		] ifNotNil: [
			token error:'Invalid identifier'.
		].
	].
	token error:'expected an indentifier'.
%

category: 'expression evaluation'
method: CPreprocessor
parse: aStream
	"Returns a token from a stream of tokens"

	| list stack |
	list := self parseA: aStream.		"Each element is a three-element array: { precedence. operator. operand }"
	stack := { list removeFirst } .
	1 to: list size do: [:i |
		| each |
		each := list at: i.
		[
			stack last first >= each first.
		] whileTrue: [
			self mergeLastTwoElementsIn: stack.
		].
		stack add: each.
	].
	[
		1 < stack size.
	] whileTrue: [
		self mergeLastTwoElementsIn: stack.
	].
	^stack first last.
%

category: 'expression evaluation'
method: CPreprocessor
parseA: aStream
	"Returns a list of the following: { precedence. operator. operand }"

	| list |
	list := { { -999 . '' .  (self parseForOperandFrom: aStream) } }.
	[true] whileTrue: [
		| operator precedence |
		(operator := aStream peek) ifNil: [^list].
		operator key == #'punctuator' ifFalse: [^list].
		(precedence := self precedenceOf: operator value) ifNil: [^list].
		aStream next.
		list add: { precedence .  operator value asSymbol .  (self parseForOperandFrom: aStream) }.
	].
%

category: 'expression evaluation'
method: CPreprocessor
parseForDefinedFrom: aStream

	| token isFunction key found |
	(isFunction := (token := aStream next) isOpenParenthesisToken) ifTrue: [
		token := aStream next.
	].
	token isIdentifierToken ifFalse: [token error:'expected an identifier'].
	key := token value.
	isFunction ifTrue: [(token := aStream next) isCloseParenthesisToken ifFalse: [ token error:'expected '')'' ']].
	found := definitions includesKey: key.
	^found
		ifTrue: [#'int16' -> 1]
		ifFalse: [#'int16' -> 0].
%

category: 'expression evaluation'
method: CPreprocessor
parseForFunction: aString from: aStream

	| token |
	(token := aStream next) isOpenParenthesisToken ifFalse: [ token error:'expected ''('' '].
	aString = 'sizeof' ifTrue: [^self parseForSizeofFrom: aStream].
	self error:'Failed in parseForFunction near line ', line asString .
%

category: 'expression evaluation'
method: CPreprocessor
parseForOperandFrom: aStream
	"Returns an expression token (which is different from a preprocessor token?)"

	| token |
	token := aStream next.
	(self numberLiteralKeys includes: token key) ifTrue: [^token].
	token key == #'integer' 		ifTrue: [^token].
	token key == #'identifier' 		ifTrue: [
		aStream atEnd ifTrue: [^token].
		token isDefinedIdentifierToken ifTrue: [^self parseForDefinedFrom: aStream].
		aStream peek isOpenParenthesisToken ifTrue: [
			^self parseForFunction: token value from: aStream.
		].
		^token.
	].
	token key == #'number' 		ifTrue: [^self numberFrom: token value].
	token key == #'defined' 		ifTrue: [^token].
	token isEmptyToken 			ifTrue: [^token].
	token key == #'character'		ifTrue: [^token].
	token key == #'punctuator' 	ifTrue: [
		token value = '!' 				ifTrue: [
			token := self parseForOperandFrom: aStream.
			^#'not' -> token.
		].
		token value = '-' 				ifTrue: [
			token := self parseForOperandFrom: aStream.
			^#'negate' -> token.
		].
		token value = '(' 				ifTrue: [
			| typeCast endToken |
			(typeCast := self readTypeSpecifierFrom: aStream) ifNil: [
				token := self parse: aStream.
			].
			(endToken := aStream next) isCloseParenthesisToken ifFalse: [endToken error: 'Expected '')'' '].
			typeCast ifNotNil: [
				token := self parseForOperandFrom: aStream.
				token key == typeCast ifTrue: [^token].
				"self halt."
			].
			^token.
		].
	].
	token error: 'unhandled expression token!'.
%

category: 'expression evaluation'
method: CPreprocessor
parseForSizeofFrom: aStream

	| class declaration token |
	class := self cDeclarationSpecies .
	declaration := class header: header.
	(token := aStream next) isCloseParenthesisToken ifFalse: [ token error:'expected '')'' '].
	^#'int32' -> declaration byteSize.
%

category: 'expression evaluation'
method: CPreprocessor
parseForSizeofStructFrom: aList

	| token fields size |
	aList size = 2 ifFalse: [ Error signal: 'invalid arg size in parseForSizeofStructFrom'].
	(token := aList at: 2) key == #'identifier' ifFalse: [ token error: 'Expected an identifier'].
	fields := header fieldsForStruct: token value.
	size := fields
		inject: 0
		into: [:sum :each | sum + each byteSize].
	^self cPreprocessorTokenSpecies int32: size.
%

category: 'other'
method: CPreprocessor
parseString: aString
 ^ self parseString: aString ignoreWarnings: false
%

category: 'directives'
method: CPreprocessor
parseString: aString ignoreWarnings: aBoolean
  | cmd |
  (cmd := self nativeCppCmd) ifNotNil:[
    | cppOut cppRes cppErr cppInStr |
    cppInStr := aString .
    (cmd includesString: 'clang') ifTrue:[
      "Darwin clang will not read from stdin"
      | tmpIn |
      tmpIn := '/tmp/cppIn', Random new integer asString , '.s' .
      (GsFile openWriteOnServer: tmpIn ) nextPutAll: aString ; flush ; close.
      cmd := cmd , ' ' , tmpIn .
      cppInStr := nil .
      tmpFnames add: tmpIn  . "for later deletion"
    ].
    cppRes := GsHostProcess _execute: cmd  input: aString .
    cppOut := cppRes at: 1 .
    cppErr := cppRes at: 2 .
    readStream := self _streamOnCppOutput: cppOut .
    aBoolean ifFalse:[ cppErr size > 0 ifTrue:[
      Error signal: 'non-empty stderr from ',cmd, ', ', cppErr
    ]].
  ] ifNil: [
	  readStream := CPreprocessorStream on: aString.
  ].
	line := 1.
	self readTillEnd.
%

category: 'accessors'
method: CPreprocessor
path
	^ path
%

category: 'other'
method: CPreprocessor
peek

	tokens isEmpty ifTrue: [^nil].
	^tokens first.
%

category: 'expression evaluation'
method: CPreprocessor
precedenceOf: aString
	"Answer a negative number so that * (-3) is GREATER than + (-4) "

	(#('*' '/' '%') includes: aString) 			ifTrue: [^-3].
	(#('+' '-') includes: aString) 				ifTrue: [^-4].
	(#('<<' '>>') includes: aString)			ifTrue: [^-5].
	(#('<' '<=' '>' '>=') includes: aString) 	ifTrue: [^-6].
	(#('==' '!=') includes: aString) 			ifTrue: [^-7].
	'&' = aString									ifTrue: [^-8].
	'^' = aString									ifTrue: [^-9].
	'|' = aString									ifTrue: [^-10].
	'&&' = aString									ifTrue: [^-11].
	'||' = aString									ifTrue: [^-12].
	(#('?' ':') includes: aString) 				ifTrue: [^-13].
	^nil.
%

category: 'other'
method: CPreprocessor
readTillEnd

	| token |
	[
		(token := self nextToken) ~~ nil .
	] whileTrue: [
		self applyToken: token.
	].
%

category: 'expression evaluation'
method: CPreprocessor
readTypeSpecifierFrom: aStream

	| token value signed size |
	(token := aStream peek) key == #'identifier' ifFalse: [^nil].
	value := token value.
	(definitions includesKey: value) ifTrue: [aStream next. ^(definitions at: value) type].
	value = 'struct'		ifTrue: [^nil].
	value = 'void' 			ifTrue: [aStream next. ^aStream peek isStarToken ifTrue: [aStream next. #'ptr'] ifFalse: [#'void']].
	value = 'float' 			ifTrue: [aStream next. ^#'float'		].
	value = '__float128'	ifTrue: [aStream next. ^#'float128'	].
	value = 'double' 		ifTrue: [aStream next. ^#'double'	].
	value = '_Complex' 	ifTrue: [aStream next. ^#'complex'	].		"this essentially means that there are two of something else (https://gcc.gnu.org/onlinedocs/gcc-4.8.0/gcc/Complex.html)"
	(#('signed' 'unsigned') includes: value) ifTrue: [
		signed := value = 'signed'.
		(token := aStream next; peek) key == #'identifier' ifFalse: [token error: 'Expected an identifier'].
		value := token value.
	].
	value = 'char' ifTrue: [
		aStream next.
		^signed == true
		ifTrue: [#'int8']
		ifFalse: [#'uint8'].
	].
	(#('long' 'short') includes: value) ifTrue: [
		size := value.
		(token := aStream next; peek) key == #'identifier' ifFalse: [token error: 'Expected an identifier'].
		value := token value.
	].
	value = 'double' ifTrue: [
		aStream next.
		size = 'long' ifFalse: [token error: 'Unexpected type'].
		^#'longDouble'.
	].
	value = 'int' ifTrue: [
		aStream next.
		^self typeForIntSigned: signed size: size.
	].
	size ifNotNil: [
		^self typeForIntSigned: signed size: size.
	].
	signed ifNotNil: [token error: 'Unexpected type (expected signed == nil) '].
	(signed == nil and: [size == nil ]) ifTrue: [^nil].
	^self
		typeForIntSigned: signed
		size: size.
%

category: 'directives'
method: CPreprocessor
removeCommentsFrom: aString for: aToken

	| string i j |
	string := aString.
	[
		0 < (i := string indexOfSubCollection: '/*' startingAt: 1).
	] whileTrue: [
		j := string indexOfSubCollection: '*/' startingAt: i.
		0 == j ifTrue: [ aToken error: 'Expected end of comment'].
		string := (string copyFrom: 1 to: i - 1) , (string copyFrom: j + 2 to: string size).
	].
	^string.
%

category: 'other'
method: CPreprocessor
searchForInclude: includePath excluding: skipPath
	"Search our searchPaths for file with the given includePath.
   If includePath begins with $/ , our searchPaths is ignored .
	If skipPath is not nil and matches an entry in our searchPaths,
	only search entries after that one.
	If found, answer the full path, if not answer nil."
  | iArg |
  iArg := includePath .
  (iArg includesIdentical: $$ ) ifTrue:[
    iArg := GsFile _expandFilename: iArg isClient: false .
    iArg ifNil:[ Error signal:'invalid environment variable in ''', includePath asString, ''''].
  ].
  (iArg size > 0 and:[ (iArg at: 1) == $/]) ifTrue:[
		(GsFile existsOnServer: iArg) ifTrue:[ ^ iArg ].
  ] ifFalse:[
	  | skipIndex paths blk |
	  skipIndex := skipPath ifNil:[ 0 ] ifNotNil:[ searchPaths indexOf: skipPath ].
    paths := { } .
	  skipIndex + 1 to: searchPaths size do: [:idx | paths add: (searchPaths at: idx)].
    blk := [:str | | aPath fullPath |
      aPath := str .
      aPath size == 0 ifTrue:[ aPath := GsFile serverCurrentDirectory ].
      aPath last == $/ ifFalse:[ aPath := aPath , $/ ].
			fullPath := aPath , iArg.
      (fullPath includesIdentical: $$ ) ifTrue:[
        fullPath := GsFile _expandFilename: fullPath isClient: false .
      ].
			(GsFile existsOnServer: fullPath) ifTrue:[ ^fullPath ] .
    ].
    paths do: blk .
    systemSearchPaths do: blk .
  ].
	^nil
%

category: 'accessors'
method: CPreprocessor
searchPaths
  "Return the list of directories used to search for a file that is the
   argument to includePath: .
   If using the native cpp , does not include the system search paths
   which are also used to search for file specified by #include directives.
   See also  CPreprocessor >> allSearchPaths "

  ^ searchPaths
%

category: 'directives'
method: CPreprocessor
skipWhile: aBlock

	| token |
	[
		token := self nextToken.
		aBlock value: token.
	] whileTrue: [].
	^token.
%

category: 'accessors'
method: CPreprocessor
tokens

	^tokens.
%

category: 'expression evaluation'
method: CPreprocessor
typeForIntSigned: aBooleanOrNil size: aStringOrNil
"
// From Linux, we have the following:
#define __SIZEOF_SHORT__ 2
#define __SIZEOF_INT__ 4
#define __SIZEOF_LONG__ 8
#define __SIZEOF_LONG_LONG__ 8
"
	aStringOrNil = 'long' ifTrue: [
		^aBooleanOrNil == false
			ifTrue: [#'uint64']
			ifFalse: [#'int64'].
	].
	aStringOrNil = 'short' ifTrue: [
		^aBooleanOrNil == false
			ifTrue: [#'uint16']
			ifFalse: [#'int16'].
	].
	^aBooleanOrNil == false
		ifTrue: [#'uint32']
		ifFalse: [#'int32'].
%

category: 'directives'
method: CPreprocessor
undef: defineToken

	| nameToken name lf |
	readStream peek == (lf := Character lf) ifTrue: [ defineToken error: 'unexpected end of line'].
	(nameToken := self nextToken) isIdentifierToken ifFalse: [ nameToken error: 'expected an identifier'].
	readStream peek == lf ifFalse: [ nameToken error:'missing end of line' ].
	name := nameToken value.
	definitions
		removeKey: name
		ifAbsent: [].
%

category: 'expression evaluation'
method: CPreprocessor
valueOf: aToken
	"Returns an Integer from a token."

	| x y key |
	key := aToken key.
	(self numberLiteralKeys includes: key)		ifTrue: [^aToken value].
	key == #'character'	ifTrue: [^aToken value codePoint].
	key == #'empty'		ifTrue: [^0].
	key == #'identifier' 	ifTrue: [
		| assoc |
		assoc := definitions
			at: aToken value
			ifAbsent: [nil].
		assoc ifNil: [
			header ifNil: [^0].
			^header enums
				at: aToken value
				ifAbsent: [0].
		].
		^self evaluate: (CPreprocessorStream on: assoc value)].
	key == #'defined' ifTrue: [^self integerFromBoolean: (definitions includesKey: aToken value)].
	key == #'not'		ifTrue: [^self integerFromBoolean: (self valueOf: aToken value) == 0].
	key == #'negate'	ifTrue: [^(self valueOf: aToken value) negated].
	key == #'&&' 		ifTrue: [
		(self valueOf: (aToken value at: 1)) == 0 ifTrue: [^0].
		^self valueOf: (aToken value at: 2).
	].
	key == #'||' 			ifTrue: [
		(self valueOf: (aToken value at: 1)) == 1 ifTrue: [^1].
		^self valueOf: (aToken value at: 2).
	].
	x := self valueOf: (aToken value at: 1).
	y := self valueOf: (aToken value at: 2).
	key == #'=='	ifTrue: [^self integerFromBoolean: x = y].
	key == #'!='	ifTrue: [^self integerFromBoolean: x ~= y].
	key == #'>='	ifTrue: [^self integerFromBoolean: x >= y].
	key == #'>'		ifTrue: [^self integerFromBoolean: x > y].
	key == #'<'		ifTrue: [^self integerFromBoolean: x < y].
	key == #'<='	ifTrue: [^self integerFromBoolean: x <= y].
	key == #'*'		ifTrue: [^x * y].
	key == #'+'		ifTrue: [^x + y].
	key == #'/'		ifTrue: [^x // y].
	key == #'-'		ifTrue: [^x - y].
	key == #'%'	ifTrue: [^x \\ y].
	key == #'<<'	ifTrue: [^x bitShift: y].
	key == #'>>'	ifTrue: [^x bitShift: y negated].
	key == #'?'		ifTrue: [^x == 1 ifTrue: [y] ifFalse: [nil]].
	key == #':'		ifTrue: [^x ~~ nil ifTrue: [x] ifFalse: [y]].
	key == #'|'		ifTrue: [^x bitOr: y].
	key == #'&'		ifTrue: [^x bitAnd: y].

	aToken error: 'Failed in valueOf:'.
%

category: 'default definitions'
method: CPreprocessor
_defaultAix71DefinitionsOld
	"The usual ... echo '' | cpp -dM ... doesn't work on AIX.
	 The AIX equivalent is:
		echo 'int main() { return 0; }' > x.C; /usr/vacpp/bin/xlC_r -qshowmacros -q64 -E x.C
"
	^'
#define _POWER 1
#define _IBMR2 1
#define _AIX71 1
#define _AIX61 1
#define _AIX53 1
#define _AIX52 1
#define _AIX51 1
#define _AIX50 1
#define _AIX43 1
#define _AIX41 1
#define _AIX32 1
#define _AIX 1
#define __VACPP_MULTI__ 1
#define _THREAD_SAFE 1
#define __IBM_INCLUDE_NEXT 1
#define __IBM_MACRO_WITH_VA_ARGS 1
#define __C99_MACRO_WITH_VA_ARGS 1
#define __C99__FUNC__ 1
#define __EXCEPTIONS 1
#define _CPPUNWIND 1
#define __DIGRAPHS__ 1
#define __LONGDOUBLE64 1
#define __IBM__ALIGN 1
#define __ALIGN 1
#define __C99_HEX_FLOAT_CONST 1
#define __IBM_CHAR32_T__ 1
#define __IBM_CHAR16_T__ 1
#define __IBM_ATTRIBUTES 1
#define __IBM_EXTENSION_KEYWORD 1
#define __IBM__TYPEOF__ 1
#define __IBM__ALIGNOF__ 1
#define __C99_PRAGMA_OPERATOR 1
#define __IBM__RESTRICT__ 1
#define __C99_RESTRICT 1
#define __BOOL__ 1
#define __OBJECT_MODEL_CLASSIC__ 1
#define __OBJECT_MODEL_COMPAT__ 1
#define __NO_RTTI__ 1
', "#define defined defined" 	"This seems to break the parser, allowing it to think 'defined' is a type declaration"
'#define __CHAR_UNSIGNED__ 1
#define __IBMCPP_EXTERN_TEMPLATE 1
#define __XPLINK_CALLBACK__ 1
#define __IBM_UTF_LITERAL 1
#define __IBM_LOCAL_LABEL 1
#define __IBM_LABEL_VALUE 1
#define __IBM_COMPUTED_GOTO 1
#define __C99_VARIABLE_LENGTH_ARRAY 1
#define __C99_COMPOUND_LITERAL 1
#define _CHAR_UNSIGNED 1
#define _LONG_LONG 1
#define _ARCH_PPC64 1
#define _ARCH_PPC 1
#define _ARCH_COM 1
#define __IBM_GCC_ASM 1
#define _EXT 1
#define _MI_BUILTIN 1
#define __BASE_FILE__ "x.C"
#define __V6ALIGN__ 1
#define __XLC13__ 1
#define __XLC121__ 1
#define __MATH__ 1
#define __STR__ 1
#define _WCHAR_T 1
#define __TOS_AIX__ 1
#define __THW_RS6000__ 1
#define _LP64 1
#define __64BIT__ 1
#define __ppc__ 1
#define __PPC__ 1
#define __PPC 1
#define __powerpc__ 1
#define __powerpc 1
#define __BIG_ENDIAN__ 1
#define _BIG_ENDIAN 1
#define __THW_PPC__ 1
#define __THW_BIG_ENDIAN__ 1
#define __unix__ 1
#define __unix 1
#define __FUNCTION__ __FUNCTION__
#define __STDC__ 0
#define __xlC_ver__ 0x0000000a
#define __xlC__ 0x0b01
#define __HOS_AIX__ 1
#define __HHW_RS6000__ 1
#define __HHW_BIG_ENDIAN__ 1
#define __IBMCPP__ 1110
#define __cplusplus 199711L
' ,
	"additional definitions (some of this looks like rubbish!)"
'
#define FLG_AIX_VERSION 71

#define ptrdiff_t long
#define wchar_t int
#define throw()
#define restrict
#define __restrict
#define __const const
#define __inline inline
#define __inline__ inline
#define __signed signed
#define __volatile
'.
%

category: 'default definitions'
method: CPreprocessor
_defaultAix72DefinitionsOld
	"The usual ... echo '' | cpp -dM ... doesn't work on AIX.
	 The AIX equivalent is:
		echo 'int main() { return 0; }' > x.C; /usr/vacpp/bin/xlC_r -qshowmacros -q64 -E x.C
"
	^'
#define _POWER 1
#define _IBMR2 1
#define _AIX72 1
#define _AIX71 1
#define _AIX61 1
#define _AIX53 1
#define _AIX52 1
#define _AIX51 1
#define _AIX50 1
#define _AIX43 1
#define _AIX41 1
#define _AIX32 1
#define _AIX 1
#define __VACPP_MULTI__ 1
#define _THREAD_SAFE 1
#define __IBM_INCLUDE_NEXT 1
#define __IBM_MACRO_WITH_VA_ARGS 1
#define __C99_MACRO_WITH_VA_ARGS 1
#define __C99__FUNC__ 1
#define __EXCEPTIONS 1
#define _CPPUNWIND 1
#define __DIGRAPHS__ 1
#define __LONGDOUBLE64 1
#define __IBM__ALIGN 1
#define __ALIGN 1
#define __C99_HEX_FLOAT_CONST 1
#define __IBM_CHAR32_T__ 1
#define __IBM_CHAR16_T__ 1
#define __IBM_ATTRIBUTES 1
#define __IBM_EXTENSION_KEYWORD 1
#define __IBM__TYPEOF__ 1
#define __IBM__ALIGNOF__ 1
#define __C99_PRAGMA_OPERATOR 1
#define __IBM__RESTRICT__ 1
#define __C99_RESTRICT 1
#define __BOOL__ 1
#define __OBJECT_MODEL_CLASSIC__ 1
#define __OBJECT_MODEL_COMPAT__ 1
#define __NO_RTTI__ 1
', "#define defined defined"    "This seems to break the parser, allowing it to think 'defined' is a type declaration"
'#define __CHAR_UNSIGNED__ 1
#define __IBMCPP_EXTERN_TEMPLATE 1
#define __XPLINK_CALLBACK__ 1
#define __IBM_UTF_LITERAL 1
#define __IBM_LOCAL_LABEL 1
#define __IBM_LABEL_VALUE 1
#define __IBM_COMPUTED_GOTO 1
#define __C99_VARIABLE_LENGTH_ARRAY 1
#define __C99_COMPOUND_LITERAL 1
#define _CHAR_UNSIGNED 1
#define _LONG_LONG 1
#define _ARCH_PPC64 1
#define _ARCH_PPC 1
#define _ARCH_COM 1
#define __IBM_GCC_ASM 1
#define _EXT 1
#define _MI_BUILTIN 1
#define __BASE_FILE__ "x.C"
#define __V6ALIGN__ 1
#define __XLC13__ 1
#define __XLC121__ 1
#define __MATH__ 1
#define __STR__ 1
#define _WCHAR_T 1
#define __TOS_AIX__ 1
#define __THW_RS6000__ 1
#define _LP64 1
#define __64BIT__ 1
#define __ppc__ 1
#define __PPC__ 1
#define __PPC 1
#define __powerpc__ 1
#define __powerpc 1
#define __BIG_ENDIAN__ 1
#define _BIG_ENDIAN 1
#define __THW_PPC__ 1
#define __THW_BIG_ENDIAN__ 1
#define __unix__ 1
#define __unix 1
#define __FUNCTION__ __FUNCTION__
#define __STDC__ 0
#define __xlC_ver__ 0x00000017
#define __xlC__ 0x0b01
#define __HOS_AIX__ 1
#define __HHW_RS6000__ 1
#define __HHW_BIG_ENDIAN__ 1
#define __IBMCPP__ 1110
#define __cplusplus 199711L
' ,
	"additional definitions (some of this looks like rubbish!)"
'
#define FLG_AIX_VERSION 72

#define ptrdiff_t long
#define wchar_t int
#define throw()
#define restrict
#define __restrict
#define __const const
#define __inline inline
#define __inline__ inline
#define __signed signed
#define __volatile
'.
%

category: 'default definitions'
method: CPreprocessor
_defaultDarwinDefinitionsOld
	"echo '' | cpp -dM
"
	^'
#define OBJC_NEW_PROPERTIES 1
#define _LP64 1
#define __APPLE_CC__ 6000
#define __APPLE__ 1
#define __ATOMIC_ACQUIRE 2
#define __ATOMIC_ACQ_REL 4
#define __ATOMIC_CONSUME 1
#define __ATOMIC_RELAXED 0
#define __ATOMIC_RELEASE 3
#define __ATOMIC_SEQ_CST 5
#define __BLOCKS__ 1
#define __BYTE_ORDER__ __ORDER_LITTLE_ENDIAN__
#define __CHAR16_TYPE__ unsigned short
#define __CHAR32_TYPE__ unsigned int
#define __CHAR_BIT__ 8
#define __CONSTANT_CFSTRINGS__ 1
#define __DBL_DENORM_MIN__ 4.9406564584124654e-324
#define __DBL_DIG__ 15
#define __DBL_EPSILON__ 2.2204460492503131e-16
#define __DBL_HAS_DENORM__ 1
#define __DBL_HAS_INFINITY__ 1
#define __DBL_HAS_QUIET_NAN__ 1
#define __DBL_MANT_DIG__ 53
#define __DBL_MAX_10_EXP__ 308
#define __DBL_MAX_EXP__ 1024
#define __DBL_MAX__ 1.7976931348623157e+308
#define __DBL_MIN_10_EXP__ (-307)
#define __DBL_MIN_EXP__ (-1021)
#define __DBL_MIN__ 2.2250738585072014e-308
#define __DECIMAL_DIG__ 21
#define __DYNAMIC__ 1
#define __ENVIRONMENT_MAC_OS_X_VERSION_MIN_REQUIRED__ 1090
#define __FINITE_MATH_ONLY__ 0
#define __FLT_DENORM_MIN__ 1.40129846e-45F
#define __FLT_DIG__ 6
#define __FLT_EPSILON__ 1.19209290e-7F
#define __FLT_EVAL_METHOD__ 0
#define __FLT_HAS_DENORM__ 1
#define __FLT_HAS_INFINITY__ 1
#define __FLT_HAS_QUIET_NAN__ 1
#define __FLT_MANT_DIG__ 24
#define __FLT_MAX_10_EXP__ 38
#define __FLT_MAX_EXP__ 128
#define __FLT_MAX__ 3.40282347e+38F
#define __FLT_MIN_10_EXP__ (-37)
#define __FLT_MIN_EXP__ (-125)
#define __FLT_MIN__ 1.17549435e-38F
#define __FLT_RADIX__ 2
#define __GCC_ATOMIC_BOOL_LOCK_FREE 2
#define __GCC_ATOMIC_CHAR16_T_LOCK_FREE 2
#define __GCC_ATOMIC_CHAR32_T_LOCK_FREE 2
#define __GCC_ATOMIC_CHAR_LOCK_FREE 2
#define __GCC_ATOMIC_INT_LOCK_FREE 2
#define __GCC_ATOMIC_LLONG_LOCK_FREE 2
#define __GCC_ATOMIC_LONG_LOCK_FREE 2
#define __GCC_ATOMIC_POINTER_LOCK_FREE 2
#define __GCC_ATOMIC_SHORT_LOCK_FREE 2
#define __GCC_ATOMIC_TEST_AND_SET_TRUEVAL 1
#define __GCC_ATOMIC_WCHAR_T_LOCK_FREE 2
#define __GCC_HAVE_SYNC_COMPARE_AND_SWAP_1 1
#define __GCC_HAVE_SYNC_COMPARE_AND_SWAP_16 1
#define __GCC_HAVE_SYNC_COMPARE_AND_SWAP_2 1
#define __GCC_HAVE_SYNC_COMPARE_AND_SWAP_4 1
#define __GCC_HAVE_SYNC_COMPARE_AND_SWAP_8 1
#define __GNUC_MINOR__ 2
#define __GNUC_PATCHLEVEL__ 1
#define __GNUC_STDC_INLINE__ 1
#define __GNUC__ 4
#define __GXX_ABI_VERSION 1002
#define __GXX_RTTI 1
#define __INT16_TYPE__ short
#define __INT32_TYPE__ int
#define __INT64_C_SUFFIX__ LL
#define __INT64_TYPE__ long long int
#define __INT8_TYPE__ char
#define __INTMAX_MAX__ 9223372036854775807L
#define __INTMAX_TYPE__ long int
#define __INTMAX_WIDTH__ 64
#define __INTPTR_TYPE__ long int
#define __INTPTR_WIDTH__ 64
#define __INT_MAX__ 2147483647
#define __LDBL_DENORM_MIN__ 3.64519953188247460253e-4951L
#define __LDBL_DIG__ 18
#define __LDBL_EPSILON__ 1.08420217248550443401e-19L
#define __LDBL_HAS_DENORM__ 1
#define __LDBL_HAS_INFINITY__ 1
#define __LDBL_HAS_QUIET_NAN__ 1
#define __LDBL_MANT_DIG__ 64
#define __LDBL_MAX_10_EXP__ 4932
#define __LDBL_MAX_EXP__ 16384
#define __LDBL_MAX__ 1.18973149535723176502e+4932L
#define __LDBL_MIN_10_EXP__ (-4931)
#define __LDBL_MIN_EXP__ (-16381)
#define __LDBL_MIN__ 3.36210314311209350626e-4932L
#define __LITTLE_ENDIAN__ 1
#define __LONG_LONG_MAX__ 9223372036854775807LL
#define __LONG_MAX__ 9223372036854775807L
#define __LP64__ 1
#define __MACH__ 1
#define __MMX__ 1
#define __NO_INLINE__ 1
#define __NO_MATH_INLINES 1
#define __ORDER_BIG_ENDIAN__ 4321
#define __ORDER_LITTLE_ENDIAN__ 1234
#define __ORDER_PDP_ENDIAN__ 3412
#define __PIC__ 2
#define __POINTER_WIDTH__ 64
#define __PRAGMA_REDEFINE_EXTNAME 1
#define __PTRDIFF_TYPE__ long int
#define __PTRDIFF_WIDTH__ 64
#define __REGISTER_PREFIX__
#define __SCHAR_MAX__ 127
#define __SHRT_MAX__ 32767
#define __SIG_ATOMIC_WIDTH__ 32
#define __SIZEOF_DOUBLE__ 8
#define __SIZEOF_FLOAT__ 4
#define __SIZEOF_INT128__ 16
#define __SIZEOF_INT__ 4
#define __SIZEOF_LONG_DOUBLE__ 16
#define __SIZEOF_LONG_LONG__ 8
#define __SIZEOF_LONG__ 8
#define __SIZEOF_POINTER__ 8
#define __SIZEOF_PTRDIFF_T__ 8
#define __SIZEOF_SHORT__ 2
#define __SIZEOF_SIZE_T__ 8
#define __SIZEOF_WCHAR_T__ 4
#define __SIZEOF_WINT_T__ 4
#define __SIZE_MAX__ 18446744073709551615UL
#define __SIZE_TYPE__ long unsigned int
#define __SIZE_WIDTH__ 64
#define __SSE2_MATH__ 1
#define __SSE2__ 1
#define __SSE3__ 1
#define __SSE_MATH__ 1
#define __SSE__ 1
#define __SSP__ 1
#define __SSSE3__ 1
#define __STDC_HOSTED__ 1
#define __STDC_UTF_16__ 1
#define __STDC_UTF_32__ 1
#define __STDC_VERSION__ 199901L
#define __UINTMAX_TYPE__ long unsigned int
#define __USER_LABEL_PREFIX__ _
#define __VERSION__ "4.2.1 Compatible Apple LLVM 6.0 (clang-600.0.56)"
#define __WCHAR_MAX__ 2147483647
#define __WCHAR_TYPE__ int
#define __WCHAR_WIDTH__ 32
#define __WINT_TYPE__ int
#define __WINT_WIDTH__ 32
#define __amd64 1
#define __amd64__ 1
#define __apple_build_version__ 6000056
#define __block __attribute__((__blocks__(byref)))
#define __clang__ 1
#define __clang_major__ 6
#define __clang_minor__ 0
#define __clang_patchlevel__ 0
#define __clang_version__ "6.0 (clang-600.0.56)"
#define __core2 1
#define __core2__ 1
#define __llvm__ 1
#define __pic__ 2
#define __strong
#define __tune_core2__ 1
#define __unsafe_unretained
#define __weak __attribute__((objc_gc(weak)))
#define __x86_64 1
#define __x86_64__ 1
' ,
	"additional definitions"
'
#define NO_ANSI_KEYWORDS
#define restrict
#define throw()
#define __const const
#define __inline inline
#define __inline__ inline
#define __restrict
#define __signed signed
#define __STDC__
#define __volatile
'
%

category: 'default definitions'
method: CPreprocessor
_defaultLinuxDefinitionsOld
"from 3.5 trunk r45820 "
	^'
#define __DBL_MIN_EXP__ (-1021)
#define __FLT_MIN__ 1.17549435e-38F
#define __CHAR_BIT__ 8
#define __WCHAR_MAX__ 2147483647
#define __GCC_HAVE_SYNC_COMPARE_AND_SWAP_1 1
#define __GCC_HAVE_SYNC_COMPARE_AND_SWAP_2 1
#define __GCC_HAVE_SYNC_COMPARE_AND_SWAP_4 1
#define __DBL_DENORM_MIN__ 4.9406564584124654e-324
#define __GCC_HAVE_SYNC_COMPARE_AND_SWAP_8 1
#define __FLT_EVAL_METHOD__ 0
#define __unix__ 1
#define __x86_64 1
#define __DBL_MIN_10_EXP__ (-307)
#define __FINITE_MATH_ONLY__ 0
#define __GNUC_PATCHLEVEL__ 3
#define __DEC64_MAX_EXP__ 385
#define __SHRT_MAX__ 32767
#define __LDBL_MAX__ 1.18973149535723176502e+4932L
#define __UINTMAX_TYPE__ long unsigned int
#define __linux 1
#define __DEC32_EPSILON__ 1E-6DF
#define __unix 1
#define __LDBL_MAX_EXP__ 16384
#define __linux__ 1
#define __SCHAR_MAX__ 127
#define __DBL_DIG__ 15
#define _FORTIFY_SOURCE 2
#define __SIZEOF_INT__ 4
#define __SIZEOF_POINTER__ 8
#define __USER_LABEL_PREFIX__
#define __STDC_HOSTED__ 1
#define __LDBL_HAS_INFINITY__ 1
#define __FLT_EPSILON__ 1.19209290e-7F
#define __LDBL_MIN__ 3.36210314311209350626e-4932L
#define __DEC32_MAX__ 9.999999E96DF
#define __SIZEOF_LONG__ 8
#define __DECIMAL_DIG__ 21
#define __gnu_linux__ 1
#define __LDBL_HAS_QUIET_NAN__ 1
#define __GNUC__ 4
#define __MMX__ 1
#define __FLT_HAS_DENORM__ 1
#define __SIZEOF_LONG_DOUBLE__ 16
#define __BIGGEST_ALIGNMENT__ 16
#define __DBL_MAX__ 1.7976931348623157e+308
#define __DBL_HAS_INFINITY__ 1
#define __DEC32_MIN_EXP__ (-94)
#define __LDBL_HAS_DENORM__ 1
#define __DEC128_MAX__ 9.999999999999999999999999999999999E6144DL
#define __DEC32_MIN__ 1E-95DF
#define __DBL_MAX_EXP__ 1024
#define __DEC128_EPSILON__ 1E-33DL
#define __SSE2_MATH__ 1
#define __amd64 1
#define __LONG_LONG_MAX__ 9223372036854775807LL
#define __SIZEOF_SIZE_T__ 8
#define __SIZEOF_WINT_T__ 4
#define __GCC_HAVE_DWARF2_CFI_ASM 1
#define __GXX_ABI_VERSION 1002
#define __FLT_MIN_EXP__ (-125)
#define __DBL_MIN__ 2.2250738585072014e-308
#define __LP64__ 1
#define __DECIMAL_BID_FORMAT__ 1
#define __DEC128_MIN__ 1E-6143DL
#define __REGISTER_PREFIX__
#define __DBL_HAS_DENORM__ 1
#define __NO_INLINE__ 1
#define __FLT_MANT_DIG__ 24
#define __VERSION__ "4.4.3"
#define __DEC64_EPSILON__ 1E-15DD
#define __DEC128_MIN_EXP__ (-6142)
#define unix 1
#define __SIZE_TYPE__ long unsigned int
#define __ELF__ 1
#define __FLT_RADIX__ 2
#define __LDBL_EPSILON__ 1.08420217248550443401e-19L
#define __SSE_MATH__ 1
#define __k8 1
#define __SIZEOF_PTRDIFF_T__ 8
#define __x86_64__ 1
#define __DEC32_SUBNORMAL_MIN__ 0.000001E-95DF
#define __FLT_HAS_QUIET_NAN__ 1
#define __FLT_MAX_10_EXP__ 38
#define __LONG_MAX__ 9223372036854775807L
#define __DEC128_SUBNORMAL_MIN__ 0.000000000000000000000000000000001E-6143DL
#define __FLT_HAS_INFINITY__ 1
#define __DEC64_MAX__ 9.999999999999999E384DD
#define __CHAR16_TYPE__ short unsigned int
#define __DEC64_MANT_DIG__ 16
#define __DEC32_MAX_EXP__ 97
#define linux 1
#define __SSE2__ 1
#define __LDBL_MANT_DIG__ 64
#define __DBL_HAS_QUIET_NAN__ 1
#define __k8__ 1
#define __WCHAR_TYPE__ int
#define __SIZEOF_FLOAT__ 4
#define __DEC64_MIN_EXP__ (-382)
#define __FLT_DIG__ 6
#define __INT_MAX__ 2147483647
#define __amd64__ 1
#define __FLT_MAX_EXP__ 128
#define __DBL_MANT_DIG__ 53
#define __DEC64_MIN__ 1E-383DD
#define __WINT_TYPE__ unsigned int
#define __SIZEOF_SHORT__ 2
#define __SSE__ 1
#define __LDBL_MIN_EXP__ (-16381)
#define __SSP__ 1
#define __LDBL_MAX_10_EXP__ 4932
#define __DBL_EPSILON__ 2.2204460492503131e-16
#define _LP64 1
#define __SIZEOF_WCHAR_T__ 4
#define __DEC_EVAL_METHOD__ 2
#define __INTMAX_MAX__ 9223372036854775807L
#define __FLT_DENORM_MIN__ 1.40129846e-45F
#define __CHAR32_TYPE__ unsigned int
#define __FLT_MAX__ 3.40282347e+38F
#define __SIZEOF_DOUBLE__ 8
#define __FLT_MIN_10_EXP__ (-37)
#define __INTMAX_TYPE__ long int
#define __DEC128_MAX_EXP__ 6145
#define __GNUC_MINOR__ 4
#define __DEC32_MANT_DIG__ 7
#define __DBL_MAX_10_EXP__ 308
#define __LDBL_DENORM_MIN__ 3.64519953188247460253e-4951L
#define __STDC__ 1
#define __PTRDIFF_TYPE__ long int
#define __DEC64_SUBNORMAL_MIN__ 0.000000000000001E-383DD
#define __DEC128_MANT_DIG__ 34
#define __LDBL_MIN_10_EXP__ (-4931)
#define __SIZEOF_LONG_LONG__ 8
#define __LDBL_DIG__ 18
#define __GNUC_GNU_INLINE__ 1
' ,
	"additional definitions"
'
#define ptrdiff_t long
#define restrict
#define size_t unsigned long
#define wchar_t int
#define throw()
#define _XOPEN_SOURCE 1
#define __const const
#define __cplusplus
#define __inline inline
#define __inline__ inline
#define __restrict
#define __signed signed
#define __volatile
#define _BSD_SOURCE 1
#define _SIZE_T
#define __GNUG__
'
%

category: 'other'
method: CPreprocessor
_init
| str |
str := self defaultLinuxDefinitions .
definitions := KeyValueDictionary new .
tokens := { } .
self _parseStringNoCpp: str .
^ self
%

category: 'Private'
method: CPreprocessor
_initializePaths
	| list |
  self nativeCppCmd .
	list := { '' }.
	(path ~~ nil and: [path first == $$ ]) ifTrue: [list add: self directory].
  cppArchMType ifNil:[  "not using native cpp"
	  list add: '/usr/include/'; add: '/usr/local/include/' .
    systemSearchPaths := { } .
  ] ifNotNil:[
    systemSearchPaths := { '/usr/include/' . '/usr/local/include/' }.
    (cppArchMType == 50 or:[ cppArchMType == 52]) 
     ifTrue:[ systemSearchPaths add: '/usr/include/linux' ].
  ].
  searchPaths := list .
%

category: 'Private'
method: CPreprocessor
_parseStringNoCpp: aString
  readStream := CPreprocessorStream on: aString.
  line := 1.
  self readTillEnd.
%

category: 'Private'
method: CPreprocessor
_streamOnCppOutput: aString
  | strm tmpOut |
  "write stdout of cpp to a file for use in debugging the preprocessor."
  tmpOut := '/tmp/cppOut', Random new integer asString , '.s' .
  (GsFile openWriteOnServer: tmpOut ) nextPutAll: aString ; flush ; close.
  tmpFnames add: tmpOut  . "for later deletion"

  (strm := CPreprocessorStream on: aString )
    cppArchMType:  cppArchMType; file: path ; line: 1 .
  ^ strm .
%

! Class implementation for 'CPreprocessorToken'

!		Class methods for 'CPreprocessorToken'

category: 'other'
classmethod: CPreprocessorToken
args: anArray
	| res |
	(res := self basicNew) initializeArgs: anArray .
	^ res
%

category: 'other'
classmethod: CPreprocessorToken
concatenation
	| res |
	(res := self basicNew) initializeConcatenation .
	^ res
%

category: 'other'
classmethod: CPreprocessorToken
define: aString
	| res |
	(res := self basicNew) initializeDefine: aString .
    ^ res
%

category: 'other'
classmethod: CPreprocessorToken
directive: aString
	| res |
	(res := self basicNew) initializeDirective: aString .
    ^ res
%

category: 'other'
classmethod: CPreprocessorToken
empty
	| res |
	(res := self basicNew) initializeEmpty .
	^ res
%

category: 'other'
classmethod: CPreprocessorToken
identifier: aString
	| res |
	(res := self basicNew) initializeIdentifier: aString .
	^ res
%

category: 'other'
classmethod: CPreprocessorToken
int16: anInteger
	| res |
	(res := self basicNew ) initializeInt16: anInteger .
	^ res
%

category: 'other'
classmethod: CPreprocessorToken
int32: anInteger
	| res |
	(res := self basicNew) initializeInt32: anInteger .
	^ res
%

category: 'other'
classmethod: CPreprocessorToken
int64: anInteger
	| res |
	(res := self basicNew) initializeInt64: anInteger .
	^ res
%

category: 'other'
classmethod: CPreprocessorToken
nextFrom: aStream filename: aString line: anInteger
	"Note that this might return nil if no more tokens!"

	^self
		nextFrom: aStream
		filename: aString
		line: anInteger
		onOneLogicalLine: false
%

category: 'other'
classmethod: CPreprocessorToken
nextFrom: aStream filename: aString line: anInteger onOneLogicalLine: aBoolean
	"Note that this might return nil if no more tokens!"

	^self basicNew
		initializeStream: aStream
		filename: aString
		line: anInteger
		singleLogicalLine: aBoolean
%

category: 'other'
classmethod: CPreprocessorToken
nextOnCurrentLineFrom: aStream filename: aString line: anInteger
	"Note that this might return nil if no more tokens!"

	^self
		nextFrom: aStream
		filename: aString
		line: anInteger
		onOneLogicalLine: true
%

category: 'other'
classmethod: CPreprocessorToken
number: aNumber
	| res |
	(res := self basicNew) initializeNumber: aNumber .
	^ res
%

category: 'other'
classmethod: CPreprocessorToken
punctuator: aString
	| res |
	(res := self basicNew) initializePunctuator: aString .
	^ res
%

category: 'other'
classmethod: CPreprocessorToken
string: aString
	| res |
	(res := self basicNew) initializeString: aString .
	^ res
%

category: 'other'
classmethod: CPreprocessorToken
uint16: anInteger
	| res |
	(res := self basicNew) initializeUInt16: anInteger .
	^ res
%

category: 'other'
classmethod: CPreprocessorToken
uint32: anInteger
	| res |
	(res := self basicNew) initializeUInt32: anInteger .
	^ res
%

category: 'other'
classmethod: CPreprocessorToken
uint64: anInteger
	| res |
	(res := self basicNew) initializeUInt64: anInteger.
	^ res
%

!		Instance methods for 'CPreprocessorToken'

category: 'other'
method: CPreprocessorToken
asAssociation
	"To facilitate automated tests"
	^type -> value.
%

category: 'other'
method: CPreprocessorToken
collectOriginalFrom: aList

	| string |
	string := String new.
	aList do: [:each | string add: each source].
	source := string.
%

category: 'other'
method: CPreprocessorToken
concatenate: aToken

	value add: aToken source trimSeparators.
%

category: 'Initializing'
method: CPreprocessorToken
defineParameters: parametersArray expansionTokens: expansionTokens

	| expansionArray i j string |
	type := #'define'.
	parametersArray ifNil: [
		value := expansionTokens
			inject: String new
			into: [:priorString :token | priorString add: token source; yourself].
		^self.
	].
	expansionArray := {}.
	string := String new.
	expansionTokens do: [:each |
		(each isIdentifierToken and: [0 < (i := parametersArray indexOf: each value)]) ifTrue: [
			j := each source indexOfSubCollection: each value startingAt: 1.
			1 < j ifTrue: [string add: (each source copyFrom: 1 to: j - 1)].
			expansionArray add: string; add: i.
			string := String new.
			j + each value size - 1 < each source size ifTrue: [string add: (each source copyFrom: j + each value size to: each source size)].
		] ifFalse: [
			string add: each source.
		].
	].
	expansionArray add: string.
	value := expansionArray.
%

category: 'Errors'
method: CPreprocessorToken
error: aString

  "aString is typically of the form 'Expected semicolon ...' "

  Error signal: (aString , ', found ''' , self printString , '''', self positionString)
%

category: 'other'
method: CPreprocessorToken
expandArguments: arguments

	| string |
	string := String new.
	value do: [:each1 |
		(each1 isKindOf: Integer) ifTrue: [	"substitution"
			| flag |
			flag := string isEmpty or: [
				(string notEmpty and: [string last ~~ $#]) or: [
				2 < string size and: [(string copyFrom: string size - 1 to: string size) = '##']]].
			flag  ifTrue: [	"simple case"
				string add: (arguments at: each1).
			] ifFalse: [		"# macro preprocessing operator creates a string"
				string at: string size put: $".		"replace the # token with the start of a string"
				(arguments at: each1) trimSeparators do: [:each2 |
					('\"' includes: each2) ifTrue: [string add: $\].
					string add: each2.
				].
				string add: $".
			].
		] ifFalse: [
			string add: each1.
		].
	].
	^string
%

category: 'Accessing'
method: CPreprocessorToken
file

	^file.
%

category: 'Reading'
method: CPreprocessorToken
hexCharacterFrom: aStream
	"Enter with pointing to 'x' of '\0xhh'"

	| string |
	string := String withAll: '16r0'.
	[true] whileTrue: [
		| char |
		char := self peekFrom: aStream.
		(string size < 6 and: [char isAlphaNumeric]) ifFalse: [
			value add: (Character codePoint: (Integer fromString: string)).
			^self.
		].
		string add: char.
		source add: aStream next.
	].
%

category: 'Initializing'
method: CPreprocessorToken
initializeArgs: anArray

	type := #'args'.
	value := anArray.
%

category: 'Initializing'
method: CPreprocessorToken
initializeConcatenation

	type := #'concatenation'.
%

category: 'Initializing'
method: CPreprocessorToken
initializeDefine: aString

	type := #'define'.
	value := aString.
%

category: 'Initializing'
method: CPreprocessorToken
initializeDirective: aString

	type := #'directive'.
	value := aString.
%

category: 'Initializing'
method: CPreprocessorToken
initializeEmpty

	type := #'empty'.
%

category: 'Initializing'
method: CPreprocessorToken
initializeIdentifier: aString

	type := #'identifier'.
	value := aString.
%

category: 'Initializing'
method: CPreprocessorToken
initializeInt16: anInteger

	type := #'int16'.
	value := anInteger.
%

category: 'Initializing'
method: CPreprocessorToken
initializeInt32: anInteger

	type := #'int32'.
	value := anInteger.
%

category: 'Initializing'
method: CPreprocessorToken
initializeInt64: anInteger

	type := #'int64'.
	value := anInteger.
%

category: 'Initializing'
method: CPreprocessorToken
initializeNumber: aNumber

	type := #'number'.
	value := aNumber.
%

category: 'Initializing'
method: CPreprocessorToken
initializePunctuator: aString

	type := #'punctuator'.
	value := aString.
%

category: 'Initializing'
method: CPreprocessorToken
initializeStream: aStream filename: aString line: anInteger singleLogicalLine: aBoolean
		"The return value from the class-side method will be what this method returns, not always a new object"
	| isBeginningOfLine char1 char2 |
	file := aStream file ifNil:[ aString ].
  stream := aStream . "save for debugging"
	line := anInteger.
  cppMType := aStream cppArchMType ifNil:[ 0 ] .
	source := String new.
  startCommentOffset := aStream position max: 1 .
  cppMType ~~ 0 ifTrue:[ (self skipCppDebugInfo: aStream ) ifNil:[ ^ nil ]].
	isBeginningOfLine := self isBeginningOfLineFor: aStream.
	aBoolean
		ifTrue: [self skipSingleLogicalLineCommentsInStream: aStream ifNothingFound: [^nil]]
		ifFalse:[ self skipMultipleBlankLinesAndCommentsInStream: aStream].
  startOffset := aStream position .
  (char1 := self peekFrom: aStream) == nil  ifTrue: [^nil].
	char2 := aStream peek2.

	(char1 == $L and: [char2 == $']) ifTrue: [self readWideCharacterFrom: aStream] ifFalse: [
	(char1 == $L and: [char2 == $"]) ifTrue: [self readWideStringFrom: aStream] ifFalse: [
	char1 isLetter	ifTrue: [	self readIdentifierFrom: aStream] ifFalse: [
	char1 == $_	ifTrue: [	self readIdentifierFrom: aStream] ifFalse: [
	char1 == $" 	ifTrue: [	self readStringFrom: aStream] ifFalse: [
	char1 == $' 	ifTrue: [	self readCharacterFrom: aStream] ifFalse: [
  char1 == $#   ifTrue: [ self readHashFrom: aStream isBeginningOfLine: isBeginningOfLine]
               ifFalse: [
  char1 isDigit   ifTrue: [ self readNumberFrom: aStream] ifFalse: [
                  self readPunctuatorFrom: aStream]]]]]]]].
	"Include trailing comments starting on this line with the source for this token"
	self skipCommentsIn: aStream.
  endOffset := aStream position .
  aStream debug ifNotNil:[
    debugBytes := aStream collection copyFrom: startCommentOffset to: endOffset - 1 .
  ].
%

category: 'Initializing'
method: CPreprocessorToken
initializeString: aString

	type := #'string'.
	value := aString.
%

category: 'Initializing'
method: CPreprocessorToken
initializeUInt16: anInteger

	type := #'uint16'.
	value := anInteger.
%

category: 'Initializing'
method: CPreprocessorToken
initializeUInt32: anInteger

	type := #'uint32'.
	value := anInteger.
%

category: 'Initializing'
method: CPreprocessorToken
initializeUInt64: anInteger

	type := #'uint64'.
	value := anInteger.
%

category: 'Testing'
method: CPreprocessorToken
isAttributeIdentifierToken

	^type == #'identifier' and: [value = '__attribute__'].
%

category: 'other'
method: CPreprocessorToken
isBeginningOfLineFor: aStream

	aStream atBeginning ifTrue: [^true].
	^aStream peek == Character lf.
%

category: 'Testing'
method: CPreprocessorToken
isCloseAngleBracketToken

	^type == #'punctuator' and: [value = '>'].
%

category: 'Testing'
method: CPreprocessorToken
isCloseCurlyBracketToken

	^type == #'punctuator' and: [value = '}'].
%

category: 'Testing'
method: CPreprocessorToken
isCloseParenthesisToken

	^type == #'punctuator' and: [value = ')'].
%

category: 'Testing'
method: CPreprocessorToken
isCloseSquareBracketToken

	^type == #'punctuator' and: [value = ']'].
%

category: 'Testing'
method: CPreprocessorToken
isColonToken

	^type == #'punctuator' and: [value = ':'].
%

category: 'Testing'
method: CPreprocessorToken
isCommaToken

	^type == #'punctuator' and: [value = ','].
%

category: 'Testing'
method: CPreprocessorToken
isConcatenationToken

	^type == #'concatenation'.
%

category: 'Testing'
method: CPreprocessorToken
isConditionalBeginDirective

	| list |
	list := #('if' 'ifdef' 'ifndef').
	^type == #'directive' and: [list includes: value].
%

category: 'Testing'
method: CPreprocessorToken
isConditionalDirective

	| list |
	list := #('if' 'else' 'endif' 'ifdef' 'ifndef' 'elif').
	^type == #'directive' and: [list includes: value].
%

category: 'Testing'
method: CPreprocessorToken
isConditionalEndDirective

	| list |
	list := #('else' 'endif' 'elif').
	^type == #'directive' and: [list includes: value].
%

category: 'Testing'
method: CPreprocessorToken
isDefinedIdentifierToken

	^type == #'identifier' and: [value = 'defined'].
%

category: 'Testing'
method: CPreprocessorToken
isDirectiveToken

	^type == #'directive'.
%

category: 'Testing'
method: CPreprocessorToken
isDotToken

	^type == #'punctuator' and: [value = '.'].
%

category: 'Testing'
method: CPreprocessorToken
isEmptyToken

	^type == #'empty'.
%

category: 'Testing'
method: CPreprocessorToken
isEndifDirective

	^type == #'directive' and: [value = 'endif'].
%

category: 'Testing'
method: CPreprocessorToken
isEqualsToken

	^type == #'punctuator' and: [value = '='].
%

category: 'Testing'
method: CPreprocessorToken
isExtensionIdentifierToken

	^type == #'identifier' and: [value = '__extension__'].
%

category: 'Testing'
method: CPreprocessorToken
isFunctionLikeMacroDefinition

	^type == #'define' and: [value isKindOf: Array].
%

category: 'Testing'
method: CPreprocessorToken
isHashToken

	^type == #'punctuator' and: [value = '#'].
%

category: 'Testing'
method: CPreprocessorToken
isIdentifierToken

	^type == #'identifier'.
%

category: 'Testing'
method: CPreprocessorToken
isIntegerToken

	^#(#int16 #int32) includes: type
%

category: 'Testing'
method: CPreprocessorToken
isOpenAngleBracketToken

	^type == #'punctuator' and: [value = '<'].
%

category: 'Testing'
method: CPreprocessorToken
isOpenCurlyBracketToken

	^type == #'punctuator' and: [value = '{'].
%

category: 'Testing'
method: CPreprocessorToken
isOpenParenthesisToken

	^type == #'punctuator' and: [value = '('].
%

category: 'Testing'
method: CPreprocessorToken
isOpenSquareBracketToken

	^type == #'punctuator' and: [value = '['].
%

category: 'Testing'
method: CPreprocessorToken
isPunctuatorToken

	^type == #'punctuator'.
%

category: 'Testing'
method: CPreprocessorToken
isReservedWord

	^#(
		'__float128'
		'_Complex'
		'auto'
		'break'
		'case'
		'char'
		'const'
		'continue'
		'default'
		'do'
		'double'
		'else'
		'entry'
		'extern'
		'float'
		'for'
		'goto'
		'if'
		'int'
		'enum'
		'long'
		'register'
		'return'
		'short'
		'signed'
		"'sizeof'"		"this should be followed by a parenthesis"
		'static'
		'struct'
		'switch'
		'typedef'
		'union'
		'unsigned'
		'void'
		'volatile'
		'while'
	) includes: value.
%

category: 'Testing'
method: CPreprocessorToken
isSemicolonToken

	^type == #'punctuator' and: [value = ';'].
%

category: 'Testing'
method: CPreprocessorToken
isStarToken

	^type == #'punctuator' and: [value = '*'].
%

category: 'Testing'
method: CPreprocessorToken
isStringToken

	^type == #'string'.
%

category: 'Testing'
method: CPreprocessorToken
isStructIdentifierToken

	^type == #'identifier' and: [value = 'struct'].
%

category: 'Testing'
method: CPreprocessorToken
isTildeToken

	^type == #'punctuator' and: [value = '~'].
%

category: 'Testing'
method: CPreprocessorToken
isUpArrowToken

	^type == #'punctuator' and: [value = '^'].
%

category: 'other'
method: CPreprocessorToken
key

	^type.
%

category: 'Accessing'
method: CPreprocessorToken
line

	^ line
%

category: 'Reading'
method: CPreprocessorToken
octalCharacterFrom: aStream
	"Enter with pointing to '0' of '\0ooo'"

	| string |
	string := String withAll: '8r0'.
	[true] whileTrue: [
		| char |
		char := self peekFrom: aStream.
		(string size < 6 and: [char isDigit]) ifFalse: [
			value add: (Character codePoint: (Integer fromString: string)).
			^self.
		].
		string add: char.
		source add: aStream next.
	].
%

category: 'Accessing'
method: CPreprocessorToken
peek
	"In order to distinguish a function-like macro definition from
	an object-like macro definition that begins with an open parenthesis,
	we need to know if there was any whitespace after the identifier.

	# define foo(bar)		/* a function-like macro */
	# define foo (bar)	/* an object-like macro */
"
	^peek
%

category: 'other'
method: CPreprocessorToken
peekFrom: aStream
	"Give back the next non-mergeLine token; does not skip whitespace, does not skip comments"

	| char1 char2 char3 lf cr |
	(char1 := aStream peek) == nil  ifTrue:[ ^ nil ].
	char1 == $\ ifFalse: [^char1].
	(char2 := aStream peek2) == nil  ifTrue:[ ^ $\  ].
	lf := Character lf .
	cr := Character cr .
	(char2 == cr or: [char2 == lf]) ifFalse:[ ^ $\ ].
	"$\ was followed by CR or LF"
	source
		add: aStream next;
		add: aStream next.
	(char3 := aStream peek) == nil  ifTrue: [^nil].
	(char2 ~~ char3 and: [char3 == cr or: [char3 == lf]]) ifFalse: [^char3].
	^self peekFrom: aStream.
%

category: 'Printing'
method: CPreprocessorToken
positionString
  | str |
  (str := ' at line ' copy)
    add: line asString ;
    add: ' in file ' ; add: file asString .
  ^ str
%

category: 'other'
method: CPreprocessorToken
printOn: aStream

	(source == nil  or: [source isEmpty]) ifTrue: [
		type printOn: aStream.
		aStream nextPutAll: ' -> '.
		value printOn: aStream.
	] ifFalse: [
		aStream nextPutAll: source.
	].
%

category: 'Reading'
method: CPreprocessorToken
readCharacterFrom: aStream

	type := #'uint8'.
	self
		readLiteralUpTo: $'
		from: aStream.
	255 < (value := value first codePoint) ifTrue: [self error: 'Should be wide character!'].
%

category: 'other'
method: CPreprocessorToken
readDebugFileNameFrom: aStream
  | ch fn lf |
  fn := String new .
  lf := Character lf .
  [ ch := aStream peek .
    ch == $" or:[ch == lf]
  ] whileFalse:[
    aStream next
  ].
  ch == lf ifTrue:[ ^ fn ].
  aStream next . "consume double quote char"
  [ | endOfFn |
    ch := aStream next .
    (endOfFn := ch == $" or:[ ch == lf]) ifFalse:[ fn add: ch ].
    endOfFn
  ] whileFalse .
  aStream file: fn .
  ^ fn
%

category: 'other'
method: CPreprocessorToken
readDebugLineNumberFrom: aStream
  | ch n zeroCp |
  n := 0 .
  zeroCp := $0 codePoint .
  [ ch := aStream peek .
    (ch >= $0 and:[ ch <= $9 ])
  ] whileTrue:[
    n := (n * 10) + (ch codePoint - zeroCp) .
    aStream next
  ].
  aStream line: n .
  ^ n
%

category: 'Reading'
method: CPreprocessorToken
readHashFrom: aStream isBeginningOfLine: aBoolean
	| char |
	source add: aStream next.	"$#"
	(char := self peekFrom: aStream) == $# ifTrue: [	"## means to merge adjacent tokens"
		source add: aStream next.
		type := #'concatenation'.
		^self.
	].
	aBoolean ifFalse: [
		type := #'punctuator'.
		value := '#'.
		^self.
	].
	self
		skipCommentsIn: aStream;
		readIdentifierFrom: aStream .
	type := #'directive'.
	value isEmpty ifTrue: [self error: 'Missing preprocessor directive'].
%

category: 'Reading'
method: CPreprocessorToken
readIdentifierFrom: aStream

	|  char |
	type := #'identifier'.
	value := String new.
	[
		char := self peekFrom: aStream.
		char ~~ nil  and: [char isAlphaNumeric or: [char == $_ or: [char == $: and: [aStream peek2 == $: or: [value last == $:]]]]].
	] whileTrue: [
		value add: aStream next.
	].
	peek := aStream peek.		"Curious to know if it is an open parenthesis"
	source add: value.
%

category: 'Reading'
method: CPreprocessorToken
readLiteralUpTo: aCharacter from: aStream

	| char lf |
	source add: aStream next.	"The open quote character"
	value := String new.
  lf := Character lf .
	[
		(char := aStream next) == lf ifTrue: [self error: 'End of literal not found on current line!'].
		source add: char.
		char = aCharacter.
	] whileFalse: [
		char == $\ ifTrue: [
			source add: (char := aStream next).
			char == $a 	ifTrue: [value add: (Character codePoint: 7	)	] ifFalse: [		"\a 	= alert, <Ctrl>+<G>"
			char == $b 	ifTrue: [value add: (Character codePoint: 8	)	] ifFalse: [		"\b 	= backspace, <Ctrl>+<H>"
			char == $f	ifTrue: [value add: (Character codePoint: 12	)	] ifFalse: [		"\f 	= form feed, <Ctrl>+<L>"
			char == $n	ifTrue: [value add: (Character codePoint: 13	)	] ifFalse: [		"\n 	= new line, <Ctrl>+<M>"
			char == $r	ifTrue: [value add: (Character codePoint: 10	)	] ifFalse: [		"\r 	= carriage return, <Ctrl>+<J>"
			char == $t	ifTrue: [value add: (Character codePoint: 9	)	] ifFalse: [		"\t 	= horizontal tab, <Ctrl>+<I>"
			char == $v	ifTrue: [value add: (Character codePoint: 11	)	] ifFalse: [		"\v 	= vertical tab, <Ctrl>+<K>"
			char == $x	ifTrue: [self hexCharacterFrom: aStream			] ifFalse: [		"\xdd = hex number"
			char == $0	ifTrue: [self octalCharacterFrom: aStream		] ifFalse: [		"\0ddd	= octal number"
			char == $'	ifTrue: [value add: char									] ifFalse: [		"\'		= single quote"
			char == $"	ifTrue: [value add: char									] ifFalse: [		"""		= double quote"
			char == $?	ifTrue: [value add: char									] ifFalse: [		"?		= question mark"
			char == $\	ifTrue: [value add: char									] ifFalse: [		"\\		= single backslash"
			]]]]]]]]]]]]].
		] ifFalse: [
			value add: char.
		].
	].
%

category: 'Reading'
method: CPreprocessorToken
readNumberFrom: aStream
"A preprocessing number has a rather bizarre definition. The category includes all the
normal integer and floating point constants one expects of C, but also a number of other
things one might not initially recognize as a number. Formally, preprocessing numbers begin
with an optional period, a required decimal digit, and then continue with any sequence of
letters, digits, underscores, periods, and exponents.
Exponents are the two-character sequences `e+', `e-', `E+', `E-', `p+', `p-', `P+', and `P-'.
(The exponents that begin with `p' or `P' are new to C99.
They are used for hexadecimal floating-point constants.)"

	| char string isLong isUnsigned |
	type := #'number'.
	value := String with: (source add: aStream next).
	[
		aStream atEnd not and: [
			char := self peekFrom: aStream.
			char isAlphaNumeric or: [char == $. or: [char == $_ or: [(char == $+ or: [char == $-]) and: ['eEpP' includes: value last]]]].
		].
	] whileTrue: [
		value add: (source add: aStream next).
	].
	isLong := false.
	isUnsigned := false.
	(2 < value size and: [(value at: 1) == $0 and: [(value at: 2) == $x ]]) ifTrue: [
		string := '16r' , (value copyFrom: 3 to: value size).
	] ifFalse: [
		value first == $0 ifTrue: [
			string := '8r' , value.
		] ifFalse: [
			string := value.
		].
	].
	('lL' includes: string last) ifTrue: [
		isLong := true.
		string := string copyFrom: 1 to: string size - 1.
	].
	('uU' includes: string last) ifTrue: [
		isUnsigned := true.
		string := string copyFrom: 1 to: string size - 1.
		('lL' includes: string last) ifTrue: [
			isLong := true.
			string := string copyFrom: 1 to: string size - 1.
		].
	].
	value := Integer fromString: string.
	(value class ~~ SmallInteger and: [16rFFFFFFFFFFFFFFFF < value]) ifTrue:[
     self error:'constant exceeds 64 bit unsigned integer'.
  ].
	type := (isLong or: [16rFFFFFFFF < value]) ifTrue: [
		(isUnsigned or: [16r7FFFFFFFFFFFFFFF < value])
			ifTrue: [#'uint64']
			ifFalse: [#'int64'].
	] ifFalse: [
		16rFFFF < value ifTrue: [
			(isUnsigned or: [16r7FFFFFFF < value])
				ifTrue: [#'uint32']
				ifFalse: [#'int32'].
		] ifFalse: [
			(isUnsigned or: [16r7FFF < value])
				ifTrue: [#'uint16']
				ifFalse: [#'int16'].
		].
	].
%

category: 'Reading'
method: CPreprocessorToken
readPunctuatorFrom: aStream

	| char1 char2 char3 twoChars threeChars |
	type := #'punctuator'.
	source add: (char1 := aStream next).
	value := String with: char1.
	(char2 := aStream peek) == nil  ifTrue: [^self].
	(char3 := aStream peek2) == nil  ifTrue: [
		(twoChars := value copy) add: char2 .
	] ifFalse: [
		(twoChars := value copy) add: char2 .
		(threeChars := twoChars copy) add: char3 .
	].
	(#('<<=' '>>=' '->*') includes: threeChars) ifTrue: [
		value := threeChars.
		source add: char2; add: char3.
		aStream next; next.
		^self.
	].
	(#('++' '--' '==' '!=' '<=' '>=' '&&' '||' '<<' '>>' '+=' '-=' '*=' '/=' '%=' '&=' '|=' '^=' '->' '.*' '::') includes: twoChars) ifTrue: [
		value := twoChars.
		source add: char2.
		aStream next.
	].
%

category: 'Reading'
method: CPreprocessorToken
readStringFrom: aStream

	type := #'string'.
	self
		readLiteralUpTo: $"
		from: aStream.
%

category: 'Reading'
method: CPreprocessorToken
readWideCharacterFrom: aStream
		"#define __WCHAR_MAX__ 2147483647"

	(source add: aStream next) == $L ifFalse: [self error: 'How did we get here!?'].
	type := #'int32'.
	self
		readLiteralUpTo: $'
		from: aStream.
	16r7FFFFFFF < (value := value first codePoint) ifTrue: [self error: 'Should be wide character!'].
%

category: 'Reading'
method: CPreprocessorToken
readWideStringFrom: aStream

	(source add: aStream next) == $L ifFalse: [self error: 'How did we get here!?'].
	type := #'string'.
	self
		readLiteralUpTo: $"
		from: aStream.
%

category: 'other'
method: CPreprocessorToken
replaceFirst: aToken
	file := aToken file.
  stream := aToken stream .
	line := aToken line.
	source := aToken source.
%

category: 'other'
method: CPreprocessorToken
replaceOther: aToken
	file := aToken file.
  stream := aToken stream .
	line := aToken line.
	source := ''.
%

category: 'other'
method: CPreprocessorToken
setValueToArrayWithEmptyToken

	value := { self class empty }.
%

category: 'other'
method: CPreprocessorToken
skipBlockCommentsIn: aStream
	| char lf |
	source add: aStream next.	"This should be the $* following the $/"
  lf := Character lf .
	[
		source add: (char := aStream next).
		char == lf ifTrue:[ line := line + 1  ].
		char == $* and: [(self peekFrom: aStream) == $/ ].
	] whileFalse: [].
	source add: aStream next.	"This should be the $/ following the $*"
	^self skipCommentsIn: aStream.
%

category: 'other'
method: CPreprocessorToken
skipCommentsIn: aStream
		"answer true if came to end-of-line, otherwise false"
	| char position lf |
  lf := Character lf .
	[
		(char := aStream peek) ~~ nil  and: [char isSeparator].
	] whileTrue: [
		char == lf ifTrue:[
      ^true
    ].
		source add: aStream next.
	].
	char == $/ ifFalse: [^false].
	position := aStream position.
	source add: aStream next.
	char := self peekFrom: aStream.
	char == $* ifTrue: [^self skipBlockCommentsIn: aStream].
	char == $/ ifTrue: [^self skipLineCommentsIn: aStream].
	source size: source size - 1.
	aStream position: position.
	^false.
%

category: 'other'
method: CPreprocessorToken
skipCppDebugInfo: aStream
  "Skip consecutive # <integer> <fileName> debuginfo lines from /usr/bin/cpp output .
   (AIX skip #line integer fileName)
   Skip #pragma lines from clang output .
   Returns nil if EOF, true if one or more lines skipped, false otherwise ."
  | char1 char2 px cx lf skipped |
  skipped := false .
  lf := Character lf .
 	[ | isDebug |
    [ char1 := self peekFrom: aStream .
      char1 == lf
    ] whileTrue:[
      aStream next.  "skip empty line"
      skipped := true .
      line := line + 1 .
    ].
    char1 ifNil:[ ^ nil ].
	  char2 := aStream peek2.
    (char1 == lf and:[ char2 == nil]) ifTrue:[ ^ nil ].
    isDebug := false .
    char1 == $# ifTrue:[
	    (char2 == $   ""
      and:[ (px := aStream position + 3) < (cx := aStream collection) size
      and:[  (cx at: px) isDigit ]]) ifTrue:[
         isDebug := true  " a # <int> <filename> line " .
         aStream next ; next. "consume char1, char2"
      ].
      (cppMType == 9 and:[ (aStream peekN: 6) = '#line ']) ifTrue:[ "#line from AIX cpp only"
         6 timesRepeat:[ aStream next ]. "consume '#line ' "
         isDebug := true  " a # <int> <filename> line " .
      ].
      isDebug ifTrue:[
        line := self readDebugLineNumberFrom: aStream .
        file := self readDebugFileNameFrom: aStream .
        cppMType == 9 ifTrue:[ | key |
          key := #GemStone_CPreprocessor_lastFile .
          file size == 0 ifTrue:[ "#line <int>  with no file name  , use last file name seen"
            file := (SessionTemps current at: key otherwise: '') copy
          ] ifFalse: [
            SessionTemps current at: key put: file copy .
          ].
        ].
      ] ifFalse:[
        "clang preprocessor produces #pragma lines on Darwin"
        char2 == $p ifTrue:[ | pStr |
          pStr := '#pragma' .
          (aStream peekN: pStr size ) = pStr ifTrue:[
            isDebug := true .
            [
              (self peekFrom: aStream ) == lf
            ] whileFalse:[
              aStream next.  "skip #pragma line"
              line := line + 1 .
            ].
          ].
        ].
      ].
    ].
    isDebug
  ] whileTrue:[
    skipped := true .  "skip to end of a debug info line"
    [aStream next == lf ] whileFalse .
    "line := line + 1 " "don't count debuginfo line"
  ].
  ^ skipped
%

category: 'other'
method: CPreprocessorToken
skipLineCommentsIn: aStream
  | lf |
	source add: aStream next.	"This should be the $/ following the $/"
  lf := Character lf .
	[
		aStream peek == lf
	] whileFalse: [
		source add: aStream next.
	].
	^true.
%

category: 'other'
method: CPreprocessorToken
skipMultipleBlankLinesAndCommentsInStream: aStream
cppMType ~~ 0 ifTrue:[
  [ | skipped |
    skipped := false .
	  [
		  [
			  self skipCommentsIn: aStream.
		  ] whileTrue: [
			  source add: aStream next.
        skipped := true .
		  ].
		  aStream peek == $\ .
	  ] whileTrue: [
		  source add: aStream next.  "line concatenation"
      skipped := true .
	  ].
    skipped ifTrue:[ skipped := self skipCppDebugInfo: aStream ].
    skipped == true
  ] whileTrue.
] ifFalse:[
  [
    [
      self skipCommentsIn: aStream.
    ] whileTrue: [
      line := line + 1.
      source add: aStream next.
    ].
    aStream peek == $\.
  ] whileTrue: [
    source add: aStream next.
  ].
]
%

category: 'other'
method: CPreprocessorToken
skipSingleLogicalLineCommentsInStream: aStream ifNothingFound: aBlock
	"Skip white space and comments on the current line, extending the
	 definition of current for lines ending with a backslash+newline."
  | lf |
	[ (self skipCommentsIn: aStream) == true ifTrue:[ ^ aBlock value ].
	  (self peekFrom: aStream) == $\
       and:[ aStream peek2 == (lf ifNil:[lf :=Character lf]) ]
  ] whileTrue:[
    cppMType ~~ 0 ifFalse:[ line := line + 1 ].
		source add: aStream next.
		source add: aStream next
  ]
%

category: 'Accessing'
method: CPreprocessorToken
source

	source == nil  ifTrue: [^''].
	^source.
%

category: 'Accessing'
method: CPreprocessorToken
stream
  ^ stream
%

category: 'Accessing'
method: CPreprocessorToken
type

	^type.
%

category: 'Accessing'
method: CPreprocessorToken
value

	^value.
%

category: 'other'
method: CPreprocessorToken
value: anObject

	value := anObject.
%

category: 'other'
method: CPreprocessorToken
valueString

	type == #'empty' ifTrue: [^''].
	type == #'identifier' ifTrue: [^value].
	type == #'int16' ifTrue: [^value printString].
	type == #'int32' ifTrue: [^value printString].
	type == #'int64' ifTrue: [^value printString].
	type == #'punctuator' ifTrue: [^value].
	type == #'string' ifTrue: [^'"' , value , '"'].
	type == #'uint16' ifTrue: [^value printString].
	type == #'uint32' ifTrue: [^value printString].
	type == #'uint64' ifTrue: [^value printString].
	self error: 'unrecognized type: ' , type printString.
%

category: 'debug'
method: CPreprocessorToken
_filePosition
  "Returns an Array  { lineNumber . positionInLine } describing the position of
   the receiver in the CPreprocessorStream's input file, 
   based on value of startOffset instVar ."
  | str ofs lNum lf |
  str := stream collection . 
  ofs := 1 .  lf := Character lf .  lNum := 1 .
  1 to: startOffset do:[ :n |
    (str at: n) == lf ifTrue:[ lNum := lNum + 1 . ofs := 1 ]
                     ifFalse:[ ofs := ofs + 1 ].
  ].
  ^ { lNum . ofs }
%

! Class implementation for 'CriticalSection'

!		Class methods for 'CriticalSection'

category: 'Instance Creation'
classmethod: CriticalSection
new
  "Answer a new CriticalSection"
  ^self basicNew _initialize
%

!		Instance methods for 'CriticalSection'

category: 'Blue Book Protocol'
method: CriticalSection
critical: aBlock
  "Wait until no other processes are sending critical to the receiver
   and then execute aBlock and return its value."

  | value activeProcess |
  activeProcess := self _scheduler activeProcess"a primitive".
  (owner == activeProcess) ifFalse: [
    semaphore wait.
    owner := activeProcess.
    value := aBlock ensure: [
      owner := nil.
      semaphore signal.
    ].
  ] ifTrue: [
    value := aBlock value.
  ].
  ^value
%

category: 'Private'
method: CriticalSection
_initialize

  owner := nil.
  semaphore := Semaphore forMutualExclusion.
%

category: 'Private'
method: CriticalSection
_scheduler

"Returns   ProcessorScheduler scheduler "
<primitive: 457>

self _primitiveFailed: #_scheduler
%

! Class implementation for 'DeletedUserProfile'

!		Class methods for 'DeletedUserProfile'

category: 'Instance Creation'
classmethod: DeletedUserProfile
createFrom: aUserProfile

| result |
result := self new .
result userId: aUserProfile userId copy.
result symbolList: aUserProfile symbolList .
result whenDeleted: DateTime now .
^ result
%

!		Instance methods for 'DeletedUserProfile'

category: 'Accessing'
method: DeletedUserProfile
symbolList

   "Return the value of the instance variable 'symbolList'."
   ^symbolList
%

category: 'Updating'
method: DeletedUserProfile
symbolList: newValue

   "Modify the value of the instance variable 'symbolList'."
   symbolList := newValue
%

category: 'Accessing'
method: DeletedUserProfile
userId

   "Return the value of the instance variable 'userId'."
   ^userId
%

category: 'Updating'
method: DeletedUserProfile
userId: newValue

   "Modify the value of the instance variable 'userId'."
   userId := newValue
%

category: 'Accessing'
method: DeletedUserProfile
whenDeleted

   "Return the value of the instance variable 'whenDeleted'."
   ^whenDeleted
%

category: 'Updating'
method: DeletedUserProfile
whenDeleted: newValue

   "Modify the value of the instance variable 'whenDeleted'."
   whenDeleted := newValue
%

! Class implementation for 'GciInterface'

!		Class methods for 'GciInterface'

category: 'Instance Creation'
classmethod: GciInterface
basicNew
"disallowed"

self shouldNotImplement: #basicNew
%

category: 'Instance Creation'
classmethod: GciInterface
new

"Create a new initialized instance."

^ self _basicNew initialize.
%

category: 'Instance Creation'
classmethod: GciInterface
newFromId: id

| result |

"Create a new initialized instance."

result := self _basicNew initialize.
result _sessionId: id.
^result
%

category: 'Prims'
classmethod: GciInterface
sessions

"Return an Array listing all of the active session ids"

^self _zeroArgPrim: 42
%

category: 'Instance Creation'
classmethod: GciInterface
_basicNew

"creates an instance registered with VM for finalization of cData"

<primitive: 674>
^ self _primitiveFailed: #_basicNew
%

category: 'Prims'
classmethod: GciInterface
_objectForOop: oop

"Return the object with the given oop.  If no object exists with this oop,
 return nil."

<primitive: 38>
self _primitiveFailed: #_objectForOop: args: { oop }
%

category: 'Prims'
classmethod: GciInterface
_oopForObject: anObject

"Return the oop for the given object."
^ anObject asOop
%

category: 'Prims'
classmethod: GciInterface
_zeroArgPrim: opcode

"Primitive dispatch.  Legal values are:
    42: GciInterface (C) | sessions
"

<primitive: 197>

^self _primitiveFailed: #_zeroArgPrim: args: { opcode }
%

!		Instance methods for 'GciInterface'

category: 'Public'
method: GciInterface
abort

"Abort the transaction in the remote repository."

trace
  ifTrue: [ self record: 'abort' ].

^ self _zeroArgPrim: 36
%

category: 'Primitives'
method: GciInterface
alteredObjects: alteredObjArray

"Invoke the GciAlteredObjs function.

 The function result of GciAlteredObjs is the method result
 and is saved in lastResult. (changed  in v3.0.1) "

| str result trc |

(trc := trace)
  ifTrue: [ str := String new add: 'alteredObjs: '; yourself ].

result :=  self _twoArgPrim: 4 with: alteredObjArray with: nil.
trc ifTrue: [
    str add: ' returned '; add: result asString.
    self record: str
  ].

^ result
%

category: 'Primitives'
method: GciInterface
callInProgress

"Return whether there is a call in progress in the execution thread in the
remote repository."

trace ifTrue: [
    self record:
      (String new add: sessionId asString; add: ' callInProgress'; yourself)
  ].

^ self _zeroArgPrim: 39
%

category: 'Primitives'
method: GciInterface
clearStack: processOop

"Clear the stack of Smalltalk execution in the remote repository."

trace ifTrue: [
    self record:
      (String new add: sessionId asString; add: ' clearStack'; yourself)
  ].
^ self _oneArgPrim: 21 with: processOop
%

category: 'Public'
method: GciInterface
commit

"Commit the transaction in the remote repository."

trace
  ifTrue: [ self record: 'commit' ].

^ self _zeroArgPrim: 34
%

category: 'Primitives'
method: GciInterface
continueWith: processOop
replaceTopOfStackWith: replaceOop
isSpecial: isSpecial
flags: flags

"Invoke the GciContinueWith function.
If replaceOop == nil and isSpecial is false, then use OOP_ILLEGAL as the
replaceOop (which means the evaluation stack is not changed) .

Returns nil if an error occurs, or the execution result if execution
completes. (change in v3.0.1)"

| str result trc |
(trc := trace) ifTrue: [
    str := String new
	add: 'continueWith ['; add: replaceOop asString; add: '] '; yourself
  ].
result := self _fourArgPrim: 1
    with: processOop
    with: replaceOop
    with: isSpecial
    with: flags.
trc ifTrue: [
    str add: ' returned '; add: result asString.
    self record: str
  ].
^ result
%

category: 'Primitives'
method: GciInterface
dirtyObjsInit

"Execute GciDirtyObjsInit."

trace
  ifTrue: [
    self record:
      (String new add: sessionId asString; add: ' dirtyObjsInit'; yourself)
  ].

^ self _zeroArgPrim: 32
%

category: 'Tracing'
method: GciInterface
disableTracing

"Enable tracing of commands issued to the subordinate gem to be logged to
a file."

trace
  ifFalse: [ ^ false ].

trace := false.
log close.
^ false
%

category: 'Tracing'
method: GciInterface
enableFileTracing: filename

"Enable tracing of commands issued to the subordinate gem to be logged to
a file."

trace
  ifTrue: [ ^ true ].

trace := true.

log := GsFile open: filename mode: 'a'.

log addAll: 'Tracing enabled at ';
  addAll: DateTime now asString; lf; flush.
^ true
%

category: 'Accessing'
method: GciInterface
errorClass

   "Return the value of the instance variable 'errorClass'."
   ^errorClass
%

category: 'Updating'
method: GciInterface
errorClass: newValue

   "Modify the value of the instance variable 'errorClass'."
  (newValue isSubclassOf: ErrorDescription)
    ifFalse: [
      self _error: #objErrConstraintViolation
        args: { newValue . ErrorDescription class . newValue class }
    ].
   errorClass := newValue
%

category: 'Accessing'
method: GciInterface
getAndClearLastError

"Return the value of lastError and clear it."

| result |
result := lastError.
lastError := nil.
^ result
%

category: 'Primitives'
method: GciInterface
getFreeOops: num

"Return an array of free remote oops from the subordinate gem.
This method will return a maximum of 2000 free oops.  You must
make multiple calls to receive more."

trace ifTrue: [ | str |
    str := String new.
    str add: 'getFreeOops: '; add: num asString.
    self record: str
  ].

^ self _oneArgPrim: 19 with: num
%

category: 'Primitives'
method: GciInterface
hardBreak

"Send a hard break to interrupt execution in the remote repository."

trace ifTrue: [
    self record:
      (String new add: sessionId asString; add: ' hardBreak'; yourself)
  ].

^ self _zeroArgPrim: 43
%

category: 'Initialization'
method: GciInterface
initialize

"Initialize the instance variables of the receiver."

trace := false.
sessionId := 0. "GCI_INVALID_SESSION_ID"
errorClass := ErrorDescription.
lastResult := _remoteNil.
^ self
%

category: 'Accessing'
method: GciInterface
lastError

   "If the most recent remote operation did not succeed due to an error,
    answer an ErrorDescription. Otherwise answer nil."
   ^lastError
%

category: 'Accessing'
method: GciInterface
lastErrorString
 
   "If the most recent remote operation did not succeed due to an error,
    answer an ErrorDescription. Otherwise answer nil."
   ^ lastError printString
%

category: 'Accessing'
method: GciInterface
lastResult

   "Answer the result of the most recent remote operation.
    This will be a remote oop unless #resultIsSpecial answers true."
   ^lastResult
%

category: 'Accessing'
method: GciInterface
lastResultAsOop
  "return an Integer , the oop of the last result.
  If last result is undefined,  276 (oop of _remoteNil) is returned"
  | rs |
  (rs := resultIsSpecial) ifNil:[ ^ lastResult asOop ].
  rs == true ifTrue:[ ^ lastResult asOop ].
  ^ lastResult
%

category: 'Accessing'
method: GciInterface
log

   "Return the value of the instance variable 'log'."
   ^log
%

category: 'Public'
method: GciInterface
login: aGemStoneParameters andExecute: aString ifFailure: aBlock

"Login to the remote repository using the given parameters.  If login is
successful, return the remote oop of the result of execution of the given
string.  If the login fails or the executed block generates an error (which
in turn will cause the session to be logged out), execute the zero argument
block (if the block is nil, raise an error)."

| str gsName result trc |

aGemStoneParameters remoteRepository == nil
  ifFalse: [ gsName := aGemStoneParameters remoteRepository gemStoneName]
  ifTrue:  [ gsName := aGemStoneParameters gemStoneName].

(trc := trace) ifTrue: [
    str := String new add: 'Logging in to '; add: gsName;
      add: ' as '; add: aGemStoneParameters username; yourself.
    self record: str
  ].

" login and execute some code "
result := self login: aGemStoneParameters execute: aString.

" when successful, result is a remote oop (an Integer) "
result == _remoteNil ifTrue: [
    aBlock == nil
      ifTrue: [ self _errorLoginFailed ]
      ifFalse: [
        ^ aBlock value
      ]
  ].
(trc and: [ aString ~~ nil ])
  ifTrue: [ self record: 'Login successful.'; record: aString ].

^ result
%

category: 'Primitives'
method: GciInterface
login: aGemStoneParameters
execute: aString

"Login to a GemStone server with the given parameters, and execute
the given string.  The execution string may be nil.  If the result of execution
is _remoteNil, this will immediately logout.  If any error occurs during login
or remote string execution, this will return _remoteNil; otherwise it returns
the remote oop of the result of execution."

^ self _twoArgPrim: 8
    with: aGemStoneParameters
    with: aString
%

category: 'Primitives'
method: GciInterface
login: aGemStoneParameters flags: flagsInt

"Login to a GemStone server with the given parameters.
  flagsInt should be result of GemStoneParameters >> loginFlags . 
 If successful, returns true ."


^ self _twoArgPrim: 10
    with: aGemStoneParameters
    with: flagsInt
%

category: 'Public'
method: GciInterface
logout

"Terminate the communication with a subordinate gem."

trace ifTrue: [
    self record: 'Logging out'.
    self disableTracing.
  ].
^ self _zeroArgPrim: 33
%

category: 'Primitives - Trav'
method: GciInterface
moreTraversal: cBuff

"Continue a traversal from a previous operation.  The returned value will
be a TraversalBuffer.  The argument cBuff should be an instance of
TraversalBuffer"

| result |
trace ifTrue: [
    self record:
      (String new add: sessionId asString; add: ' moreTraversal'; yourself)
  ].
result :=  self _oneArgPrim: 18 with: cBuff.
^ result
%

category: 'Primitives - NB'
method: GciInterface
nbAbort

"Non-blocking abort of the transaction in the remote repository."

trace
  ifTrue: [
    self record:
      (String new add: sessionId asString; add: ' nbAbort'; yourself)
  ].

^ self _zeroArgPrim: 37
%

category: 'Primitives - NB'
method: GciInterface
nbCommit

"Non-blocking commit of the transaction in the remote repository."

trace
  ifTrue: [
    self record:
      (String new add: sessionId asString; add: ' nbCommit'; yourself)
  ].

^ self _zeroArgPrim: 35
%

category: 'Primitives - NB'
method: GciInterface
nbEnd: returnType

"Test the status of a non-blocking call in progress.
The return type indicates if the non-blocking call will return
an OopType (1) or a BoolType (2).

Returns
  -1 if GCI_RESULT_NOT_READY
  0 if GCI_RESULT_PROGRESSED
  1 if GCI_RESULT_READY
  nil if an error occurred

After obtaining GCI_RESULT_READY, send lastResult or lastResultAsOop
to obtain the result.
"

| result str |
result := self _oneArgPrim: 20 with: returnType.
trace ifTrue: [
    str := String new.
    str add: sessionId asString; add: ' NB end - '.

    result == -1
      ifTrue: [ " self record: str , 'GCI_RESULT_NOT_READY' " ]
      ifFalse: [
        result == 0
          ifTrue: [ str add: 'GCI_RESULT_PROGRESSED' ]
          ifFalse: [
            result == 1
              ifTrue: [ str add: 'GCI_RESULT_READY : returned '; add: result asString ]
              ifFalse: [ str add: 'unknown NbEnd result: '; add: result asString ]
          ].
        self record: str
      ]
  ].

^ result
%

category: 'Primitives - NB'
method: GciInterface
nbEndBoolean

"cover for nbEnd:"

^self nbEnd: 2
%

category: 'Primitives - NB'
method: GciInterface
nbEndOop

"cover for nbEnd:"

^self nbEnd: 1
%

category: 'Primitives - NB'
method: GciInterface
nbEndTraversal

"cover for nbEnd:"

^self nbEnd: 2
%

category: 'Primitives'
method: GciInterface
nbLogin: aGemStoneParameters
  ^ self nbLogin: aGemStoneParameters flags: 0
%

category: 'Primitives'
method: GciInterface
nbLogin: aGemStoneParameters flags: flagsInt

"Invoke the GciNbLoginEx function.  flagsInt is per GCI_LOGIN_* bits defined
 in gci.ht. GCI_LOGIN_PW_ENCRYPTED and GCI_LOGIN_IS_SUBORDINATE
 are always ORed with the user provided flags before calling GciNbLoginEx."

^ self _twoArgPrim: 9 with: aGemStoneParameters with: flagsInt
%

category: 'Primitives - NB'
method: GciInterface
nbMoreTraversal: cBuff

"Non-blocking more traversal.
 The argument cBuff should be an instance of TraversalBuffer."

trace
  ifTrue: [
    self record:
      (String new add: sessionId asString; add: ' nbMoreTraversal'; yourself)
  ].

^ self _oneArgPrim: 23 with: cBuff
%

category: 'Primitives - NB'
method: GciInterface
nbRemoteExecute: aString

"Execute the given string and return the result of execution.
Returns nil if there was an error, else returns receiver.
Use nbEnd* and lastResult methods to obtain the remote result."


trace
  ifTrue: [
    self record:
      (String new add: sessionId asString; add: ' nbRemoteExecute:';
        add: aString; yourself)
  ].

^ self _oneArgPrim: 22 with: aString
%

category: 'Primitives - NB'
method: GciInterface
nbRemotePerform: remoteOop selector: selector args: args

"Sends the given selector to the object in a remote repository with the given
remote oop.  The arg array is an array of pairs: either a remote oop or special,
and a boolean indicating whether the arg is special or not, TRUE if the arg
is a remote oop, FALSE if it is special.
Returns nil if there was an error, else returns receiver.
Use nbEnd* and lastResult methods to obtain the remote result."

trace
  ifTrue: [
    self record: (String new add: sessionId asString;
      add: ' nbRemotePerform ['; add: remoteOop asString;
      add: '] '; add: selector; yourself)
  ].

^ self _threeArgPrim: 3
    with: remoteOop
    with: selector
    with: args
%

category: 'Primitives'
method: GciInterface
notifyHandle

"Return an OS handle that can be used in GsSocket to test if this interface
has read activity."

trace ifTrue: [
    self record:
      (String new add: sessionId asString; add: ' notifyHandle'; yourself)
  ].

^ self _zeroArgPrim: 41
%

category: 'Primitives - Trav'
method: GciInterface
performTraverse: remoteOop
selector: selector
args: argsArr
buffer: cBuff

"Sends the given selector to the object in a remote repository with the given
remote oop.  argsArr  is an Array of pairs: either a remote oop or special,
and a boolean indicating whether the arg is special or not.

The argument cBuff should be an instance of TraversalBuffer."

trace ifTrue: [ | str sz |
    str := String new add: 'Sending ['; add: remoteOop asString;
      add: '] '; add: selector; add: ' '; yourself.
    sz := argsArr size.
    1 to: sz by: 2 do: [ :i |
      (argsArr at: i + 1) ifTrue: [ str add: $~ ].
      str add: (argsArr at: i) asString.
      (i + 1) == sz ifFalse: [ str add: ', ' ]
    ].
    self record: str.
  ].
^ self _fourArgPrim: 2
    with: remoteOop
    with: selector
    with: argsArr
    with: cBuff
%

category: 'Tracing'
method: GciInterface
record: aString

"Record the given string to the trace log."

log addAll: aString; add: Character lf; flush
%

category: 'Tracing'
method: GciInterface
recordNoLf: aString

"Record the given string to the trace log with no linefeed at the end."

log addAll: aString; flush
%

category: 'Primitives'
method: GciInterface
remoteExecute: aString

"Execute the given string and return the result of execution.
The returned value will be a remote oop or a special. Send
#resultIsSpecial to determine which.
If the execution resulted in an error, _remoteNil is returned
and error information can be retrieved via #lastError."

| str result trc |

(trc := trace)
  ifTrue: [ str := String new add: 'Execute: '; add: aString; yourself ].

result :=  self _oneArgPrim: 16 with: aString.
trc ifTrue: [
    str add: ' returned '; add: result asString.
    self record: str
  ].
^ result
%

category: 'Primitives - Trav'
method: GciInterface
remoteExecuteTrav: aString buffer: cBuff

"Execute the given string and return the result of execution in the given buffer.
 The argument cBuff should be an instance of TraversalBuffer.
 The result of the execution is saved in the instVar lastResult  .
 The method result is cBuff, i.e. the result of doing a traversal on
 the result of the exection. "

trace ifTrue: [ self record: aString ].

^ self _twoArgPrim: 7
    with: aString
    with: cBuff
%

category: 'Primitives'
method: GciInterface
remotePerform: remoteOop selector: selector args: args

"Sends the given selector to the object in a remote repository with the given
remote oop.  The arg array is an array of pairs: either a remote oop or special,
and a boolean indicating whether the arg is special or not.  The result is a
remoteOop or a special. Send #resultIsSpecial to determine which."

| str result trc |
(trc := trace)
  ifTrue: [
    str := String new add: 'Sending ['; add: remoteOop asString;
      add: '] '; add: selector; yourself
  ].
result := self _threeArgPrim: 2
    with: remoteOop
    with: selector
    with: args.
trc ifTrue: [
    str add: ' returned '; add: result asString.
    self record: str
  ].
^ result
%

category: 'Primitives'
method: GciInterface
resolveSymbol: aSymbol

"Resolve the given symbol and return the remote oop."

trace ifTrue: [ self record: 'Resolve symbol' , aSymbol ].

^ self _oneArgPrim: 17 with: aSymbol
%

category: 'Accessing'
method: GciInterface
resultIsSpecial

   "Answer true if the most recent result is a special (immediate) object:
    a SmallInteger, SmallDouble, Boolean, Character, or nil.
    Answer false if the most recent result is a remote oop."
   ^resultIsSpecial
%

category: 'Accessing'
method: GciInterface
sessionId

   "Return the value of the instance variable 'sessionId'."
   ^sessionId
%

category: 'Primitives'
method: GciInterface
softBreak

"Send a soft break to interrupt execution in the remote repository."

trace ifTrue: [
    self record:
      (String new add: sessionId asString; add: ' softBreak'; yourself)
  ].

^ self _zeroArgPrim: 38
%

category: 'Primitives'
method: GciInterface
step: processOop level: level

"Invoke the GciStep function.

 Returns nil if an error occurs, or the execution result if
 execution completes.  If execution completes, saves the
 execution result in lastResult instVar (change in v3.0.1)."

| str result |
trace ifTrue: [
    str := String new add: 'GciStep ';
      add: processOop asString;
      add: ' : ';
      add: level asString;
      yourself
  ].
result :=  self _twoArgPrim: 5 with: processOop with: level.
trace ifTrue: [
    str add: ' returned '; add: result asString.
    self record: str
  ].
^ result
%

category: 'Primitives - Trav'
method: GciInterface
storeTrav: travBuff flags: flags

"Invoke the store traversal function."

trace
  ifTrue: [ self record: 'GciStoreTrav: ' , flags asString ].

^ self _twoArgPrim: 3 with: travBuff with: flags
%

category: 'Primitives - Trav'
method: GciInterface
storeTravCreate: travBuff

"Invoke the store traversal function."

^ self storeTrav: travBuff flags: 2
%

category: 'Primitives - Trav'
method: GciInterface
storeTravCreateAndFinishUpdates: travBuff

"Invoke the store traversal function."

^ self storeTrav: travBuff flags: 10
%

category: 'Primitives - Trav'
method: GciInterface
storeTravExecute: travBuff
flags: flags
environmentId: anEnvironmentId
execute: aString
alteredObjects: alteredObjArray

"Invoke the store traversal function.

 anEnvironmentId must be a SmallInteger >= 0 and <= 255,
 specifying a compilation environment.

 If execution completes without error, this method
 answers the alteredCompleted boolean, and
 the result of the message send is saved in lastResult instVar.
 If there is an error, this method answers nil and you may send
 #lastError for error information."

| str result trc |
(trc := trace)
  ifTrue: [
    str := String new add: 'GciStoreTravExecute: '; add: aString; yourself
  ].

result := self _storeTravPrim: 1
    with: travBuff
    with: flags
    with: aString
    with: alteredObjArray
    with: anEnvironmentId
    with: nil with: nil .
trc ifTrue: [
    str add: ' lastResult '; add: lastResult asString ;
        add: ' returned '; add: result asString .
    self record: str
  ].
^ result
%

category: 'Primitives - Trav'
method: GciInterface
storeTravExecute: travBuff
flags: flags
environmentId: anEnvironmentId
execute: aString
alteredObjects: alteredObjArray
traverseInto: resBuff

"Invoke the store traversal function.

 anEnvironmentId must be a SmallInteger >= 0 and <= 255,
 specifying a compilation environment.

 If execution completes without error, this method
 answers the alteredCompleted boolean,
 the result of the message send is saved in lastResult instVar,
 and the result of the message send is traversed into the
 argument resBuff.   resBuff must be instance of TraversalBuffer.

 If there is an error, this method answers nil and you may send
 #lastError for error information."

| str result trc |
(trc := trace)
  ifTrue: [
    str := String new add: 'GciStoreTravExecute: '; add: aString; yourself
  ].

result := self _storeTravPrim: 1
    with: travBuff
    with: flags
    with: aString
    with: alteredObjArray
    with: anEnvironmentId
    with: resBuff with: nil .
trc ifTrue: [
    str add: ' lastResult '; add: lastResult asString ;
        add: ' returned '; add: result asString .
    self record: str
  ].
^ result
%

category: 'Primitives - Trav'
method: GciInterface
storeTravPerform: travBuff
flags: flags
perform: remoteOop
selector: selector
args: args
alteredObjects: alteredObjArray

"Invoke the GciStoreTravDo() function, sending
 the objects in the given travBuff to the remote
 gem, then sending the message described by
 the given selector and args to the object with
 the given remoteOop.

 The given args must be an Array whose size is
 twice the number of args. At each even index
 must be a Boolean, true if the value at index-1
 is a special, false if the value is a remote oop.

 If execution completes without error, this method
 answers the alteredCompleted boolean, and
 the result of the message send is saved in lastResult instVar.
 If there is an error, this method answers nil and you may send
 #lastError for error information."

| str result trc |

(trc := trace)
  ifTrue: [
    str := String new add: 'GciStoreTravPerform ['; add: remoteOop asString;
      add: '] '; add: selector; yourself
  ].

result := self _storeTravPrim: 0
    with: travBuff
    with: flags
    with: remoteOop
    with: selector
    with: args
    with: alteredObjArray
    with: nil  .
trc ifTrue: [
    str add: ' lastResult '; add: lastResult asString ;
        add: ' returned '; add: result asString .
    self record: str
  ].
^ result
%

category: 'Primitives - Trav'
method: GciInterface
storeTravPerform: travBuff
flags: flags
perform: remoteOop
selector: selector
args: argsArray
alteredObjects: alteredObjArray
traverseInto: resBuff

"Invoke the GciStoreTravDo() function, sending the objects in
 the given travBuff to the remote gem, then sending the message
 described by the given selector and args to the object with
 the given remoteOop.
 If execution completes without error, this method
 answers the alteredCompleted boolean, and
 the result of the message send is saved in lastResult instVar.
 and the result of the message send is traversed into the
 argument resBuff.   resBuff must be instance of TraversalBuffer.

 The argsArray must be an Array whose size is
 twice the number of args to the selector being performed.
 At each even index must be a Boolean, true if the value at index-1
 is a special, false if the value is a remote oop.

 If there is an error, this method answers nil and you may send
 #lastError for error information."

| str result trc |

(trc := trace)
  ifTrue: [
    str := String new add: 'GciStoreTravPerform ['; add: remoteOop asString;
      add: '] '; add: selector; yourself
  ].

result := self _storeTravPrim: 2
    with: travBuff
    with: flags
    with: remoteOop
    with: selector
    with: argsArray
    with: alteredObjArray
    with: resBuff .
trc ifTrue: [
    str add: ' lastResult '; add: lastResult asString ;
        add: ' returned '; add: result asString .
    self record: str
  ].
^ result
%

category: 'Primitives - Trav'
method: GciInterface
traverseObjects: arrayOfOops buffer: cBuff

"Return a buffer resulting from traversing the given array of remote oops
using GciClampedTrav().  If there were too many oops, return nil.
The argument cBuff should be an instance of TraversalBuffer."

trace ifTrue: [ | str |
    str := String new.
    str add: 'Traversing '; add: arrayOfOops size asString; add: ' oops'.
    self record: str
  ].

^ self _twoArgPrim: 6 with: arrayOfOops with: cBuff
%

category: 'Error Handling'
method: GciInterface
_errorLoginFailed

"Raise an error because an attempt to login failed."

Error signal: 'login failed, ' , lastError message .
%

category: 'Private'
method: GciInterface
_fourArgPrim: opcode with: arg1 with: arg2 with: arg3 with: arg4

"Primitive dispatch.  Legal values:
    1: GciInterface | continueWith:replaceTopOfStackWith:isSpecial:flags:
		(sets lastResult instVar)
    2: GciInterface | performTraverse:selector:args:buffer:  (sets lastResult instVar)
"

<primitive: 503>

^self _primitiveFailed: #_fourArgPrim:
      args: { opcode . arg1 . arg2 . arg3 . arg4 }
%

category: 'Private'
method: GciInterface
_oneArgPrim: opcode with: arg

"Primitive dispatch.  Legal values are:
    16: GciInterface | remoteExecute:   (sets lastResult instVar)
    17: GciInterface | resolveSymbol:
    18: GciInterface | moreTraversal:
    19: GciInterface | getFreeOops:
    20: GciInterface | nbEnd:          (sets lastResult instVar)
    21: GciInterface | clearStack:
    22: GciInterface | nbRemoteExecute:
    23: GciInterface | nbMoreTraversal:
    24: reserved
"

<primitive: 198>

"Error diagnostics"
opcode == 20
  ifTrue: [ "errors in nbEnd:"
    (arg _isInteger)
	ifFalse: [ arg _errorExpectedClass: Integer].
    (arg ~~ 1 and: [arg ~~ 2])
	ifTrue:[arg _error: #rtErrArgOutOfRange args: #(1 2)].
    ].

^self _primitiveFailed: #_oneArgPrim: args: { opcode . arg }
%

category: 'Private'
method: GciInterface
_sessionId: id

"Set the session id"

sessionId := id
%

category: 'Private'
method: GciInterface
_storeTravPrim: opcode with: arg1 with: arg2 with: arg3 with: arg4 with: arg5
with: arg6 with: arg7

"Primitive dispatch.  all set lastResult instVar .
  opcode values:
    0: storeTravPerform:flags:perform:selector:args:alteredObjects:
    1: storeTravExecute:flags:environmentId:execute:alteredObjects:
    2: storeTravPerform:flags:perform:selector:args:alteredObjects:traverseInto:
    3: storeTravExecute:flags:environmentId:execute:alteredObjects:traverseInto:
"

<primitive: 506>

^self _primitiveFailed: #_storeTravPrim:
      args: { opcode . arg1 . arg2 . arg3 . arg4 . arg5 . arg6 . arg7  }
%

category: 'Private'
method: GciInterface
_threeArgPrim: opcode with: arg1 with: arg2 with: arg3

"Primitive dispatch.  Legal values:
    2: GciInterface | remotePerform:selector:args:
    3: GciInterface | nbRemotePerform:selector:args:
"

<primitive: 505>

(opcode == 3 or: [opcode == 4])
    ifTrue: [ "diagnostics for nbRemotePerform"
  arg3 size > 20 ifTrue: [arg3 _error: #gciErrArgNotPairs args: #()].
  arg3 size \\ 2 ~~ 0 ifTrue: [arg3 _error: #gciErrArgNotPairs args: #()].
  1 to: arg3 size by: 2 do: [:i |
	(arg3 at: i + 1) class == Boolean ifFalse: [
	    (arg3 at: i + 1) _errorExpectedClass: Boolean].
	(arg3 at: i + 1) ifTrue: [
	  ((arg3 at: i) _isInteger ) ifFalse: [
	    (arg3 at: i) _errorExpectedClass: Integer].
	  ].
	].
  ].

^self _primitiveFailed: #_threeArgPrim: args: { opcode . arg1 . arg2 . arg3 }
%

category: 'Private'
method: GciInterface
_twoArgPrim: opcode with: arg1 with: arg2

"Primitive dispatch.  Legal values:
    3: GciInterface | storeTrav:flags:  (sets lastResult instVar)
    4: GciInterface | alteredObjects:   (sets lastResult instVar)
    5: GciInterface | step:level:
    6: GciInterface | traverseObjects:buffer:
    7: GciInterface | remoteExecuteTrav:buffer:
    8: GciInterface | login:execute:
    9: GciInterface | nbLogin:flags:
"

<primitive: 199>

"Error diagnostics"
opcode == 8
  ifTrue: [ "errors in login"
    (arg1 isKindOf: GemStoneParameters)
	ifFalse: [ arg1 _errorExpectedClass: GemStoneParameters].
    (arg2 class isBytes)
	ifFalse: [ arg2 _error: #objErrNotByteKind].

    { arg2 .
      arg1 hostUsername .
      arg1 gemService .
      arg1 gemStoneName .
      arg1 username .
      arg1 password .
      arg1 hostPassword
	 } do: [:each |
      each size > 1024
	ifTrue: [ each _error: #rtErrBadSize args: { 1024 . each size }]].

    ].
opcode == 9
  ifTrue: [ "errors in login"
    (arg1 isKindOf: GemStoneParameters)
	ifFalse: [ arg1 _errorExpectedClass: GemStoneParameters].

    { arg1 hostUsername .
      arg1 gemService .
      arg1 gemStoneName .
      arg1 username .
      arg1 password .
      arg1 hostPassword } do: [:each |
        each size > 1024
	ifTrue: [ each _error: #rtErrBadSize args: { 1024 . each size }]
      ].
     arg2 _isSmallInteger ifFalse:[ arg2 _errorExpectedClass: SmallInteger ]
    ].

^self _primitiveFailed: #_twoArgPrim: args: { opcode . arg1 . arg2 }
%

category: 'Private'
method: GciInterface
_zeroArgPrim: opcode

"Primitive dispatch.  Legal values are:
    32: GciInterface | dirtyObjsInit
    33: GciInterface | logout    (sets lastResult instVar to _remoteNil)
    34: GciInterface | commit
    35: GciInterface | nbCommit
    36: GciInterface | abort
    37: GciInterface | nbAbort
    38: GciInterface | softBreak
    39: GciInterface | callInProgress
    41: GciInterface | notifyHandle
    42: reserved
    43: GciInterface | hardBreak
"

<primitive: 197>

^self _primitiveFailed: #_zeroArgPrim: args: { opcode }
%

! Class implementation for 'GemStoneParameters'

!		Class methods for 'GemStoneParameters'

category: 'Instance creation'
classmethod: GemStoneParameters
new

"Create a new initialized instance."

^ self basicNew initialize.
%

!		Instance methods for 'GemStoneParameters'

category: 'Updating'
method: GemStoneParameters
clearQuietLogin

^  self loginFlags: (self loginFlags bitAnd: (16r10"GCI_LOGIN_QUIET" bitInvert))
%

category: 'Accessing'
method: GemStoneParameters
defaultLoginFlags
^ 16r11  "GCI_LOGIN_PW_ENCRYPTED | GCI_LOGIN_QUIET"
%

category: 'Accessing'
method: GemStoneParameters
gemService

   "Return the value of the instance variable 'gemService'."
   ^gemService
%

category: 'Updating'
method: GemStoneParameters
gemService: newValue

   "Modify the value of the instance variable 'gemService'."
   newValue _isOneByteString ifFalse:[ newValue _validateClass: String ].
   gemService := newValue
%

category: 'Accessing'
method: GemStoneParameters
gemStoneName

   "Return the value of the instance variable 'gemStoneName'."

^ gemStoneName
%

category: 'Updating'
method: GemStoneParameters
gemStoneName: aName

"Set the gemStone name. aName must be nil(meaning use server name
of the current session) or aString. "

aName ifNotNil:[
  aName _isOneByteString ifFalse:[ aName _validateClass: String ].
].
gemStoneName := aName.
%

category: 'Accessing'
method: GemStoneParameters
hostPassword

   "Return the value of the instance variable 'hostPassword'."
   ^hostPassword
%

category: 'Updating'
method: GemStoneParameters
hostPassword: pword

"Set the host password for the receiver.  The password is encrypted.
The given password's size is set to zero."

pword _isOneByteString ifFalse:[ pword _validateClass: String ].
hostPassword := self _encrypt: pword.
hostPassword immediateInvariant.
self _securePasswords.

pword isInvariant ifFalse:[ pword size: 0 ].
^ pword
%

category: 'Accessing'
method: GemStoneParameters
hostUsername

   "Return the value of the instance variable 'hostUsername'."
   ^hostUsername
%

category: 'Updating'
method: GemStoneParameters
hostUsername: newValue

   "Modify the value of the instance variable 'hostUsername'."
   newValue _isOneByteString ifFalse:[ newValue _validateClass: String ].
   hostUsername := newValue
%

category: 'Initialization'
method: GemStoneParameters
initialize

"Initialize the instance variables of the receiver."
  ^ self setLoginWithPassword
%

category: 'Accessing'
method: GemStoneParameters
loginFlags

   "Return the value of the instance variable 'loginFlags'."

^ (self dynamicInstVarAt: #loginFlags) ifNil:[ self defaultLoginFlags ] .
%

category: 'Private'
method: GemStoneParameters
loginFlags: anInt
"Do not set loginFlags directly unless you know what you are doing."

self dynamicInstVarAt: #loginFlags put: anInt .
^ self
%

category: 'Accessing'
method: GemStoneParameters
password

   "Return the value of the instance variable 'password'."
   ^password
%

category: 'Updating'
method: GemStoneParameters
password: pword

"Set the password for the receiver.  The password is encrypted.
The given password's size is set to zero."

pword _isOneByteString ifFalse:[ pword _validateClass: String ].

pword size == 0
  ifTrue:[ self setLoginPasswordless .
           password := pword copy ]
  ifFalse:[ self setLoginWithPassword .
            password := self _encrypt: pword ].
password immediateInvariant.
self _securePasswords.
pword isInvariant ifFalse:[ pword size: 0 ].
^ pword
%

category: 'Accessing'
method: GemStoneParameters
passwordIsEncryptedAsIntegerBoolean

"Answer a C boolean (1 or 0) indicating whether the password is encrypted.
 The password will always be encrypted unless the login is passwordless."

^ self loginFlags bitAnd: 1
%

category: 'Accessing'
method: GemStoneParameters
passwordlessLoginFlags
^ 16r90  "GCI_PASSWORDLESS_LOGIN | GCI_LOGIN_QUIET"
%

category: 'Formatting'
method: GemStoneParameters
printString
  | res f |
  res := 'stoneNrs:', gemStoneName asString, ' user:', username asString .
  hostUsername ifNotNil:[ res add: ' hostuser:', hostUsername asString ].
  res add: ' gemNrs:', gemService asString .
  (f := self loginFlags) == self defaultLoginFlags ifFalse:[
    res add: ' flags:16r', f asHexString
  ].
  ^ res
%

category: 'Accessing'
method: GemStoneParameters
remoteRepository

"Return nil to indicate no remote repository."

^ nil
%

category: 'Updating'
method: GemStoneParameters
setLoginPasswordless

^ self loginFlags: self passwordlessLoginFlags
%

category: 'Updating'
method: GemStoneParameters
setLoginWithPassword

^  self loginFlags: self defaultLoginFlags
%

category: 'Updating'
method: GemStoneParameters
setSoloLogin
 
^  self loginFlags: (self loginFlags bitOr: self soloLoginFlag)
%

category: 'Accessing'
method: GemStoneParameters
soloLoginFlag
^ 16r100 "GCI_LOGIN_SOLO"
%

category: 'Accessing'
method: GemStoneParameters
username

   "Return the value of the instance variable 'username'."
   ^username
%

category: 'Updating'
method: GemStoneParameters
username: newValue

   "Modify the value of the instance variable 'username'."
   newValue _isOneByteString ifFalse:[ newValue _validateClass: String ].
   username := newValue
%

category: 'Updating'
method: GemStoneParameters
_encrypt: aString

"Return a new, encrypted string from the given string. ."

^ self _oneArgPrim: 24 with: aString
%

category: 'Error Handling'
method: GemStoneParameters
_errorBadPassword

"Raise an error because could encrypt and store a password."

self _error: #rtErrPasswordNotVariant args: #()
%

category: 'Private'
method: GemStoneParameters
_getArg: ivOffset key: key

"Obsolete method"


<protected primitive: 485>

^ nil
%

category: 'Private'
method: GemStoneParameters
_oneArgPrim: opcode with: arg

"Primitive dispatch. Legal values:
    24 GemStoneParameters | _encrypt:
"

<primitive: 198>

^self _primitiveFailed: #_oneArgPrim: args: { opcode . arg }
%

category: 'Private'
method: GemStoneParameters
_secureArg: ivOffset key: key

"Obsolete method"


<protected primitive: 490>

^ nil
%

category: 'Private'
method: GemStoneParameters
_securePasswords
"Do not allow anyone to read passwords."

| result |

result := self _zeroArgPrim: 40.
^ result
%

category: 'Private'
method: GemStoneParameters
_zeroArgPrim: opcode

"Primitive dispatch.  Legal values:
    40: GemStoneParameters | _securePasswords
"

<primitive: 197>

^self _primitiveFailed: #_zeroArgPrim: args: { opcode }
%

! Class implementation for 'GemStoneX509Parameters'

!		Class methods for 'GemStoneX509Parameters'

category: 'Instance Creation'
classmethod: GemStoneX509Parameters
newFromPemFilesWithNetldiPort: aPort netldiHost: aHostOrIp certificate: aCertFn caCertificate: aCaCertFn privateKey: aKeyFn
| result |
result := self new initialize.
result netldiPort: aPort;
       netldiHost: aHostOrIp;
       certificate: (GsX509CertificateChain newFromPemFile: aCertFn);
       caCertificate: (GsX509CertificateChain newFromPemFile: aCaCertFn);
       privateKey: (GsTlsPrivateKey newFromPemFile: aKeyFn) .
^ result
%

category: 'Instance Creation'
classmethod: GemStoneX509Parameters
newFromPemStringsWithNetldiPort: aPort netldiHost: aHostOrIp certificate: aCertString caCertificate: aCaCertString privateKey: aKeyString
| result |
result := self new initialize.
result netldiPort: aPort;
       netldiHost: aHostOrIp;
       certificate: (GsX509CertificateChain newFromPemString: aCertString);
       caCertificate: (GsX509CertificateChain newFromPemString: aCaCertString);
       privateKey: (GsTlsPrivateKey newFromPemString: aKeyString) .
^ result
%

category: 'Instance Creation'
classmethod: GemStoneX509Parameters
newWithNetldiPort: aPort netldiHost: aHostOrIp certificate: aCert caCertificate: aCaCert privateKey: aKey
| result |
result := self new initialize.
result netldiPort: aPort;
       netldiHost: aHostOrIp;
       certificate: aCert;
       caCertificate: aCaCert;
       privateKey: aKey .
^ result
%

!		Instance methods for 'GemStoneX509Parameters'

category: 'Converting'
method: GemStoneX509Parameters
asGciX509LoginArg

"Answer an instance of CPointer which represents a GciX509LoginArg derived
 from the receiver."

| cBytes |
cBytes := CByteArray gcMalloc: 80 .
cBytes
  pointerAt:  0 put: (CByteArray withAll: netldiHost asString) ;
  pointerAt:  8 put: (CByteArray withAll: netldiPort asString) ;
  pointerAt: 16 put: (CByteArray withAll: privateKey asPemString) ;
  pointerAt: 24 put: (CByteArray withAll: certificate asPemString) ;
  pointerAt: 32 put: (CByteArray withAll: caCertificate asPemString) ;
  pointerAt: 40 put: (self createCargFromInstVar: extraGemArgs) ;
  pointerAt: 48 put: (self createCargFromInstVar: dirArg) ;
  pointerAt: 56 put: (self createCargFromInstVar: logArg) ;
    int32At: 64 put: loginFlags ;
    int32At: 68 put: 1 "argsArePemStrings" ;
    int32At: 72 put: 0 "executedSessionInit" .

^ CPointer newFrom: cBytes
%

category: 'Accessing'
method: GemStoneX509Parameters
caCertificate
^ caCertificate
%

category: 'Updating'
method: GemStoneX509Parameters
caCertificate: aCaCert
caCertificate := aCaCert
%

category: 'Accessing'
method: GemStoneX509Parameters
certificate
^ certificate
%

category: 'Updating'
method: GemStoneX509Parameters
certificate: aCert
certificate := aCert
%

category: 'Converting'
method: GemStoneX509Parameters
createCargFromInstVar: anObj
^ (anObj isNil or:[anObj size == 0])
    ifTrue:[ CPointer newNull ]
   ifFalse:[ CByteArray withAll: anObj ]
%

category: 'Accessing'
method: GemStoneX509Parameters
dirArg
^ dirArg
%

category: 'Updating'
method: GemStoneX509Parameters
dirArg: aString
dirArg := aString
%

category: 'Accessing'
method: GemStoneX509Parameters
extraGemArgs
^ extraGemArgs
%

category: 'Updating'
method: GemStoneX509Parameters
extraGemArgs: aString
extraGemArgs := aString
%

category: 'Initialization'
method: GemStoneX509Parameters
initialize
 loginFlags := 0 .
 ^ self
%

category: 'Accessing'
method: GemStoneX509Parameters
logArg
^ logArg
%

category: 'Updating'
method: GemStoneX509Parameters
logArg: aString
logArg := aString
%

category: 'Accessing'
method: GemStoneX509Parameters
loginFlags
^ loginFlags
%

category: 'Updating'
method: GemStoneX509Parameters
loginFlags: anInt
loginFlags := anInt
%

category: 'Accessing'
method: GemStoneX509Parameters
netldiHost
^ netldiHost
%

category: 'Updating'
method: GemStoneX509Parameters
netldiHost: aHostOrIp
netldiHost := aHostOrIp .
%

category: 'Accessing'
method: GemStoneX509Parameters
netldiPort
^ netldiPort
%

category: 'Updating'
method: GemStoneX509Parameters
netldiPort: anInt
netldiPort := anInt .
%

category: 'Accessing'
method: GemStoneX509Parameters
privateKey
^ privateKey
%

category: 'Updating'
method: GemStoneX509Parameters
privateKey: aPrivateKey
privateKey := aPrivateKey
%

! Class implementation for 'GsBitmap'

!		Class methods for 'GsBitmap'

category: 'Enumerating'
classmethod: GsBitmap
allObjectsExcept: aCollection

"Returns an instance of GsBitmap that contains all objects that exist which are not contained in the objects transitively referenced from <aCollection>. The objects in the result may or may not be live objects (reachable from the repository roots)."

| found |

found := GsBitmap withAll: aCollection.
found := GsBitmap allTransitiveReferences: found.
^ (GsBitmap allValidOops) - found
%

category: 'Enumerating'
classmethod: GsBitmap
allTransitiveReferences: aCollection

"Similar to transitiveReferences:, however the result includes all of the normally hidden interior nodes for large objects. "

| newFound allFound diff |

newFound := GsBitmap withAll: aCollection.
allFound := newFound copy.

[true] whileTrue: [ 
  newFound := newFound allReferencedObjects.
  diff := newFound - allFound.
  allFound addAll: diff.
  newFound := diff.
  diff isEmpty ifTrue: [ ^ allFound ]
  ] 
%

category: 'Enumerating'
classmethod: GsBitmap
allValidOops

"Returns an instance of GsBitmap containing the oops of all valid objects in the repository.  This bitmap only reflects currently committed objects that are not in the process of being garbage collected, i.e, not in the possible dead or deadNotReclaimed sets."

^(GsBitmap new) _1ArgPrim: 11
%

category: 'File Operations'
classmethod: GsBitmap
auditFile: fileName
"Reads the file and counts the number of objects in the file which 
 are no longer valid.  Objects are considered invalid if they no 
 longer exist (i.e., are not present in the shared object table) 
 or present in the dead objects set maintained by stone.

 The session must be in a transaction when this method is invoked.  If the
 session is not in a transaction, an #rtErrPrimOutsideTrans error is raised.

 Returns an Array containing 2 elements 
    1 - a SmallInteger, total number of oops in the file.
    2 - a SmallInteger, number of invalid oops in the file.

 Raises an error if the file could not be opened for reading, the file
 is corrupt, fileName is not an instance of String.
"

 | arr fileInfo |
 fileInfo := GsBitmap fileInfo: fileName.
 arr := Array new.
 arr add: (fileInfo at: 1).
 arr add: (fileInfo at: 4).
 ^ arr
%

category: 'File Operations'
classmethod: GsBitmap
auditPageOrderOopFile: fileName

"Reads the page order oop file and counts the number of
 objects in the file which are no longer valid.  Objects are
 considered invalid if they no longer exist (i.e., are not
 present in the shared object table) or present in the dead objects
 set maintained by stone.

 The session must be in a transaction when this method is invoked.  If the
 session is not in a transaction, an #rtErrPrimOutsideTrans error is raised.

 Returns an Array containing 2 elements 
    1 - a SmallInteger, total number of oops in the file.
    2 - a SmallInteger, number of invalid oops in the file.

 Raises an error if the file could not be opened for reading, the file
 is corrupt, fileName is not an instance of String, or the file is
 not written in page order.
"

 | arr fileInfo |
 fileInfo := GsBitmap fileInfo: fileName.
 (fileInfo at: 2) ifFalse: [
   ArgumentTypeError signal: 'The bitmap file is not written in page order'
   ].
 arr := Array new.
 arr add: (fileInfo at: 1).
 arr add: (fileInfo at: 4).
 ^ arr
 
%

category: 'Instance Creation'
classmethod: GsBitmap
basicNew

"disallowed"

self shouldNotImplement: #basicNew
%

category: 'Debugging'
classmethod: GsBitmap
bitToOop: aSmallInteger
  "For argument that is bit number for a committed non-special object, return
   the oop as a SmallInteger ."
  ^ (aSmallInteger bitShift:  8 ) bitOr: 1 
%

category: 'File Operations'
classmethod: GsBitmap
fileInfo: bitmapFilePath

" Returns an array which contains the following values:
  1.  The number of oops in the file
  2.  True if the file was written in page order.
  3.  The number of valid oops.
  4.  The number of invalid oops (oops that are not allocated or in the
      process of being garbage collected).

  Raises an error if the file could not be opened for reading, the file
  is corrupt, or bitmapFilePath is not an instance of String.
"

^(GsBitmap new) _2ArgPrim: 20 with: bitmapFilePath
%

category: 'Hidden Set Support'
classmethod: GsBitmap
hiddenSetIdAsSymbol: oldHiddenSetId

"Returns the symbol corresponding to the old hiddenSet specifier" 

^ GsBitmap new _2ArgPrim: 19 with: oldHiddenSetId
%

category: 'Hidden Set Support'
classmethod: GsBitmap
hiddenSetSpecifiers

"Returns a list of the hidden set specifiers.

**************************************************************************************************
***** DO NOT CHANGE THE ORDER OF THE ELEMENTS IN THE LIST WITHOUT EDITING CODE IN gsbitmap.c *****
**************************************************************************************************
"

^#(
 #ListInstances
 #SaveNewPomObjs "See method #_enableTraceNewPomObjs"
 #ObjectsRead    "See method #_enableTraceObjectsRead"
 #SaveWriteSetUnion
 #CommitReleaseLocksSet
 #CommitOrAbortReleaseLocksSet
 #StrongReadSet
 #GcCandidates
 #Indexing
 #Conversion
 #WeakReferences
 #ObjInventory
 #Customer1
 #Customer2
 #Customer3
 #Customer4
 #Customer5 "last mutable hiddenSet"

 #RcReadSet
 #DepMapWriteSet
 #PomWriteSet    "Empty except after flush for commit, so only useful
		       after a transaction conflict."
 #RemovedDepMapEntries
 #SaveDepMapChangedUnion
 #ReadWriteConflicts  "StrongRead-Write conflicts "
 #WriteWriteConflicts
 #WriteDependencyConflicts
 #WriteReadLockConflicts
 #WriteWriteLockConflicts
 #AllocatedGciOops
 #ExportedDirtyObjs
 #TrackedDirtyObjs
 #ReferencedSet
 #WriteLockWriteSubset
 #NewDataPages
 #PreviousWsUnion
 #PureExportSet
 #GciTrackedObjs
 #NotifySet
)
%

category: 'Instance Creation'
classmethod: GsBitmap
new

"Returns a new empty GsBitmap"

^ self _basicNew _1ArgPrim: 1
%

category: 'Instance Creation'
classmethod: GsBitmap
newForHiddenSet: hiddenSetSpecifier

"Returns a GsBitmap that references the specified hiddenSet."

| gsBitmap idx |
gsBitmap := GsBitmap new.
idx := GsBitmap hiddenSetSpecifiers indexOfIdentical: hiddenSetSpecifier.
idx < 1 ifTrue: [ ^ hiddenSetSpecifier _error: #rtErrInvalidArgument
                              args:{ 'not a valid hiddenSetSpecifier' }] .
gsBitmap _hiddenSetId: idx.
^gsBitmap
%

category: 'File Operations'
classmethod: GsBitmap
numberOfObjectsInPageOrderFile: fileName

"Answer the number of objects in a page order oop file.

 The session must be in a transaction when this method is invoked.  If the
 session is not in a transaction, an #rtErrPrimOutsideTrans error is raised.

 Raises an error if the file could not be opened for reading, the file
 is corrupt, fileName is not an instance of String, or the file is
 not written in page order.
"

| fileInfo |

fileInfo := GsBitmap fileInfo: fileName.
(fileInfo at: 2) ifFalse: [
   ArgumentTypeError signal: 'The bitmap file is not written in page order'
   ].
^ fileInfo at: 1
%

category: 'Debugging'
classmethod: GsBitmap
oopToBit: aSmallInteger
  "For argument that is the oop of a committed non-special object, return
   the bit number."
  (aSmallInteger bitAnd: 16rFF) == 1 ifFalse:[ 
     ArgumentError signal:'argument is oop of a special object'].
  ^ aSmallInteger bitShift: - 8 .
%

category: 'File Operations'
classmethod: GsBitmap
readObjectsFromPageOrderFile: fileName startingAt: startIdx upTo: endIdx

"Reads, validates and returns objects from a page-ordered file.

 startIndex is the index of the first object in the file to be returned.  The first
 object in the file has an index of 1.  It is an error if startIndex is less than 1
 or greater than endIndex.

 endIndex is the index of the last object to return from the file.  endIndex
 must be greater than or equal to startIndex.  endIndex may exceed the index of
 the last object in the file.  In that case, all valid objects from startIndex to the
 end of the file are returned.

 Returns an array containing the valid oops in page order.
 
 Raises an error if the file could not be opened for reading, the file
 is corrupt, fileName is not an instance of String, or the file is
 not written in page order.

 It is possible that one or more object identifiers contained in the file
 are no longer valid due to garbage collection.  Objects which are no longer
 valid have nil stored in their place in the returned array.  Objects that have been
 garbage collected and are in the free oop list or the dead not reclaimed set
 are considered to be invalid.

 The session must be in a transaction when this method is invoked.  If the
 session is not in a transaction, an #rtErrPrimOutsideTrans error is raised.
"

^(GsBitmap new) _readObjectsFromPageOrderFilePrim: fileName startingAt: startIdx upto: endIdx
%

category: 'Enumerating'
classmethod: GsBitmap
transitiveReferences: aCollection

"Returns an instance of GsBitmap that contains all the objects which are transitively referenced from the objects in <aCollection>."

| newFound allFound diff |

newFound := GsBitmap withAll: aCollection.
allFound := newFound copy.

[true] whileTrue: [ 
  newFound := newFound referencedObjects.
  diff := newFound - allFound.
  allFound addAll: diff.
  newFound := diff.
  diff isEmpty ifTrue: [ ^ allFound ]
  ] 
%

category: 'Instance Creation'
classmethod: GsBitmap
with: aValue

"Returns an instance of the receiver containing the argument"

| inst |
inst := self new.
inst add: aValue.
^inst
%

category: 'Instance Creation'
classmethod: GsBitmap
with: aValue with: val2

"Returns an instance of the receiver containing the arguments"

| inst |
inst := self new.
inst add: aValue; add: val2.
^inst
%

category: 'Instance Creation'
classmethod: GsBitmap
with: aValue with: val2 with: val3

"Returns an instance of the receiver containing the arguments"
| inst |
inst := self new.
inst add: aValue; add: val2; add: val3.
^inst
%

category: 'Instance Creation'
classmethod: GsBitmap
with: aValue with: val2 with: val3 with: val4

"Returns an instance of the receiver containing the arguments"
| inst |
inst := self new.
inst add: aValue; add: val2; add: val3; add: val4.
^inst
%

category: 'Instance Creation'
classmethod: GsBitmap
withAll: aCollection

"Returns an instance of the receiver containing the elements of the argument."

| inst |
inst := self new.
aCollection do: [ :each | inst add: each ].
^ inst.
%

category: 'Private'
classmethod: GsBitmap
_basicNew

"creates an instance registered with VM for finalization of cData"

<primitive: 674>
self _primitiveFailed: #_basicNew
%

category: 'Private'
classmethod: GsBitmap
_deadNotReclaimed
 "Answer a new GsBitmap that contains the objects identified as dead
  by the last epochGc or markForCollection, and which have not been reclaimed.
  You must disable the reclaim gem before executing this. 
  If no error is signalled may include  System class >> continueTransaction. "

  System reclaimGemSessionCount > 0 ifTrue:[
    Error signal:'reclaimGem must be stopped before using #_deadNotReclaimed'.
  ].
  ^ (GsBitmap new) _1ArgPrim: 14 
%

!		Instance methods for 'GsBitmap'

category: 'Set Arithmetic'
method: GsBitmap
* aGsBitmap

"Returns a new GsBitmap with the elements that are in both the receiver and in aGsBitmap.
 Same as inersect:."

^self _2ArgPrim: 16 with: aGsBitmap
%

category: 'Set Arithmetic'
method: GsBitmap
+ aGsBitmap

"Returns a new GsBitmap with the elements that are in the receiver or aGsBitmap.
 Same as union:."

^self _2ArgPrim: 14 with: aGsBitmap
%

category: 'Set Arithmetic'
method: GsBitmap
- aGsBitmap

"Returns a new GsBitmap with the elements in the receiver that are not in aGsBitmap.
 Same as difference:."

^self _2ArgPrim: 15 with: aGsBitmap
%

category: 'Adding'
method: GsBitmap
add: anObject

"Adds a non special object to the GsBitmap.
 Returns anObject."

self _2ArgPrim: 10 with: anObject.
^anObject
%

category: 'Adding'
method: GsBitmap
addAll: anArrayOrGsBitmap

"Adds each element of the Array of non special objects or the contents of a GsBitmap
 to the receiver. Returns an Integer, the number of bits added to the receiver."

(anArrayOrGsBitmap == nil) ifTrue: [ ^anArrayOrGsBitmap ].
^self _2ArgPrim: 11 with: anArrayOrGsBitmap
%

category: 'Emumerating'
method: GsBitmap
allReferencedObjects

"Similar to referencedObjects, returning a new instance of GsBitmap containing the objects directly referenced by the objects in the receiver; but in addition, the result includes all of the normally hidden interior nodes for large objects."

^self _1ArgPrim: 10
%

category: 'Converting'
method: GsBitmap
asArray

"Returns the bits that are set in the GsBitmap as an Array of objects.
 The results is an object in temporary object memory."

^self _1ArgPrim: 4
%

category: 'Converting'
method: GsBitmap
asGsBitmap

^ self
%

category: 'Accessing'
method: GsBitmap
copy

"Returns a new GsBitmap that is a copy of the receiver."

^self _1ArgPrim: 6
%

category: 'Set Arithmetic'
method: GsBitmap
difference: aGsBitmap

"Returns a new GsBitmap with the elements in the receiver that are not in aGsBitmap.
 Same as -."

^self _2ArgPrim: 15 with: aGsBitmap
%

category: 'Enumerating'
method: GsBitmap
do: aBlock

"Executes the one argument block aBlock for each object in
 in the receiver.  Does a non destructive enumerate of the GsBitmap.
 Returns the number of objects enumerated."

 | count arr |
 count := 0.
 arr := Array new.
 arr add: 0.
 [ | n |
   arr := self enumerateWithLimit: 2000 startingAfter: (arr last).
   n := arr size .
   count := count + n .
   1 to: n do:[:j | aBlock value: (arr at: j) ] .
   n ~~ 0 .
 ] whileTrue.
 ^ count
%

category: 'Enumerating'
method: GsBitmap
enumerateAsOopsWithLimit: maxResultSize startingAfter: anOop

"Returns an array containing the first maxResultSize bits as oops
 starting with the first one after the specified oop.
 To start the enumeration use the SmallInteger zero as anOop.
 To get the next batch use the last element of the array returned.

 This enumeration is non destructive, so no values are cleared.

 If the GsBitmap contains fewer than maxResultSize elements after the
 specified object or the maxResultSize has the value 0, then it returns
 all of the elements after the specified object.
"

^self _3ArgPrim: 2 with: maxResultSize with: anOop
%

category: 'Enumerating'
method: GsBitmap
enumerateWithLimit: maxResultSize startingAfter: anObject

"Returns an array containing the first maxResultSize bits as objects
 starting with the first one after the specified object.
 To start the enumeration use the SmallInteger zero as anObject.
 To get the next batch use the last element of the array returned.

 This enumeration is non destructive, so no values are cleared.

 If the GsBitmap contains fewer than maxResultSize elements after the
 specified object or the maxResultSize has the value 0, then it returns
 all of the elements after the specified object.
"

^self _3ArgPrim: 1 with: maxResultSize with: anObject
%

category: 'Testing'
method: GsBitmap
equals: aGsBitmap

"Returns true if the receiver and argument contain exactly the same elements."

^self _2ArgPrim: 4 with: aGsBitmap
%

category: 'Searching'
method: GsBitmap
firstObjectThatReferences: anObject
"Search the receiver to find and return the first object which references anObject.
 Returns nil if no such object was found."

^self _2ArgPrim: 5 with: anObject
%

category: 'Accessing'
method: GsBitmap
hiddenSetName

"Returns the name as a symbol that corresponds to this instance.
 If there is no hidden set reference then it returns the symbol #NotAHiddenSet."

 hiddenSetId == 0 ifTrue: [ ^ #NotAHiddenSet ]
                  ifFalse: [ ^ (GsBitmap hiddenSetSpecifiers) at: hiddenSetId ]
%

category: 'Testing'
method: GsBitmap
includes: anObject

"Returns true if anObject is in the GsBitmap."

^self _2ArgPrim: 1 with: anObject
%

category: 'Set Arithmetic'
method: GsBitmap
intersect: aGsBitmap

"Returns a new GsBitmap with the elements that are in both the receiver and in aGsBitmap.
 Same as *."

^self _2ArgPrim: 16 with: aGsBitmap
%

category: 'Set Arithmetic'
method: GsBitmap
intersectSize: aGsBitmap

"Returns a SmallInteger which is the number of elements present in both the receiver and aGsBitmap."

| result newBm |
newBm := self * aGsBitmap .
result := newBm size.
newBm removeAll .
^ result
%

category: 'Testing'
method: GsBitmap
isEmpty

"Returns true there are no entries in the GsBitmap."

^self size == 0
%

category: 'Peeking'
method: GsBitmap
peek

"Answer the first element in the receiver without removing it, or nil if the receiver is empty."
^ self isEmpty ifTrue:[nil] ifFalse:[ (self peekCount: 1) at: 1]
%

category: 'Peeking'
method: GsBitmap
peekCount: aCount

"Fetches elements from the receiver without removing them.  Returns an Array that contains
 the minimum of aCount or the receiver's size entries."

^self enumerateWithLimit: aCount startingAfter: 0
%

category: 'Peeking'
method: GsBitmap
peekLast

"Answer the last in the receiver without removing it, or nil if the receiver is empty."
^ self isEmpty ifTrue:[nil] ifFalse:[ self _1ArgPrim: 8 ]
%

category: 'Private'
method: GsBitmap
primFirstObjectThatReferences: anObject

"Search the receiver to find and return the first object which references anObject. 
 Returns nil if no such object was found. Similar to the firstObjectThatReferences:
 method except this method may return an internal object as the result"

^self _2ArgPrim: 25 with: anObject
%

category: 'Private'
method: GsBitmap
primReferencedObjects

"Answer a new GsBitmap that contains the committed, non-special objects
referenced by the objects contained in the receiver. Similar to the 
referencedObjects method except this method includes internal objects
in the result, and does not include the entire collection contents
when traversing large objects or NSCs."

^self _1ArgPrim: 12
%

category: 'Formatting'
method: GsBitmap
printOn: aStream

"Puts a displayable representation of the receiver on aStream."

aStream nextPutAll: (self printStringWithMaxSize: 8).
%

category: 'Formatting'
method: GsBitmap
printString

"Returns a String with a displayable representation of the receiver."

^ self printStringWithMaxSize: 1000
%

category: 'Formatting'
method: GsBitmap
printStringWithMaxSize: n

"Returns the contents of the GsBitmap as a string with oops of the
 objects in the bitmap arranged 8 per line.
"
| count result bmSize |

count := 0.
result := String new.
bmSize := self size.
result add: ('GsBitmap contains ' , bmSize asString , ' objects. ' , Character lf).
(bmSize == 0) ifTrue: [ ^ result ].
result add: ('1. ').
self _doAsOops: [ :oop |
  count := count + 1.
  result add: (' ' , oop asString , ' ').
  ((count rem: 8) = 0 and: [count < bmSize]) ifTrue: [
     result add: (' ' , Character lf , (count + 1) asString , '. ').
     (result size > n and: [n ~= 0]) ifTrue: [
       result add: (' ........' , Character lf).
       result add: ( bmSize asString , '. ' , self peekLast asString, Character lf).
       ^ result
     ]
  ]
].
^result
%

category: 'File Operations'
method: GsBitmap
readFromFile: fileName

"Reads the contents of the file and adds the oops in the file to the
 receiver.  If the file doesn't exist or is not in the GsBitmap format,
 then this method returns an error.

 Subsets of the file can be read into a GsBitmap with
         readFromFile:withLimit:startingAt:.

 ObjectIds that are in the freelist or in the deadObjs or possibleDead sets
 are not included.

 Returns the number of objects that were not included.
"

^self _2ArgPrim: 21 with: fileName
%

category: 'File Operations'
method: GsBitmap
readFromFile: aString withLimit: maxResultSize startingAt: startIndex

"Adds the contents of the specified file indexed by the subrange:
 (startingAt, startingAt + maxResultSize).  The resulting GsBitmap
 may contain fewer than maxResultSize elements if the value of
 startingAt + maxResultSize is an index that is larger than the number of
 oops in the file or if some of the ObjectIds represented are no longer
 live objects, i.e., they were found to be in the freeList or the
 deadNotReclaimed or possible dead sets.

 If the file doesn't exist or is not in the GsBitmap format,
 then this method returns an error.

 The first object in the file has an index of 1.  It is an error if
 startIndex is less than 1.

 Returns the number of objects read.
"

<primitive: 1029>
aString _validateClass: String.
maxResultSize _validateClass: SmallInteger.
startIndex _validateClass: SmallInteger.
self _primitiveFailed: #readFromFile:withLimit:startingAt: args: { aString . maxResultSize . startIndex }
%

category: 'Enumerating'
method: GsBitmap
referencedObjects

"Answer a new GsBitmap that contains the committed, non-special objects
referenced by the objects contained in the receiver.  For each object for
which the current user has read authorization, the objects that are directly
referenced structurally by that object (from named instance variables, indexed
or NSC contents, and dynamic instance variables) are included."

^self _1ArgPrim: 9
%

category: 'Removing'
method: GsBitmap
remove: anObject

"Removes anObject from the GsBitmap.
 If the object is not present in the GsBitmap it issues #objErrNotInColl,
 otherwise it returns anObject.
"
(self _2ArgPrim: 12 with: anObject)
    ifFalse: [ self _error: #objErrNotInColl args: { anObject } ].
^anObject
%

category: 'Removing'
method: GsBitmap
remove: anObject ifAbsent: aBlock

"Removes anObject from the receiver.  If anObject is not in the
 receiver, this method evaluates aBlock and returns its value.
 The argument aBlock must be a zero-argument block.
"

(self _2ArgPrim: 12 with: anObject)
    ifFalse: [ ^ aBlock value ].
^anObject
%

category: 'Removing'
method: GsBitmap
removeAll

"Clears all of the bits in the receiver."

^self _1ArgPrim: 2
%

category: 'Removing'
method: GsBitmap
removeAll: anArrayOrGsBitmap

"Removes each element of the Array of non special objects or the contents of a GsBitmap
 from the receiver.  Returns anArrayOrGsBitmap."

^self _2ArgPrim: 13 with: anArrayOrGsBitmap
%

category: 'Removing'
method: GsBitmap
removeCount: maxToRemove
"Removes entries from the receiver, and returns an Array that contains the
 minimum of maxToRemove or the receiver's size entries."

|result|
result := self peekCount: maxToRemove .
self removeAll: result .
^result
%

category: 'Removing'
method: GsBitmap
removeFirst: count

"Remove the first count objects from the receiver and return them in a new GsBitmap.
 Objects are removed from the beginning, going from lowest to highest object ID.
"

| copy |
copy := self copy.
self _removeFirst: count.
^copy removeAll: self
%

category: 'Removing'
method: GsBitmap
removeIfPresent: anObject

"Remove anObject from the receiver.  Returns nil if anObject is
 missing from the receiver, otherwise returns the argument.
"

(self _2ArgPrim: 12 with: anObject)
    ifFalse: [ ^ nil ].
^anObject
%

category: 'Removing'
method: GsBitmap
removeLast: count

"Remove the last count objects from the receiver and return them in a new GsBitmap.
 Objects are removed from the end, going from higest to the lowest object ID.
"

| copy |
copy := self copy.
self _truncateToSize: (self size - count).
^copy removeAll: self
%

category: 'Removing'
method: GsBitmap
removeNext
"Removes the first element from the receiver and returns it.  Returns nil if the receiver is empty."

^ self isEmpty ifTrue:[nil] ifFalse:[ (self removeCount: 1) at: 1]
%

category: 'Testing'
method: GsBitmap
size

"Returns the number of bits that are set in the GsBitmap."

^self _1ArgPrim: 3
%

category: 'Accessing'
method: GsBitmap
sizeInPages

"Returns the number of 16 K pages used to implement the receiver."

^self _1ArgPrim: 7
%

category: 'Set Arithmetic'
method: GsBitmap
union: aGsBitmap

"Returns a new GsBitmap with the elements that are in the receiver or aGsBitmap.
 Same as +."

^self _2ArgPrim: 14 with: aGsBitmap
%

category: 'File Operations'
method: GsBitmap
writeToFile: aString

"Writes the contents of the receiver to the specified file.
 The file created is approximately 5 bytes for each object plus 24 bytes for
 the file header.

 If the file exists an error is returned.

 Returns the number of objectIds written to the file.
"

^self _2ArgPrim: 2 with: aString
%

category: 'File Operations'
method: GsBitmap
writeToFileInPageOrder: aString

"Writes the contents of the receiver to the specified file in pageOrder.

 Operations like instance migration which process a large volume of objects
 often run significantly faster if the objects are processed in batches that
 are in page order rather than in object ID order.

 The file created is approximately 5 bytes for each object plus 24 bytes for
 the file header.

 If the file exists an error is returned.

 Returns the number of objectIds written to the file.
"

^self _2ArgPrim: 3 with: aString
%

category: 'Private'
method: GsBitmap
_1ArgPrim: opCode

"opCode     function
   1        _basicNew
   2        removeAll
   3        size
   4        asArray
   5        asArrayOfOops
   6        copy
   7        sizeInPages
   8        peekLast
   9        referencedObjects
   10       allReferencedObjects
   11       allValidOops
   12       primReferencedObjects
   13       _asArrayOfBits
   14       _deadNotReclaimed
"

<primitive: 1026>
opCode _validateClass: SmallInteger.
self _primitiveFailed: #_1ArgPrim: args: { opCode }
%

category: 'Private'
method: GsBitmap
_2ArgPrim: opCode with: arg2

" Functions with the receiver readOnly should be first
 opCode     function
   1        includes:
   2        writeToFile:
   3        writeToFileInPageOrder:
   4        equals:
   5        firstObjectThatReferences:
   6        _includesBit:

     First mutable opcode
  10        add:         primitive returns the previous state
  11        addAll:
  12        remove:      primitive returns the previous state
  13        removeAll:
  14        union:
  15        difference:
  16        intersect:
  17        truncateToSize:
  18        _removeFirst:
  19        hiddenSetIdAsSymbol:

  20        fileInfo:
  21        readFromFile:
  22        (was auditFile)
  23        _setBits:
  24        _clearBits:
  25        primFirstObjectThatReferences:
"

<primitive: 1027>
opCode _validateClass: SmallInteger.
self _primitiveFailed: #_2ArgPrim:with: args: { opCode . arg2 }
%

category: 'Private'
method: GsBitmap
_3ArgPrim: opCode with: arg2 with: arg3

" Functions with the receiver readOnly should be first
 opCode     function
   1        enumerateWithLimit:startingAfter:
   2        enumerateAsOopsWithLimit:startingAfter:
 "

<primitive: 1028>
opCode _validateClass: SmallInteger.
self _primitiveFailed: #_3ArgPrim:with:with: args: { opCode . arg2 . arg3}
%

category: 'Private'
method: GsBitmap
_asArrayOfBits

"Returns the bits that are set in the GsBitmap as an Array of Integers
 which correspoind to the raw bit numbers in the receiver.
 See also GsBitmap class >> bitToOop: "

^ self _1ArgPrim: 13
%

category: 'Private'
method: GsBitmap
_asArrayOfOops

"Returns the bits that are set in the GsBitmap as an Array of SmallIntegers
 which correspoind to the oops of the persistent objects.
 This method can be used to return the results of a large GsBitmap in 
 an array without faulting all of the objects into memory like asArray does.
 The oops can be used as arguments to   Object class >> objectForOop: ."

^self _1ArgPrim: 5
%

category: 'Private'
method: GsBitmap
_clearBits: anArray

"Clears the bits specified by the Integers in anArray from the receiver.
 Returns the number of bits cleared."

^self _2ArgPrim: 24 with: anArray
%

category: 'Private'
method: GsBitmap
_doAsOops: aBlock

"Executes the one argument block aBlock for each oop in
 in the receiver.  Does a non destructive enumerate of the GsBitmap
 with the argument to the block being anOop.
 Returns the number of objects enumerated."

 | count arr |
 count := 0.
 arr := Array new.
 arr add: 0.
 [ | n |
   arr := self enumerateAsOopsWithLimit: 2000 startingAfter: (arr last).
   n := arr size .
   count := count + n .
   1 to: n do:[:j | aBlock value: (arr at: j) ] .
   n ~~ 0 .
 ] whileTrue.
 ^ count
%

category: 'Private'
method: GsBitmap
_hiddenSetId

^hiddenSetId
%

category: 'Private'
method: GsBitmap
_hiddenSetId: aSmallInt

hiddenSetId := aSmallInt
%

category: 'Private'
method: GsBitmap
_includesBit: aBit

"Returns true if the bit is in the GsBitmap."

^self _2ArgPrim: 6 with: aBit
%

category: 'Private'
method: GsBitmap
_readObjectsFromPageOrderFilePrim: fileName startingAt: startIdx upto: endIdx

<primitive: 170>
fileName _validateClass: String.
startIdx _validateClass: SmallInteger.
endIdx _validateClass: SmallInteger.
self _primitiveFailed: #_readObjectsFromPageOrderFile:startingAt:upTo: args: { fileName . startIdx . endIdx }
%

category: 'Private'
method: GsBitmap
_removeFirst: count

"Remove the first count objects from the receiver.  Objects are removed from
 the beginning, going from lowest to highest object ID.

 Returns the number of objects removed from the hidden set."

^self _2ArgPrim: 18 with: count
%

category: 'Private'
method: GsBitmap
_setBits: anArray

"Add the bits specified by the Integers in anArray to the receiver.
 Returns the number of bits added."

^self _2ArgPrim: 23 with: anArray
%

category: 'Private'
method: GsBitmap
_truncateToSize: newSize

"Truncate receiver by removing objects from the end of the set until it reaches a size
 of newSize.  Objects are removed in order, going from highest to lowest object ID.

 Returns the number of objects removed."

^self _2ArgPrim: 17 with: newSize
%

! Class implementation for 'GsDigitalEnvelope'

!		Class methods for 'GsDigitalEnvelope'

category: 'Examples'
classmethod: GsDigitalEnvelope
decryptExampleFromString: aPassiveObjString

"Takes a String produced by the encryptExample method and decodes the message."
| envelope privateKey msg verifyKey |

privateKey := GsTlsPrivateKey newFromPemString:
'-----BEGIN PRIVATE KEY-----
MIICdwIBADANBgkqhkiG9w0BAQEFAASCAmEwggJdAgEAAoGBAMBXQWaLW7QhuWvO
17X5c8LYDbw65if4QR2ATaNZ0Cq3Q6Q+aCsnmT1Q3AvKwUx0Y3PnASLLl0zNQN94
nbNP81vT/0D4J0Ch1HwGUErZReLDN2DSoUELdnmbrgR10Glriy3HD6wb0q+h/N45
8JpR6sTYhVlLtvnGYAJL2OW5kVRVAgMBAAECgYEAl6My+Hld7wG3gXstLVZhIXfc
PE3jLhfWnj+M9f/U0hhxx4c78OnjMigRk2piQrhvv+ybRKdlvTMEtioNilS58ogV
/I5dRoHsRd2opsUeDMloRdOMcL6HhinjGtPFqY/QXdeKKLLAfR2Mw1GKaro55hQv
DRqRk01Gd/KvWij5roECQQDz+9VW54+qolrDH2iw0BBeeYBog/ELA8vNw7te4OWH
0TrPHUDyvHkJCQ/GSWHLVQ2Rw/WoyKMTn7u/LF8pspp9AkEAydBN8IPdID8m5rk8
JYr1iPceAyoI5ZeUA1cqrFjx4HdtyVAuLGQAvVSY7fJaSzlrBeH8HVa3GlDJ3Qr1
Tt1wuQJAJnbhX14KTEBkRrbA7n8e1YYaNF/4tF/Y1YuyEncqOItH1jcqcho8iqwf
DIetHz09cmmOZRmcfA+GrdD0/8HkkQJANUUxvYHhFYj16MMOWE6Uv0GTf3xR+uCG
5lbU4cdcmUaNCS2L8pW3CELTV0O4h9CxKk1bchcYn+6hSiKBW/7hqQJBAKcucW2t
HDhYqOhZi+Eq+z7mnua7x867COGlijb3yE80rvmqBOOZc3PtJNr2SKQoBjD++B4w
HSedUWX12Gyb0SE=
-----END PRIVATE KEY-----' .

verifyKey := GsTlsPublicKey newFromPemString: '-----BEGIN PUBLIC KEY-----
MIGdMAsGCSqGSIb3DQEBCgOBjQAwgYkCgYEAwPc8s5Ox0/BOYYmH/UGHVXlcvsD2
dKu+9Plm2np4BZfjvitYEsobh+sOPJEauzx1UPxRb9vK4dk7NxBHKuHssjfDdD2A
lPUXoaGd3NzUWUHdznLwkkcbHHTbS/xiPT/FkxYM13yzUz3te0q0rQZiktpzQ8J2
qVo7m9joI7X5xVECAwEAAQ==
-----END PUBLIC KEY-----' .

envelope := (PassiveObject newWithContents: aPassiveObjString) activate.
msg := envelope decryptWithPrivateKey: privateKey
                withPublicVerificationKey: verifyKey .
^ msg
%

category: 'Decrypting'
classmethod: GsDigitalEnvelope
decryptMessage: aMsg withPrivateDecryptionKey: aGsTlsPrivateKey encryptedKey: aKey
initVector: anIv tag: aTag cipherId: anInt messageClassName: aString
digitalSignature: aSig withPublicVerificationKey: aPublicKey

"Decrypts the message and stores it in a new instance of the class with name
 aString, which must be a byte object class name.
 See the class comments for more information on GsDigitalEnvelopes."

^ self new encryptedKey: aKey ;
       	   cipherText: aMsg ;
	   initVector: anIv ;
	   cipherId: anInt ;
	   tag: aTag ;
	   messageClassName: aString ;
           digitalSignature: aSig ;
	   decryptWithPrivateKey: aGsTlsPrivateKey
           withPublicVerificationKey: aPublicKey
%

category: 'Examples'
classmethod: GsDigitalEnvelope
encryptExampleWithMessage: msg

"Create a GsDigitalEnvelope and passivate it to a string for transmission"

| publicKey envelope stream aSigningKey |

"Create RSA public key"
publicKey := GsTlsPublicKey newFromPemString:
'-----BEGIN PUBLIC KEY-----
MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDAV0Fmi1u0Iblrzte1+XPC2A28
OuYn+EEdgE2jWdAqt0OkPmgrJ5k9UNwLysFMdGNz5wEiy5dMzUDfeJ2zT/Nb0/9A
+CdAodR8BlBK2UXiwzdg0qFBC3Z5m64EddBpa4stxw+sG9KvofzeOfCaUerE2IVZ
S7b5xmACS9jluZFUVQIDAQAB
-----END PUBLIC KEY-----' .

aSigningKey := GsTlsPrivateKey newFromPemString:
'-----BEGIN PRIVATE KEY-----
MIICdQIBADALBgkqhkiG9w0BAQoEggJhMIICXQIBAAKBgQDA9zyzk7HT8E5hiYf9
QYdVeVy+wPZ0q770+WbaengFl+O+K1gSyhuH6w48kRq7PHVQ/FFv28rh2Ts3EEcq
4eyyN8N0PYCU9RehoZ3c3NRZQd3OcvCSRxscdNtL/GI9P8WTFgzXfLNTPe17SrSt
BmKS2nNDwnapWjub2OgjtfnFUQIDAQABAoGAVWbWwa9zO5aWSgrBWe+/gq/EwVPL
f9VnHSqoP7eGGQuhKtAqGZ7DUoNQeLPLveRDE8WoETaYcx5eW79jj/IPfAfKbgol
wrd+AxSGRcsK/Gskh6Drt84kCcAoXmhO/s0nfO8HgJ4cvyXWQw9l/ig8KFIl0bFd
M059mBIApIgKrTECQQDouAH+3oYk2hZ8Nlx/WmulW5JDqLAf7FR6PnclHnkM0/mC
GnYEuHlPzUakWepsaTUY8LCl3GpwfDx9U2NTt4hNAkEA1EUkzLd/YPs+9GzkL2W4
ot0sC/JujzDCWKB2d3RIRVo0pbW2pwUEQTy7f1fFpPo3qzJP1DrP+yLCAp3qxPVz
FQJBAJlEJrxOnZZDs69WthCB4odjCa9Zt7Uulmx0G0/tA9g4+wh+mN9/BxZRoYa4
WTXRDFFCo3R49/jhOY1oj/Ag3bkCQA0kwuSSMCb3J6zG2VI+ADLFcybCOipPoJkQ
RoWbA6aXsU7Zc5ff7aWEdy+pZamTfMLy+JJxmdM5Eb5LvO+5KwkCQQCWTte4IvnU
AkH1J5dEDWvpXXX/9NiTxCvdKFI2PJWxpsq6gSkoDwF2Vghe2a+ca1mQB6/HCftp
Ux5Vxey5pUsm
-----END PRIVATE KEY-----' .

"Create envelope"
envelope := GsDigitalEnvelope encryptMessage: msg
	       			 withPublicEncryptionKey: publicKey
				 cipherId: 10
                                 withPrivateSigningKey: aSigningKey.

stream := WriteStream on: String new.
"Convert to passive object format"
PassiveObject passivate: envelope toStream: stream .

"Ready for transport"
^ stream contents
%

category: 'Encrypting'
classmethod: GsDigitalEnvelope
encryptMessage: bytes withPublicEncryptionKey: aGsTlsPublicKey cipherId: anInt
withPrivateSigningKey: aSigningKey

"Encrypts the message in bytes and stores it into an instance of GsDigitalEnvelope.
 Returns the new instance or raises an exception on error.
 See the class comments for more information on GsDigitalEnvelopes."

^ (self encryptMessage: bytes withPublicEncryptionKeys: { aGsTlsPublicKey }
cipherId: anInt withPrivateSigningKey: aSigningKey) first
%

category: 'Encrypting'
classmethod: GsDigitalEnvelope
encryptMessage: bytes withPublicEncryptionKeys: arrayOfPubKeysOrCerts
cipherId: anInt withPrivateSigningKey: aSigningKey
"See the class comments for more information on GsDigitalEnvelopes."

^ self _primEncryptMessage: bytes withPublicEncryptionKeys: arrayOfPubKeysOrCerts
       cipherId: anInt withPrivateSigningKey: aSigningKey
%

category: 'Examples'
classmethod: GsDigitalEnvelope
example

| msg passiveString decryptedMsg |
msg := String withAll:
'Once upon a midnight dreary, while I pondered, weak and weary,
Over many a quaint and curious volume of forgotten lore-
While I nodded, nearly napping, suddenly there came a tapping,
As of some one gently rapping, rapping at my chamber door.
"Tis some visitor, " I muttered, "tapping at my chamber door-
Only this and nothing more."' .

passiveString := GsDigitalEnvelope encryptExampleWithMessage: msg .
decryptedMsg := GsDigitalEnvelope decryptExampleFromString: passiveString .
^ decryptedMsg = msg
%

category: 'Private'
classmethod: GsDigitalEnvelope
_primEncryptMessage: bytes withPublicEncryptionKeys: arrayOfPubKeysOrCerts
cipherId: anInt withPrivateSigningKey: aSigningKey

"A GsDigitalEnvelope is a class used to encrypt data with one or more public
 encryption keys such that the data may only be decrypted with one of the
 matching private keys. Only RSA public/private key pairs are supported.

 To create a secure digital envelope, a random session key and salt are
 created. The session key is then encrypted with each public key provided.

 bytes is message to be encrypted and must be a byte collection. Byte
 collections with a character size greater than one are accepted and will
 be converted to big endian format if necessary before encryption.

 arrayOfPubKeysOrCerts is an array containing at least 1 and no more than 16
 instances of GsTlsPublicKey or GsX509Certificate.

 cipherId determines which AEAD (Authenticated Encryption with Additional
 Data) cipher to use from the following list:

 ================================
                        Key Size
 opCode Cipher   Mode  bits/Bytes
 ================================
   4     AES     OCB     128/16
   5     AES     OCB     192/24
   6     AES     OCB     256/32
   7     AES     GCM     128/16
   8     AES     GCM     192/24
   9     AES     GCM     256/32
  10   CHACHA20 Poly1305 256/32
 ================================

 AEAD guarantees the message has not been altered. Modes 6 and 10 are thought
 to be the most secure and are recommended for most applications.

 aSigningKey must be an instance of GsTlsPrivateKey valid for generating
 digital signatures.

 Returns an Array of GsDigitalEnvelopes (one for each element of arrayOfKeys)
 upon success or raises and exception on error."

<primitive: 1088>
bytes _validateIsBytes .
arrayOfPubKeysOrCerts _validateClass: Array .
arrayOfPubKeysOrCerts size == 0
  ifTrue:[ arrayOfPubKeysOrCerts _error: #objErrCollectionEmpty].
arrayOfPubKeysOrCerts size > 16
  ifTrue:[ arrayOfPubKeysOrCerts _error: #errArgTooLarge args: {16 } ].
arrayOfPubKeysOrCerts do:[:e|
  e _validateClasses: { GsTlsPublicKey . GsX509Certificate } ; _validateIsRsa ] .
anInt _validateClass: SmallInteger .
((anInt < 4) or:[anInt > 10])
  ifTrue:[ anInt _error: #rtErrArgOutOfRange args:{ 4 . 10 } ] .
aSigningKey _validateClass: GsTlsPrivateKey ;
            _validateCreatesDigitalSignatures .
^ self _primitiveFailed:
  #_primEncryptMessage:withPublicEncryptionKeys:cipherId:withPrivateSigningKey:
%

!		Instance methods for 'GsDigitalEnvelope'

category: 'Accessing'
method: GsDigitalEnvelope
cipherId
  ^cipherId
%

category: 'Updating'
method: GsDigitalEnvelope
cipherId: anInt
  cipherId := anInt
%

category: 'Accessing'
method: GsDigitalEnvelope
cipherText
  ^cipherText
%

category: 'Updating'
method: GsDigitalEnvelope
cipherText: aByteArray
  cipherText := aByteArray
%

category: 'Decrypting'
method: GsDigitalEnvelope
decryptWithPrivateKey: aGsTlsPrivateKey withPublicVerificationKey: aPublicKey
"Decrypts the receiver using aGsTlsPrivateKey and stores it
 a new instance of the class name contained in messageClassName.

 All inst vars except for #publicEncryptionKey must be set correctly before
 invoking this method.

 Returns a new instance of messageClassName on success or raises
 an exception on error."
 | cls |
 cls := GsCurrentSession currentSession  objectNamed: self messageClassName  .
 ^ cls
      ifNil:[ self _error: #rtErrObjNotFound
                      args: { self messageClassName } ]
   ifNotNil:[ self _primDecryptWithPrivateKey: aGsTlsPrivateKey
                   into: cls basicNew
                   withPublicVerificationKey: aPublicKey ]
%

category: 'Accessing'
method: GsDigitalEnvelope
digitalSignature
  ^digitalSignature
%

category: 'Updating'
method: GsDigitalEnvelope
digitalSignature: aSig
  digitalSignature := aSig
%

category: 'Accessing'
method: GsDigitalEnvelope
encryptedKey
 ^encryptedKey
%

category: 'Updating'
method: GsDigitalEnvelope
encryptedKey: aByteArray
 encryptedKey := aByteArray
%

category: 'Accessing'
method: GsDigitalEnvelope
initVector
  ^initVector
%

category: 'Updating'
method: GsDigitalEnvelope
initVector: aByteArray
  initVector := aByteArray
%

category: 'Accessing'
method: GsDigitalEnvelope
messageClassName
  ^messageClassName
%

category: 'Updating'
method: GsDigitalEnvelope
messageClassName: aString
  messageClassName := aString
%

category: 'Accessing'
method: GsDigitalEnvelope
publicEncryptionKey
 ^publicEncryptionKey
%

category: 'Updating'
method: GsDigitalEnvelope
publicEncryptionKey: aGsTlsPublicKey
  publicEncryptionKey := aGsTlsPublicKey
%

category: 'Accessing'
method: GsDigitalEnvelope
tag
  ^tag
%

category: 'Updating'
method: GsDigitalEnvelope
tag: aByteArray
  tag := aByteArray
%

category: 'Private'
method: GsDigitalEnvelope
_primDecryptWithPrivateKey: aGsTlsPrivateKey into: aCharColl
withPublicVerificationKey: aPublicKey

<primitive: 1090>

"We don't care about publicEncryptionKey inst var for decryption"
aGsTlsPrivateKey _validateClass: GsTlsPrivateKey ; _validateIsRsa .
aPublicKey _validateClasses: { GsTlsPublicKey . GsX509Certificate } ;
           _validateValidatesDigitalSignatures .
aCharColl    _validateIsBytes .
encryptedKey _validateClass: ByteArray ; _validateNotEmpty .
cipherText   _validateClass: ByteArray ; _validateNotEmpty .
initVector   _validateClass: ByteArray ; _validateNotEmpty .
tag          _validateClass: ByteArray ; _validateNotEmpty .
digitalSignature _validateClass: ByteArray ; _validateNotEmpty .
cipherId     _validateClass: SmallInteger .
((cipherId < 4) or:[cipherId > 10])
  ifTrue:[ cipherId _error: #rtErrArgOutOfRange args:{ 4 . 10 } ] .
^ self _primitiveFailed:
  #_primDecryptWithPrivateKey:into:withPublicVerificationKey:
%

! Class implementation for 'GsFileIn'

!		Class methods for 'GsFileIn'

category: 'other'
classmethod: GsFileIn
fromClientPath: aString
"file in from path on session client machine into current session"

	self
		fromClientPath: aString
		to: nil.
%

category: 'other'
classmethod: GsFileIn
fromClientPath: aString to: anExternalSession

	self
		fromPath: aString
		on: #clientText
		to: anExternalSession.
%

category: 'other'
classmethod: GsFileIn
fromGciHostPath: aString

	self
		fromGciHostPath: aString
		to: nil.
%

category: 'other'
classmethod: GsFileIn
fromGciHostPath: aString to: anExternalSession

	self
		fromPath: aString
		on: #clientText
		to: anExternalSession.
%

category: 'other'
classmethod: GsFileIn
fromGemHostPath: aString

	self
		fromGemHostPath: aString
		to: nil.
%

category: 'other'
classmethod: GsFileIn
fromGemHostPath: aString to: anExternalSession

	self
		fromPath: aString
		on: #serverText
		to: anExternalSession.
%

category: 'other'
classmethod: GsFileIn
fromNestedClientPath: aString to: anExternalSession

	self
		fromNestedPath: aString
		on: #clientText
		to: anExternalSession.
%

category: 'other'
classmethod: GsFileIn
fromNestedPath: aString on: aFileType to: anExternalSession
"aString is file path to file containg topaz file-out format of smalltalk code.
type is either #clientFile or #serverFile to denote relative user action to use.
anExternal session is needed if file-in happens into that given session"

	| fileStream  |

	fileStream := FileStreamPortable read: aString type: aFileType.
	[ (self _fromStream: fileStream to: anExternalSession) 
         _clearTopazSessionState: false;
         doFileIn	] ensure: [fileStream close].
%

category: 'other'
classmethod: GsFileIn
fromNestedServerPath: aString to: anExternalSession

	self
		fromNestedPath: aString
		on: #serverText
		to: anExternalSession.
%

category: 'other'
classmethod: GsFileIn
fromPath: aString on: aFileType to: anExternalSession
"aString is file path to file containg topaz file-out format of smalltalk code.
type is either #clientFile or #serverFile to denote relative user action to use.
anExternal session is needed if file-in happens into that given session"

	| fileStream  |

	fileStream := FileStreamPortable read: aString type: aFileType.
	[ (self _fromStream: fileStream to: anExternalSession) doFileIn	] ensure: [fileStream close].
%

category: 'other'
classmethod: GsFileIn
fromServerPath: aString

	self
		fromServerPath: aString
		to: nil.
%

category: 'other'
classmethod: GsFileIn
fromServerPath: aString to: anExternalSession

	self
		fromPath: aString
		on: #serverText
		to: anExternalSession.
%

category: 'other'
classmethod: GsFileIn
new

	^super new
		initialize;
		yourself.
%

category: 'other'
classmethod: GsFileIn
_fromStream: aFileStream
"file in from a stream to current session"

	^self _fromStream: aFileStream to: nil
%

category: 'other'
classmethod: GsFileIn
_fromStream: aFileStream to: anExternalSessionOrNil
"anExternalSessionOrNil can be nil meaning file in will happen in current session"

	^self new
		fileStream: aFileStream;
		setSession: anExternalSessionOrNil;
		yourself
%

!		Instance methods for 'GsFileIn'

category: 'processing'
method: GsFileIn
abort

	^System abortTransaction
%

category: 'processing'
method: GsFileIn
abortTransaction

	^session abort
%

category: 'processing'
method: GsFileIn
category
	| cat |
	cat := (line copyFrom: 10 to: line size) trimSeparators.
	self currentCategory: cat
%

category: 'processing'
method: GsFileIn
classMethod

	currentClass isNil ifTrue: [self error: 'current class not defined'].
	self compileMethodIn: currentClass , ' class'.
%

category: 'processing'
method: GsFileIn
classMethod: aString

	aString ifNotNil:[ currentClass := aString ].
	self classMethod.
%

category: 'processing'
method: GsFileIn
commit

	^System commitTransaction
%

category: 'processing'
method: GsFileIn
commitTransaction

	^session commit
%

category: 'processing'
method: GsFileIn
compileEnvironment: arg

	arg isDigits ifFalse: [self error: 'ENV  only accepts integers'].
  compileEnvironment := arg .
%

category: 'processing'
method: GsFileIn
compileMethodIn: aClassContex
"compile method from stream in context of current class"

	| string |
	string := aClassContex , '
compileMethod: ' , self nextChunk printString , '
dictionaries: System myUserProfile symbolList
category: ' , category printString,
' environmentId: ', compileEnvironment.
	self execute: string.
%

category: 'processing'
method: GsFileIn
currentCategory: cat
  category := cat .
	cat isEmpty ifTrue: [self error: 'category is empty'].
	cat first = $' ifTrue: [
		cat last = $' ifFalse:[
      self error: 'category begins with quote but does not end with quote'
    ].
		category := cat copyFrom: 2 to: category size - 1.
	] ifFalse:[
    cat last = $' ifTrue:[
       self error: 'category ends with quote but does not start with quote'.
    ].
  ].
	(category includes: $') ifTrue:[ category := cat evaluate ].
%

category: 'processing'
method: GsFileIn
currentClass

	^currentClass
%

category: 'processing'
method: GsFileIn
currentClass: aClassName
    "The current category is cleared by the LOGOUT, LOGIN, SET CLASS,
    and SET SESSION commands. "

	currentClass:= aClassName.
	category := self _defaultCategory.
%

category: 'processing'
method: GsFileIn
doFileIn
[  lineNum := 0 .
	session isNil ifTrue: [self session: self].
	[
		fileStream atEnd not.
	] whileTrue: [
		line := fileStream nextLine trimSeparators.
    lineNum := lineNum + 1 .
		[
      self processLine
    ] on: Error do:[:ex | | ln |
      ln := ', at line ', lineNum asString .
      ex messageText ifNil:[ ex messageText: ln ]
                  ifNotNil:[:str | ex messageText:(str copy addAll: ln; yourself)].
      ex pass
    ]
	]
    ] ensure: [ 
      "topmost doFileIn should clear the topaz sesion state"
      self _clearTopazSessionState 
        ifTrue: [ 
          self currentProject: nil. 
          self currentPackage: nil ]
    ]
%

category: 'processing'
method: GsFileIn
doit

	self execute: self nextChunk.
%

category: 'processing'
method: GsFileIn
execute: aString

	| string result |
  session == self ifFalse:[
	  string := '[' , aString , '] on: Error do: [:ex | ^ex description]. nil'.
	  (result := session executeString: string) ifNotNil:[:aDescription |
      self error: aDescription .
      ^ Error signal: aDescription "do not expect to be here"
    ].
  ] ifTrue:[
    result := aString evaluate
  ].
  ^ result
%

category: 'processing'
method: GsFileIn
executeString:  string

	string evaluate.
	^nil
%

category: 'accessors'
method: GsFileIn
fileStream: aFileStream

	fileStream := aFileStream.
%

category: 'processing'
method: GsFileIn
ignoreList

	^#('EXPECTVALUE'
		'EXPECTERROR'
		'ERRORCOUNT'
		'FILEOUT'
		'FILEFORMAT'
		'DISPLAY'
		'LEVEL'
		'LIMIT'
		'LIST'
		'IFERR'
		'IFERR_LIST'
		'IFERR_CLEAR'
		'OMIT'
		'OUTPUT'
		'REMARK'
		'STATUS'
		'TIME')
%

category: 'Initialize'
method: GsFileIn
initialize

	session := self.
	category := self _defaultCategory.
	compileEnvironment := '0' .
%

category: 'processing'
method: GsFileIn
inputNestedFile: aPath
	"input nested file"

	| aSession isClient |
	session == self
		ifFalse: [ aSession := session ].
	isClient := (fileStream respondsTo: #'gsfile')
		ifTrue: [ fileStream gsfile isClient ]
		ifFalse: [ false ].
	isClient
		ifTrue: [ GsFileIn fromNestedClientPath: aPath to: aSession ]
		ifFalse: [ GsFileIn fromNestedServerPath: aPath to: aSession ]
%

category: 'processing'
method: GsFileIn
method

	currentClass isNil ifTrue: [self error: 'current class not defined'].
	self compileMethodIn: currentClass.
%

category: 'processing'
method: GsFileIn
method: aString

	aString ifNotNil:[ currentClass := aString ].
	self method.
%

category: 'processing'
method: GsFileIn
nextChunk

	| str |
	str := String new.
	[
		fileStream atEnd not.
	] whileTrue: [
		line := fileStream nextLine trimTrailingSeparators.
    lineNum := lineNum + 1 .
    (line notEmpty and: [line first = $%]) ifTrue: [
			^ str
		].
		str addAll: line; lf.
	].
	self error: 'ran off end of file!'.
%

category: 'processing'
method: GsFileIn
processLine
	| words command firstChar |
	line isEmpty ifTrue: [^self].
	(#('DOIT' 'PRINTIT' 'RUN' 'NBRUN') includes: line asUppercase) ifTrue: [^self doit].
	words := line subStrings.
	command := words first asUppercase.
	((firstChar := command at:1) == $! or:[ firstChar == $#])  ifTrue: [^nil].

	firstChar == $S ifTrue:[
	  command = 'SET' ifTrue: [
		  ((words at: 2) equalsNoCase: 'compile_env:') ifTrue:[
				words size == 3 ifFalse:[
					self error:'wrong number of arguments to SET COMPILE_ENV:'
				].
				^self compileEnvironment: (words at: 3)
			].
		  (((words at: 2) equalsNoCase: 'class')
			  or: [(words at: 2) equalsNoCase: 'class:']) ifTrue: [
				  words size == 3 ifFalse:[
					  self error:'wrong number of arguments to SET CLASS'
				  ].
				  ^self currentClass: (words at: 3)
           ].
		  (((words at: 2) equalsNoCase: 'category')
			  or: [(words at: 2) equalsNoCase: 'category:']) ifTrue: [
				  words size == 3 ifFalse:[
					  self error:'wrong number of arguments to SET CATEGORY'
				  ].
				  ^self currentCategory: (words at: 3)
			  ].
		  ((words at: 2) equalsNoCase: 'enableremoveall') ifTrue: [
				  words size == 3 ifFalse:[
					  self error:'wrong number of arguments to SET ENABLEREMOVEALL'
				  ].
				  ^self setEnableRemoveAll: ((words at: 3) equalsNoCase: 'on')
			  ].
		  (((words at: 2) equalsNoCase: 'project')
			  or: [(words at: 2) equalsNoCase: 'project:']) ifTrue: [
                  words size == 2 ifTrue: [ 
                      "clear current project"
                      ^self currentProject: nil ].
				  words size == 3 ifFalse:[
					  self error:'wrong number of arguments to SET PROJECT'
				  ].
				  ^self currentProject: (words at: 3)
			  ].
		  (((words at: 2) equalsNoCase: 'package')
			  or: [(words at: 2) equalsNoCase: 'package:']) ifTrue: [
                  words size == 2 ifTrue: [ 
                      "clear current package"
                      ^self currentPackage: nil ].
				  words size == 3 ifFalse:[
					  self error:'wrong number of arguments to SET PACKAGE'
				  ].
				  ^self currentPackage: (words at: 3)
			  ].
      #( 'comp' 'cla' 'cat' 'enable' 'proj' 'pack' ) do:[:str |
        ((words at: 2) at: 1 equals: str) ifTrue:[
           self error:'unrecognized SET ', (words at: 2) asString .
        ].
      ].
      GsFile gciLogServer: 'WARNING, unrecognized SET ', (words at: 2) asString.
		  ^nil
    ].
    command = 'SEND' ifTrue:[
      self _sendIsLegal ifFalse:[ self error: 'SEND not supported' ].
      words size > 3 ifTrue:[ self error:'more than 2 args to SEND'].
      ^ self execute: (words at: 2), ' ', (words at: 3)
    ]
  ].
  firstChar == $C ifTrue:[
	  (command = 'CATEGORY:' or: [command = 'CATEGORY']) ifTrue: [^self category].
	  command = 'CLASSMETHOD' ifTrue: [^self classMethod].
	  command = 'CLASSMETHOD:' ifTrue: [^self classMethod: (words atOrNil: 2)].
	  command = 'COMMIT' ifTrue: [^self commitTransaction].
  ].
  firstChar == $M ifTrue:[
	  command = 'METHOD' ifTrue: [^self method].
	  command = 'METHOD:' ifTrue: [^self method: (words atOrNil: 2)].
  ].
  firstChar == $E ifTrue:[
    command = 'ENV' ifTrue:[
      words size == 2 ifTrue:[ ^ self compileEnvironment: (words at: 2)].
      words size == 1 ifTrue:[ ^ nil "no change to env"].
      self error:'wrong number of arguments to ENV'.
    ].
   ].
	firstChar == $R ifTrue: [
		command = 'REMOVEALLMETHODS' ifTrue: [^self removeAllMethods: (words atOrNil: 2)].
		command = 'REMOVEALLCLASSMETHODS' ifTrue: [^self removeAllClassMethods: (words atOrNil: 2)].
	].
	firstChar == $A ifTrue: [
		command = 'ABORT' ifTrue: [^self abortTransaction].
	].
	firstChar == $I ifTrue: [
		command = 'INPUT' ifTrue: [words size == 1 ifTrue: [self error:'wrong number of arguments to input'].
		^self inputNestedFile: (words at: 2)].
	].
  ^(self ignoreList includes: command)
		ifTrue: [nil ]
		ifFalse: [self error:  'unrecognized command: ' , command printString ].
%

category: 'processing'
method: GsFileIn
removeAllClassMethods

	self removeAllEnabled ifFalse: [ ^ self ].
	currentClass isNil ifTrue: [self error: 'current class not defined'].
	self execute: currentClass ,' class removeAllMethods'.
%

category: 'processing'
method: GsFileIn
removeAllClassMethods: aClassName
"removes all  class methods for supplied class. Supplied class becomes current class"

	self removeAllEnabled ifFalse: [ ^ self ].
	aClassName notNil ifTrue: [currentClass := aClassName].
	currentClass isNil ifTrue: [self error: 'current class not defined'].
	self removeAllClassMethods
%

category: 'accessors'
method: GsFileIn
removeAllEnabled
	"if true (default), removeAllMethods is enabled"

	^ (self dynamicInstVarAt: #'enableRemoveAll') ~~ false
%

category: 'processing'
method: GsFileIn
removeAllMethods

	self removeAllEnabled ifFalse: [ ^ self ].
	currentClass isNil ifTrue: [self error: 'current class not defined'].
	self execute: currentClass , ' removeAllMethods'.
%

category: 'processing'
method: GsFileIn
removeAllMethods: aClassName
"remove all methods for supplied class. Supplied class becomes current class"

	self removeAllEnabled ifFalse: [ ^ self ].
	aClassName notNil ifTrue: [currentClass := aClassName].
	currentClass isNil ifTrue: [self error: 'current class not defined'].
	self removeAllMethods
%

category: 'accessors'
method: GsFileIn
session: anExternalSession
    "The current category is cleared by the LOGOUT, LOGIN, SET CLASS,
    and SET SESSION commands. "

	session := anExternalSession.
	category := self _defaultCategory.
%

category: 'accessors'
method: GsFileIn
setCurrentClass: aClassName
    "The current category is cleared by the LOGOUT, LOGIN, SET CLASS,
    and SET SESSION commands. "

	self currentClass: aClassName
%

category: 'accessors'
method: GsFileIn
setEnableRemoveAll: aBool
	"if true (default), removeAllMethods is enabled"

	self dynamicInstVarAt: #'enableRemoveAll' put: aBool
%

category: 'accessors'
method: GsFileIn
setSession: anExternalSession
    "The current category is cleared by the LOGOUT, LOGIN, SET CLASS,
    and SET SESSION commands. "

	self session: (anExternalSession ifNil: [self])
%

category: 'accessors'
method: GsFileIn
_clearTopazSessionState

	^ (self dynamicInstVarAt: #'_clearTopazSessionState') isNil
%

category: 'accessors'
method: GsFileIn
_clearTopazSessionState: aBool

	self dynamicInstVarAt: #'_clearTopazSessionState' put: aBool
%

category: 'private'
method: GsFileIn
_defaultCategory
	^ 'as yet unspecified'
%

category: 'private'
method: GsFileIn
_sendIsLegal
  ^ true
%

! Class implementation for 'GsHostProcess'

!		Class methods for 'GsHostProcess'

category: 'Instance creation'
classmethod: GsHostProcess
basicNew

"disallowed"

self shouldNotImplement: #basicNew
%

category: 'Instance creation'
classmethod: GsHostProcess
execute: commandLineString
 ^ self execute: commandLineString input: nil
%

category: 'Instance creation'
classmethod: GsHostProcess
execute: commandLineString input: stdinString
 "Executes commandLineString in a child process,
  writing stdinString to the stdin of the child.
  stdinString may be nil, in which case nothing is written to stdin of child
  If child returns non-zero exit status, signals an Error using
  contents of stderr from the child.  Otherwise returns a String
  containing stdout from the child.
  If child produces exit status
  zero and non-empty stderr the result is prefixed with
  'WARNING: <contents of stderr>' .
  Lookup in the PATH environment variable is not performed,
  the commandLineString must specify a complete path to an executable
  or script.

  Signals an error if the privilege NoPerformOnServer is true and
  commandLineString is not present in the whitelist of allowed commands
  for the session's UserProfile. See the methods in UserProfile under
  category PerformOnServer for more information."

  | arr out err result |
  arr := self _execute: commandLineString input: stdinString .
  out := arr at: 1 .
  err := arr at: 2 .
  err size > 0 ifTrue:[
    (result := 'WARNING: <' copy) addAll: err asString; add: '> ' ; lf;
      addAll: out .
  ] ifFalse:[
    result := out
  ].
  ^ result
%

category: 'Instance creation'
classmethod: GsHostProcess
fork: commandLineString
" Create a new instance of the receiver, fork a child process,
 and exec the commandLineString in the child.
 Utf16 command lines are not yet supported by the _fork: primitive.
 Lookup in the PATH environment variable is not performed,
 the commandLineString must specify a complete path to an executable
 or script to be exec'ed .
 If running in a topaz -l process and (GsFile stdin isTerminal == true)
 The child process will ignore SIGINT.

 Signals an error if the privilege NoPerformOnServer is true and
 commandLineString is not present in the whitelist of allowed commands
 for the session's UserProfile. See the methods in UserProfile under
 category PerformOnServer for more information."

  | inst |
  (inst := self _basicNew) _fork: commandLineString .
  ^ inst
%

category: 'Instance creation'
classmethod: GsHostProcess
new
  ^ self _basicNew
%

category: 'Private'
classmethod: GsHostProcess
_basicNew

"creates an instance registered with VM for finalization of cData"

<primitive: 674>
^ self _primitiveFailed: #_basicNew
%

category: 'Instance creation'
classmethod: GsHostProcess
_execute: commandLineString input: stdinString
 "Executes commandLineString in a child process .
  If stdinString ~~ nil, writes stdinString to the child's stdin.
  If child returns non-zero exit status, signals a ChildError using
  status and contents of stderr from the child.  
  Returns an Array of the form { stdout . stderr } .
  containing stdout and stderr from the child.

  Lookup in the PATH environment variable is not performed,
  the commandLineString must specify a complete path to an executable
  or script.

  Signals an error if the privilege NoPerformOnServer is true and
  commandLineString is not present in the whitelist of allowed commands
  for the session's UserProfile. See the methods in UserProfile under
  category PerformOnServer for more information."

  | inst out err status readDataBlk writeOfs nToWrite |
  writeOfs := 1 .
  nToWrite := stdinString size .
  (inst := self _basicNew) _fork: commandLineString .
  out := String new .
  err := String new .
  readDataBlk := [ | nRead |
    [ nRead := inst stdout _readInto: out startingAt: out size + 1  maxBytes: 16384 .
      nRead _isSmallInteger
    ] whileTrue .
    [ nRead := inst stderr _readInto: err startingAt: err size + 1  maxBytes: 16384 .
      nRead _isSmallInteger
    ] whileTrue .
  ].
  [ status := inst childStatus .
    status == nil
  ] whileTrue:[
    (nToWrite > 0 and:[ inst stdin writeWillNotBlock]) ifTrue:[ | nWrote |
      nWrote := inst stdin write: nToWrite from: stdinString startingAt: writeOfs .
      nWrote ifNil:[ Error signal:'lost stdin' , inst stdin lastErrorString ].
      writeOfs := writeOfs + nWrote .
      nToWrite := nToWrite - nWrote .
      nToWrite == 0 ifTrue:[ inst stdin close ].
    ].
    readDataBlk value .
    Delay waitForMilliseconds: 50 .
  ].
  readDataBlk value .
  status ~~ 0 ifTrue:[ 
    ChildError new status: status ; stderr: err ; signal
  ].
  ^ { out . err } .
%

!		Instance methods for 'GsHostProcess'

category: 'Status'
method: GsHostProcess
childHasExited
| s |
 s := self childStatus .
 s ifNil:[ ^ false "still running"].
 ^ (s  bitAnd: 16r200) == 0   "if not stopped with a signal it has exited"
%

category: 'Status'
method: GsHostProcess
childStatus
  "Returns nil if the child has not been reaped,
   or returns a SmallInteger as follows

  result == 0 means child exited with exit code of 0 .

  ((result bitAnd: 16r100) ~~ 0)  means child exited due to a signal
     and  (result bitAnd: 16rFF) is the number of the signal .

  ((result bitAnd: 16r200) ~~ 0) means child was stopped by a signal
     and  (result bitAnd: 16rFF) is the number of the signal .

  otherwize non-zero result means child exited with that error status."

  | s |
  (s := childStatus) ifNil:[
    s := self _waitChild: false  .
    s ifNotNil:[
      (s bitAnd: 16r200) == 0 ifTrue:[  "child exited"
        childStatus := s
        "in close . out close . err close ???" "close sockets to child"
      ]
    ].
  ].
  ^ s
%

category: 'Accessing'
method: GsHostProcess
commandLine
  "After fork: , returns the command line that was used to
   exec the child process."
  ^ cmd
%

category: 'Status'
method: GsHostProcess
killChild
  "Attempts to kill the child. Waits one second for child to go way.
   Returns child status. Reading from childs stdout or sterr after
   a kill may block due to no data available. (use GsSocket>>readWillNotBlock)"

^ self  _killChild: 1
%

category: 'Status'
method: GsHostProcess
killChild: timeoutSeconds
  "Attempts to kill the child. Waits specified time for child to go way.
   Returns child status. Reading from childs stdout or sterr after
   a kill may block due to no data available. (use GsSocket>>readWillNotBlock)"

  ^ self  _killChild: timeoutSeconds
%

category: 'Accessing'
method: GsHostProcess
processId
  "After fork: , returns a SmallInteger , the operating system
   process id of the child."
  ^ childPid
%

category: 'Accessing'
method: GsHostProcess
stderr
  "After fork: , returns a non-blocking read-only GsSocket
  representing the parent's end of a pipe (see   man 2 pipe )
  connected to stderr of the child.  If the GsSocket is not read
  from sufficiently to consume data, the child process may block
  waiting to write more data to its stderr ."
  ^ err
%

category: 'Accessing'
method: GsHostProcess
stdin
  "After fork: , returns a non-blocking write-only GsSocket
   representing the parent's end of a pipe (see   man 2 pipe )
   connected to stdin of the child.  The child's end of the pipe
   is blocking and a read by the child on stdin will block until
   Smalltalk code writes sufficient data to this GsSocket
   to satisfy the read."
  ^ in
%

category: 'Accessing'
method: GsHostProcess
stdout
  "After fork: , returns a non-blocking read-only GsSocket
  representing the parent's end of a pipe (see   man 2 pipe )
  connected to stdout of the child.  If the GsSocket is not read
  from sufficiently to consume data, the child process may block
  waiting to write more data to its stdout ."
  ^ out
%

category: 'Private'
method: GsHostProcess
_fork: commandLineString

"If running in a topaz -l process and (GsFile stdin isTerminal == true)
 The child process will ignore SIGINT.

 Signals an error if the privilege NoPerformOnServer is true and
 commandLineString is not present in the whitelist of allowed commands
 for the session's UserProfile. See the methods in UserProfile under
 category PerformOnServer for more information."

<primitive: 956>
commandLineString _validateClass: String .
self _primitiveFailed: #_fork: args: { commandLineString }
%

category: 'Status'
method: GsHostProcess
_killChild: timeoutSeconds
  "Attempts to kill the child. Waits specified time for child to go way.
   Returns child status."
  | s endMs |
  endMs := DateTime now asMillisecondsGmt + (1000 * timeoutSeconds).
  (s := childStatus) ifNil:[
     self _waitChild: true . "kill with SIGTERM"
     [
       Delay waitForMilliseconds:10.
       (s := self childStatus) ifNotNil:[ ^ s ].
       DateTime now asMillisecondsGmt < endMs
     ] whileTrue .
  ].
  ^ s
%

category: 'Private'
method: GsHostProcess
_waitChild: killBoolean

"calls waitpid() .
 If child is still running and killBoolean == true, attempts to kill
 the child with a SIGTERM.
 The return status is computed before attempting any kill of the child.

 Returns nil if child still running, otherwise returns a SmallInteger
 representing child status from waitpid() .

  result == 0 means child exited with exit code of 0 .

  ((result bitAnd: 16r100) ~~ 0)  means child exited due to a signal
     and  (result bitAnd: 16rFF) is the number of the signal .

  ((result bitAnd: 16r200) ~~ 0) means child was stopped by a signal
     and  (result bitAnd: 16rFF) is the number of the signal .

  otherwize non-zero result means child exited with that error status.
"
<primitive: 957>
killBoolean _validateClass: Boolean .
self _primitiveFailed: #_waitChild: args: { killBoolean }
%

! Class implementation for 'GsNetworkResourceString'

!		Class methods for 'GsNetworkResourceString'

category: 'Accessing'
classmethod: GsNetworkResourceString
currentGemHostName

	^System gemVersionReport at: #nodeName.
%

category: 'Accessing'
classmethod: GsNetworkResourceString
currentStoneHostName

  GsSession currentSession isSolo ifTrue:[ ^ 'localhost' ].

  ^System stoneVersionReport at: #nodeName
%

category: 'Accessing'
classmethod: GsNetworkResourceString
currentStoneName
	"The name of the current running stone, excluding host and other NRS information"

	^(System stoneName subStrings: $!) last
%

category: 'Instance Creation'
classmethod: GsNetworkResourceString
defaultGemNRSFromCurrent
	"Return a new gem NRS with the gem's host being the same as the current login.
      Use default gem service, and default netldi, or as set by environment variable GEMSTONE_NRS_ALL.
	Ignore any other parameters in the NRS of the current login"

	| netldiEnv |
	netldiEnv := self systemNetLDIName.
	^ self new
		node: self currentGemHostName;
		netldi: netldiEnv;
		resource: 'task';
		body: self defaultGemService;
    yourself
%

category: 'Defaults'
classmethod: GsNetworkResourceString
defaultGemService
	^'gemnetobject'
%

category: 'Defaults'
classmethod: GsNetworkResourceString
defaultNetLDIName
	^'gs64ldi'
%

category: 'Defaults'
classmethod: GsNetworkResourceString
defaultStoneName
	^'gs64stone'
%

category: 'Instance Creation'
classmethod: GsNetworkResourceString
defaultStoneNRSFromCurrent
	"Return a new stone NRS with the stone name and stone's host being the same as the current login.
	Ignore any other login parameters in the NRS of the current login"

	| stoneNameParts resourceParts protocolParts body resource node res |
	stoneNameParts := System stoneName subStrings: $!.
  stoneNameParts size >= 3 ifTrue:[
	  body := stoneNameParts at: 3.
	  resourceParts := (stoneNameParts at: 2) subStrings: $#.
	  resource := resourceParts last.
	  protocolParts := (resourceParts at: 1) subStrings: $@.
  ] ifFalse:[
    body := stoneNameParts at: 1.
    resource := 'server' .
  ].
	protocolParts size < 2 ifTrue:["handle default stone name of the form   '!#server!gs64stone' "
		node := self currentGemHostName	"if stone does not have host specified, uses gem host"
  ] ifFalse:[
    node := protocolParts at: 2
  ].
	(res := self new)
		node: node;
		resource: resource;
		body: body.
  ^ res
%

category: 'Instance Creation'
classmethod: GsNetworkResourceString
gemNRS

"Return a new basic gem NRS, which is only the gem service"

	^self new
		body: self defaultGemService;
		yourself.
%

category: 'Instance Creation'
classmethod: GsNetworkResourceString
gemNRSForNetLDI: nameOrPort

"Return a new gem NRS for a gem with the given netldi."

	^self new
		netldi: nameOrPort;
		body: self defaultGemService;
		yourself.
%

category: 'Instance Creation'
classmethod: GsNetworkResourceString
gemNRSForNetLDI: nameOrPort onHost: gemhostname

"Return a new gem NRS for a gem that will run on the given host, using the given netldi"

	^self new
		node: gemhostname;
		netldi: nameOrPort;
		body: self defaultGemService;
		yourself.
%

category: 'Instance Creation'
classmethod: GsNetworkResourceString
gemNRSForNetLDI: nameOrPort onHost: gemhostname gemService: customGemService

"Return a new gem NRS for a gem that will run on the given host, using the given netldi,
 and specifying the customGemService.  Options for <customGemService> are
 gemnetobject, gemnetdebug, or a custom script that starts up a gem."

	^self new
		node: gemhostname;
		netldi: nameOrPort;
		body: customGemService;
		yourself.
%

category: 'Instance Creation'
classmethod: GsNetworkResourceString
new

	^super new
		initialize;
		yourself.
%

category: 'Instance Creation'
classmethod: GsNetworkResourceString
stoneNRS
	"Return a new stone NRS for stone with default name."

	^self new
		body: self defaultStoneName;
		yourself
%

category: 'Instance Creation'
classmethod: GsNetworkResourceString
stoneNRSForStoneName: aStoneName
	"Return a new stone NRS with stone with the given name."

	^self new
		body: aStoneName;
		yourself
%

category: 'Instance Creation'
classmethod: GsNetworkResourceString
stoneNRSForStoneName: aStoneName onHost: stoneHostName
	"Return a new stone NRS with stone with the given name."

	^self new
		node: stoneHostName;
		body: aStoneName;
		yourself
%

category: 'Instance Creation'
classmethod: GsNetworkResourceString
systemNetLDIName

	| list ev |
  ev := System gemEnvironmentVariable: 'GEMSTONE_NRS_ALL' .
  ev ifNil:[ ^ self defaultNetLDIName ].
	list := (ev subStrings: $#) collect: [:nrs | nrs subStrings: $: ].
	^(list detect: [:nrs | nrs first matchPattern: #( 'netldi' ) ]
         ifNone: [ { self defaultNetLDIName } ]) last
%

!		Instance methods for 'GsNetworkResourceString'

category: 'Formatting'
method: GsNetworkResourceString
asString

	^self printString
%

category: 'Accessing'
method: GsNetworkResourceString
authorization
	"username [@password]
	 A valid user on the target network (default is the current user).
	 A valid password is needed only if the resource type requires authentication.
	 If no authentication information is specified, the system will try to get it from the .netrc file
		(this type of authorization is the default)."

	^authorization
%

category: 'Updating'
method: GsNetworkResourceString
authorization: aString
	"username [@password]
	 A valid user on the target network (default is the current user).
	 A valid password is needed only if the resource type requires authentication.
	 If no authentication information is specified, the system will try to get it from the .netrc file
		(this type of authorization is the default)."

	(aString isKindOf: String) ifFalse: [self error: 'parameter must be a String'].
	authorization := aString.
%

category: 'Updating'
method: GsNetworkResourceString
beEncrypted

	encrypted := true.
%

category: 'Updating'
method: GsNetworkResourceString
beNotEncrypted

	encrypted := false.
%

category: 'Accessing'
method: GsNetworkResourceString
body
	"The <body> is interpreted according to the context established by the <resource>.
	 No extended identifier expansion is done in the <body> and no special escapes are needed."

	^body.
%

category: 'Updating'
method: GsNetworkResourceString
body: aString
	"The <body> is interpreted according to the context established by the <resource>.
	 No extended identifier expansion is done in the body and no special escapes are needed."

	(aString isKindOf: String) ifFalse: [self error: 'parameter must be a String'].
	body := aString.
%

category: 'Accessing'
method: GsNetworkResourceString
dir
	"<dir> sets the default directory of the network resource.
	It has no effect if the resource already exists.
	If a directory is not set, the pattern %H is used.

	The string can contain patterns that are expanded in the context of the created resource.
	The following patterns are supported:
		%H	home directory
		%M	machine's network node name
		%N	executable's base name
		%P	process pid
		%U	user name
		%%	%"

	^dir
%

category: 'Updating'
method: GsNetworkResourceString
dir: aString
	"<dir> sets the default directory of the network resource.
	It has no effect if the resource already exists.
	If a directory is not set, the pattern %H is used.

	The string can contain patterns that are expanded in the context of the created resource.
	The following patterns are supported:
		%H	home directory
		%M	machine's network node name
		%N	executable's base name
		%P	process pid
		%U	user name
		%%	%"

	(aString isKindOf: String) ifFalse: [self error: 'parameter must be a String'].
	dir := aString.
%

category: 'Accessing'
method: GsNetworkResourceString
encrypted
	"Answer whether the authorization credentials are encrypted."

	^encrypted
%

category: 'Private'
method: GsNetworkResourceString
hasNrsHeader

	^(protocol , node , authorization , netldi , dir , log , resource)
		notEmpty
%

category: 'Private'
method: GsNetworkResourceString
initialize

	protocol := ''.
	node := ''.
	authorization := ''.
	encrypted := false.
	netldi := ''.
	dir := ''.
	log := ''.
	resource := ''.
	body := ''.
%

category: 'Accessing'
method: GsNetworkResourceString
log
	"<log> sets the name of the log file of the network resource.
	It has no effect if the resource already exists.
	If the log name is a relative path, it is relative to the working directory.
	If a log name is not set, the pattern '%N%P%M.log' is used.

	The string can contain patterns that are expanded in the context of the created resource.
	The following patterns are supported:
		%H	home directory
		%M	machine's network node name
		%N	executable's base name
		%P	process pid
		%U	user name
		%%	%"

	^log
%

category: 'Updating'
method: GsNetworkResourceString
log: aString
	"<log> sets the name of the log file of the network resource.
	It has no effect if the resource already exists.
	If the log name is a relative path, it is relative to the working directory.
	If a log name is not set, the pattern '%N%P%M.log' is used.

	The string can contain patterns that are expanded in the context of the created resource.
	The following patterns are supported:
		%H	home directory
		%M	machine's network node name
		%N	executable's base name
		%P	process pid
		%U	user name
		%%	%"


	(aString isKindOf: String) ifFalse: [self error: 'parameter must be a String'].
	log := aString.
%

category: 'Updating'
method: GsNetworkResourceString
nativeCodeConfig: anInt
 "Pass in the setting for GEM_NATIVE_CODE_ENABLED to use for the
  session, may be 0, 1, or 2."

  self body: (self body , ' -N ', anInt asString)
%

category: 'Accessing'
method: GsNetworkResourceString
netldi
	"Use the named GsNetLDI to service the request."

	^netldi
%

category: 'Updating'
method: GsNetworkResourceString
netldi: aString
	"Use the named GsNetLDI to service the request."

	(aString isKindOf: String) ifFalse: [self error: 'parameter must be a String'].
	netldi := aString.
%

category: 'Accessing'
method: GsNetworkResourceString
node
	"Specifies the host on which the resource exists.
	If no node is specified, the current machine's network node name is used.
	The identifier may be an Internet-style numeric address."

	^node
%

category: 'Updating'
method: GsNetworkResourceString
node: aString
	"Specifies the host on which the resource exists.
	If no node is specified, the current machine's network node name is used.
	The identifier may be an Internet-style numeric address."

	(aString isKindOf: String) ifFalse: [self error: 'parameter must be a String'].
	node := aString.
%

category: 'Formatting'
method: GsNetworkResourceString
printOn: aStream

	| bang |
	bang := self hasNrsHeader ifTrue: ['!'] ifFalse: [''].
	aStream nextPutAll: bang.
	self
		printSegment: node designated: '@' on: aStream;
		printSegment: authorization
			designated: (encrypted ifTrue: ['#encrypted:'] ifFalse: ['#auth:'])
			on: aStream;
		printSegment: netldi designated: '#netldi:' on: aStream;
		printSegment: dir designated: '#dir:' on: aStream;
		printSegment: log designated: '#log:' on: aStream;
		printSegment: resource designated: '#' on: aStream.
	aStream
		nextPutAll: bang;
		nextPutAll: body
%

category: 'Private'
method: GsNetworkResourceString
printSegment: aString designated: designationString on: aStream

	aString isEmpty ifTrue: [^self].
	aStream
		nextPutAll: designationString;
		nextPutAll: aString
%

category: 'Accessing'
method: GsNetworkResourceString
protocol
	"Only tcp is supported"

	^ 'tcp'
%

category: 'Updating'
method: GsNetworkResourceString
protocol: aString
   "The only supported protocol is TCP"

	(aString isKindOf: String)
		ifFalse: [self error: 'parameter must be a String'].
	((aString isEquivalent: 'TCP') or:[ aString = ''
	   or:[ aString isEquivalent: 'DEFAULT']])
		ifFalse: [self error: 'Invalid protocol: ' , aString].
	protocol := 'tcp'.
%

category: 'Accessing'
method: GsNetworkResourceString
resource
	"Identifies the intended purpose of the <body>.
	An NRS can contain only one resource modifier.
	The default resource modifier is context sensitive.
	For instance, if the system expects an NRS for a database file
	(say, in the context of copydbf), then the default is #dbf.

	'server' directs the GsNetLDI to search for the network address of a server,
	such as a GsStone or another GsNetLDI. If successful, it returns the address.
	The <body> is a network server name. A successful lookup means only
	that the service has been defined; it does not indicate whether the service
	is currently running. A new process will not be started.
	(Authorization is needed only if the GsNetLDI is on a remote node
	and is running in secure mode.)

	'task' starts a new Gem. The <body> is a GsNetLDI service name
	(such as 'gemnetobject'), followed by arguments to the command line.
	The GsNetLDI creates the named service by looking first for an entry in
	$GEMSTONE/bin/services.dat, and then in the user's home directory
	for an executable having that name.
	The GsNetLDI returns the network address of the service.
	(Authorization is needed to create a new process unless the GsNetLDI
	is in guest mode.)
	The 'task' resource modifier is also used internally to create page servers.

	'dbf' is used to access a database file. The <body> is the file spec
	of a GemStone dataabse file.
	The GsNetLDI creates a page server on the given node to access
	the database and returns the network address of the page server.
	(Authorization is needed unless the GsNetLDI is in guest mode.)

	'spawn' is used internally to start the garbage-collection Gem process.

	'monitor' is used internally to start up a shared page cache monitor.

	'file' means the nrs-body is the file spec of a file on the given host (not
	currently implemented)."

	^resource
%

category: 'Updating'
method: GsNetworkResourceString
resource: aString
	"Identifies the intended purpose of the <body>.
	An NRS can contain only one resource modifier.
	The default resource modifier is context sensitive.
	For instance, if the system expects an NRS for a database file
	(say, in the context of copydbf), then the default is #dbf.

	'server' directs the GsNetLDI to search for the network address of a server,
	such as a GsStone or another GsNetLDI. If successful, it returns the address.
	The <body> is a network server name. A successful lookup means only
	that the service has been defined; it does not indicate whether the service
	is currently running. A new process will not be started.
	(Authorization is needed only if the GsNetLDI is on a remote node
	and is running in secure mode.)

	'task' starts a new Gem. The <body> is a GsNetLDI service name
	(such as 'gemnetobject'), followed by arguments to the command line.
	The GsNetLDI creates the named service by looking first for an entry in
	$GEMSTONE/bin/services.dat, and then in the user's home directory
	for an executable having that name.
	The GsNetLDI returns the network address of the service.
	(Authorization is needed to create a new process unless the GsNetLDI
	is in guest mode.)
	The 'task' resource modifier is also used internally to create page servers.

	'dbf' is used to access a database file. The <body> is the file spec
	of a GemStone dataabse file.
	The GsNetLDI creates a page server on the given node to access
	the database and returns the network address of the page server.
	(Authorization is needed unless the GsNetLDI is in guest mode.)

	'spawn' is used internally to start the garbage-collection Gem process.

	'monitor' is used internally to start up a shared page cache monitor.

	'file' means the nrs-body is the file spec of a file on the given host (not
	currently implemented)."

	(aString isKindOf: String) ifFalse: [self error: 'parameter must be a String'].
	(#('server' 'task' 'dbf' 'spawn' 'monitor' 'file') includes: aString) ifFalse: [self error: 'Invalid resource: ', aString].
	resource := aString.
%

category: 'Updating'
method: GsNetworkResourceString
temporaryObjectCacheSize: sizeKB

  self body: (self body , ' -T ', sizeKB asString)
%

! Class implementation for 'GsObjectInventory'

!		Class methods for 'GsObjectInventory'

category: 'Garbage Analysis'
classmethod: GsObjectInventory
fastProfileGarbageFromFile: aFilename includeHiddenObjects: aBoolean

"Same as the #profileGarbageFromFile:includeHiddenObjects: method
 except the scan is performed  aggressively in order to complete
 in as little time as possible.

 This method may consume most or all host system resources while it
 is in progress."

System needsCommit
    ifTrue: [ self _error: #rtErrAbortWouldLoseData ] .
(GsBitmap newForHiddenSet: #GcCandidates) removeAll.
SystemRepository loadGcCandidatesFromFile: aFilename intoHiddenSet: #GcCandidates .
^ self _objInventory: SystemRepository _aggressiveMaxThreadCount waitForLock: 3 pageBufSize: 8
       percentCpuActiveLimit: 95 showHiddenClasses: aBoolean
       objsIn: (GsBitmap newForHiddenSet: #GcCandidates)
       listInstances: nil toFile: nil inMemoryOnly: false
%

category: 'Profiling'
classmethod: GsObjectInventory
fastProfileObjectsIn: aCollectionOrGsBitmap

"Same as the #profileObjectsIn: method except the scan is performed
 aggressively in order to complete in as little time as possible.

 This method may consume most or all host system resources while it
 is in progress."

| anArray objInvBm |
System needsCommit
  ifTrue: [ self _error: #rtErrAbortWouldLoseData ] .
(aCollectionOrGsBitmap isKindOf: GsBitmap)
  ifTrue: [ objInvBm := aCollectionOrGsBitmap ]
  ifFalse: [ anArray := aCollectionOrGsBitmap asArray.
             objInvBm := GsBitmap newForHiddenSet: #ObjInventory.
             objInvBm removeAll.
             objInvBm addAll: anArray ].

^ self _objInventory: SystemRepository _aggressiveMaxThreadCount waitForLock: 3 pageBufSize: 8
       percentCpuActiveLimit: 95 showHiddenClasses: true objsIn: objInvBm
       listInstances: nil toFile: nil inMemoryOnly: false
%

category: 'Profiling'
classmethod: GsObjectInventory
fastProfileObjectsInHiddenSet: hiddenSetSpecifier showHiddenClasses: aBool

"Same as the #profileObjectsInHiddenSet:showHiddenClasses: method
 except the scan is performed  aggressively in order to complete
 in as little time as possible.

 This method may consume most or all host system resources while it
 is in progress."

System needsCommit
    ifTrue: [ self _error: #rtErrAbortWouldLoseData ].

^ self _objInventory: SystemRepository _aggressiveMaxThreadCount waitForLock: 3 pageBufSize: 8
       percentCpuActiveLimit: 95 showHiddenClasses: aBool 
       objsIn: (GsBitmap newForHiddenSet: hiddenSetSpecifier)
       listInstances: nil toFile: nil inMemoryOnly: false
%

category: 'Repository Analysis'
classmethod: GsObjectInventory
fastProfileRepository

"Same as the #profileRepository method except the scan is performed
 aggressively in order to complete in as little time as possible.

 This method may consume most or all host system resources while it
 is in progress."

System needsCommit
    ifTrue: [ self _error: #rtErrAbortWouldLoseData ] .

^self _fastProfileRepositoryAndShowHiddenClasses: true
%

category: 'Repository Analysis'
classmethod: GsObjectInventory
fastProfileRepositoryAndSkipHiddenClasses

"Same as the #profileRepositoryAndSkipHiddenClasses method except the scan is performed
 aggressively in order to complete in as little time as possible.

 This method may consume most or all host system resources while it
 is in progress."

^self _fastProfileRepositoryAndShowHiddenClasses: false
%

category: 'Garbage Analysis'
classmethod: GsObjectInventory
profileGarbageFromFile: aFilename includeHiddenObjects: aBoolean

"Analyze the disconnected (garbage) objects in the repository using
 aFilename (an instance of String), which was produced by one of the
 Repository>>findDisconnectedObjectsAndWriteToFile: methods.  Only objects
 which still exist in the repository are analyzed.  Does not create
 references to any object in the file.

 Scans the entire repository and creates a profile by class of the objects
 in the file.  Returns a new instance of the receiver.

 DeadNotReclaimed objects (those pending garbage collection reclamation)
 are not included in the result.

 IMPORTANT:  This method stays in a transaction for its entire duration and
             is therefore not recommended for use on production systems.

 Requires the #GarbageCollection privilege.

 Acquires the garbage collection lock which prevents running garbage
 collection or other scans which requires the GC lock while this method
 is running.

 Raises error #rtErrGetGcLockFailed if the GC lock could not be acquired
 within 3 minutes.

 If this session contains uncommitted changes to the repository,
 the method  signals a error: #rtErrAbortWouldLoseData,
 to indicate that data could be lost. Otherwise
 it puts the session into auto-begin transaction mode and aborts."

System needsCommit
    ifTrue: [ self _error: #rtErrAbortWouldLoseData ] .
(GsBitmap newForHiddenSet: #GcCandidates) removeAll.
SystemRepository loadGcCandidatesFromFile: aFilename intoHiddenSet: #GcCandidates .
^ self _objInventory: SystemRepository getDefaultNumThreads waitForLock: 3 pageBufSize: 8
       percentCpuActiveLimit: 90 showHiddenClasses: aBoolean 
       objsIn: (GsBitmap newForHiddenSet: #GcCandidates)
       listInstances: nil toFile: nil inMemoryOnly: false
%

category: 'Repository Analysis'
classmethod: GsObjectInventory
profileMemory

"Scans this session's temporary object memory and creates a profile by class.
 Returns a new instance of the receiver.

 Counts the number of instances and total physical bytes occupied
 for objects in memory.
"

^ self _objInventory: SystemRepository getDefaultNumThreads waitForLock: 3 pageBufSize: 8
       percentCpuActiveLimit: 90 showHiddenClasses: true objsIn: (GsBitmap new)
       listInstances: nil toFile: nil inMemoryOnly: true
%

category: 'Profiling'
classmethod: GsObjectInventory
profileObjectsIn: aCollectionOrGsBitmap

"Generate a profile of the objects in the given collection.
 The collection must not contain any special objects, otherwise
 an error will be raised.

 The argument may be either a collection or a GsBitmap.

 Returns an instance of the receiver."

| anArray objInvBm |
System needsCommit
  ifTrue: [ self _error: #rtErrAbortWouldLoseData ] .


(aCollectionOrGsBitmap isKindOf: GsBitmap)
  ifTrue: [ objInvBm := aCollectionOrGsBitmap ]
  ifFalse: [ anArray := aCollectionOrGsBitmap asArray.
             objInvBm := GsBitmap newForHiddenSet: #ObjInventory.
             objInvBm removeAll.
             objInvBm addAll: anArray ].

^ self _objInventory: SystemRepository getDefaultNumThreads waitForLock: 3 pageBufSize: 8
       percentCpuActiveLimit: 90 showHiddenClasses: true objsIn: objInvBm
       listInstances: nil toFile: nil inMemoryOnly: false
%

category: 'Profiling'
classmethod: GsObjectInventory
profileObjectsIn: aCollectionOrGsBitmap threads: numThreads

" Same as profileObjectsIn: except that it allows specifying the number of threads to use for the scan.
 The number of threads can be overridden for any other profiling method by executing:
    SystemRepository setDefaultNumThreads: numThreads
 before executing the method.
"

| anArray objInvBm |
System needsCommit
  ifTrue: [ self _error: #rtErrAbortWouldLoseData ] .

(aCollectionOrGsBitmap isKindOf: GsBitmap)
  ifTrue: [ objInvBm := aCollectionOrGsBitmap ]
  ifFalse: [ anArray := aCollectionOrGsBitmap asArray.
             objInvBm := GsBitmap newForHiddenSet: #ObjInventory.
             objInvBm removeAll.
             objInvBm addAll: anArray ].

^self _objInventory: numThreads waitForLock: 3 pageBufSize: 8
       percentCpuActiveLimit: 90 showHiddenClasses: true objsIn: objInvBm
       listInstances: nil toFile: nil inMemoryOnly: false
%

category: 'Profiling'
classmethod: GsObjectInventory
profileObjectsInHiddenSet: hiddenSetSpecifier showHiddenClasses: aBool

"Generate a profile of the objects in the given hidden set which
 exist and for which the session has permission to read.  Objects
 which do not meet these criteria are silently omitted from the result.

 The hiddenSetSpecifer is from GsBitmap, e.g. #ListInstances.

 This method does not alter the contents of the hidden set.

 Returns an instance of the receiver.

 If this session contains uncommitted changes to the repository,
 the method  signals a error: #rtErrAbortWouldLoseData,
 to indicate that data could be lost. Otherwise
 it puts the session into auto-begin transaction mode and aborts."

System needsCommit
    ifTrue: [ self _error: #rtErrAbortWouldLoseData ].

^ self _objInventory: SystemRepository getDefaultNumThreads waitForLock: 3 pageBufSize: 8
       percentCpuActiveLimit: 90 showHiddenClasses: aBool 
       objsIn: (GsBitmap newForHiddenSet: hiddenSetSpecifier)
       listInstances: nil toFile: nil inMemoryOnly: false
%

category: 'Repository Analysis'
classmethod: GsObjectInventory
profileRepository

"Scans the entire repository and creates a profile by class.  Returns a new
 instance of the receiver.

 Counts the number of instances and total physical bytes occupied of each
 class in the repository with one or more instances.

 Objects which are pending garbage collection reclamation are not included
 in the result.

 Acquires the garbage collection lock which prevents running garbage
 collection or other scans which require the GC lock while this method
 is running.

 Raises error #rtErrGetGcLockFailed if the GC lock could not be acquired
 within 3 minutes.

 If this session contains uncommitted changes to the repository,
 the method  signals a error: #rtErrAbortWouldLoseData,
 to indicate that data could be lost. Otherwise
 it puts the session into auto-begin transaction mode and aborts."

System needsCommit
    ifTrue: [ self _error: #rtErrAbortWouldLoseData ] .

^self _profileRepositoryAndShowHiddenClasses: true
%

category: 'Repository Analysis'
classmethod: GsObjectInventory
profileRepositoryAndListInstancesInPageOrder: anArrayOfClasses toFile: aString

"Combines the functions of the following methods in a single scan of the
 repository:

   GsObjectInventory>>profileRepository
   Repository>>listInstancesInPageOrder: toFile:

 Refer to the comments in these methods for more information.

 Requires the #GarbageCollection privilege.

 Acquires the garbage collection lock which prevents running garbage
 collection or other scans which requires the GC lock while this method
 is running.

 Raises error #rtErrGetGcLockFailed if the GC lock could not be acquired
 within 3 minutes.

 Aborts the current transaction.   If this session contains uncommitted
 changes to the repository, the method  signals a error:
 #rtErrAbortWouldLoseData, to indicate that data could be lost. Otherwise
 it puts the session into auto-begin transaction mode and aborts.

 Returns an Array containing 2 elements:
  [1] - An new instance of the receiver.
  [2] - An Integer indicating the number of object identifiers written
        to the file."

| idSet objinv count |
System needsCommit
  ifTrue: [ self _error: #rtErrAbortWouldLoseData ] .

idSet := IdentitySet withAll: anArrayOfClasses .
objinv :=  self _objInventory: SystemRepository getDefaultNumThreads waitForLock: 3 pageBufSize: 8
       percentCpuActiveLimit: 90 showHiddenClasses: true
       objsIn: (GsBitmap new)
       listInstances: idSet toFile: aString inMemoryOnly: false .
count := 0.
objinv entriesByCount do: [:entry |
  (idSet includes: (entry theClass))
     ifTrue: [ count := count + (entry instanceCount)]].
^ Array with: objinv with: count
%

category: 'Repository Analysis'
classmethod: GsObjectInventory
profileRepositoryAndSkipHiddenClasses

"Performs the same function as the #profileRepository method except that
 statistics for GemStone private classes (e.g. LargeObjectNode,
 NscSetLeaf, etc) are not shown.  In effect, instances of private classes
 are ignored during the scan.  However the approximate physical space
 occupied by private objects is included in the physical size of the
 private object's root object, which will always be a public class.
 For example, the approximate physical bytes consumed by a NscSetLeaf object
 will be included in the physical size reported for root object, which will be
 an IdentitySet (or a subclass of IdentitySet)."

^self _profileRepositoryAndShowHiddenClasses: false
%

category: 'Repository Analysis'
classmethod: GsObjectInventory
profileRepositoryAndSkipHiddenClassesAndListInstancesInPageOrder: anArrayOfClasses toFile: aString

"Combines the functions of the following methods in a single scan of the
 repository:

   GsObjectInventory>>profileRepositoryAndSkipHiddenClasses
   Repository>>listInstancesInPageOrder: toFile:

 Refer to the comments in these methods for more information.

 Requires the #GarbageCollection privilege.

 Acquires the garbage collection lock which prevents running garbage
 collection or other scans which requires the GC lock while this method
 is running.

 Raises error #rtErrGetGcLockFailed if the GC lock could not be acquired
 within 3 minutes.

 Aborts the current transaction.   If this session contains uncommitted
 changes to the repository, the method  signals a error:
 #rtErrAbortWouldLoseData, to indicate that data could be lost. Otherwise
 it puts the session into auto-begin transaction mode and aborts.

 Returns an Array containing 2 elements:
  [1] - An new instance of the receiver.
  [2] - An Integer indicating the number of object identifiers written
        to the file."

| idSet objinv count |
System needsCommit
  ifTrue: [ self _error: #rtErrAbortWouldLoseData ] .

idSet := IdentitySet withAll: anArrayOfClasses .
objinv :=  self _objInventory: SystemRepository getDefaultNumThreads
       waitForLock: 3 pageBufSize: 8
       percentCpuActiveLimit: 90 showHiddenClasses: false
       objsIn: (GsBitmap new)
       listInstances: idSet toFile: aString inMemoryOnly: false .
count := 0.
objinv entriesByCount do: [:entry |
  (idSet includes: (entry theClass))
     ifTrue: [ count := count + (entry instanceCount)]].
^ Array with: objinv with: count
%

category: 'Private'
classmethod: GsObjectInventory
_fastProfileRepositoryAndShowHiddenClasses: aBoolean

System needsCommit
  ifTrue: [ self _error: #rtErrAbortWouldLoseData ] .

^ self _objInventory: SystemRepository _aggressiveMaxThreadCount waitForLock: 3 pageBufSize: 8
       percentCpuActiveLimit: 95 showHiddenClasses: aBoolean
       objsIn: (GsBitmap new) listInstances: nil toFile: nil inMemoryOnly: false
%

category: 'Private'
classmethod: GsObjectInventory
_objInventory: maxSessions waitForLock: lockWaitTime 
      pageBufSize: aBufSize percentCpuActiveLimit: percentCpu
      showHiddenClasses: aBoolean objsIn: aGsBitmap
      listInstances: anIDSetOfClasses toFile: aFileName
      inMemoryOnly: inMemBoolean

" This primitive method performs a scan of the Repository.
  If inMemBoolean==true the scan only looks at temporary object memory,
  otherwise the scan only looks at committed objects .

  This primitive uses a multi-threaded algoritm to sweep the active
  data pages in the repository to gather the information requested.

  The maxSessions argument specifies the maximum number of slave sessions
  (threads) that will be used during the operation.  The actual number of
  active threads can be adjusted to a lower value automatically at runtime
  by the main thread based on the percentCpuActiveLimit and by the user
  by interactively setting the mtThreadLimit (see details below).

  The lockWaitTime argument is used to specify how many seconds method should
  wait while attempting to acquire the gcLock.  No other garbage collection
  operations may be started or in progress while this method is running.
  Objects in the possibleDead or deadNotReclaimed sets at the start of
  the scan are ignored by the scan.

  The pageBufSize, which must be a power of two, specifies the number
  of pages to buffer per thread. This parameter in conjunction with the
  maxSessions largely determines the memory footprint needed to perform
  this operation.  The pageBufSize doesn't have much impact on the
  performance of the scan, so a default size of 8 is probably sufficient.

  The percentCpu specifies a level of total cpu activity at which the
  algorithm automatically inactivates threads to prevent overload
  of system resources.

  This algorithm makes use of additional sessions (threads) to achieve
  significant performance improvements.  It also makes space/time trade offs
  so that heap memory in addition to the TemporaryObjectCache (TOC)
  resources are used.  In fact, this algorithm doesn't require much TOC,
  except for the operations that return array results, so configuring this
  process for a smaller TOC space is advantageous.

  The memory space that is needed is variable and depends upon number of
  instances being searched for, the number found, the number of sessions
  requested and the pageBufSize specified for each.

  The objsIn: argument is a GsBitmap that specifies the objects to inventory.
  specifier, e.g. #ListInstances.

  If aGsBitmap is non empty, then only objects in the hidden set are included 
  in the results.

  If the hiddenSetSpecifier is not an empty GsBitmap, then only objects in the hidden set
  are included in the results.

  If aGsBitmap is not #GcCandidates, then the primitive a assumes that it 
  is analyzing the contents of a collection and performs the scan in a transaction 
  which can cause a large commit record backlog if the set is large and there is 
  a lot of commit activity.  Otherwise, the operation can cause the session to 
  abort to prevent a commit record backlog during the scan.

  If inMemBoolean == true, ignores arguments
     maxSessions, lockWaitTime, aBufSize, percentCpu
     aGsBitmap, aBoolean, aFileName
  and reports on the in-memory objects of this session .

  The anIDSetOfClasses and aFileName arguments are used for the combined
  functions of profiling the repository and listing specified instances.

  See the profileRepository* methods below.
"

<primitive: 897>
  | maxInt |
  maxInt := SmallInteger maximum32bitInteger .
  maxSessions _validateClass: SmallInteger; _validateMin: 1 max: maxInt .
  lockWaitTime _validateClass: SmallInteger ; _validateMin: -1 max: maxInt .
  aBufSize _validateClass: SmallInteger; _validateIsPowerOf2 .
  Repository _validatePercentage: percentCpu  .
  aBoolean _validateClass: Boolean.
  aGsBitmap _validateClass: GsBitmap .
  anIDSetOfClasses _validateInstanceOf: IdentitySet.
  aFileName _validateKindOfClass: String.
^ self _primitiveFailed: #_objInventory:waitForLock:pageBufSize:percentCpuActiveLimit:showHiddenClasses:objsIn:listInstances:toFile:inMemoryOnly:
       args: { maxSessions . lockWaitTime . aBufSize .
               percentCpu . aBoolean . aGsBitmap .
               anIDSetOfClasses . aFileName . inMemBoolean }
%

category: 'Private'
classmethod: GsObjectInventory
_profileRepositoryAndShowHiddenClasses: aBoolean

System needsCommit
  ifTrue: [ self _error: #rtErrAbortWouldLoseData ] .

^ self _objInventory: SystemRepository getDefaultNumThreads waitForLock: 3 pageBufSize: 8
       percentCpuActiveLimit: 90 showHiddenClasses: aBoolean
       objsIn: (GsBitmap new)
       listInstances: nil toFile: nil inMemoryOnly: false
%

!		Instance methods for 'GsObjectInventory'

category: 'Formatting'
method: GsObjectInventory
asString

| sz result|
sz := self entriesByCount size.
result := String new.
result addAll: 'a'; addAll: self class name; addAll: ' of '; addAll: sz asString; addAll: ' classes.'.
^result
%

category: 'Reporting'
method: GsObjectInventory
byteCountReport
	^self byteCountReportDownTo: 0
%

category: 'Reporting'
method: GsObjectInventory
byteCountReportDownTo: minCountToReport

"Return a String showing the receiver in tabular form sorted by instance count."

| totalBytes totalCount result tmp lf array line space|
lf := Character lf.
space := Character space.
result := String new.
tmp := String withAll: '*** GsObjectInventory byteCountReport printed at: '.
tmp addAll: DateTime now asString.
tmp addAll: ' ***'.
result addLineWith: tmp centeredToWidth: 80 ;
       add: lf.
result addAll: 'Hidden classes are '.
self includeHiddenClasses
  ifFalse:[ result addAll: 'not '.].
result addAll: 'included in this report.'; add: lf.
line := String new.
80 timesRepeat:[line add: $_].
line add: lf.
result addAll: line.

result 	addAll: ((String withAll: 'Class') width: 50; yourself); add: space;
		addAll: ((String withAll: 'Instances') width: -14; yourself); add: space;
		addAll: ((String withAll: 'Bytes') width: -14; yourself); add: lf.
result addAll: line.
totalBytes := 0.
totalCount := 0.
array := self entriesByBytes.
1 to: array size do:[:n| |entry|
  entry := array at: n.
  (entry byteCount < minCountToReport)
	ifTrue:[result addAll: line.
		^result ].
  result addAll: (entry theClass name asString width: 50); add: space;
		addAll: (entry instanceCount asString width: -14); add: space;
		addAll: (entry byteCount asString width: -14); add: lf.
  totalCount := totalCount + entry instanceCount.
  totalBytes := totalBytes + entry byteCount.
].
result addAll: line.
result 	addAll: ((String withAll: 'Totals') width: 50; yourself); add: space;
        addAll: (totalCount asString width: -14) ; add: space;
        addAll: (totalBytes asString width: -14); add: lf.
result addAll: line.
^result
%

category: 'Accessing'
method: GsObjectInventory
entriesByBytes

^entriesByBytes
%

category: 'Updating'
method: GsObjectInventory
entriesByBytes: newValue

entriesByBytes := newValue
%

category: 'Accessing'
method: GsObjectInventory
entriesByCount

^entriesByCount
%

category: 'Updating'
method: GsObjectInventory
entriesByCount: newValue

entriesByCount := newValue
%

category: 'Accessing'
method: GsObjectInventory
includeHiddenClasses

^includeHiddenClasses
%

category: 'Updating'
method: GsObjectInventory
includeHiddenClasses: newValue

includeHiddenClasses := newValue
%

category: 'Reporting'
method: GsObjectInventory
instanceCountReport

"Return a String showing the receiver in tabular form sorted by instance count."
^self instanceCountReportDownTo: 0
%

category: 'Reporting'
method: GsObjectInventory
instanceCountReportDownTo: minCountToReport

"Return a String showing the receiver in tabular form sorted by instance count."
| totalCount totalBytes result tmp lf array line space|
lf := Character lf.
space := Character space.
result := String new.
tmp := String withAll: '*** GsObjectInventory instanceCountReport printed at: '.
tmp addAll: DateTime now asString.
tmp addAll: ' ***'.
result addLineWith: tmp centeredToWidth: 80 ;
       add: lf.
result addAll: 'Hidden classes are '.
self includeHiddenClasses
  ifFalse:[ result addAll: 'not '.].
result addAll: 'included in this report.'; add: lf.

line := String new.
80 timesRepeat:[line add: $_].
line add: lf.
result addAll: line.
result 	addAll: ((String withAll: 'Class') width: 50; yourself); add: space;
		addAll: ((String withAll: 'Instances') width: -14; yourself); add: space;
		addAll: ((String withAll: 'Bytes') width: -14; yourself); add: lf.
result addAll: line.
array := self entriesByCount.
totalCount := 0.
totalBytes := 0.
1 to: array size do:[:n| |entry|
  entry := array at: n.
  (entry instanceCount < minCountToReport)
	ifTrue:[	result addAll: line.
			^result
	].
  result addAll: (entry theClass name asString width: 50); add: space;
		addAll: (entry instanceCount asString width: -14); add: space;
		addAll: (entry byteCount asString width: -14); add: lf.
  totalCount := totalCount + entry instanceCount.
  totalBytes := totalBytes + entry byteCount.
].
result addAll: line.
result 	addAll: ((String withAll: 'Totals') width: 50; yourself); add: space;
        addAll: (totalCount asString width: -14) ; add: space;
        addAll: (totalBytes asString width: -14); add: lf.
result addAll: line.
^result
%

! Class implementation for 'GsObjectInventoryEntry'

!		Instance methods for 'GsObjectInventoryEntry'

category: 'Formatting'
method: GsObjectInventoryEntry
asString

| result myName |
myName := self class name.
result := String new.
self theClass == nil
	ifTrue:[result addAll: 'An empty '; addAll: myName ]
	ifFalse:[ result addAll: 'a'; addAll: myName; addAll: ' for '; addAll: self theClass name].
^result

%

category: 'Accessing'
method: GsObjectInventoryEntry
byteCount

^byteCount
%

category: 'Updating'
method: GsObjectInventoryEntry
byteCount: newValue

byteCount := newValue
%

category: 'Accessing'
method: GsObjectInventoryEntry
instanceCount

^instanceCount
%

category: 'Updating'
method: GsObjectInventoryEntry
instanceCount: newValue

instanceCount := newValue
%

category: 'Accessing'
method: GsObjectInventoryEntry
theClass

^theClass
%

category: 'Updating'
method: GsObjectInventoryEntry
theClass: newValue

theClass := newValue
%

! Class implementation for 'GsPackageLibrary'

!		Class methods for 'GsPackageLibrary'

category: 'Operations'
classmethod: GsPackageLibrary
createPackageNamed: aSymbol

    | package packageLibrary |
    package := self packageNamed: aSymbol.
    package ~~ nil ifTrue: [ ^package ].
    packageLibrary := self packageLibrary.
    packageLibrary createDictionaryNamed: aSymbol at: 1.
    ^GsPackage installIn: (packageLibrary objectNamed: aSymbol).
%

category: 'Private - Installation Support'
classmethod: GsPackageLibrary
getMonticelloRepositoryDirectory
| basePath |
basePath := self getSeasideDirectory .
basePath ==  nil
  ifTrue:[ ^nil ] .
basePath addAll: 'monticello/repository/' .
^ basePath
%

category: 'Private - Installation Support'
classmethod: GsPackageLibrary
getSeasideDirectory
| basePath |
basePath := System gemEnvironmentVariable: 'SEASIDE'.
basePath == nil
 ifTrue:[
   basePath := System gemEnvironmentVariable: 'GEMSTONE'.
   basePath == nil
     ifTrue:[^nil]
     ifFalse:[basePath addAll: '/seaside/'].
  ]
  ifFalse:[
    basePath last == $/
      ifFalse: [ basePath add: $/ ].
  ].
^basePath
%

category: 'private'
classmethod: GsPackageLibrary
installMonticelloPackagesDuring: aBlock
        "install the libraries #'SessionMethods' and #'Monticell_Methods'.
         Enable #'SessionMethods' and configure for new classes to be installed into UserGlobals.
         Evaluate <aBlock> with the SymbolDictionary named #'Monticello_Globals' as the argument.
         Uninstall the library #'Monticell_Methods', but leave #'SessionMethods' enabled"

        ^self
            installMonticelloPackagesHome: (GsCurrentSession currentSession objectNamed: #UserGlobals)
            during: aBlock
%

category: 'private'
classmethod: GsPackageLibrary
installMonticelloPackagesHome: homeSymbolDict during: aBlock
        "install the libraries #'SessionMethods' and #'Monticell_Methods'.
         Enable #'SessionMethods' and configure for new classes to be installed into <homeSymbolDict>.
         Evaluate <aBlock> with the SymbolDictionary named #'Monticello_Globals' as the argument.
         Uninstall the library #'Monticell_Methods', but leave #'SessionMethods' enabled"

	| policy methodsPackage sessionMethodsPackage preInstalled enabled |
	methodsPackage := self packageNamed: #'Monticello_Methods'.
	sessionMethodsPackage := GsPackageLibrary createPackageNamed: #SessionMethods.
	preInstalled := (self userSymbolList objectNamed: methodsPackage symbolDict name) ~~ nil.
	enabled := GsPackagePolicy current enabled.

	[
	preInstalled
		ifTrue: [ enabled ifFalse: [ GsPackagePolicy current enable ] ]
		ifFalse: [
			self installPackage: sessionMethodsPackage.
			self installPackage: methodsPackage ].

	policy := GsPackagePolicy current.
	policy homeSymbolDict:  homeSymbolDict.
	policy externalSymbolList: Array new.

	aBlock value: (self packageNamed: #'Monticello_Globals') ]
		ensure: [
			preInstalled ifFalse: [ self uninstallPackage: methodsPackage ].
			enabled ifFalse: [ GsPackagePolicy current disable ] ].

%

category: 'Operations'
classmethod: GsPackageLibrary
installPackage: aPackage

    	self installPackage: aPackage enable: true
%

category: 'Operations'
classmethod: GsPackageLibrary
installPackage: aPackage enable: aBool

    	| symDict pkgDict |
    	symDict := aPackage symbolDict.
	pkgDict := Globals.
    	aPackage prereqs do: [:symbolDict |  | p |
     		p := symbolDict at: aPackage class globalName otherwise: nil.
        	p ~~ nil
			ifTrue: [ self installPackage: p  enable: false ].
		(self userSymbolList indexOf: symbolDict) < (self userSymbolList indexOf: pkgDict)
			ifTrue: [ pkgDict := p symbolDict ].
    	].
	(self userSymbolList objectNamed: symDict name) == nil
		ifTrue: [ self userSymbolList add: symDict before: pkgDict ].
	(self sessionSymbolList objectNamed: symDict name) == nil
		ifTrue: [ self  sessionSymbolList add: symDict before: pkgDict ].
	aBool
		ifTrue: [ | policy |
			policy := GsPackagePolicy current.
			policy enable.
			policy homeSymbolDict:  aPackage symbolDict.
			policy externalSymbolList: (self sessionSymbolList asArray copyWithout: aPackage symbolDict).
		].
%

category: 'Operations'
classmethod: GsPackageLibrary
installPackageNamed: aSymbol
  | pkg |
  (pkg := self packageNamed: aSymbol) ifNil:[
    Error signal:'Package ', aSymbol asString,' not found'.
  ].
  ^ self installPackage: pkg
%

category: 'Testing'
classmethod: GsPackageLibrary
isPackageInstalled: aPackage
	"Ansser true if <aPackage> has already been installed"

	^(self userSymbolList objectNamed: aPackage symbolDict name) ~~ nil
%

category: 'Monticello'
classmethod: GsPackageLibrary
lastFileNameOf: packageName inDirectory: directory
	"returns a String"

	| versionNumberBlock mczFilename |
	versionNumberBlock := self versionNumberBlock.
	mczFilename := (((directory childFiles
				collect: [:reference | reference basename])
					select: [:mczName | (mczName indexOfSubCollection: packageName) = 1])
					sortBy: [:a :b | (versionNumberBlock value: a) <= (versionNumberBlock value: b)])
					last.
	^mczFilename
%

category: 'Monticello'
classmethod: GsPackageLibrary
lastFileNameOf: packageName inPath: aPath
  "returns a String"
  self installMonticelloPackagesDuring: [:globalsPackage |
   | directory |
    directory := ((globalsPackage symbolDict at: #FSDiskFilesystem) current
                     pathFromString: aPath ) asReference.
   ^ self lastFileNameOf: packageName inDirectory: directory
  ].
%

category: 'Monticello'
classmethod: GsPackageLibrary
loadLastVersionOf: packageName fromRepositoryPath: repositoryPath
	"load the latest version of the package <packageName> into the current user's UserGlobals symbol dictionary from
	the repository located in the directory <repositoryPath> on the server."

	self installMonticelloPackagesDuring: [:globalsPackage |
    | directory repository mczFilename |
		directory := ((globalsPackage symbolDict at: #FSDiskFilesystem) current
										pathFromString: repositoryPath) asReference.
		mczFilename := self lastFileNameOf: packageName inDirectory: directory.

		repository := (globalsPackage symbolDict at: #MCFilesystemRepository) new directory: directory.
		self loadMCZFile: mczFilename fromRepository: repository
  ]
%

category: 'private'
classmethod: GsPackageLibrary
loadMCZFile: mczFilename fromRepository: repository
	"load the given <mczFilename> from the given GsMonticello repository <repository>"

        GsFile gciLogServer: 'loading ', mczFilename printString.
	(repository loadVersionFromFileNamed: mczFilename) load.
%

category: 'Monticello'
classmethod: GsPackageLibrary
loadMCZFile: mczFilename fromRepositoryPath: repositoryPath
	"load the given mcz file <mczFilename> into the current user's UserGlobals symbol dictionary from
	the repository located in the directory <repositoryPath> on the server."

	self
            loadMCZFile: mczFilename
            home: #UserGlobals
            fromRepositoryPath: repositoryPath
%

category: 'Monticello'
classmethod: GsPackageLibrary
loadMCZFile: mczFilename home: homeSymbolDictName fromRepositoryPath: repositoryPath
    "load the given mcz file <mczFilename> into the current user'ssymbol
     dictionary named <homeSymbolDictName> from
     the repository located in the directory <repositoryPath> on the server."

    self
      installMonticelloPackagesHome: (GsCurrentSession currentSession objectNamed: homeSymbolDictName asSymbol)
      during: [:globalsPackage | |repository |
		repository := (globalsPackage symbolDict at: #MCFilesystemRepository) new
			directory: ((globalsPackage symbolDict at: #FSDiskFilesystem) current pathFromString: repositoryPath) asReference.
		self loadMCZFile: mczFilename fromRepository: repository ].
%

category: 'Accessing'
classmethod: GsPackageLibrary
packageLibrary

    | packageLibrary |
    packageLibrary := (AllUsers userWithId: self packageLibraryUserName ifAbsent: []) symbolList objectNamed: self packageLibraryName.
    packageLibrary == nil
        ifTrue: [
            packageLibrary := SymbolList new.
            self userGlobals at: self packageLibraryName put: packageLibrary.
        ].
    ^packageLibrary
%

category: 'Accessing'
classmethod: GsPackageLibrary
packageLibraryName

    ^#PackageLibrary
%

category: 'Accessing'
classmethod: GsPackageLibrary
packageLibraryUserName

    ^'DataCurator'
%

category: 'Searching'
classmethod: GsPackageLibrary
packageNamed: aSymbol

    	| symDict |
	symDict := self packageLibrary objectNamed: aSymbol.
	symDict ifNil:[ ^ nil ].
	^symDict at: GsPackage globalName otherwise: nil
%

category: 'Reporting'
classmethod: GsPackageLibrary
packagesReport
  | aSymList str |
  str := String new .
  aSymList := self packageLibrary .
  aSymList do:[:aDict |
    (aDict at: GsPackage globalName otherwise: nil) ifNotNil:[:pack |
       str add: 'GsPackage oop ' , pack asOop asString .
       pack name ifNotNil:[:nam|  str add: ' for ' , nam ].
       str lf .
    ].
  ].
  ^ str
%

category: 'Monticello'
classmethod: GsPackageLibrary
saveNewVersionOf: packageName author: authorInitials message: commitComment
  toPath: repositoryPath
  "write a new version of the package <packageName>
   to the repository located in the directory <repositoryPath> on the server."
	self installMonticelloPackagesDuring:
		[:globalsPackage |
		| directory repository pkg wc version verName |
		directory := ((globalsPackage symbolDict at: #FSDiskFilesystem) current
					pathFromString: repositoryPath) asReference.
		repository := (globalsPackage symbolDict at: #MCFilesystemRepository) new
					directory: directory.
		(globalsPackage symbolDict at: #MCPlatform) current authorInitials: authorInitials.
		pkg := (globalsPackage symbolDict at: #MCPackage) named: packageName.
		wc := pkg workingCopy.
		version := wc newVersionWithName: (verName := wc uniqueVersionName)
					message: commitComment.
		repository storeVersion: version.
		System commitTransaction ifFalse: [Error signal: 'commit failed'].
		^'wrote ' , verName asString , ' , ' , version summary]
%

category: 'Accessing'
classmethod: GsPackageLibrary
sessionSymbolList

  ^ GsSession currentSession symbolList      "fix 49328"
%

category: 'Operations'
classmethod: GsPackageLibrary
uninstallPackage: aPackage

    self userSymbolList remove: aPackage symbolDict ifAbsent: [].
    self sessionSymbolList remove: aPackage symbolDict ifAbsent: [].
    GsPackagePolicy current refreshSessionMethodDictionary.
%

category: 'Operations'
classmethod: GsPackageLibrary
uninstallPackageAndPrereqs: aPackage

    "Recursively uninstall the package and its prereqs"

    | symDict pkg |
    symDict := aPackage symbolDict.
    aPackage prereqs do: [:symbolDict |
        pkg := symbolDict at: GsPackage globalName otherwise: nil.
        pkg ~~ nil ifTrue: [ GsPackageLibrary uninstallPackageAndPrereqs: pkg ].
    ].
    self userSymbolList remove: symDict ifAbsent: [].
    self sessionSymbolList remove: symDict ifAbsent: [].
%

category: 'Accessing'
classmethod: GsPackageLibrary
userGlobals

    ^self userSymbolList objectNamed: #UserGlobals
%

category: 'Accessing'
classmethod: GsPackageLibrary
userSymbolList

    ^System myUserProfile symbolList
%

category: 'private'
classmethod: GsPackageLibrary
versionNumberBlock
	"Private. Version number is apparently the portion of the name between the last two periods.
	If no periods, the entire name. If one period, everything before that period."

	^
	[:aName |
	| lastIndex numberPortion foundPeriod index |
	foundPeriod := false.
	index := aName size.
	[foundPeriod or: [index = 0]] whileFalse:
			[(aName at: index = $.) ifTrue: [foundPeriod := true].
			index := index - 1].
	numberPortion := foundPeriod
				ifTrue:
					[lastIndex := index.
					foundPeriod := false.
					[foundPeriod or: [index = 0]] whileFalse:
							[(aName at: index = $.) ifTrue: [foundPeriod := true].
							index := index - 1].
					aName copyFrom: index + 1 to: lastIndex]
				ifFalse: [aName].
	numberPortion asNumber]
%

! Class implementation for 'GsReferencePath'

!		Class methods for 'GsReferencePath'

category: 'Formatting'
classmethod: GsReferencePath
pathArrayAsString: path
"Returns a String describing the path in the form
   <pathIdx> Oop = <objectId> (<className>)
"
| pathLength obj result |

pathLength := path size.
result := String new.

1 to: pathLength do: [:i |  | refPath |
  obj := path at: i.
  result add: ( '  ' , i asString, ' oop = ', (GciInterface _oopForObject: obj) asString,
            ' (', obj class name asString , ')').
  refPath := GsReferencePath _refPathForObject: obj .
  (refPath status == #noInfo)
     ifFalse: [
       (refPath inSearchOops)
          ifTrue: [ result add: (' has ' , refPath numParents asString , ' parents') ]
          ifFalse: [
             (refPath moreParents) ifTrue: [ result add: (' has more than one parent') ]
                                ifFalse: [ result add: (' has only one parent') ]
          ].
     ].
   result add: Character lf.
].
^result
%

category: 'Primitive'
classmethod: GsReferencePath
_refPathForObject: anObjOrGsBitmap

"Returns a reference path to a single object.

 This method returns a new GsReferencePath instance.

 If a GsBitmap is passed as an argument, then each object in the bitmap is
 tested and the first object to have a complete path is returned.  If no
 object has a complete path then the status returned is #noInfo.
"

<primitive: 1024>
^ self _primitiveFailed:
    #_refPathForObject:
    args: { anObjOrGsBitmap }
%

!		Instance methods for 'GsReferencePath'

category: 'Accessing'
method: GsReferencePath
inSearchOops
 "Answer whether the target was in the searchOops."

^inSearchOops
%

category: 'Updating'
method: GsReferencePath
inSearchOops: aBoolean

inSearchOops := aBoolean
%

category: 'Testing'
method: GsReferencePath
isComplete
  "Answers whether the path returned is complete, i.e., terminates with an object
   in the limit set"

^ status == #complete
%

category: 'Testing'
method: GsReferencePath
isCycle
  "Answers whether the path contains a cycle, i.e., terminates with an object that appears
   at another position in the path."

^status == #cycle
%

category: 'Testing'
method: GsReferencePath
isNotConnected

  "Answers true if the head of the path has no parents"

^ status == #notConnected
%

category: 'Accessing'
method: GsReferencePath
moreParents
 "Answer whether it is known if there are moreParents than specified in numParents."

^moreParents
%

category: 'Updating'
method: GsReferencePath
moreParents: aBoolean

moreParents := aBoolean
%

category: 'Accessing'
method: GsReferencePath
numParents
 "Answer the number of parent objects for the target"

^numParents
%

category: 'Updating'
method: GsReferencePath
numParents: anInt

numParents := anInt
%

category: 'Accessing'
method: GsReferencePath
path
 "Answer an array of the oops that define a path to the target object"

^path
%

category: 'Updating'
method: GsReferencePath
path: anArray

path := anArray
%

category: 'Accessing'
method: GsReferencePath
status
  "Answers a symbol which defines the result for the path.
   Possible values are:
      #complete        if the path starts with an object in the limit set.
      #cycle           if an object occurs more than once in the path.
      #notConnected    if the head of the path has no parents.
  "
^status
%

category: 'Updating'
method: GsReferencePath
status: aSymbol

status := aSymbol
%

category: 'Accessing'
method: GsReferencePath
target
 "Answer the target object for the path."

^target
%

category: 'Updating'
method: GsReferencePath
target: anObj

target := anObj
%

! Class implementation for 'GsReferencePathParentsInfo'

!		Class methods for 'GsReferencePathParentsInfo'

category: 'Accessing'
classmethod: GsReferencePathParentsInfo
allParentsOfOops: aGsBitmap
"Answer a GsBitmap containing the parent objects found by the last scan of each
 child object contained in aGsBitmap."

^ self refPathParentsOf: aGsBitmap
%

category: 'Accessing'
classmethod: GsReferencePathParentsInfo
refPathParentsOf: anObj

"Returns an instance of GsReferencePathParentsInfo if anObj is a
 committed non-special object.

 If anObj is an instance of GsBitmap, returns new instance of
 GsBitmap containing all parent objects of all child objects contained
 in the argument GsBitmap found during the last scan.

 If anObj is not an instance of GsBitmap, it must be a committed
 non-special object, or a SmallInteger; a SmallInteger must be the
 objectId of a committed non-special object and can be resolved as
 (Object _objectForOop: anObj).

 If the _refPathDoScanForParents method was run with onlySearchObjs having
 the value true, then if the object was NOT in the search set for the scan,
 then an error is reported with the message: 'No info available for objects
 not in searchOops'."

| res |
res := self _refPathParentsOf: anObj .
res _isOneByteString ifTrue:[ ^ ArgumentError signal: res ].
^ res
%

category: 'Private'
classmethod: GsReferencePathParentsInfo
_refPathParentsOf: anObj

"Returns a GsBitmap, an GsReferencePathParentsInfo or a String with error details"

<primitive: 1025>
^ self _primitiveFailed: #refPathParentsOf: args: { anObj }
%

!		Instance methods for 'GsReferencePathParentsInfo'

category: 'Accessing'
method: GsReferencePathParentsInfo
additionalParentsAvailable
 "Answer whether there are known to be more parent references than were
  returned from the #refPathParentsOf: call."

^additionalParentsAvailable
%

category: 'Updating'
method: GsReferencePathParentsInfo
additionalParentsAvailable: aBoolean

additionalParentsAvailable := aBoolean
%

category: 'Accessing'
method: GsReferencePathParentsInfo
parentClassCounts
 "Answer an array containing the counts of the number of referencing object instances of the class with the corresponding
  index in the parentClassIds array.
   If the target is not found in the search objects, answer an empty array."

^parentClassCounts
%

category: 'Updating'
method: GsReferencePathParentsInfo
parentClassCounts: someIntegers

parentClassCounts := someIntegers
%

category: 'Accessing'
method: GsReferencePathParentsInfo
parentClassOops
 "Answer an array of the oops of each referencing object's class.
   If the target is not found in the search objects, answer an empty array."

^parentClassOops
%

category: 'Updating'
method: GsReferencePathParentsInfo
parentClassOops: someIntegers

parentClassOops := someIntegers
%

category: 'Accessing'
method: GsReferencePathParentsInfo
parentClassReferences
 "Answer the parent objects class reference."

^self parentClassOops collect: [:refOop | Object _objectForOop: refOop]
%

category: 'Accessing'
method: GsReferencePathParentsInfo
parentOops
 "Answer a GsBitmap containing the oops of each referencing object.
  If the target is not found in the search objects, there can only be a single parent reference returned."

^parentOops
%

category: 'Accessing'
method: GsReferencePathParentsInfo
parentOopsAsArray

 "Answer an array containing the oops of each referencing object.
  If the target is not found in the search objects, there can only be a single parent reference returned."

^parentOops asArray
%

category: 'Accessing'
method: GsReferencePathParentsInfo
parentReferences
 "Answer the parent objects referencing the target."

^self parentOops collect: [:refOop | Object _objectForOop: refOop]
%

category: 'Accessing'
method: GsReferencePathParentsInfo
parentSizesInBytes
 "Answer an array of the sum of the size in bytes (from the object header) of the referencing objects with the
  class that corresponds to the entry with the same index in the parentClassOops array.
  If the target is not found in the search objects, answer an empty array."

^parentSizesInBytes
%

category: 'Updating'
method: GsReferencePathParentsInfo
parentSizesInBytes: someIntegers

parentSizesInBytes := someIntegers
%

category: 'Accessing'
method: GsReferencePathParentsInfo
target
 "Answer the argument passed to #refPathParentsOf:."

^target
%

category: 'Updating'
method: GsReferencePathParentsInfo
target: anObject

target := anObject
%

category: 'Accessing'
method: GsReferencePathParentsInfo
targetFoundInSearch
 "Answer whether the target is found in the search objects array passed to
  Repository>>#_refPathDoScanForParents:excludeParentRefs:."

^targetFoundInSearch
%

category: 'Updating'
method: GsReferencePathParentsInfo
targetFoundInSearch: aBoolean

targetFoundInSearch := aBoolean
%

! Class implementation for 'GsSysLog'

!		Class methods for 'GsSysLog'

category: 'Setting Flags'
classmethod: GsSysLog
allFlagBits
^ 63
%

category: 'Setting Flags'
classmethod: GsSysLog
defaultFlags
"Answer a SmallInteger containing the default flags used for writing messages
 to the system log."
^ self setFlagIncludePid: (self setFlagLogToConsoleOnError: 0)
%

category: 'Setting Flags'
classmethod: GsSysLog
setFlagForStderr: anInt
^ anInt bitOr: 1
%

category: 'Setting Flags'
classmethod: GsSysLog
setFlagIncludePid: anInt
^ anInt bitOr: 8
%

category: 'Setting Flags'
classmethod: GsSysLog
setFlagLogOnGemHost: anInt
^ anInt bitOr: 32
%

category: 'Setting Flags'
classmethod: GsSysLog
setFlagLogOnStoneHost: anInt
^ anInt bitOr: 16
%

category: 'Setting Flags'
classmethod: GsSysLog
setFlagLogToConsoleOnError: anInt
^ anInt bitOr: 4
%

category: 'Setting Flags'
classmethod: GsSysLog
setFlagNoCloselog: anInt
^ anInt bitOr: 2
%

category: 'Logging'
classmethod: GsSysLog
writeErrorMessage: messageString
"Writes an error message to the syslog using default settings."

^ self writeLogMessage: messageString
       prefix: nil
       priority: #LOG_ERR
       facility: #LOG_USER
       flags: self defaultFlags
%

category: 'Logging'
classmethod: GsSysLog
writeInfoMessage: messageString
"Writes an informational message to the syslog using default settings."
^ self writeLogMessage: messageString
       prefix: nil
       priority: #LOG_INFO
       facility: #LOG_USER
       flags: self defaultFlags
%

category: 'Logging'
classmethod: GsSysLog
writeLogMessage: messageString prefix: prefixString priority: priSym facility: facSym flags: flagsInt
"Writes messageString to the system log by calling the UNIX fuctions openlog(),
 syslog() and closelog().

 The messageString argument must be an instance of String or a instance of a
 subclass of String, or an instance of Utf8.
 It also must have a size between 1 and 4905 characters.
 The message written vi syslog() will be terminated at any codepoint of zero
 within messageString .

 The prefixString argument must be an instance of String, an instance of a
 subclass of String, or nil.  If it is not nil, then it also must have a size
 between 1 and 1023 characters.  A value of nil causes the default prefix
 of 'GemStone' to be used for the prefix.  Characters beyond a codepoint of zero
 in prefixString are ignored.

 The priSym argument indicates the priority of the message and must be one
 of the following symbols:

   #LOG_EMERG      system is unusable
   #LOG_ALERT      action must be taken immediately
   #LOG_CRIT       critical conditions
   #LOG_ERR        error conditions
   #LOG_WARNING    warning conditions
   #LOG_NOTICE     normal, but significant, condition
   #LOG_INFO       informational message
   #LOG_DEBUG      debug-level message

 The facSym argument indicates what type of program is logging the message
 (called the facility) and must be one of the following symbols:

   #LOG_USER       generic user-level messages
   #LOG_LOCAL0     reserved for local use
   #LOG_LOCAL1     reserved for local use
   #LOG_LOCAL2     reserved for local use
   #LOG_LOCAL3     reserved for local use
   #LOG_LOCAL4     reserved for local use
   #LOG_LOCAL5     reserved for local use
   #LOG_LOCAL6     reserved for local use
   #LOG_LOCAL7     reserved for local use

The flagsInt argument is a SmallInteger which is either 0 or the bitwise-OR
of any of the following values:

  1 - Write the message to stderr of this process as well as the system
      logger.
  2 - Do not call closelog() after writing the message.
  4 - Write directly to system console if there is an error while sending
      to system logger (LOG_CONS option).
  8 - Include the PID with each message (LOG_PID option).
 16 - Write the message to the system logger on the stone's host.  Has no
      effect unless the gem is running on a host remote from the stone.
 32 - Write the message on the system logger gem's host.  Has no
      effect unless the gem is running on a host remote from the stone.

 For sessions that are not on same host as the stone, at least one of the bits
 corresponding to the values 16 and 32 must be set.

 Note: The host system may impose message and prefix size limits smaller than
       the limits specified above.  Consult the system documentation for the
       syslog() function to determine what the actual limits enforced by the
       system are.

 Signals an error if the privilege NoPerformOnServer is true and the
 special entry /GsSysLog/writeLogMessage is not present in the whitelist of
 allowed commands for the session's UserProfile. See the methods in
 UserProfile under category PerformOnServer for more information.

 Returns the receiver."

<primitive: 1006>
self _validateString: messageString withMaxSize: 4095 .
prefixString == nil
  ifFalse:[ self _validateString: prefixString withMaxSize: 1023 ] .
priSym  _validateClass: Symbol .
facSym  _validateClass: Symbol .
flagsInt _validateClass: SmallInteger .
((flagsInt < 0) or:[ flagsInt > self allFlagBits ])
  ifTrue:[ flagsInt _error: #rtErrArgOutOfRange args:{ 0 . self allFlagBits } ] .
(self _allPrioritySymbols includesIdentical: priSym)
  ifFalse:[ ArgumentError new object: priSym ;
                          signal: 'Invalid priority'].
(self _allFacilitySymbols includesIdentical: facSym)
  ifFalse:[ ArgumentError new object: facSym ;
                          signal: 'Invalid facility'].
((flagsInt bitAnd: (16 bitOr:32)) == 0 and:[ System sessionIsOnStoneHost not])
  ifTrue:[ ArgumentError new object: flagsInt ;
		signal:'sessionIsOnStoneHost==true, flags must specify stone or gem host'].
^ self _primitiveFailed: #_primSysLogMessage:prefix:priority:facility:flags:
       args: { messageString . prefixString . priSym . facSym . flagsInt  }
%

category: 'Logging'
classmethod: GsSysLog
writeWarningMessage: messageString
"Writes a warning message to the syslog using default settings."

^ self writeLogMessage: messageString
       prefix: nil
       priority: #LOG_WARNING
       facility: #LOG_USER
       flags: self defaultFlags
%

category: 'Private'
classmethod: GsSysLog
_allFacilitySymbols

^ { #LOG_USER   . #LOG_LOCAL0  . #LOG_LOCAL1 . #LOG_LOCAL2 . #LOG_LOCAL3 .
    #LOG_LOCAL4 . #LOG_LOCAL5  . #LOG_LOCAL6 . #LOG_LOCAL7 }
%

category: 'Private'
classmethod: GsSysLog
_allPrioritySymbols

^ { #LOG_EMERG  . #LOG_ALERT . #LOG_CRIT . #LOG_ERR . #LOG_WARNING .
    #LOG_NOTICE . #LOG_INFO  . #LOG_DEBUG }
%

category: 'Private'
classmethod: GsSysLog
_validateString: anObj withMaxSize: anInt
| sz |
(anObj isKindOfClass: Utf8) ifFalse:[
  anObj  _validateKindOfClass: String .  "single byte strings or Utf8 only"
].
sz := anObj _basicSize . "Use #_basicSize in case #size has been overloaded."
((sz == 0) or:[ sz > anInt ])
  ifTrue:[ anObj _error: #rtErrBadSize args:{ 1 . anInt } ] .
^ true
%

! Class implementation for 'GsTlsCredential'

!		Class methods for 'GsTlsCredential'

category: 'Storing and Loading'
classmethod: GsTlsCredential
loadFrom: passiveObj

"Creates and returns an active instance of the receiver from the passive form
 of the object"

| inst |
inst := self newFromPemString: passiveObj readObject .
passiveObj hasRead: inst.
^inst.
%

category: 'Private'
classmethod: GsTlsCredential
newFromPemString: aString
  self subclassResponsibility: #newFromPemString:
%

category: 'Private'
classmethod: GsTlsCredential
tls0ArgClassPrim: opCode

<primitive: 1057>
^ self _primitiveFailed: #tls0ArgClassPrim: args: { opCode }
%

category: 'Private'
classmethod: GsTlsCredential
tls3ArgPrim: opCode with: aString with: pfArg with: type

"
  OpCode   Function
=========================================================================
     0      New GsTlsCredential from PEM file, pfArg is the passphrase
     1      New GsTlsCredential from PEM string, pfArg is the passphrase
     2      New GsX509CertificateChain from PEM file
     3      New GsX509CertificateChain from PEM file
     4      New GsTlsPublicKey from a GsX509Certificate
     5      New GsTlsCredential from PEM file, pfArg is a file name
     6      New GsTlsCredential from PEM string, pfArg is a file name
=========================================================================

  Type      Kind
============================
    1       Private Key
    2       Public Key
    3       X509 Certificate
============================
"

<primitive: 1056>
^ self _primitiveFailed: #tls3ArgPrim:with:with:with: args: { opCode . aString . pfArg . type }
%

!		Instance methods for 'GsTlsCredential'

category: 'Testing'
method: GsTlsCredential
= anObj

^ self tls1ArgInstPrim: 0 with: anObj
%

category: 'Accessing'
method: GsTlsCredential
algorithm

"Answers a Symbol indicating the type of high-level PKI algorithm the
receiver uses. The high-level PKI algorithms currently supported are:

   #RSA - Rivest-Shamir-Adleman
   #DSA - Data Signature Algorithm
   #EC  - Elliptic Curve Cryptography

 All high-level algorithm have various sub-types. Use the sslAlgorithm
 method to obtain information about the specific PKI algorithm of the
 receiver.

 If the receiver is an instance of GsX509Certificate, the result
 indicates the algorithm of the public key contained therein.

 Returns #UNSUPPORTED if the algorithm could not be determined."

^ self tls0ArgInstPrim: 2
%

category: 'Converting'
method: GsTlsCredential
asPemString

^ self tls0ArgInstPrim: 0
%

category: 'Testing'
method: GsTlsCredential
canCreateDigitalSignatures
  self subclassResponsibility: #canCreateDigitalSignatures
%

category: 'Testing'
method: GsTlsCredential
canVerifyDigitalSignatures
  self subclassResponsibility: #canVerifyDigitalSignatures
%

category: 'Printing'
method: GsTlsCredential
description
"Answers a String obtained from SSL describing the receiver. The contents
 and format of the string vary depending on the receiver's class."

^ self tls0ArgInstPrim: 4
%

category: 'Hashing'
method: GsTlsCredential
hash

^ self tls0ArgInstPrim: 1
%

category: 'Testing'
method: GsTlsCredential
isPrivateKey
  self subclassResponsibility: #isPrivateKey
%

category: 'Testing'
method: GsTlsCredential
isPublicKey
  self subclassResponsibility: #isPublicKey
%

category: 'Testing'
method: GsTlsCredential
isX509Certificate
  self subclassResponsibility: #isX509Certificate
%

category: 'Comparing'
method: GsTlsCredential
matches: anotherKey

"Determines if the receiver and anotherKey match each other as a valid
 public-private key pair. If the receiver is a public key, anotherKey
 is expected to be a private key. If the receiver is a private key,
 another key is expected to be a public key.

 If the receiver or anotherKey is an instance of GsX509Certificate, the
 public key is extracted from the certificate and the comparison is
 performed as described above.

 RSA and DSA key pairs match if both keys use the same modulus.
 Elliptic curve key pairs match if both keys use the same curve and the
 same point on that curve.

 Returns true if the keys match, false if they do not match.
 Raises an error if the receiver and anotherKey are both the same type
 (public or private keys)."

^ self tls1ArgInstPrim: 2 with: anotherKey
%

category: 'Accessing'
method: GsTlsCredential
securityBits
"Answers a SmallInteger representing the number of security bits of the
 receiver.  Bits of security is defined in NIST SP800-57.  See
   https://nvlpubs.nist.gov/nistpubs/SpecialPublications/NIST.SP.800-57pt1r4.pdf
 for further information.

 For instances of GsX509Certificate, answers the security bits of the public
 key contained therein."

^ self tls0ArgInstPrim: 5
%

category: 'Accessing'
method: GsTlsCredential
sslAlgorithm

"Answers a Symbol indicating the SSL type of PKI algorithm the
 receiver uses. The values returned by OpenSSL as of version
 1.1.1 are:

    #EVP_PKEY_NONE
    #EVP_PKEY_RSA
    #EVP_PKEY_RSA2
    #EVP_PKEY_RSA_PSS
    #EVP_PKEY_DSA
    #EVP_PKEY_DSA1
    #EVP_PKEY_DSA2
    #EVP_PKEY_DSA3
    #EVP_PKEY_DSA4
    #EVP_PKEY_DH
    #EVP_PKEY_DHX
    #EVP_PKEY_EC
    #EVP_PKEY_SM2
    #EVP_PKEY_HMAC
    #EVP_PKEY_CMAC
    #EVP_PKEY_SCRYPT
    #EVP_PKEY_TLS1_PRF
    #EVP_PKEY_HKDF
    #EVP_PKEY_POLY1305
    #EVP_PKEY_SIPHASH
    #EVP_PKEY_X25519
    #EVP_PKEY_ED25519
    #EVP_PKEY_X448
    #EVP_PKEY_ED448

 If the recevier is an instance of GsX509Certificate, the result
 indicates the algorithm of the public key contained therein."

^ self tls0ArgInstPrim: 3
%

category: 'Testing'
method: GsTlsCredential
supportsDigitalSignatures
"Answers a Boolean indicating if the receiver supports digital signatures.
 The type of support offered, either signing or verifying, depends upon the
 class of the receiver."

^ self tls0ArgInstPrim: 6
%

category: 'Private'
method: GsTlsCredential
tls0ArgInstPrim: opCode

<primitive: 1057>
^ self _primitiveFailed: #tls0ArgInstPrim: args: { opCode }
%

category: 'Private'
method: GsTlsCredential
tls1ArgInstPrim: opCode with: anObj

<primitive: 1058>
^ self _primitiveFailed: #tls1ArgInstPrim: args: { opCode . anObj }
%

category: 'Storing and Loading'
method: GsTlsCredential
writeTo: passiveObj

"Writes the passive form of the receiver into passiveObj, expressed as
 a PEM string."

passiveObj writeClass: self class.
self asPemString writeTo: passiveObj .
passiveObj space
%

category: 'Private'
method: GsTlsCredential
_validateAlgorithm: expectedSymbol

^ self algorithm == expectedSymbol
    ifTrue:[ true ]
   ifFalse:[ CryptoError signal:
  ('Incorrect key algorithm. Expected: ', expectedSymbol asString, ' Actual: ', self algorithm asString)]
%

category: 'Private'
method: GsTlsCredential
_validateCreatesDigitalSignatures
^ self canCreateDigitalSignatures
    ifTrue:[ true ]
   ifFalse:[ CryptoError signal: 'This key is not valid for creating digital signatures']
%

category: 'Private'
method: GsTlsCredential
_validateIsPrivateKey
^ self isPrivateKey
    ifTrue:[ true ]
   ifFalse:[ CryptoError signal: 'Incorrect key type: expected a private key']
%

category: 'Private'
method: GsTlsCredential
_validateIsPublicKey
^ self isPublicKey
    ifTrue:[ true ]
   ifFalse:[ CryptoError signal: 'Incorrect key type: expected a public key']
%

category: 'Private'
method: GsTlsCredential
_validateIsRsa

^ self algorithm == #RSA
     ifTrue:[ true ]
    ifFalse:[  CryptoError signal: 'An RSA key or certificate is required']
%

category: 'Private'
method: GsTlsCredential
_validateValidatesDigitalSignatures
^ self canVerifyDigitalSignatures
    ifTrue:[ true ]
   ifFalse:[ CryptoError signal: 'This key is not valid for validating digital signatures']
%

! Class implementation for 'GsTlsPrivateKey'

!		Class methods for 'GsTlsPrivateKey'

category: 'Examples'
classmethod: GsTlsPrivateKey
encryptDecryptBase64Example

|privKey pubKey poe b64 poe2 |

privKey := GsTlsPrivateKey newFromPemString:
'-----BEGIN PRIVATE KEY-----
MIICdwIBADANBgkqhkiG9w0BAQEFAASCAmEwggJdAgEAAoGBAMBXQWaLW7QhuWvO
17X5c8LYDbw65if4QR2ATaNZ0Cq3Q6Q+aCsnmT1Q3AvKwUx0Y3PnASLLl0zNQN94
nbNP81vT/0D4J0Ch1HwGUErZReLDN2DSoUELdnmbrgR10Glriy3HD6wb0q+h/N45
8JpR6sTYhVlLtvnGYAJL2OW5kVRVAgMBAAECgYEAl6My+Hld7wG3gXstLVZhIXfc
PE3jLhfWnj+M9f/U0hhxx4c78OnjMigRk2piQrhvv+ybRKdlvTMEtioNilS58ogV
/I5dRoHsRd2opsUeDMloRdOMcL6HhinjGtPFqY/QXdeKKLLAfR2Mw1GKaro55hQv
DRqRk01Gd/KvWij5roECQQDz+9VW54+qolrDH2iw0BBeeYBog/ELA8vNw7te4OWH
0TrPHUDyvHkJCQ/GSWHLVQ2Rw/WoyKMTn7u/LF8pspp9AkEAydBN8IPdID8m5rk8
JYr1iPceAyoI5ZeUA1cqrFjx4HdtyVAuLGQAvVSY7fJaSzlrBeH8HVa3GlDJ3Qr1
Tt1wuQJAJnbhX14KTEBkRrbA7n8e1YYaNF/4tF/Y1YuyEncqOItH1jcqcho8iqwf
DIetHz09cmmOZRmcfA+GrdD0/8HkkQJANUUxvYHhFYj16MMOWE6Uv0GTf3xR+uCG
5lbU4cdcmUaNCS2L8pW3CELTV0O4h9CxKk1bchcYn+6hSiKBW/7hqQJBAKcucW2t
HDhYqOhZi+Eq+z7mnua7x867COGlijb3yE80rvmqBOOZc3PtJNr2SKQoBjD++B4w
HSedUWX12Gyb0SE=
-----END PRIVATE KEY-----' .

pubKey := GsTlsPublicKey newFromPemString:
'-----BEGIN PUBLIC KEY-----
MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDAV0Fmi1u0Iblrzte1+XPC2A28
OuYn+EEdgE2jWdAqt0OkPmgrJ5k9UNwLysFMdGNz5wEiy5dMzUDfeJ2zT/Nb0/9A
+CdAodR8BlBK2UXiwzdg0qFBC3Z5m64EddBpa4stxw+sG9KvofzeOfCaUerE2IVZ
S7b5xmACS9jluZFUVQIDAQAB
-----END PUBLIC KEY-----' .

poe := 'Once upon a midnight dreary, while I pondered, weak and weary,'.

"Encrypt using public key. b64 is a String "
b64 := (pubKey encrypt: poe) asBase64String.

"Decrypt using private key and convert ByteArray into String"
poe2 := (privKey decrypt: (ByteArray fromBase64String: b64)) bytesIntoString .
^ poe = poe2
%

category: 'Examples'
classmethod: GsTlsPrivateKey
encryptDecryptExample

|privKey pubKey poe crypt poe2 |

privKey := GsTlsPrivateKey newFromPemString:
'-----BEGIN PRIVATE KEY-----
MIICdwIBADANBgkqhkiG9w0BAQEFAASCAmEwggJdAgEAAoGBAMBXQWaLW7QhuWvO
17X5c8LYDbw65if4QR2ATaNZ0Cq3Q6Q+aCsnmT1Q3AvKwUx0Y3PnASLLl0zNQN94
nbNP81vT/0D4J0Ch1HwGUErZReLDN2DSoUELdnmbrgR10Glriy3HD6wb0q+h/N45
8JpR6sTYhVlLtvnGYAJL2OW5kVRVAgMBAAECgYEAl6My+Hld7wG3gXstLVZhIXfc
PE3jLhfWnj+M9f/U0hhxx4c78OnjMigRk2piQrhvv+ybRKdlvTMEtioNilS58ogV
/I5dRoHsRd2opsUeDMloRdOMcL6HhinjGtPFqY/QXdeKKLLAfR2Mw1GKaro55hQv
DRqRk01Gd/KvWij5roECQQDz+9VW54+qolrDH2iw0BBeeYBog/ELA8vNw7te4OWH
0TrPHUDyvHkJCQ/GSWHLVQ2Rw/WoyKMTn7u/LF8pspp9AkEAydBN8IPdID8m5rk8
JYr1iPceAyoI5ZeUA1cqrFjx4HdtyVAuLGQAvVSY7fJaSzlrBeH8HVa3GlDJ3Qr1
Tt1wuQJAJnbhX14KTEBkRrbA7n8e1YYaNF/4tF/Y1YuyEncqOItH1jcqcho8iqwf
DIetHz09cmmOZRmcfA+GrdD0/8HkkQJANUUxvYHhFYj16MMOWE6Uv0GTf3xR+uCG
5lbU4cdcmUaNCS2L8pW3CELTV0O4h9CxKk1bchcYn+6hSiKBW/7hqQJBAKcucW2t
HDhYqOhZi+Eq+z7mnua7x867COGlijb3yE80rvmqBOOZc3PtJNr2SKQoBjD++B4w
HSedUWX12Gyb0SE=
-----END PRIVATE KEY-----' .

pubKey := GsTlsPublicKey newFromPemString:
'-----BEGIN PUBLIC KEY-----
MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDAV0Fmi1u0Iblrzte1+XPC2A28
OuYn+EEdgE2jWdAqt0OkPmgrJ5k9UNwLysFMdGNz5wEiy5dMzUDfeJ2zT/Nb0/9A
+CdAodR8BlBK2UXiwzdg0qFBC3Z5m64EddBpa4stxw+sG9KvofzeOfCaUerE2IVZ
S7b5xmACS9jluZFUVQIDAQAB
-----END PUBLIC KEY-----' .

poe := 'Once upon a midnight dreary, while I pondered, weak and weary,'.

"Encrypt using public key. crypt is a ByteArray"
crypt := pubKey encrypt: poe.

"Decrypt using private key and convert ByteArray into String"
poe2 :=  (privKey decrypt: crypt) bytesIntoString .

^ poe = poe2
%

category: 'Instance Creation'
classmethod: GsTlsPrivateKey
newFromPemFile: fileNameString
"Reads data from the given file name in PEM format and creates a new instance
 of the receiver. If the PEM file contains multiple keys, only the
 first is read.

 Raises and exception if the file is not in PEM format or if
 the type of object in the file does not match the receiver.

 The private key is assumed to not have a passphrase."

^ self tls3ArgPrim: 0 with: fileNameString with: nil with: 1
%

category: 'Instance Creation'
classmethod: GsTlsPrivateKey
newFromPemFile: fileNameString withPassphrase: aPf
"Reads data from the given file name in PEM format and creates a new instance
 of the receiver. If the PEM file contains multiple keys, only the
 first is read.

 Raises an exception if the file is not in PEM format or if
 the type of object in the file does not match the receiver or if the
 passphrase is incorrect."

^ self tls3ArgPrim: 0 with: fileNameString with: aPf with: 1
%

category: 'Instance Creation'
classmethod: GsTlsPrivateKey
newFromPemFile: fileNameString withPassphraseFile: aPfFile
"Reads data from the given file name in PEM format and the passphrase from 
 the text file aPfFile, then creates a new instance of the receiver.
 If the PEM file contains multiple keys, only the first key is read.

 Raises an exception if the file is not in PEM format or if
 the type of object in the file does not match the receiver or if 
 aPfFile does not exist or cannot be read."
 
^ self tls3ArgPrim: 5 with: fileNameString with: aPfFile with: 1
%

category: 'Instance Creation'
classmethod: GsTlsPrivateKey
newFromPemString: aPemString
"Creates a new instance of the receiver based on the PEM string. If the PEM
 string contains multiple keys, only the first is read.

 Raises an exception if the string is not in PEM format or if the type
 of object in the PEM string does not match the receiver.

 The private key is assumed to not have a passphrase."

^ self tls3ArgPrim: 1 with: aPemString with: nil with: 1
%

category: 'Instance Creation'
classmethod: GsTlsPrivateKey
newFromPemString: aPemString withPassphrase: aPf
"Creates a new instance of the receiver based on the PEM string. If the PEM
 string contains multiple keys, only the first is read.

 Raises an exception if the string is not in PEM format or if the type
 of object in the PEM string does not match the receiver or if the
 passphrase is incorrect."

^ self tls3ArgPrim: 1 with: aPemString with: aPf with: 1
%

category: 'Instance Creation'
classmethod: GsTlsPrivateKey
newFromPemString: aPemString withPassphraseFile: aPfFile
"Creates a new instance of the receiver based on the PEM string. If the PEM
 string contains multiple keys, only the first is read. Reads the passphrase
 from the file aPfFile.

 Raises an exception if the string is not in PEM format, if the type 
 of object in the PEM string does not match the receiver, if the 
 passphrase is incorrect, or if aPfFile does not exist or cannot
 be read."

^ self tls3ArgPrim: 6 with: aPemString with: aPfFile with: 1
%

category: 'Class Membership'
classmethod: GsTlsPrivateKey
speciesForPublicKey
  ^ GsTlsPublicKey
%

!		Instance methods for 'GsTlsPrivateKey'

category: 'Converting'
method: GsTlsPrivateKey
asPublicKey
"Answers a new object which represents the public key for the receiver.
 The class of the new instance is the result of the message
 #speciesForPublicKey, which is GsTlsPublicKey by default"

^ self tls1ArgInstPrim: 1 with: self speciesForPublicKey
%

category: 'Testing'
method: GsTlsPrivateKey
canCreateDigitalSignatures
^ self supportsDigitalSignatures
%

category: 'Testing'
method: GsTlsPrivateKey
canVerifyDigitalSignatures
"Only public keys and certificates may be used to verify signatures."
^ false
%

category: 'Decrypting'
method: GsTlsPrivateKey
decrypt: aByteArray
"Decrypts aByteArray which was previously encrypted with the receiver's matching 
 public key. Only RSA keys are supported for encrypting and decrypting.

 aByteArray must be an instance of a ByteArray.

 Returns a new instance ByteArray on success.
 Raises an exception on error."

^ self tls1ArgInstPrim: 4 with: aByteArray
%

category: 'Testing'
method: GsTlsPrivateKey
isPrivateKey
 ^ true
%

category: 'Testing'
method: GsTlsPrivateKey
isPublicKey
 ^ false
%

category: 'Testing'
method: GsTlsPrivateKey
isX509Certificate
 ^ false
%

category: 'Class Membership'
method: GsTlsPrivateKey
speciesForPublicKey
  ^ self class speciesForPublicKey
%

category: 'Private'
method: GsTlsPrivateKey
_validateIsNotRsaPss
^ self sslAlgorithm ~~ #EVP_PKEY_RSA_PSS
    ifTrue:[ true ]
   ifFalse:[ CryptoError signal: 'Incorrect key type: illegal RSS_PSS private key']
%

category: 'Private'
method: GsTlsPrivateKey
_validateIsRsa
^ self algorithm == #RSA
    ifTrue:[ true ]
   ifFalse:[ CryptoError signal: 'Incorrect key algorithm: expected an RSA private key']
%

category: 'Private'
method: GsTlsPrivateKey
_validateIsRsaPss
^ self sslAlgorithm == #EVP_PKEY_RSA_PSS
    ifTrue:[ true ]
   ifFalse:[ CryptoError signal: 'Incorrect key type: expected an RSS_PSS private key']
%

! Class implementation for 'GsTlsPublicKey'

!		Class methods for 'GsTlsPublicKey'

category: 'Instance Creation'
classmethod: GsTlsPublicKey
fromCertificate: aGsX509Certificate

"Extract the public key from the argument and return a new instance of the
 receiver."

^ self tls3ArgPrim: 4  with: aGsX509Certificate with: nil with: 2
%

category: 'Instance Creation'
classmethod: GsTlsPublicKey
newFromPemFile: fileNameString
"Reads data from the given file name in PEM format and creates a new instance
 of the receiver. If the PEM file contains multiple keys, only the
 first is read.

 Raises an exception if the file is not in PEM format or if
 the type of object in the file does not match the receiver."

^ self tls3ArgPrim: 0 with: fileNameString with: nil with: 2
%

category: 'Instance Creation'
classmethod: GsTlsPublicKey
newFromPemString: aPemString
"Creates a new instance of the receiver based on the PEM string. If the PEM
 string contains multiple keys, only the first is read.

 Raises an exception if the string is not in PEM format or if the type of
 object in the PEM string does not match the receiver."

^ self tls3ArgPrim: 1 with: aPemString with: nil with: 2
%

!		Instance methods for 'GsTlsPublicKey'

category: 'Converting'
method: GsTlsPublicKey
asPublicKey
 ^ self
%

category: 'Testing'
method: GsTlsPublicKey
canCreateDigitalSignatures
"Only private keys may be used to create signatures."
^ false
%

category: 'Testing'
method: GsTlsPublicKey
canVerifyDigitalSignatures
^ self supportsDigitalSignatures
%

category: 'Encrypting'
method: GsTlsPublicKey
encrypt: aByteObj
"Encrypts aByteObj using the receiver which must be an RSA public key 
 or X509 certificate object. This method supports RSA keys only.
 Encryption is performed using the RSA-OAEP padding algorithm. 

 Only small amounts of data may be encrypted using asymmetric 
 keys. The maximum allowed size of aByteObj is dependent on the 
 the number of bits in the receiver's public key. For 2048 bit keys, 
 the maximum size is 214 bytes. For 4096 bit keys, the maximum size is 
 470 bytes.

 aByteObj must be an instance of a byte class, typically ByteArray.
 Byte objects with character sizes greater than 1 are not supported.

 Returns a new instance of ByteArray containing the encrypted data.
 Raises an exception on error."

^ self tls1ArgInstPrim: 3 with: aByteObj
%

category: 'Testing'
method: GsTlsPublicKey
isPrivateKey
 ^ false
%

category: 'Testing'
method: GsTlsPublicKey
isPublicKey
 ^ true
%

category: 'Testing'
method: GsTlsPublicKey
isX509Certificate
 ^ false
%

category: 'Private'
method: GsTlsPublicKey
_validateIsNotRsaPss
^ self sslAlgorithm ~~ #EVP_PKEY_RSA_PSS
    ifTrue:[ true ]
   ifFalse:[ CryptoError signal: 'Incorrect key type: illegal RSS_PSS public key']
%

category: 'Private'
method: GsTlsPublicKey
_validateIsRsaPss
^ self sslAlgorithm == #EVP_PKEY_RSA_PSS
    ifTrue:[ true ]
   ifFalse:[ CryptoError signal: 'Incorrect key type: expected an RSS_PSS public key']
%

! Class implementation for 'GsX509Certificate'

!		Class methods for 'GsX509Certificate'

category: 'Instance Creation'
classmethod: GsX509Certificate
newFromPemFile: fileNameString
"Reads data from the given file name in PEM format and creates a new instance
 of the receiver. If the PEM file contains multiple certificates, only
 the first is read.

 Raises an exception if the file is not in PEM format or if
 the type of object in the file does not match the receiver."

^ self tls3ArgPrim: 0 with: fileNameString with: nil with: 3
%

category: 'Instance Creation'
classmethod: GsX509Certificate
newFromPemString: aPemString
"Creates a new instance of the receiver based on the PEM string. If the PEM
 string contains multiple certificates, only the first is read.

 Raises an exception if the string is not in PEM format or if the type of object in
 the PEM string does not match the receiver."

^ self tls3ArgPrim: 1 with: aPemString with: nil with: 3
%

!		Instance methods for 'GsX509Certificate'

category: 'Converting'
method: GsX509Certificate
asPublicKey
"Extract the public key from the receiver and return a new instance
 of the public key class for the receiver (default: GsTlsPublicKey)."

 ^ self publicKeySpecies fromCertificate: self
%

category: 'Testing'
method: GsX509Certificate
canCreateDigitalSignatures

^ false
%

category: 'Testing'
method: GsX509Certificate
canVerifyDigitalSignatures
^ self supportsDigitalSignatures
%

category: 'Encrypting'
method: GsX509Certificate
encrypt: aByteObj
"Encrypts aByteObj using the receiver which must be an RSA public key 
 or X509 certificate object. This method supports RSA keys only.
 Encryption is performed using the RSA-OAEP padding algorithm. 

 Only small amounts of data may be encrypted using asymmetric 
 keys. The maximum allowed size of aByteObj is dependent on the 
 the number of bits in the receiver's public key. For 2048 bit keys, 
 the maximum size is 214 bytes. For 4096 bit keys, the maximum size is
 470 bytes.

 aByteObj must be an instance of a byte class, typically ByteArray.
 Byte objects with character sizes greater than 1 are not supported.

 Returns a new instance of ByteArray containing the encrypted data.
 Raises an exception on error."

^ self tls1ArgInstPrim: 3 with: aByteObj
%

category: 'Testing'
method: GsX509Certificate
isPrivateKey
 ^ false
%

category: 'Testing'
method: GsX509Certificate
isPublicKey
 ^ false
%

category: 'Testing'
method: GsX509Certificate
isX509Certificate
 ^ true
%

category: 'Converting'
method: GsX509Certificate
publicKeySpecies
 ^ GsTlsPublicKey
%

! Class implementation for 'GsUuidV4'

!		Class methods for 'GsUuidV4'

category: 'Instance Creation'
classmethod: GsUuidV4
fromString: aUuidString

"Returns a new instance of the receiver. Raises an exception if aUuidString
 is not a valid UUID version 4 string in the following format:

   xxxxxxxx-xxxx-4xxx-Vxxx-xxxxxxxxxxxx

 where x is any valid lower-case hex digit and V is one of 8,9,a or b.

 See RFC 4122 for details"

^ self _oneArgClassPrim: aUuidString opCode: 1
%

category: 'Instance Creation'
classmethod: GsUuidV4
new
^ self _basicNew
%

category: 'Instance Creation'
classmethod: GsUuidV4
new: aSize
^ self shouldNotImplement: #new:
%

category: 'Private'
classmethod: GsUuidV4
_basicNew

^self _zeroArgClassPrim: 1
%

category: 'Private'
classmethod: GsUuidV4
_oneArgClassPrim: arg opCode: opCode

"
opCode	kind	method
===============================
1	class	fromString:
2       inst	<
===============================
"

<primitive: 1123>
opCode _validateClass: SmallInteger .
self _primitiveFailed: #_oneArgClassPrim: .
self _uncontinuableError
%

category: 'Private'
classmethod: GsUuidV4
_zeroArgClassPrim: opCode

"
opCode	kind	method
===============================
1	class	_basicNew
2	inst	asString
3       inst    asInteger
===============================
"

<primitive: 1122>
opCode _validateClass: SmallInteger .
self _primitiveFailed: #_zeroArgClassPrim: .
self _uncontinuableError
%

!		Instance methods for 'GsUuidV4'

category: 'Comparing'
method: GsUuidV4
< aUuid

"Answer a Boolean indicating if the receiver is less than
 aUuid. Raises an exception if aUuid is not a valid instance
 of GsUuidV4 or a subclass."
 
^self _oneArgInstancePrim: aUuid opCode: 2
%

category: 'Comparing'
method: GsUuidV4
<= aUuid
"Answer a Boolean indicating if the receiver is less than
 or equal to aUuid. Raises an exception if aUuid is not a valid instance
 of GsUuidV4 or a subclass."

^ (self = aUuid) or:[self < aUuid]
%

category: 'Comparing'
method: GsUuidV4
= anotherUuid

"Returns true if all of the following conditions are true, otherwise
returns false.

 1.  The receiver and anotherUuid are of the same class.
 2.  The two objects are the same size.
 3.  The corresponding elements of the receiver and anotherUuid
     are equal."

<primitive: 613>
self _primitiveFailed: #= .
self _uncontinuableError
%

category: 'Comparing'
method: GsUuidV4
> aUuid
"Answer a Boolean indicating if the receiver is greater than
 aUuid. Raises an exception if aUuid is not a valid instance
 of GsUuidV4 or a subclass."
 
^ aUuid < self
%

category: 'Comparing'
method: GsUuidV4
>= aUuid
"Answer a Boolean indicating if the receiver is greater than
 or equal to aUuid. Raises an exception if aUuid is not a valid instance
 of GsUuidV4 or a subclass."
 
^ (self = aUuid) or:[self > aUuid]
%

category: 'Converting'
method: GsUuidV4
asInteger

^ self _zeroArgInstancePrim: 3
%

category: 'Private - Converting'
method: GsUuidV4
asInteger2
"Smalltalk implementation of the asInteger method."

| sum |
sum := 0 .
1 to: 16 do:[:n| sum := sum + ((self at: n) * (256 raisedTo: (n - 1)))].
^sum
%

category: 'Converting'
method: GsUuidV4
asString
"Returns a 36 character string representing the receiver formatted as specified in
 RFC 4122."
 
^ self _zeroArgInstancePrim: 2 .
%

category: 'Converting'
method: GsUuidV4
asString36
"Encode the receiver as a base 36 string using 0-9 and lowercase a-z.
 Returns an instance of String."

^ (self asInteger printStringRadix: 36) asLowercase
%

category: 'Comparing'
method: GsUuidV4
hash

"Returns a positive SmallInteger based on the byte contents of the receiver.
 Uses a case-sensitive string hash algorithm.
 The algorithm implemented is described in:

 [Pearson 90]
 Pearson, Peter K., Fast Hashing of Variable-Length Text Strings,
 Communications of the ACM 33, 6, (June 1990), 677-680."

<primitive: 31>
self _primitiveFailed: #hash .
self _uncontinuableError
%

category: 'Storing and Loading'
method: GsUuidV4
loadFrom: passiveObj

"Reads from passiveObj the passive form of an object with named instance
 variable format.  Converts the object to its active form by loading the
 information into the receiver."

super loadFrom: passiveObj .
self immediateInvariant .
^ self
%

category: 'Copying'
method: GsUuidV4
postCopy
self immediateInvariant .
^ self
%

category: 'Printing'
method: GsUuidV4
printOn: aStream
"Prints a representation of the receiver onto aStream."
 
^ aStream nextPutAll: 'an UUID(';
  	  nextPutAll: self asString ;
	  nextPut: $) ;
	  yourself
%

category: 'Printing'
method: GsUuidV4
printString
"Returns a 36 character string representing the receiver formatted as specified in
 RFC 4122."
 
^ self asString
%

category: 'Updating'
method: GsUuidV4
size: anInteger
^ self shouldNotImplement: #size:
%

category: 'Accessing'
method: GsUuidV4
version
"Answer the UUID version of this object.  See RFC 4122 for UUID version
 definitions."
 
 ^ 4
%

category: 'Updating'
method: GsUuidV4
_basicSize: anInteger
^ self shouldNotImplement: #_basicSize:
%

category: 'Private'
method: GsUuidV4
_oneArgInstancePrim: arg opCode: opCode

"
opCode	kind	method
===============================
1	class	fromString:
2	inst    <
===============================
"

<primitive: 1123>
opCode _validateClass: SmallInteger .
self _primitiveFailed: #_oneArgClassPrim: .
self _uncontinuableError
%

category: 'Private'
method: GsUuidV4
_zeroArgInstancePrim: opCode

"
opCode	kind	method
===============================
1	class	_basicNew
2	inst	asString
3       inst    asInteger
===============================
"

<primitive: 1122>
opCode _validateClass: SmallInteger .
self _primitiveFailed: #_zeroArgInstancePrim: .
self _uncontinuableError
%

! Class implementation for 'KerberosPrincipal'

!		Class methods for 'KerberosPrincipal'

category: 'Accessing'
classmethod: KerberosPrincipal
allPrincipals
  ^ Globals at: #AllKerberosPrincipals otherwise: nil
%

category: 'Private'
classmethod: KerberosPrincipal
basicNewWithName: aStringOrSymbol loginUserProfile: aUserProfile
"Creates a new instance of the receiver, but does not add the new instance
 to the list to AllKerberosPrincipals.  It is an error if a principal with the same name
 already exists.  It is allowed to use nil for aUserProfile, in the case the
 KerberosPrincipal does not map to a single UserProfile."

| result |
((self principalWithName: aStringOrSymbol) notNil)
  ifTrue:[ ^ self _error: #rtErrPrincipalAlreadyExists args: { aStringOrSymbol } ] .

result := super new .
result _initializeForName: aStringOrSymbol ; loginUserProfile: aUserProfile .
^ result
%

category: 'Illegal Operations'
classmethod: KerberosPrincipal
new

"Disallowed.  To create a new KerberosPrincipal, use newWithName:loginUserProfile: instead "

self shouldNotImplement: #new
%

category: 'Illegal Operations'
classmethod: KerberosPrincipal
new: anInt

"Disallowed.  To create a new KerberosPrincipal, use newWithName:loginUserProfile: instead."
self shouldNotImplement: #new:
%

category: 'Updating'
classmethod: KerberosPrincipal
newPrincipalWithName: aStringOrSymbol loginUserProfile: aUserProfile
"Creates a new instance of KerberosPrincipal and adds it to the AllKerberosPrincipals
 collection. It is an error if a principal with the same name already exits. It is allowed to
 use nil for aUserProfile, in the case the KerberosPrincipal does not map to a single
 UserProfile.

 Requires write access to the GsObjectSecurityPolicy for DataCurator."

| result |
result := self basicNewWithName: aStringOrSymbol loginUserProfile: aUserProfile .
self allPrincipals at: aStringOrSymbol put: result .
^ result
%

category: 'Accessing'
classmethod: KerberosPrincipal
principalWithName: aStringOrSymbol
"Answer the KerberosPrincipal that has the given name or nil if no
 such KerberosPrincipal exists."

  ^ self allPrincipals at: aStringOrSymbol otherwise: nil
%

category: 'Group Management'
classmethod: KerberosPrincipal
removeGroup: aUserProfileGroup

"Remove the given UserProfileGroup object from every instance of KerberosPrincipal contained
 in the global collection AllKerberosPrincipals.  Returns the receiver.

 Requires write access to the DataCurator segment."

aUserProfileGroup _validateClass: UserProfileGroup .
self allPrincipals valuesDo:[:eachPrincipal| eachPrincipal removeGroup: aUserProfileGroup ].
^ self
%

category: 'Group Management'
classmethod: KerberosPrincipal
removeGroupWithName: aStringOrSymbol

"Remove the UserProfileGroup with name aStringOrSymbol from every instance of
 KerberosPrincipal contained in the global collection AllKerberosPrincipals.
 Returns the receiver.

 Requires write access to the DataCurator segment."

| group |
group := UserProfileGroup groupWithName: aStringOrSymbol ifAbsent:[^ self ].
self allPrincipals valuesDo:[:eachPrincipal| eachPrincipal removeGroup: group ].
^ self
%

!		Instance methods for 'KerberosPrincipal'

category: 'Accessing'
method: KerberosPrincipal
addGroup: aUserProfileGroup
  aUserProfileGroup _validateClass: UserProfileGroup .
  loginUserProfileGroups add: aUserProfileGroup .
  ^ self
%

category: 'Accessing'
method: KerberosPrincipal
loginAsAnyoneEnabled
  ^ loginAsAnyoneEnabled
%

category: 'Updating'
method: KerberosPrincipal
loginAsAnyoneEnabled: aBoolean
  loginAsAnyoneEnabled := aBoolean
%

category: 'Accessing'
method: KerberosPrincipal
loginUserProfile
  ^ loginUserProfile
%

category: 'Updating'
method: KerberosPrincipal
loginUserProfile: aUserProfile
  loginUserProfile := aUserProfile
%

category: 'Accessing'
method: KerberosPrincipal
loginUserProfileGroups
  ^ loginUserProfileGroups
%

category: 'Accessing'
method: KerberosPrincipal
name
  ^ name
%

category: 'Removing'
method: KerberosPrincipal
removeGroup: aUserProfileGroup
  loginUserProfileGroups removeIdentical: aUserProfileGroup ifAbsent:[] .
  ^ self
%

category: 'Removing'
method: KerberosPrincipal
removeGroup: aUserProfileGroup ifAbsent: aBlock
  aUserProfileGroup _validateClass: UserProfileGroup .
  loginUserProfileGroups removeIdentical: aUserProfileGroup ifAbsent: aBlock .
  ^ self
%

category: 'Testing'
method: KerberosPrincipal
validateLoginFor: aUserProfile

aUserProfile _validateClass: UserProfile .
(aUserProfile userId = 'SystemUser')
  ifTrue:[ ^ false ]. "Passwordless login may not be used for SystemUser"

(aUserProfile == loginUserProfile)
  ifTrue:[ ^ true ].

loginAsAnyoneEnabled == true
  ifTrue:[ ^ true ].

^ (loginUserProfileGroups detect:[:e| e includesIdentical: aUserProfile] ifNone:[nil]) notNil
%

category: 'Private'
method: KerberosPrincipal
_initializeForName: aStringOrSymbol
"Private.  Initializes the receiver. Used only at instance creation time."
name := aStringOrSymbol asSymbol .
loginUserProfileGroups := IdentitySet new .
loginAsAnyoneEnabled := false .
^ self

%

! Class implementation for 'LdapDirectoryServer'

!		Class methods for 'LdapDirectoryServer'

category: 'Accessing'
classmethod: LdapDirectoryServer
allServers
  ^ AllLdapDirectoryServers
%

category: 'Instance Creation'
classmethod: LdapDirectoryServer
basicNewWithUri: uri bindDN: aBindDn password: password
"Creates a new instance of the receiver, but does not add the new instance
 to the list of LDAP servers used to process login requests."

| result |
result := super new.
result uri: uri ;
       bindDN: aBindDn ;
       password: password .

^ result
%

category: 'Instance Creation'
classmethod: LdapDirectoryServer
basicNewWithUri: uri bindDN: aBindDn password: password baseDN: baseDn tlsCaCert: caCert tlsCert: cert tlsKey: key tlsReqCert: aSymbol
"Creates a new instance of the receiver but does not add it 
 the list of LdapDirectoryServer objects used to authorize logins."
 
| result |
result := super new.
result uri: uri ;
	bindDN: aBindDn ;
	password: password ;
	baseDN: baseDn ;
	tlsCaCert: caCert ;
	tlsCert: cert ;
	tlsKey: key ;
	tlsReqCert: aSymbol .
   
^ result
%

category: 'Searching'
classmethod: LdapDirectoryServer
findServerWithUri: aUriString
"Searches for an instance of LdapDirectoryServer with the given URI.
 Returns nil if the directory server was not found."

^ self allServers detect:[:e| e uri = aUriString ] ifNone:[ nil ]
%

category: 'Illegal Operations'
classmethod: LdapDirectoryServer
new

"Disallowed.  To create a new LdapDirectoryServer, use newWithUri:... instead."

self shouldNotImplement: #new
%

category: 'Illegal Operations'
classmethod: LdapDirectoryServer
new: anInt

"Disallowed.  To create a new LdapDirectoryServer, use newWithUri:... instead."
self shouldNotImplement: #new:
%

category: 'Instance Creation'
classmethod: LdapDirectoryServer
newWithUri: uri bindDN: aBindDn password: password
"Creates a new instance of the receiver and adds the resulting object to
 the list of LdapDirectoryServer objects used to authorize logins."

| result |
result := self basicNewWithUri: uri
               bindDN: aBindDn
	       password: password .
self allServers add: result .
^ result
%

category: 'Instance Creation'
classmethod: LdapDirectoryServer
newWithUri: uri bindDN: aBindDn password: password baseDN: baseDn tlsCaCert: caCert tlsCert: cert tlsKey: key tlsReqCert: aSymbol
"Creates a new instance of the receiver and adds the resulting object to
 the list of LdapDirectoryServer objects used to authorize logins."
 
| result |
result := self basicNewWithUri: uri bindDN: aBindDn password: password baseDN: baseDn tlsCaCert: caCert tlsCert: cert tlsKey: key tlsReqCert: aSymbol .
self allServers add: result .	       
^ result
%

category: 'Removing'
classmethod: LdapDirectoryServer
removeServerWithUri: aUriString
"Removes an instance of LdapDirectoryServer with the given URI.
 Returns true if the directory server was removed, false if it
 could not be found."

| server |
server := self findServerWithUri: aUriString .
server isNil
  ifTrue:[ ^ false "not found" ] .

self allServers removeIdentical: server .
^ true
%

category: 'Connection Testing'
classmethod: LdapDirectoryServer
testConnectionToServer: uri bindDN: aBindDn password: password
"Attempts to perform a bind using aBindDn and password to the LDAP server specified by
 uri.  Returns true if the connection was successful, otherwise returns false."

 | result |
 "Create a temporary instance."
result := self basicNewWithUri: uri
               bindDN: aBindDn
	       password: password .
^ result testBind
%

category: 'Connection Testing'
classmethod: LdapDirectoryServer
testConnectionToServer: uri bindDN: aBindDn password: password baseDN: baseDn tlsCaCert: caCert tlsCert: cert tlsKey: key tlsReqCert: aSymbol
"Attempts to perform a bind using aBindDn and password to the LDAP server specified by
 uri.  Also sets the TLS credentials if those arguments are not nil.
Returns true if the connection was successful, otherwise returns false."
 
 | result |
 "Create a temporary instance."
result := self basicNewWithUri: uri
               bindDN: aBindDn
	       password: password 
	       baseDN: baseDn
	       tlsCaCert: caCert
	       tlsCert: cert
	       tlsKey: key 
	       tlsReqCert: aSymbol .
^ result testBind
%

category: 'Private - Initializing'
classmethod: LdapDirectoryServer
_smartInitialize
"This method should only be called once during filein or image upgrade."
  (AllLdapDirectoryServers == nil)
    ifTrue:[ | newArray |
      newArray := Array new .
      newArray _unsafeSetOop: 156929  "OOP_AllLdapDirectoryServers".
      newArray objectSecurityPolicy: (Globals at:#DataCuratorObjectSecurityPolicy) .
      AllLdapDirectoryServers := newArray .
      ^ 'created'
  ] .
  ^ 'exists'
%

!		Instance methods for 'LdapDirectoryServer'

category: 'Accessing'
method: LdapDirectoryServer
baseDN
  ^ baseDN
%

category: 'Updating'
method: LdapDirectoryServer
baseDN: newValue
  baseDN := newValue copy
%

category: 'Accessing'
method: LdapDirectoryServer
bindDN
  ^ bindDN
%

category: 'Updating'
method: LdapDirectoryServer
bindDN: aString
  bindDN := aString copy
%

category: 'Accessing'
method: LdapDirectoryServer
bindPW
  ^ bindPW
%

category: 'Updating'
method: LdapDirectoryServer
password: aString
^ aString == nil
    ifTrue:[ nil ]
   ifFalse:[ self _encryptPassword: aString ]
%

category: 'Private'
method: LdapDirectoryServer
testBind
"Attempt to bind to the specified LDAP server. Returns true if successful, false if
 the password is invalid.  Raises an error if an LDAP error occurs."

| result |
result := self _testBind .
result class == String
  ifTrue:[ IOError signal: result ].
^ result
%

category: 'Accessing'
method: LdapDirectoryServer
tlsCaCert
  ^ tlsCaCert
%

category: 'Updating'
method: LdapDirectoryServer
tlsCaCert: newValue
  tlsCaCert := newValue copy
%

category: 'Accessing'
method: LdapDirectoryServer
tlsCaCertDir
  ^ tlsCaCertDir
%

category: 'Updating'
method: LdapDirectoryServer
tlsCaCertDir: newValue
  tlsCaCertDir := newValue copy
%

category: 'Accessing'
method: LdapDirectoryServer
tlsCert
  ^ tlsCert
%

category: 'Updating'
method: LdapDirectoryServer
tlsCert: newValue
  tlsCert := newValue copy
%

category: 'Accessing'
method: LdapDirectoryServer
tlsKey
  ^ tlsKey
%

category: 'Updating'
method: LdapDirectoryServer
tlsKey: newValue
  tlsKey := newValue copy
%

category: 'Accessing'
method: LdapDirectoryServer
tlsReqCert
  ^ tlsReqCert
%

category: 'Updating'
method: LdapDirectoryServer
tlsReqCert: newValue
"A symbol which specifies what checks to perform on server certificates
in a TLS session, if any. The following symbols are recognized:

	#never -   The client will not request or check any server certificate.
	#allow -   The  server certificate is requested. If no certificate is provided,
		          the session proceeds normally. If a bad certificate is provided,
			it will be ignored and the session proceeds normally.
	#try -	The server certificate is requested. If no certificate is provided,
			the session proceeds normally. If a bad certificate is provided,
			the session is immediately terminated.
	#demand -  The server certificate is requested. If no certificate is provided,
			or a bad certificate is provided, the session is immediately
			terminated. This is the default setting.
"
newValue isSymbol
	ifTrue:[  
		({ #never . #allow . #try . #demand } includesIdentical: newValue)
				ifFalse:[ ^ ArgumentError signal: 'Illegal tlsReqCert symbol' ].
	] ifFalse:[
		newValue isNil 
			ifFalse:[ ^ ArgumentError signal: 'Illegal object for tlsReqCert ' ] 
	].
	tlsReqCert := newValue 
%

category: 'Accessing'
method: LdapDirectoryServer
uri
  ^ uri
%

category: 'Updating'
method: LdapDirectoryServer
uri: aString
  uri := aString copy
%

category: 'Password Validation'
method: LdapDirectoryServer
validatePassword: aPassword forUserId: aUserId withBaseDn: aBaseDn filterDn: aFilterDn
"Use the receiver validate the password aPassword is valid for aUserId.  

 In order to validate the password, the complete distinguish name (DN) for 
 aUserId must be determined.  The DN can either be constructed from the aBaseDn
 pattern (explicit mode) or the DN may be resolved by searching the LDAP directory
 (search mode).  In explicit mode, aBaseDn must be a string that contains the string
 wildcard sequence '%s'.  GemStone will substitute '%s' with aUserId before
 doing the password validation.  aFilterDn must be nil in explicit mode.

 In search mode, aBaseDn is the search pattern used to resolve the DN and must
 NOT contain the string wildcard sequence '%s'.  In search mode, aFilterDn must
 be a string that contains the string wildcard sequence '%s'.  See the examples
 below.

 aUserId must be a string which represents the aUserId to be validated.
 aPassword must be a string which is the password for aUserId.

 Returns true if aPassword is the correct password for aUserId. Otherwise returns
 false if the password is incorrect or an error occurred while communicating
 with the LDAP server.  

 Setting the variable GS_DEBUG_LDAP in the gem's environment will cause LDAP debugging
 information to be printed to stdout.

 Example 1: Explicit mode

(LdapDirectoryServer basicNewWithUri: 'ldaps://myldap.mydomain.com'
 bindDN: nil password: nil baseDN: nil tlsCaCert: '/home/gemstone/cacert.pem'
 tlsCert: '/home/gemstone/cert.pem' 
tlsKey: '/home/gemstone/key.pem' tlsReqCert: #never)
validatePassword: 'swordfish' forUserId: 'DataCurator' 
withBaseDn: 'uid=%s,ou=Users,dc=mycompany,dc=com' filterDn: nil

 Example 2: Search mode with anonymous bind

(LdapDirectoryServer basicNewWithUri: 'ldaps://myldap.mydomain.com'
 bindDN: nil password: nil baseDN: nil tlsCaCert: '/home/gemstone/cacert.pem'
 tlsCert: '/home/gemstone/cert.pem' 
tlsKey: '/home/gemstone/key.pem' tlsReqCert: #never)
validatePassword: 'swordfish' forUserId: 'DataCurator' 
withBaseDn: 'ou=Users,dc=mycompany,dc=com' filterDn: '(uid=%s)'

Example 3: Search mode with authenticated bind

(LdapDirectoryServer basicNewWithUri: 'ldaps://myldap.mydomain.com'
 bindDN: 'LdapBindUser'  password: 'LdapBindPassword' baseDN: nil tlsCaCert: '/home/gemstone/cacert.pem'
 tlsCert: '/home/gemstone/cert.pem' 
tlsKey: '/home/gemstone/key.pem' tlsReqCert: #never)
validatePassword: 'swordfish' forUserId: 'DataCurator' 
withBaseDn: 'ou=Users,dc=mycompany,dc=com' filterDn: '(uid=%s)'
"

^ self _oneArgLdapPrim: 1 with: (Array with: aUserId with: aPassword with: aBaseDn with: aFilterDn)
%

category: 'Private'
method: LdapDirectoryServer
_encryptPassword: aString
"Encrypt aString into a ByteArray. Store the ByteArray in the bindPW inst var.
 Returns the receiver."

<primitive: 1008>
self _validateClass: LdapDirectoryServer .
aString _validateClass: String .
self _primitiveFailed: #_encryptPassword: args: { aString } .
self _uncontinuableError
%

category: 'Private'
method: LdapDirectoryServer
_oneArgLdapPrim: opCode with: arg

<primitive: 1009>
self _validateClass: LdapDirectoryServer .
self _primitiveFailed: #_oneArgLdapPrim:with: args: { opCode . arg} . 
self _uncontinuableError
%

category: 'Private'
method: LdapDirectoryServer
_testBind
^ self _oneArgLdapPrim: 0 with: nil
%

! Class implementation for 'PassiveObject'

!		Class methods for 'PassiveObject'

category: 'Instance Creation'
classmethod: PassiveObject
fromClientTextFile: fileName

"Creates a new instance of the receiver, and sets the instance's description
 string from the contents of the given client text file."

^ super new fromClientTextFile: fileName
%

category: 'Instance Creation'
classmethod: PassiveObject
fromServerTextFile: fileName

"Creates a new instance of the receiver, and sets the instance's description
 string from the contents of the given text file."

^ super new fromServerTextFile: fileName
%

category: 'Instance Creation'
classmethod: PassiveObject
new

"Disallowed.  Use one of the other methods in category 'Instance Creation'
 to obtain a new PassiveObject."

self shouldNotImplement: #new
%

category: 'Stream I/O'
classmethod: PassiveObject
newOnStream: aStream
  "Creates a new instance of the receiver, and sets the instance's description
 from the text on the given stream."

  ^ super new contents: aStream
%

category: 'Instance Creation'
classmethod: PassiveObject
newWithContents: passiveString

"Create a new PassiveObject for an existing description.  This is normally
 used to create an instance of PassiveObject for use in activating an object
 previously stored into a passive textual description.  The argument is the
 contents instance variable from a PassiveObject in which descriptions of other
 objects were written."

^super new contents: passiveString
%

category: 'Instance Creation'
classmethod: PassiveObject
passivate: anObject

"Writes the given file to a new instance of this class.  This method is normally
 invoked indirectly by sending the message 'passivate' to an object."

^super new passivate: anObject
%

category: 'Stream I/O'
classmethod: PassiveObject
passivate: anObject toStream: stream

"Writes the given object to the given stream, returning the stream."

^ (super new) passivate: anObject toStream: stream
%

!		Instance methods for 'PassiveObject'

category: 'Reading'
method: PassiveObject
activate
"Loads the object(s) whose representation is contained in the receiver's
 stream."

| object cancelBlock delim |

self initializeForActivation.
(contents class isBytes) ifTrue: [
  str := self readStreamClass on: contents
]
ifFalse: [
  (contents isKindOf: GsFile) ifTrue: [
    file := contents.
    file isOpen ifFalse:[ file open "reopen the file" ].
    str := self readStreamClass on: String new.
    epos := file position.
  ]
  ifFalse: [
    str := contents.
  ].
].
cancelBlock := [ objects := classes := str := exitBlock :=
  cancelBlock := exitBlock := nil ].
exitBlock  := [ cancelBlock value.  ^self].  "for error exits"
self peek == $^ ifTrue:[
  self next . "skip the $^ "
  version := self readInt .
  "skip the $^ that terminates the version header "
  (delim := self next) == $^ ifFalse:[
    self _halt: 'Version header trailing $^ not found.'
  ].
] ifFalse:[
  self halt: 'missing version header, or passive object from Gemstone/S 32bit v4.x'
].
object := self readObject.
cancelBlock value.  "comment out for debugging activation."
cancelBlock := exitBlock := nil .
file ifNotNil:[ file close ].  "reduce number of open files"
^object
%

category: 'Private - File Buffering'
method: PassiveObject
atEnd

"Private."

(file ~~ nil and: [epos == nil or: [str atEnd]]) ifTrue: [
  ^file atEnd
].
^str atEnd
%

category: 'Private - File Buffering'
method: PassiveObject
backupExternal
  "Backup the file stream to current position."

  epos
    ifNotNil: [
      file position: epos + str _fastPosition - 1.
      epos := nil	"epos being nil shows that str is invalid" ]
%

category: 'Private'
method: PassiveObject
bagMark

"Returns the character that precedes the end of instance variables markers in
 Bag objects."

^ $/
%

category: 'Private'
method: PassiveObject
checkEBuf

"Loads the cached stream from the external stream if necessary."

(file ~~ nil and: [ epos == nil or: [ str atEnd ] ]) ifTrue: [
  self loadEBuf
].
%

category: 'Private'
method: PassiveObject
checkForBagMark

"Sees the comment in writeBagMark for an explanation of Bag markers.  Skips any
 white space and then returns whether the next token is a Bag marker."

self skipWhiteSpace.
self atEnd ifTrue: [ ^false ].
^(self next == self bagMark) ifTrue: [ true ] ifFalse: [ str skip: -1. false ]
%

category: 'Private'
method: PassiveObject
checkForInstVarMark

"Sees the comment in writeBagMark for an explanation of Bag markers.  Skips any
 white space and then returns whether the next token is a Bag marker."

| char |

self skipWhiteSpace.
self atEnd ifTrue: [ ^false ].
char := self next.
str skip: -1.
^ char == $" .
%

category: 'Private'
method: PassiveObject
contents

"Returns the content string of the receiver."

^contents
%

category: 'Private'
method: PassiveObject
contents: aStringOrStreamOrGsFile
  "Sets the content string of the receiver."

  contents := aStringOrStreamOrGsFile
%

category: 'Private'
method: PassiveObject
cr

str lf
%

category: 'Private'
method: PassiveObject
endNamedInstVars

"An empty instance variable name identifies the end of named instance
 variables."

str nextPut: $" ; nextPut: $"
%

category: 'File I/O'
method: PassiveObject
fromClientTextFile: fileName

"Sets the receiver's description string from the contents of the given text
 file."

contents := GsFile openRead: fileName .
contents ifNil:[ self _halt:'Unable to open file: ' , fileName ].
%

category: 'File I/O'
method: PassiveObject
fromServerTextFile: fileName

"Sets the receiver's description string from the contents of the given text
 file."

contents := GsFile openReadOnServer: fileName .
contents ifNil:[ self _halt:'Unable to open file: ' , fileName ].
%

category: 'Reading'
method: PassiveObject
hasRead: anObject

"The given object has been instantiated but not filled out with values yet:
 assign it an identifier.  All classes must send this message to their
 strObject before filling in a new instance's values."
anObject isSpecial ifTrue:[ Error signal:'arg to hadRead: is special'. ].
objects add: anObject .
"self _checkObjectAt: objects size." "uncomment to debug activate"
^ anObject
%

category: 'Reading'
method: PassiveObject
hasRead: anObject marker: marker

"For objects whose values must be at least partially read before the object
 can be marked as read, the objectPositionMarker method can be used to
 reserve the correct object number for the as yet uninstantiated object.
 The marker token returned by objectPositionMarker can then later be used
 with this method to record the instantiated object.  For an example
 see ExecBlock class | loadFrom:."

anObject isSpecial ifTrue:[ Error signal:'arg to hadRead: is special'. ].
objects at: marker put: anObject.
"self _checkObjectAt: marker . " "uncomment to debug activate"
^anObject
%

category: 'Private'
method: PassiveObject
hasWritten: anObject
"Sees if the given object has been written already.  If so, writes out its
 identifier and returns true.  Otherwise, returns false."
| id |
anObject containsIdentity ifTrue: [^false].
id := System _inMap: 2"objects" at: anObject putIfAbsent: nextObjectNo
      serialNum: mapCache .
id == nextObjectNo ifTrue: [
  "a new entry"
  anObject isSpecial ifTrue:[ Error signal:'special object not expected'].
  objects add: anObject .
  nextObjectNo := nextObjectNo + 1.
  ^ false
] ifFalse: [
  str nextPut: $: .
  self writeInt: id .
  ^ true
]
%

category: 'Private - Initialization'
method: PassiveObject
initializeForActivation

"Prepares the receiver to activate an object that is in its passive form."

"uncomment to debug activate with _checkObjectAt: "
"objects size > 0 ifTrue:[ self dynamicInstVarAt:#saveObjs put: objects ]."

classes := { } .
objects := { } .
ivNames := { } .
nextClassNo  :=
nextObjectNo :=
nextIVNo     := 1.
epos := nil.
version := nil "the activate method will read the version header" .
%

category: 'Private - Initialization'
method: PassiveObject
initializeForStore

"Prepares the receiver to passivate an object."
classes := { } . "prevent gc of temp objects"
objects := { } . "prevent gc of temp objects"
mapCache := System _initMap: 1 "classes".
System _initMap: 2 "objects".
ivStrings := { } .
nextClassNo  :=
nextObjectNo :=
nextIVNo     := 1.
str := self writeStreamClass on: (String new).
version := 620 .
%

category: 'Private'
method: PassiveObject
ivName

"Returns the name of the last named instance variable read with readNamedIV.
 If no variable was found in readNamedIV, returns nil."

^ ivName
%

category: 'Private'
method: PassiveObject
ivValue

"Returns the value of the last named instance variable read with readNamedIV.
 If no variable was found in readNamedIV, returns nil."

^ ivVal
%

category: 'Private'
method: PassiveObject
lf

str lf
%

category: 'Reading'
method: PassiveObject
load: amount byteStringsInto: byteObj
  "Loads the given number of formatted byte-sized numbers into the given byte
 object."

  | nextIdx |
  file
    ifNotNil: [
      self backupExternal.
      file next: amount byteStringsInto: byteObj ]
    ifNil: [
      nextIdx := System
        userAction: #'GsfPassiveObjLoadByteStrings'
        with: byteObj
        with: amount
        with: str _collection
        with: str _fastPosition.
      nextIdx ifNotNil: [ str _fastPosition: nextIdx ] ]
%

category: 'Private'
method: PassiveObject
loadEBuf

"Load bytes into the cached input stream."

| c |

c := str _collection.
(epos ~~ nil and: [str atEnd not]) ifTrue: [
  "loading while not at the end of the cache stream - append the next line
   to the string"
  c add: file nextLine.
  ^self
].
epos := file position.
c size: 0.
c add: file nextLine.
str _fastPosition: 1.
%

category: 'Private'
method: PassiveObject
next

"Inlined checkEBuf."

(file ~~ nil and: [ epos == nil or: [str atEnd]]) ifTrue: [ self loadEBuf ].

^ str _fastNext
%

category: 'Private'
method: PassiveObject
next: n basicBytesTo: aString

"Private.  Stores the next n input bytes into aString."

"Used in loading JapaneseStrings"

epos ifNotNil: [ self backupExternal ].
^ file ifNotNil: [ file _next: n basicInto: aString ]
          ifNil: [ str  _next: n basicInto: aString ]
%

category: 'Private'
method: PassiveObject
next: n bytesTo: aString

"Stores the next n input bytes into the given string."

epos ifNotNil: [ self backupExternal ].
^ file ifNotNil: [ file next: n into: aString ]
          ifNil: [ str  nextElements: n into: aString ]
%

category: 'Private'
method: PassiveObject
nextClassNumber

"Private."

| cur |

cur := nextClassNo.
nextClassNo := nextClassNo + 1.
^ cur
%

category: 'Private'
method: PassiveObject
nextPut: aCharacter

"Private."

str nextPut: aCharacter
%

category: 'Private'
method: PassiveObject
nextPutAll: aString

"Private."

str nextPutAll: aString
%

category: 'Private'
method: PassiveObject
nextPutAllBytes: aString

"Private."

str _nextPutAllBytes: aString
%

category: 'Private - Initialization'
method: PassiveObject
nextPutVersion

"Writes the version header to the receiver's stream."

self nextPut: $^ ; nextPutAll: version asString; nextPut: $^
%

category: 'Reading'
method: PassiveObject
objectPositionMarker

"Reserve a place for an object that's being read but has no ID yet.  The marker
 can be used with hasRead:marker: when the object has been created.  An example
 use is activation of ExecBlock objects, which must read a source code
 string and compile it to create the block object.  On writing the block, the
 block is assigned an object number before the string, so on reading the block
 back in this ordering must be maintained."

objects add: nil.
^ objects size
%

category: 'Accessing'
method: PassiveObject
oldClassMap

"Returns the value of the oldClassMap instance variable."

^ oldClassMap
%

category: 'Accessing'
method: PassiveObject
oldClassMap: aSymbolDictionary

"Updates the value of the oldClassMap instance variable."

oldClassMap := aSymbolDictionary
%

category: 'Private'
method: PassiveObject
passivate: anObject
self initializeForStore.
self nextPutVersion .
self hasWritten: anObject.  "assigns an identifier for the object"
anObject writeTo: self.
contents := str _collection.
System _initMap: 1"classes";  "deallocate map"
       _initMap: 2"objects".  "deallocate map"

"uncomment to debug, to check for sends of objectPositionMarker
  without matching send of  hasRead:marker: "
"1 to: objects size do:[:n | (objects at: n) == nil ifTrue:[ nil pause ]]."

classes := objects := str := nil.  "comment out if using _checkObjectAt: for debugging activate"
^ self
%

category: 'Stream I/O'
method: PassiveObject
passivate: anObject toStream: streamOrFile

"Passivates the given object, writing the description out to the given stream.
 This does not result in a state where the receiver can activate the object.

 It is intended that streamOrFile be an instance of GsFile opened
 for writing, and that a new instance of PassiveObject be used to read
 the file when re-activation is desired."

self initializeForStore.
str := streamOrFile.
self nextPutVersion .
self hasWritten: anObject.  "assigns an identifier for the object"
anObject writeTo: self.
System _initMap: 1"classes"; "deallocate map"
       _initMap: 2"objects". "deallocate map"
str isExternal ifTrue:[ str close ] .
str := nil.

"uncomment to debug, to check for sends of objectPositionMarker
  without matching send of  hasRead:marker: "
"1 to: objects size do:[:n | (objects at: n) == nil ifTrue:[ nil pause ]]."

classes := objects := str := nil. "comment out if using _checkObjectAt: for debugging activate"

^ self
%

category: 'Private'
method: PassiveObject
peek

"Inlined checkEBuf."

(file ~~ nil and: [ epos == nil or: [str atEnd]]) ifTrue: [ self loadEBuf ].
^str peek
%

category: 'Private'
method: PassiveObject
putIvName: ivname
| id s nivno |
"classes dict is overloaded - no need to keep two dictionaries"
id := System _inMap: 1"classes" at: ivname putIfAbsent: (nivno := nextIVNo)
      serialNum: mapCache .
id == nivno ifTrue: [
  classes add: ivname .
  nextIVNo := nivno + 1.
  s := String new.
  s add: $" ; addAll: ivname; add: $" .
  str nextPutAll: s.
  s size: 1; addAll: id asString; add: $".
  ivStrings add: s.
] ifFalse: [
  str nextPutAll: (ivStrings at: id)
].
%

category: 'Private'
method: PassiveObject
readClass

"Private.  Reads in a class name or ID and returns the corresponding class."

| id name class ch |

self skipWhiteSpace.
ch := self next.
ch == $? ifTrue:[
  id := self readInt.
  ^ classes at: id
].
"get the class name and see if the class exists in this image"
name := String with: ch .
name addAll: (self upTo: $( ).

(class := self resolveSymbol: name ) ifNil:[
  self _halt: 'Your GemStone repository is missing class ' , name  .

  "if application proceeded from the notification error, try
  to fetch the object again.  Exit if not found"
  class := self resolveSymbol: name.
  "class is either nil (not found) or the Association for 'name'"
  class ifNil: [exitBlock value].
  class := class value.
] ifNotNil: [
  class := class value
].
classes add: class.
^ class
%

category: 'Private'
method: PassiveObject
readInt
  "Reads an int from the input position"

  | idx coll int c neg size |
  (file ~~ nil and: [ epos == nil or: [ str atEnd ] ])
    ifTrue: [ self loadEBuf ].	"this code disrespects the privacy of the stream, but this
 method must be as fast as possible"
  idx := str _fastPosition.
  coll := str _collection.
  int := 0.
  size := coll size.
  neg := (coll at: idx) == $-.
  neg
    ifTrue: [ idx := idx + 1 ].
  idx to: size do: [ :i |
    c := (coll at: i) codePoint.
    (48 <= c and: [ c <= 57 ])
      ifTrue: [ int := int * 10 + c - 48 ]
      ifFalse: [
        "End of integer"
        idx := i.
        c == 32
          ifTrue: [ idx := idx + 1 ].
        str _fastPosition: idx.
        ^ neg
          ifTrue: [ int * -1 ]
          ifFalse: [ int ] ] ].	"End of string"
  idx := size + 1.
  str _fastPosition: idx.
  ^ neg
    ifTrue: [ int * -1 ]
    ifFalse: [ int ]
%

category: 'Private'
method: PassiveObject
readNamedIV

"Reads the next instance variable name and object and puts them into ivName and
 ivValue in the receiver.  Returns false if the next input item is not an
 instance variable name or the end-of-named-instance-variables mark, and true
 otherwise.  If a name and object are not both read, ivName and ivValue will be
 nil."

| char obj name globalName ascii int |

"Care must be taken in this method to not rely on the state of ivName
 and ivVal.  This method must be reentrant for recursive activations
 started within this method, and it must return the correct values in
 ivName/ivVal when completed"

ivName := ivVal := nil.

self skipWhiteSpace.
self atEnd ifTrue: [ ^false ].
self checkEBuf.
char := str _fastNext.
char == $/ ifTrue: [
  "end of Bag mark - precedes ivPrefix marks"
  str skip: -1.
  ^true
].

char == $"  ifFalse: [
  str skip: -1.
  ^false
].

"check for end of named instance variables"
char := str _fastNext.
char == $"  ifTrue: [
  str skip: -2.
  ^true
].

ascii := char codePoint.
(ascii <= 57 and: [48 <= ascii]) ifTrue: [ | ivSz |
  str skip: -1.
  int := self readInt.
  self next. "consume the quote char"
  int > (ivSz := ivNames size) ifTrue: [
    self _halt:
'A forward instance variable name reference has been encountered
during object activation.  Select "continue" to proceed and
skip activation of this object'.
    exitBlock value
  ].
  name := ivNames at: int.
]
ifFalse: [
  name := String with: char.
  [ str atEnd not and: [
    char := str _fastNext.  char ~~ $"  ] ] whileTrue: [
    name add: char
  ].
  ivNames add: name.
].

self skipWhiteSpace.
char := str peek.
char == $. ifTrue: [
  str next.
  ivName := name.
  ivVal := nil.
  ^true
].
char == $* ifTrue: [
  str next.
  ivName := name.
  ivVal := true.
  ^true
].
char == $~ ifTrue: [
  str next.
  ivName := name.
  ivVal := false.
  ^true
].
(char == $# and:[ version >= 500]) ifTrue: [
  str next.
  ivName := name.
  ivVal := _remoteNil .
  ^true
].

ascii := char codePoint.

((57 >= ascii and: [ascii >= 48]) or: [char == $-]) ifTrue: [
  obj := self readInt.
  obj _isSmallInteger ifFalse: [
    (version >= 500) ifTrue:[
      self hasRead: obj.  "identity of object was relevant at passivation"
    ].
  ].
  ivName := name.
  ivVal := obj.
  ^true
].

char == $: ifTrue: [ | oSz |
  "identifier of an object that's already been activated"
  str _fastNext.
  obj := self readInt.
  (oSz := objects size) >= obj ifTrue: [ obj := objects at: obj ]
  ifFalse: [
    self _halt: 'An object identifier was found in passive description
that has not yet been defined.' .
    exitBlock value
  ].
  ivName := name.
  ivVal  := obj.
  ^true
].

char == $$ ifTrue: [ "8-bit Character"
  str _fastNext.
  obj := str _fastNext.
  "chars contain their identity, so no identifier is needed"
  ivName := name.
  ivVal  := obj.
  ^true
].
(char == $! _and:[ version >= 500]) ifTrue: [ "16-bit Character"
  str _fastNext.
  obj := Character withValue:
    (( str _fastNext codePoint * 256) + str _fastNext codePoint) .
  ivName := name.
  ivVal  := obj.
  ^true
].
(char == $& _and:[ version >= 600]) ifTrue:[ "32bit character"
  str _fastNext.
  obj := 0 .
  4 timesRepeat:[ obj := (obj * 256) + str _fastNext codePoint ].
  ivName := name.
  ivVal  := Character withValue: obj .
  ^true
].
"check for a letter or a name token.  Character isLetter is "
(char == $? or: [char isLetter]) ifTrue: [
  "a class ID or name"
  obj := (self readClass loadFrom: self).
  ivName := name.
  ivVal  := obj.
  ^true
].

(char == $@ or: [char == $%]) ifFalse: [
  self _halt: 'Unknown token type encountered in passive object description.' .
  exitBlock value
].

"a global reference"
str _fastNext.
globalName := self upTo: $ .
obj := self resolveSymbol: globalName .
obj ifNotNil:[
  obj := obj value
] ifNil: [
  self _halt:
     'A passive object is being activated that refers to an object named '
     , globalName , '. ' ,
     'However, your environment does not include an object by this name.' .
  ^exitBlock value
].

"check for metaclass reference"
char == $% ifTrue: [
  obj := obj class
].

self hasRead: obj.
ivName := name.
ivVal  := obj.
^true
%

category: 'Reading'
method: PassiveObject
readObject
"Returns the next object from the stream."

| char obj ascii globalName |

self skipWhiteSpace.
self atEnd ifTrue: [
  ^nil
].
self checkEBuf.
char := str peek.

char == $. ifTrue: [
  str next.
  ^nil
].
char == $# ifTrue: [
  str next.
  ^ _remoteNil
].

char == $* ifTrue: [
  str next.
  ^true
].

char == $~ ifTrue: [
  str next.
  ^false
].

ascii := char codePoint.

((57 >= ascii and: [ascii >= 48]) or: [char == $-]) ifTrue: [
  obj := self readInt.
  obj _isSmallInteger ifFalse: [
    (version >= 500) ifTrue:[
      self hasRead: obj.  "identity of object was relevant at passivation"
    ]
  ].
  ^obj
].

char == $: ifTrue: [
  "identifier of an object that's already been activated"
  self next.
  obj := self readInt.
  (objects size >= obj) ifTrue: [ obj := objects at: obj ]
  ifFalse: [
    self _halt: 'An object identifier was found in passive description
that has not yet been defined.' .
    exitBlock value
  ].
  ^obj
].

char == $$ ifTrue: [ "8-bit Character"
  str _fastNext.
  obj := str _fastNext.
  "chars contain their identity, so no identifier is needed"
  ^obj
].
(char == $! _and:[ version >= 500]) ifTrue: [ "16-bit Character"
  str _fastNext.
  obj := Character withValue:
    (( str _fastNext codePoint * 256) + str _fastNext codePoint) .
  "chars contain their identity, so no identifier is needed"
  ^obj
].
(char == $& _and:[ version >= 600]) ifTrue:[ "32bit character"
  str _fastNext.
  obj := 0 .
  4 timesRepeat:[ obj := (obj * 256) + str _fastNext codePoint ].
  ^ Character withValue: obj
].
"check for a letter or a name token.  Character isLetter is "
(char isLetter or: [char == $?]) ifTrue: [
  "a class ID or name"
  ^ self readClass loadFrom: self .
].

(char == $@ or: [char == $%]) ifFalse: [
  self _halt:
'Unknown token type encountered in passive object description.' .
  exitBlock value
].

"a global reference"
self next.  "gobble the prefix"
globalName := self upTo: $ .
globalName := globalName asSymbol.
obj := self resolveSymbol: globalName .
obj ifNotNil: [
  obj := obj value
] ifNil: [
  self _halt:
    'A passive object is being activated that refers to an object named '
       , globalName , '. ' ,
    'However, your environment does not include an object by this name.' .
  ^exitBlock value
].

"check for metaclass reference"
char == $% ifTrue: [
  obj := obj class
].

self hasRead: obj .
^obj
%

category: 'Private'
method: PassiveObject
readSize

^self skipWhiteSpace; readInt
%

category: 'Private'
method: PassiveObject
readStreamClass

^ReadStreamLegacy
%

category: 'Private'
method: PassiveObject
resolveSymbol: aString

"Private.  Returns the SymbolAssociation found by searching the appropriate
 dictionaries and symbol list, or nil if not found."

| sym assoc |
sym := Symbol _existingWithAll: aString  .
sym ifNil:[ ^ nil ].
oldClassMap ifNotNil:[
  assoc := oldClassMap associationAt: sym otherwise: nil .
  assoc ifNotNil:[ ^ assoc ].
].
^ GsSession currentSession resolveSymbol: sym
%

category: 'Private'
method: PassiveObject
skipNamedInstVars

"Read any remaining named instance variables - they are obsolete now."

| c bagMark |

bagMark := self bagMark.
self skipWhiteSpace .
[ ((c := self next) == $" ) and:[self next == $" ] ] whileFalse: [
  (c == bagMark) ifTrue: [
    str skip: 1.
    ^self
  ] ifFalse: [
    str skip: -2.
  ].
  (self readNamedIV) ifFalse: [ ^self ].
  self skipWhiteSpace.
].
%

category: 'Private'
method: PassiveObject
skipWhiteSpace

| c |
[ self atEnd ] whileFalse: [
  c := (self next) codePoint.  "read from self to make sure buffering is ok"
  (c < 33 and: [c == 32 or: [c == 10 or: [c == 9 or: [c == 13 or: [c == 12]]]]])
  ifFalse: [
    str skip: -1.
    ^self.
  ].
].
%

category: 'Private'
method: PassiveObject
space

str nextPut: $  .
%

category: 'File I/O'
method: PassiveObject
toClientTextFile: fileName

"Writes the receiver's passive description to the given text file."

self deprecated: 'PassiveObject>>toClientTextFile: deprecated in v3.x.  Use an instance of GsFile to access the file system.'.

contents ifNil: [
   ''  toClientTextFile: fileName
] ifNotNil: [
  contents toClientTextFile: fileName
]
%

category: 'File I/O'
method: PassiveObject
toServerTextFile: fileName

"Writes the receiver's passive description to the given text file."

self deprecated: 'PassiveObject>>toServerTextFile: deprecated in v3.x.  Use an instance of GsFile to access the file system.'.

contents ifNil: [
   ''  toServerTextFile: fileName
] ifNotNil: [
  contents toServerTextFile: fileName
]
%

category: 'Private'
method: PassiveObject
upTo: aChar

^str upTo: aChar
%

category: 'Private'
method: PassiveObject
upToSeparator

| c result size |

result := String new.
self checkEBuf.
size := str size.
[str atEnd or: [(c := str next) isSeparator]] whileFalse: [
  result add: c.
  c := nil
].
c ifNotNil: [
  str skip: -1
].
^result
%

category: 'Accessing'
method: PassiveObject
version

"Returns the value of the version instance variable, which represents the
 version of GemStone that wrote the passivated object(s).
 Version 5.x of GemStone 32bit has value 500.
 Gemstone/64 v2.4 has value 510 .
 Gemstone/64 v2.4.x has value 600 .
 Gemstone/64 v3.0 has value 610 . 
 Gemstone/64 v3.6 has value 620 . "

^ version
%

category: 'Private'
method: PassiveObject
writeBagMark

"Older versions of GemStone did not allow named instance variables in Bag and
 its subclasses so the passive descriptions of these objects did not include
 named instance variable sections.  These classes can now have named instance
 variables, so descriptions of their instances now have named instance variable
 sections.  The loading algorithms have difficulty in distinguishing a
 zero-length Bag from its surrounding objects without the help of a special
 token.  This method writes that token onto the output stream."

self nextPut: self bagMark
%

category: 'Private'
method: PassiveObject
writeBytes: byteObj

str isExternal ifTrue: [
  str printBytes: byteObj
]
ifFalse: [
  str nextPutAll: (System userAction: #GsfPassiveObjPrint with: byteObj)
]
%

category: 'Private'
method: PassiveObject
writeClass: aClass
"Sees if the given class has been written to str already.  If so, writes out its
 identifier and returns true.  Otherwise, writes out its name and returns
 false."
| id |
id := System _inMap: 1"classes" at: aClass putIfAbsent: nextClassNo
      serialNum: mapCache .
id == nextClassNo ifTrue: [
  "a new class"
  classes add: aClass .
  nextClassNo := nextClassNo + 1.
  str nextPutAll: aClass name; nextPut: $( .
  ^ false
] ifFalse: [
  str nextPut: $? .
  self writeInt: id .
  ^ true
]
%

category: 'Private'
method: PassiveObject
writeGlobalRef: name

str nextPut: $@; nextPutAll: name; nextPut: $ .
%

category: 'Private'
method: PassiveObject
writeInt: anInteger

"Write an Integer to the output stream."

str nextPutAll: anInteger asString; nextPut: $ .
%

category: 'Writing'
method: PassiveObject
writeNamedIvsFrom: anObject class: aClass

  | ivs nFixedIvs sym |
  ivs := aClass _instVarNames .
  nFixedIvs := aClass instSize .
  aClass firstPublicInstVar to: nFixedIvs do: [:i |
    sym := ivs at: i .
    (anObject shouldWriteInstVar: sym ) ifTrue: [
      self writeObject: (anObject instVarAt: i) named: sym .
    ].
  ].
  anObject tagSize ~~ 0 ifTrue:[ |dynIvNames |
    dynIvNames := anObject _instvarNamesAfter: nFixedIvs .
    1 to: dynIvNames size do:[:j |
      sym := dynIvNames at: j .
      (anObject shouldWriteDynamicInstVar: sym) ifTrue:[
        self writeObject: (anObject dynamicInstVarAt: sym) named: sym
      ].
    ].
  ].
%

category: 'Writing'
method: PassiveObject
writeObject: anObject
"Use this method to write components of another object to the output stream."

"true, false and nil are handled internally since they make up a large
 part of many objects.  This lets activation and passivation avoid
 checking to see if these objects have been read/written each time
 they are encountered."

anObject ifNil:[
  str nextPut: $. .
  ^nil
  ].
anObject == _remoteNil ifTrue:[
  str nextPut: $# .
  ^_remoteNil
  ].
anObject == true ifTrue: [
  str nextPut: $* .
  ^true
  ].
anObject == false ifTrue: [
  str nextPut: $~ .
  ^false
  ].

(self hasWritten: anObject) ifTrue: [^anObject].

"at this point, a query to global directories could be made, and
  a 'Global' entry could be made in the stream, instead of passivating
  'anObject'.  This could be useful in clamping off objects that have
  their own version-control lists"

(anObject isBehavior) ifTrue: [
  anObject isMeta ifTrue: [
    self nextPut: $%; nextPutAll: anObject thisClass name
  ]
  ifFalse: [
    self nextPut: $@; nextPutAll: anObject name; nextPut: $ .
  ].
]
ifFalse: [
  anObject writeTo: self
].
^anObject
%

category: 'Writing'
method: PassiveObject
writeObject: anObject named: objName

"Use this method to write components of another object to the output stream with
 instance variable names included.  When read back in, the corresponding named
 instance variable reading method must be used."

(anObject isKindOf: Collection) ifTrue: [
  str lf
].
self putIvName: objName.
^self writeObject: anObject
%

category: 'Private'
method: PassiveObject
writeSize: anInteger

"Write a size to the string"

str nextPutAll: anInteger asString; nextPut: $ .
%

category: 'Private'
method: PassiveObject
writeStreamClass

^WriteStreamLegacy
%

category: 'Private'
method: PassiveObject
_checkObjectAt: idx
(self dynamicInstVarAt:#saveObjs) ifNotNil:[:saveObjs | | saveCls cls ok |
  saveCls := (saveObjs at: idx) class .
  cls := (objects at: idx) class .
  (ok := saveCls == cls) ifFalse:[  
    cls == ExecBlock ifTrue:[ ok := saveCls _subclassOf: ExecBlock ].
  ].
  ok ifFalse:[
    self _halt:' bad object'.
  ].
].
%

category: 'Private'
method: PassiveObject
_halt: aString
 | pos line column ln |
 [ str ifNotNil:[
    pos := str position .
    line := (ln := (contents ifNil:[ str _collection]) _lineNumberFor: pos) at: 1 .
    column := ln at: 2 .
  ].
 ] on: Error do:[:ex | "ignore" ].
 ^ super _halt: aString .
%

! Class implementation for 'Pragma'

!		Class methods for 'Pragma'

category: 'finding'
classmethod: Pragma
allNamed: aSymbol from: aSubClass to: aSuperClass
	"Answer a collection of all pragmas found in methods of all classes between aSubClass and aSuperClass (inclusive) whose keyword is aSymbol."

	| stream |
	stream := WriteStream on: (Array new: 100).
	{aSubClass} , aSubClass allSuperClasses do:
			[:class |
			self withPragmasIn: class
				do: [:pragma | pragma keyword = aSymbol ifTrue: [stream nextPut: pragma]].
			aSuperClass = class ifTrue: [^stream contents]].
	^stream contents
%

category: 'finding'
classmethod: Pragma
allNamed: aSymbol from: aSubClass to: aSuperClass sortedByArgument: anInteger
	"Answer a collection of all pragmas found in methods of all classes between aSubClass and aSuperClass (inclusive) whose keyword is aSymbol, sorted according to argument anInteger."

	^ self allNamed: aSymbol from: aSubClass to: aSuperClass sortedUsing: [ :a :b | (a argumentAt: anInteger) < (b argumentAt: anInteger) ].
%

category: 'finding'
classmethod: Pragma
allNamed: aSymbol from: aSubClass to: aSuperClass sortedUsing: aSortBlock
	"Answer a collection of all pragmas found in methods of all classes between aSubClass and aSuperClass (inclusive) whose keyword is aSymbol, sorted according to aSortBlock."

	^ (self allNamed: aSymbol from: aSubClass to: aSuperClass) sortWithBlock: aSortBlock.
%

category: 'finding'
classmethod: Pragma
allNamed: aSymbol in: aClass
	"Answer a collection of all pragmas found in methods of aClass whose keyword is aSymbol."

	| stream |
	stream := WriteStream on: (Array new: 100).
	self withPragmasIn: aClass
		do: [:pragma | pragma keyword = aSymbol ifTrue: [stream nextPut: pragma]].
	^stream contents
%

category: 'finding'
classmethod: Pragma
allNamed: aSymbol in: aClass sortedByArgument: anInteger
	"Answer a collection of all pragmas found in methods of aClass whose keyword is aSymbol, sorted according to argument anInteger."

	^ self allNamed: aSymbol in: aClass sortedUsing: [ :a :b | (a argumentAt: anInteger) < (b argumentAt: anInteger) ].
%

category: 'finding'
classmethod: Pragma
allNamed: aSymbol in: aClass sortedUsing: aSortBlock
	"Answer a collection of all pragmas found in methods of aClass whose keyword is aSymbol, sorted according to aSortBlock."

	^ (self allNamed: aSymbol in: aClass) sortWithBlock: aSortBlock.
%

category: 'private'
classmethod: Pragma
keyword: aSymbol arguments: anArray
	^ self new
		setKeyword: aSymbol;
		setArguments: anArray;
		yourself.
%

category: 'private'
classmethod: Pragma
withPragmasIn: aClass do: aBlock
	(aClass methodDictForEnv: 0) keysAndValuesDo: [ :selector :method | method pragmas do: aBlock ].
%

!		Instance methods for 'Pragma'

category: 'accessing-pragma'
method: Pragma
argumentAt: anInteger
	"Answer one of the arguments of the pragma."

	^ self arguments at: anInteger.
%

category: 'accessing-pragma'
method: Pragma
arguments
	"Answer the arguments of the receiving pragma. For a pragma defined as <key1: val1 key2: val2> this will answer #(val1 val2)."

	^ arguments
%

category: 'accessing-pragma'
method: Pragma
keyword
	"Answer the keyword of the receiving pragma. For a pragma defined as <key1: val1 key2: val2> this will answer #key1:key2."

	^ keyword
%

category: 'accessing-pragma'
method: Pragma
message
	"Answer the message of the receiving pragma."

	^ Message selector: self keyword arguments: self arguments.
%

category: 'accessing-method'
method: Pragma
method
	"Answer the compiled-method containing the pragma."

	^ method
%

category: 'accessing-method'
method: Pragma
methodClass
	"Answer the class of the method containing the pragma."

	^self method inClass
%

category: 'accessing-pragma'
method: Pragma
numArgs
	"Answer the number of arguments in the pragma."

	^ self arguments size.
%

category: 'printing'
method: Pragma
printOn: aStream
	aStream nextPut: $<.
	self keyword precedence = 1
		ifTrue: [ aStream space; nextPutAll: self keyword ]
		ifFalse: [
			self keyword keywords with: self arguments do: [ :key :arg |
				aStream space; nextPutAll: key; space; print: arg ]].
	aStream space; nextPut: $>.
%

category: 'accessing-method'
method: Pragma
selector
	"Answer the selector of the method containing the pragma."

	^ method selector.
%

category: 'initialization'
method: Pragma
setArguments: anArray
	arguments := anArray
%

category: 'initialization'
method: Pragma
setKeyword: aSymbol
	keyword := aSymbol
%

category: 'initialization'
method: Pragma
setMethod: aCompiledMethod
	method := aCompiledMethod
%

category: 'testing'
method: Pragma
_refersToLiteral: aLiteral
  ^ self keyword == aLiteral or: [ self arguments _refersToLiteral: aLiteral ]
%

! Class implementation for 'Processor'

!		Class methods for 'Processor'

category: 'Accessing'
classmethod: Processor
activePriority

^ self _scheduler activePriority
%

category: 'Accessing'
classmethod: Processor
activeProcess

^ self _scheduler activeProcess
%

category: 'Accessing'
classmethod: Processor
allProcesses

^ self _scheduler allProcesses
%

category: 'Event Scheduling'
classmethod: Processor
cancelWhenReadable: aGsSocket signal: objToNotify

^ self _scheduler cancelWhenReadable: aGsSocket signal: objToNotify
%

category: 'Event Scheduling'
classmethod: Processor
cancelWhenWritable: aGsSocket signal: objToNotify

^ self _scheduler cancelWhenWritable: aGsSocket signal: objToNotify
%

category: 'Priorities'
classmethod: Processor
highestPriority

^ self _scheduler highestPriority
%

category: 'Priorities'
classmethod: Processor
highIOPriority

^ self _scheduler highIOPriority
%

category: 'Priorities'
classmethod: Processor
lowestPriority

^ self _scheduler lowestPriority
%

category: 'Priorities'
classmethod: Processor
lowIOPriority

^ self _scheduler lowIOPriority
%

category: 'Accessing'
classmethod: Processor
readyProcesses

^ self _scheduler readyProcesses
%

category: 'Accessing'
classmethod: Processor
suspendedProcesses

^ self _scheduler suspendedProcesses
%

category: 'Priorities'
classmethod: Processor
systemBackgroundPriority

^ self _scheduler systemBackgroundPriority
%

category: 'Priorities'
classmethod: Processor
timingPriority

^ self _scheduler timingPriority
%

category: 'Priorities'
classmethod: Processor
userBackgroundPriority

^ self _scheduler userBackgroundPriority
%

category: 'Priorities'
classmethod: Processor
userInterruptPriority

^ self _scheduler userInterruptPriority
%

category: 'Priorities'
classmethod: Processor
userSchedulingPriority

^ self _scheduler userSchedulingPriority
%

category: 'Accessing'
classmethod: Processor
waitingProcesses

^ self _scheduler waitingProcesses
%

category: 'Event Scheduling'
classmethod: Processor
whenReadable: aGsSocket signal: objToNotify

^ self _scheduler whenReadable: aGsSocket signal: objToNotify
%

category: 'Event Scheduling'
classmethod: Processor
whenWritable: aGsSocket signal: objToNotify

^ self _scheduler  whenWritable: aGsSocket signal: objToNotify
%

category: 'Process State Change'
classmethod: Processor
yield

^ self _scheduler yield
%

category: 'Private'
classmethod: Processor
_scheduler

"Returns   ProcessorScheduler scheduler "
<primitive: 457>

self _primitiveFailed: #_scheduler
%

! Class implementation for 'ProfMonitor'

!		Class methods for 'ProfMonitor'

category: 'Estimating'
classmethod: ProfMonitor
computeInterval: unprofiledCpuTimeSeconds
 "Returns an estimated profiling interval in nanoseconds for an execution
  taking the specified amount of cpu time, to yield
  approximately 100000 samples.  The number of samples might vary
  by +/- 30% from the target.  The profiled execution will take much
  longer to execute than the same non-profiled execution.

  The 10.0/100000 portion of this computation is an approximation.
  A more sophisticated algorithm might use a different value for
  <= 1 second cpu  than it does for 20 seconds of cpu. There might
  also be some variation in the constant needed between very slow
  and very fast cpu hardware.  As the total cpu time gets smaller,
  the overhead of profiling , plus limited resolution of the software
  clocks could require some non-linearity in the algorithm.
  A more sophisticated algorithm might calibrates itself to a specific
  real or virtualized cpu  and store calibration data in
     SessionTemps current .
"
 | ns |
 ns := (10.0 * unprofiledCpuTimeSeconds / 100000 / 1.0e-9 ) asInteger .
 ns < 1000 ifTrue:[ ns := 1000 ].
 ^ ns
%

category: 'Defaults'
classmethod: ProfMonitor
defaultIntervalNs

"Returns the number of CPU nanoseconds used for a monitoring interval if no
 interval is given.
 This value produces about 100000 samples for an unprofiled CPU time of 5 seconds."

 ^ 500000 "500 micro seconds"
%

category: 'Reporting'
classmethod: ProfMonitor
defaultReports
  ^{#samples . #stackSamples . #senders . #objCreation}
%

category: 'Quick Profiling'
classmethod: ProfMonitor
monitorBlock: aBlock

"Profile the execution of a block and return a formatted report of the results.
 An interval of 1 millisecond is used, and the results are reported down
 methods that use 3% of the total time"

^self monitorBlock: aBlock
       downTo: 0.03
       intervalNs: self defaultIntervalNs
       options: #()
%

category: 'Quick Profiling'
classmethod: ProfMonitor
monitorBlock: aBlock downTo: threshold

"Profile the execution of a block and return a formatted report of the results.
 An interval of 1 millisecond is used. The threshold argument should be
 a Float 0.01-0.99, or a SmallInteger > 1, specifying the percent of time or
 the number of hits, below which to exclude methods from the report."

 ^self monitorBlock: aBlock
       downTo: threshold
       intervalNs: self defaultIntervalNs
       options: #()
%

category: 'Quick Profiling'
classmethod: ProfMonitor
monitorBlock: aBlock downTo: threshold interval: millisecondsPerSample

"Profile the execution of a block and return a formatted report of the results.
 The millisecondsPerSample argument gives the CPU time interval between
 samples in milliseconds.  The threshold argument should be a Float 0.01-0.99,
 or a SmallInteger > 1, specifying the percent of time or the number of hits,
 below which to exclude methods from the report."

^self monitorBlock: aBlock
       downTo: threshold
       intervalNs: (millisecondsPerSample * 1000000)
       options: #()
%

category: 'Quick Profiling'
classmethod: ProfMonitor
monitorBlock: aBlock downTo: threshold intervalNs: nanosecondsPerSample

"Profile the execution of a block and return a formatted report of the results.
 The nanosecondsPerSample argument gives the CPU time interval between
 samples in nanoseconds. The threshold argument should be a Float 0.01-0.99,
 or a SmallInteger > 1, specifying the percent of time or the number of hits,
 below which to exclude methods from the report."

 ^self monitorBlock: aBlock
       downTo: threshold
       intervalNs: nanosecondsPerSample
       options: #()
%

category: 'Quick Profiling'
classmethod: ProfMonitor
monitorBlock: aBlock downTo: threshold intervalNs: nanosecondsPerSample options: anArray
 "Profile the execution of a block and return a formatted report of the results.
  threshold should be a Float in the range 0.01 to 0.99 specifying a percent of
  total time below which to exclude methods from the report, or a SmallInteger > 1
  specifying a sample count below which to exclude methods from the report.
  The nanosecondsPerSample argument gives the CPU time interval between samples.
  anArray is an Array of Strings or Symbols containing at most one of
    #objFaults #pageFaults #edenUsage #gcTime #objCreation
  and optionally
    #cpu or #real .
  #cpu or #real (if included) specifies real or cpu time sampling, otherwise the i
  default depends on the type of profiling.
    If profiling type is not specified, the default is #cpu.
    #gcTime defaults to #cpu, and is in units of milliseconds  .
    #objFaults and #pageFaults default to #real, and are in units of faults .
    #edenUsage defaults to #reali, and is in units of bytes.
    #objCreation defaults to #cpu, and produces additional reports."

  | inst result |
  inst := self basicNew initializeNoFile .
  inst setOptions: anArray .
  threshold _validateClasses: { Float . SmallInteger }.
  threshold < 0.01 ifTrue:[ ArgumentError signal:'threshold must be > 0.01' ].
  inst _createFile: self newProfileFileName;  intervalNs: nanosecondsPerSample .
  inst monitorBlock: aBlock.
  result := inst reportDownTo: threshold reports: self defaultReports .
  inst removeResults ; removeFile .
  ^ result
%

category: 'Quick Profiling'
classmethod: ProfMonitor
monitorBlock: aBlock downTo: threshold intervalNs: nanosecondsPerSample reports: reportArray
 "Profile the execution of a block and get a report of the result.
  threshold should be a Float in the range 0.01 to 0.99 specifying a percent of total time below
   which to exclude methods from the report, or a SmallInteger > 1 specifying a sample count below
  which to exclude methods from the report.
  The nanosecondsPerSample argument gives the CPU time interval between samples.
  anArray is an Array of Strings or Symbols.
 reportsArray can include any or all of
      #samples #stackSamples #senders #objCreation #tree #objCreationTree
  specifying which reports to include and the desired order.
  specifying an obj creation report enables object creation; specifying a tree
  report uses ProfMonitorTree."

| inst result |
inst := ((reportArray includes: #tree) or: [reportArray includes: #objCreationTree])
	ifTrue: [(Globals at: #ProfMonitorTree) basicNew initializeNoFile .]
	ifFalse: [self basicNew initializeNoFile .].

((reportArray includes:  #objCreation) or: [reportArray includes: #objCreationTree])
	ifTrue: [inst setOptions: {#objCreation} ].

  threshold _validateClasses: { Float . SmallInteger }.
  threshold < 0.01 ifTrue:[ ArgumentError signal:'threshold must be > 0.01' ].
  inst _createFile: self newProfileFileName;  intervalNs: nanosecondsPerSample .
  inst monitorBlock: aBlock.
  result := inst reportDownTo: threshold reports: reportArray .
  inst removeResults ; removeFile .
  ^ result
%

category: 'Quick Profiling'
classmethod: ProfMonitor
monitorBlock: aBlock intervalNs: nanosecondsPerSample

"Profile the execution of a block and return a formatted report of the results.
 The nanosecondsPerSample argument gives the CPU time interval
 between samples, and the results are reported down to methods that
 use 3% of the total time"

^ self monitorBlock: aBlock
       downTo: 0.03
       intervalNs: nanosecondsPerSample
       options: #()
%

category: 'Quick Profiling'
classmethod: ProfMonitor
monitorBlock: aBlock intervalNs: nanosecondsPerSample options: anArray
 "Profile the execution of a block and return a formatted report of the results.
  The report includes sampled items each of which is more than 3% of the total.
  The nanosecondsPerSample argument gives the CPU time interval between samples.
  anArray is an Array of Strings or Symbols containing at most one of
  #objFaults #pageFaults #edenUsage #gcTime #objCreation   and optionally
  #cpu or #real .
  For details see commnets in monitorBlock:downTo:intervalNs:options:."

^ self monitorBlock: aBlock
       downTo: 0.03
       intervalNs: nanosecondsPerSample
       options: anArray
%

category: 'Quick Profiling'
classmethod: ProfMonitor
monitorBlock: aBlock reports: reportsArray

"Profile the execution of a block and return a formatted report of
 the results. An interval of 1 millisecond is used, and the results
 are reported down to 3% of the number of hits per method.
 reportsArray can include any or all of
      #samples #stackSamples #senders #objCreation #tree #objCreationTree
  specifying which reports to include and the desired order.
  specifying an obj creation report enables object creation; specifying a tree
  report uses ProfMonitorTree."

^self monitorBlock: aBlock
       downTo: 0.03
       intervalNs: self defaultIntervalNs
       reports: reportsArray
%

category: 'Instance Creation'
classmethod: ProfMonitor
new

"Returns a new profiler with default initialization."

^ self basicNew initialize
%

category: 'Private'
classmethod: ProfMonitor
newProfileFileName

"Returns a String to be used as the name of a temporary file which will
 contain profiling data.  The file name will be gem<processId>_<randomInt>.pro,
 in the directory defined by the environment variable $GEMSTONE_CHILD_LOG,
 the current directory or /tmp if neither of the above can be created."

| result pidStr aFile env filename randInt |
pidStr := (System gemVersionAt: #processId ) printString.
filename := (String withAll: 'gem').
randInt := HostRandom new integerBetween:100000 and:999999 .
filename addAll: pidStr; add: $_ ; addAll: randInt asString; addAll: '.pro'.

env := (System gemEnvironmentVariable: 'GEMSTONE_CHILD_LOG').
env == nil
  ifTrue: [  result := String withAll: './'.]
  ifFalse: [ result := String withAll: env. result addAll: '/'].
result addAll: filename.

aFile := GsFile openWriteOnServer: result.
aFile ifNotNil:[
  aFile close .
  ^ result
  ].
result := (String withAll: '/tmp/').
result addAll: filename.
^ result
%

category: 'Instance Creation'
classmethod: ProfMonitor
newWithFile: fileName

"Creates a new profiler with the given output file name and default monitoring
 interval."

^self newWithFile: fileName intervalNs: self defaultIntervalNs
%

category: 'Instance Creation'
classmethod: ProfMonitor
newWithFile: fileName interval: millisecondsPerSample

"Creates a new profiler with the specified output file name and monitoring
 interval"

| inst |
(inst := self basicNew) initializeNoFile ;
   _createFile: fileName;
   interval: millisecondsPerSample .
^ inst
%

category: 'Instance Creation'
classmethod: ProfMonitor
newWithFile: fileName intervalNs: nanosecondsPerSample

"Creates a new profiler with the specified output file name and monitoring
 interval"

| inst |
(inst := self basicNew) initializeNoFile ;
   _createFile: fileName;
   intervalNs: nanosecondsPerSample .
^ inst
%

category: 'Profiling'
classmethod: ProfMonitor
profileOn

"Creates a default instance, starts it monitoring, and returns it.
 To turn off profiling, send the message profileOff to the instance."

| inst |

inst := self new .
inst startMonitoring.
^inst.
%

category: 'Profiling'
classmethod: ProfMonitor
runBlock: aBlock

"Profile the execution of a block and return an instance of the receiver.
 The default sample interval will result in about 25000 samples per
 second of CPU time.

 Use gatherResults followed by reporting methods to view results."

| inst |
inst := self basicNew initializeNoFile .
inst _createFile: self newProfileFileName;
             intervalNs: self defaultIntervalNs  .
inst runBlock: aBlock .
^ inst
%

category: 'Profiling'
classmethod: ProfMonitor
runBlock: aBlock intervalNs: nanosecondsPerSample

"Profile the execution of a block and return an instance of the receiver.
 The nanosecondsPerSample argument gives the CPU time interval between
 samples.

 Use gatherResults followed by reporting methods to view results."

| inst |
inst := self basicNew initializeNoFile .
inst _createFile: self newProfileFileName;  intervalNs: nanosecondsPerSample .
inst runBlock: aBlock .
^ inst
%

!		Instance methods for 'ProfMonitor'

category: 'Accessing'
method: ProfMonitor
endTime

	^endTime
%

category: 'Accessing'
method: ProfMonitor
fileName

"Returns the name of the active file."

file ifNil:[ ^ nil ].
^ file name
%

category: 'Private'
method: ProfMonitor
forChild: childEntry tallyParentMethod: aSender rcvrClass: rcvrClass in: tempDict
increment: anInteger

"Private."

| children parentEntry d childTallies cTally parentTallies |
(aSender class == GsNMethod) ifFalse:[
  "ignore methods that were garbage collected and reused."
  ^ nil
  ].

"Add parent to child"
(d := tempDict at: aSender otherwise: nil ) ifNil:[
	d := IdentityKeyValueDictionary new.
	tempDict at: aSender put: d ].

(parentEntry := d at: rcvrClass otherwise: nil) ifNil:[
  parentEntry := ProfMonitorEntry newForMethod: aSender
                    receiverClass: rcvrClass.
  parentEntry total: anInteger .
  d at: rcvrClass put: parentEntry
] ifNotNil:[
  parentEntry incrementTotal: anInteger .
].

childTallies := parentEntry childTallies.
cTally := childTallies at: childEntry otherwise: 0.
childTallies at: childEntry put: (cTally + 1).

childEntry parents add: parentEntry.

"Add child to parent"
(children := parentEntry children ) ifNil:[
  children := IdentitySet new .
  parentEntry children: children .
].
children add: childEntry.

parentTallies := childEntry parentTallies.
cTally := parentTallies at: parentEntry otherwise: 0.
parentTallies at: parentEntry put: (cTally + 1).

^parentEntry
%

category: 'Reporting'
method: ProfMonitor
gatherResults
"If the receiver's file of sampling data has not been read, read it into memory,
 analyze the samples and store the results of analysis in the
 results instance variable of the receiver.
 After gatherResults has run, this instances' sample file is no longer needed
 and can be deleted with  ProfMonitor>>removeFile .

 For 100000 samples, GEM_TEMPOBJ_CACHE_SIZE should
 be set to at least 300MB to avoid AlmostOutOfMemory errors ."

  | resultSet mthDict objDict rawArray j sysRepos rawArraySiz totalSamples elapsedTime
    statBlock tlyInfo fileData statStr |

  "Now process the statistical sample file."
  results ifNotNil:[ ^ self "sample file was already read" ].

  mthDict := IdentityKeyValueDictionary new .
  objDict := KeyValueDictionary new .
  fileData := self _readSampleFile .
  fileData ifNil:[ ^ 'No profiling data available' ].

  rawArray := fileData at: 1 .
  rawArraySiz := rawArray size .
  rawArraySiz == 0 ifTrue:[
    results := nil .
    ^ self .
  ].
  sysRepos := SystemRepository .
  j := 1 .
  tlyInfo := self _tallyInfo .
  statBlock := tlyInfo at: 2 .
  self dynamicInstVarAt:#tallyName put: (tlyInfo at: 1).

  [j < rawArraySiz ] whileTrue:[
    | sample recursionSet aMethod rcvrClass depth statsWord sTly |
    sample := rawArray at: j .
    sample == sysRepos
      ifFalse: [ Error signal: 'valid sample file: bad frame header' ]
      ifTrue:[   "sample header"
        j := j + 1 .
        (sample := rawArray at: j) _isSmallInteger
           ifTrue:[ depth := sample.  j := j + 1 ]
           ifFalse:[ Error signal:'invalid sample file: invalid depth' ].
        (sample := rawArray at: j) _isSmallInteger
           ifTrue:[ statsWord := sample. j := j + 1 ]
           ifFalse:[ Error signal:'invalid sample file: invalid statsWord'].
        sTly := statBlock ifNil:[ 1 ] ifNotNil:[ statBlock value: statsWord ]
      ].
    recursionSet := IdentitySet new.
    aMethod := rawArray at: j .
    aMethod == true ifTrue:[ "an object creation sample"
      | newObjClass aSender rcvr key d d2 anEntry child |
      newObjClass := rawArray at: j + 1 .
      j := j + 2.
      aSender := rawArray at: j.
      rcvr := rawArray at: j + 1.
      rcvr := Object. "suppress polymorphism reporting, TODO add enable/disable"
      key := (Array with: newObjClass with: aSender).
      (d := objDict at: key otherwise: nil) ifNil: [
        d := KeyValueDictionary new.
        objDict at: key put: d. ].
      (d2 := d at: aSender otherwise: nil) ifNil: [
        d2 := IdentityKeyValueDictionary new.
        d at: aSender put: d2 ].

      (anEntry := d2 at: rcvr otherwise: nil) ifNil: [
        anEntry := ProfMonitorEntry newForClass: newObjClass
                        method: aSender receiverClass: rcvr.
        d2 at: rcvr put: anEntry ].
       anEntry incrementTally: 1 .
      "Now scan through call stack"
      child := anEntry.
      recursionSet add: child.
      1 to: depth-1 do: [:m |
        child ifNotNil: [
          aSender := rawArray at: j + (m * 2).
          rcvr := rawArray at: j + (m * 2) + 1.
          aSender ifNotNil: [ rcvr ifNotNil:[
            rcvr := Object .  "supress polymorphism reporting,"
                              "TODO add enable/disable "
            child := self forChild: child
                          tallyParentMethod: aSender
                          rcvrClass: rcvr
                          in: d increment: 1 .
            (recursionSet includes: child) ifTrue: [
              child recursed: true].
            recursionSet add: child ]]]]
    ] ifFalse:[ "statistical method execution sample"
     sTly > 0 ifTrue: [
      rcvrClass := rawArray at: j + 1.
      ((aMethod class == GsNMethod or:[ aMethod == #GCI ])
         and:[ rcvrClass isBehavior]) ifTrue:[
        | d anEntry |
        "method still exists or is a reenter marker"
        (d := mthDict at: aMethod otherwise: nil) ifNil: [
          d := IdentityKeyValueDictionary new.
          mthDict at: aMethod put: d. ].
        rcvrClass := Object .  "supress polymorphism reporting,"
                               "TODO add enable/disable "
        (anEntry := d at: rcvrClass otherwise: nil) ifNil:[
          anEntry := ProfMonitorEntry newForMethod: aMethod
                        receiverClass: rcvrClass.
          d at: rcvrClass put: anEntry ].
        anEntry incrementTally: sTly  .
        depth > 1 ifTrue:[ | child rcvr |
          child := anEntry.
          recursionSet add: child.
          0 to: depth-2 do: [:m |
            child ifNotNil: [ | aSender |
              aSender := rawArray at: j + (m * 2) + 2.
              aSender ifNotNil: [
              rcvr := rawArray at: j + (m * 2) + 3.
              rcvr ifNotNil: [
                rcvr := Object .  "supress polymorphism reporting,"
                                  "TODO add enable/disable "
                child := self forChild: child
                              tallyParentMethod: aSender
                              rcvrClass: rcvr
                              in: mthDict increment: sTly  .
                (recursionSet includes: child) ifTrue: [
                  child recursed: true].
                recursionSet add: child. ]]]]]]]].
    j := j + (depth * 2).
  ].

  (endTime >= startTime) ifTrue: [
    elapsedTime := endTime - startTime.
  ] ifFalse: [
    elapsedTime := endTime + (16rffffffff - startTime).
  ].

  "Consolidate results"
  resultSet := IdentityBag new.
  totalSamples := 0.
  mthDict valuesDo: [:d |
    d valuesDo: [ :anEntry |
      resultSet add: anEntry .
      anEntry cmethod class == GsNMethod ifTrue:[
        totalSamples := totalSamples + anEntry tally ]]].

  (statStr := String new) add: (fileData at: 5) asString ; add:' pageFaults  ';
    add: ((fileData at: 3"reads") + (fileData at: 4"wrts")) asString; add: ' objFaults  ';
    add: (fileData at: 2) asString; add:' gcMs  ' ;
    add: (fileData at: 6) asString; add:' edenBytesUsed' .
  results := { resultSet . objDict . totalSamples . statStr } .
%

category: 'Private'
method: ProfMonitor
initialize

"Private."

self initializeNoFile .
self _createFile: self class newProfileFileName .
file close .
%

category: 'Private'
method: ProfMonitor
initializeNoFile

"Private."

interval := self class defaultIntervalNs .
sampleDepth := 1000.
traceObjCreation := 0 . "object creation trace disabled, cpu time sampling"
%

category: 'Accessing'
method: ProfMonitor
interval

	^interval
%

category: 'Updating'
method: ProfMonitor
interval: milliseconds

"Assign the sampling interval of the receiver."

| ns |
milliseconds _isSmallInteger ifFalse:[ ns _validateClass: SmallInteger ].
ns := milliseconds * 1000000 .
self intervalNs: ns .
%

category: 'Updating'
method: ProfMonitor
intervalNs: nanoseconds
  "Assign the sampling interval of the receiver.
   See also class method  computeInterval:  .
  "

nanoseconds _isSmallInteger ifFalse:[ nanoseconds _validateClass: SmallInteger ].
((nanoseconds < 1000) and: [nanoseconds ~~ 0]) ifTrue:[
  OutOfRange new name:'' min: 1000 actual: nanoseconds;
   details: 'invalid sampling interval(nanoseconds)'; signal.
].
interval := nanoseconds
%

category: 'Monitoring'
method: ProfMonitor
monitorBlock: aBlock

"This method starts profiling, executes the block, and terminates profiling,
 and reads the sample file into memory .
 Use reportDownTo: to generate results"

self runBlock: aBlock .
self gatherResults ; removeFile .
%

category: 'Sampling'
method: ProfMonitor
numberOfSamples
  "Returns a SmallInteger, the number of samples actually taken during
   the profiled execution.  The result is zero until stopMonitoring
   has been sent at least once."
  ^ numSamples ifNil:[ 0 ]
%

category: 'Private'
method: ProfMonitor
prepareForReportWithThreshold: thresholdArg
  "Reporting uses some dynamic instance variables for the thresholds, time, and totals"

  | total  |
  results ifNil:[ self gatherResults; removeFile  ].
  results ifNil:[ ^self].

  total := 0.
  (results at: 1) do: [:each |
    each cmethod class == GsNMethod ifTrue:[
      total := total + each tally ]].
  self dynamicInstVarAt: #totalTallies put: total.
  self dynamicInstVarAt: #reportThreshold put: (thresholdArg < 1.0
	ifTrue:[ (thresholdArg * total) asInteger ]
	ifFalse:[ thresholdArg asInteger ]).

  self dynamicInstVarAt: #elapsedTime put: ((endTime >= startTime)
	ifTrue: [endTime - startTime]
	ifFalse: [endTime + (16rffffffff - startTime)]).
%

category: 'Monitoring'
method: ProfMonitor
profileOff
 |rpt |
"Stop the given monitor and report."

self stopMonitoring; gatherResults; removeFile.
rpt := self reportDownTo: 0.03 .
^ rpt
%

category: 'Updating'
method: ProfMonitor
removeFile

"Removes the file generated by profiling operations in this profile monitor,
 if the file still exists."

| f fileName |
(f := file) ifNotNil:[
  fileName := file pathName .
  f close .
  GsFile removeServerFile: fileName .
  file := nil .
].
%

category: 'Updating'
method: ProfMonitor
removeResults

"Releases results to aid garbage collection."

results ifNotNil:[
  results := nil .
  ].
%

category: 'Reporting'
method: ProfMonitor
report

"Formats and returns a string holding a report of the receiver's most
 recent profile run."

 ^ self reportDownTo: 0.03.
%

category: 'Reporting'
method: ProfMonitor
reportAfterRun

"Formats and returns a string holding a report of the receiver's most
 recent profile run."
 | res |
 self gatherResults ; removeFile .
 res := self reportDownTo: 0.03.
 self removeResults .
 ^ res
%

category: 'Reporting'
method: ProfMonitor
reportAfterRunDownTo: tallyThreshold

"Formats and returns a string holding a report of the receiver's most
 recent profile run."
 | res |
 self gatherResults ; removeFile .
 res := self reportDownTo: tallyThreshold.
 self removeResults .
 ^ res
%

category: 'Reporting'
method: ProfMonitor
reportDownTo: thresholdArg

"Formats and returns a string holding a report of the receiver's most recent
 profile run.  Stops reporting when a tally smaller than tally is
 encountered. "

 ^self reportDownTo: thresholdArg reports: self class defaultReports
%

category: 'Reporting'
method: ProfMonitor
reportDownTo: thresholdArg reports: arrayOfReports

"Formats and returns a string holding a report of the receiver's most recent
 profile run.  Stops reporting when a tally smaller than tally is encountered.

 thresholdArg should be a SmallInteger or a Float > 0 .
 A thresholdArg < 1.0 is interpreted as a percentage of the total
 samples, otherwise thresholdArg is intepreted as an absolute value.
 Report elements whose sample count is less than the threshold are
 omitted from the report."

  | saveFpe |
  results ifNil:[ self gatherResults ; removeFile ].
  results ifNil:[ ^'No profiling data available.'].
  ^ [ |rpt|
      saveFpe := FloatingPointError enabledExceptions .
      FloatingPointError enableExceptions: nil .
      self prepareForReportWithThreshold: thresholdArg.
      rpt := String new .
      (self dynamicInstVarAt: #overrunStr) ifNotNil:[:str | rpt add: str ; lf].

      arrayOfReports do: [:sym |
        sym == #samples ifTrue: [
	   rpt addAll: (self _samplingReport); lf; lf ].
        sym == #stackSamples ifTrue: [
	   rpt addAll: (self _stackReport); lf; lf ].
        (sym == #senders and: [(self dynamicInstVarAt: #totalTallies) > 0])  ifTrue: [
	   rpt addAll: (self _sendersReport); lf; lf ].
        (sym == #objCreation and: [ (traceObjCreation bitAnd: 1) ~~ 0 and:
	  [(self dynamicInstVarAt: #totalTallies) > 0]]) ifTrue: [
	   rpt addAll: (self _objCreationReport); lf; lf.].
      ].
      rpt
    ] ensure:[
      saveFpe size > 0 ifTrue:[ FloatingPointError enableExceptions: saveFpe].
    ]
%

category: 'Accessing'
method: ProfMonitor
results

"Returns the value of the instance variable results."

^results
%

category: 'Updating'
method: ProfMonitor
results: newValue

 "Modify the value of the instance variable results."

results:= newValue
%

category: 'Monitoring'
method: ProfMonitor
resumeSampling
  "if high resolution sampling in use, resumes sampling."
interval >= 10000000 ifTrue:[
  Error signal:'resume only supported with high resolution sampling'
].
self _zeroArgPrim: 5
%

category: 'Monitoring'
method: ProfMonitor
runBlock: aBlock

"Starts profiling, executes the block, and terminates profiling.
 Does not read the sample file.
 Use gatherResults followed by reporting methods to view results."

[ self startMonitoring.
  aBlock value.
] ensure:[
  self stopMonitoring .
].
%

category: 'Accessing'
method: ProfMonitor
sampleDepth

        ^sampleDepth
%

category: 'Updating'
method: ProfMonitor
sampleDepth: newValue

"Modify the value of the instance variable sampleDepth. Should be
 at least 20; small values will prune method call stacks and object
 creation stacks."

sampleDepth := newValue
%

category: 'Accessing'
method: ProfMonitor
sampling
  "Returns the type of sampling in use,  #real or #cpu ."

  ^ (traceObjCreation bitAnd: 2) == 0 ifTrue:[ #cpu ] ifFalse:[ #real ]
%

category: 'Updating'
method: ProfMonitor
setOptions: anArray
 "By default ProfMonitor analyzes execution time using cpu time .
  Alternatively, one of the following kinds of profiling can be selected.
      #objFaults #pageFaults #edenUsage #gcTime #objCreation .

  anArray is an Array of Strings or Symbols containing
    at most one of #objFaults #pageFaults #edenUsage #gcTime #objCreation .
  and optionally  #cpu or #real .

  The last #cpu or #real if any specifies real or cpu time sampling.
  #gcTime implies default #cpu  and is in units of milliseconds  .
  #objFaults and #pageFaults are in units of faults and imply default #real .
  #edenUsage  is in units of bytes and implies default #real .
  #objCreation implies default #cpu .
  "
  | sKind cnt mask defKind |
  cnt := 0 .
  mask := 0 .
  anArray do:[:x | | sym |
    sym := Symbol _existingWithAll: x .
    sym == #real ifTrue:[ sKind := #real ] ifFalse:[
    sym == #cpu ifTrue:[ sKind := #cpu ] ifFalse:[
    sym == #objFaults ifTrue:[ defKind := #real . mask := 16r4 . cnt := cnt + 1 ] ifFalse:[
    sym == #pageFaults ifTrue:[ defKind := #real . mask := 16r8 . cnt := cnt + 1 ] ifFalse:[
    sym == #edenUsage ifTrue:[ defKind := #real . mask := 16r10 . cnt := cnt + 1 ] ifFalse:[
    sym == #gcTime ifTrue:[ defKind := #cpu . mask := 16r20 . cnt := cnt + 1 ] ifFalse:[
    sym == #objCreation ifTrue:[ defKind := #cpu . mask := 16r1 . cnt := cnt + 1 ] ifFalse:[
      Error signal: 'unrecognized option ', x asString
    ]]]]]]].
  ].
  cnt > 1 ifTrue:[ Error signal:'too many options given' ].
  sKind ifNil:[ sKind := defKind ifNil:[ #cpu ]].
  sKind == #real ifTrue:[
    (System gemVersionAt: #osName) = 'Darwin' ifTrue:[ "clock_gettime not avail"
      Error signal:'Only #cpu profiling is supported on Darwin OS'.
    ].
    mask := mask bitOr: 16r2
  ].
  traceObjCreation := mask .
%

category: 'Monitoring'
method: ProfMonitor
startMonitoring

"Starts monitoring."
results ifNotNil:[ results := nil "force re-read of sample file"].
self _openFileAppend .
self _zeroArgPrim: 1 .  "enable and start monitoring in the virtual machine"
%

category: 'Accessing'
method: ProfMonitor
startTime

	^startTime
%

category: 'Monitoring'
method: ProfMonitor
stopMonitoring

"Stops monitoring. stores total number of samples written to file
  in the numSamples instVar."
| cnt delta |
cnt := self _zeroArgPrim: 2  . "stop monitoring in the virtual machine"
(delta := endTime - startTime) <= 1 ifTrue:[  "fix 41260"
  (OutOfRange new )
     name: 'CPU time used' min: 1 actual: delta ;
     details: 'code to be profiled must use at least 1ms of CPU or real time' ;
	 signal
].
numSamples ifNil:[ numSamples := 0 ].
numSamples := numSamples + cnt  .
self dynamicInstVarAt: #overrunStr put: (self _zeroArgPrim: 6).
file close .
%

category: 'Monitoring'
method: ProfMonitor
suspendSampling
  "if high resolution sampling in use, suspends sampling."
interval >= 10000000 ifTrue:[
  Error signal:'suspend only supported with high resolution sampling'
].
self _zeroArgPrim: 4
%

category: 'Updating'
method: ProfMonitor
traceObjectCreation: aBoolean

"Enable (aBoolean == true) or disable profiling of object creation.  The state
 change will take effect on the next invocation of ProfMonitor>>startMonitoring
 for the receiver."

aBoolean _validateClass: Boolean .
aBoolean ifTrue:[ traceObjCreation := traceObjCreation bitOr: 1 ]
         ifFalse:[ traceObjCreation := traceObjCreation bitAnd: 1 bitInvert ].
sampleDepth < 2 ifTrue:[ sampleDepth := 2 ].
%

category: 'Private'
method: ProfMonitor
_createFile: fileName

"Creates the sampling file for writing with the specified file name."
| f |
(f := file) ifNotNil:[
  f isOpen ifTrue:[ f close ].
  file := nil .
].
f := GsFile open: fileName mode: 'wb+' onClient: false .
f ifNil:[
  fileName _error: #bkupErrOpenFailed
              args:{ 'create' . GsFile serverErrorString }
].
file := f
%

category: 'Private'
method: ProfMonitor
_intervalHeaderString

| res divisor units tmp |
res := 'monitoring interval:  ' copy.
interval < 1000 ifTrue:[ "currently illegal argument"
  res addAll: interval asString ; addAll: ' ns'.  ^ res  ].

interval >= 1000000
  ifTrue: [divisor := 1000000 . units := ' ms']
  ifFalse: [divisor := 1000 . units := ' us' ].

res addAll: (interval // divisor ) asString.
tmp := (interval \\ divisor ).
tmp > 0 ifTrue:
   [res add: $. ; addAll: (interval \\ divisor ) asString].
res addAll: units .
res add: ' ,  ' ; add: self numberOfSamples asString ; add: ' samples' .
^ res
%

category: 'Private'
method: ProfMonitor
_objCreationReport

  | classes minTally tallySet rpt nonrep nonreptallies meths counts |

  minTally := self dynamicInstVarAt: #reportThreshold.
  rpt := String new .
  rpt add: (self _reportHeader: 'OBJECT CREATION REPORT'); lf;
	addAll: ' tally  class of created object'; lf.
  (sampleDepth > 1)
    ifTrue: [ rpt addAll: '           call stack'; lf ]
    ifFalse: [ rpt addAll: '           callers'; lf ].

  nonrep := 0.  "non reported classes (below threshold)"
  nonreptallies := 0.

  counts := IdentityKeyValueDictionary new.
  (results at: 2) keysAndValuesDo: [:k :d | | cls tally |
    cls := k at: 1.
    tally := (counts at: cls ifAbsent: [ counts at: cls put: 0 ]).
    d valuesDo: [:d2 |
      d2 valuesDo: [:e |
        e cclass == nil  ifFalse: [ tally := tally + (e tally) ]]].
    counts at: cls put: tally ].
  classes := Array new.
  counts keysAndValuesDo: [:k :v | classes add: (Array with: k with: v)].
  classes := classes asSortedCollection: [:x :y | (x at: 2) > (y at: 2)].
  classes := classes collect: [:x | x at: 1].

  classes do: [:class |

    (counts at: class) < minTally ifTrue: [
      nonrep := nonrep + 1.
      nonreptallies := nonreptallies + (counts at: class).
      ]
    ifFalse:[
      rpt
        addAll: '------  -----------------------------------------'; lf.
	  rpt lf ;
	    addAll: ((counts at: class) asString width: -6); addAll: '  ' ;
	    addAll: (class name asString width: 12) ; lf.

    tallySet := IdentitySet new.
    (results at: 2) keysAndValuesDo: [:k :d |
      ((k at: 1) = class) ifTrue: [ | sender |
        sender := (k at: 2).
        d valuesDo: [:d2 |
          d2 valuesDo: [:e |
               e cclass == nil  ifFalse: [
                 tallySet add: e]]]]].

    meths := tallySet sortDescending: 'tally'.
    meths do: [:each | | aMeth |
      aMeth := each cmethod .
      (aMeth _class == GsNMethod _or:[ aMeth == #GCI ]) ifTrue:[

        | aClass |
        aClass := aMeth .
        (sampleDepth > 1) ifTrue: [
          rpt addAll: ' - - -  - - - - - - - - - - - - - - - - - - - - -'; lf ].
        rpt add: '         ';
            add: (each tally asString width: -6);
            add: '  ';
            add: (each asStringWidth: 12) ; lf.
        self _objCreationReportScanParents: each level: 0
             to: rpt seen: Set new ]]]].

  nonrep > 0 ifTrue: [
    rpt lf; lf;
        addAll: '------  -----------------------------------------'; lf;
        addAll: (nonreptallies asString width: -6); addAll: '  ' ;
        addAll: 'Instances of ' ;
        addAll: nonrep asString ;
        addAll: ' other classes'; lf
  ].

  ^rpt
%

category: 'Private'
method: ProfMonitor
_objCreationReportScanParents: entry level: level to: rpt seen: visited

  "Scan the parents of a given entry, printing them out indented
   according to how deep in the scan we are.  Stop when we hit an
   entry we've already visited. "

  | parents tallies lf |

  lf := Character lf.
  (parents := entry parents) ifNotNil: [
    tallies := entry parentTallies.
    parents := (parents sortDescending: 'tally') asArray.
    parents do: [:parent | |  visit |
      visit := Array with: parent with: entry.
      (visited includes: visit)
      ifFalse: [
        rpt add: '             '.
        level timesRepeat: [ rpt add: '  ' ].
        rpt
          add: ((parent childTallies at: entry otherwise: -1)
               asString width: -4);
          add: '  ';
          add: (parent asStringWidth: 12) ; lf.
          visited add: visit.
               self _objCreationReportScanParents: parent
                   level: (level + 1) to: rpt seen: visited ]]].
%

category: 'Private'
method: ProfMonitor
_openFileAppend

"Reopens the sampling file for writing."

| f |
(f := file ) ifNil:[ Error signal: 'cannot append to nil file'].
f isOpen ifFalse:[ | fileName |
  fileName := f pathName .
  f := GsFile open: fileName mode: 'ab+' onClient: false .
  f ifNil:[
    fileName _error: #bkupErrOpenFailed
              args:{ 'append' . GsFile serverErrorString }
  ].
  file := f
].
%

category: 'Private'
method: ProfMonitor
_openFileRead

"Reopens the sampling file for reading."

| f fileName |
(f := file ) ifNil:[ Error signal: 'cannot reopen nil file'].
"ignore any lost transient state on the file."
([ f isOpen ] on: Error do:[:ex | ex return: false]) ifTrue:[
  f seekFromBeginning: 0 .
] ifFalse:[
  fileName := f pathName .
  f := GsFile open: fileName mode: 'rb' onClient: false .
  f ifNil:[
    fileName _error: #bkupErrOpenFailed
                args:{ 'read' . GsFile serverErrorString }
  ].
  file := f
].
%

category: 'Private'
method: ProfMonitor
_readSampleFile

"Returns the raw sample data generated by the monitoring code, for use
 by the output routines.

 result is an Array of the form
    { sampleArray . gcTime . objReads . objWrites . pageFaults . edenBytesUsed }

 sampleArray has the following format:
           aSmallInteger - depth of sampling for next section of Array,
           aSmallInteger - stats sample word
 optional: nil
 optional: aClass
           aGsNMethod 1
           aClass     1
           aGsNMethod 2
           aClass     2
           ...
           aGsNMethod N
           aClass     N

 where N = depth as specified by the initial aSmallInteger.

 The (aGsNMethod, aClass) pairs represent stack frames.
 The optional (nil, aClass) pair at the beginning indicate the sample
 was taken during the creation of an instance of the designated class.
"

| arr |
self _openFileRead.
arr := self _zeroArgPrim: 3.
file close .
(arr at: 1) ifNil:[ ^ nil ].
^ arr
%

category: 'Private'
method: ProfMonitor
_reportHeader: nameStr

  | rpt |
  rpt := String new.
  rpt add:'================'; lf ; add: nameStr; lf ;
       add: self _timeHeaderString; lf;
	 add: self _intervalHeaderString; lf;
	 add: self _reportThresholdHeaderString; lf.
  ^rpt
%

category: 'Private'
method: ProfMonitor
_reportThresholdHeaderString

  | pct rpt |
  rpt := String new.
  rpt add: 'report limit threshold: '.
  ((self dynamicInstVarAt: #reportThreshold) = 0 or: [(self dynamicInstVarAt: #totalTallies) = 0])
	ifTrue: [rpt add: ' 0 hits'.  ^rpt].
  pct := (((self dynamicInstVarAt: #reportThreshold) / (self dynamicInstVarAt: #totalTallies)) * 100.0) asStringUsingFormat: #(1 1 false).
  rpt
      add: (self dynamicInstVarAt: #reportThreshold) asString;
	add: ' hits / ';
	add: pct;
	add: '%'.
  ^rpt
%

category: 'Private'
method: ProfMonitor
_samplingReport

  | rpt lf nonrep nonrepTallies total ave pct meths tallySet nameStr
    thresh tlyName |

  thresh := self dynamicInstVarAt: #reportThreshold.
  total := self dynamicInstVarAt: #totalTallies.

  tallySet := results at: 1 .
  rpt := String new .
  nameStr := 'STATISTICAL SAMPLING RESULTS' .
  lf := Character lf.
  meths := tallySet sortDescending: 'tally'.

  rpt add: (self _reportHeader: nameStr).
  rpt add: (results at: 4"statsSummary"); lf .

  rpt lf;
    add:   (tlyName := self dynamicInstVarAt:#tallyName) ;
    addAll:          '    %   class and method name'; lf;

    addAll: '------   -----   --------------------------------------'; lf.

  total = 0 ifTrue:[
    rpt add: 'total '; add: tlyName; add:' is zero '; lf.
    ^ rpt
  ].

  nonrep := 0.  "non reported methods (below tally threshold.)"
  nonrepTallies := 0.
  meths do: [:each |
    each cmethod class == GsNMethod ifTrue:[ | tly |
      (tly := each tally) < thresh ifTrue: [
	nonrep := nonrep + 1.
	nonrepTallies := nonrepTallies + tly ]
      ifFalse: [
	pct := tly asFloat * 100.0 / total.
	rpt add: (tly  asString width: -6); addAll: '  ' ;
	    add: (pct asStringUsingFormat: #(-6 2 false)); addAll: '   ';
	    add: (each asStringWidth: 25) ; lf ]]].

  nonrep > 0 ifTrue: [
    pct := nonrepTallies asFloat * 100.0 / total.
    rpt addAll: (nonrepTallies asString width: -6); addAll: '  ' ;
        addAll: (pct asStringUsingFormat: #(-6 2 false)); addAll: '   ';
        addAll: nonrep asString ; addAll: ' other methods'; lf ].

  ave := total // (meths size max: 1).
  rpt addAll: (total asString width: -6); addAll: '  100.00   ';
    addAll: 'Total'; lf.
  ^rpt
%

category: 'Private'
method: ProfMonitor
_sendersReport
"Report formatting is:

  %     %                       Parent
 self total   total local  Method
 Time  Time    secs   %         Child

"

  | tallyThreshold tallySet nameStr rpt meths elapsedTime totalSamples methodMs pMap cMap |

  elapsedTime := self dynamicInstVarAt: #elapsedTime.
  tallyThreshold := self dynamicInstVarAt: #reportThreshold.
  tallySet := results at: 1 .
  nameStr := 'STATISTICAL METHOD SENDERS RESULTS' .
  rpt := String new .
  meths := tallySet sortDescending: 'total'.
  rpt add: (self _reportHeader: nameStr).

  totalSamples := results at: 3 .

  rpt lf;
    addAll: '     %       %                     Parent'; lf;
    addAll: '  self  total   total  local  Method'; lf;
    addAll: '  Time   Time      ms    %         Child'; lf;
    addAll: '------ ------  ------  -----  -----------'; lf.
  meths do: [:each | | aMeth |
    aMeth := each cmethod .
    (aMeth class == GsNMethod or:[ aMeth == #GCI ]) ifTrue:[
      each total < tallyThreshold ifFalse:[ | parents children |
        rpt lf .
        methodMs := each total * elapsedTime asFloat / totalSamples.
        pMap := each parentTallies.
        cMap := each childTallies.
        "PARENTS"
        (parents := each parents) ifNotNil: [
          parents do: [:parent | | pt |
            pt := pMap at: parent otherwise: 0.
            rpt
              add: '                 ';
              add: ((pt * elapsedTime asFloat / totalSamples)
                   asStringUsingFormat: #(-6 1 false)); space;
              add: ((pt * elapsedTime *100.0 / totalSamples / methodMs)
                   asStringUsingFormat: #(-6 1 false)); space; space;
              add: '     ';
              add: (parent asStringWidth: 12) ; lf ]].
        "SELF"
        rpt add:'= ' ;
          add: ((each tally * 100.0 / totalSamples)
               asStringUsingFormat: #(-6 1 false)); space;
          add: ((each total * 100.0  / totalSamples)
               asStringUsingFormat: #(-6 1 false)); space; space;
          add: (methodMs asStringUsingFormat: #(-6 1 false)); space;
          add: ((each tally * elapsedTime *100.0 / totalSamples / methodMs)
               asStringUsingFormat: #(-6 1 false)); space; space;
          add: (each asStringWidth: 12 );
          add: '   [oop ' , aMeth asOop asString ; add: $] ; lf .
        "CHILDREN"
        (children := each children) ~~ nil  ifTrue: [
          children do: [:child | | ct |
            ct := cMap at: child otherwise: 0.
            rpt
              add: '                 ';
              add: ((ct * elapsedTime asFloat / totalSamples)
                   asStringUsingFormat: #(-6 1 false)); space;
              add: ((ct * elapsedTime * 100.0 / totalSamples / methodMs)
                   asStringUsingFormat: #(-6 1 false)); space; space;
              add: '     ';
              add: (child asStringWidth: 12) ; lf ]].
        rpt addAll: '-----------------------------------------------------';
            lf ]]].
  ^rpt
%

category: 'Private'
method: ProfMonitor
_stackReport

  | rpt nonrep nonreptallies ave pct meths tallySet nameStr
    tlyName tallyThreshold total |

  tallyThreshold := self dynamicInstVarAt: #reportThreshold.
  total := self dynamicInstVarAt: #totalTallies.

  tallySet := results at: 1 .
  nameStr := 'STATISTICAL STACK SAMPLING RESULTS' .
  rpt := String new .

  meths := tallySet sortDescending: 'total'.

  rpt add: (self _reportHeader: nameStr).
  rpt add: (results at: 4"statsSummary"); lf .
  ((tlyName := self dynamicInstVarAt:#tallyName ) at: 1 equals:'tally') ifFalse:[
     rpt add: 'tallying:  ' ; add: tlyName ; lf .
  ].
  rpt lf;
    addAll: ' total       %   class and method name'; lf;
    addAll: '------   -----   --------------------------------------'; lf.
  total = 0 ifTrue:[
    rpt add: 'total '; add: tlyName; add:' is zero '; lf.
    ^ rpt
  ].
  nonrep := 0.  "non reported methods (below tally threshold."
  nonreptallies := 0.
  meths do: [:each | | aTotal |
    each cmethod class == GsNMethod ifTrue:[
      (aTotal := each total) < tallyThreshold ifTrue: [
	      nonrep := nonrep + 1.
	      nonreptallies := nonreptallies + each tally.
      ] ifFalse: [
	      pct := aTotal asFloat * 100.0 / total.
	      rpt add: (aTotal asString width: -6); addAll: '  ' ;
				add: (pct asStringUsingFormat: #(-6 2 false)); addAll: '   ';
			  add: (each asStringWidth: 25);  lf .
      ].
    ].
  ].

  nonrep > 0 ifTrue: [
    pct := nonreptallies asFloat * 100.0 / total.
    rpt addAll: (nonreptallies asString width: -6); addAll: '  ' ;
        addAll: (pct asStringUsingFormat: #(-6 2 false)); addAll: '   ';
        addAll: nonrep asString ; addAll: ' other methods'; lf
  ].

  ave := total // (meths size max: 1).
  rpt addAll: (total asString width: -6); addAll: '  100.00   ';
    addAll: 'Total'; lf.
  ^rpt
%

category: 'Private'
method: ProfMonitor
_tallyInfo
 | iv |
 "Returns an Array of the form { tallyNameString . statsWordExtractionBlock }."
 iv := traceObjCreation.
 "following must agree with VM C code in profileStatsWord() and code in setOptions:
    16r4  for elapsed time sampling, tally object faults
    16r8  for elapsed time sampling, tally page faults
    16r10  for elapsed time sampling, tally eden bytes used
    16r20  for elapsed time sampling, tally temp obj memory gc time
 "
 (iv bitAnd: 16r4) ~~ 0 ifTrue:[
       "10 bits of objWrites and 13 bits of objReads"
   ^ { ' objFaults' .
     [:w | ((w bitShift: -20) bitAnd: 16r3FF) + ((w bitShift: -30) bitAnd: 16r1FFF)]} ].

 (iv bitAnd: 16r8) ~~ 0 ifTrue:[
   ^ { 'pageFaults' . [:w | w bitAnd: 16r3FF ] "10 bits of page faults"}].

 (iv bitAnd: 16r10) ~~ 0 ifTrue:[  "17 bits of eden bytes used"
   ^ { 'edenBytes' . [:w | (w bitShift: -43) bitAnd: 16r1FFFF ] } ].

 (iv bitAnd: 16r20) ~~ 0 ifTrue:[  "10 bits of gc time"
   ^ { 'gcTimeMs ' . [:w | (w bitShift: -10) bitAnd: 16r3FF ]} ].

 ^   { 'tally    ' . nil } "assume just time sampling"
%

category: 'Private'
method: ProfMonitor
_timeHeaderString

  | rpt |
  rpt := String new.
  rpt
	add: 'elapsed ';
      add: (self sampling == #cpu ifTrue:['CPU'] ifFalse:['REAL']) ;
      add: ' time:    ';
      add: (self dynamicInstVarAt: #elapsedTime) asString; add: ' ms' .
  ^rpt
%

category: 'Private'
method: ProfMonitor
_zeroArgPrim: opcode

"opcode      function
   1		start profiling - returns receiver
   2		stop profiling - returns number of samples written to sample file
   3    read sample file - returns contents of file in an Array
   4    suspend high res sampling
   5    resume  high res sampling
   6    get and clear overrun info, result is a String or nil
   7    read clock
"
<primitive: 191>
self _primitiveFailed: #_zeroArgPrim: args: { opcode }
%

! Class implementation for 'ProfMonitorTree'

!		Class methods for 'ProfMonitorTree'

category: 'Reporting'
classmethod: ProfMonitorTree
defaultReports
  ^super defaultReports, {#tree . #objCreationTree}
%

!		Instance methods for 'ProfMonitorTree'

category: 'Private'
method: ProfMonitorTree
gatherPMEsForTree

  | res rawArraySiz rawArrayPointer sampleStart sampleEnd reposCls fileData |

  res := OrderedCollection new.
  fileData := self _readSampleFile .
  rawArray := fileData at: 1 .
  (rawArraySiz := rawArray size) < 1 ifTrue:[ ^ self ].
  rawArrayPointer := 1 .
  rootPME := self readFirstPME.
  objRootPMEDict := IdentityKeyValueDictionary new.
  reposCls := SystemRepository.
  [ rawArrayPointer < rawArraySiz ] whileTrue:[
      (rawArray at: rawArrayPointer) == reposCls ifFalse:[
         Error signal: 'data order problem'
      ].
      sampleStart := rawArrayPointer + 3.   "skip count and statsWord"
      sampleEnd := sampleStart + ((rawArray at: rawArrayPointer + 1) * 2) - 1.
      ((rawArray at: sampleStart) == true)
      ifTrue: [
        "handle object trace report"
        sampleEnd := sampleEnd + 2.
        self tallyObjPME: (rawArray at: sampleStart + 1)
          position: sampleEnd
          startIndex: sampleStart + 2
          endIndex: sampleEnd ]
      ifFalse: [
        "handle method trace report"
        self tallyPME: rootPME
          position: sampleEnd
          startIndex: sampleStart
          endIndex: sampleEnd
         ].
      rawArrayPointer := sampleEnd + 1.
  ].
%

category: 'Reporting'
method: ProfMonitorTree
gatherResults
  "See superclass comment"
  super gatherResults.
  self gatherPMEsForTree.
%

category: 'Private'
method: ProfMonitorTree
printablePercentFor: aFractionOrOtherNumber

  ^((aFractionOrOtherNumber asFloat * 100)
    asStringUsingFormat: #(-6 1 false)) , '%'
%

category: 'Private'
method: ProfMonitorTree
printPME: aPME on: str total: theTotal

  str add: (self printablePercentFor: (aPME tally / theTotal)); space.
  str add: '('; add: aPME tally asString; add: ')'; space.

  str add: (aPME asStringWidth:20) ; lf
%

category: 'Private'
method: ProfMonitorTree
readFirstPME
  "trace consistes of SystemRepository, count, a stats word, and (count*2) slots with method and class.
  The highest point in context is at end, create a PME based on that."

| index count |
index := 1.
(rawArray at: index) == SystemRepository
  ifFalse:[ Error signal: 'Cannot read first PME'].
count := (rawArray at: index + 1).
count _isSmallInteger ifFalse:[ Error signal: 'corrupt prof monitor file'].

index := index + 1. "Allow for statsword"

^ ProfMonitorEntry newForMethod: (rawArray at: (index + (count*2)))
    receiverClass: (rawArray at: (index + (count*2) + 1)).
%

category: 'Reporting'
method: ProfMonitorTree
reportDownTo: thresholdArg reports: arrayOfReports

"Formats and returns a string holding a report of the receiver's most recent
 profile run.  Stops reporting when a tally smaller than tally is encountered.

 thresholdArg should be a SmallInteger or a Float > 0 .
 A thresholdArg < 1.0 is interpreted as a percentage of the total
 samples, otherwise thresholdArg is intepreted as an absolute value.
 Report elements whose sample count is less than the threshold are
 omitted from the report."

  | saveFpe |
  results ifNil:[ ^'No profiling data are available.'].
  ^ [ | rpt |
    saveFpe := FloatingPointError enabledExceptions .
    FloatingPointError enableExceptions: nil .

    self prepareForReportWithThreshold: thresholdArg.

    rpt := String new .
    (self dynamicInstVarAt: #overrunStr) ifNotNil:[:str | rpt add: str ; lf].

    arrayOfReports do: [:sym |
      sym == #samples ifTrue: [
	 rpt addAll: (self _samplingReport); lf; lf ].
      sym == #stackSamples ifTrue: [
	 rpt addAll: (self _stackReport); lf; lf ].
      (sym == #senders and: [(self dynamicInstVarAt: #totalTallies) > 0])  ifTrue: [
	 rpt addAll: (self _sendersReport); lf; lf ].
      (sym == #objCreation and: [ (traceObjCreation bitAnd: 1) ~~ 0 and:
	[(self dynamicInstVarAt: #totalTallies) > 0]]) ifTrue: [
	  rpt addAll: (self _objCreationReport); lf; lf.].
      sym == #tree ifTrue: [
	 rpt addAll: (self _methodTreeReport); lf; lf ].
      (sym == #objCreationTree and: [ (traceObjCreation bitAnd: 1) ~~ 0 and:
	[(self dynamicInstVarAt: #totalTallies) > 0]]) ifTrue: [
	 rpt addAll: (self _objectCreationTreeReport); lf; lf ].
     ].
     rpt
   ] ensure:[
     saveFpe size > 0 ifTrue:[ FloatingPointError enableExceptions: saveFpe].
   ]
%

category: 'Private'
method: ProfMonitorTree
tallyObjPME: aClass position: index startIndex: startIndex endIndex: endIndex

  | aPME |
  (aPME := objRootPMEDict at: aClass otherwise: nil) ifNil: [
    aPME := self readFirstPME.
    objRootPMEDict at: aClass put: aPME ].
  ^ self tallyPME: aPME position: index startIndex: startIndex endIndex: endIndex
%

category: 'Private'
method: ProfMonitorTree
tallyPathPME: aPME position: index startIndex: startIndex endIndex: endIndex

  "Add a tally point for the PME's child, the one that matches the stack at
  the given index.  Create child if does not exist. "

  | aMethod aClass matchingPME |
  aMethod := rawArray at: index - 1.
  aMethod class == GsNMethod ifFalse:[ aMethod := nil ].
  aClass := rawArray at: index .
  aPME ifNotNil:[
    aPME children do: [:aChildPME |
      aChildPME cmethod == aMethod ifTrue:[ matchingPME := aChildPME ].
    ].
    aMethod ifNotNil:[ aClass ifNotNil:[
      matchingPME ifNil:[
        matchingPME := ProfMonitorEntry newForMethod: aMethod receiverClass: aClass.
        aPME children add: matchingPME.
      ].
    ]].
  ].
  ^ matchingPME
%

category: 'Private'
method: ProfMonitorTree
tallyPME: aPME position: index startIndex: startIndex endIndex: endIndex
  " go backwards, top of stack is at end"

  | childPME idxMinus1 idxMinus2 mth |

  idxMinus1 := index - 1 .
  mth := rawArray at: idxMinus1 .
  mth ifNotNil:[ mth class == GsNMethod ifTrue:[ aPME ifNotNil:[
    mth == aPME cmethod ifTrue: [aPME tally: aPME tally + 1]
  ]]].

  idxMinus1 == startIndex ifTrue: [^self "end of path" ] .

  idxMinus2 := index - 2 .
  childPME := self tallyPathPME: aPME position: idxMinus2
            startIndex: startIndex endIndex: endIndex.

  self tallyPME: childPME
      position: idxMinus2
      startIndex: startIndex endIndex: endIndex.
%

category: 'Private'
method: ProfMonitorTree
treePrintPME: aPME on: str tabs: tabs thisTab: myTab total: theTotal downTo: limit
  | children childrenTab |

  tabs do: [:tab | str add: tab].
  self printPME: aPME on: str total: theTotal.
  children := aPME children.
  children isEmpty ifFalse: [
      tabs addLast: myTab.
      children := children asSortedCollection: [:a :b | a tally > b tally].
      1 to: children size do: [:i | | child |
          child := children at: i.
          (child tally >= limit) ifTrue: [
            childrenTab := i < children size ifTrue: ['   |'] ifFalse: ['   '].
            self
              treePrintPME: child
              on: str
              tabs: tabs
              thisTab: childrenTab
              total: theTotal
              downTo: limit
          ].
      ].
      tabs removeLast
    ]
%

category: 'Private'
method: ProfMonitorTree
_methodTreeReport
  "Return a report of the method call stack in tree form"

  | rpt thresholdArg |

  rpt := String new.
 " If there's no samples, bail"
  rootPME == nil  ifTrue: [ ^rpt ].

  thresholdArg := self dynamicInstVarAt: #reportThreshold.

  rpt add: (self _reportHeader: 'STACK SAMPLING TREE RESULTS'); lf.

  self _treeReportDownTo: thresholdArg on: rootPME to: rpt.

^ rpt
%

category: 'Private'
method: ProfMonitorTree
_objectCreationTreeReport
  "report on object creation, in tree form."

  | rpt croots tally |

  tally := self dynamicInstVarAt: #reportThreshold.

  rpt := String new.
  rpt add: (self _reportHeader: 'OBJECT CREATION TREE REPORT'); lf.

  " If there's no samples, bail "
  (rootPME == nil  or: [objRootPMEDict keys size < 1]) ifTrue: [
     rpt add: ' - - No results to report - -' ; lf.
     ^ rpt.
     ].

  croots := Array new.
  objRootPMEDict keysAndValuesDo: [ :cls :root |
    croots add: (Array with: cls with: root)].
  croots := croots
    asSortedCollection: [:a :b | ((a at: 2) tally) > ((b at: 2) tally)].
  croots do: [:r | | cls root |
    cls := r at: 1.
    root := r at: 2.
	rpt add: 'root tally is ', root tally asString; lf.
    root tally < tally ifFalse: [
  		rpt add:'----------------'; lf ; add: cls name ; lf ; lf.
     		self _treeReportDownTo: tally on: root to: rpt ]].
^ rpt
%

category: 'Private'
method: ProfMonitorTree
_treeReportDownTo: tally on: root to: rpt

root children do: [:aPME |
  self
    treePrintPME: aPME
    on: rpt
    tabs: OrderedCollection new
    thisTab: '  '
    total: aPME tally
    downTo: tally
  ].
rpt lf; lf.
%

! Class implementation for 'ProfMonitorEntry'

!		Class methods for 'ProfMonitorEntry'

category: 'Instance Creation'
classmethod: ProfMonitorEntry
new

  | pme |
  pme := self _basicNew.
  pme initialize.
  ^ pme
%

category: 'Instance Creation'
classmethod: ProfMonitorEntry
newForClass: aClass method: aMethod receiverClass: rcvrClass

  | pme |
  pme := self new.
  pme cclass: aClass.
  pme cmethod: aMethod.
  pme rcvrClass: rcvrClass.
  ^pme.
%

category: 'Instance Creation'
classmethod: ProfMonitorEntry
newForClass: aClass receiverClass: rcvrClass

  ^ self newForClass: aClass method: nil receiverClass: rcvrClass
%

category: 'Instance Creation'
classmethod: ProfMonitorEntry
newForMethod: aMethod receiverClass: rcvrClass

  ^ self newForClass: nil method: aMethod receiverClass: rcvrClass
%

!		Instance methods for 'ProfMonitorEntry'

category: 'Reporting'
method: ProfMonitorEntry
asStringWidth: nameWidth
  | str mth |
  mth := cmethod .
  mth == #GCI ifTrue:[
    str := #GCI asString width: nameWidth .
  ] ifFalse:[ | rcvCls |
    str := mth _classAndSelectorNameWidth: nameWidth .
    (mth inClass ~~ (rcvCls := rcvrClass) and:[ rcvCls ~~ Object]) ifTrue:[
      str add: ' [' ; add: rcvCls name ; add: ']' .
    ].
  ].
  ^ str
%

category: 'Accessing'
method: ProfMonitorEntry
cclass

   "Return the value of the instance variable 'cclass'."
   ^cclass
%

category: 'Updating'
method: ProfMonitorEntry
cclass: newValue

   "Modify the value of the instance variable 'cclass'."
   cclass := newValue
%

category: 'Accessing'
method: ProfMonitorEntry
children

   "Return the value of the instance variable 'children'."
   ^children
%

category: 'Accessing'
method: ProfMonitorEntry
childTallies

   "Return the value of the instance variable 'childTallies'."
   ^childTallies
%

category: 'Accessing'
method: ProfMonitorEntry
cmethod

   "Return the value of the instance variable 'cmethod'."
   ^cmethod
%

category: 'Updating'
method: ProfMonitorEntry
cmethod: newValue

   "Modify the value of the instance variable 'cmethod'."
   cmethod := newValue
%

category: 'Updating'
method: ProfMonitorEntry
incrementTally: anInt

  tally := tally + anInt .
  total := total + anInt .
%

category: 'Updating'
method: ProfMonitorEntry
incrementTotal: anInt

  total := total + anInt .
%

category: 'Initialization'
method: ProfMonitorEntry
initialize

  tally := 0.
  total :=  0.
  childTallies := IdentityDictionary new.
  parentTallies := IdentityDictionary new.
  children := IdentitySet new.
  parents := IdentitySet new.
  recursed := false.
%

category: 'Accessing'
method: ProfMonitorEntry
parents

   "Return the value of the instance variable 'parents'."
   ^parents
%

category: 'Accessing'
method: ProfMonitorEntry
parentTallies

   "Return the value of the instance variable 'parentTallies'."
   ^parentTallies
%

category: 'Accessing'
method: ProfMonitorEntry
rcvrClass

   "Return the value of the instance variable 'rcvrClass'."
   ^rcvrClass
%

category: 'Updating'
method: ProfMonitorEntry
rcvrClass: newValue

   "Modify the value of the instance variable 'rcvrClass'."
   rcvrClass := newValue
%

category: 'Accessing'
method: ProfMonitorEntry
recursed

   "Return the value of the instance variable 'recursed'."
   ^recursed
%

category: 'Updating'
method: ProfMonitorEntry
recursed: newValue

   "Modify the value of the instance variable 'recursed'."
   recursed := newValue
%

category: 'Accessing'
method: ProfMonitorEntry
root

   "Return the value of the instance variable 'root'."
   ^root
%

category: 'Updating'
method: ProfMonitorEntry
root: newValue

   "Modify the value of the instance variable 'root'."
   root := newValue
%

category: 'Accessing'
method: ProfMonitorEntry
tally

   "Return the value of the instance variable 'tally'."
   ^tally
%

category: 'Updating'
method: ProfMonitorEntry
tally: newValue

   "Modify the value of the instance variable 'tally'."
   tally := newValue
%

category: 'Accessing'
method: ProfMonitorEntry
total

   "Return the value of the instance variable 'total'."
   ^total
%

category: 'Updating'
method: ProfMonitorEntry
total: newValue

   "Modify the value of the instance variable 'total'."
   total := newValue
%

! Class implementation for 'SharedQueue'

!		Class methods for 'SharedQueue'

category: 'Instance Creation'
classmethod: SharedQueue
new
  "Answer a new SharedQueue"
  ^self basicNew initialize
%

category: 'Instance Creation'
classmethod: SharedQueue
new: size
  "Answer a new SharedQueue.  The argument is ignored "
  ^self new
%

!		Instance methods for 'SharedQueue'

category: 'Private'
method: SharedQueue
initialize

  valueAvailable := Semaphore new.
  contents := { } .
%

category: 'Testing'
method: SharedQueue
isEmpty
  "Return true if the receiver does not contains any objects."

  ^(self size == 0)
%

category: 'Removing'
method: SharedQueue
next
  "Returns with the first object added to the receiver that has not
   yet been removed. If the receiver is empty, the active
   GsProcess waits until an object is added to it.
   If more than one GsProcess is waiting then the one with the
   highest priority that has been waiting the longest will get the
   next item added."

  |value|

  valueAvailable wait.
  value := contents removeFirst.
  ^value
%

category: 'Adding'
method: SharedQueue
nextPut: value
  "Add value to the contents of the receiver. If a GsProcess has been
   waiting for an object, allow it to proceed.
   Returns the added value."

  contents addLast: value.
  valueAvailable signal.
  ^value.
%

category: 'Accessing'
method: SharedQueue
peek
  "Returns the result of next without removing the object. If the
   receiver is empty return nil."

  |value actualSize |

  actualSize := self size.
  (actualSize == 0) ifTrue: [
    value := nil.
  ] ifFalse: [
    | nextIdx |
    "Some of the first elements may belong to guys waiting on the semaphore
     that have already been signalled but have not yet had a chance to run."
    nextIdx := (contents size) - (actualSize - 1).
    value := contents at: nextIdx.
  ].
  ^value
%

category: 'Formatting'
method: SharedQueue
printOn: aStream

"Puts a displayable representation of the receiver on the given stream."

| startIdx sz |
super printOn: aStream .
aStream nextPutAll: '( ' .
sz := contents size.
(self isEmpty) ifFalse: [
  startIdx := sz - (self size - 1).
  contents from: startIdx to: sz doWithIndex: [ :anElement :count |
    aStream position > 700 ifTrue:[
      "prevent infinite recursion when printing cyclic structures, and
       limit the size of result when printing large collections."
      aStream nextPutAll: '...)' .
      ^ self
      ] .
    anElement printOn: aStream .
    count < sz ifTrue:[ aStream nextPutAll: ', ' ].
  ].
].
aStream nextPut: $) .
%

category: 'Accessing'
method: SharedQueue
size
  "Return the number of object that are still in the queue."

  ^valueAvailable excessSignals
%

category: 'Private'
method: SharedQueue
_canWaitOnSocket

  ^ true
%

category: 'Private'
method: SharedQueue
_changePriority: aGsProcess from: oldPriority

  ^ self  "do nothing"
%

category: 'Testing'
method: SharedQueue
_isLarge

"Returns true if the object is implemented as a tree of private smaller objects"

^ true
%

category: 'Private'
method: SharedQueue
_reapSignal: signalSource
  "Put signalSource on the receiver."

  self nextPut: signalSource
%

! Class implementation for 'JsonParser'

!		Instance methods for 'JsonParser'

category: 'other'
method: JsonParser
array

	^((	$[ asParser , #space asParser star , $] asParser) 	==> [:tokens | #()])
	| ((	$[ asParser , elements , $] asParser) 					==> [:tokens | tokens at: 2])
%

category: 'other'
method: JsonParser
character

	^(($\ asParser , escape) 											==> [:tokens | tokens at: 2])
	| (($" asParser not , $\ asParser not , #any asParser) 	==> [:tokens | tokens at: 3])
%

category: 'other'
method: JsonParser
element

	^value trim
%

category: 'other'
method: JsonParser
elements

	^(element , ($, asParser , elements) star) ==> [:tokens |
		(tokens at: 2) isEmpty
			ifTrue: [Array with: (tokens at: 1)]
			ifFalse: [(Array with: (tokens at: 1)) , (((tokens at: 2) at: 1) at: 2)]]
%

category: 'other'
method: JsonParser
escape

	^$" asParser
	| $\ asParser
	| $/ asParser
	| ($b asParser ==> [:tokens | Character codePoint: 8])
	| ($n asParser ==> [:tokens | Character lf])
	| ($r asParser ==> [:tokens | Character cr])
	| ($t asParser ==> [:tokens | Character tab])
	| (($u asParser , (#hex asParser times: 4) flatten) ==> [:tokens | Character codePoint: ('16r' , (tokens at: 2)) asNumber])
%

category: 'other'
method: JsonParser
exp

	^(($E asParser | $e asParser) , sign optional , #digit asParser plus) flatten
%

category: 'other'
method: JsonParser
frac

	^($. asParser , #digit asParser plus flatten) ==> [:tokens | '.' , tokens last]
%

category: 'other'
method: JsonParser
int

	^(sign optional , #digit asParser plus) flatten
%

category: 'other'
method: JsonParser
json

	^element
%

category: 'other'
method: JsonParser
member

	^(string trim , $: asParser , element) ==> [:tokens | (tokens at: 1) -> (tokens at: 3)]
%

category: 'other'
method: JsonParser
members

	^(member , ($, asParser , members) star) ==> [:tokens |
		| assoc more |
		assoc := tokens at: 1.
		more := tokens at: 2.
		more isEmpty ifTrue: [
			Dictionary with: assoc
		] ifFalse: [
			((more at: 1) at: 2)	"ignore the comma"
				add: assoc;
				yourself.
		].
	]
%

category: 'other'
method: JsonParser
number

	^(int , frac optional , exp optional) ==> [:tokens | ((tokens at: 1) , ((tokens at: 2) ifNil: ['']) , ((tokens at: 3) ifNil: [''])) asNumber]
%

category: 'other'
method: JsonParser
object

	^((	${ asParser , #space asParser star , $} asParser) 	==> [:tokens | Dictionary new])
	| ((	${ asParser , members , $} asParser) 					==> [:tokens | tokens at: 2])
%

category: 'other'
method: JsonParser
sign

	^$+ asParser
	| $- asParser
%

category: 'other'
method: JsonParser
start

	^json
%

category: 'other'
method: JsonParser
string

	^($" asParser , character star , $" asParser) ==> [:tokens | String withAll: (tokens at: 2)]
%

category: 'other'
method: JsonParser
value

	^(array
	| object
	| string
	| ('true' asParser ==> [:tokens | true])
	| ('false' asParser ==> [:tokens | false])
	| ('null' asParser ==> [:tokens | nil])
	| number) memoized
%

! Class implementation for 'CPreprocessorStream'

!		Instance methods for 'CPreprocessorStream'

category: 'Accessing'
method: CPreprocessorStream
cppArchMType
  ^ cppArchMType
%

category: 'Accessing'
method: CPreprocessorStream
cppArchMType: aSmallInt
  cppArchMType := aSmallInt
%

category: 'Accessing'
method: CPreprocessorStream
debug
  ^ debug 
%

category: 'Accessing'
method: CPreprocessorStream
debug: aBoolean
  "aBoolean == true enables some debug details in CPreprocessorToken ."
  ^ debug := aBoolean .
%

category: 'Accessing'
method: CPreprocessorStream
file
  "Returns a String, a file name"
  ^ file
%

category: 'Accessing'
method: CPreprocessorStream
file: aFileName
  file := aFileName
%

category: 'Accessing'
method: CPreprocessorStream
line
  ^ line
%

category: 'Accessing'
method: CPreprocessorStream
line: aLineNumber
  line := aLineNumber
%

! Class implementation for 'PPStream'

!		Instance methods for 'PPStream'

category: 'converting'
method: PPStream
asPetitStream
	^ self
%

category: 'accessing'
method: PPStream
back
	"Go back one element and return it."

	self skip: -1.
	^ self peek
%

category: 'accessing'
method: PPStream
collection
	"Answer the underlying collection."

	^ collection
%

category: 'positioning'
method: PPStream
column
	^ self column: position.
%

category: 'positioning'
method: PPStream
column: pos
	| nl |
	(pos = -1) ifTrue: [  ^ 0 ].
	(pos > readLimit) ifTrue: [ ^ self error: 'Out of limit' ].

	nl := self newlines.
	1 to: nl size do: [ :index |
		((nl at: index) > pos) ifTrue: [ ^ pos - (nl at: (index - 1)) + 1 ]
	].
"	nl keysAndValuesDo: [ :index :value |
		(value > pos) ifTrue: [ ^ pos - (nl at: (index - 1)) + 1]
	].
"
	^ pos - (nl at: (nl size )) + 1
%

category: 'positioning'
method: PPStream
fillNewlines
	| tmp line |
	newlines := OrderedCollection new.

	tmp := position.
	line := 0.

	(0 to: readLimit) do: [:index |
		position := index.
		self isStartOfLine ifTrue: [ newlines add: position ]
	].
	position := tmp.
	newlines := newlines asArray.
	^ newlines
%

category: 'queries'
method: PPStream
insideCRLF
	(position < 1) ifTrue: [ ^ false ].

	^ (self peek = (Character codePoint: 10)) and: [ self peekBack = (Character codePoint: 13) ]
%

category: 'queries'
method: PPStream
isEndOfLine
	self atEnd ifTrue: [ ^ true ].
	self insideCRLF ifTrue: [ ^ false ].
	^ (self peek = (Character codePoint: 13) or: [ self peek = (Character codePoint: 10)]).
%

category: 'queries'
method: PPStream
isStartOfLine
	(position = 0) ifTrue: [ ^ true ].

	self insideCRLF ifTrue: [ ^ false ].

	^ (self peekBack = (Character codePoint: 13)) or: [ self peekBack = (Character codePoint: 10)].
%

category: 'positioning'
method: PPStream
line
	^ self line: position
%

category: 'positioning'
method: PPStream
line: pos
	| nl |
	(pos = -1) ifTrue: [  ^ 0 ].
	(pos > readLimit) ifTrue: [ ^ self error: 'Out of limit' ].

	nl := self newlines.
	nl keysAndValuesDo: [ :index :value |
		(value > pos) ifTrue: [ ^ (index - 1)]
	].

	^ nl size
%

category: 'positioning'
method: PPStream
newlines
	^ newlines ifNil: [
		newlines := self fillNewlines.
	]
%

category: 'accessing'
method: PPStream
next: anInteger
	"Answer up to anInteger elements of my collection. Overridden for efficiency."

	| answer endPosition |
	endPosition := position + anInteger min: readLimit.
	answer := collection copyFrom: position + 1 to: endPosition.
	position := endPosition.
	^ answer
%

category: 'accessing'
method: PPStream
peek
	"An improved version of peek, that is slightly faster than the built in version."

	^ self atEnd ifFalse: [ collection at: position + 1 ]
%

category: 'accessing'
method: PPStream
peekBack
	"Return the element at the previous position, without changing position."

	| element |
	element := self back.
	self skip: 1.
	^ element
%

category: 'accessing'
method: PPStream
position: anInteger
	"The receiver does not check for invalid arguments passed to this method, as it is solely used with valid indexes for backtracking."

	position := anInteger
%

category: 'printing'
method: PPStream
printOn: aStream
	(collection isKindOf: CharacterCollection)
		ifFalse: [ ^ super printOn: aStream ].
	aStream
		nextPutAll: (collection copyFrom: 1 to: position);
		nextPut: (Character codePoint: 183);
		nextPutAll: (collection copyFrom: position + 1 to: readLimit)
%

category: 'accessing'
method: PPStream
size
	"
		The same implementation as a ReadStream. Implemented here for compatibility with Smalltalk/X
		that has different implementation in a ReadStream
	"
	^readLimit
%

category: 'accessing'
method: PPStream
uncheckedPeek
	"An unchecked version of peek that throws an error if we try to peek over the end of the stream, even faster than #peek."

	^ collection at: position + 1
%

! Class implementation for 'AppendableString'

!		Class methods for 'AppendableString'

category: 'Storing and Loading'
classmethod: AppendableString
loadFrom: passiveObj

"Reads from passiveObj the passive form of an object.  Converts the object to
 its active form by loading the information into a new instance of the receiver.
 Returns the new instance."

| inst |

inst := self basicNew: passiveObj readSize.
inst loadFrom: passiveObj.
^inst
%

category: 'Instance Creation'
classmethod: AppendableString
new: aSize
  "Disallowed,  use the inherited   String class >> new ."
  self shouldNotImplement: #new:
%

!		Instance methods for 'AppendableString'

category: 'Adding'
method: AppendableString
add: aCharacterOrString
  <primitive: 296>
  ^ self nextPutAll: aCharacterOrString
%

category: 'Adding'
method: AppendableString
addAll: aString
  <primitive: 296>
  ^ self nextPutAll: aString
%

category: 'Adding'
method: AppendableString
addCodePoint: aSmallInteger
  <primitive: 1047>
  ^ self nextPut: (Character codePoint: aSmallInteger).
%

category: 'Adding'
method: AppendableString
addLast: aCharacterOrString
  <primitive: 296>
  ^ self nextPutAll: aCharacterOrString
%

category: 'Updating'
method: AppendableString
at: anIndex put: aChar

anIndex == (self size + 1) ifTrue:[
  ^ self add: aChar .
].
^ self _errorIndexOutOfRange: anIndex
%

category: 'Updating'
method: AppendableString
codePointAt: anIndex put: aSmallInteger

anIndex == (self size + 1) ifTrue:[
  ^ self addCodePoint: aSmallInteger .
].
^ self _errorIndexOutOfRange: anIndex
%

category: 'Accessing'
method: AppendableString
contents
  ^ self
%

category: 'Character writing'
method: AppendableString
cr
  self addCodePoint: 13
%

category: 'Character writing'
method: AppendableString
crlf
  self addCodePoint: 13 ; addCodePoint: 10
%

category: 'Character writing'
method: AppendableString
crtab
  self addCodePoint: 13 ; addCodePoint: 9
%

category: 'Character writing'
method: AppendableString
crtab: anInteger
  "Append a return character, followed by anInteger tab characters, to the
  receiver."

  self addCodePoint: 13 .
  anInteger timesRepeat: [ self addCodePoint: 9 ]
%

category: 'Updating'
method: AppendableString
insertAll: aCharOrCharColl at: anIndex

anIndex == (self size + 1) ifTrue:[
  ^ self addAll: aCharOrCharColl
].
^ self _errorIndexOutOfRange: anIndex
%

category: 'Adding'
method: AppendableString
nextPut: aCharacterOrString
  <primitive: 296>
  ^ self nextPutAll: aCharacterOrString
%

category: 'Adding'
method: AppendableString
nextPutAll: aCharacterOrString
  <primitive: 296>
  aCharacterOrString class == Character ifTrue:[
    aCharacterOrString codePoint > 255 ifTrue:[
      ArgumentError signal:'codePoint exceeds 255'.
    ].
  ].
  aCharacterOrString stringCharSize == 1 ifFalse:[
    aCharacterOrString _validateKindOfClass: String .
  ].
  ^ self _primitiveFailed: #nextPutAll: args: { aCharacterOrString }.
%

category: 'Encoding'
method: AppendableString
nextPutAllUtf8: aCharacterOrString
 "Appends the UTF8 encoding of the argument to receiver"
 <primitive: 1045>
  aCharacterOrString _validateKindOfClasses: { Character . String } .
  ^ self _primitiveFailed: #nextPutAllUtf8: args: { aCharacterOrString }
%

category: 'Adding'
method: AppendableString
nextPutCodePoint: aSmallInteger
  <primitive: 1047>
  ^ self nextPut: (Character codePoint: aSmallInteger).
%

category: 'Updating'
method: AppendableString
removeFrom: startIndex to: stopIndex

"Disallowed"
  self shouldNotImplement: #removeFrom:to:
%

category: 'Updating'
method: AppendableString
size: anInteger

anInteger == 0 ifFalse:[
  Error signal:' size: should only be used to reset a stream to empty'
].
^super size: anInteger
%

category: 'Character writing'
method: AppendableString
space
  self addCodePoint: 32
%

category: 'Character writing'
method: AppendableString
space: anInteger
  "Append anInteger space characters to the receiver."

  anInteger timesRepeat: [ self addCodePoint: 32 ]
%

category: 'Character writing'
method: AppendableString
tab
  self addCodePoint: 9
%

category: 'Character writing'
method: AppendableString
tab: anInteger
"Append anInteger tab characters to the receiver."

anInteger timesRepeat: [self tab]
%

category: 'Updating'
method: AppendableString
_reverseFrom: aString
"Disallowed"
  self shouldNotImplement: #_reverseFrom:
%

! Class implementation for 'ISOLatin'

!		Instance methods for 'ISOLatin'

category: 'Formatting'
method: ISOLatin
printOn: aStream

"Puts a displayable representation of the receiver on the given stream."

aStream _collection class == String ifTrue:[ aStream _convertToISOLatin ].

^ super printOn: aStream
%

! Class implementation for 'GsTestCase'

!		Class methods for 'GsTestCase'

category: 'Converting'
classmethod: GsTestCase
asPrintable: aString
| res |
GsFile stdoutServer isTerminal ifFalse:[ ^ aString ]
"avoid freezing certain Xterm windows with control chars".
res := String new .
1 to: aString size do:[:n | | ch |
  ch := aString codePointAt: n .
  ch < 16r20 ifTrue:[
    (ch == 10"\n" or:[ ch == 9"\t" ]) ifTrue:[ res addCodePoint: ch ]
             ifFalse:[ res add: $^ ; addCodePoint: 16r40 + ch ]
     ] ifFalse:[
  ch < 16r7F ifTrue:[ res addCodePoint: ch ] ifFalse:[
  ch == 16r7F ifTrue:[ res addAll:'^?' ] ifFalse:[ | cpStr sz |
    res addAll:'\u' .
    cpStr := ch asHexString .
    sz := cpStr size .
    [ sz < 4 ] whileTrue:[ res add: $0 . sz := sz + 1 ].
    res addAll: cpStr .
 ]]]
].
^ res
%

category: 'Debugging'
classmethod: GsTestCase
confirm: aSelector

	^[
		self debug: aSelector.
		true.
	] on: Error , TestFailure do: [:ex |
		false.
	].
%

category: 'Debugging'
classmethod: GsTestCase
debug: aSelector
  SessionTemps current at:#GsTestCase_debug put: true . "supress stack report in exception message"
  self openSunitLog: #stdout .
  ^ super debug: aSelector
%

category: 'Debugging'
classmethod: GsTestCase
debugEx

"receiver should be a concrete test case class .
 run and get stack at first error."
^ self debugSuite: self suite
%

category: 'Debugging'
classmethod: GsTestCase
debugEx: aTestCaseClass

"Run suite for specified class and get stack at first error."

^ self debugSuite: aTestCaseClass suite
%

category: 'Debugging'
classmethod: GsTestCase
debugSuite: aTestSuite

  AlmostOutOfMemoryError enable ; threshold: 90 .
  GsTestCase openSunitLog: #stdout .
  [
    SessionTemps current at:#GsTestCase_debug put: true . "supress stack report in exception message"
    aTestSuite tests do: [:each |
      (each isKindOf: TestSuite)
        ifTrue:  [self debugSuite: each]
        ifFalse: [each debugInSuite].
    ].
  ] ensure: [
    TestResource resetResources: self resources.
  ].
  GsTestCase flushLog .
  ^ 'ok'
%

category: 'Debugging'
classmethod: GsTestCase
dummyHostCallDebugger
GsFile stdoutServer isTerminal ifFalse:[ | f |
  f := GsFile openWriteOnServer:'HostCallDebugger.log' .
  f nextPutAll:'HostCallDebugger', ': process ' , System gemProcessId asString,
     ' waiting for topaz -r to attach with DEBUGGEM' ; lf .
  f close .
].
%

category: 'Logging'
classmethod: GsTestCase
flushLog

| sunitLog |
sunitLog := System sessionStateAt: 1 .
sunitLog ifNotNil:[ sunitLog flush ].
%

category: 'Testing'
classmethod: GsTestCase
isAbstract
	"Override to true if a TestCase subclass is Abstract and should not have
	TestCase instances built from it"

	^self sunitName = #GsTestCase
%

category: 'Testing'
classmethod: GsTestCase
isArm64Darwin
^ (System gemVersionAt: #cpuArchitecture) = 'arm64'
%

category: 'Testing'
classmethod: GsTestCase
isArm64Linux
^ (System gemVersionAt: #cpuArchitecture) = 'aarch64'
%

category: 'Testing'
classmethod: GsTestCase
isDebug
  ^ self isDebug: nil
%

category: 'Testing'
classmethod: GsTestCase
isDebug: anException
  | tmps now |
  now := DateAndTime now asStringMs .
  tmps := SessionTemps current .
  (tmps at:#GsTestCase_debug otherwise: false) ifTrue:[
    ^ true
    "running a test case via debug: or debugEx , let topaz handle the error"
  ].
  ((System gemEnvironmentVariable:'GsTestCaseWaitForDebug') ~~ nil
    or:[ anException isKindOf: AlmostOutOfMemoryError ])
  ifTrue:[
    self pauseForDebug
  ].
  ^ false "log failure to SUnit.log and keep running"
%

category: 'Testing'
classmethod: GsTestCase
isLinux
   ^ (System gemVersionAt: 'osName') = 'Linux'
%

category: 'Testing'
classmethod: GsTestCase
isLinuxOrSolaris
| os |
os := System gemVersionAt: 'osName'.
^ os = 'Linux' or:[ os = 'SunOS' ]
%

category: 'Testing'
classmethod: GsTestCase
isSolaris
  "Needed on class side by GsSocketTestCase"
  ^(System gemVersionAt: 'osName') = 'SunOS'
%

category: 'Testing'
classmethod: GsTestCase
isSparcSolaris
^ (System gemVersionAt: #cpuArchitecture) = 'SPARC'
%

category: 'Testing'
classmethod: GsTestCase
isUbuntu20Linux
  ^ self isUbuntuLinux and:[ (System performOnServer: 'cat /etc/os-release') includesString: 'Ubuntu 20' ]
%

category: 'Testing'
classmethod: GsTestCase
isUbuntuLinux
  ^ self isLinux and:[ (System gemVersionAt: 'osVersion') includesString:'Ubuntu' ]
%

category: 'Testing'
classmethod: GsTestCase
isWindows

  ^ GsFile gciClientIsWindows .
%

category: 'Logging'
classmethod: GsTestCase
log: aString
| sunitLog |
sunitLog := System sessionStateAt: 1 .
sunitLog ifNil:[
  "if not already open, assume in an external session's gem, log to filesystem"
  sunitLog := self openSunitLog: #filesystem
].
sunitLog nextPutAll: (self asPrintable: aString) ; flush
%

category: 'Logging'
classmethod: GsTestCase
logCr: aString

| str |
str := aString , Character lf .
GsTestCase log: str
%

category: 'Logging'
classmethod: GsTestCase
openSunitLog: aKind
"aKind == #stdout means to GsFile stdout, otherwise to SUnit.log file"
| aLog |
aLog := System sessionStateAt: 1.
aLog ifNil:[
  aKind == #stdout ifFalse:[
    aLog := GsFile openAppendOnServer: GsTestSuite logFilePath.
  ].
  aLog ifNil:[
    "use stdout if file system open failed. Example: remote topaz -l
     and logFilePath generates file system path
     based on extent locations without /export ."
    aLog := GsFile stdoutServer . "assume topaz -l, if interactive"
  ].
  System sessionStateAt: 1 put: aLog.
].
^ aLog
%

category: 'Debugging'
classmethod: GsTestCase
pauseForDebug
  GsFile stdoutServer isTerminal ifFalse:[ |tmps |
     self dummyHostCallDebugger .
     GsFile gciLogServer:'--------'.
     GsFile gciLogServer:( GsProcess stackReportToLevel:30).
     GsFile gciLogServer:'--------'.
     GsFile gciLogServer:'Waiting for debugger to attach, use topaz -r, DEBUGGEM'.
     GsFile stdoutServer flush .
     tmps := SessionTemps current .
     tmps at: #WaitForDebug put: true .
     [ tmps at: #WaitForDebug  ] whileTrue:[ Delay waitForSeconds: 1 ].  "Wait for DEBUGGEM"
  ].
  self pause "not trappable error ; back to topaz "
%

category: 'Miscellaneous'
classmethod: GsTestCase
random

        ^ SessionTemps current at:#Random ifAbsentPut: [Random new].
%

category: 'Test Suite'
classmethod: GsTestCase
suite

	| suite tests |
	suite := super suite.
	tests := suite tests.
	tests copy do: [:each |
		(each isKindOf: GsTestSuite) ifTrue: [
			| assoc |
			assoc := System myUserProfile resolveSymbol: each name asSymbol.
			(assoc notNil and: [assoc value wantsToBeRunByItself]) ifTrue: [
				tests remove: each.
			].
		].
	].
	^suite.
%

category: 'Test Suite'
classmethod: GsTestCase
suiteAsExecutionSource

  " return an execution string of all test cases that
    don't need to be run by themselves, for use
    in debugging a new VM from topaz -l  ."
  | str LF |
  str := String new .
  LF := Character lf .
  str addAll:'run'; add: LF .
  GsTestCase suite tests do:[:aTst |
    str addAll:'GsTestCase debugEx: '; addAll: aTst name ; add: $. ; add: LF
  ].
  str add: $% ; add: LF .
  ^ str
%

category: 'Test Suite'
classmethod: GsTestCase
suiteClass
	^GsTestSuite
%

category: 'Debugging'
classmethod: GsTestCase
waitForDebug
 "uncomment for attach with DEBUGGEM"
 "GsFile gciLogServer:'WAITING for topaz to attach'.
  [ true ] whileTrue:[ Delay waitForSeconds: 1 ].
 "
%

category: 'Testing'
classmethod: GsTestCase
wantsToBeRunByItself

	^false.
%

!		Instance methods for 'GsTestCase'

category: 'Transaction Management'
method: GsTestCase
abort
	System abortTransaction.
%

category: 'Miscellaneous'
method: GsTestCase
addAllTestsTo: aList

	aList add: self.
%

category: 'Miscellaneous'
method: GsTestCase
addSession: aSession
"return a session for similarity with collection methods"
	^self sessions add: aSession
%

category: 'Asserting'
method: GsTestCase
assert: aBoolean

  self assert: aBoolean description:'' .
%

category: 'Asserting'
method: GsTestCase
assert: aBoolean description: aString
  | str |
  aBoolean == true  ifFalse: [
    str := aString .
    str _isExecBlock ifTrue:[ str := aString value ].
    self logFailure: str.
    GsTestResult resumableFailure sunitSignalWith: str
  ]
%

category: 'Asserting'
method: GsTestCase
assert: aBoolean description: aString resumable: resumableBoolean
  | exception |
  aBoolean == true  ifFalse: [
    self logFailure: aString.
    exception := resumableBoolean ifTrue: [
      GsTestResult resumableFailure
    ] ifFalse: [
      GsTestResult failure
    ].
    exception sunitSignalWith: aString
  ]
%

category: 'Asserting'
method: GsTestCase
assert: a equals: b description: c
  self assert: a = b description:
    a asString, ' not equal to ' , b asString , ' for ', c
%

category: 'Asserting'
method: GsTestCase
assert: a greaterEqual: b
  self assert: a >= b description:
    a asString, ' not >= ' , b asString
%

category: 'Asserting'
method: GsTestCase
assert: a identical: b
  self assert: a == b description: 'OOP ' , a asOop asString, ' not identical to OOP ' , b asOop asString
%

category: 'Asserting'
method: GsTestCase
assert: a identical: b description: c
  self assert: a == b description:
   'OOP ' , a asOop asString, ' not identical to OOP ' , b asOop asString , ' for ', c
%

category: 'Asserting'
method: GsTestCase
assert: a isEquivalentTo: b
	| difference epsilon |
	epsilon := (a abs max: b abs) * 1.0e-08.
	difference := (a - b) abs asScaledDecimal: 12.
	self assert: difference <= epsilon description: a printString, ' is not equivalent to ', b printString.
%

category: 'Asserting'
method: GsTestCase
assert: a lessThan: b
  self assert: a < b description:
    a asString, ' not < ' , b asString
%

category: 'Asserting'
method: GsTestCase
assert: aString matchPattern: aPatternArray

	self assert: (aString matchPattern: aPatternArray) description: aString printString, ' does not match ', aPatternArray printString.
%

category: 'Asserting'
method: GsTestCase
assert: a notIdentical: b
  self assert: a ~~ b description: ' expected a ', a printString, ' to not be identical to b '
%

category: 'Asserting'
method: GsTestCase
assert: a notIdentical: b description: str
  self assert: a ~~ b description: str .
%

category: 'Asserting'
method: GsTestCase
assertQuietNan: f1
  self assert: (f1 _isNaN _and: [ f1 kind == #quietNaN ])
%

category: 'Transaction Management'
method: GsTestCase
begin

	System beginTransaction.
%

category: 'Transaction Management'
method: GsTestCase
commit
   ^GsSession isSolo or: [System commitTransaction or: [self error: 'commit failed']]
%

category: 'Miscellaneous'
method: GsTestCase
compileMethod: aStr class: anObject

	self assert: (anObject compileMethod: aStr dictionaries: System myUserProfile symbolList category: 'other') == nil.
%

category: 'Transaction Management'
method: GsTestCase
continue

	^System continueTransaction
%

category: 'Debugging'
method: GsTestCase
debug
   [ (self class selector: testSelector) runCase
   ] ensure: [
     [ TestResource resetResources: self resources
     ] on: Notification do:[:ex |
        ex class defaultHandlers size > 0 ifTrue:[ ex pass ].
        Error signal: ex asString
     ]
   ].
%

category: 'Debugging'
method: GsTestCase
debugInSuite
   "used from GsTestCase class >> debugSuite: that does its own cleanup"

   (GsTestResult excludeInSoloSession: self) ifTrue:[
     GsTestCase logCr: self printString , ' -  Excluding in SoloSession' .
   ] ifFalse: [
     (self class selector: testSelector) runCase
   ]
%

category: 'Asserting'
method: GsTestCase
deny: a equals: b
  self assert: (a = b) not description: 'OOP ' , a asOop asString, ' is equal to OOP ' , b asOop asString
%

category: 'Asserting'
method: GsTestCase
deny: a identical: b
  self assert: a ~~ b description: 'OOP ' , a asOop asString, ' is identical to OOP ' , b asOop asString
%

category: 'Asserting'
method: GsTestCase
ensureExtentsExist: anInteger

	| existingName i lastNumber extOffset |
	extOffset := System repositoryIsEncrypted ifTrue:[ 4 ] ifFalse:[ 3 ] .
	SystemRepository numberOfExtents >= anInteger ifTrue: [^self].
	existingName := SystemRepository fileNames last.
	i := existingName size - extOffset.
	(existingName copyFrom: i to: i + extOffset) = SystemRepository defaultFileExtension
	  ifFalse: [ self error: 'unexpected extent name' ].
	[
		i > 1 and: [(existingName at: i - 1) isDigit].
	] whileTrue: [
		i := i - 1.
	].
	i = (existingName size - extOffset) ifTrue: [
		self error: 'extent name does not end in digit'.
	].
	lastNumber := (existingName copyFrom: i to: existingName size - (extOffset + 1)) asNumber.
	[
		SystemRepository numberOfExtents < anInteger.
	] whileTrue: [
		| newName |
		lastNumber := lastNumber + 1.
		newName := (existingName copyFrom: 1 to: i - 1) ,
			lastNumber printString , SystemRepository defaultFileExtension .
		SystemRepository createExtent: newName.
	].
	System hasMissingGcGems ifTrue: [
		System stopAllGcGems.
		System startAllGcGems.
	].
%

category: 'Asserting'
method: GsTestCase
ensureGcRunning
	System ensureGcRunning.
	self deny: System hasMissingGcGems description: 'System hasMissingGcGems in ensureGcRunning'.
%

category: 'Miscellaneous'
method: GsTestCase
forceLogoutSessions
  self sessions ifNotNil:[:list |
    list do: [:each | each ifNotNil:[ each forceLogout ] ].
    list size: 0 .
  ].
%

category: 'Miscellaneous'
method: GsTestCase
gciErrorClass
	^ self isAix
		ifTrue: [GciLegacyError]
		ifFalse: [GciError].
%

category: 'Running'
method: GsTestCase
ignoringDeprecatedDo: aBlock
  ^ aBlock on: Deprecated do:[:ex | ex resume  ]
%

category: 'Running'
method: GsTestCase
ignoringDeprecatedShould: aBlock raise: anObject
  ^ self should: [  aBlock on: Deprecated do:[:ex | ex resume ]]
      raise: anObject  description:''
%

category: 'Testing'
method: GsTestCase
isAix
  ^ (System gemVersionAt: 'osName') = 'AIX'
%

category: 'Testing'
method: GsTestCase
isAix6
^ self isAix and:[ (System gemVersionReport at: #osVersion) = '6' ].
%

category: 'Testing'
method: GsTestCase
isAix7
^ self isAix and:[ (System gemVersionReport at: #osVersion) = '7' ].
%

category: 'Testing'
method: GsTestCase
isArm64Darwin
	^self class isArm64Darwin
%

category: 'Testing'
method: GsTestCase
isArm64Linux
	^self class isArm64Linux
%

category: 'Testing'
method: GsTestCase
isDarwin
  ^ (System gemVersionAt: #osName) = 'Darwin'
%

category: 'Testing'
method: GsTestCase
isLinux
	^self class isLinux
%

category: 'Testing'
method: GsTestCase
isLinuxOrDarwin

  ^self isLinux or: [self isDarwin]
%

category: 'Testing'
method: GsTestCase
isLinuxOrDarwinOrAix

  ^self isLinuxOrDarwin or: [self isAix]
%

category: 'Testing'
method: GsTestCase
isLinuxOrSolaris
  ^self class isLinuxOrSolaris
%

category: 'Testing'
method: GsTestCase
isSolaris
  ^ self class isSolaris
%

category: 'Testing'
method: GsTestCase
isSolo
  ^GsSession isSolo
%

category: 'Testing'
method: GsTestCase
isSparcSolaris
  ^ self class isSparcSolaris
%

category: 'Testing'
method: GsTestCase
isUbuntuLinux
  ^ self class isUbuntuLinux
%

category: 'Testing'
method: GsTestCase
isValidException: expClass

	expClass _isArray
		ifTrue: [
			(expClass includesIdentical: AbstractException)
				ifTrue: ["error in test code"
					self assert: false
						description:'expected classes must not include AbstractException']]
		ifFalse: [
			self assert: expClass ~~ AbstractException
				description:'expected class must not == AbstractException'
	].
	^true
%

category: 'Testing'
method: GsTestCase
isWindows

	^self class isWindows
%

category: 'Miscellaneous'
method: GsTestCase
loadAverageString
  | str idx |
  str := System performOnServer:'uptime' .
  idx := str findString: 'load average' startingAt: 1 .
  idx ~~ 0 ifTrue:[
    idx > 1 ifTrue:[
      str at: idx-1 put: $[ ; at: str size put: $] .
      idx := idx-1
    ].
    ^ str copyFrom: idx to: str size .
  ].
  ^ 'load average not available'
%

category: 'Logging'
method: GsTestCase
log: aString

GsTestCase log: aString
%

category: 'Logging'
method: GsTestCase
logCr: aString

GsTestCase logCr: aString
%

category: 'Logging'
method: GsTestCase
logFailure: aString

 self logCr:' ' , Time now asStringMs , ' FAILURE: ', aString  .
 GsTestCase isDebug ifFalse:[
   self logCr:'------------------------------(' ;
   logCr: (GsProcess stackReportToLevel:300) ;
"   logCr: (GsProcess _fullStackReport ) ;  "   "uncomment this to get more output in SUnit.log "
   logCr:'  ------------------------------)' .
 ].
 "uncomment for attach with DEBUGGEM"
 "GsFile gciLogServer:'WAITING for topaz to attach'.
  [ true ] whileTrue:[ Delay waitForSeconds: 1 ].
 "
%

category: 'Logging'
method: GsTestCase
logLoadAverage
  self logCr:' ' , self loadAverageString , ' ' .
%

category: 'Running'
method: GsTestCase
nilTestCaseInstanceVariables
  "nil out instance variables of the test case AFTER tearDown has been called. Since all test cases
   are kept around by the testSuite, we need to clear out any objects that may be referenced by the
   test cases themselves to avoid blowing out temp obj memory while running ernie0."

  "skip #testSelector in slot 1"
  2 to: self class allInstVarNames size do: [:ivIndex |
    self instVarAt: ivIndex put: nil ]
%

category: 'Debugging'
method: GsTestCase
pauseForDebug
  self class pauseForDebug
%

category: 'Running'
method: GsTestCase
performTest

	self shouldRepeatIfInterruptedByGC ifTrue: [
		self repeatIfInterruptedByGC: [super performTest].
	] ifFalse: [
		super performTest.
	].
%

category: 'Printing'
method: GsTestCase
printOn: aStream

	aStream
		nextPutAll: self class printString;
		nextPutAll: ' debug: #';
		nextPutAll: (testSelector isNil ifTrue: ['??'] ifFalse: [testSelector]).

%

category: 'Miscellaneous'
method: GsTestCase
random

	^ SessionTemps current at:#Random ifAbsentPut: [Random new].
%

category: 'Miscellaneous'
method: GsTestCase
removeUserId: userId
	| user |

	(user := AllUsers userWithId: userId ifAbsent: [nil]) == nil
		ifFalse: [AllUsers removeAndCleanup: user].
%

category: 'Miscellaneous'
method: GsTestCase
removeUserIds: userIds

	userIds do: [:userId | self removeUserId: userId].
%

category: 'Miscellaneous'
method: GsTestCase
repeatIfInterruptedByGC: aBlock

	| oldScavenge oldMarkSweep newScavenge newMarkSweep |
	10 timesRepeat: [
		oldScavenge := System myCacheStatisticWithName: 'ScavengeCount'.
		oldMarkSweep := System myCacheStatisticWithName: 'MarkSweepCount'.
		aBlock value.
		newScavenge := System myCacheStatisticWithName: 'ScavengeCount'.
		newMarkSweep := System myCacheStatisticWithName: 'MarkSweepCount'.
		(oldScavenge = newScavenge and: [oldMarkSweep = newMarkSweep]) ifTrue: [^self].
		System  _generationScavenge_vmMarkSweep .
	].
	self error: 'Block could not be performed without being interrupted by GC'.
%

category: 'Miscellaneous'
method: GsTestCase
resultDirectory
  ^ (System clientEnvironmentVariable: 'resultdir') ifNil:[
      (System gemEnvironmentVariable: 'resultdir') ifNil:[
         "assume interactive debugging"
         GsFile serverCurrentDirectory
   ]].
%

category: 'Running'
method: GsTestCase
run
        | result |
        result := GsTestResult new.
        self run: result.
        ^result
%

category: 'Running'
method: GsTestCase
runCase
	| msg pagesBefore pagesAfter cpuTime elapsedTime time cnt cntStr isRO |
	pagesBefore := System pageReads + System pageWrites.
	msg := Time now asStringMs .
	msg add: $   ;
		addAll: self printString;
		addAll:' - start...' .
	GsTestCase log: msg.
  [
	  elapsedTime := Time millisecondsElapsedTime: [
		  cpuTime := System millisecondsToRun: [
			[ super runCase ] ensure: [ self nilTestCaseInstanceVariables ] ].
	  ].
  ] on: Notification do:[:ex |
    ex class defaultHandlers size > 0 ifTrue:[ ex pass ].
    Error signal: ex asString
  ].
  cntStr := String new .
  (isRO := GsSession isSolo) ifFalse:[
	  cnt := System persistentCounterAt: 25 incrementBy: 1 .
	  cntStr add: $Z ; addAll: cnt asString .
  ].
	pagesAfter := System pageReads + System pageWrites.
	time := 0 == elapsedTime
		ifTrue: [100]
		ifFalse: [cpuTime * 100s1 / elapsedTime].
	(msg := String new)
		add: 'pass; ';
		add: (pagesAfter - pagesBefore) printString;
		add: ' page(s); ';
		add: 'CPU=';
		add: time printString;
		add: '%; ';
		add: elapsedTime printString;
		add: ' ms. ' .
  isRO ifFalse:[ msg add: ' tranlogMark ' ; add: cntStr  ].
	GsTestCase logCr: msg.
  isRO ifFalse:[ System _markTranlogWith: cntStr ].
%

category: 'Miscellaneous'
method: GsTestCase
sessions
  | tmps |
  ^ (tmps := SessionTemps current) at:#GsTestCase_sessions ifAbsent:[
    ^ tmps at: #GsTestCase_sessions put: { } .
  ]
%

category: 'Miscellaneous'
method: GsTestCase
setAbortTimeout: sigAbTime
  sigAbTime ~~ 60 ifTrue:[ | systemUser timeStr |
    timeStr := sigAbTime asString .
    (System stoneConfigurationAt: #StnGemAbortTimeoutSeconds) = sigAbTime ifFalse:[
      (systemUser := GsExternalSession newDefault) username: 'SystemUser'; login .
       systemUser executeString:
  'System stoneConfigurationAt: #StnGemAbortTimeoutSeconds put: ', timeStr, ' .
   System stoneConfigurationAt: #StnGemLostOtTimeout put: ', timeStr, '.' .
       systemUser logout .
      self assert: (System stoneConfigurationAt: #StnGemAbortTimeoutSeconds) equals: sigAbTime .
      self assert: (System stoneConfigurationAt: #StnGemLostOtTimeout) equals: sigAbTime .
    ].
  ]
%

category: 'Setup and Tear Down'
method: GsTestCase
setUp
  super setUp.
  SessionTemps current at:#GsTestCase_sessions put: { }
%

category: 'Testing Exceptions'
method: GsTestCase
should: aBlock
  "reimplement to catch any unexpected exceptions"
  [
    self assert: aBlock value
  ] onException: AbstractException do:[:ex |
    self assert: false description: 'unexpected exception'
  ]
%

category: 'Testing Exceptions'
method: GsTestCase
should: aBlock raise: anObject

 ^ self should: aBlock raise: anObject description:''
%

category: 'Testing Exceptions'
method: GsTestCase
should: aBlock raise: anObject description: descString

	| expectedErrorNumber expClass |

	anObject _isInteger
		ifTrue: [	expectedErrorNumber := anObject]
		ifFalse: [
			anObject _isSymbol
				ifTrue: [expectedErrorNumber := ErrorSymbols at: anObject]
				ifFalse: [
					^(anObject isBehavior and: [anObject isSubclassOf: AbstractException])
						ifTrue: [self should: aBlock raiseClasses: anObject numbers: #() description: descString]
						ifFalse: [super should: aBlock raise: anObject]
			]
	].

	(expClass := Exception legacyNumberToClasses: expectedErrorNumber) ifNil:[
		^self assert: false description: 'invalid error number'
	].
	self
		should: aBlock
		raiseClasses: expClass
		numbers: (Array with: expectedErrorNumber)
		description: descString
%

category: 'Testing Exceptions'
method: GsTestCase
should: aBlock raiseClasses: expClass numbers: expectedErrorNumbers description: descString
  "expClass is either a Class or an Array of Classes."

	| saveEx success exString actualErrorNumber |
	saveEx := nil . "force method temps here for debugging"
	actualErrorNumber := nil .
	exString := ' no exception raised ' .
	success := false .

	self isValidException: expClass.
	[
	  aBlock onException: expClass do: [:ex |
		saveEx := ex . "for debugging"
		actualErrorNumber := ex number.
		exString := ex description , ' (' , actualErrorNumber printString , ')'.
		success := true
			or: [expectedErrorNumbers isEmpty
			or: [expectedErrorNumbers includes: actualErrorNumber]]].
	] onException: AbstractException do: [:ex |
		saveEx := ex .
		actualErrorNumber := ex number.
		exString := ex description , ' (' , actualErrorNumber printString , ')'.
		[
			(GsCurrentSession currentSession resolveSymbol:#GciError)  ifNotNil: [ :assoc |
				ex class == assoc _value
					ifTrue:[
						success
							ifFalse: [success := ex matchesClasses: expClass].
				]
			]
		] onSynchronous: AbstractException do: [:exb |  exb return "ignore"].

		"do the assert inside handler, so original signal  point still on the stack!"
		self
			assert: success
			description: 'Expected ', expClass printString ,
				' (' , expectedErrorNumbers printString , ') ' ,
				descString , ', GOT ' , exString.
		^self "if execution continued..."
	].
	self
		assert: success
		description: 'Expected ', expClass printString ,
			' (' , expectedErrorNumbers printString , ') ' ,
			descString , ', GOT ' , exString.
%

category: 'Testing Exceptions'
method: GsTestCase
should: aBlock raiseOneOf: anArray

  "anArray should be an Array of Integers or error symbols or exception classes "
  | expClasses expNumbers |
  expClasses := { } .
  expNumbers := { } .
  anArray do:[:elem | | errNum aClass |
     elem _isSymbol ifTrue:[
       errNum := ErrorSymbols at: elem
     ] ifFalse:[
       elem _isInteger ifTrue:[
         errNum := elem .
         expNumbers add: errNum .
       ] ifFalse:[
         (elem isBehavior and:[ elem isSubclassOf: Exception]) ifTrue:[
            aClass := elem
         ] ifFalse:[
            ^ self assert: false description: 'invalid element in arg raiseOneOf:'
     ]]].
     aClass ifNil:[ (aClass := Exception legacyNumberToClasses: errNum) ifNil:[
       ^ self assert: false description: 'invalid error number'
     ]].
     aClass _isArray ifTrue:[ expClasses addAll: aClass ]
       ifFalse:[ expClasses add: aClass ].
  ].
  self should: aBlock raiseClasses: expClasses numbers: expNumbers description: ''
%

category: 'Testing Exceptions'
method: GsTestCase
shouldRepeatIfInterruptedByGC

	^false.
%

category: 'Accessing'
method: GsTestCase
signalFailure: aString
        GsTestResult failure sunitSignalWith: aString
%

category: 'Miscellaneous'
method: GsTestCase
smFloatLiteralClass
^ 1.0 class .

%

category: 'Miscellaneous'
method: GsTestCase
smFloatResultClass
^ (1.0 + 1.0) class
%

category: 'Setup and Tear Down'
method: GsTestCase
tearDown
  | sessions tm nSess cnt |
  sessions := SessionTemps current removeKey: #GsTestCase_sessions ifAbsent:[ #() ].
  (nSess := sessions size) > 0 ifTrue:[
    1 to: nSess do:[:j | | sess |
      (sess := sessions at: j ) ifNotNil:[
        sess isLoggedIn ifFalse:[ sess := nil ].
        sess ifNotNil:[
          [
            sess isCallInProgress ifTrue:[ sess forceLogout .
              GsFile gciLogServer: 'sess ' , sess asOop asString, ' forced logout' .
                                        sess := nil
            ] ifFalse:[
             GsFile gciLogServer: 'sess ' , sess asOop asString, ' nbLogout ' .
             sess nbLogout
            ].
          ] on: self gciErrorClass do:[:ex |
             ex originalNumber == 4100 ifTrue:["ignore invalid session"]
                                       ifFalse:[ ex pass ]
          ].
        ].
      ].
      sessions at: j put: sess.
    ].
    sessions do:[:aSess | aSess ifNotNil:[ aSess _waitForLogout ]].
    tm := Time now .
    "allow for one other session owned by a TestResource."
    [ (cnt := System currentUserSessionCount) > 2 ] whileTrue:[
      Delay waitForMilliseconds:50 .
      (Time now subtractTime: tm ) asMilliseconds > 8000 ifTrue:[
         self log: '(--', System currentSessionsReport , '--)'.
         Error signal:'sessions not logged out'
      ].
    ]
  ].
  super tearDown.
%

category: 'Miscellaneous'
method: GsTestCase
untrappableError

" Send this message for debugging the test framework,
  so you can get a stack with no trapping of the error by the test framework.
  Error 6004 (HardBreak) is not trappable by Smalltalk code ."

System signal:6004 args:#() signalDictionary:GemStoneError
%

! Class implementation for 'GsTestResult'

!		Class methods for 'GsTestResult'

category: 'Excluding'
classmethod: GsTestResult
excludeInSoloSession: aTestCase

"Overwritten by Ernie"

^ false
%

category: 'Accessing'
classmethod: GsTestResult
failureLogFile
  ^ SessionTemps current at: #GsTestResultFailuresLog ifAbsentPut:[ | f |
     f := GsFile openAppendOnServer:'SUnitFailures.log' .
     f ifNil:[ Error signal:'open failed', GsFile serverErrorString ].
     f
  ]
%

!		Instance methods for 'GsTestResult'

category: 'Adding'
method: GsTestResult
addError: aTestCase
  "nil pause . ""uncomment to debug test framework"
  self logFailure: aTestCase .
  super addError: aTestCase printString  "don't keep aTestCase alive in memory"
%

category: 'Adding'
method: GsTestResult
addFailure: aTestCase
  "nil pause . ""uncomment to debug test framework"
  self logFailure: aTestCase .
  super addFailure: aTestCase printString  "don't keep aTestCase alive in memory"
%

category: 'Adding'
method: GsTestResult
addPass: aTestCase
  ^self passed add: aTestCase printString  "don't keep aTestCase alive in memory"
%

category: 'Accessing'
method: GsTestResult
defects
 ^ self failures
%

category: 'Accessing'
method: GsTestResult
errors
  "One list in order of occurrance"
  ^ self failures
%

category: 'Accessing'
method: GsTestResult
failures
   failures ifNil: [failures := NonPersistentArray new ].
   ^failures
%

category: 'Logging'
method: GsTestResult
logFailure: aTestCase
 (System gemEnvironmentVariable: 'resultdir') ifNotNil:[:path |  | idx dir str ver |
    self class failureLogFile ifNotNil:[ :f |
      idx := path indexOfLastByte: $/ codePoint startingAt: path size .
      dir := path copyFrom: idx + 1 to: path size .
      ver := System _gemVersion .
      idx := ver indexOf: $, startingAt: 1 .
      ver := ver copyFrom: 1 to: idx - 1 .
      str := ver,', ', System hostname, ', ', dir , ', ', aTestCase printString .
      f nextPutAll: str lf ; flush .
    ].
 ] ifNil:[ "assume interactive, don't log" ].
%

category: 'Accessing'
method: GsTestResult
passed
   passed ifNil: [passed := NonPersistentArray new ].
   ^ passed
%

category: 'Running'
method: GsTestResult
runCase: aTestCase
" | debugBlk |
uncomment and enable to get an SUnit.log file of send...debug: of all the test cases"
" (SessionTemps current at: #Ernie_collectCases otherwise: nil) ifNotNil:[
   GsTestCase logCr: aTestCase class name , ' debug: ', aTestCase selector printString.
   ^ self
 ]."
" debugBlk := [ :ex |
   (SessionTemps current at: #Ernie_debugIgnoreErrNum otherwise: nil) ifNotNil:[:n |
     ex gsNumber == n ifFalse:[ nil pause ].
   ].
 ]. "
 (self class excludeInSoloSession: aTestCase) ifTrue:[
   GsTestCase logCr: aTestCase printString , ' -  Excluding in Solo session'.
   ^ self .
 ].
 [
   [  aTestCase runCase.
      self passed add: aTestCase.
   ] on: self class failure do: [:ex |
     "debugBlk value: ex . "
     self addFailure: aTestCase.
     GsTestCase logCr: 'fail - ' , ex description asString.
     self
   ].
 ] on: (Error, Notification) do: [:ex |
   ex class defaultHandlers size > 0 ifTrue:[ ex pass ].
		"debugBlk value: ex  ."
		self addError: aTestCase.
		GsTestCase logCr: 'error - ' , ex description asString .
	  GsTestCase isDebug ifFalse:[
           GsTestCase logCr:'------------------------------(
' , (GsProcess stackReportToLevel:300) , '
------------------------------)'.
   ].
   self
 ].
%

! Class implementation for 'GsTestSuite'

!		Class methods for 'GsTestSuite'

category: 'Accessing'
classmethod: GsTestSuite
firstElementOfNRS

  | firstElement dbfNRS |

  firstElement := SystemRepository fileNames at: 1.
  dbfNRS := (firstElement isKindOf: Array)
    ifTrue:  [ firstElement first ] "32-bit has an array of arrays of { extent, replicate}"
    ifFalse: [ firstElement].       "64-bit has an array of strings"
  ^ dbfNRS
%

category: 'Accessing'
classmethod: GsTestSuite
logFilePath

  | path |
  path := './SUnit.log'.
  ^ path .
%

!		Instance methods for 'GsTestSuite'

category: 'Adding'
method: GsTestSuite
addAllTestsTo: aList

	tests do: [:each |
		each addAllTestsTo: aList.
	].
%

category: 'Accessing'
method: GsTestSuite
allTests

	| list |
	list := OrderedCollection new.
	self addAllTestsTo: list.
	^list.
%

category: 'Debugging'
method: GsTestSuite
asDebugString
^ self _asExecString: ' debug: '
%

category: 'Debugging'
method: GsTestSuite
asRunString
^ self _asExecString: ' run: '
%

category: 'Accessing'
method: GsTestSuite
errorIfDefects

        | result list |
        result := self run.
        (list := result defects) notEmpty ifTrue: [list error: 'Found ' , list size printString , ' defects'].
        ^true.
%

category: 'Running'
method: GsTestSuite
run
  | result |
  result := GsTestResult new.
  GsTestCase openSunitLog: #filesystem .
  [self run: result] sunitEnsure: [self resources do: [:each | each reset]].
  GsTestCase flushLog .
  ^result
%

category: 'Running'
method: GsTestSuite
run: aResult

  self tests do: [:each |  "each may be either a TestSuite or a TestCase"
    self sunitChanged: each.
    each run: aResult
  ]
%

category: 'Debugging'
method: GsTestSuite
_asExecString: runStr
  | str lf |
  str := String new . lf := Character lf .
  str addAll:'run'; add: lf  .
  self tests do: [:each |
    str addAll: each class name ; addAll: runStr ;
      addAll: ' #'; addAll: each selector ; addAll: ' .'; add: lf
  ].
  str add: $% ; add: lf .
  ^ str
%

! Class extensions for 'AbstractBagEnumerator'

!		Instance methods for 'AbstractBagEnumerator'

category: 'accessing'
method: AbstractBagEnumerator
doBlock: aBlock
  doBlock := aBlock
%

category: 'accessing'
method: AbstractBagEnumerator
evaluator: anEvaluator
  evaluator := anEvaluator.
  bag := evaluator nsc _asIdentityBag
%

category: 'querying'
method: AbstractBagEnumerator
findAllValuesFor: aValue
  ^ self findAllValuesFor: aValue and: nil
%

category: 'querying'
method: AbstractBagEnumerator
findAllValuesFor: aValue1 and: aValue2
  | theBlock tmpHolder result |
  theBlock := doBlock.
  theBlock
    ifNil: [
      tmpHolder := evaluator tmpHolder.
      theBlock := [ :each | tmpHolder add: each ] ].
  result := evaluator isIndexOnRootNsc
    ifTrue: [ self _findRootValues: aValue1 and: aValue2 do: theBlock ]
    ifFalse: [
      evaluator isCollectionBased
        ifTrue: [ self _findTraversedCollectionBasedValues: aValue1 and: aValue2 do: theBlock ]
        ifFalse: [
          self _createIvOffsetCache.
          self _findTraversedValues: aValue1 and: aValue2 do: theBlock ] ].
  ^ doBlock ifNil: [ tmpHolder completeBag ] ifNotNil: [ result ]
%

category: 'accessing'
method: AbstractBagEnumerator
selector: aSelector
  selector := aSelector
%

category: 'traversing'
method: AbstractBagEnumerator
traversePathFor: anObject endObjDo: aBlock
  | endObj |
  self _createIvOffsetCache.
  endObj := self _traversePathForObject: anObject.
  endObj ~~ #'_incompletePathTraversal'
    ifTrue: [ aBlock value: endObj ]
%

category: 'testing'
method: AbstractBagEnumerator
value: aValue and: ignored test: endObj
  ^ endObj perform: selector with: aValue
%

category: 'private'
method: AbstractBagEnumerator
_createIvOffsetCache
  self _createIvOffsetCacheFor: evaluator
%

category: 'private'
method: AbstractBagEnumerator
_createIvOffsetCacheFor: anEvaluator
  | cache |
  cache := anEvaluator _createIvOffsetCache.
  ivOffsetCache1 := cache at: 1.
  ivOffsetCache2 := cache at: 2
%

category: 'private'
method: AbstractBagEnumerator
_findNonNilRootValues: aValue1 and: aValue2 do: aBlock
  1 to: bag size do: [ :i |
    | obj |
    (obj := bag _at: i) ~~ nil
      ifTrue: [
        (self value: aValue1 and: aValue2 test: obj)
          ifTrue: [ aBlock value: obj ] ] ]
%

category: 'private'
method: AbstractBagEnumerator
_findRootValues: aValue1 and: aValue2 do: aBlock
  1 to: bag size do: [ :i |
    | obj |
    obj := bag _at: i.
    (self value: aValue1 and: aValue2 test: obj)
      ifTrue: [ aBlock value: obj ] ]
%

category: 'private'
method: AbstractBagEnumerator
_findTraversedCollectionBasedValues: aValue1 and: aValue2 do: aBlock
  | obj |
  1 to: bag size do: [ :i |
    (obj := bag _at: i) ~~ nil
      ifTrue: [
        evaluator
          traverse: obj
          do: [ :endObj |
            (self value: aValue1 and: aValue2 test: endObj)
              ifTrue: [ aBlock value: obj ] ] ] ]
%

category: 'private'
method: AbstractBagEnumerator
_findTraversedValues: aValue1 and: aValue2 do: aBlock
  "This method assumes that the evaluator is not over a collection-based instance variable."

  1 to: bag size do: [ :i |
    | obj |
    (obj := bag _at: i) ~~ nil
      ifTrue: [
        | endObj |
        endObj := evaluator
          _traverse: obj
          cachedOffsets: ivOffsetCache2
          cachedClasses: ivOffsetCache1
          incomplete: #'_incompletePathTraversal'.
        endObj ~~ #'_incompletePathTraversal'
          ifTrue: [
            (self value: aValue1 and: aValue2 test: endObj)
              ifTrue: [ aBlock value: obj ] ] ] ]
%

category: 'private'
method: AbstractBagEnumerator
_traversePathForObject: obj
  "This method assumes that the evaluator is not over a collection-based instance variable."

  ^ evaluator
    _traverse: obj
    cachedOffsets: ivOffsetCache2
    cachedClasses: ivOffsetCache1
    incomplete: #'_incompletePathTraversal'
%

! Class extensions for 'AbstractDictionary'

!		Instance methods for 'AbstractDictionary'

category: 'Repository Conversion'
method: AbstractDictionary
fixRefsAfterConversion 

"Default Dictionary method for fixing references to
 ObsLargePositiveInteger and ObsLargeNegativeInteger
 instances that can now be represented as a
 SmallInteger and Floats and SmallFloats which can now be represented as
 a SmallDouble."

| array convBm |

convBm := (GsBitmap newForHiddenSet: #Conversion).
(convBm includes: self) 
        ifTrue:[^false]. "already fixed this one"

"Fix inst var refs first"
self fixInstVarRefsAfterConversion.

"now handle keys and values"
array := { } .
self keysAndValuesDo:[:k :v|
        (k needsFixingAfterConversion or:[v needsFixingAfterConversion])
                ifTrue:[array add: k; add: v.].
        ].
1 to: array size by: 2 do:[:n| |k v newKey newValue|
        k := array at: n.
        v := array at: (n + 1).
        self removeKey: k.
        k needsFixingAfterConversion
                ifTrue:[newKey := k + 0]
                ifFalse:[newKey := k].
        v needsFixingAfterConversion
                ifTrue:[newValue := v + 0]
                ifFalse:[newValue := v].
        self at: newKey put: newValue.
].
convBm add: self.
^true
%

category: 'Object Canonicalization'
method: AbstractDictionary
_canonicalizeReferencesUsingPolicy: aReferencingObjectPolicy

	^aReferencingObjectPolicy canonicalizeReferencesInDictionary: self
%

! Class extensions for 'AbstractIndexSpecification'

!		Class methods for 'AbstractIndexSpecification'

category: 'instance creation'
classmethod: AbstractIndexSpecification
path: aString lastElementClass: aClass

	^(self new)
		path: aString;
		lastElementClass: aClass;
		yourself
%

!		Instance methods for 'AbstractIndexSpecification'

category: 'accessing'
method: AbstractIndexSpecification
collator
  "No collator associate with non-Unicode indexes"

  ^ nil
%

category: 'accessing'
method: AbstractIndexSpecification
createIndexOn: anNsc
  IndexManager current createIndexFor: anNsc fromSpec: self
%

category: 'accessing'
method: AbstractIndexSpecification
defaultEnumeratedPathTermClass
  ^ self legacyIndex
    ifTrue: [ EnumeratedPathTerm ]
    ifFalse: [ GsEnumeratedPathTerm ]
%

category: 'accessing'
method: AbstractIndexSpecification
defaultPathTermClass
  ^ self requirePathTerms
    ifTrue: [ self legacyIndex
        ifTrue: [ PathTerm ]
        ifFalse: [ GsPathTerm ] ]
    ifFalse: [ self legacyIndex
        ifTrue: [ OptionalPathTerm ]
        ifFalse: [ GsOptionalPathTerm ] ]
%

category: 'accessing'
method: AbstractIndexSpecification
defaultSelectorPathTermClass
  ^ self legacyIndex
    ifTrue: [ SelectorPathTerm ]
    ifFalse: [ GsSelectorPathTerm ]
%

category: 'accessing'
method: AbstractIndexSpecification
defaultSetValuedPathTermClass
  ^ self legacyIndex
    ifTrue: [ SetValuedPathTerm ]
    ifFalse: [ GsSetValuedPathTerm ]
%

category: 'accessing'
method: AbstractIndexSpecification
indexType

	^ self subclassResponsibility: #indexType
%

category: 'accessing'
method: AbstractIndexSpecification
indexTypePrintString
  self subclassResponsibility: #'indexTypePrintString'
%

category: 'testing'
method: AbstractIndexSpecification
isIndexedOn: anNsc
  ^ (anNsc _findIndexesWithPath: self path asArrayOfPathTerms) isEmpty not
%

category: 'accessing'
method: AbstractIndexSpecification
lastElementClass

	^lastElementClass
%

category: 'accessing'
method: AbstractIndexSpecification
lastElementClass: aClass

	lastElementClass := aClass
%

category: 'accessing'
method: AbstractIndexSpecification
legacyIndex
  | val |
  val := self dynamicInstVarAt: #'legacyIndex'.
  ^ val ifNil: [ true ]
%

category: 'accessing'
method: AbstractIndexSpecification
legacyIndex: aBool
  self dynamicInstVarAt: #'legacyIndex' put: aBool
%

category: 'accessing'
method: AbstractIndexSpecification
optimizedComparison
  | val |
  val := self dynamicInstVarAt: #'optimizedComparison'.
  ^ val ifNil: [ false ]
%

category: 'accessing'
method: AbstractIndexSpecification
optimizedComparison: aBool
  self dynamicInstVarAt: #'optimizedComparison' put: aBool
%

category: 'accessing'
method: AbstractIndexSpecification
optionalPathTerms
  ^ self requirePathTerms not
%

category: 'accessing'
method: AbstractIndexSpecification
optionalPathTerms: aBool
  self requirePathTerms: aBool not
%

category: 'accessing'
method: AbstractIndexSpecification
options
  | options |
  options := GsIndexOptions basicNew.
  self reducedConflict
    ifTrue: [ options setReducedConflict ]
    ifFalse: [ options clearReducedConflict ].
  self optionalPathTerms
    ifTrue: [ options setOptionalPathTerms ]
    ifFalse: [ options clearOptionalPathTerms ].
  self legacyIndex
    ifTrue: [
      options setLegacyIndex.
      options clearBtreePlusIndex.
      options clearOptimizedComparison "by definition" ]
    ifFalse: [
      options setBtreePlusIndex.
      options clearLegacyIndex.
      "optimized comparisons only apply to btreePlus index"
      self optimizedComparison
        ifTrue: [ options setOptimizedComparison ]
        ifFalse: [ options clearOptimizedComparison ] ].
  ^ options
%

category: 'accessing'
method: AbstractIndexSpecification
options: aGsIndexOptions
  self optionalPathTerms: aGsIndexOptions optionalPathTerms.
  self reducedConflict: aGsIndexOptions reducedConflict.
  self legacyIndex: aGsIndexOptions legacyIndex.
  self optimizedComparison: aGsIndexOptions optimizedComparison
%

category: 'accessing'
method: AbstractIndexSpecification
path

	^path
%

category: 'accessing'
method: AbstractIndexSpecification
path: aString

	path := aString
%

category: 'printing'
method: AbstractIndexSpecification
printOptionsSelectorOn: aStream
  aStream
    lf;
    tab;
    tab;
    nextPutAll: 'options: '.
  self options printOn: aStream
%

category: 'printing'
method: AbstractIndexSpecification
printSelectorOn: aStream

  aStream nextPutAll: self indexTypePrintString.
  self path isEmpty
    ifTrue: [ aStream nextPutAll: ': ''''' ]
    ifFalse: [ aStream nextPutAll: ': ''each.' , self path , '''' ].
  self lastElementClass ifNotNil: [ :cls | aStream
        lf;
        tab;
        tab;
        nextPutAll: 'lastElementClass: ' , cls name asString ].
  self collator ifNotNil: [ :icuColl | aStream
        lf;
        tab;
        tab;
        nextPutAll:
            'collator: (IcuCollator forLocaleNamed: ' , icuColl locale name printString
                , ')' ].
  self printOptionsSelectorOn: aStream
%

category: 'accessing'
method: AbstractIndexSpecification
reducedConflict
  | val |
  val := self dynamicInstVarAt: #'reducedConflict'.
  ^ val ifNil: [ false ]
%

category: 'accessing'
method: AbstractIndexSpecification
reducedConflict: aBool
  self dynamicInstVarAt: #'reducedConflict' put: aBool
%

category: 'accessing'
method: AbstractIndexSpecification
removeIndexFrom: anNsc
  (self isIndexedOn: anNsc)
    ifTrue: [ anNsc removeEqualityIndexOn: self path ]
%

category: 'accessing'
method: AbstractIndexSpecification
requirePathTerms
  requirePathTerms ifNil: [ requirePathTerms := true ].
  ^ requirePathTerms
%

category: 'accessing'
method: AbstractIndexSpecification
requirePathTerms: aBool
  requirePathTerms := aBool
%

category: 'accessing'
method: AbstractIndexSpecification
_createIndex
  self subclassResponsibility: #'_createIndex'
%

category: 'private'
method: AbstractIndexSpecification
_validateLastElementClassOn: anNsc
  "noop"


%

category: 'private'
method: AbstractIndexSpecification
_validatePathOn: anNsc
  anNsc _checkIndexPathExpression: self path
%

category: 'private'
method: AbstractIndexSpecification
_validateSpecificationOn: anNsc
  self _validateLastElementClassOn: anNsc.
  self _validatePathOn: anNsc
%

! Class extensions for 'AbstractReferencingObjectPolicy'

!		Class methods for 'AbstractReferencingObjectPolicy'

category: 'Instance Creation'
classmethod: AbstractReferencingObjectPolicy
new

	self error: 'Use #newForManager:'.
%

category: 'Instance Creation'
classmethod: AbstractReferencingObjectPolicy
newForManager: aManager

	^self basicNew
		initialize: aManager;
		yourself.
%

!		Instance methods for 'AbstractReferencingObjectPolicy'

category: 'Subclass Responsibilities'
method: AbstractReferencingObjectPolicy
canonicalizeReferencesIn: aReferencingObject

	self subclassResponsibility: #'canonicalizeReferencesIn:'.
%

category: 'Initialization'
method: AbstractReferencingObjectPolicy
initialize: aManager

	manager := aManager.
	self objectSecurityPolicy: aManager objectSecurityPolicy.
%

! Class extensions for 'Array'

!		Instance methods for 'Array'

category: 'Index Query Support'
method: Array
buildGsQueryParserNodeFor: aGsQueryParser
  | receiverNode messages |
  receiverNode := self at: 1.
  messages := self at: 2.
  aGsQueryParser build: receiverNode messages: messages
%

category: 'Private'
method: Array
_buildWeakRefSet

"Adds the receiver to the weakRefObjs hiddenSet."

(GsBitmap newForHiddenSet: #WeakReferences) add: self.
^self
%

category: 'Object Canonicalization'
method: Array
_canonicalizeReferencesUsingPolicy: aReferencingObjectPolicy

	^aReferencingObjectPolicy canonicalizeReferencesInObject: self
%

category: 'Testing'
method: Array
_literalEqual: anotherLiteral
  "For two literals to be _literalEqual, their class must be identical and
   otherwise equal"

  self class == anotherLiteral class
    ifFalse: [ ^ false ].
  self size == anotherLiteral size
    ifFalse: [ ^ false ].
  self
    with: anotherLiteral
    do: [ :e1 :e2 |
      (e1 _literalEqual: e2)
        ifFalse: [ ^ false ] ].
  ^ true
%

category: 'Testing'
method: Array
_refersToLiteral: literal
  "Answer true if literal is identical to any literal in receiver, even if imbedded
   in further structures."
  1 to: self size do: [ :index |
    | lit |
    (literal _literalEqual: (lit := self at: index))
      ifTrue: [ ^ true ].
    (lit _refersToLiteral: literal)
      ifTrue: [ ^ true ] ].
  ^ false
%

category: 'Testing'
method: Array
_refersToNonSymbolLiteral: argLiteral
  "Answer true if literal is equivalent to any non-symbol element of receiver.
   Used by ClassOrganizer.
   If literal is a SymbolAssociation, the value of literal is used.
   If literal is an Array,  elements of literal are searched ."
  | argVal argInvariant argKey aLit mySize |
  mySize := self size .
  mySize > 0 ifTrue:[
    argInvariant := false .
    (argLiteral isKindOfClass: SymbolAssociation) ifTrue:[
      argKey := argLiteral key .
      argVal := argLiteral _value .
    ].
    1 to: mySize do: [ :index |
      (aLit := self at: index ) _isSymbol ifFalse:[
        (aLit _literalEqual: argLiteral ) ifTrue: [ ^ true ].
        argVal ifNotNil:[ (aLit _literalEqual: argVal) ifTrue:[ ^ true ]].
        aLit _isArray ifTrue:[
          (aLit _refersToNonSymbolLiteral: argLiteral) ifTrue: [ ^ true ]
        ] ifFalse:[
          (aLit isKindOfClass: SymbolAssociation) ifTrue:[ | v |
             v := aLit _value .
             argVal ifNotNil:[ v == argVal ifTrue:[ ^ true]]
                    ifNil:[ v == argLiteral ifTrue:[ ^ true ]].
          ]
        ]
      ]
    ].
  ].
  ^ false
%

! Class extensions for 'BagEnumerator'

!		Instance methods for 'BagEnumerator'

category: 'accessing'
method: BagEnumerator
compareEqual
  selector := #'_idxForCompareEqualTo:'
%

category: 'accessing'
method: BagEnumerator
compareGreaterThan
  selector := #'_idxForCompareGreaterThan:'
%

category: 'accessing'
method: BagEnumerator
compareGreaterThanOrEqual
  selector := #'_idxForCompareGreaterThanOrEqualTo:'
%

category: 'accessing'
method: BagEnumerator
compareIdentical
  selector := #'=='
%

category: 'accessing'
method: BagEnumerator
compareLessThan
  selector := #'_idxForCompareLessThan:'
%

category: 'accessing'
method: BagEnumerator
compareLessThanOrEqual
  selector := #'_idxForCompareLessThanOrEqualTo:'
%

category: 'accessing'
method: BagEnumerator
compareNotEqual
  selector := #'_idxForCompareNotEqualTo:'
%

category: 'accessing'
method: BagEnumerator
compareNotIdentical
  selector := #'~~'
%

! Class extensions for 'BagRangeEnumerator'

!		Instance methods for 'BagRangeEnumerator'

category: 'accessing'
method: BagRangeEnumerator
compareGreaterThanAndLessThan
  selector := #'_idxForCompareGreaterThan:'.
  selector2 := #'_idxForCompareLessThan:'
%

category: 'accessing'
method: BagRangeEnumerator
compareGreaterThanAndLessThanOrEqual
  selector := #'_idxForCompareGreaterThan:'.
  selector2 := #'_idxForCompareLessThanOrEqualTo:'
%

category: 'accessing'
method: BagRangeEnumerator
compareGreaterThanOrEqualAndLessThan
  selector := #'_idxForCompareGreaterThanOrEqualTo:'.
  selector2 := #'_idxForCompareLessThan:'
%

category: 'accessing'
method: BagRangeEnumerator
compareGreaterThanOrEqualAndLessThanOrEqual
  selector := #'_idxForCompareGreaterThanOrEqualTo:'.
  selector2 := #'_idxForCompareLessThanOrEqualTo:'
%

category: 'testing'
method: BagRangeEnumerator
value: aValue1 and: aValue2 test: endObj
  ^ (endObj perform: selector with: aValue1)
    and: [ endObj perform: selector2 with: aValue2 ]
%

! Class extensions for 'BagUnicodeEnumerator'

!		Instance methods for 'BagUnicodeEnumerator'

category: 'accessing'
method: BagUnicodeEnumerator
compareEqual
  selector := #'_idxForCompareEqualTo:collator:'
%

category: 'accessing'
method: BagUnicodeEnumerator
compareGreaterThan
  selector := #'_idxForCompareGreaterThan:collator:'
%

category: 'accessing'
method: BagUnicodeEnumerator
compareGreaterThanOrEqual
  selector := #'_idxForCompareGreaterThanOrEqualTo:collator:'
%

category: 'accessing'
method: BagUnicodeEnumerator
compareIdentical
  "use BagEnumerator for identity comparisons"

  self shouldNotImplement: #'compareIdentical'
%

category: 'accessing'
method: BagUnicodeEnumerator
compareLessThan
  selector := #'_idxForCompareLessThan:collator:'
%

category: 'accessing'
method: BagUnicodeEnumerator
compareLessThanOrEqual
  selector := #'_idxForCompareLessThanOrEqualTo:collator:'
%

category: 'accessing'
method: BagUnicodeEnumerator
compareNotEqual
  selector := #'_idxForCompareNotEqualTo:collator:'
%

category: 'accessing'
method: BagUnicodeEnumerator
compareNotIdentical
  "use BagEnumerator for identity comparisons"

  self shouldNotImplement: #'compareNotIdentical'
%

category: 'accessing'
method: BagUnicodeEnumerator
evaluator: anEvaluator
  super evaluator: anEvaluator.
  collator := anEvaluator collator
%

category: 'testing'
method: BagUnicodeEnumerator
value: aValue and: ignored test: endObj
  ^ endObj perform: selector with: aValue with: collator
%

! Class extensions for 'BagUnicodeRangeEnumerator'

!		Instance methods for 'BagUnicodeRangeEnumerator'

category: 'accessing'
method: BagUnicodeRangeEnumerator
compareGreaterThanAndLessThan
  selector := #'_idxForCompareGreaterThan:collator:'.
  selector2 := #'_idxForCompareLessThan:collator:'
%

category: 'accessing'
method: BagUnicodeRangeEnumerator
compareGreaterThanAndLessThanOrEqual
  selector := #'_idxForCompareGreaterThan:collator:'.
  selector2 := #'_idxForCompareLessThanOrEqualTo:collator:'
%

category: 'accessing'
method: BagUnicodeRangeEnumerator
compareGreaterThanOrEqualAndLessThan
  selector := #'_idxForCompareGreaterThanOrEqualTo:collator:'.
  selector2 := #'_idxForCompareLessThan:collator:'
%

category: 'accessing'
method: BagUnicodeRangeEnumerator
compareGreaterThanOrEqualAndLessThanOrEqual
  selector := #'_idxForCompareGreaterThanOrEqualTo:collator:'.
  selector2 := #'_idxForCompareLessThanOrEqualTo:collator:'
%

category: 'accessing'
method: BagUnicodeRangeEnumerator
evaluator: anEvaluator
  super evaluator: anEvaluator.
  collator := anEvaluator collator
%

category: 'testing'
method: BagUnicodeRangeEnumerator
value: aValue1 and: aValue2 test: endObj
  ^ (endObj perform: selector with: aValue1 with: collator)
    and: [ endObj perform: selector2 with: aValue2 with: collator ]
%

! Class extensions for 'BasicSortNode'

!		Class methods for 'BasicSortNode'

category: 'Constants'
classmethod: BasicSortNode
entrySize

"Returns the size of an entry (with 2 slots for encryption)."

^ 4
%

category: 'Constants'
classmethod: BasicSortNode
maxNumberOfElements

"Returns the number of entries that are allowed in a leaf node."

^ 500
%

category: 'Indexing Support'
classmethod: BasicSortNode
recalculateSelectionTree: sortNodeArray for: node offsets: offsets

"Recalculate the selection tree based on a change of the minimum entry
 in the given node."

<primitive: 211>
self _primitiveFailed: #recalculateSelectionTreeFor:offsets:
     args: { sortNodeArray . node . offsets }.
self _uncontinuableError
%

!		Instance methods for 'BasicSortNode'

category: 'Updating'
method: BasicSortNode
at: aKey put: aValue hasSecondarySort: hasSecondarySort

"Adds the key/value pair to the node.  Sender must verify that the node is not
 full."

^ self _at: aKey put: aValue forBtree: false hasSecondarySort: hasSecondarySort
%

category: 'Updating'
method: BasicSortNode
btreeAt: aKey put: aValue

"Adds the key/value pair to the node.  Sender must verify that the node is not
 full."

^ self _at: aKey put: aValue forBtree: true hasSecondarySort: false
%

category: 'Constants'
method: BasicSortNode
entrySize

"Returns the size of an entry (with 2 slots for encryption)."

^ 4
%

category: 'Testing'
method: BasicSortNode
isFull

"Returns if the node is full."

^ numElements == 500
%

category: 'Updating'
method: BasicSortNode
_at: aKey put: aValue forBtree: aBoolean hasSecondarySort: hasSecondarySort

"Adds the key/value pair to the node.  Sender must verify that the node is not
 full."

<primitive: 360>
self _primitiveFailed: #_at:put:forBtree:hasSecondarySort:
     args: { aKey . aValue . aBoolean . hasSecondarySort } .
self _uncontinuableError
%

category: 'Searching'
method: BasicSortNode
_binarySearchCoveringKey: aKey totalOrder: aBoolean

"Returns the index for the first entry in which aKey is found utilizing a
 binary search.  This is the first entry whose key >= aKey. Uses a binary
 search."

<primitive: 205>
self _primitiveFailed: #_binarySearchCoveringKey:totalOrder:
     args: { aKey . aBoolean } .
self _uncontinuableError
%

category: 'Searching'
method: BasicSortNode
_binarySearchCoveringKey: aKey value: aValue

"Returns the index for the entry in which aKey/aValue would be inserted.  This
 is the first entry which has its key >= aKey.  If multiple entries have the
 same key (key = aKey), then aValue is used (since entries with duplicate keys
 are inserted by the value's OOP ordering).  If the receiver is empty, returns
 1.  Uses a binary search."

<primitive: 204>
self _primitiveFailed: #_binarySearchCoveringKey:value:
     args: { aKey . aValue } .
self _uncontinuableError
%

category: 'Updating'
method: BasicSortNode
_btreeInsertKey: aKey value: aValue atIndex: insertionIndex

"Insert the key/value pair in the receiver.  The sender of this message must
 verify that the entry will fit in the receiver and must provide the insertion
 index."

| lastIndex |
lastIndex := numElements * 4.

"move entries down to make room for a new entry, or add room at the end"
self _insertAt: insertionIndex
     from: nil fromStart: 1 fromEnd: 4
     numToMoveDown: (lastIndex - insertionIndex + 1) .

" add the new entry "
super _at: insertionIndex put: aValue.
super _at: (insertionIndex + 1) put: aKey.

self _insertEncryptionFor: aKey value: aValue startingAt: (insertionIndex + 2).

numElements := numElements + 1
%

category: 'Testing'
method: BasicSortNode
_canCompare: aKey withClass: aClass

"Returns whether the receiver can make comparisons with the given key."

^ self _basicCanCompare: aKey withClass: aClass
%

category: 'Comparison Operators'
method: BasicSortNode
_compareEntryAt: index1
lessThanNode: aNode
entryAt: index2
useValue: aBoolean

"Perform a < comparison between the entries at the given indexes.
 Use encryption to optimize the comparison."

<primitive: 159>
self _primitiveFailed: #_compareEntryAt:lessThanNode:entryAt:useValue:
     args: { index1 . aNode . index2 . aBoolean } .
self _uncontinuableError
%

category: 'Comparison Operators'
method: BasicSortNode
_compareKey: aKey equalToEntryAt: index

"Performs an equality comparison between aKey and the entry whose key is at the
 given index.  Use encryption to make the comparison faster."

"Boolean must be false; case-insensitive semantics not yet implemented."

<primitive: 35>
self _primitiveFailed: #_compareKey:equalToEntryAt:
     args: { aKey . index } .
self _uncontinuableError
%

category: 'Audit'
method: BasicSortNode
_encryptionFor: aKey

"Get the encryption for the given value and return it
 in a 2 slot Array."

<primitive: 871>
self _primitiveFailed: #_encryptionFor: args: { aKey }
%

category: 'Constants'
method: BasicSortNode
_encryptionSize

"Two slots are used for encryption."

^ 2
%

category: 'Updating'
method: BasicSortNode
_insertEncryptionFor: aKey value: aValue startingAt: index

"Get the encryption for the given value and place it
 in the receiver starting at the given index."

<primitive: 234>
self _primitiveFailed: #_insertEncryptionFor:value:startingAt:
     args: { aKey . aValue . index } .
self _uncontinuableError
%

category: 'Accessing'
method: BasicSortNode
_lastIndex

"Returns the index of the last used slot in the node."

^ numElements * 4
%

! Class extensions for 'Behavior'

!		Instance methods for 'Behavior'

category: 'Updating Categories'
method: Behavior
addCategory: aString
  ^ self addCategory: aString environmentId: 0
%

category: 'Updating Categories'
method: Behavior
addCategory: aString environmentId: envId

"Adds aString as a method category for the receiver.  If aString is already a
 method category, generates an error.
 Returns the newly added category (a SymbolSet)."

| aSymbol canWrite res policy |
self _validatePrivilege ifFalse:[ ^ nil ].
aSymbol := aString asSymbol .
(self includesCategory: aSymbol environmentId: envId ) ifTrue:[
  ^ self _error: #classErrMethCatExists args: { aString . self }
].
canWrite := self canWriteMethods .
policy := GsPackagePolicy currentOrNil .
(canWrite or:[ envId ~~ 0 or: [ policy == nil ]]) ifTrue:[ | aSet catDict |
  catDict :=  self _baseCategorysForStore: envId .
  catDict at: aSymbol put: ( aSet := SymbolSet new ) .
  res := aSet
] ifFalse: [
  res := policy addCategory: aSymbol for: self
].
self _announceReorganized .
^ res
%

category: 'Method Timestamps'
method: Behavior
authorInitials
    ^ GsPackagePolicy authorInitials
%

category: 'Testing'
method: Behavior
canWriteMethods

  ^ self canWriteMethodsEnv: 0
%

category: 'Testing'
method: Behavior
canWriteMethodsEnv: envId

  | mds dict |
  (mds := methDicts) _isArray ifTrue:[
    dict := mds atOrNil: (envId*4 + 1) .
    dict ifNotNil:[ ^ dict canBeWritten ].
    ^ mds canBeWritten
  ] ifFalse:[
    mds ifNotNil:[
      envId == 0 ifTrue:[ ^ mds canBeWritten ]
    ].
  ].
  ^ self canBeWritten
%

category: 'Method Timestamps'
method: Behavior
changeStamp
  "Answer a string to be pasted into source code to mark who changed it and when."
  ^ self authorInitials , ' ' , (Date today asStringUsingFormat: #(2 1 3 $/ 1 1 $: false )), ' ',
    (Time now asString copyFrom: 1 to: 5)
%

category: 'Class Timestamps'
method: Behavior
commentStamp

  "Return the comment timeStamp.
   Both a Class and its metaclass share a single comment timeStamp"
  | eDict |
  (eDict := self extraDict) ifNil:[ ^ nil ].
  ^ eDict at: #GSClassCommentStamp otherwise: nil
%

category: 'Class Timestamps'
method: Behavior
commentStamp: aStamp
  "Set the receiver's comment timeStamp to aStamp.
   Both a Class and its metaclass share a single comment stamp"

  | eDict |
  (eDict := self extraDictForStore) ifNotNil:[
    eDict at: #GSClassCommentStamp put: aStamp
  ].
%

category: 'Updating the Method Dictionary'
method: Behavior
compileTransientMethod: sourceString dictionaries: aSymbolList environmentId: environmentId
  "This method compiles some source code for the receiver and installs the method into
   the transient method dictionary."

  <primitive: 2001>  "enter protected mode"
  | prot |
  self _validatePrivilege
    ifFalse: [ ^nil].
  [
    prot := System _protectedMode.
    ^ self _compileTransientMethod: sourceString dictionaries: aSymbolList environmentId: environmentId  ]
    ensure: [ prot _leaveProtectedMode ]
%

category: 'Pragmas'
method: Behavior
createPragmaFrom: aPragmaArray for: aGsMethod
  | pragma args pragmas keyword |
  aPragmaArray isEmpty
    ifTrue: [ ^ nil ].
  pragmas := Array new.
  1 to: aPragmaArray size by: 2 do: [ :i |
    keyword := aPragmaArray at: i.
    args := aPragmaArray at: i + 1.
    args == nil
      ifTrue: [ args := #() ].
    pragma := Pragma keyword: keyword arguments: args.
    pragma setMethod: aGsMethod.
    pragmas add: pragma ].
  ^ pragmas
%

category: 'Fileout'
method: Behavior
fileOutCategories

"Returns a String or MultiByteString with all the receiver's methods in
 Topaz Filein format."

| strm |
strm := AppendStream on: String new .
self fileOutCategoriesOn: strm .
^ strm contents
%

category: 'Fileout'
method: Behavior
fileOutCategoriesOn: stream

"Writes the receiver's categories and methods onto the given stream
 in Topaz filein format."

| lf cls nm |

self _fileoutHeaderOn: stream  .
cls := self thisClass.
lf := Character lf.
stream nextPut: lf.
nm := cls name.

self fileOutMethodRemovalOn: stream name: nm.

self fileOutPreMethodsOn: stream.

stream nextPutAll: '! ------------------- Class methods for '; _fileOutAll: nm; nextPut: lf.
cls class sortedCategoryNames do: [:category |
  cls class fileOutCategory: category on: stream
].

stream nextPutAll: '! ------------------- Instance methods for '; _fileOutAll: nm; nextPut: lf.
cls sortedCategoryNames do: [:category |
  cls fileOutCategory: category on: stream
].

self fileOutPostMethodsOn: stream.

^stream
%

category: 'Fileout'
method: Behavior
fileOutCategory: catName

"Returns a String or MultiByteString containing the methods of the given category in
 Topaz Filein format."

| strm |
strm := AppendStream on: String new .
self fileOutCategory: catName on: strm .
^ strm contents
%

category: 'Fileout'
method: Behavior
fileOutCategory: catName on: stream

^ self fileOutCategory: catName on: stream environmentId: 0
%

category: 'Fileout'
method: Behavior
fileOutCategory: catName on: stream environmentId: envId

"Files out the given category on the given stream."

| sels |

self _fileoutHeaderOn: stream  .
sels := self sortedSelectorsIn: catName environmentId: envId .
stream nextPutAll:'set compile_env: ' ; nextPutAll: envId asString ; lf .
sels do: [:selector |
  self fileOutMethod: selector environmentId: envId on: stream
]
%

category: 'Fileout'
method: Behavior
fileOutClass

"Returns a String or MultiByteString with the receiver's class definition
 and all the receiver's methods in Topaz Filein format."

| strm |
strm := AppendStream on: String new .
self fileOutClassOn: strm environmentId: 0 .
^ strm contents
%

category: 'Fileout'
method: Behavior
fileOutClassByCategoryOn: stream

"Writes the receiver's definition and methods onto the given stream in
 filein format."

self _fileoutHeaderOn: stream  .
self fileOutClassDefinitionOn: stream .
self fileOutCategoriesOn: stream.
%

category: 'Fileout'
method: Behavior
fileOutClassCategoryOn: stream

"Writes out class category, if there is one for this class."

self _fileoutHeaderOn: stream  .
(self _classCategory) ifNotNil:[ :cat |
  stream nextPutAll: 'expectvalue /Class'; lf ;
         nextPutAll: 'doit'; lf ;
         _fileOutAll: (self name asString);
         nextPutAll: ' category: ';
         _fileOutAll: cat quoted ; lf ;
         nextPut: $% ; lf .
].
%

category: 'Fileout'
method: Behavior
fileOutClassDefinitionOn: stream

^ self fileOutClassDefinitionOn: stream environmentId: 0
%

category: 'Fileout'
method: Behavior
fileOutClassDefinitionOn: stream environmentId: envId

"Writes the receiver's preclass, class definition, and comment onto
 the given stream in filein format."

self _fileoutHeaderOn: stream  .
stream nextPutAll:'set compile_env: 0'; lf .
envId == 0 ifTrue:[
  stream    nextPutAll: '! ------------------- Class definition for ' ;
       _fileOutAll: self thisClass name; lf .
  self fileOutPreClassOn: stream .
  stream nextPutAll: 'expectvalue /Class'; lf ;
    nextPutAll: 'doit'; lf ;
    _fileOutAll: self definition; lf ;
    nextPut: $% ; lf .
  self fileOutCommentOn: stream .
  self fileOutClassCategoryOn: stream .
  self _fileOutEnvSuperclassesOn: stream .
] ifFalse:[
  self _fileOutEnvSuperclass: envId on: stream .
].
%

category: 'Fileout'
method: Behavior
fileOutClassOn: stream

"Writes the receiver's definition and methods onto the given stream in
 filein format."

self _fileoutHeaderOn: stream  .
self fileOutClassDefinitionOn: stream .
self fileOutMethodsOn: stream .
%

category: 'Fileout'
method: Behavior
fileOutClassOn: stream environmentId: envId

"Writes the receiver's definition and methods onto the given stream in
 filein format."

self _fileoutHeaderOn: stream  .
self fileOutClassDefinitionOn: stream environmentId: envId .
self fileOutMethodsOn: stream environmentId: envId .
%

category: 'Fileout'
method: Behavior
fileOutCommentOn: stream

"Writes code to create class comment onto the given stream in
 filein format."

self _fileoutHeaderOn: stream  .
self commentForFileout ifNotNil:[ :cmt |
  stream nextPutAll: 'expectvalue /Class'; lf ;
    nextPutAll: 'doit'; lf ;
    _fileOutAll: self thisClass name; nextPutAll: ' comment: ' ; lf ;
    _fileOutAll: cmt printString; lf ;
    nextPut:    $%;  lf
].
%

category: 'Fileout'
method: Behavior
fileOutMethod: selector
  ^ self fileOutMethod: selector environmentId: 0
%

category: 'Fileout'
method: Behavior
fileOutMethod: selector environmentId: envId

"Returns a String or MultiByteString with the given method's category and
 source in Topaz Filein format."

| strm |
strm := AppendStream on: String new .
self fileOutMethod: selector environmentId: envId on: strm .
^ strm contents
%

category: 'Fileout'
method: Behavior
fileOutMethod: selector environmentId: envArg on: stream

"Writes the given method's source to the given stream in Topaz Filein format."

| lf cat src envId |
envId := envArg < 0 ifTrue:[ 0 - envArg ] ifFalse:[ envArg ].
self _fileoutHeaderOn: stream  .
src := self sourceCodeAt: selector environmentId: envId .
((src _isOneByteString not)
    and:[ (stream dynamicInstVarAt: #utf8Bool) == false ]) ifTrue:[
   src _asString ifNotNil:[ :s | src := s "source ok" ]
                 ifNil:[ Error signal: 'source for ' , selector printString,
           ' contains codePoint > 255  when 8 bit fileout requested' ]
].
lf := Character lf.
cat := self categoryOfSelector: selector environmentId: envId.
cat ifNil:[
  ^ self _error: #rtErrKeyNotFound args: { selector }
].
stream nextPutAll: 'category: '''; _fileOutAll: cat; nextPut: $'; nextPut: lf .
envArg > 0 ifTrue:[
  stream nextPutAll:'set compile_env: '; nextPutAll: envId asString ; nextPut: lf .
].
stream
  nextPutAll: (self isMeta ifTrue: [ 'classmethod: ' ]
              ifFalse: [ 'method: ' ]) ;
  _fileOutAll: self thisClass name; nextPut: lf .
stream _fileOutAll: src.
src last == lf ifFalse: [
  stream nextPut: lf
].
stream nextPut:  $% ; nextPut: lf .
envArg > 0 ifTrue:[
  stream nextPutAll:'set compile_env: 0'; nextPut: lf .
].
%

category: 'Fileout'
method: Behavior
fileOutMethod: selector on: stream
 ^ self fileOutMethod: selector environmentId: 0 on: stream
%

category: 'Fileout'
method: Behavior
fileOutMethodRemovalOn: stream name: clsname

"Writes code to remove all the receiver's methods onto the given stream
 in filein format."

self _fileoutHeaderOn: stream  .
stream nextPutAll: '! ------------------- Remove existing behavior from ';
  _fileOutAll: clsname; lf ;
  _fileOutAll: 'removeAllMethods ';
    nextPutAll: clsname; lf ;
  _fileOutAll: 'removeAllClassMethods ';
    nextPutAll: clsname ; lf .
%

category: 'Fileout'
method: Behavior
fileOutMethodRemovalOn: stream name: clsname environmentId: envId

"Writes code to remove all the receiver's methods onto the given stream
 in filein format."

| theSend |
theSend := ' removeAllMethods' ,
          (envId == 0 ifTrue:[ '.' ] ifFalse:[ ': ' , envId asString , '.']) .
self _fileoutHeaderOn: stream  .
stream nextPutAll: '! ------------------- Remove existing behavior from ';
  _fileOutAll: clsname; lf ;
  "keep trailing spaces on next line for diff compatibility with previous releases"
  nextPutAll: 'expectvalue /Metaclass3
doit
';
  _fileOutAll: clsname;
    nextPutAll: theSend ; lf ;
  _fileOutAll: clsname;
    nextPutAll: ' class' ; nextPutAll: theSend ; lf ;
  nextPut: $% ; lf .
%

category: 'Fileout'
method: Behavior
fileOutMethods

"Returns a String or MultiByteString with all the receiver's methods
 in Topaz Filein format."

| strm |
strm := AppendStream on: String new.
self fileOutMethodsOn: strm .
^ strm contents
%

category: 'Fileout'
method: Behavior
fileOutMethodsOn: stream

"File out this class's methods, but sort the selectors alphabetically."

| cls sels nm |
self _fileoutHeaderOn: stream  .
stream ifNil: [^self].
cls := self thisClass.
nm := cls name.

self fileOutMethodRemovalOn: stream name: nm.
self fileOutPreMethodsOn: stream.

stream nextPutAll: '! ------------------- Class methods for '; _fileOutAll: nm; lf.
sels := SortedCollection withAll: (cls class selectorsForEnvironment: 0 ).
1 to: sels size do: [:i |
  cls class fileOutMethod: (sels at: i) on: stream .
].
stream nextPutAll: '! ------------------- Instance methods for '; _fileOutAll: nm; lf.
sels := SortedCollection withAll: (cls selectorsForEnvironment: 0 ).
1 to: sels size do: [:i |
  cls fileOutMethod: (sels at: i) on: stream .
].
self fileOutPostMethodsOn: stream.

^stream
%

category: 'Fileout'
method: Behavior
fileOutMethodsOn: stream environmentId: envId

"File out this class's methods, but sort the selectors alphabetically."

| cls sels nm |
self _fileoutHeaderOn: stream  .
stream ifNil: [^self].
cls := self thisClass.
nm := cls name.

self fileOutMethodRemovalOn: stream name: nm environmentId: envId .
self fileOutPreMethodsOn: stream environmentId: envId .

stream nextPutAll:'set compile_env: '; nextPutAll: envId asString ; lf .
stream nextPutAll: '! ------------------- Class methods for '; _fileOutAll: nm; lf.
sels := SortedCollection withAll: (cls class selectorsForEnvironment: envId ).
1 to: sels size do: [:i |
  cls class fileOutMethod: (sels at: i)  environmentId: 0 - envId on: stream .
].
stream nextPutAll: '! ------------------- Instance methods for '; _fileOutAll: nm; lf.
sels := SortedCollection withAll: (cls selectorsForEnvironment: envId ).
1 to: sels size do: [:i |
  cls fileOutMethod: (sels at: i) environmentId: 0 - envId on: stream .
].
self fileOutPostMethodsOn: stream.
envId ~~ 0 ifTrue:[ stream nextPutAll:'set compile_env: 0' ; lf ].
^stream
%

category: 'Fileout'
method: Behavior
fileOutPostMethodsOn: stream

 ^ self fileOutPostMethodsOn: stream environmentId: 0
%

category: 'Fileout'
method: Behavior
fileOutPostMethodsOn: stream environmentId: envId

"This method gives classes an opportunity to file out information not
 normally emitted by the predefined fileout methods.  Classes may override
 this method (as a class method, of course) to add extra code to the
 output stream.  Emitted code should be in Topaz filein format.  It will
 be placed after method creation."

%

category: 'Fileout'
method: Behavior
fileOutPreClassOn: stream

"This method gives classes an opportunity to file out information not
 normally emitted by the predefined fileout methods.  Classes may override
 this method (as a class method, of course) to add extra code to the
 output stream.  Emitted code should be in Topaz filein format.  It will
 be placed before any other fileout information for the class."

%

category: 'Fileout'
method: Behavior
fileOutPreMethodsOn: stream

^ self fileOutPreMethodsOn: stream environmentId: 0
%

category: 'Fileout'
method: Behavior
fileOutPreMethodsOn: stream environmentId: envId

"This method gives classes an opportunity to file out information not
 normally emitted by the predefined fileout methods.  Classes may override
 this method (as a class method, of course) to add extra code to the
 output stream.  Emitted code should be in Topaz filein format.  It will
 be placed after existing method removal and before method creation."

%

category: 'Accessing'
method: Behavior
indexManager

^IndexManager current
%

category: 'Method Timestamps'
method: Behavior
methodStampDictName
  ^ #GSMethodStampDict
%

category: 'Updating Categories'
method: Behavior
moveMethod: aSelector toCategory: categoryName
  ^ self _rwMoveMethod: aSelector toCategory: categoryName
%

category: 'Updating Categories'
method: Behavior
moveMethod: aSelector toCategory: categoryName environmentId: envId
	"Moves the method aSelector (a String) from its current category to the
 specified category (also a String).  If either aSelector or categoryName is
 not in the receiver's method dictionary, or if aSelector is already in
 categoryName, generates an error..
 This method does not account for selectors inherited from superclasses."

	| selSym catSym oldCat policy method |
	self _validatePrivilege ifFalse: [^nil].
	(self includesCategory: categoryName environmentId: envId)
		ifFalse: [^self _categoryNotFound: categoryName].
	selSym := aSelector asSymbol.
	policy := GsPackagePolicy currentOrNil.
	method := self
				compiledMethodAt: selSym
				environmentId: envId
				otherwise: nil
				usePackages: oldCat notNil.
	method ifNil: [^self _error: #classErrSelectorNotFound args: {aSelector}].
	oldCat := self categoryOfSelector: aSelector environmentId: envId.
	catSym := categoryName asSymbol.
	(envId ~~ 0 or: [self canWriteMethods or: [policy == nil]])
		ifTrue:
			[| catDict |
			catDict := self _baseCategorysForStore: envId.
			oldCat ifNotNil: [(catDict at: oldCat) remove: selSym].
			(catDict at: catSym) add: selSym]
		ifFalse: [policy moveSelector: selSym toCategory: catSym for: self].
	self _needsAnnouncement
		ifTrue: [self _announceMethodMoved: method oldCategory: oldCat]
%

category: 'Fileout'
method: Behavior
multibyteSources

"Returns an Array of selectors whose source strings contain code points > 255"
| res |
res := { } .
self selectors do:[:sel | | str |
  str := (self compiledMethodAt: sel) sourceString .
  ((str _stringCharSize > 1) and:[ str _asString == nil]) ifTrue:[
    res add: sel .
  ].
].
^ res
%

category: 'Fileout'
method: Behavior
nameForFileout

"Deprecated. Returns the name to be used for this class for fileout."

| arr sz |
self deprecated: 'Behavior>>nameForFileout deprecated v3.2.'.

arr := GsCurrentSession currentSession symbolList dictionariesAndSymbolsOf: self.
1 to: (sz := arr size) do:[:j | | nm |
  (nm := (arr at: j) at: 2)  == self name ifTrue:[ ^ nm ].
].
sz == 0 ifTrue:[ ^ self thisClass name ].
Error signal:'during fileout, class name does not match name in dictionary(s)'
%

category: 'Pragmas'
method: Behavior
pragmaDictName

  ^ #GSMethodPragmaDict
%

category: 'Pragmas'
method: Behavior
pragmasForMethod: selector
  "Get the Pragmas for the method specified by  selector."

  | pragmas selSym meth |
  selSym := Symbol _existingWithAll: selector  .
  selSym ifNil:[ ^ #() ] .
  meth := self compiledMethodAt: selector otherwise: nil .
  meth ifNotNil:[
    pragmas := meth pragmas.
    pragmas ifNotNil:[ ^ pragmas ].
  ].
  ^ self _pragmasForMethod: meth .
%

category: 'Pragmas'
method: Behavior
pragmasForMethod: selector env: envId
  "Get the Pragmas for the method specified by selector and envId."

  | meth |
  envId == 0 ifTrue:[ ^ self pragmasForMethod: selector ].
  meth := self compiledMethodAt: selector environmentId: envId otherwise: nil.
  meth ifNil:[ ^ #() ].
  meth pragmas ifNotNil:[ :p | ^ p ].
  ^ #()
%

category: 'Modifying Classes'
method: Behavior
recompileAllMethodsInContext: aSymbolList

"Recompiles all methods for the receiver, using the specified symbol list.

 The environmentId of each method is preserved by the recompilation.

 This method is designed to allow a user interface to issue GciContinue after
 fixing the source code for a method in error.  GciContinue will reattempt the
 compilation of the method which contained an error, then proceed to the next
 method."

| envId |
self _validatePrivilege ifFalse:[ ^ nil ].
envId := 0 .
self env: envId unifiedCategoriesDo:[ :theCategory :selectorList |
    selectorList do: [ :aSelector| | aMeth err theSource |
      [ "This Block supports GciContinue"
        "Make sure the method is there before trying to recompile it.
         An exception handler may have removed the method!"
        err := nil .
        aMeth := self compiledMethodAt: aSelector environmentId: envId otherwise: nil .
        aMeth ifNotNil:[ | mEnvId |
          theSource := aMeth sourceString .
          (mEnvId := aMeth environmentId) == envId ifFalse:[
             self error:'mismatched environmentId'
          ].
          [
             self compileMethod: theSource dictionaries: aSymbolList
                          category: theCategory environmentId: envId .
           ] onException: CompileError do:[:ex |
            err := ex .
            ex outer .
          ]
        ].
        err == nil
      ] untilTrue .
    ] .
].
^ self
%

category: 'Modifying Classes'
method: Behavior
recompileAllSubclassMethodsInContext: aSymbolList

"Recompiles all methods for the receiver and its subclasses, using
 the specified symbol list.  If the receiver is not modifiable,
 then methods in subclasses will not be recompiled, since only
 modifiable classes should have the Subclasses class variable present."

| theSubclasses |
self _validatePrivilege ifFalse:[ ^ nil ].
self _removeAllSubclassCode .
self recompileAllMethodsInContext: aSymbolList .
theSubclasses := self _subclasses .
theSubclasses ifNotNil:[
  theSubclasses do:[:x | x recompileAllSubclassMethodsInContext: aSymbolList ]
  ].
^ self
%

category: 'Updating the Method Dictionary'
method: Behavior
removeAllMethods
  ^ self removeAllMethods: 0
%

category: 'Updating Categories'
method: Behavior
removeCategory: categoryName environmentId: envId

"Removes the specified category and all its methods from the receiver's
 method dictionary.  If categoryName is not in the receiver's categories,
 generates an error.
 Any breakpoints in removed methods are cleared."

| theSelectors catSym allCats |
self _validatePrivilege ifFalse:[ ^ nil ].
(self includesCategory: categoryName environmentId: envId ) ifFalse:[
  ^ self _categoryNotFound: categoryName .
].
catSym := categoryName asSymbol .
allCats := self _unifiedCategorys: envId .
theSelectors := (allCats at: catSym ) copy.
1 to: theSelectors size do: [ :j |
  self _basicRemoveSelector: (theSelectors at: j) environmentId: envId
].
envId == 0 ifTrue:[ | policy |
  policy := GsPackagePolicy currentOrNil .
  policy ifNotNil:[ :pp | pp removeCategory: catSym for: self ].
  (self canBeWritten or: [ policy == nil ]) ifTrue:[
    (self _baseCategorys: envId) removeKey: catSym otherwise: nil .
  ].
] ifFalse: [
  (self _baseCategorys: envId) removeKey: catSym
].
self _announceReorganized .
%

category: 'Updating the Method Dictionary'
method: Behavior
removeSelector: aString environmentId: envId

"Removes the method whose selector is aString from the receiver's method
 dictionary.  If the selector is not in the method dictionary, generates an
 error."

| selector removedFromBaseDict |

self _validatePrivilege ifFalse:[ ^ nil ].
selector := Symbol _existingWithAll: aString .
selector ifNotNil:[
  removedFromBaseDict := self _basicRemoveSelector: selector environmentId: envId.
  removedFromBaseDict ifTrue:[ | cDict |
    cDict := self _baseCategorys: envId .
    cDict keysAndValuesDo: [:aKey :setOfSelectors |
        (setOfSelectors remove: selector otherwise: nil ) ifNotNil:[
           ^ self "done"
        ]
     ].
    ^ self _error: #classErrSelectorNotFound args: { aString } .
  ].
] ifNil:[
  ^ self _error: #classErrSelectorNotFound args: { aString } .
]
%

category: 'Updating the Method Dictionary'
method: Behavior
removeTransientSelector: aString environmentId: envId
  "Removes the method whose selector is aString from the receiver's transient
   method dictionary.  If the selector is not in the transient method dictionary,
   generates an error."

  | selector |
  self _validatePrivilege
    ifFalse: [ ^nil].
  selector := Symbol _existingWithAll: aString.
  selector
    ifNotNil: [
      | md tmeth |
      md := self transientMethodDictForEnv: envId.
      md ifNotNil: [ tmeth := md removeKey: selector otherwise: nil ].
      tmeth ifNotNil: [ ^ self _refreshLookupCache: selector oldMethod: tmeth env: envId ] ].
  ^ self _error: #'classErrSelectorNotFound' args: {aString}
%

category: 'Updating the Method Dictionary'
method: Behavior
removeTransientSelector: aString environmentId: envId ifAbsent: aBlock
  "Removes the method whose selector is aString from the receiver's
   transient method dictionary.  If the selector is not in the
   transient method dictionary, returns the result of evaluating the
   zero-argument block aBlock.  Otherwise, returns the receiver."

  | aKey tmd meth |
  self _validatePrivilege
    ifFalse: [ ^ nil ].
  aKey := Symbol _existingWithAll: aString.
  aKey
    ifNotNil: [
      tmd := self transientMethodDictForEnv: envId.
      tmd ifNotNil: [ meth := tmd at: aKey otherwise: nil ] ].
  meth ifNil: [ ^ aBlock value ].
  self removeTransientSelector: aKey environmentId: envId
%

category: 'Updating Categories'
method: Behavior
renameCategory: categoryName to: newCategoryName
  ^ self renameCategory: categoryName to: newCategoryName environmentId: 0
%

category: 'Updating Categories'
method: Behavior
renameCategory: categoryName to: newCategoryName environmentId: envId

"Changes the name of the specified category to newCategoryName (a
 String), and returns the receiver.  If categoryName is not in the
 receiver's method dictionary, or if newCategoryName is already in the
 receiver's method dictionary, generates an error."

| catSym newCatSym oldCatSet policy |
self _validatePrivilege ifFalse:[ ^ nil ].
(self includesCategory: newCategoryName environmentId: envId ) ifTrue:[
  ^ self _error: #classErrMethCatExists args: { newCategoryName . self }
].
(self includesCategory: categoryName environmentId: envId ) ifFalse:[
   ^ self _error: #classErrMethCatNotFound args: { categoryName }
].
newCatSym := newCategoryName asSymbol .
catSym := categoryName asSymbol.
policy := GsPackagePolicy currentOrNil .
(envId ~~ 0 or:[ self canWriteMethods or: [ policy == nil ]]) ifTrue:[ | catDict|
   catDict :=  self _baseCategorysForStore: envId .
   catDict at: newCatSym put: (oldCatSet := catDict at: catSym ).
   catDict removeKey: catSym .
] ifFalse: [   | pkgCats catSet |
   pkgCats := GsMethodDictionary new  .
   policy copyCategoryDictFor: self into: pkgCats .
   oldCatSet := pkgCats at: catSym otherwise: { } .
   catSet := self addCategory: newCatSym environmentId: envId .
   catSet addAll: oldCatSet.
   policy removeCategory: catSym for: self.
].
self _needsAnnouncement ifTrue:[
  oldCatSet do: [:sel |
     self _announceMethodMoved: (self compiledMethodAt: sel) oldCategory: catSym
  ].
].
%

category: 'Updating Categories'
method: Behavior
renameOrMergeCategory: oldName to: newName
  ^ self renameOrMergeCategory: oldName to: newName environmentId: 0
%

category: 'Updating Categories'
method: Behavior
renameOrMergeCategory: oldName to: newName environmentId: envId

"Changes the name of the specified category to newName (a String), and
 returns the receiver.  If oldName is not an existing category in the receiver
 generates an error.  If newName is already in the receiver's
 category list, moves all the methods from the old category to the new
 category, and removes the old category."

| oldsym newsym oldCatSet policy |
self _validatePrivilege ifFalse:[ ^ nil ].
(self includesCategory: oldName environmentId: envId) ifFalse:[
  ^ self _categoryNotFound: oldName
].
(self includesCategory: newName environmentId: envId) ifFalse:[
  ^ self renameCategory: oldName to: newName environmentId: envId
].
oldsym := oldName asSymbol.
newsym := newName asSymbol.
policy := GsPackagePolicy currentOrNil .
(envId ~~ 0 or:[ self canWriteMethods or: [ policy == nil ]])  ifTrue:[ | catDict |
  catDict := self _baseCategorysForStore: envId .
  oldCatSet := catDict at: oldsym .
  (catDict at: newsym ) addAll: oldCatSet .
  catDict removeKey: oldsym .
] ifFalse:[ |  pkgCats |
  pkgCats := GsMethodDictionary new  .
  policy copyCategoryDictFor: self into: pkgCats .
  oldCatSet := (pkgCats at: oldsym ) copy .
  oldCatSet do:[ :aSelector |
     policy moveSelector: aSelector toCategory: newsym for: self .
  ].
  policy removeCategory: oldsym for: self.
].
self _needsAnnouncement ifTrue:[
  oldCatSet do: [:sel |
     self _announceMethodMoved: (self compiledMethodAt: sel) oldCategory: oldsym
  ].
].
%

category: 'Pragmas'
method: Behavior
setPragmas: pragmaArray forMethod: selector

  "Deprecated, pragmas are now generated into GsNMethod's debugInfo during compile.

   Set the pragmas for the given method .
   This code shared by Classes and metaclasses,
   parameterized by pragmaDictName."

  | methodPragmaDict eDict selSym |
  pragmaArray ifNotNil:[
    self deprecated: 'Behavior >> setPragmas:forMethod: deprecated in 3.5' .
  ].
  selSym := Symbol _existingWithAll: selector  .
  selSym ifNil:[ self error:'invalid selector'].
  GsPackagePolicy currentOrNil ifNotNil:[:pp |
     (pp setPragmas: pragmaArray forBehavior: self forMethod: selSym ) ifNotNil:[ ^self ].
  ].
  (eDict := self extraDictForStore) ifNotNil:[ | dictName |
     dictName := self pragmaDictName .
     methodPragmaDict := eDict at: dictName otherwise: nil .
     methodPragmaDict ifNil: [
       GsObjectSecurityPolicy setCurrent: self objectSecurityPolicy while:[
         methodPragmaDict := IdentityKeyValueDictionary new.
       ].
       eDict at: dictName put: methodPragmaDict.
     ].
     pragmaArray ifNil:[ methodPragmaDict removeKey: selSym otherwise: nil  ]
         ifNotNil: [ methodPragmaDict at: selSym put: pragmaArray ]
  ].
%

category: 'Method Timestamps'
method: Behavior
setStamp: aStamp forMethod: selector
	"Set the timestamp for the given method, when 
		session methods are enabled.
		This code shared by Classes and metaclasses,
		parameterized by methodStampDictName."

	| methodStampDict eDict selSym |
	selSym := Symbol _existingWithAll: selector.
	selSym ifNil: [ self error: 'invalid selector' ].
	GsPackagePolicy currentOrNil
		ifNotNil: [ :pp | 
			(pp setStamp: aStamp forBehavior: self forMethod: selSym) ifNotNil: [ ^ self ].
			(eDict := self extraDictForStore)
				ifNotNil: [ 
					| dictName |
					dictName := self methodStampDictName.
					methodStampDict := eDict at: dictName otherwise: nil.
					methodStampDict
						ifNil: [ 
							aStamp
								ifNil: [ 
									"no need to add a new methodStampDict, 
										when we intend to remove a key from
										it (bug 49169)"
									^ self ].
							GsObjectSecurityPolicy
								setCurrent: self objectSecurityPolicy
								while: [ methodStampDict := IdentityKeyValueDictionary new ].
							eDict at: dictName put: methodStampDict ].
					aStamp
						ifNil: [ methodStampDict removeKey: selSym otherwise: nil ]
						ifNotNil: [ methodStampDict at: selSym put: aStamp ] ] ]
%

category: 'Method Timestamps'
method: Behavior
stampForMethod: selector
  "Get the timestamp for the given method"

  | stamp methodStampDict eDict selSym |
  selSym := Symbol _existingWithAll: selector  .
  selSym ifNil:[ ^ '' ].
  stamp := GsPackagePolicy currentOrNil ifNotNil:[:pp| pp stampForMethod: selSym in: self].
  stamp ifNotNil: [ ^stamp ].

  (eDict := self extraDictForStore) ifNil:[ ^'' ].
  (methodStampDict := eDict at: self methodStampDictName otherwise: nil) ifNil: [ ^'' ].
  ^ methodStampDict at: selSym otherwise: ''
%

category: 'Class Timestamps'
method: Behavior
theNonMetaClass
  "Sent to a class or metaclass, always return the class.
   Used by Monticello"

  ^self
%

category: 'Modifying Classes'
method: Behavior
upgradeComments

  " Upgrade comment representation to GS/64 3.1 standard.
    Prints out info on changes made to log file.
    Prints out WARNING info if any unusual conditions noted.
    Returns an array of two Boolean elements:
      1:  true if any warnings, otherwise false
      2:  true if a change was made to class, otherwise false
  "

  | prefix meta precomment comment descript descriptStr warning changed lf |

  System currentObjectSecurityPolicy: self objectSecurityPolicy.
  prefix := '    Class ' , (self name asString) , ': '.
  comment := nil.
  precomment := self _extraDictAt: #comment.
  meta := self class.
  warning := false.
  changed := false.
  lf := Character lf.
  " Check for comment method "
  (meta includesSelector: #comment)
  ifTrue: [
    comment := [ self comment ] on: Error do:[:ex | 'old comment not available'].
    (comment isKindOf: CharacterCollection)
    ifFalse: [
      GsFile gciLogServer: prefix , lf ,
      '          WARNING: Non-standard comment method.' , lf ,
      '          No changes made.'.
      warning := true.
      ^ Array with: warning with: changed ]
    ifTrue: [
      self _extraDictAt: #comment put: comment.
      meta removeSelector: #comment.
      changed := true.
      GsFile gciLogServer: prefix , 'Using comment method.'.
      precomment isNil ifFalse: [
        (precomment = comment) ifFalse: [
          GsFile gciLogServer:
          '          WARNING: Pre-existing #comment field will be lost!'.
          warning := true.
      "fall-through deliberate"
      ]]]].
  " Now check description field"
  descript := self _extraDictAt: #description.
  descript ifNil: [
    comment ifNil: [
      GsFile gciLogServer: prefix , 'No comment method or #description field.'.
      precomment ifNotNil:[ GsFile gciLogServer:
        '          Pre-existing #comment field will be used.' ]
      ifNil: [ GsFile gciLogServer: '          No changes made.']].
    ^ Array with: warning with: changed ].

  (descript isKindOf: GsClassDocumentation)
  ifFalse: [
    comment ifNil: [
      GsFile gciLogServer: prefix , lf ,
'          WARNING: No comment method and non-standard #description field.'.
      precomment ifNotNil: [
        GsFile gciLogServer:
        '          Pre-existing #comment field will be used.' ].
      GsFile gciLogServer: '          No changes made.'.
      warning := true.
      ^ Array with: warning with: changed ]
    ifNotNil: [
      GsFile gciLogServer:
      '          WARNING: Non-standard #description field will be deleted!'.
      self _extraDictRemoveKey: #description.
      changed := true.
      warning := true.
      ^ Array with: warning with: changed ]].

  descriptStr := descript asString.
  comment ifNil: [
    GsFile gciLogServer: prefix , 'Using #description field.'.
      precomment ifNotNil: [
        (precomment = descriptStr) ifFalse: [
          GsFile gciLogServer:
      '          WARNING: Pre-existing #comment field will be overridden!'.
          warning := true ]].
    self _extraDictAt: #comment put: descriptStr.
    self _extraDictRemoveKey: #description.
    changed := true.
    ^ Array with: warning with: changed ]
  ifNotNil: [
    self _extraDictRemoveKey: #description.
    changed := true.
    (comment = descriptStr)
    ifTrue: [  ^ Array with: warning with: changed ]
    ifFalse: [
      GsFile gciLogServer:
      '          WARNING: Comment method and #description field mismatch.'.
      GsFile gciLogServer:
      '          WARNING: description field will be deleted!'.
      warning := true.
      ^ Array with: warning with: changed ]].
^ Array with: warning with: changed
%

category: 'Modifying Classes'
method: Behavior
_addClassVar: aSymbol value: aVal

"Adds the class variable with name aSymbol to the receiver's
 class variables dictionary."
  | dict |
  self _validatePrivilege ifTrue:[
    (dict := classVars) ifNil:[ dict := self _createClassVarsDict ].
    (dict associationAt: aSymbol otherwise: nil) ifNotNil:[ :assoc |
       assoc _value: aVal
    ] ifNil:[ | assocClass |
      assocClass := SessionTemps current at:#ClassVariablesAssociationClass otherwise: SymbolAssociation.

      dict addAssociation:( assocClass newWithKey: aSymbol value: aVal)  .
    ]
  ]
%

category: 'Updating Categories'
method: Behavior
_announceReorganized
  ^ self
%

category: 'Updating the Method Dictionary'
method: Behavior
_basicRemoveSelector: aSymbol environmentId: envId

"Private."
| oldMeth removedFromSelf |
self _validatePrivilege ifFalse:[ ^ nil ].
removedFromSelf := false.
envId == 0 ifTrue:[
  oldMeth := GsPackagePolicy currentOrNil ifNotNil:[:pp| pp removeMethodAt: aSymbol for: self].
  oldMeth ifNil: [
    (self persistentMethodDictForEnv: 0) ifNotNil:[:dict |
       oldMeth := dict removeKey: aSymbol . "runtime error here if key not found"
    ].
    self setStamp: nil forMethod: aSymbol.
    removedFromSelf := true.
  ].
  self _codeChangedForEnv: envId .
  self _refreshLookupCache: aSymbol oldMethod: oldMeth env: envId .
] ifFalse:[
  removedFromSelf := self __basicRemoveSelector: aSymbol environmentId: envId .
].
^removedFromSelf
%

category: 'Updating the Method Dictionary'
method: Behavior
_compileTransientMethod: sourceString dictionaries: aSymbolList environmentId: environmentId
  "This method compiles some source code for the receiver and installs the method into
   the transient method dictionary.
   The first argument, sourceString, is the string of source code to be compiled.

   The second argument is a SymbolList to be used in parsing, along with the list of all
   class variables and pool dictionaries for the receiver and all of its
   superclasses.

   sourceString must be a kind of String or MultiByteString.  Instances of
   JapaneseString are not supported as source strings.  String literals
   ('abc') are generated as instances of the class of sourceString,
   unless sourceString is a Symbol, in which case 'abc' produces a String.
   If sourceString is a DoubleByteSymbol, 'abc' produces a DoubleByteString.

   anEnvironmentId must be a SmallInteger >= 0 and <= 16rFFFF.
   0 denotes the base Smalltalk image.  1 is reserved for use by Ruby.

   If a method with the same selector does not already exist an error is signalled.

   If there are no errors, this adds the resulting compiled method to the
   receiver's method dictionary and returns that method,
   otherwise signals a CompileError .
   A CompileWarning may be signaled, after adding the new method
   to a receiver's method dictionary."

  <protected>
  | meth tmd categ preCompiledMethod |
  self objectSecurityPolicy
    ifNotNil: [:policy |
      policy currentUserCanWrite
        ifFalse: [ self error: 'You must be able to write to the receiver to add transient session methods' ] ].
   preCompiledMethod := self
        _primitiveCompileMethod: sourceString
        symbolList: aSymbolList
        category: #'xxyzzy'
        oldLitVars: nil
        intoMethodDict: GsMethodDictionary new
        intoCategories: GsMethodDictionary new
        environmentId: environmentId. "pre-compile the method source to extract selector"
  self
    _checkCompileResult: preCompiledMethod
    source: sourceString
    suppressCompileWarning: true.
  preCompiledMethod class == GsNMethod
    ifTrue: [
      (self categoryOfSelector: preCompiledMethod selector)
        ifNil: [
          self
            error:
              'Transient method: ' , preCompiledMethod selector asString
                , ' must override an existing method.' ]
        ifNotNil: [ :existingCategory |
          "Use the category of the existing persistent method"
          categ := existingCategory ] ].
  tmd := self transientMethodDictForEnv: environmentId.
  tmd ifNil: [
    tmd := GsMethodDictionary new.
    self _transientSessionMethodBehaviorsCache add: self.
    self transientMethodDictForEnv: environmentId put: tmd.
  ].
  meth := self
    compileMethod: sourceString
    dictionaries: aSymbolList
    category: categ
    intoMethodDict: tmd
    intoCategories: nil
    intoPragmas: nil
    environmentId: environmentId.
  self _clearLookupCaches: environmentId.
  ^ meth
%

category: 'Fileout'
method: Behavior
_fileOutEnvSuperclass: envId on: stream
  | sup |
  sup := self superclassForEnv: envId .
  sup ~~ self superClass ifTrue:[
    stream nextPutAll: 'doit'; lf ;
       _fileOutAll: self thisClass name ;
       nextPutAll: ' superclassForEnv: '; nextPutAll: envId asString ;
       nextPutAll: ' put: ' ;  _fileOutAll: sup name ; nextPutAll:' . true ' ; lf ;
       nextPut: $% ; lf .
  ].
%

category: 'Fileout'
method: Behavior
_fileOutEnvSuperclassesOn: stream
  | max |
  max := self _maxSuperclassEnv .
  max downTo: 1 do:[:n |
    self _fileOutEnvSuperclass: n on: stream
  ]
%

category: 'Fileout'
method: Behavior
_fileoutHeaderOn: stream

  stream isEmpty ifTrue:[
    (stream isKindOf: GsFile) ifTrue:[
      stream nextPutAll: 'fileformat utf8' ; lf .
    ].
    "Gs64 v3.3, no SET SOURCESTRINGCLASS directives in fileouts."
  ].
%

category: 'Private'
method: Behavior
_fileOutMethod: selector environmentId: envId

"Returns a string with the given method's category and source in Topaz
 Filein format."

| strm |
strm := AppendStream on: String new.
self fileOutMethod: selector environmentId: envId on: strm .
^ strm contents
%

category: 'Updating Categories'
method: Behavior
_needsAnnouncement
 "Result controls sends of  _announceMethodMoved:oldCategory: .
  This implementation replaced when Seaside or other GUI tools installed. "

  ^ false
%

category: 'Pragmas'
method: Behavior
_pragmasForMethod: aGsNMethod
  "Get the legacy Pragmas for a method compiled before 3.5.
   This code shared by Classes and metaclasses,
   parameterized by pragmaDictName."

  | pragmas methodPragmaDict eDict selSym |
  selSym := aGsNMethod selector .
  pragmas := GsPackagePolicy currentOrNil ifNotNil:[:pp | pp  pragmasForMethod: selSym in: self].
  pragmas ifNotNil: [ ^pragmas ].

  (eDict := self extraDict) ifNil:[ ^#() ].
  (methodPragmaDict := eDict at: self pragmaDictName otherwise: nil) ifNil: [ ^#() ].
  ^ methodPragmaDict at: selSym otherwise: #()
%

category: 'Modifying Classes'
method: Behavior
_removeAllSubclassCode

"Dereference the code objects of all environment 0 GsMethods of the receiver,
 to force recompilation of those methods."

| theSubclasses aDict envId |
self _validatePrivilege ifFalse:[ ^ nil ].
envId := 0 .
theSubclasses := self _subclasses .
theSubclasses ifNotNil:[
  theSubclasses do:[:x| x _removeAllSubclassCode ] .
  ].
GsPackagePolicy currentOrNil ifNotNil:[:pp | pp removeAllSubclassCodeFor: self "envId 0 only"].
aDict := self persistentMethodDictForEnv: envId .
aDict ifNotNil:[
  aDict keysAndValuesDo:[ :aKey :aMethod |
    aDict at: aKey put: ((aDict at: aKey) _copyToForceRecompilation).
  ].
  self _codeChangedForEnv: envId  .
].
self _refreshClassCache: true .
^ self
%

category: 'Fileout'
method: Behavior
_topazFileOutCategory: catName header: headerStr asUtf8: utf8Bool

^ self _topazFileOutCategory: catName header: headerStr asUtf8: utf8Bool env: 0
%

category: 'Fileout'
method: Behavior
_topazFileOutCategory: catName header: headerStr asUtf8: utf8Bool env: envId
| strm |
strm := AppendStream on: String new  .
strm dynamicInstVarAt: #utf8Bool put: utf8Bool .
strm nextPutAll: headerStr .
self fileOutCategory: catName on: strm environmentId: envId .
^ utf8Bool ifTrue:[ strm contents encodeAsUTF8 ] ifFalse:[ strm contents ].
%

category: 'Fileout'
method: Behavior
_topazFileoutClass: headerStr asUtf8: utf8Bool

^ self _topazFileoutClass: headerStr asUtf8: utf8Bool env: 0
%

category: 'Fileout'
method: Behavior
_topazFileoutClass: headerStr asUtf8: utf8Bool env: envId
| strm |
strm := AppendStream on: String new .
strm dynamicInstVarAt: #utf8Bool put: utf8Bool .
strm nextPutAll: headerStr .
self fileOutClassOn: strm environmentId: envId .
^ utf8Bool ifTrue:[ strm contents encodeAsUTF8 ] ifFalse:[ strm contents ].
%

category: 'Fileout'
method: Behavior
_topazFileoutMethod: selector header: headerStr asUtf8: utf8Bool

^ self _topazFileoutMethod: selector header: headerStr asUtf8: utf8Bool env: 0
%

category: 'Fileout'
method: Behavior
_topazFileoutMethod: selector header: headerStr asUtf8: utf8Bool env: envId

| strm |
strm := AppendStream on: String new .
strm nextPutAll: headerStr .
strm dynamicInstVarAt: #utf8Bool put: utf8Bool .
self fileOutMethod: selector environmentId: envId on: strm .
^ utf8Bool ifTrue:[ strm contents encodeAsUTF8 ] ifFalse:[ strm contents ].
%

category: 'Updating the Method Dictionary'
method: Behavior
_transientSessionMethodBehaviorsCache
  | behaviors |
  behaviors := SessionTemps current
    at: self _transientSessionMethodBehaviorsCacheName
    ifAbsent: [
      behaviors := IdentitySet new _setNoStubbing.
      SessionTemps current
        at: self _transientSessionMethodBehaviorsCacheName
        put: behaviors ].
  ^behaviors
%

category: 'Updating the Method Dictionary'
method: Behavior
_transientSessionMethodBehaviorsCacheName
  ^ #'TransientSessionMethod_Behaviors'
%

category: 'Updating the Method Dictionary'
method: Behavior
__basicRemoveSelector: aSymbol environmentId: envId
"returns  true if a method found to remove"
| md pmd removed tmeth pmeth |
self _validatePrivilege ifFalse:[ ^ nil ].
md := self transientMethodDictForEnv: envId .
removed := false .
md ifNotNil:[
  tmeth := md removeKey: aSymbol otherwise: nil .
].
pmd := self persistentMethodDictForEnv: envId .
pmd ifNotNil:[
  pmeth := pmd removeKey: aSymbol otherwise: nil .
].
"Now refresh method lookup caches to account for removal of the selector
 and delete any breakpoints in the removed method(s) ."
tmeth ifNotNil:[
  self _refreshLookupCache: aSymbol oldMethod: tmeth env: envId .
  removed := true
].
pmeth ifNotNil:[
  removed := true .
  self _codeChangedForEnv: envId .
  self _refreshLookupCache: aSymbol oldMethod: pmeth env: envId
].
^ removed
%

! Class extensions for 'BlockClosure'

!		Instance methods for 'BlockClosure'

category: 'PetitParser-Core-Operators'
method: BlockClosure
asParser
	"Answer a parser implemented in the receiving one-argument block."

	^ PPPluggableParser on: self
%

! Class extensions for 'BlockSorter'

!		Class methods for 'BlockSorter'

category: 'Instance Creation'
classmethod: BlockSorter
on: anNsc with: sortBlock

^ self on: anNsc with: sortBlock collator: nil
%

category: 'Instance Creation'
classmethod: BlockSorter
on: anNsc with: sortBlock collator: anIcuCollator

 "Returns an initialized instance of BlockSorter.

 To use BlockSorter explicitly outside of the indexing subsystem,
 the recommended way is to send  sortWithBlock:  or  sortWithBlock:persistentRoot:
 to a kind of Collection."

| inst sortNode  |
inst := self new.
inst sortBlock: sortBlock collator: anIcuCollator .
sortNode := inst sortNodeClassForSort new: anNsc size.
sortNode blockSorter: inst.

inst sortNodes: (SortNodeArray with: sortNode).
^ inst
%

!		Instance methods for 'BlockSorter'

category: 'Accessing'
method: BlockSorter
sortBlock

^sortBlock
%

category: 'Updating'
method: BlockSorter
sortBlock: aBlock

sortBlock := aBlock
%

category: 'Updating'
method: BlockSorter
sortBlock: aBlock  collator: anIcuCollator

sortBlock := aBlock .
anIcuCollator ifNotNil:[
  self dynamicInstVarAt: #collator put: anIcuCollator .
].
%

category: 'Private'
method: BlockSorter
sortInto: anArray startingAt: index

"Returns anArray filled with objects that have been added to the receiver, in
 sorted order."
sortNodes size == 1
  ifTrue: [ (sortNodes at: 1) sortInto: anArray startingAt: index ]
  ifFalse: [
    sortNodes size == 2
      ifTrue: [ sortNodes binaryMergeAscendingInto: anArray startingAt: index  ]
      ifFalse: [  sortNodes nwayMergeAscendingInto: anArray startingAt: index ].
  ].
^ anArray
%

category: 'Accessing'
method: BlockSorter
sortNodeClassForSort

"Returns the class of SortBlockNode to use."
^ (self dynamicInstVarAt: #collator)
    ifNil:[  SortBlockNode ]
    ifNotNil:[ SortBlockUnicodeNode ]
%

category: 'Accessing'
method: BlockSorter
sortNodes

"Returns the value of the instance variable 'sortNodes'."

^sortNodes
%

category: 'Updating'
method: BlockSorter
sortNodes: anArray

sortNodes := anArray
%

category: 'Updating'
method: BlockSorter
_addObject: anObject
inNodes: nodeArray

  | lastNode |
    lastNode := nodeArray at: nodeArray size.
    " if the last sort node is full, create a new one "
    lastNode isFull
      ifTrue: [
        lastNode := lastNode class new: lastNode numElements.
        lastNode blockSorter: self.
        nodeArray add: lastNode
      ].
  " add an entry to the sort node "
  lastNode _at: anObject
    put: anObject
    forBtree: false
%

! Class extensions for 'BtreeBasicInteriorNode'

!		Class methods for 'BtreeBasicInteriorNode'

category: 'Constants'
classmethod: BtreeBasicInteriorNode
entrySize

"Returns the size of an entry (with 2 slots for encryption)."

^ 4 "2 + self _encryptionSize"
%

category: 'Constants'
classmethod: BtreeBasicInteriorNode
maxNumberOfElements

"Returns the number of entries that are allowed in a leaf node."

^ 500 "2000 / self entrySize"
%

!		Instance methods for 'BtreeBasicInteriorNode'

category: 'Constants'
method: BtreeBasicInteriorNode
entrySize

"Returns the size of an entry (with 2 slots for encryption)."

^ 4 "2 + self _encryptionSize"
%

category: 'Constants'
method: BtreeBasicInteriorNode
mergeThreshold

"Returns the threshold such that if an entry has less than this number, it must
 have elements added from its sibling or be merged with its sibling.  This
 amount is usually the same as the result of the message
 'self maxNumberOfElements quo: 2'."

^ 250
%

category: 'Constants'
method: BtreeBasicInteriorNode
parentNodeClass

"Returns the class of node to be created as the parent when a split occurs."

^ BtreeBasicInteriorNode
%

category: 'Searching'
method: BtreeBasicInteriorNode
_binarySearchCoveringKey: aKey totalOrder: aBoolean

"Returns the index for the first entry in which aKey is found utilizing a
 binary search.  This is the first entry whose key >= aKey."

<primitive: 206>
self _primitiveFailed: #_binarySearchCoveringKey:totalOrder:
     args: { aKey . aBoolean }.
self _uncontinuableError
%

category: 'Searching'
method: BtreeBasicInteriorNode
_binarySearchCoveringKey: aKey value: aValue

"Returns the index for the entry in which aKey/aValue would be inserted.  This
 is the first entry which has its key >= aKey.  If multiple entries have the
 same key (key = aKey), then aValue is used (since entries with duplicate keys
 are inserted by the value's OOP ordering).  If the receiver is empty, returns
 1.  Uses a binary search."

<primitive: 85>
self _primitiveFailed: #_binarySearchCoveringKey:value:
     args: { aKey . aValue }.
self _uncontinuableError
%

category: 'Testing'
method: BtreeBasicInteriorNode
_canCompare: aKey withClass: aClass

"Returns true if the receiver can make comparisons with the given key, and
 false otherwise."

^ self _basicCanCompare: aKey withClass: aClass
%

category: 'Comparison Operators'
method: BtreeBasicInteriorNode
_compareKey: aKey equalToEntryAt: index

"Performs an equality comparison between aKey and the entry whose key is at the
 given index.  Use encryption to make the comparison faster."

<primitive: 40>
self _primitiveFailed: #_compareKey:equalToEntryAt: args: { aKey . index }.
self _uncontinuableError
%

category: 'Audit'
method: BtreeBasicInteriorNode
_encryptionFor: aKey

"Get the encryption for the given value and return it
 in a 2 slot Array."

<primitive: 871>
self _primitiveFailed: #_encryptionFor: args: { aKey }
%

category: 'Constants'
method: BtreeBasicInteriorNode
_encryptionSize

"Two slots are used for encryption."

^ 2
%

category: 'Accessing'
method: BtreeBasicInteriorNode
_lastIndex

"Returns the index of the last used slot in the node."

^ numElements * 4
%

category: 'Accessing'
method: BtreeBasicInteriorNode
_lastKeyIndex

"Returns the index of the key of the last entry, or zero if the node is empty."

^ numElements == 0
    ifTrue: [ 0 ]
    ifFalse: [ numElements * 4 - 2 ]
%

! Class extensions for 'BtreeBasicLeafNode'

!		Class methods for 'BtreeBasicLeafNode'

category: 'Constants'
classmethod: BtreeBasicLeafNode
entrySize

"Returns the size of an entry (with 2 slots for encryption)."

^ 4
%

category: 'Constants'
classmethod: BtreeBasicLeafNode
maxNumberOfElements

"Returns the number of entries that are allowed in a leaf node."

^ 500
%

!		Instance methods for 'BtreeBasicLeafNode'

category: 'Constants'
method: BtreeBasicLeafNode
entrySize

"Returns the size of an entry (with 2 slots for encryption)."

^ 4
%

category: 'Constants'
method: BtreeBasicLeafNode
mergeThreshold

"Returns the threshold such that if an entry has less than this number, it must
 have elements added from its sibling or be merged with its sibling.  This
 value is usually the same as the result of the message
 'self maxNumberOfElements quo: 2'."

^ 250
%

category: 'Constants'
method: BtreeBasicLeafNode
parentNodeClass

"Returns the class of node to be created as the parent when a split occurs."

^ BtreeBasicInteriorNode
%

category: 'Query Support'
method: BtreeBasicLeafNode
_addValues: aQuerySpec
start: startIndex
end: endIndex
into: collection

<primitive: 555>

^super
    _addValues: aQuerySpec
    start: startIndex
    end: endIndex
    into: collection
%

category: 'Searching'
method: BtreeBasicLeafNode
_binarySearchCoveringKey: aKey totalOrder: aBoolean

"Returns the index for the first entry in which aKey is found utilizing a
 binary search.  This is the first entry whose key >= aKey."

<primitive: 114>
self _primitiveFailed: #_binarySearchCoveringKey:totalOrder:
     args: { aKey . aBoolean }.
self _uncontinuableError
%

category: 'Searching'
method: BtreeBasicLeafNode
_binarySearchCoveringKey: aKey value: aValue

"Returns the index for the entry in which aKey/aValue would be inserted.  This
 is the first entry which has its key >= aKey.  If multiple entries have the
 same key (key = aKey), then aValue is used (since entries with duplicate keys
 are inserted by the value's OOP ordering).  If the receiver is empty, returns
 1.  Uses a binary search."

<primitive: 112>
self _primitiveFailed: #_binarySearchCoveringKey:value:
     args: { aKey . aValue }.
self _uncontinuableError
%

category: 'Searching'
method: BtreeBasicLeafNode
_binarySearchForKey: aKey value: aValue

"Returns the 'value' index whose key equality matches aKey.  If no match is
 found, returns zero.  Uses a binary search."

<primitive: 113>
self _primitiveFailed: #_binarySearchForKey:value:
     args: { aKey . aValue }.
self _uncontinuableError
%

category: 'Testing'
method: BtreeBasicLeafNode
_canCompare: aKey withClass: aClass

"Returns whether the receiver can make comparisons with the given key."

^ self _basicCanCompare: aKey withClass: aClass
%

category: 'Comparison Operators'
method: BtreeBasicLeafNode
_compareKey: aKey equalToEntryAt: index

"Performs an equality comparison between aKey and the entry whose key is at the
 given index.  Use encryption to make the comparison faster."

<primitive: 160>
self _primitiveFailed: #_compareKey:equalToEntryAt:
     args: { aKey . index }.
self _uncontinuableError
%

category: 'Audit'
method: BtreeBasicLeafNode
_encryptionFor: aKey

"Get the encryption for the given value and return it
 in a 2 slot Array."

<primitive: 871>
self _primitiveFailed: #_encryptionFor: args: { aKey }
%

category: 'Constants'
method: BtreeBasicLeafNode
_encryptionSize

"Two slots are used for encryption."

^ 2
%

category: 'Searching'
method: BtreeBasicLeafNode
_findAllValuesForIdenticalKey: aKey into: aCollection using: aComparison
  "Finds all the values for the given identical key, placing them in the
 collection.  For leaf nodes, must first find the appropriate entry, then
 iterate through successive entries until we reach the end or a key does
 not match.  Return whether the last key was equal or not (so the caller
 knows it must check the next leaf node)."

  | index maxIndex querySpec class querySpecClass |
  " find first entry that might contain the key"
  index := self _findCoveringIndexForKey: aKey totalOrder: false.
  index == 0
    ifTrue: [ ^ false ].
  maxIndex := self _lastIndex.
  querySpecClass := self collator
    ifNil: [ BtreeComparisonQuerySpec ]
    ifNotNil: [ BtreeUnicodeComparisonQuerySpec ].
  querySpec := querySpecClass key: aKey selector: #'=='.
  querySpec collator: self collator.
  class := aCollection class.
  (class == Array or: [ class == NscBuilder ])
    ifTrue: [
      querySpec
        addValuesFrom: self
        start: index
        end: maxIndex
        into: aCollection ]
    ifFalse: [
      | ar |
      ar := {}.
      querySpec
        addValuesFrom: self
        start: index
        end: maxIndex
        into: ar.
      aCollection addAll: ar ].
  ^ self _compare: aComparison key: aKey equalToEntryAt: maxIndex - 4 + 2
%

category: 'Updating'
method: BtreeBasicLeafNode
_insertEncryptionFor: aKey value: aValue startingAt: index

"Gets the encryption for the given value and places it in the receiver starting
 at the given index."

<primitive: 373>
self _primitiveFailed: #_insertEncryptionFor:value:startingAt:
     args: { aKey . aValue . index }.
self _uncontinuableError
%

category: 'Accessing'
method: BtreeBasicLeafNode
_lastIndex

"Returns the index of the last used slot in the node."

^ numElements * 4
%

category: 'Accessing'
method: BtreeBasicLeafNode
_lastKeyIndex

"Returns the index of the key of the last entry, or zero if the node is empty."

^ numElements == 0
    ifTrue: [ 0 ]
    ifFalse: [ numElements * 4 - 2 ]
%

category: 'Query Support'
method: BtreeBasicLeafNode
_traverseValues: aQuerySpec
start: startIndex
end: endIndex
previous: previousValue
into: collection

<primitive: 588>

^ super
    _traverseValues: aQuerySpec
    start: startIndex
    end: endIndex
    previous: previousValue
    into: collection
%

! Class extensions for 'BtreeComparisonForCompare'

!		Class methods for 'BtreeComparisonForCompare'

category: 'Comparison Operators'
classmethod: BtreeComparisonForCompare
compareKey: aKey equalTo: aValue

^ aKey _idxForCompareEqualTo: aValue
%

category: 'Comparison Operators'
classmethod: BtreeComparisonForCompare
compareKey: aKey greaterThan: aValue

^ aKey _idxForCompareGreaterThan: aValue
%

category: 'Comparison Operators'
classmethod: BtreeComparisonForCompare
compareKey: aKey greaterThanOrEqualTo: aValue

^ aKey _idxForCompareGreaterThanOrEqualTo: aValue
%

category: 'Comparison Operators'
classmethod: BtreeComparisonForCompare
compareKey: aKey lessThan: aValue

^ aKey _idxForCompareLessThan: aValue
%

category: 'Comparison Operators'
classmethod: BtreeComparisonForCompare
compareKey: aKey lessThanOrEqualTo: aValue

^ aKey _idxForCompareLessThanOrEqualTo: aValue
%

category: 'instance creation'
classmethod: BtreeComparisonForCompare
newForComparison
  ^ self new
%

category: 'instance creation'
classmethod: BtreeComparisonForCompare
newForComparison: aCollatorOrNil
  ^ aCollatorOrNil
    ifNil: [ self new ]
    ifNotNil: [ :collator |
      BtreeComparisonForUnicodeCompare new
        collator: collator;
        yourself ]
%

category: 'instance creation'
classmethod: BtreeComparisonForCompare
newForSort
  ^ BtreeComparisonForSort new
%

category: 'instance creation'
classmethod: BtreeComparisonForCompare
newForSort: aCollatorOrNil
  ^ aCollatorOrNil
    ifNil: [ BtreeComparisonForSort new ]
    ifNotNil: [ :collator |
      BtreeComparisonForUnicodeSort new
        collator: collator;
        yourself ]
%

category: 'Testing'
classmethod: BtreeComparisonForCompare
satisfiableQueryGreaterThan: val1 andEquals: bool1 andLessThan: val2 andEquals: bool2
  ^ ((val1 _idxForCompareGreaterThan: val2)
    or: [ (val1 _idxForCompareEqualTo: val2) and: [ (bool1 and: [ bool2 ]) not ] ])
    not
%

!		Instance methods for 'BtreeComparisonForCompare'

category: 'Comparison Operators'
method: BtreeComparisonForCompare
compareKey: aKey equalTo: aValue

^ aKey _idxForCompareEqualTo: aValue
%

category: 'Comparison Operators'
method: BtreeComparisonForCompare
compareKey: aKey greaterThan: aValue

^ aKey _idxForCompareGreaterThan: aValue
%

category: 'Comparison Operators'
method: BtreeComparisonForCompare
compareKey: aKey greaterThanOrEqualTo: aValue

^ aKey _idxForCompareGreaterThanOrEqualTo: aValue
%

category: 'Comparison Operators'
method: BtreeComparisonForCompare
compareKey: aKey lessThan: aValue

^ aKey _idxForCompareLessThan: aValue
%

category: 'Comparison Operators'
method: BtreeComparisonForCompare
compareKey: aKey lessThanOrEqualTo: aValue

^ aKey _idxForCompareLessThanOrEqualTo: aValue
%

category: 'Testing'
method: BtreeComparisonForCompare
satisfiableQueryGreaterThan: val1 andEquals: bool1 andLessThan: val2 andEquals: bool2
  ^ ((val1 _idxForCompareGreaterThan: val2)
    or: [ (val1 _idxForCompareEqualTo: val2) and: [ (bool1 and: [ bool2 ]) not ] ])
    not
%

! Class extensions for 'BtreeComparisonForIdentity'

!		Class methods for 'BtreeComparisonForIdentity'

category: 'Instance Creation'
classmethod: BtreeComparisonForIdentity
newForSort
  ^ self new
%

!		Instance methods for 'BtreeComparisonForIdentity'

category: 'Comparison Operators'
method: BtreeComparisonForIdentity
compareKey: aKey equalTo: aValue
  ^ aKey == aValue
%

category: 'Comparison Operators'
method: BtreeComparisonForIdentity
compareKey: aKey greaterThan: aValue
  ^ aKey asOop > aValue asOop
%

category: 'Comparison Operators'
method: BtreeComparisonForIdentity
compareKey: aKey greaterThanOrEqualTo: aValue
  ^ aKey asOop >= aValue asOop
%

category: 'Comparison Operators'
method: BtreeComparisonForIdentity
compareKey: aKey lessThan: aValue
  ^ aKey asOop < aValue asOop
%

category: 'Comparison Operators'
method: BtreeComparisonForIdentity
compareKey: aKey lessThanOrEqualTo: aValue
  ^ aKey asOop <= aValue asOop
%

category: 'Testing'
method: BtreeComparisonForIdentity
satisfiableQueryGreaterThan: val1 andEquals: bool1 andLessThan: val2 andEquals: bool2

  ^ ((val1 _idxForCompareGreaterThan: val2)
    or: [ (val1 _idxForSortEqualTo: val2) and: [ (bool1 and: [ bool2 ]) not ] ])
    not
%

! Class extensions for 'BtreeComparisonForSort'

!		Class methods for 'BtreeComparisonForSort'

category: 'Comparison Operators'
classmethod: BtreeComparisonForSort
compareKey: aKey equalTo: aValue

^ aKey _idxForSortEqualTo: aValue
%

category: 'Comparison Operators'
classmethod: BtreeComparisonForSort
compareKey: aKey greaterThan: aValue

^ aKey _idxForSortGreaterThan: aValue
%

category: 'Comparison Operators'
classmethod: BtreeComparisonForSort
compareKey: aKey greaterThanOrEqualTo: aValue

^ aKey _idxForSortGreaterThanOrEqualTo: aValue
%

category: 'Comparison Operators'
classmethod: BtreeComparisonForSort
compareKey: aKey lessThan: aValue

^ aKey _idxForSortLessThan: aValue
%

category: 'Comparison Operators'
classmethod: BtreeComparisonForSort
compareKey: aKey lessThanOrEqualTo: aValue

^ aKey _idxForSortLessThanOrEqualTo: aValue
%

category: 'Testing'
classmethod: BtreeComparisonForSort
satisfiableQueryGreaterThan: val1
andEquals: bool1
andLessThan: val2
andEquals: bool2


  ^( (val1 _idxForCompareGreaterThan: val2) or:
      [ (val1 _idxForSortEqualTo: val2) and: [ (bool1 and:[bool2]) not ] ] ) not
%

!		Instance methods for 'BtreeComparisonForSort'

category: 'Comparison Operators'
method: BtreeComparisonForSort
compareKey: aKey equalTo: aValue

^ aKey _idxForSortEqualTo: aValue
%

category: 'Comparison Operators'
method: BtreeComparisonForSort
compareKey: aKey greaterThan: aValue

^ aKey _idxForSortGreaterThan: aValue
%

category: 'Comparison Operators'
method: BtreeComparisonForSort
compareKey: aKey greaterThanOrEqualTo: aValue

^ aKey _idxForSortGreaterThanOrEqualTo: aValue
%

category: 'Comparison Operators'
method: BtreeComparisonForSort
compareKey: aKey lessThan: aValue

^ aKey _idxForSortLessThan: aValue
%

category: 'Comparison Operators'
method: BtreeComparisonForSort
compareKey: aKey lessThanOrEqualTo: aValue

^ aKey _idxForSortLessThanOrEqualTo: aValue
%

category: 'Testing'
method: BtreeComparisonForSort
satisfiableQueryGreaterThan: val1
andEquals: bool1
andLessThan: val2
andEquals: bool2


  ^( (val1 _idxForCompareGreaterThan: val2) or:
      [ (val1 _idxForSortEqualTo: val2) and: [ (bool1 and:[bool2]) not ] ] ) not
%

! Class extensions for 'BtreeComparisonForUnicodeCompare'

!		Instance methods for 'BtreeComparisonForUnicodeCompare'

category: 'initialization'
method: BtreeComparisonForUnicodeCompare
collator: anIcuCollator
  collator := anIcuCollator
%

category: 'Comparison Operators'
method: BtreeComparisonForUnicodeCompare
compareKey: aKey equalTo: aValue
  ^ aKey _idxForCompareEqualTo: aValue collator: collator
%

category: 'Comparison Operators'
method: BtreeComparisonForUnicodeCompare
compareKey: aKey greaterThan: aValue
  ^ aKey _idxForCompareGreaterThan: aValue collator: collator
%

category: 'Comparison Operators'
method: BtreeComparisonForUnicodeCompare
compareKey: aKey greaterThanOrEqualTo: aValue
  ^ aKey _idxForCompareGreaterThanOrEqualTo: aValue collator: collator
%

category: 'Comparison Operators'
method: BtreeComparisonForUnicodeCompare
compareKey: aKey lessThan: aValue
  ^ aKey _idxForCompareLessThan: aValue collator: collator
%

category: 'Comparison Operators'
method: BtreeComparisonForUnicodeCompare
compareKey: aKey lessThanOrEqualTo: aValue
  ^ aKey _idxForCompareLessThanOrEqualTo: aValue collator: collator
%

category: 'Testing'
method: BtreeComparisonForUnicodeCompare
satisfiableQueryGreaterThan: val1 andEquals: bool1 andLessThan: val2 andEquals: bool2
  ^ ((val1 _idxForCompareGreaterThan: val2 collator: collator)
    or: [
      (val1 _idxForCompareEqualTo: val2 collator: collator)
        and: [ (bool1 and: [ bool2 ]) not ] ])
    not
%

! Class extensions for 'BtreeComparisonForUnicodeSort'

!		Instance methods for 'BtreeComparisonForUnicodeSort'

category: 'initialization'
method: BtreeComparisonForUnicodeSort
collator: anIcuCollator
  collator := anIcuCollator
%

category: 'Comparison Operators'
method: BtreeComparisonForUnicodeSort
compareKey: aKey equalTo: aValue
  ^ aKey _idxForSortEqualTo: aValue collator: collator
%

category: 'Comparison Operators'
method: BtreeComparisonForUnicodeSort
compareKey: aKey greaterThan: aValue
  ^ aKey _idxForSortGreaterThan: aValue collator: collator
%

category: 'Comparison Operators'
method: BtreeComparisonForUnicodeSort
compareKey: aKey greaterThanOrEqualTo: aValue
  ^ aKey _idxForSortGreaterThanOrEqualTo: aValue collator: collator
%

category: 'Comparison Operators'
method: BtreeComparisonForUnicodeSort
compareKey: aKey lessThan: aValue
  ^ aKey _idxForSortLessThan: aValue collator: collator
%

category: 'Comparison Operators'
method: BtreeComparisonForUnicodeSort
compareKey: aKey lessThanOrEqualTo: aValue
  ^ aKey _idxForSortLessThanOrEqualTo: aValue collator: collator
%

category: 'Testing'
method: BtreeComparisonForUnicodeSort
satisfiableQueryGreaterThan: val1 andEquals: bool1 andLessThan: val2 andEquals: bool2
  ^ ((val1 _idxForCompareGreaterThan: val2 collator: collator)
    or: [
      (val1 _idxForSortEqualTo: val2 collator: collator)
        and: [ (bool1 and: [ bool2 ]) not ] ])
    not
%

! Class extensions for 'BtreeComparisonQuerySpec'

!		Class methods for 'BtreeComparisonQuerySpec'

category: 'Instance Creation'
classmethod: BtreeComparisonQuerySpec
key: aKey selector: aSelector

^self new key: aKey selector: aSelector
%

!		Instance methods for 'BtreeComparisonQuerySpec'

category: 'Accessing'
method: BtreeComparisonQuerySpec
collator
  ^ nil
%

category: 'Accessing'
method: BtreeComparisonQuerySpec
collator: ignored
  "ignored"


%

category: 'Comparing'
method: BtreeComparisonQuerySpec
compare: entry using: selector
  ^ entry perform: selector with: key
%

category: 'Comparing'
method: BtreeComparisonQuerySpec
compareKey: entry
  ^ entry perform: (self performSelector: opCode) with: key
%

category: 'Updating'
method: BtreeComparisonQuerySpec
key: aKey selector: aSelector

key := aKey.
opCode := self operationSelectors indexOf: aSelector.
%

category: 'Accessing'
method: BtreeComparisonQuerySpec
operationSelectors

"Returns an Array of comparison operation selectors whose ordering corresponds
 to the operation integer for each predicate entry in the receiver."

^ #( #< #> #= #== #<= #>= #~= #~~)
%

category: 'Accessing'
method: BtreeComparisonQuerySpec
performSelector: anOpCode

^self performSelectors at: anOpCode
%

category: 'Accessing'
method: BtreeComparisonQuerySpec
performSelectors

"Returns an Array of comparison operation selectors whose ordering corresponds
 to the operation selectors."

^ #( #_idxForCompareLessThan:
    #_idxForCompareGreaterThan:
    #_idxForCompareEqualTo:
    #==
    #_idxForCompareLessThanOrEqualTo:
    #_idxForCompareGreaterThanOrEqualTo:
    #_idxForCompareNotEqualTo:
    #~~
  )
%

category: 'Querying'
method: BtreeComparisonQuerySpec
_addRootObjectsFrom: aLeafNode entrySize: entrySize start: startIndex end: endIndex into: collection
  | sel |
  sel := self performSelector: opCode.
  startIndex to: endIndex by: entrySize do: [ :i |
    (self compare: (aLeafNode keyAt: i) using: sel)
      ifTrue: [ collection add: (aLeafNode rootObjectAt: i) ] ]
%

category: 'Querying'
method: BtreeComparisonQuerySpec
_addValuesFrom: aLeafNode entrySize: entrySize start: startIndex end: endIndex into: collection
  | sel |
  sel := self performSelector: opCode.
  startIndex to: endIndex by: entrySize do: [ :i |
    (self compare: (aLeafNode _basicAt: i + 1) using: sel)
      ifTrue: [ collection add: (aLeafNode _basicAt: i) ] ]
%

category: 'Querying'
method: BtreeComparisonQuerySpec
_traverseValuesFrom: aLeafNode entrySize: entrySize start: startIndex end: endIndex previous: previousValue into: collection
  | val prevVal aKey sel |
  sel := self performSelector: opCode.
  prevVal := previousValue.
  startIndex to: endIndex by: entrySize do: [ :i |
    aKey := aLeafNode _basicAt: i + 1.
    val := aLeafNode _basicAt: i.
    ((self compare: aKey using: sel) and: [ val ~~ prevVal ])
      ifTrue: [
        rangeIndex
          _addAllFor: val
          into: collection
          offset: offset
          pathTerm: pathTerm ].
    prevVal := val ].
  ^ prevVal
%

! Class extensions for 'BtreeInteriorNode'

!		Instance methods for 'BtreeInteriorNode'

category: 'Updating'
method: BtreeInteriorNode
at: aKey put: aValue

"Adds the key/value pair to one of the leaf nodes.  If a split occurs, returns
 the new sibling, otherwise returns the receiver."

| index node returnNode newSibling lastKeyIndex lastChildKey lastChildKeyIndex |

index := self _binarySearchCoveringKey: aKey value: aValue.

lastKeyIndex := self _lastKeyIndex.
" if insertion would occur past the last entry, use the last entry "
index > lastKeyIndex
    ifTrue: [ index := lastKeyIndex - 1 ].

node := super at: index.
returnNode := node at: aKey put: aValue.

" see if last key in child node has changed "
lastChildKeyIndex := node _lastKeyIndex.
lastChildKey := node _at: lastChildKeyIndex.
(lastChildKey == (super at: (index + 1)))
    ifFalse: [ " update key and encryption in the receiver "
        self primitiveAt: (index + 1) put: lastChildKey.
        self _insertEncryptionFor: lastChildKey value: node startingAt: (index + 2)
    ].

" see if a split occurred "
returnNode == node
    ifTrue: [
        " if inserted into the last node, update the last value "
        (index == (lastKeyIndex - 1))
            ifTrue: [ self _updateLastValue ].
    ]
    ifFalse: [ " returnNode is the second half of the split "

        " determine if a split is needed in the receiver "
        numElements == self class maxNumberOfElements
            ifTrue: [
                newSibling :=
                    self _splitUsingKey: (returnNode _at: returnNode _lastKeyIndex)
                        value: returnNode.

                " update the last value of the new sibling and the receiver "
                newSibling lastValue:
                    (newSibling at: (newSibling _lastKeyIndex - 1)) lastValue.
                lastValue := (super at: (self _lastKeyIndex - 1)) lastValue.

                ^ newSibling
            ]
            ifFalse: [ " entry will fit in the receiver "

                " if child node was the last node "
                index == (lastKeyIndex - 1)
                    ifTrue: [ lastValue := returnNode lastValue ].

                self
                    _insertKey: (returnNode _at: returnNode _lastKeyIndex)
                    value: returnNode
                    atIndex: (index + returnNode entrySize)
            ]
    ]
%

category: 'Updating'
method: BtreeInteriorNode
btreeAt: aKey put: aValue

""

^ self at: aKey put: aValue
%

category: 'Accessing'
method: BtreeInteriorNode
lastValue

"Returns the value of the instance variable 'lastValue'."

^ lastValue
%

category: 'Updating'
method: BtreeInteriorNode
lastValue: newValue

"Modifies the value of the instance variable 'lastValue'."

lastValue := newValue
%

category: 'Constants'
method: BtreeInteriorNode
mergeThreshold

"Returns the threshold such that if an entry has less than this number, it must
 have elements added from its sibling or be merged with its sibling.  This
 value is usually the same as the result of the message
 'self maxNumberOfElements quo: 2'."

^ 500
%

category: 'Private'
method: BtreeInteriorNode
numElementsInStack: array
level: level
endNode: endNode
endIndex: endIndex
into: result

"Puts the count in the first slot in the argument array and returns whether we
 reached the end."

| count finished |
" save current count "
count := result at: 1.

" for each child node starting at the node on the stack "
(array at: level) to: (numElements * self entrySize) by: self entrySize do: [ :i |
    " reset the count to zero "
    result at: 1 put: 0.

    " recursive call to child node "
    finished := (super at: i) numElementsInStack: array
        level: level - 2
        endNode: endNode
        endIndex: endIndex
        into: result.

    " accumulate the count "
    count := count + (result at: 1).
    " if reached the end node, put the count in the result Array "
    finished
        ifTrue: [
            result at: 1 put: count.
            ^ true
        ]
].
" put the count in the result Array "
result at: 1 put: count.
^ false
%

category: 'Accessing'
method: BtreeInteriorNode
objectSecurityPolicy: anObjectSecurityPolicy

"Assign the receiver and its leaf nodes the given security policy."

super objectSecurityPolicy: anObjectSecurityPolicy.

1 to: (numElements * self entrySize) by: self entrySize do: [ :i |
    (super at: i) objectSecurityPolicy: anObjectSecurityPolicy
]
%

category: 'Printing'
method: BtreeInteriorNode
printOn: aStream withIndentationLevel: anInteger

"Puts a displayable representation of the keys of the receiver on the given
 stream, indenting the given number of spaces."

anInteger timesRepeat: [ aStream nextPut: Character space ].
aStream nextPutAll: '[ ';
    nextPutAll: lastValue asString;
    nextPutAll: ' ]';

    "nextPutAll: '  { '; nextPutAll: self _alias asString; nextPutAll: ' }';"
    nextPut: Character lf.

1 to: (numElements * self entrySize) by: self entrySize do: [ :i |
    anInteger timesRepeat: [ aStream nextPut: Character space ].
    aStream nextPutAll: (super at: (i + 1)) asString; nextPut: Character lf.
    (super at: i) printOn: aStream withIndentationLevel: (anInteger + 4)
]
%

category: 'Printing'
method: BtreeInteriorNode
printOn: aStream withIndentationLevel: anInteger includingValues: aBoolean

"Puts a displayable representation of the keys of the receiver on the given
 stream, indenting the given number of spaces."

aBoolean
    ifTrue: [
        anInteger timesRepeat: [ aStream nextPut: Character space ].
        aStream nextPutAll: '[ ';
            nextPutAll: lastValue asString;
            nextPutAll: ' ]';
            "nextPutAll: '  { '; nextPutAll: self _alias asString; nextPutAll: ' }';"
            nextPut: Character lf.
    ].

1 to: (numElements * self entrySize) by: self entrySize do: [ :i |
    anInteger timesRepeat: [ aStream nextPut: Character space ].
    aStream nextPutAll: (super at: (i + 1)) asString; nextPut: Character lf.
    (super at: i) printOn: aStream withIndentationLevel: (anInteger + 4) includingValues: aBoolean
]
%

category: 'Removing'
method: BtreeInteriorNode
removeKey: aKey value: aValue

"Removes the key/value pair.  Find the appropriate child node and invoke the
 remove operation on it.  If the remove occurred, check if a merge or coalesce
 is necessary."

| nodeIndex node lastChildKeyIndex lastChildKey |
(self _compareLastKeyLessThanOrEqualToKey: aKey value: aValue)
    ifFalse: [ ^ false ].

nodeIndex := self _binarySearchCoveringKey: aKey value: aValue.
node := super at: nodeIndex.

(node removeKey: aKey value: aValue)
    ifTrue: [ " remove occurred "

        " see if last key in child node has changed "
        lastChildKeyIndex := node _lastKeyIndex.
        lastChildKey := node at: lastChildKeyIndex.
        (lastChildKey == (super at: (nodeIndex + 1)))
            ifFalse: [ " update key and encryption in the receiver "
                self primitiveAt: (nodeIndex + 1) put: lastChildKey.
                self
                    _insertEncryptionFor: lastChildKey
                    value: node
                    startingAt: (nodeIndex + 2)
            ].

        " see if the node's number of entries is below the threshold "
        node numElements < node mergeThreshold
            ifTrue: [ " try to steal entries from a neighboring sibling "
                (self _attemptTakingFromNeighborForNodeAt: nodeIndex)
                    ifFalse: [
                        " could not take from neighbor, merge with a neighbor instead "
                        self _mergeFromNeighborForNodeAt: nodeIndex
                    ]
            ].

        self _updateLastValue.

        ^ true
    ]
    ifFalse: [ ^ false ]
%

category: 'Printing'
method: BtreeInteriorNode
stringRep

""

| aStream |

aStream := PrintStream printingOn: String new.

1 to: (numElements * self entrySize) by: self entrySize do: [ :i |
    aStream nextPutAll: (super at: (i + 1)) asString; nextPut: Character space
].
aStream nextPut: Character lf.
^ aStream contents
%

category: 'Accessing'
method: BtreeInteriorNode
totalElements

"Return the total number of elements in the leaf nodes."

| sum |

sum := 0.
1 to: (numElements * self entrySize) by: self entrySize do: [ :i |
    sum := sum + (super at: i) totalElements
].
^ sum
%

category: 'RC Updating'
method: BtreeInteriorNode
_at: aKey put: aValue for: anIndexObj selectiveAbortSet: selectiveAbortSetOrNil

"Adds the key/value pair to one of the leaf nodes.  If a split occurs, returns
 the new sibling, otherwise returns the receiver."

| index node returnNode newSibling lastKeyIndex lastChildKey lastChildKeyIndex |

index := self _binarySearchCoveringKey: aKey value: aValue.

lastKeyIndex := self _lastKeyIndex.
" if insertion would occur past the last entry, use the last entry "
index > lastKeyIndex
    ifTrue: [ index := lastKeyIndex - 1 ].

node := super at: index.
returnNode := node btreeAt: aKey put: aValue for: anIndexObj selectiveAbortSet: selectiveAbortSetOrNil.

" see if last key in child node has changed "
lastChildKeyIndex := node _lastKeyIndex.
lastChildKey := node _at: lastChildKeyIndex.
(lastChildKey == (super at: (index + 1)))
    ifFalse: [ " update key and encryption in the receiver "
        self primitiveAt: (index + 1) put: lastChildKey.
        self _insertEncryptionFor: lastChildKey value: node startingAt: (index + 2)
    ].

" see if a split occurred "
returnNode == node
    ifTrue: [
        " if inserted into the last node, update the last value "
        (index == (lastKeyIndex - 1))
            ifTrue: [ self _updateLastValue ].
    ]
    ifFalse: [ " returnNode is the second half of the split "

          selectiveAbortSetOrNil ~~ nil ifTrue: [ selectiveAbortSetOrNil add: returnNode ].
        System _addRootObjectToRcReadSet: returnNode.
        System redoLog addConflictObject: returnNode for: anIndexObj.
        " determine if a split is needed in the receiver "
        numElements == self class maxNumberOfElements
            ifTrue: [
                newSibling :=
                    self _splitUsingKey: (returnNode _at: returnNode _lastKeyIndex)
                        value: returnNode.

                " update the last value of the new sibling and the receiver "
                newSibling lastValue:
                    (newSibling at: (newSibling _lastKeyIndex - 1)) lastValue.
                lastValue := (super at: (self _lastKeyIndex - 1)) lastValue.

                ^ newSibling
            ]
            ifFalse: [ " entry will fit in the receiver "

                " if child node was the last node "
                index == (lastKeyIndex - 1)
                    ifTrue: [ lastValue := returnNode lastValue ].

                self
                    _insertKey: (returnNode _at: returnNode _lastKeyIndex)
                    value: returnNode
                    atIndex: (index + returnNode entrySize)
            ]
    ]
%

category: 'Removing'
method: BtreeInteriorNode
_attemptTakingFromNeighborForNodeAt: nodeIndex

"The node at the given index has too few entries, so try to take entries from
 one of its neighboring siblings.  First try the next (right) sibling, then
 the previous (left) sibling."

| node sibling eSize siblingLoss numSiblingElements copyStart copyEnd
fromNextSibling fromPreviousSibling targetStart lastChildKey
siblingLastIdx numToMove |

node := super at: nodeIndex.
fromNextSibling := false.  " is true if taken from next sibling "
fromPreviousSibling := false.  " is true if taken from previous sibling "

eSize := node entrySize.
" check if the node is the last entry "
nodeIndex == (self _lastKeyIndex - 1)
    ifFalse: [ " this is not the last entry, check the next sibling "
        sibling := super at: (nodeIndex + self entrySize).
        numSiblingElements := sibling numElements.
        numSiblingElements < (node mergeThreshold + 1)
            ifFalse: [ " can take entries from next sibling "
                fromNextSibling := true.
                siblingLoss := (numSiblingElements - node mergeThreshold) quo: 2.
                siblingLoss == 0 ifTrue: [ siblingLoss := 1 ].
                copyStart := 1.
                copyEnd := siblingLoss * eSize.
                numToMove := 0 .
                targetStart := node _lastIndex + 1
            ]
    ].

" if could not get entries from next sibling and this is not the first entry "
(fromNextSibling not and: [ nodeIndex > 1 ] )
    ifTrue: [ " try previous entry "
        sibling := super at: (nodeIndex - self entrySize).
        numSiblingElements := sibling numElements.
        numSiblingElements < (node mergeThreshold + 1)
            ifFalse: [ " can take entries from previous sibling "
                fromPreviousSibling := true.
                siblingLoss := (numSiblingElements - node mergeThreshold) quo: 2.
                siblingLoss == 0 ifTrue: [ siblingLoss := 1 ].
                copyStart := (numSiblingElements - siblingLoss) * eSize + 1.
                copyEnd := numSiblingElements * eSize.
                numToMove := (node numElements) * eSize .
                targetStart := 1
            ]
    ].

" if cannot take from previous or next sibling "
(fromPreviousSibling or:[ fromNextSibling ])
    ifFalse: [ ^ false ].

" copy from sibling and insert into node "
node _insertAt: targetStart
     from: sibling fromStart: copyStart fromEnd: copyEnd
     numToMoveDown: numToMove .

node numElements: (node numElements + siblingLoss).

fromNextSibling
    ifTrue: [
        " shift next sibling entries "
        sibling _deleteNoShrinkFrom: copyStart to: copyEnd .

        sibling numElements: (numSiblingElements - siblingLoss).

        " update the receiver's key for this entry "
        lastChildKey := node at: (node _lastKeyIndex).
        self primitiveAt: (nodeIndex + 1) put: lastChildKey.
        self _insertEncryptionFor: lastChildKey value: node startingAt: (nodeIndex + 2).

        node _updateLastValue
    ].

fromPreviousSibling
    ifTrue: [
        sibling numElements: (numSiblingElements - siblingLoss).

        " update the receiver's key for previous entry "
        siblingLastIdx := sibling _lastKeyIndex .
        lastChildKey := sibling at: siblingLastIdx .
        self  primitiveAt: (nodeIndex + 1 - eSize) put: (sibling at: siblingLastIdx ).
        self _insertEncryptionFor: lastChildKey value: sibling startingAt: (nodeIndex + 2 - eSize).

        sibling _updateLastValue .

       " nil out sibling entries at end "
        sibling _deleteNoShrinkFrom: copyStart to: copyEnd .
    ].

^ true
%

category: 'RC Removing'
method: BtreeInteriorNode
_attemptTakingFromNeighborForNodeAt: nodeIndex for: anIndexObj selectiveAbortSet: selectiveAbortSetOrNil

"The node at the given index has too few entries, so try to take entries from
 one of its neighboring siblings.  First try the next (right) sibling, then
 the previous (left) sibling."

| node sibling eSize siblingLoss numSiblingElements copyStart copyEnd
fromNextSibling fromPreviousSibling targetStart lastChildKey
siblingLastIdx numToMove |

node := super at: nodeIndex.
(selectiveAbortSetOrNil ~~ nil and: [ (selectiveAbortSetOrNil includes: node) not ])
        ifTrue: [
                selectiveAbortSetOrNil add: node.
                node _selectiveAbort ].
fromNextSibling := false.  " is true if taken from next sibling "
fromPreviousSibling := false.  " is true if taken from previous sibling "

eSize := node entrySize.
" check if the node is the last entry "
nodeIndex == (self _lastKeyIndex - 1)
    ifFalse: [ " this is not the last entry, check the next sibling "
        sibling := super at: (nodeIndex + self entrySize).
          (selectiveAbortSetOrNil ~~ nil and: [ (selectiveAbortSetOrNil includes: sibling) not ])
                ifTrue: [
                        selectiveAbortSetOrNil add: sibling.
                        sibling _selectiveAbort ].
        numSiblingElements := sibling numElements.
        numSiblingElements < (node mergeThreshold + 1)
            ifFalse: [ " can take entries from next sibling "
                fromNextSibling := true.
                siblingLoss := (numSiblingElements - node mergeThreshold) quo: 2.
                siblingLoss == 0 ifTrue: [ siblingLoss := 1 ].
                copyStart := 1.
                copyEnd := siblingLoss * eSize.
                numToMove := 0 .
                targetStart := node _lastIndex + 1
            ]
    ].

" if could not get entries from next sibling and this is not the first entry "
(fromNextSibling not and: [ nodeIndex > 1 ] )
    ifTrue: [ " try previous entry "
        sibling := super at: (nodeIndex - self entrySize).
          (selectiveAbortSetOrNil ~~ nil and: [ (selectiveAbortSetOrNil includes: sibling) not ])
                ifTrue: [
                        selectiveAbortSetOrNil add: sibling.
                        sibling _selectiveAbort ].
        numSiblingElements := sibling numElements.
        numSiblingElements < (node mergeThreshold + 1)
            ifFalse: [ " can take entries from previous sibling "
                fromPreviousSibling := true.
                siblingLoss := (numSiblingElements - node mergeThreshold) quo: 2.
                siblingLoss == 0 ifTrue: [ siblingLoss := 1 ].
                copyStart := (numSiblingElements - siblingLoss) * eSize + 1.
                copyEnd := numSiblingElements * eSize.
                numToMove := (node numElements) * eSize .
                targetStart := 1
            ]
    ].

" if cannot take from previous or next sibling "
(fromPreviousSibling or:[ fromNextSibling ])
    ifFalse: [ ^ false ].

" copy from sibling and insert into node "
node _insertAt: targetStart
     from: sibling fromStart: copyStart fromEnd: copyEnd
     numToMoveDown: numToMove .

node numElements: (node numElements + siblingLoss).

fromNextSibling
    ifTrue: [
        " shift next sibling entries "
        sibling _deleteNoShrinkFrom: copyStart to: copyEnd .

        sibling numElements: (numSiblingElements - siblingLoss).

        " update the receiver's key for this entry "
        lastChildKey := node at: (node _lastKeyIndex).
        self primitiveAt: (nodeIndex + 1) put: lastChildKey.
        self _insertEncryptionFor: lastChildKey value: node startingAt: (nodeIndex + 2).

        node _updateLastValue
    ].

fromPreviousSibling
    ifTrue: [
        sibling numElements: (numSiblingElements - siblingLoss).

        " update the receiver's key for previous entry "
        siblingLastIdx := sibling _lastKeyIndex .
        lastChildKey := sibling at: siblingLastIdx .
        self  primitiveAt: (nodeIndex + 1 - eSize) put: (sibling at: siblingLastIdx ).
        self _insertEncryptionFor: lastChildKey value: sibling startingAt: (nodeIndex + 2 - eSize).

        sibling _updateLastValue .

       " nil out sibling entries at end "
        sibling _deleteNoShrinkFrom: copyStart to: copyEnd .
    ].

System _addRootObjectToRcReadSet: node.
System _addRootObjectToRcReadSet: sibling.
System redoLog addConflictObject: node for: anIndexObj.
System redoLog addConflictObject: sibling for: anIndexObj.
^ true
%

category: 'Audit'
method: BtreeInteriorNode
_auditChildConsistencyError: pathTerm key: k lastChildKey: lastChildKey childNode: childNode index: index on: aString
  pathTerm
    auditInfo:
      {k.
      nil.
      nil}
    on: aString.
  aString
    add: 'Btree interior node [';
    add: self asOop asString;
    add: '] at index: ';
    add: index asString;
    add: ' has key ';
    add: k printString printString;
    add: ' [';
    add: k asOop asString;
    add: '] that does not match the last key ';
    add: lastChildKey printString printString;
    add: ' [';
    add: lastChildKey asOop asString;
    add: ' ] of the child node [';
    add: childNode asOop asString;
    add: ']';
    add: Character lf.
  BtreePlusNodeAuditor checkDebug: aString 
%

category: 'Audit'
method: BtreeInteriorNode
_auditEncryptionError: pathTerm key: k index: index encryptedEntry: encryptedEntry encryptedKey: encryptedKey on: aString
  pathTerm
    auditInfo:
      {k.
      nil.
      nil}
    on: aString.
  aString
    add: 'Btree interior node[';
    add: self asOop asString;
    add: '] at index: ';
    add: index asString;
    add: ' has encryptedKey associated with key [';
    add: k asOop asString;
    add: '] that is [';
    add: (encryptedEntry at: 1) asOop asString;
    add: ', ';
    add: (encryptedEntry at: 2) asOop asString;
    add: '] but should be [';
    add: (encryptedKey at: 1) asOop asString;
    add: ', ';
    add: (encryptedKey at: 2) asOop asString;
    add: ']';
    add: Character lf .
  BtreePlusNodeAuditor checkDebug: aString 
%

category: 'Audit'
method: BtreeInteriorNode
_auditKeyOrderError: pathTerm key: k previousKey: previousKey index: index on: aString
  pathTerm
    auditInfo:
      {k.
      nil.
      nil}
    on: aString.
  aString
    add: 'Btree interior node [';
    add: self asOop asString;
    add: '] at index: ';
    add: index asString;
    add: ' has key ';
    add: k printString printString;
    add: ' out of order [';
    add: k asOop asString;
    add: '] that sorts greater than previous key';
    add: previousKey printString printString;
    add: ' [';
    add: previousKey asOop asString;
    add: ']';
    add: Character lf .
  BtreePlusNodeAuditor checkDebug: aString 
%

category: 'Audit'
method: BtreeInteriorNode
_auditLeafKeysValuesAndEncryptedFor: pathTerm on: aString do: aBlock
  "Audit the receiver's entries and each child node"

  | sentinel previousKey comparisonForSort |
  sentinel := Object new.
  previousKey := sentinel.
  comparisonForSort := self comparisonForSort.
  1 to: numElements * self entrySize by: self entrySize do: [ :i | | child k encryptedEntry encryptedKey lastChildKey |
    k := self _at: i + 1.
    previousKey == sentinel
      ifFalse: [ (comparisonForSort compareKey: previousKey lessThanOrEqualTo: k)
          ifFalse: [ self
              _auditKeyOrderError: pathTerm
              key: k
              previousKey: previousKey
              index: i
              on: aString ] ].
    previousKey := k.
    child := super at: i.
    lastChildKey := child at: child _lastKeyIndex.
    lastChildKey == k
      ifFalse: [ self
          _auditChildConsistencyError: pathTerm
          key: k
          lastChildKey: lastChildKey
          childNode: child
          index: i
          on: aString ].
    self _encryptionSize == 2
      ifTrue: [ encryptedEntry := {(self _at: i + 2).
        (self _at: i + 3)}.
        encryptedKey := self _encryptionFor: k.
        encryptedEntry = encryptedKey
          ifFalse: [ self
              _auditEncryptionError: pathTerm
              key: k
              index: i
              encryptedEntry: encryptedEntry
              encryptedKey: encryptedKey
              on: aString ] ].
    child _auditLeafKeysValuesAndEncryptedFor: pathTerm on: aString do: aBlock	"audit child node" ]
%

category: 'Comparison Operators'
method: BtreeInteriorNode
_compare: comparisonForSort key: aKey value: aValue equalToEntryAt: index
  "Performs a = comparison between aKey and the entry whose key is at the given
 index.  If the keys are equal, use the OOP of the value as the next basis for
 comparison.  For interior nodes, the value is the last value stored in the
 last leaf node.  The default implementation uses no encryption."

  ^ (comparisonForSort compareKey: aKey equalTo: (super at: index))
    and: [ aValue asOop = (super at: index - 1) lastValue asOop ]
%

category: 'Comparison Operators'
method: BtreeInteriorNode
_compare: comparisonForSort key: aKey value: aValue lessThanOrEqualToEntryAt: index
  "Performs a <= comparison between aKey and the entry whose key is at the given
 index.  If the keys are equal, then use the OOP of the value for the
 comparison.  For interior nodes, the value is the last value stored in the
 last leaf node.  The default implementation uses no encryption."

  " first compare the keys "

  (comparisonForSort compareKey: aKey lessThan: (super at: index))
    ifTrue: [ ^ true ]. " if the keys are equal, use the OOP of the value "
  (comparisonForSort compareKey: aKey equalTo: (super at: index))
    ifTrue: [ ^ aValue asOop <= (super at: index - 1) lastValue asOop ].
  ^ false
%

category: 'Comparison Operators'
method: BtreeInteriorNode
_compareKey: aKey value: aValue equalToEntryAt: index

"Performs a = comparison between aKey and the entry whose key is at the given
 index.  If the keys are equal, use the OOP of the values as the next basis for
 comparison.  For interior nodes, the value is the last value stored in the
 last leaf node.  The default implementation uses no encryption."

^ (aKey _idxForSortEqualTo: (super at: index)) and:
  [ aValue asOop = (super at: index - 1) lastValue asOop ]
%

category: 'Comparison Operators'
method: BtreeInteriorNode
_compareKey: aKey value: aValue greaterThanEntryAt: index

"Performs a > comparison between aKey and the entry whose key is at the given
 index.  If the keys are equal, then use the OOP of the value for the
 comparison.  The default implementation uses no encryption."

" first compare the keys "
( aKey _idxForSortGreaterThan: (super at: index) )
    ifTrue: [ ^ true ].

^ false
%

category: 'Comparison Operators'
method: BtreeInteriorNode
_compareKey: aKey value: aValue lessThanEntryAt: index

"Performs a < comparison between aKey and the entry whose key is at the given
 index.  If the keys are equal, then use the OOP of the value for the
 comparison.  The default implementation uses no encryption."

" first compare the keys "
( aKey _idxForSortLessThan: (super at: index) )
    ifTrue: [ ^ true ].

^ false
%

category: 'Comparison Operators'
method: BtreeInteriorNode
_compareKey: aKey value: aValue lessThanOrEqualToEntryAt: index

"Performs a <= comparison between aKey and the entry whose key is at the given
 index.  If the keys are equal, then use the OOP of the value for the
 comparison.  For interior nodes, the value is the last value stored in the
 last leaf node.  The default implementation uses no encryption."

" first compare the keys "
( aKey _idxForSortLessThan: (super at: index) )
    ifTrue: [ ^ true ].

" if the keys are equal, use the OOP of the value "
(aKey _idxForSortEqualTo: (super at: index))
    ifTrue: [ ^ aValue asOop <= (super at: index - 1) lastValue asOop ].

^ false
%

category: 'Comparison Operators'
method: BtreeInteriorNode
_compareValueOop: aValue greaterThanEntryValueOopAt: index

""

^ aValue asOop > (super at: index - 1) lastValue asOop
%

category: 'Comparison Operators'
method: BtreeInteriorNode
_compareValueOop: aValue lessThanOrEqualToEntryValueOopAt: index

""

^ aValue asOop <= (super at: index - 1) lastValue asOop
%

category: 'Searching'
method: BtreeInteriorNode
_findAllValuesForIdenticalKey: aKey into: aCollection using: aComparison

"Finds all the values for the given identical key, placing them in the
 collection.  For interior nodes, must first find the appropriate child
 node.  Return whether the last key was equal or not (so the caller
 knows it must check the next node)."

| index eSize maxIndex |
" find first child node that might contain the key "
index := self _findCoveringIndexForKey: aKey totalOrder: false.
index == 0 ifTrue: [ ^ false ].

((super at: index) _findAllValuesForIdenticalKey: aKey into: aCollection using: aComparison)
  ifFalse: [ ^ false ].

eSize := self entrySize.
maxIndex := self _lastIndex.
index := index + eSize.

" now scan child nodes until no values are added to the collection "
[ (index < maxIndex) and:
[ (super at: index) _findAllValuesForIdenticalKey: aKey into: aCollection using: aComparison ] ]
  whileTrue: [ index := index + eSize ].
^ index >= maxIndex
%

category: 'Searching'
method: BtreeInteriorNode
_findAllValuesForKey: aKey into: aCollection using: aComparison

"Finds all the values for the given key, placing them in the collection.  For
 interior nodes, must first find the appropriate child node.  While child nodes
 find additional values for the key, continue with the next child."

| index eSize prevSize maxIndex |
" find first child node that might contain the key "
index := self _findCoveringIndexForKey: aKey totalOrder: false.
index == 0 ifTrue: [ ^ self ].

prevSize := aCollection size.
(super at: index) _findAllValuesForKey: aKey into: aCollection using: aComparison.

eSize := self entrySize.
maxIndex := self _lastIndex.
index := index + eSize.

" now scan child nodes until no values are added to the collection "
[ (index < maxIndex) and:
[ prevSize < aCollection size ] ] whileTrue: [
    prevSize := aCollection size.
    (super at: index) _scanForAllValuesForKey: aKey into: aCollection using: aComparison.
    index := index + eSize
]
%

category: 'Searching Support'
method: BtreeInteriorNode
_findAllValuesGreaterThanKey: aKey into: anArray using: aComparison
  "Puts into anArray the index and the leaf node of the entry that is greater
 than the given key, plus the index and interior node of the path taken to
 reach the leaf.  Returns true if a value was found, false otherwise.  Do this
 by invoking the same operation on the appropriate child node."

  | index eSize lastIndex comparisonForSort |
  lastIndex := self _lastKeyIndex.
  lastIndex == 0
    ifTrue: [ ^ false ].
  " find index where key would be inserted "
  index := self _findCoveringIndexForKey: aKey totalOrder: false.
  index == 0
    ifTrue: [ ^ false ].
  "scan across all entries that sort ="
  eSize := self entrySize.
  comparisonForSort := self comparisonForSort.
  [ self _compare: comparisonForSort key: aKey equalToEntryAt: index + 1 ]
    whileTrue: [ index := index + eSize.
      index > lastIndex
        ifTrue: [ ^ false ] ].
  " see if this child has any greater than the key "
  ((super at: index)
    _findAllValuesGreaterThanKey: aKey
    into: anArray
    using: aComparison)
    ifFalse: [ ^ false ].
  anArray addLast: index.
  anArray addLast: self.
  ^ true
%

category: 'Searching Support'
method: BtreeInteriorNode
_findAllValuesLessThanKey: aKey andEquals: aBoolean into: anArray using: aComparison
  "Puts into anArray the index and the leaf node of the entry that is less than
 (or less than and equal to if aBoolean is true) the given key, plus the index
 and interior node of the path taken to reach the leaf.  Returns true if a
 value was found, false otherwise.  Does this by invoking the same operation
 on the appropriate child node."

  | index eSize lastIndex comparisonForSort |
  lastIndex := self _lastIndex.
  lastIndex == 0
    ifTrue: [ ^ false ].
  aBoolean
    ifFalse: [ ^ self _findAllValuesLessThanKey: aKey into: anArray using: aComparison ].
  " first see if all entries are > aKey "
  comparisonForSort := self comparisonForSort.
  (self
    _compare: comparisonForSort
    key: aKey
    lessThanOrEqualToEntryAt: self _lastKeyIndex)
    ifFalse: [ "bugfix 33805 - verify that aKey is > last entry"
      (aKey == nil
        or: [ self _compare: aComparison key: aKey greaterThanEntryAt: self _lastKeyIndex ])
        ifTrue: [ self _putLastIndexOfLastChildInto: anArray.
          ^ true ] ].
  "find index of first entry >= aKey"
  index := self _findCoveringIndexForKey: aKey totalOrder: false.
  index == 0
    ifTrue: [ ^ false ].
  "scan across all of the values that sort ="
  eSize := self entrySize.
  (self _compare: comparisonForSort key: aKey equalToEntryAt: index + 1)
    ifTrue: [ [ index < lastIndex
        and: [ self _compare: comparisonForSort key: aKey equalToEntryAt: index + 1 ] ]
        whileTrue: [ index := index + eSize ].
      " if we scanned past the end, subtract an entry "
      index > lastIndex
        ifTrue: [ index := index - eSize ] ].
  " see if child has any entries less than or equal to aKey "
  ((super at: index)
    _findAllValuesLessThanKey: aKey
    andEquals: true
    into: anArray
    using: comparisonForSort)
    ifFalse: [ " this child did not find any "
      " if it is not the first child "
      index > 1
        ifTrue: [ " then the entry is the rightmost leaf entry of the previous child "
          index := index - eSize.
          (super at: index) _putLastIndexOfLastChildInto: anArray ]
        ifFalse: [ ^ false ] ].
  anArray addLast: index.
  anArray addLast: self.
  ^ true
%

category: 'Searching Support'
method: BtreeInteriorNode
_findAllValuesLessThanKey: aKey into: anArray using: aComparison
  "Puts into anArray the index and the leaf node of the entry that is less than
 (or less than and equal to if aBoolean is true) the given key, plus the index
 and interior node of the path taken to reach the leaf.  Returns true if a
 value was found, false otherwise.  Does this by invoking the same operation
 on the appropriate child node."

  | index eSize lastIndex |
  lastIndex := self _lastIndex.
  lastIndex == 0
    ifTrue: [ ^ false ].
  " first see if all entries are > aKey "
  (self
    _compare: self comparisonForSort
    key: aKey
    lessThanOrEqualToEntryAt: self _lastKeyIndex)
    ifFalse: [ "bugfix 33805 - verify that aKey is > last entry"
      (aKey == nil
        or: [ self _compare: aComparison key: aKey greaterThanEntryAt: self _lastKeyIndex ])
        ifTrue: [ self _putLastIndexOfLastChildInto: anArray.
          ^ true ] ].
  " find index where key would be inserted "
  index := self _findCoveringIndexForKey: aKey totalOrder: false.
  index == 0
    ifTrue: [ ^ false ].
  eSize := self entrySize.
  " see if this child has any less than the key "
  ((super at: index)
    _findAllValuesLessThanKey: aKey
    into: anArray
    using: aComparison)
    ifFalse: [ " this child did not find any "
      " if it is not the first child "
      index > 1
        ifTrue: [ " then the entry is the rightmost leaf entry of the previous child "
          index := index - eSize.
          (super at: index) _putLastIndexOfLastChildInto: anArray ]
        ifFalse: [ ^ false ] ].
  anArray addLast: index.
  anArray addLast: self.
  ^ true
%

category: 'Searching'
method: BtreeInteriorNode
_findFirstValueForKey: aKey using: aComparison

"Returns the first value associated with the given key.  For interior nodes,
 find the appropriate child node and ask it to find the first value."

| index |
" find first child node that might contain the key "
index := self _findCoveringIndexForKey: aKey totalOrder: false.
index == 0 ifTrue: [ ^ #_incompletePathTraversal ].

^ (super at: index) _findFirstValueForKey: aKey using: aComparison
%

category: 'Updating'
method: BtreeInteriorNode
_insertEncryptionFor: aKey value: node startingAt: insertionIndex

"Copies the encryption present in the child node to the receiver."

| nodeIndex eSize |

" if it exists, insert the encryption (copy from child node) "
eSize := node _encryptionSize.
eSize > 0 ifTrue: [
  nodeIndex := node _lastKeyIndex.
 "node copyFrom: (nodeIndex + 1) to: (nodeIndex + eSize) into: self startingAt: insertionIndex"
  self replaceFrom: insertionIndex to: insertionIndex + eSize - 1
	with: node startingAt: nodeIndex + 1
]
%

category: 'Searching Support'
method: BtreeInteriorNode
_lastValuesNotIdenticalTo: aKey into: array
  "Send this message to all the receiver's children."

  1 to: numElements * self entrySize by: self entrySize do: [ :i | (super at: i) _lastValuesNotIdenticalTo: aKey into: array ].
  ^ array
%

category: 'Enumerating'
method: BtreeInteriorNode
_leafKeysAndValuesDo: aBlock

"Execute the two-argument block for each child node."

1 to: (numElements * self entrySize) by: self entrySize do: [ :i |
    (super at: i) _leafKeysAndValuesDo: aBlock
]
%

category: 'Removing'
method: BtreeInteriorNode
_mergeFromNeighborForNodeAt: nodeIndex

"The node at the given index has too few entries and neighboring siblings had
 too few entries to take from, so merge with one of its neighboring siblings.
 First tries the next (right) sibling, then the previous (left) sibling."

| node sibling eSize myESize numSiblingElements copyStart lastChildKey myLastIndex |

node := super at: nodeIndex.
eSize := node entrySize.
myESize := self entrySize.

" check if the node is the last entry "
nodeIndex == (self _lastKeyIndex - 1)
    ifTrue: [ " this is the last entry, try the previous sibling "
        nodeIndex > 1
            ifTrue: [ " keep sibling, throw away node "
                sibling := super at: (nodeIndex - myESize).
                numSiblingElements := sibling numElements.

                " move node's entries onto end of sibling "
                sibling _insertAt: (sibling _lastIndex + 1)
                   from: node fromStart: 1 fromEnd: (node numElements * eSize)
                   numToMoveDown: 0 .

                sibling numElements: (node numElements + numSiblingElements).

                " update the key for the sibling's entry in the receiver "
                lastChildKey := sibling at: (sibling _lastKeyIndex).
                self primitiveAt: (nodeIndex - myESize + 1) put: lastChildKey.
                self
                    _insertEncryptionFor: lastChildKey
                    value: sibling
                    startingAt: (nodeIndex - myESize + 2).

                sibling _updateLastValue
            ]
            ifFalse:[ self _error: #rtErrBtreeInvalidMerge.
                      self _uncontinuableError ]
    ]
    " this is not the last entry, get the next sibling "
    ifFalse: [ " keep node, throw away sibling "
        sibling := super at: (nodeIndex + myESize).
        numSiblingElements := sibling numElements.

        "copy from sibling onto end of node "
        node _insertAt: (node _lastIndex + 1)
             from: sibling fromStart: 1 fromEnd: (numSiblingElements * eSize)
             numToMoveDown: 0 .

        copyStart := nodeIndex + myESize + myESize.
        " if sibling was not the last entry in the receiver "
        myLastIndex := self _lastIndex .
        copyStart < myLastIndex
            ifTrue: [
                " move entries in receiver to the left "
                self _deleteNoShrinkFrom: (nodeIndex + myESize)
			to: copyStart - 1
            ].

        node numElements: (node numElements + numSiblingElements).

        " update the key for the node's entry in the receiver "
        lastChildKey := node at: (node _lastKeyIndex).
        self primitiveAt: (nodeIndex + 1) put: lastChildKey.
        self
            _insertEncryptionFor: lastChildKey
            value: node
            startingAt: (nodeIndex + 2).

        node _updateLastValue
    ].

numElements := numElements - 1.

" nil out the last entry of the receiver "
myLastIndex := self _lastIndex .
self _deleteNoShrinkFrom: myLastIndex + 1 to: myLastIndex + myESize.

%

category: 'RC Removing'
method: BtreeInteriorNode
_mergeFromNeighborForNodeAt: nodeIndex for: anIndexObj selectiveAbortSet: selectiveAbortSetOrNil

"The node at the given index has too few entries and neighboring siblings had
 too few entries to take from, so merge with one of its neighboring siblings.
 First tries the next (right) sibling, then the previous (left) sibling."

| node sibling eSize myESize numSiblingElements copyStart lastChildKey myLastIndex |

node := super at: nodeIndex.
(selectiveAbortSetOrNil ~~ nil and: [ (selectiveAbortSetOrNil includes: node) not ])
        ifTrue: [
                selectiveAbortSetOrNil add: node.
                node _selectiveAbort ].
eSize := node entrySize.
myESize := self entrySize.

" check if the node is the last entry "
nodeIndex == (self _lastKeyIndex - 1)
    ifTrue: [ " this is the last entry, try the previous sibling "
        nodeIndex > 1
            ifTrue: [ " keep sibling, throw away node "
                sibling := super at: (nodeIndex - myESize).
                    (selectiveAbortSetOrNil ~~ nil and: [ (selectiveAbortSetOrNil includes: sibling) not ])
                                ifTrue: [
                                        selectiveAbortSetOrNil add: sibling.
                                        sibling _selectiveAbort ].
                numSiblingElements := sibling numElements.

                " move node's entries onto end of sibling "
                sibling _insertAt: (sibling _lastIndex + 1)
                   from: node fromStart: 1 fromEnd: (node numElements * eSize)
                   numToMoveDown: 0 .

                sibling numElements: (node numElements + numSiblingElements).

                " update the key for the sibling's entry in the receiver "
                lastChildKey := sibling at: (sibling _lastKeyIndex).
                self primitiveAt: (nodeIndex - myESize + 1) put: lastChildKey.
                self
                    _insertEncryptionFor: lastChildKey
                    value: sibling
                    startingAt: (nodeIndex - myESize + 2).

                sibling _updateLastValue
            ]
            ifFalse:[ self _error: #rtErrBtreeInvalidMerge.
                      self _uncontinuableError ]
    ]
    " this is not the last entry, get the next sibling "
    ifFalse: [ " keep node, throw away sibling "
        sibling := super at: (nodeIndex + myESize).
          (selectiveAbortSetOrNil ~~ nil and: [ (selectiveAbortSetOrNil includes: sibling) not ])
                ifTrue: [
                        selectiveAbortSetOrNil add: sibling.
                        sibling _selectiveAbort ].
        numSiblingElements := sibling numElements.

        "copy from sibling onto end of node "
        node _insertAt: (node _lastIndex + 1)
             from: sibling fromStart: 1 fromEnd: (numSiblingElements * eSize)
             numToMoveDown: 0 .

        copyStart := nodeIndex + myESize + myESize.
        " if sibling was not the last entry in the receiver "
        myLastIndex := self _lastIndex .
        copyStart < myLastIndex
            ifTrue: [
                " move entries in receiver to the left "
                self _deleteNoShrinkFrom: (nodeIndex + myESize)
                        to: copyStart - 1
            ].

        node numElements: (node numElements + numSiblingElements).

        " update the key for the node's entry in the receiver "
        lastChildKey := node at: (node _lastKeyIndex).
        self primitiveAt: (nodeIndex + 1) put: lastChildKey.
        self
            _insertEncryptionFor: lastChildKey
            value: node
            startingAt: (nodeIndex + 2).

        node _updateLastValue
    ].

System _addRootObjectToRcReadSet: node.
System _addRootObjectToRcReadSet: sibling.
System redoLog addConflictObject: node for: anIndexObj.
System redoLog addConflictObject: sibling for: anIndexObj.

numElements := numElements - 1.

" nil out the last entry of the receiver "
myLastIndex := self _lastIndex .
self _deleteNoShrinkFrom: myLastIndex + 1 to: myLastIndex + myESize.
%

category: 'Enumerating'
method: BtreeInteriorNode
_preOrderDo: aBlock

"Execute the one-argument block with the receiver, then
 invoke the same message on the child nodes."

aBlock value: self.

1 to: (numElements * self entrySize) by: self entrySize do: [ :i |
    (super at: i) _preOrderDo: aBlock
]
%

category: 'Sorting Support'
method: BtreeInteriorNode
_putAscendingValuesInto: array startingAt: offset

"Returns the number of elements."

| j |
j := offset.
1 to: (numElements * self entrySize) by: self entrySize do: [ :i |
  j := j + ((super at: i) _putAscendingValuesInto: array startingAt: j)
].
^ j - offset
%

category: 'Sorting Support'
method: BtreeInteriorNode
_putDescendingValuesInto: array startingAt: offset

"Returns the number of elements."

| j |
j := offset.
1 to: (numElements * self entrySize) by: self entrySize do: [ :i |
  j := j - ((super at: i) _putDescendingValuesInto: array startingAt: j)
].
^ offset - j
%

category: 'Searching Support'
method: BtreeInteriorNode
_putFirstIndexOfFirstChildInto: anArray

"Ask the first child in the receiver to
 putFirstIndexOfFirstChildInto: anArray."

(super at: 1) _putFirstIndexOfFirstChildInto: anArray.
anArray addLast: 1.
anArray addLast: self
%

category: 'Searching Support'
method: BtreeInteriorNode
_putFirstIndexOfFirstChildInto: anArray ifGreaterThanOrEqualTo: aKey using: aComparison

"Ask the first child in the receiver to putFirstIndexOfFirstChildInto:ifGreaterThanOrEqualTo:.

 Because of NANs we need to validate the assumption of the caller
 (i.e., that all entries are greater than aKey). See bug33805."

"make sure that key is less than or equal to first entry"
(aKey == nil
   or: [ self _compare: aComparison key: aKey lessThanOrEqualToEntryAt: 2 ])
  ifTrue: [
    (super at: 1) _putFirstIndexOfFirstChildInto: anArray ifGreaterThanOrEqualTo: aKey using: aComparison.
    anArray addLast: 1.
  ]
  ifFalse: [
    anArray addLast: 0.
  ].
anArray addLast: self.
%

category: 'Searching Support'
method: BtreeInteriorNode
_putLastIndexOfLastChildInto: anArray

"Asks the last child in the receiver to
 putLastIndexOfLastChildInto: anArray ."

(super at: self _lastKeyIndex - 1) _putLastIndexOfLastChildInto: anArray.
anArray addLast: self _lastKeyIndex - 1.
anArray addLast: self
%

category: 'RC Removing'
method: BtreeInteriorNode
_removeKey: aKey value: aValue for: anIndexObj selectiveAbortSet: selectiveAbortSetOrNil
"Removes the key/value pair.  Find the appropriate child node and invoke the
 remove operation on it.  If the remove occurred, check if a merge or coalesce
 is necessary."

| nodeIndex node lastChildKeyIndex lastChildKey |
(self _compareLastKeyLessThanOrEqualToKey: aKey value: aValue)
    ifFalse: [ ^ false ].

nodeIndex := self _binarySearchCoveringKey: aKey value: aValue.
node := super at: nodeIndex.

(node removeKey: aKey value: aValue for: anIndexObj selectiveAbortSet: selectiveAbortSetOrNil)
    ifTrue: [ " remove occurred "

        " see if last key in child node has changed "
        lastChildKeyIndex := node _lastKeyIndex.
        lastChildKey := node at: lastChildKeyIndex.
        (lastChildKey == (super at: (nodeIndex + 1)))
            ifFalse: [ " update key and encryption in the receiver "
                self primitiveAt: (nodeIndex + 1) put: lastChildKey.
                self
                    _insertEncryptionFor: lastChildKey
                    value: node
                    startingAt: (nodeIndex + 2)
            ].

        " see if the node's number of entries is below the threshold "
        node numElements < node mergeThreshold
            ifTrue: [ " try to steal entries from a neighboring sibling "
                (self _attemptTakingFromNeighborForNodeAt: nodeIndex for: anIndexObj selectiveAbortSet: selectiveAbortSetOrNil)
                    ifFalse: [
                        " could not take from neighbor, merge with a neighbor instead "
                        self _mergeFromNeighborForNodeAt: nodeIndex for: anIndexObj selectiveAbortSet: selectiveAbortSetOrNil
                    ]
            ].

        self _updateLastValue.

        ^ true
    ]
    ifFalse: [ ^ false ]
%

category: 'Searching'
method: BtreeInteriorNode
_scanForAllValuesForKey: aKey into: aCollection using: aComparison

"Places all values associated with the given key into aCollection.
 Start with the first entry, and iterate through consecutive entries
 until the first entry that does not add to the collection."

| index eSize prevSize maxIndex |
prevSize := aCollection size.
(super at: 1) _findAllValuesForKey: aKey into: aCollection using: aComparison.

eSize := self entrySize.
maxIndex := self _lastIndex.
index := 1 + eSize.

[ (index < maxIndex) and:
[ prevSize < aCollection size ] ] whileTrue: [
    prevSize := aCollection size.
    (super at: index) _scanForAllValuesForKey: aKey into: aCollection using: aComparison.
    index := index + eSize
]
%

category: 'Updating'
method: BtreeInteriorNode
_splitUsingKey: aKey value: aNode
  "Creates a new sibling node, moving half of the receiver's entries into
 the sibling.  Then insert a new entry with the given key/node into either
 the receiver or sibling.  Returns the new sibling."

  | insertionIndex newSibling lastKeyIndex lastKey lastVal node comparisonForSort |
  newSibling := self _createSibling.
  " get the last key in the receiver "
  lastKeyIndex := self _lastKeyIndex.
  lastKey := super at: lastKeyIndex.
  " get the last value in the new entry's node (this is what insertion is based upon) "
  lastVal := aNode lastValue.
  " determine if new entry goes in the first half or second half "
  comparisonForSort := self comparisonForSort.
  (self
    _compare: comparisonForSort
    key: aKey
    value: lastVal
    lessThanOrEqualToEntryAt: lastKeyIndex)
    ifTrue: [ " adding to the first half "
      insertionIndex := self _binarySearchCoveringKey: aKey value: lastVal.	" HR6190 "
      (node := self _at: insertionIndex) ~~ nil
        ifTrue: [ (node
            _compare: comparisonForSort
            key: aKey
            value: lastVal
            lessThanOrEqualToEntryAt: 2)
            ifFalse: [ insertionIndex := insertionIndex + self entrySize ] ].
      self _insertKey: aKey value: aNode atIndex: insertionIndex ]
    ifFalse: [ " adding to the second half "
      insertionIndex := newSibling _binarySearchCoveringKey: aKey value: lastVal.	" HR6190 "
      insertionIndex <= newSibling size
        ifTrue: [ "fix 31179"
          (node := newSibling _at: insertionIndex) ~~ nil
            ifTrue: [ (node
                _compare: comparisonForSort
                key: aKey
                value: lastVal
                lessThanOrEqualToEntryAt: 2)
                ifFalse: [ insertionIndex := insertionIndex + self entrySize ] ] ].
      newSibling _insertKey: aKey value: aNode atIndex: insertionIndex ].
  ^ newSibling
%

category: 'Accessing'
method: BtreeInteriorNode
_totalElementsIn: stack endNode: endNode endIndex: endIndex into: array

"Determine the total number of entries, checking the given stack and
 end node from a stream object.  The given Array contains the current
 sum of elements in the first slot, and the second slots indicates if
 the end was hit."

| i start |
(i := stack indexOf: self) ~~ 0
  ifTrue: [ start := stack at: i - 1 ]
  ifFalse: [ start := 1 ].

start to: self _lastIndex by: self entrySize do: [ :j |
  (super at: j) _totalElementsIn: stack
    endNode: endNode
    endIndex: endIndex
    into: array.
  (array at: 2) ifTrue: [ ^ self ]
].
%

category: 'Updating'
method: BtreeInteriorNode
_updateLastValue

"Update the last value of the interior node by asking the last entry what its
 last value is.  Do not change the value unless there has been a change."

| nodeLastValue |

nodeLastValue := (super at: (self _lastKeyIndex - 1)) lastValue.
(nodeLastValue == lastValue)
    ifFalse: [ lastValue := nodeLastValue ]
%

! Class extensions for 'BtreeLeafNode'

!		Instance methods for 'BtreeLeafNode'

category: 'Updating'
method: BtreeLeafNode
at: aKey put: aValue

"Adds the key/value pair to the node.  If the node is full, performs a 'split'
 on the parent.  Returns the new sibling if a split is performed, otherwise
 returns the receiver."

| index |
" determine if a split is needed "
numElements == self class maxNumberOfElements
  ifTrue: [ " performs the split and returns the new sibling "
    ^ self _splitUsingKey: aKey value: aValue
  ]
  ifFalse: [ " entry will fit in leaf node "
    numElements == 0
      ifTrue: [ index := 1 ]
      ifFalse: [
        index := self _binarySearchCoveringKey: aKey value: aValue.
      ].
    self _insertKey: aKey value: aValue atIndex: index
  ]
%

category: 'Updating'
method: BtreeLeafNode
btreeAt: aKey put: aValue

""

^ self at: aKey put: aValue
%

category: 'Testing'
method: BtreeLeafNode
isLeaf

"Returns whether the B-tree node is a leaf node."

^ true
%

category: 'Accessing'
method: BtreeLeafNode
lastValue

"Returns the value for the last entry in the receiver."

^ super at: (numElements - 1 * self entrySize + 1)
%

category: 'Constants'
method: BtreeLeafNode
mergeThreshold

"Returns the threshold such that if an entry has less than this number, it must
 have elements added from its sibling or be merged with its sibling.  This
 value is usually the same as the result of the message
 'self maxNumberOfElements quo: 2'."

^ 500
%

category: 'Private'
method: BtreeLeafNode
numElementsInStack: array
level: level
endNode: endNode
endIndex: endIndex
into: result

"Put the count in the first slot in the argument array and returns whether we
 reached the end."

" if receiver is the beginning node "
self == (array at: level + 1)
    ifTrue: [
        " if receiver is also the ending node "
        self == endNode
            ifTrue: [ " all entries within this node "
                result at: 1 put: ( endIndex - (array at: level)) // self entrySize.
                ^ true
            ]
            ifFalse: [ " first elements are in this node "
                result at: 1 put: numElements - ((array at: level) // self entrySize).
                ^ false
            ]
    ]
    ifFalse: [
        " if receiver is the ending node "
        self == endNode
            ifTrue: [ " last elements are in this node "
                result at: 1 put: endIndex // self entrySize.
                ^ true
            ]
            ifFalse: [ " all elements are in this node "
                result at: 1 put: numElements.
                ^ false
            ]
    ]
%

category: 'Printing'
method: BtreeLeafNode
printOn: aStream withIndentationLevel: anInteger

"Puts a displayable representation of the keys of the receiver on the given
 stream, indenting the given number of spaces."

anInteger timesRepeat: [ aStream nextPut: Character space ].

"aStream nextPutAll: '  { '; nextPutAll: self _alias asString; nextPutAll: ' } '."

2 to: (numElements * self entrySize) by: self entrySize do: [ :i |
    aStream nextPutAll: (super at: i) asString;
        nextPut: $(;
        nextPutAll: (super at: i - 1) asString;
        nextPutAll: ') '
].
aStream nextPut: Character lf
%

category: 'Printing'
method: BtreeLeafNode
printOn: aStream withIndentationLevel: anInteger includingValues: aBoolean

"Puts a displayable representation of the keys of the receiver on the given
 stream, indenting the given number of spaces."

anInteger timesRepeat: [ aStream nextPut: Character space ].

"aStream nextPutAll: '  { '; nextPutAll: self _alias asString; nextPutAll: ' } '."

2 to: (numElements * self entrySize) by: self entrySize do: [ :i |
    aStream nextPutAll: (super at: i) asString.

    "aStream nextPut: $(;
        nextPutAll: (super at: i - 1) _alias asString;
        nextPut: $).
    "
    aBoolean
        ifTrue: [
            aStream nextPut: $(;
                nextPutAll: (super at: i - 1) asString;
                nextPutAll: ') '
        ]
        ifFalse: [ aStream nextPutAll: ' ' ]
].
aStream nextPut: Character lf
%

category: 'Removing'
method: BtreeLeafNode
removeKey: aKey value: aValue

"Removes the key/value pair.  Finds the index for the given key and then shifts
 any following entries to the left."

| valueIndex eSize |
valueIndex := self _binarySearchForKey: aKey value: aValue.

valueIndex == 0 ifTrue: [ ^ false ].
eSize := self entrySize.

self _deleteNoShrinkFrom: valueIndex to: valueIndex + eSize - 1 .
numElements := numElements - 1.

^ true
%

category: 'Printing'
method: BtreeLeafNode
stringRep

""

| aStream |

aStream := PrintStream printingOn: String new.
self printOn: aStream withIndentationLevel: 0.
^ aStream contents
%

category: 'Accessing'
method: BtreeLeafNode
totalElements

"Return the number of elements."

^ numElements
%

category: 'Query Support'
method: BtreeLeafNode
_addValues: aQuerySpec
start: startIndex
end: endIndex
into: collection

^aQuerySpec
    _addValuesFrom: self
    entrySize: self entrySize
    start: startIndex
    end: endIndex
    into: collection
%

category: 'Audit'
method: BtreeLeafNode
_auditLeafKeysValuesAndEncryptedDo: aBlock

"Execute the three-argument block with the key, value, and encryption array of each entry in the
 receiver."

1 to: (numElements * self entrySize) by: self entrySize do: [ :i | | k encryptedEntry encryptedKey |
    k := self _at: i + 1.
    encryptedKey := encryptedEntry := nil.
    self _encryptionSize == 2
        ifTrue: [
            encryptedEntry := { (self _at: i + 2) . (self _at: i + 3) }.
            encryptedKey := self _encryptionFor: k ].
    aBlock value: k value: (self _at: i) value: encryptedEntry value: encryptedKey
]
%

category: 'Audit'
method: BtreeLeafNode
_auditLeafKeysValuesAndEncryptedFor: pathTerm on: aString do: aBlock
  self _auditLeafKeysValuesAndEncryptedDo: aBlock
%

category: 'Comparison Operators'
method: BtreeLeafNode
_compare: comparisonForSort key: aKey value: aValue equalToEntryAt: index
  "Performs a = comparison between aKey and the entry whose key is at the given
 index.  If the keys are equal, use the OOP of the value as the next basis for
 comparison.  The default implementation uses no encryption."

  ^ (comparisonForSort compareKey: aKey equalTo: (super at: index))
    and: [ aValue asOop = (super at: index - 1) asOop ]
%

category: 'Comparison Operators'
method: BtreeLeafNode
_compare: comparisonForSort key: aKey value: aValue lessThanOrEqualToEntryAt: index
  "Performs a <= comparison between aKey and the entry whose key is at the given
 index.  If the keys are equal, then use the OOP of the value for the
 comparison.  The default implementation uses no encryption."

  " first compare the keys "

  (comparisonForSort compareKey: aKey lessThan: (super at: index))
    ifTrue: [ ^ true ]. " if the keys are equal, use the OOP of the value "
  (comparisonForSort compareKey: aKey equalTo: (super at: index))
    ifTrue: [ ^ aValue asOop <= (super at: index - 1) asOop ].
  ^ false
%

category: 'Comparison Operators'
method: BtreeLeafNode
_compareKey: aKey value: aValue equalToEntryAt: index
  "Performs a = comparison between aKey and the entry whose key is at the given
 index.  If the keys are equal, use the OOP of the value as the next basis for
 comparison.  The default implementation uses no encryption."

  ^ (aKey _idxForSortEqualTo: (super at: index))
    and: [ aValue asOop = (super at: index - 1) asOop ]
%

category: 'Comparison Operators'
method: BtreeLeafNode
_compareKey: aKey value: aValue greaterThanEntryAt: index

"Performs a > comparison between aKey and the entry whose key is at the given
 index.  If the keys are equal, then use the OOP of the value for the
 comparison.  The default implementation uses no encryption."

" first compare the keys "
( aKey _idxForSortGreaterThan: (super at: index) )
    ifTrue: [ ^ true ].

^ false
%

category: 'Comparison Operators'
method: BtreeLeafNode
_compareKey: aKey value: aValue lessThanEntryAt: index

"Performs a < comparison between aKey and the entry whose key is at the given
 index.  If the keys are equal, then use the OOP of the value for the
 comparison.  The default implementation uses no encryption."

" first compare the keys "
( aKey _idxForSortLessThan: (super at: index) )
    ifTrue: [ ^ true ].

^ false
%

category: 'Comparison Operators'
method: BtreeLeafNode
_compareKey: aKey value: aValue lessThanOrEqualToEntryAt: index

"Performs a <= comparison between aKey and the entry whose key is at the given
 index.  If the keys are equal, then use the OOP of the value for the
 comparison.  The default implementation uses no encryption."

" first compare the keys "
( aKey _idxForSortLessThan: (super at: index) )
    ifTrue: [ ^ true ].

" if the keys are equal, use the OOP of the value "
(aKey _idxForSortEqualTo: (super at: index))
    ifTrue: [ ^ aValue asOop <= (super at: (index - 1)) asOop ].

^ false
%

category: 'Comparison Operators'
method: BtreeLeafNode
_compareValueOop: aValue greaterThanEntryValueOopAt: index

""

^ aValue asOop > (super at: (index - 1)) asOop
%

category: 'Comparison Operators'
method: BtreeLeafNode
_compareValueOop: aValue lessThanOrEqualToEntryValueOopAt: index

""

^ aValue asOop <= (super at: (index - 1)) asOop
%

category: 'Searching'
method: BtreeLeafNode
_findAllValuesForIdenticalKey: aKey into: aCollection using: aComparison

"Finds all the values for the given identical key, placing them in the
 collection.  For leaf nodes, must first find the appropriate entry, then
 iterate through successive entries until we reach the end or a key does
 not match.  Return whether the last key was equal or not (so the caller
 knows it must check the next leaf node)."

| index eSize maxIndex |
" find first entry that might contain the key "
index := self _findCoveringIndexForKey: aKey totalOrder: false.
index == 0 ifTrue: [ ^ false ].

eSize := self entrySize.
maxIndex := self _lastIndex.

" now scan entries until reach the end or no match using sort ="
[ (index < maxIndex) and:
[ self _compare: aComparison key: aKey equalToEntryAt: index + 1 ] ] whileTrue: [
  (aKey == (super at: index + 1))
    ifTrue: [ aCollection add: (super at: index) ].
  index := index + eSize
].
^ index >= maxIndex
%

category: 'Searching'
method: BtreeLeafNode
_findAllValuesForKey: aKey into: aCollection using: aComparison

"Finds all the values for the given key, placing them in the collection.  For
 leaf nodes, must first find the appropriate entry, then iterate through
 successive entries until we reach the end or a key does not match."

| index eSize maxIndex |
" find first entry that might contain the key "
index := self _findCoveringIndexForKey: aKey totalOrder: false.
index == 0 ifTrue: [ ^ self ].

eSize := self entrySize.
maxIndex := self _lastIndex.

" now scan entries until reach the end or no match using sort ="
[ (index < maxIndex) and:
[ self _compare: aComparison key: aKey equalToEntryAt: (index + 1) ] ] whileTrue: [
    aCollection add: (super at: index).
    index := index + eSize
]
%

category: 'Searching Support'
method: BtreeLeafNode
_findAllValuesGreaterThanKey: aKey into: anArray using: aComparison
  "Puts into anArray the index and the leaf node of the entry that is greater
 than the given key.  Returns true if a value was found, false otherwise."

  | index eSize lastIndex comparisonForSort |
  numElements == 0
    ifTrue: [ ^ false ].
  lastIndex := self _lastKeyIndex.
  " find index where the key would be inserted "
  index := self _findCoveringIndexForKey: aKey totalOrder: false.
  index == 0
    ifTrue: [ ^ false ].
  "skip keys that sort ="
  eSize := self entrySize.
  comparisonForSort := self comparisonForSort.
  [ self _compare: comparisonForSort key: aKey equalToEntryAt: index + 1 ]
    whileTrue: [ index := index + eSize.
      index > lastIndex
        ifTrue: [ ^ false ] ].
  aKey ~~ nil
    ifTrue: [ "bugfix 33805 - verify that aKey < index entry"
      (self _compare: comparisonForSort key: aKey lessThanEntryAt: index + 1)
        ifFalse: [ ^ false ] ].
  anArray addLast: index.
  anArray addLast: self.
  ^ true
%

category: 'Searching Support'
method: BtreeLeafNode
_findAllValuesLessThanKey: aKey andEquals: aBoolean into: anArray using: aComparison

"Puts into anArray the index and the leaf node of the entry that is less than
 (or less than and equal to if aBoolean is true) the given key.  Returns true
 if a value was found, false otherwise."

numElements == 0
    ifTrue: [ ^ false ].

aBoolean
  ifFalse: [ ^self  _findAllValuesLessThanKey: aKey into: anArray using: aComparison].

(self _findAllValuesGreaterThanKey: aKey into: anArray using: aComparison)
  ifTrue: [
    | eSize index |
    eSize := self entrySize.
    index := anArray at: 1.
    index > eSize
      ifTrue: [
        "move index pointer for first greater than entry to first less than or equal to entry"
        index := index - eSize.
        anArray at: 1 put: index.
      ]
      ifFalse: [
         "first entry is greater than, so no entries are less than or equal"
         anArray size: 0.
        ^false
      ].
    ^true
  ].
  ((aKey == nil)
    or: [ self _compare: aComparison key: aKey greaterThanOrEqualToEntryAt: self _lastKeyIndex ])
    ifTrue: [
      " if so, put the rightmost leaf entry in the Array "
      self _putLastIndexOfLastChildInto: anArray.
      ^ true
    ].
^false
%

category: 'Searching Support'
method: BtreeLeafNode
_findAllValuesLessThanKey: aKey into: anArray using: aComparison
  "Puts into anArray the index and the leaf node of the entry that is less than
 the given key.  Returns true if a value was found, false otherwise."

  | index eSize lastIndex comparisonForSort |
  numElements == 0
    ifTrue: [ ^ false ].
  lastIndex := self _lastIndex.
  comparisonForSort := self comparisonForSort.
  " first see if all entries are > aKey "
  (self
    _compare: comparisonForSort
    key: aKey
    lessThanOrEqualToEntryAt: self _lastKeyIndex)
    ifFalse: [ "bugfix 33805 - verify that aKey is > index entry"
      (aKey == nil
        or: [ self _compare: aComparison key: aKey greaterThanEntryAt: self _lastKeyIndex ])
        ifTrue: [ " if so, put the rightmost leaf entry in the Array "
          self _putLastIndexOfLastChildInto: anArray.
          ^ true ] ].
  " find index where the key would be inserted "
  index := self _findCoveringIndexForKey: aKey totalOrder: false.
  " if index == 0, found no entryes"
  index == 0
    ifTrue: [ ^ false ].
  " if index == 1, check if any are < aKey "
  index == 1
    ifTrue: [ " if the first entry is greater than or equal to aKey, none satisfy "
      ((self _compare: comparisonForSort key: aKey lessThanEntryAt: 2)
        or: [ self _compare: comparisonForSort key: aKey equalToEntryAt: 2 ])
        ifTrue: [ ^ false ] ].
  eSize := self entrySize.
  index > 1
    ifTrue: [
      " subtract an entry to point to a valid 'less than' entry "
      index := index - eSize ].
  aKey ~~ nil
    ifTrue: [ "bugfix 33805 - verify that index aKey is > entry"
      (self _compare: comparisonForSort key: aKey greaterThanEntryAt: index + 1)
        ifFalse: [ (self _compare: aComparison key: aKey equalToEntryAt: index + 1)
            ifTrue: [ ^ false ].
          (self _compare: aComparison key: aKey lessThanEntryAt: index + 1)
            ifFalse: [ ^ false ] ] ].
  anArray addLast: index.
  anArray addLast: self.
  ^ true
%

category: 'Searching'
method: BtreeLeafNode
_findFirstValueForKey: aKey using: aComparison
  "Returns the first value associated with the given key.  For leaf nodes, finds
 the appropriate entry and makes the comparison.  If one is not found,
 returns the incomplete path traversal object."

  | index eSize maxIndex comparisonForSort |
  index := self _findCoveringIndexForKey: aKey totalOrder: false.
  index == 0
    ifTrue: [ ^ #'_incompletePathTraversal' ].
  eSize := self entrySize.
  maxIndex := self _lastIndex.
  comparisonForSort := self comparisonForSort.
  " now scan entries until reach the end or no match "
  [ index < maxIndex
    and: [ self _compare: comparisonForSort key: aKey lessThanOrEqualToEntryAt: index + 1 ] ]
    whileTrue: [ (self _compare: aComparison key: aKey equalToEntryAt: index + 1)
        ifTrue: [ ^ super at: index ].
      index := index + eSize ].
  ^ #'_incompletePathTraversal'
%

category: 'Private'
method: BtreeLeafNode
_insertEncodingForString: aString encoding: numToEncode startingAt: startIdx

<primitive: 538>
aString  _validateClass: String .
numToEncode _validateClass: SmallInteger .
startIdx _validateClass: SmallInteger .

^ self _primitiveFailed: #_insertEncodingForString:encoding:startingAt:
       args: { aString . numToEncode . startIdx }
%

category: 'Updating'
method: BtreeLeafNode
_insertEncryptionFor: aKey value: aValue startingAt: insertionIndex

"Gets the encryption for the given key and place it in the receiver starting at
 the given index.  Subclasses may provide their own encryption; there is no
 default encryption."

%

category: 'Searching Support'
method: BtreeLeafNode
_lastValuesNotIdenticalTo: aKey into: array
  ""

  1 to: numElements * self entrySize by: self entrySize do: [ :i |
    (self _at: i + 1) == aKey
      ifFalse: [ array add: (self _at: i) ] ].
  ^ array
%

category: 'Enumerating'
method: BtreeLeafNode
_leafKeysAndValuesDo: aBlock

"Execute the two-argument block with the key and value of each entry in the
 receiver."

1 to: (numElements * self entrySize) by: self entrySize do: [ :i |
    aBlock value: (self _at: i + 1) value: (self _at: i)
]
%

category: 'Aggregate Support'
method: BtreeLeafNode
_numNonNilElements

"Returns the number of non-nil elements."

| count |
count := 0.
" count from beginning the number of nils "
2 to: (numElements * self entrySize) by: self entrySize do: [ :i |
    nil == (self _at: i) ifTrue: [ count := count + 1]
].

^ numElements - count
%

category: 'Enumerating'
method: BtreeLeafNode
_preOrderDo: aBlock

"Execute the one-argument block with the receiver."

aBlock value: self
%

category: 'Sorting Support'
method: BtreeLeafNode
_putAscendingValuesInto: array startingAt: offset

"Returns the number of elements."

| j |
j := offset.
1 to: (numElements * self entrySize) by: self entrySize do: [ :i |
  array at: j put: (self _at: i).
  j := j + 1
].
^ numElements
%

category: 'Sorting Support'
method: BtreeLeafNode
_putDescendingValuesInto: array startingAt: offset

"Returns the number of elements."

| j |
j := offset.
1 to: (numElements * self entrySize) by: self entrySize do: [ :i |
  array at: j put: (self _at: i).
  j := j - 1
].
^ numElements
%

category: 'Searching Support'
method: BtreeLeafNode
_putFirstIndexOfFirstChildInto: anArray

"Puts the receiver and the first index of the receiver into the Array."

numElements == 0
    ifTrue: [ anArray addLast: 0]
    ifFalse: [ anArray addLast: 1 ].
anArray addLast: self
%

category: 'Searching Support'
method: BtreeLeafNode
_putFirstIndexOfFirstChildInto: anArray ifGreaterThanOrEqualTo: aKey using: aComparison

"If first entry is greater than or equal to aKey, Puts the receiver
 and the first index of the receiver into the Array.

 Because of NANs we need to validate the assumption of the caller
 (i.e., that all entries are greater than aKey). See bug33805."

"make sure that key is less than or equal to first entry"
(aKey == nil
   or: [ self _compare: aComparison key: aKey lessThanOrEqualToEntryAt: 2 ])
  ifTrue: [
    numElements == 0
      ifTrue: [ anArray addLast: 0]
      ifFalse: [ anArray addLast: 1 ].
  ]
  ifFalse: [
    anArray addLast: 0.
  ].
  anArray addLast: self
%

category: 'Searching Support'
method: BtreeLeafNode
_putLastIndexOfLastChildInto: anArray

"Puts the receiver and the last index of the receiver into the Array."

numElements = 0
  ifTrue: [ anArray addLast: 0 ]
  ifFalse: [ anArray addLast: self _lastKeyIndex - 1 ].
anArray addLast: self
%

category: 'Searching'
method: BtreeLeafNode
_scanForAllValuesForKey: aKey into: aCollection using: aComparison

"Places all values associated with the given key into aCollection.  Start with
 the first entry, and iterate through consecutive entries until we reach the
 end or the key does not match."

| index eSize maxIndex |

numElements == 0 ifTrue: [ ^ self ].
index := 1.
eSize := self entrySize.
maxIndex := self _lastIndex.

" now scan entries until reach the end or no match using sort ="
[ (index < maxIndex) and:
[ self _compare: aComparison key: aKey equalToEntryAt: (index + 1) ] ] whileTrue: [
    aCollection add: (super at: index).
    index := index + eSize
]
%

category: 'Updating'
method: BtreeLeafNode
_splitUsingKey: aKey value: aValue
  "Creates a new sibling node, moving half of the receiver's entries into the
 sibling.  Then inserts a new entry with the given key/value into either the
 receiver or sibling.  Returns the new sibling."

  | index newSibling lastKeyIndex lastKey comparisonForSort |
  newSibling := self _createSibling.
  lastKeyIndex := self _lastKeyIndex.	" get the last key in the receiver "
  lastKey := super at: lastKeyIndex.
  comparisonForSort := self comparisonForSort.
  " determine if new entry goes in the first half or second half "
  (self
    _compare: comparisonForSort
    key: aKey
    value: aValue
    lessThanOrEqualToEntryAt: lastKeyIndex)
    ifTrue: [ " adding to the first half "
      index := self _binarySearchCoveringKey: aKey value: aValue.
      self _insertKey: aKey value: aValue atIndex: index ]
    ifFalse: [ " adding to the second half "
      index := newSibling _binarySearchCoveringKey: aKey value: aValue.
      newSibling _insertKey: aKey value: aValue atIndex: index ].
  ^ newSibling
%

category: 'Accessing'
method: BtreeLeafNode
_totalElementsIn: stack endNode: endNode endIndex: endIndex into: array
  "Determine the total number of entries, checking the given stack and
 end node from a stream object.  The given Array contains the current
 sum of elements in the first slot, and the second slots indicates if
 the end was hit."

  | i start end sum delta |
  (i := stack indexOf: self) ~~ 0
    ifTrue: [ start := stack at: i - 1 ]
    ifFalse: [ start := 1 ].
  self == endNode
    ifTrue: [
      end := endIndex.
      array at: 2 put: true ]
    ifFalse: [ end := self _lastIndex ].
  delta := end - start.
  delta < 0
    ifTrue: [ delta := delta negated ].
  sum := (array at: 1) + (delta // self entrySize) + 1.
  array at: 1 put: sum
%

category: 'Query Support'
method: BtreeLeafNode
_traverseValues: aQuerySpec
start: startIndex
end: endIndex
previous: previousValue
into: collection

^aQuerySpec
    _traverseValuesFrom: self
    entrySize: self entrySize
    start: startIndex
    end: endIndex
    previous: previousValue
    into: collection
%

category: 'Updating'
method: BtreeLeafNode
_updateLastValue

"For leaf nodes, the last value is derived, so nothing is required."

%

! Class extensions for 'BtreeNode'

!		Class methods for 'BtreeNode'

category: 'Constants'
classmethod: BtreeNode
entrySize

"Returns the size of an entry with no encryption."

^ 2
%

category: 'Constants'
classmethod: BtreeNode
maxNumberOfElements

"Returns the number of entries that are allowed in an interior node."

^ 1000
%

category: 'Instance Creation'
classmethod: BtreeNode
new

"Returns a new initialized instance with the correct size."

^ (super new: self entrySize * self maxNumberOfElements) numElements: 0.
%

!		Instance methods for 'BtreeNode'

category: 'Audit'
method: BtreeNode
auditNsc: nsc for: pathTerm offset: offset on: aString
  "Verifies that the btree structure consistent relative to the given pathTerm."

  | indicatesIndexOnNscElements count key value bag ivOffset bagOfKeys setOfKeys comparisonForSort previousKey previousValue sentinel enumBag |
  indicatesIndexOnNscElements := pathTerm indicatesIndexOnNscElements.
  count := 0.
  bag := IdentityBag new.
  enumBag := IdentityBag new.
  bagOfKeys := IdentityBag new.
  setOfKeys := IdentitySet new.
  comparisonForSort := self comparisonForSort.
  sentinel := Object new.
  previousKey := sentinel.
  self
    _auditLeafKeysValuesAndEncryptedFor: pathTerm
    on: aString
    do: [ :k :v :encryptedEntry :encryptedKey | previousKey == sentinel
        ifFalse: [ (comparisonForSort compareKey: previousKey lessThanOrEqualTo: k)
            ifTrue: [ (comparisonForSort compareKey: previousKey equalTo: k)
                ifTrue: [ previousValue asOop <= v asOop
                    ifFalse: [ pathTerm auditInfo: {k.
                          nil.
                          nil} on: aString.
                      aString
                        add: 'Btree [';
                        add: self asOop asString;
                        add:
                            '] has out of oop order key/value pairs where the key ';
                        add: k printString printString;
                        add: ' [';
                        add: k asOop asString;
                        add: '] is equal to previous key ';
                        add: previousKey printString printString;
                        add: ' [';
                        add: previousKey asOop asString;
                        add: '] but the oop of the value ';
                        add: v printString printString;
                        add: ' [';
                        add: v asOop asString;
                        add: '] is less than the oop of the previous value ';
                        add: previousValue printString printString;
                        add: ' [';
                        add: previousValue asOop asString;
                        add: ']';
                        add: Character lf . self checkDebug: aString ] ] ]
            ifFalse: [ pathTerm auditInfo: {k.
                  nil.
                  nil} on: aString.
              aString
                add: 'Btree [';
                add: self asOop asString;
                add: '] has key ';
                add: k printString printString;
                add: ' out of order [';
                add: k asOop asString;
                add: '] that sorts greater than previous key';
                add: previousKey printString printString;
                add: ' [';
                add: previousKey asOop asString;
                add: ']';
                add: Character lf . self checkDebug: aString ] ].
      previousKey := k.
      previousValue := v.
      encryptedEntry ~~ nil
        ifTrue: [ encryptedEntry = encryptedKey
            ifFalse: [ pathTerm auditInfo: {k.
                  nil.
                  nil} on: aString.
              aString
                add: 'Btree [';
                add: self asOop asString;
                add: '] has encryptedKey for [';
                add: v asOop asString;
                add: '] of class ';
                add: v class asString;
                add: ' associated with key [';
                add: k asOop asString;
                add: '] that is [';
                add: (encryptedEntry at: 1) asOop asString;
                add: ', ';
                add: (encryptedEntry at: 2) asOop asString;
                add: '] but should be [';
                add: (encryptedKey at: 1) asOop asString;
                add: ', ';
                add: (encryptedKey at: 2) asOop asString;
                add: ']';
                add: Character lf . self checkDebug: aString ] ].
      count := count + 1.
      indicatesIndexOnNscElements
        ifTrue: [ v == k
            ifFalse: [ pathTerm auditInfo: {k.
                  nil.
                  nil} on: aString.
              aString
                add: 'Btree [';
                add: self asOop asString;
                add: '] has entry for [';
                add: v asOop asString;
                add: '] of class ';
                add: v class asString;
                add: ' associated with incorrect key [';
                add: k asOop asString;
                add: '] should be ( ';
                add: v asOop asString;
                add: ') ';
                add: Character lf . self checkDebug: aString ] ]
        ifFalse: [ | hasEntryFor expectedEntryValue |
          hasEntryFor := false.
          pathTerm isEnumeratedTerm
            ifTrue: [ | ivOffsets |
              ivOffsets := pathTerm _ivOffsetsFor: v.
              ivOffsets do: [ :off | | expected |
                  off ifNotNil: [ (expected := v instVarAt: off) == k
                        ifTrue: [ hasEntryFor := true.
                          expectedEntryValue := expected ] ] ] ]
            ifFalse: [ pathTerm isSelectorTerm
                ifTrue: [ expectedEntryValue := v perform: pathTerm termSelector.
                  hasEntryFor := expectedEntryValue _idxForSortEqualTo: k ]
                ifFalse: [ ivOffset := pathTerm _ivOffsetFor: v.
                  hasEntryFor := (expectedEntryValue := v instVarAt: ivOffset)
                    == k ] ].
          hasEntryFor
            ifFalse: [ pathTerm auditInfo: {k.
                  nil.
                  nil} on: aString.
              aString
                add: 'Btree [';
                add: self asOop asString;
                add: '] has entry for [';
                add: v asOop asString;
                add: '] of class ';
                add: v class asString;
                add: ' associated with incorrect key [';
                add: k asOop asString;
                add: '] should be ( ';
                add: expectedEntryValue asOop asString;
                add: ') ';
                add: Character lf . self checkDebug: aString ] ].
      count > 1
        ifTrue: [ value == v
            ifFalse: [ self
                _auditKey: key
                value: value
                bag: bag
                nsc: nsc
                for: pathTerm
                offset: offset
                enumBag: enumBag
                on: aString ].
          (comparisonForSort compareKey: key equalTo: k)
            ifTrue: [ bagOfKeys add: k.
              setOfKeys add: k ]
            ifFalse: [ 1 to: setOfKeys size do: [ :n | | aKey |
                aKey := setOfKeys _at: n.
                (DependencyList for: aKey) ~~ nil
                  ifTrue: [ pathTerm
                      auditDepListForLastElementObject: aKey
                      occurrences: (bagOfKeys occurrencesOf: aKey)
                      index: (pathTerm at: offset)
                      on: aString ] ].
              bagOfKeys removeAll: bagOfKeys.
              setOfKeys removeAll: setOfKeys.
              bagOfKeys add: k.
              setOfKeys add: k ] ]
        ifFalse: [ bagOfKeys add: k.
          setOfKeys add: k ].
      value := v.
      key := k.
      bag add: v.
      pathTerm isEnumeratedTerm
        ifTrue: [ enumBag add: v ] ].
  count > 0
    ifTrue: [ self
        _auditKey: key
        value: value
        bag: bag
        nsc: nsc
        for: pathTerm
        offset: offset
        enumBag: enumBag
        on: aString ].
  1 to: setOfKeys size do: [ :n | | aKey |
    aKey := setOfKeys _at: n.
    (DependencyList for: aKey) ~~ nil
      ifTrue: [ pathTerm
          auditDepListForLastElementObject: aKey
          occurrences: (bagOfKeys occurrencesOf: aKey)
          index: (pathTerm at: offset)
          on: aString ] ].
  ^ count
%

category: 'Audit'
method: BtreeNode
checkDebug: aString
  BtreePlusNodeAuditor checkDebug: aString 
%

category: 'Accessing'
method: BtreeNode
collator
  ^ self dynamicInstVarAt: #'collator'
%

category: 'Accessing'
method: BtreeNode
collator: anIcuCollator
  ^ self dynamicInstVarAt: #'collator' put: anIcuCollator
%

category: 'Comparison Operators'
method: BtreeNode
comparisonForSort
  ^ BtreeComparisonForCompare newForSort: self collator
%

category: 'Constants'
method: BtreeNode
entrySize

"Returns the size of an entry with no encryption."

^ 2
%

category: 'Testing'
method: BtreeNode
isBtreeNode

"Returns true: the receiver is a B-tree node."

^ true
%

category: 'Testing'
method: BtreeNode
isLeaf

"Returns whether the B-tree node is a leaf node.  The default return is false."

^ false
%

category: 'Indexing Support'
method: BtreeNode
maxNumWhenMerging

"Returns the maximum number of entries to add when building interior nodes
during a merge sort on index creation."

" ^ (self mergeThreshold + self class maxNumberOfElements) // 2 "
^ self class maxNumberOfElements - 5
%

category: 'Accessing'
method: BtreeNode
numElements

"Returns the value of the instance variable 'numElements'."

^ numElements
%

category: 'Updating'
method: BtreeNode
numElements: newValue

"Modify the value of the instance variable 'numElements'."

numElements := newValue
%

category: 'Constants'
method: BtreeNode
parentNodeClass

"Returns the class of node to be created as the parent when a split occurs."

^ BtreeInteriorNode
%

category: 'Printing'
method: BtreeNode
prettyPrint

""

| aStream |
aStream := PrintStream printingOn: String new.
self printOn: aStream withIndentationLevel: 0 includingValues: false.
^ aStream contents
%

category: 'Updating'
method: BtreeNode
primitiveAt: anIndex put: aValue

"Stores the argument aValue in the indexed variable of the
 receiver indicated by anIndex.  The argument anIndex must not be
 larger than 1 + the size of the receiver, and must not be less than 1.

 Generates an error if anIndex is not a SmallInteger or is out of
 bounds, if the receiver is not indexable, or if the
 receiver is not of the right class to store the given value.

 The primitive is equivalent to GciStoreIdxOop or GciStoreByte,
 depending on implementation of the receiver."

<primitive: 268>

(anIndex _isInteger)
  ifFalse: [ ^ self _errorNonIntegerIndex: anIndex].
(self class isIndexable) "not an indexable object"
  ifFalse: [ ^ self _errorNotIndexable].
(anIndex < 1 or:[ anIndex > (self size + 1)]) "out of bounds"
  ifTrue: [ ^ self _errorIndexOutOfRange: anIndex].
(self class isBytes)
ifTrue: [ ((aValue class ~~ SmallInteger) or: [ (aValue < 0) | (aValue > 255) ])
    ifTrue: [^ aValue _error: #rtErrExpectedByteValue].
  ].

self _primitiveFailed: #at:put: args: { anIndex . aValue }.
self _uncontinuableError
%

category: 'Formatting'
method: BtreeNode
printOn: aStream

"Puts a displayable representation of the receiver on the given stream."

"Default printing for non-protected access."


aStream nextPutAll: self asString
%

category: 'Audit'
method: BtreeNode
_auditKey: key value: value bag: bag nsc: nsc for: pathTerm offset: offset enumBag: enumBag on: aString
  "Private. "

  | num ar index startPt |
  index := pathTerm at: offset.
  index indexDictionary ~~ nil
    ifTrue: [
      ar := {}.
      index isIndexOnNscElements
        ifTrue: [ startPt := index size ]
        ifFalse: [ startPt := index lastPathComponentsDictionaryOffset ].
      startPt := startPt max: 1.
      index
        _addAllFor: value
        into: ar
        offset: 0
        pathTerm: (index at: startPt).
      num := ar size ]
    ifFalse: [ num := nsc occurrencesOf: value ].
  pathTerm isEnumeratedTerm
    ifTrue: [
      pathTerm == (index at: index size)
        ifTrue: [ num := (enumBag occurrencesOf: value) ]
        ifFalse: [ num := (enumBag occurrencesOf: value) * num ] ].
  bag size == num
    ifFalse: [
      pathTerm
        auditInfo:
          {key.
          nil.
          nil}
        on: aString.
      aString
        add: 'Btree [';
        add: self asOop asString;
        add: '] has incorrect number of entries (';
        add: bag size asString;
        add: ') for [';
        add: value asOop asString;
        add: '] of class ';
        add: value class asString;
        add: ' (should be ';
        add: num asString;
        add: ')';
        add: Character lf . self checkDebug: aString ].
  bag removeAll: bag.
  enumBag removeAll: enumBag
%

category: 'Audit'
method: BtreeNode
_auditLeafKeysValuesAndEncryptedFor: pathTerm on: aString do: aBlock
  self subclassResponsibility: #'_auditLeafKeysValuesAndEncryptedFor:on:do:'
%

category: 'Testing'
method: BtreeNode
_basicCanCompare: aKey withClass: aClass
  "Returns true if the receiver can make comparisons with the given key, and
false otherwise.  Used for basic nodes."

  ^ aKey _idxBasicCanCompareWithClass: aClass
%

category: 'Searching'
method: BtreeNode
_binarySearchCoveringKey: aKey totalOrder: aBoolean
  "Returns the index for the first entry in which aKey is found utilizing a
binary search.  This is the first entry whose key >= aKey."

  | lowPt midPt highPt entrySize index entryGreaterThan comparisonForSort |
  entrySize := self entrySize.
  lowPt := 1.
  highPt := numElements.
  entryGreaterThan := false.
  comparisonForSort := self comparisonForSort.
  [ lowPt <= highPt ] whileTrue: [ midPt := lowPt + highPt quo: 2.
      index := (midPt - 1) * entrySize + 2.
      entryGreaterThan := false.
      (self _compare: comparisonForSort key: aKey lessThanEntryAt: index)
        ifTrue: [ highPt := midPt - 1 ]
        ifFalse: [ (self _compare: comparisonForSort key: aKey greaterThanEntryAt: index)
            ifTrue: [ lowPt := midPt + 1.
              entryGreaterThan := true ]
            ifFalse: [ highPt := midPt - 1 ] ] ].
  entryGreaterThan
    ifTrue: [ ^ index + entrySize - 1 ].
  ^ index - 1
%

category: 'Searching'
method: BtreeNode
_binarySearchCoveringKey: aKey value: aValue
  "Returns the index for the entry in which aKey/aValue would be inserted.  This
 is the first entry which has its key >= aKey.  If multiple entries have the
 same key (key = aKey), then aValue is used (since entries with duplicate keys
 are inserted by the value's OOP ordering).  If the receiver is empty, returns
 1.  Uses a binary search."

  | lowPt midPt highPt entrySize index entryGreaterThan entryEqualTo comparisonForSort |
  entrySize := self entrySize.
  lowPt := 1.
  highPt := numElements.
  entryGreaterThan := false.
  comparisonForSort := self comparisonForSort.
  [ lowPt <= highPt ] whileTrue: [ entryGreaterThan := false.
      entryEqualTo := false.
      midPt := lowPt + highPt quo: 2.
      index := (midPt - 1) * entrySize + 2.
      (self
        _compare: comparisonForSort
        key: aKey
        value: aValue
        lessThanEntryAt: index)
        ifTrue: [ highPt := midPt - 1 ]
        ifFalse: [ (self
            _compare: comparisonForSort
            key: aKey
            value: aValue
            greaterThanEntryAt: index)
            ifTrue: [ lowPt := midPt + 1.
              entryGreaterThan := true ]
            ifFalse: [ (self _compare: comparisonForSort key: aKey equalToEntryAt: index)
                ifTrue: [ (self _compareValueOop: aValue lessThanOrEqualToEntryValueOopAt: index)
                    ifTrue: [ highPt := midPt - 1 ]
                    ifFalse: [ lowPt := midPt + 1 ].
                  entryEqualTo := true ]
                ifFalse: [ lowPt := midPt + 1 ] ] ] ].
  entryGreaterThan
    ifTrue: [ ^ index + entrySize - 1 ].
  (entryEqualTo
    and: [ self _compareValueOop: aValue greaterThanEntryValueOopAt: index ])
    ifTrue: [ ^ index + entrySize - 1 ].
  ^ index - 1
%

category: 'Searching'
method: BtreeNode
_binarySearchForKey: aKey value: aValue
  "Returns the 'value' index whose key equality matches aKey.  If no match is
found, returns zero.  Uses a binary search."

  | lowPt midPt highPt entrySize index comparisonForSort |
  numElements == 0
    ifTrue: [ ^ 0 ].
  entrySize := self entrySize.
  lowPt := 1.
  highPt := numElements.
  comparisonForSort := self comparisonForSort.
  [ lowPt <= highPt ] whileTrue: [ midPt := lowPt + highPt quo: 2.
      index := (midPt - 1) * entrySize + 2.
      (self
        _compare: comparisonForSort
        key: aKey
        value: aValue
        equalToEntryAt: index)
        ifTrue: [ ^ index - 1 ].
      (self
        _compare: comparisonForSort
        key: aKey
        value: aValue
        lessThanOrEqualToEntryAt: index)
        ifTrue: [ highPt := midPt - 1 ]
        ifFalse: [ lowPt := midPt + 1 ] ].
  ^ 0
%

category: 'Testing'
method: BtreeNode
_canCompare: aKey withClass: aClass

"Returns whether the receiver can make comparisons with the given key.
Returns true since the comparison will actually be attempted."

^ true
%

category: 'Comparison Operators'
method: BtreeNode
_compare: aComparison key: aKey equalToEntryAt: index

"Performs a = comparison between aKey and the entry whose key is at the given
index.  The default implementation uses no encryption."

^ aComparison compareKey: aKey equalTo: (self _at: index)
%

category: 'Comparison Operators'
method: BtreeNode
_compare: aComparison key: aKey greaterThanEntryAt: index

"Perform a > comparison between aKey and the entry whose key is at the given
index.  The default implementation uses no encryption."

^ aComparison compareKey: aKey greaterThan: (self _at: index)
%

category: 'Comparison Operators'
method: BtreeNode
_compare: aComparison key: aKey greaterThanOrEqualToEntryAt: index

"Perform a >= comparison between aKey and the entry whose key is at the given
index.  The default implementation uses no encryption."

^ aComparison compareKey: aKey greaterThanOrEqualTo: (self _at: index)
%

category: 'Comparison Operators'
method: BtreeNode
_compare: aComparison key: aKey lessThanEntryAt: index

"Perform a < comparison between aKey and the entry whose key is at the given
index.  The default implementation uses no encryption."

^ aComparison compareKey: aKey lessThan: (self _at: index)
%

category: 'Comparison Operators'
method: BtreeNode
_compare: aComparison key: aKey lessThanOrEqualToEntryAt: index

"Perform a <= comparison between aKey and the entry whose key is at the given
index.  The default implementation uses no encryption."

^ aComparison compareKey: aKey lessThanOrEqualTo: (self _at: index)
%

category: 'Comparison Operators'
method: BtreeNode
_compare: comparisonForSort key: aKey value: aValue greaterThanEntryAt: index
  "Performs a > comparison between aKey and the entry whose key is at the given
 index.  If the keys are equal, then use the OOP of the value for the
 comparison.  The default implementation uses no encryption."

  " first compare the keys "

  (comparisonForSort compareKey: aKey greaterThan: (super at: index))
    ifTrue: [ ^ true ].
  ^ false
%

category: 'Comparison Operators'
method: BtreeNode
_compare: comparisonForSort key: aKey value: aValue lessThanEntryAt: index
  "Performs a < comparison between aKey and the entry whose key is at the given
 index.  If the keys are equal, then use the OOP of the value for the
 comparison.  The default implementation uses no encryption."

  " first compare the keys "

  (comparisonForSort compareKey: aKey lessThan: (super at: index))
    ifTrue: [ ^ true ].
  ^ false
%

category: 'Comparison Operators'
method: BtreeNode
_compareKey: aKey equalToEntryAt: index
  "Performs a = comparison between aKey and the entry whose key is at the given
index.  The default implementation uses no encryption."

  ^ self _compare: self comparisonForSort key: aKey equalToEntryAt: index
%

category: 'Comparison Operators'
method: BtreeNode
_compareKey: aKey greaterThanEntryAt: index
  "Perform a > comparison between aKey and the entry whose key is at the given
index.  The default implementation uses no encryption."

  ^ self _compare: self comparisonForSort key: aKey greaterThanEntryAt: index
%

category: 'Comparison Operators'
method: BtreeNode
_compareKey: aKey greaterThanOrEqualToEntryAt: index
  "Perform a >= comparison between aKey and the entry whose key is at the given
index.  The default implementation uses no encryption."

  ^ self
    _compare: self comparisonForSort
    key: aKey
    greaterThanOrEqualToEntryAt: index
%

category: 'Comparison Operators'
method: BtreeNode
_compareKey: aKey lessThanEntryAt: index
  "Perform a < comparison between aKey and the entry whose key is at the given
index.  The default implementation uses no encryption."

  ^ self _compare: self comparisonForSort key: aKey lessThanEntryAt: index
%

category: 'Comparison Operators'
method: BtreeNode
_compareKey: aKey lessThanOrEqualToEntryAt: index
  "Performs a <= comparison between aKey and the entry whose key is at the given
index.  The default implementation uses no encryption."

  ^ self
    _compare: self comparisonForSort
    key: aKey
    lessThanOrEqualToEntryAt: index
%

category: 'Comparison Operators'
method: BtreeNode
_compareLastKeyLessThanOrEqualToKey: aKey value: aValue
  "Returns whether the receivers last key/value pair is greater than or equal to
the given key/value pair."

  numElements == 0
    ifTrue: [ ^ false ].	" return aKey <= last key "
  ^ self
    _compare: self comparisonForSort
    key: aKey
    value: aValue
    lessThanOrEqualToEntryAt: self _lastKeyIndex
%

category: 'Updating'
method: BtreeNode
_createSibling
  "Creates a new sibling node and moves half of the receiver's entries into the
sibling.  Returns the new sibling."

  | newSibling sz splitIndex halfNumElements |
  newSibling := self class new.
  newSibling
    objectSecurityPolicy: self objectSecurityPolicy;
    collator: self collator.
  sz := numElements * self entrySize.
  halfNumElements := numElements quo: 2.
  splitIndex := halfNumElements * self entrySize + 1.	" splitIndex is where to split the receiver "
  newSibling
    _insertAt: 1
    from: self
    fromStart: splitIndex
    fromEnd: sz
    numToMoveDown: 0.	" copy the last half of entries into the new sibling "
  self _deleteNoShrinkFrom: splitIndex to: sz.	" nil out last half of receiver "
  newSibling numElements: numElements - halfNumElements.	" update the element counts in the receiver..."
  numElements := halfNumElements.	"... and the sibling "
  ^ newSibling
%

category: 'Constants'
method: BtreeNode
_encryptionSize

"There is no default encryption."

^ 0
%

category: 'Searching'
method: BtreeNode
_findAllValuesForIdenticalKey: aKey into: aCollection
  "Finds all the values for the given identical key, placing them in the
 collection.  Return whether the last key was equal or not (so the caller
 knows it must check the next leaf node)."

  ^ self
    _findAllValuesForIdenticalKey: aKey
    into: aCollection
    using: self comparisonForSort
%

category: 'Searching'
method: BtreeNode
_findAllValuesForKey: aKey into: aCollection
  "Finds all the values for the given key, placing them in the collection."

  ^ self
    _findAllValuesForKey: aKey
    into: aCollection
    using: self comparisonForSort
%

category: 'Searching Support'
method: BtreeNode
_findAllValuesGreaterThanKey: aKey into: anArray
  "Puts into anArray the index and the leaf node of the entry that is greater
 than the given key.  Returns true if a value was found, false otherwise."

  ^ self
    _findAllValuesGreaterThanKey: aKey
    into: anArray
    using: (BtreeComparisonForCompare newForComparison: self collator)
%

category: 'Searching Support'
method: BtreeNode
_findAllValuesLessThanKey: aKey andEquals: aBoolean into: anArray
  "Puts into anArray information about the location of the match.  Returns true
 if a value was found, false otherwise."

  ^ self
    _findAllValuesLessThanKey: aKey
    andEquals: aBoolean
    into: anArray
    using: (BtreeComparisonForCompare newForComparison: self collator)
%

category: 'Searching Support'
method: BtreeNode
_findAllValuesLessThanKey: aKey into: anArray
  "Puts into anArray information about the location of the match.  Returns true
 if a value was found, false otherwise."

  ^ self
    _findAllValuesLessThanKey: aKey
    into: anArray
    using: (BtreeComparisonForCompare newForComparison: self collator)
%

category: 'Searching'
method: BtreeNode
_findCoveringIndexForKey: aKey totalOrder: bool1

"Returns the index for the first entry in which aKey is found.  This is the
first entry whose key >= aKey.  If the receiver's last key is greater than
aKey, or if the receiver is empty, returns 0.  Uses a binary search."

| index |
numElements == 0 ifTrue: [ ^ 0 ].

index := self _binarySearchCoveringKey: aKey totalOrder: bool1.
" check if not found "
^ index > self _lastKeyIndex
ifTrue: [ 0 ]
ifFalse: [ index ]
%

category: 'Searching'
method: BtreeNode
_findFirstValueForKey: aKey
  "Returns the first value associated with the given key."

  ^ self
    _findFirstValueForKey: aKey
    using: (BtreeComparisonForCompare newForComparison: self collator)
%

category: 'Updating'
method: BtreeNode
_incrementNumElements

"Increment the value of the instance variable 'numElements' by 1."

numElements := numElements + 1
%

category: 'Updating'
method: BtreeNode
_insertKey: aKey value: aValue atIndex: insertionIndex

"Insert the key/value pair in the receiver.  The sender of this message must
verify that the entry will fit in the receiver and provide the insertion
index."

| endIndex entrySize |

" see if any existing entries have to be moved "
entrySize := self entrySize .
endIndex := (numElements * entrySize) .

"move entries down to make room for a new entry, or add room at the end"
self _insertAt: insertionIndex
     from: nil "from abstract Array of nils"
     fromStart: 1
     fromEnd: entrySize
     numToMoveDown: (endIndex - insertionIndex + 1) .


" add the new entry "
self _at: insertionIndex put: aValue.
self _at: (insertionIndex + 1) put: aKey.

self _insertEncryptionFor: aKey value: aValue startingAt: (insertionIndex + 2).

numElements := numElements + 1
%

category: 'Accessing'
method: BtreeNode
_lastIndex

"Returns the index of the last used slot in the node."

^ numElements * self entrySize
%

category: 'Accessing'
method: BtreeNode
_lastKeyIndex

"Returns the index of the key of the last entry, or zero if the node is empty."

^ numElements == 0
ifTrue: [ 0 ]
ifFalse: [ numElements - 1 * self entrySize + 2 ]
%

category: 'Searching Support'
method: BtreeNode
_putFirstIndexOfFirstChildInto: anArray ifGreaterThanOrEqualTo: aKey
  "Puts first entry that is greater than or equal to aKey into the Array."

  ^ self
    _putFirstIndexOfFirstChildInto: anArray
    ifGreaterThanOrEqualTo: aKey
    using: (BtreeComparisonForCompare newForComparison: self collator)
%

category: 'Searching'
method: BtreeNode
_scanForAllValuesForKey: aKey into: aCollection
  "Places all values associated with the given key into aCollection."

  ^ self
    _scanForAllValuesForKey: aKey
    into: aCollection
    using: self comparisonForSort
%

! Class extensions for 'BtreeOptimizedComparison'

!		Instance methods for 'BtreeOptimizedComparison'

category: 'Comparison Operators'
method: BtreeOptimizedComparison
compareKey: aKey equalTo: aValue

^ aKey = aValue
%

category: 'Comparison Operators'
method: BtreeOptimizedComparison
compareKey: aKey greaterThan: aValue

^ aKey > aValue
%

category: 'Comparison Operators'
method: BtreeOptimizedComparison
compareKey: aKey greaterThanOrEqualTo: aValue

^ aKey >= aValue
%

category: 'Comparison Operators'
method: BtreeOptimizedComparison
compareKey: aKey lessThan: aValue

^ aKey < aValue
%

category: 'Comparison Operators'
method: BtreeOptimizedComparison
compareKey: aKey lessThanOrEqualTo: aValue

^ aKey <= aValue
%

category: 'Testing'
method: BtreeOptimizedComparison
satisfiableQueryGreaterThan: val1
andEquals: bool1
andLessThan: val2
andEquals: bool2

  "nil is a special case for optimized comparisons ... allowed in queries, but not as value in index"
  ^ val1 ifNil: [ true ]
    ifNotNil: [
      ((val1 > val2) or:
        [ (val1 = val2) and: [ (bool1 and:[bool2]) not ] ] ) not ]
%

! Class extensions for 'BtreeOptimizedUnicodeComparison'

!		Instance methods for 'BtreeOptimizedUnicodeComparison'

category: 'initialization'
method: BtreeOptimizedUnicodeComparison
collator: anIcuCollator
  collator := anIcuCollator
%

category: 'Comparison Operators'
method: BtreeOptimizedUnicodeComparison
compareKey: aKey equalTo: aValue
  ^ aKey _equals: aValue collator: collator useMinSize: 900
%

category: 'Comparison Operators'
method: BtreeOptimizedUnicodeComparison
compareKey: aKey greaterThan: aValue
  ^ (aKey compareTo: aValue collator: collator useMinSize: 900) > 0
%

category: 'Comparison Operators'
method: BtreeOptimizedUnicodeComparison
compareKey: aKey greaterThanOrEqualTo: aValue
  ^ (self compareKey: aKey lessThan: aValue) not
%

category: 'Comparison Operators'
method: BtreeOptimizedUnicodeComparison
compareKey: aKey lessThan: aValue
  ^ (aKey compareTo: aValue collator: nil useMinSize: 900) < 0
%

category: 'Comparison Operators'
method: BtreeOptimizedUnicodeComparison
compareKey: aKey lessThanOrEqualTo: aValue
  ^ (self compareKey: aKey greaterThan: aValue) not
%

category: 'Testing'
method: BtreeOptimizedUnicodeComparison
satisfiableQueryGreaterThan: val1 andEquals: bool1 andLessThan: val2 andEquals: bool2

  ^ (val1 isNil or: [ val2 isNil ])
    ifTrue: [
      ((val1 _idxForCompareGreaterThan: val2)
        or: [ (val1 _idxForCompareEqualTo: val2) and: [ (bool1 and: [ bool2 ]) not ] ]) not ]
    ifFalse: [
      ((self compareKey: val1 greaterThan: val2)
        or: [
          (self compareKey: val1 equalTo: val2)
            and: [ (bool1 and: [ bool2 ]) not ] ]) not ]
%

! Class extensions for 'BtreePlusComparisonQuerySpec'

!		Class methods for 'BtreePlusComparisonQuerySpec'

category: 'Instance Creation'
classmethod: BtreePlusComparisonQuerySpec
key: aKey selector: aSelector

^self new key: aKey selector: aSelector
%

!		Instance methods for 'BtreePlusComparisonQuerySpec'

category: 'Testing'
method: BtreePlusComparisonQuerySpec
canUseOptimizedComparison

  ^ #( #< #> #= #<= #>= ) includes: selector
%

category: 'Accessing'
method: BtreePlusComparisonQuerySpec
collator
  ^ nil
%

category: 'Accessing'
method: BtreePlusComparisonQuerySpec
collator: ignored
  "ignored"


%

category: 'Comparing'
method: BtreePlusComparisonQuerySpec
compare: entry using: sel
  ^ entry perform: sel with: key
%

category: 'Comparing'
method: BtreePlusComparisonQuerySpec
compareKey: entry
  ^ entry perform: selector with: key
%

category: 'Updating'
method: BtreePlusComparisonQuerySpec
key: aKey selector: aSelector
  key := aKey.
  self optimizingComparison
    ifTrue: [ selector := aSelector ]
    ifFalse: [ opCode := self operationSelectors indexOf: aSelector.
      selector := self performSelector: opCode ]
%

category: 'Accessing'
method: BtreePlusComparisonQuerySpec
operationSelectors

"Returns an Array of comparison operation selectors whose ordering corresponds
 to the operation integer for each predicate entry in the receiver."

^ #( #< #> #= #== #<= #>= #~= #~~)
%

category: 'Accessing'
method: BtreePlusComparisonQuerySpec
optimizedUnicodeStringPerformSelectors
  "Returns an Array of comparison operation selectors whose ordering corresponds
 to the optimized operation selectors."

  ^ #(#'_idxForCompareLessThan:collator:' #'_idxForCompareGreaterThan:collator:' #'_idxForCompareEqualTo:collator:' #'==' #'_idxForCompareLessThanOrEqualTo:collator:' #'_idxForCompareGreaterThanOrEqualTo:collator:' #'_idxForCompareNotEqualTo:collator:' #'~~')
%

category: 'Accessing'
method: BtreePlusComparisonQuerySpec
optimizedUnicodeSymbolPerformSelectors
  "Returns an Array of comparison operation selectors whose ordering corresponds
 to the optimized operation selectors."

  ^ #(#'_idxForCompareLessThan:collator:' #'_idxForCompareGreaterThan:collator:' #'==' #'==' #'_idxForCompareLessThanOrEqualTo:collator:' #'_idxForCompareGreaterThanOrEqualTo:collator:' #'~~' #'~~')
%

category: 'Testing'
method: BtreePlusComparisonQuerySpec
optimizingComparison
  "Answer true if the receiver is optimizing comparisons"

  rangeIndex ifNil: [ ^ false ].
  ^ optimizingComparison
%

category: 'Accessing'
method: BtreePlusComparisonQuerySpec
performSelector: anOpCode

^self performSelectors at: anOpCode
%

category: 'Accessing'
method: BtreePlusComparisonQuerySpec
performSelectors

"Returns an Array of comparison operation selectors whose ordering corresponds
 to the operation selectors."

^ #( #_idxForCompareLessThan:
    #_idxForCompareGreaterThan:
    #_idxForCompareEqualTo:
    #==
    #_idxForCompareLessThanOrEqualTo:
    #_idxForCompareGreaterThanOrEqualTo:
    #_idxForCompareNotEqualTo:
    #~~
  )
%

category: 'Updating'
method: BtreePlusComparisonQuerySpec
rangeIndex: aGsRangeOrIdenityIndex
  "needed to know whether or not to optimize comparisons"

  rangeIndex := aGsRangeOrIdenityIndex.
  optimizingComparison := rangeIndex optimizingComparison
%

category: 'Accessing'
method: BtreePlusComparisonQuerySpec
unicodePerformSelector: anOpCode
  ^ rangeIndex constraintType == #'symbol'
      ifTrue: [ self optimizedUnicodeSymbolPerformSelectors at: anOpCode ]
      ifFalse: [
        rangeIndex constraintType == #'string'
          ifTrue: [ self optimizedUnicodeStringPerformSelectors at: anOpCode ]
          ifFalse: [
            "rangeIndex constraintType == #unicodeString or nil"
            self performSelector: anOpCode ] ]
%

category: 'Querying'
method: BtreePlusComparisonQuerySpec
_addRootObjectsFrom: aLeafNode entrySize: entrySize start: startIndex end: endIndex into: collection
  (self optimizingComparison and: [ self canUseOptimizedComparison ])
    ifTrue: [ startIndex to: endIndex by: entrySize do: [ :i | collection add: (aLeafNode rootObjectAt: i) ] ]
    ifFalse: [ startIndex to: endIndex by: entrySize do: [ :i | (self compare: (aLeafNode keyAt: i) using: selector)
          ifTrue: [ collection add: (aLeafNode rootObjectAt: i) ] ] ]
%

category: 'Querying'
method: BtreePlusComparisonQuerySpec
_addValuesFrom: aLeafNode entrySize: entrySize start: startIndex end: endIndex into: collection
  self shouldNotImplement: #'_addValuesFrom:entrySize:start:end:into:'
%

category: 'Querying'
method: BtreePlusComparisonQuerySpec
_traverseValuesFrom: aLeafNode entrySize: entrySize start: startIndex end: endIndex previous: previousValue into: collection
  self shouldNotImplement: #'_traverseValuesFrom:entrySize:start:end:previous:into:'
%

! Class extensions for 'BtreePlusGsIndexReadStream'

!		Class methods for 'BtreePlusGsIndexReadStream'

category: 'Instance Creation'
classmethod: BtreePlusGsIndexReadStream
on: aGsRangeIndex
  "Create a stream that can access the entire contents of the given RangeEqualityIndex."

  | newStream |
  newStream := super on: aGsRangeIndex btreeRoot.
  newStream rangeIndex: aGsRangeIndex.
  ^ newStream
%

!		Instance methods for 'BtreePlusGsIndexReadStream'

category: 'Query Support'
method: BtreePlusGsIndexReadStream
approxNumElements

"Returns the number of leaf node entries represented by the receiver.  This is
 approximately the number of elements because objects may share sub-objects
 which converge to the same leaf node entry."

^ self size
%

category: 'Testing'
method: BtreePlusGsIndexReadStream
atEnd
  "Returns true if there are no more elements to return through the logical
 iteration of the stream."

  mustCompare
    ifTrue: [ "bug 44079: need to skip key/value pairs that do not satisfy the querySpec"
      [ | aKey |
      currentIndex == 0
        ifTrue: [ ^ true ].
      aKey := currentNode keyAt: currentIndex.
      streamQuerySpec compareKey: aKey ] whileFalse: [
          self _btreeNextRootObject.
          currentIndex == 0
            ifTrue: [ ^ true ] ] ].
  ^ currentIndex == 0
%

category: 'Accessing'
method: BtreePlusGsIndexReadStream
btreeComparisonQuerySpec
  ^ self gsIndex btreeComparisonQuerySpec
%

category: 'Accessing'
method: BtreePlusGsIndexReadStream
btreeRangeComparisonQuerySpec
  ^ self gsIndex btreeRangeComparisonQuerySpec
%

category: 'Private'
method: BtreePlusGsIndexReadStream
getNext
  "Returns the next value on a stream of range index values."

  "QueryExecutor compat"

  ^ self next
%

category: 'Updating'
method: BtreePlusGsIndexReadStream
gsIndex
  "Answer the value of the instance variable 'gsIndex'."

  ^gsIndex
%

category: 'Updating'
method: BtreePlusGsIndexReadStream
identityIndex: aGsIndex
  "Modify the value of the instance variable 'gsIndex'."

  gsIndex := aGsIndex
%

category: 'Query Support'
method: BtreePlusGsIndexReadStream
makeNsc

"Returns a new NSC that contains all the elements from the receiver."

| tmpHolder |
tmpHolder := NscBuilder for: gsIndex nscRoot species new max: gsIndex nscRoot size.

streamQuerySpec
  ifNil: [
    self _valuesAddInto: tmpHolder ]
  ifNotNil: [
    self _valuesAddInto: tmpHolder spec: streamQuerySpec ].

" make the stream be at the end "
currentIndex := 0.

^ tmpHolder completeBag
%

category: 'Query Support'
method: BtreePlusGsIndexReadStream
makeNscComparing: aSelector key: aKey

"Returns a new NSC that contains all the elements from the receiver."

| tmpHolder |
tmpHolder := NscBuilder for: gsIndex nscRoot species new max: gsIndex nscRoot size.

self _valuesAddInto: tmpHolder comparing: aSelector key: aKey.

" make the stream be at the end "
currentIndex := 0.

^ tmpHolder completeBag
%

category: 'Query Support'
method: BtreePlusGsIndexReadStream
makeNscComparing: aSelector1 key: aKey1 and: aSelector2 key: aKey2

"Returns a new NSC that contains all the elements from the receiver."

| tmpHolder |
tmpHolder := NscBuilder for: gsIndex nscRoot species new max: gsIndex nscRoot size.

self _valuesAddInto: tmpHolder comparing: aSelector1 key: aKey1 and: aSelector2 key: aKey2.

" make the stream be at the end "
currentIndex := 0.
^ tmpHolder completeBag
%

category: 'Accessing'
method: BtreePlusGsIndexReadStream
next
  "Returns the next root object on a stream of B-tree values and root objects.  Update the current
 stack for a subsequent 'next'."

  optimizedComparison
    ifTrue: [
      currentIndex == 0
        ifTrue: [ ^ self _errorEndOfStream ].
     ^ self _btreeNextRootObject ].
  "bug 44079: use #atEnd to skip key/value pairs that do not satisfy the querySpec ... "
  self atEnd
    ifTrue: [ ^ self _errorEndOfStream ].
  ^ self _btreeNextRootObject
%

category: 'Query Support'
method: BtreePlusGsIndexReadStream
nextRootComparing: aSelector key: aKey
  " iterate through the stream, return first value that satisfies query "

  [ self _atEnd not ]
    whileTrue: [
      (self _peekKey perform: aSelector with: aKey)
        ifTrue: [ ^ self next ].
      self _btreeNext ].
  ^ #'_incompletePathTraversal'
%

category: 'Query Support'
method: BtreePlusGsIndexReadStream
nextRootComparing: aSelector1 key: aKey1 and: aSelector2 key: aKey2
  " iterate through the stream, return first value that satisfies query "

  [ self _atEnd not ]
    whileTrue: [
      | key |
      key := self _peekKey.
      ((key perform: aSelector1 with: aKey1)
        and: [ key perform: aSelector2 with: aKey2 ])
        ifTrue: [ ^ self next ].
      self _btreeNext ].
  ^ #'_incompletePathTraversal'
%

category: 'Updating'
method: BtreePlusGsIndexReadStream
rangeIndex: aGsIndex
  "Modify the value of the instance variable 'gsIndex'."

  gsIndex := aGsIndex.
  optimizedComparison := gsIndex optimizingComparison.
  mustCompare := false
%

category: 'Conversion'
method: BtreePlusGsIndexReadStream
reversed

  | reversed |
  reversed := (self reversedRangeIndexClass on: self gsIndex).

  self atEnd
    ifTrue: [ reversed currentIndex: 0 ]
    ifFalse: [
      reversed
        currentIndex: endIndex;
        currentNode: endNode;
        endIndex: currentIndex;
        endNode: currentNode;
        streamQuerySpec: self streamQuerySpec;
        yourself ].
  ^ reversed
%

category: 'Private'
method: BtreePlusGsIndexReadStream
reversedRangeIndexClass
  ^ BtreePlusGsReversedIndexReadStream
%

category: 'Accessing'
method: BtreePlusGsIndexReadStream
skip: amount
  "advance the receiver's position by amount elements"

  | count |
  count := 0.
  [ self atEnd not and: [ count < amount ] ]
    whileTrue: [ 
      self _btreeNextNoValue.
      count := count + 1 ]
%

category: 'Accessing'
method: BtreePlusGsIndexReadStream
streamQuerySpec
  ^ streamQuerySpec
%

category: 'Accessing'
method: BtreePlusGsIndexReadStream
streamQuerySpec: aBtreeQuerySpec
  streamQuerySpec := aBtreeQuerySpec.
  (optimizedComparison
    and: [ aBtreeQuerySpec == nil or: [ aBtreeQuerySpec canUseOptimizedComparison ] ])
    ifTrue: [ mustCompare := false ]
    ifFalse: [
      "bug 44079: need to skip key/value pairs that do not satisfy the streamQuerySpec.
       If optimizedComparison is true, then not exposed to bug 44079. "
      mustCompare := aBtreeQuerySpec notNil ]
%

category: 'Private'
method: BtreePlusGsIndexReadStream
_advance
   "Advances the B-tree portion of the stream without advancing any of the set
     iteration indexes."

   ^ self next
%

category: 'Query Support'
method: BtreePlusGsIndexReadStream
_scanForRootObjectMaps: aKey value: aValue valueOop: valueOop using: comparisonForCompare do: aBlock
  "Adds each entry value into the given NSC."

  | eSize |
  " get the index into the leaf node and see if it has reached the end "
  currentIndex == 0
    ifTrue: [ ^ self ].
  eSize := endNode entrySize.
  " while current node is not the end node "
  [ endNode ~~ currentNode ]
    whileTrue: [
      " scan key and values of currentNode "
      currentNode
        _scanForRootObjectMapsStartingAt: currentIndex
        end: currentLastValIndex
        key: aKey
        value: aValue
        valueOop: valueOop
        using: comparisonForCompare
        do: aBlock.
      " get the next leaf node "
      self _nextLeaf ].
  " scan key and values of endNode "
  currentNode
    _scanForRootObjectMapsStartingAt: currentIndex
    end: endIndex
    key: aKey
    value: aValue
    valueOop: valueOop
    using: comparisonForCompare
    do: aBlock.
%

category: 'Query Support'
method: BtreePlusGsIndexReadStream
_valuesAddInto: collection

"Adds each entry value into the given NSC."

| querySpec |
querySpec := BtreeQuerySpec new.
^self _valuesAddInto: collection spec: querySpec
%

category: 'Query Support'
method: BtreePlusGsIndexReadStream
_valuesAddInto: collection comparing: aSelector key: aKey
  "Adds each entry value into the given NSC."

  | querySpec |
  querySpec := self btreeComparisonQuerySpec
    key: aKey selector: aSelector;
    yourself.
  ^ self _valuesAddInto: collection spec: querySpec
%

category: 'Query Support'
method: BtreePlusGsIndexReadStream
_valuesAddInto: collection comparing: aSelector1 key: aKey1 and: aSelector2 key: aKey2
  "Adds each entry value into the given NSC."

  | querySpec |
  querySpec := self btreeRangeComparisonQuerySpec
    key: aKey1 selector: aSelector1;
    key2: aKey2 selector2: aSelector2;
    yourself.
  ^ self _valuesAddInto: collection spec: querySpec
%

category: 'Query Support'
method: BtreePlusGsIndexReadStream
_valuesAddInto: collection identicalTo: aKey
  "For each entry whose key is identical to the given key, add the value into
 the given collection."

  | querySpec |
  querySpec := self btreeComparisonQuerySpec
    key: aKey selector: #'==';
    yourself.
  ^ self _valuesAddInto: collection spec: querySpec
%

category: 'Query Support'
method: BtreePlusGsIndexReadStream
_valuesAddInto: collection notEqualTo: aKey
  "For each entry whose key is not identical to the given key, add the value
 into the given collection."

  | querySpec |
  querySpec := self btreeComparisonQuerySpec
    key: aKey selector: #'~=';
    yourself.
  ^ self _valuesAddInto: collection spec: querySpec
%

category: 'Query Support'
method: BtreePlusGsIndexReadStream
_valuesAddInto: collection notIdenticalTo: aKey
  "For each entry whose key is not identical to the given key, add the value
 into the given collection."

  | querySpec |
  querySpec := self btreeComparisonQuerySpec
    key: aKey selector: #'~~';
    yourself.
  ^ self _valuesAddInto: collection spec: querySpec
%

category: 'Query Support'
method: BtreePlusGsIndexReadStream
_valuesAddInto: collection spec: querySpec
  "Adds each entry value into the given NSC."

  | eSize |
  " get the index into the leaf node and see if it has reached the end "
  currentIndex == 0
    ifTrue: [ ^ self ].
  eSize := endNode entrySize.
  " while current node is not the end node "
  [ endNode ~~ currentNode ]
    whileTrue: [ " put the values for the current node in the collection "
      querySpec
        addRootObjectsFrom: currentNode
        start: currentIndex
        end: currentNode numElements * eSize
        into: collection.
      " get the next leaf node "
      self _nextLeaf ].
  " put values of end node in the collection "
  querySpec
    addRootObjectsFrom: currentNode
    start: currentIndex
    end: endIndex
    into: collection
%

! Class extensions for 'BtreePlusGsReversedIndexReadStream'

!		Class methods for 'BtreePlusGsReversedIndexReadStream'

category: 'Instance Creation'
classmethod: BtreePlusGsReversedIndexReadStream
on: aGsRangeIndex
  "Create a stream that can access the entire contents of the B-tree whose
 root node is aBtreeNode."

  | arr1 arr2 newStream btreeNode |
  arr1 := {}.
  arr2 := {}.
  btreeNode := aGsRangeIndex btreeRoot.
  btreeNode _putFirstIndexOfFirstChildInto: arr2.
  btreeNode _putLastIndexOfLastChildInto: arr1.
  newStream := self new.
  newStream endIndex: (arr2 at: 1).
  newStream endNode: (arr2 at: 2).
  newStream currentStack: arr1.
  newStream rangeIndex: aGsRangeIndex.
  ^ newStream
%

!		Instance methods for 'BtreePlusGsReversedIndexReadStream'

category: 'Private'
method: BtreePlusGsReversedIndexReadStream
reversedRangeIndexClass
  ^ BtreePlusGsIndexReadStream
%

category: 'Accessing'
method: BtreePlusGsReversedIndexReadStream
size

"Returns the number of elements contained in the receiver (that is, how many
successful 'previous' operations can be performed)."

| total theNode theIndex lastNode |
self atEnd ifTrue: [
  ^ 0
  ].
total := 0.
theNode := currentNode.
theIndex := currentIndex.
lastNode := false.
[ lastNode ] whileFalse: [
  lastNode := theNode == endNode.
  total := total + (theNode
    _totalElementsReversedFrom: theIndex
    toEndNode: endNode
    endIndex: endIndex).
  lastNode
    ifFalse: [
      theNode := theNode previousLeaf.
      theIndex := theNode _lastIndex ] ].
^ total
%

category: 'Accessing'
method: BtreePlusGsReversedIndexReadStream
skip: amount
  "advance the receiver's position by amount elements"

  | count |
  count := 0.
  [ self atEnd not and: [ count < amount ] ]
    whileTrue: [ 
      self _btreePreviousNoValue.
      count := count + 1 ]
%

category: 'Accessing'
method: BtreePlusGsReversedIndexReadStream
_btreeNextRootObject
  "Returns the previous root object on a stream of B-tree values and root objects.  Updates the current
 stack for a subsequent 'previous'."

  ^self _btreePreviousRootObject
%

category: 'Accessing'
method: BtreePlusGsReversedIndexReadStream
_btreeNextValue

"Returns the previous value on a stream of B-tree values and root objects.  Updates the current
 stack for a subsequent 'previous'."

^ self _btreePreviousValue
%

category: 'Accessing'
method: BtreePlusGsReversedIndexReadStream
_btreePreviousNoValue
  "Returns the next value on a stream of B-tree values and root objects.  Updates the current
 stack for a subsequent 'next'."

  " get the index into the leaf node and see if it has reached the end "
  currentIndex == 0
    ifTrue: [ ^ self _errorEndOfStream ].	" get the leaf and the value within the leaf "
  (currentNode == endNode and: [ endIndex == currentIndex ])
    ifTrue: [ 
      currentIndex := 0.
      ^ self ].	" see if index refers to first entry in this leaf "
  currentIndex == 1
    ifTrue: [ 
      " must look down the stack for the next leaf node "
      self _previousLeaf ]
    ifFalse: [ currentIndex := currentIndex - currentEntrySize ].
%

category: 'Accessing'
method: BtreePlusGsReversedIndexReadStream
_btreePreviousRootObject
  "Returns the next root object on a stream of B-tree values and root objects.  Updates the current
 stack for a subsequent 'next'."

  | root |
  " get the root value within the leaf "
  root := currentNode rootObjectAt: currentIndex.
  " if this is the end of the stream, sets the top currentIndex to zero and returns "
  (currentNode == endNode and: [ endIndex == currentIndex ])
    ifTrue: [ currentIndex := 0.
      ^ root ].
  " see if currentIndex refers to last entry in this leaf "
  currentIndex == 1
    ifTrue: [ self _previousLeaf ]
    ifFalse: [ currentIndex := currentIndex - currentEntrySize ].
  ^ root
%

category: 'Accessing'
method: BtreePlusGsReversedIndexReadStream
_btreePreviousValue

"Returns the next value on a stream of B-tree values and root objects.  Updates the current
 stack for a subsequent 'next'."

| val    |
" get the index into the leaf node and see if it has reached the end "
currentIndex == 0
    ifTrue: [ ^ self _errorEndOfStream ].

" get the leaf and the value within the leaf "
val := currentNode at: currentIndex.

" if this is the end of the stream, sets the top index to zero and returns "
( currentNode == endNode and: [ endIndex == currentIndex ] )
    ifTrue: [
        currentIndex := 0.
        ^ val
    ].

" see if index refers to first entry in this leaf "
currentIndex == 1
    ifTrue: [
        " must look down the stack for the next leaf node "
        self _previousLeaf
    ]
    ifFalse: [ currentIndex := (currentIndex - currentEntrySize) ].

^ val
%

category: 'Accessing'
method: BtreePlusGsReversedIndexReadStream
_previousLeaf
  "Get the previous leaf node and make it the current node."

  self currentNode: currentNode previousLeaf.
  currentNode ifNil: [ ^ self _errorEndOfStream ].
  currentIndex := currentLastValIndex
%

category: 'Query Support'
method: BtreePlusGsReversedIndexReadStream
_valuesAddInto: collection spec: querySpec
  "Adds each entry value into the given NSC."

  | eSize |
  " get the index into the leaf node and see if it has reached the end "
  currentIndex == 0
    ifTrue: [ ^ self ].
  eSize := endNode entrySize.
  " while current node is not the end node "
  [ endNode ~~ currentNode ]
    whileTrue: [ " put root objects for the current node in the collection "
      querySpec
        addRootObjectsFrom: currentNode
        start: 1
        end: currentIndex
        into: collection.
      " get the previous leaf node "
      self _previousLeaf ].
  " put root objects of end node in the collection "
  querySpec
    addRootObjectsFrom: currentNode
    start: endIndex
    end: currentIndex
    into: collection
%

! Class extensions for 'BtreePlusInteriorKeyValueNode'

!		Class methods for 'BtreePlusInteriorKeyValueNode'

category: 'Constants'
classmethod: BtreePlusInteriorKeyValueNode
entrySize
  "Returns the size of an entry."

  "in-lined on instance-side for performance"

  ^ 2
%

category: 'Constants'
classmethod: BtreePlusInteriorKeyValueNode
maxNumberOfElements
  "Returns the number of entries that are allowed in an interior node."

  ^ 1014
%

!		Instance methods for 'BtreePlusInteriorKeyValueNode'

category: 'Updating'
method: BtreePlusInteriorKeyValueNode
at: aKey put: aValue root: ignored
  "Adds the key/value/root tuple to one of the leaf nodes.  If a split occurs, returns
   the new sibling, otherwise returns the receiver."

  ^ super at: aKey put: aValue root: nil
%

category: 'Rc Updating'
method: BtreePlusInteriorKeyValueNode
at: aKey put: aValue root: ignored selectiveAbortSet: selectiveAbortSetOrNil
  "Adds the key/value/root pair to the node.  If the node is full, performs a 'split'
 on the parent.  Returns the new sibling if a split is performed, otherwise
 returns the receiver."

  ^ super at: aKey put: aValue root: nil selectiveAbortSet: selectiveAbortSetOrNil
%

category: 'Searching'
method: BtreePlusInteriorKeyValueNode
binarySearchCoveringKey: aKey value: aValue root: ignored
  "Returns the index for the entry in which aKey/aValue would be inserted.  This
 is the first entry which has its key >= aKey.  If multiple entries have the
 same key (key = aKey), then aValue is used (since entries with duplicate keys
 are inserted by the value's OOP ordering).  If multiple entries have the same value
 (value = aValue), then rootObject is used (since entries with duplicate values are
 inserted by the rootObject's OOP ordering). If the receiver is empty, returns
 1.  Uses a binary search."

  ^ self binarySearchCoveringKey: aKey value: aValue
%

category: 'Comparison Operators'
method: BtreePlusInteriorKeyValueNode
compareValueOop: aValue greaterThanEntryValueOopAt: keyIndex root: ignored
  "Perform a > comparison between the oop of aValue and oop of the entry whose value is
   at the given index."

  ^ self compareValueOop: aValue greaterThanEntryValueOopAt: keyIndex
%

category: 'Comparison Operators'
method: BtreePlusInteriorKeyValueNode
compareValueOop: aValue greaterThanEntryValueOopAt: keyIndex root: ignored selectiveAbortSet: selectiveAbortSetOrNil
  "Perform a > comparison between the oop of aValue and oop of the entry whose value is
   at the given index."

  ^ self compareValueOop: aValue greaterThanEntryValueOopAt: keyIndex selectiveAbortSet: selectiveAbortSetOrNil
%

category: 'Comparison Operators'
method: BtreePlusInteriorKeyValueNode
compareValueOop: aValue lessThanOrEqualToEntryValueOopAt: keyIndex root: ignored
  "Perform a <= comparison between the oop of aValue and oop of the entry whose value is
   at the given index."

  ^ self compareValueOop: aValue lessThanOrEqualToEntryValueOopAt: keyIndex
%

category: 'Comparison Operators'
method: BtreePlusInteriorKeyValueNode
compareValueOop: aValue lessThanOrEqualToEntryValueOopAt: keyIndex root: ignored selectiveAbortSet: selectiveAbortSetOrNil
  "Perform a <= comparison between the oop of aValue and oop of the entry whose value is
   at the given index."

  ^ self compareValueOop: aValue lessThanOrEqualToEntryValueOopAt: keyIndex selectiveAbortSet: selectiveAbortSetOrNil
%

category: 'Constants'
method: BtreePlusInteriorKeyValueNode
entrySize
  "Returns the size of an entry."

  "in-line of `self class entrySize` for performance"

  ^ 2
%

category: 'Accessing'
method: BtreePlusInteriorKeyValueNode
rootIndexOffset
  "Answer the offset from entry index for the root object. Typical order is value/key/root.
   The key and root object is the same for the receiver. The root object is not updated."

  ^ 1
%

category: 'Updating'
method: BtreePlusInteriorKeyValueNode
updateLastChildRoot: lastChildRoot at: index

  " Update the root object for receiver, if last child root has changed "

  "the root object is not updated ... as it is not recorded in the receiver "
%

category: 'Updating'
method: BtreePlusInteriorKeyValueNode
_insertKey: aKey value: newPredecessorNode atIndex: insertionIndex
  "Insert the key/value pair in the receiver.  The sender of this message must
verify that the entry will fit in the receiver and provide the insertion
index."

  | endIndex entrySize |
  entrySize := self entrySize.
  endIndex := numElements * entrySize.

  " newPredecessorNode node is being inserted in front of node at insertionIndex, update the previous/next leaf values for both nodes"
  (self at: insertionIndex)
    ifNil: [
      insertionIndex > 1
        ifTrue: [
          | previousNode |
          previousNode := self at: insertionIndex - entrySize.
          newPredecessorNode
            _updateLeafNodeLinksForNewPreviousLeaf:  previousNode
            newNextLeaf: previousNode nextLeaf ] ]
    ifNotNil: [:formerPredecessorNode |
      formerPredecessorNode
        _updateLeafNodeLinksForNewPreviousLeaf: newPredecessorNode
        newNextLeaf: formerPredecessorNode nextLeaf ].

  self _insertAt: insertionIndex
       value: newPredecessorNode value: aKey
       numToMoveDown: endIndex - insertionIndex + 1 .

  numElements := numElements + 1


%

category: 'Updating'
method: BtreePlusInteriorKeyValueNode
_insertKey: aKey value: newPredecessorNode atIndex: insertionIndex  selectiveAbortSet: selectiveAbortSetOrNil
  "Insert the key/value pair in the receiver.  The sender of this message must
verify that the entry will fit in the receiver and provide the insertion
index."

  | endIndex entrySize |
  entrySize := self entrySize.
  endIndex := numElements * entrySize.

  " newPredecessorNode node is being inserted in front of node at insertionIndex, update the previous/next leaf values for both nodes"
  (self at: insertionIndex)
    ifNil: [
      insertionIndex > 1
        ifTrue: [
          | previousNode |
          previousNode := self at: insertionIndex - entrySize.
          self _selectiveAbort: previousNode ifNotIn: selectiveAbortSetOrNil.
          newPredecessorNode
            _updateLeafNodeLinksForNewPreviousLeaf:  previousNode
            newNextLeaf: previousNode nextLeaf
            selectiveAbortSet: selectiveAbortSetOrNil ] ]
    ifNotNil: [:formerPredecessorNode |
      self _selectiveAbort: formerPredecessorNode ifNotIn: selectiveAbortSetOrNil.
      formerPredecessorNode
        _updateLeafNodeLinksForNewPreviousLeaf: newPredecessorNode
        newNextLeaf: formerPredecessorNode nextLeaf
        selectiveAbortSet: selectiveAbortSetOrNil ].

  self _insertAt: insertionIndex
       value: newPredecessorNode value: aKey
       numToMoveDown: endIndex - insertionIndex + 1 .

  numElements := numElements + 1


%

category: 'Updating'
method: BtreePlusInteriorKeyValueNode
_insertKey: aKey value: aValue root: ignored atIndex: insertionIndex

"Insert the key/value pair in the receiver.  The sender of this message must
verify that the entry will fit in the receiver and provide the insertion
index."

self _insertKey: aKey value: aValue atIndex: insertionIndex
%

category: 'Updating'
method: BtreePlusInteriorKeyValueNode
_insertKey: aKey value: aValue root: ignored atIndex: insertionIndex selectiveAbortSet: selectiveAbortSetOrNil

"Insert the key/value pair in the receiver.  The sender of this message must
verify that the entry will fit in the receiver and provide the insertion
index."

self _insertKey: aKey value: aValue atIndex: insertionIndex selectiveAbortSet: selectiveAbortSetOrNil
%

! Class extensions for 'BtreePlusInteriorKeyValueRootObjectNode'

!		Class methods for 'BtreePlusInteriorKeyValueRootObjectNode'

category: 'Constants'
classmethod: BtreePlusInteriorKeyValueRootObjectNode
entrySize
  "Returns the size of an entry."

  "in-lined on instance-side for performance"

  ^ 3
%

category: 'Constants'
classmethod: BtreePlusInteriorKeyValueRootObjectNode
maxNumberOfElements
  "Returns the number of entries that are allowed in an interior node."

  ^ 676
%

!		Instance methods for 'BtreePlusInteriorKeyValueRootObjectNode'

category: 'Comparison Operators'
method: BtreePlusInteriorKeyValueRootObjectNode
compareValueOop: aValue greaterThanEntryValueOopAt: keyIndex root: aRootObject
  "Perform a > comparison between the oop of aValue and oop of the entry whose value is
   at the given index. If the value oops are equal, compare the oop of aRootObject and the
   oop of the root object at the given index."

  | entryValue entryValueLastValue |
  entryValue := self at: keyIndex - self keyIndexOffset.
  entryValueLastValue := entryValue lastValue.
  "aValue asOop = entryValueLastValue asOop"
  aValue == entryValueLastValue
    ifTrue: [ ^ aRootObject asOop > entryValue lastRoot asOop ].
  ^ aValue asOop > entryValueLastValue asOop
%

category: 'Comparison Operators'
method: BtreePlusInteriorKeyValueRootObjectNode
compareValueOop: aValue greaterThanEntryValueOopAt: keyIndex root: aRootObject selectiveAbortSet: selectiveAbortSetOrNil
  "Perform a > comparison between the oop of aValue and oop of the entry whose value is
   at the given index. If the value oops are equal, compare the oop of aRootObject and the
   oop of the root object at the given index."

  | entryValue entryValueLastValue |
  entryValue := self at: keyIndex - self keyIndexOffset.
  self _selectiveAbort: entryValue ifNotIn: selectiveAbortSetOrNil.
  entryValueLastValue := entryValue lastValue.
  "aValue asOop = entryValueLastValue asOop"
  aValue == entryValueLastValue
    ifTrue: [ ^ aRootObject asOop > entryValue lastRoot asOop ].
  ^ aValue asOop > entryValueLastValue asOop
%

category: 'Comparison Operators'
method: BtreePlusInteriorKeyValueRootObjectNode
compareValueOop: aValue lessThanOrEqualToEntryValueOopAt: keyIndex root: aRootObject
  "Perform a <= comparison between the oop of aValue and oop of the entry whose value is
   at the given index. If the value oops are equal, compare the oop of aRootObject and the
   oop of the root object at the given index."

  | entryValue entryValueLastValue |
  entryValue := self at: keyIndex - self keyIndexOffset.
  entryValueLastValue := entryValue lastValue.
  "aValue asOop = entryValueLastValue asOop"
  aValue == entryValueLastValue
    ifTrue: [ ^ aRootObject asOop <= entryValue lastRoot asOop ].
  ^ aValue asOop < entryValueLastValue asOop
%

category: 'Comparison Operators'
method: BtreePlusInteriorKeyValueRootObjectNode
compareValueOop: aValue lessThanOrEqualToEntryValueOopAt: keyIndex root: aRootObject selectiveAbortSet: selectiveAbortSetOrNil
  "Perform a <= comparison between the oop of aValue and oop of the entry whose value is
   at the given index. If the value oops are equal, compare the oop of aRootObject and the
   oop of the root object at the given index."

  | entryValue entryValueLastValue |
  entryValue := self at: keyIndex - self keyIndexOffset.
  self _selectiveAbort: entryValue ifNotIn: selectiveAbortSetOrNil.
  entryValueLastValue := entryValue lastValue.
  "aValue asOop = entryValueLastValue asOop"
  aValue == entryValueLastValue
    ifTrue: [ ^ aRootObject asOop <= entryValue lastRoot asOop ].
  ^ aValue asOop < entryValueLastValue asOop
%

category: 'Constants'
method: BtreePlusInteriorKeyValueRootObjectNode
entrySize
  "Returns the size of an entry."

  "in-line of `self class entrySize` for performance"

  ^ 3
%

category: 'Updating'
method: BtreePlusInteriorKeyValueRootObjectNode
_insertKey: aKey value: newPredecessorNode root: rootObject atIndex: insertionIndex
  "Insert the key/value pair in the receiver.  The sender of this message must
verify that the entry will fit in the receiver and provide the insertion
index."

  | endIndex entrySize |
  entrySize := self entrySize.
  endIndex := numElements * entrySize.

  " newPredecessorNode node is being inserted in front of node at insertionIndex,
    update the previous/next leaf values for both nodes --- only applies to leaf nodes"
  newPredecessorNode isLeaf
    ifTrue: [
      (self at: insertionIndex )
        ifNil: [
          insertionIndex > 1
            ifTrue: [
              | previousNode |
              previousNode := self at: insertionIndex - entrySize.
              newPredecessorNode
                _updateLeafNodeLinksForNewPreviousLeaf:   previousNode
                newNextLeaf: previousNode nextLeaf ] ]
        ifNotNil: [:formerPredecessorNode |
          formerPredecessorNode
            _updateLeafNodeLinksForNewPreviousLeaf: newPredecessorNode
            newNextLeaf: formerPredecessorNode nextLeaf ] ].

  self _insertAt: insertionIndex
       value: newPredecessorNode value: aKey value: rootObject
       numToMoveDown: endIndex - insertionIndex + 1.

  numElements := numElements + 1

%

category: 'Updating'
method: BtreePlusInteriorKeyValueRootObjectNode
_insertKey: aKey value: newPredecessorNode root: rootObject atIndex: insertionIndex selectiveAbortSet: selectiveAbortSetOrNil
  "Insert the key/value pair in the receiver.  The sender of this message must
verify that the entry will fit in the receiver and provide the insertion
index."

  | endIndex entrySize |
  entrySize := self entrySize.
  endIndex := numElements * entrySize.

  " newPredecessorNode node is being inserted in front of node at insertionIndex, update the previous/next leaf values for both nodes"
  (self at: insertionIndex)
    ifNil: [
      insertionIndex > 1
        ifTrue: [
          | previousNode |
          previousNode := self at: insertionIndex - entrySize.
          self _selectiveAbort: previousNode ifNotIn: selectiveAbortSetOrNil.
          newPredecessorNode
            _updateLeafNodeLinksForNewPreviousLeaf: previousNode
            newNextLeaf: previousNode nextLeaf
            selectiveAbortSet: selectiveAbortSetOrNil ] ]
    ifNotNil: [:formerPredecessorNode |
      self _selectiveAbort: formerPredecessorNode ifNotIn: selectiveAbortSetOrNil.
      formerPredecessorNode
        _updateLeafNodeLinksForNewPreviousLeaf: newPredecessorNode
        newNextLeaf: formerPredecessorNode nextLeaf
        selectiveAbortSet: selectiveAbortSetOrNil ].

  self _insertAt: insertionIndex
       value: newPredecessorNode value: aKey value: rootObject
       numToMoveDown: endIndex - insertionIndex + 1.

  numElements := numElements + 1

%

! Class extensions for 'BtreePlusInteriorNode'

!		Instance methods for 'BtreePlusInteriorNode'

category: 'Updating'
method: BtreePlusInteriorNode
at: aKey put: aValue root: rootObject

  "Adds the key/value/root tuple to one of the leaf nodes.  If a split occurs, returns
   the new sibling, otherwise returns the receiver."

  | index node returnNode |
  index := self binarySearchInteriorNodeCoveringKey: aKey put: aValue root: rootObject.
  node := self at: index.
  returnNode := node at: aKey put: aValue root: rootObject.
  ^ self updateAfterAddAt: index child: node returnNode: returnNode
%

category: 'Rc Updating'
method: BtreePlusInteriorNode
at: aKey put: aValue root: rootObject selectiveAbortSet: selectiveAbortSetOrNil
  "Adds the key/value/root pair to the node.  If the node is full, performs a 'split'
 on the parent.  Returns the new sibling if a split is performed, otherwise
 returns the receiver."

  | returnNode |
  self _selectiveAbort: self ifNotIn: selectiveAbortSetOrNil.
  returnNode := self _at: aKey put: aValue root: rootObject selectiveAbortSet: selectiveAbortSetOrNil.
  returnNode ~~ self
    ifTrue: [
      self rootNode _addBtreePlusNodeToRcReadSet: returnNode ].
  self rootNode _addBtreePlusNodeToRcReadSet: self.
  ^ returnNode
%

category: 'Audit'
method: BtreePlusInteriorNode
auditForPathTerm: pathTerm using: auditor parentNode: parentNode previousChild: previousSibling nextChild: nextSibling do: aBlock
  "Audit the receiver's entries and each child node"

  | sentinel previousKey comparisonForSort keyIndexOffset rootIndexOffset lastEntryIndex lastChildNode previousChild nextChild eSize child |
  sentinel := Object new.
  previousKey := sentinel.
  child := previousChild := nextChild := nil.
  previousSibling ifNotNil: [ child := previousSibling at: previousSibling _lastEntryIndex ].
  comparisonForSort := self comparisonForSort.
  keyIndexOffset := self keyIndexOffset.
  rootIndexOffset := self rootIndexOffset.
  lastEntryIndex := self _lastEntryIndex.
  lastChildNode := self at: lastEntryIndex.
  eSize := self entrySize.
  lastChildNode lastValue == self lastValue
    ifFalse: [ auditor
        btreeInteriorNode: self
        childConsistencyError: pathTerm
        lastValue: self lastValue
        lastChildValue: lastChildNode lastValue
        childNode: lastChildNode ].
  lastChildNode lastRoot == self lastRoot
    ifFalse: [ auditor
        btreeInteriorNode: self
        childConsistencyError: pathTerm
        lastRoot: self lastRoot
        lastChildRoot: lastChildNode lastRoot
        childNode: lastChildNode].
  1 to: numElements * self entrySize by: self entrySize do: [ :i | | k r lastChildKey lastChildRoot |
    k := self at: i + keyIndexOffset.
    r := self at: i + rootIndexOffset.
    previousKey == sentinel
      ifFalse: [ (comparisonForSort compareKey: previousKey lessThanOrEqualTo: k)
          ifFalse: [ auditor
              btreeInteriorNode: self
              keyOrderError: pathTerm
              key: k
              previousKey: previousKey
              index: i ] ].
    previousKey := k.
    previousChild := child.
    (i + eSize) <= lastEntryIndex
      ifTrue: [ nextChild := self at: i + eSize ]
      ifFalse: [
        nextChild := nil.
        nextSibling ifNotNil: [ nextChild := nextSibling at: 1 ] ].
    child := self at: i.
    lastChildKey := child at: child _lastKeyIndex.
    lastChildKey == k
      ifFalse: [ auditor
          btreeInteriorNode: self
          childConsistencyError: pathTerm
          key: k
          lastChildKey: lastChildKey
          childNode: child
          index: i ].
    lastChildRoot := child at: child _lastRootIndex.
    lastChildRoot == r
      ifFalse: [ auditor
          btreeInteriorNode: self
          childConsistencyError: pathTerm
          key: k
          root: r
          lastChildRoot: lastChildRoot
          childNode: child
          index: i ].
    child auditForPathTerm: pathTerm using: auditor parentNode: self previousChild: previousChild nextChild: nextChild do: aBlock ]
%

category: 'Searching'
method: BtreePlusInteriorNode
binarySearchCoveringKey: aKey value: aValue root: rootObject selectiveAbortSet: selectiveAbortSetOrNil
  "Returns the index for the entry in which aKey/aValue would be inserted.  This
 is the first entry which has its key >= aKey.  If multiple entries have the
 same key (key = aKey), then aValue is used (since entries with duplicate keys
 are inserted by the value's OOP ordering).  If multiple entries have the same value
 (value = aValue), then rootObject is used (since entries with duplicate values are
 inserted by the rootObject's OOP ordering). If the receiver is empty, returns
 1.  Uses a binary search."

  | lowPt midPt highPt entrySize index entryGreaterThan entryEqualTo comparisonForSort keyIndexOffset |
  entrySize := self entrySize.
  lowPt := 1.
  highPt := numElements.
  entryGreaterThan := false.
  comparisonForSort := self comparisonForSort.
  keyIndexOffset := self keyIndexOffset.
  [ lowPt <= highPt ]
    whileTrue: [
      | objAtIndex |
      entryGreaterThan := false.
      entryEqualTo := false.
      midPt := lowPt + highPt quo: 2.
      index := (midPt - 1) * entrySize + 1 + keyIndexOffset.
      objAtIndex := self at: index.
      (comparisonForSort compareKey: aKey lessThan: objAtIndex)
        ifTrue: [ highPt := midPt - 1 ]
        ifFalse: [
          (comparisonForSort compareKey: aKey greaterThan: objAtIndex)
            ifTrue: [
              lowPt := midPt + 1.
              entryGreaterThan := true ]
            ifFalse: [
              "If keys are equal, then secondary sort key is oop value, tertiary sort key os oop of rootObject"
              (comparisonForSort compareKey: aKey equalTo: objAtIndex)
                ifTrue: [
                  (self
                    compareValueOop: aValue
                    lessThanOrEqualToEntryValueOopAt: index
                    root: rootObject
                    selectiveAbortSet: selectiveAbortSetOrNil)
                    ifTrue: [ highPt := midPt - 1 ]
                    ifFalse: [ lowPt := midPt + 1 ].
                  entryEqualTo := true ]
                ifFalse: [ lowPt := midPt + 1 ] ] ] ].
  entryGreaterThan
    ifTrue: [ ^ index + entrySize - keyIndexOffset ].
  (entryEqualTo
    and: [
      "use secondary sort key (oop of value), tertiary sort key os oop of rootObject"
      self
        compareValueOop: aValue
        greaterThanEntryValueOopAt: index
        root: rootObject
        selectiveAbortSet: selectiveAbortSetOrNil ])
    ifTrue: [ ^ index + entrySize - keyIndexOffset ].
  ^ index - keyIndexOffset
%

category: 'Searching'
method: BtreePlusInteriorNode
binarySearchCoveringKey: aKey value: aValue selectiveAbortSet: selectiveAbortSetOrNil
  "Returns the index for the entry in which aKey/aValue would be inserted.  This
 is the first entry which has its key >= aKey.  If multiple entries have the
 same key (key = aKey), then aValue is used (since entries with duplicate keys
 are inserted by the value's OOP ordering). If the receiver is empty, returns
 1.  Uses a binary search."

  | lowPt midPt highPt entrySize index entryGreaterThan entryEqualTo comparisonForSort keyIndexOffset |
  entrySize := self entrySize.
  lowPt := 1.
  highPt := numElements.
  entryGreaterThan := false.
  comparisonForSort := self comparisonForSort.
  keyIndexOffset := self keyIndexOffset.
  [ lowPt <= highPt ] whileTrue: [ | objAtIndex |
      entryGreaterThan := false.
      entryEqualTo := false.
      midPt := lowPt + highPt quo: 2.
      index := (midPt - 1) * entrySize + 1 + keyIndexOffset.
      objAtIndex := self at: index.
      (comparisonForSort compareKey: aKey lessThan: objAtIndex)
        ifTrue: [ highPt := midPt - 1 ]
        ifFalse: [ (comparisonForSort compareKey: aKey greaterThan: objAtIndex)
            ifTrue: [ lowPt := midPt + 1.
              entryGreaterThan := true ]
            ifFalse: [ "If keys are equal, then secondary sort key is oop value, tertiary sort key os oop of rootObject"
              (comparisonForSort compareKey: aKey equalTo: objAtIndex)
                ifTrue: [ (self
                    compareValueOop: aValue
                    lessThanOrEqualToEntryValueOopAt: index
                    selectiveAbortSet: selectiveAbortSetOrNil)
                    ifTrue: [ highPt := midPt - 1 ]
                    ifFalse: [ lowPt := midPt + 1 ].
                  entryEqualTo := true ]
                ifFalse: [ lowPt := midPt + 1 ] ] ] ].
  entryGreaterThan
    ifTrue: [ ^ index + entrySize - keyIndexOffset ].
  (entryEqualTo
    and: [ "use secondary sort key (oop of value), tertiary sort key os oop of rootObject"
      self
        compareValueOop: aValue
        greaterThanEntryValueOopAt: index
        selectiveAbortSet: selectiveAbortSetOrNil ])
    ifTrue: [ ^ index + entrySize - keyIndexOffset ].
  ^ index - keyIndexOffset
%

category: 'Updating'
method: BtreePlusInteriorNode
binarySearchInteriorNodeCoveringKey: aKey put: aValue root: rootObject

  "Find the index of the first child node in which the insertion would occur"

  | index lastKeyIndex |
  index := self binarySearchCoveringKey: aKey value: aValue root: rootObject.
  lastKeyIndex := self _lastKeyIndex.
  " if insertion would occur past the last entry, use the last entry "
  index > lastKeyIndex
    ifTrue: [ index := lastKeyIndex - self keyIndexOffset ].
  ^ index.
%

category: 'Updating'
method: BtreePlusInteriorNode
binarySearchInteriorNodeCoveringKey: aKey put: aValue root: rootObject selectiveAbortSet: selectiveAbortSetOrNil

  "Find the index of the first child node in which the insertion would occur"

  | index lastKeyIndex |
  index := self binarySearchCoveringKey: aKey value: aValue root: rootObject  selectiveAbortSet: selectiveAbortSetOrNil.
  lastKeyIndex := self _lastKeyIndex.
  " if insertion would occur past the last entry, use the last entry "
  index > lastKeyIndex
    ifTrue: [ index := lastKeyIndex - self keyIndexOffset ].
  ^ index.
%

category: 'Comparison Operators'
method: BtreePlusInteriorNode
compare: comparisonForSort key: aKey value: aValue equalToEntryAt: keyIndex
  "Performs a = comparison between aKey and the entry whose key is at the given
 index.  If the keys are equal, use the OOP of the value as the next basis for
 comparison."

  | entryIndex |
  entryIndex := keyIndex - self keyIndexOffset.
  ^ (comparisonForSort compareKey: aKey equalTo: (self at: keyIndex))
    and: [
      "aValue asOop = (self at: entryIndex) lastValue asOop"
      aValue == (self at: entryIndex) lastValue ]
%

category: 'Comparison Operators'
method: BtreePlusInteriorNode
compare: comparisonForSort key: aKey value: aValue equalToEntryAt: keyIndex root: rootObject
  "Performs a = comparison between aKey and the entry whose key is at the given
 index.  If the keys are equal, use the OOP of the value as the next basis for
 comparison. If the value oops are equeal, use the oop of the rootObject as the
 next basis for comparison."

  ^ (comparisonForSort compareKey: aKey equalTo: (self at: keyIndex))
    and: [ | entryIndex |
      entryIndex := keyIndex - self keyIndexOffset.
      "aValue asOop = (self at: entryIndex) lastValue asOop"
      aValue == (self at: entryIndex) lastValue
        and: [
          "rootObject asOop = (self at: entryIndex) lastRoot asOop"
          rootObject == (self at: entryIndex) lastRoot ] ]
%

category: 'Comparison Operators'
method: BtreePlusInteriorNode
compare: comparisonForSort key: aKey value: aValue lessThanOrEqualToEntryAt: keyIndex
  "Performs a <= comparison between aKey and the entry whose key is at the given
 index. If the keys are equal, then use the OOP of the value for the
 comparison."

  | keyIndexEntry |
  keyIndexEntry := self at: keyIndex.
  (comparisonForSort compareKey: aKey lessThan: keyIndexEntry)
    ifTrue: [ ^ true ].
  (comparisonForSort compareKey: aKey equalTo: keyIndexEntry)
    ifTrue: [ | entryIndex |
      entryIndex := keyIndex - self keyIndexOffset.
      ^ aValue asOop <= (self at: entryIndex) lastValue asOop ].
  ^ false
%

category: 'Comparison Operators'
method: BtreePlusInteriorNode
compare: comparisonForSort key: aKey value: aValue lessThanOrEqualToEntryAt: keyIndex root: rootObject
  "Performs a <= comparison between aKey and the entry whose key is at the given
 index.  If the keys are equal, then use the OOP of the value for the
 comparison. If the value oops are equal, use the OOP of the rootObject for the
 comparison."

  | keyIndexEntry |
  keyIndexEntry := self at: keyIndex.
  (comparisonForSort compareKey: aKey lessThan: keyIndexEntry)
    ifTrue: [ ^ true ].
  (comparisonForSort compareKey: aKey equalTo: keyIndexEntry)
    ifTrue: [ | entryIndexEntry entryIndexEntryLastEntry |
      entryIndexEntry := self at: keyIndex - self keyIndexOffset.
      "aValue asOop = entryIndexEntry lastValue asOop"
      entryIndexEntryLastEntry := entryIndexEntry lastValue.
      aValue == entryIndexEntryLastEntry
        ifTrue: [ ^ rootObject asOop <= entryIndexEntry lastRoot asOop ].
      ^ aValue asOop < entryIndexEntryLastEntry asOop ].
  ^ false
%

category: 'Comparison Operators'
method: BtreePlusInteriorNode
compare: comparisonForSort key: aKey value: aValue lessThanOrEqualToEntryAt: keyIndex root: rootObject selectiveAbortSet: selectiveAbortSetOrNil
  "Performs a <= comparison between aKey and the entry whose key is at the given
 index.  If the keys are equal, then use the OOP of the value for the
 comparison. If the value oops are equal, use the OOP of the rootObject for the
 comparison."

  | keyIndexEntry |
  keyIndexEntry := self at: keyIndex.
  (comparisonForSort compareKey: aKey lessThan: keyIndexEntry)
    ifTrue: [ ^ true ].
  (comparisonForSort compareKey: aKey equalTo: keyIndexEntry)
    ifTrue: [ | entryIndexEntry entryIndexEntryLastEntry |
      entryIndexEntry := self at: keyIndex - self keyIndexOffset.
      self _selectiveAbort: entryIndexEntry ifNotIn: selectiveAbortSetOrNil.
      "aValue asOop = entryIndexEntry lastValue asOop"
      entryIndexEntryLastEntry := entryIndexEntry lastValue.
      aValue == entryIndexEntryLastEntry
        ifTrue: [ ^ rootObject asOop <= entryIndexEntry lastRoot asOop ].
      ^ aValue asOop < entryIndexEntryLastEntry asOop ].
  ^ false
%

category: 'Comparison Operators'
method: BtreePlusInteriorNode
compare: comparisonForSort key: aKey value: aValue lessThanOrEqualToEntryAt: keyIndex root: rootObject selectiveAbortSetOrNil: selectiveAbortSetOrNil
  "Performs a <= comparison between aKey and the entry whose key is at the given
 index.  If the keys are equal, then use the OOP of the value for the
 comparison. If the value oops are equal, use the OOP of the rootObject for the
 comparison."

  | keyIndexEntry |
  keyIndexEntry := self at: keyIndex.
  (comparisonForSort compareKey: aKey lessThan: keyIndexEntry)
    ifTrue: [ ^ true ].
  (comparisonForSort compareKey: aKey equalTo: keyIndexEntry)
    ifTrue: [ | entryIndexEntry entryIndexEntryLastEntry |
      entryIndexEntry := self at: keyIndex - self keyIndexOffset.
      self _selectiveAbort: entryIndexEntry ifNotIn: selectiveAbortSetOrNil.
      "aValue asOop = entryIndexEntry lastValue asOop"
      entryIndexEntryLastEntry := entryIndexEntry lastValue.
      aValue == entryIndexEntryLastEntry
        ifTrue: [ ^ rootObject asOop <= entryIndexEntry lastRoot asOop ].
      ^ aValue asOop < entryIndexEntryLastEntry asOop ].
  ^ false
%

category: 'Comparison Operators'
method: BtreePlusInteriorNode
compareLastKeyLessThanOrEqualToKey: aKey value: aValue root: rootObject
  "Returns whether the receivers last key/value pair is greater than or equal to
the given key/value pair."

  numElements == 0
    ifTrue: [ ^ false ].
  " return aKey <= last key "
  ^ self
    compare: self comparisonForSort
    key: aKey
    value: aValue
    lessThanOrEqualToEntryAt: self _lastKeyIndex
    root: rootObject
%

category: 'Comparison Operators'
method: BtreePlusInteriorNode
compareLastKeyLessThanOrEqualToKey: aKey value: aValue root: rootObject selectiveAbortSet: selectiveAbortSetOrNil
  "Returns whether the receivers last key/value pair is greater than or equal to
the given key/value pair."

  numElements == 0
    ifTrue: [ ^ false ].
  " return aKey <= last key "
  ^ self
    compare: self comparisonForSort
    key: aKey
    value: aValue
    lessThanOrEqualToEntryAt: self _lastKeyIndex
    root: rootObject
    selectiveAbortSet: selectiveAbortSetOrNil
%

category: 'Comparison Operators'
method: BtreePlusInteriorNode
compareValueOop: aValue greaterThanEntryValueOopAt: keyIndex
  "Perform a > comparison between the oop of aValue and oop of the entry whose value is
   at the given index."

  ^ aValue asOop > (self at: keyIndex - self keyIndexOffset) lastValue asOop
%

category: 'Comparison Operators'
method: BtreePlusInteriorNode
compareValueOop: aValue greaterThanEntryValueOopAt: keyIndex selectiveAbortSet: selectiveAbortSetOrNil
  "Perform a > comparison between the oop of aValue and oop of the entry whose value is
   at the given index."

  | entryNode |
  entryNode := self at: keyIndex - self keyIndexOffset.
  self _selectiveAbort: entryNode ifNotIn: selectiveAbortSetOrNil.
  ^ aValue asOop > entryNode lastValue asOop
%

category: 'Comparison Operators'
method: BtreePlusInteriorNode
compareValueOop: aValue lessThanOrEqualToEntryValueOopAt: keyIndex
  "Perform a <= comparison between the oop of aValue and oop of the entry whose value is
   at the given index."

  ^ aValue asOop <= (self at: keyIndex - self keyIndexOffset) lastValue asOop
%

category: 'Comparison Operators'
method: BtreePlusInteriorNode
compareValueOop: aValue lessThanOrEqualToEntryValueOopAt: keyIndex selectiveAbortSet: selectiveAbortSetOrNil
  "Perform a <= comparison between the oop of aValue and oop of the entry whose value is
   at the given index."

  | entryNode |
  entryNode := self at: keyIndex - self keyIndexOffset.
  self _selectiveAbort: entryNode ifNotIn: selectiveAbortSetOrNil.
  ^ aValue asOop <= entryNode lastValue asOop
%

category: 'Accessing'
method: BtreePlusInteriorNode
lastRoot
  ^ lastRoot
%

category: 'Updating'
method: BtreePlusInteriorNode
lastRoot: anObject
  lastRoot := anObject
%

category: 'Accessing'
method: BtreePlusInteriorNode
lastValue

"Returns the value of the instance variable 'lastValue'."

^ lastValue
%

category: 'Updating'
method: BtreePlusInteriorNode
lastValue: newValue

"Modifies the value of the instance variable 'lastValue'."

lastValue := newValue
%

category: 'Accessing'
method: BtreePlusInteriorNode
nextLeaf
  "BtreePlusLeafNode compat"

  ^ nil
%

category: 'Accessing'
method: BtreePlusInteriorNode
nextLeaf: ignored
  "BtreePlusLeafNode compat - noop"
%

category: 'Constants'
method: BtreePlusInteriorNode
parentNodeClass
  "Returns the class of node to be created as the parent when a split occurs."

  ^ self class
%

category: 'Accessing'
method: BtreePlusInteriorNode
previousLeaf
  "BtreePlusLeafNode compat"

  ^ nil
%

category: 'Accessing'
method: BtreePlusInteriorNode
previousLeaf:  ignored
  "BtreePlusLeafNode compat - noop"
%

category: 'Updating'
method: BtreePlusInteriorNode
primitiveAt: anIndex put: aValue

"Stores the argument aValue in the indexed variable of the
 receiver indicated by anIndex.  The argument anIndex must not be
 larger than 1 + the size of the receiver, and must not be less than 1.

 Generates an error if anIndex is not a SmallInteger or is out of
 bounds, if the receiver is not indexable, or if the
 receiver is not of the right class to store the given value.

 The primitive is equivalent to GciStoreIdxOop or GciStoreByte,
 depending on implementation of the receiver."

<primitive: 268>

(anIndex _isInteger)
  ifFalse: [ ^ self _errorNonIntegerIndex: anIndex].
(self class isIndexable) "not an indexable object"
  ifFalse: [ ^ self _errorNotIndexable].
(anIndex < 1 or:[ anIndex > (self size + 1)]) "out of bounds"
  ifTrue: [ ^ self _errorIndexOutOfRange: anIndex].
(self class isBytes)
ifTrue: [ ((aValue class ~~ SmallInteger) or: [ (aValue < 0) | (aValue > 255) ])
    ifTrue: [^ aValue _error: #rtErrExpectedByteValue].
  ].

self _primitiveFailed: #at:put: args: { anIndex . aValue }.
self _uncontinuableError
%

category: 'Printing'
method: BtreePlusInteriorNode
printOn: aStream withIndentationLevel: anInteger

"Puts a displayable representation of the keys of the receiver on the given
 stream, indenting the given number of spaces."

anInteger timesRepeat: [ aStream nextPut: Character space ].
aStream nextPutAll: '[ ';
    nextPutAll: self lastValue asString;
    nextPutAll: ' ';
    nextPutAll: self lastRoot asString;
    nextPutAll: ' ]';

    nextPut: Character lf.

1 to: (numElements * self entrySize) by: self entrySize do: [ :i |
    anInteger timesRepeat: [ aStream nextPut: Character space ].
    aStream nextPutAll: (self at: (i + self keyIndexOffset)) asString; nextPut: Character lf.
    (self at: i) printOn: aStream withIndentationLevel: (anInteger + 4)
]
%

category: 'Printing'
method: BtreePlusInteriorNode
printOn: aStream withIndentationLevel: anInteger includingValues: aBoolean

"Puts a displayable representation of the keys of the receiver on the given
 stream, indenting the given number of spaces."

aBoolean
    ifTrue: [
        anInteger timesRepeat: [ aStream nextPut: Character space ].
        aStream nextPutAll: '[ ';
            nextPutAll: self lastValue asString;
            nextPutAll: ' ';
            nextPutAll: self lastRoot asString;
            nextPutAll: ' ]';
            "nextPutAll: '  { '; nextPutAll: self _alias asString; nextPutAll: ' }';"
            nextPut: Character lf.
    ].

1 to: (numElements * self entrySize) by: self entrySize do: [ :i |
    anInteger timesRepeat: [ aStream nextPut: Character space ].
    aStream nextPutAll: (self at: (i + 1)) asString; nextPut: Character lf.
    (self at: i) printOn: aStream withIndentationLevel: (anInteger + 4) includingValues: aBoolean
]
%

category: 'Removing'
method: BtreePlusInteriorNode
removedEntryFromNode: node atIndex: nodeIndex
  "Remove occurred, check if a merge or coalesce is necessary."

  | keyIndexOffset lastChildKeyIndex lastChildKey lastChildRoot |
  keyIndexOffset := self keyIndexOffset.
  " see if last key in child node has changed "
  lastChildKeyIndex := node _lastKeyIndex.
  lastChildKey := node at: lastChildKeyIndex.
  lastChildKey == (self at: nodeIndex + keyIndexOffset)
    ifFalse: [ " update key and encryption in the receiver "
      self primitiveAt: nodeIndex + keyIndexOffset put: lastChildKey ].
  " see if the node's number of entries is below the threshold "
  node numElements < node mergeThreshold
    ifTrue: [ " try to steal entries from a neighboring sibling "
      (self _attemptTakingFromNeighborForNodeAt: nodeIndex)
        ifFalse: [ " could not take from neighbor, merge with a neighbor instead. lastChildRoot and lastValue updated"
          self _mergeFromNeighborForNodeAt: nodeIndex.
          ^ self  ] ].
  " see if last root in child node has changed "
  lastChildRoot := node at: node _lastRootIndex.
  self updateLastChildRoot: lastChildRoot at: nodeIndex.
  self _updateLastValue.
%

category: 'Rc Removing'
method: BtreePlusInteriorNode
removedEntryFromNode: node atIndex: nodeIndex selectiveAbortSet: selectiveAbortSetOrNil
  "Remove occurred, check if a merge or coalesce is necessary."

  | keyIndexOffset lastChildKeyIndex lastChildKey lastChildRoot |
  keyIndexOffset := self keyIndexOffset.
  " see if last key in child node has changed "
  lastChildKeyIndex := node _lastKeyIndex.
  lastChildKey := node at: lastChildKeyIndex.
  lastChildKey == (self at: nodeIndex + keyIndexOffset)
    ifFalse: [ " update key and encryption in the receiver "
      self primitiveAt: nodeIndex + keyIndexOffset put: lastChildKey ].
  " see if the node's number of entries is below the threshold "
  node numElements < node mergeThreshold
    ifTrue: [ " try to steal entries from a neighboring sibling "
      (self _attemptTakingFromNeighborForNodeAt: nodeIndex selectiveAbortSet: selectiveAbortSetOrNil)
        ifFalse: [ " could not take from neighbor, merge with a neighbor instead. lastChildRoot and lastValue updated"
          self _mergeFromNeighborForNodeAt: nodeIndex selectiveAbortSet: selectiveAbortSetOrNil.
          ^ self  ] ].
  " see if last root in child node has changed "
  lastChildRoot := node at: node _lastRootIndex.
  self updateLastChildRoot: lastChildRoot at: nodeIndex.
  self _updateLastValue: selectiveAbortSetOrNil.
%

category: 'Removing'
method: BtreePlusInteriorNode
removeKey: aKey value: aValue root: rootObject
  "Removes the key/value pair.  Find the appropriate child node and invoke the
 remove operation on it.  If the remove occurred, check if a merge or coalesce
 is necessary."

  | nodeIndex node |
  (self compareLastKeyLessThanOrEqualToKey: aKey value: aValue root: rootObject)
    ifFalse: [ ^ false ].
  nodeIndex := self
    binarySearchCoveringKey: aKey
    value: aValue
    root: rootObject.
  node := self at: nodeIndex.
  ^ (node removeKey: aKey value: aValue root: rootObject)
    ifTrue: [ " remove occurred - merge or coalesce if necessary"
      self removedEntryFromNode: node atIndex: nodeIndex.
      true ]
    ifFalse: [ false ]
%

category: 'Rc Removing'
method: BtreePlusInteriorNode
removeKey: aKey value: aValue root: rootObject selectiveAbortSet: selectiveAbortSetOrNil
  "Removes the key/value pair.  Find the appropriate child node and invoke the
 remove operation on it.  If the remove occurred, check if a merge or coalesce
 is necessary."

  | res nodeIndex node |
  self _selectiveAbort: self ifNotIn: selectiveAbortSetOrNil.
   (self compareLastKeyLessThanOrEqualToKey: aKey value: aValue root: rootObject selectiveAbortSet: selectiveAbortSetOrNil)
    ifFalse: [ ^ false ].
  nodeIndex := self
    binarySearchCoveringKey: aKey
    value: aValue
    root: rootObject
    selectiveAbortSet: selectiveAbortSetOrNil.
  node := self at: nodeIndex.
  self _selectiveAbort: node ifNotIn: selectiveAbortSetOrNil.
  res := (node removeKey: aKey value: aValue root: rootObject selectiveAbortSet: selectiveAbortSetOrNil)
    ifTrue: [ " remove occurred - merge or coalesce if necessary"
      self removedEntryFromNode: node atIndex: nodeIndex selectiveAbortSet: selectiveAbortSetOrNil.
      true ]
    ifFalse: [ false ].
  self rootNode _addBtreePlusNodeToRcReadSet: self.
  ^ res
%

category: 'Accessing'
method: BtreePlusInteriorNode
totalElements

"Return the total number of elements in the leaf nodes."

| sum |

sum := 0.
1 to: (numElements * self entrySize) by: self entrySize do: [ :i |
    sum := sum + (self at: i) totalElements
].
^ sum
%

category: 'Updating'
method: BtreePlusInteriorNode
updateAfterAddAt: index child: node returnNode: returnNode

  "Adds the key/value/root tuple to one of the leaf nodes.  If a split occurs, returns
   the new sibling, otherwise returns the receiver."

  | lastChildKey keyIndexOffset lastChildRoot |

  " see if last key in child node has changed "
  lastChildKey := node at: node _lastKeyIndex.
  keyIndexOffset := self keyIndexOffset.
  lastChildKey == (self at: index + keyIndexOffset)
    ifFalse: [ " update key and encryption in the receiver "
      self primitiveAt: index + keyIndexOffset put: lastChildKey ].
  " see if last root in child node has changed "
  lastChildRoot := node at: node _lastRootIndex.
  self updateLastChildRoot: lastChildRoot at: index.


  " see if a split occurred "
  returnNode == node
    ifTrue: [
      " if inserted into the last node, update the last value "
      index == self _lastEntryIndex
        ifTrue: [ self _updateLastValue ] ]
    ifFalse: [ " returnNode is the second half of the split "
      " determine if a split is needed in the receiver "
      numElements == self maxNumberOfElements
        ifTrue: [ | newSibling |
          newSibling := self
            _splitUsingKey: (node at: node _lastKeyIndex)
            node: node
            newSibling: returnNode.

          " update the last value and last root of the new sibling and the receiver "
          newSibling _updateLastValue.
          self _updateLastValue.
          ^ newSibling ]
        ifFalse: [ " entry will fit in the receiver "

          " if child node was the last node "
          index == self _lastEntryIndex
            ifTrue: [
              self lastValue: returnNode lastValue.
              self lastRoot: returnNode lastRoot ].
          self
            _insertKey: (returnNode at: returnNode _lastKeyIndex)
            value: returnNode
            root: (returnNode at: returnNode _lastRootIndex)
            atIndex: index + self entrySize.
          " see if last root in child node has changed "
          lastChildRoot := returnNode at: returnNode _lastRootIndex.
          self updateLastChildRoot: lastChildRoot at: index + self entrySize ] ]
%

category: 'Updating'
method: BtreePlusInteriorNode
updateAfterAddAt: index child: node returnNode: returnNode selectiveAbortSet: selectiveAbortSetOrNil

  "Adds the key/value/root tuple to one of the leaf nodes.  If a split occurs, returns
   the new sibling, otherwise returns the receiver."

  "node already selectively aborted"

  | lastChildKey keyIndexOffset lastChildRoot |

  " see if last key in child node has changed "
  lastChildKey := node at: node _lastKeyIndex.
  keyIndexOffset := self keyIndexOffset.
  lastChildKey == (self at: index + keyIndexOffset)
    ifFalse: [ " update key and encryption in the receiver "
      self primitiveAt: index + keyIndexOffset put: lastChildKey ].
  " see if last root in child node has changed "
  lastChildRoot := node at: node _lastRootIndex.
  self updateLastChildRoot: lastChildRoot at: index.


  " see if a split occurred "
  returnNode == node
    ifTrue: [
      " if inserted into the last node, update the last value "
      index == self _lastEntryIndex
        ifTrue: [ self _updateLastValue: selectiveAbortSetOrNil ] ]
    ifFalse: [ " returnNode is the second half of the split "
      " determine if a split is needed in the receiver "
      numElements == self maxNumberOfElements
        ifTrue: [ | newSibling |
          newSibling := self
            _splitUsingKey: (node at: node _lastKeyIndex)
            node: node
            newSibling: returnNode
            selectiveAbortSet: selectiveAbortSetOrNil.

          " update the last value and last root of the new sibling and the receiver "
          newSibling _updateLastValue: selectiveAbortSetOrNil.
          self _updateLastValue: selectiveAbortSetOrNil.
          self rootNode _addBtreePlusNodeToRcReadSet: newSibling.
          ^ newSibling ]
        ifFalse: [ " entry will fit in the receiver "

          " if child node was the last node "
          index == self _lastEntryIndex
            ifTrue: [
              self lastValue: returnNode lastValue.
              self lastRoot: returnNode lastRoot ].
          self
            _insertKey: (returnNode at: returnNode _lastKeyIndex)
            value: returnNode
            root: (returnNode at: returnNode _lastRootIndex)
            atIndex: index + self entrySize
            selectiveAbortSet: selectiveAbortSetOrNil.
          " see if last root in child node has changed "
          lastChildRoot := returnNode at: returnNode _lastRootIndex.
          self updateLastChildRoot: lastChildRoot at: index + self entrySize ] ]
%

category: 'Updating'
method: BtreePlusInteriorNode
updateLastChildRoot: lastChildRoot at: index

  " Update the root object for receiver, if last child root has changed "

  | rootIndexOffset |
  rootIndexOffset := self rootIndexOffset.
  lastChildRoot == (self at: index + rootIndexOffset)
    ifFalse: [  self primitiveAt: index + rootIndexOffset put: lastChildRoot ].
%

category: 'Rc Updating'
method: BtreePlusInteriorNode
_at: aKey put: aValue root: rootObject selectiveAbortSet: selectiveAbortSetOrNil
  "Adds the key/value/root pair to the node.  If the node is full, performs a 'split'
 on the parent.  Returns the new sibling if a split is performed, otherwise
 returns the receiver."

  "self has already been selectively aborted"

  | index node returnNode |
  index := self binarySearchInteriorNodeCoveringKey: aKey put: aValue root: rootObject  selectiveAbortSet: selectiveAbortSetOrNil.
  node := self at: index.
  self _selectiveAbort: node ifNotIn: selectiveAbortSetOrNil.
  returnNode := node
    at: aKey
    put: aValue
    root: rootObject
    selectiveAbortSet: selectiveAbortSetOrNil. "node is selectively aborted and added to rcReadSet"
  ^ self updateAfterAddAt: index child: node returnNode: returnNode selectiveAbortSet: selectiveAbortSetOrNil
%

category: 'Removing'
method: BtreePlusInteriorNode
_attemptTakingFromNeighborForNodeAt: nodeIndex

"The node at the given index has too few entries, so try to take entries from
 one of its neighboring siblings.  First try the next (right) sibling, then
 the previous (left) sibling."

| node sibling siblingEntrySize siblingLoss numSiblingElements copyStart copyEnd
fromNextSibling fromPreviousSibling targetStart lastChildKey  numToMove keyIndexOffset entrySize lastChildRoot |

node := self at: nodeIndex.
fromNextSibling := false.  " is true if taken from next sibling "
fromPreviousSibling := false.  " is true if taken from previous sibling "

siblingEntrySize := node entrySize.
entrySize := self entrySize.
keyIndexOffset := self keyIndexOffset.
" check if the node is the last entry "
nodeIndex == (self _lastKeyIndex - keyIndexOffset)
    ifFalse: [ " this is not the last entry, check the next sibling "
        sibling := self at: (nodeIndex + self entrySize).
        numSiblingElements := sibling numElements.
        numSiblingElements < (node mergeThreshold + 1)
            ifFalse: [ " can take entries from next sibling "
                fromNextSibling := true.
                siblingLoss := (numSiblingElements - node mergeThreshold) quo: 2.
                siblingLoss == 0 ifTrue: [ siblingLoss := 1 ].
                copyStart := 1.
                copyEnd := siblingLoss * siblingEntrySize.
                numToMove := 0 .
                targetStart := node _lastIndex + 1
            ]
    ].

" if could not get entries from next sibling and this is not the first entry "
(fromNextSibling not and: [ nodeIndex > 1 ] )
    ifTrue: [ " try previous entry "
        sibling := self at: (nodeIndex - self entrySize).
        numSiblingElements := sibling numElements.
        numSiblingElements < (node mergeThreshold + 1)
            ifFalse: [ " can take entries from previous sibling "
                fromPreviousSibling := true.
                siblingLoss := (numSiblingElements - node mergeThreshold) quo: 2.
                siblingLoss == 0 ifTrue: [ siblingLoss := 1 ].
                copyStart := (numSiblingElements - siblingLoss) * siblingEntrySize + 1.
                copyEnd := numSiblingElements * siblingEntrySize.
                numToMove := (node numElements) * siblingEntrySize .
                targetStart := 1
            ]
    ].

" if cannot take from previous or next sibling "
(fromPreviousSibling or:[ fromNextSibling ])
    ifFalse: [ ^ false ].

" copy from sibling and insert into node "
node _insertAt: targetStart
     from: sibling fromStart: copyStart fromEnd: copyEnd
     numToMoveDown: numToMove .

node numElements: (node numElements + siblingLoss).

fromNextSibling
    ifTrue: [
        "entries added to end of node from beginning of sibling"
        sibling _deleteNoShrinkFrom: copyStart to: copyEnd .

        sibling numElements: (numSiblingElements - siblingLoss).

        " update the receiver's key for this entry "
        lastChildKey := node at: (node _lastKeyIndex).
        self primitiveAt: (nodeIndex + keyIndexOffset) put: lastChildKey.
        " see if last root in child node has changed "
        lastChildRoot := node at: node _lastRootIndex.
        self updateLastChildRoot: lastChildRoot at: nodeIndex.
        node _updateLastValue
    ].

fromPreviousSibling
    ifTrue: [
        "entries added to beginning of node from end of sibling"
        sibling numElements: (numSiblingElements - siblingLoss).

        " update the receiver's key for previous entry "
        lastChildKey := sibling at: sibling _lastKeyIndex .
        self  primitiveAt: (nodeIndex + keyIndexOffset - entrySize) put: lastChildKey.
        " see if last root in child node has changed "
        lastChildRoot := sibling at: sibling _lastRootIndex.
        self updateLastChildRoot: lastChildRoot at: nodeIndex - entrySize.
        sibling _updateLastValue .

       " nil out sibling entries at end "
        sibling _deleteNoShrinkFrom: copyStart to: copyEnd .
    ].

^ true
%

category: 'Rc Removing'
method: BtreePlusInteriorNode
_attemptTakingFromNeighborForNodeAt: nodeIndex selectiveAbortSet: selectiveAbortSetOrNil

"The node at the given index has too few entries, so try to take entries from
 one of its neighboring siblings.  First try the next (right) sibling, then
 the previous (left) sibling."

| node sibling siblingEntrySize siblingLoss numSiblingElements copyStart copyEnd
fromNextSibling fromPreviousSibling targetStart lastChildKey numToMove keyIndexOffset entrySize lastChildRoot |

node := self at: nodeIndex.
self _selectiveAbort: node ifNotIn: selectiveAbortSetOrNil.
fromNextSibling := false.  " is true if taken from next sibling "
fromPreviousSibling := false.  " is true if taken from previous sibling "

siblingEntrySize := node entrySize.
entrySize := self entrySize.
keyIndexOffset := self keyIndexOffset.
" check if the node is the last entry "
nodeIndex == (self _lastKeyIndex - keyIndexOffset)
    ifFalse: [ " this is not the last entry, check the next sibling "
        sibling := self at: (nodeIndex + self entrySize).
        self _selectiveAbort: sibling ifNotIn: selectiveAbortSetOrNil.
        numSiblingElements := sibling numElements.
        numSiblingElements < (node mergeThreshold + 1)
            ifFalse: [ " can take entries from next sibling "
                fromNextSibling := true.
                siblingLoss := (numSiblingElements - node mergeThreshold) quo: 2.
                siblingLoss == 0 ifTrue: [ siblingLoss := 1 ].
                copyStart := 1.
                copyEnd := siblingLoss * siblingEntrySize.
                numToMove := 0 .
                targetStart := node _lastIndex + 1
            ]
    ].

" if could not get entries from next sibling and this is not the first entry "
(fromNextSibling not and: [ nodeIndex > 1 ] )
    ifTrue: [ " try previous entry "
        sibling := self at: (nodeIndex - self entrySize).
        self _selectiveAbort: sibling ifNotIn: selectiveAbortSetOrNil.
        numSiblingElements := sibling numElements.
        numSiblingElements < (node mergeThreshold + 1)
            ifFalse: [ " can take entries from previous sibling "
                fromPreviousSibling := true.
                siblingLoss := (numSiblingElements - node mergeThreshold) quo: 2.
                siblingLoss == 0 ifTrue: [ siblingLoss := 1 ].
                copyStart := (numSiblingElements - siblingLoss) * siblingEntrySize + 1.
                copyEnd := numSiblingElements * siblingEntrySize.
                numToMove := (node numElements) * siblingEntrySize .
                targetStart := 1
            ]
    ].

" if cannot take from previous or next sibling "
(fromPreviousSibling or:[ fromNextSibling ])
    ifFalse: [ ^ false ].

" copy from sibling and insert into node "
node _insertAt: targetStart
     from: sibling fromStart: copyStart fromEnd: copyEnd
     numToMoveDown: numToMove .

node numElements: (node numElements + siblingLoss).

fromNextSibling
    ifTrue: [
        "entries added to end of node from beginning of sibling"
        sibling _deleteNoShrinkFrom: copyStart to: copyEnd .

        sibling numElements: (numSiblingElements - siblingLoss).

        " update the receiver's key for this entry "
        lastChildKey := node at: (node _lastKeyIndex).
        self primitiveAt: (nodeIndex + keyIndexOffset) put: lastChildKey.
        " see if last root in child node has changed "
        lastChildRoot := node at: node _lastRootIndex.
        self updateLastChildRoot: lastChildRoot at: nodeIndex.
        node _updateLastValue: selectiveAbortSetOrNil
    ].

fromPreviousSibling
    ifTrue: [
        "entries added to beginning of node from end of sibling"
        sibling numElements: (numSiblingElements - siblingLoss).

        " update the receiver's key for previous entry "
        lastChildKey := sibling at: sibling _lastKeyIndex .
        self  primitiveAt: (nodeIndex + keyIndexOffset - entrySize) put: lastChildKey.
        " see if last root in child node has changed "
        lastChildRoot := sibling at: sibling _lastRootIndex.
        self updateLastChildRoot: lastChildRoot at: nodeIndex - entrySize.
        sibling _updateLastValue: selectiveAbortSetOrNil .

       " nil out sibling entries at end "
        sibling _deleteNoShrinkFrom: copyStart to: copyEnd .
    ].

self rootNode
  _addBtreePlusNodeToRcReadSet: node;
  _addBtreePlusNodeToRcReadSet: sibling.
^ true
%

category: 'Searching'
method: BtreePlusInteriorNode
_findAllValuesForIdenticalKey: aKey into: aCollection using: aComparison

"Finds all the values for the given identical key, placing them in the
 collection.  For interior nodes, must first find the appropriate child
 node.  Return whether the last key was equal or not (so the caller
 knows it must check the next node)."

| index eSize maxIndex |
" find first child node that might contain the key "
index := self _findCoveringIndexForKey: aKey totalOrder: false.
index == 0 ifTrue: [ ^ false ].

((self at: index) _findAllValuesForIdenticalKey: aKey into: aCollection using: aComparison)
  ifFalse: [ ^ false ].

eSize := self entrySize.
maxIndex := self _lastIndex.
index := index + eSize.

" now scan child nodes until no values are added to the collection "
[ (index < maxIndex) and:
[ (self at: index) _findAllValuesForIdenticalKey: aKey into: aCollection using: aComparison ] ]
  whileTrue: [ index := index + eSize ].
^ index >= maxIndex
%

category: 'Searching Support'
method: BtreePlusInteriorNode
_findAllValuesGreaterThanKey: aKey into: anArray using: aComparison
  "Puts into anArray the index and the leaf node of the entry that is greater
 than the given key, plus the index and interior node of the path taken to
 reach the leaf.  Returns true if a value was found, false otherwise.  Do this
 by invoking the same operation on the appropriate child node."

  | index eSize lastKeyIndex keyIndexOffset comparisonForSort |
  lastKeyIndex := self _lastKeyIndex.
  lastKeyIndex == 0
    ifTrue: [ ^ false ].
  " find index where key would be inserted "
  comparisonForSort := self comparisonForSort.
  index := self _findCoveringIndexForKey: aKey totalOrder: false  using: comparisonForSort.
  index == 0
    ifTrue: [ ^ false ].
  "scan across all entries that sort ="
  eSize := self entrySize.
  keyIndexOffset := self keyIndexOffset.
  [ comparisonForSort compareKey: aKey equalTo: (self at: index + keyIndexOffset) ]
    whileTrue: [ index := index + eSize.
      index > lastKeyIndex
        ifTrue: [ ^ false ] ].
  " see if this child has any greater than the key "
  ((self at: index)
    _findAllValuesGreaterThanKey: aKey
    into: anArray
    using: aComparison)
    ifFalse: [ ^ false ].
  ^ true
%

category: 'Searching Support'
method: BtreePlusInteriorNode
_findAllValuesLessThanKey: aKey andEquals: aBoolean into: anArray using: aComparison
  "Puts into anArray the index and the leaf node of the entry that is less than
 (or less than and equal to if aBoolean is true) the given key, plus the index
 and interior node of the path taken to reach the leaf.  Returns true if a
 value was found, false otherwise.  Does this by invoking the same operation
 on the appropriate child node."

  | index eSize lastIndex lastKeyIndex comparisonForSort keyIndexOffset |
  lastIndex := self _lastIndex.
  lastIndex == 0
    ifTrue: [ ^ false ].
  aBoolean
    ifFalse: [ ^ self _findAllValuesLessThanKey: aKey into: anArray using: aComparison ].
  " first see if all entries are > aKey "
  lastKeyIndex := self _lastKeyIndex.
  comparisonForSort := self comparisonForSort.
  (comparisonForSort
    compareKey: aKey
    lessThanOrEqualTo: (self at: lastKeyIndex))
    ifFalse: [ "bugfix 33805 - verify that aKey is > last entry"
      (aKey == nil
        or: [ comparisonForSort compareKey: aKey greaterThan: (self at: lastKeyIndex) ])
        ifTrue: [ self _putLastIndexOfLastChildInto: anArray.
          ^ true ] ].
  "find index of first entry >= aKey"
  index := self _findCoveringIndexForKey: aKey totalOrder: false using: comparisonForSort.
  index == 0
    ifTrue: [ ^ false ].
  "scan across all of the values that sort ="
  eSize := self entrySize.
  keyIndexOffset := self keyIndexOffset.
  (comparisonForSort compareKey: aKey equalTo: (self at: index + keyIndexOffset))
    ifTrue: [
      [ index < lastIndex
        and: [ comparisonForSort compareKey: aKey equalTo: (self at: index + keyIndexOffset) ] ]
        whileTrue: [ index := index + eSize ].
      " if we scanned past the end, subtract an entry "
      index > lastIndex
        ifTrue: [ index := index - eSize ] ].
  " see if child has any entries less than or equal to aKey "
  ((self at: index)
    _findAllValuesLessThanKey: aKey
    andEquals: true
    into: anArray
    using: comparisonForSort)
    ifFalse: [ " this child did not find any "
      " if it is not the first child "
      index > 1
        ifTrue: [ " then the entry is the rightmost leaf entry of the previous child "
          index := index - eSize.
          (self at: index) _putLastIndexOfLastChildInto: anArray ]
        ifFalse: [ ^ false ] ].
  ^ true
%

category: 'Searching Support'
method: BtreePlusInteriorNode
_findAllValuesLessThanKey: aKey into: anArray using: aComparison
  "Puts into anArray the index and the leaf node of the entry that is less than
 (or less than and equal to if aBoolean is true) the given key, plus the index
 and interior node of the path taken to reach the leaf.  Returns true if a
 value was found, false otherwise.  Does this by invoking the same operation
 on the appropriate child node."

  | index eSize lastIndex lastKeyIndex comparisonForSort |
  lastIndex := self _lastIndex.
  lastIndex == 0
    ifTrue: [ ^ false ].
  " first see if all entries are > aKey "
  lastKeyIndex := self _lastKeyIndex.
  comparisonForSort := self comparisonForSort.
  (comparisonForSort
    compareKey: aKey
    lessThanOrEqualTo: (self at: lastKeyIndex))
    ifFalse: [ "bugfix 33805 - verify that aKey is > last entry"
      (aKey == nil
        or: [ aComparison compareKey: aKey greaterThan: (self at: lastKeyIndex) ])
        ifTrue: [ self _putLastIndexOfLastChildInto: anArray.
          ^ true ] ].
  " find index where key would be inserted "
  index := self _findCoveringIndexForKey: aKey totalOrder: false using: comparisonForSort.
  index == 0
    ifTrue: [ ^ false ].
  eSize := self entrySize.
  " see if this child has any less than the key "
  ((self at: index)
    _findAllValuesLessThanKey: aKey
    into: anArray
    using: aComparison)
    ifFalse: [ " this child did not find any "
      " if it is not the first child "
      index > 1
        ifTrue: [ " then the entry is the rightmost leaf entry of the previous child "
          index := index - eSize.
          (super at: index) _putLastIndexOfLastChildInto: anArray ]
        ifFalse: [ ^ false ] ].
  ^ true
%

category: 'Searching'
method: BtreePlusInteriorNode
_findAndCountKey: aKey value: aValue root: rootObj into: col
"return whether the last key was equal or not (so the caller knows to check next node"

| index eSize maxIndex |
index := self _findCoveringIndexForKey: aKey totalOrder: false.
index == 0 ifTrue: [ ^ false ].

((self at: index) _findAndCountKey: aKey value: aValue root: rootObj into: col)
  ifFalse: [ ^ false ].

eSize := self entrySize.
maxIndex := self _lastIndex.
index := index + eSize.

[ (index < maxIndex) and:
[ (self at: index) _findAndCountKey: aKey value: aValue root: rootObj into: col ] ]
  whileTrue: [ index := index + eSize ].
^ index >= maxIndex
%

category: 'Searching'
method: BtreePlusInteriorNode
_findFirstRootForKey: aKey using: aComparison

"Returns the first root object associated with the given key.  For interior nodes,
 find the appropriate child node and ask it to find the first root."

| index |
" find first child node that might contain the key "
index := self _findCoveringIndexForKey: aKey totalOrder: false.
index == 0 ifTrue: [ ^ #_incompletePathTraversal ].

^ (self at: index) _findFirstRootForKey: aKey using: aComparison
%

category: 'Searching Support'
method: BtreePlusInteriorNode
_lastRootObjectsNotIdenticalTo: aKey into: array
  "Send this message to all the receiver's children."

  1 to: numElements * self entrySize by: self entrySize do: [ :i | (self at: i) _lastRootObjectsNotIdenticalTo: aKey into: array ].
%

category: 'Enumerating'
method: BtreePlusInteriorNode
_leafKeysValuesAndRootsDo: aBlock

"Execute the two-argument block for each child node."

1 to: (numElements * self entrySize) by: self entrySize do: [ :i |
    (self at: i) _leafKeysValuesAndRootsDo: aBlock
]
%

category: 'Removing'
method: BtreePlusInteriorNode
_mergeFromNeighborForNodeAt: nodeIndex

"The node at the given index has too few entries and neighboring siblings had
 too few entries to take from, so merge with one of its neighboring siblings.
 First tries the next (right) sibling, then the previous (left) sibling."

| node sibling eSize myESize numSiblingElements copyStart lastChildKey myLastIndex keyIndexOffset lastChildRoot |
node := self at: nodeIndex.
eSize := node entrySize.
myESize := self entrySize.
keyIndexOffset := self keyIndexOffset.

" check if the node is the last entry "
nodeIndex == self _lastEntryIndex
    ifTrue: [ " this is the last entry, try the previous sibling "
        nodeIndex > 1
            ifTrue: [ " keep sibling, throw away node "
                sibling := self at: (nodeIndex - myESize).
                numSiblingElements := sibling numElements.

                " move node's entries onto end of sibling "
                sibling _insertAt: (sibling _lastIndex + keyIndexOffset)
                   from: node fromStart: 1 fromEnd: (node numElements * eSize)
                   numToMoveDown: 0 .

                sibling numElements: (node numElements + numSiblingElements).

                " update the key for the sibling's entry in the receiver "
                lastChildKey := sibling at: (sibling _lastKeyIndex).
                self primitiveAt: (nodeIndex - myESize + keyIndexOffset) put: lastChildKey.
                " see if last root in child node has changed "
                lastChildRoot := sibling at: sibling _lastRootIndex.
                self updateLastChildRoot: lastChildRoot at: nodeIndex - myESize.
                sibling _updateLastValue.
                "update nextLeaf of sibling and update previousLeaf of node nextLeaf"
                sibling nextLeaf: node nextLeaf.
                node nextLeaf ifNotNil: [:nLeaf | nLeaf previousLeaf: sibling ] ]
            ifFalse:[ self _error: #rtErrBtreeInvalidMerge.
                      self _uncontinuableError ].
        numElements := numElements - 1. "update here -- when losing node (next clause), need to update numElements mid-stream"
    ]
    " this is not the last entry, get the next sibling "
    ifFalse: [ " keep node, throw away sibling "
        sibling := self at: (nodeIndex + myESize).
        numSiblingElements := sibling numElements.

        "copy from sibling onto end of node "
        node _insertAt: (node _lastIndex + keyIndexOffset)
             from: sibling fromStart: 1 fromEnd: (numSiblingElements * eSize)
             numToMoveDown: 0 .

        copyStart := nodeIndex + myESize + myESize.
        " if sibling was not the last entry in the receiver "
        myLastIndex := self _lastIndex .
        copyStart < myLastIndex
            ifTrue: [
                " move entries in receiver to the left "
                self _deleteNoShrinkFrom: (nodeIndex + myESize) to: copyStart - 1
            ].

        numElements := numElements - 1. "subsequent _last*Index calculation needs to be correct"
        node numElements: (node numElements + numSiblingElements).

        " update the key for the node's entry in the receiver "
        lastChildKey := node at: (node _lastKeyIndex).
        self primitiveAt: (nodeIndex + keyIndexOffset) put: lastChildKey.
        " see if last root in child node has changed "
        lastChildRoot := node at: node _lastRootIndex.
        self updateLastChildRoot: lastChildRoot at: nodeIndex.
        node _updateLastValue.
        "update nextLeaf of node using the next element in the receiver"
        nodeIndex == self _lastEntryIndex
          ifTrue: [ "update nextLeaf of node and update previousLeaf of sibling nextLeaf"
            node nextLeaf: sibling nextLeaf.
            sibling nextLeaf ifNotNil: [:nLeaf | nLeaf previousLeaf: node ] ]
          ifFalse: [ "sibling is not the last entry so splice in sibling's sibling"
            | newNextLeaf |
            newNextLeaf := self at: (nodeIndex + myESize).
            node nextLeaf: newNextLeaf.
            newNextLeaf previousLeaf: node ] ].

" nil out the last entry of the receiver, we've either explicitly dropped last entry, or
  we slid the entries down in receiver and need to delete duplicate last entry"
myLastIndex := self _lastIndex .
self _deleteNoShrinkFrom: myLastIndex + 1 to: myLastIndex + myESize.
self _updateLastValue.
%

category: 'Rc Removing'
method: BtreePlusInteriorNode
_mergeFromNeighborForNodeAt: nodeIndex selectiveAbortSet: selectiveAbortSetOrNil

"The node at the given index has too few entries and neighboring siblings had
 too few entries to take from, so merge with one of its neighboring siblings.
 First tries the next (right) sibling, then the previous (left) sibling."

| node sibling eSize myESize numSiblingElements copyStart lastChildKey myLastIndex keyIndexOffset lastChildRoot |

node := self at: nodeIndex.
self _selectiveAbort: node ifNotIn: selectiveAbortSetOrNil.
eSize := node entrySize.
myESize := self entrySize.
keyIndexOffset := self keyIndexOffset.
" check if the node is the last entry "
nodeIndex == self _lastEntryIndex
    ifTrue: [ " this is the last entry, try the previous sibling "
        nodeIndex > 1
            ifTrue: [ " keep sibling, throw away node "
                sibling := self at: (nodeIndex - myESize).
                self _selectiveAbort: sibling ifNotIn: selectiveAbortSetOrNil.
                numSiblingElements := sibling numElements.

                " move node's entries onto end of sibling "
                sibling _insertAt: (sibling _lastIndex + keyIndexOffset)
                   from: node fromStart: 1 fromEnd: (node numElements * eSize)
                   numToMoveDown: 0 .

                sibling numElements: (node numElements + numSiblingElements).

                " update the key for the sibling's entry in the receiver "
                lastChildKey := sibling at: (sibling _lastKeyIndex).
                self primitiveAt: (nodeIndex - myESize + keyIndexOffset) put: lastChildKey.
                " see if last root in child node has changed "
                lastChildRoot := sibling at: sibling _lastRootIndex.
                self updateLastChildRoot: lastChildRoot at: nodeIndex - myESize.
                sibling _updateLastValue: selectiveAbortSetOrNil.
                "update nextLeaf of sibling and update previousLeaf of node nextLeaf"
                sibling nextLeaf: node nextLeaf.
                node nextLeaf ifNotNil: [:nLeaf |
                  self _selectiveAbort: nLeaf ifNotIn: selectiveAbortSetOrNil.
                  nLeaf previousLeaf: sibling.
                  self rootNode _addBtreePlusNodeToRcReadSet: nLeaf ].
                self rootNode _addBtreePlusNodeToRcReadSet: sibling.
                "write dropped node to force a commit conflict and force replay, in case
                 another session makes mods to the node"
                node numElements: node numElements.
                self rootNode _addBtreePlusNodeToRcReadSet: node ]
            ifFalse:[ self _error: #rtErrBtreeInvalidMerge.
                      self _uncontinuableError ].
        numElements := numElements - 1. "update here -- when losing node (next clause), need to update numElements mid-stream"
    ]
    " this is not the last entry, get the next sibling "
    ifFalse: [ " keep node, throw away sibling "
        sibling := self at: (nodeIndex + myESize).
        self _selectiveAbort: sibling ifNotIn: selectiveAbortSetOrNil.
        numSiblingElements := sibling numElements.

        "copy from sibling onto end of node "
        node _insertAt: (node _lastIndex + keyIndexOffset)
             from: sibling fromStart: 1 fromEnd: (numSiblingElements * eSize)
             numToMoveDown: 0 .

        copyStart := nodeIndex + myESize + myESize.
        " if sibling was not the last entry in the receiver "
        myLastIndex := self _lastIndex .
        copyStart < myLastIndex
            ifTrue: [
                " move entries in receiver to the left "
                self _deleteNoShrinkFrom: (nodeIndex + myESize) to: copyStart - 1
            ].

        numElements := numElements - 1. "subsequent _last*Index calculation needs to be correct"
        node numElements: (node numElements + numSiblingElements).

        " update the key for the node's entry in the receiver "
        lastChildKey := node at: (node _lastKeyIndex).
        self primitiveAt: (nodeIndex + keyIndexOffset) put: lastChildKey.
        " see if last root in child node has changed "
        lastChildRoot := node at: node _lastRootIndex.
        self updateLastChildRoot: lastChildRoot at: nodeIndex.
        node _updateLastValue: selectiveAbortSetOrNil.
        "update nextLeaf of node using the next element in the receiver"
        nodeIndex == self _lastEntryIndex
          ifTrue: [ "update nextLeaf of node and update previousLeaf of sibling nextLeaf"
            node nextLeaf: sibling nextLeaf.
            sibling nextLeaf ifNotNil: [:nLeaf |
              self _selectiveAbort: nLeaf ifNotIn: selectiveAbortSetOrNil.
              nLeaf previousLeaf: node.
              self rootNode _addBtreePlusNodeToRcReadSet: nLeaf ] ]
          ifFalse: [ "sibling is not the last entry so splice in sibling's sibling"
            | newNextLeaf |
            newNextLeaf := self at: (nodeIndex + myESize).
            self _selectiveAbort: newNextLeaf ifNotIn: selectiveAbortSetOrNil.
            node nextLeaf: newNextLeaf.
            newNextLeaf previousLeaf: node.
            self rootNode _addBtreePlusNodeToRcReadSet: newNextLeaf ].
        self rootNode _addBtreePlusNodeToRcReadSet: node.
        "write dropped sibling to force a commit conflict and force replay, in case
         another session makes mods to the node"
        sibling numElements: sibling numElements.
        self rootNode _addBtreePlusNodeToRcReadSet: sibling  ].

" nil out the last entry of the receiver, we've either explicitly dropped last entry, or
  we slid the entries down in receiver and need to delete duplicate last entry"
myLastIndex := self _lastIndex .
self _deleteNoShrinkFrom: myLastIndex + 1 to: myLastIndex + myESize.
self _updateLastValue: selectiveAbortSetOrNil.
%

category: 'Enumerating'
method: BtreePlusInteriorNode
_preOrderDo: aBlock
  aBlock value: self.
  1 to: numElements * self entrySize by: self entrySize do: [ :i | (self at: i) _preOrderDo: aBlock ]
%

category: 'Sorting Support'
method: BtreePlusInteriorNode
_putAscendingRootObjectsInto: array startingAt: offset

"Returns the number of elements."

| j |
j := offset.
1 to: (numElements * self entrySize) by: self entrySize do: [ :i |
  j := j + ((self at: i) _putAscendingRootObjectsInto: array startingAt: j)
].
^ j - offset
%

category: 'Sorting Support'
method: BtreePlusInteriorNode
_putDescendingRootObjectsInto: array startingAt: offset

"Returns the number of elements."

| j |
j := offset.
1 to: (numElements * self entrySize) by: self entrySize do: [ :i |
  j := j - ((self at: i) _putDescendingRootObjectsInto: array startingAt: j)
].
^ offset - j
%

category: 'Searching Support'
method: BtreePlusInteriorNode
_putFirstIndexOfFirstChildInto: anArray
  "Ask the first child in the receiver to
 putFirstIndexOfFirstChildInto: anArray."

  (self at: 1) _putFirstIndexOfFirstChildInto: anArray
%

category: 'Searching Support'
method: BtreePlusInteriorNode
_putFirstIndexOfFirstChildInto: anArray ifGreaterThanOrEqualTo: aKey using: aComparison
  "Ask the first child in the receiver to putFirstIndexOfFirstChildInto:ifGreaterThanOrEqualTo:.

 Because of NANs we need to validate the assumption of the caller
 (i.e., that all entries are greater than aKey). See bug33805."

  "make sure that key is less than or equal to first entry"

  (aKey == nil
    or: [ aComparison compareKey: aKey lessThanOrEqualTo: (self at: 1 + self keyIndexOffset) ])
    ifTrue: [ (self at: 1)
        _putFirstIndexOfFirstChildInto: anArray
        ifGreaterThanOrEqualTo: aKey
        using: aComparison ]
    ifFalse: [ anArray addLast: 0 ]
%

category: 'Searching Support'
method: BtreePlusInteriorNode
_putLastIndexOfLastChildInto: anArray
  "Asks the last child in the receiver to
 putLastIndexOfLastChildInto: anArray ."

  | index |
  index := self _lastKeyIndex - self keyIndexOffset.
  (self at: index)
    _putLastIndexOfLastChildInto: anArray.
%

category: 'Updating'
method: BtreePlusInteriorNode
_splitUsingKey: aChildKey node: aChildNode newSibling: newChildSibling
  "Called when aChileNode itself was split and there wasn't room in the receiver for the
   newChildSibling. Creates a new sibling node of the receiver; moving the second half of the
   receiver's entries into the newSibling; finds the sibling where aChildNode ended up and inserts
   newChildSibling immediately after aChildNode. "

  | insertionIndex newSibling lastKeyIndex lastKey lastVal lastRootObject comparisonForSort |
  newSibling := self _createSibling.
  " get the last key in the receiver "
  lastKeyIndex := self _lastKeyIndex.
  lastKey := self at: lastKeyIndex.
  " get the last value and last root in the new entry's node (this is what insertion is based upon) "
  lastVal := aChildNode lastValue.
  lastRootObject := aChildNode lastRoot.
  " determine if childNode end up in the first half (self) or second half (newSibling)"
  comparisonForSort := self comparisonForSort.
  (self
    compare: comparisonForSort
    key: aChildKey
    value: lastVal
    lessThanOrEqualToEntryAt: lastKeyIndex
    root: lastRootObject)
    ifTrue: [
      "aChildNode ended up in first half"
      insertionIndex := self binarySearchCoveringKey: aChildKey value: lastVal root: lastRootObject.
      "insert newChildSibling after aChildNode"
      self
        _insertKey: (newChildSibling at: newChildSibling _lastKeyIndex)
        value: newChildSibling
        root: newChildSibling lastRoot
        atIndex: insertionIndex + self entrySize ]
    ifFalse: [
      "aChildNode ended up in second half"
       insertionIndex := newSibling binarySearchCoveringKey: aChildKey value: lastVal root: lastRootObject .
      "insert newChildSibling after aChildNode"
      newSibling
        _insertKey: (newChildSibling at: newChildSibling _lastKeyIndex)
        value: newChildSibling
        root: newChildSibling lastRoot
        atIndex: insertionIndex + self entrySize ].
  ^ newSibling
%

category: 'Updating'
method: BtreePlusInteriorNode
_splitUsingKey: aChildKey node: aChildNode newSibling: newChildSibling selectiveAbortSet: selectiveAbortSetOrNil
  "Called when aChileNode itself was split and there wasn't room in the receiver for the
   newChildSibling. Creates a new sibling node of the receiver; moving the second half of the
   receiver's entries into the newSibling; finds the sibling where aChildNode ended up and inserts
   newChildSibling immediately after aChildNode. "

  | insertionIndex newSibling lastKeyIndex lastKey lastVal lastRootObject comparisonForSort |
  newSibling := self _createSibling: selectiveAbortSetOrNil.
  " get the last key in the receiver "
  lastKeyIndex := self _lastKeyIndex.
  lastKey := self at: lastKeyIndex.
  " get the last value and last root in the new entry's node (this is what insertion is based upon) "
  lastVal := aChildNode lastValue.
  lastRootObject := aChildNode lastRoot.
  " determine if childNode end up in the first half (self) or second half (newSibling)"
  comparisonForSort := self comparisonForSort.
  (self
    compare: comparisonForSort
    key: aChildKey
    value: lastVal
    lessThanOrEqualToEntryAt: lastKeyIndex
    root: lastRootObject
    selectiveAbortSet: selectiveAbortSetOrNil)
    ifTrue: [
      "aChildNode ended up in first half"
      insertionIndex := self binarySearchCoveringKey: aChildKey value: lastVal root: lastRootObject selectiveAbortSet: selectiveAbortSetOrNil.
      "insert newChildSibling after aChildNode"
      self
        _insertKey: (newChildSibling at: newChildSibling _lastKeyIndex)
        value: newChildSibling
        root: newChildSibling lastRoot
        atIndex: insertionIndex + self entrySize
        selectiveAbortSet: selectiveAbortSetOrNil ]
    ifFalse: [
      "aChildNode ended up in second half"
       insertionIndex := newSibling binarySearchCoveringKey: aChildKey value: lastVal root: lastRootObject selectiveAbortSet: selectiveAbortSetOrNil.
      "insert newChildSibling after aChildNode"
      newSibling
        _insertKey: (newChildSibling at: newChildSibling _lastKeyIndex)
        value: newChildSibling
        root: newChildSibling lastRoot
        atIndex: insertionIndex + self entrySize
        selectiveAbortSet: selectiveAbortSetOrNil ].
  ^ newSibling
%

category: 'Updating'
method: BtreePlusInteriorNode
_updateLastValue
  "Update the last value of the interior node by asking the last entry what its
 last value is.  Do not change the value unless there has been a change."

  | nodeLastValue nodeLastRoot   lastChildNode |
  lastChildNode := self at: self _lastEntryIndex.
  nodeLastValue := lastChildNode lastValue.
  nodeLastValue == self lastValue
    ifFalse: [ self lastValue: nodeLastValue ].
  nodeLastRoot := lastChildNode lastRoot.
  nodeLastRoot == self lastRoot
    ifFalse: [ self lastRoot: nodeLastRoot ]
%

category: 'Updating'
method: BtreePlusInteriorNode
_updateLastValue: selectiveAbortSetOrNil
  "Update the last value of the interior node by asking the last entry what its
 last value is.  Do not change the value unless there has been a change."

  | nodeLastValue nodeLastRoot   lastChildNode |
  lastChildNode := self at: self _lastEntryIndex.
  self _selectiveAbort: lastChildNode ifNotIn: selectiveAbortSetOrNil.
  nodeLastValue := lastChildNode lastValue.
  nodeLastValue == self lastValue
    ifFalse: [ self lastValue: nodeLastValue ].
  nodeLastRoot := lastChildNode lastRoot.
  nodeLastRoot == self lastRoot
    ifFalse: [ self lastRoot: nodeLastRoot ]
%

category: 'Updating'
method: BtreePlusInteriorNode
_updateLeafNodeLinksForNewPreviousLeaf: newPreviousLeaf newNextLeaf: newNextLeaf
  " newPreviousNode is being inserted in before of receiver, update the previous/next leaf values for both nodes"

  "currently a noop"
%

category: 'Updating'
method: BtreePlusInteriorNode
_updateLeafNodeLinksForNewPreviousLeaf: newPreviousLeaf newNextLeaf: newNextLeaf  selectiveAbortSet: selectiveAbortSetOrNil
  " newPreviousNode is being inserted in before of receiver, update the previous/next leaf values for both nodes"

  "currently a noop"
%

! Class extensions for 'BtreePlusLeafKeyNode'

!		Class methods for 'BtreePlusLeafKeyNode'

category: 'Constants'
classmethod: BtreePlusLeafKeyNode
entrySize
  "Returns the size of an entry with no encryption."

  "in-lined on instance-side for performance"

  ^ 1
%

category: 'Constants'
classmethod: BtreePlusLeafKeyNode
maxNumberOfElements
  "Returns the number of entries that are allowed in an interior node."

  ^ 2028
%

!		Instance methods for 'BtreePlusLeafKeyNode'

category: 'Updating'
method: BtreePlusLeafKeyNode
at: aKey put: aValue root: ignoredRoot
  "Adds the key/value pair to the node.  If the node is full, performs a 'split'
 on the parent.  Returns the new sibling if a split is performed, otherwise
 returns the receiver."

  | index |
  " determine if a split is needed "
  numElements == self maxNumberOfElements
    ifTrue: [ " performs the split and returns the new sibling "
      ^ self _splitUsingKey: aKey value: aValue  ]
    ifFalse: [ " entry will fit in leaf node "
      numElements == 0
        ifTrue: [ index := 1 ]
        ifFalse: [ index := self binarySearchCoveringKey: aKey ].
      self _insertKey: aKey atIndex: index ]
%

category: 'Updating'
method: BtreePlusLeafKeyNode
at: aKey put: aValue root: ignoredRoot selectiveAbortSet: selectiveAbortSetOrNil
  "Adds the key/value pair to the node.  If the node is full, performs a 'split'
 on the parent.  Returns the new sibling if a split is performed, otherwise
 returns the receiver."

  | index |
  " determine if a split is needed "
  self _selectiveAbort: self ifNotIn: selectiveAbortSetOrNil.
  self rootNode _addBtreePlusNodeToRcReadSet: self.
  numElements == self maxNumberOfElements
    ifTrue: [ " performs the split and returns the new sibling "
      ^ self _splitUsingKey: aKey value: aValue selectiveAbortSet: selectiveAbortSetOrNil ]
    ifFalse: [ " entry will fit in leaf node "
      numElements == 0
        ifTrue: [ index := 1 ]
        ifFalse: [ index := self binarySearchCoveringKey: aKey ].
      self _insertKey: aKey atIndex: index ]
%

category: 'Comparison Operators'
method: BtreePlusLeafKeyNode
compare: comparisonForSort key: aKey value: aValue equalToEntryAt: keyIndex root: ignoredRootObject
  "Performs a = comparison between aKey and the entry whose key is at the given
 index. If the keys are equal, use the OOP of the value as the next basis for
 comparison."

  ^ self compare: comparisonForSort key: aKey value: aValue equalToEntryAt: keyIndex
%

category: 'Comparison Operators'
method: BtreePlusLeafKeyNode
compare: comparisonForSort key: aKey value: aValue lessThanOrEqualToEntryAt: keyIndex root: ignoredRootObject
  "Performs a <= comparison between aKey and the entry whose key is at the given
 index. If the keys are equal, then use the OOP of the value for the comparison."

  ^self compare: comparisonForSort key: aKey value: aValue lessThanOrEqualToEntryAt: keyIndex
%

category: 'Comparison Operators'
method: BtreePlusLeafKeyNode
compareValueOop: aValue greaterThanEntryValueOopAt: keyIndex
  "Perform a > comparison between the oop of aValue and oop of the entry whose value is
   at the given index."

  "value/key/root use same index"

  ^ aValue asOop > (self at: keyIndex) asOop
%

category: 'Comparison Operators'
method: BtreePlusLeafKeyNode
compareValueOop: aValue greaterThanEntryValueOopAt: keyIndex root: ignored
  "Perform a > comparison between the oop of aValue and oop of the entry whose value is
   at the given index. "

  ^ self compareValueOop: aValue greaterThanEntryValueOopAt: keyIndex
%

category: 'Comparison Operators'
method: BtreePlusLeafKeyNode
compareValueOop: aValue lessThanOrEqualToEntryValueOopAt: keyIndex
  "Perform a <= comparison between the oop of aValue and oop of the entry whose value is
   at the given index."

  "value/key/root use same index"

  ^ aValue asOop <= (self at: keyIndex) asOop
%

category: 'Comparison Operators'
method: BtreePlusLeafKeyNode
compareValueOop: aValue lessThanOrEqualToEntryValueOopAt: keyIndex root: ignored
  "Perform a <= comparison between the oop of aValue and oop of the entry whose value is
   at the given index."

  ^ self compareValueOop: aValue lessThanOrEqualToEntryValueOopAt: keyIndex
%

category: 'Constants'
method: BtreePlusLeafKeyNode
entrySize
  "Returns the size of an entry."

  "in-line of `self class entrySize` for performance"

  ^ 1
%

category: 'Accessing'
method: BtreePlusLeafKeyNode
keyIndexOffset
  "Answer the offset from entry index for the key. Typical order is value/key/root.
   The value, key and root objects are the same for the receiver."

  ^ 0
%

category: 'Constants'
method: BtreePlusLeafKeyNode
parentNodeClass
  "Returns the class of node to be created as the parent when a split occurs."

  ^ BtreePlusInteriorKeyValueNode
%

category: 'Accessing'
method: BtreePlusLeafKeyNode
rootIndexOffset
  "Answer the offset from entry index for the root object. Typical order is value/key/root.
   The value, key and root objects are the same for the receiver."

  ^ 0
%

category: 'Updating'
method: BtreePlusLeafKeyNode
_insertKey: aKey atIndex: insertionIndex

"Insert the key/value pair in the receiver.  The sender of this message must
verify that the entry will fit in the receiver and provide the insertion
index."

| endIndex entrySize |

" see if any existing entries have to be moved "
entrySize := self entrySize .
endIndex := (numElements * entrySize) .

self _insertAt: insertionIndex
     value: aKey
     numToMoveDown: (endIndex - insertionIndex + 1) .

"no prefix encoding"

numElements := numElements + 1
%

category: 'Updating'
method: BtreePlusLeafKeyNode
_insertKey: aKey value: ignoredValue atIndex: insertionIndex
  "Insert the key/value pair in the receiver.  The sender of this message must
verify that the entry will fit in the receiver and provide the insertion
index."

self _insertKey: aKey atIndex: insertionIndex

%

category: 'Updating'
method: BtreePlusLeafKeyNode
_insertKey: aKey value: ignoredValue root: ignoredRoot atIndex: insertionIndex

"Insert the key/value pair in the receiver.  The sender of this message must
verify that the entry will fit in the receiver and provide the insertion
index."

self _insertKey: aKey atIndex: insertionIndex
%

category: 'Updating'
method: BtreePlusLeafKeyNode
_insertKey: aKey value: ignoredValue root: ignoredRoot atIndex: insertionIndex selectiveAbortSet: ignored

"Compat with BtreePlustInteriorNode api ... inserts do not require selective abort logic"

self _insertKey: aKey value: ignoredValue root: ignoredRoot atIndex: insertionIndex
%

! Class extensions for 'BtreePlusLeafKeyValueNode'

!		Class methods for 'BtreePlusLeafKeyValueNode'

category: 'Constants'
classmethod: BtreePlusLeafKeyValueNode
entrySize
  "Returns the size of an entry with no encryption."

  "in-lined on instance-side for performance"

  ^ 2
%

category: 'Constants'
classmethod: BtreePlusLeafKeyValueNode
maxNumberOfElements
  "Returns the number of entries that are allowed in an interior node."

  ^ 1014
%

!		Instance methods for 'BtreePlusLeafKeyValueNode'

category: 'Updating'
method: BtreePlusLeafKeyValueNode
at: aKey put: aValue root: ignored
  "Adds the key/value pair to the node.  If the node is full, performs a 'split'
 on the parent.  Returns the new sibling if a split is performed, otherwise
 returns the receiver."

  | index |
  " determine if a split is needed "
  numElements == self maxNumberOfElements
    ifTrue: [ " performs the split and returns the new sibling "
      ^ self _splitUsingKey: aKey value: aValue ]
    ifFalse: [ " entry will fit in leaf node "
      numElements == 0
        ifTrue: [ index := 1 ]
        ifFalse: [ index := self binarySearchCoveringKey: aKey value: aValue ].
      self _insertKey: aKey value: aValue atIndex: index ]
%

category: 'Updating'
method: BtreePlusLeafKeyValueNode
at: aKey put: aValue root: ignored selectiveAbortSet: selectiveAbortSetOrNil
  "Adds the key/value pair to the node.  If the node is full, performs a 'split'
 on the parent.  Returns the new sibling if a split is performed, otherwise
 returns the receiver."

  | index |
  " determine if a split is needed "
  self _selectiveAbort: self ifNotIn: selectiveAbortSetOrNil.
  self rootNode _addBtreePlusNodeToRcReadSet: self.
  numElements == self maxNumberOfElements
    ifTrue: [ " performs the split and returns the new sibling "
      ^ self _splitUsingKey: aKey value: aValue selectiveAbortSet: selectiveAbortSetOrNil ]
    ifFalse: [ " entry will fit in leaf node "
      numElements == 0
        ifTrue: [ index := 1 ]
        ifFalse: [ index := self binarySearchCoveringKey: aKey value: aValue ].
      self _insertKey: aKey value: aValue atIndex: index ]
%

category: 'Comparison Operators'
method: BtreePlusLeafKeyValueNode
compare: comparisonForSort key: aKey value: aValue equalToEntryAt: keyIndex root: rootObject
  "Performs a = comparison between aKey and the entry whose key is at the given
 index. If the keys are equal, use the OOP of the value as the next basis for
 comparison."

  ^ self compare: comparisonForSort key: aKey value: aValue equalToEntryAt: keyIndex
%

category: 'Comparison Operators'
method: BtreePlusLeafKeyValueNode
compare: comparisonForSort key: aKey value: aValue lessThanOrEqualToEntryAt: keyIndex root: ignoredRootObject
  "Performs a <= comparison between aKey and the entry whose key is at the given
 index. If the keys are equal, then use the OOP of the value for the comparison."

  ^self compare: comparisonForSort key: aKey value: aValue lessThanOrEqualToEntryAt: keyIndex
%

category: 'Comparison Operators'
method: BtreePlusLeafKeyValueNode
compareValueOop: aValue greaterThanEntryValueOopAt: keyIndex root: ignored
  "Perform a > comparison between the oop of aValue and oop of the entry whose value is
   at the given index. "

  ^ self compareValueOop: aValue greaterThanEntryValueOopAt: keyIndex
%

category: 'Comparison Operators'
method: BtreePlusLeafKeyValueNode
compareValueOop: aValue lessThanOrEqualToEntryValueOopAt: keyIndex root: ignored
  "Perform a <= comparison between the oop of aValue and oop of the entry whose value is
   at the given index."

  ^ self compareValueOop: aValue lessThanOrEqualToEntryValueOopAt: keyIndex
%

category: 'Constants'
method: BtreePlusLeafKeyValueNode
entrySize
  "Returns the size of an entry."

  "in-line of `self class entrySize` for performance"

  ^ 2
%

category: 'Constants'
method: BtreePlusLeafKeyValueNode
parentNodeClass
  "Returns the class of node to be created as the parent when a split occurs."

  ^ BtreePlusInteriorKeyValueRootObjectNode
%

category: 'Accessing'
method: BtreePlusLeafKeyValueNode
rootIndexOffset
  "Answer the offset from entry index for the root object. Typical order is value/key/root.
   The value and root object is the same for the receiver."

  ^ 0
%

category: 'Updating'
method: BtreePlusLeafKeyValueNode
_insertKey: aKey value: aValue atIndex: insertionIndex
  "Insert the key/value pair in the receiver.  The sender of this message must
verify that the entry will fit in the receiver and provide the insertion
index."

  | endIndex entrySize |
  entrySize := self entrySize.
  endIndex := numElements * entrySize.

  self _insertAt: insertionIndex
       value: aValue value: aKey
       numToMoveDown: endIndex - insertionIndex + 1 .

  "no prefix encoding"

  numElements := numElements + 1


%

category: 'Updating'
method: BtreePlusLeafKeyValueNode
_insertKey: aKey value: aValue root: ignored atIndex: insertionIndex

"Insert the key/value pair in the receiver.  The sender of this message must
verify that the entry will fit in the receiver and provide the insertion
index."

self _insertKey: aKey value: aValue atIndex: insertionIndex
%

category: 'Updating'
method: BtreePlusLeafKeyValueNode
_insertKey: aKey value: aValue root: ignored atIndex: insertionIndex selectiveAbortSet: ignoredSet

"Compat with BtreePlustInteriorNode api ... inserts do not require selective abort logic"

self _insertKey: aKey value: aValue root: ignored atIndex: insertionIndex
%

! Class extensions for 'BtreePlusLeafKeyValueRootObjectNode'

!		Class methods for 'BtreePlusLeafKeyValueRootObjectNode'

category: 'Constants'
classmethod: BtreePlusLeafKeyValueRootObjectNode
entrySize
  "Returns the size of an entry with no encryption."

  "in-lined on instance-side for performance"

  ^ 3
%

category: 'Constants'
classmethod: BtreePlusLeafKeyValueRootObjectNode
maxNumberOfElements
  "Returns the number of entries that are allowed in an interior node."

  ^ 676
%

!		Instance methods for 'BtreePlusLeafKeyValueRootObjectNode'

category: 'Updating'
method: BtreePlusLeafKeyValueRootObjectNode
at: aKey put: aValue root: rootObject
  "Adds the key/value/root pair to the node.  If the node is full, performs a 'split'
 on the parent.  Returns the new sibling if a split is performed, otherwise
 returns the receiver."

  | index |
  " determine if a split is needed "
  numElements == self maxNumberOfElements
    ifTrue: [ " performs the split and returns the new sibling "
      ^ self _splitUsingKey: aKey value: aValue root: rootObject ]
    ifFalse: [ " entry will fit in leaf node "
      numElements == 0
        ifTrue: [ index := 1 ]
        ifFalse: [ index := self binarySearchCoveringKey: aKey value: aValue root: rootObject ].
      self
        _insertKey: aKey
        value: aValue
        root: rootObject
        atIndex: index ]
%

category: 'Updating'
method: BtreePlusLeafKeyValueRootObjectNode
at: aKey put: aValue root: rootObject selectiveAbortSet: selectiveAbortSetOrNil
  "Adds the key/value/root pair to the node.  If the node is full, performs a 'split'
 on the parent.  Returns the new sibling if a split is performed, otherwise
 returns the receiver."

  | index |
  " determine if a split is needed "
  self _selectiveAbort: self ifNotIn: selectiveAbortSetOrNil.
  self rootNode _addBtreePlusNodeToRcReadSet: self.
  numElements == self maxNumberOfElements
    ifTrue: [ " performs the split and returns the new sibling "
      ^ self _splitUsingKey: aKey value: aValue root: rootObject selectiveAbortSet: selectiveAbortSetOrNil ]
    ifFalse: [ " entry will fit in leaf node "
      numElements == 0
        ifTrue: [ index := 1 ]
        ifFalse: [ index := self binarySearchCoveringKey: aKey value: aValue root: rootObject ].
      self
        _insertKey: aKey
        value: aValue
        root: rootObject
        atIndex: index ]
%

category: 'Comparison Operators'
method: BtreePlusLeafKeyValueRootObjectNode
compareValueOop: aValue greaterThanEntryValueOopAt: keyIndex root: aRootObject
  "Perform a > comparison between the oop of aValue and oop of the entry whose value is
   at the given index. If the value oops are equal, compare the oop of aRootObject and the
   oop of the root object at the given index."

  | keyIndexOffset entryValue |
  keyIndexOffset := self keyIndexOffset.
  entryValue := self at: keyIndex - keyIndexOffset.
  "aValue asOop = entryValue asOop"
  aValue == entryValue
    ifTrue: [ ^ aRootObject asOop > (self at: keyIndex - keyIndexOffset + self rootIndexOffset) asOop ].
  ^ aValue asOop > entryValue asOop
%

category: 'Comparison Operators'
method: BtreePlusLeafKeyValueRootObjectNode
compareValueOop: aValue lessThanOrEqualToEntryValueOopAt: keyIndex root: aRootObject
  "Perform a <= comparison between the oop of aValue and oop of the entry whose value is
   at the given index. If the value oops are equal, compare the oop of aRootObject and the
   oop of the root object at the given index."

  | keyIndexOffset entryValue |
  keyIndexOffset := self keyIndexOffset.
  entryValue := self at: keyIndex - keyIndexOffset.
  "aValue asOop = entryValue asOop"
  aValue == entryValue
    ifTrue: [ ^ aRootObject asOop <= (self at: keyIndex - keyIndexOffset + self rootIndexOffset) asOop ].
  ^ aValue asOop < entryValue asOop
%

category: 'Constants'
method: BtreePlusLeafKeyValueRootObjectNode
entrySize
  "Returns the size of an entry."

  "in-line of `self class entrySize` for performance"

  ^ 3
%

category: 'Constants'
method: BtreePlusLeafKeyValueRootObjectNode
parentNodeClass
  "Returns the class of node to be created as the parent when a split occurs."

  ^ BtreePlusInteriorKeyValueRootObjectNode
%

category: 'Updating'
method: BtreePlusLeafKeyValueRootObjectNode
_insertKey: aKey value: aValue root: rootObject atIndex: insertionIndex
  "Insert the key/value pair in the receiver.  The sender of this message must
verify that the entry will fit in the receiver and provide the insertion
index."

  | endIndex entrySize |
  entrySize := self entrySize.
  endIndex := numElements * entrySize.
  self _insertAt: insertionIndex
       value: aValue value: aKey value: rootObject
       numToMoveDown: endIndex - insertionIndex + 1.

  "no prefix encoding."

  numElements := numElements + 1

%

category: 'Updating'
method: BtreePlusLeafKeyValueRootObjectNode
_insertKey: aKey value: aValue root: rootObject atIndex: insertionIndex selectiveAbortSet: ignored
"Compat with BtreePlustInteriorNode api ... inserts do not require selective abort logic"

  self _insertKey: aKey value: aValue root: rootObject atIndex: insertionIndex

%

! Class extensions for 'BtreePlusLeafNode'

!		Instance methods for 'BtreePlusLeafNode'

category: 'Audit'
method: BtreePlusLeafNode
auditForPathTerm: pathTerm using: auditor parentNode: parentNode previousChild: previousChild nextChild: nextChild do: aBlock
  "Execute the three-argument block with the key, value, root of each entry in the receiver."

  | keyIndexOffset rootIndexOffset |
  keyIndexOffset := self keyIndexOffset.
  rootIndexOffset := self rootIndexOffset.
  previousChild == previousLeaf
    ifFalse: [
      auditor
        btree: self
        parentNode: parentNode
        previousLeafMismatch: pathTerm
        previousLeaf: previousLeaf
        parentPreviousNode: previousChild ].
  nextChild == nextLeaf
    ifFalse: [
      auditor
        btree: self
        parentNode: parentNode
        nextLeafMismatch: pathTerm
        nextLeaf: nextLeaf
        parentNextNode: nextChild ].
  1 to: numElements * self entrySize by: self entrySize do: [ :i | | v k r |
    v := self at: i.
    k := self at: i + keyIndexOffset.
    r := self at: i + rootIndexOffset.
    aBlock value: self value: k value: v value: r ]
%

category: 'Comparison Operators'
method: BtreePlusLeafNode
compare: comparisonForSort key: aKey value: aValue equalToEntryAt: keyIndex
  "Performs a = comparison between aKey and the entry whose key is at the given
 index.  If the keys are equal, use the OOP of the value as the next basis for
 comparison."

  | entryIndex |
  entryIndex := keyIndex - self keyIndexOffset.
  ^ (comparisonForSort compareKey: aKey equalTo: (self at: keyIndex))
    and: [ aValue == (self at: entryIndex) ]
%

category: 'Comparison Operators'
method: BtreePlusLeafNode
compare: comparisonForSort key: aKey value: aValue equalToEntryAt: keyIndex root: rootObject
  "Performs a = comparison between aKey and the entry whose key is at the given
 index.  If the keys are equal, use the OOP of the value as the next basis for
 comparison. If the value oops are equeal, use the oop of the rootObject as the
 next basis for comparison."

  ^ (comparisonForSort compareKey: aKey equalTo: (self at: keyIndex))
    and: [ | entryIndex |
      entryIndex := keyIndex - self keyIndexOffset.
      aValue == (self at: entryIndex)
        and: [ rootObject == (self at: entryIndex + self rootIndexOffset) ] ]
%

category: 'Comparison Operators'
method: BtreePlusLeafNode
compare: comparisonForSort key: aKey value: aValue lessThanOrEqualToEntryAt: keyIndex
  "Performs a <= comparison between aKey and the entry whose key is at the given
 index. If the keys are equal, then use the OOP of the value for the
 comparison."

  (comparisonForSort compareKey: aKey lessThan: (self at: keyIndex))
    ifTrue: [ ^ true ].
  (comparisonForSort compareKey: aKey equalTo: (self at: keyIndex))
    ifTrue: [ | entryIndex |
      entryIndex := keyIndex - self keyIndexOffset.
      ^aValue asOop <= (self at: entryIndex) asOop ].
  ^ false
%

category: 'Comparison Operators'
method: BtreePlusLeafNode
compare: comparisonForSort key: aKey value: aValue lessThanOrEqualToEntryAt: keyIndex root: rootObject
  "Performs a <= comparison between aKey and the entry whose key is at the given
 index.  If the keys are equal, then use the OOP of the value for the
 comparison. If the value oops are equal, use the OOP of the rootObject for the
 comparison."

  (comparisonForSort compareKey: aKey lessThan: (self at: keyIndex))
    ifTrue: [ ^ true ].
  (comparisonForSort compareKey: aKey equalTo: (self at: keyIndex))
    ifTrue: [ | entryIndex entryIndexValue |
      entryIndex := keyIndex - self keyIndexOffset.
      entryIndexValue := self at: entryIndex.
      "aValue asOop = (entryIndexValue) asOop"
      aValue == entryIndexValue
        ifTrue: [ ^ rootObject asOop <= (self at: entryIndex + self rootIndexOffset) asOop ].
      ^ aValue asOop < entryIndexValue asOop ].
  ^ false
%

category: 'Comparison Operators'
method: BtreePlusLeafNode
compare: comparisonForSort key: aKey value: aValue lessThanOrEqualToEntryAt: keyIndex root: rootObject selectiveAbortSet: selectiveAbortSetOrNil

  "Performs a <= comparison between aKey and the entry whose key is at the given
 index.  If the keys are equal, then use the OOP of the value for the
 comparison. If the value oops are equal, use the OOP of the rootObject for the
 comparison."

 ""

^ self compare: comparisonForSort key: aKey value: aValue lessThanOrEqualToEntryAt: keyIndex root: rootObject
%

category: 'Comparison Operators'
method: BtreePlusLeafNode
compareValueOop: aValue greaterThanEntryValueOopAt: keyIndex
  "Perform a > comparison between the oop of aValue and oop of the entry whose value is
   at the given index."


  ^ aValue asOop > (self at: keyIndex - self keyIndexOffset) asOop
%

category: 'Comparison Operators'
method: BtreePlusLeafNode
compareValueOop: aValue lessThanOrEqualToEntryValueOopAt: keyIndex
  "Perform a <= comparison between the oop of aValue and oop of the entry whose value is
   at the given index."

  ^ aValue asOop <= (self at: keyIndex - self keyIndexOffset) asOop
%

category: 'Testing'
method: BtreePlusLeafNode
isLeaf

"Returns whether the B-tree node is a leaf node."

^ true
%

category: 'Accessing'
method: BtreePlusLeafNode
keyAt: anIndex
  "answer the key for the given index"

  ^ self at: anIndex + self keyIndexOffset
%

category: 'Accessing'
method: BtreePlusLeafNode
lastKey

"Returns the key for the last entry in the receiver."

^ self at: (self _lastEntryIndex + self keyIndexOffset)
%

category: 'Accessing'
method: BtreePlusLeafNode
lastRoot

"Returns the root object for the last entry in the receiver."

^ self at: (self _lastEntryIndex + self rootIndexOffset)
%

category: 'Accessing'
method: BtreePlusLeafNode
lastValue

"Returns the value for the last entry in the receiver."

^ self at: self _lastEntryIndex
%

category: 'Accessing'
method: BtreePlusLeafNode
nextLeaf
  "Returns the value of the instance variable 'nextLeaf'."

  ^ nextLeaf
%

category: 'Accessing'
method: BtreePlusLeafNode
nextLeaf: anObject
  "Modify the value of the instance variable 'nextLeaf'."

  nextLeaf := anObject
%

category: 'Accessing'
method: BtreePlusLeafNode
previousLeaf
  "Returns the value of the instance variable 'previousLeaf'."

  ^ previousLeaf
%

category: 'Accessing'
method: BtreePlusLeafNode
previousLeaf: anObject
  "Modify the value of the instance variable 'previousLeaf'."

  previousLeaf := anObject
%

category: 'Printing'
method: BtreePlusLeafNode
printOn: aStream withIndentationLevel: anInteger

"Puts a displayable representation of the keys of the receiver on the given
 stream, indenting the given number of spaces."

anInteger timesRepeat: [ aStream nextPut: Character space ].

"aStream nextPutAll: '  { '; nextPutAll: self _alias asString; nextPutAll: ' } '."

2 to: (numElements * self entrySize) by: self entrySize do: [ :i |
    aStream nextPutAll: (super at: i) asString;
        nextPut: $(;
        nextPutAll: (super at: i - 1) asString;
        nextPutAll: ') '
].
aStream nextPut: Character lf
%

category: 'Printing'
method: BtreePlusLeafNode
printOn: aStream withIndentationLevel: anInteger includingValues: aBoolean

"Puts a displayable representation of the keys of the receiver on the given
 stream, indenting the given number of spaces."

| valueIndexOffset |
valueIndexOffset := self valueIndexOffset.

anInteger timesRepeat: [ aStream nextPut: Character space ].

2 to: (numElements * self entrySize) by: self entrySize do: [ :i |
    aStream nextPutAll: (self at: i) asString.

    aBoolean
        ifTrue: [
            aStream nextPut: $(;
                nextPutAll: (self at: i + valueIndexOffset) asString;
                nextPutAll: ') '
        ]
        ifFalse: [ aStream nextPutAll: ' ' ]
].
aStream nextPut: Character lf
%

category: 'Removing'
method: BtreePlusLeafNode
removeKey: aKey value: aValue root: rootObject
  "Removes the key/value pair.  Finds the index for the given key and then shifts
 any following entries to the left."

  | valueIndex eSize |
  valueIndex := self binarySearchForKey: aKey value: aValue root: rootObject.
  valueIndex == 0
    ifTrue: [ ^ false ].
  eSize := self entrySize.
  self _deleteNoShrinkFrom: valueIndex to: valueIndex + eSize - 1.
  numElements := numElements - 1.
  ^ true
%

category: 'Rc Removing'
method: BtreePlusLeafNode
removeKey: aKey value: aValue root: rootObject selectiveAbortSet: selectiveAbortSetOrNil
  "Removes the key/value pair.  Finds the index for the given key and then shifts
 any following entries to the left."

  | wasRemoved |
  self _selectiveAbort: self ifNotIn: selectiveAbortSetOrNil.
  wasRemoved := self removeKey: aKey value: aValue root: rootObject.
  self rootNode _addBtreePlusNodeToRcReadSet: self.
  ^ wasRemoved
%

category: 'Accessing'
method: BtreePlusLeafNode
rootObjectAt: anIndex
  "answer the root object for the given index"

  ^ self at: anIndex + self rootIndexOffset
%

category: 'Accessing'
method: BtreePlusLeafNode
totalElements

"Return the number of elements."

^ numElements
%

category: 'Query Support'
method: BtreePlusLeafNode
_addRootObjects: aQuerySpec start: startIndex end: endIndex into: collection
  ^ (aQuerySpec canUseOptimizedComparison and: [ self rootNode indexObject optimizingComparison ])
    ifTrue: [
      self
        _primAddRootObjects: aQuerySpec
        start: startIndex + self rootIndexOffset
        end: endIndex + self rootIndexOffset
        into: collection
        entrySize: self entrySize ]
    ifFalse: [
      super
        _addRootObjects: aQuerySpec
        start: startIndex
        end: endIndex
        into: collection ]
%

category: 'Comparison Operators'
method: BtreePlusLeafNode
_compare: aComparison key: aKey equalToEntryAt: index

"Performs a = comparison between aKey and the entry whose key is at the given
index.  The default implementation uses no encryption."

^ aComparison compareKey: aKey equalTo: (self _at: index)
%

category: 'Comparison Operators'
method: BtreePlusLeafNode
_compare: aComparison key: aKey lessThanOrEqualToEntryAt: index

"Perform a <= comparison between aKey and the entry whose key is at the given
index.  The default implementation uses no encryption."

^ aComparison compareKey: aKey lessThanOrEqualTo: (self at: index)
%

category: 'Updating'
method: BtreePlusLeafNode
_createSibling
  "Creates a new sibling node and move the second half of the receiver's entries into the
sibling.  Returns the new sibling."

  | newSibling nLeaf |
  newSibling := super _createSibling.
  nLeaf := self nextLeaf.
  newSibling
    previousLeaf: self;
    nextLeaf: nLeaf.
  nLeaf ifNotNil: [ nLeaf previousLeaf: newSibling ].
  self nextLeaf: newSibling.
  ^ newSibling
%

category: 'Updating'
method: BtreePlusLeafNode
_createSibling: selectiveAbortSetOrNil
  "Creates a new sibling node and moves half of the receiver's entries into the
sibling.  Returns the new sibling."

  | newSibling nLeaf |
  newSibling := super _createSibling.
  nLeaf := self nextLeaf.
  newSibling
    previousLeaf: self;
    nextLeaf: nLeaf.
  nLeaf
    ifNotNil: [
      self _selectiveAbort: nLeaf ifNotIn: selectiveAbortSetOrNil.
      nLeaf previousLeaf: newSibling.
      self rootNode _addBtreePlusNodeToRcReadSet: nLeaf ].
  self nextLeaf: newSibling.
  self rootNode _addBtreePlusNodeToRcReadSet: self.
  ^ newSibling
%

category: 'Searching'
method: BtreePlusLeafNode
_findAllValuesForIdenticalKey: aKey into: aCollection using: aComparison

"Finds all the values for the given identical key, placing them in the
 collection.  For leaf nodes, must first find the appropriate entry, then
 iterate through successive entries until we reach the end or a key does
 not match.  Return whether the last key was equal or not (so the caller
 knows it must check the next leaf node)."

| index eSize maxIndex keyIndexOffset |
" find first entry that might contain the key "
index := self _findCoveringIndexForKey: aKey totalOrder: false.
index == 0 ifTrue: [ ^ false ].

eSize := self entrySize.
maxIndex := self _lastIndex.

" now scan entries until reach the end or no match using sort ="
keyIndexOffset := self keyIndexOffset.
[ (index < maxIndex) and:
[ aComparison compareKey: aKey equalTo: (self at: index + keyIndexOffset) ] ] whileTrue: [
  (aKey == (self at: index + keyIndexOffset))
    ifTrue: [ aCollection add: (self at: index) ].
  index := index + eSize
].
^ index >= maxIndex
%

category: 'Searching Support'
method: BtreePlusLeafNode
_findAllValuesGreaterThanKey: aKey into: anArray using: aComparison
  "Puts into anArray the index and the leaf node of the entry that is greater
 than the given key.  Returns true if a value was found, false otherwise."

  | entryIndex eSize lastIndex keyIndexOffset comparisonForSort |
  numElements == 0
    ifTrue: [ ^ false ].
  lastIndex := self _lastKeyIndex.	" find index where the key would be inserted "
  comparisonForSort := self comparisonForSort.
  entryIndex := self _findCoveringIndexForKey: aKey totalOrder: false using: comparisonForSort.
  entryIndex == 0
    ifTrue: [ ^ false ].	"skip keys that sort ="
  eSize := self entrySize.
  keyIndexOffset := self keyIndexOffset.
  [ comparisonForSort
    compareKey: aKey
    equalTo: (self at: entryIndex + keyIndexOffset) ]
    whileTrue: [ entryIndex := entryIndex + eSize.
      entryIndex > lastIndex
        ifTrue: [ ^ false ] ].
  aKey ~~ nil
    ifTrue: [ "bugfix 33805 - verify that aKey < index entry"
      (comparisonForSort
        compareKey: aKey
        lessThan: (self at: entryIndex + keyIndexOffset))
        ifFalse: [ ^ false ] ].
  anArray addLast: entryIndex.
  anArray addLast: self.
  ^ true
%

category: 'Searching Support'
method: BtreePlusLeafNode
_findAllValuesLessThanKey: aKey andEquals: aBoolean into: anArray using: aComparison
  "Puts into anArray the index and the leaf node of the entry that is less than
 (or less than and equal to if aBoolean is true) the given key.  Returns true
 if a value was found, false otherwise."

  numElements == 0
    ifTrue: [ ^ false ].
  aBoolean
    ifFalse: [ ^ self _findAllValuesLessThanKey: aKey into: anArray using: aComparison ].
  (self _findAllValuesGreaterThanKey: aKey into: anArray using: aComparison)
    ifTrue: [ | eSize index |
      eSize := self entrySize.
      index := anArray at: 1.
      index > eSize
        ifTrue: [ "move index pointer for first greater than entry to first less than or equal to entry"
          index := index - eSize.
          anArray at: 1 put: index ]
        ifFalse: [ "first entry is greater than, so no entries are less than or equal"
          anArray size: 0.
          ^ false ].
      ^ true ].
  (aKey == nil or: [ aComparison
        compareKey: aKey
        greaterThanOrEqualTo: (self at: self _lastKeyIndex) ])
    ifTrue: [ " if so, put the rightmost leaf entry in the Array "
      self _putLastIndexOfLastChildInto: anArray.
      ^ true ].
  ^ false
%

category: 'Searching Support'
method: BtreePlusLeafNode
_findAllValuesLessThanKey: aKey into: anArray using: aComparison
  "Puts into anArray the index and the leaf node of the entry that is less than
 the given key.  Returns true if a value was found, false otherwise."

  | entryIndex eSize lastIndex lastKeyIndex keyIndex comparisonForSort |
  numElements == 0
    ifTrue: [ ^ false ].
  lastIndex := self _lastIndex.
  " first see if all entries are > aKey "
  lastKeyIndex := self _lastKeyIndex.
  comparisonForSort := self comparisonForSort.
  (comparisonForSort
    compareKey: aKey
    lessThanOrEqualTo: (self at: lastKeyIndex))
    ifFalse: [ "bugfix 33805 - verify that aKey is > index entry"
      (aKey == nil
        or: [ aComparison compareKey: aKey greaterThan: (self at: lastKeyIndex) ])
        ifTrue: [ " if so, put the rightmost leaf entry in the Array "
          self _putLastIndexOfLastChildInto: anArray.
          ^ true ] ].
  " find index where the key would be inserted "
  entryIndex := self _findCoveringIndexForKey: aKey totalOrder: false  using: comparisonForSort.	" if index == 0, found no entryes"
  entryIndex == 0
    ifTrue: [ ^ false ].
  " if index == 1, check if any are < aKey "
  entryIndex == 1
    ifTrue: [ " if the first entry is greater than or equal to aKey, none satisfy "
      | keyIndexOffset |
      keyIndexOffset := self keyIndexOffset.
      ((comparisonForSort compareKey: aKey lessThan: (self at: entryIndex + keyIndexOffset))
        or: [ comparisonForSort compareKey: aKey equalTo: (self at: entryIndex + keyIndexOffset) ])
        ifTrue: [ ^ false ] ].
  eSize := self entrySize.
  entryIndex > 1
    ifTrue: [ " subtract an entry to point to a valid 'less than' entry "
      entryIndex := entryIndex - eSize ].
  keyIndex := entryIndex + self keyIndexOffset.
  aKey ~~ nil
    ifTrue: [ "bugfix 33805 - verify that index aKey is > entry"
      (comparisonForSort compareKey: aKey greaterThan: (self at: keyIndex))
        ifFalse: [ (aComparison compareKey: aKey equalTo: (self at: keyIndex))
            ifTrue: [ ^ false ].
          (aComparison compareKey: aKey lessThan: (self at: keyIndex))
            ifFalse: [ ^ false ] ] ].
  anArray addLast: entryIndex.
  anArray addLast: self.
  ^ true
%

category: 'Searching'
method: BtreePlusLeafNode
_findAndCountKey: aKey value: aValue root: rootObj into: col

  | index eSize maxIndex keyIndexOffset comparisonForSort rootIndexOffset |
  comparisonForSort := self comparisonForSort.
  index := self _findCoveringIndexForKey: aKey totalOrder: false.
  index == 0
    ifTrue: [ ^ false].
  eSize := self entrySize.
  maxIndex := self _lastEntryIndex.
  keyIndexOffset := self keyIndexOffset.
  rootIndexOffset := self rootIndexOffset.
  " now scan entries until reach the end or no match "
  [ index <= maxIndex
    and: [ self _compare: comparisonForSort key: aKey equalToEntryAt: index + keyIndexOffset] ]
    whileTrue: [
      (((self at: index + keyIndexOffset) == aKey) and: [((self at: index) == aValue) and: [(self at: index + rootIndexOffset) == rootObj]]) ifTrue: [ col add: rootObj ].
      index := index + eSize ].
  ^ index >= maxIndex
%

category: 'Searching'
method: BtreePlusLeafNode
_findFirstRootForKey: aKey using: aComparison
  "Returns the first root object associated with the given key.  For leaf nodes, finds
 the appropriate entry and makes the comparison.  Follow nextLeaf if we run off end of
 recevier before finding a match. If one is not found, returns the incomplete path
 traversal object."

  | index eSize maxIndex comparisonForSort keyIndexOffset |
  comparisonForSort := self comparisonForSort.
  index := self _findCoveringIndexForKey: aKey totalOrder: false using: comparisonForSort.
  index == 0
    ifTrue: [ ^ #'_incompletePathTraversal' ].
  eSize := self entrySize.
  maxIndex := self _lastEntryIndex.
  keyIndexOffset := self keyIndexOffset.
  " now scan entries until reach the end or no match "
  [ index <= maxIndex
    and: [ self _compare: comparisonForSort key: aKey equalToEntryAt: index + keyIndexOffset ] ]
    whileTrue: [ (self _compare: aComparison key: aKey equalToEntryAt: index + keyIndexOffset)
        ifTrue: [ ^ self rootObjectAt: index ].
      index := index + eSize ].
  (index > maxIndex and: [ self nextLeaf notNil ])
    ifTrue: [
      "continue the search with the next leaf node .. if nextLeaf not nil"
      ^ self nextLeaf _findFirstRootForKey: aKey using: aComparison ].
  ^ #'_incompletePathTraversal'
%

category: 'Searching Support'
method: BtreePlusLeafNode
_lastRootObjectsNotIdenticalTo: aKey into: array
  ""

  1 to: numElements * self entrySize by: self entrySize do: [ :i |
    (self keyAt: i) == aKey
      ifFalse: [ array add: (self rootObjectAt: i) ] ].

%

category: 'Enumerating'
method: BtreePlusLeafNode
_leafKeysValuesAndRootsDo: aBlock
  "Execute the two-argument block with the key and value of each entry in the
 receiver."

  | keyIndexOffset rootIndexOffset |
  keyIndexOffset := self keyIndexOffset.
  rootIndexOffset := self rootIndexOffset.
  1 to: numElements * self entrySize by: self entrySize do: [ :i |
    aBlock
      value: (self at: i + keyIndexOffset)
      value: (self at: i)
      value: (self at: i + rootIndexOffset) ]
%

category: 'Enumerating'
method: BtreePlusLeafNode
_preOrderDo: aBlock
  aBlock value: self
%

category: 'Query Support'
method: BtreePlusLeafNode
_primAddRootObjects: aQuerySpec start: startIndex end: endIndex into: collection entrySize: entrySize
  <primitive: 1038>
  ^ super
    _addRootObjects: aQuerySpec
    start: startIndex
    end: endIndex
    into: collection
%

category: 'Sorting Support'
method: BtreePlusLeafNode
_putAscendingRootObjectsInto: array startingAt: offset

"Returns the number of elements."

| j |
j := offset.
1 to: (numElements * self entrySize) by: self entrySize do: [ :i |
  array at: j put: (self rootObjectAt: i).
  j := j + 1
].
^ numElements
%

category: 'Sorting Support'
method: BtreePlusLeafNode
_putDescendingRootObjectsInto: array startingAt: offset

"Returns the number of elements."

| j |
j := offset.
1 to: (numElements * self entrySize) by: self entrySize do: [ :i |
  array at: j put: (self rootObjectAt: i).
  j := j - 1
].
^ numElements
%

category: 'Searching Support'
method: BtreePlusLeafNode
_putFirstIndexOfFirstChildInto: anArray

"Puts the receiver and the first index of the receiver into the Array."

numElements == 0
    ifTrue: [ anArray addLast: 0]
    ifFalse: [ anArray addLast: 1 ].
anArray addLast: self
%

category: 'Searching Support'
method: BtreePlusLeafNode
_putFirstIndexOfFirstChildInto: anArray ifGreaterThanOrEqualTo: aKey using: aComparison

"If first entry is greater than or equal to aKey, Puts the receiver
 and the first index of the receiver into the Array.

 Because of NANs we need to validate the assumption of the caller
 (i.e., that all entries are greater than aKey). See bug33805."

"make sure that key is less than or equal to first entry"
(aKey == nil or: [ numElements == 0
   or: [ aComparison compareKey: aKey lessThanOrEqualTo: (self at: 1 + self keyIndexOffset) ] ])
  ifTrue: [
    numElements == 0
      ifTrue: [ anArray addLast: 0]
      ifFalse: [ anArray addLast: 1 ].
  ]
  ifFalse: [
    anArray addLast: 0.
  ].
  anArray addLast: self
%

category: 'Searching Support'
method: BtreePlusLeafNode
_putLastIndexOfLastChildInto: anArray
  "Puts the receiver and the last index of the receiver into the Array."

  anArray addLast: self _lastKeyIndex - self keyIndexOffset.
  anArray addLast: self
%

category: 'Enumerating'
method: BtreePlusLeafNode
_scanForRootObjectMapsStartingAt: startIndex end: endIndex key: aKey value: aValue valueOop: valueOop using: comparisonForCompare do: aBlock
  "Given the fact that the keys from startIndex through endIndex are all #=, we know that
   all equal keys are sorted by the oop of the value.

     If the key at endIndex is equal to aKey
       If the oop of the value at endIndex is less than the oop of aValue we can skip
         the elements of the entire leafNode.
     If the key at startIndex is equal to aKey
       If the oop of the value at startIndex is greater than the oop of aValue we can skip
         the elements of the entire leafNode.
"

  | index eSize keyIndexOffset rootIndexOffset firstKey lastKey |
  keyIndexOffset := self keyIndexOffset.
  firstKey := self at: startIndex + keyIndexOffset.
  (comparisonForCompare compareKey: aKey equalTo: firstKey)
    ifTrue: [ (self at: startIndex) asOop > valueOop ifTrue: [ ^ self ] ].
  lastKey := self at: endIndex + keyIndexOffset.
  (comparisonForCompare compareKey: aKey equalTo: lastKey)
    ifTrue: [ (self at: endIndex) asOop < valueOop ifTrue: [ ^ self ] ].
  index := startIndex.
  eSize := self entrySize.
  rootIndexOffset := self rootIndexOffset.
  [ index <= endIndex ]
    whileTrue: [
      ((self at: index) == aValue and: [ (self at: index + keyIndexOffset) == aKey ])
        ifTrue: [ aBlock value: (self at: index + rootIndexOffset) ].
      index := index + eSize ]
%

category: 'Updating'
method: BtreePlusLeafNode
_splitUsingKey: aKey value: aValue
  "Creates a new sibling node, moving the second half of the receiver's entries into the
 sibling.  Then inserts a new entry with the given key/value into either the
 receiver or sibling.  Returns the new sibling."

  | index newSibling lastKeyIndex lastKey comparisonForSort |
  newSibling := self _createSibling.
  lastKeyIndex := self _lastKeyIndex.
  lastKey := super at: lastKeyIndex.
  comparisonForSort := self comparisonForSort.
  (self
    compare: comparisonForSort
    key: aKey
    value: aValue
    lessThanOrEqualToEntryAt: lastKeyIndex
    root: nil)
    ifTrue: [ " adding to the first half "
      index := self
        binarySearchCoveringKey: aKey
        value: aValue.
      self
        _insertKey: aKey
        value: aValue
        atIndex: index ]
    ifFalse: [ " adding to the second half "
      index := newSibling
        binarySearchCoveringKey: aKey
        value: aValue.
      newSibling
        _insertKey: aKey
        value: aValue
        atIndex: index ].
  ^ newSibling
%

category: 'Updating'
method: BtreePlusLeafNode
_splitUsingKey: aKey value: aValue root: rootObject
  "Creates a new sibling node, moving the second half of the receiver's entries into the
 sibling.  Then inserts a new entry with the given key/value/rootObject into either the
 receiver or sibling.  Returns the new sibling."

  | index newSibling lastKeyIndex lastKey comparisonForSort |
  newSibling := self _createSibling.
  lastKeyIndex := self _lastKeyIndex.
  lastKey := super at: lastKeyIndex.
  comparisonForSort := self comparisonForSort.
  (self
    compare: comparisonForSort
    key: aKey
    value: aValue
    lessThanOrEqualToEntryAt: lastKeyIndex
    root: rootObject)
    ifTrue: [ " adding to the first half "
      index := self
        binarySearchCoveringKey: aKey
        value: aValue
        root: rootObject.
      self
        _insertKey: aKey
        value: aValue
        root: rootObject
        atIndex: index ]
    ifFalse: [ " adding to the second half "
      index := newSibling
        binarySearchCoveringKey: aKey
        value: aValue
        root: rootObject.
      newSibling
        _insertKey: aKey
        value: aValue
        root: rootObject
        atIndex: index ].
  ^ newSibling
%

category: 'Updating'
method: BtreePlusLeafNode
_splitUsingKey: aKey value: aValue root: rootObject selectiveAbortSet: selectiveAbortSetOrNil
  "Creates a new sibling node, moving the second half of the receiver's entries into the
 sibling.  Then inserts a new entry with the given key/value/rootObject into either the
 receiver or sibling.  Returns the new sibling."

  | index newSibling lastKeyIndex lastKey comparisonForSort |
  newSibling := self _createSibling: selectiveAbortSetOrNil.
  lastKeyIndex := self _lastKeyIndex.
  lastKey := self at: lastKeyIndex.
  comparisonForSort := self comparisonForSort.
  (self
    compare: comparisonForSort
    key: aKey
    value: aValue
    lessThanOrEqualToEntryAt: lastKeyIndex
    root: rootObject)
    ifTrue: [ " adding to the first half "
      index := self
        binarySearchCoveringKey: aKey
        value: aValue
        root: rootObject.
      self
        _insertKey: aKey
        value: aValue
        root: rootObject
        atIndex: index ]
    ifFalse: [ " adding to the second half "
      index := newSibling
        binarySearchCoveringKey: aKey
        value: aValue
        root: rootObject.
      newSibling
        _insertKey: aKey
        value: aValue
        root: rootObject
        atIndex: index ].
  ^ newSibling
%

category: 'Updating'
method: BtreePlusLeafNode
_splitUsingKey: aKey value: aValue selectiveAbortSet: selectiveAbortSetOrNil
  "Creates a new sibling node, moving the second half of the receiver's entries into the
 sibling.  Then inserts a new entry with the given key/value into either the
 receiver or sibling.  Returns the new sibling."

  | index newSibling lastKeyIndex lastKey comparisonForSort |
  newSibling := self _createSibling: selectiveAbortSetOrNil.
  lastKeyIndex := self _lastKeyIndex.
  lastKey := super at: lastKeyIndex.
  comparisonForSort := self comparisonForSort.
  (self
    compare: comparisonForSort
    key: aKey
    value: aValue
    lessThanOrEqualToEntryAt: lastKeyIndex
    root: nil)
    ifTrue: [ " adding to the first half "
      index := self
        binarySearchCoveringKey: aKey
        value: aValue.
      self
        _insertKey: aKey
        value: aValue
        atIndex: index ]
    ifFalse: [ " adding to the second half "
      index := newSibling
        binarySearchCoveringKey: aKey
        value: aValue.
      newSibling
        _insertKey: aKey
        value: aValue
        atIndex: index ].
  ^ newSibling
%

category: 'Accessing'
method: BtreePlusLeafNode
_totalElementsFrom: start toEndNode: endNode endIndex: endIndex
  "Determine the number of entries in the receiver counting from start.
   If the receiver is the endNode, then count to endIndex, otherwise count
   to the last index of the receiver."

  | end delta |
  end := self == endNode
    ifTrue: [ endIndex ]
    ifFalse: [ end := self _lastIndex ].
  delta := end - start.
  delta < 0
    ifTrue: [ delta := delta negated ].
  ^ (delta // self entrySize) + 1
%

category: 'Accessing'
method: BtreePlusLeafNode
_totalElementsReversedFrom: start toEndNode: endNode endIndex: endIndex
  "Determine the number of entries in the receiver counting backwards from start.
   If the receiver is the endNode, then count backwards to endIndex, otherwise count
   backwards to 1."

  | end delta |
  end := self == endNode
    ifTrue: [ endIndex ]
    ifFalse: [ 1 ].
  delta := start - end.
  delta < 0
    ifTrue: [ delta := delta negated ].
  ^ (delta // self entrySize) + 1
%

category: 'Updating'
method: BtreePlusLeafNode
_updateLastValue

"For leaf nodes, the last value is derived, so nothing is required."

%

category: 'Updating'
method: BtreePlusLeafNode
_updateLastValue: selectiveAbortSetOrNil

"For leaf nodes, the last value is derived, so nothing is required."

%

category: 'Updating'
method: BtreePlusLeafNode
_updateLeafNodeLinksForNewPreviousLeaf: newPreviousLeaf newNextLeaf: newNextLeaf
  " newPreviousNode is being inserted in before of receiver, update the previous/next leaf values for both nodes"

  | originalPrevious  |
  originalPrevious := self previousLeaf.
  originalPrevious ~~ newPreviousLeaf
    ifTrue: [
      newPreviousLeaf
        previousLeaf: originalPrevious;
        nextLeaf: self.
      originalPrevious ifNotNil: [  originalPrevious nextLeaf: newPreviousLeaf ].
      self
        previousLeaf: newPreviousLeaf;
        nextLeaf: newNextLeaf.
      newNextLeaf
        ifNotNil: [ newNextLeaf previousLeaf: self ] ].
%

category: 'Updating'
method: BtreePlusLeafNode
_updateLeafNodeLinksForNewPreviousLeaf: newPreviousLeaf newNextLeaf: newNextLeaf  selectiveAbortSet: selectiveAbortSetOrNil
  " newPreviousNode is being inserted in before of receiver, update the previous/next leaf values for both nodes"

  | originalPrevious  |
  originalPrevious := self previousLeaf.
  originalPrevious ~~ newPreviousLeaf
    ifTrue: [
      originalPrevious ifNotNil: [
        self _selectiveAbort: originalPrevious ifNotIn: selectiveAbortSetOrNil ].
      newPreviousLeaf ifNotNil: [
        self _selectiveAbort: newPreviousLeaf ifNotIn: selectiveAbortSetOrNil ].
      newNextLeaf  ifNotNil: [
        self _selectiveAbort: newNextLeaf ifNotIn: selectiveAbortSetOrNil ].
      newPreviousLeaf
        previousLeaf: originalPrevious;
        nextLeaf: self.
      self rootNode _addBtreePlusNodeToRcReadSet: newPreviousLeaf.
      originalPrevious ifNotNil: [
        originalPrevious nextLeaf: newPreviousLeaf.
        self rootNode _addBtreePlusNodeToRcReadSet: originalPrevious ].
      self
        previousLeaf: newPreviousLeaf;
        nextLeaf: newNextLeaf.
      self rootNode _addBtreePlusNodeToRcReadSet: self.
      newNextLeaf
        ifNotNil: [
          newNextLeaf previousLeaf: self.
          self rootNode _addBtreePlusNodeToRcReadSet: newNextLeaf ] ].
%

! Class extensions for 'BtreePlusNode'

!		Class methods for 'BtreePlusNode'

category: 'Constants'
classmethod: BtreePlusNode
entrySize
  "Returns the size of an entry."

  "in-lined on instance-side for performance"

  self subclassResponsibility: #'entrySize'
%

category: 'Instance Creation'
classmethod: BtreePlusNode
new

"Returns a new initialized instance with the correct size."

^ (super new: self entrySize * self maxNumberOfElements) numElements: 0.
%

!		Instance methods for 'BtreePlusNode'

category: 'Updating'
method: BtreePlusNode
add: anObject
  self shouldNotImplement: #add:
%

category: 'Updating'
method: BtreePlusNode
addAll: aCollection
  self shouldNotImplement: #addAll:
%

category: 'Updating'
method: BtreePlusNode
addLast: anObject
  self shouldNotImplement: #addLast:
%

category: 'Updating'
method: BtreePlusNode
at: aKey put: aValue
  self shouldNotImplement: #at:put:
%

category: 'Updating'
method: BtreePlusNode
at: aKey put: aValue root: rootObject
  "Adds the key/value/root tuple to the node.  If the node is full, performs a 'split'
 on the parent.  Returns the new sibling if a split is performed, otherwise
 returns the receiver."

  self subclassResponsibility: #'at:put:root:'
%

category: 'Rc Updating'
method: BtreePlusNode
at: aKey put: aValue root: rootObject selectiveAbortSet: selectiveAbortSetOrNil
  "Adds the key/value/root tuple to the node.  If the node is full, performs a 'split'
 on the parent.  Returns the new sibling if a split is performed, otherwise
 returns the receiver."

  self subclassResponsibility: #'at:put:root:selectiveAbortSet:'
%

category: 'Audit'
method: BtreePlusNode
auditDepListForLastElements: setOfKeys bagOfKeys: bagOfKeys for: pathTerm offset: offset using: auditor
  self rootNode isIdentityIndex
    ifTrue: [ "Identity indexes do not use dependency lists"
      ^ self ].
  1 to: setOfKeys size do: [ :n | | aKey |
    aKey := setOfKeys _at: n.
    (DependencyList for: aKey) ~~ nil
      ifTrue: [ pathTerm
          auditDepListForLastElementObject: aKey
          occurrences: (bagOfKeys occurrencesOf: aKey)
          index: (pathTerm at: offset)
          using: auditor ] ]
%

category: 'Audit'
method: BtreePlusNode
auditForPathTerm: pathTerm using: auditor do: aBlock
  "Audit the receiver's entries and each child node"

  self auditForPathTerm: pathTerm using: auditor parentNode: nil previousChild: nil nextChild: nil do: aBlock
%

category: 'Audit'
method: BtreePlusNode
auditForPathTerm: pathTerm using: auditor parentNode: parentNode previousChild: previousChild nextChild: nextChild do: aBlock
  self subclassResponsibility: #'auditForPathTerm:using:parentNode:previousChild:nextChild:do:'
%

category: 'Audit'
method: BtreePlusNode
auditKey: key value: value root: rootObject bag: bag nsc: nsc for: pathTerm offset: offset bagOfRoots: bagOfRoots enumBag: enumBag  setValBag: setValBag using: auditor
  | num bagSize |
  num := bagOfRoots occurrencesOf: rootObject.
  pathTerm isEnumeratedTerm
    ifTrue: [ (num := enumBag occurrencesOf: value) * num ].
  pathTerm isSetValuedTerm
    ifTrue: [ (num := setValBag occurrencesOf: value) ].
  bagSize := bag size.
  bagSize == num
    ifFalse: [ auditor
        btree: self
        incorrectNumberOfEntries: pathTerm
        key: key
        value: value
        bag: bag
        numExpected: num ].
  bag removeAll: bag.
  enumBag removeAll: enumBag.
  setValBag removeAll: setValBag.
  bagOfRoots removeAll: bagOfRoots.
%

category: 'Audit'
method: BtreePlusNode
auditNsc: nsc for: pathTerm offset: offset using: auditor
  "Verifies that the btree structure consistent relative to the given pathTerm."

  | indicatesIndexOnNscElements indicatesMultiValue count key value rootObject bag ivOffset bagOfKeys setOfKeys comparisonForSort previousKey previousValue sentinel enumBag previousRoot enumValue setValBag setValValue lastChildNode  bagOfRoots |
  indicatesIndexOnNscElements := pathTerm indicatesIndexOnNscElements.
  indicatesMultiValue := pathTerm indicatesMultiValue.
  count := 0.
  bag := IdentityBag new.
  enumBag := IdentityBag new.
  setValBag := IdentityBag new.
  bagOfKeys := IdentityBag new.
  bagOfRoots := IdentityBag new.
  setOfKeys := IdentitySet new.
  comparisonForSort := self comparisonForSort.
  sentinel := Object new.
  previousRoot := previousKey := sentinel.
  lastChildNode := sentinel.
  self
    auditForPathTerm: pathTerm
    using: auditor
    do: [ :childNode :k :v :r | setValValue := enumValue := false.
        lastChildNode := childNode.
        previousKey == sentinel
        ifFalse: [ (comparisonForSort compareKey: previousKey lessThanOrEqualTo: k)
            ifTrue: [ (comparisonForSort compareKey: previousKey equalTo: k)
                ifTrue: [ previousValue asOop <= v asOop
                    ifFalse: [ auditor
                        btree: childNode
                        outOfOrderKeyValuePairs: pathTerm
                        key: k
                        previous: previousKey
                        value: v
                        previous: previousValue ].
                  previousValue asOop = v asOop
                    ifTrue: [ previousRoot asOop <= r asOop
                        ifFalse: [ auditor
                            btree: childNode
                            outOfOrderKeyValueRootPairs: pathTerm
                            key: k
                            previous: previousKey
                            value: v
                            previous: previousValue
                            root: r
                            previous: previousRoot ] ] ] ]
            ifFalse: [ auditor btree: childNode outOfOrderKeys: pathTerm key: k previous: previousKey ] ].
      previousKey := k.
      previousValue := v.
      previousRoot := r.
      count := count + 1.
      indicatesIndexOnNscElements
        ifTrue: [ pathTerm isSetValuedTerm ifFalse: [v == k
            ifFalse: [ auditor
                btree: childNode
                mismatchedKeyAndValueForIndexOnNscElements: pathTerm
                key: k
                value: v ] ].
          indicatesMultiValue
            ifFalse: [
              v == r
                ifFalse: [
                  auditor
                    btree: childNode
                    mismatchedRootAndValueForIndexOnNscElements: pathTerm
                    key: k
                    value: v
                    root: r ] ] .
pathTerm isSetValuedTerm ifTrue: [ setValValue := true ]]
        ifFalse: [ pathTerm isEnumeratedTerm
            ifTrue: [ | ivOffsets res  |
              ivOffsets := pathTerm _ivOffsetsFor: v.
              res := {}.
              ivOffsets
                do: [ :off | | expected |
                 off ifNotNil: [
                  (expected := v instVarAt: off) == k
                    ifTrue: [ res add: {true} ]
                    ifFalse: [ res add: {false. expected. off} ] ] ].
              res
                detect: [:ar | ar at: 1 ]
                ifNone: [
                  res do: [:ar |
                    auditor
                            btree: childNode
                            incorrectKey: pathTerm
                            key: k
                            value: v
                            expectedKey: (ar at: 2)
                            ivOffset: (ar at: 3) ] ].
              enumValue := true ]
            ifFalse: [ | expected |
              pathTerm isSelectorTerm
                ifTrue: [ expected := v perform: pathTerm termSelector.
                  (expected _idxForSortEqualTo: k)
                    ifFalse: [ auditor
                        btree: childNode
                        incorrectKeyForEnumeratedPathTerm: pathTerm
                        key: k
                        value: v
                        expectedKey: expected
                        selector: pathTerm termSelector ] ]
                ifFalse: [
                  pathTerm isSetValuedTerm
                    ifTrue: [ setValValue := true ]
                    ifFalse: [
                      ivOffset := pathTerm _ivOffsetFor: v.
                      (expected := v instVarAt: ivOffset) == k
                        ifFalse: [ auditor
                          btree: childNode
                          incorrectKey: pathTerm
                          key: k
                          value: v
                          expectedKey: expected
                          ivOffset: ivOffset ] ] ] ] ].
      count > 1
        ifTrue: [
          (key == k and: [ value == v and: [ rootObject == r ] ])
            ifFalse: [ childNode
                auditKey: key
                value: value
                root: rootObject
                bag: bag
                nsc: nsc
                for: pathTerm
                offset: offset
                bagOfRoots: bagOfRoots
                enumBag: enumBag
                setValBag: setValBag
                using: auditor ].
          (comparisonForSort compareKey: key equalTo: k)
            ifTrue: [ bagOfKeys add: k.
              setOfKeys add: k ]
            ifFalse: [
              self
                auditDepListForLastElements: setOfKeys
                bagOfKeys: bagOfKeys
                for: pathTerm
                offset: offset
                using: auditor.
              bagOfKeys removeAll: bagOfKeys.
              setOfKeys removeAll: setOfKeys.
              bagOfKeys add: k.
              setOfKeys add: k ] ]
        ifFalse: [ bagOfKeys add: k.
          setOfKeys add: k ].
      bagOfRoots add: r.
      value := v.
      key := k.
      rootObject := r.
      bag add: v.
      enumValue ifTrue: [ enumBag add: v ].
      setValValue ifTrue: [ setValBag add: v ] ].
  (count > 0 and: [ lastChildNode ~~ sentinel ])
    ifTrue: [ lastChildNode
        auditKey: key
        value: value
        root: rootObject
        bag: bag
        nsc: nsc
        for: pathTerm
        offset: offset
        bagOfRoots: bagOfRoots
        enumBag: enumBag
        setValBag: setValBag
        using: auditor ].
  self
    auditDepListForLastElements: setOfKeys
    bagOfKeys: bagOfKeys
    for: pathTerm
    offset: offset
    using: auditor.
  ^ count
%

category: 'Searching'
method: BtreePlusNode
binarySearchCompareLessThanOrEqualTo: aKey forEntryAt: index using: aComparisonForSort
  | entry |
  entry := self at: index.
  (aComparisonForSort compareKey: aKey lessThan: entry)
    ifTrue: [ ^ true ]
    ifFalse: [ (aComparisonForSort compareKey: aKey greaterThan: entry)
        ifTrue: [ ^ false ]
        ifFalse: [ ^ true ] ]
%

category: 'Searching'
method: BtreePlusNode
binarySearchCoveringKey: aKey
  "Returns the index for the entry in which aKey would be inserted.  This
   is the first entry which has its key >= aKey. If the receiver is empty, returns
   1.  Uses a binary search."

  | lowPt midPt highPt entrySize index entryGreaterThan entryEqualTo comparisonForSort keyIndexOffset |
  entrySize := self entrySize.
  lowPt := 1.
  highPt := numElements.
  entryGreaterThan := false.
  comparisonForSort := self comparisonForSort.
  keyIndexOffset := self keyIndexOffset.
  [ lowPt <= highPt ] whileTrue: [ | objAtIndex |
      entryGreaterThan := false.
      entryEqualTo := false.
      midPt := lowPt + highPt quo: 2.
      index := (midPt - 1) * entrySize + 1 + keyIndexOffset.
      objAtIndex := self at: index.
      (comparisonForSort compareKey: aKey lessThan: objAtIndex)
        ifTrue: [ highPt := midPt - 1 ]
        ifFalse: [ (comparisonForSort compareKey: aKey greaterThan: objAtIndex)
            ifTrue: [ lowPt := midPt + 1.
              entryGreaterThan := true ]
            ifFalse: [ "If keys are equal, then secondary sort key is oop value, tertiary sort key os oop of rootObject"
              (comparisonForSort compareKey: aKey equalTo: objAtIndex)
                ifTrue: [ (self
                    compareValueOop: aKey
                    lessThanOrEqualToEntryValueOopAt: index)
                    ifTrue: [ highPt := midPt - 1 ]
                    ifFalse: [ lowPt := midPt + 1 ].
                  entryEqualTo := true ]
                ifFalse: [ lowPt := midPt + 1 ] ] ] ].
  entryGreaterThan
    ifTrue: [ ^ index + entrySize - keyIndexOffset ].
  (entryEqualTo
    and: [ "use secondary sort key (oop of value), tertiary sort key os oop of rootObject"
      self
        compareValueOop: aKey
        greaterThanEntryValueOopAt: index ])
    ifTrue: [ ^ index + entrySize - keyIndexOffset ].
  ^ index - keyIndexOffset
%

category: 'Searching'
method: BtreePlusNode
binarySearchCoveringKey: aKey totalOrder: aBoolean
  "Returns the index for the first entry in which aKey is found utilizing a
binary search.  This is the first entry whose key >= aKey."

  ^ self binarySearchCoveringKey: aKey totalOrder: aBoolean using: self comparisonForSort
%

category: 'Searching'
method: BtreePlusNode
binarySearchCoveringKey: aKey totalOrder: aBoolean using: aComparisonForSort
  "Returns the index for the first entry in which aKey is found utilizing a
binary search.  This is the first entry whose key >= aKey."

  | lowPt midPt highPt entrySize index entryGreaterThan keyIndexOffset |
  entrySize := self entrySize.
  lowPt := 1.
  highPt := numElements.
  entryGreaterThan := false.
  keyIndexOffset := self keyIndexOffset.
  [ lowPt <= highPt ] whileTrue: [ midPt := lowPt + highPt quo: 2.
      index := (midPt - 1) * entrySize + 1 + keyIndexOffset.
      entryGreaterThan := false.
      (self
        binarySearchCompareLessThanOrEqualTo: aKey
        forEntryAt: index
        using: aComparisonForSort)
        ifTrue: [ highPt := midPt - 1 ]
        ifFalse: [ lowPt := midPt + 1.
          entryGreaterThan := true ] ].
  entryGreaterThan
    ifTrue: [ ^ index + entrySize - keyIndexOffset ].
  ^ index - keyIndexOffset
%

category: 'Searching'
method: BtreePlusNode
binarySearchCoveringKey: aKey value: aValue
  "Returns the index for the entry in which aKey/aValue would be inserted.  This
 is the first entry which has its key >= aKey.  If multiple entries have the
 same key (key = aKey), then aValue is used (since entries with duplicate keys
 are inserted by the value's OOP ordering). If the receiver is empty, returns
 1.  Uses a binary search."

  | lowPt midPt highPt entrySize index entryGreaterThan entryEqualTo comparisonForSort keyIndexOffset |
  entrySize := self entrySize.
  lowPt := 1.
  highPt := numElements.
  entryGreaterThan := false.
  comparisonForSort := self comparisonForSort.
  keyIndexOffset := self keyIndexOffset.
  [ lowPt <= highPt ] whileTrue: [ | objAtIndex |
      entryGreaterThan := false.
      entryEqualTo := false.
      midPt := lowPt + highPt quo: 2.
      index := (midPt - 1) * entrySize + 1 + keyIndexOffset.
      objAtIndex := self at: index.
      (comparisonForSort compareKey: aKey lessThan: objAtIndex)
        ifTrue: [ highPt := midPt - 1 ]
        ifFalse: [ (comparisonForSort compareKey: aKey greaterThan: objAtIndex)
            ifTrue: [ lowPt := midPt + 1.
              entryGreaterThan := true ]
            ifFalse: [ "If keys are equal, then secondary sort key is oop value, tertiary sort key os oop of rootObject"
              (comparisonForSort compareKey: aKey equalTo: objAtIndex)
                ifTrue: [ (self
                    compareValueOop: aValue
                    lessThanOrEqualToEntryValueOopAt: index)
                    ifTrue: [ highPt := midPt - 1 ]
                    ifFalse: [ lowPt := midPt + 1 ].
                  entryEqualTo := true ]
                ifFalse: [ lowPt := midPt + 1 ] ] ] ].
  entryGreaterThan
    ifTrue: [ ^ index + entrySize - keyIndexOffset ].
  (entryEqualTo
    and: [ "use secondary sort key (oop of value), tertiary sort key os oop of rootObject"
      self
        compareValueOop: aValue
        greaterThanEntryValueOopAt: index ])
    ifTrue: [ ^ index + entrySize - keyIndexOffset ].
  ^ index - keyIndexOffset
%

category: 'Searching'
method: BtreePlusNode
binarySearchCoveringKey: aKey value: aValue root: rootObject
  "Returns the index for the entry in which aKey/aValue would be inserted.  This
 is the first entry which has its key >= aKey.  If multiple entries have the
 same key (key = aKey), then aValue is used (since entries with duplicate keys
 are inserted by the value's OOP ordering).  If multiple entries have the same value
 (value = aValue), then rootObject is used (since entries with duplicate values are
 inserted by the rootObject's OOP ordering). If the receiver is empty, returns
 1.  Uses a binary search."

  | lowPt midPt highPt entrySize index entryGreaterThan entryEqualTo comparisonForSort keyIndexOffset |
  entrySize := self entrySize.
  lowPt := 1.
  highPt := numElements.
  entryGreaterThan := false.
  comparisonForSort := self comparisonForSort.
  keyIndexOffset := self keyIndexOffset.
  [ lowPt <= highPt ]
    whileTrue: [
      | objAtIndex |
      entryGreaterThan := false.
      entryEqualTo := false.
      midPt := lowPt + highPt quo: 2.
      index := (midPt - 1) * entrySize + 1 + keyIndexOffset.
      objAtIndex := self at: index.
      (comparisonForSort compareKey: aKey lessThan: objAtIndex)
        ifTrue: [ highPt := midPt - 1 ]
        ifFalse: [
          (comparisonForSort compareKey: aKey greaterThan: objAtIndex)
            ifTrue: [
              lowPt := midPt + 1.
              entryGreaterThan := true ]
            ifFalse: [
              "If keys are equal, then secondary sort key is oop value, tertiary sort key os oop of rootObject"
              (comparisonForSort compareKey: aKey equalTo: objAtIndex)
                ifTrue: [
                  (self
                    compareValueOop: aValue
                    lessThanOrEqualToEntryValueOopAt: index
                    root: rootObject)
                    ifTrue: [ highPt := midPt - 1 ]
                    ifFalse: [ lowPt := midPt + 1 ].
                  entryEqualTo := true ]
                ifFalse: [ lowPt := midPt + 1 ] ] ] ].
  entryGreaterThan
    ifTrue: [ ^ index + entrySize - keyIndexOffset ].
  (entryEqualTo
    and: [
      "use secondary sort key (oop of value), tertiary sort key os oop of rootObject"
      self
        compareValueOop: aValue
        greaterThanEntryValueOopAt: index
        root: rootObject ])
    ifTrue: [ ^ index + entrySize - keyIndexOffset ].
  ^ index - keyIndexOffset
%

category: 'Searching'
method: BtreePlusNode
binarySearchForKey: aKey value: aValue root: rootObject
  "Returns the 'value' index whose key equality matches aKey and whose root matches rootObject.
   If no match is found, returns zero.  Uses a binary search."

  | lowPt midPt highPt entrySize index comparisonForSort keyIndexOffset |
  numElements == 0
    ifTrue: [ ^ 0 ].
  entrySize := self entrySize.
  lowPt := 1.
  highPt := numElements.
  comparisonForSort := self comparisonForSort.
  keyIndexOffset := self keyIndexOffset.
  [ lowPt <= highPt ] whileTrue: [ midPt := lowPt + highPt quo: 2.
      index := (midPt - 1) * entrySize + 1 + keyIndexOffset.
      (self
        compare: comparisonForSort
        key: aKey
        value: aValue
        equalToEntryAt: index
        root: rootObject)
        ifTrue: [ ^ index - keyIndexOffset ].
      (self
        compare: comparisonForSort
        key: aKey
        value: aValue
        lessThanOrEqualToEntryAt: index
        root: rootObject)
        ifTrue: [ highPt := midPt - 1 ]
        ifFalse: [ lowPt := midPt + 1 ] ].
  ^ 0
%

category: 'Accessing'
method: BtreePlusNode
collator
  "Answer the collator for the receiver"

  ^ rootNode collator
%

category: 'Comparison Operators'
method: BtreePlusNode
compareValueOop: aValue greaterThanEntryValueOopAt: keyIndex
  "Perform a > comparison between the oop of aValue and oop of the entry whose value is
   at the given index."

  self subclassResponsibility: #'compareValueOop:greaterThanEntryValueAt:'
%

category: 'Comparison Operators'
method: BtreePlusNode
compareValueOop: aValue greaterThanEntryValueOopAt: keyIndex root: aRootObjectOrNil
  "Perform a > comparison between the oop of aValue and oop of the entry whose value is
   at the given index. If the value oops are equal, compare the oop of aRootObjectOrNil and the
   oop of the root object at the given index."

  self subclassResponsibility: #'compareValueOop:greaterThanEntryValueAt:root:'
%

category: 'Comparison Operators'
method: BtreePlusNode
compareValueOop: aValue lessThanOrEqualToEntryValueOopAt: keyIndex
  "Perform a <= comparison between the oop of aValue and oop of the entry whose value is
   at the given index."

  self
    subclassResponsibility: #'compareValueOop:lessThanOrEqualToEntryValueOopAt:'
%

category: 'Comparison Operators'
method: BtreePlusNode
compareValueOop: aValue lessThanOrEqualToEntryValueOopAt: keyIndex root: aRootObjectOrNil
  "Perform a <= comparison between the oop of aValue and oop of the entry whose value is
   at the given index."

  self
    subclassResponsibility: #'compareValueOop:lessThanOrEqualToEntryValueOopAt:root:'
%

category: 'Comparison Operators'
method: BtreePlusNode
comparisonForSort
  "Answer the comparison object to be used for this index"

  ^ rootNode comparisonForSort
%

category: 'Constants'
method: BtreePlusNode
entrySize
  "Returns the size of an entry."

  "in-line of `self class entrySize` for performance"

  self subclassResponsibility: #'entrySize'
%

category: 'Accessing'
method: BtreePlusNode
indexObject

  ^ self rootNode indexObject
%

category: 'Testing'
method: BtreePlusNode
isBtreePlusNode
  ^ true
%

category: 'Testing'
method: BtreePlusNode
isLeaf

"Returns whether the B-tree node is a leaf node."

^ false
%

category: 'Accessing'
method: BtreePlusNode
keyIndexOffset
  "Answer the offset from entry index for the key. Typical order is value/key/root."

  ^ 1
%

category: 'Accessing'
method: BtreePlusNode
maxNumberOfElements
  ^ self class maxNumberOfElements
%

category: 'Constants'
method: BtreePlusNode
mergeThreshold

"Returns the threshold such that if an entry has less than this number, it must
 have elements added from its sibling or be merged with its sibling."

^ self maxNumberOfElements quo: 2.
%

category: 'Accessing'
method: BtreePlusNode
numElements

"Returns the value of the instance variable 'numElements'."

^ numElements
%

category: 'Updating'
method: BtreePlusNode
numElements: newValue

"Modify the value of the instance variable 'numElements'."

numElements := newValue
%

category: 'Constants'
method: BtreePlusNode
parentNodeClass
  "Returns the class of node to be created as the parent when a split occurs."

  ^ self subclassResponsibility: #'parentNodeClass'
%

category: 'Printing'
method: BtreePlusNode
prettyPrint

""

| aStream |
aStream := PrintStream printingOn: String new.
self printOn: aStream withIndentationLevel: 0 includingValues: false.
^ aStream contents
%

category: 'Accessing'
method: BtreePlusNode
rootIndexOffset
  "Answer the offset from entry index for the root object. Typical order is value/key/root."

  ^ 2
%

category: 'Accessing'
method: BtreePlusNode
rootNode
  "Answer the BtreePlusRoot of the receiver"

  ^ rootNode
%

category: 'Accessing'
method: BtreePlusNode
rootNode: aBtreePlusRoot
  "set the BtreePlusRoot of the receiver"

  rootNode := aBtreePlusRoot
%

category: 'Accessing'
method: BtreePlusNode
valueIndexOffset
  "Answer the offset from entry index for the value. Typical order is value/key/root."

  ^ 0
%

category: 'Query Support'
method: BtreePlusNode
_addRootObjects: aQuerySpec
start: startIndex
end: endIndex
into: collection

^aQuerySpec
    _addRootObjectsFrom: self
    entrySize: self entrySize
    start: startIndex
    end: endIndex
    into: collection
%

category: 'Testing'
method: BtreePlusNode
_basicCanCompare: aKey withClass: aClass
  "Returns true if the receiver can make comparisons with the given key, and
false otherwise.  Used for basic nodes."

  ^ aKey _idxBasicPlusCanCompareWithClass: aClass
%

category: 'Testing'
method: BtreePlusNode
_canCompare: aKey withClass: aClass
  "Returns whether the receiver can make comparisons with the given key."

  ^ self indexObject optimizingComparison
    ifTrue: [ self _canCompareOptimized: aKey withClass: aClass ]
    ifFalse: [ aKey == nil
        ifTrue: [ ^ true ].
      self _canCompareStandard: aKey withClass: aClass ]
%

category: 'Testing'
method: BtreePlusNode
_canCompareOptimized: aKey withClass: aClass
  "Returns whether the receiver can make comparisons with the given key.
If optimized compare okay, apply standard rules."

  (aKey _idxOptimizedCompareWithClass: aClass) ifFalse: [ ^ false ].
  ^ self _canCompareStandard: aKey withClass: aClass
%

category: 'Testing'
method: BtreePlusNode
_canCompareStandard: aKey withClass: aClass
  "Returns whether the receiver can make comparisons with the given key."

  (GsRangeEqualityIndex isBasicClass: aClass)
    ifTrue: [
      "preserve legacy index constraints for basic index classes"
      ^ self _basicCanCompare: aKey withClass: aClass ].
  ^ true
%

category: 'Updating'
method: BtreePlusNode
_createSibling
  "Creates a new sibling node and move the second half of the receiver's entries into the
sibling.  Returns the new sibling."

  | newSibling sz splitIndex halfNumElements |
  newSibling := self class new.
  newSibling
    objectSecurityPolicy: self objectSecurityPolicy;
    rootNode: self rootNode.
  sz := numElements * self entrySize.
  halfNumElements := numElements quo: 2.
  splitIndex := halfNumElements * self entrySize + 1.	" splitIndex is where to split the receiver "
  newSibling
    _insertAt: 1
    from: self
    fromStart: splitIndex
    fromEnd: sz
    numToMoveDown: 0.	" copy the last half of entries into the new sibling "
  self _deleteNoShrinkFrom: splitIndex to: sz.	" nil out last half of receiver "
  newSibling numElements: numElements - halfNumElements.	" update the element counts in the receiver..."
  numElements := halfNumElements.	"... and the sibling "
  ^ newSibling
%

category: 'Updating'
method: BtreePlusNode
_createSibling: selectiveAbortSetOrNil
  "Creates a new sibling node and move the second half half of the receiver's entries into the
sibling.  Returns the new sibling."

  ^ self _createSibling
%

category: 'Searching'
method: BtreePlusNode
_findAllValuesForIdenticalKey: aKey into: aCollection
  "Finds all the values for the given identical key, placing them in the
 collection.  Return whether the last key was equal or not (so the caller
 knows it must check the next leaf node)."

  ^ self
    _findAllValuesForIdenticalKey: aKey
    into: aCollection
    using: self comparisonForSort
%

category: 'Searching'
method: BtreePlusNode
_findCoveringIndexForKey: aKey totalOrder: bool1
  "Returns the index for the first entry in which aKey is found.  This is the
first entry whose key >= aKey.  If the receiver's last key is greater than
aKey, or if the receiver is empty, returns 0.  Uses a binary search."

  ^ self _findCoveringIndexForKey: aKey totalOrder: bool1 using: self comparisonForSort
%

category: 'Searching'
method: BtreePlusNode
_findCoveringIndexForKey: aKey totalOrder: bool1 using: aComparison
  "Returns the index for the first entry in which aKey is found.  This is the
first entry whose key >= aKey.  If the receiver's last key is greater than
aKey, or if the receiver is empty, returns 0.  Uses a binary search."

  | index |
  numElements == 0
    ifTrue: [ ^ 0 ].
  index := self binarySearchCoveringKey: aKey totalOrder: bool1  using: aComparison.	" check if not found "
  ^ index > self _lastKeyIndex
    ifTrue: [ 0 ]
    ifFalse: [ index ]
%

category: 'Accessing'
method: BtreePlusNode
_lastEntryIndex
  "Returns the index of the last entry in the node, zero if the node is empty."

  numElements == 0
    ifTrue: [ ^ 0 ].
  ^ (numElements - 1) * self entrySize + 1
%

category: 'Accessing'
method: BtreePlusNode
_lastIndex

"Returns the index of the last used slot in the node."

^ numElements * self entrySize
%

category: 'Accessing'
method: BtreePlusNode
_lastKeyIndex
  "Returns the index of the key of the last entry, or zero if the node is empty."

  ^ numElements == 0
    ifTrue: [ 0 ]
    ifFalse: [ self _lastEntryIndex + self keyIndexOffset ]
%

category: 'Accessing'
method: BtreePlusNode
_lastRootIndex
  "Returns the index of the root object of the last entry, or zero if the node is empty."

  ^ numElements == 0
    ifTrue: [ 0 ]
    ifFalse: [ self _lastEntryIndex + self rootIndexOffset ]
%

category: 'Audit'
method: BtreePlusNode
_primEncodingFor: aKey

"Get the encryption for the given value and return it
 in a 2 slot Array."

<primitive: 871>
self _primitiveFailed: #'_encodingFor:' args: { aKey }
%

category: 'Rc Updating'
method: BtreePlusNode
_selectiveAbort: aNode ifNotIn: selectiveAbortSetOrNil

  (selectiveAbortSetOrNil ~~ nil
    and: [ (selectiveAbortSetOrNil includes: aNode) not ])
    ifTrue: [
      selectiveAbortSetOrNil add: aNode.
      aNode _selectiveAbort ].
%

! Class extensions for 'BtreePlusNodeAuditor'

!		Class methods for 'BtreePlusNodeAuditor'

category: 'Audit'
classmethod: BtreePlusNodeAuditor
checkDebug: auditResultString 
  (SessionTemps current at: #GsDebugIndexing otherwise: false) ifTrue:[
    "Signal an error so the point at which problem found is on the stack."
    Error signal: (auditResultString ifNil:[ 'unknown error' ]).
  ].
%

!		Instance methods for 'BtreePlusNodeAuditor'

category: 'pathterm audit failures'
method: BtreePlusNodeAuditor
auditInfoFor: pathTerm info: array
  | obj indexObj depList pathTermName |
  pathTerm size == 0
    ifTrue: [ ^ self ].
  obj := array at: 1.
  indexObj := array at: 2.
  depList := array at: 3.
  auditResultString add: 'object'.
  (obj isKindOf: CharacterCollection)
    ifTrue: [ auditResultString
        add: Character space;
        add: obj ].
  auditResultString
    add: ' [';
    add: obj asOop asString;
    add: '] of class ';
    add: obj class asString.
  indexObj ~~ nil
    ifTrue: [ auditResultString
        add: ', ';
        add: (indexObj isRangeEqualityIndex
                ifTrue: [ 'equality' ]
                ifFalse: [ 'identity' ]);
        add: ' index <';
        add: indexObj pathComponentsString;
        add: '> [';
        add: indexObj asOop asString;
        add: ']' ].
  auditResultString
    add: ', path term <';
    add: pathTerm name.
  (pathTermName := pathTerm name) == #'*'
    ifTrue: [ auditResultString add: ' offset: ' , pathTerm offset asString ].
  auditResultString
    add: '> [';
    add: pathTerm asOop asString;
    add: ']'.
  depList ~~ nil
    ifTrue: [ auditResultString
        add: ', depList [';
        add: depList asOop asString;
        add: ']' ].
  auditResultString
    add:
      '
    -- ' .
  self checkDebug
%

category: 'accessing'
method: BtreePlusNodeAuditor
auditResultString

   ^auditResultString
%

category: 'accessing'
method: BtreePlusNodeAuditor
auditResultString: anObject

   auditResultString := anObject
%

category: 'btree audit failures'
method: BtreePlusNodeAuditor
btree: btree incorrectCountForKeyValueRootPairs: pathTerm key: k value: v  root: r found: foundCount expected: expectedCount
  pathTerm auditInfo: {k.
      nil.
      nil} using: self.
  auditResultString
    add: 'Btree [';
    add: btree asOop asString;
    add: '] has incorrect count for key/value/root tuple; key ';
    add: k printString printString;
    add: ' [';
    add: k asOop asString;
    add: '] value ';
    add: v printString printString;
    add: ' [';
    add: v asOop asString;
    add: '] root ';
    add: r printString printString;
    add: ' [';
    add: r asOop asString;
    add: ']. Found ';
    add: foundCount printString ;
    add: ' occurences and expected ';
    add: expectedCount printString;
    add: Character lf .
  self checkDebug
%

category: 'btree audit failures'
method: BtreePlusNodeAuditor
btree: btree incorrectKey: pathTerm key: k value: v expectedKey: expectedKey ivOffset: ivOffset
  pathTerm auditInfo: {k.
      nil.
      nil} using: self.
  auditResultString
    add: 'Btree [';
    add: btree asOop asString;
    add: '] has entry for [';
    add: v asOop asString;
    add: '] of class ';
    add: v class asString;
    add: ' associated with incorrect key [';
    add: k asOop asString;
    add: '] expected value is ( ';
    add: expectedKey asOop asString;
    add: '). The key should be identical to the instance variable at offset ( ';
    add: ivOffset asString;
    add: ') in [';
    add: v asOop asString;
    add: ']';
    add: Character lf .
  self checkDebug
%

category: 'btree audit failures'
method: BtreePlusNodeAuditor
btree: btree incorrectKeyForEnumeratedPathTerm: pathTerm key: k value: v expectedKey: expectedKey selector: selector
  pathTerm auditInfo: {k.
      nil.
      nil} using: self.
  auditResultString
    add: 'Btree [';
    add: btree asOop asString;
    add: '] has entry for [';
    add: v asOop asString;
    add: '] of class ';
    add: v class asString;
    add: ' associated with incorrect key [';
    add: k asOop asString;
    add: '] expected value is ( ';
    add: expectedKey asOop asString;
    add: '). The key should sort equal to the value returned by the selector #';
    add: selector asString;
    add: ' when sent to [';
    add: v asOop asString;
    add: ']';
    add: Character lf.
  self checkDebug
%

category: 'btree audit failures'
method: BtreePlusNodeAuditor
btree: btree incorrectNumberOfEntries: pathTerm key: k value: v bag: bag numExpected: numExpected
  pathTerm auditInfo: {k.
      nil.
      nil} using: self.
  auditResultString
    add: 'Btree [';
    add: btree asOop asString;
    add: '] has incorrect number of entries (';
    add: bag size asString;
    add: ') for [';
    add: v asOop asString;
    add: '] of class ';
    add: v class asString;
    add: ' (should be ';
    add: numExpected asString;
    add: ')';
    add: Character lf .
  self checkDebug
%

category: 'btree audit failures'
method: BtreePlusNodeAuditor
btree: btree mismatchedKeyAndValueForIndexOnNscElements: pathTerm key: k value: v
  pathTerm auditInfo: {k.
      nil.
      nil} using: self.
  auditResultString
    add: 'Btree [';
    add: btree asOop asString;
    add: '] has entry for [';
    add: v asOop asString;
    add: '] of class ';
    add: v class asString;
    add: ' associated with incorrect key [';
    add: k asOop asString;
    add: '] should be ( ';
    add: v asOop asString;
    add: '). Key and value should be identical.';
    add: Character lf .
  self checkDebug
%

category: 'btree audit failures'
method: BtreePlusNodeAuditor
btree: btree mismatchedRootAndValueForIndexOnNscElements: pathTerm key: k value: v root: r
  pathTerm auditInfo: {k.
      nil.
      nil} using: self.
  auditResultString
    add: 'Btree [';
    add: btree asOop asString;
    add: '] has entry for [';
    add: v asOop asString;
    add: '] of class ';
    add: v class asString;
    add: ' associated with incorrect root object [';
    add: r asOop asString;
    add: '] should be ( ';
    add: v asOop asString;
    add: ') ';
    add: Character lf .
  self checkDebug
%

category: 'btree audit failures'
method: BtreePlusNodeAuditor
btree: btree outOfOrderKeys: pathTerm key: k previous: previousKey
  pathTerm auditInfo: {k.
      nil.
      nil} using: self.
  auditResultString
    add: 'Btree [';
    add: btree asOop asString;
    add: '] has key ';
    add: k printString printString;
    add: ' out of order [';
    add: k asOop asString;
    add: '] that sorts greater than previous key';
    add: previousKey printString printString;
    add: ' [';
    add: previousKey asOop asString;
    add: ']';
    add: Character lf .
  self checkDebug
%

category: 'btree audit failures'
method: BtreePlusNodeAuditor
btree: btree outOfOrderKeyValuePairs: pathTerm key: k previous: previousKey value: v previous: previousValue
  pathTerm auditInfo: {k.
      nil.
      nil} using: self.
  auditResultString
    add: 'Btree [';
    add: btree asOop asString;
    add: '] has out of oop order key/value pairs where the key ';
    add: k printString printString;
    add: ' [';
    add: k asOop asString;
    add: '] is equal to previous key ';
    add: previousKey printString printString;
    add: ' [';
    add: previousKey asOop asString;
    add: '] but the oop of the value ';
    add: v printString printString;
    add: ' [';
    add: v asOop asString;
    add: '] is less than the oop of the previous value ';
    add: previousValue printString printString;
    add: ' [';
    add: previousValue asOop asString;
    add: ']';
    add: Character lf .
  self checkDebug
%

category: 'btree audit failures'
method: BtreePlusNodeAuditor
btree: btree outOfOrderKeyValueRootPairs: pathTerm key: k previous: previousKey value: v previous: previousValue root: r previous: previousRoot
  pathTerm auditInfo: {k.
      nil.
      nil} using: self.
  auditResultString
    add: 'Btree [';
    add: btree asOop asString;
    add: '] has out of oop order key/value/root where the key ';
    add: k printString printString;
    add: ' [';
    add: k asOop asString;
    add: '] is equal to previous key ';
    add: previousKey printString printString;
    add: ' [';
    add: previousKey asOop asString;
    add: '] and oop of the value ';
    add: v printString printString;
    add: ' [';
    add: v asOop asString;
    add: '] is equal to the oop of the previous value ';
    add: previousValue printString printString;
    add: ' [';
    add: previousValue asOop asString;
    add: '] but the oop of the root ';
    add: r printString printString;
    add: ' [';
    add: r asOop asString;
    add: '] is less than the oop of the previous root ';
    add: previousRoot printString printString;
    add: ' [';
    add: previousRoot asOop asString;
    add: ']';
    add: Character lf .
  self checkDebug
%

category: 'btree audit failures'
method: BtreePlusNodeAuditor
btree: btree parentNode: parentNode nextLeafMismatch: pathTerm nextLeaf: nextLeaf parentNextNode: nextNode
  auditResultString
    add: 'Btree [';
    add: btree asOop asString;
    add: '] has a next leaf node [';
    add: nextLeaf asOop asString;
    add: '] of class ';
    add: nextLeaf class asString;
    add: ' that does not match the next leaf node [';
    add: nextNode asOop asString;
    add: '] that is expected by the parent node [';
    add: parentNode asOop asString;
    add: ']';
    add: Character lf .
  self checkDebug
%

category: 'btree audit failures'
method: BtreePlusNodeAuditor
btree: btree parentNode: parentNode previousLeafMismatch: pathTerm previousLeaf: previousLeaf parentPreviousNode: previousNode
  auditResultString
    add: 'Btree [';
    add: btree asOop asString;
    add: '] has a previous leaf node [';
    add: previousLeaf asOop asString;
    add: '] of class ';
    add: previousLeaf class asString;
    add: ' that does not match the previous leaf node [';
    add: previousNode asOop asString;
    add: '] that is expected by parent node [';
    add: parentNode asOop asString;
    add: ']';
    add: Character lf .
  self checkDebug
%

category: 'btree audit failures'
method: BtreePlusNodeAuditor
btreeInteriorNode: btree childConsistencyError: pathTerm key: k lastChildKey: lastChildKey childNode: childNode index: index
  pathTerm auditInfo: {k.
      nil.
      nil} using: self.
  auditResultString
    add: 'Btree interior node [';
    add: btree asOop asString;
    add: '] at index: ';
    add: index asString;
    add: ' has key ';
    add: k printString printString;
    add: ' [';
    add: k asOop asString;
    add: '] that does not match the last key ';
    add: lastChildKey printString printString;
    add: ' [';
    add: lastChildKey asOop asString;
    add: ' ] of the child node [';
    add: childNode asOop asString;
    add: ']';
    add: Character lf .
  self checkDebug
%

category: 'btree audit failures'
method: BtreePlusNodeAuditor
btreeInteriorNode: btree childConsistencyError: pathTerm key: k root: r lastChildRoot: lastChildRoot childNode: childNode index: index
  pathTerm auditInfo: {k.
      nil.
      nil} using: self.
  auditResultString
    add: 'Btree interior node [';
    add: btree asOop asString;
    add: '] at index: ';
    add: index asString;
    add: ' has root ';
    add: r printString printString;
    add: ' [';
    add: r asOop asString;
    add: '] that does not match the last root ';
    add: lastChildRoot printString printString;
    add: ' [';
    add: lastChildRoot asOop asString;
    add: ' ] of the child node [';
    add: childNode asOop asString;
    add: ']';
    add: Character lf .
  self checkDebug
%

category: 'btree audit failures'
method: BtreePlusNodeAuditor
btreeInteriorNode: btree childConsistencyError: pathTerm lastRoot: lastRoot lastChildRoot: lastChildRoot childNode: childNode
  auditResultString
    add: 'Btree interior node [';
    add: btree asOop asString;
    add: '] has lastRoot ';
    add: lastRoot printString printString;
    add: ' [';
    add: lastRoot asOop asString;
    add: '] that does not match the last child root ';
    add: lastChildRoot printString printString;
    add: ' [';
    add: lastChildRoot asOop asString;
    add: ' ] of the child node [';
    add: childNode asOop asString;
    add: ']';
    add: Character lf .
  self checkDebug
%

category: 'btree audit failures'
method: BtreePlusNodeAuditor
btreeInteriorNode: btree childConsistencyError: pathTerm lastValue: lastValue lastChildValue: lastChildValue childNode: childNode
  auditResultString
    add: 'Btree interior node [';
    add: btree asOop asString;
    add: ']  has lastValue ';
    add: lastValue printString printString;
    add: ' [';
    add: lastValue asOop asString;
    add: '] that does not match the last child value ';
    add: lastChildValue printString printString;
    add: ' [';
    add: lastChildValue asOop asString;
    add: '] of the child node [';
    add: childNode asOop asString;
    add: ']';
    add: Character lf .
  self checkDebug
%

category: 'btree audit failures'
method: BtreePlusNodeAuditor
btreeInteriorNode: btree keyOrderError: pathTerm key: k previousKey: previousKey index: index
  pathTerm
    auditInfo:
      {k.
      nil.
      nil}
    using: self.
  auditResultString
    add: 'Btree interior node [';
    add: btree asOop asString;
    add: '] at index: ';
    add: index asString;
    add: ' has key ';
    add: k printString printString;
    add: ' out of order [';
    add: k asOop asString;
    add: '] that sorts greater than previous key';
    add: previousKey printString printString;
    add: ' [';
    add: previousKey asOop asString;
    add: ']';
    add: Character lf .
  self checkDebug
%

category: 'btree audit failures'
method: BtreePlusNodeAuditor
btreeInteriorNodeKeyOrderError: pathTerm key: k previousKey: previousKey index: index
  pathTerm
    auditInfo:
      {k.
      nil.
      nil}
    using: self.
  auditResultString
    add: 'Btree interior node [';
    add: self asOop asString;
    add: '] at index: ';
    add: index asString;
    add: ' has key ';
    add: k printString printString;
    add: ' out of order [';
    add: k asOop asString;
    add: '] that sorts greater than previous key';
    add: previousKey printString printString;
    add: ' [';
    add: previousKey asOop asString;
    add: ']';
    add: Character lf .
  self checkDebug
%

category: 'Audit'
method: BtreePlusNodeAuditor
checkDebug 
  self class checkDebug: auditResultString
%

category: 'pathterm audit failures'
method: BtreePlusNodeAuditor
dependencyListHasIncorrectIvOffset: pathTerm object: obj indexObj: indexObj depList: depList ivOffset: ivOffset expectedIvOffset: expectedIvOffset
  pathTerm auditInfo: {obj.
      indexObj.
      depList} using: self.
  auditResultString
    add: 'DependencyList has incorrect iv offset ';
    add: ivOffset asString;
    add: ' instead of ';
    add: expectedIvOffset asString;
    add: Character lf .
  self checkDebug
%

category: 'pathterm audit failures'
method: BtreePlusNodeAuditor
dependencyListHasIncorrectRefCount: pathTerm object: obj indexObj: indexObj depList: depList referenceCount: referenceCount numOccurrences: num
  pathTerm auditInfo: {obj.
      indexObj.
      depList} using: self.
  auditResultString
    add: ' DependencyList has incorrect ref count ';
    add: referenceCount asString;
    add: ' for occurrences ';
    add: num asString;
    add: Character lf .
  self checkDebug
%

category: 'pathterm audit failures'
method: BtreePlusNodeAuditor
dependencyListHasNoEntryForPathTerm: pathTerm object: obj indexObj: indexObj depList: depList
  pathTerm auditInfo: {obj.
      indexObj.
      depList} using: self.
  auditResultString
    add: 'DependencyList has no entry for path term';
    add: Character lf .
  self checkDebug
%

category: 'pathterm audit failures'
method: BtreePlusNodeAuditor
dependencyListUnexpectedLastElementLocation: pathTerm object: obj indexObj: indexObj depList: depList ivOffset: ivOffset
  pathTerm auditInfo: {obj.
      indexObj.
      depList} using: self.
  auditResultString
    add: ' DependencyList on last element in unexepected location ';
    add: ivOffset asString;
    add: Character lf .
  self checkDebug
%

category: 'pathterm audit failures'
method: BtreePlusNodeAuditor
pathTermIncorrectNilOnPathCount: pathTerm root: root got: actual  expected: expected
  auditResultString
    add: Character lf;
    add: ' -- Incorrect nil on path count for pathTerm [';
    add: pathTerm asOop asString;
    add: '] expected ';
    add: expected asString;
    add: ' got ';
    add: actual asString;
    add: ' for root object [';
    add: root asOop asString;
    add: '].';
    add: Character lf .
  self checkDebug
%

category: 'pathterm audit failures'
method: BtreePlusNodeAuditor
pathTermIncorrectNumberOfBtreeEntries: pathTerm index: i offset: offset
  auditResultString
    add: Character lf;
    add: ' -- The number of entries in Btree [';
    add: (pathTerm at: i) btreeRoot asOop asString;
    add: '] for pathTerm [';
    add: pathTerm asOop asString;
    add: '] offset ';
    add: offset asString;
    add: ' does not match the number of entries in the base collection (extra elements in either the base collection or btree).';
    add: Character lf .
  self checkDebug
%

category: 'pathterm audit failures'
method: BtreePlusNodeAuditor
pathTermInvalidIvOffset: pathTerm ivOffset: ivOffset object: obj
  auditResultString
    add: Character lf;
    add: ' -- Invalid ivOffset for pathTerm [';
    add: pathTerm asOop asString;
    add: ' an instance variable name [';
    add: pathTerm name asString;
    add: '] at ivOffset ';
    add: ivOffset asString;
    add: ' in the object [';
    add: obj asOop asString;
    add: '] does not exist.';
    add: Character lf .
  self checkDebug
%

category: 'pathterm audit failures'
method: BtreePlusNodeAuditor
pathTermObjectHasNoDependencyBitSet: pathTerm object: obj indexObj: indexObj depList: depList
  pathTerm auditInfo: {obj.
      indexObj.
      depList} using: self.
  auditResultString
    add: ' Object has DependencyList but no dependency bit is set';
    add: Character lf .
  self checkDebug
%

category: 'pathterm audit failures'
method: BtreePlusNodeAuditor
pathTermObjectHasNoDependencyList: pathTerm object: obj indexObj: indexObj depList: depList
  pathTerm auditInfo: {obj.
      indexObj.
      depList} using: self.
  auditResultString
    add: ' Object has no dependency list';
    add: Character lf .
  self checkDebug
%

category: 'pathterm audit failures'
method: BtreePlusNodeAuditor
setValuedPathTermExtraNilOnPathCount: pathTerm root: root excessCount: excessNilOnPathCount   auditResultString
    add: Character lf;
    add: ' -- Nil on path count too high for pathTerm [';
    add: pathTerm asOop asString;
    add: '] excess ';
    add: excessNilOnPathCount asString;
    add: ' for root object [';
    add: root asOop asString;
    add: '].';
    add: Character lf .
  self checkDebug
%

! Class extensions for 'BtreePlusRangeComparisonQuerySpec'

!		Class methods for 'BtreePlusRangeComparisonQuerySpec'

category: 'Instance Creation'
classmethod: BtreePlusRangeComparisonQuerySpec
key: aKey selector: aSelector and: aKey2 selector: aSelector2

| new |
new := self new key: aKey selector: aSelector.
new key2: aKey2 selector2: aSelector2.
^new
%

!		Instance methods for 'BtreePlusRangeComparisonQuerySpec'

category: 'Comparing'
method: BtreePlusRangeComparisonQuerySpec
compare: entry using: sel1 and: sel2
  ^ (entry perform: sel1 with: key) and: [ entry perform: sel2 with: key2 ]
%

category: 'Comparing'
method: BtreePlusRangeComparisonQuerySpec
compareKey: entry
  ^ (entry perform: selector with: key)
    and: [ entry perform: selector2 with: key2 ]
%

category: 'Updating'
method: BtreePlusRangeComparisonQuerySpec
key2: aKey2 selector2: aSelector2
  key2 := aKey2.
  self optimizingComparison
    ifTrue: [ selector2 := aSelector2 ]
    ifFalse: [ opCode2 := self operationSelectors indexOf: aSelector2.
      selector2 := self performSelector: opCode2 ]
%

category: 'Updating'
method: BtreePlusRangeComparisonQuerySpec
_addRootObjectsFrom: aLeafNode entrySize: entrySize start: startIndex end: endIndex into: collection
   (self optimizingComparison and: [ self canUseOptimizedComparison ])
    ifTrue: [ startIndex to: endIndex by: entrySize do: [ :i | collection add: (aLeafNode rootObjectAt: i) ] ]
    ifFalse: [ startIndex to: endIndex by: entrySize do: [ :i | | aKey |
        aKey := aLeafNode keyAt: i.
        (self compare: aKey using: selector and: selector2)
          ifTrue: [ collection add: (aLeafNode rootObjectAt: i) ] ] ]
%

! Class extensions for 'BtreePlusReadStream'

!		Class methods for 'BtreePlusReadStream'

category: 'Instance Creation'
classmethod: BtreePlusReadStream
on: aBtreeNode

"Create a stream that can access the entire contents of the B-tree whose
 root node is aBtreeNode."

| arr1 arr2 newStream |
arr1 := { } .
arr2 := { } .

aBtreeNode _putFirstIndexOfFirstChildInto: arr1.
aBtreeNode _putLastIndexOfLastChildInto: arr2.

newStream := self new.
newStream currentIndex: (arr1 at: 1).
newStream currentNode: (arr1 at: 2).
newStream endIndex: (arr2 at: 1).
newStream endNode: (arr2 at: 2).
^ newStream
%

!		Instance methods for 'BtreePlusReadStream'

category: 'Testing'
method: BtreePlusReadStream
atEnd
  "Returns true if the receiver is positioned at the end of the stream, and
 false otherwise."

  ^ self _atEnd
%

category: 'Accessing'
method: BtreePlusReadStream
currentIndex

"Returns the value of the instance variable 'currentIndex'."

^currentIndex
%

category: 'Updating'
method: BtreePlusReadStream
currentIndex: newValue

"Modify the value of the instance variable 'currentIndex'."

currentIndex := newValue
%

category: 'Accessing'
method: BtreePlusReadStream
currentNode

"Returns the value of the instance variable 'currentNode'."

^currentNode
%

category: 'Updating'
method: BtreePlusReadStream
currentNode: newValue
  "Modify the value of the instance variable 'currentNode'."

  currentNode := newValue.
  currentLastValIndex := currentNode _lastEntryIndex.
  currentEntrySize := currentNode entrySize.
%

category: 'Accessing'
method: BtreePlusReadStream
currentStack: array1

"Set the currentIndex and currentNode from array1"

currentIndex := array1 at: 1.
currentIndex ~~ 0
  ifTrue: [ self currentNode: ( array1 at: 2) ]
%

category: 'Accessing'
method: BtreePlusReadStream
endIndex

"Returns the value of the instance variable 'endIndex'."

^endIndex
%

category: 'Updating'
method: BtreePlusReadStream
endIndex: newValue

"Modify the value of the instance variable 'endIndex'."

endIndex := newValue
%

category: 'Accessing'
method: BtreePlusReadStream
endNode

"Returns the value of the instance variable 'endNode'."

^endNode
%

category: 'Updating'
method: BtreePlusReadStream
endNode: newValue

"Modify the value of the instance variable 'endNode'."

endNode := newValue
%

category: 'Accessing'
method: BtreePlusReadStream
next
  "Returns the next root object on a stream of B-tree values and root objects.  Updates the current
 stack for a subsequent 'next'."

  | root |
  currentIndex == 0
    ifTrue: [ ^ self _errorEndOfStream ].	" get the root value within the leaf "
  root := currentNode rootObjectAt: currentIndex.	" if this is the end of the stream, sets the top currentIndex to zero and returns "
  (currentNode == endNode and: [ endIndex == currentIndex ])
    ifTrue: [ currentIndex := 0.
      ^ root ].	" see if currentIndex refers to last entry in this leaf "
  currentIndex == currentLastValIndex
    ifTrue: [ self _nextLeaf ]
    ifFalse: [ currentIndex := currentIndex + currentEntrySize ].
  ^ root
%

category: 'Adding'
method: BtreePlusReadStream
nextPut: anObject

"Disallowed.  You cannot write to a BtreeReadStream."

self shouldNotImplement: #nextPut:
%

category: 'Accessing'
method: BtreePlusReadStream
nextRoot
  "Returns the next root object on a stream of B-tree values and root objects.  Update the current
 stack for a subsequent 'next'."

  currentIndex == 0
    ifTrue: [ ^ self _errorEndOfStream ].
  ^ self _btreeNextRootObject
%

category: 'Accessing'
method: BtreePlusReadStream
size

"Returns the number of elements contained in the receiver (that is, how many
successful 'next' operations can be performed)."

| total theNode theIndex lastNode |
self atEnd ifTrue: [
  ^ 0
  ].
total := 0.
theNode := currentNode.
theIndex := currentIndex.
lastNode := false.
[ lastNode ] whileFalse: [
  lastNode := theNode == endNode.
  total := total + (theNode
    _totalElementsFrom: theIndex
    toEndNode: endNode
    endIndex: endIndex).
  theNode := theNode nextLeaf ].
^ total
%

category: 'Testing'
method: BtreePlusReadStream
_atEnd
  "Returns true if the receiver is positioned at the end of the stream, and
 false otherwise."

  ^ currentIndex == 0
%

category: 'Testing'
method: BtreePlusReadStream
_btreeAtEnd

""

^ currentIndex == 0
%

category: 'Accessing'
method: BtreePlusReadStream
_btreeNext

"Returns the next value on a stream of B-tree values and root objects.  Updates the current
 stack for a subsequent 'next'."

^ self _btreeNextValue
%

category: 'Accessing'
method: BtreePlusReadStream
_btreeNextNoValue

"Returns the next value on a stream of B-tree values and root objects.  Updates the current
 stack for a subsequent 'next'."

" get the index into the leaf node and see if it has reached the end "
currentIndex == 0
    ifTrue: [ ^ self _errorEndOfStream ].

" if this is the end of the stream, sets the top index to zero and returns "
( currentNode == endNode and: [ endIndex == currentIndex ] )
    ifTrue: [
        currentIndex := 0.
        ^ self
    ].

" see if index refers to last entry in this leaf "
currentIndex == currentLastValIndex
    ifTrue: [
        " must look down the stack for the next leaf node "
        self _nextLeaf
    ]
    ifFalse: [ currentIndex := (currentIndex + currentEntrySize) ].
%

category: 'Accessing'
method: BtreePlusReadStream
_btreeNextRootObject
  "Returns the next root object on a stream of B-tree values and root objects.  Updates the current
 stack for a subsequent 'next'."

  | root |
  " get the root value within the leaf "
  root := currentNode rootObjectAt: currentIndex.
  " if this is the end of the stream, sets the top currentIndex to zero and returns "
  (currentNode == endNode and: [ endIndex == currentIndex ])
    ifTrue: [ currentIndex := 0.
      ^ root ].
  " see if currentIndex refers to last entry in this leaf "
  currentIndex == currentLastValIndex
    ifTrue: [ self _nextLeaf ]
    ifFalse: [ currentIndex := currentIndex + currentEntrySize ].
  ^ root
%

category: 'Accessing'
method: BtreePlusReadStream
_btreeNextValue

"Returns the next value on a stream of B-tree values and root objects.  Updates the current
 stack for a subsequent 'next'."

| val    |
" get the index into the leaf node and see if it has reached the end "
currentIndex == 0
    ifTrue: [ ^ self _errorEndOfStream ].

" get the leaf and the value within the leaf "
val := currentNode at: currentIndex.

" if this is the end of the stream, sets the top index to zero and returns "
( currentNode == endNode and: [ endIndex == currentIndex ] )
    ifTrue: [
        currentIndex := 0.
        ^ val
    ].

" see if index refers to last entry in this leaf "
currentIndex == currentLastValIndex
    ifTrue: [
        " must look down the stack for the next leaf node "
        self _nextLeaf
    ]
    ifFalse: [ currentIndex := (currentIndex + currentEntrySize) ].

^ val
%

category: 'Error Handling'
method: BtreePlusReadStream
_errorEndOfStream

"Raises an error due to an attempt to read beyond the end of the stream."

^ self _error: #rtErrBtreeReadStreamEndOfStream .
%

category: 'Query Support'
method: BtreePlusReadStream
_hasSameEndAs: otherStream

"Returns true if the receiver has the same end index and end node as the
 otherStream."

^ endIndex == otherStream endIndex and: [
   endNode == otherStream endNode ]
%

category: 'Accessing'
method: BtreePlusReadStream
_nextLeaf
  "Get the next leaf node and make it the current node."

  self currentNode: currentNode nextLeaf.
  currentNode ifNil: [ ^ self _errorEndOfStream ].
  currentIndex := 1
%

category: 'Private'
method: BtreePlusReadStream
_peekKey
  "Returns the key of the current entry in the stream."

  currentIndex == 0
    ifTrue: [ ^ self _errorEndOfStream ].
  ^ currentNode keyAt: currentIndex
%

category: 'Private'
method: BtreePlusReadStream
_peekRoot
  "Returns the root of the current entry in the stream."


  currentIndex == 0
    ifTrue: [ ^ self _errorEndOfStream ].
  ^ currentNode rootObjectAt: currentIndex
%

category: 'Private'
method: BtreePlusReadStream
_peekValue
  "Returns the value of the current entry in the stream."

  currentIndex == 0
    ifTrue: [ ^ self _errorEndOfStream ].
  ^ currentNode at: currentIndex
%

category: 'Query Support'
method: BtreePlusReadStream
_positionToEnd

"Sets the current stack to the end index and end node.  This
 has the effect of advancing the stream to the last object."

currentIndex := endIndex.
self currentNode: endNode
%

! Class extensions for 'BtreePlusRoot'

!		Instance methods for 'BtreePlusRoot'

category: 'Audit'
method: BtreePlusRoot
auditNsc: nsc for: pathTerm offset: offset on: aString
  "Verifies that the btree structure consistent relative to the given pathTerm."

  | auditor |
  auditor := BtreePlusNodeAuditor new auditResultString: aString; yourself.
  ^self btreeRootNode auditNsc: nsc for: pathTerm offset: offset using: auditor
%

category: 'Accessing'
method: BtreePlusRoot
btreeAt: aKey put: aValue root: rootObject
  "Insert the key/value/rootObject tuple into the root B-tree node.  Must check to see if a
 split occurred.  If so, create a new root node and put the old root and the
 new split node into the new root."

  | returnNode |
  returnNode := self btreeRootNode at: aKey put: aValue root: rootObject.
  returnNode == btreeRootNode
    ifFalse: [
      " create the new root node "
      btreeRootNode := self _createNewRootNodeForSplit: returnNode ]
%

category: 'Accessing'
method: BtreePlusRoot
btreeRootNode
  ^ btreeRootNode
    ifNil: [ btreeRootNode := indexObject btreePlusLeafNodeClass new
        rootNode: self;
        objectSecurityPolicy: self objectSecurityPolicy;
        yourself ]
%

category: 'Accessing'
method: BtreePlusRoot
btreeRootNode: aBtreePlusNode
  aBtreePlusNode rootNode: self.
  btreeRootNode := aBtreePlusNode
%

category: 'Accessing'
method: BtreePlusRoot
collator
  ^ self indexObject collator
%

category: 'Comparison Operators'
method: BtreePlusRoot
comparisonForSort
  "Answer the comparison object to be used for this index"

  ^ self indexObject comparisonForSort
%

category: 'Accessing'
method: BtreePlusRoot
indexObject
  "Answer the GsAbstractIndex that associated with this btree"

  ^ indexObject
%

category: 'Accessing'
method: BtreePlusRoot
indexObject: aGsAbstractIndex
  "Set the GsAbstractIndex that associated with this btree"

  indexObject := aGsAbstractIndex
%

category: 'Testing'
method: BtreePlusRoot
isIdentityIndex
  ^ self indexObject isIdentityIndex
%

category: 'Accessing'
method: BtreePlusRoot
maxNumberOfElements
  ^ self btreeRootNode maxNumberOfElements
%

category: 'Printing'
method: BtreePlusRoot
prettyPrint

""

^self btreeRootNode prettyPrint
%

category: 'Removing'
method: BtreePlusRoot
removeKey: aKey value: aValue root: rootObject
  "Removes the key and value from the B-tree root node.  Must check to see if
 a merge occurred in the root such that the root only contains a single
 entry.  If so, make the single entry the new root.  Returns whether the
 removal occurred."

  (btreeRootNode removeKey: aKey value: aValue root: rootObject)
    ifFalse: [ ^ false ].
  self updateBtreeRootNodeOnRemoval.
  ^ true
%

category: 'Statistics'
method: BtreePlusRoot
report
  | strm info leafCount totalElements |
  strm := AppendStream on: String new.
  info := {}.
  self btreeRootNode _putFirstIndexOfFirstChildInto: info.
  totalElements := leafCount := 0.
  (info at: 1) > 0
    ifTrue: [ | leaf |
      leaf := info at: 2.
      [ leaf notNil ] whileTrue: [ leafCount := leafCount + 1.
          totalElements := totalElements + leaf numElements.
          leaf := leaf nextLeaf ] ].
  leafCount == 0
    ifTrue: [ strm nextPutAll: 'The btree is empty' ]
    ifFalse: [ strm nextPutAll: 'There are ' , leafCount printString , ' leaf nodes with '
            , totalElements printString , ' elements ('
            , (totalElements / leafCount asScaledDecimal: 2) printString
            , ' elements/node).' ].
  ^ strm contents
%

category: 'Accessing'
method: BtreePlusRoot
totalElements

"Return the number of elements."

^ btreeRootNode totalElements
%

category: 'Removing'
method: BtreePlusRoot
updateBtreeRootNodeOnRemoval
  "If the current root node is an interior node of size one, replace the current root node with its
   single child"

  (btreeRootNode numElements == 1 and: [ btreeRootNode isLeaf not ])
    ifTrue: [ btreeRootNode := btreeRootNode
        at: btreeRootNode _lastKeyIndex - btreeRootNode keyIndexOffset ].
%

category: 'Rc compatibility'
method: BtreePlusRoot
_addBtreePlusNodeToRcReadSet: aBtreePlusNode
  "noop for non-rc btrees"
%

category: 'Testing'
method: BtreePlusRoot
_canCompare: aKey withClass: aClass
  "Returns whether the receiver can make comparisons with the given key."

  ^ btreeRootNode _canCompare: aKey withClass: aClass
%

category: 'Accessing'
method: BtreePlusRoot
_createNewRootNodeForSplit: returnNode
  "Create a new root node and put the old root and the new split node into the new root."
  " returnNode is the second half of the split "

  |  node |
  " create the new parent node "
  node := btreeRootNode parentNodeClass new
    rootNode: self;
    objectSecurityPolicy: self objectSecurityPolicy;
    lastValue: returnNode lastValue;
    lastRoot: returnNode lastRoot.
  " insert the first half (the original root) "
  node
     _insertKey: (btreeRootNode _at: btreeRootNode _lastKeyIndex)
     value: btreeRootNode
     root: (btreeRootNode _at: btreeRootNode _lastRootIndex)
     atIndex: 1.
  " insert the second half "
  node
    _insertKey: (returnNode _at: returnNode _lastKeyIndex)
    value: returnNode
    root: (returnNode _at: returnNode _lastRootIndex)
    atIndex: node entrySize + 1.
  ^ node
%

category: 'Searching Support'
method: BtreePlusRoot
_findAllValuesForIdenticalKey: aKey into: aCollection
  "Finds all the values for the given identical key, placing them in the
 collection.  Return whether the last key was equal or not (so the caller
 knows it must check the next leaf node)."

  ^ self btreeRootNode _findAllValuesForIdenticalKey: aKey into: aCollection
%

category: 'Searching Support'
method: BtreePlusRoot
_findAllValuesGreaterThanKey: aKey into: anArray using: aComparison
  "Puts into anArray the index and the leaf node of the entry that is greater
 than the given key.  Returns true if a value was found, false otherwise."

  ^ self btreeRootNode _findAllValuesGreaterThanKey: aKey into: anArray using: aComparison
%

category: 'Searching Support'
method: BtreePlusRoot
_findAllValuesLessThanKey: aKey andEquals: aBoolean into: anArray using: aComparison
  "Puts into anArray the index and the leaf node of the entry that is less than
 (or less than and equal to if aBoolean is true) the given key.  Returns true
 if a value was found, false otherwise."

  ^ self btreeRootNode
    _findAllValuesLessThanKey: aKey
    andEquals: aBoolean
    into: anArray
    using: aComparison
%

category: 'Searching'
method: BtreePlusRoot
_findFirstRootForKey: aKey using: aComparison
"Returns the first root object associated with the given key.  For interior nodes,
 find the appropriate child node and ask it to find the first root."

^ self btreeRootNode _findFirstRootForKey: aKey using: aComparison
%

category: 'Searching Support'
method: BtreePlusRoot
_lastRootObjectsNotIdenticalTo: aKey into: array

  self btreeRootNode _lastRootObjectsNotIdenticalTo: aKey into: array
%

category: 'Enumerating'
method: BtreePlusRoot
_leafKeysValuesAndRootsDo: aBlock

"Execute the two-argument block for each child node."

btreeRootNode _leafKeysValuesAndRootsDo: aBlock
%

category: 'Enumerating'
method: BtreePlusRoot
_preOrderDo: aBlock
  btreeRootNode _preOrderDo: aBlock
%

category: 'Sorting Support'
method: BtreePlusRoot
_putAscendingRootObjectsInto: array startingAt: offset

"Returns the number of elements."

^ self btreeRootNode _putAscendingRootObjectsInto: array startingAt: offset
%

category: 'Sorting Support'
method: BtreePlusRoot
_putDescendingRootObjectsInto: array startingAt: offset

"Returns the number of elements."

^ self btreeRootNode _putDescendingRootObjectsInto: array startingAt: offset
%

category: 'Searching Support'
method: BtreePlusRoot
_putFirstIndexOfFirstChildInto: anArray
  "Puts the receiver and the first index of the receiver into the Array."

  self btreeRootNode _putFirstIndexOfFirstChildInto: anArray
%

category: 'Searching Support'
method: BtreePlusRoot
_putFirstIndexOfFirstChildInto: anArray ifGreaterThanOrEqualTo: aKey using: aComparison

"If first entry is greater than or equal to aKey, Puts the receiver
 and the first index of the receiver into the Array.

 Because of NANs we need to validate the assumption of the caller
 (i.e., that all entries are greater than aKey). See bug33805."

self btreeRootNode _putFirstIndexOfFirstChildInto: anArray ifGreaterThanOrEqualTo: aKey using: aComparison
%

category: 'Searching Support'
method: BtreePlusRoot
_putLastIndexOfLastChildInto: anArray
  "Asks the last child in the receiver to
 putLastIndexOfLastChildInto: anArray ."

  self btreeRootNode _putLastIndexOfLastChildInto: anArray
%

! Class extensions for 'BtreePlusRootObjectMap'

!		Class methods for 'BtreePlusRootObjectMap'

category: 'instance creation'
classmethod: BtreePlusRootObjectMap
new
  ^ self basicNew
    initialize;
    yourself
%

!		Instance methods for 'BtreePlusRootObjectMap'

category: 'accessing'
method: BtreePlusRootObjectMap
cumulativeFactor

   ^cumulativeFactor
%

category: 'accessing'
method: BtreePlusRootObjectMap
cumulativeFactor: anObject

   cumulativeFactor := anObject
%

category: 'initialization'
method: BtreePlusRootObjectMap
initialize
  roots := BtreePlusTraversalMapDictionary new.
  cumulativeFactor := 0.
  traversalMap := BtreePlusTraversalMapDictionary new.
%

category: 'copying'
method: BtreePlusRootObjectMap
mergeFromCopy: aRootObjectMap
  | newBag |
  aRootObjectMap roots keysAndValuesDo: [ :rootObj :rootIndexBag |
    (self roots at: rootObj otherwise: nil)
      ifNotNil: [ :oldBag |
        newBag := rootIndexBag _union: oldBag ]
      ifNil: [
        newBag := rootIndexBag ].
    self roots at: rootObj put: newBag ].
  aRootObjectMap traversalMap keysAndValuesDo: [ :obj :indexBag |
    (traversalMap at: obj otherwise: nil)
      ifNotNil: [ :oldBag |
        newBag := indexBag _union: oldBag ]
      ifNil: [
        newBag := indexBag ].
    self traversalMap at: obj put: newBag ]
%

category: 'accessing'
method: BtreePlusRootObjectMap
pivotObject

   ^pivotObject
%

category: 'accessing'
method: BtreePlusRootObjectMap
pivotObject: anObject

   pivotObject := anObject
%

category: 'accessing'
method: BtreePlusRootObjectMap
pivotPathTerm

   ^pivotPathTerm
%

category: 'accessing'
method: BtreePlusRootObjectMap
pivotPathTerm: anObject

   pivotPathTerm := anObject
%

category: 'copying'
method: BtreePlusRootObjectMap
postCopy
  roots := BtreePlusTraversalMapDictionary new.
  traversalMap := BtreePlusTraversalMapDictionary new
%

category: 'resolving'
method: BtreePlusRootObjectMap
resolveTraversalRootObjectsFor: anObject
  ^ self
    resolveTraversalRootObjectsFor: anObject
    level: self pivotPathTerm offset
    into: IdentityBag new
    visited: IdentitySet new.
%

category: 'resolving'
method: BtreePlusRootObjectMap
resolveTraversalRootObjectsFor: anObject level: level into: defaultRoots visited: visited

  | objs bag currentLevel |
  level = 0
    ifTrue: [ ^ defaultRoots ].
  bag := self traversalMap at: anObject ifAbsent: [ ^ self roots at: anObject ifAbsent: [defaultRoots]].
  objs := IdentityBag new.
  currentLevel := level.
  bag
    do: [ :obj |
      (visited includes: obj)
        ifFalse: [
          obj class isNsc
            ifTrue: [ currentLevel := level + 1 ].
          visited add: obj.
          objs := objs
            _union:
              (self
                resolveTraversalRootObjectsFor: obj
                level: currentLevel - 1
                into: bag
                visited: visited) ] ].
  ^ objs
%

category: 'accessing'
method: BtreePlusRootObjectMap
roots

   ^roots
%

category: 'accessing'
method: BtreePlusRootObjectMap
roots: anObject

   roots := anObject
%

category: 'accessing'
method: BtreePlusRootObjectMap
traversalMap

   ^traversalMap
%

category: 'accessing'
method: BtreePlusRootObjectMap
traversalMap: anObject

   traversalMap := anObject
%

! Class extensions for 'BtreePlusTraversalMapDictionary'

!		Instance methods for 'BtreePlusTraversalMapDictionary'

category: 'Accessing'
method: BtreePlusTraversalMapDictionary
at: aKey

aKey ifNil: [ ^ super at: self].
^ super at: aKey
%

category: 'Accessing'
method: BtreePlusTraversalMapDictionary
at: aKey ifAbsent: aBlock

aKey ifNil: [ ^ super at: self ifAbsent: aBlock ].
^ super at: aKey ifAbsent: aBlock
%

category: 'Accessing'
method: BtreePlusTraversalMapDictionary
at: aKey ifAbsentPut: aBlock

aKey ifNil: [ ^ super at: self ifAbsentPut: aBlock ].
^ super at: aKey ifAbsentPut: aBlock
%

category: 'Accessing'
method: BtreePlusTraversalMapDictionary
at: aKey otherwise: defaultValue

aKey ifNil: [ ^ super at: self otherwise: defaultValue ].
^ super at: aKey otherwise: defaultValue
%

category: 'Updating'
method: BtreePlusTraversalMapDictionary
at: aKey put: aValue

aKey ifNil: [ ^ super at: self put: aValue ].
^ super at: aKey put: aValue
%

category: 'Enumerating'
method: BtreePlusTraversalMapDictionary
keysAndValuesDo: aBlock

"Evaluates aBlock with each of the receiver's key/value pairs as the
 arguments.  The argument aBlock must be a two-argument block.  The
 first argument is the key and the second argument is the value of
 each key/value pair."

| aKey collisionBkt |

1 to: tableSize * 2 by: 2 do: [ :tableIndex |
  (aKey := self _at: tableIndex) ifNil: [
    (collisionBkt := self _at: (tableIndex + 1)) ifNotNil: [
      1 to: collisionBkt _basicSize by: 2 do: [ :j |
        (aKey := collisionBkt _at: j) ifNotNil: [
          aKey == self ifTrue: [ aKey := nil ].
          aBlock value: aKey value: (collisionBkt _at: j + 1).
	].
      ].
    ].
  ] ifNotNil: [
    aKey == self ifTrue: [ aKey := nil ].
    aBlock value: aKey value: (self _at: tableIndex + 1).
  ].
].
%

category: 'Removing'
method: BtreePlusTraversalMapDictionary
removeKey: aKey ifAbsent: aBlock
  aKey ifNil: [ ^ super removeKey: self ifAbsent: aBlock ].
  ^ super removeKey: aKey ifAbsent: aBlock
%

! Class extensions for 'BtreePlusUnicodeComparisonQuerySpec'

!		Instance methods for 'BtreePlusUnicodeComparisonQuerySpec'

category: 'Accessing'
method: BtreePlusUnicodeComparisonQuerySpec
collator
  ^ collator
%

category: 'Accessing'
method: BtreePlusUnicodeComparisonQuerySpec
collator: anIcuCollator
  collator :=  anIcuCollator
%

category: 'Comparing'
method: BtreePlusUnicodeComparisonQuerySpec
compare: entry using: sel
  ^ sel numArgs == 1
    ifTrue: [ entry perform: sel with: key ]
    ifFalse: [ entry perform: sel with: key with: self collator ]
%

category: 'Comparing'
method: BtreePlusUnicodeComparisonQuerySpec
compareKey: entry
  ^ selector numArgs == 1
    ifTrue: [ entry perform: selector with: key ]
    ifFalse: [ entry perform: selector with: key with: self collator ]
%

category: 'Updating'
method: BtreePlusUnicodeComparisonQuerySpec
key: aKey selector: aSelector
  key := aKey.
  opCode := self operationSelectors indexOf: aSelector.
  selector := self unicodePerformSelector: opCode
%

category: 'Accessing'
method: BtreePlusUnicodeComparisonQuerySpec
performSelectors
  "Returns an Array of comparison operation selectors whose ordering corresponds
 to the operation selectors."

  ^ #(#'_idxForCompareLessThan:collator:' #'_idxForCompareGreaterThan:collator:' #'_idxForCompareEqualTo:collator:' #'==' #'_idxForCompareLessThanOrEqualTo:collator:' #'_idxForCompareGreaterThanOrEqualTo:collator:' #'_idxForCompareNotEqualTo:collator:' #'~~')
%

! Class extensions for 'BtreePlusUnicodeRangeComparisonQuerySpec'

!		Instance methods for 'BtreePlusUnicodeRangeComparisonQuerySpec'

category: 'Accessing'
method: BtreePlusUnicodeRangeComparisonQuerySpec
collator
  ^ collator
%

category: 'Accessing'
method: BtreePlusUnicodeRangeComparisonQuerySpec
collator: anIcuCollator
  collator :=  anIcuCollator
%

category: 'Comparing'
method: BtreePlusUnicodeRangeComparisonQuerySpec
compare: entry using: sel1 and: sel2
  ^ (entry perform: sel1 with: key with: self collator)
    and: [ entry perform: sel2 with: key2 with: self collator ]
%

category: 'Updating'
method: BtreePlusUnicodeRangeComparisonQuerySpec
key2: aKey2 selector2: aSelector2
  key2 := aKey2.
  opCode2 := self operationSelectors indexOf: aSelector2.
  selector2 := self unicodePerformSelector: opCode2
%

category: 'Updating'
method: BtreePlusUnicodeRangeComparisonQuerySpec
key: aKey selector: aSelector
  key := aKey.
  opCode := self operationSelectors indexOf: aSelector.
  selector := self unicodePerformSelector: opCode
%

category: 'Accessing'
method: BtreePlusUnicodeRangeComparisonQuerySpec
performSelectors
  "Returns an Array of comparison operation selectors whose ordering corresponds
 to the operation selectors."

  ^ #(#'_idxForCompareLessThan:collator:' #'_idxForCompareGreaterThan:collator:' #'_idxForCompareEqualTo:collator:' #'==' #'_idxForCompareLessThanOrEqualTo:collator:' #'_idxForCompareGreaterThanOrEqualTo:collator:' #'_idxForCompareNotEqualTo:collator:' #'~~')
%

! Class extensions for 'BtreeQuerySpec'

!		Instance methods for 'BtreeQuerySpec'

category: 'Querying'
method: BtreeQuerySpec
addRootObjectsFrom: aLeafNode
start: startIndex
end: endIndex
into: collection

^ aLeafNode
    _addRootObjects: self
    start: startIndex
    end: endIndex
    into: collection
%

category: 'Querying'
method: BtreeQuerySpec
addValuesFrom: aLeafNode
start: startIndex
end: endIndex
into: collection

^ aLeafNode
    _addValues: self
    start: startIndex
    end: endIndex
    into: collection
%

category: 'Testing'
method: BtreeQuerySpec
canUseOptimizedComparison

  ^ false
%

category: 'Updating'
method: BtreeQuerySpec
rangeIndex: aRangeIndex offset: anOffset pathTerm: aPathTerm

rangeIndex := aRangeIndex.
offset := anOffset.
pathTerm := aPathTerm.
%

category: 'Querying'
method: BtreeQuerySpec
traverseValuesFrom: aLeafNode
start: startIndex
end: endIndex
previous: previousValue
into: collection

^ aLeafNode
    _traverseValues: self
    start: startIndex
    end: endIndex
    previous: previousValue
    into: collection
%

category: 'Querying'
method: BtreeQuerySpec
_addRootObjectsFrom: aLeafNode
entrySize: entrySize
start: startIndex
end: endIndex
into: collection

startIndex to: endIndex by: entrySize do: [ :i |
  collection add: (aLeafNode rootObjectAt: i).
].
%

category: 'Querying'
method: BtreeQuerySpec
_addValuesFrom: aLeafNode
entrySize: entrySize
start: startIndex
end: endIndex
into: collection

startIndex to: endIndex by: entrySize do: [ :i |
  collection add: (aLeafNode _basicAt: i).
].
%

category: 'Querying'
method: BtreeQuerySpec
_traverseValuesFrom: aLeafNode
entrySize: entrySize
start: startIndex
end: endIndex
previous: previousValue
into: collection

  | val prevVal |
prevVal := previousValue.
startIndex to: endIndex by: entrySize do: [ :i |
val := aLeafNode _basicAt: i.
  (val == prevVal)
     ifFalse: [
       rangeIndex _addAllFor: val
         into: collection
         offset: offset
         pathTerm: pathTerm
     ].
  prevVal := val
].
^prevVal
%

! Class extensions for 'BtreeRangeComparisonQuerySpec'

!		Class methods for 'BtreeRangeComparisonQuerySpec'

category: 'Instance Creation'
classmethod: BtreeRangeComparisonQuerySpec
key: aKey selector: aSelector and: aKey2 selector: aSelector2

| new |
new := self new key: aKey selector: aSelector.
new key2: aKey2 selector2: aSelector2.
^new
%

!		Instance methods for 'BtreeRangeComparisonQuerySpec'

category: 'Comparing'
method: BtreeRangeComparisonQuerySpec
compare: entry using: selector1 and: selector2
  ^ (entry perform: selector1 with: key)
    and: [ entry perform: selector2 with: key2 ]
%

category: 'Comparing'
method: BtreeRangeComparisonQuerySpec
compareKey: entry
  ^ (entry perform: (self performSelector: opCode) with: key)
    and: [ entry perform: (self performSelector: opCode2) with: key2 ]
%

category: 'Updating'
method: BtreeRangeComparisonQuerySpec
key2: aKey2 selector2: aSelector2

key2 := aKey2.
opCode2 := self operationSelectors indexOf: aSelector2.
%

category: 'Querying'
method: BtreeRangeComparisonQuerySpec
_addRootObjectsFrom: aLeafNode entrySize: entrySize start: startIndex end: endIndex into: collection
  | sel1 sel2 |
  sel1 := self performSelector: opCode.
  sel2 := self performSelector: opCode2.
  startIndex to: endIndex by: entrySize do: [ :i | | aKey |
    aKey := aLeafNode keyAt: i.
    (self compare: aKey using: sel1 and: sel2)
      ifTrue: [ collection add: (aLeafNode rootObjectAt: i) ] ]
%

category: 'Querying'
method: BtreeRangeComparisonQuerySpec
_addValuesFrom: aLeafNode entrySize: entrySize start: startIndex end: endIndex into: collection
  | sel1 sel2 |
  sel1 := self performSelector: opCode.
  sel2 := self performSelector: opCode2.
  startIndex to: endIndex by: entrySize do: [ :i |
    | aKey |
    aKey := aLeafNode _basicAt: i + 1.
    (self compare: aKey using: sel1 and: sel2)
      ifTrue: [ collection add: (aLeafNode _basicAt: i) ] ]
%

category: 'Querying'
method: BtreeRangeComparisonQuerySpec
_traverseValuesFrom: aLeafNode entrySize: entrySize start: startIndex end: endIndex previous: previousValue into: collection
  | val prevVal aKey sel1 sel2 |
  sel1 := self performSelector: opCode.
  sel2 := self performSelector: opCode2.
  prevVal := previousValue.
  startIndex to: endIndex by: entrySize do: [ :i |
    aKey := aLeafNode _basicAt: i + 1.
    val := aLeafNode _basicAt: i.
    ((self compare: aKey using: sel1 and: sel2) and: [ val ~~ prevVal ])
      ifTrue: [
        rangeIndex
          _addAllFor: val
          into: collection
          offset: offset
          pathTerm: pathTerm ].
    prevVal := val ].
  ^ prevVal
%

! Class extensions for 'BtreeReadStream'

!		Class methods for 'BtreeReadStream'

category: 'Instance Creation'
classmethod: BtreeReadStream
on: aBtreeNode

"Create a stream that can access the entire contents of the B-tree whose
 root node is aBtreeNode."

| arr1 arr2 newStream |
arr1 := { } .
arr2 := { } .

aBtreeNode _putFirstIndexOfFirstChildInto: arr1.
aBtreeNode _putLastIndexOfLastChildInto: arr2.

newStream := self new.
newStream endIndex: (arr2 at: 1).
newStream endNode: (arr2 at: 2).
newStream currentStack: arr1.

^ newStream
%

!		Instance methods for 'BtreeReadStream'

category: 'Testing'
method: BtreeReadStream
atEnd
  "Returns true if the receiver is positioned at the end of the stream, and
 false otherwise."

  ^ self _atEnd
%

category: 'Query Support'
method: BtreeReadStream
btreeRangeComparisonQuerySpec
  ^ self _btreeRangeComparisonQuerySpecClass new
%

category: 'Accessing'
method: BtreeReadStream
currentStack

"Returns the value of the instance variable 'currentStack'."

^currentStack
%

category: 'Updating'
method: BtreeReadStream
currentStack: newValue

"Modifies the value of the instance variable 'currentStack'."

currentStack := newValue
%

category: 'Accessing'
method: BtreeReadStream
endIndex

"Returns the value of the instance variable 'endIndex'."

^endIndex
%

category: 'Updating'
method: BtreeReadStream
endIndex: newValue

"Modify the value of the instance variable 'endIndex'."

endIndex := newValue
%

category: 'Accessing'
method: BtreeReadStream
endNode

"Returns the value of the instance variable 'endNode'."

^endNode
%

category: 'Updating'
method: BtreeReadStream
endNode: newValue

"Modify the value of the instance variable 'endNode'."

endNode := newValue
%

category: 'Accessing'
method: BtreeReadStream
next

"Returns the next value on a stream of B-tree values.  Update the current
 stack for a subsequent 'next'."

self _btreeAtEnd
    ifTrue: [ ^ self _errorEndOfStream ].

^ self _btreeNext
%

category: 'Adding'
method: BtreeReadStream
nextPut: anObject

"Disallowed.  You cannot write to a BtreeReadStream."

self shouldNotImplement: #nextPut:
%

category: 'Accessing'
method: BtreeReadStream
size

"Returns the number of elements contained in the receiver (that is, how many
successful 'next' operations can be performed)."

| array |
self atEnd ifTrue: [
  ^ 0
  ].
array := { 0 . false }.
(currentStack at: currentStack size)
  _totalElementsIn: currentStack
  endNode: endNode
  endIndex: endIndex
  into: array.
^ array at: 1
%

category: 'Accessing'
method: BtreeReadStream
streamQuerySpec
  ^ streamQuerySpec
%

category: 'Accessing'
method: BtreeReadStream
streamQuerySpec: aBtreeQuerySpec
  streamQuerySpec := aBtreeQuerySpec
%

category: 'Testing'
method: BtreeReadStream
_atEnd
  "Returns true if the receiver is positioned at the end of the stream, and
 false otherwise."

  ^ (currentStack at: 1) == 0
%

category: 'Testing'
method: BtreeReadStream
_btreeAtEnd

""

^ (currentStack at: 1) == 0
%

category: 'Query Support'
method: BtreeReadStream
_btreeComparisonQuerySpecClass
  ^ (endNode notNil and: [ endNode collator notNil ])
    ifTrue: [ BtreeUnicodeComparisonQuerySpec ]
    ifFalse: [ BtreeComparisonQuerySpec ]
%

category: 'Accessing'
method: BtreeReadStream
_btreeNext

"Returns the next value on a stream of B-tree values.  Updates the current
 stack for a subsequent 'next'."

| val leaf index lastValIndex |
" get the index into the leaf node and see if it has reached the end "
index := currentStack at: 1.
index == 0
    ifTrue: [ ^ self _errorEndOfStream ].

" get the leaf and the value within the leaf "
leaf := currentStack at: 2.
val := leaf _basicAt: index.

" if this is the end of the stream, sets the top index to zero and returns "
( leaf == endNode and: [ endIndex == index ] )
    ifTrue: [
        currentStack at: 1 put: 0.
        ^ val
    ].

" see if index refers to last entry in this leaf "
lastValIndex := leaf _lastKeyIndex - 1.
index > lastValIndex
    ifTrue: [ self _error: #rtErrInvalidBtreeReadStream ].

index == lastValIndex
    ifTrue: [
        " must look down the stack for the next leaf node "
        self _nextLeaf
    ]
    ifFalse: [ currentStack at: 1 put: (index + leaf entrySize) ].

^ val
%

category: 'Query Support'
method: BtreeReadStream
_btreeRangeComparisonQuerySpecClass
  ^ (endNode notNil and: [ endNode collator notNil ])
    ifTrue: [ BtreeUnicodeRangeComparisonQuerySpec ]
    ifFalse: [ BtreeRangeComparisonQuerySpec ]
%

category: 'Error Handling'
method: BtreeReadStream
_errorEndOfStream

"Raises an error due to an attempt to read beyond the end of the stream."

^ self _error: #rtErrBtreeReadStreamEndOfStream .
%

category: 'Query Support'
method: BtreeReadStream
_hasSameEndAs: otherStream

"Returns true if the receiver has the same end index and end node as the
 otherStream."

^ endIndex == otherStream endIndex and: [
   endNode == otherStream endNode ]
%

category: 'Accessing'
method: BtreeReadStream
_nextLeaf

"Looks down the stack for the next leaf node and makes it the current node."

| nodeIndex notPositioned currentNode currentIndex nextIndex node |

nodeIndex := 4.
notPositioned := true.
[ notPositioned ] whileTrue: [
    currentIndex := currentStack at: nodeIndex - 1.
    nil == (currentNode := currentStack at: nodeIndex)
        ifTrue: [ self _error: #rtErrInvalidBtreeReadStream ].


    " if the current index is the last in the node "
    currentIndex == (currentNode _lastKeyIndex - 1)
        ifTrue: [ " must look down the stack another level "
            nodeIndex == currentStack size
                ifTrue: [ ^ self _errorEndOfStream ].
            nodeIndex := nodeIndex + 2
        ]
        ifFalse: [ " current node has a next entry "
            nextIndex := currentIndex + currentNode entrySize.
            " put the next entry (index and node) on the stack "
            currentStack at: nodeIndex - 1 put: nextIndex.
            nil == (node := currentNode _basicAt: nextIndex)
                ifTrue: [ self _error: #rtErrInvalidBtreeReadStream ].
            currentStack at: nodeIndex - 2 put: node.

            " put the first child on any remaining levels in the stack "
            nodeIndex - 3 _downTo: 3 by: 2 do: [ :i |
                currentStack at: i put: 1.
                currentStack at: i -1 put: ((currentStack at: i + 1) _basicAt: 1)
            ].
            currentStack at: 1 put: 1.
            notPositioned := false
        ]
]
%

category: 'Private'
method: BtreeReadStream
_peekKey

"Returns the key of the current entry in the stream."

| i |
i := currentStack at: 1.
i == 0
    ifTrue: [ ^ self _errorEndOfStream ].
^ (currentStack at: 2) _basicAt: i + 1
%

category: 'Private'
method: BtreeReadStream
_peekValue
  "Returns the value of the current entry in the stream."

  | i |
  i := currentStack at: 1.
  i == 0
    ifTrue: [ ^ self _errorEndOfStream ].
  ^ (currentStack at: 2) _basicAt: i
%

category: 'Query Support'
method: BtreeReadStream
_positionToEnd

"Sets the current stack to the end index and end node.  This
 has the effect of advancing the stream to the last object."

currentStack at: 1 put: endIndex.
currentStack at: 2 put: endNode
%

category: 'Query Support'
method: BtreeReadStream
_valuesAddInto: collection

"Adds each entry value into the given NSC."

| querySpec |
querySpec := BtreeQuerySpec new.
^self _valuesAddInto: collection spec: querySpec
%

category: 'Query Support'
method: BtreeReadStream
_valuesAddInto: collection comparing: aSelector key: aKey
  "Adds each entry value into the given NSC."

  | querySpec |
  querySpec := self _btreeComparisonQuerySpecClass key: aKey selector: aSelector.
  endNode ifNotNil: [ querySpec collator: endNode collator ].
  ^ self _valuesAddInto: collection spec: querySpec
%

category: 'Query Support'
method: BtreeReadStream
_valuesAddInto: collection comparing: aSelector1 key: aKey1 and: aSelector2 key: aKey2
  "Adds each entry value into the given NSC."

  | querySpec |
  querySpec := self _btreeRangeComparisonQuerySpecClass
    key: aKey1
    selector: aSelector1
    and: aKey2
    selector: aSelector2.
  endNode ifNotNil: [ querySpec collator: endNode collator ].
  ^ self _valuesAddInto: collection spec: querySpec
%

category: 'Query Support'
method: BtreeReadStream
_valuesAddInto: collection identicalTo: aKey
  "For each entry whose key is identical to the given key, add the value into
 the given collection."

  | querySpec |
  querySpec := self _btreeComparisonQuerySpecClass key: aKey selector: #'=='.
  endNode ifNotNil: [ querySpec collator: endNode collator ].
  ^ self _valuesAddInto: collection spec: querySpec
%

category: 'Query Support'
method: BtreeReadStream
_valuesAddInto: collection notEqualTo: aKey
  "For each entry whose key is not identical to the given key, add the value
 into the given collection."

  | querySpec |
  querySpec := self _btreeComparisonQuerySpecClass key: aKey selector: #'~='.
  endNode ifNotNil: [ querySpec collator: endNode collator ].
  ^ self _valuesAddInto: collection spec: querySpec
%

category: 'Query Support'
method: BtreeReadStream
_valuesAddInto: collection notIdenticalTo: aKey
  "For each entry whose key is not identical to the given key, add the value
 into the given collection."

  | querySpec |
  querySpec := self _btreeComparisonQuerySpecClass key: aKey selector: #'~~'.
  endNode ifNotNil: [ querySpec collator: endNode collator ].
  ^ self _valuesAddInto: collection spec: querySpec
%

category: 'Query Support'
method: BtreeReadStream
_valuesAddInto: collection spec: querySpec

"Adds each entry value into the given NSC."

| leaf index eSize |

" get the index into the leaf node and see if it has reached the end "
index := currentStack at: 1.
index == 0
    ifTrue: [ ^ self ].

leaf := currentStack at: 2.
eSize := endNode entrySize.
" while current node is not the end node "
[ endNode ~~ leaf ] whileTrue: [
    " put the values for the current node in the set "
    querySpec addValuesFrom: leaf
                     start: index
                     end: leaf numElements * eSize
                     into: collection.
    " look down the stack for the next leaf node "
    self _nextLeaf.

    leaf := currentStack at: 2.
    index := 1
].

" put values of end node in the NSC "
querySpec addValuesFrom: leaf
                 start: index
                 end: endIndex
                 into: collection.
%

! Class extensions for 'BtreeUnicodeComparisonQuerySpec'

!		Instance methods for 'BtreeUnicodeComparisonQuerySpec'

category: 'Accessing'
method: BtreeUnicodeComparisonQuerySpec
collator
  ^ collator
%

category: 'Accessing'
method: BtreeUnicodeComparisonQuerySpec
collator: anIcuCollator
  collator :=  anIcuCollator
%

category: 'Comparing'
method: BtreeUnicodeComparisonQuerySpec
compare: entry using: selector
  ^ selector numArgs == 1
    ifTrue: [ entry perform: selector with: key ]
    ifFalse: [ entry perform: selector with: key with: self collator ]
%

category: 'Comparing'
method: BtreeUnicodeComparisonQuerySpec
compareKey: entry
  ^ entry perform: (self performSelector: opCode) with: key with: self collator
%

category: 'Accessing'
method: BtreeUnicodeComparisonQuerySpec
performSelectors
  "Returns an Array of comparison operation selectors whose ordering corresponds
 to the operation selectors."

  ^ #(#'_idxForCompareLessThan:collator:' #'_idxForCompareGreaterThan:collator:' #'_idxForCompareEqualTo:collator:' #'==' #'_idxForCompareLessThanOrEqualTo:collator:' #'_idxForCompareGreaterThanOrEqualTo:collator:' #'_idxForCompareNotEqualTo:collator:' #'~~')
%

! Class extensions for 'BtreeUnicodeRangeComparisonQuerySpec'

!		Instance methods for 'BtreeUnicodeRangeComparisonQuerySpec'

category: 'Accessing'
method: BtreeUnicodeRangeComparisonQuerySpec
collator
  ^ collator
%

category: 'Accessing'
method: BtreeUnicodeRangeComparisonQuerySpec
collator: anIcuCollator
  collator :=  anIcuCollator
%

category: 'Comparing'
method: BtreeUnicodeRangeComparisonQuerySpec
compare: entry using: selector1 and: selector2
  ^ (entry perform: selector1 with: key with: self collator)
    and: [ entry perform: selector2 with: key2 with: self collator ]
%

category: 'Accessing'
method: BtreeUnicodeRangeComparisonQuerySpec
performSelectors
  "Returns an Array of comparison operation selectors whose ordering corresponds
 to the operation selectors."

  ^ #(#'_idxForCompareLessThan:collator:' #'_idxForCompareGreaterThan:collator:' #'_idxForCompareEqualTo:collator:' #'==' #'_idxForCompareLessThanOrEqualTo:collator:' #'_idxForCompareGreaterThanOrEqualTo:collator:' #'_idxForCompareNotEqualTo:collator:' #'~~')
%

! Class extensions for 'BucketValueBag'

!		Class methods for 'BucketValueBag'

category: 'Instance Creation'
classmethod: BucketValueBag
new

"Disallowed.  You cannot create a BucketValueBag through the normal
 means.  This class is for internal use only."

self shouldNotImplement: #new
%

category: 'Private'
classmethod: BucketValueBag
_hasInstance: anObject

"Returns whether the argument is an instance of BucketValueBag without
 encountering authorization errors."

<primitive: 186>
self _primitiveFailed: #_hasInstance: args: { anObject }.
self _uncontinuableError
%

! Class extensions for 'CanonicalObjectManager'

!		Class methods for 'CanonicalObjectManager'

category: 'Instance Creation'
classmethod: CanonicalObjectManager
clearDefault
"
	CanonicalObjectManager clearDefault.
"
	default := nil.
%

category: 'Instance Creation'
classmethod: CanonicalObjectManager
default

	default ifNil: [
		default := Array with: self new.
		default first objectSecurityPolicy: securityPolicy.
	].
	^default first.
%

category: 'Instance Creation'
classmethod: CanonicalObjectManager
new

	^super new
		initialize;
		yourself.
%

category: 'Security'
classmethod: CanonicalObjectManager
securityPolicy

	^securityPolicy
%

category: 'Security'
classmethod: CanonicalObjectManager
securityPolicy: anObjectSecurityPolicy

	securityPolicy := anObjectSecurityPolicy.
	default ifNotNil: [self default objectSecurityPolicy: anObjectSecurityPolicy].
%

!		Instance methods for 'CanonicalObjectManager'

category: 'Accessors'
method: CanonicalObjectManager
canonicalClasses

	^registries keys
		inject: IdentitySet new
		into: [:sum :each | sum addAll: each. sum].
%

category: 'Registry Management'
method: CanonicalObjectManager
canonicalizePotentialCanonicalObjects

	registries do: [:each | each canonicalizePotentialCanonicalObjects].
%

category: 'Canonical'
method: CanonicalObjectManager
canonicalObjectFor: anObject
	"returns a possible canonical object"

	| domain |
	domain := self
		_registryFor: anObject
		ifAbsent: [^anObject].
	^domain canonicalObjectFor: anObject.
%

category: 'Cleanup'
method: CanonicalObjectManager
cleanupAll: aCollection

	| beginTime endTime |
	beginTime := System timeNs.
	aCollection do: [:each |
		referencingObjectPolicy canonicalizeReferencesIn: each.
	].
	endTime := System timeNs.
	self
		sessionCacheStatAt: 3 		incrementBy: 1;  						"count of calls to #'cleanupAll:'"
		sessionCacheStatAt: 4 		incrementBy: aCollection size;  	"count of objects scanned during cleanup"
		sessionCacheStatAt: 10	incrementBy: ((endTime - beginTime) // 1000 max: 1);	"microseconds in #'cleanupAll:'"
		yourself.
%

category: 'Cleanup'
method: CanonicalObjectManager
cleanupWriteSet

	| beginTime writeSet endTime |
	beginTime := System timeNs.
	writeSet := self _writeSet.
	endTime := System timeNs.
	self
		sessionCacheStatAt: 9 incrementBy: ((endTime - beginTime) // 1000 max: 1);	"microseconds in building writeSet"
		cleanupAll: writeSet;
		yourself.
%

category: 'Registry Management'
method: CanonicalObjectManager
createRegistryFor: aClass

	registries
		at: aClass classHistory
		ifAbsentPut: [CanonicalObjectRegistry newForManager: self].
%

category: 'Canonical'
method: CanonicalObjectManager
hasCanonicalObjectFor: anObject

	| domain |
	domain := self
		_registryFor: anObject
		ifAbsent: [^false].
	^domain hasCanonicalObjectFor: anObject.
%

category: 'Canonical'
method: CanonicalObjectManager
hasUltimateCanonicalObjectFor: anObject

	| domain |
	domain := self
		_registryFor: anObject
		ifAbsent: [^false].
	^domain hasUltimateCanonicalObjectFor: anObject.
%

category: 'Initialize'
method: CanonicalObjectManager
initialize

	registries :=  IdentityKeyValueDictionary new.
	referencingObjectPolicy := ReferencingObjectPolicy newForManager: self.
%

category: 'Registry Management'
method: CanonicalObjectManager
isCanonicalClass: aClass

	^registries includesKey: aClass classHistory.
%

category: 'Canonical'
method: CanonicalObjectManager
isCanonicalObject: anObject
	"Could answer true for two equivalent objects if both are in potentialCanonicalObjects"

	| domain |
	domain := self
		_registryFor: anObject
		ifAbsent: [^false].
	^domain isCanonicalObject: anObject.
%

category: 'Canonical'
method: CanonicalObjectManager
isUltimateCanonicalObject: anObject

	| domain |
	domain := self
		_registryFor: anObject
		ifAbsent: [^false].
	^domain isUltimateCanonicalObject: anObject.
%

category: 'Security'
method: CanonicalObjectManager
objectSecurityPolicy: anObjectSecurityPolicy

	super objectSecurityPolicy: anObjectSecurityPolicy.
	referencingObjectPolicy objectSecurityPolicy: anObjectSecurityPolicy.
	registries objectSecurityPolicy: anObjectSecurityPolicy.
%

category: 'Accessors'
method: CanonicalObjectManager
referencingObjectPolicy

	^referencingObjectPolicy
%

category: 'Statistics'
method: CanonicalObjectManager
resetSessionCacheStats

	| endOffset |
	sessionCacheStatOffset ifNil: [^self].
	endOffset := sessionCacheStatOffset + self sessionCacheStats size - 1.
	sessionCacheStatOffset to: endOffset do: [:i |
		System sessionCacheStatAt: i put: 0.
	].
%

category: 'Statistics'
method: CanonicalObjectManager
sessionCacheStatAt: anIndex

	sessionCacheStatOffset ifNil: [^0].
	^System
		sessionCacheStatAt: sessionCacheStatOffset + anIndex - 1.
%

category: 'Statistics'
method: CanonicalObjectManager
sessionCacheStatAt: anIndex incrementBy: aSmallInt

	sessionCacheStatOffset ifNil: [^self].
	System
		sessionCacheStatAt: sessionCacheStatOffset + anIndex - 1
		incrementBy: aSmallInt.
%

category: 'Statistics'
method: CanonicalObjectManager
sessionCacheStatAt: anIndex put: aSmallInt

	sessionCacheStatOffset ifNil: [^self].
	System
		sessionCacheStatAt: sessionCacheStatOffset + anIndex - 1
		put: aSmallInt.
%

category: 'Statistics'
method: CanonicalObjectManager
sessionCacheStatDescriptions

	^#(
	"1"	'count of objects added to global registry'
	"2"	'count of objects added to potentialCanonicalObjects'

	"3"	'count of calls to #''cleanupAll:'''
	"4"    'count of objects scanned during cleanup'
	"5"    'count of referencing objects scanned during cleanup'
	"6"    'count of referencing objects changed during cleanup'
	"7"    'count of references changed during cleanup'
	"8"	'count of invariant referencing objects scanned during cleanup'

	"9"    'microseconds in building writeSet'
	"10"	'microseconds in #''cleanupAll:'''
	)
%

category: 'Statistics'
method: CanonicalObjectManager
sessionCacheStatOffset
	"nil means do not collect any statistics; aSmallInteger means start statistics here"

	^sessionCacheStatOffset
%

category: 'Statistics'
method: CanonicalObjectManager
sessionCacheStatOffset: anIntegerOrNil
	"nil means do not collect any statistics; aSmallInteger means start statistics here"

	sessionCacheStatOffset := anIntegerOrNil.
%

category: 'Statistics'
method: CanonicalObjectManager
sessionCacheStats
"
	CanonicalObjectManager soleInstance sessionCacheStats.
"
	^self sessionCacheStatsForSession: System session.
%

category: 'Statistics'
method: CanonicalObjectManager
sessionCacheStatsForSession: anInteger

	sessionCacheStatOffset ifNil: [^#()].
	^(System sessionCacheStatsForSessionId: anInteger)
		copyFrom: sessionCacheStatOffset + 1
		to: sessionCacheStatOffset + self sessionCacheStatDescriptions size.
%

category: 'Statistics'
method: CanonicalObjectManager
sessionCacheStatsSize

	^self sessionCacheStatDescriptions size
%

category: 'Canonical'
method: CanonicalObjectManager
ultimateCanonicalObjectFor: anObject
	"returns an actual canonical object (with possible conflicts)"

	| domain |
	domain := self
		_registryFor: anObject
		ifAbsent: [^anObject].
	^domain ultimateCanonicalObjectFor: anObject.
%

category: 'Accessors'
method: CanonicalObjectManager
_registries

	^registries.
%

category: 'Canonical'
method: CanonicalObjectManager
_registryFor: anObject ifAbsent: aBlock

	^registries
		at: anObject class classHistory
		ifAbsent: aBlock.
%

category: 'Cleanup'
method: CanonicalObjectManager
_writeSet

	| writeSet queue |
	queue := OrderedCollection withAll: System _writtenObjects.
	writeSet := IdentitySet new.
	[
		queue notEmpty.
	] whileTrue: [
		| next |
		next := queue removeLast.
		next class isBytes ifFalse: [
			writeSet add: next.
			1 to: next _primitiveSize do: [:i |
				| x |
				x := next _primitiveAtNoFault: i otherwise: nil.
				(x isSpecial or: [x class isBytes or: [x isCommitted or: [writeSet includes: x]]]) not ifTrue: [
					queue add: x.
				].
			].
		].
	].
	^writeSet.
%

category: 'Cleanup'
method: CanonicalObjectManager
_writeSetAdding: newObjects ignoring: oldObjects

	| writeSet queue |
	queue := OrderedCollection withAll: System _writtenObjects.
	writeSet := IdentitySet new.
	[
		queue notEmpty.
	] whileTrue: [
		| next |
		next := queue removeLast.
		next class isBytes ifFalse: [
			writeSet add: next.
			1 to: next _primitiveSize do: [:i |
				| x |
				x := next _primitiveAt: i.
				(x isSpecial or: [x class isBytes or: [x isCommitted or: [writeSet includes: x]]]) not ifTrue: [
					queue add: x.
				].
			].
		].
	].
	^writeSet.
%

! Class extensions for 'CanonicalObjectPolicy'

!		Instance methods for 'CanonicalObjectPolicy'

category: 'other'
method: CanonicalObjectPolicy
canonicalRepresentationOf: anObject

	^anObject immediateInvariant.
%

category: 'other'
method: CanonicalObjectPolicy
wantsToCanonicalize: anObject

	^anObject size < 256.
%

! Class extensions for 'CanonicalObjectRegistry'

!		Class methods for 'CanonicalObjectRegistry'

category: 'Instance Creation'
classmethod: CanonicalObjectRegistry
new

	self shouldNotImplement: #'new'.
%

category: 'Instance Creation'
classmethod: CanonicalObjectRegistry
newForManager: aManager

	^super new
		initializeForManager: aManager;
		yourself.
%

!		Instance methods for 'CanonicalObjectRegistry'

category: 'Registry Management'
method: CanonicalObjectRegistry
canonicalizePotentialCanonicalObjects

	| list |
	list := potentialCanonicalObjects asArray.
	potentialCanonicalObjects removeAll: list.
	list do: [:each |
		self ultimateCanonicalObjectFor: each.
	].
%

category: 'Lookup'
method: CanonicalObjectRegistry
canonicalObjectFor: anObject
	"returns an actual or potential canonical object (without
	conflicts, but might need to canonicalize potentials later).
	Does not yet deal with local registry."

	| canonical |
	canonical := self ultimateCanonicalObjectOrNilFor: anObject.
	canonical ifNotNil: [^canonical].
	potentialCanonicalObjects do: [:each | anObject = each ifTrue: [^each]].
	(canonicalObjectPolicy wantsToCanonicalize: anObject) ifFalse: [^anObject].
	canonical := canonicalObjectPolicy canonicalRepresentationOf: anObject.
	potentialCanonicalObjects add: canonical.
	manager sessionCacheStatAt: 2 incrementBy: 1.
	^canonical.
%

category: 'Lookup'
method: CanonicalObjectRegistry
hasCanonicalObjectFor: anObject

	| canonical |
	canonical := self ultimateCanonicalObjectOrNilFor: anObject.
	canonical ifNotNil: [^true].
	^potentialCanonicalObjects includesValue: anObject.
%

category: 'Lookup'
method: CanonicalObjectRegistry
hasUltimateCanonicalObjectFor: anObject

	"^(registry at: anObject otherwise: nil) notNil."
	^registry includesKey: anObject
%

category: 'Initialize'
method: CanonicalObjectRegistry
initializeForManager: aManager

	canonicalObjectPolicy := CanonicalObjectPolicy new.
	manager := aManager.
	potentialCanonicalObjects := RcIdentityBag new.
	registry := KeyValueDictionary new.
	self objectSecurityPolicy: aManager objectSecurityPolicy.
%

category: 'Lookup'
method: CanonicalObjectRegistry
isCanonicalObject: anObject
	"Could answer true for two equivalent objects if both are in potentialCanonicalObjects"

	| canonical |
	canonical := self ultimateCanonicalObjectOrNilFor: anObject.
	canonical == anObject ifTrue: [^true].
	^potentialCanonicalObjects includesIdentical: anObject.
%

category: 'Lookup'
method: CanonicalObjectRegistry
isUltimateCanonicalObject: anObject

	^(registry at: anObject otherwise: nil) == anObject.
%

category: 'Security'
method: CanonicalObjectRegistry
objectSecurityPolicy: anObjectSecurityPolicy

	super objectSecurityPolicy: anObjectSecurityPolicy.
	canonicalObjectPolicy objectSecurityPolicy: anObjectSecurityPolicy.
	potentialCanonicalObjects objectSecurityPolicy: anObjectSecurityPolicy.
	registry objectSecurityPolicy: anObjectSecurityPolicy.
%

category: 'Lookup'
method: CanonicalObjectRegistry
ultimateCanonicalObjectFor: anObject
	"returns an actual canonical object (with possible conflicts)"

	^registry
		at: anObject
		ifAbsentPut: [
			manager sessionCacheStatAt: 1 incrementBy: 1.
			canonicalObjectPolicy canonicalRepresentationOf: anObject].
%

category: 'Lookup'
method: CanonicalObjectRegistry
ultimateCanonicalObjectOrNilFor: anObject

	^registry
		at: anObject
		ifAbsent: [nil].
%

category: 'Accessors'
method: CanonicalObjectRegistry
_canonicalObjectPolicy

	^canonicalObjectPolicy.
%

category: 'Accessors'
method: CanonicalObjectRegistry
_potentialCanonicalObjects

	^potentialCanonicalObjects.
%

category: 'Accessors'
method: CanonicalObjectRegistry
_registry

	^registry.
%

! Class extensions for 'CByteArray'

!		Class methods for 'CByteArray'

removeallmethods CByteArray
removeallclassmethods CByteArray

category: 'Private'
classmethod: CByteArray
basicNew
 "disallowed"
  self shouldNotImplement: #basicNew
%

category: 'Instance Creation'
classmethod: CByteArray
computeSizeForArrayOfByteObjects: arrayOfByteObjs extraNullPointer: addExtraNull
  "Compute the number of bytes needed to contain arrayOfByteObjs in
   an instance of the receiver which will represent an array of bytes in C.
   Each element of arrayOfByteObjs must be a String . 
   DoubleByteString or QuadByteString are not allowed.
   Space for a NUL character for each element is included in the total.
   If addExtraNull is true, space for an extra NULL element in the array of C
   pointers will be included (some C functions require a terminating NULL)."

| totalBytes sz |
totalBytes := 0.

"Validate each element and add up sizes"
1 to: (sz := arrayOfByteObjs size) do:[:n | | e | 
  e := arrayOfByteObjs at: n .
  e charSize == 1 ifFalse:[ e _validateIsBytes ; _validateCharSizeIs: 1 ].
	totalBytes := totalBytes + e size .
 ].
totalBytes := totalBytes + sz . "one NUL terminating each string"
totalBytes := totalBytes +  (8 * sz)  .  "Add size for 8 byte pointers"
addExtraNull ifTrue:[ 
  totalBytes := totalBytes + 8  "Add space for terminating NULL pointer"
  ].
^ totalBytes
%

category: 'Instance Creation'
classmethod: CByteArray
computeSizeForArrayOfInt32: arrayOfInt32
  "Validate each element and compute the number of bytes needed to contain arrayOfInt32 in 
  an instance of the receiver which will represent an array of bytes in C."

| min max siz |
max := SmallInteger maximum32bitInteger .
min := SmallInteger minimum32bitInteger .
1 to: (siz := arrayOfInt32 size) do:[:n | | e |
    e := arrayOfInt32 at: n .
    e _isSmallInteger ifFalse:[  e _validateClass: SmallInteger ].
		(e < min or:[ e > max]) 
				ifTrue:[ e _error: #rtErrArgOutOfRange args: { min . max } ]
  ].
^ 4 * siz 
%

category: 'Instance Creation'
classmethod: CByteArray
computeSizeForArrayOfInt64: arrayOfInt64
   "Validate each element and compute the number of bytes needed to contain arrayOfInt64 in 
   an instance of the receiver which will represent an array of bytes in C."

  | sz |
  1 to: (sz := arrayOfInt64 size) do:[:n| | e |
    (e := arrayOfInt64 at:n) _isSmallInteger ifFalse:[ 
       e _isInteger ifTrue:[ | min max |
         (e > (max:=16r7fffffffffffffff) or:[ e < (min:=-16r8000000000000000)]) ifTrue:[ 
            e _error: #rtErrArgOutOfRange args: { min . max }  
          ].
       ] ifFalse:[
         e _validateClass: Integer ].
       ].
  ].
  ^ 8 * sz
%

category: 'Instance Creation'
classmethod: CByteArray
computeSizeForArrayOfUtf8Encoded: arrayOfStrings extraNullPointer: extraNullBoolean
  "Compute the number of bytes needed to contain arrayOfStrings in an instance of
   the receiver which will represent an array of bytes in C. Elements in arrayOfStrings
   must be kinds of String or MultiByteString. Space for a NULL character for each
   element is included in the total. If extraNullBoolean is true, space for an additional
   NULL element in the array of C pointers will be included."

| totalBytes sz |
totalBytes := 0.
1 to: (sz :=arrayOfStrings size) do:[:n |
  totalBytes := totalBytes + (arrayOfStrings at: n) sizeForEncodeAsUTF8
 ].
totalBytes := totalBytes + sz . "one NUL terminating each encoded string."
totalBytes := totalBytes + (sz * 8) .  "one pointer for each string"
extraNullBoolean ifTrue:[ totalBytes := totalBytes + 8 ].
^ totalBytes
%

category: 'Instance Creation'
classmethod: CByteArray
fromArrayEncodeUtf8: arrayOfStrings extraNullPointer: addExtraNull
  "Takes an array of String objects and creates a C array of pointers to UTF8 encoded bytes.
   Each element of arrayOfStrings must be a String or MultiByteString . 
   Space for a NUL character for each element is included in the total.
   If addExtraNull is true, an extra NULL pointer is appended to the list
   of pointers to terminate the list (some C functions require a terminating NULL)."

| inst |
inst := self gcMalloc: (self computeSizeForArrayOfUtf8Encoded: arrayOfStrings 
                              extraNullPointer: addExtraNull).
^ inst addUtf8Encoded: arrayOfStrings extraNullPointer: addExtraNull
%

category: 'Instance Creation'
classmethod: CByteArray
fromArrayOfByteObjects: arrayOfByteObjs extraNullPointer: addExtraNull
  "Takes an array of byte objects and creates a C array of pointers to bytes.
   Each element of arrayOfByteObjs must be a String; 
   DoubleByteString or QuadByteString are not allowed.
   Space for a NUL character for each element is included in the total.
   If addExtraNull is true, an extra NULL pointer is appended to the list
   of pointers to terminate the list (some C functions require a terminating NULL)."

| inst |
inst := self gcMalloc:(self computeSizeForArrayOfByteObjects: arrayOfByteObjs 
                              extraNullPointer: addExtraNull).
^ inst addArrayOfByteObjects: arrayOfByteObjs extraNullPointer: addExtraNull
%

category: 'Instance Creation'
classmethod: CByteArray
fromArrayOfInt32: arrayOfInt32s
   "Takes an array of 32-bit ints and creates a C array."

| inst |
inst := self gcMalloc: (self computeSizeForArrayOfInt32: arrayOfInt32s).
^ inst addArrayOfInt32: arrayOfInt32s
%

category: 'Instance Creation'
classmethod: CByteArray
fromArrayOfInt64: arrayOfInt64s
  "Takes an array of 64-bit ints and creates a C array."
| inst |
inst := self gcMalloc: (self computeSizeForArrayOfInt64: arrayOfInt64s).
^ inst addArrayOfInt64: arrayOfInt64s
%

category: 'Instance Creation'
classmethod: CByteArray
fromCharStar: aCPointer

 "no fence, not auto freed, primitive does strlen() to determine size"

^ self _newFrom: aCPointer offset: 0 numBytes: -1 gcFree: 0
%

category: 'Instance Creation'
classmethod: CByteArray
fromCharStarGcFree: aCPointer
 "no fence, will auto-free with free(), primitive does strlen() to determine size"

^ self _newFrom: aCPointer offset: 0 numBytes: -1 gcFree: AutoFree
%

category: 'Instance Creation'
classmethod: CByteArray
fromCPointer: aCPointer numBytes: anInt
 "no fence, not auto freed. aCPointer may also be aCByteArray"

^ self _newFrom: aCPointer offset: 0 numBytes: anInt gcFree: 0
%

category: 'Instance Creation'
classmethod: CByteArray
fromCPointerGcFree: aCPointer numBytes: anInt
 "no fence, will auto-free with free() "

^ self _newFrom: aCPointer offset: 0 numBytes: anInt gcFree: AutoFree
%

category: 'Instance Creation'
classmethod: CByteArray
fromRegionOf: aCByteArray offset: zeroBasedOffset numBytes: aSize
  ^ self _newFrom: aCByteArray offset: zeroBasedOffset numBytes: aSize gcFree: 0
%

category: 'Instance Creation'
classmethod: CByteArray
gcMalloc: numBytes
 "(with fence words, freed by in-memory GC, memory is zeroed"

^ self _newFrom: nil offset: 0 numBytes: numBytes gcFree: AutoFreeFenced
%

category: 'Instance Creation'
classmethod: CByteArray
malloc: numBytes
  "no fence words, never freed , or freed by a C function to be called,
   memory is zeroed.
   numBytes == -1 means encapsulate a NULL pointer. "

^ self _newFrom: nil offset: 0 numBytes: numBytes gcFree: 0
%

category: 'Private'
classmethod: CByteArray
new
 "disallowed"
  self shouldNotImplement: #new
%

category: 'Instance Creation'
classmethod: CByteArray
newNull
  "create an instance representing a NULL pointer."

  ^ self malloc: -1
%

category: 'Instance Creation'
classmethod: CByteArray
withAll: anObject

"anObject may be a String, ByteArray or CByteArray.
 Returns a new instance of the receiver containing a copy of
 the bytes of the argument.   If anObject is a String, the
 resulting ByteArray contains the bytes of the String plus
 a terminator byte with value zero.

 Use CByteArray class >> withAll:nullTerminate: for more control
 over terminator.

 Warning, ByteArray usually stores integers in big-endian order,
 not CPU native byte order."

^ self withAll: anObject nullTerminate: anObject _isOneByteString 
%

category: 'Instance Creation'
classmethod: CByteArray
withAll: anObject nullTerminate: aBoolean

"anObject may be a String, ByteArray, Utf8, Utf16 or CByteArray.
 Returns a new instance of the receiver containing a copy of
 the bytes of the argument.   If aBoolean==true the 
 resulting CByteArray contains the bytes of the argument plus
 a terminator byte (or Utf16 codepoint) with value zero.

 If argument is a Utf16, the result has code points in CPU byte order.

 Warning, ByteArray usually stores integers in big-endian order,
 not CPU native byte order."

  | res argSiz allocSiz isUtf16 termSize |
  isUtf16 := false .
  (anObject stringCharSize == 1 
   or:[ (anObject isKindOfClass: CByteArray)
   or:[ (anObject isKindOfClass: Utf8) 
   or:[ (isUtf16:= anObject isKindOfClass: Utf16) ]]]) ifFalse:[
       anObject _validateKindOfClasses: 
          { String . ByteArray . CByteArray . Utf8 . Utf16 }.
  ].
  argSiz := anObject size .
  termSize := aBoolean ifTrue:[ 1 ] ifFalse:[ 0 ] .
  isUtf16 ifTrue:[ 
     argSiz := anObject basicSize  . termSize := termSize + termSize .
  ].
  allocSiz := argSiz + termSize .
  res := self gcMalloc: allocSiz .
  argSiz ~~ 0 ifTrue:[
    res copyBytesFrom: anObject from: 1 to: argSiz into: 0 allowCodePointZero: true .
  ].
  ^ res
%

category: 'Instance Creation'
classmethod: CByteArray
_newFrom: aCPointer offset: anOffset numBytes: aSize gcFree: gcKind

"aCPointer may also be aCByteArray, or anInteger address.
 If aCPointer is a CByteArray with memory size 0 , it is assumed to
 be something like a  pointer field of a Struct which references another
 struct, and no checks are done for aSize <= anOffset + aCPointer.size "

<primitive: 711>
anOffset _validateClass: SmallInteger .
anOffset < 0 ifTrue:[ anOffset _error: #errArgTooSmall args:{ 0 } ].
aSize _validateClass: SmallInteger .
aSize < -1 ifTrue:[ aSize _error: #rtErrArgOutOfRange args:{ -1 } ].
gcKind _validateClass: SmallInteger .
aCPointer ifNotNil:[ | argCls |
  ((argCls:=aCPointer class) == CByteArray or:[ argCls == CPointer
        or:[ aCPointer _isInteger ]]) ifFalse:[
     ArgumentTypeError new name: 'aCPointer' expectedClass: { CPointer. CByteArray. Integer }
		actualArg: aCPointer ; signal
  ].
  (gcKind == 0 or:[ gcKind == 1]) ifFalse:[
     gcKind _error: #rtErrArgOutOfRange args:{ 0 . 1 } ].
  argCls == CByteArray ifTrue:[ | csz |
    (anOffset + aSize) >= (csz := aCPointer size) ifTrue:[
      (anOffset + aSize) _error: #errArgTooLarge args:{ csz } .
    ].
  ].
  aCPointer _isInteger ifTrue:[
    (aSize ~~ 0 or:[ gcKind ~~ 0]) ifTrue:[
      ArgumentError signal: 'invalid args for fromAddress:' .
    ].
  ].
] ifNil:[
  (gcKind == 0 or:[ gcKind == 2]) ifFalse:[ gcKind _error: #rtErrArgOutOfRange].
].
"if we get here malloc probably failed with no more C heap"
^ self _primitiveFailed: #_newFrom:offset:numBytes:gcFree:
       args: { aCPointer . anOffset . aSize . gcKind }
%

!		Instance methods for 'CByteArray'

category: 'Updating'
method: CByteArray
addArrayOfByteObjects: arrayOfByteObjs extraNullPointer: addExtraNull
  "Write the elements of arrayOfByteObjs, which must be a kinds of String (single-byte),
   to the receiver, starting at offset 1 of the argument and overwriting existing contents.
   Elements of arrayOfByteObjs must be a kinds of String,
   DoubleByteString and QuadByteString are not allowed.
   Signals an error if any of the elements of arrayOfByteObjs contain codePoint zero."

|arySize stringAddress stringOffset ptrOffset |
stringOffset := (arySize := arrayOfByteObjs size) * 8 .
"Leave room for terminating NULL in list of pointers if requested"
addExtraNull ifTrue:[ stringOffset := stringOffset + 8].
stringAddress := self memoryAddress + stringOffset .
ptrOffset := 0 .
1 to: arySize do:[:n | | e sz |
  e := arrayOfByteObjs at: n .
	sz := e size.
	self copyBytesFrom: e from: 1 to: sz into: stringOffset allowCodePointZero: false .
	stringOffset := stringOffset + sz .
	self uint8At: stringOffset put: 0 .
	stringOffset := stringOffset + 1 .
	self int64At: ptrOffset put: stringAddress  .
	ptrOffset := ptrOffset + 8 .
	stringAddress := stringAddress + (sz + 1) .
  ].
"Add terminating NULL to list of pointers if requested"
addExtraNull ifTrue:[ self int64At: ptrOffset put: 0 ].  
^self
%

category: 'Updating'
method: CByteArray
addArrayOfInt32: arrayOfInt32
   "Write the elements of arrayOfInt32 to the receiver, starting at offset 1 of the
   argument, and overwriting existing contents."

|offset|
offset := 0.
1 to: arrayOfInt32 size do:[:n| 
  self int32At: offset put: (arrayOfInt32 at: n).
  offset := offset + 4 
].
^self
%

category: 'Updating'
method: CByteArray
addArrayOfInt64: arrayOfInt64
   "Write the elements of arrayOfInt64 to the receiver, starting at offset 1 of the
   argument and overwriting existing contents."

|offset|
offset := 0.
1 to: arrayOfInt64 size do:[:n | 
  self int64At: offset put: (arrayOfInt64 at: n).
  offset := offset + 8 
].
^self
%

category: 'Updating'
method: CByteArray
addUtf8Encoded: arrayOfStrings extraNullPointer: addExtraNull
  "Write the elements of arrayOfStrings, which must be a kinds of String or
   MultiByteString, to the receiver, starting at offset 1 of the argument and 
   overwriting existing contents.
   Signals an Error if any of the elements of arrayOfStrings contain codePoint zero ."

| arySize stringAddress stringOffset ptrOffset |
stringOffset := (arySize := arrayOfStrings size) * 8 .
"Leave room for terminating NULL in list of pointers if requested"
addExtraNull ifTrue:[ stringOffset := stringOffset + 8].
stringAddress := self memoryAddress + stringOffset .
ptrOffset := 0 .
1 to: arySize do:[:n | |e sz |
  e := arrayOfStrings at: n .
	sz := self encodeUTF8From: e into: stringOffset allowCodePointZero: false .
	stringOffset := stringOffset + sz .
	self uint8At: stringOffset put: 0 .
	stringOffset := stringOffset + 1 .
	self int64At: ptrOffset put: stringAddress  .
	ptrOffset := ptrOffset + 8 .
	stringAddress := stringAddress + (sz + 1) .
].
"Add terminating NULL to list of pointers if requested"
addExtraNull ifTrue:[ self int64At: ptrOffset put: 0 ].  
^self
%

category: 'Formatting'
method: CByteArray
asString
  | res |
  (res := super asString ) add: self _inspect .
  ^ res
%

category: 'Accessing'
method: CByteArray
autoRelease
  ^ (info bitAnd: AutoFree) ~~ 0  "fixed 48558"
%

category: 'Updating'
method: CByteArray
autoRelease: aBoolean

"change the auto-free behavior of the receiver's C to match aBoolean.
 Generates an error if the receiver has VmOwned or Fenced bits set.
"

<primitive: 866>
self _primitiveFailed: #autoRelease: args: { aBoolean }
%

category: 'Copying'
method: CByteArray
byteArrayFrom: zeroBasedStart to: zeroBasedEnd

 "return a new ByteArray containing the specified bytes of the receiver."

^ self _copyFrom: zeroBasedStart to: zeroBasedEnd resKind: ByteArray
%

category: 'Copying'
method: CByteArray
CByteArrayFrom: zeroBasedStart to: zeroBasedEnd
 "return a new CByteArray , auto freed, containing specified bytes of receiver."

^ self _copyFrom: zeroBasedStart to: zeroBasedEnd resKind: CByteArray
%

category: 'Updating'
method: CByteArray
ccallinAt: zeroBasedOffset put: aCCallin
  "Store the C address for a bound CCallin. Returns receiver."
  self _signed: 10 at: zeroBasedOffset truncatePut: aCCallin .
  self _updateReferences: zeroBasedOffset value: aCCallin .
%

category: 'Accessing elements'
method: CByteArray
ccalloutAt: zeroBasedStart name: aString result: resType args: argumentTypes
  "Return a CCallout which encapsulates the pointer at zeroBasedStart in
   the receiver as a C function that can be be called.
   resType and argumentTypes must conform to documentation in
     CCallout class >> library:name:result:args:
   "
  | fAddr cco |
  fAddr := self pointerAt: zeroBasedStart resultClass: CPointer .
  cco := CCallout library: nil name: aString result: resType args: argumentTypes  .
  cco _bindFunction: fAddr .
  ^ cco
%

category: 'Updating'
method: CByteArray
ccalloutAt: zeroBasedOffset put: aCCallout
  "Store the C address for a CCallout. Returns receiver."

  (aCCallout isKindOf: CCallout) ifFalse:[ aCCallout _validateClass: CCallout].
  aCCallout bind .
  self _signed: 11 at: zeroBasedOffset truncatePut: aCCallout
%

category: 'Copying'
method: CByteArray
copy
 "disallowed"
  self shouldNotImplement: #copy
%

category: 'Updating'
method: CByteArray
copyBytesFrom: anObject from: oneBasedStart to: oneBasedEnd into: zeroBasedDestOffset
  ^ self copyBytesFrom: anObject from: oneBasedStart to: oneBasedEnd into: zeroBasedDestOffset
       allowCodePointZero: false .
%

category: 'Updating'
method: CByteArray
copyBytesFrom: anObject from: oneBasedStart to: oneBasedEnd into: zeroBasedDestOffset allowCodePointZero: zeroBoolean

"Copy the specified bytes of anObject into the receiver at the given offset.
 AnObject may be any byte format object or a CByteArray.

 An error is signalled of any of the following are true
    oneBasedStart < 1
    zeroBasedDestOffset < 0
    self size > 0 and:[ zeroBasedDestOffset >= self size ]

 If zeroBoolean==false and anObject is not a CByteArray 
 and anObject contains a byte, word, or codePoint with value zero,
 signals an error .

 Returns number of bytes copied (possibly zero) .

 Warning, ByteArray usually stores integers in big-endian order,
 not CPU native byte order. Most other byte format classes
 use CPU native byte order."

<primitive: 713>
zeroBasedDestOffset _validateClass: SmallInteger .
oneBasedStart _validateClass: SmallInteger .
oneBasedEnd _validateClass: SmallInteger .
zeroBoolean _validateClass: Boolean .

"if we get here, either receiver or a CByteArray passed as anObject
 is probably a committed instance that has been faulted in and has no Cdata."
self _primitiveFailed: #copyBytesFrom:from:to:into:
     args: { anObject . oneBasedStart .  oneBasedEnd . zeroBasedDestOffset . zeroBoolean }
%

category: 'Copying'
method: CByteArray
copyFrom: anObj from: oneBasedStart to: oneBasedEnd into: zeroBasedDestOffset

"anObject may be a String, ByteArray or CByteArray .
 copies specified bytes of anObject into receiver .

 An error is signalled of any of the following are true
    oneBasedStart < 1
    zeroBasedDestOffset < 0
    self size > 0 and:[ zeroBasedDestOffset >= self size ]

 The number of bytes copied may be zero.
 The method copyBytesFrom:from:to:into:   returns the number of bytes copied.

 Warning, ByteArray usually stores integers in big-endian order,
 not CPU native byte order."

 self copyBytesFrom: anObj from: oneBasedStart to: oneBasedEnd into: zeroBasedDestOffset allowCodePointZero: true .
 ^ self
%

category: 'Copying'
method: CByteArray
decodeUTF8from: zeroBasedStart to: zeroBasedEnd unicode: unicodeBoolean
  "Decode the UTF8 encoded bytes of the receiver from zeroBasedStart to zeroBasedEnd ;
   if unicodeBoolean==false returns a String, DoubleByteString or QuadByteString ,
   if unicodeBoolean==true  returns a Unicode7 , Unicode16 or Unicode32 . 
  If zeroBasedEnd == -1,  strlen() is used starting from zeroBasedStart
  to determine the number of bytes to be decoded."
 
 <primitive: 357>
 zeroBasedStart _validateClass: SmallInteger .
 zeroBasedEnd _validateClass: SmallInteger .
 unicodeBoolean _validateClass: Boolean .
 self _primitiveFailed: #decodeUTF8from:to:unicode: args: { zeroBasedStart . zeroBasedEnd . unicodeBoolean }.
%

category: 'Accessing'
method: CByteArray
derivedFrom: aCByteArray
  "used to ensure that aCByteArray is kept alive by GC as long
   as receiver is alive. "
  derivedFrom := aCByteArray
%

category: 'Accessing elements'
method: CByteArray
doubleAt: zeroBasedOffset
 "fetch 8 byte float and return a Float or SmallDouble"
 ^ self _unsigned: 0 at: zeroBasedOffset
%

category: 'Updating'
method: CByteArray
doubleAt: zeroBasedOffset put: aFloat
  "store a Float or SmallDouble into 64bits"
  self _signed: 9 at: zeroBasedOffset put: aFloat
%

category: 'Updating'
method: CByteArray
doubleAt: zeroBasedOffset truncatePut: aFloat
  "store a Float or SmallDouble into 64bits"
  self _signed: 0 at: zeroBasedOffset truncatePut: aFloat
%

category: 'Updating'
method: CByteArray
encodeUTF8From: anObject into: zeroBasedDestOffset allowCodePointZero: zeroBoolean
 "anObject may be a String or MultiByteString .
  The codepoints in anObject are encoded into UTF8 and the resulting
  UTF8 bytes are copied into the receiver starting at zeroBasedDestOffset . 

  If zeroBoolean==false, signals an Error if anObject contains codePoint zero.

  Returns a SmallInteger, possibly zero, the number of UTF8 bytes copied into
  the receiver.  There is no terminating NUL byte written to the destination"

 <primitive: 331>
 zeroBasedDestOffset _validateClass: SmallInteger .
 anObject _validateClasses:{ String . MultiByteString }.
 zeroBoolean _validateClass: Boolean .
 self _primitiveFailed: #encodeUTF8From:into:allowCodePointZero: 
     args: { anObject . zeroBasedDestOffset . zeroBoolean }
%

category: 'Accessing elements'
method: CByteArray
floatAt: zeroBasedOffset
 "fetch 4 byte float and return a Float or SmallDouble"
 ^ self _unsigned: 9 at: zeroBasedOffset
%

category: 'Updating'
method: CByteArray
floatAt: zeroBasedOffset put: aFloat
  "store a Float or SmallDouble into 32bits.
  if aFloat would loose exponent bits
  or convert a non-zero to a zero when converted to
  a 4 byte C float, signals an error."
  self _signed: 10 at: zeroBasedOffset put: aFloat
%

category: 'Updating'
method: CByteArray
floatAt: zeroBasedOffset truncatePut: aFloat
  "store a Float or SmallDouble into 32bits"
  self _signed: -1 at: zeroBasedOffset truncatePut: aFloat
%

category: 'Accessing'
method: CByteArray
gcFreeKind
  ^ info bitAnd: GcFreeMask
%

category: 'Private'
method: CByteArray
instVarAt: offset put: value

 "disallowed"
 self shouldNotImplement: #instVarAt:put:
%

category: 'Accessing elements'
method: CByteArray
int16At: zeroBasedOffset
 "return specified signed 16 bit integer"
  ^ self _signed: 2 at: zeroBasedOffset  with: nil
%

category: 'Updating'
method: CByteArray
int16At: zeroBasedOffset put: anInteger
  "check that anInteger is representable in 16 bits and store"
  self _signed: -2 at: zeroBasedOffset put: anInteger
%

category: 'Updating'
method: CByteArray
int16At: zeroBasedOffset truncatePut: anInteger
  "truncate anInteger to 16 bits and store"
  self _signed: 2 at: zeroBasedOffset truncatePut: anInteger
%

category: 'Accessing elements'
method: CByteArray
int32At: zeroBasedOffset
 "return specified signed 32 bit integer"
  ^ self _signed: 4 at: zeroBasedOffset  with: nil
%

category: 'Updating'
method: CByteArray
int32At: zeroBasedOffset put: anInteger
  "check that anInteger is representable in 32 bits and store"
  self _signed: -4 at: zeroBasedOffset put: anInteger
%

category: 'Updating'
method: CByteArray
int32At: zeroBasedOffset truncatePut: anInteger
  "truncate anInteger to 32 bits and store"
  self _signed: 4 at: zeroBasedOffset truncatePut: anInteger
%

category: 'Accessing elements'
method: CByteArray
int64At: zeroBasedOffset

 "return specified signed 64 bit integer"
  ^ self _signed: 8 at: zeroBasedOffset  with: nil
%

category: 'Updating'
method: CByteArray
int64At: zeroBasedOffset put: anInteger
  "check that anInteger is representable in 64 bits and store"
  self _signed: -8 at: zeroBasedOffset put: anInteger
%

category: 'Updating'
method: CByteArray
int64At: zeroBasedOffset truncatePut: anInteger
  "truncate anInteger to 64 bits and store"
  self _signed: 8 at: zeroBasedOffset truncatePut: anInteger
%

category: 'Accessing elements'
method: CByteArray
int8At: zeroBasedOffset

 "return specified signed 8 bit integer"
  ^ self _signed: 1 at: zeroBasedOffset  with: nil
%

category: 'Updating'
method: CByteArray
int8At: zeroBasedOffset put: anInteger
  "check that anInteger is representable in 8 bits and store"
  self _signed: -1 at: zeroBasedOffset put: anInteger
%

category: 'Updating'
method: CByteArray
int8At: zeroBasedOffset truncatePut: anInteger
  "truncate anInteger to 8 bits and store"
  self _signed: 1 at: zeroBasedOffset truncatePut: anInteger
%

category: 'Accessing'
method: CByteArray
isDead
  ^ (info bitAnd: AppDeadMask) ~~ 0
%

category: 'Accessing elements'
method: CByteArray
memoryAddress
  "Returns the starting address of the C memory, as a signed 64bit Integer."
  ^ self _signed: 8 at: -2 with: nil
%

category: 'Updating'
method: CByteArray
memset: anInt from: zeroBasedStart to: zeroBasedEnd

 "set specified bytes of the receiver to the value anInt .
  end==-1 means to the end of the receiver.
  anInt must be >=0  and <= 255 . "

 <primitive: 712>
 | sz |
 anInt _validateClass: SmallInteger .
 (anInt < 0 or:[ anInt > 255]) ifTrue:[
   anInt _error: #rtErrArgOutOfRange args:{ 0 . 255 }
 ].
 zeroBasedStart _validateClass: SmallInteger .
 sz := self size .
 (zeroBasedStart < 0 or:[ zeroBasedStart >= sz ]) ifTrue:[
   zeroBasedStart _error: #rtErrArgOutOfRange args:{ 0 . sz - 1 }
 ].
 zeroBasedEnd _validateClass: SmallInteger .
 (zeroBasedEnd < -1 or:[ zeroBasedEnd >= sz ]) ifTrue:[
   zeroBasedEnd _error: #rtErrArgOutOfRange: args:{ -1 . sz - 1 }
 ].
 "if we get here the receiver is probably a committed instance that
  has been faulted in and has no Cdata."
 self _primitiveFailed: #memset:from:to:
      args: { anInt . zeroBasedStart . zeroBasedEnd }
%

category: 'Instance Creation'
method: CByteArray
newFrom: anOffset numBytes: anInt
 "Returns a new instance of CByteArray representing a portion
  of the receiver.  no fence, not auto freed,
  anInt == -1 means  numBytes == strlen(self.memory) - anOffset .
  anInt == -2 means  numBytes == self.memory_size - anOffset .
  anOffset is zero based"

^ CByteArray _newFrom: self offset: anOffset numBytes: anInt gcFree: 0
%

category: 'Updating'
method: CByteArray
pointerAt: zeroBasedOffset put: aCByteArray
  self _signed: 9 at: zeroBasedOffset truncatePut: aCByteArray .
  self _updateReferences: zeroBasedOffset value: aCByteArray .
%

category: 'Accessing elements'
method: CByteArray
pointerAt: zeroBasedOffset resultClass: aClass
  "Result is an instance of aClass encapsulating the C pointer
   fetched from 8 bytes of the receiver starting at zeroBasedOffset.
   zeroBasedOffset may need to be aligned on 8 bytes on some CPUs.
   aClass must be CByteArray, CPointer, a subclass of CByteArray
   or a subclass of CPointer."

  ^ self _signed: 10 at: zeroBasedOffset with: aClass
%

category: 'Accessing'
method: CByteArray
setDead
  "sets the isDead bit, without marking object dirty"
  <primitive: 847>
  self _primitiveFailed: #setDead
%

category: 'Accessing'
method: CByteArray
size
  "The result may be zero if the receiver encapsulates memory for
   which the size is not known, such as instances created by class methods
     fromCharStar:
     fromCharStarGcFree:
   Instances created by the class methods
     fromCPointer:numBytes:
     fromCPointerGcFree:numBytes:
     fromRegionOf:offset:numBytes:
   will haave the size known ."

  ^ info bitShift: -4
%

category: 'Copying'
method: CByteArray
stringFrom: zeroBasedStart
 "return a new String containing the bytes of the receiver 
  from specified start byte to the first byte preceeding a zero byte.
 
  Interprets the data starting at &body[zeroBasedStart] as 
  NUL terminated char*  data , and returns an instance of String containing
  that data."

^ self _copyFrom: zeroBasedStart to: -1 resKind: String
%

category: 'Copying'
method: CByteArray
stringFrom: zeroBasedStart to: zeroBasedEnd
 "return a new String containing the specified bytes of the receiver."

^ self _copyFrom: zeroBasedStart to: zeroBasedEnd resKind: String
%

category: 'Accessing elements'
method: CByteArray
stringFromCharStarAt: zeroBasedOffset
  "Using the 8 bytes starting at zeroBasedOffset as a 'char *' type, 
   return a String with the contents of the referenced C-string."

  ^ self _signed: 9 at: zeroBasedOffset with: nil
%

category: 'Copying'
method: CByteArray
strlenFrom: zeroBasedStart
  "Return result of strlen() starting from the byte of receiver specified by zeroBasedStart."

  ^ self _copyFrom: zeroBasedStart to: -1 resKind: nil .
%

category: 'Accessing elements'
method: CByteArray
uint16At: zeroBasedOffset
 "return specified unsigned 16 bit integer"
 ^ self _unsigned: 2 at: zeroBasedOffset
%

category: 'Updating'
method: CByteArray
uint16At: zeroBasedOffset put: anInteger
  "check that anInteger is representable in 16 bits and store"
  self _signed: 2 at: zeroBasedOffset put: anInteger
%

category: 'Accessing elements'
method: CByteArray
uint32At: zeroBasedOffset
 "return specified unsigned 32 bit integer"
 ^ self _unsigned: 4 at: zeroBasedOffset
%

category: 'Updating'
method: CByteArray
uint32At: zeroBasedOffset put: anInteger
  "check that anInteger is representable in 32 bits and store"
  self _signed: 4 at: zeroBasedOffset put: anInteger
%

category: 'Accessing elements'
method: CByteArray
uint64At: zeroBasedOffset
 "return specified unsigned 64 bit integer"
 ^ self _unsigned: 8 at: zeroBasedOffset
%

category: 'Updating'
method: CByteArray
uint64At: zeroBasedOffset put: anInteger
  "check that anInteger is representable in 64 bits and store"
  self _signed: 8 at: zeroBasedOffset put: anInteger
%

category: 'Accessing elements'
method: CByteArray
uint8At: zeroBasedOffset
 "return specified unsigned 8 bit integer"
 ^ self _unsigned: 1 at: zeroBasedOffset
%

category: 'Updating'
method: CByteArray
uint8At: zeroBasedOffset put: anInteger
  "check that anInteger is representable in 8 bits and store"

  self _signed: 1 at: zeroBasedOffset put: anInteger
%

category: 'Copying'
method: CByteArray
utf16From: zeroBasedStart to: zeroBasedEnd
 "return a new Utf16 containing the specified bytes of the receiver."

^ self _copyFrom: zeroBasedStart to: zeroBasedEnd resKind: Utf16
%

category: 'Copying'
method: CByteArray
utf8From: zeroBasedStart to: zeroBasedEnd

 "return a new Utf8 containing the specified bytes of the receiver."

^ self _copyFrom: zeroBasedStart to: zeroBasedEnd resKind: Utf8
%

category: 'Private'
method: CByteArray
_copyFrom: zeroBasedStart to: zeroBasedEnd resKind: aClass
  "zeroBasedStart, zeroBasedEnd must be SmallInteger in range
    of the receiver's C memory.
   if zeroBasedEnd == -1,  a search for a NUL byte is done to determine the length
   aClass must be CByteArray, String, ByteArray, Utf8, Utf16, or nil.
   if aClass == nil, result is number of bytes from zeroBasedStart to the
   first NUL byte,  i.e. strlen() "

<primitive: 714>
zeroBasedStart _validateClass: SmallInteger .
zeroBasedEnd _validateClass: SmallInteger .
"at this point byteSize or zeroBasedOffset are probably out of range,
  or aClass is invalid"
^self _primitiveFailed: #_copyFrom:to:resKind:
      args: { zeroBasedStart . zeroBasedEnd . aClass }
%

category: 'Formatting'
method: CByteArray
_inspect
  | res |
  (res := String new)
    add: ' size='; add: self size asString ;
    add: ' gcFree=0x'; add: self gcFreeKind asHexString ;
    add: ' dead='; add: self isDead asString ;
    add: ' address=0x' ; add: self memoryAddress asHexString .
  ^ res
%

category: 'Updating'
method: CByteArray
_signed: byteSize at: zeroBasedOffset put: aValue

"byteSize describes bytes of the receiver into which
 aValue is to be stored:
    1, 2, 4, or 8 - unsigned integer of specified size
   -1, -2, -4, -8 - signed integer of specified size
    9 -  8 byte C double
    10 - 4 byte C float
 Stores into the specified bytes of the receiver in CPU native byte order
 the specified least sigificant bytes of aValue .
 There is no required alignment for zeroBasedOffset.
 If aValue is an Integer and would loose bits by truncating
 to the specified size, an error is signaled.
 If aValue is a Float, and truncation would loose exponent bits
 or convert a non-zero to a zero, an error is signalled.
"
 <primitive: 246>
 byteSize _validateClass: SmallInteger .
 zeroBasedOffset _validateClass: SmallInteger .
 (byteSize == 9 or:[ byteSize == 10]) ifTrue:[
   aValue _validateClasses: { Float . SmallFloat } .
 ] ifFalse:[
   (aValue isKindOf: Integer) ifTrue:[
     ArgumentError signal:'argument out of range for destination'
   ].
   aValue _validateClass: Integer.
 ].
 "at this point byteSize is invalid"
 self _primitiveFailed: #_signed:at:put:
     args: { byteSize . zeroBasedOffset . aValue }
%

category: 'Updating'
method: CByteArray
_signed: byteSize at: zeroBasedOffset truncatePut: aValue

"byteSize describes bytes of the receiver into which
 aValue will be stored:
    -1 - 4 byte C float
    0 -  8 byte C double
    1, 2, 4, or 8 - integer of specified size
    9  -  aValue is a CByteArray( or nil)
          address of Cdata of CByteArray (or NULL)
         is to be stored for pointerAt:put:  ,
          or aValue is a CPointer, the encapsulated C pointer
         is to be stored for pointerAt:put:  ,
   10 - value is a CCallin or nil ,
        The native code address to be used for a call back , or NULL
         is to be stored for ccallinAt:put: .
   11 - value is a CCallout or nil ,
        The native code address to be used for a call out , or NULL
         is to be stored for ccalloutAt:put: .
 Stores into the specified bytes of the receiver in CPU native byte order
 the specified least sigificant bytes of aValue .
 There is no required alignment for zeroBasedOffset.
 If aValue is a Float and truncation to 4 byte C float
 would loose exponent bits and produce an Infinity
 an error is signaled, otherwise aValue is silently
 truncated as needed to fit in the destination bytes.
"

<primitive: 717>
byteSize _validateClass: SmallInteger .
zeroBasedOffset _validateClass: SmallInteger .
aValue ifNotNil:[ aValue _validateClass: CByteArray ].
(byteSize < -1 or:[ byteSize > 11]) ifTrue:[
   ArgumentError new name:'byteSize'; signal:'invalid byteSize arg'
].
byteSize <= 0 ifTrue:[ aValue _validateClasses: { Float . SmallFloat } ].
byteSize == 9 ifTrue:[
 aValue ifNotNil:[ aValue _validateClasses:{ CByteArray . CPointer }]
].
byteSize == 10 ifTrue:[
 aValue ifNotNil:[ aValue _validateClass: CCallin ].
].
byteSize == 11 ifTrue:[
 aValue ifNotNil:[ aValue _validateClass: CCallout ].
].
aValue _validateClass: Integer.
self _primitiveFailed: #_signed:at:truncatePut:
     args: { byteSize . zeroBasedOffset . aValue }
%

category: 'Accessing elements'
method: CByteArray
_signed: byteSize at: zeroBasedOffset with: thirdArg

"byteSize must be 1, 2, 4, 8, 9 or 10

 If receiver is of size 8, zeroBasedOffset == -1 , and byteSize 1 2 or 4,
 accesses the value  (self int64At:0) in native byte order and 
 returns the specified number of least signifigant bytes of that value,
 as would have been stored by a function arg
 of type  char* , short*, or int*   

 If zeroBasedOffset == -2 , and byteSize == 8,
 returns the starting address of the C memory, as a signed 64bit Integer.
 There is no required alignment for zeroBasedOffset.

 if byteSize == 9 , treats the 8 bytes at zeroBasedOffset
   as a  char*  pointer and returns nil if the pointer is NULL,
   or a new String based on strlen() of that pointer

 if byteSize == 10,  thirdArg is a subclass of CByteArray or CPointer,
   create an instance of thirdArg which encapsulates a C pointer fetched from
   the specified zeroBasedOffset in receiver's C memory .
"
<primitive: 715>
self _primitiveFailed: #_signed:at:with:
     args: { byteSize . zeroBasedOffset . thirdArg }
%

category: 'Accessing elements'
method: CByteArray
_unsigned: byteSize at: zeroBasedOffset

"For byteSize one of 0(double) 1, 2, 4, 8, 9(float)
   For zeroBasedOffset >= 0 , returns the integer
   of specified byte size , or the 8 byte double,
   starting at specified offset.

 If receiver is of size 8, zeroBasedOffset == -1 , and byteSize 1 2 or 4,
 accesses the value  (self int64At:0) in native byte order and 
 returns the specified number of least signifigant bytes of that value.

 If byteSize == -1, then receiver is searched for a byte value of 0
 starting at zeroBasedOffset, and the zero-based offset of the
 first such byte is returned, or -1 returned of no such byte found.

 There is no required alignment for zeroBasedOffset.
"

<primitive: 716>
self _primitiveFailed: #_unsigned:at:
     args: { byteSize . zeroBasedOffset }
%

category: 'Updating'
method: CByteArray
_updateReferences: zeroBasedOffset value: anObject
  | childs idx |
  anObject ifNotNil:[
    (childs := referencesTo) ifNil:[
      childs  := Array new .
      referencesTo := childs .
    ].
    childs size < (idx := zeroBasedOffset+1) ifTrue:[ childs size: idx ].
    childs at: idx put: anObject .
  ] ifNil:[
    (childs := referencesTo) ifNotNil:[
      idx := zeroBasedOffset + 1.
      childs size >= idx ifTrue:[ childs at: idx put: nil ].
    ]
  ]
%

! Class extensions for 'CCallin'

!		Class methods for 'CCallin'

removeallmethods CCallin
removeallclassmethods CCallin

category: 'Instance creation'
classmethod: CCallin
name: aName result: resType args: argumentTypes
  ^ self name: aName result: resType args: argumentTypes envId: 0"default smalltalk"
%

category: 'Instance creation'
classmethod: CCallin
name: aName result: resType args: argumentTypes  envId: envId

"aName, resType are per comments in  CCallout(C)>>library:name:result:args: .

 argumentTypes must specify all of the arguments to be passed ,
 per comments in  library:name:result:args:  argumentTypes may not contain
 a CCallin .

 resType may not be a CCallin

 C varargs are not allowed
"
  | res |
  (res := self _basicNew)
      _name: aName result: resType
			args: argumentTypes varArgsAfter: -1 ;
     envId: envId  .
  res immediateInvariant . "uses must make a copy"
  ^ res
%

!		Instance methods for 'CCallin'

category: 'Accessing'
method: CCallin
callinName
  ^ fName
%

category: 'Binding'
method: CCallin
copyBindTo: aBlock

"Return a copy of the receiver which is bound to
 the specified block.  The result would typically be
 used as second arg to CByteArray>>ccallinAt:put:  when
 building an Array of function pointers."

^ self _copyForCFunction _bindTo: aBlock
%

category: 'Initialization'
method: CCallin
envId: anEnvId

  envId := anEnvId
%

category: 'Private'
method: CCallin
_bindTo: aBlock

"Install aBlock as the code to be executed when
 the receiver is called from C ."

<primitive: 324>
aBlock _validateClass: ExecBlock .
self _primitiveFailed: #_bindTo:
      args: { aBlock }
%

category: 'Private'
method: CCallin
_copyForCFunction

 | res |
  "must use _basicNew to create cData slot"
 (res := self class _basicNew)
   _fname: fName argTypes: argTypes resultType: resultType
        cTypes: cTypes argCounts: argCounts
        argTypesDict: argTypesDict envId: envId  .
 ^ res
%

category: 'Private'
method: CCallin
_fname: afName argTypes: aargTypes resultType: aresultType
  cTypes: acTypes argCounts: aargCounts
  argTypesDict: aargTypesDict envId: aenvId

  fName := afName  .
  argTypes := aargTypes  .
  resultType := aresultType .
  cTypes := acTypes  .
  argCounts := aargCounts .
  argTypesDict := aargTypesDict  .
  envId := aenvId  .
%

! Class extensions for 'CCallout'

!		Class methods for 'CCallout'

removeallmethods CCallout
removeallclassmethods CCallout

category: 'Calling'
classmethod: CCallout
errno

"Returns the SmallInteger value of the current GsProcess's ffiErrno.
 ffiErrno is used and updated by CCallout >> callWith: ."

^ self _errno: -1
%

category: 'Calling'
classmethod: CCallout
errno: aSmallInteger
 "Stores aSmallInteger into the current GsProcess's ffiErrno ,
  and returns the previous value of ffiErrno as a SmallInteger."

aSmallInteger _isSmallInteger ifFalse:[
  aSmallInteger _validateClass: SmallInteger .
].
(aSmallInteger >= 0 and:[ aSmallInteger <= 16r7fffffff]) ifFalse:[
  OutOfRange new
    name: 'errno' min: 0 max: 16r7fffffff actual: aSmallInteger ;
    signal
].
^ self _errno: aSmallInteger
%

category: 'Instance creation'
classmethod: CCallout
library: aCLibrary name: aName result: resType args: argumentTypes

" aCLibrary may be a CLibrary,  or nil if current process should
  be searched with dlsym(),
  or an Array of CLibraries to be searched.
  See CFunction(C)>>comment for more details.

  aName must be a String .  It will be used as arg to dlsym() at the first
  time the function is called.

  resType is one of
    #int64    -->  C function returns an int64, or any unsigned C integer
                smaller than 64bits ; call will return an Integer
    #uint64   -->  C function returns a uint64 ; call will return an Integer
    #int32    -->  C function returns a signed C integer 32bits or smaller;
		   call will return a SmallInteger;
		   #int64 can be used instead of #int32 on Sparc only .
    #uint32   -->  C function returns a C uint ; call returns a SmallInteger.
    #int16    -->  C function returns a C short ; call returns a SmallInteger
    #uint16   -->  C function returns a C ushort ; call returns a SmallInteger
    #int8     -->  C function returns a C char ; call returns a SmallInteger
    #uint8    -->  C function returns a C uchar ; call returns a SmallInteger

    #bool     --  C function returns zero or non-zero C integer of any size
                     call returns TRUE or FALSE
    #double    -->  C function returns an C double,
                call will return a SmallDouble or Float .
    #float     -->  C function returns an C float,
                call will return a SmallDouble or Float .
    #ptr      -->  call will return nil or a CPointer
    #'char*'  -->  call will return nil or a String
    #void     -->  call always returns nil

  argumentTypes is an Array of zero or more elements. Each element is one of
    #int64     --> arg must be an Integer representable as a C int64
    #uint64    --> arg must be an Integer representable as a C uint64
    #int32     --> arg must be an Integer representable as a C 32bit int
    #uint32    --> arg must be an Integer representable as a C 32bit uint
    #int16     --> arg must be an Integer representable as a C 16bit short
    #uint16    --> arg must be an Integer representable as a C 16bit ushort
    #int8     --> arg must be an Integer representable as a C 8 bit signed char
    #uint8    --> arg must be an Integer representable as a C 8 bit uchar

    #bool     --> arg must ba a Boolean

    #double    --> arg must be a SmallDouble or Float ,
    #float    --> arg must be a SmallDouble or Float
    #ptr       --> arg must be nil, a CByteArray or a CPointer  ,
                if nil , C  NULL is passed .
		if CByteArray, address of body is passed .
                if CPointer, the encapsulated  pointer is passed .
    #'&ptr'    -->  arg must be a CPointer whose value
                  will be passed and updated on return.
    #'char*'   --> arg must be a non-nil String in which case
               body is copied to C memory before call and copied
                from C memory (and possible grown/shrunk) after call.
                C memory will not be valid after the call finishes.
                The C memory copy of the String has a zero byte appended.
                Unicode7 is allowed. Utf8, Uncode16, Unicode32 are not allowed.
    #'const char*'  --> arg must be nil( to pass NULL)
                or a String or Utf8 (body is copied to C memory before call) 
                C memory will not be valid after the call finishes.
                The C memory copy of the String has a zero byte appended.
                Unicode7 is allowed. Uncode16, Unicode32 are not allowed.
    #'const UChar*'  --> arg must be nil (to pass NULL)
 	 or a Unicode7, Uncode16, or Unicode32, or Utf8.
         The body of the string is copied to C memory in UTF16 form before
         the call.
         The C memory copy has a codepoint zero appended.
         C memory will not be valid after the call finishes.

    #'UChar*' --> arg must be a Unicode7, Uncode16, or Unicode32.
         The body of the string is copied to C memory in UTF16 form before
         the call, and copied back from C memory after the call.
         The C memory copy has a codepoint zero appended.
         The copy back may grow or shrink the arg, and may become the arg
         to a Uncode16 or a Unicode32.


    Note C strings which should persist in C memory after a function call
    should be passed using CByteArray created from an instance of String.

    When native code is disabled in the gem config file, use of double or
    float args imply a maximum of 4 arguments , excluding var args .
"
  | res |
  (res := self _basicNew) _setLibrary: aCLibrary ;
     _name: aName result: resType args: argumentTypes varArgsAfter: -1 .
  ^ res

%

category: 'Instance creation'
classmethod: CCallout
library: aCLibrary name: aName result: resType args: argumentTypes
varArgsAfter: varArgsAfter

"aCLibrary, aName, resType are per comments in  library:name:result:args: .

 argumentTypes must specify all of the arguments to be passed ,
 per comments in  library:name:result:args:  .

 If C varargs allowed, varArgsAfter must be >=0   and
    <  argumentTypes size   , and must also be <=4  ,
 else varArgsAfter==-1 to denote no varargs .

 For example, if varArgsAfter==3 and  (argumentTypes size == 5)
 and none of argumentTypes or resType specify #double,
 a C function call of the form
    f(a,b,c,d,e);
 will be made using a prototype of the form
    intptr_t f(intptr_t a, intptr_t b, intptr_t c, ...);
"
  | res |
  (res := self _basicNew) _setLibrary: aCLibrary ;
      _name: aName result: resType
			args: argumentTypes varArgsAfter: varArgsAfter .
  ^ res
%

category: 'Private'
classmethod: CCallout
_errno: aSmallInteger

"If aSmallInteger == -1, Returns the SmallInteger value of the
 current GsProcess's  ffiErrno .
 If aSmallInteger >= 0, stores aSmallInteger into the GsProcess's ffiErrno state.  
 ffiErrno is used and updated by CCallout >> callWith: . "

<primitive: 474>
aSmallInteger _validateClass: SmallInteger .
^ self _primitiveFailed: #_errno: args: { aSmallInteger }
%

!		Instance methods for 'CCallout'

category: 'Private'
method: CCallout
bind
  "Attempt to resolve the C function described by the receiver,
   using dlopen() if needed, and dlsym() ."

  <primitive: 529>
  lastError ifNotNil:[   "lastError was set by the primitive"
     ^ ArgumentError signal: lastError .
  ].
  self _primitiveFailed: #bind
%

category: 'Calling'
method: CCallout
callWith: argsArray

"invoke the function described by the receiver.
 First send of this method during a lifetime of the receiver in memory
 triggers dlopen() (if needed) , dlsym() , and generation of native code for
 callout stub(if native code enabled by configuration file) .
 If function expects zero args,  argsArray must be an empty array or nil.
 If function supports varArgs, then the variable args come after the
 fixed arguments in argsArray, and each variable arg is represented
 as 2 elements of argsArray,
    a typeSymbol, and an argValue .
 The typeSymbol must occur as a key in the class variable ArgTypesDict.
 If native code configured, uses the callout stub's native
 code to marshal arguments into C register/stack, else uses a C switch
 statement which only supports a limited range of function signatures
 and does not support C float arguments .

 See  CCallout class >>library:name:result:args:  for further details.

 The current GsProcess contains a field    int  ffiErrno which
 is initialized to zero at GsProcess creation .
 Before calling the function, this primitive executes   errno = ffiErrno .
 After the function returns the primitive excecutes  ffiErrno = errno .
 ffiErrno is accessable with the methods  CCallout class >> errno
 and CCallout class >> errno:  . "

<primitive: 710>
| nPassed nRequired |
lastError ifNotNil:[   "lastError was set by the primitive"
   ^ ArgumentError signal: lastError .
].
argsArray class == Array ifFalse:[
  ArgumentTypeError new name:'argsArray' expectedClass: Array actualArg: argsArray ;
       signal .
].
(nPassed := argsArray size) == (nRequired := argTypes size) ifFalse:[
  ArgumentError new signal:
    nPassed asString , ' args given , ' , nRequired asString, ' args required for:  ' ,
      self signatureString .
].
^ self _primitiveFailed: #callWith: args: { argsArray }
%

category: 'Accessing'
method: CCallout
version
  ^ self dynamicInstVarAt: #version
%

category: 'Accessing'
method: CCallout
version: aString
  "aString will be used as third arg to dlvsym() "
  ^ self dynamicInstVarAt: #version put: aString
%

category: 'Private'
method: CCallout
_bindFunction: aCpointer
  "Install  aCpointer memoryAddress  as the address of the C function"
  <primitive: 1036>
  aCpointer _validateClass: CPointer .
  self _primitiveFailed: #_bindFunction args: { aCpointer }
%

category: 'Private'
method: CCallout
_library
  ^ library
%

category: 'Private'
method: CCallout
_setLibrary: aCLibrary

 aCLibrary ifNotNil:[ aCLibrary _validateClass: CLibrary ] .
 library := aCLibrary .
%

! Class extensions for 'CFunction'

!		Class methods for 'CFunction'

removeallmethods CFunction
removeallclassmethods CFunction

category: 'Documentation'
classmethod: CFunction
basicNew
 "disallowed"
  self shouldNotImplement: #basicNew
%

category: 'Instance Creation'
classmethod: CFunction
name: aName result: resType args: argumentTypes
  "aName is the C function name of the new Callout .

  resType, argumentTypes, varArgsAfter are per the comments in
    CCallout>>name:result:args: . "

  | res |
  (res := self _basicNew)
     _name: aName result: resType args: argumentTypes varArgsAfter: -1 .
  res immediateInvariant .
  ^ res
%

category: 'Instance Creation'
classmethod: CFunction
name: aName result: resType args: argumentTypes
varArgsAfter: varArgsAfter
  "aName is the C function name of the new Callin .

  resType, argumentTypes, varArgsAfter are per the comments in
    CCallout>>library:name:result:args:varArgsAfter: . "

  | res |
  (res := self _basicNew)
      _name: aName result: resType
                        args: argumentTypes varArgsAfter: varArgsAfter .
  res immediateInvariant .
  ^ res
%

category: 'Documentation'
classmethod: CFunction
new
 "disallowed"
  self shouldNotImplement: #new
%

category: 'Documentation'
classmethod: CFunction
_basicNew

  "creates an instance registered with VM for finalization of cData"
  <primitive: 674>
  ^self _primitiveFailed: #_basicNew
%

!		Instance methods for 'CFunction'

category: 'Formatting'
method: CFunction
asString
  | res fn |
  res := super asString .
  (fn := fName) ifNotNil:[  res add: $  ; add: fn ].
  ^ res
%

category: 'Accessing'
method: CFunction
coerceNameToSymbol
   fName := fName asSymbol
%

category: 'Accessing'
method: CFunction
name
 ^ fName
%

category: 'Formatting'
method: CFunction
numFixedArgs
  ^ argCounts bitAnd: ArgCounts_fixedMask
%

category: 'Formatting'
method: CFunction
numParameterTypes
  ^ argTypes size
%

category: 'Formatting'
method: CFunction
signatureString
  | res fn types nTypes nFixed varAllowed |
  (res := resultType asString) .
  (fn := fName) ifNotNil:[
     types := argTypes .
     nTypes := types size .
     nFixed := self numFixedArgs .
     varAllowed := self varArgsAllowed .
     res add: $  ; add: fn ; add: $(  .
     1 to: nFixed do:[:n | | aType |
       n > 1 ifTrue:[ res add: ', ' ].
       aType := types at: n .
       aType _isSymbol ifTrue:[ res add: aType ]
                      ifFalse:[ res add:( aType callinName ); add: '()' ].
     ].
     varAllowed ifTrue:[
       res add:', (VarArgs:) '.
       nFixed + 1 to: nTypes do:[:m | | aType |
         m > (nFixed + 1) ifTrue:[ res add: ', ' ].
         aType := types at: m .
         aType _isSymbol ifTrue:[ res add: aType ]
                      ifFalse:[ res add:( aType callinName ); add: '()' ].
       ].
     ].
     res add: $)  .
  ].
  ^ res
%

category: 'Formatting'
method: CFunction
varArgsAllowed
  ^ (argCounts bitAnd: ArgCounts_varArgsMask) ~~ 0
%

category: 'Private'
method: CFunction
_name: aName result: resType args: argumentTypes varArgsAfter: varArgsAfter

 "If C varargs allowed, varArgsAfter must be >=0   and
    <  argumentTypes size   , and must also be <=4  ,
  else varArgsAfter==-1 to denote no varargs ."

 | rType numAtypes ctyps |
 (aName isKindOfClass: String) ifFalse:[
   ArgumentTypeError new name: 'aName' expectedClass: String actualArg: aName ; signal .
   ^ nil
 ].
 aName size > 1023 ifTrue:[  "must agree with code in VM prim 710"
   ArgumentError new name: 'fName' ; signal: 'CFunction name exceeds 1023 chars' .
   ^ nil
 ].
 fName := aName .

 (rType := ResTypesDict at: resType otherwise: nil ) ifNil:[
   ArgumentError new name: 'resType' ; signal: 'not a valid CFunction result type'  .
   ^ nil
 ].
 resultType := resType .
 numAtypes := argumentTypes size .
 ctyps := ByteArray new: numAtypes + 1 .
 ctyps at: 1 put: rType .  "for C type of result"
 argumentTypes ifNotNil:[
   numAtypes > CFUNC_max_params ifTrue:[
     ArgumentError new name: 'argumentTypes' ;
       signal: 'CFunction number of args must be <= ', CFUNC_max_params asString  .
     ^ nil
   ].
   1 to: numAtypes do:[:j | | aSym typ |
     aSym :=  argumentTypes at: j .
     (typ := ArgTypesDict at: aSym otherwise: nil ) ifNil:[
       ((aSym isKindOfClass: CCallin) and:[ self isKindOfClass: CCallout]) ifTrue:[
         argumentTypes at: j put:( aSym _copyForCFunction ) .
         typ := ArgTypesDict at: #ffiCallback .
       ] ifFalse:[
         ArgumentError signal: aSym printString , ' is not a valid CFunction arg type' .
         ^ nil
       ].
     ].
     ctyps at: j + 1 put: typ .  "type of an arg"
   ].
 ].
 argTypes := argumentTypes .
 varArgsAfter >= 0 ifTrue:[
   varArgsAfter <= numAtypes ifTrue:[
      argCounts := varArgsAfter bitOr:  ArgCounts_varArgsMask .
      argTypesDict := ArgTypesDict .
   ] ifFalse:[
     ArgumentError new name:'varArgsAfter' ;
	signal:'varArgsAfter must be -1, or <= number of types'.
   ]
 ] ifFalse:[
   argCounts := numAtypes .
   varArgsAfter == -1 ifFalse:[
     ArgumentError new name:'varArgsAfter';
	signal:'varArgsAfter must be -1, or <= number of types'.
   ].
 ].
 ctyps immediateInvariant.
 cTypes := ctyps .
%

! Class extensions for 'Character'

!		Instance methods for 'Character'

category: 'PetitParser-Core-Converting'
method: Character
asParser
	"Answer a parser that accepts the receiving character."

	^ PPLiteralObjectParser on: self
%

category: 'PetitParser-Core-Operators'
method: Character
to: aCharacter
	"Create a parser for a range of characters between the receiver and the argument."

	^ PPPredicateObjectParser between: self and: aCharacter
%

! Class extensions for 'CharacterCollection'

!		Class methods for 'CharacterCollection'

category: 'Indexing Support'
classmethod: CharacterCollection
_idxCanOptimizeComparison
  "Answer true if it is possible to optimize index-related comparisons by replacing
   _idxForCompare* calles with a primitive comparison call instead.

     _idxForCompareEqualTo:              #=
     _idxForCompareGreaterThan:          #>
     _idxForCompareGreaterThanOrEqualTo: #>=
     _idxForCompareLessThan:             #<
     _idxForCompareLessThanOrEqualTo:    #<=
     _idxForCompareNotEqualTo:           #~=
   "

  "In order to optimize Numeric comparisons, NANs (#_isNaN is true) must be excluded
   from indexed collection"


  "In order to optimize CharacterCollection comparisons, elements of the indexed collections
   must be all Symbols or all Unicode Strings."

  ^ true
%

!		Instance methods for 'CharacterCollection'

category: 'Index Query Support'
method: CharacterCollection
asCachedQuery
  ^ GsQuery
    fromString: self
    options: GsQueryOptions default + GsQueryOptions cacheQueryResult
%

category: 'Index Query Support'
method: CharacterCollection
asCachedQueryOn: anNsc
  ^ GsQuery
    fromString: self
    on: anNsc
    options: GsQueryOptions default + GsQueryOptions cacheQueryResult
%

category: 'PetitParser-Core-Converting'
method: CharacterCollection
asParser
	"Answer a parser that accepts the receiving string."

	^ PPLiteralSequenceParser on: self
%

category: 'Index Query Support'
method: CharacterCollection
asQuery
  ^ GsQuery fromString: self
%

category: 'Index Query Support'
method: CharacterCollection
asQueryOn: anNsc
  ^ GsQuery fromString: self on: anNsc
%

category: 'Non-Printable Characters'
method: CharacterCollection
tab
"Appends a tab to the receiver and returns the receiver."

  self addCodePoint: 9
%

category: 'New Indexing Comparison'
method: CharacterCollection
_idxForCompareEqualToCharacterCollection: arg
  "second half of a double dispatch call from CharacterCollection>>_idxForCompareEqualTo:."

  ^ self _idxPrimCompareEqualTo: arg
%

category: 'New Indexing Comparison - for Compare'
method: CharacterCollection
_idxForCompareEqualToUnicode: aUnicodeString collator: anIcuCollator
"second half of a double dispatch call from CharacterCollection>>_idxForCompareEqualTo:collator:."

  ^ (aUnicodeString compareTo: self collator: anIcuCollator useMinSize: 900)
    == 0
%

category: 'New Indexing Comparison - for Compare'
method: CharacterCollection
_idxForCompareGreaterThanOrEqualToUnicode: aUnicodeString collator: anIcuCollator

"second half of a double dispatch call from CharacterCollection>>_idxForCompareGreaterThanOrEqualTo:collator:. Note that aUnicodeString should be the receiver in any >= comparison"

  ^ (aUnicodeString
    compareTo: self
    collator: anIcuCollator
    useMinSize: 900) >= 0
%

category: 'New Indexing Comparison - for Compare'
method: CharacterCollection
_idxForCompareGreaterThanUnicode: aUnicodeString collator: anIcuCollator

"second half of a double dispatch call from CharacterCollection>>_idxForCompareGreaterThan:collator:. Note that aUnicodeString should be the receiver in any > comparison"

  ^ (aUnicodeString
    compareTo: self
    collator: anIcuCollator
    useMinSize: 900) == 1
%

category: 'New Indexing Comparison - for Compare'
method: CharacterCollection
_idxForCompareLessThanOrEqualToUnicode: aUnicodeString collator: anIcuCollator

"second half of a double dispatch call from CharacterCollection>>_idxForCompareLessThanOrEqualTo:collator:. Note that aUnicodeString should be the receiver in any <= comparison"

  ^ (aUnicodeString
    compareTo: self
    collator: anIcuCollator
    useMinSize: 900) <= 0
%

category: 'New Indexing Comparison - for Compare'
method: CharacterCollection
_idxForCompareLessThanUnicode: aUnicodeString collator: anIcuCollator

"second half of a double dispatch call from CharacterCollection>>_idxForCompareLessThan:collator:. Note that aUnicodeString should be the receiver in any < comparison"

  ^ (aUnicodeString
    compareTo: self
    collator: anIcuCollator
    useMinSize: 900) == -1
%

category: 'New Indexing Comparison - for Sort'
method: CharacterCollection
_idxForSortEqualToCharacterCollection: aCharacterCollection collator: anIcuCollator
  "second half of a double dispatch call from CharacterCollection>>_idxForSortEqualTo:collator:."

  ^ (aCharacterCollection
    compareTo: self
    collator: anIcuCollator
    useMinSize: 900) == 0
%

category: 'New Indexing Comparison'
method: CharacterCollection
_idxForSortEqualToSymbol: aSymbol
  "second half of a double dispatch call from Symbol>>_idxForSortEqualTo:."

  ^ self _idxPrimCompareEqualTo: aSymbol asString
%

category: 'New Indexing Comparison - for Sort'
method: CharacterCollection
_idxForSortGreaterThanCharacterCollection: aCharacterCollection collator: anIcuCollator
  "second half of a double dispatch call from CharacterCollection>>_idxForSortGreaterThan:collator:. Note that aCharacterCollection should be the receiver in any > comparison"

  ^ (aCharacterCollection
    compareTo: self
    collator: anIcuCollator
    useMinSize: 900) == 1
%

category: 'New Indexing Comparison - for Sort'
method: CharacterCollection
_idxForSortGreaterThanOrEqualToCharacterCollection: aCharacterCollection collator: anIcuCollator
  "second half of a double dispatch call from CharacterCollection>>_idxForSortGreaterThanOrEqualTo:collator:. Note that aCharacterCollection should be the receiver in any >= comparison"

  ^ (aCharacterCollection
    compareTo: self
    collator: anIcuCollator
    useMinSize: 900) >= 0
%

category: 'New Indexing Comparison - for Sort'
method: CharacterCollection
_idxForSortLessThanCharacterCollection: aCharacterCollection collator: anIcuCollator
  "second half of a double dispatch call from CharacterCollection>>_idxForSortLessThan:collator:. Note that aCharacterCollection should be the receiver in any < comparison"

  ^ (aCharacterCollection
    compareTo: self
    collator: anIcuCollator
    useMinSize: 900) == -1
%

category: 'New Indexing Comparison - for Sort'
method: CharacterCollection
_idxForSortLessThanOrEqualToCharacterCollection: aCharacterCollection collator: anIcuCollator
  "second half of a double dispatch call from CharacterCollection>>_idxForSortLessThanOrEqualTo:collator:. Note that aCharacterCollection should be the receiver in any <= comparison"

  ^ (aCharacterCollection
    compareTo: self
    collator: anIcuCollator
    useMinSize: 900) <= 0
%

category: 'Indexing Support'
method: CharacterCollection
_idxOptimizedCompareWithClass: aClass
  "Returns true if the receiver may be inserted into a BtreePlusNode whose
   #lastElementClass is <aClass> and whose comparisons are optimized."

  "Sent when index option optimizeComparison is true and aClass responds true to #_idxCanOptimizeComparison"

  "if aClass is Symbol, DoubleByteSymbol, or QuadByteSymbol the receiver must be a symbol.
   Otherwise the receiver must not be a Symbol. "

  self class == aClass ifTrue: [ ^ true ].
  (self _idxBasicCanCompareWithClass: aClass)
    ifFalse: [
        "If using Unicode compares, then *String and Unicode* instances may be compared.
         If not using Unicode compares then *String and Unicode* instances may not be compared."
      ^ false ].
  ({Symbol. DoubleByteSymbol. QuadByteSymbol} includes: aClass)
    ifTrue: [ ^ self _isSymbol ].
  ^self _isSymbol not
%

! Class extensions for 'Class'

!		Class methods for 'Class'

category: 'Dynamic Literal Variables'
classmethod: Class
classVariablesAssociationClass: aClass
  | tmps |
  tmps := SessionTemps current .
  (aClass == nil or:[ aClass == SymbolAssociation]) ifTrue:[
     GsNMethod dynamicLiteralVariables: false .
     ^ tmps removeKey:#ClassVariablesAssociationClass otherwise: nil .
  ] ifFalse:[ | prev |
    (aClass _subclassOf: SymbolAssociation) ifFalse:[  "ignore classHistory"
      aClass _error: #rtErrNotASubclassOf args:{ aClass }
    ].
    GsNMethod dynamicLiteralVariables: true .
    prev := tmps at:#ClassVariablesAssociationClass otherwise: nil .
    tmps at:#ClassVariablesAssociationClass put: aClass .
    ^ prev
  ]
%

!		Instance methods for 'Class'

category: 'Private'
method: Class
unsafeRenameInstVarNamed: oldName to: newName
"Renames an instance variable of a class. Once completed, all instances of
 the receiver and its subclasses will have the new instance variable name.
 Recompiles all methods in the receiver and its subclasses which directly reference
 the instance variable.

 Returns true on success. Raises an exception and prevents the transaction
 from being committed on error. Raises an error if the current transaction contains
 uncommitted changes. Raises an error if oldName is an inherited instance 
 variable. Renaming inherited instance variables is disallowed.

 *** WARNINGS ***
1) Do not use if any instances are members of any indexed collection. Doing so will likely corrupt the indexes and make them unusable.
2) This is a private method. Use at your own peril.
 *** WARNINGS ****
"
System needsCommit 
  ifTrue: [ self _error: #rtErrAbortWouldLoseData ] .
(self instVarNames includesIdentical: oldName asSymbol)
	ifFalse:[ Error signal: ('class ', self name asString, ' does not have an instance variable named #', oldName asString) ].
[
  |oldMethsAndOffsets oldIvName newIvName newMeths org |
  org := ClassOrganizer new .
  oldIvName := oldName asSymbol .
  newIvName := newName asSymbol .
  oldMethsAndOffsets := Array new .
  (org accessorsOf: oldIvName inClass: self ) do:[:meth | 
    meth isMethodForBlock ifTrue:[ Error signal: 'problem in class organizer' ].
    (meth sourceOffsetsOfInstVar: oldIvName) ifNotNil:[ :offsets|
      oldMethsAndOffsets add: { meth . offsets }.
    ] ifNil:[ Error signal: 'instVar not found in method' ].
  ].

  self _unsafeRenameInstVarNamed: oldIvName to: newIvName.
  self allSubclasses do:[:e| e _unsafeRenameInstVarNamed: oldIvName to: newIvName.].
  newMeths := Array new .
  oldMethsAndOffsets do:[:ary | | meth offsets src |
    meth := ary at: 1 .
    offsets := ary at: 2 .
    src := meth sourceString copy .
    (SortedCollection withAll: offsets) reverseDo:[:ofs |
      src removeFrom: ofs to: (ofs + oldIvName size - 1) .
      src insertAll: newIvName at: ofs .
    ].
  newMeths add:( meth inClass compileMethod: src ).
 ].
  self _refreshClassCache: true .
] on: Error do:[:ex|   System disableCommitsUntilAbortWithReason: 'error in #unsafeRenameInstVarNamedto:' . ex resume ].
^ true
%

category: 'Private'
method: Class
_clearCachedOrganizer

   ClassOrganizer clearCachedOrganizer
%

category: 'Private'
method: Class
_logServer: aString
  (SessionTemps current at: #ROWAN_TRACE otherwise: nil) == false ifFalse:[
     GsFile gciLogServer: aString .
  ]
%

category: 'Subclass Creation'
method: Class
_makeClassVarDict: anArrayOfClassVars

"Turns Array of class variable names into a SymbolDictionary.
 Returns nil if anArrayOfClassVars is empty or nil. "

| newDict numCvs |
self _validatePrivilege ifTrue:[
  anArrayOfClassVars ifNotNil:[
    anArrayOfClassVars _isArray ifFalse:[
      (anArrayOfClassVars _validateClass: Array) ifFalse:[ ^ nil ].
    ].
    (numCvs := anArrayOfClassVars size) ~~ 0 ifTrue:[ | assocClass  |
      newDict := SymbolDictionary new.
      assocClass := SessionTemps current at:#ClassVariablesAssociationClass otherwise: SymbolAssociation.
      1 to: numCvs do: [:index|
        | aVarName aSym definingClass |
	aVarName := anArrayOfClassVars at: index .
        (aVarName _isOneByteString or:[ aVarName _validateClass: CharacterCollection]) ifTrue:[
	  aSym := aVarName asSymbol .
	  aSym validateIsIdentifier "fix bug 9666" .
	  definingClass := self _classDefiningClassVar: aSym .  "fix bug 10480"
	  definingClass ifNotNil:[
            LookupError new object: definingClass; key: aSym ; reason: #classErrClassVarNameExists ;
		details: 'class variable already exists'; signal
	  ] ifNil:[
	    newDict addAssociation:( assocClass newWithKey: aSym value: nil )
	  ]
        ].
      ].
    ].
  ].
].
^ newDict .
%

category: 'Private'
method: Class
_sortedClassVarNames

"Returns a sorted list of class variable names. "

 | res |
 res := SortedCollection new .
 classVars ifNotNil:[ res addAll: classVars keys ].
 ^ res
%

category: 'Private'
method: Class
_unsafeRenameInstVarNamed: oldName to: newName

"Do not call this method directly. Call Class>>#unsafeRenameInstVarNamed:to:
 instead, which calls this method."
| idx |
idx := self _instVarNames indexOfIdentical: oldName  .
idx == 0 ifTrue:[ self error: ('instvar with name', oldName asString, ' not found')].
self _instVarNames _unsafeAt: idx put: newName.
self _refreshClassCache: true .
^ true
%

category: 'Private'
method: Class
_validateInstancesPersistent

"check that it is legal to make instances of the receiver
 persistent."

| list |
list := {
  IdentityKeySoftValueDictionary . IdentitySoftCollisionBucket .
  KeySoftValueDictionary . SoftCollisionBucket . SoftReference . Semaphore
 }.
1 to: list size do:[ :n |  | aCls |
  aCls := list at: n .
  aCls == self ifTrue:[
    ImproperOperation new reason: #rtErrSuperclassIsNP;
	details: 'instances of this class are always non-persistent';
	object: self ; signal .
    ^ false
  ]
].
^ true
%

! Class extensions for 'CLibrary'

!		Class methods for 'CLibrary'

removeallmethods CLibrary
removeallclassmethods CLibrary

category: 'Private'
classmethod: CLibrary
basicNew

 "disallowed"
  self shouldNotImplement: #basicNew
%

category: 'Accessing'
classmethod: CLibrary
hasCSymbol: aString

"return true if dlsym() finds specified name in any loaded library
 in the current process."

^ self _prim: 4 arg: aString arg: nil 
%

category: 'Accessing'
classmethod: CLibrary
hasCSymbol: aString version: versionString

"return true if dlvsym() finds specified name in any loaded library
 in the current process.  versionString should be non-nil . "
 
^ self _prim: 4 arg: aString arg: versionString
%

category: 'Instance creation'
classmethod: CLibrary
named: libraryName

  "if libraryName does not include a  '.'  character, then the OS dependent
   suffix such as  '.so'   will be appended prior to attempting to load
   the library"

  ^ self _basicNew _initialize: libraryName
%

category: 'Private'
classmethod: CLibrary
new
 "disallowed"
  self shouldNotImplement: #new
%

category: 'Private'
classmethod: CLibrary
_basicNew

  "creates an instance registered with VM for finalization of cData"
  <primitive: 674>
  ^self _primitiveFailed: #_basicNew
%

category: 'Private'
classmethod: CLibrary
_prim: opcode arg: anArg arg: argTwo
  "opcode==4  process dlsym() or dlvsym "

<primitive: 709>
anArg _validateClass: String .
argTwo ifNotNil:[
  argTwo _validateClass: String
].
self _primitiveFailed: #_prim:arg:arg: args: { opcode . anArg . argTwo }
%

!		Instance methods for 'CLibrary'

category: 'Accessing'
method: CLibrary
expandedName

 "If dlopen() has been successfully called for the in-memory copy
  of the receiver, then return the expanded name as it was passed to dlopen,
  otherwise return the name after expanding environment variables and
  symbolic links as described in CLibary>>load. "

 name == nil ifTrue:[ self error:'nil name'].
 ^ self _prim: 2 arg: nil arg: nil
%

category: 'Accessing'
method: CLibrary
hasCSymbol: aString

"Return true if dlsym() finds specified name in the shared library
 represented by receiver. dladdr() used if available to qualify
 the result of dlsym() to within receiver's shared library.

 dladdr() not implemented on AIX, so this method will return
 true if the specified name exists in any library loaded thus
 far into the process."

| dladdrLibNam expName |
dladdrLibNam := self _libNameForSymbol: aString .
self isLoaded ifFalse:[ ^ false ].
dladdrLibNam ifNil:[ ^ false ].
dladdrLibNam == true ifTrue:[
  "found by dlsym() and dladdr() not supported by OS"
  ^ true
].
expName := self expandedName .
"ignore version numbers on .so  which is target of a symlink"
(dladdrLibNam at: 1 equals: expName ) ifTrue:[ ^ true ].
(expName at: ((expName size - 2) max: 1) equals:'.so') ifTrue:[
  "solaris or linux"
  ^ (dladdrLibNam findString: expName startingAt: 1) >= 1 .
].
(expName at: ((expName size - 5) max: 1) equals:'.dylib') ifTrue:[ | k |
   "mac"
  k := expName indexOf: $. startingAt: 1 .
  k >= 1 ifTrue:[ | prefix |
    prefix := expName copyFrom: 1 to: k .
    ^ (dladdrLibNam findString: prefix startingAt: 1) >= 1
  ].
].
^ false
%

category: 'Accessing'
method: CLibrary
isLoaded

"Return true if shared library described by receiver has been loaded
 since the receiver was created or faulted into memory,
 false otherwise."

^ self _prim: 0 arg: nil arg: nil .
%

category: 'Accessing'
method: CLibrary
lastError
 "Return the String returned by dlerror() from the last failed dlopen()
  since this object was created or faulted into memory ."

  self isLoaded . "ensure current C state"
  ^ lastError
%

category: 'Loading'
method: CLibrary
load
"  Load the shared library described by receiver if not already loaded.
   Before calling dlopen(), any environment variables in the name
   (beginning with $$ and limited by $/ ) are expanded using the
   current environment of the session's gem or topaz -l process,
   and symbolic links are followed.  The name must not exceed 2046
   characters and the expanded form must not exceed 8190 characters.
   The flags to dlopen include RTLD_LAZY.
   On AIX, lazy bind is not implemented (RTLD_LAZY has RTLD_NOW semantics).
   See CLibrary(C)>>comment for details of flags passed to dlopen().

   Returns true if successful, or a String describing the error from dlopen().
"

 ^ self _prim: 1 arg: false arg: nil 
%

category: 'Loading'
method: CLibrary
loadResolveAll

  "Like  Clibrary>>load, except flags to dlopen include RTLD_NOW."

 ^ self _prim: 1 arg: true arg: nil 
%

category: 'Accessing'
method: CLibrary
name

^ name
%

category: 'Private'
method: CLibrary
_initialize: aName
  (aName isKindOfClass: String) ifFalse:[
    aName _error: #rtErrBadArgKind args: { String }.
  ].
  aName size > 2047 ifTrue:[  "must agree with loadCLibrary in VM"
    aName _error: #errArgTooLarge args:{ 2047 } .
  ].
  name := aName
%

category: 'Accessing'
method: CLibrary
_libNameForSymbol: aString
  "Call dlsym() for aString use receiver's handle from dlopen().
   If dlsym() returns non-NULL
     if dladdr() supported by the OS
       return a String containing dladdr(dlsym(aString))->dli_fname
     else
       return true .

Returns nil if shared library represented by receiver cannot
   be loaded, dlsym() fails to find aString, or dladdr() fails.
  "
  ^ self _prim: 3 arg: aString arg: nil 
%

category: 'Accessing'
method: CLibrary
_libNameForSymbol: aString version: versionString
  "Call dlvsym() for aString use receiver's handle from dlopen().
   If dlvsym() returns non-NULL
     if dladdr() supported by the OS
       return a String containing dladdr(dlsym(aString))->dli_fname
     else
       return true .

  versionString should be non-nil .
   
Returns nil if shared library represented by receiver cannot
   be loaded, dlsym() fails to find aString, or dladdr() fails.
  "
  ^ self _prim: 3 arg: aString arg: versionString
 
%

category: 'Private'
method: CLibrary
_prim: opcode arg: anArg arg: argTwo

" opcode==0  isLoaded,  anArg not used .
  opcode==1  load  , anArg is Boolean rtldNow
  opcode==2  expandedName  , anArg not used .
  opcode==3  dlsym(). anArg is a String. , argTwo nil. If receiver not loaded,
               does  (self _prim:1 arg:false) before calling dlsym()
  opcode==3  dlvsym(). anArg is a String, argTwo aString. If receiver not loaded,
               does  (self _prim:1 arg:false) before calling dlsym()
"

<primitive: 709>

opcode == 3 ifTrue:[ 
  anArg _validateClass: String .
  argTwo ifNotNil:[ argTwo _validateClass: String ].
].
opcode == 1 ifTrue:[ anArg _validateClass: Boolean ].
self _primitiveFailed: #_prim:arg:arg: args: { opcode . anArg }
%

! Class extensions for 'Collection'

!		Instance methods for 'Collection'

category: 'PetitParser-Core-Converting'
method: Collection
asChoiceParser
	^ PPChoiceParser withAll: (self collect: [ :each | each asParser ])
%

category: 'Converting'
method: Collection
asGsBitmap

"Returns a GsBitmap with the contents of the receiver."

^GsBitmap withAll: self asArray
%

category: 'PetitParser-Converting'
method: Collection
asParser
	"Create a range of characters between start and stop."

	(self allSatisfy: [ :e | e isKindOf: Character ]) ifTrue: [
		| charSet |
		charSet := PPCharSetPredicate on: [ :char | self includes: char ] .
     	^ PPPredicateObjectParser on: charSet message: 'One of these charactes expected: ', self printString.
	].


	^ super asParser
	"
		($a to:$f) asParser parse:'a'
		($a to:$f) asParser parse:'g'
	"
%

category: 'PetitParser-Core-Converting'
method: Collection
asSequenceParser
	^ PPSequenceParser withAll: (self collect: [ :each | each asParser ])
%

category: 'Sorting'
method: Collection
sortWithBlock: sortBlock

"Returns an Array containing the elements of the receiver, sorted based on the
 sortBlock. The block must take two arguments, and it should return true if the
 first argument should precede the second argument, and false if not. The
 expressions within the block are expected to by symmetrical (i.e., if the first
 arg is _less_ than the second, then the block will return false when the arguments
 are reversed and if the first arg is _equal_ to the second arg, then the block
 will return false regardless of argument order)."

  self size <= 2000 ifTrue:[ | sc |
    sc := SortedCollection sortBlock: sortBlock .
    self do:[:elem | sc add: elem ]  .
    ^ Array withAll: sc .
  ] ifFalse:[
    ^ self sortWithBlock: sortBlock  persistentRoot: nil collator: nil .
  ]
%

category: 'Sorting'
method: Collection
sortWithBlock: sortBlock collator: anIcuCollator

^ self sortWithBlock: sortBlock  persistentRoot: nil collator: anIcuCollator
%

category: 'Sorting'
method: Collection
sortWithBlock: sortBlock  persistentRoot: persistentArrayOrNil

^ self sortWithBlock: sortBlock  persistentRoot: persistentArrayOrNil collator: nil
%

category: 'Sorting'
method: Collection
sortWithBlock: sortBlock  persistentRoot: persistentArrayOrNil collator: anIcuCollator

"Returns an Array containing the elements of the receiver, sorted based on the
 sortBlock.

 If anIcuCollator == nil, the sortBlock must take two arguments.
 If anIcuCollator is an IcuCollator, then the block must take a 3rd argument which
 is an IcuCollator, as used in the blocks for IcuSortedCollection.

 The sortBlock should return true if the first argument should precede the second argument,
 and false if not. The expressions within the block are expected to by symmetrical
 (i.e., if the first arg is _less_ than the second, then the block will return false
 when the arguments are reversed and if the first arg is _equal_ to the second arg,
 then the block will return false regardless of argument order).

 If persistentArrayOrNil is notNil, then it is expected to be an empty persistent array and
 the array will be used to persist large temporary data structures created during
 the sorting operation. IndexManager>>autoCommit must be true in order for periodic
 commits to  be made during the sorting operation. When the sort operation is complete
 the persistent array will be emptied and a final commit performed. The persistentArrayOrNil
 and  IndexManager>>autoCommit should be used when a collection is so large that it
 isn't practical to allocate enough temporary memory.
"

 | sorter aColl sortNodes |
sorter := BlockSorter on: self with: sortBlock collator: anIcuCollator .
sortNodes := sorter sortNodes.
aColl := self _asCollectionForSorting.
(IndexManager autoCommit and: [ persistentArrayOrNil ~~ nil ])
  ifTrue: [
    | result obj mgr |
    (mgr := IndexManager current) executeStartingIndexMaintenance: [
      persistentArrayOrNil add: sorter.
      persistentArrayOrNil add: aColl.
      mgr _doCommit.
      1 to: aColl size do: [ :i |
        obj := aColl _at: i.
         sorter _addObject: obj
                  inNodes: sortNodes.
      ].
      result := sorter sortInto: (Array new: self size) startingAt: 1.
      persistentArrayOrNil size: 0 ].
    ^result ]
  ifFalse: [ | result obj |
    1 to: aColl size do: [ :i |
      obj := aColl _at: i.
       sorter _addObject: obj
                inNodes: sortNodes.
    ].
    result := sorter sortInto: (Array new: self size) startingAt: 1.
    ^ result
].
%

category: 'Object Canonicalization'
method: Collection
_canonicalizeReferencesUsingPolicy: aReferencingObjectPolicy

	self error: 'Unable to canonicalize references in ' , self printString.
%

category: 'Private'
method: Collection
_indexObjectsFor: pathArrays
  "Returns an Array of index objects (either PathEvaluators or
 RangeEqualityIndexes) that correspond to the paths described
 in the pathArrays (each element is an Array of Strings)."

  | pathArray indexObj indexObjs k sz |
  indexObjs := {}.
  1 to: pathArrays size do: [ :i |
    pathArray := pathArrays at: i.
    indexObj := self _findRangeIndexWithPath: pathArray.
    indexObj == nil
      ifTrue: [  | holder |
        indexObj := PathEvaluator new nsc: self.
        1 to: pathArray size do: [ :j | indexObj addLast: (pathArray at: j) ].
        holder := { indexObj  } .
        indexObj  := nil .
        indexObj :=  PathEvaluator asMostSpecificType: holder .

        indexObjs isEmpty
          ifTrue: [ indexObjs add: indexObj ]
          ifFalse: [
            " don't add a duplicate path "
            k := 1.
            sz := indexObjs size.
            [ k <= sz and: [ (indexObj hasSamePathAs: (indexObjs at: k)) not ] ]
              whileTrue: [ k := k + 1 ].
            k > sz
              ifTrue: [ indexObjs add: indexObj ] ] ]
      ifFalse: [ indexObjs add: indexObj ] ].
  ^ indexObjs
%

! Class extensions for 'CollectionBasedPathEvaluator'

!		Instance methods for 'CollectionBasedPathEvaluator'

category: 'Testing'
method: CollectionBasedPathEvaluator
isCollectionBased
  "Returns true."

  ^ true
%

category: 'Testing'
method: CollectionBasedPathEvaluator
termsRequired
  "Answer true if receiver requires that instance variables of indexed objects are present "

  ^ self _pathTermsRequired
%

category: 'Traversing'
method: CollectionBasedPathEvaluator
traverse: anObject andCompare: selector with: aValue
  "Traverse the given object and perform the comparison operation
 on the object at the end of the path and the given value."

  "This method assumes that the index is not over a set-valued instance variable."

  "This method is intended for support of QueryExecutor only"

  self shouldNotImplement: #'traverse:andCompare:with:'
%

category: 'Traversing'
method: CollectionBasedPathEvaluator
traverse: anObject andCompare: selector withTraverser: aTraverser
  "Traverse the given object and perform the comparison operation on the object
 at the end of the path and the value obtained by using the traverser."

  "This method assumes that the index is not over a set-valued instance variable and is in support Of QueryExecutor only."

  "This method is intended for support of QueryExecutor only"

  self shouldNotImplement: #'traverse:andCompare:withTraverser:'
%

category: 'Traversing'
method: CollectionBasedPathEvaluator
traverse: anObject startingAt: offset do: aBlock
  "Traverse the sub-objects of anObject, using the path names of the receiver
 starting at the path name at the given offset.  Evaluate <aBlock> for each endObject."

  self subclassResponsibility: #'traverse:startingAt:do:'
%

category: 'Traversing'
method: CollectionBasedPathEvaluator
traverse: anObject startingAt: offset into: resultSet
  "Traverse the sub-objects of all the objects in the NSC, using the path names
 of the receiver starting at the path term at the given offset.  Add each
 object at the end of the traversal to the result set.  Returns the result
 set."

  self subclassResponsibility: #'traverse:startingAt:into:'
%

category: 'Traversing'
method: CollectionBasedPathEvaluator
traverseObject: anObject
  "This method is intended for support of QueryExecutor only"

  self shouldNotImplement: #'traverseObject:'
%

category: 'Traversing'
method: CollectionBasedPathEvaluator
traverseObject: anObject incompletesInto: incompleteArray incomplete: incomplete
  "This method is intended for support of QueryExecutor only"

  self shouldNotImplement: #'traverseObject:incompletesInto:incomplete:'
%

category: 'Accessing'
method: CollectionBasedPathEvaluator
_pathTermsRequired
  pathTermsRequired ifNil: [ pathTermsRequired := true ].
  ^ pathTermsRequired
%

category: 'Accessing'
method: CollectionBasedPathEvaluator
_pathTermsRequired: aBoolOrNil
  pathTermsRequired := aBoolOrNil
%

category: 'Traversing'
method: CollectionBasedPathEvaluator
_traverse: anObject cachedOffsets: offsets cachedClasses: classes incomplete: incompletePathTraversal
  "This method assumes that the index is not over a set-valued instance variable."

  self shouldNotImplement: #'_traverse:cachedOffsets:cachedClasses:incomplete:'
%

category: 'Traversing'
method: CollectionBasedPathEvaluator
_traverseObject: anObject
  "Traverse the sub-objects of the given object using the path names of the
 receiver.  This method assumes that the index is not over a set-valued
 instance variable.  For that kind of index, use the traverse:startingAt:into:
 method.  If a nil value is reached before the end of the path, returns the
 incompletePathTraversalObject."

  "This method is intended for support of QueryExecutor only"

  self shouldNotImplement: #'_traverseObject:'
%

category: 'Traversing'
method: CollectionBasedPathEvaluator
_traverseObject: anObject cache: ivOffsetCache
  "Traverse the sub-objects of the given object using the path names of the
 receiver.  This method assumes that the index is not over a set-valued
 instance variable.  For that kind of index, use the traverse:startingAt:into:
 method.  If a nil value is reached before the end of the path, returns the
 incompletePathTraversalObject."

  "This method is intended for support of QueryExecutor only"

  self shouldNotImplement: #'_traverseObject:cache:'
%

category: 'Traversing'
method: CollectionBasedPathEvaluator
_traverseObject: anObject incompletesInto: incompleteArray incomplete: incomplete
  "This method assumes that the index is not over a set-valued instance variable."

  "Intended for support of PathSort ... no collection-based terms"

  self shouldNotImplement: #'_traverse:incompletesInto:incomplete:'
%

! Class extensions for 'CollectionBasedPathTerm'

!		Instance methods for 'CollectionBasedPathTerm'

category: 'Updating Indexes'
method: CollectionBasedPathTerm
addIndexListEntriesFor: nscBag index: indexObj
  "Update the Bag of NSC's index lists."

  | anNsc iList nextOffset |
  nextOffset := offset + 1.
  1 to: nscBag size do: [ :i |
    " for each NSC in the Bag of NSCs ... update the index list "
    anNsc := nscBag at: i.
    anNsc class isNsc
      ifFalse: [ ^ self _errorPathObjectNotAnNsc: anNsc ].
    iList := anNsc _getIndexList.
    anNsc _putInWriteSet.
    iList addIndex: indexObj withOffset: nextOffset nsc: anNsc ]
%

category: 'Deprecated'
method: CollectionBasedPathTerm
allDependencyListsFor: anNsc into: all
  "Put any dependency lists that can be found from the receiver into the given set."

  self deprecated: 'CollectionBasedPathTerm>>allDependencyListsFor:into: deprecated v3.3.
    Use DependencyList class>>depMapValues to collect dependency lists.'.  "bug 43886"
  self subclassResponsibility: #'allDependencyListsFor:into:'
%

category: 'Deprecated'
method: CollectionBasedPathTerm
auditObject: obj occurrences: num on: aString builder: nscBuilder
  "called by UnorderedCollection>>_incrementalAuditIndexes:to: and not this type of
   old audit not supported for collection-based pathterms"

  self shouldNotImplement: #'auditObject:occurrences:on:builder:'
%

category: 'Updating Indexes'
method: CollectionBasedPathTerm
cleanupDependencyListFor: anNsc
  ""

  self subclassResponsibility: #'cleanupDependencyListFor:'
%

category: 'Updating Indexes'
method: CollectionBasedPathTerm
getMappingInfoFor: anObject ifObject: origObject atOffset: origOffset replaceWith: otherObject
  "Gathers all the objects, their dependency lists, and the instance variable
 offset for each path term in the tree of path terms.  Puts them in a
 MappingInfo object.  Builds a tree of MappingInfo objects for each child path
 term.

 It is possible that this method is invoked due to an instance variable
 modification.  In that case, we want to traverse the path terms as if the
 modification had occurred.  Thus, if anObject is the one that was modified
 (that is, if it is identical to origObject) and the instance variable offset of
 this path term is the same instance variable offset that was modified (that is,
 it is equal to origOffset), then rather than getting the next object along the
 path, use the otherObject."

  self
    subclassResponsibility: #'getMappingInfoFor:ifObject:atOffset:replaceWith:'
%

category: 'Testing'
method: CollectionBasedPathTerm
indicatesMultiValue
  "Returns true, the receiver indicates that the index is on an
 instance variable that may have multiple values (i.e., collection based path term)"

  ^ true
%

category: 'Testing'
method: CollectionBasedPathTerm
isCollectionBasedTerm
  "Returns true if the receiver is an enumerated path term or a term that indicates a
   set-valued instance variable."

  ^ true
%

category: 'Accessing'
method: CollectionBasedPathTerm
nextObj: anObj do: aBlock
  self subclassResponsibility: #'nextObj:do:'
%

category: 'Updating Indexes'
method: CollectionBasedPathTerm
removeIndexListEntriesFor: nscBag index: indexObj
  "Update the Bag of NSC's index lists."

  | anNsc iList nextOffset |
  nextOffset := offset + 1.	" for each NSC in the Bag of NSCs ... "
  1 to: nscBag size do: [ :i |
    anNsc := nscBag at: i.
    iList := anNsc _getIndexList.
    anNsc _putInWriteSet.	" update the index list "
    iList removeIndex: indexObj withOffset: nextOffset for: anNsc ]
%

category: 'Updating Indexes'
method: CollectionBasedPathTerm
removeMappingsFor: anObject lastOne: aBoolean logging: doLogging
  "Remove entries in the index dictionary and dependency lists for anObject."

  self subclassResponsibility: #'removeMappingsFor:lastOne:logging:'
%

category: 'Accessing'
method: CollectionBasedPathTerm
requirePathTerms
  requirePathTerms ifNil: [ ^ true ].
  ^ requirePathTerms
%

category: 'Accessing'
method: CollectionBasedPathTerm
requirePathTerms: aBool
  requirePathTerms := aBool
%

category: 'Testing'
method: CollectionBasedPathTerm
termsRequired
  "Answer true if receiver requires that instance variables of indexed objects are present "

  ^ self requirePathTerms
%

category: 'Error Handling'
method: CollectionBasedPathTerm
_errorPathObjectNotAnNsc: anObject
  "An object traversed along an index path through a set-valued instance
 variable was not an NSC."

  ImproperOperation new
    reason: #'rtErrPathTermObjectNotAnNsc';
    object: anObject;
    details: 'Expected an UnorderedCollection';
    signal
%

category: 'Accessing'
method: CollectionBasedPathTerm
_nextObjectFor: anObject
  "Cannot use this shortcut method"

  self shouldNotImplement: #'_nextObjectFor:'
%

category: 'Indexing Support'
method: CollectionBasedPathTerm
_updateCollectionBasedIndexFor: anIndex on: anNsc offset: anOffset addingIndex: addingIndex
  "noop by default"


%

! Class extensions for 'CollisionBucket'

!		Instance methods for 'CollisionBucket'

category: 'Repository Conversion'
method: CollisionBucket
fixRefsAfterConversion

"Default method for fixing references to ObsLargePositiveInteger 
 and ObsLargeNegativeInteger instances that can now be represented
 as a SmallInteger and Floats and SmallFloats which can now be 
 represented as a SmallDouble.  For collision buckets, we send
 the message to our parent Dictionary and let him do the fix up."

|dict result convBm |
convBm := (GsBitmap newForHiddenSet: #Conversion).
(convBm includes: self) 
        ifTrue:[^false]. "already fixed this one"
dict := self keyValueDictionary.
result := false.
dict ~~ nil
        ifTrue:[result := dict fixRefsAfterConversion].
convBm add: self.
^result
%

! Class extensions for 'ConstrainedCharacterCollectionIndexSpecification'

!		Class methods for 'ConstrainedCharacterCollectionIndexSpecification'

category: 'instance creation'
classmethod: ConstrainedCharacterCollectionIndexSpecification
path: aString collator: anIcuCollator
  | res |
  (res := self new)
    path: aString;
    collator: anIcuCollator .
  ^ res
%

category: 'instance creation'
classmethod: ConstrainedCharacterCollectionIndexSpecification
path: aString lastElementClass: aClass
  ^ self shouldNotImplement: #'path:lastElementClass:'
%

!		Instance methods for 'ConstrainedCharacterCollectionIndexSpecification'

category: 'accessing'
method: ConstrainedCharacterCollectionIndexSpecification
collator
  "Returns IcuCollator to be used when comparing Unicode strings. collator may be nil."

  ^ collator
%

category: 'accessing'
method: ConstrainedCharacterCollectionIndexSpecification
collator: anIcuCollatorOrNil
  "Set the receiver's collator. Use a copy of anIcuCollator to disallow
   changes to strength, etc, that might affect the sort ordering. "

  anIcuCollatorOrNil
    ifNil: [ collator := nil ]
    ifNotNil: [ collator := anIcuCollatorOrNil copy immediateInvariant ]
%

category: 'accessing'
method: ConstrainedCharacterCollectionIndexSpecification
constraintType
  "Returns the constraintType, either #string or #symbol."

  ^ constraintType
%

category: 'accessing'
method: ConstrainedCharacterCollectionIndexSpecification
constraintType: aSymbol
  "Set the constraintType, either #string or #symbol."

  constraintType := aSymbol
%

category: 'accessing'
method: ConstrainedCharacterCollectionIndexSpecification
equalityIndexClass
  ^ GsConstrainedCharacterCollectionIndex
%

category: 'accessing'
method: ConstrainedCharacterCollectionIndexSpecification
indexTypePrintString
  ^ self constraintType == #string
    ifTrue: [ 'stringOptimizedIndex' ]
    ifFalse: [ 'symbolOptimizedIndex' ]
%

category: 'accessing'
method: ConstrainedCharacterCollectionIndexSpecification
_createIndex
  ^ (self equalityIndexClass newWithCollator: self collator)
    options: self options;
    constraintType: self constraintType;
    yourself
%

category: 'private'
method: ConstrainedCharacterCollectionIndexSpecification
_validateLastElementClassOn: anNsc
  "noop"


%

! Class extensions for 'CPointer'

!		Class methods for 'CPointer'

removeallmethods CPointer
removeallclassmethods CPointer

category: 'Private'
classmethod: CPointer
basicNew
 "disallowed"
  self shouldNotImplement: #basicNew
%

category: 'Private'
classmethod: CPointer
new
 "disallowed"
  self shouldNotImplement: #new
%

category: 'Instance creation'
classmethod: CPointer
newFrom: aCByteArray

"Return a new instance of CPointer which is a reference to body
 of a CByteArray.
 The result can be used as an argument a CFunction which has
 type #'ptr' or #'&ptr' . "

^ self newNull _initFrom: aCByteArray offset: 0
%

category: 'Instance creation'
classmethod: CPointer
newNull
  "Create a new instance with value NULL.
   The result can be used as an argument a CFunction which has
   type #'ptr' or #'&ptr' .

   Non-NULL instances are also returned from CFunction calls when result
   type is  #ptr ; pass such instances to CByteArray classmethods to
   get an instance of CByteArray with which to access the data.
 "

<primitive: 674>  "instance is registered with VM for CData finalization"
^ self _primitiveFailed: #newNull
%

!		Instance methods for 'CPointer'

category: 'Formatting'
method: CPointer
asString
  | res |
  (res := super asString ) add: self _inspect .
  ^ res
%

category: 'Accessing'
method: CPointer
decodeFromUTF8ToString 
  "Decode the NUL terminated UTF8 data starting at self memoryAddress 
   and return a String, DoubleByteString or QuadByteString"
  ^ self _access: 3 
%

category: 'Accessing'
method: CPointer
decodeFromUTF8ToUnicode 
  "Decode the NUL terminated UTF8 data starting at self memoryAddress 
   and return a Unicode7, Unicode16 or Unicode32"
  ^ self _access: 4 
%

category: 'Testing'
method: CPointer
isNull
"Answer true if the receiver is a NULL pointer, false otherwise."

^ self memoryAddress == 0
%

category: 'Accessing'
method: CPointer
memoryAddress
  "Returns the starting address of the C memory, as a signed 64bit Integer."

  ^ self _access: 0 
%

category: 'Testing'
method: CPointer
notNull
"Answer true if the receiver is not a NULL pointer, false otherwise."

^ self memoryAddress ~~ 0
%

category: 'Accessing'
method: CPointer
stringFromCharStar 
  "Return a String from the char* data starting at self memoryAddress"
  ^ self _access: 1 
%

category: 'Accessing'
method: CPointer
utf8FromCharStar 
  "Return a Utf8 from the char* data starting at self memoryAddress"
  ^ self _access: 2 
%

category: 'Accessing'
method: CPointer
_access: opcode
  "Opcode
    0 returns the starting address of the C memory, as a signed 64bit Integer.
    1 assume NUL terminated char* data and return a String .
    2 assume NUL terminated char* data and return a UTF8 .
    3 decode NUL terminated UTF8 data returning a String or DoubleByteString .
    4 decode NUL terminated UTF8 data returning a Unicode7, or Unicode16
  " 
<primitive: 846>
opcode _validateClass: SmallInteger .
^ self _primitiveFailed: #_access: args: { opcode }
%

category: 'Private'
method: CPointer
_initFrom: aCByteArray offset: zeroBasedOffset

 <primitive: 718>
 aCByteArray _validateClass: CByteArray .
 aCByteArray memoryAddress == 0 ifTrue:[
   "CByteArray might be a committed instance faulted."
   ArgumentError signal:'CByteArray has NULL C memory address'.
 ].
 zeroBasedOffset _validateClass: SmallInteger .
 ArgumentError signal:'zeroBasedOffset out of bounds of aCByteArray'.
 self _primitiveFailed: #_initFrom:offset:
      args: { aCByteArray . zeroBasedOffset }
%

category: 'Formatting'
method: CPointer
_inspect
  | res |
  (res := String new)
    add: ' address=0x' ; add: self memoryAddress asHexString .
  ^ res
%

! Class extensions for 'CZstream'

!		Class methods for 'CZstream'

removeallmethods CZstream
removeallclassmethods CZstream

category: 'Stream processing'
classmethod: CZstream
adler32: byteObject initialCrc: startCrc

"compute the adler32 checksum of the byteObject, per zlib.h .
 startCrc, must be aSmallInteger, >=0 and <= 16rFFFFFFFF .
 Normally startCrc should be 1 . "

<primitive: 886>
self _primitiveFailed: #adler32:initialCrc:
     args: { byteObject . startCrc }
%

category: 'Stream processing'
classmethod: CZstream
crc32: byteObject initialCrc: startCrc

"compute the crc32 checksum of the byteObject, per zlib.h .
 startCrc, must be aSmallInteger, >=0 and <= 16rFFFFFFFF .
 Normally startCrc should be 0 . "

<primitive: 888>
self _primitiveFailed: #crc32:initialCrc:
     args: { byteObject . startCrc }
%

category: 'Stream processing'
classmethod: CZstream
crcTable
"Returns an Array containing the contents of crc_table[0] per crc32.h"
<primitive: 887>

self _primitiveFailed: #crcTable
%

category: 'Instance creation'
classmethod: CZstream
new

  ^ self _basicNew
%

category: 'Instance creation'
classmethod: CZstream
openRead: anIO
^ self openRead: anIO errorClass: IOError
%

category: 'Instance creation'
classmethod: CZstream
openRead: anIO errorClass: anExceptionClass

| inst |
(inst := self _basicNew )
   open: false io: anIO errorClass: anExceptionClass
	comprLevel: -1 "Z_DEFAULT_COMPRESSION".
^ inst
%

category: 'Instance creation'
classmethod: CZstream
openWrite: anIO
^ self openWrite: anIO errorClass: IOError comprLevel: -1"Z_DEFAULT_COMPRESSION"
%

category: 'Instance creation'
classmethod: CZstream
openWrite: anIO errorClass: anExceptionClass comprLevel: anInt
| inst |
(inst := self _basicNew )
   open: true io: anIO errorClass: anExceptionClass comprLevel: anInt .
^ inst
%

category: 'Private'
classmethod: CZstream
_basicNew

  "creates an instance registered with VM for finalization of cData"
  <primitive: 674>
  ^self _primitiveFailed: #_basicNew
%

!		Instance methods for 'CZstream'

category: 'Stream processing'
method: CZstream
atEnd
"Returns true if an input stream is at eof, or has been closed by
  _finishReading"

 ioObj ifNotNil:[ | bs |
   bufSize ~~ 0 ifTrue:[ ^ false ].
   bs := self _readAndDecompress .
   ^ bs == 0
 ].
 ^ true
%

category: 'Stream processing'
method: CZstream
close
 forWrite ifTrue:[
   self flush: nil .
   self _streamOp: 1 with: nil . "close underlying stream"
 ] ifFalse:[
   self _finishReading
 ]
%

category: 'Stream processing'
method: CZstream
flush

  ^ self flush: nil "equivalent to Z_FINISH"
%

category: 'Stream processing'
method: CZstream
flush: flagsInt
  "flagsInt may be nil (implies Z_FINISH)
   or should be Z_FLUSH_SYNC .
   Ruby has additional code in git "
  | bs csiz done |
  (bs := bufSize) ~~ 0 ifTrue:[
    comprBuffer ifNil:[ comprBuffer := String new: ( bs max: 256) ].
    self _compressAndWriteFrom: buffer count: bs
    "at this point buffer has been consumed "
  ].
  done := false .
  [ done ] whileFalse:[
    comprBuffer ifNil:[ comprBuffer := String new: 256 ].
    done := self _streamOp: 2 with: flagsInt .  "deflate(zstream, flags)"
    (csiz := comprSize) ~~ 0 ifTrue:[ | status |
      status := ioObj write: csiz from: comprBuffer .
      status ifNil:[ errorClass signal: 'error on output object' ].
      comprSize := 0
    ]
  ].
%

category: 'Stream processing'
method: CZstream
header
  "Returns an Array, { originalName. comment. mtime }
   from header of a gzip file, or signals an error.  mtime is a time_t as an Integer"
  forWrite ifTrue:[ errorClass signal:'stream not opened for reading'].
  header ifNil:[
    self _readAndDecompress .
    header == false ifTrue:[ errorClass signal:'stream has no gzip header'].
  ].
  ^ header
%

category: 'Initialization'
method: CZstream
open: writeBoolean io: anIO errorClass: anExceptionClass comprLevel: anInt
  self _setNoStubbing . "ensure buffers stay in memory if rcvr committed"
  forWrite := writeBoolean .
  ioObj := anIO .
  errorClass := anExceptionClass .
  writeBoolean ifTrue:[ buffer := String new: 1024 ]
             ifFalse:[ buffer := nil ].
  bufSize := 0 .
  "logically comprBuffer is a ByteArray, but for use from Ruby,
     we need to use a String "
  writeBoolean ifTrue:[ comprBuffer := nil "created on demand" ]
              ifFalse:[ comprBuffer := String new: 1024 "grown as needed" ].
  comprSize := 0 .
  comprOffset := 1 .
  header := nil .
  self _streamOp: 0 with: anInt . "initialize C z_stream"
%

category: 'Stream processing'
method: CZstream
position
 "Returns the current position of the receiver, or nil receiver has been closed"

 ioObj ifNil:[ ^ nil ].
 forWrite ifTrue:[
   ^ (self _streamOp: 3 with:nil )"z_stream.total_out" + bufSize
 ] ifFalse:[
   ^ (self _streamOp: 3 with:nil )"z_stream.total_in" - bufSize
 ]
%

category: 'Stream processing'
method: CZstream
read: maxBytes
  "read and decompress up to maxBytes from receiver,
   returning a String which may be smaller than maxBytes.
   Result will be of size 0 if EOF hit."
  | res bs |
  maxBytes == 0 ifTrue:[ errorClass signal:'maxBytes must be > 0'].
  (bs := bufSize) == 0 ifTrue:[
    bs := self _readAndDecompress .
    bs == 0 ifTrue:[ ^ String new ].
  ].
  maxBytes >= bs ifTrue:[
    res := buffer .
    res size: bs .
    buffer := nil .
    bufSize := 0 .
  ] ifFalse:[
    res := buffer copyFrom:1 to: maxBytes .
   "buffer copyFrom: maxBytes + 1 to: bs into: buffer startingAt: 1 ."
    buffer replaceFrom: 1 to:  bs - maxBytes with: buffer startingAt: maxBytes + 1 .
    bufSize := bs - maxBytes .
  ].
  ^ res
%

category: 'Stream processing'
method: CZstream
readAll
| res str |
res := String new .
[ true ] whileTrue:[
  str := self read: 16384 .
  str size == 0 ifTrue:[ ^ res ].
  res addAll: str .
]
%

category: 'Stream processing'
method: CZstream
write: aString
 "aString may also be aByteArray"
  ^ self write: aString count: aString size
%

category: 'Stream processing'
method: CZstream
write: aString  count: numBytes
 "aString may also be aByteArray"

 | bs |
 numBytes < HalfComprBufSize ifTrue:[
   (numBytes + (bs:= bufSize))  >  HalfComprBufSize ifTrue:[
     self _compressAndWriteFrom: buffer count: bs .
     bs := 0 .
     bufSize := 0 .
   ].
  "aString copyFrom: 1 to: numBytes into: buffer startingAt: bs + 1 . "
   buffer replaceFrom: bs + 1 to: bs + numBytes with: aString startingAt: 1 .
   bufSize := bs + numBytes .
 ] ifFalse:[
   (bs := bufSize) ~~ 0 ifTrue:[
     self _compressAndWriteFrom: buffer count: bs .
     bufSize := 0 .
   ].
   self _compressAndWriteFrom: aString count: numBytes
 ]
%

category: 'Stream processing'
method: CZstream
writeHeader: aGzipHeaderArray
  "must be the first write after opening a new stream, to
   be used if a gzip header is desired on the compressed output

   aGzipHeaderArray is of form
     { originalNameString. commentString . mtimeSmallInt} "

  ^ self _compress: aGzipHeaderArray from: nil to: nil
%

category: 'Stream processing'
method: CZstream
_compress: aBuffer from: offset to: endOffset

"Usages
  _compress: aStringOrByteArray from: aSmallInt to: aSmallInt
     buffer is a String or ByteArray, containing uncompressed data
     per offset, endOffset.  primitive writes compressedData into
     self.comprBuffer, and updates self.comprSize

     result is offset to use for next call, or endOffset + 1
     if buffer is was completely consumed.

  _compress: anGzipHeaderArray from: nil to: nil
     result is nil , must be first call after init for write.
"

<primitive: 648>
%

category: 'Stream processing'
method: CZstream
_compressAndWriteFrom: inputObj count: numBytes
  "Ruby has additional code in git "
  | ofs |
  ofs := 1 .
  [ true ] whileTrue:[ | csiz |
    (csiz := comprSize) > HalfComprBufSize ifTrue:[ | status |
      status := ioObj write: csiz from: comprBuffer .
      status ifNil:[ errorClass signal: 'error on output object' ].
      comprSize := 0
    ].
    ofs > numBytes ifTrue:[
      ^ self "DONE"
    ].
    comprBuffer ifNil:[ comprBuffer := String new: ComprBufSize ].
    "compress primitive updates comprSize to reflect bytes added
      to comprBuffer ."
    ofs := self _compress: inputObj from: ofs to: numBytes .
  ]
%

category: 'Stream processing'
method: CZstream
_decompress

"decompress the bytes  (comprBuffer copyFrom: comprOffset to: comprSize)
            into       buffer at:1  .
 grows buffer as needed up to max of 16K and
 returns new value of bufSize instVar,
 which reflects number of bytes available in buffer.
 Also updates comprOffset instVar to reflect bytes consumed. "

<primitive: 705>
self _primitiveFailed: #_decompress:
%

category: 'Stream processing'
method: CZstream
_finishReading

"Closes a stream that was open for input and deallocates zlib C memory"
self _streamOp: 1 with: nil
%

category: 'Stream processing'
method: CZstream
_readAndDecompress
  "Returns the number of available bytes in uncompressed  buffer,
   or zero if at EOF.  Ruby has additional code in git "
  | bs |
  bs := bufSize .
  [ bs == 0 ] whileTrue:[
    comprOffset > comprSize ifTrue:[ | cbuf count |
      count := ioObj read: (cbuf := comprBuffer) size into: comprBuffer  .
      count == 0 ifTrue:[ ^ 0 "EOF" ].
      count ifNil:[ errorClass signal:'error on input stream' ].
      comprOffset := 1 .
      comprSize := count .
    ].
    bs := self _decompress
  ].
  ^ bs
%

category: 'Stream processing'
method: CZstream
_streamOp: opcode with: anArg

"opcode  0  initialize the C z_stream , anArg is compression level for output
         1  close the zstream , sets ioObj to nil
         2  flush zstream to comprBuf, returns true of no more output
         3  get position, from the C z_stream  return total_in for an output stream
               or total_out for an output stream"

<primitive: 647>
opcode == 1 ifTrue:[ errorClass signal:'stream already closed'].
opcode == 2 ifTrue:[ errorClass signal:'stream already closed'].
self _primitiveFailed: #_streamOp: args: { opcode . anArg }
%

! Class extensions for 'Delay'

!		Class methods for 'Delay'

removeallmethods Delay
removeallclassmethods Delay

category: 'Instance Creation'
classmethod: Delay
forMilliseconds: millisecondCount
  "Answer a new instance that will suspend the active process
   for millisecondCount milliseconds when sent the message wait."

  ^ self _basicNew interval: millisecondCount
%

category: 'Instance Creation'
classmethod: Delay
forSeconds: secondCount
  "Answer a new instance that will suspend the active process
   for secondCount seconds when sent the message wait."

  ^ self forMilliseconds: secondCount * 1000
%

category: 'General Inquiries'
classmethod: Delay
millisecondClockValue
  "Returns a SmallInteger, the current value of the millisecond clock.

   Gs64 v2.2, changed to no longer rollover to zero after 524287999 "

<primitive: 651>
^ self _primitiveFailed: #millisecondClockValue
%

category: 'Instance Creation'
classmethod: Delay
new

"Disallowed."

self shouldNotImplement: #new
%

category: 'Instance Creation'
classmethod: Delay
untilMilliseconds: millisecondValue
  "Answer a new instance that will suspend the active process
   until the millisecond clock reaches the value millisecondValue."

  millisecondValue _isSmallInteger ifFalse:[
    millisecondValue _validateClass: SmallInteger.
  ].
  millisecondValue < 0 ifTrue:[
    ^ millisecondValue _error: #rtErrArgNotPositive
  ].
  ^ self _basicNew _signalTime: millisecondValue
%

category: 'Process Delay'
classmethod: Delay
waitForMilliseconds: millisecondCount
  "Suspends the active process for millisecondCount milliseconds.
   Note that this method does not create or use an instance of Delay.
   Returns the receiver."

  | sched |
  millisecondCount < 0 ifTrue:[
    ^ millisecondCount _error: #rtErrArgNotPositive
  ].
  (sched := self _scheduler) _enterCritical .
  sched _waitForMilliseconds: millisecondCount .  "exits critical"
  1 timesRepeat:[ self class ].  "check for a Break"
  ^self
%

category: 'Process Delay'
classmethod: Delay
waitForSeconds: secondCount
  "Suspends the active process for secondCount seconds.
   Note that this method does not create or use an instance of Delay.
   Returns the receiver."

  | sched |
  secondCount < 0 ifTrue:[
    ^ secondCount _error: #rtErrArgNotPositive
  ].
  (sched := self _scheduler) _enterCritical .
  sched _waitForMilliseconds: secondCount * 1000 .  "exits critical"
  1 timesRepeat:[ self class ].  "check for a Break"
  ^self
%

category: 'Process Delay'
classmethod: Delay
waitUntilMilliseconds: millisecondValue
  "Suspends the active process until the millisecond clock
   reaches the value millisecondValue.
   Note that this method does not create or use an instance of Delay.
   Returns the receiver."

  | delta sched |
  millisecondValue _isSmallInteger ifFalse:[
    millisecondValue _validateClass: SmallInteger.
  ].
  millisecondValue < 0 ifTrue:[
    ^ millisecondValue _error: #rtErrArgNotPositive
  ].
  (sched := self _scheduler) _enterCritical .
  delta := millisecondValue -  sched _now .
  delta < 0 ifTrue:[ delta := 0 ].
  sched _waitForMilliseconds: delta.
  1 timesRepeat:[ self class ].  "check for a Break"
  ^self
%

category: 'GBS Access'
classmethod: Delay
_highPriorityWaitForMilliseconds: millisecondCount
  "Set the active process's priority high and then
   suspends the active process for millisecondCount milliseconds.
   Note that this method does not create or use an instance of Delay.
   Returns the receiver."

  | sched oldPrio proc |
  (sched := self _scheduler) _enterCritical .
  proc := sched activeProcess .
  oldPrio := proc _raisePriority .
  sched _waitForMilliseconds: millisecondCount .  "exits critical"
  sched _enterCritical .
  sched activeProcess == proc ifTrue:[
    proc priority: oldPrio .
  ].
  sched _exitCritical .
  1 timesRepeat:[ self class ].  "check for a Break"
  ^ self
%

category: 'Private'
classmethod: Delay
_scheduler

"Returns   ProcessorScheduler scheduler "
<primitive: 457>

self _primitiveFailed: #_scheduler
%

!		Instance methods for 'Delay'

category: 'Process Delay'
method: Delay
highPriorityWait
  "Suspend the active process until the millisecond clock
   reaches the appropriate value.  The active process priority
   is raised for the duration of the wait, so that expiration of the delay
   will cause the active process to resume thus interrupting any infinite loop
   or infinite wait for socket activity in other processes."

 ^ self _wait: true
%

category: 'Testing'
method: Delay
inProgress
  "Returns true if a GsProcess is currently waiting on the receiver."

  ^(target ~~ nil)
%

category: 'Private'
method: Delay
interval: millisecondCount
  "initialize the receiver to delay on an interval"

  millisecondCount _isSmallInteger ifFalse:[
    millisecondCount _validateClass: SmallInteger.
  ].
  millisecondCount < 0 ifTrue:[
    ^ millisecondCount _error: #rtErrArgNotPositive
  ].
  interval := millisecondCount .
  signalTime := nil .
  target := nil .
%

category: 'Formatting'
method: Delay
printOn: aStream
  aStream
    nextPutAll: self class name;
    nextPut: $(.
  self asOop printOn: aStream.
  aStream nextPutAll: ',i='.
  interval printOn: aStream.
  aStream nextPutAll: ',t='.
  signalTime printOn: aStream.
  aStream nextPutAll: ',s='.
  target printOn: aStream.
  aStream nextPut: $).
%

category: 'Accessing'
method: Delay
priority
  | targ |
  ^ (targ := target) class == GsProcess ifTrue:[  targ priority ]
		ifFalse:[ 15 "inline userSchedulingPriority" ].
%

category: 'Accessing'
method: Delay
resumptionTime
  "Answer the value of the millisecond clock at which
   the delayed process will be resumed.  This will be nil
   if the receiver was created with an interval and no
   wait has been issued."

  (interval == nil) ifTrue: [
    ^signalTime
  ] ifFalse: [
    (target ~~ nil"inline inProgress") ifTrue: [
      ^signalTime
    ] ifFalse: [
      ^nil
    ].
  ].
%

category: 'Process Delay'
method: Delay
signal
  "Causes the receiver to signal any processes that have sent wait to it."

  self _scheduler _delayUnschedule: self.
  ^self _activate.
%

category: 'Process Delay'
method: Delay
wait
  "Suspend the active process until the millisecond clock
   reaches the appropriate value."

self _wait: false
%

category: 'Private'
method: Delay
_activate
  "Causes the receiver to signal any processes that have sent wait to it."

  target _signalAll .
  target := nil.
  ^self
%

category: 'Private'
method: Delay
_cancel: aGsProcess
  "Cancels a delay that is in progress.
   The receiver will not signal any processes that have sent wait to it.
   Only use if you know that the processes that are waiting on the receiver
   will be signalled in some other way."

  (aGsProcess == target) ifTrue: [
    self _scheduler _delayUnschedule: self.
    target := nil.
  ].
%

category: 'Private'
method: Delay
_changePriority: aGsProcess from: oldPriority
  "Sent by code in GsProcess to change the priority of aGsProcess.waitingOn,
   when aGsProcess.waitingOn is a Delay.  Since a Delay does not contain
   a list of processes sorted by priority, there is nothing to do."
%

category: 'Private'
method: Delay
_scheduler

"Returns   ProcessorScheduler scheduler "
<primitive: 457>

self _primitiveFailed: #_scheduler
%

category: 'Private'
method: Delay
_signalTime
  ^signalTime
%

category: 'Private'
method: Delay
_signalTime: millisecondClockValue
  "sets the receiver's signal time w/o regard to the current time
   or delay interval"

  signalTime := millisecondClockValue
%

category: 'Private'
method: Delay
_targetProcess
  "Returns the GsProcess that is waiting for the receiver."
  | targ |
  ^ (targ := target) class == GsProcess ifTrue: [ targ ] ifFalse: [ nil ]
%

category: 'Private'
method: Delay
_unscheduleProcess: aGsProcess
  "Used by ProcessorScheduler"
  self _cancel: aGsProcess.
%

category: 'Private'
method: Delay
_wait: highPriorityBoolean

  "Suspend the active process until the millisecond clock
   reaches the appropriate value."

  | interv targ proc oldPrio sched |
  (sched := self _scheduler) _enterCritical .
  (interv := interval) ifNotNil: [
    "If another process is already using this interval delay raise an error"
    target ifNotNil: [
      sched _exitCritical .
      ThreadError new _number: 2365 ; reason: #rtErrDelayInProgress ;
         object: self ; details:'Another GsProcess already waiting on this Delay';
         signal .
      ^ self
    ].
  ].
  highPriorityBoolean ifTrue:[
    proc := sched activeProcess .
    oldPrio := proc _raisePriority .
  ].
  interv ifNotNil: [
    signalTime := interv + (sched _now).
    targ := sched activeProcess .
    target := targ .
    targ _waitingOn: self.
    sched _delaySchedule: self.
  ] ifNil: [
    (targ := target) ifNil: [
      targ := Semaphore new.
      target := targ .
      sched _delaySchedule: self.
    ].
  ].
  sched _exitCritical .
  [
    targ _wait .
  ] ensure: [ 
    sched _enterCritical .
    sched _delayUnschedule: self .
    sched _exitCritical .
  ].
  highPriorityBoolean ifTrue:[
    sched _enterCritical .
    sched activeProcess == proc ifTrue:[
      proc priority: oldPrio .
    ].
    sched _exitCritical .
  ].
  1 timesRepeat:[ self class ].  "check for a Break"
  ^self
%

! Class extensions for 'DependencyList'

!		Class methods for 'DependencyList'

category: 'Updating'
classmethod: DependencyList
clearForAll: anArray
"Sets the dependency entry for all elements of anArray to be nil."

<primitive: 982>
| tl |
(tl := System transactionLevel) ~~ 1 ifTrue:[
  Error signal:( tl == 0 ifTrue:[ 'operation not supported outside of a transaction']
			ifFalse:[ 'operation not supported in a nested transaction']).
].
anArray class ~~ Array ifTrue:[ ArgumentTypeError signal:'argument must be an Array'].
self _primitiveFailed: #clear:forAll: args: { anArray } .
self _uncontinuableError
%

category: 'Updating'
classmethod: DependencyList
clearForHiddenSet: hiddenSetSpecifier

"For each object represented in the hidden set, set the dependency entry to nil,
 and remove the object from the hidden set.
 hiddenSetSpecifier should be 2 or  in the range 41..45 inclusive.
 Returns a SmallInteger, the number of objects processed."

<primitive: 1016>
hiddenSetSpecifier _validateClass: SmallInteger.
(hiddenSetSpecifier == 2 or:[ hiddenSetSpecifier >= 41 and:[hiddenSetSpecifier <= 45]])
  ifFalse:[  ArgumentError signal:'invalid hidden set' ].
self _primitiveFailed: #clearForHiddenSet: args: { hiddenSetSpecifier } .
self _uncontinuableError
%

category: 'Accessing'
classmethod: DependencyList
depMapKeys

"Return an array of objects that have dependents."

^self _depMap: true
%

category: 'Accessing'
classmethod: DependencyList
depMapKeysToHiddenSet:  aHiddenSetId

"Returns the objects that have dependents in the specified hidden set.
 The hiddenSet id must be one of the Reserved for GemStone hidden sets"

^self _depMap: true toHiddenSet: aHiddenSetId
%

category: 'Accessing'
classmethod: DependencyList
depMapValues

"Returns array of objects that are dependents."

^self _depMap: false
%

category: 'Accessing'
classmethod: DependencyList
depMapValuesToHiddenSet: aHiddenSetId

"Returns the objects that are dependents in the specified hidden set.
 The hiddenSet id must be one of the Reserved for GemStone hidden sets"

^self _depMap: false toHiddenSet: aHiddenSetId
%

category: 'Accessing'
classmethod: DependencyList
for: anObject

"Returns the dependency list for the receiver.  If one does not exist,
 returns nil."

<primitive: 585>
self _primitiveFailed: #for: args: { anObject } .
self _uncontinuableError
%

category: 'Copying'
classmethod: DependencyList
from: aDepList

"Returns a dependency list that is a copy of the given dependency list."

| dl pathTerm pathTerms |
aDepList == nil
  ifTrue: [ ^ self new ].

dl := aDepList copy.
1 to: dl size by: 2 do: [ :i |
  pathTerm := aDepList at: i.
  pathTerm _isObsoletePathTerm
    ifTrue: [
      " lazy initialization of pathTerms set "
      pathTerms == nil
        ifTrue: [ pathTerms := IdentitySet new ].
      pathTerms add: pathTerm.
    ]
].

" remove obsolete path terms if there are any "
pathTerms == nil
  ifFalse: [
    1 to: pathTerms size do: [ :i |
      dl _removeCompletelyPathTerm: (pathTerms at: i)
    ]
  ].
^ dl
%

category: 'Testing'
classmethod: DependencyList
needsDepList: anObject

"Returns whether anObject needs a dependency list if it is the last
 object along an equality index path."

<primitive: 210>
self _primitiveFailed: #needsDepList: args: { anObject } .
self _uncontinuableError
%

category: 'Removing'
classmethod: DependencyList
removePathTerm: pathTerm for: anObject

^self removePathTerm: pathTerm for: anObject logging: false
%

category: 'Removing'
classmethod: DependencyList
removePathTerm: pathTerm for: anObject logging: aBoolean
  "Removes the entry (an entry has 2 slots) for the given path term.
 If it is the last remaining entry, then the dependency list becomes
 nil."

  | depList |
  depList := self for: anObject.
  depList == nil
    ifTrue: [ ^ self ].
  depList size == 0
    ifTrue: [
      self set: nil for: anObject.
      ^ self ].
  (depList size == 2
    and: [ (depList includesIdentical: pathTerm) and: [ (self needsDepList: anObject) not ] ])
    ifTrue: [
      " if only one entry, remove dependency "
      self set: nil for: anObject.
      ^ self ].
  depList := self from: depList.
  depList _removePathTerm: pathTerm for: anObject.
  self set: (SharedDependencyLists at: depList logging: true) for: anObject
%

category: 'Removing'
classmethod: DependencyList
removeTracker: tracker for: anObject
  "Removes the given tracking object from the receiver."

  | depList |
  depList := self for: anObject.
  depList == nil
    ifTrue: [ ^ self ].	" if only one entry, set the dependency tag to be nil "
  (depList size <= 2 and: [ tracker == (depList at: 1) ])
    ifTrue: [
      self set: nil for: anObject.
      ^ self ].
  depList := self from: depList.
  depList _removeTracker: tracker for: anObject.
  self set: (SharedDependencyLists at: depList logging: true) for: anObject
%

category: 'Updating'
classmethod: DependencyList
set: aDependent for: anObject

"Sets the dependency entry for anObject to be aDependent."

<primitive: 584>
self _primitiveFailed: #set:for: args: { aDependent . anObject } .
self _uncontinuableError
%

category: 'Private'
classmethod: DependencyList
_depMap: aBool

<primitive: 586>
aBool _validateClass: Boolean.
^self _primitiveFailed: #_depMap: args: { aBool }.
%

category: 'Private'
classmethod: DependencyList
_depMap: aBool toHiddenSet: aHiddenSetId

<primitive: 587>
aBool _validateClass: Boolean .
aHiddenSetId _validateClass: SmallInteger .
^self _primitiveFailed: #_depMap: args: {aBool . aHiddenSetId}.
%

!		Instance methods for 'DependencyList'

category: 'Comparing'
method: DependencyList
< depList

"Returns whether the receiver precedes the argument when sorted based upon
 the OOPs of the path terms. "

<primitive: 333>
self _primitiveFailed: #< args: { depList } .
self _uncontinuableError
%

category: 'Comparing'
method: DependencyList
= anotherDependencyList
    "If the comparison comes down to the element-wise test, only
    compare path terms and use identity.

    N.B. a hash method is not required for this class because its use
    is private to Gemstone. If one were desirable, the technique would
    be to OR the path term identities."

    | size |
    self == anotherDependencyList ifTrue:
        [^true].
    self class == anotherDependencyList class ifFalse:
        [^false].
    size := anotherDependencyList size.
    self size == size ifFalse:
        [^false].
    1 to: size do:
        [ :i |
         (self at: i) == (anotherDependencyList at: i) ifFalse:
             [^false]].
    ^true
%

category: 'Comparing'
method: DependencyList
> depList

"Returns whether the receiver follows the argument when sorted based upon
 the OOPs of the path terms."

<primitive: 522>
self _primitiveFailed: #> args: { depList } .
self _uncontinuableError
%

category: 'Updating'
method: DependencyList
addPathTerm: pathTerm
withIVOffset: anInteger
for: anObject

"Adds an entry containing the path term, and instance variable offset to the
 receiver. Primitive will grow receiver if necessary."

<primitive: 523>
self _primitiveFailed: #addPathTerm:withIVOffset:for:
     args: { pathTerm . anInteger . anObject } .
self _uncontinuableError
%

category: 'Testing'
method: DependencyList
containsAnyOf: arrayOfPathTerms

"Returns whether the receiver contains an entry with any path term in
 the Array of path terms."

1 to: self size by: 2 do: [ :i |
  ( arrayOfPathTerms includesIdentical: (self at: i) )
    ifTrue: [ ^ true ]
].
^ false
%

category: 'Updating'
method: DependencyList
copyAndAddLastElementPathTerm: pathTerm for: object
  "Makes a copy of the receiver that has an additional entry containing the
 path term, and instance variable offset."

  | sz dl ptOop thisTerm referenceCount |
  referenceCount := -1.	"reference counts are negative numbers"
  ptOop := pathTerm asOop.
  sz := self size.
  1 to: sz by: 2 do: [ :i |
    thisTerm := self at: i.
    pathTerm == thisTerm
      ifTrue: [
        dl := self copy.
        (self class needsDepList: object)
          ifTrue: [
            | existingReferenceCount |
            "bump reference count"
            existingReferenceCount := dl at: i + 1.
            existingReferenceCount := existingReferenceCount > 0
              ifTrue: [
                object class isBytes
                  ifFalse: [
                    "not a reference count, no need to do anything else (bug42640)"
                    ^dl ].
                "upgraded reference counts are positive numbers for byte indexable
                 objects, negate and decrement count ... Bug 42460"
                existingReferenceCount negated - 1 ]
              ifFalse: [
                "reference counts are negative numbers ... just decrement the count ... Bug 42460"
                existingReferenceCount - 1 ].
           dl at: i + 1 put: existingReferenceCount ].
        ^ dl ]
      ifFalse: [
        ptOop < thisTerm asOop
          ifTrue: [
            dl := self class new: sz + 2.
            i == 1
              ifTrue: [
                dl
                  replaceFrom: 3
                  to: 2 + sz
                  with: self
                  startingAt: 1 ]
              ifFalse: [
                dl
                  replaceFrom: 1
                  to: i - 1
                  with: self
                  startingAt: 1.
                dl
                  replaceFrom: i + 2
                  to: 2 + sz
                  with: self
                  startingAt: i ].
            dl at: i put: pathTerm.
            dl at: i + 1 put: referenceCount.
            ^ dl ] ] ].
  dl := self class new: sz + 2.
  sz > 0
    ifTrue: [
      dl
        replaceFrom: 1
        to: sz
        with: self
        startingAt: 1 ].
  dl at: sz + 1 put: pathTerm.
  dl at: sz + 2 put: referenceCount.
  ^ dl
%

category: 'Updating'
method: DependencyList
copyAndAddPathTerm: pathTerm withIVOffset: ivOffset for: object
  "Makes a copy of the receiver that has an additional entry containing the
 path term, and instance variable offset."

  | sz dl ptOop thisTerm |
  ptOop := pathTerm asOop.
  sz := self size.
  1 to: sz by: 2 do: [ :i |
    thisTerm := self at: i.
    pathTerm == thisTerm
      ifTrue: [ ^ self copy ]
      ifFalse: [
        ptOop < thisTerm asOop
          ifTrue: [
            dl := self class new: sz + 2.
            i == 1
              ifTrue: [
                dl
                  replaceFrom: 3
                  to: 2 + sz
                  with: self
                  startingAt: 1 ]
              ifFalse: [
                dl
                  replaceFrom: 1
                  to: i - 1
                  with: self
                  startingAt: 1.
                dl
                  replaceFrom: i + 2
                  to: 2 + sz
                  with: self
                  startingAt: i ].
            dl at: i put: pathTerm.
            dl at: i + 1 put: ivOffset.
            ^ dl ] ] ].
  dl := self class new: sz + 2.
  sz > 0
    ifTrue: [
      dl
        replaceFrom: 1
        to: sz
        with: self
        startingAt: 1 ].
  dl at: sz + 1 put: pathTerm.
  dl at: sz + 2 put: ivOffset.
  ^ dl
%

category: 'Updating'
method: DependencyList
copyAndAddTracker: tracker withId: anInteger for: object

"Adds the tracking object and the integer offset to the receiver."

| sz dl trackerOop thisTerm |

trackerOop := tracker asOop.
sz := self size.
1 to: sz by: 2 do: [ :i |
  thisTerm := self at: i.
  (tracker == thisTerm)
    ifTrue: [ ^ self copy ]
    ifFalse: [
      trackerOop < thisTerm asOop
        ifTrue: [
          dl := self class new: sz + 2.
          i == 1
            ifTrue: [
              "self copyFrom: 1 to: sz into: dl startingAt: 3. "
              dl replaceFrom: 3 to: 2 + sz  with: self startingAt: 1 .
            ]
            ifFalse: [
              "self copyFrom: 1 to: i - 1 into: dl startingAt: 1 "
              dl replaceFrom: 1 to: i - 1 with: self startingAt: 1 .
              "self copyFrom: i to: sz into: dl startingAt: i + 2 "
              dl replaceFrom: i + 2 to: 2 + sz "(i + 2) + sz - i" with: self startingAt: i
             ].
          dl at: i put: tracker.
          dl at: i + 1 put: anInteger.
          ^ dl
        ]
    ]
].

dl := self class new: sz + 2.
sz ~~ 0 ifTrue: [
  "self copyFrom: 1 to: sz into: dl startingAt: 1 "
  dl replaceFrom: 1 to: sz with: self startingAt: 1
].
dl at: sz + 1 put: tracker.
dl at: sz + 2 put: anInteger.
^ dl
%

category: 'Searching'
method: DependencyList
getInstVarOffsetWithPathTerm: pathTerm
  "Returns the instance variable offset for the entry at which a path term is
 located in the receiver, or zero if it is not found.

 Should only be used with non-collection based pathTerms ... "

  "Performs a linear search."

  | i |
  (i := self _findOffsetForPathTerm: pathTerm) == nil
    ifTrue: [ ^ 0 ].
  ^ self at: i + 1
%

category: 'Removing'
method: DependencyList
removeCompletelyPathTerm: pathTerm for: anObject
  "Removes the entry with the given path term.  Returns the instance variable
 offset for the given path term."

  | depList ivOffset depListClass |
  " if only one entry, set the dependency tag to be nil "
  (self size == 2 and: [ pathTerm == (self at: 1) ])
    ifTrue: [
      DependencyList set: nil for: anObject.
      ^ self at: 2	"may be negative for reference counting of last element dependency list" ].
  depListClass := self class.
  depList := depListClass from: self.
  ivOffset := depList _removeCompletelyPathTerm: pathTerm.	"may be negative for reference counting of last element dependency list"
  depListClass
    set: (SharedDependencyLists at: depList logging: true)
    for: anObject.
  IndexManager current commitIndexMaintenance: nil at: 0.	"fix 43647: call commitIndexMaintenance bug indexObj and progressCount not applicable"
  ^ ivOffset
%

category: 'Removing'
method: DependencyList
removePathTerms: pathTerms for: anObject

^self removePathTerms: pathTerms for: anObject logging: false
%

category: 'Removing'
method: DependencyList
removePathTerms: pathTerms for: anObject logging: aBoolean

"Removes the entries for the given collection of path terms.  If they are
 the last remaining entries, then the dependency list becomes nil."

" if it is a byte object "
| depListClass |
depListClass := self class .
1 to: pathTerms size do: [ :j |
  depListClass removePathTerm: (pathTerms at: j) for: anObject logging: aBoolean
]
%

category: 'Searching'
method: DependencyList
_findAllTrackersOfClass: aClass

"Returns an Array of all tracker objects of the given class."

| result |
result := { } .
2 to: self size by: 2 do: [ :i |
  ( (self at: i) <= 0 and: [ (self at: i - 1) class == aClass ] )
    ifTrue: [ result add: (self at: i - 1) ]
].
^ result
%

category: 'Searching'
method: DependencyList
_findOffsetForPathTerm: pathTerm

"Returns the offset at which a path term is located in the receiver, or nil
 if it is not found.  Performs a linear search."

1 to: self size by: 2 do: [ :i |
  pathTerm == (self at: i)
    ifTrue: [ ^ i ]
].
^ nil
%

category: 'Searching'
method: DependencyList
_findPathTermForOffset: offset

"Returns the path term associated with the given instance variable offset if
 it exists; otherwise returns nil. NOTE: there may be more than one pathTerm for
 the given object this method returns only the first."

2 to: self size by: 2 do: [ :i |
  (self at: i) == offset
    ifTrue: [ ^ self at: i - 1 ]
].
^ nil
%

category: 'Searching'
method: DependencyList
_findTrackerOfClass: aClass

"Returns the first tracker object of the given class.  If none is found,
 returns nil."

2 to: self size by: 2 do: [ :i |
  ( (self at: i) <= 0 and: [ (self at: i - 1) class == aClass ] )
    ifTrue: [ ^ self at: i - 1 ]
].
^ nil
%

category: 'Searching'
method: DependencyList
_getAllTrackers

"Returns an Array of all tracker objects of the given class."


| result |
result := { } .
2 to: self size by: 2 do: [ :i |
  (self at: i) <= 0
    ifTrue: [ result add: (self at: i - 1) ]
].
^ result
%

category: 'Testing'
method: DependencyList
_hasObsoletePathTerm

"Returns whether the receiver has an obsolete path term
 (one whose size is zero)."

1 to: self size by: 2 do: [ :i |
  ( (self at: i + 1) > 0 and: [ (self at: i) size == 0 ] )
    ifTrue: [ ^ true ]
].
^ false
%

category: 'Auditing'
method: DependencyList
_needsSorting

"Return whether all pathterms in the receiver are in the correct order."

| hash prevHash |
prevHash := 0.
1 to: self size by: 2 do: [ :i |
  hash := (self at: i) asOop.
  hash < prevHash
    ifTrue: [ ^ true ]
    ifFalse: [ prevHash := hash ].
].
^ false
%

category: 'Removing'
method: DependencyList
_removeCompletelyPathTerm: pathTerm
  "Removes the entry with the given path term.  Returns the instance variable
   offset for the given path term
     or
   reference count of last element if iv offset is negative"

  | sz ivOffset |
  sz := self size.
  1 to: sz by: 2 do: [ :i |
    pathTerm == (self at: i)
      ifTrue: [
        ivOffset := self at: i + 1.
        i == (sz - 1)
          ifFalse: [
            " not last entry shift remaining entries "
            self
              replaceFrom: i
              to: sz - 2
              with: self
              startingAt: i + 2 ].
        self size: sz - 2.
        ^ ivOffset ] ].
  ^ 0
%

category: 'Auditing'
method: DependencyList
_removeEntryAtOffset: offset

"Remove the entry at the given offset."

| sz |
offset odd
  ifFalse: [ ^ self ].

sz := self size.
offset == (sz - 1) ifFalse: [
  "self copyFrom: offset + 2 to: sz into: self startingAt: offset  "
  self replaceFrom: offset to:  sz -  2 with: self startingAt: offset + 2
].
self size: sz - 2.
%

category: 'Removing'
method: DependencyList
_removePathTerm: pathTerm for: anObject
  "Removes the entry with the given path term."

  | sz ivOffset |
  sz := self size.
  1 to: sz by: 2 do: [ :i |
    pathTerm == (self at: i)
      ifTrue: [
        ivOffset := self at: i + 1.
        ((DependencyList needsDepList: anObject)
          and: [ (anObject class isBytes and: [ ivOffset > 1 ]) or: [ ivOffset < -1 ] ])
          ifTrue: [
            ivOffset > 1
              ifTrue: [
                "Bug 42640 - upgraded indexes may have positive reference count for
                 byte indexable objects"
                self at: i + 1 put: ivOffset - 1 ]
              ifFalse: [
                "reference counts are negative numbers"
                " increment reference count"
                self at: i + 1 put: ivOffset + 1 ] ]
          ifFalse: [
            " see if found in the last entry "
            i == (sz - 1)
              ifFalse: [
                " shift remaining entries "
                self
                  replaceFrom: i
                  to: sz - 2
                  with: self
                  startingAt: i + 2 ].
            self size: sz - 2 ].
        ^ self ] ]
%

category: 'Removing'
method: DependencyList
_removeTracker: tracker for: anObject

"Removes the given tracking object from the receiver."

| sz |
sz := self size.
1 to: sz by: 2 do: [ :i |
  tracker == (self at: i)
    ifTrue: [
      " see if found in the last entry "
      i == (sz - 1)
        ifFalse: [ " shift remaining entries "
          " self copyFrom: i + 2 to: sz into: self startingAt: i "
          self replaceFrom: i to: sz - 2 with: self startingAt: i + 2
        ].
      self size: sz - 2.
      ^ self
    ]
]
%

category: 'Reduced Conflict Support'
method: DependencyList
_replaceReferencesWith: aDepList

"Scans the write set, looking for objects that have the receiver for a
 dependency tag.  For each one, replace the dependency tag with aDepList."

| writeSet obj depListClass |
writeSet := (GsBitmap newForHiddenSet: #DepMapWriteSet) asArray.
depListClass := self class .
1 to: writeSet size do: [ :i |
  obj := writeSet _at: i.
  self == (depListClass for: obj)
    ifTrue: [ depListClass set: aDepList for: obj ]
]
%

category: 'Auditing'
method: DependencyList
_sortEntries: aBucket

"Find entries that are not in order, then reinsert them in the
correct position.  Remove the receiver from the given bucket and
reinsert it in the shared dependency lists table.  Return the number
of entries sorted."

| hash prevHash entriesToMove |
prevHash := 0.
1 to: self size by: 2 do: [ :i |
  hash := (self at: i) asOop.
  hash < prevHash
    ifTrue: [
      entriesToMove == nil
        ifTrue: [ entriesToMove := { }  ].
      entriesToMove add: i; add: (self at: i); add: (self at: i + 1)
    ]
    ifFalse: [ prevHash := hash ].
].
entriesToMove size ~~ 0
  ifTrue: [
    aBucket remove: self.
    1 to: entriesToMove size by: 3 do: [ :i |
      self _removeEntryAtOffset: (entriesToMove at: i).
      self addPathTerm: (entriesToMove at: i + 1)
        withIVOffset: (entriesToMove at: i + 2)
        for: nil.
    ].
    SharedDependencyLists at: self logging: false
  ].
^ entriesToMove size
%

! Class extensions for 'DepListBucket'

!		Class methods for 'DepListBucket'

category: 'Instance Creation'
classmethod: DepListBucket
new

"Returns a DepListBucket with a default capacity of ten entries."


^ self new: 3
%

category: 'Instance Creation'
classmethod: DepListBucket
new: aSize

"Returns a DepListBucket with the given capacity of entries."


^ (super new: aSize) initialize
%

!		Instance methods for 'DepListBucket'

category: 'Updating'
method: DepListBucket
at: depList

"Returns the dependency list in the receiver that is equivalent to the given
 dependency list.  If one does not exist, add the given dependency list to the
 receiver and returns the given dependency list.  If one is found, the given
 dependency list is sized to zero."

  | dl |
  dl := self _bucketAt: depList.
  dl objectSecurityPolicy: self objectSecurityPolicy .
  ^dl
%

category: 'Enumerating'
method: DepListBucket
do: aBlock

"For each dependency list in the receiver, evaluates the one-argument block
 aBlock with the dependency list as the argument."


| aDL |
1 to: numElements do: [ :j |
  aDL := self _at: j.
  aDL == nil
    ifFalse: [ aBlock value: aDL ]
]
%

category: 'Constants'
method: DepListBucket
growIncrement

"Returns the number of entries to grow when needed."


^ 10
%

category: 'Initializing'
method: DepListBucket
initialize

"Initializes the instance variable of the receiver."


numElements := 0.
%

category: 'Removing'
method: DepListBucket
remove: aDepList

"Remove the given dependency list from the receiver.  Returns whether the
 removal occurred."


| offset |
offset := self _linearSearchFor: aDepList.
offset == 0
  ifTrue: [ ^ false ].

self _deleteNoShrinkFrom: offset to: offset .
numElements := numElements - 1.

^ true
%

category: 'Updating'
method: DepListBucket
reset

"Reset all entries to nil and the number of elements to zero."


super size: 0.
numElements := 0.
super size: self growIncrement.
System _addEntireObjectToRcReadSet: self
%

category: 'Updating'
method: DepListBucket
resizeIfNecessary

"Check the size of the receiver to see if it is unnecessarily greater
 than a page in size.  If so, resize it."


( self _basicSize > 2000 and: [ numElements < 2000 ] )
  ifTrue: [ super size: (2000 min: numElements + self growIncrement) ].
%

category: 'Accessing'
method: DepListBucket
size

"Returns the value of the numElements instance variable."

^ numElements
%

category: 'Searching'
method: DepListBucket
_binarySearchFor: aDepList

"Returns the offset into the receiver where the given dependency list
 can be found.  If not found, returns zero."


| lowPt midPt highPt currDL |

numElements == 0
  ifTrue: [ ^ 0 ].

lowPt := 1.
highPt := numElements.
[ lowPt <= highPt ] whileTrue: [
  midPt := (lowPt + highPt) quo: 2.
  currDL := self _rcAt: midPt.

  "use identity-based comparison of elements of dependency lists"
  (currDL hasIdenticalContents: aDepList)
    ifTrue: [ ^ midPt ].

  aDepList < currDL
    ifTrue: [ highPt := midPt - 1 ]
    ifFalse: [ lowPt := midPt + 1 ]
].

^ 0
%

category: 'Updating'
method: DepListBucket
_bucketAt: depList

"Returns the dependency list in the receiver that is equivalent to the given
 dependency list.  If one does not exist, add the given dependency list to the
 receiver and returns the given dependency list.  If one is found, the given
 dependency list is sized to zero."

<primitive: 215>
depList _validateInstanceOf: DependencyList .
self _primitiveFailed: #_bucketAt: args: { depList }
%

category: 'Auditing'
method: DepListBucket
_hasEntryOutOfOrder

"Return whether the receiver has any entry out of order."



| depList prevDepList |
self size > 1
  ifTrue: [
    prevDepList := self _at: 1.
    2 to: self size do: [ :j |
      depList := self _at: j.
      depList < prevDepList
        ifTrue: [ ^ true ]
    ]
  ].
^ false
%

category: 'Searching'
method: DepListBucket
_linearSearchFor: aDepList

"Private.  Returns the offset into the receiver where the given dependency list
 can be found.  If not found, returns zero."



1 to: numElements do: [ :j |
  aDepList == (self _at: j)
    ifTrue: [ ^ j ]
].
^ 0
%

! Class extensions for 'DepListTable'

!		Class methods for 'DepListTable'

category: 'Instance Creation'
classmethod: DepListTable
new

"Returns a DepListTable with the default table size."

| newOne |
newOne := self new: 751.
^ newOne
%

category: 'Instance Creation'
classmethod: DepListTable
new: size

"Returns a DepListTable with the given size."

| newOne |
newOne := (super new: size) initialize.
^ newOne
%

category: 'Private'
classmethod: DepListTable
_hasDependencyBitFor: anObj

"If anObj is a SmallInteger, it is interpreted as an OopType,
 and a depMap lookup is done , without looking at the in-memory state
 (if any) of that object.

 If anObj a non-special object, returns the in-memory hasDependency bit
 for that object without regard to the state of the shadow or shared depMap.

 Returns a Boolean."
<primitive: 161>
self _primitiveFailed: #_hasDependencyBitFor: args: { anObj } .
self _uncontinuableError
%

!		Instance methods for 'DepListTable'

category: 'Adding'
method: DepListTable
add: newObject

""
self shouldNotImplement: #add:
%

category: 'Updating'
method: DepListTable
addObsoletePathTerm: aPathTerm

"Adds the given path term to the set of obsolete path terms."

" obsoletePathTerms add: aPathTerm "
%

category: 'Accessing'
method: DepListTable
allEntries

"Returns an IdentitySet containing the receiver's entries."

| entries bkt |
entries := IdentitySet new.
1 to: self _basicSize do: [ :i |
  bkt := self _at: i.
  1 to: bkt size do: [ :j |
    entries add: (bkt _at: j).
  ]
].
^ entries
%

category: 'Updating'
method: DepListTable
at: depList logging: aBoolean
  "Returns the dependency list in the receiver that is equivalent to the
 given dependency list.  If one does not exist, add the given dependency
 list to the receiver and returns the given dependency list.  If the
 collision bucket is updated and aBoolean is true, log the operation
 in the system redo log."

  | dl bkt |
  (depList == nil or: [ depList isEmpty ])
    ifTrue: [ ^ nil ].
  bkt := self depListBucketFor: depList.
  dl := bkt at: depList.
  dl == depList
    ifTrue: [
      " new entry was added "
      aBoolean
        ifTrue: [ self _logAdditionOf: depList inCollisionBucket: bkt ].
      depList objectSecurityPolicy: self objectSecurityPolicy ].
  System _addEntireObjectToRcReadSet: bkt.
  System redoLog addLargeConflictObject: bkt for: self.
  ^ dl
%

category: 'Auditing'
method: DepListTable
auditAndRepair

"Search for any dependency lists or collision buckets that have
entries out of order, and repair them.  Get all dependency
lists by directly enumerating through all dependency lists in the
SharedDependencyLists table.  This method only touches internal
indexing objects, not application objects.  Perform any repairs
needed and return a string describing the repairs."

^ self _auditAndRepair: false
%

category: 'Clustering'
method: DepListTable
clusterDepthFirst

"This method clusters the receiver.  Returns true if the receiver has
 already been clustered during the current transaction; returns false
 otherwise."

| result |
self cluster
  ifTrue: [ result := true ]
  ifFalse: [
    " obsoletePathTerms cluster. "
    1 to: self _basicSize do: [ :i | (self _at: i) cluster ].
    result := false
  ].
^ result
%

category: 'Accessing'
method: DepListTable
depListBucketFor: depList

"Returns the bucket where the given depList would be found."

<primitive: 524>
self _primitiveFailed: #depListBucketFor: args: { depList } .
self _uncontinuableError
%

category: 'Enumerating'
method: DepListTable
do: aBlock

"For each dependency list in the receiver, evaluates the one-argument block
 aBlock with the dependency list as the argument."

aBlock _isExecBlock ifFalse:[ aBlock _validateClass: ExecBlock ].
1 to: self _basicSize do: [ :i |
  (self _at: i) do: aBlock
]
%

category: 'Auditing'
method: DepListTable
findNscsWithIndexes

"Return any indexed NSCs we can find."

| result |
result := IdentitySet new.
self allEntries accompaniedBy: result do: [ :res :dl |
  1 to: dl size by: 2 do: [ :i | | pt |
    pt := dl at: i.
    pt size > 0 ifTrue: [ res add: pt getRootNsc ].
  ].
].
^ result
%

category: 'Auditing'
method: DepListTable
fullAuditAndRepair

"Search for any dependency lists or collision buckets that have
entries out of order, and repair them.  Get all dependency
lists by finding all nsc's with indexes that we can, and iterate through
application objects, traversing down each index. path.  This
method performs a superset of the functionality of 'auditAndRepair'.
This can take much more time than 'auditAndRepair', due to the
number of objects fetched.  Perform any repairs needed and return
a string describing the repairs."

^ self _auditAndRepair: true
%

category: 'Initialization'
method: DepListTable
initialize

"Initializes a new instance."

1 to: self _basicSize do: [ :i |
  self at: i put: DepListBucket new.	"Hard-code the class (#43087)"
].

"No need to use obsoletePathTerms set with strong dependency list references
obsoletePathTerms := IdentitySet new.
"
self objectSecurityPolicy: GsIndexingObjectSecurityPolicy.
%

category: 'Updating'
method: DepListTable
objectSecurityPolicy: anObjectSecurityPolicy

"Place the receiver and its collision buckets in the given security policy."

super objectSecurityPolicy: anObjectSecurityPolicy.
1 to: self _basicSize do: [ :i |
  (self _at: i) objectSecurityPolicy: anObjectSecurityPolicy
].

%

category: 'Printing'
method: DepListTable
printOn: aStream

"Prints a string representation of the receiver on the given stream."

aStream nextPutAll: 'SharedDependencyLists'
%

category: 'Hashing'
method: DepListTable
rebuildTable: newSize

"Rebuilds the table by saving the current state, initializing and changing
 the size of the table, and adding the entries saved back to the table.
 This method is intended to be used by the system administrator when the
 table has become too large.  If it is invoked directly by an application,
 concurrency conflicts may result."

| depLists origSize |
(newSize <= 0)
  ifTrue: [
    newSize _error: #rtErrArgNotPositive .
    ^ self
  ].

" get all entries "
depLists := self allEntries.

origSize := self _basicSize.
" reset each bucket to be empty "
1 to: origSize do: [ :i | (self _at: i) reset ].

super size: newSize.

newSize > origSize
  ifTrue: [ " growing the table "
    (origSize + 1) to: newSize do: [ :i |
      super at: i put: DepListBucket new
    ]
  ].

" now add the entries back to the table "
1 to: depLists size do: [ :i |
  self at: (depLists _at: i) logging: false
].

self objectSecurityPolicy: GsIndexingObjectSecurityPolicy.
%

category: 'Repository Conversion'
method: DepListTable
reinitialize

"Reinitializes a given DepListTable.  This method is to be used only during
 conversion."

self initialize.
%

category: 'Updating'
method: DepListTable
remove: depList logging: aBoolean
  "Remove the given dependency list from the receiver.
   Returns whether the removal occurred."

  | bkt result |
  bkt := self depListBucketFor: depList.
  result := bkt remove: depList.
  result
    ifTrue: [
      aBoolean
        ifTrue: [ self _logRemovalOf: depList inCollisionBucket: bkt ].
      System _addEntireObjectToRcReadSet: bkt.
      System redoLog addLargeConflictObject: bkt for: self ].
  ^ result
%

category: 'Updating'
method: DepListTable
removeEntriesContaining: arrayOfPathTerms
  "Remove all dependency lists from the receiver that have any of the
 path terms contained in the arrayOfPathTerms."

  | bkt depLists depList |
  depLists := {}.
  1 to: self _basicSize do: [ :i |
    bkt := self _at: i.
    depLists size: 0.
    1 to: bkt size do: [ :j |
      " build Array of dependency lists to remove "
      depList := bkt _at: j.
      (depList containsAnyOf: arrayOfPathTerms)
        ifTrue: [ depLists add: depList ] ].
    1 to: depLists size do: [ :j |
      depList := depLists at: j.
      self remove: depList logging: true.
      depList size: 0	" resize dependency list to avoid object audit errors " ].
    bkt resizeIfNecessary.
    IndexManager current commitIndexMaintenance: nil at: 0	"fix 43647: call commitIndexMaintenance bug indexObj and progressCount not applicable" ].
  arrayOfPathTerms size: 0	" avoid object audit errors "
%

category: 'Updating'
method: DepListTable
removeEntriesContainingTracker: aTracker

"Find each dependency list in the receiver that contains a tracker,
 and remove it from the receiver.  Return an Array of dependency lists
 that were removed."

| bkt depLists depList tmpList |

depLists := { } .
tmpList := { } .
1 to: self _basicSize do: [ :i |
  bkt := self _at: i.

  tmpList size: 0.
  " build Array of dependency lists to remove "
  1 to: bkt size do: [ :j |
    depList := bkt _at: j.
    (depList includesIdentical: aTracker)
      ifTrue: [ tmpList add: depList ]
  ].

  tmpList isEmpty
    ifFalse: [
      1 to: tmpList size do: [ :j |
        (self remove: (tmpList at: j) logging: true)
          ifFalse: [ self _error: #rtErrKeyNotFound args: { depList } ].
      ]
    ].

  depLists addAll: tmpList.
].

^ depLists
%

category: 'Accessing'
method: DepListTable
size

"Returns the number of entries in the receiver."
| num collisionBkt |
num := 0.
1 to: self _basicSize do: [ :i |
    collisionBkt := self _at: i.
    num := num + collisionBkt size
].
^ num
%

category: 'Statistics'
method: DepListTable
statistics

"Returns a Dictionary containing statistics that can be useful in determining
 the performance of the dependency list table."

| bkt dict bktCnt maxBkt sizes cntDict sz total str phySize |
cntDict := KeyValueDictionary new.
dict := SymbolDictionary new.
maxBkt := self _at: 1.
bktCnt := 0.
sizes := 0.
phySize := self physicalSize.
1 to: self _basicSize do: [ :i |
  bkt := self _at: i.

  sz := bkt size.
  sz > 0
    ifTrue: [

      total := cntDict at: sz ifAbsent: [ cntDict at: sz put: 0 ].
      cntDict at: sz put: total + 1.

      bktCnt := bktCnt + 1.
      sizes := sizes + sz.
      " check for max bucket "
      sz > maxBkt size
        ifTrue: [ maxBkt := bkt ].
    ].
  phySize := phySize + bkt physicalSize.
].
dict at: #RootSize put: self _basicSize.
dict at: #TotalBuckets put: bktCnt.
dict at: #LargestBucketSize put: maxBkt size.
dict at: #PhysicalSize put: phySize.

bktCnt > 0
  ifTrue: [ dict at: #AvgEntriesPerBucket put: (sizes // bktCnt) ]
  ifFalse: [ dict at: #AvgEntriesPerBucket put: 0 ].

str := String new.
(cntDict keys sortAscending: #'') do: [ :i |
  str add: i asString; add: ' -> ';
    add: (cntDict at: i) asString; add: Character lf
].
dict at: #Histogram put: str.

^ dict
%

category: 'Updating'
method: DepListTable
_add: depList
  "Replay the addition of the given dependency list to the receiver.
 If there is already an equivalent dependency list in the receiver,
 replace all references to the given dependency list with a reference
 to the dependency list in the table."

  | dl bkt |
  bkt := self depListBucketFor: depList.
  dl := bkt at: depList.
  dl == depList
    ifFalse: [
      " must replace references "
      depList _replaceReferencesWith: dl ].
  System _addEntireObjectToRcReadSet: bkt.
  System redoLog addLargeConflictObject: bkt for: self.
  ^ true
%

category: 'Auditing'
method: DepListTable
_auditAndRepair: aBool
  "Search for any dependency lists or collision buckets that have
entries out of order, and repair them.  Perform any repairs needed
and return a string describing the repairs."

  | aString |
  aString := String new.
  self _resortEntriesLogging: aString.
  self _repairOutOfOrderBucketsLogging: aString.
  aBool
    ifTrue: [ self _auditDepMapEntries: aString ].
  aString size == 0
    ifTrue: [ ^ 'SharedDependencyLists ok' ]
    ifFalse: [
      ^ 'Audit and repair of SharedDependencyLists:
' , aString ]
%

category: 'Auditing'
method: DepListTable
_auditDepMapEntries: str
  "verify that all of the dependencyLists tracked in DependencyMap exist in the
   receiver and all of the dependencyLists in the receiver are tracked in
   DependencyMap. Also look for duplicate dependencyLists"

  "repair:
     depLists in SharedDepencencyList but not in DepMap
     depList in DepMap not in SharedDependencyLists
   "

  | sharedBag sharedIdentityBag sharedIdentitySet depMapIdentitySet depMapDepListsNotInShared |
  sharedBag := Bag new.
  sharedIdentityBag := IdentityBag new.
  depMapDepListsNotInShared := 0.
  1 to: self _basicSize do: [ :i |
    | bkt |
    bkt := self _at: i.
    1 to: bkt size do: [ :j |
      | dl |
      dl := bkt _at: j.
      sharedBag add: dl.
      sharedIdentityBag add: dl ] ].
  sharedIdentityBag
    do: [ :dl |
      | o |
      (o := sharedIdentityBag occurrencesOf: dl) > 1
        ifTrue: [
          "identical entries - should never happen"
          str
            add: 'DependencyList ';
            add: dl printString;
            add: ' [' , dl asOop asString , ']';
            add: ' has ';
            add: o asString;
            add: ' identical entries';
            add: Character lf ].
      (o := sharedBag occurrencesOf: dl) > 1
        ifTrue: [
          "not really sharing are we?"
          str
            add: 'DependencyList ';
            add: dl printString;
            add: ' [' , dl asOop asString , ']';
            add: ' has ';
            add: o asString;
            add: ' duplicate equivalent entries';
            add: Character lf ] ].
  depMapIdentitySet := IdentitySet new.
  sharedIdentitySet := sharedIdentityBag asIdentitySet.
  DependencyList depMapValuesToHiddenSet: 2.
  System
    hiddenSet: 2
    do: [ :depList |
      depMapIdentitySet add: depList.
      (sharedIdentitySet includes: depList)
        ifFalse: [
          "depList in DepMap not in SharedDependencyLists"
          depMapDepListsNotInShared := depMapDepListsNotInShared + 1.
          SharedDependencyLists at: depList logging: false ] ].
  sharedIdentitySet removeAllPresent: depMapIdentitySet.
  sharedIdentitySet
    do: [ :depList |
      "depLists in SharedDepencencyList but not in DepMap
       we can repair by removing depList from the SharedDependencyList"
      self remove: depList logging: false.
      depList size: 0	" resize dependency list to avoid object audit errors " ].
  depMapDepListsNotInShared > 0
    ifTrue: [
      str
        add: depMapDepListsNotInShared printString;
        add:
            ' dependency lists were in DepMap and not in SharedDepencyLists (repaired)';
        add: Character lf ]
%

category: 'Updating'
method: DepListTable
_buildWeakRefSet

"Put each dependency list in the weak references set."

| weakRef |
weakRef := (GsBitmap newForHiddenSet: #WeakReferences).
1 to: self _basicSize do: [ :i | | bkt |
  bkt := self _at: i.
  1 to: bkt size do: [ :j |
    weakRef add: (bkt _at: j)
  ]
].
%

category: 'Private'
method: DepListTable
_logAdditionOf: depList inCollisionBucket: collisionBkt

"Logs the addition of the given dependency list in the system redo log."

| logEntry |

logEntry := LogEntry new.
logEntry receiver: self;
    selector: #_add:;
    argArray: { depList }.
System redoLog addLogEntry: logEntry
%

category: 'Private'
method: DepListTable
_logRemovalOf: depList inCollisionBucket: collisionBkt
  "Logs the removal of the given dependency list in the system redo log."

  | logEntry |
  logEntry := LogEntry new.
  logEntry
    receiver: self;
    selector: #'_remove:';
    argArray: {depList}.
  System redoLog addLogEntry: logEntry
%

category: 'Updating'
method: DepListTable
_remove: depList
  "Replay the removal of the given dependency list from the receiver.
   If the dependencyList is obsolete (size 0) then there is no need to
   attempt the removal"

  depList size == 0
    ifTrue: [ ^ true ].
  ^ self remove: depList logging: false
%

category: 'Updating'
method: DepListTable
_removeAllTrackingOf: aTracker

"Remove the receiver from all dependency lists.  The receiver will
 no longer be notified when objects are modified, and may become
 eligible for garbage collection."

| entries depList |
entries := self removeEntriesContainingTracker: aTracker.
1 to: entries size do: [ :i |
  depList := entries at: i.
  depList _removeCompletelyPathTerm: aTracker.
  self at: depList logging: false.
].
%

category: 'Auditing'
method: DepListTable
_repairOutOfOrderBucketsLogging: aString

"Repair any collision buckets that have dependency lists out of order."

| bkt depList ooBkts cnt copy |
ooBkts := { } .
" first pass, find buckets that need rebuilding "
1 to: self _basicSize do: [ :i |
  (bkt := self _at: i) _hasEntryOutOfOrder
    ifTrue: [ ooBkts add: bkt ]
].
ooBkts size ~~ 0
  ifTrue: [
    aString add: 'Found '; add: ooBkts size asString;
      add: ' bucket(s) that contained entries out of order.'; add: Character lf.

    " second pass, make copies and reset buckets "
    1 to: ooBkts size do: [ :i |
      copy := (bkt := ooBkts at: i) copy.
      bkt reset.
      ooBkts at: i put: copy.
    ].
    " third pass, re-insert entries "
    cnt := 0.
    1 to: ooBkts size do: [ :i |
      bkt := ooBkts at: i.
      1 to: bkt size do: [ :j |
        depList := bkt _at: j.
        (self at: depList logging: false) == depList
          ifFalse: [ cnt := cnt + 1 ]
      ]
    ].
    cnt ~~ 0
      ifTrue: [
        aString add: 'Re-insertion found '; add: cnt asString;
          add: ' equivalent dependency list(s)'; add: Character lf.
      ]
  ].
^ aString
%

category: 'Private'
method: DepListTable
_resolveRcConflictsWith: conflictObjects

"A logical write-write conflict has occurred on the receiver.  The objects that
 had the actual physical write-write conflicts are in the conflictObjects
 Array.  Selectively abort the receiver and then attempt to replay the
 operations maintained in the System redo log.  Returns true if all the
 operations could be replayed; otherwise returns false."

| result |
result := self _abortAndReplay: conflictObjects.
^ result
%

category: 'Auditing'
method: DepListTable
_resortEntriesLogging: aString
  "Resort all entries in the receiver that need it.  Append a record of
what was done on the given string."

  | cnt depList bkt needsSorting empties zeros |
  cnt := 0.
  zeros := IdentitySet new.
  needsSorting := {}.
  empties := {}.
  1 to: self _basicSize do: [ :i |
    bkt := self _at: i.
    needsSorting size: 0.
    empties size: 0.	" find entries that need sorting "
    1 to: bkt size do: [ :j |
      (depList := bkt _at: j) size == 0
        ifTrue: [ empties add: depList ]
        ifFalse: [
          depList _needsSorting
            ifTrue: [ needsSorting add: depList ] ] ].
    zeros addAll: empties.
    1 to: empties size do: [ :j |
      " remove empty dependency lists "
      bkt remove: (empties _at: j) ].
    cnt := cnt + needsSorting size.
    1 to: needsSorting size do: [ :j |
      " remove, resort, then reinsert them "
      (needsSorting _at: j) _sortEntries: bkt ] ].
  zeros size > 0
    ifTrue: [
      aString
        add: zeros size asString;
        add: ' dependency list(s) were empty: ';
        add: Character lf;
        add: Character tab;
        add: 'dependency list oops: '.
      zeros do: [ :dl | aString add: dl asOop printString , ' ' ].
      aString lf ].
  cnt > 0
    ifTrue: [
      aString
        add: cnt asString;
        add: ' dependency list(s) needed their entries sorted.';
        add: Character lf ].
  ^ aString
%

category: 'Private'
method: DepListTable
_selectiveAbort

"Abort the collision buckets."

super _selectiveAbort.
1 to: self _basicSize do: [ :i | (self _at: i) _selectiveAbort ]
%

! Class extensions for 'DoubleByteString'

!		Instance methods for 'DoubleByteString'

category: 'Comparing'
method: DoubleByteString
compareTo: argString collator: anIcuCollator useMinSize: aMinSize

"Returns -1, 0 or 1,  when receiver is less than,
 equal to, or greater than argString .
 argString must be a String, MultiByteString, or a Utf8.
 anIcuCollator == nil is interpreted as   IcuCollator default .

 If aMinSize == false, normal comparision is done.

 If aMinSize==true, compare stops at (self size min: argString size),
 which is Squeak semantics for comparison.

 If aMinSize is a SmallInteger >= 1, compare stops at
   aMinSize min: (self size min: argString size) ."
<primitive: 978>   "prim handles String, DoubleByteString args"
anIcuCollator ifNil:[
  (System __sessionStateAt: 20) ifNil:[
    ^ self compareTo: argString collator: IcuCollator default useMinSize: aMinSize ]
] ifNotNil:[ anIcuCollator _validateClass: IcuCollator ].
aMinSize _validateClasses: { Boolean . SmallInteger }.
argString _validateClasses: { String . Utf8 }.
^ self _primitiveFailed: #compareTo:collator:useMinSize:
        args: { argString . anIcuCollator . aMinSize }
%

category: 'Comparing'
method: DoubleByteString
_equals: argString collator: anIcuCollator useMinSize: aFalse

"Returns true if argString compares equals to the receiver using anIcuCollator
 and if argString is not a Symbol, otherwise returns false "
<primitive: 992>
anIcuCollator ifNil:[ (System __sessionStateAt: 20) ifNil:[
  ^ self _equals: argString collator: IcuCollator default useMinSize: aFalse ]
] ifNotNil:[  anIcuCollator _validateClass: IcuCollator ].
(argString isKindOf: CharacterCollection) ifTrue:[ ^ argString = self ].
^ false
%

! Class extensions for 'DoubleByteSymbol'

!		Instance methods for 'DoubleByteSymbol'

category: 'PetitParser-Core-Converting'
method: DoubleByteSymbol
asParser
	"Answer a predicate parser named after the receiving symbol. Possible symbols are the method selectors on the class-side of PPPredicateObjectParser."

	^ PPPredicateObjectParser perform: self
%

category: 'New Indexing Comparison'
method: DoubleByteSymbol
_idxUnicodeCompareEqualTo: aCharCollection
  "No Unicode Symbols, so answer false"

  ^false
%

! Class extensions for 'EnumeratedPathEvaluator'

!		Instance methods for 'EnumeratedPathEvaluator'

category: 'Accessing'
method: EnumeratedPathEvaluator
enumeratedObjectsFor: theObj pathTerm: enumeratedPathName at: nscOffset
  | nextObj ivOffset enumeratedObjects |
  nextObj := theObj.
  nil == nextObj
    ifTrue: [ ^ #() ].
  enumeratedObjects := {}.
  (enumeratedPathName subStringsDelimitedBy: $|)
    do: [ :pathName |
      ivOffset := nextObj class _ivOffsetOf: pathName asSymbol.
      ivOffset == nil
        ifTrue: [ enumeratedObjects add: nil ]
        ifFalse: [ enumeratedObjects add: (nextObj instVarAt: ivOffset) ] ].
  ^ enumeratedObjects
%

category: 'Testing'
method: EnumeratedPathEvaluator
hasEnumeratedTerm
  "Returns true if the path has a term that indicates an enumerated path term."

  ^ true
%

category: 'Testing'
method: EnumeratedPathEvaluator
isIndexOnNscElements
  "Returns whether the receiver is a path directly on the elements of an NSC
 (either the root NSC or an enumerated instance variable along the path)."

  ^ (self at: self size) includes: $|
%

category: 'Traversing'
method: EnumeratedPathEvaluator
traverse: anObject startingAt: offset do: aBlock
  "Traverse the sub-objects of anObject, using the path names of the receiver
 starting at the path name at the given offset.  For each object at the end of
 the traversal, evaluate the given block."

  | nextObj ivOffset pathName nscOffset sz |
  (nil == anObject _and: [ self isIndexOnNscElements not ])
    ifTrue: [ ^ self ].
  nextObj := anObject.
  sz := self size.
  offset to: sz do: [ :i |
    pathName := self at: i.
    (pathName includes: $|)
      ifTrue: [
        nscOffset := i + 1.
        (self enumeratedObjectsFor: nextObj pathTerm: pathName at: nscOffset)
          do: [ :obj | self traverse: obj startingAt: nscOffset do: aBlock ].
        ^ self ]
      ifFalse: [
        nil == nextObj
          ifTrue: [ ^ self ].
        ivOffset := nextObj class _ivOffsetOf: pathName.
        ivOffset == nil
          ifTrue: [ nextObj := nil ]
          ifFalse: [ nextObj := nextObj instVarAt: ivOffset ] ].
    (nil == nextObj _and: [ i ~= sz ])
      ifTrue: [ ^ self ] ].
  ^ aBlock value: nextObj
%

category: 'Traversing'
method: EnumeratedPathEvaluator
traverse: anObject startingAt: offset into: resultSet
  "Traverse the sub-objects of all the objects in the NSC, using the path names
 of the receiver starting at the path term at the given offset.  Add each
 object at the end of the traversal to the result set.  Returns the result
 set."

  | nextObj ivOffset pathName nscOffset sz |
  (nil == anObject _and: [ self isIndexOnNscElements not ])
    ifTrue: [ ^ resultSet ].
  nextObj := anObject.
  sz := self size.
  offset to: sz do: [ :i |
    pathName := self at: i.
    (pathName includes: $|)
      ifTrue: [
        nscOffset := i + 1.
        (self enumeratedObjectsFor: nextObj pathTerm: pathName at: nscOffset)
          do: [ :obj | self traverse: obj startingAt: nscOffset into: resultSet ].
        ^ resultSet ]
      ifFalse: [
        nil == nextObj
          ifTrue: [ ^ resultSet ].
        ivOffset := nextObj class _ivOffsetOf: pathName.
        ivOffset == nil
          ifTrue: [
            nextObj _errorInvalidOffset: pathName.
            nextObj := nil ]
          ifFalse: [ nextObj := nextObj instVarAt: ivOffset ] ].
    (nil == nextObj _and: [ i ~= sz ])
      ifTrue: [ ^ resultSet ] ].
  resultSet add: nextObj.
  ^ resultSet
%

! Class extensions for 'EnumeratedPathTerm'

!		Instance methods for 'EnumeratedPathTerm'

category: 'Updating Indexes'
method: EnumeratedPathTerm
addMappingsForObject: anObject logging: aBoolean
  "Add index dictionary and dependency list entries for anObject."

  | ivOffset indexDict sz |
  (nil == anObject or: [ self size == 0 ])
    ifTrue: [ ^ self ].
  self pathTermElements
    do: [ :pathTermElement |
      (self _ivOffsetFor: anObject pathName: pathTermElement)
        ifNil: [ self _invalidIvOffset: anObject ]
        ifNotNil: [ :off | ivOffset := off ] ].
  anObject
    getDepListAndAddPathTerm: self
    withIVOffset: ivOffset
    logging: aBoolean.	" add an entry to the objects dependency list ... note that we ar only using the last ivOffset and that is okay as we compensate in the places that the ivOffset is used..."
  sz := children size.
  indexDict := self getIndexDictionary.
  self
    nextObj: anObject
    do: [ :nextObj |
      " insert an entry into the index dictionary "
      indexDict
        _at: nextObj
        put: anObject
        term: self
        logging: aBoolean.
      updateBtree ~~ nil
        ifTrue: [
          " insert an entry into the B-tree "
          updateBtree btreeAt: nextObj put: anObject.
          needsDepList
            ifTrue: [
              " add an entry to the very last object's dependency list "
              nextObj getDepListAndAddLastElementPathTerm: self logging: aBoolean ] ].
      nil ~~ nextObj
        ifTrue: [
          1 to: sz do: [ :i |
            " make recursive call to add mappings "
            (children at: i) addMappingsForObject: nextObj logging: aBoolean ] ] ]
%

category: 'Updating Indexes'
method: EnumeratedPathTerm
addMappingsUsing: mapInfo logging: aBoolean
  "Adds index dictionary and dependency list entries for the object described by
 the map info object.  If aBoolean is true, operations will be recorded in the
 system redo log."

  | pathTerm object ivOffset indexDict dictUpdated |
  pathTerm := mapInfo pathTerm.
  pathTerm size == 0
    ifTrue: [ ^ self ].
  object := mapInfo object.
  nil == object
    ifTrue: [ ^ self ].
  self pathTermElements
    do: [ :pathTermElement |
      (self _ivOffsetFor: object pathName: pathTermElement)
        ifNil: [ self _invalidIvOffset: object ]
        ifNotNil: [ :off | ivOffset := off ] ].
  object
    getDepListAndAddPathTerm: pathTerm
    withIVOffset: ivOffset
    logging: aBoolean.	" add an entry to the objects dependency list "
  dictUpdated := false.
  indexDict := self getIndexDictionary.
  1 to: mapInfo size do: [ :k |
    | nextMaps |
    " for each child mapping "
    nextMaps := mapInfo at: k.
    1 to: nextMaps size do: [ :i |
      | nextMap nextObj nextPathTerm |
      " there is a collection of mappings for each element in the set "
      nextMap := nextMaps at: i.
      nextObj := nextMap object.
      updateBtree ~~ nil
        ifTrue: [
          " insert an entry into the B-tree "
          updateBtree btreeAt: nextObj put: object.
          (needsDepList and: [ nil ~~ nextObj ])
            ifTrue: [
              " add an entry to the very last object's dependency list "
              nextObj
                getDepListAndAddLastElementPathTerm: pathTerm
                logging: aBoolean ] ].
      (updateDict notNil and: [ dictUpdated not ])
        ifTrue: [
          " insert an entry into the index dictionary "
          indexDict
            _at: nextObj
            put: object
            term: self
            logging: aBoolean ].
      (nextPathTerm := nextMap pathTerm) ~~ nil
        ifTrue: [ nextPathTerm addMappingsUsing: nextMap logging: aBoolean ] ].
    dictUpdated := true ]
%

category: 'Deprecated'
method: EnumeratedPathTerm
allDependencyListsFor: anObject into: all
  "Put any dependency lists that can be found from the receiver
into the given set."

  | nextObj depList |
  self deprecated: 'EnumeratedPathTerm>>allDependencyListsFor:into: deprecated v3.3.
     Use DependencyList class>>depMapValues to collect dependency lists.'.  "bug 43886"

  (nil == anObject or: [ self size == 0 ])
    ifTrue: [ ^ self ].
  (depList := DependencyList for: anObject) == nil
    ifTrue: [ ^ self ].
  all add: depList.
  self indicatesIndexOnRootNsc
    ifTrue: [ ^ self ].
  self pathTermElements
    do: [ :pathName |
      nextObj := self _nextObjectFor: anObject pathName: pathName.
      nextObj
        ifNotNil: [
          needsDepList
            ifTrue: [
              (depList := DependencyList for: nextObj) ~~ nil
                ifTrue: [ all add: depList ] ].
          1 to: children size do: [ :i | (children at: i) allDependencyListsFor: nextObj into: all ] ] ]
%

category: 'Audit'
method: EnumeratedPathTerm
auditDepListFor: obj index: indexObj on: aString optionalSentinel: optionalSentinel
  "Private."

  | depList j ivOffset |
  (nil == obj or: [ self size == 0 ])
    ifTrue: [ ^ nil ].
  depList := DependencyList for: obj.
  depList == nil
    ifTrue: [
      obj isInvariant
        ifFalse: [
          self
            auditInfo:
              {obj.
              indexObj.
              depList}
            on: aString.
          aString
            add: ' Object has no dependency list';
            add: Character lf . self checkDebug: aString ] ]
    ifFalse: [
      (DepListTable _hasDependencyBitFor: obj)
        ifFalse: [
          self
            auditInfo:
              {obj.
              indexObj.
              depList}
            on: aString.
          aString
            add: ' Object has DependencyList but no dependency bit is set';
            add: Character lf. self checkDebug: aString  ].
      j := depList _findOffsetForPathTerm: self.
      j == nil
        ifTrue: [
          self
            auditInfo:
              {obj.
              indexObj.
              depList}
            on: aString.
          aString
            add: 'DependencyList has no entry for path term';
            add: Character lf . self checkDebug: aString ]
        ifFalse: [
          "found entry for self in depList"
          ivOffset := depList at: j + 1.	"may be negative for last element reference count"
          ivOffset < 0
            ifTrue: [
              "reference count for last element, but we don't expect reference
               count here ... see needsDepList clause below where depList
               existence is sufficient"
              self
                auditInfo:
                  {obj.
                  indexObj.
                  depList}
                on: aString.
              aString
                add: 'DependencyList on last element in unexepected location ';
                add: ivOffset asString;
                add: Character lf. self checkDebug: aString .
              ^ self ] ] ].
  needsDepList
    ifTrue: [
      self
        nextObj: obj
        do: [ :nextObj |
          (DependencyList needsDepList: nextObj)
            ifTrue: [
              depList := DependencyList for: nextObj.
              depList == nil
                ifTrue: [
                  self
                    auditInfo:
                      {nextObj.
                      indexObj.
                      depList}
                    on: aString.
                  aString
                    add: ' Object has no dependency list';
                    add: Character lf . self checkDebug: aString ] ] ] ].
  ^ self
%

category: 'Audit'
method: EnumeratedPathTerm
auditIndexDictionaryForObject: obj occurrences: num on: aString
  "Private.  Unsupported method for GemStone Technical Support."

  "Verifies that the given object has the correct index dictionary entries for the receiver."

  | sz indexObj newNum dictChecked nextObjBag |
  sz := self size.
  (nil == obj _or: [ sz == 0 ])
    ifTrue: [ ^ aString ].
  nextObjBag := IdentityBag new.
  self nextObj: obj do: [ :nextObj | nextObjBag add: nextObj ].
  nextObjBag
    do: [ :nextObj |
      dictChecked := false.
      1 to: sz do: [ :i |
        " for each index that utilizes the path term "
        indexObj := self at: i.
        (indexObj isRangeEqualityIndex and: [ indexObj size == offset ])
          ifFalse: [
            " verify index dictionary has correct entries "
            dictChecked
              ifFalse: [
                | occurs |
                occurs := nextObjBag occurrencesOf: nextObj.
                newNum := self
                  auditDictionaryEntryFor: obj
                  and: nextObj
                  occurrences: num * occurs
                  on: aString.
                dictChecked := true ] ] ].
      nextObj ~~ nil
        ifTrue: [
          1 to: children size do: [ :i |
            (children at: i)
              auditIndexDictionaryForObject: nextObj
              occurrences: newNum
              on: aString ] ] ]
%

category: 'Audit'
method: EnumeratedPathTerm
auditNscCountsFor: obj on: aString count: btreeCounts
  "Private. "

  | sz |
  sz := self size.
  (nil == obj _or: [ sz == 0 ])
    ifTrue: [ ^ aString ].
  nil == obj
    ifTrue: [ ^ self ].
  self
    auditDepListFor: obj
    index: nil
    on: aString
    optionalSentinel: Object new.
  self
    nextObj: obj
    do: [ :nextObj |
      | index |
      index := 1.
      children isEmpty
        ifTrue: [ self auditDirectNscCountsFor: nextObj on: aString count: btreeCounts ]
        ifFalse: [
          1 to: sz do: [ :i |
            | count indexObj |
            indexObj := self at: i.
            (indexObj isRangeEqualityIndex and: [ indexObj size == offset ])
              ifTrue: [
                count := btreeCounts at: index.
                count == 0
                  ifTrue: [
                    aString
                      add: Character lf;
                      add: ' -- The number of entries in Btree [';
                      add: (self at: i) btreeRoot asOop asString;
                      add: '] for pathTerm [';
                      add: self asOop asString;
                      add: ' offset ';
                      add: offset asString;
                      add:
                          '] does not match the number of entries in the base collection (extra elements in either the base collection or btree).';
                      add: Character lf ].
                btreeCounts at: index put: count - 1.
                index := index + 1 ] ].
          nextObj ~~ nil
            ifTrue: [
              1 to: children size do: [ :i |
                (children at: i)
                  auditNscCountsFor: nextObj
                  on: aString
                  count: (btreeCounts at: index).
                index := index + 1 ] ] ] ]
%

category: 'Audit'
method: EnumeratedPathTerm
checkDebug: aString
  BtreePlusNodeAuditor checkDebug: aString 
%

category: 'Updating Indexes'
method: EnumeratedPathTerm
cleanupDependencyListFor: anObject
  ""

  | deplistOffset nextObj depList |
  (nil == anObject or: [ self size == 0 ])
    ifTrue: [ ^ self ].
  (depList := DependencyList for: anObject) == nil
    ifTrue: [ ^ self ].
  deplistOffset := depList removeCompletelyPathTerm: self for: anObject.	" remove the receiver from the dependency list "
  (self indicatesIndexOnRootNsc
    or: [
      "last element dependency list"
      deplistOffset < 0 ])
    ifTrue: [ ^ self ].
  self pathTermElements
    do: [ :pathName |
      (self _ivOffsetFor: anObject pathName: pathName)
        ifNotNil: [ :ivOffset |
          nextObj := self _nextObjectFor: anObject atInstVar: ivOffset.
          nextObj
            ifNotNil: [
              needsDepList
                ifTrue: [
                  (depList := DependencyList for: nextObj) ~~ nil
                    ifTrue: [ depList removeCompletelyPathTerm: self for: nextObj ] ].
              1 to: children size do: [ :i | (children at: i) cleanupDependencyListFor: nextObj ] ] ] ]
%

category: 'Testing'
method: EnumeratedPathTerm
coversIvOffset: anIvOffset for: anObject
  "Answer true if the receiver covers the given iv offset (see bug 46705)"

  self pathTermElements
    do: [ :pathTermElement |
      (self _ivOffsetFor: anObject pathName: pathTermElement)
        ifNil: [ ^false ]
        ifNotNil: [ :off | anIvOffset = off ifTrue: [ ^true ] ] ].
  ^ false
%

category: 'Updating Indexes'
method: EnumeratedPathTerm
getMappingInfoFor: anObject ifObject: origObject atOffset: origOffset replaceWith: otherObject
  "Gathers all the objects, their dependency lists, and the instance variable
 offset for each path term in the tree of path terms.  Puts them in a
 MappingInfo object.  Builds a tree of MappingInfo objects for each child path
 term."

  | ivOffset nextObj maps mapInfo |
  mapInfo := self _mappingInfoClass new pathTerm: self.
  (nil == anObject or: [ self size == 0 ])
    ifTrue: [ ^ mapInfo ].
  mapInfo object: anObject.
  (updateBtree ~~ nil or: [ children isEmpty ])
    ifTrue: [
      maps := Array new.
      self pathTermElements
        do: [ :pathName |
          ivOffset := self _ivOffsetFor: anObject pathName: pathName.
          ivOffset
            ifNotNil: [
              nextObj := self _nextObjectFor: anObject atInstVar: ivOffset.
              updateBtree ~~ nil
                ifTrue: [
                  (self _checkBtreeComparisonWith: nextObj)
                  ifFalse: [
                    | exa |
                    (exa := ImproperOperation new)
                      _number:
                          (ErrorSymbols at: #'rtErrRangeEqualityIndexInvalidClassKindForBtree');
                      args: { nextObj class. self name. updateBtree lastElementClassDescription }.
                    ^ {false.	" indicating no indexing objects were modified "
                    exa} ] ].
              maps add: (self _mappingInfoClass new object: nextObj) ] ].
      mapInfo addLast: maps.
      ^ mapInfo ].
  1 to: children size do: [ :i |
    " for each following path term "
    maps := Array new.
    self pathTermElements
      do: [ :pathName |
        | aMapInfo |
        ivOffset := self _ivOffsetFor: anObject pathName: pathName.
        ivOffset
          ifNotNil: [
            " get the next object along the path "
            nextObj := self _nextObjectFor: anObject atInstVar: ivOffset.
            aMapInfo := (children at: i)
              getMappingInfoFor: nextObj
              ifObject: origObject
              atOffset: origOffset
              replaceWith: otherObject.
            aMapInfo class == self _mappingInfoClass
              ifFalse: [ ^ aMapInfo	"an Array of error info" ].
            maps add: aMapInfo ] ].
    mapInfo addLast: maps ].
  ^ mapInfo
%

category: 'Testing'
method: EnumeratedPathTerm
hasMatchingTerm: aSymbol
  "Answer true if the receiver's term matches <aSymbol>"

  ^ self name == (self _canonicalizeTerm: aSymbol)
%

category: 'Testing'
method: EnumeratedPathTerm
indicatesIndexOnNscElements
  "Returns false. The ides is not on elements of an nsc."

  ^ false
%

category: 'Testing'
method: EnumeratedPathTerm
isEnumeratedTerm
  "Returns true if the receiver indicates an enumerated path term."

  ^ true
%

category: 'Updating'
method: EnumeratedPathTerm
name: aSymbol
  name := self _canonicalizeTerm: aSymbol
%

category: 'Accessing'
method: EnumeratedPathTerm
nextObj: anObj do: aBlock
  | found |
  (nil == anObj or: [ self size == 0 ])
    ifTrue: [ ^ self ].
  found := false.
  self pathTermElements
    do: [ :pathName |
      | ivOffset |
      (ivOffset := self _ivOffsetFor: anObj pathName: pathName) ~~ nil
        ifTrue: [
          | nextObj |
          found := true.
          nextObj := self _nextObjectFor: anObj atInstVar: ivOffset.
           aBlock value: nextObj ] ].
  found
    ifFalse: [ ^ self _invalidIvOffset: anObj ]
%

category: 'Accessing'
method: EnumeratedPathTerm
pathTermElements
  "return the individual pathTerm elements"

  ^ self name subStringsDelimitedBy: $|
%

category: 'Updating Indexes'
method: EnumeratedPathTerm
removeMappingsFor: anObject lastOne: aBoolean logging: doLogging
  "Remove entries in the index dictionary and dependency lists for anObject."

  | nextObj depList more isLast |
  self size == 0
    ifTrue: [ ^ self ].
  self pathTermElements
    do: [ :pathName |
      nextObj := self _nextObjectFor: anObject pathName: pathName.
      updateBtree ~~ nil
        ifTrue: [
          " remove an entry from the B-tree "
          updateBtree btreeRemoveKey: nextObj value: anObject.
          DependencyList removePathTerm: self for: nextObj logging: doLogging	" remove dependency list entry for next object " ].
      more := false.
      updateDict ~~ nil
        ifTrue: [
          " remove the index dictionary entry "
          more := updateDict
            removeKey: nextObj
            value: anObject
            term: self
            logging: doLogging ].
      (nil ~~ nextObj and: [ children isEmpty not ])
        ifTrue: [
          " make recursive call to remove mappings "
          isLast := aBoolean and: [ more not ].
          1 to: children size do: [ :i | (children at: i) removeMappingsFor: nextObj lastOne: isLast logging: doLogging ].
          isLast
            ifTrue: [
              " remove dependency list entries for next object "
              (depList := DependencyList for: nextObj) ~~ nil
                ifTrue: [ depList removePathTerms: children for: nextObj logging: doLogging ] ] ] ]
%

category: 'Updating Indexes'
method: EnumeratedPathTerm
removeMappingsSkipBtreeFor: anObject lastOne: aBoolean logging: doLogging
  "Remove entries in the index dictionary and dependency lists for anObject.
 This version for index removal, it does not update the btree since the btree
 is going away (#40858)."

  | nextObj depList more isLast |
  self size == 0
    ifTrue: [ ^ self ].
  self pathTermElements
    do: [ :pathName |
      nextObj := self _nextObjectFor: anObject pathName: pathName.
      updateBtree ~~ nil
        ifTrue: [
          " skip update of btree, index is going away"
          " remove dependency list entry for next object "
          DependencyList removePathTerm: self for: nextObj logging: doLogging ].
      more := false.
      updateDict ~~ nil
        ifTrue: [
          " remove the index dictionary entry "
          more := updateDict
            removeKey: nextObj
            value: anObject
            term: self
            logging: doLogging ].
      (nil ~~ nextObj and: [ children isEmpty not ])
        ifTrue: [
          " make recursive call to remove mappings "
          isLast := aBoolean and: [ more not ].
          1 to: children size do: [ :i | (children at: i) removeMappingsFor: nextObj lastOne: isLast logging: doLogging ].
          isLast
            ifTrue: [
              " remove dependency list entries for next object "
              (depList := DependencyList for: nextObj) ~~ nil
                ifTrue: [ depList removePathTerms: children for: nextObj logging: doLogging ] ] ] ]
%

category: 'Updating'
method: EnumeratedPathTerm
_canonicalizeTerm: aSymbol
  "Canonicalize the pathTerm name, so that terms are in alphabetical order"

  | terms sz canon |
  terms := (aSymbol subStringsDelimitedBy: $|) sortAscending.
  canon := String new.
  sz := terms size.
  1 to: sz do: [ :index |
    | term |
    term := terms at: index.
    canon add: term.
    index < sz
      ifTrue: [ canon add: $| ] ].
  ^ canon asSymbol
%

category: 'Accessing'
method: EnumeratedPathTerm
_ivOffsetFor: anObject pathName: pathName
  "Returns the instance variable offset of anObject for the pathName which is one of the enumarated instance variables."

  ^ (self _classOf: anObject) _ivOffsetOf: pathName asSymbol
%

category: 'Accessing'
method: EnumeratedPathTerm
_ivOffsetsFor: anObject
  ^ self pathTermElements
    collect: [ :pathTermElement | self _ivOffsetFor: anObject pathName: pathTermElement ]
%

category: 'Accessing'
method: EnumeratedPathTerm
_nextObjectFor: anObject pathName: aPathName
  "Returns the object at the instance variable that corresponds to the receiver
 path term."

  | ivOffset |
  ivOffset := self _ivOffsetFor: anObject pathName: aPathName.
  ivOffset ifNil: [ ^ nil ].
  ^ self _nextObjectFor: anObject atInstVar: ivOffset
%

! Class extensions for 'EqualityIndexQueryEvaluator'

!		Instance methods for 'EqualityIndexQueryEvaluator'

category: 'Accessing'
method: EqualityIndexQueryEvaluator
btreeReadStreamClass
  "Returns the class of btree read stream to create for query results."

  ^ index btreeReadStreamClass
%

category: 'Accessing'
method: EqualityIndexQueryEvaluator
btreeRoot

  ^self index btreeRoot
%

category: 'Accessing'
method: EqualityIndexQueryEvaluator
comparisonForCompare
  ^ self index comparisonForCompare
%

category: 'Accessing'
method: EqualityIndexQueryEvaluator
comparisonForSort
  ^ BtreeComparisonForCompare newForSort: self collator
%

category: 'Query Select'
method: EqualityIndexQueryEvaluator
findAllValuesEqualTo: aValue
  "Returns a set of all values that satisfy the query."

  | stream |
  stream := self _findAllValuesEqualTo: aValue using: self comparisonForCompare.
  ^ self doBlock
    ifNotNil: [ [ stream atEnd ] whileFalse: [ self doBlock value: stream next ] ]
    ifNil: [ stream makeNscComparing: #'=' key: aValue ]
%

category: 'Query Select'
method: EqualityIndexQueryEvaluator
findAllValuesGreaterThan: val1 andEquals: bool1 andLessThan: val2 andEquals: bool2
  "Returns a set of all values that satisfy the query."

  | selector1 selector2 stream |
  selector1 := bool1
    ifTrue: [ #'>=' ]
    ifFalse: [ #'>' ].
  selector2 := bool2
    ifTrue: [ #'<=' ]
    ifFalse: [ #'<' ].
  stream := self
    _findAllValuesGreaterThan: val1
    andEquals: bool1
    andLessThan: val2
    andEquals: bool2
    using: self comparisonForCompare.
  ^ self doBlock
    ifNotNil: [ stream streamQuerySpec: (stream btreeRangeComparisonQuerySpec
            key: val1 selector: selector1;
            key2: val2 selector2: selector2;
            yourself).
      [ stream atEnd ] whileFalse: [ self doBlock value: stream next ] ]
    ifNil: [ stream
        makeNscComparing: selector1
        key: val1
        and: selector2
        key: val2 ]
%

category: 'Query Select'
method: EqualityIndexQueryEvaluator
findAllValuesGreaterThanKey: aValue andEquals: aBoolean
  "Returns a set of all values that satisfy the query."

  | selector stream |
  selector := aBoolean
    ifTrue: [ #'>=' ]
    ifFalse: [ #'>' ].
  stream := self
    _findAllValuesGreaterThanKey: aValue
    andEquals: aBoolean
    using: self comparisonForCompare.
  ^ self doBlock
    ifNotNil: [ [ stream atEnd ] whileFalse: [ self doBlock value: stream next ] ]
    ifNil: [ stream makeNscComparing: selector key: aValue ]
%

category: 'Query Select'
method: EqualityIndexQueryEvaluator
findAllValuesIdenticalTo: aValue
  "Returns a set of all values that satisfy the query.  Since this is an identity
 comparison on a range index (which supports equality comparison), this
 method creates a B-tree read stream for equal values, then iterates through the
 values making the identity comparison."

  | tmpHolder stream |
  " optimize query for objects in the NSC itself "
  self index isIndexOnRootNsc
    ifTrue: [
      doBlock
        ifNil: [
          " optimize query for objects in the NSC itself "
          ^ self _allIdenticalTo: aValue in: self nscRoot ].
      ^ self _allIdenticalTo: aValue in: self nscRoot do: doBlock  ].
  stream := self _findAllValuesIdenticalTo: aValue.
  self doBlock
    ifNotNil: [
      stream atEnd
        ifTrue: [ ^ self nscRoot species new ].
      ^ [ stream atEnd ]
           whileFalse: [
             | nextKey next |
             nextKey := stream _peekKey.
             next := stream next.
             nextKey == aValue
             ifTrue: [ self doBlock value: next ] ] ].
  stream atEnd
    ifTrue: [ ^ self nscRoot species new ].
  tmpHolder := NscBuilder
    for: self nscRoot species new
    max: self sizeForNscBuilder.
  self index size == 1
    ifTrue: [ stream _valuesAddInto: tmpHolder identicalTo: aValue ]
    ifFalse: [ stream _uniqueValuesAddInto: tmpHolder identicalTo: aValue ].
  ^ tmpHolder completeBag
%

category: 'Query Select'
method: EqualityIndexQueryEvaluator
findAllValuesLessThanKey: aValue andEquals: aBoolean
  "Returns a set of all values that satisfy the query."

  | selector stream |
  selector := aBoolean
    ifTrue: [ #'<=' ]
    ifFalse: [ #'<' ].
  stream := self
    _findAllValuesGreaterThan: nil
    andEquals: true
    andLessThan: aValue
    andEquals: aBoolean
    using: self comparisonForCompare.
  ^ self doBlock
    ifNotNil: [ | querySpec |
      querySpec := self index btreeComparisonQuerySpec
        key: aValue selector: selector;
        yourself.
      stream streamQuerySpec: querySpec.
      [ stream atEnd ] whileFalse: [ self doBlock value: stream next ] ]
    ifNil: [ stream makeNscComparing: selector key: aValue ]
%

category: 'Query Select'
method: EqualityIndexQueryEvaluator
findAllValuesNotEqualTo: aValue
  "Returns a set of all values that satisfy the query."

  | preStream eqStream postStream querySpec |
  preStream := self
    _findAllValuesGreaterThan: nil
    andEquals: true
    andLessThan: aValue
    andEquals: false
    using: self comparisonForSort.
  eqStream := self
    _findAllValuesGreaterThan: aValue
    andEquals: true
    andLessThan: aValue
    andEquals: true
    using: self comparisonForSort.
  querySpec := self index btreeComparisonQuerySpec
    key: aValue selector: #'~=';
    yourself.
  eqStream streamQuerySpec: querySpec.
  postStream := self
    _findAllValuesGreaterThanKey: aValue
    andEquals: false
    using: self comparisonForSort.
  postStream streamQuerySpec: nil.
  ^ self doBlock
    ifNotNil: [ :aBlock |
      [ preStream atEnd ] whileFalse: [ aBlock value: preStream getNext ].
      [ eqStream atEnd ] whileFalse: [ aBlock value: eqStream getNext ].
      [ postStream atEnd ] whileFalse: [ aBlock value: postStream getNext ] ]
    ifNil: [
      | tmpHolder |
      tmpHolder := NscBuilder
        for: self nscRoot species new
        max: self sizeForNscBuilder.
      self index size == 1
        ifTrue: [
          preStream _valuesAddInto: tmpHolder.
          eqStream _valuesAddInto: tmpHolder notEqualTo: aValue.
          postStream _valuesAddInto: tmpHolder ]
        ifFalse: [
          preStream _uniqueValuesAddInto: tmpHolder.
          eqStream _uniqueValuesAddInto: tmpHolder notEqualTo: aValue.
          postStream _uniqueValuesAddInto: tmpHolder ].
      tmpHolder completeBag ]
%

category: 'Query Detect'
method: EqualityIndexQueryEvaluator
findFirstValueEqualTo: aValue

"Returns the first value that satisfies the query."

| val |
(index _canCompareWith: aValue)
    ifFalse: [ self _error: #assocErrBadComparison ].

val := self btreeRoot _findFirstValueForKey: aValue using: self comparisonForCompare.

(val == #_incompletePathTraversal)
    ifTrue: [ ^ #_incompletePathTraversal ].

^ self _findFirstValueForKey: val
%

category: 'Query Detect'
method: EqualityIndexQueryEvaluator
findFirstValueGreaterThan: val1
andEquals: bool1
andLessThan: val2
andEquals: bool2

"Returns the first value that satisfies the query."

| stream selector1 selector2 |
stream := self
    _findAllValuesGreaterThan: val1
    andEquals: bool1
    andLessThan: val2
    andEquals: bool2
    using: self comparisonForCompare.

stream == nil
  ifTrue: [ ^ #_incompletePathTraversal ].
selector1 := bool1
  ifTrue: [ #_idxForCompareGreaterThanOrEqualTo: ]
  ifFalse: [ #_idxForCompareGreaterThan: ].
selector2 := bool2
  ifTrue: [ #_idxForCompareLessThanOrEqualTo: ]
  ifFalse: [ #_idxForCompareLessThan: ].
^ stream getNextValueComparing: selector1 key: val1 and: selector2 key: val2
%

category: 'Query Detect'
method: EqualityIndexQueryEvaluator
findFirstValueGreaterThanKey: aValue
andEquals: aBoolean

"Returns the first value that satisfies the query."

| stream selector |
stream := self  _findAllValuesGreaterThanKey: aValue
                    andEquals: aBoolean
                    using: self comparisonForCompare.
stream == nil
  ifTrue: [ ^ #_incompletePathTraversal ].
selector := aBoolean
  ifTrue: [ #_idxForCompareGreaterThanOrEqualTo: ]
  ifFalse: [ #_idxForCompareGreaterThan: ].
^ stream getNextValueComparing: selector key: aValue
%

category: 'Query Detect'
method: EqualityIndexQueryEvaluator
findFirstValueIdenticalTo: aValue
  "Returns the first value that satisfies the query.  Since this is an identity
 comparison on a range index (which supports equality comparison), create a
 BtreeReadStream for equal values, then iterate through the values making
 the identity comparison."

  | stream |
  stream := self _findAllValuesIdenticalTo: aValue.
  stream atEnd
    ifTrue: [ ^ #'_incompletePathTraversal' ].	" iterate through the stream, checking for an identical value "
  [ stream _atEnd ]
    whileFalse: [
      stream _peekKey == aValue
        ifTrue: [
          ^ self _findFirstValueForKey: stream _peekValue ].
      stream _btreeNext ].
  ^ #'_incompletePathTraversal'
%

category: 'Query Detect'
method: EqualityIndexQueryEvaluator
findFirstValueLessThanKey: aValue
andEquals: aBoolean

"Returns the first value that satisfies the query."

| stream selector |
stream := self
      _findAllValuesGreaterThan: nil
      andEquals: true
      andLessThan: aValue
      andEquals: aBoolean
      using: self comparisonForCompare.
stream == nil
  ifTrue: [ ^ #_incompletePathTraversal ].
selector := aBoolean
  ifTrue: [ #_idxForCompareLessThanOrEqualTo: ]
  ifFalse: [ #_idxForCompareLessThan: ].
^ stream getNextValueComparing: selector key: aValue
%

category: 'Query Detect'
method: EqualityIndexQueryEvaluator
findFirstValueNotEqualTo: aValue
  "Returns the first value that satisfies the query."

  | stream totalStream obj bag incomplete |
  " find the ones that are equal "
  stream := self
    _findAllValuesGreaterThan: aValue
    andEquals: true
    andLessThan: aValue
    andEquals: true
    using: self comparisonForCompare.
  stream _atEnd
    ifTrue: [ " if none are equal, pick the first one "
      self hasSetValuedTerm
        ifTrue: [ bag := self nscRoot _asIdentityBag.
          1 to: bag size do: [ :i | nil ~~ (bag _at: i)
              ifTrue: [ ^ bag _at: i ] ].
          ^ #'_incompletePathTraversal' ]
        ifFalse: [ incomplete := #'_incompletePathTraversal'.
          bag := self nscRoot _asIdentityBag.
          1 to: bag size do: [ :i | obj := bag _at: i.
            (self index traverseObject: obj) == incomplete
              ifFalse: [ ^ obj ] ].
          ^ #'_incompletePathTraversal' ] ].
  totalStream := self readStreamClass on: self index.	" get a stream over the entire NSC "
  (totalStream _peekKey _idxForCompareNotEqualTo: stream _peekKey)
    ifTrue: [ " see if very first object is not equal "
      ^ totalStream getNext ].
  (totalStream _hasSameEndAs: stream)
    ifTrue: [ " see if end of original stream is the very last object "
      ^ #'_incompletePathTraversal' ]
    ifFalse: [ " advance the stream to the last object "
      totalStream _positionToEnd.
      ^ totalStream getNext ]
%

category: 'Accessing'
method: EqualityIndexQueryEvaluator
readStreamClass
  "Returns the class of read stream to create for query results."

  ^ index readStreamClass
%

category: 'Searching'
method: EqualityIndexQueryEvaluator
_findAllValuesEqualTo: val1 using: aComparison
  "Returns a RangeIndexReadStream that iterates over all objects in the index
 that satisfy the query."

  | stream querySpec |
  stream := self
    _findAllValuesGreaterThan: val1
    andEquals: true
    andLessThan: val1
    andEquals: true
    using: aComparison.
  querySpec := self index btreeComparisonQuerySpec
    key: val1 selector: #'=';
    yourself.
  stream streamQuerySpec: querySpec.
  ^ stream
%

category: 'Searching'
method: EqualityIndexQueryEvaluator
_findAllValuesGreaterThan: val1 andEquals: bool1 andLessThan: val2 andEquals: bool2 using: aComparison
  "Returns a RangeIndexReadStream that iterates over all objects in the index
 that satisfy the query."

  | array1 array2 stream doNext |
  ((self index _canCompareWith: val1) and: [ self index _canCompareWith: val2 ])
    ifFalse: [ self _error: #'assocErrBadComparison' ].
  stream := self readStreamClass new rangeIndex: self index.	" check to see if the query is even satisfiable "
  (aComparison
    satisfiableQueryGreaterThan: val1
    andEquals: bool1
    andLessThan: val2
    andEquals: bool2)
    ifFalse: [
      stream currentStack: {0}.
      ^ stream ].
  doNext := false.
  array1 := {}.	" see if querying > or >= "
  bool1
    ifTrue: [
      " if >=, perform < and do an '_advance' operation later "
      (self btreeRoot
        _findAllValuesLessThanKey: val1
        andEquals: false
        into: array1
        using: aComparison)
        ifTrue: [ doNext := true ]
        ifFalse: [
          " all were greater than or equal to "
          self btreeRoot
            _putFirstIndexOfFirstChildInto: array1
            ifGreaterThanOrEqualTo: val1
            using: aComparison ] ]
    ifFalse: [
      " if >, ask the B-tree specifically for > "
      (self btreeRoot
        _findAllValuesGreaterThanKey: val1
        into: array1
        using: aComparison)
        ifFalse: [
          " none were greater than "
          stream currentStack: {0}.
          ^ stream ] ].
  array2 := {}.	" ask the B-tree for the second boundary of the query result "
  (self btreeRoot
    _findAllValuesLessThanKey: val2
    andEquals: bool2
    into: array2
    using: aComparison)
    ifFalse: [
      " none were found less than "
      stream currentStack: {0}.
      ^ stream ].
  stream endIndex: (array2 at: 1).
  stream endNode: (array2 at: 2).
  (stream endNode == (array1 at: 2) and: [ stream endIndex < (array1 at: 1) ])
    ifTrue: [
      array1 at: 1 put: 0.
      stream currentStack: array1.
      ^ stream ].
  stream currentStack: array1.
  doNext
    ifTrue: [
      " advance the B-tree positioning "
      stream _advance ].
  ^ stream
%

category: 'Searching'
method: EqualityIndexQueryEvaluator
_findAllValuesGreaterThanKey: aKey andEquals: aBoolean
  "Returns a RangeIndexReadStream that iterates over all objects in the index
 that satisfy the query."

  ^ self
    _findAllValuesGreaterThanKey: aKey
    andEquals: aBoolean
    using: self comparisonForCompare
%

category: 'Searching'
method: EqualityIndexQueryEvaluator
_findAllValuesGreaterThanKey: aKey andEquals: aBoolean using: aComparison
  "Returns a RangeIndexReadStream that iterates over all objects in the index
 that satisfy the query."

  | array1 array2 stream doNext querySpec |
  (self index _canCompareWith: aKey)
    ifFalse: [ self _error: #'assocErrBadComparison' ].
  stream := self readStreamClass new rangeIndex: self index.
  doNext := false.
  array1 := {}.	" see if querying > or >= "
  aBoolean
    ifTrue: [
      " if >=, perform < and do a 'next' operation later "
      (self btreeRoot
        _findAllValuesLessThanKey: aKey
        andEquals: false
        into: array1
        using: aComparison)
        ifTrue: [ doNext := true ]
        ifFalse: [
          " all were greater than or equal to "
          self btreeRoot
            _putFirstIndexOfFirstChildInto: array1
            ifGreaterThanOrEqualTo: aKey
            using: aComparison ] ]
    ifFalse: [
      " if >, ask the B-tree specifically for > "
      (self btreeRoot
        _findAllValuesGreaterThanKey: aKey
        into: array1
        using: aComparison)
        ifFalse: [
          " none were greater than "
          stream currentStack: {0}.
          ^ stream ] ].
  array2 := {}.
  self btreeRoot _putLastIndexOfLastChildInto: array2.
  stream currentStack: array1.
  stream endIndex: (array2 at: 1).
  stream endNode: (array2 at: 2).
  doNext
    ifTrue: [ stream _advance ].
  querySpec := self index btreeComparisonQuerySpec
    key: aKey
    selector:
      (aBoolean
        ifTrue: [ #'>=' ]
        ifFalse: [ #'>' ]);
    yourself.
  stream streamQuerySpec: querySpec.
  ^ stream
%

category: 'Searching'
method: EqualityIndexQueryEvaluator
_findAllValuesIdenticalTo: aValue
  "Returns a set of all values that satisfy the query.  Since this is an identity
 comparison on a range index (which supports equality comparison), this
 method creates a B-tree read stream for equal values, then iterates through the
 values making the identity comparison."

  | array1 array2 stream doNext |
  stream := self readStreamClass on: self index.
  " if can't make the comparison, then none are identical "
  (self index _canCompareWith: aValue)
    ifFalse: [
       stream currentStack: {0}.
       ^ stream ].
  " get boundary entries in the B-tree "
  array1 := {}.
  " >=, perform < and do an 'next' operation later "
  doNext := false.
  (self btreeRoot
    _findAllValuesLessThanKey: aValue
    andEquals: false
    into: array1
    using: self comparisonForCompare)
    ifTrue: [ doNext := true ]
    ifFalse: [ " all were greater than or equal to "
      self btreeRoot
        _putFirstIndexOfFirstChildInto: array1
        ifGreaterThanOrEqualTo: aValue
        using: self comparisonForCompare ].
  array2 := {}.
  (self btreeRoot
    _findAllValuesLessThanKey: aValue
    andEquals: true
    into: array2
    using: self comparisonForCompare)
    ifFalse: [ " none were found less than "
       stream currentStack: {0}.
       ^ stream ].
  " create the read stream "
  stream currentStack: array1.
  stream endIndex: (array2 at: 1).
  stream endNode: (array2 at: 2).
  doNext
    ifTrue: [ " advance the B-tree positioning "
      stream _advance ].
  ^ stream
%

category: 'Query Select'
method: EqualityIndexQueryEvaluator
_findAllValuesIdenticalToAsNsc: aValue
  "Answer a collecation of all values identical to aValue"

  | stream querySpec |
  stream := self _findAllValuesIdenticalTo: aValue.
  querySpec := self btreeComparisonQuerySpec
    key: aValue selector: #==;
    yourself.
  stream streamQuerySpec: querySpec.
  ^ stream makeNsc
%

category: 'Searching'
method: EqualityIndexQueryEvaluator
_findAllValuesLessThanKey: aKey andEquals: aBoolean using: aComparison
  "Returns a RangeIndexReadStream that iterates over all objects in the index
 that satisfy the query."

  | array1 array2 stream querySpec |
  (self index _canCompareWith: aKey)
    ifFalse: [ self _error: #'assocErrBadComparison' ].
  stream := self readStreamClass new rangeIndex: self index.
  array2 := {}.	" ask the B-tree to make the search and put the result path into array2 "
  (self btreeRoot
    _findAllValuesLessThanKey: aKey
    andEquals: aBoolean
    into: array2
    using: aComparison)
    ifTrue: [
      array1 := {}.	" put path to first entry of the B-tree into array1 "
      self btreeRoot _putFirstIndexOfFirstChildInto: array1.
      stream currentStack: array1.
      stream endIndex: (array2 at: 1).
      stream endNode: (array2 at: 2) ]
    ifFalse: [
      " none were found "
      stream currentStack: {0} ].
  querySpec := self index btreeComparisonQuerySpec
    key: aKey
    selector:
      (aBoolean
        ifTrue: [ #'<=' ]
        ifFalse: [ #'<' ]);
    yourself.
  stream streamQuerySpec: querySpec.
  ^ stream
%

category: 'Searching'
method: EqualityIndexQueryEvaluator
_findAllValuesThroughSetsNotIdenticalTo: aKey
  "Returns a set of all values that satisfy the query.  This method works
 when the path is through a set-valued instance variable."

  | tmpVals tmpHolder startPt pathTerm idx |
  tmpHolder := NscBuilder
    for: self nscRoot species new
    max: self sizeForNscBuilder.
  idx := self index.
  tmpVals := idx btreeRoot _lastValuesNotIdenticalTo: aKey into: Array new.
  startPt := idx lastPathComponentsDictionaryOffset.
  pathTerm := idx at: startPt.
  1 to: tmpVals size do: [ :i |
    idx
      _addAllFor: (tmpVals _at: i)
      into: tmpHolder
      offset: startPt
      pathTerm: pathTerm ].
  ^ tmpHolder completeBag
%

category: 'Searching'
method: EqualityIndexQueryEvaluator
_findFirstKeyNotIdenticalTo: aKey atTerm: pathTerm
  "Returns the first key in the receiver's B-tree that is not identical to the
 given key."

  | stream key |
  stream := self btreeReadStreamClass on: self btreeRoot.
  [ stream _atEnd ] whileFalse: [ key := stream _peekKey.
      key == aKey
        ifFalse: [ ^ key ].
      stream _btreeNext ].
  ^ #'_incompletePathTraversal'
%

! Class extensions for 'EqualityIndexSpecification'

!		Instance methods for 'EqualityIndexSpecification'

category: 'accessing'
method: EqualityIndexSpecification
equalityIndexClass
  ^ self legacyIndex
    ifTrue: [ RangeEqualityIndex ]
    ifFalse: [ GsRangeEqualityIndex ]
%

category: 'accessing'
method: EqualityIndexSpecification
indexType

	^#equality
%

category: 'accessing'
method: EqualityIndexSpecification
indexTypePrintString
  ^ 'equalityIndex'
%

category: 'accessing'
method: EqualityIndexSpecification
removeIndexFrom: anNsc
  (self isIndexedOn: anNsc)
    ifTrue: [ anNsc removeEqualityIndexOn: self path ]
%

category: 'accessing'
method: EqualityIndexSpecification
_createIndex
  | index |
  index := self equalityIndexClass
    newWithLastElementClass: self lastElementClass.
  self legacyIndex
    ifFalse: [ index options: self options ].
  ^ index
%

category: 'private'
method: EqualityIndexSpecification
_validateLastElementClassOn: anNsc
  | aClass |
  aClass := self lastElementClass.
  aClass _validateClass: Behavior.
  ((aClass canUnderstand: #'<=')
    or: [ aClass == Boolean or: [ aClass == UndefinedObject ] ])
    ifFalse: [ anNsc _error: #'rtErrBagClassDoesNotSupportRangeOperators' args:{aClass} ]
%

! Class extensions for 'ExitClientError'

!		Class methods for 'ExitClientError'

category: 'instance creation'
classmethod: ExitClientError
signal: errorMessage status: anInteger
  ^ self new
    status: anInteger;
    signal: errorMessage
%

!		Instance methods for 'ExitClientError'

category: 'Instance initialization'
method: ExitClientError
initialize
  gsNumber := ERR_ExitClientError .
  gsResumable := false .
  gsTrappable := true .
%

category: 'accessing'
method: ExitClientError
status
  ^ status
%

category: 'accessing'
method: ExitClientError
status: anInteger
  status := anInteger
%

! Class extensions for 'FalseClass'

!		Class methods for 'FalseClass'

removeallmethods FalseClass
removeallclassmethods FalseClass

category: 'Instance creation'
classmethod: FalseClass
new
  self shouldNotImplement: #new
%

category: 'Instance creation'
classmethod: FalseClass
new: aSize
  self shouldNotImplement: #new:
%

category: 'Instance creation'
classmethod: FalseClass
_basicNew
  self shouldNotImplement: #_basicNew
%

category: 'Instance creation'
classmethod: FalseClass
_basicNew: aSize
  self shouldNotImplement: #_basicNew:
%

!		Instance methods for 'FalseClass'

category: 'Class Membership'
method: FalseClass
class
  "The environment 0 class is always Boolean"
  ^ Boolean
%

! Class extensions for 'Gs32DisjunctiveClauseOptimizer'

!		Instance methods for 'Gs32DisjunctiveClauseOptimizer'

category: 'optimizing'
method: Gs32DisjunctiveClauseOptimizer
consolidateEnumerablePredicates
  "Consolidate predicates that have a path terms that can be combined into a single
	EnumeratedPath query, i.e., a clause of the form:

      (each.firstName = name) | (each.lastName = name)

    and an index with enumerated path term for

      each.firstName|lastName
"

  | primaries |
  primaries := self predicates copy.
  1 to: primaries size do: [ :index |
    (primaries at: index)
      ifNotNil: [ :primaryPredicate | self consolidateEnumeratedPredicates: primaries with: primaryPredicate ] ].
  predicates := primaries select: [ :each | each ~~ nil  ]
%

category: 'optimizing'
method: Gs32DisjunctiveClauseOptimizer
consolidateEnumeratedPredicates: primaries with: primaryPredicate
  | consolidatedPredicate |
  primaries
    do: [ :secondaryPredicate |
      (secondaryPredicate ~~ nil  and: [ primaryPredicate ~~ secondaryPredicate ])
        ifTrue: [
          (primaryPredicate canConsolidateEnumeratedWith: secondaryPredicate)
            ifTrue: [
              primaries at: (primaries indexOf: secondaryPredicate) put: nil.
              consolidatedPredicate := primaryPredicate
                consolidateEnumeratedWith: secondaryPredicate.
              primaries
                at: (primaries indexOf: primaryPredicate)
                put: consolidatedPredicate.
              ^ self ] ] ]
%

category: 'accessing'
method: Gs32DisjunctiveClauseOptimizer
predicatesAsFormula
  | newFormula |
  newFormula := (predicates at: 1) copy.
  2 to: predicates size do: [ :index | newFormula := newFormula | (predicates at: index) copy ].
  ^ (newFormula bindEvaluatorsFor: self nsc collator: self collator)
    immediateInvariant
%

category: 'optimizing'
method: Gs32DisjunctiveClauseOptimizer
removeRedundantDisjunctivePredicates
  | primaries |
  [
  primaries := self predicates copy.
  1 to: primaries size do: [ :index |
    (primaries at: index)
      ifNotNil: [ :primaryPredicate | self removeRedundantDisjunctivePredicates: primaries with: primaryPredicate ] ].
  predicates := primaries select: [ :each | each ~~ nil  ] ]
    on: GsUnsatisfiableQueryNotification
    do: [ :note |
      "short circuit analysis and replace whole enchilada with a `true` predicate"
      predicates := OrderedCollection with: (GsQueryPredicate constant: true).
      ^ self ]
%

category: 'optimizing'
method: Gs32DisjunctiveClauseOptimizer
removeRedundantDisjunctivePredicates: primaries with: primaryPredicate
  primaries
    do: [ :secondaryPredicate |
      (secondaryPredicate ~~ nil  and: [ primaryPredicate ~~ secondaryPredicate ])
        ifTrue: [
          (primaryPredicate redundantDisjunctivePredicateBetween: secondaryPredicate)
            ifNotNil: [ :redundantPredicate | primaries at: (primaries indexOf: redundantPredicate) put: nil ] ] ]
%

category: 'optimizing'
method: Gs32DisjunctiveClauseOptimizer
runOptimizations
  self queryOptions removeRedundantPredicates
    ifTrue: [ self removeRedundantDisjunctivePredicates ].
  self queryOptions consolidateEnumerablePredicates
    ifTrue: [ self consolidateEnumerablePredicates ]
%

! Class extensions for 'Gs32Optimizer'

!		Instance methods for 'Gs32Optimizer'

category: 'visiting'
method: Gs32Optimizer
acceptCompoundClause: aCompoundClause
  "replace conjunctive normal form clauses with optimized equivalent"

  | clause |
  clause := aCompoundClause clause1.
  clause isDisjunctiveNormalForm
    ifTrue: [
      clause isDisjunctiveClause
        ifTrue: [ clause := self optimizeDisjunctiveCompoundClause: clause ].
      clause := self optimizeDisjunctiveNormalClause: clause.
      aCompoundClause clause1: clause ]
    ifFalse: [
      clause isDisjunctiveClause
        ifTrue: [
          clause := self optimizeDisjunctiveCompoundClause: clause.
          aCompoundClause clause1: clause ] ].
  clause := aCompoundClause clause2.
  clause isDisjunctiveNormalForm
    ifTrue: [
      clause isDisjunctiveClause
        ifTrue: [ clause := self optimizeDisjunctiveCompoundClause: clause ].
      clause := self optimizeDisjunctiveNormalClause: clause.
      aCompoundClause clause2: clause ]
    ifFalse: [
      clause isDisjunctiveClause
        ifTrue: [
          clause := self optimizeDisjunctiveCompoundClause: clause.
          aCompoundClause clause2: clause ] ].
  super acceptCompoundClause: aCompoundClause
%

category: 'optimizing'
method: Gs32Optimizer
optimize
  | formulaCopy |
  formulaCopy := (GsClassicQueryBlockOptimizer
    optimize: self formula
    on: self nsc
    options: self queryOptions) copy.
  formulaCopy isDisjunctiveNormalForm
    ifTrue: [
      formulaCopy isDisjunctiveClause
        ifTrue: [ formulaCopy := self optimizeDisjunctiveCompoundClause: formulaCopy ].
      formulaCopy := self optimizeDisjunctiveNormalClause: formulaCopy ]
    ifFalse: [
      formulaCopy isDisjunctiveClause
        ifTrue: [ formulaCopy := self optimizeDisjunctiveCompoundClause: formulaCopy ] ].
  self visitFormula: formulaCopy.
  self transformed
    ifTrue: [
      "given the nature of the disjunctive clause transforms, we need to keep optimizing until nothing is changed"
      self formula: formulaCopy copy.
      self transformed: false.
      ^ self optimize ].
  ^ formulaCopy immediateInvariant
%

category: 'optimizing'
method: Gs32Optimizer
optimizeConjunctiveNormalClause: aClause
  ^ aClause
%

category: 'optimizing'
method: Gs32Optimizer
optimizeDisjunctiveCompoundClause: aClause
  | optimizer |
  self queryOptions consolidateUnaryConstantPredicates
    ifFalse: [ ^ aClause ].
  (optimizer := Gs32UnaryConstantPredicateOptimizer new)
    formula: aClause;
    nsc: self nsc;
    queryOptions: self queryOptions .
  ^ (optimizer optimizeFrom: self) copy
%

category: 'optimizing'
method: Gs32Optimizer
optimizeDisjunctiveNormalClause: aClause
  ^ (Gs32DisjunctiveClauseOptimizer
    optimize: aClause
    on: self nsc
    options: self queryOptions) copy
%

category: 'accessing'
method: Gs32Optimizer
transformed
  transformed ifNil: [ transformed := false ].
  ^transformed
%

category: 'accessing'
method: Gs32Optimizer
transformed: aBool
  transformed := aBool
%

! Class extensions for 'Gs32UnaryConstantPredicateOptimizer'

!		Instance methods for 'Gs32UnaryConstantPredicateOptimizer'

category: 'optimizing'
method: Gs32UnaryConstantPredicateOptimizer
optimizeFrom: aGs32Optimizer
  "Simplify compound clause involving predicates that are unary-constant (true or false) or
   constant-constant. The predicate is removed, or the expression is consolidated."

  | truePredicate falsePredicate clause1 clause2 |
  clause1 := self formula clause1.
  clause2 := self formula clause2.
  truePredicate := falsePredicate := nil.
  (clause1 isConstantConstant and: [ clause1 isConstantBound ])
    ifTrue: [
      clause1 executePredicate
        ifTrue: [
          aGs32Optimizer transformed: true.
          ^ clause1 ]
        ifFalse: [
          aGs32Optimizer transformed: true.
          ^ clause2 ] ]
    ifFalse: [
      (clause2 isConstantConstant and: [ clause2 isConstantBound ])
        ifTrue: [
          clause2 executePredicate
            ifTrue: [
              aGs32Optimizer transformed: true.
              ^ clause2 ]
            ifFalse: [
              aGs32Optimizer transformed: true.
              ^ clause1 ] ] ].
  ^ self formula
%

! Class extensions for 'GsAbstractIndex'

!		Instance methods for 'GsAbstractIndex'

category: 'Updating Indexes'
method: GsAbstractIndex
addDirectMappingsFor: aBag indexList: iList
  "Add an entry for an index on the elements of the NSC."

  | anObject firstPathTerm indexMgr |
  indexMgr := self indexManager.
  firstPathTerm := self firstPathTerm.
  indexMgr autoCommit
    ifTrue: [ nscRoot _lockForIndexCreation ].
  self lastPathTerm needsDepList
    ifTrue: [ 1 to: aBag size do: [ :i | " Add an entry for an index on the elements of the NSC. "
        nil ~~ (anObject := aBag _at: i)
          ifTrue: [ " add an entry in the dependency list "
            anObject
              getDepListAndAddLastElementPathTerm: firstPathTerm
              logging: false ].
        self btreeAt: anObject put: anObject root: anObject.
        i \\ 100 == 0
          ifTrue: [ indexMgr commitIndexMaintenance: self at: i ] ] ]
    ifFalse: [ 1 to: aBag size do: [ :i | anObject := aBag _at: i.
        self btreeAt: anObject put: anObject root: anObject.
        i \\ 100 == 0
          ifTrue: [ indexMgr commitIndexMaintenance: self at: i ] ] ]
%

category: 'Converting'
method: GsAbstractIndex
asIndexSpecification
  ^ self subclassResponsibility: #'asIndexSpecification'
%

category: 'Support'
method: GsAbstractIndex
asPathEvaluator
  "Returns a PathEvaluator over the same path as the receiver."

  | pathEval holder |
  pathEval := PathEvaluator new.
  1 to: self size do: [ :i | pathEval add: (self at: i) name ].
  pathEval nsc: nscRoot.
  holder := { pathEval } .
  pathEval := nil .
  ^ PathEvaluator asMostSpecificType: holder .
%

category: 'Converting'
method: GsAbstractIndex
asString
  | str |
  str := '('.
  1 to: self size do: [ :index |
    | pt |
    pt := self at: index.
    str := str , pt name asString.
    index < self size
      ifTrue: [ str := str , '.' ] ].
  ^ super asString , str , ')'
%

category: 'Updating'
method: GsAbstractIndex
btreeAt: aKey put: aValue root: rootObject
  "Insert the key/value pair into the root B-tree node, validate that aKey can be stored in btree."

  self _validateCanCompareWith: aKey.	"signal error if comparison not valid"
  btreeRoot btreeAt: aKey put: aValue root: rootObject
%

category: 'Stream Accessing'
method: GsAbstractIndex
btreeComparisonQuerySpec
  ^ BtreePlusComparisonQuerySpec new
    rangeIndex: self;
    yourself
%

category: 'Btree Accessing'
method: GsAbstractIndex
btreePlusLeafNodeClass
  ^ self isIndexOnRootNsc
      ifTrue: [ BtreePlusLeafKeyNode ]
      ifFalse: [ self isIndexOnFirstTerm
          ifTrue: [ BtreePlusLeafKeyValueNode ]
          ifFalse: [ BtreePlusLeafKeyValueRootObjectNode ] ]
%

category: 'Stream Accessing'
method: GsAbstractIndex
btreeRangeComparisonQuerySpec
  ^ BtreePlusRangeComparisonQuerySpec new
%

category: 'Stream Accessing'
method: GsAbstractIndex
btreeReadStreamClass
  "Returns the class of btree read stream to create for query results."

  ^ BtreePlusReadStream
%

category: 'Updating'
method: GsAbstractIndex
btreeRemoveKey: aKey value: aValue root: rootObject
  "Removes the key and value from the B-tree root node.  Must check to see if
 a merge occurred in the root such that the root only contains a single
 entry.  If so, make the single entry the new root.  Returns whether the
 removal occurred."

  ^ btreeRoot removeKey: aKey value: aValue root: rootObject
%

category: 'Accessing'
method: GsAbstractIndex
btreeRoot
  ^ btreeRoot
    ifNil: [
      btreeRoot := self options reducedConflict
        ifTrue: [ RcBtreePlusRoot new ]
        ifFalse: [ BtreePlusRoot new ].
      btreeRoot
        indexObject: self;
        yourself ]
%

category: 'Clustering'
method: GsAbstractIndex
clusterDepthFirst

"Cluster the receiver.  Only need to cluster the path terms."

1 to: self size do: [ :i |
  (self at: i) clusterDepthFirst
]
%

category: 'Accessing'
method: GsAbstractIndex
collator
  "No IcuCollator associated with this index."

  ^ nil
%

category: 'Comparison Operators'
method: GsAbstractIndex
comparisonForCompare
  self subclassResponsibility: #comparisonForCompare
%

category: 'Comparison Operators'
method: GsAbstractIndex
comparisonForSort
  "called during creation of receiver, so initialize unset instance variables"

  self subclassResponsibility: #comparisonForSort
%

category: 'Traversing'
method: GsAbstractIndex
cumulativeFactorFor: anObject upTo: aPathTerm startingAt: anOffset
  "Traverse the sub-objects of the given object using the path terms of the
 receiver up to the given path term. Return an Array of objects. The index
 may be a collection based index."

  | nextObj sz i thePathTerm theResult factor |
  nil == anObject
    ifTrue: [ ^ 0 ].
  nextObj := anObject.
  sz := self size.
  i := anOffset.
  theResult := { nextObj }.
  factor := 0.
  [ thePathTerm := self at: i.
  thePathTerm ~~ aPathTerm and: [ i <= sz ] ]
    whileTrue: [
      theResult do: [ :nextTraversalObj |
        | enumeratedValues terms |
        thePathTerm indicatesMultiValue
          ifTrue: [
            theResult := {}.
            enumeratedValues := IdentityBag new.
terms := 0.
            thePathTerm
              nextObj: nextTraversalObj
              do: [ :obj :ivOffset |
                  enumeratedValues add: obj.
                  factor := factor + (self
                    cumulativeFactorFor: obj
                    upTo: aPathTerm
                    startingAt: i + 1).
                  terms := terms + 1.
                 ].
            factor := factor + (enumeratedValues size / terms).
            ^ factor ]
          ifFalse: [
            nextObj := thePathTerm _nextObjectFor: nextTraversalObj.
            nil == nextObj
              ifTrue: [ ^ factor  ].
            theResult := { nextObj } ] ].
      i := i + 1 ].
  ^ factor
%

category: 'Searching'
method: GsAbstractIndex
findRootObjectMaps: rootObjectMap pathTerm: pathTerm key: aKey value: aValue
  | stream theKey |
  stream := self asQueryEvaluator
    _findAllValuesGreaterThanKey: aKey
    andEquals: true.
  [
  stream _btreeAtEnd not
    and: [
      theKey := stream _peekKey.
      theKey _idxForSortEqualTo: aKey ] ]
    whileTrue: [
       "collect key/value/root tuples for entries in the btree whose intermediate parent object
       is reachable from the root object in the entry."
      (theKey == aKey and: [ stream _peekValue == aValue ])
        ifTrue: [
          self
            findRootObjects: rootObjectMap
            rootObject: stream _peekRoot
            pathTerm: pathTerm
            key: aKey
            value: aValue ].
      stream _btreeNextNoValue "safe as long as we don't start using reversed read streams" ]
%

category: 'Searching'
method: GsAbstractIndex
findRootObjects: rootObjectMap rootObject: rootObject pathTerm: pathTerm key: aKey value: aValue
  | pivotObject pivotPathTerm pivotPathTermOffset rootIsPivot |
  pivotPathTerm := rootObjectMap pivotPathTerm.
  pivotPathTermOffset := pivotPathTerm offset.
  pivotObject := rootObjectMap pivotObject.

  rootIsPivot := false.
  pivotPathTermOffset == 1
    ifTrue: [
      rootIsPivot := pivotObject == rootObject.
      rootIsPivot ifTrue: [ (rootObjectMap traversalMap at: rootObject ifAbsentPut: [ IdentityBag new ]) add: rootObject ] ]
    ifFalse: [ (rootObjectMap roots at: rootObject ifAbsentPut: [ IdentityBag new ]) add: rootObject ].

  pathTerm offset == 1
    ifTrue: [ ^ self ].
  (rootObjectMap traversalMap at: aKey ifAbsentPut: [ IdentityBag new ]) add: aValue.
  pathTerm offset == 2
    ifTrue: [
      (rootObjectMap traversalMap at: aValue ifAbsentPut: [ IdentityBag new ]) add: rootObject.
      ^ self ].
  (pivotPathTermOffset ~~ 1 or: [ rootIsPivot ] )
    ifTrue: [
      self
        traverse: rootObject
        parent: nil
        upTo: pathTerm
        startingAt: 1
        do: [ :term :parent :child | (rootObjectMap traversalMap at: child ifAbsentPut: [ IdentityBag new ]) add: parent ] ].
%

category: 'Searching'
method: GsAbstractIndex
findRootObjectsComparingForKey: aKey value: aValue
  | stream rootObjects theKey |
  stream := self asQueryEvaluator
    _findAllValuesGreaterThanKey: aKey
    andEquals: true.
  rootObjects := IdentityBag new.
  [ stream _btreeAtEnd not and: [
    theKey := stream _peekKey.
    theKey _idxForSortEqualTo: aKey ] ]
    whileTrue: [
      | rootObject |
      "collect key/value/root tuples for entries in the btree whose intermediate parent object
       is reachable from the root object in the entry."
      ((theKey _idxForCompareEqualTo: aKey) and: [ stream _peekValue == aValue ])
        ifTrue: [ "selec value entries that are identically equal to aValue"
          rootObject := stream _peekRoot.
          rootObjects add: rootObject ].
      stream _btreeNext ].
 ^ rootObjects
%

category: 'Searching'
method: GsAbstractIndex
findRootObjectsForKey: aKey value: aValue
  | stream rootObjects theKey |
  stream := self asQueryEvaluator
    _findAllValuesGreaterThanKey: aKey
    andEquals: true.
  rootObjects := IdentityBag new.
  [
  stream _btreeAtEnd not
    and: [
      theKey := stream _peekKey.
      theKey _idxForSortEqualTo: aKey ] ]
    whileTrue: [
      | rootObject |
      "collect key/value/root tuples for entries in the btree whose intermediate parent object
       is reachable from the root object in the entry."
      (theKey == aKey and: [ stream _peekValue == aValue ])
        ifTrue: [
          "select value entries that are identically equal to aValue"
          rootObject := stream _peekRoot.
          rootObjects add: rootObject ].
      stream _btreeNext ].
  ^ rootObjects
%

category: 'Accessing'
method: GsAbstractIndex
firstPathTerm

"Returns the first path term in the path components list."

^ self at: 1
%

category: 'Testing'
method: GsAbstractIndex
hasCollectionBasedTerm
  "Returns true if the path has an enumerated path term or a term that indicates a
   set-valued instance variable."

  ^ self hasEnumeratedTerm or: [ self hasSetValuedTerm ]
%

category: 'Testing'
method: GsAbstractIndex
hasEnumeratedTerm
  "Returns true if the path has a term that indicates an enumerated path term."

  1 to: self size do: [ :i |
    (self at: i) isEnumeratedTerm
      ifTrue: [ ^ true ] ].
  ^ false
%

category: 'Testing'
method: GsAbstractIndex
hasIndexDictionary
  "Answer if receiver has an indexDictionary."

  "indexDictionary not used by any of receiver's subclasses"

  ^ false
%

category: 'Testing'
method: GsAbstractIndex
hasIndexOnPath: pathArray
  "Returns whether the receiver's path components match the path represented by
 pathArray."

  self size == pathArray size
    ifFalse: [ ^ false ].
  1 to: self size do: [ :i |
    ((self at: i) hasMatchingTerm: (pathArray at: i))
      ifFalse: [ ^ false ] ].
  ^ isComplete
%

category: 'Testing'
method: GsAbstractIndex
hasIndexOnPath: pathArray startingAt: offset

"Returns whether the receiver's path components match the path represented by
 pathArray."

self size - offset + 1 == pathArray size
  ifFalse: [ ^ false ].

offset to: self size do: [ :i |
  (self at: i) name == (pathArray at: i + 1 - offset)
    ifFalse: [ ^ false ].
].
^ isComplete
%

category: 'Support'
method: GsAbstractIndex
hasSamePathAs: anIndex

"Returns whether the given index is on the same path as the receiver.
 This can only be true if the index is identical."

^ self == anIndex
%

category: 'Testing'
method: GsAbstractIndex
hasSetValuedTerm
  "Returns true if the receiver has any path term that indicates a set-valued
 instance variable."

  1 to: self size do: [ :i |
    (self at: i) isSetValuedTerm
      ifTrue: [ ^ true ] ].
  ^ false
%

category: 'Accessing'
method: GsAbstractIndex
indexDictionary

"GsAbstractIndexes do not have an indexDictionary."

^nil
%

category: 'Accessing'
method: GsAbstractIndex
indexManager

^IndexManager current
%

category: 'Accessing'
method: GsAbstractIndex
indexType
  ^ self subclassResponsibility: #'indexType'
%

category: 'Testing'
method: GsAbstractIndex
isComplete

"Returns the value of the instance variable 'isComplete'."

isComplete == nil
  ifTrue: [ ^ true ].
^ isComplete
%

category: 'Testing'
method: GsAbstractIndex
isIdentityIndex

"Returns false, subclasses will override as needed."

^ false
%

category: 'Testing'
method: GsAbstractIndex
isIndexOnFirstTerm

"Returns whether the receiver is an index on the first and only path term and is not on
 a root element of the nsc."

^ self lastPathTerm indicatesIndexOnRootNsc
  ifTrue: [ ^false ]
  ifFalse:[ self size == 1 ]
%

category: 'Testing'
method: GsAbstractIndex
isIndexOnNscElements

"Returns whether the receiver is an index directly on the elements of an NSC
 (either the root NSC or a set-valued instance variable on the path)."

^ self lastPathTerm indicatesIndexOnNscElements
%

category: 'Testing'
method: GsAbstractIndex
isIndexOnRootNsc

"Returns whether the receiver is an index directly on the elements of
 the root NSC."

^ self lastPathTerm indicatesIndexOnRootNsc
%

category: 'Testing'
method: GsAbstractIndex
isLegacyIndex

"Legacy indexes are kinds of IdentityIndex, so return false for a kind of GsAbstractIndex."

^ false
%

category: 'Testing'
method: GsAbstractIndex
isPathEvaluator

^ false
%

category: 'Testing'
method: GsAbstractIndex
isRangeEqualityIndex

"Returns false, subclasses will override as needed."

^ false
%

category: 'Testing'
method: GsAbstractIndex
isReducedConflictIndex
  "answer true if the receiver supports reduced conflict operations"

  ^ self options reducedConflict
%

category: 'Testing'
method: GsAbstractIndex
isStreamable

"Returns true, subclasses will override as needed."

^ true
%

category: 'Accessing'
method: GsAbstractIndex
lastPathTerm

"Returns the last path term in the path components list."

^ self at: self size
%

category: 'Modification Tracking Support'
method: GsAbstractIndex
modifiedObject: aKey userData: valArray
  "Notification that modification of aKey is completed and that the receiver
   should update the btree using value and root from valArray."

  ^ self btreeAt: aKey put: (valArray at: 1) root: (valArray at: 2)
%

category: 'Accessing'
method: GsAbstractIndex
nscRoot

"Returns the value of the instance variable 'nscRoot'."

^nscRoot
%

category: 'Updating'
method: GsAbstractIndex
nscRoot: newValue

"Modify the value of the instance variable 'nscRoot'."

nscRoot := newValue.
"force lazy initialization of comparisonForSort iv to avoid commit conflicts later... make it invariant, for good measure."
self comparisonForSort immediateInvariant
%

category: 'Testing'
method: GsAbstractIndex
optimizingComparison
  "Answer true if comparison operations can be optimized in Btree operations and elsewhere.
   Controlled by optimizedComparison index option."

  ^ self options optimizedComparison
%

category: 'Accessing'
method: GsAbstractIndex
options
  "index options include: optionalPathTerms, reducedConflict, legacyIndex"

  ^ options
%

category: 'Accessing'
method: GsAbstractIndex
options: aGsIndexOptions
  "make copy to perserve integrity of the incoming options object"

  options := aGsIndexOptions copy _reify immediateInvariant
%

category: 'Accessing'
method: GsAbstractIndex
pathComponentsString

"Returns a string of the path components."

^ self pathComponentsStringStartingAt: 1
%

category: 'Accessing'
method: GsAbstractIndex
pathComponentsStringStartingAt: offset

"Returns a string of the path components."

| str sz |

sz := self size.
str := String new.
offset to: sz do: [ :i |
    str addAll: (self at: i) name.
    i == sz
        ifFalse: [ str add: $.  ]
].
^ str
%

category: 'Updating Indexes'
method: GsAbstractIndex
postIndexCreation: originalBtreeRoot
  btreeRoot btreeRootNode isBtreePlusNode
    ifFalse: [
      | leafNodes pathSorter |
      "Use a merge sort to create a complete B-tree from a PathSorter
       stored in the btreeRoot instance variable."
      leafNodes := {(originalBtreeRoot btreeRootNode)}.	" create an Array containing an empty B-tree node "
      pathSorter := btreeRoot btreeRootNode.
      btreeRoot := {leafNodes.
      pathSorter}.	"per bug 36147, we need the leafNodes array to be persistent to avoid some out-of-memory conditions during index creation"
      pathSorter sortIntoBtreeNodes: leafNodes.	" produce an Array containing many B-tree leaf nodes, all sorted "
      btreeRoot btreeRootNode: (pathSorter createInteriorNodesFor: leafNodes)	" now build up interior nodes for the leaves " ].
  isComplete := true.
  self indexManager autoCommit
    ifTrue: [ | systm |
      systm := System.
      systm commitTransaction
        ifFalse: [ nscRoot _errorCouldNotCommitDuringIndexCreation ].
      systm transactionMode == #'manualBegin'
        ifTrue: [ systm beginTransaction ] ]
%

category: 'Index Creation'
method: GsAbstractIndex
preIndexCreation
  "record that index creation has started and "

  isComplete := false.
  progress := 0.
  nscRoot size > self btreeRoot maxNumberOfElements
    ifTrue: [ ^ self _preIndexCreationSort ].
  ^ btreeRoot
%

category: 'Updating Indexes'
method: GsAbstractIndex
preIndexRemoval

isComplete := false.
progress := 0.

^ nil
%

category: 'Formatting'
method: GsAbstractIndex
printOn: aStream

"Puts a displayable representation of the receiver on the given stream."

"Copy the implementation from Object so we don't inherit it from Collection."

aStream nextPutAll: self asString
%

category: 'Accessing'
method: GsAbstractIndex
progress

"Returns the value of the instance variable 'progress'."

^progress
%

category: 'Updating'
method: GsAbstractIndex
progress: newValue

"Modifies the value of the instance variable 'progress'."

progress := newValue
%

category: 'Stream Accessing'
method: GsAbstractIndex
readStreamClass
  "Returns the class of read stream to create for query results."

  ^ BtreePlusGsIndexReadStream
%

category: 'Accessing'
method: GsAbstractIndex
sizeForNscBuilder

"Returns the size to be used when an NscBuilder is collecting objects."

^ nscRoot size
%

category: 'Testing'
method: GsAbstractIndex
termsRequired
  "Returns true if the receiver has any path term that has termsRequired set."

  1 to: self size do: [ :i |
    (self at: i) termsRequired
      ifTrue: [ ^ true ] ].
  ^ false
%

category: 'Traversing'
method: GsAbstractIndex
traverse: anObject parent: aParent pathTerm: aPathTerm startingAt: anOffset limit: limit do: aBlock
  ""

  | nextObj thePathTerm nextTraversalObj |
  nil == anObject
    ifTrue: [ ^ self ].
  nextTraversalObj := anObject.
  anOffset to: limit do:
    [:i |
        thePathTerm := self at: i.
        thePathTerm indicatesMultiValue
          ifTrue: [
            thePathTerm
              nextObj: nextTraversalObj
              do: [ :obj |
                aBlock value: thePathTerm value: nextTraversalObj value: obj.
                self
                  traverse: obj
                  parent: nextTraversalObj
                  thru: aPathTerm
                  startingAt: i + 1
                  do: aBlock ].
            ^ self ]
          ifFalse: [
            nextObj := thePathTerm _nextObjectFor: nextTraversalObj.
            aBlock value: thePathTerm value: nextTraversalObj value: nextObj.
            nil == nextObj
              ifTrue: [ ^ self ].
            nextTraversalObj := nextObj ] ]
%

category: 'Traversing'
method: GsAbstractIndex
traverse: anObject parent: aParent thru: aPathTerm startingAt: anOffset do: aBlock
  ""

  | limit |
  nil == anObject
    ifTrue: [ ^ self ].
  limit := (self indexOfIdentical: aPathTerm).
  ^ self
    traverse: anObject
    parent: aParent
    pathTerm: aPathTerm
    startingAt: anOffset
    limit: limit
    do: aBlock
%

category: 'Traversing'
method: GsAbstractIndex
traverse: anObject parent: aParent upTo: aPathTerm startingAt: anOffset do: aBlock
  ""

  | limit |
  nil == anObject
    ifTrue: [ ^ self ].
  limit := (self indexOfIdentical: aPathTerm) - 1.
  ^ self
    traverse: anObject
    parent: aParent
    pathTerm: aPathTerm
    startingAt: anOffset
    limit: limit
    do: aBlock
%

category: 'Traversing'
method: GsAbstractIndex
traverse: anObject upTo: aPathTerm
  "Traverse the sub-objects of the given object using the path terms of the
 receiver up to the given path term.  This method assumes that the index is not
 over a set-valued instance variable.  For that kind of index, use the
 traverse:upTo:startingAt:into: method."

  | nextObj sz i |
  nil == anObject
    ifTrue: [ ^ anObject ].
  nextObj := anObject.
  sz := self size.
  i := 1.
  [ (self at: i) ~~ aPathTerm and: [ i <= sz ] ]
    whileTrue: [
      nextObj := (self at: i) _getNextObjectForTraversal: nextObj.
      nil == nextObj
        ifTrue: [ ^ nextObj ].
      i := i + 1 ].
  ^ nextObj
%

category: 'Traversing'
method: GsAbstractIndex
traverse: anObject upTo: aPathTerm startingAt: anOffset addingIndex: addingIndex do: aBlock
  "Traverse the sub-objects of anObject, using the path terms of the receiver up
 to the given path term.  Add each object at the end of the traversal to the
 result set.  If addingIndex is true, add an index list entry for the
 receiver to any NSCs encountered along the path; if false, remove an index list entry for the receiver.  Returns the result set."

  self traverse: anObject withRoot: anObject upTo: aPathTerm startingAt: anOffset addingIndex: addingIndex do: aBlock
%

category: 'Traversing'
method: GsAbstractIndex
traverse: anObject withRoot: rootObject upTo: aPathTerm startingAt: anOffset addingIndex: addingIndex do: aBlock
  "Traverse the sub-objects of anObject, using the path terms of the receiver up
 to the given path term.  Add each object at the end of the traversal to the
 result set.  If addingIndex is true, add an index list entry for the
 receiver to any NSCs encountered along the path; if false, remove an index list entry for the receiver.  Returns the result set."

  | nextObj sz i thePathTerm nscOffset |
  nextObj := anObject.
  sz := self size.
  i := anOffset.
  [ (self at: i) ~~ aPathTerm _and: [ i <= sz _and: [ nil ~~ nextObj ] ] ]
    whileTrue: [
      thePathTerm := self at: i.
      thePathTerm indicatesMultiValue
        ifTrue: [
          " if indexing over a collection-based instance variable "
          thePathTerm
            _updateCollectionBasedIndexFor: self
            on: nextObj
            offset: i
            addingIndex: addingIndex.
          nscOffset := i + 1.
          thePathTerm
            nextObj: nextObj
            do: [ :obj |
              " for each object in the collection-based instance variable make recursive call "
              self
                traverse: obj
                withRoot: rootObject
                upTo: aPathTerm
                startingAt: nscOffset
                addingIndex: addingIndex
                do: aBlock ].
          ^ self ]
        ifFalse: [ nextObj := (self at: i) _getNextObjectForTraversal: nextObj ].
      i := i + 1 ].
  i == 1
    ifTrue: [
      "no traversal"
      aBlock value: #'_incompletePathTraversal' value: rootObject.
      ^ self ].
  (nil ~~ nextObj _and: [ aBlock ~~ nil ])
    ifTrue: [ aBlock value: nextObj value: rootObject ].
%

category: 'Traversing'
method: GsAbstractIndex
traverseAllWithParents: anObject parent: theParent upTo: aPathTerm startingAt: anOffset
  "Traverse the sub-objects of the given object using the path terms of the
 receiver up to the given path term. Return an Array of objects. The index
 may be a collection based index."

  | nextObj sz i thePathTerm theResult |
  theResult := {{ theParent. anObject }}.
  nil == anObject
    ifTrue: [ ^ theResult ].
  sz := self size.
  i := anOffset.
  [ thePathTerm := self at: i.
  thePathTerm ~~ aPathTerm and: [ i <= sz ] ]
    whileTrue: [
      theResult do: [ :ar | | nextTraversalObj |
        nextTraversalObj := ar at: 2.
        thePathTerm indicatesMultiValue
          ifTrue: [
            theResult := {}.
            thePathTerm
              nextObj: nextTraversalObj
              do: [ :obj | | result |
                " for each object in the collection-based instance variable make recursive call "
                result := self
                  traverseAllWithParents: obj
                  parent: nextTraversalObj
                  upTo: aPathTerm
                  startingAt: i + 1.
                theResult addAll: result ].
            ^ theResult ]
          ifFalse: [
            nextObj := thePathTerm _nextObjectFor: nextTraversalObj.
            theResult := {{ nextTraversalObj. nextObj }}.
            nil == nextObj
              ifTrue: [ ^ theResult ] ] ].
      i := i + 1 ].
  ^ theResult
%

category: 'Traversing'
method: GsAbstractIndex
traverseAllWithParents: anObject upTo: aPathTerm startingAt: anOffset
  "Traverse the sub-objects of the given object using the path terms of the
 receiver up to the given path term. Return an Array of objects. The index
 may be a collection based index."

 ^ self traverseAllWithParents: anObject parent: nil upTo: aPathTerm startingAt: anOffset
%

category: 'Traversing'
method: GsAbstractIndex
traverseObject: anObject

"Traverse the sub-objects of the given object using the path terms of the
 receiver.  This method assumes that the index is not over a set-valued
 instance variable.  For that kind of index, use the traverse:startingAt:into:
 method.  If a nil value is reached before the end of the path, returns the
 incompletePathTraversal object."

self isIndexOnNscElements
    ifTrue: [ ^ anObject ].

nil == anObject
    ifTrue: [ ^ #_incompletePathTraversal ].

^ self _traverseObject: anObject
%

category: 'Testing'
method: GsAbstractIndex
_canCompare: aKey withClass: aClass
  "Returns whether the receiver can make B-tree comparisons with the given key."


  ^ self btreeRoot _canCompare: aKey withClass: aClass
%

category: 'Testing'
method: GsAbstractIndex
_checkSameIndexOptionsAs: anIndexSpec
  ^ self termsRequired == anIndexSpec requirePathTerms
%

category: 'Testing'
method: GsAbstractIndex
_checkSameLastElementClassAs: indexObj
  ^ indexObj _checkSameLastElementClassAsEqualityIndex: self
%

category: 'Updating'
method: GsAbstractIndex
_clear
  "Assigns nil to important instance variables."

  btreeRoot := nil.
  nscRoot := nil.
  self size: 0
%

category: 'Testing'
method: GsAbstractIndex
_commonPathTermsWith: anEvaluatorOrIndex
  ^ anEvaluatorOrIndex _commonPathTermsWithIndex: self
%

category: 'Testing'
method: GsAbstractIndex
_commonPathTermsWithIndex: anIndex
  | commonSize commonTerms |
  commonSize := self size min: anIndex size.
  commonTerms := {}.
  1 to: commonSize do: [ :index |
    | term |
    (term := (self at: index) name) = (anIndex at: index) name
      ifFalse: [ ^ commonTerms ].
    commonTerms add: term ].
  ^ commonTerms
%

category: 'Indexing Support'
method: GsAbstractIndex
_doPutCommonPathTermsForPathArray: pathArray for: anIndexList

"Find the common path terms that already exist for indexes whose path
 components match pathArray (an Array of Strings).  Adds those path terms to
 the end of receiver.  Do not put a common path term into receiver that
 is the last path term for an existing index."

| firstUnique somePathTerms j minSize sz someSz |
firstUnique := 0.
sz := pathArray size.
1 to: anIndexList size by: 2 do: [ :i |
  j := anIndexList at: i + 1.
  " only consider index objects for which the NSC is the root "
  j == 1
    ifTrue: [
      somePathTerms := anIndexList at: i.
      someSz := somePathTerms size.
      minSize := someSz min: sz.

      [ j <= minSize and:
      [ (somePathTerms at: j) name = (pathArray at: j) ] ] whileTrue: [
        ( j > firstUnique _and:
          [ ( j < someSz )_and: [
              j ~~ sz ] ] )
             ifTrue: [
               firstUnique := j.
               self addLast: (somePathTerms at: j) ].
          j := j + 1 ] ] ].
%

category: 'Searching'
method: GsAbstractIndex
_findFirstUnsharedPathTerm
  "Returns the first path term that is not shared by any other indexes.  This is
 the first path term whose only index is the receiver - which should always be the last term. "

  | pathTerm sz |
  sz := self size.
  1 to: sz do: [ :i |
    pathTerm := self at: i.
    (pathTerm size == 1 and: [ self == (pathTerm at: 1) ])
      ifTrue: [ ^ pathTerm ] ].
  self error: 'no unshared path term found' "should never get here"
%

category: 'Support'
method: GsAbstractIndex
_findSetValuedPathTermOffset
  "Returns the offset of the set-valued path term in the receiver.  If none
 exists, returns 0."

  1 to: self size do: [ :i |
    (self at: i) indicatesMultiValue
      ifTrue: [ ^ i ] ].
  ^ 0
%

category: 'Sorting'
method: GsAbstractIndex
_getObjectsWithNilOnPath

"Returns an Array containing each object that has a nil value along the path."

| array |
" gather the root objects with nil on the path "
array := { } .
self _getObjectsWithNilOnPathInto: array.
^ array

%

category: 'Sorting'
method: GsAbstractIndex
_getObjectsWithNilOnPathInto: anNscBuilderOrArray

"Returns an Array containing each object that has a nil value along the path."

1 to: self size - 1 do: [ :i |
    (self at: i) nilOnPath ifNotNil: [:nilOnPath | anNscBuilderOrArray addAll: nilOnPath ]
].

%

category: 'Testing'
method: GsAbstractIndex
_isIndexObject

"Returns true if the receiver is an index object; returns false otherwise."

^ true
%

category: 'Indexing Support'
method: GsAbstractIndex
_partialPathComponentsStringUpTo: offset

"Returns the path components string up to the given offset."

| str |
str := String new.
1 to: (offset min: self size) do: [ :i |
    str add: (self at: i) name.
    i == offset
        ifFalse: [ str add: $. ]
].
^ str
%

category: 'Index Creation'
method: GsAbstractIndex
_preIndexCreationBuildIndexDictionaryFor: pathArray for: anNsc
  "afford an opportunity to resize dictionary before adding new elements during index creation"

  "noop"

%

category: 'Index Creation'
method: GsAbstractIndex
_preIndexCreationSort
  | btreeRootNode |
  true
    ifTrue: [
      "skip pre-sort for now"
      ^ self btreeRoot ].
  btreeRootNode := (PathSorter on: {self} directions: #(true))
    lastNodeOffset: 1;
    yourself.
  ^ self btreeRoot
    btreeRootNode: btreeRootNode;
    yourself
%

category: 'Removing'
method: GsAbstractIndex
_removeBtreeEntriesForKey: aKey

"Removes all entries in the B-tree that have a key identical to aKey.
 Returns an Array of values corresponding to each entry that was removed."

| stream vals |
" first we need to find all values that have aKey as the key "
stream := self asQueryEvaluator _findAllValuesGreaterThanKey: aKey andEquals: true.
vals := { } .

[ stream _btreeAtEnd not and:
[ stream _peekKey _idxForSortEqualTo: aKey ] ] whileTrue: [
    aKey == stream _peekKey
        ifTrue: [ | val root |
          "remove the entry for the value"
          val := stream _peekValue.
          root := stream _peekRoot.
          vals add: {val. root} ].
    stream _btreeNext
].
" now remove the entry for each value "
vals do: [ :ar |
  (self btreeRemoveKey: aKey value: (ar at: 1) root: (ar at: 2))
].

^ vals
%

category: 'Updating'
method: GsAbstractIndex
_setPathTermState
  "For the last path term, indicate the need to update the B-tree.
   Indicate if the last object along the path needs a dependency list."

  | lastPathTerm |
  lastPathTerm := self at: self size.
  lastPathTerm updateBtree: self
%

category: 'Statistics'
method: GsAbstractIndex
_statisticsInto: dict

"Puts statistical information into the given dictionary."

| arr arr1 arr2 |
arr := dict at: #BtreeSpaceUtilization ifAbsent: [
  dict
    at: #BtreeSpaceUtilization
    put:  { { } . { } }
].

arr1 := arr at: 1.
arr2 := arr at: 2.

btreeRoot _preOrderDo: [ :node |
  arr1 add: node numElements.
  arr2 add: node class maxNumberOfElements.
].
%

category: 'Traversing'
method: GsAbstractIndex
_traverseObject: anObject
  "Traverse the sub-objects of the given object using the path terms of the
 receiver.  This method assumes that the index is not over a set-valued
 instance variable.  For that kind of index, use the traverse:startingAt:into:
 method.  If a nil value is reached before the end of the path, returns the
 incompletePathTraversal object."

  | nextObj sz pathTerm |
  nextObj := anObject.
  sz := self size.
  1 to: sz do: [ :i |
    pathTerm := self at: i.
    nextObj := pathTerm _getNextObjectForTraversal: nextObj.
    (nil == nextObj and: [ i ~~ sz ])
      ifTrue: [ ^ #'_incompletePathTraversal' ] ].
  ^ nextObj
%

category: 'Traversing'
method: GsAbstractIndex
_traverseObject: anObject incompletesInto: incompleteArray incomplete: incomplete
  "Traverse the sub-objects of the given object using the path terms of the
 receiver.  This method assumes that the index is not over a set-valued
 instance variable.  For that kind of index, use the traverse:startingAt:into:
 method.  If a nil value is reached before the end of the path, place the object
 into the appropriate Array in the incompleteArray of Arrays."

  | nextObj sz pathTerm |
  nextObj := anObject.
  sz := self size.
  1 to: sz do: [ :i |
    pathTerm := self at: i.
    nextObj := pathTerm _getNextObjectForTraversal: nextObj.
    (nil == nextObj and: [ i ~~ sz ])
      ifTrue: [
        incompleteArray == nil
          ifTrue: [ ^ nil ].
        (incompleteArray at: i + 1) add: anObject.
        ^ incomplete ] ].
  ^ nextObj
%

category: 'Testing'
method: GsAbstractIndex
_validateCanCompareWith: aKey
  "noop"

%

! Class extensions for 'GsAbstractQueryOptimizer'

!		Class methods for 'GsAbstractQueryOptimizer'

category: 'instance creation'
classmethod: GsAbstractQueryOptimizer
optimize: aFormula on: anNsc options: aGsQueryOptions
  ^ self new
    formula: aFormula;
    nsc: anNsc;
    queryOptions: aGsQueryOptions;
    optimize
%

!		Instance methods for 'GsAbstractQueryOptimizer'

category: 'accessing'
method: GsAbstractQueryOptimizer
collator
  ^ self formula collator
%

category: 'accessing'
method: GsAbstractQueryOptimizer
formula
  ^ formula
%

category: 'accessing'
method: GsAbstractQueryOptimizer
formula: aFormula
  formula := aFormula copy
%

category: 'testing'
method: GsAbstractQueryOptimizer
hasNsc
  ^ nsc ~~ nil
%

category: 'accessing'
method: GsAbstractQueryOptimizer
nsc
  ^ nsc
%

category: 'accessing'
method: GsAbstractQueryOptimizer
nsc: anNsc
  nsc := anNsc
%

category: 'optimizing'
method: GsAbstractQueryOptimizer
optimize
  self subclassResponsibility: #optimize
%

category: 'accessing'
method: GsAbstractQueryOptimizer
queryOptions
  ^ queryOptions
%

category: 'accessing'
method: GsAbstractQueryOptimizer
queryOptions: aGsQueryOptions
  queryOptions := aGsQueryOptions
%

! Class extensions for 'GsAbstractQueryPredicate'

!		Instance methods for 'GsAbstractQueryPredicate'

category: 'visitors'
method: GsAbstractQueryPredicate
acceptVisitor: aFormulaVisitor
  super acceptVisitor: aFormulaVisitor.
  aFormulaVisitor acceptPredicate: self
%

category: 'optimizing'
method: GsAbstractQueryPredicate
applyDeMorgansTransform
  "do not transform, but propagate the transform"

  ^ self
%

category: 'querying-private'
method: GsAbstractQueryPredicate
elementValue: anObject
  "the pathTerms in the query will use anObject as the starting point ... analagous to an object in the nsc that is bound to a query"

  "with a set-valued path term, we may get multiple evaluations of the block ... a value along the path will result in no evaluation of the block"

  self elementValueEvaluator
    traverse: anObject
    do: [ :resolvedObject |
      | res |
      res := self lastElementValue: resolvedObject.
      res
        ifTrue: [ ^ res ] ].
  ^ false
%

category: 'querying-private'
method: GsAbstractQueryPredicate
elementValueEvaluator
  "companion method to #elementValue:"

  "anObject is the value obtained by traversing path terms to the last value ... analgous to the last element class"

  "not all subclasses are required to implement this selector, if they do not implement this selector, then they must implement #elementValue:"

  self subclassResponsibility: #'elementValueEvaluator'
%

category: 'testing'
method: GsAbstractQueryPredicate
isPredicate
  ^ true
%

category: 'querying-private'
method: GsAbstractQueryPredicate
lastElementValue: anObject
  "companion method to #elementValue:"

  "anObject is the value obtained by traversing path terms to the last value ... analgous to the last element class"

  "not all subclasses are required to implement this selector, if they do not implement this selector, then they must implement #elementValue:"

  self subclassResponsibility: #'lastElementValue:'
%

! Class extensions for 'GsAbstractReferenceAssociation'

!		Instance methods for 'GsAbstractReferenceAssociation'

category: 'converting'
method: GsAbstractReferenceAssociation
asFormula
  self subclassResponsibility: #asFormula
%

category: 'converting'
method: GsAbstractReferenceAssociation
asFormulaWithSelectorParts: selectorParts
  ^ GsUnaryClause
    clause: self asFormula
    operator: selectorParts first inputValue asSymbol
%

category: 'converting'
method: GsAbstractReferenceAssociation
asFormulaWithSelectorParts: selectorParts arguments: arguments
  ^ arguments first
    constructFormulaWithSelector: selectorParts first inputValue
    againstConstantReferenceAssoction: self
%

category: 'converting'
method: GsAbstractReferenceAssociation
asReferenceAssociation
  ^ self
%

category: 'converting'
method: GsAbstractReferenceAssociation
asString
    ^ self printString
%

category: 'accessing'
method: GsAbstractReferenceAssociation
bind: variableName to: anObject
  "noop"

%

category: 'private'
method: GsAbstractReferenceAssociation
buildGsQueryParserNodeFor: aGsQueryParser
  aGsQueryParser build: self messages: nil
%

category: 'private'
method: GsAbstractReferenceAssociation
constructFormulaWithSelector: selector againstConstantReferenceAssoction: aConstantReferenceAssociation
  ^ GsConstantConstantPredicate new
    operand1: aConstantReferenceAssociation;
    operator: selector asSymbol;
    operand2: self;
    immediateInvariant
%

category: 'private'
method: GsAbstractReferenceAssociation
constructFormulaWithSelector: selector againstPathReferenceAssoction: aPathReferenceAssociation
  ^ GsPathConstantPredicate new
    path1: aPathReferenceAssociation;
    operator: selector asSymbol;
    operand2: self;
    immediateInvariant
%

category: 'testing'
method: GsAbstractReferenceAssociation
hasEnumeratedTerm
  ^ false
%

category: 'testing'
method: GsAbstractReferenceAssociation
hasSamePathAs: aReferenceAssoc
  ^ false
%

category: 'testing'
method: GsAbstractReferenceAssociation
isBound
  ^ true
%

category: 'printing'
method: GsAbstractReferenceAssociation
printOn: aStream
  aStream nextPutAll: self key asString
%

category: 'accessing'
method: GsAbstractReferenceAssociation
unbind
  "remove all bindings"

  "noop"

%

! Class extensions for 'GsClassicConjunctiveClauseOptimizer'

!		Instance methods for 'GsClassicConjunctiveClauseOptimizer'

category: 'optimizing'
method: GsClassicConjunctiveClauseOptimizer
consolidatePredicates: primaries with: primaryPredicate
  "See if the primaryPredicates can be consolidated with any of the primiaries."

  "see QueryExecuter>>_consolidatePredicatesAt:and:"

  | consolidatedPredicate |
  primaries
    do: [ :secondaryPredicate |
      (secondaryPredicate ~~ nil  and: [ primaryPredicate ~~ secondaryPredicate ])
        ifTrue: [
          (primaryPredicate canConsolidateWith: secondaryPredicate)
            ifTrue: [
              primaries at: (primaries indexOf: secondaryPredicate) put: nil.
              consolidatedPredicate := primaryPredicate
                consolidateWith: secondaryPredicate.
              consolidatedPredicate evaluator: primaryPredicate evaluator1.
              primaries
                at: (primaries indexOf: primaryPredicate)
                put: consolidatedPredicate.
              ^ self ] ] ]
%

category: 'optimizing'
method: GsClassicConjunctiveClauseOptimizer
consolidateRangePredicates
  "See if any predicates can be consolidated (i.e. can be satisfied
	with a single lookup using a range predicate)."

  "see QueryExecuter>>_consolidatePredicatesAt:and:"

  | primaries |
  primaries := self predicates copy.
  1 to: primaries size do: [ :index |
    (primaries at: index)
      ifNotNil: [ :primaryPredicate | self consolidatePredicates: primaries with: primaryPredicate ] ].
  predicates := primaries select: [ :each | each ~~ nil  ]
%

category: 'optimizing'
method: GsClassicConjunctiveClauseOptimizer
consolidateUnaryConstantPredicates
  "Simplify formulas involving predicates that are unary-constant (true or false) or
   constant-constant. The predicate is removed, or the expression is consolidated."

  | otherPredicates truePredicate falsePredicate |
  self predicates size <= 1
    ifTrue: [
      "a single predicate ... no more optimization called for"
      ^ self ].
  truePredicate := falsePredicate := nil.
  otherPredicates := OrderedCollection new.
  self predicates
    do: [ :predicate |
      (predicate isConstantConstant and: [ predicate isConstantBound ])
        ifTrue: [
          predicate executePredicate
            ifTrue: [ truePredicate := predicate ]
            ifFalse: [ falsePredicate := predicate ] ]
        ifFalse: [ otherPredicates add: predicate ] ].
  falsePredicate
    ifNotNil: [ predicates := {falsePredicate} ]
    ifNil: [ truePredicate ifNotNil: [ predicates := otherPredicates ] ]
%

category: 'optimizing'
method: GsClassicConjunctiveClauseOptimizer
normalizePredicates
  predicates := self predicates
    collect: [ :each |
      "normalize predicates to make simplify analysis"
      each normalize ]
%

category: 'optimizing'
method: GsClassicConjunctiveClauseOptimizer
removeRedundantPredicates
  "see QueryExecuter>>_removeRedundantOperatorsAt:and:"

  | primaries |
  [
  primaries := self predicates copy.
  1 to: primaries size do: [ :index |
    (primaries at: index)
      ifNotNil: [ :primaryPredicate | self removeRedundantPredicates: primaries with: primaryPredicate ] ].
  predicates := primaries select: [ :each | each ~~ nil  ] ]
    on: GsUnsatisfiableQueryNotification
    do: [ :note |
      "short circuit analysis and replace whole enchilada with a `false` predicate"
      predicates := OrderedCollection with: (GsQueryPredicate constant: false).
      ^ self ]
%

category: 'optimizing'
method: GsClassicConjunctiveClauseOptimizer
removeRedundantPredicates: primaries with: primaryPredicate
  "see QueryExecuter>>_removeRedundantOperatorsAt:and:"

  primaries
    do: [ :secondaryPredicate |
      (secondaryPredicate ~~ nil  and: [ primaryPredicate ~~ secondaryPredicate ])
        ifTrue: [
          (primaryPredicate redundantPredicateBetween: secondaryPredicate)
            ifNotNil: [ :redundantPredicate | primaries at: (primaries indexOf: redundantPredicate) put: nil ] ] ]
%

category: 'optimizing'
method: GsClassicConjunctiveClauseOptimizer
reorderPredicates
  | constList identList equalList otherList indexList |
  self predicates size < 2
    ifTrue: [ ^ self ].
  constList := {}.
  identList := {}.
  equalList := {}.
  otherList := {}.
  indexList := {}.
  self predicates
    do: [ :each |
      " if it is constant-constant "
      each isConstantConstant
        ifTrue: [ constList addLast: each ]
        ifFalse: [
          " if an index exists on the path and it is not path-path "
          (each isPathPath not and: [ each usesPathEvaluator not ])
            ifTrue: [ indexList addLast: each ]
            ifFalse: [
              " if it is an identity operation (== or ~~) "
              each usesIdentityOperation
                ifTrue: [ identList addLast: each ]
                ifFalse: [
                  " if operation is = or ~= "
                  each usesEqualityOperation
                    ifTrue: [ equalList addLast: each ]
                    ifFalse: [ otherList addLast: each ] ] ] ] ].
  predicates := OrderedCollection new.
  1 to: constList size do: [ :i | predicates addLast: (constList at: i) ].
  1 to: indexList size do: [ :i | predicates addLast: (indexList at: i) ].
  1 to: identList size do: [ :i | predicates addLast: (identList at: i) ].
  1 to: equalList size do: [ :i | predicates addLast: (equalList at: i) ].
  1 to: otherList size do: [ :i | predicates addLast: (otherList at: i) ]
%

category: 'optimizing'
method: GsClassicConjunctiveClauseOptimizer
runOptimizations
  self queryOptions transformCommonPaths
    ifTrue: [ self transformCommonPaths ].
  self queryOptions normalizePredicates
    ifTrue: [ self normalizePredicates ].
  self queryOptions removeRedundantPredicates
    ifTrue: [ self removeRedundantPredicates ].
  self queryOptions consolidateRangePredicates
    ifTrue: [ self consolidateRangePredicates ].
  self queryOptions consolidateUnaryConstantPredicates
    ifTrue: [ self consolidateUnaryConstantPredicates ].
  self queryOptions reorderPredicates
    ifTrue: [ self reorderPredicates ]
%

category: 'optimizing'
method: GsClassicConjunctiveClauseOptimizer
transformCommonPaths
  "see QueryExecuter>>_checkPathPathAt:"

  predicates := self predicates collect: [ :each | each transformCommonPaths ]
%

! Class extensions for 'GsClassicQueryBlockOptimizer'

!		Instance methods for 'GsClassicQueryBlockOptimizer'

category: 'visiting'
method: GsClassicQueryBlockOptimizer
acceptCompoundClause: aCompoundClause
  "replace conjunctive normal form clauses with optimized equivalent"

  aCompoundClause clause1 isConjunctiveNormalForm
    ifTrue: [
      aCompoundClause
        clause1: (self optimizeConjunctiveNormalClause: aCompoundClause clause1) ].
  aCompoundClause clause2 isConjunctiveNormalForm
    ifTrue: [
      aCompoundClause
        clause2: (self optimizeConjunctiveNormalClause: aCompoundClause clause2) ].
  super acceptCompoundClause: aCompoundClause
%

category: 'visiting'
method: GsClassicQueryBlockOptimizer
acceptUnaryClause: aUnaryClause
  | clause |
  self queryOptions applyDeMorgansLaws
    ifTrue: [ self applyDeMorgansLaws: aUnaryClause ].
  clause := aUnaryClause clause.
  clause isConjunctiveNormalForm
    ifTrue: [ clause := self optimizeConjunctiveNormalClause: clause ].
  aUnaryClause clause: clause.
  super acceptUnaryClause: aUnaryClause
%

category: 'optimizing'
method: GsClassicQueryBlockOptimizer
applyDeMorgansLaws: aClause
  ^ aClause applyDeMorgansTransform
%

category: 'optimizing'
method: GsClassicQueryBlockOptimizer
optimize
  | formulaCopy optimizedFormula |
  formulaCopy := self formula copy.
  optimizedFormula := formulaCopy isConjunctiveNormalForm
    ifTrue: [ self optimizeConjunctiveNormalClause: formulaCopy ]
    ifFalse: [
      self queryOptions applyDeMorgansLaws
        ifTrue: [
          formulaCopy := self applyDeMorgansLaws: formulaCopy.
          formulaCopy isConjunctiveNormalForm
            ifTrue: [ self optimizeConjunctiveNormalClause: formulaCopy ]
            ifFalse: [ self visitFormula: formulaCopy ] ]
        ifFalse: [ self visitFormula: formulaCopy ] ].
  ^ optimizedFormula immediateInvariant
%

category: 'optimizing'
method: GsClassicQueryBlockOptimizer
optimizeConjunctiveNormalClause: aClause
  ^ (GsClassicConjunctiveClauseOptimizer
    optimize: aClause
    on: self nsc
    options: self queryOptions) copy
%

! Class extensions for 'GsClauseOptimizer'

!		Instance methods for 'GsClauseOptimizer'

category: 'visiting'
method: GsClauseOptimizer
acceptPredicate: aPredicate
  self predicates add: aPredicate
%

category: 'accessing'
method: GsClauseOptimizer
nsc: anNsc
  super nsc: anNsc.
  nsc
    ifNotNil: [ formula := formula bindEvaluatorsFor: anNsc collator: self collator ]
%

category: 'optimizing'
method: GsClauseOptimizer
optimize
  self visitFormula: self formula.
  self runOptimizations.
  ^ self predicatesAsFormula
%

category: 'accessing'
method: GsClauseOptimizer
predicates
  predicates ifNil: [ predicates := OrderedCollection new ].
  ^ predicates
%

category: 'accessing'
method: GsClauseOptimizer
predicatesAsFormula
  | newFormula |
  newFormula := (predicates at: 1) copy.
  2 to: predicates size do: [ :index | newFormula := newFormula & (predicates at: index) copy ].
  ^ (newFormula bindEvaluatorsFor: self nsc collator: self collator)
    immediateInvariant
%

category: 'optimizing'
method: GsClauseOptimizer
runOptimizations
  "noop"

%

! Class extensions for 'GsCollectionBasedPathTerm'

!		Instance methods for 'GsCollectionBasedPathTerm'

category: 'Updating Indexes'
method: GsCollectionBasedPathTerm
cleanupDependencyListFor: anNsc
  ""

  self subclassResponsibility: #'cleanupDependencyListFor:'
%

category: 'Modification'
method: GsCollectionBasedPathTerm
findRootObjectsForKey: aKey value: aValue
 ^true ifTrue: [super findRootObjectsForKey: aKey value: aValue]
ifFalse: [  updateBtree findRootObjectsComparingForKey: aKey value: aValue]
%

category: 'Testing'
method: GsCollectionBasedPathTerm
indicatesMultiValue
  "Returns true, the receiver indicates that the index is on an
 instance variable that may have multiple values (i.e., collection based path term)"

  ^ true
%

category: 'Accessing'
method: GsCollectionBasedPathTerm
nextObj: anObj do: aBlock
  self subclassResponsibility: #'nextObj:do:'
%

category: 'Accessing'
method: GsCollectionBasedPathTerm
_nextObjectFor: anObject
  "Cannot use this shortcut method"

  self shouldNotImplement: #'_nextObjectFor:'
%

category: 'Testing'
method: GsCollectionBasedPathTerm
_totalNumSetValuedTerms
  "for use of AddMappingsForObject:root:logging: in UnorderedCollection>>_updateIndexesForAdditionOf:logging:"

  ^ 3
%

category: 'Indexing Support'
method: GsCollectionBasedPathTerm
_updateCollectionBasedIndexFor: anIndex on: anNsc offset: anOffset addingIndex: addingIndex
  "noop by default"


%

! Class extensions for 'GsCompoundClause'

!		Class methods for 'GsCompoundClause'

category: 'instance creation'
classmethod: GsCompoundClause
clause: clause1 operator: anOperator clause: clause2
  | res |
  (res := self new)
    clause1: clause1;
    operator: anOperator;
    clause2: clause2 .
  ^ res
%

!		Instance methods for 'GsCompoundClause'

category: 'visiting'
method: GsCompoundClause
acceptVisitor: aFormulaVisitor
  super acceptVisitor: aFormulaVisitor.
  aFormulaVisitor acceptCompoundClause: self
%

category: 'optimizing'
method: GsCompoundClause
applyDeMorgansNegationTransform
  "actively apply De Morgan's laws ... operating on copy"

  self clause1: self clause1 applyDeMorgansNegationTransform.
  self operator: self operatorNegated.
  self clause2: self clause2 applyDeMorgansNegationTransform
%

category: 'optimizing'
method: GsCompoundClause
applyDeMorgansTransform
  "do not transform, but propagate the transform ... operating on copy"

  self clause1: self clause1 applyDeMorgansTransform.
  self clause2: self clause2 applyDeMorgansTransform.
  ^ self
%

category: 'converting'
method: GsCompoundClause
asFormulaWithSelectorParts: selectorParts arguments: arguments
  | selector |
  selector := selectorParts first inputValue asSymbol.
  ^ self perform: selector with: arguments first
%

category: 'transforming'
method: GsCompoundClause
bind: variableName to: value
  | bound |
  bound := self copy.
  bound clause1: (bound clause1 bind: variableName to: value).
  bound clause2: (bound clause2 bind: variableName to: value).
  ^ bound immediateInvariant
%

category: 'private'
method: GsCompoundClause
bindEvaluators
  clause1 := clause1 bindEvaluatorsFor: nsc collator: self collator.
  clause2 := clause2 bindEvaluatorsFor: nsc collator: self collator.
  super bindEvaluators
%

category: 'private'
method: GsCompoundClause
bruteThreshold
  "number of elements in result set where brute force query is cheaper than using index."

  ^ 1000
%

category: 'accessing'
method: GsCompoundClause
clause1
  ^ clause1
%

category: 'accessing'
method: GsCompoundClause
clause1: newValue
  clause1 := newValue
%

category: 'accessing'
method: GsCompoundClause
clause2
  ^ clause2
%

category: 'accessing'
method: GsCompoundClause
clause2: newValue
  clause2 := newValue
%

category: 'querying-private'
method: GsCompoundClause
elementValue: anObject
  "the pathTerms in the query will use anObject as the starting point ... analagous to an object in the nsc that is bound to a query"

  ^ (self clause1 elementValue: anObject)
    perform: self operator
    with: (self clause2 elementValue: anObject)
%

category: 'querying'
method: GsCompoundClause
executeAndDo: aBlock
  | preparedClause2 |
  preparedClause2 := self clause2 prepareForExecution.
  self operator == #'&'
    ifTrue: [
      self clause1
        executeAndDo: [ :obj |
          (preparedClause2 elementValue: obj)
            ifTrue: [ aBlock value: obj ] ] ]
    ifFalse: [
      | preparedClause1 |
      preparedClause1 := self clause1 prepareForExecution.
      self _nsc
        do: [ :obj |
          (preparedClause1 elementValue: obj)
            ifTrue: [ aBlock value: obj ]
            ifFalse: [
              (preparedClause2 elementValue: obj)
                ifTrue: [ aBlock value: obj ] ] ] ]
%

category: 'querying-private'
method: GsCompoundClause
executeClause
  ^ self executeClauseUsing: self operator
%

category: 'querying-private'
method: GsCompoundClause
executeClauseNegated
  | intermediateResult |
  intermediateResult := self clause1 executeClauseNegated.
  intermediateResult isEmpty
    ifTrue: [
      self operatorNegated == #'&'
        ifTrue: [ ^ intermediateResult ]
        ifFalse: [ ^ self clause2 executeClauseNegated ] ].
  ^ (self operatorNegated == #'&'
    and: [
      intermediateResult size < self bruteThreshold
        or: [ self clause2 usesPathEvaluatorForFirstClause ] ])
    ifTrue: [
      "Evaluate clause2 against intermediateResult when performing an #& and intermediateResult size
       is less than 1000. Otherwise it is more efficient to use an index for clause2."
      self clause2 executeClauseNegatedOn: intermediateResult ]
    ifFalse: [
      intermediateResult
        perform: (self resultOperatorFor: self operatorNegated)
        with: self clause2 executeClauseNegated ]
%

category: 'querying-private'
method: GsCompoundClause
executeClauseUsing: anOperator
  | intermediateResult |
  intermediateResult := self clause1 executeClause.
  intermediateResult isEmpty
    ifTrue: [
      anOperator == #'&'
        ifTrue: [ ^ intermediateResult ]
        ifFalse: [ ^ self clause2 executeClause ] ].
  ^ (anOperator == #'&'
    and: [
      intermediateResult size < self bruteThreshold
        or: [ self clause2 usesPathEvaluatorForFirstClause ] ])
    ifTrue: [
      "Evaluate clause2 against intermediateResult when performing an #& and intermediateResult size
       is less than 1000. Otherwise it is more efficient to use an index for clause2."
      self clause2 executeClauseOn: intermediateResult ]
    ifFalse: [
      intermediateResult
        perform: (self resultOperatorFor: anOperator)
        with: self clause2 executeClause ]
%

category: 'querying-private'
method: GsCompoundClause
executeNegatedAndDo: aBlock
  | preparedClause2 |
  preparedClause2 := self clause2 prepareForExecution.
  self operatorNegated == #'&'
    ifTrue: [
      self clause1
        executeNegatedAndDo: [ :obj |
          (preparedClause2 elementValue: obj)
            ifFalse: [ aBlock value: obj ] ] ]
    ifFalse: [
      | preparedClause1 |
      preparedClause1 := self clause1 prepareForExecution.
      self _nsc
        do: [ :obj |
          (preparedClause1 elementValue: obj)
            ifTrue: [
              (preparedClause2 elementValue: obj)
                ifFalse: [ aBlock value: obj ] ]
            ifFalse: [ aBlock value: obj ] ] ]
%

category: 'private'
method: GsCompoundClause
immediateInvariant
  super immediateInvariant.
  clause1 immediateInvariant.
  clause2 immediateInvariant
%

category: 'testing'
method: GsCompoundClause
isCompoundPredicate
  ^ true
%

category: 'testing'
method: GsCompoundClause
isConjunctiveNormalForm
  ^ self operator == #'&'
    and: [
      self clause1 isConjunctiveNormalForm
        and: [ self clause2 isConjunctiveNormalForm ] ]
%

category: 'testing'
method: GsCompoundClause
isDisjunctiveClause
  ^ self operator == #'|'
%

category: 'testing'
method: GsCompoundClause
isDisjunctiveNormalForm
  ^ self operator == #'|'
    and: [
      self clause1 isDisjunctiveNormalForm
        and: [ self clause2 isDisjunctiveNormalForm ] ]
%

category: 'operators'
method: GsCompoundClause
normalize
  | normalized |
  normalized := super normalize.
  normalized clause1: clause1 normalize.
  normalized clause2: clause2 normalize
%

category: 'accessing'
method: GsCompoundClause
operator
  ^operator
%

category: 'accessing'
method: GsCompoundClause
operator: aSymbol
  operator := aSymbol
%

category: 'accessing'
method: GsCompoundClause
operatorNegated
  ^ operator == #'&'
    ifTrue: [ #'|' ]
    ifFalse: [ #'&' ]
%

category: 'private'
method: GsCompoundClause
postCopy
  clause1 := clause1 copy.
  clause2 := clause2 copy.
  super postCopy
%

category: 'printing'
method: GsCompoundClause
printOn: aStream
  | parenthesizeClause |
  aStream nextPutAll: self clause1 printString.
  aStream nextPutAll: ' ' , self operator asString , ' '.
  parenthesizeClause := self clause2 isCompoundPredicate.
  parenthesizeClause
    ifTrue: [ aStream nextPut: $( ].
  aStream nextPutAll: self clause2 printString.
  parenthesizeClause
    ifTrue: [ aStream nextPut: $) ]
%

category: 'accessing'
method: GsCompoundClause
resultOperatorFor: anOperator
  ^ anOperator == #'&'
    ifTrue: [
      "intersection"
      #'*' ]
    ifFalse: [
      "minimal union"
      #'_union:' ]
%

category: 'transforming'
method: GsCompoundClause
unbind
  "remove all bindings"

  | unbound |
  unbound := super unbind.
  unbound clause1: unbound clause1 unbind.
  unbound clause2: unbound clause2 unbind.
  ^ unbound immediateInvariant
%

category: 'testing'
method: GsCompoundClause
usesPathEvaluator
  ^ self clause1 usesPathEvaluator and: [ self clause2 usesPathEvaluator ]
%

category: 'testing'
method: GsCompoundClause
usesPathEvaluatorForFirstClause
  ^ self clause1 usesPathEvaluatorForFirstClause
%

category: 'private'
method: GsCompoundClause
_predicateAndEvaluatorsDo: aBlock
  "visit all predicates in receiver and provide access to predicate and list of evaluators
   for the predicate"

  super _predicateAndEvaluatorsDo: aBlock.
  self clause1 _predicateAndEvaluatorsDo: aBlock.
  self clause2 _predicateAndEvaluatorsDo: aBlock
%

category: 'testing'
method: GsCompoundClause
_queryUsesIdentityIndex
  "answer true if the one or more of the clauses has an evaluator that is an range or identity index"

  ^ clause1 _queryUsesIdentityIndex or: [ clause2 _queryUsesIdentityIndex ]
%

category: 'testing'
method: GsCompoundClause
_queryUsesIndex
  "answer true if the one or more of the clauses has an evaluator that is a range or identity index"

  ^ clause1 _queryUsesIndex or: [ clause2 _queryUsesIndex ]
%

! Class extensions for 'GsConjunctiveClauseConjoinSetChecker'

!		Class methods for 'GsConjunctiveClauseConjoinSetChecker'

category: 'instance creation'
classmethod: GsConjunctiveClauseConjoinSetChecker
check: aFormula on: anNsc
  ^ self new
    formula: aFormula;
    nsc: anNsc;
    queryOptions: GsQueryOptions default;
    check
%

!		Instance methods for 'GsConjunctiveClauseConjoinSetChecker'

category: 'visiting'
method: GsConjunctiveClauseConjoinSetChecker
acceptPredicate: aPredicate
  "collect all predicates which use comparison operators, are not range predicates and have
   a collection based term"

  (aPredicate usesComparisonOperation not or: [ aPredicate usesRangeOperation ])
    ifTrue: [
      "not exposed to bug43764"
      ^ self ].
  aPredicate _evaluators
    detect: [ :evaluator | evaluator hasCollectionBasedTerm ]
    ifNone: [
      "not exposed to bug43764"
      ^ self ].
  super acceptPredicate: aPredicate
%

category: 'checking'
method: GsConjunctiveClauseConjoinSetChecker
check
  "collect all predicates which use comparison operators, are not range predicates and have
   a collection based term in common with another predicate"

  | collectionBasedEvaluators commonPathTerms |
  self visitFormula: self formula.
  collectionBasedEvaluators := {}.
  self predicates
    do: [ :predicate |
      collectionBasedEvaluators
        addAll:
          (predicate _evaluators select: [ :each | each hasCollectionBasedTerm ]) ].
  collectionBasedEvaluators size <= 1
    ifTrue: [
      "not exposed"
      ^ self ].
  1 to: collectionBasedEvaluators size do: [ :outerIndex |
    | outerEvaluator |
    outerEvaluator := collectionBasedEvaluators at: outerIndex.
    1 to: collectionBasedEvaluators size do: [ :innerIndex |
      | innerEvaluator |
      innerEvaluator := collectionBasedEvaluators at: innerIndex.
      innerIndex == outerIndex
        ifFalse: [
          "see if there are common terms"
          commonPathTerms := innerEvaluator _commonPathTermsWith: outerEvaluator.
          (commonPathTerms includes: #'*')
            ifTrue: [
              "Cannot evaluate a formula where two conjoined predicates are collection based"
              ^ self
                _errorMalformedQuery: commonPathTerms
                senderLocationID: #'check' ].
          commonPathTerms
            do: [ :term |
              (term includes: $|)
                ifTrue: [
                  "Cannot evaluate a formula where two conjoined predicates are collection based"
                  ^ self
                    _errorMalformedQuery: commonPathTerms
                    senderLocationID: #'check' ] ] ] ] ]
%

category: 'private'
method: GsConjunctiveClauseConjoinSetChecker
_errorMalformedQuery: commonPathTerms senderLocationID: senderLocationID
  | str |
  str := commonPathTerms at: 1.
  2 to: commonPathTerms size do: [ :index | str := str , '.' , (commonPathTerms at: index) ].
  ^ GsMalformedQueryExpressionError
    bug43764MalformedQuery:
      str printString , ' in clause ' , self formula printString
    senderLocationID: senderLocationID
%

! Class extensions for 'GsConstantConstantPredicate'

!		Instance methods for 'GsConstantConstantPredicate'

category: 'transforming'
method: GsConstantConstantPredicate
bind: variableName to: value
  ^ self operator == #'unary'
    ifTrue: [
      | bound |
      bound := self copy.
      bound operand1: (bound operand1 bind: variableName to: value).
      ^ bound immediateInvariant ]
    ifFalse: [ super bind: variableName to: value ]
%

category: 'querying-private'
method: GsConstantConstantPredicate
elementValue: anObject
  "the pathTerms in the query will use anObject as the starting point ... analagous to an object in the nsc that is bound to a query"

  ^ self executePredicate
%

category: 'querying'
method: GsConstantConstantPredicate
executeAndDo: aBlock
  self executePredicate
    ifTrue: [ nsc do: aBlock ]
%

category: 'querying-private'
method: GsConstantConstantPredicate
executeClause
  ^ self executePredicate
    ifTrue: [ nsc ]
    ifFalse: [ nsc species new ]
%

category: 'querying-private'
method: GsConstantConstantPredicate
executeClauseNegated
  self executePredicateNegated
    ifTrue: [ ^ nsc ]
    ifFalse: [ ^ nsc species new ]
%

category: 'querying-private'
method: GsConstantConstantPredicate
executeNegatedAndDo: aBlock
  self executePredicateNegated
    ifTrue: [ nsc do: aBlock ]
%

category: 'querying-private'
method: GsConstantConstantPredicate
executePredicate
  ^ self operator == #'unary'
    ifTrue: [ self operand1 _idxValue ]
    ifFalse: [
      self operand1 _idxValue
        perform: (self comparisonSelectorFor: self operator)
        with: self operand2 _idxValue ]
%

category: 'querying-private'
method: GsConstantConstantPredicate
executePredicateNegated
  ^ self operator == #'unary'
    ifTrue: [ self operand1 _idxValue not ]
    ifFalse: [ self operand1 _idxValue perform: self operatorNegated with: self operand2 _idxValue ]
%

category: 'testing'
method: GsConstantConstantPredicate
isConstantBound
  self operator == #'unary'
    ifTrue: [ ^ self operand1 isBound ].
  ^ self operand1 isBound and: [ self operand2 isBound ]
%

category: 'testing'
method: GsConstantConstantPredicate
isConstantConstant
  ^ true
%

category: 'printing'
method: GsConstantConstantPredicate
printOn: aStream
  self operator ~~ #'unary'
    ifTrue: [ ^ super printOn: aStream ].
  aStream nextPutAll: '( ' , self operand1 key asString , ' )'
%

category: 'querying'
method: GsConstantConstantPredicate
readStream
  self shouldNotImplement: #'readStream'
%

category: 'private'
method: GsConstantConstantPredicate
_evaluators
  "return list of evaluators associated with predicate"

  ^ #()
%

category: 'initialization'
method: GsConstantConstantPredicate
_fromArray: varsArray terms: termsArray links: linksArray paths: pathsArray startingAt: i
  self constant1: (varsArray at: (termsArray at: i + 5)).
  operator := self operationSelectors at: (termsArray at: i) + 1.
  self constant2: (varsArray at: (termsArray at: i + 2))
%

! Class extensions for 'GsConstantPathPredicate'

!		Class methods for 'GsConstantPathPredicate'

category: 'instance creation'
classmethod: GsConstantPathPredicate
constant: operand1 operator: operator path: operand2
  | res |
  (res := self new)
    constant1: operand1;
    operator: operator;
    path2: operand2 .
  ^ res
%

!		Instance methods for 'GsConstantPathPredicate'

category: 'private'
method: GsConstantPathPredicate
bindEvaluators
  evaluator1 := self
    _bindEvaluator: nsc
    for: self path
    isRangeEqualityOperation: (self isRangeEqualityOperation: self operator).
  super bindEvaluators
%

category: 'transforming'
method: GsConstantPathPredicate
collapseToRangePredicateIfPossible: aPathXPredicate
  ^ aPathXPredicate collapseToRangePredicateForConstantPathPredicate: self
%

category: 'accessing'
method: GsConstantPathPredicate
constant
  ^ self operand1 _idxValue
%

category: 'accessing'
method: GsConstantPathPredicate
evaluator
  ^ evaluator1
%

category: 'querying'
method: GsConstantPathPredicate
executeAndDo: aBlock
  ^ self executeAndDo: aBlock using: self operator
%

category: 'querying-private'
method: GsConstantPathPredicate
executeAndDo: aBlock using: anOperator
  | queryEvaluator |
  queryEvaluator := self evaluator1 asQueryEvaluator.
  queryEvaluator doBlock: aBlock.
  ^ self executeClauseUsing: anOperator queryEvaluator: queryEvaluator
%

category: 'querying-private'
method: GsConstantPathPredicate
executeClause
  ^ self executeClauseUsing: self operator
%

category: 'querying-private'
method: GsConstantPathPredicate
executeClauseNegated
  ^ self executeClauseUsing: self operatorNegated
%

category: 'querying-private'
method: GsConstantPathPredicate
executeClauseUsing: anOperator
  | queryEvaluator |
  queryEvaluator := self evaluator1 asQueryEvaluator.
  ^ self executeClauseUsing: anOperator queryEvaluator: queryEvaluator
%

category: 'querying-private'
method: GsConstantPathPredicate
executeClauseUsing: anOperator queryEvaluator: queryEvaluator
  | invertedOperator |
  invertedOperator := self inverseOperatorFor: anOperator.
  self _check: self evaluator1 compare: invertedOperator value: self constant.
  (invertedOperator == #'<' or: [ invertedOperator == #'<=' ])
    ifTrue: [
      (self constant == nil and: [ invertedOperator == #'<=' ])
        ifTrue: [ ^ queryEvaluator findAllValuesEqualTo: nil ]
        ifFalse: [
          ^ queryEvaluator
            findAllValuesLessThanKey: self constant
            andEquals: invertedOperator == #'<=' ] ].
  (invertedOperator == #'>' or: [ invertedOperator == #'>=' ])
    ifTrue: [
      (self constant == nil and: [ invertedOperator == #'>=' ])
        ifTrue: [ ^ queryEvaluator findAllValuesEqualTo: nil ]
        ifFalse: [
          ^ queryEvaluator
            findAllValuesGreaterThanKey: self constant
            andEquals: invertedOperator == #'>=' ] ].
  invertedOperator == #'='
    ifTrue: [ ^ queryEvaluator findAllValuesEqualTo: self constant ].
  invertedOperator == #'~='
    ifTrue: [ ^ queryEvaluator findAllValuesNotEqualTo: self constant ].
  invertedOperator == #'=='
    ifTrue: [ ^ queryEvaluator findAllValuesIdenticalTo: self constant ].
  invertedOperator == #'~~'
    ifTrue: [ ^ queryEvaluator findAllValuesNotIdenticalTo: self constant ]
%

category: 'querying-private'
method: GsConstantPathPredicate
executeNegatedAndDo: aBlock
  ^ self executeAndDo: aBlock using: self operatorNegated
%

category: 'testing'
method: GsConstantPathPredicate
isConstantBound
  ^ self operand1 isBound
%

category: 'querying-private'
method: GsConstantPathPredicate
lastElementValue: anObject
  "anObject is the value obtained by traversing path terms to the last value ... analgous to the last element class"

  ^ self constant
    perform: (self comparisonSelectorFor: self operator)
    with: anObject
%

category: 'operators'
method: GsConstantPathPredicate
normalize
  | res |
  (res := GsPathConstantPredicate new)
    operand1: self operand2 copy;
    evaluator1: self evaluator1;
    operator: (self inverseOperatorFor: self operator);
    operand2: self operand1 copy .
  ^ res
%

category: 'testing'
method: GsConstantPathPredicate
operand2IsPath
  ^ true
%

category: 'accessing'
method: GsConstantPathPredicate
rawPath
  ^ self operand2
%

category: 'initialization'
method: GsConstantPathPredicate
_fromArray: varsArray terms: termsArray links: linksArray paths: pathsArray startingAt: i
  self constant1: (varsArray at: (termsArray at: i + 5)).
  operator := self operationSelectors at: (termsArray at: i) + 1.
  self
    path2:
      (self _pathFrom: linksArray paths: pathsArray offset: (termsArray at: i + 3))
%

! Class extensions for 'GsConstantReferenceAssociation'

!		Instance methods for 'GsConstantReferenceAssociation'

category: 'printing'
method: GsConstantReferenceAssociation
printOn: aStream
  aStream nextPutAll: self value printString
%

! Class extensions for 'GsConstrainedCharacterCollectionIndex'

!		Class methods for 'GsConstrainedCharacterCollectionIndex'

category: 'instance creation'
classmethod: GsConstrainedCharacterCollectionIndex
newWithCollator: anIcuCollatorOrNil
  "Create a new instance and initialize its B-tree root."

  | newOne |
  newOne := super new.
  newOne collator: anIcuCollatorOrNil.
  ^ newOne
%

category: 'instance creation'
classmethod: GsConstrainedCharacterCollectionIndex
newWithLastElementClass: aClass
  self shouldNotImplement: #'newWithLastElementClass:'
%

!		Instance methods for 'GsConstrainedCharacterCollectionIndex'

category: 'conversion'
method: GsConstrainedCharacterCollectionIndex
asIndexSpecification
  ^ (ConstrainedCharacterCollectionIndexSpecification
    path: self pathComponentsString
    collator: self collator)
    options: self options;
    constraintType: self constraintType;
    yourself
%

category: 'Accessing'
method: GsConstrainedCharacterCollectionIndex
collator
  "Returns IcuCollator to be used when comparing Unicode strings. collator may be nil."

  ^ collator
%

category: 'Accessing'
method: GsConstrainedCharacterCollectionIndex
collator: anIcuCollatorOrNil
  "Set the receiver's collator. Use a copy of anIcuCollator to disallow
   changes to strength, etc, that might affect the sort ordering. "

  anIcuCollatorOrNil
    ifNil: [ collator := nil ]
    ifNotNil: [ collator := anIcuCollatorOrNil copy immediateInvariant ]
%

category: 'Comparison Operators'
method: GsConstrainedCharacterCollectionIndex
comparisonForCompare
  collator
    ifNil: [ ^ super comparisonForCompare ].
  ^ BtreeOptimizedUnicodeComparison new
      collator: self collator;
      yourself
%

category: 'Comparison Operators'
method: GsConstrainedCharacterCollectionIndex
comparisonForSort
  "called during creation of receiver, so initialize unset instance variables"

  ^ comparisonForSort
      ifNil: [
        (self constraintType == #symbol and: [ collator isNil ])
          ifTrue: [
            "use unicode collation for Symbols, so that Symbols with NUL bytes handled
             correctly. See bug 47116."
            self collator: IcuCollator default ].
        collator
          ifNil: [ comparisonForSort := self comparisonForCompare ]
          ifNotNil: [
            comparisonForSort := BtreeOptimizedUnicodeComparison new
            collator: self collator;
            yourself ] ]
%

category: 'Accessing'
method: GsConstrainedCharacterCollectionIndex
constraintType
  "Returns the constraintType, either #string or #symbol."

  ^ constraintType
%

category: 'Accessing'
method: GsConstrainedCharacterCollectionIndex
constraintType: aSymbol
  "Set the constraintType, either #string or #symbol."

  (aSymbol ~~ #string and: [ aSymbol ~~ #symbol ])
    ifTrue: [ ArgumentError signal: self class name asString, ' constraintType must #string or #symbol.'].
  constraintType := aSymbol
%

category: 'Accessing'
method: GsConstrainedCharacterCollectionIndex
lastElementClass
  ^ CharacterCollection
%

category: 'Accessing'
method: GsConstrainedCharacterCollectionIndex
lastElementClassDescription
  "answer a description of the lastElementClass of the receiver,
   suitable for use in an error message"

  ^ self constraintType == #string
    ifTrue: [ 'String, DoubleByeString, or QuadByteString with optimizedComparison' ]
    ifFalse: [
      "self constraintType == #symbol"
      'Symbol, DoubleByeSymbol, or QuadByteSymbol with optimizedComparison' ].
%

category: 'Testing'
method: GsConstrainedCharacterCollectionIndex
optimizingComparison
  "optimizedComparison option is uncoditionally true"

  ^ true
%

category: 'Testing'
method: GsConstrainedCharacterCollectionIndex
_canCompareWith: aKey
  "Returns whether the receiver can make B-tree comparisons with the given key."

  (self constraintType == #string or: [ self constraintType == #unicodeString ])
    ifTrue: [
      | keyClass |
      keyClass := aKey class.
      (aKey _isSymbol not
        and: [ (keyClass _subclassOf: String)
          or: [ (keyClass _subclassOf: DoubleByteString)
              or: [ keyClass _subclassOf: QuadByteString ] ] ])
        ifFalse: [ ^ false ].
      (CharacterCollection isInUnicodeComparisonMode or: [ self constraintType == #unicodeString ])
        ifTrue: [ ^ true ]
        ifFalse: [
          "self constraintType == #string and unicode comparison mode DISABLED"
          ^ ((keyClass == Unicode7)
            or: [ (keyClass == Unicode16)
              or: [ keyClass == Unicode32 ] ]) not ] ]
    ifFalse: [
      "self constraintType == #symbol"
      ^ aKey _isSymbol ]
%

category: 'Updating'
method: GsConstrainedCharacterCollectionIndex
_setLastPathTermState
  "Last object along the path unconditionally needs a dependency list."

  | lastPathTerm |
  lastPathTerm := self at: self size.
  lastPathTerm needsDepList: true
%

! Class extensions for 'GsCurrentSession'

!		Instance methods for 'GsCurrentSession'

category: 'Transaction Control'
method: GsCurrentSession
hasConflicts

"Determines, given the present state of the receiver, if any concurrency
 conflicts exist that would cause a subsequent commit operation to fail.
 Returns false if it finds no conflicts with other concurrent transactions.
 Returns true if it does find conflicts, which can then be examined by
 calling the System class>>transactionConflicts method.

 This method has meaningful results whether or not the receiver is currently
 running inside a transaction.

 Note:  Even if this method returns false, there is no guarantee that a
        subsequent commit operation will succeed.

 If certain updates have been made to reduced conflict objects, it cannot
 be determined until a commit is attempted whether or not a conflict exists.
 In the following cases, this method always returns true:

   * Any change to an RcPositiveCounter during the current session.
   * One or more removals from an RcIdentityBag during the current session.
   * A session performs both additions and removals from an RcQueue which
     it has not accessed in this transaction or previous transactions.
"

 | result systm |
 systm := System .
 result := systm _validateTransaction.
 result == -1 ifTrue:[ ^ false "read-only transaction" ].
 result == 0 ifTrue: [
    (GsBitmap newForHiddenSet: #RcReadSet) size == 0
       ifTrue: [ ^ false ]
       ifFalse: [^ self _scanRedoLogForConflicts ]
  ] ifFalse: [
    result == 1
      ifTrue: [ ^ self _RcHasConflicts  ]
      ifFalse: [ ^ true "validationFailure" ]
  ].
  self halt: 'logic error' .
  ^ true "if we get here it is a logic error, but indicate conflicts exist"
%

category: 'Initialization'
method: GsCurrentSession
initialize

" This method is executed once at Session initialization,
  after the ProcessorScheduler is initialized.  It is invoked from
  ProcessorScheduler>>_initialize:  if the GciLogin for this session
  did not include the login flag  GCI_CLIENT_DOES_SESSION_INIT .
  For logins specifying the flag GCI_CLIENT_DOES_SESSION_INIT ,
  the Gci application is responsible for invoking this methd by sending
     GsCurrentSession initialize
  .

  To install application specific initialization code,
  use UserProfile>>loginHook: .

  Deprecated behavior:
    This method may be modified to invoke application specific
    initialization code.

    Use extreme caution when testing modifications to this method.
    Errors in this method may unrecoverably disable commits and
    require restore from backup.  Prior to testing modifications,
    make a full backup of your system.  During testing, disable
    execution of application specific code for user SystemUser to
    allow recovery.
"

"Globals at: #IcuLibraryVersion checks are now done in C
 during VM initialization.  The value of IcuLibraryVersion determines
 the version of the libicu libraries loaded by the VM.

 The association (Globals associationAt: #IcuLibraryVersion) is
 owned by SystemUser; its value should only be changed by SystemUser
 when no other user sessions are logged in, after which stone must
 be shutdown and restarted.
"

"install a sessionMethodDictionary if GsPackagePolicy is enabled"
System myUserProfile isSystemProfile ifFalse:[
  GsPackagePolicy enabled
    ifTrue:[ GsPackagePolicy loadSessionMethodDictionary ]
    ifFalse:[ Unicode16 installUnicodeComparePrimitives ].

  "invoke the  method or block specified by  UserProfile >> loginHook: "
  userProfile _postLoginInitialize .
] ifTrue:[
  "SystemUser, GcUser, SymbolUser, HostAgentUser  use this code path, fix 47547"
  Unicode16 installUnicodeComparePrimitives .
].
^ self
%

! Class extensions for 'GsEnumeratedPathTerm'

!		Instance methods for 'GsEnumeratedPathTerm'

category: 'Updating Indexes'
method: GsEnumeratedPathTerm
addMappingsForObject: anObject root: rootObject logging: aBoolean
  "Add dependency list entries for anObject."

  | ivOffset sz |
  (nil == anObject or: [ self size == 0 ])
    ifTrue: [ ^ self ].
  self pathTermElements
    do: [ :pathTermElement | (self _ivOffsetFor: anObject pathName: pathTermElement)
        ifNil: [ self _invalidIvOffset: anObject ]
        ifNotNil: [ :off | ivOffset := off ] ].
  anObject
    getDepListAndAddPathTerm: self
    withIVOffset: ivOffset
    logging: aBoolean.
	" add an entry to the objects dependency list ... note that we ar only using the last ivOffset and that is okay as we compensate in the places that the ivOffset is used..."
  sz := children size.
  self nextObj: anObject do: [ :nextObj |
      updateBtree ~~ nil
        ifTrue: [
          " insert an entry into the btree "
          (self _checkBtreeComparisonWith: nextObj)
            ifFalse: [
              ImproperOperation new
                _number:
                    (ErrorSymbols at: #'rtErrRangeEqualityIndexInvalidClassKindForBtree');
                args: { nextObj class. self name. updateBtree lastElementClassDescription };
                signal ].
          updateBtree btreeAt: nextObj put: anObject root: rootObject.
          needsDepList
            ifTrue: [
              " add an entry in the dependency list "
              nextObj getDepListAndAddLastElementPathTerm: self logging: false ] ].
      nil == nextObj
        ifTrue: [ self recordNilOnPathForRoot: rootObject ]
        ifFalse: [
          1 to: sz do: [ :i | " make recursive call to add mappings "
            (children at: i)
              addMappingsForObject: nextObj
              root: rootObject
              logging: aBoolean ] ] ]
%

category: 'Audit'
method: GsEnumeratedPathTerm
auditDepListFor: obj index: indexObj using: auditor optionalSentinel: optionalSentinel
  "Private."

  | depList j ivOffset |
  (nil == obj or: [ self size == 0 ])
    ifTrue: [ ^ nil ].
  depList := DependencyList for: obj.
  depList == nil
    ifTrue: [
      obj isInvariant
        ifFalse: [ auditor pathTermObjectHasNoDependencyList: self object: obj indexObj: indexObj depList: depList ] ]
    ifFalse: [
      (DepListTable _hasDependencyBitFor: obj)
        ifFalse: [ auditor pathTermObjectHasNoDependencyBitSet: self object: obj indexObj: indexObj depList: depList ].
      j := depList _findOffsetForPathTerm: self.
      j == nil
        ifTrue: [ auditor dependencyListHasNoEntryForPathTerm: self object: obj indexObj: indexObj depList: depList ]
        ifFalse: [
          "found entry for self in depList"
          ivOffset := depList at: j + 1.	"may be negative for last element reference count"
          ivOffset < 0
            ifTrue: [
              "reference count for last element, but we don't expect reference
               count here ... see needsDepList clause below where depList
               existence is sufficient"
              auditor dependencyListUnexpectedLastElementLocation: self object: obj indexObj: indexObj depList: depList ivOffset: ivOffset.
              ^ self ] ] ].
  needsDepList
    ifTrue: [
      self
        nextObj: obj
        do: [ :nextObj |
          nextObj ifNotNil: [
            (DependencyList needsDepList: nextObj)
              ifTrue: [
                depList := DependencyList for: nextObj.
                depList == nil
                  ifTrue: [
                    nextObj isInvariant
                      ifFalse: [ auditor pathTermObjectHasNoDependencyList: self object: nextObj indexObj: indexObj depList: depList ] ] ] ] ] ].
  ^ self
%

category: 'Audit'
method: GsEnumeratedPathTerm
auditNscCountsFor: obj using: auditor count: btreeCounts
  "Private. "

  | sz |
  sz := self size.
  (nil == obj _or: [ sz == 0 ])
    ifTrue: [ ^ self ].
  self
    auditDepListFor: obj
    index: nil
    using: auditor
    optionalSentinel: Object new.
  self nextObj: obj do: [ :nextObj | | index |
      index := 1.
      children isEmpty
        ifTrue: [ self auditDirectNscCountsFor: nextObj using: auditor count: btreeCounts ]
        ifFalse: [ 1 to: sz do: [ :i | | count indexObj |
            indexObj := self at: i.
            indexObj size == offset
              ifTrue: [ count := btreeCounts at: index.
                count == 0
                  ifTrue: [ auditor pathTermIncorrectNumberOfBtreeEntries: self index: i offset: offset ].
                btreeCounts at: index put: count - 1.
                index := index + 1 ] ].
          nextObj ~~ nil
            ifTrue: [ 1 to: children size do: [ :i | (children at: i)
                  auditNscCountsFor: nextObj
                  using: auditor
                  count: (btreeCounts at: index).
                index := index + 1 ] ] ] ]
%

category: 'Audit'
method: GsEnumeratedPathTerm
auditUpdateCacheFor: anObject root: root nilOnPathRoots: nilOnPathRoots occurrences: num using: auditor
  "verify proper accounting for objects with nil on path"

  self nextObj: anObject do: [ :nextObj |
     (nil == nextObj and: [ updateBtree isNil ])
      ifTrue: [
        | nilOnPathNum |
        nilOnPathNum := nilOnPath asIdentitySet occurrencesOf: root.
        nilOnPathNum = num
          ifFalse: [ auditor pathTermIncorrectNilOnPathCount: self root: root got: nilOnPathNum  expected: num ] ]
      ifFalse: [
        1 to: children size do: [ :i |
          (children at: i)
            auditUpdateCacheFor: nextObj
            root: root
            nilOnPathRoots: nilOnPathRoots
            occurrences: num
            using: auditor ] ] ]
%

category: 'Updating Indexes'
method: GsEnumeratedPathTerm
cleanupDependencyListFor: anObject
  ""

  | deplistOffset nextObj depList |
  (nil == anObject or: [ self size == 0 ])
    ifTrue: [ ^ self ].
  (depList := DependencyList for: anObject) == nil
    ifTrue: [ ^ self ].
  deplistOffset := depList removeCompletelyPathTerm: self for: anObject.	" remove the receiver from the dependency list "
  (self indicatesIndexOnRootNsc
    or: [
      "last element dependency list"
      deplistOffset < 0 ])
    ifTrue: [ ^ self ].
  self pathTermElements
    do: [ :pathName |
      (self _ivOffsetFor: anObject pathName: pathName)
        ifNotNil: [ :ivOffset |
          nextObj := self _nextObjectFor: anObject atInstVar: ivOffset.
          nextObj
            ifNotNil: [
              needsDepList
                ifTrue: [
                  (depList := DependencyList for: nextObj) ~~ nil
                    ifTrue: [ depList removeCompletelyPathTerm: self for: nextObj ] ].
              1 to: children size do: [ :i | (children at: i) cleanupDependencyListFor: nextObj ] ] ] ]
%

category: 'Testing'
method: GsEnumeratedPathTerm
coversIvOffset: anIvOffset for: anObject
  "Answer true if the receiver covers the given iv offset (see bug 46705)"

  self pathTermElements
    do: [ :pathTermElement |
      (self _ivOffsetFor: anObject pathName: pathTermElement)
        ifNil: [ self _invalidIvOffset: anObject ]
        ifNotNil: [ :off | anIvOffset = off ifTrue: [ ^true ] ] ].
  ^ false
%

category: 'Modification'
method: GsEnumeratedPathTerm
findReachableRootObjectMapsFor: anObject ivOffset: ivOffset oldValue: oldValue

  | indexObj factor theFactor rootObjectMap traversalRootObjects traversalReachableRoots |
  rootObjectMap := BtreePlusRootObjectMap new
    pivotObject: anObject;
    pivotPathTerm: self;
    yourself.
  self findReachableRootObjectMaps: rootObjectMap for: anObject ivOffset: ivOffset oldValue: oldValue sanity: false.
  traversalRootObjects := rootObjectMap resolveTraversalRootObjectsFor: oldValue.
  indexObj := self at: self size.
factor := rootObjectMap cumulativeFactor.
  (traversalRootObjects includes: anObject)
    ifTrue: [ theFactor := (traversalRootObjects occurrencesOf: anObject) ]
    ifFalse: [
      | enumeratedValues |
      enumeratedValues := IdentityBag new.
      self nextObj: anObject do: [:nextObj |
        enumeratedValues add: nextObj].
      theFactor := (enumeratedValues occurrencesOf: oldValue) ].
  theFactor ~~ 1
    ifTrue: [ factor := factor + theFactor ].
factor == 0 ifTrue: [ ^ traversalRootObjects ].
  traversalReachableRoots := IdentityBag new.
  traversalRootObjects asIdentitySet do: [:rootObject |
    | num |
    theFactor := factor + (indexObj cumulativeFactorFor: rootObject upTo: self startingAt: 1).
    num := traversalRootObjects occurrencesOf: rootObject.
    traversalReachableRoots add: rootObject withOccurrences: (num / theFactor) ceiling ].
  ^ traversalReachableRoots
%

category: 'Modification'
method: GsEnumeratedPathTerm
findReachableRootsFor: anObject ivOffset: ivOffset oldValue: oldValue

  | rootObjects indexObj reachableRoots factor |
  rootObjects := super findReachableRootsFor: anObject ivOffset: ivOffset oldValue: oldValue.
  indexObj := self at: self size.
  (rootObjects includes: anObject)
    ifTrue: [ factor := rootObjects occurrencesOf: anObject ]
    ifFalse: [
      | enumeratedValues |
      enumeratedValues := IdentityBag new.
      self nextObj: anObject do: [:nextObj |
        enumeratedValues add: nextObj].
      factor := (enumeratedValues occurrencesOf: oldValue) ].
  factor == 1
    ifTrue: [ ^ rootObjects ].
  reachableRoots := IdentityBag new.
  rootObjects asIdentitySet do: [:rootObject |
    | num theFactor |
    theFactor := factor + (indexObj cumulativeFactorFor: rootObject upTo: self startingAt: 1).
    num := rootObjects occurrencesOf: rootObject.
    reachableRoots add: rootObject withOccurrences: (num / theFactor) ceiling ].
  ^ reachableRoots
%

category: 'Collection Based Modification'
method: GsEnumeratedPathTerm
findRootObjectMaps: rootObjectMap for: anObject
  "Traverse btree nodes from receiver to leaf term. Collect rootObjects for all btree elements
   for which anObject is a key or parent of a key."

  (rootObjectMap traversalMap includesKey: anObject)
    ifTrue: [
      "only way for the key to be present, is that to have come through this pathTerm/object before.
       And that can happen if one or more of the enumerated terms has identical values"
      ^ self  ].
  self pathTermElements
    do: [ :pathName |
      "Make a full pass for each of the enumerated instance variables"
      | ivOffset |
      ivOffset := self _ivOffsetFor: anObject pathName: pathName.
      ivOffset ifNil: [ self _invalidIvOffset: anObject ].
      self findRootObjectMaps: rootObjectMap for: anObject ivOffset: ivOffset]
%

category: 'Collection Based Modification'
method: GsEnumeratedPathTerm
findRootObjectMaps: rootObjectMap for: anObject ivOffset: ivOffset

  (rootObjectMap traversalMap includesKey: anObject)
    ifTrue: [
      "only way for the key to be present, is that to have come through this pathTerm/object before.
       And that can happen if one or more of the enumerated terms has identical values"
      ^ self  ].
  super findRootObjectMaps: rootObjectMap for: anObject ivOffset: ivOffset
%

category: 'Collection Based Modification'
method: GsEnumeratedPathTerm
findRootObjectMaps: rootObjectMap for: anObject ivOffset: ivOffset oldValue: oldValue

  (rootObjectMap traversalMap includesKey: anObject)
    ifTrue: [
      "only way for the key to be present, is that to have come through this pathTerm/object before.
       And that can happen if one or more of the enumerated terms has identical values"
      ^ self  ].
  super findRootObjectMaps: rootObjectMap for: anObject ivOffset: ivOffset oldValue: oldValue
%

category: 'Collection Based Modification'
method: GsEnumeratedPathTerm
findRootObjectMaps: rootObjectMap for: anObject oldValue: oldValue
  "Traverse btree nodes from receiver to leaf term. Collect rootObjects for all btree elements
   for which anObject is a key or parent of a key."
| enumeratedValues factor |
  enumeratedValues := IdentityBag new.
  self nextObj: anObject do: [:nextObj |
    enumeratedValues add: nextObj].
factor := 0.
  self pathTermElements
    do: [ :pathName |
      "Make a full pass for each of the enumerated instance variables"
      | ivOffset nextOldValue |
      ivOffset := self _ivOffsetFor: anObject pathName: pathName.
      ivOffset ifNil: [ self _invalidIvOffset: anObject ].
      nextOldValue := self _nextObjectFor: oldValue atInstVar: ivOffset.
      factor := factor + (enumeratedValues occurrencesOf: nextOldValue)].
factor > 1 ifTrue: [
rootObjectMap cumulativeFactor: (factor + (rootObjectMap cumulativeFactor))].
  (rootObjectMap traversalMap includesKey: anObject)
    ifTrue: [
      "only way for the key to be present, is that to have come through this pathTerm/object before.
       And that can happen if one or more of the enumerated terms has identical values"
      ^ self  ].
  self pathTermElements
    do: [ :pathName |
      "Make a full pass for each of the enumerated instance variables"
      | ivOffset nextOldValue |
      ivOffset := self _ivOffsetFor: anObject pathName: pathName.
      ivOffset ifNil: [ self _invalidIvOffset: anObject ].
      nextOldValue := self _nextObjectFor: oldValue atInstVar: ivOffset.
      self
         findRootObjectMaps: rootObjectMap
         for: anObject
         ivOffset: ivOffset
         oldValue: nextOldValue ].
%

category: 'Collection Based Modification'
method: GsEnumeratedPathTerm
findRootObjectsFor: anObject
  "Traverse btree nodes from receiver to leaf term. Collect rootObjects for all btree elements
   for which anObject is a key or parent of a key."

  | rootObjects |
  rootObjects := IdentityBag new.
  self pathTermElements
    do: [ :pathName |
      "Make a full pass for each of the enumerated instance variables"
      | roots ivOffset |
      ivOffset := self _ivOffsetFor: anObject pathName: pathName.
      ivOffset ifNil: [ self _invalidIvOffset: anObject ].
      roots := self findRootObjectsFor: anObject ivOffset: ivOffset.
      rootObjects := rootObjects _union: roots ].
  ^ rootObjects
%

category: 'Collection Based Modification'
method: GsEnumeratedPathTerm
findRootObjectsFor: anObject oldValue: oldValue
  "Traverse btree nodes from receiver to leaf term. Collect rootObjects for all btree elements
   for which anObject is a key or parent of a key."

  | rootObjects factor enumeratedValues reachableRoots |
  rootObjects := IdentityBag new.
  enumeratedValues := IdentityBag new.
  self nextObj: anObject do: [:nextObj |
    enumeratedValues add: nextObj].
  factor := 0.
  self pathTermElements
    do: [ :pathName |
      "Make a full pass for each of the enumerated instance variables"
      | roots ivOffset nextOldValue |
      ivOffset := self _ivOffsetFor: anObject pathName: pathName.
      ivOffset ifNil: [ self _invalidIvOffset: anObject ].
      nextOldValue := self _nextObjectFor: oldValue atInstVar: ivOffset.
      factor := factor + (enumeratedValues occurrencesOf: nextOldValue).
      roots := self
        findRootObjectsFor: anObject
        ivOffset: ivOffset
        oldValue: nextOldValue.
      rootObjects := rootObjects _union: roots ].
  factor == 1 ifTrue: [ ^ rootObjects ].
  reachableRoots := IdentityBag new.
  rootObjects asIdentitySet do: [:rootObject |
    | num |
    num := rootObjects occurrencesOf: rootObject.
    reachableRoots add: rootObject withOccurrences: (num / factor) ceiling ].
  ^ reachableRoots
%

category: 'Testing'
method: GsEnumeratedPathTerm
hasMatchingTerm: aSymbol
  "Answer true if the receiver's term matches <aSymbol>"

  ^ self name == (self _canonicalizeTerm: aSymbol)
%

category: 'Testing'
method: GsEnumeratedPathTerm
indicatesIndexOnNscElements
  "Returns false. The ides is not on elements of an nsc."

  ^ false
%

category: 'Testing'
method: GsEnumeratedPathTerm
isEnumeratedTerm
  "Returns true if the receiver indicates an enumerated path term."

  ^ true
%

category: 'Accessing'
method: GsEnumeratedPathTerm
nextObj: anObj do: aBlock
  | found |
  (nil == anObj or: [ self size == 0 ])
    ifTrue: [ ^ self ].
  found := false.
  self pathTermElements
    do: [ :pathName |
      | ivOffset |
      (ivOffset := self _ivOffsetFor: anObj pathName: pathName) ~~ nil
        ifTrue: [
          | nextObj |
          found := true.
          nextObj := self _nextObjectFor: anObj atInstVar: ivOffset.
          aBlock cull: nextObj cull: ivOffset ] ].
  found
    ifFalse: [ ^ self _invalidIvOffset: anObj ]
%

category: 'Accessing'
method: GsEnumeratedPathTerm
pathTermElements
  "return the individual pathTerm elements"

  ^ self name subStringsDelimitedBy: $|
%

category: 'Removing'
method: GsEnumeratedPathTerm
removeMappingsFor: anObject root: rootObject lastOne: aBoolean logging: doLogging
  "Remove entries in the btree and dependency lists for anObject."

  | nextObj depList isLast |
  self size == 0
    ifTrue: [ ^ self ].
  self pathTermElements
    do: [ :pathName |
      nextObj := self _nextObjectFor: anObject pathName: pathName.
      updateBtree ~~ nil
        ifTrue: [
          " remove an entry from the B-tree "
          (updateBtree btreeRemoveKey: nextObj value: anObject root: rootObject)
            ifFalse: [ self _errorObjectNotInBtree: nextObj value: anObject root: rootObject ].
          DependencyList removePathTerm: self for: nextObj logging: doLogging	" remove dependency list entry for next object " ].
      nextObj ifNil: [ self removeNilOnPathForRoot: rootObject ].
      (nil ~~ nextObj and: [ children isEmpty not ])
        ifTrue: [
          aBoolean
            ifTrue: [
              | last |
              last := (children at: 1) _isLastOccurrenceInIndexFor: nextObj.
              isLast := aBoolean and: [ last ] ]
            ifFalse: [ isLast := false ].
          " make recursive call to remove mappings "
          1 to: children size do: [ :i | (children at: i) removeMappingsFor: nextObj root: rootObject lastOne: isLast logging: doLogging ].
          isLast
            ifFalse: [
              "check again in case there are no more references left in btree"
              isLast := ((children at: 1) findReachableRootsFor: nextObj) isEmpty ].
          isLast
            ifTrue: [
              " remove dependency list entries for next object "
              (depList := DependencyList for: nextObj) ~~ nil
                ifTrue: [ depList removePathTerms: children for: nextObj logging: doLogging ] ] ] ]
%

category: 'Modification'
method: GsEnumeratedPathTerm
traverseAllReachableFor: root indexObj: indexObj

  ^ (indexObj traverseAllWithParents: root upTo: self startingAt: 1) collect: [:each | each at: 2]
%

category: 'Updating'
method: GsEnumeratedPathTerm
_canonicalizeTerm: aSymbol
  "Canonicalize the pathTerm name, so that terms are in alphabetical order"

  | terms sz canon |
  terms := (aSymbol subStringsDelimitedBy: $|) sortAscending.
  canon := String new.
  sz := terms size.
  1 to: sz do: [ :index |
    | term |
    term := terms at: index.
    canon add: term.
    index < sz
      ifTrue: [ canon add: $| ] ].
  ^ canon asSymbol
%

category: 'Testing'
method: GsEnumeratedPathTerm
_isLastOccurrenceInIndexFor: anObject

  ^ (self findReachableRootsFor: anObject) size <= 1
%

category: 'Accessing'
method: GsEnumeratedPathTerm
_ivOffsetFor: anObject pathName: pathName
  "Returns the instance variable offset of anObject for the pathName which is one of the enumarated instance variables."

  ^ (self _classOf: anObject) _ivOffsetOf: pathName asSymbol
%

category: 'Accessing'
method: GsEnumeratedPathTerm
_ivOffsetsFor: anObject
  ^ self pathTermElements
    collect: [ :pathTermElement | self _ivOffsetFor: anObject pathName: pathTermElement ]
%

category: 'Accessing'
method: GsEnumeratedPathTerm
_nextObjectFor: anObject pathName: aPathName
  "Returns the object at the instance variable that corresponds to the receiver
 path term."

  | ivOffset |
  ivOffset := self _ivOffsetFor: anObject pathName: aPathName.
  ivOffset ifNil: [ ^ nil ].
  ^ self _nextObjectFor: anObject atInstVar: ivOffset
%

! Class extensions for 'GsEqualityIndexQueryEvaluator'

!		Instance methods for 'GsEqualityIndexQueryEvaluator'

category: 'Accessing'
method: GsEqualityIndexQueryEvaluator
btreeReadStreamClass
  "Returns the class of btree read stream to create for query results."

  ^ index btreeReadStreamClass
%

category: 'Accessing'
method: GsEqualityIndexQueryEvaluator
btreeRoot

  ^self index btreeRoot
%

category: 'Accessing'
method: GsEqualityIndexQueryEvaluator
comparisonForCompare
  ^ self index comparisonForCompare
%

category: 'Accessing'
method: GsEqualityIndexQueryEvaluator
comparisonForSort
  ^ self index comparisonForSort
%

category: 'Query Select'
method: GsEqualityIndexQueryEvaluator
findAllValuesEqualTo: aValue
  "Returns a set of all values that satisfy the query."

  | stream |
  stream := self _findAllValuesEqualTo: aValue using: self comparisonForCompare.
  ^ self doBlock
    ifNotNil: [ [ stream atEnd ] whileFalse: [ self doBlock value: stream next ] ]
    ifNil: [ stream makeNscComparing: #'=' key: aValue ]
%

category: 'Query Select'
method: GsEqualityIndexQueryEvaluator
findAllValuesGreaterThan: val1 andEquals: bool1 andLessThan: val2 andEquals: bool2
  "Returns a set of all values that satisfy the query."

  | selector1 selector2 stream |
  selector1 := bool1
    ifTrue: [ #'>=' ]
    ifFalse: [ #'>' ].
  selector2 := bool2
    ifTrue: [ #'<=' ]
    ifFalse: [ #'<' ].
  stream := self
    _findAllValuesGreaterThan: val1
    andEquals: bool1
    andLessThan: val2
    andEquals: bool2
    using: self comparisonForCompare.
  ^ self doBlock
    ifNotNil: [ stream streamQuerySpec: (stream btreeRangeComparisonQuerySpec
            key: val1 selector: selector1;
            key2: val2 selector2: selector2;
            yourself).
      [ stream atEnd ] whileFalse: [ self doBlock value: stream next ] ]
    ifNil: [ stream
        makeNscComparing: selector1
        key: val1
        and: selector2
        key: val2 ]
%

category: 'Query Select'
method: GsEqualityIndexQueryEvaluator
findAllValuesGreaterThanKey: aValue andEquals: aBoolean
  "Returns a set of all values that satisfy the query."

  | selector stream |
  selector := aBoolean
    ifTrue: [ #'>=' ]
    ifFalse: [ #'>' ].
  stream := self
    _findAllValuesGreaterThanKey: aValue
    andEquals: aBoolean
    using: self comparisonForCompare.
  ^ self doBlock
    ifNotNil: [ [ stream atEnd ] whileFalse: [ self doBlock value: stream next ] ]
    ifNil: [ stream makeNscComparing: selector key: aValue ]
%

category: 'Query Select'
method: GsEqualityIndexQueryEvaluator
findAllValuesLessThanKey: aValue andEquals: aBoolean
  "Returns a set of all values that satisfy the query."

  | selector stream |
  selector := aBoolean
    ifTrue: [ #'<=' ]
    ifFalse: [ #'<' ].
  stream := self
    _findAllValuesGreaterThan: nil
    andEquals: true
    andLessThan: aValue
    andEquals: aBoolean
    using: self comparisonForCompare.
  ^ self doBlock
    ifNotNil: [ | querySpec |
      querySpec := self index btreeComparisonQuerySpec
        key: aValue selector: selector;
        yourself.
      stream streamQuerySpec: querySpec.
      [ stream atEnd ] whileFalse: [ self doBlock value: stream next ] ]
    ifNil: [ stream makeNscComparing: selector key: aValue ]
%

category: 'Query Select'
method: GsEqualityIndexQueryEvaluator
findAllValuesNotEqualTo: aValue
  "Returns a set of all values that satisfy the query."

  | preStream eqStream postStream querySpec |
  preStream := self
    _findAllValuesGreaterThan: nil
    andEquals: true
    andLessThan: aValue
    andEquals: false
    using: self comparisonForSort.
  eqStream := self
    _findAllValuesGreaterThan: aValue
    andEquals: true
    andLessThan: aValue
    andEquals: true
    using: self comparisonForSort.
  querySpec := self index btreeComparisonQuerySpec
    key: aValue selector: #'~=';
    yourself.
  eqStream streamQuerySpec: querySpec.
  postStream := self
    _findAllValuesGreaterThanKey: aValue
    andEquals: false
    using: self comparisonForSort.
  postStream streamQuerySpec: nil.
  ^ self doBlock
    ifNotNil: [ :aBlock |
      [ preStream atEnd ] whileFalse: [ aBlock value: preStream next ].
      [ eqStream atEnd ] whileFalse: [ aBlock value: eqStream next ].
      [ postStream atEnd ] whileFalse: [ aBlock value: postStream next ] ]
    ifNil: [
      | tmpHolder |
      tmpHolder := NscBuilder
        for: self nscRoot species new
        max: self sizeForNscBuilder.
      preStream _valuesAddInto: tmpHolder.
      eqStream _valuesAddInto: tmpHolder notEqualTo: aValue.
      postStream _valuesAddInto: tmpHolder.
      tmpHolder completeBag ]
%

category: 'Query Detect'
method: GsEqualityIndexQueryEvaluator
findFirstValueEqualTo: aValue

"Returns the first value that satisfies the query."

(index _canCompareWith: aValue)
    ifFalse: [ self _error: #assocErrBadComparison ].

^ self btreeRoot _findFirstRootForKey: aValue using: self comparisonForCompare
%

category: 'Query Detect'
method: GsEqualityIndexQueryEvaluator
findFirstValueGreaterThan: val1
andEquals: bool1
andLessThan: val2
andEquals: bool2

"Returns the first value that satisfies the query."

| stream selector1 selector2 |
stream := self
    _findAllValuesGreaterThan: val1
    andEquals: bool1
    andLessThan: val2
    andEquals: bool2
    using: self comparisonForCompare.

stream == nil
  ifTrue: [ ^ #_incompletePathTraversal ].
selector1 := bool1
  ifTrue: [ #'_idxForCompareGreaterThanOrEqualTo:' ]
  ifFalse: [ #'_idxForCompareGreaterThan:' ].
selector2 := bool2
  ifTrue: [ #'_idxForCompareLessThanOrEqualTo:' ]
  ifFalse: [ #'_idxForCompareLessThan:' ].
^ stream nextRootComparing: selector1 key: val1 and: selector2 key: val2
%

category: 'Query Detect'
method: GsEqualityIndexQueryEvaluator
findFirstValueGreaterThanKey: aValue
andEquals: aBoolean

"Returns the first value that satisfies the query."

| stream selector |
stream := self  _findAllValuesGreaterThanKey: aValue
                    andEquals: aBoolean
                    using: self comparisonForCompare.
stream == nil
  ifTrue: [ ^ #_incompletePathTraversal ].
selector := aBoolean
  ifTrue: [ #'_idxForCompareGreaterThanOrEqualTo:' ]
  ifFalse: [ #'_idxForCompareGreaterThan:' ].
^ stream nextRootComparing: selector key: aValue
%

category: 'Query Detect'
method: GsEqualityIndexQueryEvaluator
findFirstValueIdenticalTo: aValue
  "Returns the first value that satisfies the query.  Since this is an identity
 comparison on a range index (which supports equality comparison), create a
 BtreeReadStream for equal values, then iterate through the values making
 the identity comparison."

  | stream |
  stream := self _findAllValuesIdenticalTo: aValue.
  stream == nil
    ifTrue: [ ^ #'_incompletePathTraversal' ].	" iterate through the stream, checking for an identical value "
  [ stream _atEnd ]
    whileFalse: [
      stream _peekKey == aValue
        ifTrue: [
          ^ stream _peekRoot ].
      stream _btreeNext ].
  ^ #'_incompletePathTraversal'
%

category: 'Query Detect'
method: GsEqualityIndexQueryEvaluator
findFirstValueLessThanKey: aValue
andEquals: aBoolean

"Returns the first value that satisfies the query."

| stream selector |
stream := self
      _findAllValuesGreaterThan: nil
      andEquals: true
      andLessThan: aValue
      andEquals: aBoolean
      using: self comparisonForCompare.
stream == nil
  ifTrue: [ ^ #_incompletePathTraversal ].
selector := aBoolean
  ifTrue: [ #'_idxForCompareLessThanOrEqualTo:' ]
  ifFalse: [ #'_idxForCompareLessThan:' ].
^ stream nextRootComparing: selector key: aValue
%

category: 'Query Detect'
method: GsEqualityIndexQueryEvaluator
findFirstValueNotEqualTo: aValue
  "Returns the first value that satisfies the query."

  | stream totalStream obj bag incomplete |
  " find the ones that are equal "
  stream := self
    _findAllValuesGreaterThan: aValue
    andEquals: true
    andLessThan: aValue
    andEquals: true
    using: self comparisonForCompare.
  stream _atEnd
    ifTrue: [ " if none are equal, pick the first one "
      self hasSetValuedTerm
        ifTrue: [ bag := self nscRoot _asIdentityBag.
          1 to: bag size do: [ :i | nil ~~ (bag _at: i)
              ifTrue: [ ^ bag _at: i ] ].
          ^ #'_incompletePathTraversal' ]
        ifFalse: [ incomplete := #'_incompletePathTraversal'.
          bag := self nscRoot _asIdentityBag.
          1 to: bag size do: [ :i | obj := bag _at: i.
            (self index traverseObject: obj) == incomplete
              ifFalse: [ ^ obj ] ].
          ^ #'_incompletePathTraversal' ] ].
  totalStream := self readStreamClass on: self index.	" get a stream over the entire NSC "
  (totalStream _peekKey _idxForCompareNotEqualTo: stream _peekKey)
    ifTrue: [ " see if very first object is not equal "
      ^ totalStream next ].
  (totalStream _hasSameEndAs: stream)
    ifTrue: [ " see if end of original stream is the very last object "
      ^ #'_incompletePathTraversal' ]
    ifFalse: [ " advance the stream to the last object "
      totalStream _positionToEnd.
      ^ totalStream next ]
%

category: 'Accessing'
method: GsEqualityIndexQueryEvaluator
readStreamClass
  "Returns the class of read stream to create for query results."

  ^ index readStreamClass
%

category: 'Searching'
method: GsEqualityIndexQueryEvaluator
_findAllValuesEqualTo: val1 using: aComparison
  "Returns a RangeIndexReadStream that iterates over all objects in the index
 that satisfy the query."

  | stream querySpec |
  stream := self
    _findAllValuesGreaterThan: val1
    andEquals: true
    andLessThan: val1
    andEquals: true
    using: aComparison.
  querySpec := self index btreeComparisonQuerySpec
    key: val1 selector: #'=';
    yourself.
  stream streamQuerySpec: querySpec.
  ^ stream
%

category: 'Searching'
method: GsEqualityIndexQueryEvaluator
_findAllValuesGreaterThan: val1 andEquals: bool1 andLessThan: val2 andEquals: bool2 using: aComparison
  "Returns a RangeIndexReadStream that iterates over all objects in the index
 that satisfy the query."

  | array1 array2 stream doNext |
  val1 ifNotNil: [
    "nil allowed in all queries, disallowed as a key in optimized comparison indexes."
    (self index _canCompareWith: val1)
      ifFalse: [ self _error: #'assocErrBadComparison' ] ].
  (self index _canCompareWith: val2 )
    ifFalse: [ self _error: #'assocErrBadComparison' ].
  stream := self readStreamClass new rangeIndex: self index.	" check to see if the query is even satisfiable "
  (aComparison
    satisfiableQueryGreaterThan: val1
    andEquals: bool1
    andLessThan: val2
    andEquals: bool2)
    ifFalse: [
      stream currentStack: {0}.
      ^ stream ].
  doNext := false.
  array1 := {}.
  (self index optimizingComparison and: [ val1 == nil ])
    ifTrue: [
      " all were greater than or equal to "
      self btreeRoot
        _putFirstIndexOfFirstChildInto: array1
        ifGreaterThanOrEqualTo: val1
        using: aComparison ]
    ifFalse: [
      " see if querying > or >= "
      bool1
        ifTrue: [
          " if >=, perform < and do an '_advance' operation later "
          (self btreeRoot
            _findAllValuesLessThanKey: val1
            andEquals: false
            into: array1
            using: aComparison)
              ifTrue: [ doNext := true ]
              ifFalse: [
                " all were greater than or equal to "
                self btreeRoot
                  _putFirstIndexOfFirstChildInto: array1
                  ifGreaterThanOrEqualTo: val1
                  using: aComparison ] ]
        ifFalse: [
          " if >, ask the B-tree specifically for > "
          (self btreeRoot
            _findAllValuesGreaterThanKey: val1
            into: array1
            using: aComparison)
              ifFalse: [
                " none were greater than "
                stream currentStack: {0}.
                ^ stream ] ] ].
  array2 := {}.	" ask the B-tree for the second boundary of the query result "
  (self btreeRoot
    _findAllValuesLessThanKey: val2
    andEquals: bool2
    into: array2
    using: aComparison)
    ifFalse: [
      " none were found less than "
      stream currentStack: {0}.
      ^ stream ].
  stream endIndex: (array2 at: 1).
  stream endNode: (array2 at: 2).
  (stream endNode == (array1 at: 2) and: [ stream endIndex < (array1 at: 1) ])
    ifTrue: [
      array1 at: 1 put: 0.
      stream currentStack: array1.
      ^ stream ].
  stream currentStack: array1.
  doNext
    ifTrue: [
      " advance the B-tree positioning "
      stream _advance ].
  ^ stream
%

category: 'Searching'
method: GsEqualityIndexQueryEvaluator
_findAllValuesGreaterThanKey: aKey andEquals: aBoolean
  "Returns a RangeIndexReadStream that iterates over all objects in the index
 that satisfy the query."

  ^ self
    _findAllValuesGreaterThanKey: aKey
    andEquals: aBoolean
    using: self comparisonForCompare
%

category: 'Searching'
method: GsEqualityIndexQueryEvaluator
_findAllValuesGreaterThanKey: aKey andEquals: aBoolean using: aComparison
  "Returns a RangeIndexReadStream that iterates over all objects in the index
 that satisfy the query."

  | array1 array2 stream doNext querySpec |
  (self index _canCompareWith: aKey)
    ifFalse: [ self _error: #'assocErrBadComparison' ].
  stream := self readStreamClass new rangeIndex: self index.
  doNext := false.
  array1 := {}.	" see if querying > or >= "
  aBoolean
    ifTrue: [
      " if >=, perform < and do a 'next' operation later "
      (self btreeRoot
        _findAllValuesLessThanKey: aKey
        andEquals: false
        into: array1
        using: aComparison)
        ifTrue: [ doNext := true ]
        ifFalse: [
          " all were greater than or equal to "
          self btreeRoot
            _putFirstIndexOfFirstChildInto: array1
            ifGreaterThanOrEqualTo: aKey
            using: aComparison ] ]
    ifFalse: [
      " if >, ask the B-tree specifically for > "
      (self btreeRoot
        _findAllValuesGreaterThanKey: aKey
        into: array1
        using: aComparison)
        ifFalse: [
          " none were greater than "
          stream currentStack: {0}.
          ^ stream ] ].
  array2 := {}.
  self btreeRoot _putLastIndexOfLastChildInto: array2.
  stream currentStack: array1.
  stream endIndex: (array2 at: 1).
  stream endNode: (array2 at: 2).
  doNext
    ifTrue: [ stream _advance ].
  querySpec := self index btreeComparisonQuerySpec
    key: aKey
    selector:
      (aBoolean
        ifTrue: [ #'>=' ]
        ifFalse: [ #'>' ]);
    yourself.
  stream streamQuerySpec: querySpec.
  ^ stream
%

category: 'Searching'
method: GsEqualityIndexQueryEvaluator
_findAllValuesIdenticalTo: aValue
  "Returns a set of all values that satisfy the query.  Since this is an identity
 comparison on a range index (which supports equality comparison), this
 method creates a B-tree read stream for equal values, then iterates through the
 values making the identity comparison."

  |  stream  |
  stream := super _findAllValuesIdenticalTo: aValue.
  stream
    streamQuerySpec: (stream btreeComparisonQuerySpec key: aValue selector: #'==').
  ^ stream
%

category: 'Searching'
method: GsEqualityIndexQueryEvaluator
_findAllValuesLessThanKey: aKey andEquals: aBoolean using: aComparison
  "Returns a RangeIndexReadStream that iterates over all objects in the index
 that satisfy the query."

  | array1 array2 stream querySpec |
  (self index _canCompareWith: aKey)
    ifFalse: [ self _error: #'assocErrBadComparison' ].
  stream := self readStreamClass new rangeIndex: self index.
  array2 := {}.	" ask the B-tree to make the search and put the result path into array2 "
  (self btreeRoot
    _findAllValuesLessThanKey: aKey
    andEquals: aBoolean
    into: array2
    using: aComparison)
    ifTrue: [
      array1 := {}.	" put path to first entry of the B-tree into array1 "
      self btreeRoot _putFirstIndexOfFirstChildInto: array1.
      stream currentStack: array1.
      stream endIndex: (array2 at: 1).
      stream endNode: (array2 at: 2) ]
    ifFalse: [
      " none were found "
      stream currentStack: {0} ].
  querySpec := self index btreeComparisonQuerySpec
    key: aKey
    selector:
      (aBoolean
        ifTrue: [ #'<=' ]
        ifFalse: [ #'<' ]);
    yourself.
  stream streamQuerySpec: querySpec.
  ^ stream
%

category: 'Searching'
method: GsEqualityIndexQueryEvaluator
_findFirstKeyNotIdenticalTo: aKey atTerm: pathTerm
  "Returns the first key in the receiver's B-tree that is not identical to the
 given key."

  | stream key |
  stream := self btreeReadStreamClass on: self btreeRoot.
  [ stream _atEnd ] whileFalse: [ key := stream _peekKey.
      key == aKey
        ifFalse: [ ^ key ].
      stream _btreeNext ].
  ^ #'_incompletePathTraversal'
%

! Class extensions for 'GsEventLog'

!		Class methods for 'GsEventLog'

category: 'Instance Creation'
classmethod: GsEventLog
current
  ^ CurrentLog ifNil: [
     		CurrentLog := self new .
     		CurrentLog.
 		].
%

category: 'Immutability'
classmethod: GsEventLog
entriesModifiable
	self current entriesModifiable
%

category: 'Immutability'
classmethod: GsEventLog
entriesUnmodifiable
	self current entriesUnmodifiable
%

category: 'Add Log Entries'
classmethod: GsEventLog
logDebug

	^self current addEntry: GsEventLogEntry debug
%

category: 'Add Log Entries'
classmethod: GsEventLog
logDebug: aString

	^self current addEntry:
		(GsEventLogEntry debug
			label: aString;
			yourself)
%

category: 'Add Log Entries'
classmethod: GsEventLog
logError

	^self current addEntry: GsEventLogEntry error
%

category: 'Add Log Entries'
classmethod: GsEventLog
logError: aString

	^self current addEntry:
		(GsEventLogEntry error
			label: aString;
			yourself)
%

category: 'Add Log Entries'
classmethod: GsEventLog
logFatal

	^self current addEntry: GsEventLogEntry fatal
%

category: 'Add Log Entries'
classmethod: GsEventLog
logFatal: aString

	^self current addEntry:
		(GsEventLogEntry fatal
			label: aString;
			yourself)
%

category: 'Add Log Entries'
classmethod: GsEventLog
logInfo

	^self current addEntry: GsEventLogEntry info
%

category: 'Add Log Entries'
classmethod: GsEventLog
logInfo: aString

	^self current addEntry:
		(GsEventLogEntry info
			label: aString;
			yourself)
%

category: 'Add Log Entries'
classmethod: GsEventLog
logObject: anObject

	^GsEventLogEntry trace
		object: anObject;
		label: anObject printString;
		addToLog;
		yourself.
%

category: 'Add Log Entries'
classmethod: GsEventLog
logTrace

	^self current addEntry: GsEventLogEntry trace
%

category: 'Add Log Entries'
classmethod: GsEventLog
logTrace: aString

	^self current addEntry:
		(GsEventLogEntry trace
			label: aString;
			yourself)
%

category: 'Add Log Entries'
classmethod: GsEventLog
logWarning

	^self current addEntry: GsEventLogEntry warning
%

category: 'Add Log Entries'
classmethod: GsEventLog
logWarning: aString

	^self current addEntry:
		(GsEventLogEntry warning
			label: aString;
			yourself)
%

category: 'Instance Creation'
classmethod: GsEventLog
new
	^super new initialize

%

category: 'Private'
classmethod: GsEventLog
_logSystemInfoEventFor: subsystem label: aString object: obj

	GsEventLogSystemEntry info
		subsystem: subsystem;
		label: aString;
		object: obj;
		_addSystemEntryToLog.
%

category: 'Instance Creation'
classmethod: GsEventLog
_newWithEntries: anRcArray

	^self new
		_entryArray: anRcArray;
		yourself
%

!		Instance methods for 'GsEventLog'

category: 'Deleting'
method: GsEventLog
acquireGsEventLogLock
	"The lock is not needed for add, only for delete"

	| arr |
	arr := self _entryArray.
	System writeLock: arr
		ifDenied: [ ^false ]
		ifChanged: [
			System addToCommitOrAbortReleaseLocksSet: arr.
			^false ].
	System addToCommitOrAbortReleaseLocksSet: arr.
	^true
%

category: 'Actions'
method: GsEventLog
addEntry: anEntry

	self _entryArray add: anEntry.
	self _newEntriesInvariant ifTrue: [anEntry makeUnmodifiable].
	^anEntry
%

category: 'Deleting'
method: GsEventLog
deleteAllEntries
	"Delete all entries in the recevier, except for system events or events that cannot be deleted. "

	self _entryArray removeAllSuchThat: [:entry | entry canBeDeleted]
%

category: 'Deleting'
method: GsEventLog
deleteEntries: anotherEventLog
	"delete all entries in the argument from the receiver.
	Quiety ignore entries that are not present or are that cannot be deleted.
	This method does not delete system events."

	self _entryArray == anotherEventLog _entryArray ifTrue: [
		"remove all"
		^self deleteAllEntries].

	anotherEventLog _entryArray do: [:anEvent | self deleteEntry: anEvent]
%

category: 'Deleting'
method: GsEventLog
deleteEntry: anEvent
	"Remove the given event from the receiver, if allowed"

	anEvent canBeDeleted
		ifTrue: [self _basicDeleteEntry: anEvent].
%

category: 'Queries'
method: GsEventLog
entriesDo: aBlock
	"Execute aBlock for each entry"

	self _entryArray do: aBlock.
%

category: 'Actions'
method: GsEventLog
entriesModifiable
	self _newEntriesInvariant: false
%

category: 'Queries'
method: GsEventLog
entriesSatisfying: aBlock
	"return a new instance of the receiver containing the entries from the receiver that satisfy the block"

	| results |
	results := self _entryArray select: aBlock.
	^self class _newWithEntries: results
%

category: 'Actions'
method: GsEventLog
entriesUnmodifiable
	self _newEntriesInvariant: true
%

category: 'Initialization'
method: GsEventLog
initialize
	self objectSecurityPolicy: nil.
	self _entryArray:
		(RcArray new
			objectSecurityPolicy: nil;
			yourself).
	self _newEntriesInvariant: false.
%

category: 'Queries'
method: GsEventLog
last
	^entryArray last
%

category: 'Reporting'
method: GsEventLog
report
	| str |
	str := AppendStream on: String new.
	self _entryArray do: [:entry | entry printOn: str.  str lf].
	^str contents
%

category: 'Queries'
method: GsEventLog
size
	^entryArray size
%

category: 'Queries'
method: GsEventLog
systemEvents
	^self _entryArray entriesSatisfying: [:ev | ev isSystemEvent]
%

category: 'Queries'
method: GsEventLog
userEvents
	^self entriesSatisfying: [:ev | ev isUserEvent]
%

category: 'Actions'
method: GsEventLog
_addSystemEntry: anEntry

	self _entryArray add: anEntry.
	anEntry makeUnmodifiable.
%

category: 'Private-Deleting system entries'
method: GsEventLog
_basicDeleteAllEntries
	"Delete all entries in the recevier, including system events and events that are
	configured to not be deleted. "

	self _entryArray size: 0.
%

category: 'Private-Deleting system entries'
method: GsEventLog
_basicDeleteEntry: anEvent
	"Remove the given event from the receiver"

	self _entryArray remove: anEvent ifAbsent: [].
%

category: 'Private-Deleting system entries'
method: GsEventLog
_deleteEntriesIncludingSystem: anotherEventLog
	"delete all entries in the argument from the receiver, including system events
	and events marked do not delete."

	self _entryArray == anotherEventLog _entryArray ifTrue: [
		"remove all"
		^self _basicDeleteAllEntries].

	anotherEventLog _entryArray do: [:anEvent | self _basicDeleteEntry: anEvent]
%

category: 'Accessing'
method: GsEventLog
_entryArray
	^entryArray
%

category: 'Updating'
method: GsEventLog
_entryArray: newValue
	entryArray := newValue
%

category: 'Accessing'
method: GsEventLog
_newEntriesInvariant
	^newEntriesInvariant
%

category: 'Updating'
method: GsEventLog
_newEntriesInvariant: newValue
	newEntriesInvariant := newValue
%

! Class extensions for 'GsEventLogEntry'

!		Class methods for 'GsEventLogEntry'

category: 'Instance Creation'
classmethod: GsEventLogEntry
debug

	^self _new
		_priority: self debugPriority;
		yourself
%

category: 'Constants'
classmethod: GsEventLogEntry
debugPriority
	^60
%

category: 'Instance Creation'
classmethod: GsEventLogEntry
error

	^self _new
		_priority: self errorPriority;
		yourself
%

category: 'Constants'
classmethod: GsEventLogEntry
errorPriority
	^20
%

category: 'Instance Creation'
classmethod: GsEventLogEntry
fatal

	^self _new
		_priority: self fatalPriority;
		yourself
%

category: 'Constants'
classmethod: GsEventLogEntry
fatalPriority
	^10
%

category: 'Instance Creation'
classmethod: GsEventLogEntry
info

	^self _new
		_priority: self infoPriority;
		yourself
%

category: 'Constants'
classmethod: GsEventLogEntry
infoPriority
	^40
%

category: 'Instance Creation'
classmethod: GsEventLogEntry
trace

	^self _new
		_priority: self tracePriority;
		yourself
%

category: 'Constants'
classmethod: GsEventLogEntry
tracePriority
	^50
%

category: 'Instance Creation'
classmethod: GsEventLogEntry
warning

	^self _new
		_priority: self warningPriority;
		yourself
%

category: 'Constants'
classmethod: GsEventLogEntry
warningPriority
	^30
%

category: 'Instance Creation'
classmethod: GsEventLogEntry
_new
	^super new initialize
%

!		Instance methods for 'GsEventLogEntry'

category: 'Actions'
method: GsEventLogEntry
addToLog

	GsEventLog current addEntry: self
%

category: 'Testing'
method: GsEventLogEntry
canBeDeleted
	^self isInvariant not
%

category: 'Actions'
method: GsEventLogEntry
deleteEntry
	"Delete the receiver from the current GsEventLog"

	GsEventLog current deleteEntry: self
%

category: 'Testing'
method: GsEventLogEntry
hasTag

	^tag ~~ nil
%

category: 'Initialization'
method: GsEventLogEntry
initialize

	pid := System gemVersionReport at: 'processId'.
	timestamp := DateAndTime now.
	object := nil.
	label := String new.
%

category: 'Testing'
method: GsEventLogEntry
isSystemEvent
	^false
%

category: 'Testing'
method: GsEventLogEntry
isUserEvent
	^true
%

category: 'Accessing'
method: GsEventLogEntry
label
	^label
%

category: 'Updating'
method: GsEventLogEntry
label: newValue
	label := newValue
%

category: 'Actions'
method: GsEventLogEntry
makeUnmodifiable
	self immediateInvariant.
%

category: 'Accessing'
method: GsEventLogEntry
object
	^object
%

category: 'Updating'
method: GsEventLogEntry
object: newValue
	object := newValue
%

category: 'Accessing'
method: GsEventLogEntry
pid
	^pid
%

category: 'Displaying'
method: GsEventLogEntry
printOn: aStream

	aStream
		nextPutAll: self timestampString;
		tab;
		nextPutAll: self processIdentification;
		tab;
		nextPutAll: self priorityAsLabel;
		tab;
		nextPutAll: self label.
	self object notNil ifTrue:
		[aStream tab; nextPutAll: self object asString].

%

category: 'Accessing'
method: GsEventLogEntry
priority
	^priority
%

category: 'Displaying'
method: GsEventLogEntry
priorityAsLabel
	self priority = self class errorPriority ifTrue: [^'Error'].
	self priority = self class warningPriority ifTrue: [^'Warn'].
	self priority = self class infoPriority ifTrue: [^'Info'].
	self priority = self class tracePriority ifTrue: [^'Trace'].
	self priority = self class debugPriority ifTrue: [^'Debug'].
	self priority = self class fatalPriority ifTrue: [^'Fatal'].
	^'Unknown'
%

category: 'Displaying'
method: GsEventLogEntry
processIdentification
	^self pid asString
%

category: 'Displaying'
method: GsEventLogEntry
report
	| str |
	str := AppendStream on: String new.
	self printOn: str.
	^str contents
%

category: 'Displaying'
method: GsEventLogEntry
subsecondDigits
	"The number of digits of subsecond resolution for timestamps"
	^4
%

category: 'Accessing'
method: GsEventLogEntry
tag
	^tag
%

category: 'Updating'
method: GsEventLogEntry
tag: newValue
	tag := newValue
%

category: 'Accessing'
method: GsEventLogEntry
timestamp
	^timestamp
%

category: 'Displaying'
method: GsEventLogEntry
timestampString
	| s |
	s := AppendStream on: String new.
	timestamp printLocalWithSubsecondDigits: self subsecondDigits on: s.
	^s contents
%

category: 'Private'
method: GsEventLogEntry
_addSystemEntryToLog

	GsEventLog current _addSystemEntry: self
%

category: 'Updating'
method: GsEventLogEntry
_priority: anInteger
	priority := anInteger
%

! Class extensions for 'GsEventLogSystemEntry'

!		Class methods for 'GsEventLogSystemEntry'

category: 'Instance creation'
classmethod: GsEventLogSystemEntry
new
	self shouldNotImplement: #new
%

!		Instance methods for 'GsEventLogSystemEntry'

category: 'Testing'
method: GsEventLogSystemEntry
canBeDeleted
	^false
%

category: 'Actions'
method: GsEventLogSystemEntry
deleteEntry
	"This protocol does not delete system entries"

	^self
%

category: 'Testing'
method: GsEventLogSystemEntry
isSystemEvent
	^true
%

category: 'Testing'
method: GsEventLogSystemEntry
isUserEvent
	^false
%

category: 'Displaying'
method: GsEventLogSystemEntry
printOn: aStream

	aStream
		nextPutAll: self timestampString;
		tab;
		nextPutAll: self priorityAsLabel;
		tab;
		nextPutAll: '(System) ';
		nextPutAll: self label.

	self object notNil ifTrue:
		[aStream tab; nextPutAll: self object asString].
%

category: 'Accessing'
method: GsEventLogSystemEntry
subsystem
	^subsystem
%

category: 'Updating'
method: GsEventLogSystemEntry
subsystem: newValue
	subsystem := newValue
%

! Class extensions for 'GsIdentityIndex'

!		Instance methods for 'GsIdentityIndex'

category: 'Converting'
method: GsIdentityIndex
asIndexSpecification
  ^ (IdentityIndexSpecification path: self pathComponentsString)
    options: self options;
    requirePathTerms: self termsRequired;
    yourself
%

category: 'Converting'
method: GsIdentityIndex
asQueryEvaluator
  ^ GsIdentityIndexQueryEvaluator on: self
%

category: 'Comparison Operators'
method: GsIdentityIndex
comparisonForCompare
  ^ BtreeComparisonForIdentity new
%

category: 'Comparison Operators'
method: GsIdentityIndex
comparisonForSort
  "called during creation of receiver, so initialize unset instance variables"

  ^ comparisonForSort ifNil: [ comparisonForSort := BtreeComparisonForIdentity new ]
%

category: 'Accessing'
method: GsIdentityIndex
indexType
  ^ #'identity'
%

category: 'Testing'
method: GsIdentityIndex
isIdentityIndex

"Returns true."

^ true
%

category: 'Testing'
method: GsIdentityIndex
_canCompare: aKey withClass: aClass
  "Returns whether the receiver can make B-tree comparisons with the given key."
  ^ true
%

category: 'Testing'
method: GsIdentityIndex
_canCompareWith: aKey
  "Returns whether the receiver can make B-tree comparisons with the given key."

  ^ true
%

category: 'Testing'
method: GsIdentityIndex
_checkSameLastElementClassAsEqualityIndex: equalityIndexObj
  ^ false
%

! Class extensions for 'GsIdentityIndexQueryEvaluator'

!		Instance methods for 'GsIdentityIndexQueryEvaluator'

category: 'Accessing'
method: GsIdentityIndexQueryEvaluator
btreeReadStreamClass
  "Returns the class of btree read stream to create for query results."

  ^ index btreeReadStreamClass
%

category: 'Accessing'
method: GsIdentityIndexQueryEvaluator
btreeRoot

  ^self index btreeRoot
%

category: 'Accessing'
method: GsIdentityIndexQueryEvaluator
comparisonForCompare
  ^ self index comparisonForCompare
%

category: 'Accessing'
method: GsIdentityIndexQueryEvaluator
comparisonForSort
  ^ self index comparisonForSort
%

category: 'Query Select'
method: GsIdentityIndexQueryEvaluator
findAllValuesEqualTo: aValue

"Identity indexes do not support equality comparison."

^ self _errorCannotInvokeRangeOperationOnIdentityIndex
%

category: 'Query Select'
method: GsIdentityIndexQueryEvaluator
findAllValuesGreaterThan: val1
andEquals: bool1
andLessThan: val2
andEquals: bool2

"Identity indexes do not support range comparison."

^ self _errorCannotInvokeRangeOperationOnIdentityIndex
%

category: 'Query Select'
method: GsIdentityIndexQueryEvaluator
findAllValuesGreaterThanKey: aValue andEquals: aBoolean

"Identity indexes do not support range comparison."

^ self _errorCannotInvokeRangeOperationOnIdentityIndex
%

category: 'Query Select'
method: GsIdentityIndexQueryEvaluator
findAllValuesIdenticalTo: aValue do: aBlock
  "Iterates over all values that satisfy the query.  "

  ^ (self findAllValuesIdenticalTo: aValue) do: aBlock
%

category: 'Query Select'
method: GsIdentityIndexQueryEvaluator
findAllValuesLessThanKey: aValue andEquals: aBoolean

"Identity indexes do not support range comparison."

^ self _errorCannotInvokeRangeOperationOnIdentityIndex
%

category: 'Query Select'
method: GsIdentityIndexQueryEvaluator
findAllValuesNotEqualTo: aValue

"Identity indexes do not support equality comparison."

^ self _errorCannotInvokeRangeOperationOnIdentityIndex
%

category: 'Query Detect'
method: GsIdentityIndexQueryEvaluator
findFirstValueEqualTo: aValue

"Identity indexes do not support range comparison."

^ self _errorCannotInvokeRangeOperationOnIdentityIndex
%

category: 'Query Detect'
method: GsIdentityIndexQueryEvaluator
findFirstValueGreaterThan: val1
andEquals: bool1
andLessThan: val2
andEquals: bool2

"Identity indexes do not support range comparison."

^ self _errorCannotInvokeRangeOperationOnIdentityIndex
%

category: 'Query Detect'
method: GsIdentityIndexQueryEvaluator
findFirstValueGreaterThanKey: aValue
andEquals: aBoolean

"Identity indexes do not support range comparison."

^ self _errorCannotInvokeRangeOperationOnIdentityIndex
%

category: 'Query Detect'
method: GsIdentityIndexQueryEvaluator
findFirstValueIdenticalTo: aValue
  "Returns the first value that satisfies the query.  Since this is an identity
 comparison on a range index (which supports equality comparison), create a
 BtreeReadStream for equal values, then iterate through the values making
 the identity comparison."

  | stream |
  stream := self _findAllValuesIdenticalTo: aValue.
  stream == nil
    ifTrue: [ ^ #'_incompletePathTraversal' ].	" iterate through the stream, checking for an identical value "
  [ stream _atEnd ]
    whileFalse: [
      stream _peekKey == aValue
        ifTrue: [ ^ stream _peekRoot ].
      stream _btreeNext ].
  ^ #'_incompletePathTraversal'
%

category: 'Query Detect'
method: GsIdentityIndexQueryEvaluator
findFirstValueLessThanKey: aValue
andEquals: aBoolean

"Identity indexes do not support range comparison."

^ self _errorCannotInvokeRangeOperationOnIdentityIndex
%

category: 'Query Detect'
method: GsIdentityIndexQueryEvaluator
findFirstValueNotEqualTo: aValue

"Identity indexes do not support range comparison."

^ self _errorCannotInvokeRangeOperationOnIdentityIndex
%

category: 'Accessing'
method: GsIdentityIndexQueryEvaluator
readStreamClass
  "Returns the class of read stream to create for query results."

  ^ index readStreamClass
%

category: 'Searching'
method: GsIdentityIndexQueryEvaluator
_findAllValuesGreaterThanKey: aKey andEquals: aBoolean
  "Returns a BtreePlusRangeIndexReadStream that iterates over all objects in the index
 that satisfy the query."

  ^ self
    _findAllValuesGreaterThanKey: aKey
    andEquals: aBoolean
    using: self comparisonForSort
%

category: 'Searching'
method: GsIdentityIndexQueryEvaluator
_findAllValuesGreaterThanKey: aKey andEquals: aBoolean using: aComparison
  "Returns a RangeIndexReadStream that iterates over all objects in the index
 that satisfy the query."

  | array1 array2 stream doNext querySpec |
  (self index _canCompareWith: aKey)
    ifFalse: [ self _error: #'assocErrBadComparison' ].
  stream := self readStreamClass new rangeIndex: self index.
  doNext := false.
  array1 := {}.	" see if querying > or >= "
  aBoolean
    ifTrue: [
      " if >=, perform < and do a 'next' operation later "
      (self btreeRoot
        _findAllValuesLessThanKey: aKey
        andEquals: false
        into: array1
        using: aComparison)
        ifTrue: [ doNext := true ]
        ifFalse: [
          " all were greater than or equal to "
          self btreeRoot
            _putFirstIndexOfFirstChildInto: array1
            ifGreaterThanOrEqualTo: aKey
            using: aComparison ] ]
    ifFalse: [
      " if >, ask the B-tree specifically for > "
      (self btreeRoot
        _findAllValuesGreaterThanKey: aKey
        into: array1
        using: aComparison)
        ifFalse: [
          " none were greater than "
          stream currentStack: {0}.
          ^ stream ] ].
  array2 := {}.
  self btreeRoot _putLastIndexOfLastChildInto: array2.
  stream currentStack: array1.
  stream endIndex: (array2 at: 1).
  stream endNode: (array2 at: 2).
  doNext
    ifTrue: [ stream _advance ].
  querySpec := self index btreeComparisonQuerySpec
    key: aKey selector: (aBoolean
            ifTrue: [ #'>=' ]
            ifFalse: [ #'>' ]);
    yourself.
  stream streamQuerySpec: querySpec.
  ^ stream
%

category: 'Searching'
method: GsIdentityIndexQueryEvaluator
_findFirstKeyNotIdenticalTo: aKey atTerm: pathTerm
  "Returns the first key in the receiver's B-tree that is not identical to the
 given key."

  | stream key |
  stream := self btreeReadStreamClass on: self btreeRoot.
  [ stream _atEnd ] whileFalse: [ key := stream _peekKey.
      key == aKey
        ifFalse: [ ^ key ].
      stream _btreeNext ].
  ^ #'_incompletePathTraversal'
%

! Class extensions for 'GsIndexedQueryEvaluator'

!		Class methods for 'GsIndexedQueryEvaluator'

category: 'Instance Creation'
classmethod: GsIndexedQueryEvaluator
on: anIndex

  ^ self new index: anIndex
%

!		Instance methods for 'GsIndexedQueryEvaluator'

category: 'Accessing'
method: GsIndexedQueryEvaluator
btreeComparisonQuerySpec

  ^self index btreeComparisonQuerySpec
%

category: 'Accessing'
method: GsIndexedQueryEvaluator
collator
  "Return the IcuCollator to be used in comparing Unicode strings"

  ^ self index collator
%

category: 'Accessing'
method: GsIndexedQueryEvaluator
doBlock
  ^ doBlock
%

category: 'Accessing'
method: GsIndexedQueryEvaluator
doBlock: aBlock
  doBlock := aBlock
%

category: 'Query Select'
method: GsIndexedQueryEvaluator
findAllValuesIdenticalTo: aValue
  "Returns a set of all values that satisfy the query.  Since this is an identity
 comparison on a range index (which supports equality comparison), this
 method creates a B-tree read stream for equal values, then iterates through the
 values making the identity comparison."

  | tmpHolder stream |
  " optimize query for objects in the NSC itself "
  self index isIndexOnRootNsc
    ifTrue: [
      doBlock
        ifNil: [
          " optimize query for objects in the NSC itself "
          ^ self _allIdenticalTo: aValue in: self nscRoot ].
      ^ self _allIdenticalTo: aValue in: self nscRoot do: doBlock ].
  stream := self _findAllValuesIdenticalTo: aValue.
  self doBlock
    ifNotNil: [
      stream atEnd
        ifTrue: [ ^ self ].
      ^ [ stream atEnd ]
           whileFalse: [
             | nextKey next |
             nextKey := stream _peekKey.
             next := stream next.
             nextKey == aValue
             ifTrue: [ self doBlock value: next ] ] ].
  stream atEnd
    ifTrue: [ ^ self nscRoot species new ].
  tmpHolder := NscBuilder
    for: self nscRoot species new
    max: self sizeForNscBuilder.
  stream _valuesAddInto: tmpHolder identicalTo: aValue.
  ^ tmpHolder completeBag
%

category: 'Query Select'
method: GsIndexedQueryEvaluator
findAllValuesNotIdenticalTo: aValue
  "Returns a set of all values that satisfy the query."

  | tmpHolder res |
  self index isIndexOnRootNsc
    ifTrue: [
      tmpHolder := self nscRoot species new.
      tmpHolder addAll: self nscRoot.
      tmpHolder removeAll: (self _allIdenticalTo: aValue in: self nscRoot).
      doBlock ifNotNil: [ tmpHolder do: doBlock ].
      ^ tmpHolder ].
  self hasCollectionBasedTerm
    ifTrue: [
      res := self _findAllValuesThroughSetsNotIdenticalTo: aValue.
      doBlock ifNotNil: [ res do: doBlock ].
      ^ res ].
  tmpHolder := NscBuilder
    for: self nscRoot species new
    max: self sizeForNscBuilder.
  tmpHolder _addAllNsc: (self _findAllValuesIdenticalTo: aValue) makeNsc.	" get all objects identical to aValue and identical to nil "
  tmpHolder _addAllNsc: (self _allIdenticalTo: nil in: self nscRoot).
  " get all objects with nil along the path "
  self index _getObjectsWithNilOnPathInto: tmpHolder.
  res := self nscRoot _asIdentityBag - tmpHolder completeBag _asIdentityBag.
  doBlock ifNotNil: [ res do: doBlock ].
  res class == self nscRoot species
    ifFalse: [
      | finalRes |
      finalRes := self nscRoot species new.
      finalRes addAll: res.
      ^ finalRes ].
  ^ res
%

category: 'Query Select'
method: GsIndexedQueryEvaluator
findAllValuesNotIdenticalTo: aValue do: aBlock
  "Iterates over all values that satisfy the query."

  | result |
  result := self findAllValuesNotIdenticalTo: aValue.
  result do: aBlock.
  ^ result
%

category: 'Query Detect'
method: GsIndexedQueryEvaluator
findFirstValueIdenticalTo: aValue

  ^self subclassResponsibility: #findFirstValueIdenticalTo:
%

category: 'Query Detect'
method: GsIndexedQueryEvaluator
findFirstValueNotIdenticalTo: aValue

"Returns the first value that satisfies the query."

| key lastPathTerm |

lastPathTerm := self index lastPathTerm.
" optimize query for objects in the NSC itself "
self index isIndexOnRootNsc
  ifTrue: [
    index nscRoot do: [ :element |
      element == aValue
        ifFalse: [ ^ element ] ].
    ^ #_incompletePathTraversal ].

key := self _findFirstKeyNotIdenticalTo: aValue atTerm: lastPathTerm.
(key == #_incompletePathTraversal)
  ifTrue: [ ^ #_incompletePathTraversal ].

^ self findFirstValueIdenticalTo: key
%

category: 'Testing'
method: GsIndexedQueryEvaluator
hasCollectionBasedTerm
  ^ self index hasCollectionBasedTerm
%

category: 'Testing'
method: GsIndexedQueryEvaluator
hasSetValuedTerm
  ^ self index hasSetValuedTerm
%

category: 'Accessing'
method: GsIndexedQueryEvaluator
index

  ^index
%

category: 'Updating'
method: GsIndexedQueryEvaluator
index: anIndex

  index := anIndex
%

category: 'Accessing'
method: GsIndexedQueryEvaluator
nscRoot

^self index nscRoot
%

category: 'Accessing'
method: GsIndexedQueryEvaluator
sizeForNscBuilder

"Returns the size to be used when an NscBuilder is collecting objects."

^ self nscRoot size
%

category: 'Support'
method: GsIndexedQueryEvaluator
_allIdenticalTo: anObject in: nsc

"Returns a new NSC containing the given object with the number of occurrences
 as in the root NSC."

| result tmp |
result := self _primAllIdenticalTo: anObject in: nsc _asIdentityBag.
result class = nsc species
  ifFalse: [
    tmp := nsc species new.
    tmp addAll: result.
    result := tmp
  ].
^ result
%

category: 'Support'
method: GsIndexedQueryEvaluator
_allIdenticalTo: anObject in: nsc do: aBlock
  "Returns a new NSC containing the given object with the number of occurrences
 as in the root NSC."

  | result |
  result := self _primAllIdenticalTo: anObject in: nsc _asIdentityBag.
  result do: aBlock
%

category: 'Error Handling'
method: GsIndexedQueryEvaluator
_errorCannotInvokeRangeOperationOnIdentityIndex

"An attempt was made to use a range operation (< > = <= >=) on a path
 expression only supported by an identity index."

^ self index _errorCannotInvokeRangeOperationOnIdentityIndex
%

category: 'Searching'
method: GsIndexedQueryEvaluator
_findAllValuesIdenticalTo: aValue
  "Returns a set of all values that satisfy the query."

  | array1 array2 stream doNext |
  " if can't make the comparison, then none are identical "
  (self index _canCompareWith: aValue)
    ifFalse: [ self _error: #'assocErrBadComparison' ].
  " get boundary entries in the B-tree "
  array1 := {}.
  " >=, perform < and do an 'next' operation later "
  doNext := false.
  (self btreeRoot
    _findAllValuesLessThanKey: aValue
    andEquals: false
    into: array1
    using: self comparisonForCompare)
    ifTrue: [ doNext := true ]
    ifFalse: [ " all were greater than or equal to "
      self btreeRoot
        _putFirstIndexOfFirstChildInto: array1
        ifGreaterThanOrEqualTo: aValue
        using: self comparisonForCompare ].
  array2 := {}.
  stream := self readStreamClass on: self index.
  (self btreeRoot
    _findAllValuesLessThanKey: aValue
    andEquals: true
    into: array2
    using: self comparisonForCompare)
    ifFalse: [ " none were found less than "
       stream currentStack: {0}.
       ^ stream ].
  " create the read stream "
  stream currentStack: array1.
  stream endIndex: (array2 at: 1).
  stream endNode: (array2 at: 2).
  doNext
    ifTrue: [ " advance the B-tree positioning "
      stream _advance ].
  ^ stream
%

category: 'Searching'
method: GsIndexedQueryEvaluator
_findAllValuesThroughSetsNotIdenticalTo: aKey
  "Returns a set of all values that satisfy the query.  This method works
 when the path is through a set-valued instance variable."

  |  tmpHolder idx |
  tmpHolder := NscBuilder
    for: self nscRoot species new
    max: self sizeForNscBuilder.
  idx := self index.
  idx btreeRoot _lastRootObjectsNotIdenticalTo: aKey into: tmpHolder.
  ^ tmpHolder completeBag
%

category: 'Searching'
method: GsIndexedQueryEvaluator
_findFirstKeyNotIdenticalTo: aValue atTerm: pathTerm

  ^IndexedQueryEvaluator subclassResponsibility: #_findFirstKeyNotIdenticalTo:atTerm:
%

category: 'Support'
method: GsIndexedQueryEvaluator
_primAllIdenticalTo: anObject in: nsc

"Returns a new NSC containing the given object with the number of occurrences
 as in the root NSC."

<primitive: 340>

self _primitiveFailed: #_primAllIdenticalTo:in: args: { anObject . nsc } .
self _uncontinuableError
%

! Class extensions for 'GsIndexOptions'

!		Class methods for 'GsIndexOptions'

category: 'Accessing'
classmethod: GsIndexOptions
btreePlusIndex
  "Create a btree plus index that uses the new BtreePlusNodes for indexing."

  "Use basicNew to bypass initialization, thus making it possible to use the default index options
   to supply the value for slots not explicitly set or cleared."

  "Only one of legacyIndex or btreePlusIndex may be set in an instance"

  ^ self basicNew
    clearLegacyIndex; "record that legacyIndex is false"
    setBtreePlusIndex;
    yourself
%

category: 'Default'
classmethod: GsIndexOptions
default
  "default options "

  (SessionTemps current at: #GsDefaultIndexOptions ifAbsent: [])
    ifNotNil: [:sessionDefault | ^ sessionDefault ].
  (Globals at: #GsDefaultIndexOptions ifAbsent: [])
    ifNotNil: [ :default | ^ default ].
  "set state explicitly to avoid infinite loop getting default options when no default defined yet."
  ^ self basicNew
      btreePlusIndex: true;
      legacyIndex: false;
      reducedConflict: false;
      optionalPathTerms: false;
      optimizedComparison: false;
      yourself
%

category: 'Default'
classmethod: GsIndexOptions
default: aGsIndexOptions
  "set persistent default options"

  ^ Globals at: #GsDefaultIndexOptions put: aGsIndexOptions _reify immediateInvariant
%

category: 'Accessing'
classmethod: GsIndexOptions
legacyIndex
  "Create a legacy index that uses BtreeNodes instead of the new BtreePlusNodes for indexing."

  "Use basicNew to bypass initialization, thus making it possible to use the default index options
   to supply the value for slots not explicitly set or cleared."

  ^ self basicNew
    clearBtreePlusIndex; "record that btreePlusIndex is false"
    setLegacyIndex;
    yourself
%

category: 'Accessing'
classmethod: GsIndexOptions
optimizedComparison
  "Eliminate per element comparison testing for indexed queries and use native #=
   instead of _idxForCompare* methods when comparisons are needed. In order to be
   able to do these optimizations, the following constraints are imposed on the
   last element values:
    - values must be a kind of the last element class.
    - nil is not allowed as a value.
    - For Float last element class, a NaN is not allowed as a value.
    - For String last element class, Symbols are not allowed as a value.
    - For Symbol last element class, Strings are not allowed as a value.
   "

  "Use basicNew to bypass initialization, thus making it possible to use the default index options
   to supply the value for slots not explicitly set or cleared."

  ^ self basicNew
    optimizedComparison: true; "set directly, to allow optimizedComparision option to be set, when lagacyIndex is default (bug 47145)"
    yourself
%

category: 'Accessing'
classmethod: GsIndexOptions
optionalPathTerms
  "Do not signal an error if instance variable missing along index path."

  "Use basicNew to bypass initialization, thus making it possible to use the default index options
   to supply the value for slots not explicitly set or cleared."

  ^ self basicNew
    setOptionalPathTerms;
    yourself
%

category: 'Accessing'
classmethod: GsIndexOptions
reducedConflict
  "Create a reduced conflict index"

  "Use basicNew to bypass initialization, thus making it possible to use the default index options
   to supply the value for slots not explicitly set or cleared."

  ^ self basicNew
    setReducedConflict;
    yourself
%

category: 'Default'
classmethod: GsIndexOptions
sessionDefault: aGsIndexOptions
  "set default index options for this session only"

  aGsIndexOptions ifNotNil: [ aGsIndexOptions _reify immediateInvariant ].
  ^ SessionTemps current at: #GsDefaultIndexOptions put: aGsIndexOptions
%

!		Instance methods for 'GsIndexOptions'

category: 'Comparison'
method: GsIndexOptions
= aGsIndexOptions
  (aGsIndexOptions isKindOf: self class)
    ifFalse: [ ^ false ].
  ^ self reducedConflict = aGsIndexOptions reducedConflict
    and: [ self optionalPathTerms = aGsIndexOptions optionalPathTerms
        and: [ self legacyIndex = aGsIndexOptions legacyIndex
            and: [ self optimizedComparison = aGsIndexOptions optimizedComparison ] ] ]
%

category: 'Accessing'
method: GsIndexOptions
btreePlusIndex
  ^ self _btreePlusIndex ifNil: [ self defaultOptions btreePlusIndex ]
%

category: 'Private'
method: GsIndexOptions
btreePlusIndex: aBool
  "Private method ... should never be called by method external to GsIndexOptions.
   Use set* and clear* methods instead."

  self dynamicInstVarAt: #'btreePlusIndex' put: aBool.
%

category: 'Operators'
method: GsIndexOptions
clearBtreePlusIndex
  self btreePlusIndex: false.
  self _legacyIndex == false
    ifTrue: [ self setLegacyIndex ]
%

category: 'Operators'
method: GsIndexOptions
clearLegacyIndex
  self legacyIndex: false.
  self _btreePlusIndex == false
    ifTrue: [ self setBtreePlusIndex ]
%

category: 'Operators'
method: GsIndexOptions
clearOptimizedComparison
  self optimizedComparison: false
%

category: 'Operators'
method: GsIndexOptions
clearOptionalPathTerms
  self optionalPathTerms: false
%

category: 'Operators'
method: GsIndexOptions
clearReducedConflict
  self reducedConflict: false
%

category: 'Operators'
method: GsIndexOptions
combineWith: aGsIndexOptions
  "all set/cleared option values in receiver set/cleared in <aGsIndexOptions>"

  self _reducedConflict == true
    ifTrue: [ aGsIndexOptions setReducedConflict ].
  self _reducedConflict == false
    ifTrue: [ aGsIndexOptions clearReducedConflict ].
  self _optionalPathTerms == true
    ifTrue: [ aGsIndexOptions setOptionalPathTerms ].
  self _optionalPathTerms == false
    ifTrue: [ aGsIndexOptions clearOptionalPathTerms ].
  self _legacyIndex == true
    ifTrue: [ aGsIndexOptions setLegacyIndex ].
  self _legacyIndex == false
    ifTrue: [ aGsIndexOptions clearLegacyIndex ].
  self _btreePlusIndex == true
    ifTrue: [ aGsIndexOptions setBtreePlusIndex ].
  self _btreePlusIndex == false
    ifTrue: [ aGsIndexOptions clearBtreePlusIndex ].
  self _optimizedComparison == true
    ifTrue: [ aGsIndexOptions setOptimizedComparison ].
  self _optimizedComparison == false
    ifTrue: [ aGsIndexOptions clearOptimizedComparison ].
  ^ aGsIndexOptions
%

category: 'Accessing'
method: GsIndexOptions
defaultOptions

  ^ self class default
%

category: 'Comparison'
method: GsIndexOptions
hash
  "Returns an Integer hash code for the receiver."

  ^ (((((((self btreePlusIndex hash bitShift: -1)
    bitXor: self reducedConflict hash) bitShift: -1)
    bitXor: self optionalPathTerms hash) bitShift: -1)
    bitXor: self legacyIndex hash) bitShift: -1)
    bitXor: self optimizedComparison hash
%

category: 'Initialize-Release'
method: GsIndexOptions
initialize
  | default |
  super initialize.
  default := self defaultOptions.
  self btreePlusIndex: default btreePlusIndex.
  self legacyIndex: default legacyIndex.
  self reducedConflict: false.
  self optionalPathTerms: false.
  self optimizedComparison: false
%

category: 'Accessing'
method: GsIndexOptions
legacyIndex
  ^ self _legacyIndex ifNil: [ self defaultOptions legacyIndex ]
%

category: 'Private'
method: GsIndexOptions
legacyIndex: aBool
  "Private method ... should never be called by method external to GsIndexOptions.
   Use set* and clear* methods instead."

  self dynamicInstVarAt: #'legacyIndex' put: aBool.
%

category: 'Operators'
method: GsIndexOptions
negateWith: aGsIndexOptions
  "all set/cleared option values in receiver cleared/set in <aGsIndexOptions>"

  self _reducedConflict == true
    ifTrue: [ aGsIndexOptions clearReducedConflict ].
  self _reducedConflict == false
    ifTrue: [ aGsIndexOptions setReducedConflict ].
  self _optionalPathTerms == true
    ifTrue: [ aGsIndexOptions clearOptionalPathTerms ].
  self _optionalPathTerms == false
    ifTrue: [ aGsIndexOptions setOptionalPathTerms ].
  self _legacyIndex == true
    ifTrue: [
      aGsIndexOptions clearLegacyIndex.
      aGsIndexOptions setBtreePlusIndex ].
  self _legacyIndex == false
    ifTrue: [
      aGsIndexOptions setLegacyIndex.
      aGsIndexOptions clearBtreePlusIndex ].
  self _btreePlusIndex == true
    ifTrue: [
      aGsIndexOptions clearBtreePlusIndex.
      aGsIndexOptions setLegacyIndex].
  self _btreePlusIndex == false
    ifTrue: [
      aGsIndexOptions setBtreePlusIndex.
      aGsIndexOptions clearLegacyIndex].
  self _optimizedComparison == true
    ifTrue: [ aGsIndexOptions clearOptimizedComparison ].
  self _optimizedComparison == false
    ifTrue: [ aGsIndexOptions setOptimizedComparison ].
  ^ aGsIndexOptions
%

category: 'Accessing'
method: GsIndexOptions
optimizedComparison
  ^ self _optimizedComparison
    ifNil: [
    self _legacyIndex == true
      ifTrue: [ false ]
      ifFalse: [ self defaultOptions optimizedComparison ] ]
%

category: 'Private'
method: GsIndexOptions
optimizedComparison: aBool
  "Private method ... should never be called by method external to GsIndexOptions.
   Use set* and clear* methods instead."

  self dynamicInstVarAt: #'optimizedComparison' put: aBool
%

category: 'Accessing'
method: GsIndexOptions
optionalPathTerms
  ^ self _optionalPathTerms ifNil: [ self defaultOptions optionalPathTerms ]
%

category: 'Private'
method: GsIndexOptions
optionalPathTerms: aBool
  "Private method ... should never be called by method external to GsIndexOptions.
   Use set* and clear* methods instead."

  self dynamicInstVarAt: #'optionalPathTerms' put: aBool
%

category: 'Printing'
method: GsIndexOptions
printOn: aStream
  self legacyIndex
    ifTrue: [
      self btreePlusIndex
        ifTrue: [
          "should never get here"
          self _errorIncorrectIndexTypeOptionsCombo ].
      aStream nextPutAll: 'GsIndexOptions legacyIndex'.
      self optimizedComparison
        ifTrue: [
          "should never get here"
           self _errorOptimizedComparisonAndLegacyIndexSet ].
      self optionalPathTerms
        ifTrue: [ aStream nextPutAll: ' + GsIndexOptions optionalPathTerms' ].
      self reducedConflict
        ifTrue: [ aStream nextPutAll: ' + GsIndexOptions reducedConflict' ] ]
    ifFalse: [
      self btreePlusIndex
        ifFalse: [
          "should never get here"
          self _errorIncorrectIndexTypeOptionsCombo ].
      aStream nextPutAll: 'GsIndexOptions btreePlusIndex'.
      self optimizedComparison
        ifTrue: [ aStream nextPutAll: ' + GsIndexOptions optimizedComparison'].
      self optionalPathTerms
        ifTrue: [ aStream nextPutAll: ' + GsIndexOptions optionalPathTerms' ].
      self reducedConflict
        ifTrue: [ aStream nextPutAll: ' + GsIndexOptions reducedConflict' ] ]
%

category: 'Accessing'
method: GsIndexOptions
reducedConflict
  ^ self _reducedConflict ifNil: [ self defaultOptions reducedConflict ]
%

category: 'Private'
method: GsIndexOptions
reducedConflict: aBool
  "Private method ... should never be called by method external to GsIndexOptions.
   Use set* and clear* methods instead."

  self dynamicInstVarAt: #'reducedConflict' put: aBool
%

category: 'Operators'
method: GsIndexOptions
setBtreePlusIndex
  self btreePlusIndex: true.
  self legacyIndex
    ifTrue: [ self clearLegacyIndex ]
%

category: 'Operators'
method: GsIndexOptions
setLegacyIndex
  self legacyIndex: true.
  self btreePlusIndex
    ifTrue: [ self clearBtreePlusIndex ].
  self optimizedComparison
    ifTrue: [ self clearOptimizedComparison ]
%

category: 'Operators'
method: GsIndexOptions
setOptimizedComparison
  self legacyIndex
    ifTrue: [
      "do not set optimizedComparison if legacyIndex already set"
      ^ self ].
  self optimizedComparison: true
%

category: 'Operators'
method: GsIndexOptions
setOptionalPathTerms
  self optionalPathTerms: true
%

category: 'Operators'
method: GsIndexOptions
setReducedConflict
  self reducedConflict: true
%

category: 'Private'
method: GsIndexOptions
_btreePlusIndex
  ^ self dynamicInstVarAt: #'btreePlusIndex'
%

category: 'Errors'
method: GsIndexOptions
_errorIncorrectIndexTypeOptionsCombo

  InternalError signal: 'Invalid GsIndexOptions instance: Only one of either legacyIndex or btreePlusIndex options should be set.'
%

category: 'Errors'
method: GsIndexOptions
_errorOptimizedComparisonAndLegacyIndexSet

  InternalError signal: 'Invalid GsIndexOptions instance: optimizedComparison should never be set when legacyIndex is set'
%

category: 'Private'
method: GsIndexOptions
_legacyIndex
  ^ self dynamicInstVarAt: #'legacyIndex'
%

category: 'Private'
method: GsIndexOptions
_optimizedComparison
  ^ self dynamicInstVarAt: #'optimizedComparison'
%

category: 'Private'
method: GsIndexOptions
_optionalPathTerms
  ^ self dynamicInstVarAt: #'optionalPathTerms'
%

category: 'Private'
method: GsIndexOptions
_reducedConflict
  ^ self dynamicInstVarAt: #'reducedConflict'
%

category: 'Private'
method: GsIndexOptions
_reify
  "Ensure that all slots are set or cleared , no nil slots ... nil slots should be set
   consistent with current default options"

  | default |
  default := self defaultOptions.
  self _reducedConflict ifNil: [ self reducedConflict: default reducedConflict ].
  self _optionalPathTerms ifNil: [ self optionalPathTerms: default optionalPathTerms ].
  self _legacyIndex ifNil: [ self legacyIndex: default legacyIndex ].
  self _btreePlusIndex ifNil: [ self btreePlusIndex: default btreePlusIndex ].
  self _optimizedComparison ifNil: [
    self legacyIndex
      ifTrue: [ self optimizedComparison: false ]
      ifFalse: [ self optimizedComparison: default optimizedComparison ] ].
 self legacyIndex
   ifTrue: [
     self optimizedComparison ifTrue: [ self _errorOptimizedComparisonAndLegacyIndexSet ].
     self btreePlusIndex ifTrue: [ self _errorIncorrectIndexTypeOptionsCombo ]].
 self btreePlusIndex
   ifTrue: [ self legacyIndex ifTrue: [ self _errorIncorrectIndexTypeOptionsCombo ]].

%

! Class extensions for 'GsIndexSpec'

!		Instance methods for 'GsIndexSpec'

category: 'Index Creation'
method: GsIndexSpec
createIndexesOn: anNsc
  self specs do: [ :indexSpec | indexSpec createIndexOn: anNsc ]
%

category: 'Private'
method: GsIndexSpec
defaultCollator
  ^ IcuCollator default
%

category: 'Private'
method: GsIndexSpec
defaultOptions
  defaultOptions ifNil: [ defaultOptions := GsIndexOptions default ].
  ^ defaultOptions
%

category: 'Specification'
method: GsIndexSpec
equalityIndex: path lastElementClass: aClass
  "Specify that  an equality index on the given path and last element class, using default
   index options be created."

  self equalityIndex: path lastElementClass: aClass options: self defaultOptions
%

category: 'Specification'
method: GsIndexSpec
equalityIndex: path lastElementClass: aClass options: aGsIndexOptions
  "Specify that an equality index with the given path, last element class and index options
   be created.

   If the last element class is a unicode class (one of the Unicode* classes or any
     CharacterCollection when using unicode comparison mode), then create a unicode
     equality index using the default collator.

   If the reducedConflict option is specified, create a reduced conflict equality index.

   For btree plus indexes, optimized comparisons will not be used. If optimized comparisons is
     desired, use #stringOptimizedIndex:.
"

  | specClass options |
  (RangeEqualityIndex _isUnicodeLastElementClass: aClass)
    ifTrue: [ ^ self unicodeIndex: path collator: self defaultCollator options: aGsIndexOptions ].
  options := (aClass == CharacterCollection or: [aClass isSubclassOf: CharacterCollection])
    ifTrue: [ aGsIndexOptions - GsIndexOptions optimizedComparison ]
    ifFalse: [ aGsIndexOptions ].
  specClass := options reducedConflict
    ifTrue: [ RcEqualityIndexSpecification ]
    ifFalse: [ EqualityIndexSpecification ].
  self specs
    add: ((specClass path: (self preparedPath: path) lastElementClass: aClass)
        options: options;
        yourself)
%

category: 'Specification'
method: GsIndexSpec
identityIndex: path
  "Specify that  an identiy index on the given path, using default index options be created."

  self identityIndex: path options: self defaultOptions
%

category: 'Specification'
method: GsIndexSpec
identityIndex: path options: aGsIndexOptions
  "Specify that an identity index with the given pathand index options be created."

  | options |
  options := aGsIndexOptions.
  (options legacyIndex )
    ifTrue: [
      options reducedConflict
        ifTrue: [ Warning signal: 'The reducedConflict option has no effect for an identity index' ] ]
    ifFalse: [
      "new indexes need to have reducedConflict option explicitly set"
      options := options + GsIndexOptions reducedConflict].
  self specs add: ((IdentityIndexSpecification path: (self preparedPath: path))
        options: options;
        yourself)
%

category: 'Private'
method: GsIndexSpec
preparedPath: aPath
  "strip each from <aPath>"

  | pathTerms stream |
  pathTerms := aPath asArrayOf32PathTerms.
  pathTerms first = #'each'
    ifFalse: [ ^ aPath ].
  stream := String new.
  2 to: pathTerms size do: [ :index |
    stream addAll: (pathTerms at: index).
    index < pathTerms size
      ifTrue: [ stream add: $. ] ].
  ^ stream
%

category: 'Printing'
method: GsIndexSpec
printOn: aStream
  aStream
    nextPutAll: self class name asString , ' new';
    lf.
  1 to: self specs size do: [ :index |
    | spec |
    spec := self specs at: index.
    aStream tab.
    spec printSelectorOn: aStream.
    aStream
      nextPut: $;;
      lf ].
  aStream
    tab;
    nextPutAll: 'yourself.'
%

category: 'Index Creation'
method: GsIndexSpec
removeIndexesFrom: anNsc
  self specs do: [ :indexSpec | indexSpec removeIndexFrom: anNsc ]
%

category: 'Private'
method: GsIndexSpec
specs
  specs ifNil: [ specs := Array new ].
  ^ specs
%

category: 'Specification'
method: GsIndexSpec
stringOptimizedIndex: path
  "Specify that an equality index on the given path be created. The btreePlusIndex and
     optimizedComparison options will be unconditionally set in the index options.

   When unicode comparison mode is in effect (see CharacterCollection
     class>>isInUnicodeComparisonMode), the elements of the collection will be constrained to
     be any type of String (String, Unicode7, DoubleByteString, Unicode16, QuadByteString,
     Unicode32). The current default collator will be used for comparison operations in the
     index.

   When unicode comparison mode is NOT in effect (see CharacterCollection
     class>>isInUnicodeComparisonMode), the elements of the collection will be constrained to
     be a type of non-unicode String (String, DoubleByteString, QuadByteString). The
     native String comparison operators (#<, #<=, #=, #~, #>, #>=, #==, #~~) will be used for
     comparison operations in the index.
"

  self
    stringOptimizedIndex: path
    options: self defaultOptions
%

category: 'Specification'
method: GsIndexSpec
stringOptimizedIndex: path options: aGsIndexOptions
  "Specify that an equality index on the given path using the given index options be created.
     The btreePlusIndex and optimizedComparison options will be unconditionally set in the
     index options.

   When unicode comparison mode is in effect (see CharacterCollection
     class>>isInUnicodeComparisonMode), the elements of the collection will be constrained to
     be any type of String (String, Unicode7, DoubleByteString, Unicode16, QuadByteString,
     Unicode32). The current default collator will be used for comparison operations in the
     index.

   When unicode comparison mode is NOT in effect (see CharacterCollection
     class>>isInUnicodeComparisonMode), the elements of the collection will be constrained to
     be a type of non-unicode String (String, DoubleByteString, QuadByteString). The
     native String comparison operators (#<, #<=, #=, #~, #>, #>=, #==, #~~) will be used
     for comparison operations in the index.
"

  self
    _optimizedCharacterCollectionIndex: path
    constraintType: #string
    collator: nil
    options: aGsIndexOptions
%

category: 'Specification'
method: GsIndexSpec
symbolOptimizedIndex: path
  "Specify that an equality index on the given path be created. The btreePlusIndex and
     optimizedComparison options will be unconditionally set in the index options.

   When unicode comparison mode is in effect (see CharacterCollection
     class>>isInUnicodeComparisonMode), the elements of the collection will be constrained to
     be any type of Symbol (Symbol, DoubleByteSymbol, QuadByteSymbol). The current default
     collator will be used for comparison operations in the index.

   When unicode comparison mode is NOT in effect (see CharacterCollection
     class>>isInUnicodeComparisonMode), the elements of the collection will be constrained to
     be a type of Symbol (Symbol, DoubleByteSymbol, QuadByteSymbol). The native String
     comparison operators (#<, #<=, #=, #~, #>, #>=, #==, #~~) will be used for
     comparison operations in the index.
"

  self
    symbolOptimizedIndex: path
    options: self defaultOptions
%

category: 'Specification'
method: GsIndexSpec
symbolOptimizedIndex: path collator: icuCollator
  "Specify that an equality index on the given path be created. The btreePlusIndex and
     optimizedComparison options will be unconditionally set in the index options.

   Whether or not unicode comparison mode is in effect (see CharacterCollection
     class>>isInUnicodeComparisonMode), the elements of the collection will be constrained to
     be any type of Symbol (Symbol, DoubleByteSymbol, QuadByteSymbol). The given
     collator will be used for comparison operations in the index.
"

  self
    symbolOptimizedIndex: path
    collator: icuCollator
    options: self defaultOptions
%

category: 'Specification'
method: GsIndexSpec
symbolOptimizedIndex: path collator: icuCollator options: aGsIndexOptions
  "Specify that an equality index on the given path using the given index options be created.
     The btreePlusIndex and optimizedComparison options will be unconditionally set in the
     index options.

   Whether or not unicode comparison mode is in effect (see CharacterCollection
     class>>isInUnicodeComparisonMode), the elements of the collection will be constrained to
     be any type of Symbol (Symbol, DoubleByteSymbol, QuadByteSymbol). The given
     collator will be used for comparison operations in the index.
"

  self
    _optimizedCharacterCollectionIndex: path
    constraintType: #symbol
    collator: icuCollator
    options: aGsIndexOptions
%

category: 'Specification'
method: GsIndexSpec
symbolOptimizedIndex: path options: aGsIndexOptions
  "Specify that an equality index on the given path using the given index options be created.
     The btreePlusIndex and optimizedComparison options will be unconditionally set in the
     index options.

   When unicode comparison mode is in effect (see CharacterCollection
     class>>isInUnicodeComparisonMode), the elements of the collection will be constrained to
     be any type of Symbol (Symbol, DoubleByteSymbol, QuadByteSymbol). The current default
     collator will be used for comparison operations in the index.

   When unicode comparison mode is NOT in effect (see CharacterCollection
     class>>isInUnicodeComparisonMode), the elements of the collection will be constrained to
     be a type of Symbol (Symbol, DoubleByteSymbol, QuadByteSymbol). The native String
     comparison operators (#<, #<=, #=, #~, #>, #>=, #==, #~~) for comparison
     operations in the index.
"

  self
    _optimizedCharacterCollectionIndex: path
    constraintType: #symbol
    collator: nil
    options: aGsIndexOptions
%

category: 'Specification'
method: GsIndexSpec
unicodeIndex: path
  "Specify that a unicode equality index on the given path using the default collator and default
    index options be created.

   When using string comparison mode, a unicode equality index is constrained to the unicode
    string classes Unicode7, Unicode16, and Unicode32.

   When using unicode comparison mode, a unicode equality index is constrained to be a type
     of CharacterCollection.

   For btree plus indexes, optimized comparisons will not be used. If optimized comparisons is
     desired, use either #unicodeStringOptimizedIndex: or #symbolOptimizedIndex:collator:.
"

  self
    unicodeIndex: path
    collator: self defaultCollator
    options: self defaultOptions
%

category: 'Specification'
method: GsIndexSpec
unicodeIndex: path collator: collator
  "Specify that a unicode equality index on the given path using the given collator and default
    index options be created.

   When using string comparison mode, a unicode equality index is constrained to the unicode
    string classes Unicode7, Unicode16, and Unicode32.

   When using unicode comparison mode, a unicode equality index is constrained to be a type
     of CharacterCollection.

   For btree plus indexes, optimized comparisons will not be used. If optimized comparisons is
     desired, use either #unicodeStringOptimizedIndex: or #symbolOptimizedIndex:collator:.
"

  self unicodeIndex: path collator: collator options: self defaultOptions
%

category: 'Specification'
method: GsIndexSpec
unicodeIndex: path collator: collator options: aGsIndexOptions
  "Specify that a unicode equality index on the given path using the given collator and given
    index options be created.

   When using string comparison mode, a unicode equality index is constrained to the unicode
    string classes Unicode7, Unicode16, and Unicode32.

   When using unicode comparison mode, a unicode equality index is constrained to be a type
     of CharacterCollection.

   For btree plus indexes, optimized comparisons will not be used. If optimized comparisons is
     desired, use either #unicodeStringOptimizedIndex: or #symbolOptimizedIndex:collator:.
"

  | options specClass spec |
  options := aGsIndexOptions.
  specClass := UnicodeIndexSpecification.
  options := options - GsIndexOptions optimizedComparison.
  options legacyIndex
    ifTrue: [
      options reducedConflict
        ifTrue: [ specClass := RcUnicodeIndexSpecification ] ].
 spec := (specClass path: (self preparedPath: path) collator: collator)
    options: options;
    yourself.
  self specs add: spec
%

category: 'Specification'
method: GsIndexSpec
unicodeIndex: path options: aGsIndexOptions
  "Specify that a unicode equality index on the given path using the default collator and given
    index options be created.

   When using string comparison mode, a unicode equality index is constrained to the unicode
    string classes Unicode7, Unicode16, and Unicode32.

   When using unicode comparison mode, a unicode equality index is constrained to be a type
     of CharacterCollection.

   For btree plus indexes, optimized comparisons will not be used. If optimized comparisons is
     desired, use either #unicodeStringOptimizedIndex: or #symbolOptimizedIndex:collator:.
"

  self unicodeIndex: path collator: self defaultCollator options: aGsIndexOptions
%

category: 'Specification'
method: GsIndexSpec
unicodeStringOptimizedIndex: path
  "Specify that an equality index on the given path be created using the default collator and
     default index options. The btreePlusIndex and optimizedComparison options will be
     unconditionally set in the index options.

   Whether or not unicode comparison mode is in effect (see CharacterCollection
     class>>isInUnicodeComparisonMode), the elements of the collection will be constrained to
     be any type of String (String, Unicode7, DoubleByteString, Unicode16, QuadByteString,
     Unicode32). The current default collator will be used for comparison operations in the
     index.
"

  self
    unicodeStringOptimizedIndex: path
    collator: self defaultCollator
    options: self defaultOptions
%

category: 'Specification'
method: GsIndexSpec
unicodeStringOptimizedIndex: path collator: collator
  "Specify that an equality index on the given path be created using the given collator and
     the default index options. The btreePlusIndex and optimizedComparison options will be
     unconditionally set in the index options.

   Whether or not unicode comparison mode is in effect (see CharacterCollection
     class>>isInUnicodeComparisonMode), the elements of the collection will be constrained to
     be any type of String (String, Unicode7, DoubleByteString, Unicode16, QuadByteString,
     Unicode32). The current default collator will be used for comparison operations in the
     index.
"

  self
    unicodeStringOptimizedIndex: path
    collator: collator
    options: self defaultOptions
%

category: 'Specification'
method: GsIndexSpec
unicodeStringOptimizedIndex: path collator: collator options: aGsIndexOptions
  "Specify that an equality index on the given path be created using the given collator and
     the given index options. The btreePlusIndex and optimizedComparison options will be
     unconditionally set in the index options.

   Whether or not unicode comparison mode is in effect (see CharacterCollection
     class>>isInUnicodeComparisonMode), the elements of the collection will be constrained to
     be any type of String (String, Unicode7, DoubleByteString, Unicode16, QuadByteString,
     Unicode32). The current default collator will be used for comparison operations in the
     index.
"

  self
    _optimizedCharacterCollectionIndex: path
    constraintType: #'unicodeString'
    collator: collator
    options: aGsIndexOptions
%

category: 'Specification'
method: GsIndexSpec
unicodeStringOptimizedIndex: path options: aGsIndexOptions
  "Specify that an equality index on the given path be created using the default collator and
     the given index options. The btreePlusIndex and optimizedComparison options will be
     unconditionally set in the index options.

   Whether or not unicode comparison mode is in effect (see CharacterCollection
     class>>isInUnicodeComparisonMode), the elements of the collection will be constrained to
     be any type of String (String, Unicode7, DoubleByteString, Unicode16, QuadByteString,
     Unicode32). The current default collator will be used for comparison operations in the
     index.
"

  self
    unicodeStringOptimizedIndex: path
    collator: self defaultCollator
    options: aGsIndexOptions
%

category: 'Private'
method: GsIndexSpec
_optimizedCharacterCollectionIndex: path constraintType: constraintType collator: collatorOrNil options: aGsIndexOptions
  "Specify that an equality index on the given path using the given index options be created.
     The btreePlusIndex and optimizedComparison options will be unconditionally set in the
     index options.

   If the collatorOrNil is nil and unicode comparison mode is in effect (see
     CharacterCollection class>>isInUnicodeComparisonMode), the default collator will be used
     for comparison operations in the index.

   If the collatorOrNil is nil and unicode comparison mode is NOT in effect (see
     CharacterCollection class>>isInUnicodeComparisonMode), then the native String
     comparison operators (#<, #<=, #=, #~, #>, #>=, #==, #~~) will be used for
     comparison operations in the index.

   If the collatorOrNil is not nil, the given collator will be used for comparison operations
     in the index, whether or not unicode comparison mode is in effect (see CharacterCollection
     class>>isInUnicodeComparisonMode).
"

  "constraintType may be: #unicodeString, #symbol, or #string:

     If #unicodeString, then the elements of the collection will be constrained to any type of
     String (String, Unicode7, DoubleByteString, Unicode16, QuadByteString, Unicode32) and a
     collator will be used for comparison.

     If #symbol, then the elements of the collection will be constrained to be a type of
     Symbol (Symbol, DoubleByteSymbol, or QuadByteSymbol).

     If #string, then the elements of the collection will be constrained based on whether
       or not unicode comparison mode is in effect or not (see CharacterCollection
       class>>isInUnicodeComparisonMode).

       When unicode comparison mode is in effect the elements of the collection will be
         constrained to be any type of String (String, Unicode7, DoubleByteString, Unicode16,
         QuadByteString,  Unicode32).

       When unicode comparison mode is NOT in effect the elements of the collection will be
         constrained to be a type of non-unicode String (String, DoubleByteString,
         QuadByteString).
"

  | options spec |
  options := aGsIndexOptions + GsIndexOptions btreePlusIndex + GsIndexOptions optimizedComparison.
  spec := constraintType == #unicodeString
    ifTrue: [ | collator |
      collator := collatorOrNil ifNil: [ self defaultCollator ].
      (UnicodeIndexSpecification
        path: (self preparedPath: path)
        collator: collator)
          constraintType: constraintType; "#unicodeString"
          yourself]
    ifFalse: [ | theCollator |
      theCollator := collatorOrNil
        ifNil: [
          CharacterCollection isInUnicodeComparisonMode
            ifTrue: [
              "in unicode comparison mode, we always have a collator"
              self defaultCollator]
            ifFalse: [ nil ] ]
        ifNotNil: [ collatorOrNil ].
      (ConstrainedCharacterCollectionIndexSpecification
        path: (self preparedPath: path)
        collator: theCollator)
          constraintType: constraintType;
          yourself ].
  spec options: options.
  self specs add: spec
%

! Class extensions for 'GsMalformedQueryExpressionError'

!		Class methods for 'GsMalformedQueryExpressionError'

category: 'Instance Creation'
classmethod: GsMalformedQueryExpressionError
bug43764MalformedQuery: explanation senderLocationID: senderLocationID
  "Invalid query formulation. Query cannot be properly evaluated ...
   The query must be rewritten."

  "senderLocationID used to identify the method and/or class of the sender to help
   validate test coverage"

  ^ (self new
    bug43764MalformedQuery: explanation;
    reason: senderLocationID) signal
%

category: 'Instance Creation'
classmethod: GsMalformedQueryExpressionError
bug43764QueryCannotBeAnalyzed: senderLocationID
  "query may be exposed to bug43764, but the query options applyDeMorgansLaws and consolidateRangePredicates must be set before proper analysis can be done"

  "senderLocationID used to identify the method and/or class of the sender to help
   validate test coverage"

  ^ (self new
    bug43764QueryCannotBeAnalyzed;
    reason: senderLocationID) signal
%

category: 'Instance Creation'
classmethod: GsMalformedQueryExpressionError
bug43764QueryMustBeOptimized: senderLocationID
  "Query is not exposed to Bug 43764, but the query must be optimized with the
   appropriate query options to be successfully evaluated"

  "senderLocationID used to identify the method and/or class of the sender to help
   validate test coverage"

  ^ (self new
    bug43764QueryMustBeOptimized;
    reason: senderLocationID) signal
%

category: 'Instance Creation'
classmethod: GsMalformedQueryExpressionError
collectionIsNotQueryable: explanation senderLocationID: senderLocationID
  "Collection is not queryable."

  ^ self new
    collectionIsNotQueryable: explanation;
    reason: senderLocationID;
    signal
%

category: 'Instance Creation'
classmethod: GsMalformedQueryExpressionError
queryIsNotStreamable: explanation senderLocationID: senderLocationID
  "Query is not streamable."

  "senderLocationID used to identify the method and/or class of the sender to help
   validate test coverage"

  ^ (self new
    queryIsNotStreamable: explanation;
    reason: senderLocationID) signal
%

category: 'Instance Creation'
classmethod: GsMalformedQueryExpressionError
streamableQueryCannotBeAnalyzed: senderLocationID
  "cannot determine if query can be streamed, the query options applyDeMorgansLaws and consolidateRangePredicates must be set before proper analysis can be done"

  "senderLocationID used to identify the method and/or class of the sender to help
   validate test coverage"

  ^ (self new
    streamableQueryCannotBeAnalyzed;
    reason: senderLocationID) signal
%

category: 'Instance Creation'
classmethod: GsMalformedQueryExpressionError
streamableQueryMustBeOptimized: senderLocationID
  "Query can be streamed, but the query must be optimized with the
   appropriate query options to be successfully evaluated"

  "senderLocationID used to identify the method and/or class of the sender to help
   validate test coverage"

  ^ (self new
    streamableQueryMustBeOptimized;
    reason: senderLocationID) signal
%

!		Instance methods for 'GsMalformedQueryExpressionError'

category: 'Initialization'
method: GsMalformedQueryExpressionError
bug43764MalformedQuery: explanation
  "Invalid query formulation. Query cannot be properly evaluated ...
   The query must be rewritten."

  self
    errorCondition: #'bug43764MalformedQuery';
    messageText:
        'Invalid query formulation with conjoined collection based path terms: '
            , explanation
            ,
              ' (#bug43764MalformedQuery). See bugnote: http://gemtalksystems.com/data/bugnotes/43764.html.'
%

category: 'Initialization'
method: GsMalformedQueryExpressionError
bug43764QueryCannotBeAnalyzed
  "query may be exposed to bug43764, but the query options applyDeMorgansLaws and consolidateRangePredicates must be set before proper analysis can be done"

  self
    errorCondition: #'bug43764QueryCannotBeAnalyzed';
    messageText:
        'Invalid query formulation involving collection based path terms. Query must be  optimized to properly evaluate exposure to Bug 43764. Set the query options applyDeMorgansLaws and consolidateRangePredicates and try again (#bug43764QueryCannotBeAnalyzed). See bugnote: http://gemtalksystems.com/data/bugnotes/43764.html.'
%

category: 'Initialization'
method: GsMalformedQueryExpressionError
bug43764QueryMustBeOptimized
  "Query is not exposed to Bug 43764, but the query must be optimized with the
   appropriate query options to be successfully evaluated"

  self
    errorCondition: #'bug43764QueryMustBeOptimized';
    messageText:
        'Invalid query formulation involving collection based path terms. If you optimize the query and set the query options applyDeMorgansLaws and consolidateRangePredicates the query can be evaluated successfully (#bug43764QueryMustBeOptimized). See bugnote: http://gemtalksystems.com/data/bugnotes/43764.html.'
%

category: 'Initialization'
method: GsMalformedQueryExpressionError
collectionIsNotQueryable: explanation
  "Collection is not queryable."

  self
    errorCondition: #'collectionIsNotQueryable';
    messageText:
        'A GsQuery may not be created on an instance of class ' , explanation , '.'
            , ' (#collectionIsNotQueryable).'
%

category: 'Accessing'
method: GsMalformedQueryExpressionError
errorCondition
  ^ errorCondition
%

category: 'Accessing'
method: GsMalformedQueryExpressionError
errorCondition: aSymbol
  errorCondition := aSymbol
%

category: 'Initialization'
method: GsMalformedQueryExpressionError
queryIsNotStreamable: explanation
  "Query is not streamable."

  self
    errorCondition: #'queryIsNotStreamable';
    messageText:
        'Query may not be streamed. '
            , explanation , ' (#queryIsNotStreamable).'
%

category: 'Initialization'
method: GsMalformedQueryExpressionError
streamableQueryCannotBeAnalyzed
  "cannot determine if query can be streamed, the query options applyDeMorgansLaws and consolidateRangePredicates must be set before proper analysis can be done"

  self
    errorCondition: #'streamableQueryCannotBeAnalyzed';
    messageText:
        'Invalid query formulation involving collection based path terms. Query must be  optimized to properly evaluate whether or not the query is streamable. Set the query options applyDeMorgansLaws and consolidateRangePredicates and try again (#streamableQueryCannotBeAnalyzed).'
%

category: 'Initialization'
method: GsMalformedQueryExpressionError
streamableQueryMustBeOptimized
  "Query can be streamed, but the query must be optimized with the
   appropriate query options to be successfully evaluated"

  self
    errorCondition: #'streamableQueryMustBeOptimized';
    messageText:
        'Query cannot be streamed as is. If you optimize the query and set the query options applyDeMorgansLaws and consolidateRangePredicates the query can be evaluated successfully (#streamableQueryMustBeOptimized).'
%

! Class extensions for 'GsObjectSecurityPolicySet'

!		Instance methods for 'GsObjectSecurityPolicySet'

category: 'Removing'
method: GsObjectSecurityPolicySet
remove: anObject

"Protected version of Bag | remove:"
<protected>

^ super remove: anObject
%

category: 'Removing'
method: GsObjectSecurityPolicySet
remove: anObject ifAbsent: exceptionBlock

"Protected version of Bag | remove:ifAbsent:"
<protected>

^ super remove: anObject ifAbsent: exceptionBlock
%

category: 'Removing'
method: GsObjectSecurityPolicySet
removeIfPresent: anObject

"Protected version of Bag | removeIfPresent:"
<protected>

^ super removeIfPresent: anObject
%

category: 'Updating'
method: GsObjectSecurityPolicySet
_removeAll: aCollection errIfAbsent: aBool

"Protected version of Bag | _removeAll:errIfAbsent:"
<protected>

^ super _removeAll: aCollection errIfAbsent: aBool
%

! Class extensions for 'GsOptionalPathTerm'

!		Instance methods for 'GsOptionalPathTerm'

category: 'Testing'
method: GsOptionalPathTerm
isOptionalTerm
  ^ true
%

category: 'Testing'
method: GsOptionalPathTerm
termsRequired
  "Answer true if receiver requires that instance variables of indexed objects are present "

  ^ false
%

category: 'Traversing'
method: GsOptionalPathTerm
_getNextObjectForTraversal: anObject
  " get the next object along the path "

  | ivOffset nextObj |
  ivOffset := anObject _findIVOffsetForPathTerm: self.
  ivOffset == nil
    ifTrue: [ nextObj := nil ]
    ifFalse: [ nextObj := anObject instVarAt: ivOffset ].
  ^ nextObj
%

! Class extensions for 'GsOptions'

!		Class methods for 'GsOptions'

category: 'instance creation'
classmethod: GsOptions
new
  ^ self basicNew initialize
%

!		Instance methods for 'GsOptions'

category: 'Operators'
method: GsOptions
+ aGsQueryOptions
  ^ aGsQueryOptions combineWith: self copy
%

category: 'Operators'
method: GsOptions
- aGsQueryOptions
  ^ aGsQueryOptions negateWith: self copy
%

category: 'Operators'
method: GsOptions
combineWith: aGsQueryOptions
  self subclassResponsibility: #'combineWith:'
%

category: 'initialization'
method: GsOptions
initialize

%

category: 'Operators'
method: GsOptions
negateWith: aGsQueryOptions
  self subclassResponsibility: #'negateWith:'
%

category: 'Operators'
method: GsOptions
not

  ^ self negateWith: self class basicNew
%

! Class extensions for 'GsPathConstantPredicate'

!		Instance methods for 'GsPathConstantPredicate'

category: 'transforming'
method: GsPathConstantPredicate
bind: variableName to: value
  ^ self operator == #'unary'
    ifTrue: [
      | bound |
      bound := self copy.
      bound operand1: (bound operand1 bind: variableName to: value).
      ^ bound immediateInvariant ]
    ifFalse: [ super bind: variableName to: value ]
%

category: 'private'
method: GsPathConstantPredicate
bindEvaluators
  evaluator1 := self
    _bindEvaluator: nsc
    for: self path
    isRangeEqualityOperation: (self isRangeEqualityOperation: self operator).
  super bindEvaluators
%

category: 'optimizing'
method: GsPathConstantPredicate
canConsolidateEnumeratedWith: secondaryPredicate
  ^ secondaryPredicate canConsolidateEnumeratedWithPathConstantPredicate: self
%

category: 'optimizing'
method: GsPathConstantPredicate
canConsolidateEnumeratedWithPathConstantPredicate: primaryPredicate
  | pathTerms primaryPathTerms |
  (primaryPredicate operand1 hasSamePathAs: self operand1)
    ifTrue: [ ^ false ].
  (primaryPredicate isConstantBound and: [ self isConstantBound ])
    ifFalse: [ ^ false ].
  primaryPredicate operator == self operator
    ifFalse: [ ^ false ].
  (primaryPredicate constant _idxForCompareEqualTo: self constant)
    ifFalse: [ ^ false ].
  pathTerms := self _pathTerms.
  primaryPathTerms := primaryPredicate _pathTerms.
  ^ pathTerms size = primaryPathTerms size
%

category: 'optimizing'
method: GsPathConstantPredicate
canConsolidateWith: secondaryPredicate
  ^ secondaryPredicate canConsolidateWithPathConstantPredicate: self
%

category: 'optimizing'
method: GsPathConstantPredicate
canConsolidateWithPathConstantPredicate: primaryPredicate
  | op1 op2 |
  (primaryPredicate operand1 hasSamePathAs: self operand1)
    ifFalse: [ ^ false ].
  (primaryPredicate isConstantBound and: [ self isConstantBound ])
    ifFalse: [ ^ false ].
  op1 := primaryPredicate operator.
  op2 := self operator.
  ((op1 == #'>' or: [ op1 == #'>=' ]) and: [ op2 == #'<' or: [ op2 == #'<=' ] ])
    ifTrue: [
      " if first operator is > or >= and last operator is < or <= "
      ^ primaryPredicate constant _idxForCompareLessThanOrEqualTo: self constant ].
  ((op1 == #'<' or: [ op1 == #'<=' ]) and: [ op2 == #'>' or: [ op2 == #'>=' ] ])
    ifTrue: [
      " if first operator is < or <= and last operator is > or >= "
      ^ primaryPredicate constant
        _idxForCompareGreaterThanOrEqualTo: self constant ].
  ^ false
%

category: 'transforming'
method: GsPathConstantPredicate
collapseToRangePredicateForConstantPathPredicate: aConstantPathPredicate
  (self compatibleRangeOperatorsFor: aConstantPathPredicate operator)
    ifFalse: [ ^ super collapseToRangePredicateForConstantPathPredicate: aConstantPathPredicate ].
  ^ GsRangeQueryPredicate
    operand: aConstantPathPredicate operand1 copy
    operator: aConstantPathPredicate operator
    path: self path
    operator: self operator
    operand: self operand2 copy
%

category: 'transforming'
method: GsPathConstantPredicate
collapseToRangePredicateForPathConstantPredicate: aPathConstantPredicate
  (self compatibleInverseRangeOperatorsFor: aPathConstantPredicate operator)
    ifFalse: [ ^ super collapseToRangePredicateForPathConstantPredicate: aPathConstantPredicate ].
  ^ GsRangeQueryPredicate
    operand: aPathConstantPredicate operand2 copy
    operator: (self inverseOperatorFor: aPathConstantPredicate operator)
    path: self path
    operator: self operator
    operand: self operand2 copy
%

category: 'transforming'
method: GsPathConstantPredicate
collapseToRangePredicateIfPossible: aPathXPredicate
  ^ aPathXPredicate collapseToRangePredicateForPathConstantPredicate: self
%

category: 'transforming'
method: GsPathConstantPredicate
consolidateEnumeratedWith: secondaryPredicate
  "caller must ensure that canConsolidateEnumeratedWith: has already been called"

  | pathTerms secondaryPathTerms candidateOperand1 candidatePathString |
  pathTerms := self _pathTerms.
  secondaryPathTerms := secondaryPredicate _pathTerms.
  candidatePathString := 'each'.
  1 to: pathTerms size do: [ :i |
    | primaryTerm secondaryTerm |
    primaryTerm := pathTerms at: i.
    secondaryTerm := secondaryPathTerms at: i.
    primaryTerm = secondaryTerm
      ifTrue: [ candidatePathString := candidatePathString , '.' , primaryTerm ]
      ifFalse: [
        primaryTerm > secondaryTerm
          ifTrue: [
            | swap |
            swap := primaryTerm.
            primaryTerm := secondaryTerm.
            secondaryTerm := swap ].
        candidatePathString := candidatePathString , '.' , primaryTerm , '|'
          , secondaryTerm ] ].
  candidateOperand1 := GsQueryPathReferenceAssociation
    newWithKey: candidatePathString
    value: nil.
  ^ GsPathConstantPredicate
    operand: candidateOperand1
    operator: operator
    operand: operand2
%

category: 'transforming'
method: GsPathConstantPredicate
consolidateWith: secondaryPredicate
  (secondaryPredicate canConsolidateWithPathConstantPredicate: self)
    ifFalse: [
      self
        error:
          'Cannot consolidate ' , self printString , ' with '
            , secondaryPredicate printString ].
  (self compatibleInverseRangeOperatorsFor: secondaryPredicate operator)
    ifFalse: [ self error: 'fail safe test failed' ].
  ^ (self operator == #'>' or: [ self operator == #'>=' ])
    ifTrue: [
      GsRangeQueryPredicate
        operand: self operand2 copy
        operator: (self inverseOperatorFor: self operator)
        path: self path
        operator: secondaryPredicate operator
        operand: secondaryPredicate operand2 copy ]
    ifFalse: [
      GsRangeQueryPredicate
        operand: secondaryPredicate operand2 copy
        operator:
          (secondaryPredicate inverseOperatorFor: secondaryPredicate operator)
        path: self path
        operator: self operator
        operand: self operand2 copy ]
%

category: 'accessing'
method: GsPathConstantPredicate
constant
  ^ self operand2 _idxValue
%

category: 'querying'
method: GsPathConstantPredicate
executeAndDo: aBlock
  ^ self executeAndDo: aBlock using: self operator
%

category: 'querying-private'
method: GsPathConstantPredicate
executeAndDo: aBlock using: anOperator
  | queryEvaluator |
  queryEvaluator := self evaluator1 asQueryEvaluator.
  queryEvaluator doBlock: aBlock.
  ^ self executeClauseUsing: anOperator queryEvaluator: queryEvaluator
%

category: 'querying-private'
method: GsPathConstantPredicate
executeClause
  ^ self executeClauseUsing: self operator
%

category: 'querying-private'
method: GsPathConstantPredicate
executeClauseNegated
  ^ self executeClauseUsing: self operatorNegated
%

category: 'querying-private'
method: GsPathConstantPredicate
executeClauseUsing: anOperator
  | queryEvaluator |
  queryEvaluator := self evaluator1 asQueryEvaluator.
  ^ self executeClauseUsing: anOperator queryEvaluator: queryEvaluator
%

category: 'querying-private'
method: GsPathConstantPredicate
executeClauseUsing: anOperator queryEvaluator: queryEvaluator
  | theOperator theConstant |
  theOperator := anOperator.
  theConstant := self constant.
  theOperator == #'unary'
    ifTrue: [
      theOperator := #'=='.
      theConstant := true ].
  theOperator == #'unaryNot'
    ifTrue: [
      theOperator := #'~~'.
      theConstant := true ].
  self _check: self evaluator1 compare: theOperator value: theConstant.
  (theOperator == #'<' or: [ theOperator == #'<=' ])
    ifTrue: [
      (theConstant == nil and: [ theOperator == #'<=' ])
        ifTrue: [ ^ queryEvaluator findAllValuesEqualTo: nil ]
        ifFalse: [
          ^ queryEvaluator
            findAllValuesLessThanKey: theConstant
            andEquals: theOperator == #'<=' ] ].
  (theOperator == #'>' or: [ theOperator == #'>=' ])
    ifTrue: [
      (theConstant == nil and: [ theOperator == #'>=' ])
        ifTrue: [ ^ queryEvaluator findAllValuesEqualTo: nil ]
        ifFalse: [
          ^ queryEvaluator
            findAllValuesGreaterThanKey: theConstant
            andEquals: theOperator == #'>=' ] ].
  theOperator == #'='
    ifTrue: [ ^ queryEvaluator findAllValuesEqualTo: theConstant ].
  theOperator == #'~='
    ifTrue: [ ^ queryEvaluator findAllValuesNotEqualTo: theConstant ].
  theOperator == #'=='
    ifTrue: [ ^ queryEvaluator findAllValuesIdenticalTo: theConstant ].
  theOperator == #'~~'
    ifTrue: [ ^ queryEvaluator findAllValuesNotIdenticalTo: theConstant ]
%

category: 'querying-private'
method: GsPathConstantPredicate
executeNegatedAndDo: aBlock
  ^ self executeAndDo: aBlock using: self operatorNegated
%

category: 'testing'
method: GsPathConstantPredicate
isConstantBound
  (self operator == #'unary' or: [ self operator == #'unaryNot' ])
    ifTrue: [ ^ false ].
  ^ self operand2 isBound
%

category: 'querying-private'
method: GsPathConstantPredicate
lastElementValue: anObject
  "anObject is the value obtained by traversing path terms to the last value ... analgous to the last element class"

  | theOperator theConstant |
  theOperator := self operator.
  theConstant := self constant.
  theOperator == #'unary'
    ifTrue: [
      theOperator := #'=='.
      theConstant := true ].
  theOperator == #'unaryNot'
    ifTrue: [
      theOperator := #'~~'.
      theConstant := true ].
  ^ anObject
    perform: (self comparisonSelectorFor: theOperator)
    with: theConstant
%

category: 'testing'
method: GsPathConstantPredicate
operand1IsPath
  ^ true
%

category: 'querying-private'
method: GsPathConstantPredicate
prepareForExecution
  "Return an object equivalent to the receiver that is prepared for execution within
   the context of a block."

  | ans |
  ans := GsPreparedPathConstantPredicate new
    path1: operand1;
    operator: operator;
    constant2: self constant;
    _nsc: nsc collator: collator;
    evaluator1: evaluator1;
    prepare.
  ^ans
%

category: 'printing'
method: GsPathConstantPredicate
printOn: aStream
  self operator ~~ #'unary'
    ifTrue: [ ^ super printOn: aStream ].
  aStream nextPutAll: '( ' , self operand1 key asString , ' )'
%

category: 'accessing'
method: GsPathConstantPredicate
rawPath
  ^ self operand1
%

category: 'optimizing'
method: GsPathConstantPredicate
redundantDisjunctivePredicateBetween: secondaryPredicate
  ^ secondaryPredicate redundantDisjunctivePredicateBetweenPathConstant: self
%

category: 'optimizing'
method: GsPathConstantPredicate
redundantDisjunctivePredicateBetweenPathConstant: primaryPredicate
  | op1 op2 |
  (primaryPredicate operand1 hasSamePathAs: self operand1)
    ifFalse: [ ^ nil ].
  (primaryPredicate isConstantBound and: [ self isConstantBound ])
    ifFalse: [ ^ nil ].
  (primaryPredicate constant == nil or: [ self constant == nil ])
    ifTrue: [ ^ nil ].
  op1 := primaryPredicate operator.
  op2 := self operator.
  op1 == op2
    ifTrue: [
      " operators are the same "
      (op1 == #'<' or: [ op1 == #'<=' ])
        ifTrue: [
          " operator: < or <= "
          " choose largest value "
          ^ (primaryPredicate constant _idxForCompareLessThan: self constant)
            ifTrue: [ primaryPredicate ]
            ifFalse: [ self ] ].
      (op1 == #'>' or: [ op1 == #'>=' ])
        ifTrue: [
          " operator: > or >= "
          " choose smallest value "
          ^ (primaryPredicate constant _idxForCompareGreaterThan: self constant)
            ifTrue: [ primaryPredicate ]
            ifFalse: [ self ] ].
      (op1 == #'=' or: [ op1 == #'~=' ])
        ifTrue: [
          " operator: = or ~="
          ^ (primaryPredicate constant _idxForCompareEqualTo: self constant)
            ifTrue: [ self ]
            ifFalse: [ nil ] ].
      (op1 == #'==' or: [ op1 == #'~~' ])
        ifTrue: [
          " operator: == or ~~"
          ^ primaryPredicate constant == self constant
            ifTrue: [ self ]
            ifFalse: [ nil ] ] ]
    ifFalse: [
      " operators are different "
      ((op1 == #'<' and: [ op2 == #'<=' ])
        or: [ op1 == #'<=' and: [ op2 == #'<' ] ])
        ifTrue: [
          " op1: < and op2: <= "
          " op1: <= and op2: < "
          " choose largest value "
          ^ (primaryPredicate constant _idxForCompareLessThan: self constant)
            ifTrue: [ primaryPredicate ]
            ifFalse: [
              (primaryPredicate constant _idxForCompareGreaterThan: self constant)
                ifTrue: [ self ]
                ifFalse: [
                  " operands are = "
                  op1 == #'<'
                    ifTrue: [ primaryPredicate ]
                    ifFalse: [ self ] ] ] ].
      ((op1 == #'>' and: [ op2 == #'>=' ])
        or: [ op1 == #'>=' and: [ op2 == #'>' ] ])
        ifTrue: [
          " op1: > and op2: >= "
          " op1: >= and op2: > "
          " choose largest value "
          ^ (primaryPredicate constant _idxForCompareGreaterThan: self constant)
            ifTrue: [ primaryPredicate ]
            ifFalse: [
              (primaryPredicate constant _idxForCompareLessThan: self constant)
                ifTrue: [ self ]
                ifFalse: [
                  " operands are = "
                  op1 == #'>'
                    ifTrue: [ primaryPredicate ]
                    ifFalse: [ self ] ] ] ].
      ((op1 == #'=' and: [ op2 == #'==' ])
        or: [ op1 == #'==' and: [ op2 == #'=' ] ])
        ifTrue: [
          " op1: = and op2: == "
          " op1: == and op2: = "
          ^ primaryPredicate constant == self constant
            ifTrue: [
              op2 == #'=='
                ifTrue: [ primaryPredicate ]
                ifFalse: [ self ] ]
            ifFalse: [ nil ] ].
      ((op1 == #'==' and: [ op2 == #'~~' ])
        or: [ op1 == #'~~' and: [ op2 == #'==' ] ])
        ifTrue: [
          " op1: == and op2: ~~ "
          " op1: ~~ and op2: == "
          ^ primaryPredicate constant == self constant
            ifTrue: [ self _unsatisfiableQuery ]
            ifFalse: [ self _unsatisfiableQuery ] ].
      (op1 == #'=' or: [ op1 == #'==' ])
        ifTrue: [
          " op1: = or op1: =="
          op2 == #'<'
            ifTrue: [
              " op2: < "
              ^ (primaryPredicate constant _idxForCompareLessThan: self constant)
                ifTrue: [ primaryPredicate ]
                ifFalse: [ nil ] ].
          op2 == #'<='
            ifTrue: [
              " op2: <= "
              ^ (primaryPredicate constant
                _idxForCompareLessThanOrEqualTo: self constant)
                ifTrue: [ primaryPredicate ]
                ifFalse: [ nil ] ].
          op2 == #'>'
            ifTrue: [
              " op2: > "
              ^ (primaryPredicate constant
                _idxForCompareGreaterThan: self constant)
                ifTrue: [ primaryPredicate ]
                ifFalse: [ nil ] ].
          op2 == #'>='
            ifTrue: [
              " op2: >= "
              ^ (primaryPredicate constant
                _idxForCompareGreaterThanOrEqualTo: self constant)
                ifTrue: [ primaryPredicate ]
                ifFalse: [ nil ] ].
          op2 == #'~='
            ifTrue: [
              " op2: ~= "
              ^ (primaryPredicate constant _idxForCompareEqualTo: self constant)
                ifTrue: [ self _unsatisfiableQuery ]
                ifFalse: [ self _unsatisfiableQuery ] ] ].
      (op2 == #'=' or: [ op2 == #'==' ])
        ifTrue: [
          " op2: = or op2: =="
          op1 == #'<'
            ifTrue: [
              " op1: < "
              ^ (self constant _idxForCompareLessThan: primaryPredicate constant)
                ifTrue: [ self ]
                ifFalse: [ nil ] ].
          op1 == #'<='
            ifTrue: [
              " op1: <= "
              ^ (self constant
                _idxForCompareLessThanOrEqualTo: primaryPredicate constant)
                ifTrue: [ self ]
                ifFalse: [ nil ] ].
          op1 == #'>'
            ifTrue: [
              " op1: > "
              ^ (self constant
                _idxForCompareGreaterThan: primaryPredicate constant)
                ifTrue: [ self ]
                ifFalse: [ nil ] ].
          op1 == #'>='
            ifTrue: [
              " op1: >= "
              ^ (self constant
                _idxForCompareGreaterThanOrEqualTo: primaryPredicate constant)
                ifTrue: [ self ]
                ifFalse: [ nil ] ].
          op1 == #'~='
            ifTrue: [
              " op1: ~= "
              ^ (self constant _idxForCompareEqualTo: primaryPredicate constant)
                ifTrue: [ self _unsatisfiableQuery ]
                ifFalse: [ self _unsatisfiableQuery ] ] ] ].
  ^ nil
%

category: 'optimizing'
method: GsPathConstantPredicate
redundantPredicateBetween: secondaryPredicate
  ^ secondaryPredicate redundantPredicateBetweenPathConstant: self
%

category: 'optimizing'
method: GsPathConstantPredicate
redundantPredicateBetweenPathConstant: primaryPredicate
  | op1 op2 |
  (primaryPredicate operand1 hasSamePathAs: self operand1)
    ifTrue: [
      primaryPredicate operand1 hasEnumeratedTerm
        ifTrue: [ ^ nil ] ]
    ifFalse: [ ^ nil ].
  (primaryPredicate isConstantBound and: [ self isConstantBound ])
    ifFalse: [ ^ nil ].
  (primaryPredicate constant == nil or: [ self constant == nil ])
    ifTrue: [ ^ nil ].
  op1 := primaryPredicate operator.
  op2 := self operator.
  op1 == op2
    ifTrue: [
      " operators are the same "
      (op1 == #'<' or: [ op1 == #'<=' ])
        ifTrue: [
          " operator: < or <= "
          " choose smallest value "
          ^ (primaryPredicate constant _idxForCompareLessThan: self constant)
            ifTrue: [ self ]
            ifFalse: [ primaryPredicate ] ].
      (op1 == #'>' or: [ op1 == #'>=' ])
        ifTrue: [
          " operator: > or >= "
          " choose largest value "
          ^ (primaryPredicate constant _idxForCompareGreaterThan: self constant)
            ifTrue: [ self ]
            ifFalse: [ primaryPredicate ] ].
      op1 == #'='
        ifTrue: [
          " operator: = "
          ^ (primaryPredicate constant _idxForCompareEqualTo: self constant)
            ifTrue: [ self ]
            ifFalse: [ self _unsatisfiableQuery ] ].
      op1 == #'~='
        ifTrue: [
          " operator: = "
          ^ (primaryPredicate constant _idxForCompareEqualTo: self constant)
            ifTrue: [ self ]
            ifFalse: [ nil ] ].
      op1 == #'=='
        ifTrue: [
          " operator: == "
          ^ primaryPredicate constant == self constant
            ifTrue: [ self ]
            ifFalse: [ self _unsatisfiableQuery ] ].
      op1 == #'~~'
        ifTrue: [
          " operator: == "
          ^ primaryPredicate constant == self constant
            ifTrue: [ self ]
            ifFalse: [ nil ] ] ]
    ifFalse: [
      " operators are different "
      ((op1 == #'<' and: [ op2 == #'<=' ])
        or: [ op1 == #'<=' and: [ op2 == #'<' ] ])
        ifTrue: [
          " op1: < and op2: <= "
          " op1: <= and op2: < "
          " choose smallest value "
          ^ (primaryPredicate constant _idxForCompareLessThan: self constant)
            ifTrue: [ self ]
            ifFalse: [
              (primaryPredicate constant _idxForCompareGreaterThan: self constant)
                ifTrue: [ primaryPredicate ]
                ifFalse: [
                  " operands are = "
                  op1 == #'<'
                    ifTrue: [ self ]
                    ifFalse: [ primaryPredicate ] ] ] ].
      ((op1 == #'>' and: [ op2 == #'>=' ])
        or: [ op1 == #'>=' and: [ op2 == #'>' ] ])
        ifTrue: [
          " op1: > and op2: >= "
          " op1: >= and op2: > "
          " choose largest value "
          ^ (primaryPredicate constant _idxForCompareGreaterThan: self constant)
            ifTrue: [ self ]
            ifFalse: [
              (primaryPredicate constant _idxForCompareLessThan: self constant)
                ifTrue: [ primaryPredicate ]
                ifFalse: [
                  " operands are = "
                  op1 == #'>'
                    ifTrue: [ self ]
                    ifFalse: [ primaryPredicate ] ] ] ].
      ((op1 == #'=' and: [ op2 == #'==' ])
        or: [ op1 == #'==' and: [ op2 == #'=' ] ])
        ifTrue: [
          " op1: = and op2: == "
          " op1: == and op2: = "
          ^ primaryPredicate constant == self constant
            ifTrue: [
              op2 == #'=='
                ifTrue: [ primaryPredicate ]
                ifFalse: [ self ] ]
            ifFalse: [ self _unsatisfiableQuery ] ].
      ((op1 == #'==' and: [ op2 == #'~~' ])
        or: [ op1 == #'~~' and: [ op2 == #'==' ] ])
        ifTrue: [
          " op1: == and op2: ~~ "
          " op1: ~~ and op2: == "
          ^ primaryPredicate constant == self constant
            ifTrue: [ self _unsatisfiableQuery ]
            ifFalse: [
              op1 == #'=='
                ifTrue: [ self ]
                ifFalse: [ primaryPredicate ] ] ].
      (op1 == #'=' or: [ op1 == #'==' ])
        ifTrue: [
          " op1: = or op1: =="
          op2 == #'<'
            ifTrue: [
              " op2: < "
              ^ (primaryPredicate constant _idxForCompareLessThan: self constant)
                ifTrue: [ self ]
                ifFalse: [ self _unsatisfiableQuery ] ].
          op2 == #'<='
            ifTrue: [
              " op2: <= "
              ^ (primaryPredicate constant
                _idxForCompareLessThanOrEqualTo: self constant)
                ifTrue: [ self ]
                ifFalse: [ self _unsatisfiableQuery ] ].
          op2 == #'>'
            ifTrue: [
              " op2: > "
              ^ (primaryPredicate constant
                _idxForCompareGreaterThan: self constant)
                ifTrue: [ self ]
                ifFalse: [ self _unsatisfiableQuery ] ].
          op2 == #'>='
            ifTrue: [
              " op2: >= "
              ^ (primaryPredicate constant
                _idxForCompareGreaterThanOrEqualTo: self constant)
                ifTrue: [ self ]
                ifFalse: [ self _unsatisfiableQuery ] ].
          op2 == #'~='
            ifTrue: [
              " op2: ~= "
              ^ (primaryPredicate constant _idxForCompareEqualTo: self constant)
                ifTrue: [ self _unsatisfiableQuery ]
                ifFalse: [ self ] ] ].
      (op2 == #'=' or: [ op2 == #'==' ])
        ifTrue: [
          " op2: = or op2: =="
          op1 == #'<'
            ifTrue: [
              " op1: < "
              ^ (self constant _idxForCompareLessThan: primaryPredicate constant)
                ifTrue: [ primaryPredicate ]
                ifFalse: [ self _unsatisfiableQuery ] ].
          op1 == #'<='
            ifTrue: [
              " op1: <= "
              ^ (self constant
                _idxForCompareLessThanOrEqualTo: primaryPredicate constant)
                ifTrue: [ primaryPredicate ]
                ifFalse: [ self _unsatisfiableQuery ] ].
          op1 == #'>'
            ifTrue: [
              " op1: > "
              ^ (self constant
                _idxForCompareGreaterThan: primaryPredicate constant)
                ifTrue: [ primaryPredicate ]
                ifFalse: [ self _unsatisfiableQuery ] ].
          op1 == #'>='
            ifTrue: [
              " op1: >= "
              ^ (self constant
                _idxForCompareGreaterThanOrEqualTo: primaryPredicate constant)
                ifTrue: [ primaryPredicate ]
                ifFalse: [ self _unsatisfiableQuery ] ].
          op1 == #'~='
            ifTrue: [
              " op1: ~= "
              ^ (self constant _idxForCompareEqualTo: primaryPredicate constant)
                ifTrue: [ self _unsatisfiableQuery ]
                ifFalse: [ primaryPredicate ] ] ] ].
  ^ nil
%

category: 'initialization'
method: GsPathConstantPredicate
_fromArray: varsArray terms: termsArray links: linksArray paths: pathsArray startingAt: i
  self
    path1:
      (self _pathFrom: linksArray paths: pathsArray offset: (termsArray at: i + 6)).
  operator := self operationSelectors at: (termsArray at: i) + 1.
  operator == #'unary'
    ifTrue: [
      "recast predicate to be '== true'"
      operator := #'=='.
      self constant2: true ]
    ifFalse: [ self constant2: (varsArray at: (termsArray at: i + 2)) ]
%

category: 'private'
method: GsPathConstantPredicate
_unsatisfiableQuery
  GsUnsatisfiableQueryNotification signal.
  ^ nil
%

! Class extensions for 'GsPathPathPredicate'

!		Instance methods for 'GsPathPathPredicate'

category: 'accessing'
method: GsPathPathPredicate
bagEnumeratorFor: anOperator
  | op enumerator |
  op := self comparisonSelectorFor: anOperator.
  (self collator == nil or: [ op == #'==' or: [ op == #'~~' ] ])
    ifTrue: [
      enumerator := PathPathBagEnumerator new
        selector: op .
        ]
    ifFalse: [
      enumerator := PathPathBagUnicodeEnumerator new
        selector: op , #'collator:';
        collator: self collator .
        ].
  enumerator
    evaluator: self evaluator1;
    evaluator2: self evaluator2 .
  ^ enumerator
%

category: 'private'
method: GsPathPathPredicate
bindEvaluators
  "unconditionally use pathEvaluatorClass"

  | pathEvaluator |
  pathEvaluator := self pathEvaluatorFor: self path1.
  evaluator1 := pathEvaluator nsc: nsc.
  pathEvaluator := self pathEvaluatorFor: self path2.
  evaluator2 := pathEvaluator nsc: nsc.
  super bindEvaluators
%

category: 'querying-private'
method: GsPathPathPredicate
elementValue: anObject
  "the pathTerms in the query will use anObject as the starting point ... analagous to an object in the nsc that is bound to a query"

  | evaluatorA evaluatorB tmp1 tmp2 |
  evaluatorA := evaluator1 ifNil: [ self pathEvaluatorFor: self path1 ].
  evaluatorB := evaluator2 ifNil: [ self pathEvaluatorFor: self path2 ].
  tmp1 := Array new.
  tmp2 := Array new.
  evaluatorA traverse: anObject startingAt: 1 into: tmp1.
  evaluatorB traverse: anObject startingAt: 1 into: tmp2.
  tmp1
    do: [ :obj1 |
      tmp2
        do: [ :obj2 |
          (obj1 perform: (self comparisonSelectorFor: self operator) with: obj2)
            ifTrue: [ ^ true ] ] ].
  ^ false
%

category: 'accessing'
method: GsPathPathPredicate
elementValueEvaluator
  "Ambiguous ... elementValue: does not use this method"

  ^ self shouldNotImplement: #'elementValueEvaluator
'
%

category: 'accessing'
method: GsPathPathPredicate
evaluator
  ^ evaluator1
%

category: 'accessing'
method: GsPathPathPredicate
evaluator2
  ^ evaluator2
%

category: 'accessing'
method: GsPathPathPredicate
evaluator2: anEvaluator
  evaluator2 := anEvaluator
%

category: 'querying-private'
method: GsPathPathPredicate
executeAndDo: aBlock using: anOperator
  (self bagEnumeratorFor: anOperator)
    doBlock: aBlock;
    findAllValues
%

category: 'querying-private'
method: GsPathPathPredicate
executeClause
  ^ self executeClauseUsing: self operator
%

category: 'querying-private'
method: GsPathPathPredicate
executeClauseNegated
  ^ self executeClauseUsing: self operatorNegated
%

category: 'querying-private'
method: GsPathPathPredicate
executeClauseUsing: anOperator
  ^ (self bagEnumeratorFor: anOperator) findAllValues
%

category: 'querying-private'
method: GsPathPathPredicate
executeNegatedAndDo: aBlock
  ^ self executeAndDo: aBlock using: self operatorNegated
%

category: 'testing'
method: GsPathPathPredicate
isPathPath
  ^ true
%

category: 'testing'
method: GsPathPathPredicate
operand1IsPath
  ^ true
%

category: 'testing'
method: GsPathPathPredicate
operand2IsPath
  ^ true
%

category: 'accessing'
method: GsPathPathPredicate
path
  "Ambiguous - path1 and path2 both exist"

  ^ self shouldNotImplement: #'path'
%

category: 'accessing'
method: GsPathPathPredicate
path1
  ^ self operand1 key
%

category: 'accessing'
method: GsPathPathPredicate
path2
  ^ self operand2 key
%

category: 'querying'
method: GsPathPathPredicate
readStream
  self shouldNotImplement: #'readStream'
%

category: 'transforming'
method: GsPathPathPredicate
transformCommonPaths
  "If the predicate is a path-path and path paths are the same:
	- if operator is =, ==, <=, >= predicate will always be true.
	  Transform  to unary true query
	- otherwise the predicate will always be false.
	  Transform  to unary false query"

  (self operand1 hasSamePathAs: self operand2)
    ifFalse: [ ^ self ].
  (#(#'=' #'==' #'<=' #'>=') includes: self operator)
    ifTrue: [ ^ GsQueryPredicate constant: true ].
  ^ GsQueryPredicate constant: false
%

category: 'private'
method: GsPathPathPredicate
unbindEvaluators
  "remove all bindings"

  super unbindEvaluators.
  evaluator2 := nil
%

category: 'testing'
method: GsPathPathPredicate
usesPathEvaluator
  ^ self evaluator1 isPathEvaluator and: [ self evaluator2 isPathEvaluator ]
%

category: 'private'
method: GsPathPathPredicate
_evaluators
  "return list of evaluators associated with predicate"

  ^ {(self evaluator1).
  (self evaluator2)}
%

category: 'initialization'
method: GsPathPathPredicate
_fromArray: varsArray terms: termsArray links: linksArray paths: pathsArray startingAt: i
  self
    path2:
      (self _pathFrom: linksArray paths: pathsArray offset: (termsArray at: i + 6)).
  operator := self
    inverseOperatorFor: (self operationSelectors at: (termsArray at: i) + 1).
  self
    path1:
      (self _pathFrom: linksArray paths: pathsArray offset: (termsArray at: i + 3))
%

category: 'accessing'
method: GsPathPathPredicate
_pathTerms
  "ambiguous"

  ^ self shouldNotImplement: #'_pathTerms'
%

! Class extensions for 'GsPathTerm'

!		Class methods for 'GsPathTerm'

category: 'Instance Creation'
classmethod: GsPathTerm
new

"Create an initialized instance of the receiver."

^ self basicNew initialize
%

!		Instance methods for 'GsPathTerm'

category: 'Adding'
method: GsPathTerm
addDirectMappingFor: anObject root: rootObject nsc: anNsc logging: aBoolean
  " Update the B-tree and the dependency list for anObject."

  updateBtree ~~ nil
    ifTrue: [ updateBtree btreeAt: anObject put: anObject root: rootObject ].
  needsDepList
    ifTrue: [ " add an entry in the dependency list "
      anObject getDepListAndAddLastElementPathTerm: self logging: aBoolean ]
%

category: 'Adding'
method: GsPathTerm
addMappingsForObject: anObject at: ivOffset root: rootObject logging: aBoolean
  ^self addMappingsForObject: anObject root: rootObject logging: aBoolean
%

category: 'Adding'
method: GsPathTerm
addMappingsForObject: anObject logging: aBoolean
  self addMappingsForObject: anObject root: anObject logging: aBoolean
%

category: 'Adding'
method: GsPathTerm
addMappingsForObject: anObject root: rootObject logging: aBoolean
  "Add dependency list entries for anObject."

  | ivOffset nextObj |
  (nil == anObject or: [ self size == 0 ])
    ifTrue: [ ^ self ].
  (ivOffset := self _ivOffsetFor: anObject) == nil
    ifTrue: [ ^ self _errorInvalidOffset: anObject ].
  anObject
    getDepListAndAddPathTerm: self
    withIVOffset: ivOffset
    logging: aBoolean.	" add an entry to the objects dependency list "
  nextObj := self _nextObjectFor: anObject atInstVar: ivOffset.	" get the next object along the path "
  updateBtree ~~ nil
    ifTrue: [ " insert an entry into the B-tree "
      (self _checkBtreeComparisonWith: nextObj)
        ifFalse: [
          ImproperOperation new
            _number:
                (ErrorSymbols at: #'rtErrRangeEqualityIndexInvalidClassKindForBtree');
            args: { nextObj class. self name. updateBtree lastElementClassDescription };
            signal ].
      updateBtree btreeAt: nextObj put: anObject root: rootObject.
      needsDepList
        ifTrue: [ " add an entry to the very last object's dependency list "
          nextObj getDepListAndAddLastElementPathTerm: self logging: aBoolean ] ].
  nil == nextObj
    ifTrue: [ ^ self recordNilOnPathForRoot: rootObject].
  1 to: children size do: [ :i | " make recursive call to add mappings "
    (children at: i)
      addMappingsForObject: nextObj
      root: rootObject
      logging: aBoolean ]
%

category: 'Adding'
method: GsPathTerm
addMappingsForObject: rootObject traverseUpTo: aPathTerm for: anIndexObject logging: aBoolean
  | object |
  object := anIndexObject traverse: rootObject upTo: aPathTerm.
  self addMappingsForObject: object root: rootObject logging: aBoolean
%

category: 'Formatting'
method: GsPathTerm
asString
  ^ super asString , ' on ' , self name asString printString
%

category: 'Audit'
method: GsPathTerm
auditDepListFor: obj index: indexObj using: auditor optionalSentinel: optionalSentinel
  "Private."

  | depList j nextObj ivOffset |
  (nil == obj or: [ self size == 0 ])
    ifTrue: [ ^ self ].
  depList := DependencyList for: obj.
  depList == nil
    ifTrue: [
      (obj isInvariant not and: [ self isOptionalTerm not ])
        ifTrue: [ auditor pathTermObjectHasNoDependencyList: self object: obj indexObj: indexObj depList: depList ].
      nextObj := self _nextObjectFor: obj ]
    ifFalse: [
      (DepListTable _hasDependencyBitFor: obj)
        ifFalse: [ auditor pathTermObjectHasNoDependencyBitSet: self object: obj indexObj: indexObj depList: depList ].
      j := depList _findOffsetForPathTerm: self.
      j == nil
        ifTrue: [
          | ivOff |
          "no entry for self in depList"
          ivOff := self _ivOffsetFor: obj.
          (self isOptionalTerm and: [ ivOff isNil ])
            ifTrue: [
              "no dependencyList if there's no slot"
              nextObj := optionalSentinel ]
            ifFalse: [ auditor dependencyListHasNoEntryForPathTerm: self object: obj indexObj: indexObj depList: depList ] ]
        ifFalse: [
          "found entry for self in depList"
          ivOffset := depList at: j + 1.	"may be negative for last element reference count"
          ivOffset < 0
            ifTrue: [
              "reference count for last element, but we don't expect reference
               count here ... see needsDepList clause below where depList
               existence is sufficient"
              auditor dependencyListUnexpectedLastElementLocation: self object: obj indexObj: indexObj depList: depList ivOffset: ivOffset.
              ^ obj ]
            ifFalse: [ | expectedIvOffset |
              ivOffset ~~ (expectedIvOffset := self _ivOffsetFor: obj)
                ifTrue: [
                  auditor dependencyListHasIncorrectIvOffset: self object: obj indexObj: indexObj depList: depList ivOffset: ivOffset expectedIvOffset: expectedIvOffset.
                  ivOffset := expectedIvOffset "allow audit to continue, despite fatal nature of this situation" ].
              nextObj := obj instVarAt: ivOffset ] ] ].
  ((needsDepList and: [ nextObj ~~ nil ])
    and: [ DependencyList needsDepList: nextObj ])
    ifTrue: [
      depList := DependencyList for: nextObj.
      (depList == nil and: [ self isOptionalTerm not ])
        ifTrue: [ auditor pathTermObjectHasNoDependencyList: self object: obj indexObj: indexObj depList: depList ] ].
  ^ nextObj
%

category: 'Audit'
method: GsPathTerm
auditDepListForLastElementObject: obj occurrences: num index: indexObj using: auditor
  | depList j |
  (self size == 0 or: [ obj isInvariant ])
    ifTrue: [ ^ self ].
  depList := DependencyList for: obj.
  depList == nil
    ifTrue: [ auditor
        pathTermObjectHasNoDependencyList: self
        object: obj
        indexObj: indexObj
        depList: depList ]
    ifFalse: [ (DepListTable _hasDependencyBitFor: obj)
        ifFalse: [ auditor
            pathTermObjectHasNoDependencyBitSet: self
            object: obj
            indexObj: indexObj
            depList: depList ].
      j := depList _findOffsetForPathTerm: self.
      j == nil
        ifTrue: [ "hack to avoid false positives for index paths ending in *"
          self name = #'*'
            ifFalse: [ auditor
                dependencyListHasNoEntryForPathTerm: self
                object: obj
                indexObj: indexObj
                depList: depList ] ]
        ifFalse: [ | referenceCount nonReferenceCountTerm |
          referenceCount := depList at: j + 1.
          nonReferenceCountTerm := false.
          referenceCount > 0
            ifTrue: [ "upgraded indexes from pre-3.2 may have positive rerence count, but only for Byte indexable ojbects"
              obj class isBytes
                ifFalse: [ "ivOffset and not a reference count"
                  nonReferenceCountTerm := true ] ]
            ifFalse: [ referenceCount := referenceCount negated ].
          nonReferenceCountTerm
            ifTrue: [ "not a reference count and will be audited by PathTerm>>auditDepListFor:index:on:optionalSentinel: "
              "noop"
               ]
            ifFalse: [ referenceCount == num
                ifFalse: [ auditor
                    dependencyListHasIncorrectRefCount: self
                    object: obj
                    indexObj: indexObj
                    depList: depList
                    referenceCount: referenceCount
                    numOccurrences: num ] ] ] ]
%

category: 'Audit'
method: GsPathTerm
auditDirectNscCountsFor: obj using: auditor count: btreeCounts
  "Private. "

  | index |
  self size == 0
    ifTrue: [ ^ self ].
  (needsDepList and: [ nil ~~ obj ])
    ifTrue: [ | depList |
      depList := DependencyList for: obj.
      (depList == nil and: [ obj isInvariant not ])
        ifTrue: [ auditor pathTermObjectHasNoDependencyList: self object: obj indexObj: nil depList: depList ]
        ifFalse: [ obj isInvariant not
            ifTrue: [ (DepListTable _hasDependencyBitFor: obj)
                ifFalse: [ auditor pathTermObjectHasNoDependencyBitSet: self object: obj indexObj: nil depList: depList ] ] ] ].
  index := 1.
  1 to: self size do: [ :i | | count indexObj |
    indexObj := self at: i.
    indexObj size == offset
      ifTrue: [ count := btreeCounts at: index.
        count == 0
          ifTrue: [ auditor pathTermIncorrectNumberOfBtreeEntries: self index: i offset: offset ].
        btreeCounts at: index put: count - 1.
        index := index + 1 ] ]
%

category: 'Audit'
method: GsPathTerm
auditInfo: array using: auditor
  auditor auditInfoFor: self info: array
%

category: 'Audit'
method: GsPathTerm
auditNsc: nsc on: aString level: level
  "Verifies that the equality index objects are consistent.
 Returns a string that describes any inconsistencies found."

  | indexObj btreeCounts count |
  "aString add: 'entering obj, num is ', num printString; lf."
  self size == 0
    ifTrue: [ ^ aString ].	" for each index that utilizes the path term "
  level == 1 ifTrue: [ self auditUpdateCache: nsc on: aString ].
  btreeCounts := {}.
  1 to: self size do: [ :i | indexObj := self at: i.
    indexObj size == offset
      ifTrue: [ " verify B-tree has correct entries "
        count := indexObj btreeRoot
          auditNsc: nsc
          for: self
          offset: i
          on: aString.
        btreeCounts add: count ] ].
  1 to: children size do: [ :i | | resultArray |
    resultArray := (children at: i) auditNsc: nsc on: aString level: level + 1.
    btreeCounts add: resultArray ].
  ^ btreeCounts
%

category: 'Audit'
method: GsPathTerm
auditNscCountsFor: obj on: aString count: btreeCounts
  "Private. "

  | auditor |
  auditor := BtreePlusNodeAuditor new auditResultString: aString; yourself.
  true
    ifTrue:[ self auditNscCountsFor: obj using: auditor count: btreeCounts ]
    ifFalse: [
      "use this audit to provide more detailed information about btree element count audit failures"
      "not fully tested, but it is know to provide better information audit errors with the
       BtreePlusNodeAuditor>>pathTermIncorrectNumberOfBtreeEntries:index:offset: message."

      "bypass call to _auditBtreeCounts:on: in UnorderedCollection>>_fastAuditEqualityIndexes as well"
      self auditNscForRootObj: obj rootObj: obj using: auditor ].
  ^ auditor auditResultString
%

category: 'Audit'
method: GsPathTerm
auditNscCountsFor: obj using: auditor count: btreeCounts
  "Private. "

  | nextObj index optionalSentinel |
  self size == 0
    ifTrue: [ ^ self ].
  self indicatesIndexOnNscElements
    ifTrue: [ ^ self auditDirectNscCountsFor: obj using: auditor count: btreeCounts ].
  nil == obj
    ifTrue: [ ^ self ].
  optionalSentinel := Object new.
  nextObj := self
    auditDepListFor: obj
    index: nil
    using: auditor
    optionalSentinel: optionalSentinel.
  nextObj == optionalSentinel
    ifTrue: [ ^ self ].
  index := 1.
  1 to: self size do: [ :i | | count indexObj |
    indexObj := self at: i.
    indexObj size == offset
      ifTrue: [ count := btreeCounts at: index.
        (count == 0 and: [ self isOptionalTerm not ])
          ifTrue: [ "an index with optional path terms may have 0 entries"
             auditor pathTermIncorrectNumberOfBtreeEntries: self index: i offset: offset ].
        (count == 0 and: [ self isOptionalTerm ])
          ifFalse: [ btreeCounts at: index put: count - 1 ].
        index := index + 1 ] ].
  1 to: children size do: [ :i | (children at: i)
      auditNscCountsFor: nextObj
      using: auditor
      count: (btreeCounts at: index).
    index := index + 1 ]
%

category: 'Audit'
method: GsPathTerm
auditNscForRootObj: obj rootObj: rootObj using: auditor
  "Private. "

  | nextObj optionalSentinel |
  self size == 0
    ifTrue: [ ^ self ].
  self indicatesIndexOnNscElements
    ifTrue: [ "^ self auditDirectNscRootObj: obj using: auditor" self error: 'not yet implemented' ].
  nil == obj
    ifTrue: [ ^ self ].
  optionalSentinel := Object new.
  nextObj := self
    auditDepListFor: obj
    index: nil
    using: auditor
    optionalSentinel: optionalSentinel.
  (nextObj == optionalSentinel or: [ nextObj == nil ])
    ifTrue: [ ^ self ].
  1 to: self size do: [ :i | | indexObj |
    indexObj := self at: i.
    indexObj size == offset
      ifTrue: [ | col found expected |
        col := IdentityBag new.
        indexObj btreeRoot btreeRootNode _findAndCountKey: nextObj value: obj root: rootObj into: col.
        (found := col size) == (expected := indexObj nscRoot occurrencesOf: rootObj)
          ifFalse: [
            auditor
              btree: indexObj btreeRoot
              incorrectCountForKeyValueRootPairs: self
              key: nextObj
              value: obj
              root: rootObj
              found: found
              expected: expected ] ] ].
  1 to: children size do: [ :i | (children at: i)
      auditNscForRootObj: nextObj
      rootObj: rootObj
      using: auditor ]
%

category: 'Audit'
method: GsPathTerm
auditUpdateCache: nsc on: aString
  "Verifies that the update caches (nilOnPath) are consistent.
 Returns a string that describes any inconsistencies found."

  | auditor prevObj |
  auditor := BtreePlusNodeAuditor new auditResultString: aString; yourself.
  prevObj := #_incompletePathTraversal.
  nsc do: [ :obj |
    obj ~~ prevObj
      ifTrue: [
        self auditUpdateCacheFor: obj
          root: obj
          nilOnPathRoots: nil
          occurrences: (nsc occurrencesOf: obj)
          using: auditor ].
    prevObj := obj ].
%

category: 'Audit'
method: GsPathTerm
auditUpdateCacheFor: anObject root: root nilOnPathRoots: nilOnPathRoots occurrences: num using: auditor
  "verify proper accounting for objects with nil on path"

  | ivOffset nextObj |
  self indicatesIndexOnRootNsc
    ifTrue: [ ^ self ].
  (ivOffset := self _ivOffsetFor: anObject) == nil
    ifTrue: [
      self isOptionalTerm ifTrue: [ ^ self ].
      auditor pathTermInvalidIvOffset: self ivOffset: ivOffset object: anObject ].
  nextObj := self _nextObjectFor: anObject atInstVar: ivOffset.
  (nil == nextObj and: [ updateBtree isNil ])
    ifTrue: [
      | nilOnPathNum |
      nilOnPathNum := nilOnPath occurrencesOf: root.
      nilOnPathRoots
        ifNil: [
          nilOnPathNum = num
           ifFalse: [ auditor pathTermIncorrectNilOnPathCount: self root: root got: nilOnPathNum  expected: num ] ]
        ifNotNil: [
          | expected count |
          expected := nilOnPathRoots occurrencesOf: root.
          count := 0.
          expected
            timesRepeat: [
              nilOnPathRoots
                remove: root
                ifAbsent: [
                  auditor pathTermIncorrectNilOnPathCount: self root: root got: count expected: expected.
                  ^ self ].
              count := count + 1 ] ].
      ^ self ].
  1 to: children size do: [ :i |
    (children at: i)
      auditUpdateCacheFor: nextObj
      root: root
      nilOnPathRoots: nilOnPathRoots
      occurrences: num
      using: auditor ]
%

category: 'Accessing'
method: GsPathTerm
children

"Returns the value of the instance variable 'children'."

^children
%

category: 'Updating'
method: GsPathTerm
children: newValue

"Modify the value of the instance variable 'children'."

children := newValue
%

category: 'Updating Indexes'
method: GsPathTerm
cleanupDependencyListFor: anObject
  ""

  | ivOffset nextObj depList |
  (nil == anObject or: [ self size == 0 ])
    ifTrue: [ ^ self ].
  (depList := DependencyList for: anObject) == nil
    ifTrue: [ ^ self ].
  ivOffset := depList removeCompletelyPathTerm: self for: anObject.	" remove the receiver from the dependency list "
  (self indicatesIndexOnRootNsc
    or: [
      "last element dependency list"
      ivOffset < 0 ])
    ifTrue: [ ^ self ].
  ivOffset == 0
    ifTrue: [ nextObj := self _nextObjectFor: anObject ]
    ifFalse: [
      [ nextObj := self _nextObjectFor: anObject atInstVar: ivOffset ]
        onException: Error
        do: [ :ex |
          "Handle any error thrown during execution of _nextObjectFor:
     Cannot resolve the path for this guy --- can't have been added to index,
     in fact this object could have caused the failure in the first place"
          ^ self ] ].
  nil == nextObj
    ifTrue: [ ^ self ].
  needsDepList
    ifTrue: [
      (depList := DependencyList for: nextObj) ~~ nil
        ifTrue: [ depList removeCompletelyPathTerm: self for: nextObj ].
      ^ self ].
  1 to: children size do: [ :i | (children at: i) cleanupDependencyListFor: nextObj ]
%

category: 'Clustering'
method: GsPathTerm
clusterDepthFirst

"Cluster the receiver."

name cluster.
securityPolicies cluster.
children cluster.
1 to: children size do: [ :i | (children at: i) cluster ]
%

category: 'Testing'
method: GsPathTerm
coversIvOffset: anIvOffset for: anObject
  "Answer true if the receiver covers the given iv offset (see bug 46705)"

  ^false
%

category: 'Modification'
method: GsPathTerm
findAllReachableNilOnPathRoots

  | reachableRoots |
  reachableRoots := IdentityBag new.
  reachableRoots addAll: nilOnPath.
  1 to: children size do: [:i |
    reachableRoots addAll: (children at: i) findAllReachableNilOnPathRoots ].
  ^ reachableRoots
%

category: 'Modification'
method: GsPathTerm
findReachableNilOnPathRoots

  | reachableRoots |
  reachableRoots := IdentityBag new.
  reachableRoots addAll: nilOnPath.
  1 to: children size do: [:i |
    reachableRoots addAll: (children at: i) nilOnPath ].
  ^ reachableRoots
%

category: 'Modification'
method: GsPathTerm
findReachableRootObjectMaps: rootObjectMap for: anObject ivOffset: ivOffset oldValue: oldValue sanity: sanity
  | traversalRootObjects |
  self findRootObjectMaps: rootObjectMap for: anObject ivOffset: ivOffset oldValue: oldValue.
  traversalRootObjects := rootObjectMap resolveTraversalRootObjectsFor: anObject.
  ^ traversalRootObjects
%

category: 'Collection Based Modification'
method: GsPathTerm
findReachableRootObjectMapsFor: anObject
  | rootObjectMap indexObj reachableRoots rootObjects |
  rootObjectMap := BtreePlusRootObjectMap new
    pivotObject: anObject;
    pivotPathTerm: self;
    yourself.
  self findRootObjectMaps: rootObjectMap for: anObject.
  rootObjects := rootObjectMap resolveTraversalRootObjectsFor: anObject.
  indexObj := self at: self size.
  reachableRoots := IdentityBag new.
  rootObjects asIdentitySet do: [:root |
    (indexObj traverseAllWithParents: root upTo: self startingAt: 1)
      do: [ :ar | | intermediateObjectReachableFromRoot |
         intermediateObjectReachableFromRoot := ar at: 2.
        intermediateObjectReachableFromRoot == anObject
          ifTrue: [ reachableRoots add: root withOccurrences: (rootObjects occurrencesOf: root) ] ] ].
  ^ reachableRoots
%

category: 'Modification'
method: GsPathTerm
findReachableRootObjectMapsFor: anObject ivOffset: ivOffset oldValue: oldValue
  | rootObjectMap |
  rootObjectMap := BtreePlusRootObjectMap new
    pivotObject: anObject;
    pivotPathTerm: self;
    yourself.
  ^ self
    findReachableRootObjectMaps: rootObjectMap
    for: anObject
    ivOffset: ivOffset
    oldValue: oldValue
    sanity: false
%

category: 'Collection Based Modification'
method: GsPathTerm
findReachableRootsFor: anObject
  | rootObjects indexObj reachableRoots |
  rootObjects := self findRootObjectsFor: anObject.
  indexObj := self at: self size.
  "select rootObjects for which anNsc is reachable"
  reachableRoots := IdentityBag new.
  rootObjects asIdentitySet do: [:root |
    (indexObj traverseAllWithParents: root upTo: self startingAt: 1)
      do: [ :ar | | intermediateObjectReachableFromRoot |
         intermediateObjectReachableFromRoot := ar at: 2.
        intermediateObjectReachableFromRoot == anObject
          ifTrue: [ reachableRoots add: root withOccurrences: (rootObjects occurrencesOf: root) ] ] ].
  ^ reachableRoots
%

category: 'Modification'
method: GsPathTerm
findReachableRootsFor: anObject ivOffset: ivOffset oldValue: oldValue
  | rootObjects indexObj reachableRoots reachableNilOnPathRoots |
  rootObjects := self findRootObjectsFor: anObject ivOffset: ivOffset oldValue: oldValue.
  reachableNilOnPathRoots := self findReachableNilOnPathRoots.
  rootObjects addAll: reachableNilOnPathRoots.
  indexObj := self at: self size.
  "select rootObjects for which anObject is reachable"
  reachableRoots := IdentityBag new.
  rootObjects asIdentitySet do: [:root |
    (self traverseAllReachableFor: root indexObj: indexObj)
      do: [ :intermediateObjectReachableFromRoot |
        intermediateObjectReachableFromRoot == anObject
          ifTrue: [ reachableRoots add: root withOccurrences: (rootObjects occurrencesOf: root) ] ] ].
  ^ reachableRoots
%

category: 'Collection Based Modification'
method: GsPathTerm
findRootObjectMaps: rootObjectMap for: anObject
  "Traverse btree nodes from receiver to leaf term. Collect rootObjects for all btree elements
   for which anObject is a key or parent of a key."

  | ivOffset |
  ivOffset := self _ivOffsetFor: anObject.
  ivOffset ifNil: [ self _invalidIvOffset: anObject ].
  self findRootObjectMaps: rootObjectMap for: anObject ivOffset: ivOffset
%

category: 'Collection Based Modification'
method: GsPathTerm
findRootObjectMaps: rootObjectMap for: anObject ivOffset: ivOffset
  "Traverse btree nodes from receiver to leaf term. Collect rootObjects for all btree elements
   for which anObject at is a key or parent of a key."

  | nextObj |
  nextObj := self _nextObjectFor: anObject atInstVar: ivOffset.
  nextObj
    ifNil: [
      | indexObj |
      indexObj := self at: self size.
      nilOnPath do: [:nilOnPathRoot |
        indexObj
          traverse: nilOnPathRoot
          parent: nil
          thru: self
          startingAt: 1
          do: [ :term :parent :child |
            (rootObjectMap traversalMap at: child ifAbsentPut: [ IdentityBag new ]) add: parent  ] ] ].
  updateBtree ~~ nil
    ifTrue: [
      "btree exists for receiver, collect the root objects, where anObject is the key and nextObj
       is the value."
      self findRootObjectMaps: rootObjectMap forKey: nextObj value: anObject ].
  (nil == nextObj or: [ self children isEmpty ])
    ifTrue: [ ^ self ].
  1 to: children size do: [:i |
    (children at: i) findRootObjectMaps: rootObjectMap for: nextObj ]
%

category: 'Collection Based Modification'
method: GsPathTerm
findRootObjectMaps: rootObjectMap for: anObject ivOffset: ivOffset oldValue: oldValue
  "Traverse btree nodes from receiver to leaf term. Collect rootObjects for all btree elements
   for which anObject at is a key or parent of a key."

  | nextObj |
  nextObj := self _nextObjectFor: anObject atInstVar: ivOffset.
  oldValue
    ifNil: [
      (rootObjectMap traversalMap includesKey: anObject)
        ifFalse: [
          | indexObj pivotObject  nscRoot |
          indexObj := self at: self size.
          nscRoot := indexObj nscRoot.
          pivotObject := rootObjectMap pivotObject.
          nilOnPath asIdentitySet do: [:nilOnPathRoot |
            "nilOnPath collection may have more entries than exist in the nscRoot - set valued
               path terms, but we are only interested in the root object counts for nscRoot."
            indexObj
              traverse: nilOnPathRoot
              parent: nil
              thru: self
              startingAt: 1
              do: [ :term :parent :child |
                (nscRoot occurrencesOf: nilOnPathRoot) timesRepeat: [ (rootObjectMap traversalMap at: child ifAbsentPut: [ IdentityBag new ]) add: parent ] ].
            pivotObject == nilOnPathRoot
              ifTrue: [ (nscRoot occurrencesOf: nilOnPathRoot) timesRepeat: [ (rootObjectMap traversalMap at: nilOnPathRoot ifAbsentPut: [ IdentityBag new ]) add: nilOnPathRoot ] ] ] ] ].
  nextObj == oldValue ifFalse: [ self error: 'unexpected error: oldValue and nextObj should be identical by definition.' ].
  updateBtree ~~ nil
    ifTrue: [
      "btree exists for receiver, collect the root objects, where anObject is the key and nextObj
       is the value."
      self findRootObjectMaps: rootObjectMap forKey: nextObj value: anObject ].
  (nil == nextObj or: [ self children isEmpty ])
    ifTrue: [ ^ self ].
  1 to: children size do: [:i |
    (children at: i) findRootObjectMaps: rootObjectMap for: nextObj oldValue: oldValue ]
%

category: 'Collection Based Modification'
method: GsPathTerm
findRootObjectMaps: rootObjectMap for: anObject oldValue: oldValue
  "Traverse btree nodes from receiver to leaf term. Collect rootObjects for all btree elements
   for which anObject is a key or parent of a key."

  | ivOffset |
  ivOffset := self _ivOffsetFor: anObject.
  ivOffset ifNil: [ self _invalidIvOffset: anObject ].
  self
      findRootObjectMaps: rootObjectMap
      for: anObject
      ivOffset: ivOffset
      oldValue: (self _nextObjectFor: oldValue atInstVar: ivOffset).
%

category: 'Modification'
method: GsPathTerm
findRootObjectMaps: rootObjectMap forKey: aKey value: aValue
  | indexRootObjectMap  |
  indexRootObjectMap := rootObjectMap copy.
  updateBtree
    findRootObjectMaps: indexRootObjectMap
    pathTerm: self
    key: aKey
    value: aValue.
  rootObjectMap mergeFromCopy: indexRootObjectMap.
%

category: 'Collection Based Modification'
method: GsPathTerm
findRootObjectsFor: anObject
  "Traverse btree nodes from receiver to leaf term. Collect rootObjects for all btree elements
   for which anObject is a key or parent of a key."

  | ivOffset |
  ivOffset := self _ivOffsetFor: anObject.
  ivOffset ifNil: [ self _invalidIvOffset: anObject ].
  ^ self findRootObjectsFor: anObject ivOffset: ivOffset
%

category: 'Collection Based Modification'
method: GsPathTerm
findRootObjectsFor: anObject ivOffset: ivOffset
  "Traverse btree nodes from receiver to leaf term. Collect rootObjects for all btree elements
   for which anObject at is a key or parent of a key."

  | rootObjects nextObj roots |
  nextObj := self _nextObjectFor: anObject atInstVar: ivOffset.
  rootObjects := updateBtree ~~ nil
    ifTrue: [
      "btree exists for receiver, collect the root objects, where anObject is the key and nextObj
       is the value."
      self findRootObjectsForKey: nextObj value: anObject ]
    ifFalse: [ IdentityBag new ].
  (nil == nextObj or: [ self children isEmpty ])
    ifTrue: [ ^ rootObjects ].
  1 to: children size do: [:i |
    roots := (children at: i) findRootObjectsFor: nextObj.
    rootObjects := rootObjects _union: roots  ].
  ^ rootObjects
%

category: 'Collection Based Modification'
method: GsPathTerm
findRootObjectsFor: anObject ivOffset: ivOffset oldValue: oldValue
  "Traverse btree nodes from receiver to leaf term. Collect rootObjects for all btree elements
   for which anObject at is a key or parent of a key."

  | rootObjects nextObj roots |
  rootObjects := IdentityBag new.
  nextObj := self _nextObjectFor: anObject atInstVar: ivOffset.
  nextObj == oldValue ifFalse: [ self error: 'unexpected error: oldValue and nextObj should be identical by definition.' ].
  updateBtree ~~ nil
    ifTrue: [
      "btree exists for receiver, collect the root objects, where anObject is the key and nextObj
       is the value."
      rootObjects := self findRootObjectsForKey: nextObj value: anObject ].
  (nil == nextObj or: [ self children isEmpty ])
    ifTrue: [ ^ rootObjects ].
  1 to: children size do: [:i |
    roots := (children at: i) findRootObjectsFor: nextObj oldValue: oldValue.
    rootObjects := rootObjects _union: roots  ].
  ^ rootObjects
%

category: 'Collection Based Modification'
method: GsPathTerm
findRootObjectsFor: anObject oldValue: oldValue
  "Traverse btree nodes from receiver to leaf term. Collect rootObjects for all btree elements
   for which anObject is a key or parent of a key."

  | ivOffset |
  ivOffset := self _ivOffsetFor: anObject.
  ivOffset ifNil: [ self _invalidIvOffset: anObject ].
  ^ self
      findRootObjectsFor: anObject
      ivOffset: ivOffset
      oldValue: (self _nextObjectFor: oldValue atInstVar: ivOffset).
%

category: 'Modification'
method: GsPathTerm
findRootObjectsForKey: aKey value: aValue
  ^ updateBtree findRootObjectsForKey: aKey value: aValue
%

category: 'Accessing'
method: GsPathTerm
getIndexDictionary

"Returns the index dictionary associated with the receiver."

"no idexDictionary associated with the receiver"

^ nil
%

category: 'Accessing'
method: GsPathTerm
getParentTerm

"Returns the parent path term of the receiver.  This is determined by looking
 at the previous path term of the first index object that utilizes this path
 term.  If there is no parent, returns nil."

offset > 1
    ifTrue: [ ^ (self at: 1) at: offset - 1 ]
    ifFalse: [ ^ nil ]
%

category: 'Accessing'
method: GsPathTerm
getRootNsc

"Returns the root NSC for the index in which the receiver is a term."

^ (self at: 1) nscRoot
%

category: 'Testing'
method: GsPathTerm
hasIndexDictionary
  "Answer if receiver's index may have an indexDictionary."

  ^ false
%

category: 'Testing'
method: GsPathTerm
hasMatchingTerm: aSymbol
  "Answer true if the receiver's term matches <aSymbol>"

  ^ self name == aSymbol
%

category: 'Testing'
method: GsPathTerm
indicatesIndexOnNscElements

"Returns true if the path term indicates that the index is on elements of the
 NSC itself.  This is the case if the path is '' (two single quotes).  This
 method is overridden by SetValuedPathTerm to return true."

^ name ==  #''
%

category: 'Testing'
method: GsPathTerm
indicatesIndexOnRootNsc
  "Returns true if the path term indicates that the index is on elements of the
 NSC itself.  This is the case if the path is '' (two single quotes)."

  ^ name == #''
%

category: 'Testing'
method: GsPathTerm
indicatesMultiValue
  "Returns false, the receiver does not indicate that the index is on an
 instance variable that may have multiple values (i.e., collection based path term)"

  ^ false
%

category: 'Testing'
method: GsPathTerm
indicatesNsc
  "Returns false, the receiver does not indicate that the index is on an
 instance variable that is expected to be a collection (i.e., set valued pathterm."

  ^ false
%

category: 'Initialization'
method: GsPathTerm
initialize

"Initialize the receiver with default values."

securityPolicies := GsObjectSecurityPolicySet new.
children := { } .
needsDepList := false.
nilOnPath := RcLowMaintenanceIdentityBag new
%

category: 'Testing'
method: GsPathTerm
isEnumeratedTerm
  "Returns true if the receiver indicates an enumerated path term."

  ^ false
%

category: 'Testing'
method: GsPathTerm
isOptionalTerm
  ^ false
%

category: 'Testing'
method: GsPathTerm
isRangeEqualityIndexLastPathTerm

"Returns true if the receiver is the last path term of a RangeEqualityIndex."

1 to: self size do: [ :i |
    ( (self at: i) isRangeEqualityIndex and: [ (self at: i) size == offset ] )
        ifTrue: [ ^ true ]
].
^ false
%

category: 'Testing'
method: GsPathTerm
isSelectorTerm
  ^ false
%

category: 'Testing'
method: GsPathTerm
isSetValuedTerm
  "Returns true if the receiver indicates a set-valued instance variable."

  ^ false
%

category: 'Accessing'
method: GsPathTerm
name

"Returns the value of the instance variable 'name'."

^name
%

category: 'Updating'
method: GsPathTerm
name: newValue

"Modify the value of the instance variable 'name'."

name := newValue
%

category: 'Accessing'
method: GsPathTerm
needsDepList

"Returns the value of the instance variable 'needsDepList'."

^needsDepList
%

category: 'Updating'
method: GsPathTerm
needsDepList: newValue

"Modify the value of the instance variable 'needsDepList'."

needsDepList := newValue
%

category: 'Accessing'
method: GsPathTerm
nilOnPath
  "return nil or identity bag that contains root objects with nil along the path"

  ^ nilOnPath
%

category: 'Accessing'
method: GsPathTerm
objectSecurityPolicy: anObjectSecurityPolicy

"Assign the receiver and its children to the given security policy."

super objectSecurityPolicy: anObjectSecurityPolicy.
children objectSecurityPolicy: anObjectSecurityPolicy.
1 to: children size do: [ :i |
    (children at: i) objectSecurityPolicy: anObjectSecurityPolicy
].
securityPolicies objectSecurityPolicy: anObjectSecurityPolicy.
%

category: 'Accessing'
method: GsPathTerm
offset

"Returns the value of the instance variable 'offset'."

^offset
%

category: 'Updating'
method: GsPathTerm
offset: newValue

"Modify the value of the instance variable 'offset'."

offset := newValue
%

category: 'Private'
method: GsPathTerm
recordNilOnPathForRoot: rootObject

  "record fact that rootObject has a nil on the path for this path term"

  updateBtree ifNotNil: [ ^ self ].
  nilOnPath add: rootObject
%

category: 'Removing'
method: GsPathTerm
removeDirectMappingFor: anObject logging: doLogging
  "There is a range index directly on the elements of the NSC.  Update the
 B-tree."

  updateBtree ~~ nil
    ifTrue: [ " remove it from the B-tree "
      updateBtree btreeRemoveKey: anObject value: anObject root: anObject ]
%

category: 'Removing'
method: GsPathTerm
removeDirectMappingFor: anObject root: root nsc: anNsc logging: doLogging
  "There is a range index directly on the elements of the NSC.  Update the
 B-tree."

  updateBtree ~~ nil
    ifTrue: [ " remove it from the B-tree "
      (updateBtree btreeRemoveKey: anObject value: anObject root: root)
         ifFalse: [ self _errorObjectNotInBtree: anObject value: anObject root: root ] ]
%

category: 'Index Maintenance'
method: GsPathTerm
removeIndex: indexObj

"The given index is being removed from this path term."

1 to: self size do: [ :i |
    indexObj == (self at: i)
        ifTrue: [ ^ self removeAtIndex: i ]
]

%

category: 'Removing'
method: GsPathTerm
removeMappingsFor: anObject at: ivOffset root: rootObject lastOne: lastOne logging: doLogging

  ^self removeMappingsFor: anObject root: rootObject lastOne: lastOne logging: doLogging
%

category: 'Removing'
method: GsPathTerm
removeMappingsFor: anObject lastOne: lastOne logging: doLogging
  ^self removeMappingsFor: anObject root: anObject lastOne: lastOne logging: doLogging
%

category: 'Removing'
method: GsPathTerm
removeMappingsFor: anObject root: rootObject lastOne: aBoolean logging: doLogging
  "Remove entries in the btree and dependency lists for anObject."

  | nextObj depList more isLast |
  self size == 0
    ifTrue: [ ^ self ].
  nextObj := self _nextObjectFor: anObject.
  updateBtree ~~ nil
    ifTrue: [
      " remove an entry from the B-tree "
      (updateBtree btreeRemoveKey: nextObj value: anObject root: rootObject)
        ifFalse: [ self _errorObjectNotInBtree: nextObj value: anObject root: rootObject ].
      DependencyList removePathTerm: self for: nextObj logging: doLogging	" remove dependency list entry for next object " ].
  nextObj ifNil: [ self removeNilOnPathForRoot: rootObject ].
  more := false.
  (nil ~~ nextObj and: [ children isEmpty not ])
    ifTrue: [
      aBoolean
        ifTrue: [
          | last |
          last := (children at: 1) _isLastOccurrenceInIndexFor: nextObj.
          isLast := aBoolean and: [ last ] ]
        ifFalse: [ isLast := false ].
          " make recursive call to remove mappings "
      1 to: children size do: [ :i |
        (children at: i) removeMappingsFor: nextObj root: rootObject lastOne: isLast logging: doLogging ].
      isLast
        ifFalse: [
          "check again in case there are no more references left in btree"
          isLast := ((children at: 1) findReachableRootsFor: nextObj) isEmpty ].
      isLast
        ifTrue: [
          " remove dependency list entries for next object "
          (depList := DependencyList for: nextObj) ~~ nil
            ifTrue: [ depList removePathTerms: children for: nextObj logging: doLogging ] ] ]
%

category: 'Updating Indexes'
method: GsPathTerm
removeMappingsSkipBtreeFor: anObject root: rootObj lastOne: aBoolean logging: doLogging

"Remove entries in the dependency lists for anObject.
 This version for index removal, it does not update the btree since the btree
 is going away (#40858)."

| nextObj depList isLast |
self size == 0
  ifTrue: [ ^ self ].

nextObj := self _nextObjectFor: anObject.

updateBtree ~~ nil
  ifTrue: [
    " skip update of btree, index is going away"

    " remove dependency list entry for next object "
    DependencyList removePathTerm: self for: nextObj logging: doLogging.
  ].

( nil ~~ nextObj and: [ children isEmpty not ] )
  ifTrue: [
    aBoolean
      ifTrue: [
        | last |
        last := (children at: 1) _isLastOccurrenceInIndexFor: nextObj.
        isLast := aBoolean and: [last ] ]
      ifFalse: [ isLast := false ].
    " make recursive call to remove mappings "
    1 to: children size do: [ :i |
      (children at: i) removeMappingsSkipBtreeFor: nextObj
        root: rootObj
        lastOne: isLast
        logging: doLogging
    ].
        " remove dependency list entries for next object "
        (depList := DependencyList for: nextObj) ~~ nil
          ifTrue: [ depList removePathTerms: children for: nextObj logging: doLogging ]
  ]
%

category: 'Private'
method: GsPathTerm
removeNilOnPathForRoot: rootObject

  "rootObject with nil on path has been removed"

  updateBtree ifNotNil: [ ^ self ].
  nilOnPath remove: rootObject
%

category: 'Accessing'
method: GsPathTerm
requirePathTerms: aBool
  "compat with PathTerm implementation"

  ^ self termsRequired: aBool
%

category: 'Accessing'
method: GsPathTerm
termsRequired
  ^ termsRequired ifNil: [ termsRequired := true ]
%

category: 'Accessing'
method: GsPathTerm
termsRequired: aBool
  termsRequired := aBool
%

category: 'Modification'
method: GsPathTerm
traverseAllReachableFor: root indexObj: indexObj

  | res |
  res := IdentitySet new.
  (indexObj traverseAllWithParents: root upTo: self startingAt: 1) do: [:each | res add: (each at: 2) ].
  ^ res
%

category: 'Updating Indexes'
method: GsPathTerm
undoDirectMappingFor: anObject logging: doLogging
  "There is a range index directly on the elements of the NSC."
  " no indexDictionary in the receiver ... noop"
%

category: 'Updating Indexes'
method: GsPathTerm
undoMappingsFor: anObject lastOne: aBoolean logging: doLogging

"Remove entries in the index dictionary and dependency lists for anObject."


| nextObj depList more isLast |
self size == 0
  ifTrue: [ ^ self ].

[
    nextObj := self _nextObjectFor: anObject.
] onException: Error do:[ :ex |
    "Handle any error thrown during execution of _nextObjectFor:
     Cannot resolve the path for this guy --- can't have been added to index,
     in fact this object could have caused the failure in the first place"
    ^ self
].

updateBtree ~~ nil
  ifTrue: [
    " remove dependency list entry for next object "
    DependencyList removePathTerm: self for: nextObj logging: doLogging.
  ].

more := false.
( nil ~~ nextObj and: [ children isEmpty not ] )
  ifTrue: [ " make recursive call to remove mappings "
    isLast := aBoolean and: [ more not ].
    1 to: children size do: [ :i |
      (children at: i) undoMappingsFor: nextObj
        lastOne: isLast
        logging: doLogging
    ].
    isLast
      ifTrue: [
        " remove dependency list entries for next object "
        (depList := DependencyList for: nextObj) ~~ nil
          ifTrue: [ depList removePathTerms: children for: nextObj logging: doLogging ]
      ]
  ]
%

category: 'Modification'
method: GsPathTerm
update: anObject at: ivOffset to: newValue
  "The instance variable for anObject is being changed to newValue.
 Update the btrees and dependency lists for the old value and the
 newValue.  Returns true if the index objects were modified correctly;
 otherwise returns an Array containing error information."

  | oldValue reachableRoots |
  self size == 0
    ifTrue: [ ^ true ].
  oldValue := anObject instVarAt: ivOffset.
  reachableRoots := self findReachableRootObjectMapsFor: anObject ivOffset: ivOffset oldValue: oldValue.
  updateBtree ifNotNil: [
    self
      updateBtreeDirectFor: anObject
      at: ivOffset
      oldValue: oldValue
      to: newValue
      roots: reachableRoots ].
  self
    updateBtreeFor: anObject
    at: ivOffset
    oldValue: oldValue
    to: newValue
    roots: reachableRoots.
  ^ true
%

category: 'Updating'
method: GsPathTerm
updateBtree
  "Answer the value of the instance variable 'updateBtree'."

  ^ updateBtree
%

category: 'Updating'
method: GsPathTerm
updateBtree: aGsAbstractIndex
  "Modify the value of the instance variable 'updateBtree'."

  updateBtree := aGsAbstractIndex
%

category: 'Modification'
method: GsPathTerm
updateBtreeDirectFor: anObject at: ivOffset oldValue: oldValue to: newValue roots: reachableRoots
  "The instance variable for anObject is being changed from olValue to newValue.
 Update the btrees associated with the receiver for the old value and the newValue."

  "BtreePlusEqualityTests>>#testEnumeratedIndexUpdateLeaf fails wrong result set"
  "BtreePlusEqualityTests>>#testMultiEnumeratedIndexUpdateB passes (modulo deplist count)"

  (self _checkBtreeComparisonWith: newValue)
    ifFalse: [
      ImproperOperation new
        args: {newValue class. self name. updateBtree lastElementClassDescription};
        _number:
            (ErrorSymbols at: #'rtErrRangeEqualityIndexInvalidClassKindForBtree');
        signal].
  reachableRoots do: [ :root |
    (updateBtree
      btreeRemoveKey: oldValue
      value: anObject
      root: root)
        ifFalse: [ self _errorObjectNotInBtree: oldValue value: anObject root: root ] ].
  (needsDepList and: [ nil ~~ oldValue ])
    ifTrue: [
      reachableRoots size
        timesRepeat: [ DependencyList removePathTerm: self for: oldValue logging: false ] ].
  reachableRoots do: [ :root |
    " insert an entry into the B-tree "
    updateBtree btreeAt: newValue put: anObject root: root.
    needsDepList
      ifTrue: [
        " add an entry in the dependency list "
        newValue getDepListAndAddLastElementPathTerm: self logging: false ] ].
%

category: 'Modification'
method: GsPathTerm
updateBtreeFor: anObject at: ivOffset oldValue: oldValue to: newValue roots: reachableRoots
  "The instance variable for anObject is being changed from olValue to newValue.
 There are no btrees associated directly with the receiver. Traverse the receiver's
 children and update the btrees and dependency lists for the old value and the newValue."

  | doLogging |
  doLogging := UnorderedCollection _isRcIndexLoggingEnabled.
  reachableRoots do: [ :root |
    self updateEntriesFor: oldValue
      to: newValue
      root: root
      lastOne: true
      logging: doLogging ].
  (oldValue ~~ nil and: [ children size > 0 ])
    ifTrue: [
      | childRoots |
      childRoots := (children at: 1) findReachableRootObjectMapsFor: oldValue.
      (childRoots - reachableRoots) isEmpty
        ifTrue: [
          | depList |
          " remove dependency list entries for next object "
          (depList := DependencyList for: oldValue) ~~ nil
            ifTrue: [ depList removePathTerms: children for: oldValue logging: doLogging ] ] ]
%

category: 'Modification'
method: GsPathTerm
updateEntriesFor: oldValue to: newValue root: rootObject lastOne: aBoolean logging: doLogging
  "Remove entries in the index dictionary and dependency lists for anObject."

  self size == 0
    ifTrue: [ ^ self ].
  oldValue == nil
    ifTrue: [ self removeNilOnPathForRoot: rootObject ]
    ifFalse: [
      1 to: children size do: [ :i |
        (children at: i)
          removeMappingsFor: oldValue
          root: rootObject
          lastOne: aBoolean
          logging: doLogging ] ].
  newValue == nil
    ifTrue: [ self recordNilOnPathForRoot: rootObject ]
    ifFalse: [
      1 to: children size do: [ :i |
        (children at: i)
          addMappingsForObject: newValue root: rootObject logging: doLogging ] ]
%

category: 'Updating'
method: GsPathTerm
_addChildTerm: aPathTerm
  children addLast: aPathTerm
%

category: 'Testing'
method: GsPathTerm
_checkBtreeComparisonWith: anObject

"Returns whether the receiver's B-tree can hold an entry with anObject as the
 key."

^ updateBtree _canCompareWith: anObject
%

category: 'Accessing'
method: GsPathTerm
_classOf: anObject
  "Reflection classOf:"

  <primitive: 166>
  self _primitiveFailed: #'_classOf:' args: {anObject}.
  self _uncontinuableError
%

category: 'Updating Indexes'
method: GsPathTerm
_clear


"Assigns nil to important instance variables and sets the receiver's size
 to zero."

children := nil.
updateBtree := nil.
self size: 0.
%

category: 'Updating'
method: GsPathTerm
_determineChildren
  "Determine the children of the receiver by getting the next path term for each
 index object that utilizes the receiver path term."

  | indexObj |
  children size: 0.
  1 to: self size do: [ :i |
    indexObj := self at: i.
    (indexObj size > offset
      and: [ (children includesIdentical: (indexObj at: offset + 1)) not ])
      ifTrue: [ self _addChildTerm: (indexObj at: offset + 1) ] ]
%

category: 'Index Maintenance'
method: GsPathTerm
_doAddMappingsFor: anNSC on: indexObj indexManager: indexManager hasSet: hasSet
  "Adds the mappings in the index dictionary, dependency lists, and so on for all
 elements in the receiver."

  | bag |
  bag := anNSC _asIdentityBag.
  hasSet
    ifTrue: [
      | updateIndexList objNsc incomplete |
      " if there is a set-valued instance variable, collect objects in a
      Bag on which to update the index dictionary "
      updateIndexList := false.
      (self == indexObj lastPathTerm
        _and: [ self size > 1 _and: [ (self at: 1) size ~= (self at: 2) size ] ])
        ifTrue: [
          " see if index is subsumed by an existing index "
          " if last path term is #*, will need to update the
          last objects' index list "
          self indicatesMultiValue
            ifTrue: [
              updateIndexList := true.
              objNsc := NscBuilder
                for: IdentityBag new
                max: indexObj sizeForNscBuilder ]
            ifFalse: [ objNsc := nil ] ]
        ifFalse: [ objNsc := NscBuilder for: IdentityBag new max: indexObj sizeForNscBuilder ].
      incomplete := #'_incompletePathTraversal'.
       1 to: bag size do: [ :i |
        " for each element in the NSC ... "
        " traverse up to the point of the unshared path term "
        indexObj
          traverse: (bag _at: i)
          upTo: self
          startingAt: 1
          addingIndex: true
          do: [:endObj :rootObj |
            objNsc ~~ nil
              ifTrue: [
                updateIndexList
                  ifTrue: [ self addIndexListEntriesFor: objNsc completeBag index: indexObj ]
                  ifFalse: [
                    endObj ~~ incomplete
                      ifTrue: [
                        " only remove mappings once for a given object "
                        self
                          addMappingsForObject: endObj
                          root: rootObj
                          logging: false ] ].
                i \\ 100 == 0
                  ifTrue: [ indexManager commitIndexMaintenance: indexObj at: i ] ] ] ] ]
    ifFalse: [
      | object |
      "no set-valued terms"
      indexManager autoCommit
        ifTrue: [ anNSC _lockForIndexCreation ].
      indexObj firstPathTerm == self
        ifTrue: [
          " see if need to traverse to the first unshared path term "
          1 to: bag size do: [ :i |
            object := bag _at: i.
            self addMappingsForObject: object logging: false.
            i \\ 100 == 0
              ifTrue: [ indexManager commitIndexMaintenance: indexObj at: i ] ] ]
        ifFalse: [
          1 to: bag size do: [ :i |
            " traverse up to the point of the unshared path term "
            object := bag _at: i.
            self addMappingsForObject: object traverseUpTo: self for: indexObj logging: false.
            i \\ 100 == 0
              ifTrue: [ indexManager commitIndexMaintenance: indexObj at: i ] ] ] ].
  ^ anNSC
%

category: 'Testing'
method: GsPathTerm
_doNotPerformPretraversalFor: anObject
  "Returns whether to do a preparatory traversal (using MappingInfo objects)
 when anObject is being added to an indexed Bag or IdentityBag."

  ^ true
%

category: 'Index Maintenance'
method: GsPathTerm
_doRemoveIndex: indexObj nsc: nsc
      "Remove the index associated with the receiver from the nsc."

      | bag incomplete indexManager allTerms |
      indexManager := IndexManager current.
      bag := nsc _asIdentityBag.
      incomplete := #'_incompletePathTraversal'.
      indexObj _findSetValuedPathTermOffset ~~ 0
        ifTrue: [
          | updateIndexList objNsc |
          "See if there is a set-valued instance variable before the unshared path
     term."
          updateIndexList := false.
          (self == indexObj lastPathTerm
            _and: [ self size > 1 _and: [ (self at: 1) size ~= (self at: 2) size ] ])
            ifTrue: [
              " see if index is subsumed by an existing index "
              " if last path term is #*, will need to update the
              last objects' index list "
              self indicatesMultiValue
                ifTrue: [
                  updateIndexList := true.
                  objNsc := NscBuilder
                    for: IdentityBag new
                    max: indexObj sizeForNscBuilder ]
                ifFalse: [ objNsc := nil ] ]
            ifFalse: [ objNsc := NscBuilder for: IdentityBag new max: indexObj sizeForNscBuilder ].
          1 to: bag size do: [ :i |
            " for each element in the NSC ... "
            " traverse up to the point of the unshared path term "
            indexObj
              traverse: (bag _at: i)
              upTo: self
              startingAt: 1
              addingIndex: false
              do: [:endObj :rootObj |
                objNsc ~~ nil
                  ifTrue: [
                    updateIndexList
                      ifTrue: [ self removeIndexListEntriesFor: objNsc completeBag index: indexObj ]
                      ifFalse: [
                        endObj ~~ incomplete
                          ifTrue: [
                            " only remove mappings once for a given object "
                            self
                              removeMappingsFor: endObj
                              root: rootObj
                              lastOne: true
                              logging: false.
                            DependencyList removePathTerm: self for: endObj ] ] ] ] ] ]
        ifFalse: [ | obj |
          self indicatesIndexOnRootNsc
            ifTrue: [
              " see if the index is on elements of the NSC "
              1 to: bag size do: [ :j |
                obj := bag _at: j.
                self removeDirectMappingFor: obj logging: false.
                DependencyList removePathTerm: self for: obj.
                indexManager commitIndexMaintenance: indexObj at: j ] ]
            ifFalse: [
              [ | endObj |
              1 to: bag size do: [ :j |
                obj := bag _at: j.
                endObj := indexObj traverse: obj upTo: self.
                (nil ~~ endObj and: [ incomplete ~~ endObj ])
                  ifTrue: [
                    self removeMappingsSkipBtreeFor: endObj root: obj lastOne: true logging: false.
                    DependencyList removePathTerm: self for: endObj.
                    indexManager commitIndexMaintenance: indexObj at: j ] ] ]
                onException: Error
                do: [ :ex |
                  ex number == (ErrorSymbols at: #'rtErrObjectPathTermNotInDependencyList')
                    ifTrue: [
                      "continue execution"
                      ex resume ]
                    ifFalse: [ ex outer ] ] ].
          allTerms := self _thisAndAllChildTerms ].
      ^ allTerms
%

category: 'Private'
method: GsPathTerm
_errorInvalidOffset: anObject
  "If missing path slots are tolerated, return an empty MappingInfo. Otherwise
   return an error array"

  (LookupError new
    _number:(ErrorSymbols at: #'rtErrObjectInvalidOffset');
    args: {anObject. name printString}) signal
%

category: 'Error Handling'
method: GsPathTerm
_errorObjectNotInBtree: key value: value root: root
  "An entry for the key/value/root was not present in the B-tree."

  ImproperOperation new
    args:
        {key.
          value.
          root};
    _number: (ErrorSymbols at: #'rtErrRangeEqualityIndexObjectNotInBtree');
    signal:
        'An entry for the key/value/root tuple (' , key asOop printString , '/'
            , value asOop printString , '/' , root asOop printString
            , ') was not present in the index [', updateBtree asOop printString, ']'
%

category: 'Traversing'
method: GsPathTerm
_getNextObjectForTraversal: anObject
  " get the next object along the path "

  | ivOffset nextObj |
  ivOffset := anObject _findIVOffsetForPathTerm: self.
  ivOffset == nil
    ifTrue: [
      anObject _errorPathTermNotInDependencyList: self.
      nextObj := nil ]
    ifFalse: [ nextObj := anObject instVarAt: ivOffset ].
  ^ nextObj
%

category: 'Become Support'
method: GsPathTerm
_getPathTermIndexReferencesInto: refsToRcvr for: anObject
  "Place information about references to the receiver due to the receiver's
 participation in an index into the given Array.  The Array consists of pairs:

 1) An object that references the receiver.  If the object is directly
    contained in an indexed NSC, then this object is the NSC.  If the object
    in the dependency list is a tracking object (for object modification
    tracking), then this object is the tracking object.
 2) The offset of the instance variable in that object that references the
    receiver.
 3) If the object is the last path term, this number is < 0 and is a reference
    count for the number of times .
 3) If the object in the dependency list is a tracking
    object, this number is 0.

 This is used only in support of the 'become:' method."

  | indexObj rootObjects parents prevPathTerm |
  self size = 0
    ifTrue: [ ^ self ].
  indexObj := self at: 1.
  self offset == 1
    ifTrue: [
      "anObject is the first path term in an index (which means anObject
       is directly contained in an indexed NSC) "
      anObject
        _addToReferences: indexObj nscRoot
        offset: 0
        occurrences: (indexObj nscRoot occurrencesOf: anObject)
        into: refsToRcvr.
      ^ self ].
  rootObjects := self findRootObjectsFor: anObject.
  parents := IdentityBag new.
  rootObjects asIdentitySet do: [:root |
    (indexObj traverseAllWithParents: root upTo: self startingAt: 1)
      do: [ :ar | | intermediateObjectReachableFromRoot parentObject |
        parentObject := ar at: 1.
        intermediateObjectReachableFromRoot := ar at: 2.
        intermediateObjectReachableFromRoot == anObject
          ifTrue: [ parents add: parentObject withOccurrences: (rootObjects occurrencesOf: root) ] ] ].
  " get the previous path term in the index "
  prevPathTerm := indexObj at: self offset - 1.
  parents do: [:parentObj |
    prevPathTerm indicatesMultiValue
      ifTrue: [
        anObject
          _addToReferences: parentObj
          offset: 0
          occurrences: (parentObj occurrencesOf: anObject)
          into: refsToRcvr ]
      ifFalse: [
        anObject
          _addToReferences: parentObj
          offset: (prevPathTerm _ivOffsetFor: parentObj)
          occurrences: 1
          into: refsToRcvr ] ]
%

category: 'Private'
method: GsPathTerm
_invalidIvOffset: anObject
  "If missing path slots are tolerated, return. Otherwise signal an error"

  self termsRequired
    ifFalse: [ ^ self ].
  anObject _errorInvalidOffset: name.
  self _uncontinuableError
%

category: 'Testing'
method: GsPathTerm
_isLastOccurrenceInIndexFor: anObject

  ^ (self findReachableRootsFor: anObject) size <= 1
%

category: 'Testing'
method: GsPathTerm
_isObsoletePathTerm

"Returns whether the receiver is obsolete."

^ self size == 0
%

category: 'Accessing'
method: GsPathTerm
_ivOffsetFor: anObject

"Returns the instance variable offset of anObject for the instance variable
 corresponding to the receiver path term."

^ (self _classOf: anObject) _ivOffsetOf: name
%

category: 'Private'
method: GsPathTerm
_makeObsolete

"Makes the receiver and all its children obsolete."



1 to: children size do: [ :i | (children at: i) _makeObsolete ].
self _clear.
%

category: 'Accessing'
method: GsPathTerm
_nextObjectFor: anObject

"Returns the object at the instance variable that corresponds to the receiver
 path term."


^ self _nextObjectFor: anObject atInstVar: (self _ivOffsetFor: anObject)
%

category: 'Accessing'
method: GsPathTerm
_nextObjectFor: anObject atInstVar: ivOffset

"Returns the object at the instance variable that corresponds to the receiver
 path term."

<primitive: 167>
self _primitiveFailed: #_nextObjectFor:atInstVar:
     args: { anObject . ivOffset } .
self _uncontinuableError
%

category: 'Reduced Conflict Support'
method: GsPathTerm
_selectiveAbort

 "Do nothing"
%

category: 'Accessing'
method: GsPathTerm
_thisAndAllChildTerms

"Returns an Array containing the receiver and all child path terms."


^ self _thisAndAllChildTermsInto: { }
%

category: 'Accessing'
method: GsPathTerm
_thisAndAllChildTermsInto: array

"Returns an Array containing the receiver and all child path terms."


array add: self.

1 to: children size do: [ :i |
  (children at: i) _thisAndAllChildTermsInto: array
].

^ array
%

category: 'Testing'
method: GsPathTerm
_totalNumSetValuedTerms
  ""

  | total |
  self indicatesNsc
    ifTrue: [ total := 1 ]
    ifFalse: [ total := 0 ].
  1 to: children size do: [ :i | total := total + (children at: i) _totalNumSetValuedTerms ].
  ^ total
%

! Class extensions for 'GsPreparedPathConstantPredicate'

!		Instance methods for 'GsPreparedPathConstantPredicate'

category: 'querying-private'
method: GsPreparedPathConstantPredicate
elementValue: anObject
  "the pathTerms in the query will use anObject as the starting point ... analagous to an object in the nsc that is bound to a query"

  "with a set-valued path term, we may get multiple evaluations of the block ... a value along the path will result in no evaluation of the block"

  preparedEvaluator
    traverse: anObject
    cachedOffsets: cachedOffsets
    cachedClasses: cachedClasses
    do: [ :resolvedObject |
      (resolvedObject perform: preparedOperator with: preparedConstant)
        ifTrue: [ ^ true ] ].
  ^ false
%

category: 'private'
method: GsPreparedPathConstantPredicate
prepare
  "cache all of the objects needed for repeated evaluation within a loop"

  | ivOffsetCache |
  preparedOperator := self operator.
  preparedConstant := self constant.
  preparedOperator == #'unary'
    ifTrue: [ preparedOperator := #'=='.
      preparedConstant := true ].
  preparedOperator == #'unaryNot'
    ifTrue: [ preparedOperator := #'~~'.
      preparedConstant := true ].
  self evaluator optimizingComparison
    ifFalse: [ preparedOperator := self comparisonSelectorFor: preparedOperator ].
  preparedEvaluator := self elementValueEvaluator.
  preparedEvaluatorSize := preparedEvaluator size.
  ivOffsetCache := preparedEvaluator _createIvOffsetCache.
  cachedClasses := ivOffsetCache at: 1.
  cachedOffsets := ivOffsetCache at: 2
%

! Class extensions for 'GsPreparedRangeQueryPredicate'

!		Instance methods for 'GsPreparedRangeQueryPredicate'

category: 'querying-private'
method: GsPreparedRangeQueryPredicate
elementValue: anObject
  "the pathTerms in the query will use anObject as the starting point ... analagous to an object in the nsc that is bound to a query"

  "with a set-valued path term, we may get multiple evaluations of the block ... a value along the path will result in no evaluation of the block"

  preparedEvaluator
    traverse: anObject
    cachedOffsets: cachedOffsets
    cachedClasses: cachedClasses
    do: [ :resolvedObject | (preparedConstant1 perform: preparedOperator1 with: resolvedObject)
    & (resolvedObject perform: preparedOperator2 with: preparedConstant2)
        ifTrue: [ ^ true ] ].
  ^ false
%

category: 'private'
method: GsPreparedRangeQueryPredicate
prepare
  "cache all of the objects needed for repeated evaluation within a loop"

  | ivOffsetCache |
  self evaluator optimizingComparison
    ifTrue: [ self isNormal
        ifTrue: [ preparedOperator1 := self operator1.
          preparedOperator2 := self operator2 ]
        ifFalse: [ preparedOperator1 := self inverseOperatorFor: self operator1.
          preparedOperator2 := self inverseOperatorFor: self operator2 ] ]
    ifFalse: [ self isNormal
        ifTrue: [ preparedOperator1 := self comparisonSelectorFor: self operator1.
          preparedOperator2 := self comparisonSelectorFor: self operator2 ]
        ifFalse: [ preparedOperator1 := self
            comparisonSelectorFor: (self inverseOperatorFor: self operator1).
          preparedOperator2 := self
            comparisonSelectorFor: (self inverseOperatorFor: self operator2) ] ].
  preparedConstant1 := self constant1.
  preparedConstant2 := self constant2.
  preparedEvaluator := self elementValueEvaluator.
  preparedEvaluatorSize := preparedEvaluator size.
  ivOffsetCache := preparedEvaluator _createIvOffsetCache.
  cachedClasses := ivOffsetCache at: 1.
  cachedOffsets := ivOffsetCache at: 2
%

! Class extensions for 'GsProcess'

!		Class methods for 'GsProcess'

category: 'Accessing'
classmethod: GsProcess
methodAt: aLevel
  "Return the GsNMethod in which the sender of methodAt: is executing."
  ^ GsProcess _methodInFrameContents:(GsProcess _frameContentsAt: aLevel + 1) 
%

!		Instance methods for 'GsProcess'

category: 'Changing Process State'
method: GsProcess
terminate
 "Terminates the receiver. If receiver is not the current process,
  it will be raised to normal priority and sent a termination interrupt.

  If receiver is a forked process, i.e. not the GsProcess of the
  current execute or perform, returns the receiver after receiver
  has been terminated.

  If receiver is a non-forked process , then
  after completion of the termination,  a not-trappable
  an error is returned to the GCI, containing
  a not-trappable instance of TerminateProcess,
  The   instance of TerminateProcess may have a stack captured,
  but   the GsProcess associated with the error has no stack
  and is terminated."

  ^ self terminateTimeoutMs: 30000"wait up to 30 seconds for ensure blocks to complete"
%

category: 'Changing Process State'
method: GsProcess
terminate9
  "agressive termination that executes in the sender's green thread
   without yielding and without using the receiver's stack to execute
   the ensure blocks ."
  | minfo |
  ((minfo := modeInfo) bitAnd: ModeInfo_continuationMask) ~~ 0 ifTrue:[
    self error:'cannot terminate an instance that is a continuation'
  ].
  (minfo bitAnd: ModeInfo_terminationStarted) == 0 ifTrue:[
    "ensure blocks not attempted yet"
    [
      self _executeEnsureBlocks .
    ] on: Error do:[ :ex |
      "GsFile gciLogServer: '-- Failure during ensure blocks, ' , ex asString ."
      ex return: nil  "abandon further execution of ensure blocks"
    ]
  ].
  self _finishTermination .
%

category: 'Changing Process State'
method: GsProcess
terminateTimeoutMs: timeoutMs
 "Terminates the receiver. If receiver is not the current process,
  it will be raised to normal priority and sent a termination interrupt.

  The argument timeoutMs is a SmallInteger specifying maximum time
  in milliseconds to wait for ensure blocks of the receiver to finish.
  If termination is not complete after this time, an Error is signalled.

  If receiver is a forked process, i.e. not the GsProcess of the
  current execute or perform, returns the receiver after receiver
  has been terminated.

  If receiver is a non-forked process , then after completion of the termination,  
  a not-trappable error is returned to the GCI, containing
  a not-trappable instance of TerminateProcess,
  The   instance of TerminateProcess may have a stack captured,
  but   the GsProcess associated with the error has no stack
  and is terminated .
  "
  | minfo theEx |
  ((minfo := modeInfo) bitAnd: ModeInfo_continuationMask) ~~ 0 ifTrue:[
     ImproperOperation new object: self;
           signal:'cannot terminate an instance that is a continuation' .
  ].
  [  Notification signal ] onSynchronous: AbstractException do:[ :ex |
    "capture stack in case GemExceptionSignalCapturesStack is true"
    (theEx := TerminateProcess new) _gsStack: ex _gsStack .
  ].
  (minfo bitAnd: ModeInfo_terminationStarted) ~~ 0 ifTrue:[ "termination already started"
      "GsFile gciLogServer:'-- termination already started'."
      self _finishTermination .
  ] ifFalse:[ | currentProc |
      self _setModeinfoBit: ModeInfo_terminationStarted value: 1 .
      (self == (currentProc := self _current)) ifTrue:[ "receiver is the active process"
        "GsFile gciLogServer:'-- _serviceTerminationInterrupt' ."
        self _serviceTerminationInterrupt .
      ] ifFalse:[ | sched cPrio slept |
        "GsFile gciLogServer:'-- beforked ' ."
        self beForked . 
        (sched := self _scheduler) _enterCritical .
        self _storeBit: 3 value: true . "set INT_GSPROC_TERMINATE_MASK bit"
        self _unscheduleProcess . "undo waiting on delays, semaphores, etc"
        self priority <= (cPrio := currentProc priority) ifTrue:[
          self _setPriority: cPrio + 1 .
        ].
        sched _scheduleProcess: self "put on readyQ";
              _exitCritical .
        slept := 0 .
        [ self _isTerminated ] whileFalse:[
          slept > timeoutMs ifTrue:[ ThreadError signal: 'Termination waited too long'].
          Delay waitForMilliseconds: 10.
          slept := slept + 10 .
        ].
      ]
  ] .
  "self _isTerminated ifFalse:[
    GsFile gciLogServer:'-- termination not complete, skip terminate9'.
    self terminate9
  ]."
  (minfo bitAnd: ModeInfo_forked) == 0 ifTrue:[
    "GsFile gciLogServer:'-- terminatedReturnToGci'."
    self _isTerminated ifFalse:[
      Error signal:'Termination failed to complete.'
    ].
    self _terminatedReturnToGci: theEx
  ].
%

category: 'Private'
method: GsProcess
_finishTermination
  "returns receiver"
  | wasInCrit sched |
  wasInCrit := (sched := self _scheduler) _enterCritical .
  block ifNil: [
    uaCount_depth := 0.
    arStack := nil.
    interruptFlag_stEntryCount := 0 .
  ] ifNotNil:[
    block := nil
  ].
  "remoteProcess := nil. "
  self _setModeinfoBit: ModeInfo_terminated value: 1 .
  self _signalJoiners .
  wasInCrit == 0 ifTrue:[ sched _exitCritical ].
  sched _terminateScheduledProcess: self.
%

category: 'Private'
method: GsProcess
_serviceTerminationInterrupt
  [
    self _executeEnsureBlocks .
  ] on: Error do:[:ex |
    "GsFile gciLogServer: '-- Failure during ensure blocks, ' , ex asString ."
    ex return: nil ."ignore exception"
  ].
  [
    ^ self _finishTermination
  ] on: Error do:[:ex |
    GsFile gciLogServer: ('-- Failure during _finishTermination, ' , ex asString) lf ;
          gciLogServer: ex stackReport .
    ex return: nil ."ignore exception"
  ]
%

category: 'Private'
method: GsProcess
_terminatedReturnToGci: anException

"If receiver was not the most recently started main GsProcess,
 i.e. not from most recent IntSendMsg or IntExecute ,
 return the receiver.

 Otherwise return control to the GCI with a GciErrorSType encapsulating
 anException .  The receiver will be the GsProcess associated with that
 GciErrorSType , and will have no stack."

<primitive: 543>
self _primitiveFailed: #_terminatedReturnToGci args: { anException } .
self _uncontinuableError  "should never reach here"
%

! Class extensions for 'GsQuery'

!		Class methods for 'GsQuery'

category: 'defaults'
classmethod: GsQuery
defaultOptimizerClass
  DefaultOptimizerClass ifNil: [ DefaultOptimizerClass := Gs32Optimizer ].
  ^ DefaultOptimizerClass
%

category: 'defaults'
classmethod: GsQuery
defaultOptimizerClass: anOptimizerClass
  DefaultOptimizerClass := anOptimizerClass
%

category: 'defaults'
classmethod: GsQuery
defaultQueryOptions
  DefaultQueryOptions ifNil: [ DefaultQueryOptions := GsQueryOptions default ].
  ^ DefaultQueryOptions
%

category: 'defaults'
classmethod: GsQuery
defaultQueryOptions: aGsQueryOptions
  DefaultQueryOptions := aGsQueryOptions
%

category: 'instance creation'
classmethod: GsQuery
fromFormula: aGsQueryFormula
  ^ self fromFormula: aGsQueryFormula on: nil options: self defaultQueryOptions
%

category: 'instance creation'
classmethod: GsQuery
fromFormula: aGsQueryFormula on: anNsc
  ^ self
    fromFormula: aGsQueryFormula
    on: anNsc
    options: self defaultQueryOptions
%

category: 'instance creation'
classmethod: GsQuery
fromFormula: aGsQueryFormula on: anNsc options: aGsQueryOptions
  ^ self new
    formula: aGsQueryFormula immediateInvariant;
    on: anNsc;
    queryOptions: aGsQueryOptions;
    yourself
%

category: 'instance creation'
classmethod: GsQuery
fromFormula: aGsQueryFormula options: aGsQueryOptions
  ^ self fromFormula: aGsQueryFormula on: nil options: aGsQueryOptions
%

category: 'instance creation'
classmethod: GsQuery
fromSelectBlock: aSelectBlock
  | formula |
  formula := GsQueryPredicate fromSelectBlock: aSelectBlock.
  ^ self fromFormula: formula immediateInvariant
%

category: 'instance creation'
classmethod: GsQuery
fromSelectBlock: aSelectBlock on: anNsc
  "formula returned by
	GsQueryPredicate class>>fromSelectBlock:usingQueryExecuterWith: is already
	bound to nsc, so we need to directly set nsc"

  | formula |
  formula := GsQueryPredicate
    fromSelectBlock: aSelectBlock
    usingQueryExecuterWith: anNsc.
  ^ self new
    formula: formula immediateInvariant;
    _nsc: anNsc;
    yourself
%

category: 'instance creation'
classmethod: GsQuery
fromString: aString
  ^ self fromFormula: (GsQueryPredicate fromQueryStatement: aString)
%

category: 'instance creation'
classmethod: GsQuery
fromString: aString on: anNsc
  ^ self fromFormula: (GsQueryPredicate fromQueryStatement: aString) on: anNsc
%

category: 'instance creation'
classmethod: GsQuery
fromString: aString on: anNsc options: aGsQueryOptions
  ^ self
    fromFormula: (GsQueryPredicate fromQueryStatement: aString)
    on: anNsc
    options: aGsQueryOptions
%

category: 'instance creation'
classmethod: GsQuery
fromString: aString options: aGsQueryOptions
  ^ self
    fromFormula: (GsQueryPredicate fromQueryStatement: aString)
    options: aGsQueryOptions
%

category: 'instance creation'
classmethod: GsQuery
_initialize
  self
    defaultQueryOptions;
    defaultOptimizerClass
%

!		Instance methods for 'GsQuery'

category: 'collection'
method: GsQuery
any
  ^ self anyIfNone: [ ^ self error: 'this collection is empty' ]
%

category: 'collection'
method: GsQuery
anyIfNone: noneBlock
  ^ self detect: [ :each | ^ each ] ifNone: noneBlock
%

category: 'converting'
method: GsQuery
asArray
  ^ self queryResult asArray
%

category: 'converting'
method: GsQuery
asIdentityBag
  ^ self queryResult asIdentityBag
%

category: 'querying'
method: GsQuery
bind: variableName to: value
  "bind the given <value> to the <variableName> reference in the query predicate"

  self _formula: (self _formula bind: variableName to: value)
%

category: 'private'
method: GsQuery
cacheQueryResult
  ^ self queryOptions cacheQueryResult
%

category: 'collection'
method: GsQuery
collect: collectBlock
  | resultSet cachedResult |
  self formula isInvariant
    ifFalse: [ self error: 'formula should be invariant' ].
  self cacheQueryResult
    ifTrue: [
      queryResult ifNotNil: [ ^ queryResult collect: collectBlock ].
      cachedResult := nsc speciesForCollect new ].
  resultSet := nsc speciesForCollect new.
  self formula _checkForBug43764: self.
  self formula
    executeAndDo: [ :obj |
      | res |
      res := collectBlock value: obj.
      resultSet add: res.
      self cacheQueryResult
        ifTrue: [ cachedResult add: obj ] ].
  queryResult := cachedResult.
  ^ resultSet
%

category: 'collection'
method: GsQuery
detect: detectBlock
  ^ self
    detect: detectBlock
    ifNone: [ ^ self _error: #'assocErrNoElementsDetected' args: {detectBlock} ]
%

category: 'collection'
method: GsQuery
detect: detectBlock ifNone: noneBlock
  | cachedResult |
  self formula isInvariant
    ifFalse: [ self error: 'formula should be invariant' ].
  self cacheQueryResult
    ifTrue: [
      queryResult ifNotNil: [ ^ queryResult detect: detectBlock ].
      cachedResult := nsc species new ].
  self formula _checkForBug43764: self.
  self formula
    executeAndDo: [ :obj |
      (detectBlock value: obj)
        ifTrue: [ ^ obj ].
      self cacheQueryResult
        ifTrue: [ cachedResult add: obj ] ].
  queryResult := cachedResult.
  ^ noneBlock value
%

category: 'collection'
method: GsQuery
do: doBlock
  | cachedResult |
  self formula isInvariant
    ifFalse: [ self error: 'formula should be invariant' ].
  self cacheQueryResult
    ifTrue: [
      queryResult ifNotNil: [ ^ queryResult do: doBlock ].
      cachedResult := nsc species new ].
  self formula _checkForBug43764: self.
  self cacheQueryResult
    ifTrue: [
      self formula
        executeAndDo: [ :obj |
          doBlock value: obj.
          cachedResult add: obj ] ]
    ifFalse: [ self formula executeAndDo: [ :obj | doBlock value: obj ] ].
  queryResult := cachedResult.
  ^ self
%

category: 'querying'
method: GsQuery
elementValue: each
  "the pathTerms in the query will use anObject as the starting point ... analagous to an object in the nsc that is bound to a query"

  self formula _checkForBug43764: self.
  ^ self formula elementValue: each
%

category: 'accessing'
method: GsQuery
formula
  ^ self queryOptions autoOptimize
    ifTrue: [ self optimizedFormula ]
    ifFalse: [ formula ]
%

category: 'private'
method: GsQuery
formula: aQueryFormula
  | theFormula |
  originalFormula := aQueryFormula unbind.
  theFormula := self _nsc
    ifNil: [ aQueryFormula ]
    ifNotNil: [ aQueryFormula bindEvaluatorsFor: self _nsc collator: self _collator ].
  self _formula: theFormula
%

category: 'private'
method: GsQuery
immediateInvariant
  super immediateInvariant.
  formula immediateInvariant
%

category: 'collection'
method: GsQuery
includes: anObject
  ^ self queryResult includes: anObject
%

category: 'collection'
method: GsQuery
isEmpty
  ^ self queryResult isEmpty
%

category: 'querying'
method: GsQuery
on: anNsc
  "Bind the query to the given <anNsc>"

  self on: anNsc collator: nil
%

category: 'querying'
method: GsQuery
on: anNscOrSequenceableCollection collator: anIcuCollator
  "Bind the query to the given <anNsc> and <anIcuCollator>"

  self _validateQueryableCollection: anNscOrSequenceableCollection.
  self _nsc: anNscOrSequenceableCollection.
  self _collator: anIcuCollator.
  self _formula
    ifNotNil: [
      self
        _formula:
          (self _formula bindEvaluatorsFor: self _nsc collator: self _collator) ]
%

category: 'querying'
method: GsQuery
optimize
  self _formula: self optimizedFormula
%

category: 'accessing'
method: GsQuery
optimizedFormula
  ^ self optimizeFormulaUsing: self class defaultOptimizerClass
%

category: 'private'
method: GsQuery
optimizeFormulaUsing: queryOptimizerClass
  formula ifNil: [ ^ nil ].
  ^ queryOptimizerClass
    optimize: formula
    on: self _nsc
    options: self queryOptions
%

category: 'querying'
method: GsQuery
optionalPathTerms
  self _formula ifNotNil: [ self _formula: self _formula optionalPathTerms ]
%

category: 'accessing'
method: GsQuery
originalFormula
  ^ originalFormula
%

category: 'printing'
method: GsQuery
printOn: aStream
  self formula printOn: aStream
%

category: 'accessing'
method: GsQuery
queryOptions
  queryOptions ifNil: [ queryOptions := self class defaultQueryOptions ].
  ^ queryOptions
%

category: 'private'
method: GsQuery
queryOptions: aGsQueryOptions
  queryOptions := aGsQueryOptions.
  queryOptions optionalPathTerms
    ifTrue: [ formula := formula optionalPathTerms ]
%

category: 'accessing'
method: GsQuery
queryResult
  self formula isInvariant
    ifFalse: [ self error: 'formula should be invariant' ].
  ^ self cacheQueryResult
    ifTrue: [
      queryResult
        ifNil: [
          self formula _checkForBug43764: self.
          queryResult := self formula execute ].
      queryResult ]
    ifFalse: [
      self formula _checkForBug43764: self.
      self formula execute ]
%

category: 'collection'
method: GsQuery
readStream
  "Return a BtreeReadStream or RangeIndexReadStream on the query result"

  self formula isInvariant
    ifFalse: [ self error: 'formula should be invariant' ].
  self formula _checkForBug43764: self.
  self formula _checkForStreamableQuery: self.
  ^ self formula readStream
%

category: 'collection'
method: GsQuery
reject: rejectBlock
  | resultSet cachedResult |
  self formula isInvariant
    ifFalse: [ self error: 'formula should be invariant' ].
  self cacheQueryResult
    ifTrue: [
      queryResult ifNotNil: [ ^ queryResult reject: rejectBlock ].
      cachedResult := nsc species new ].
  resultSet := nsc species new.
  self formula _checkForBug43764: self.
  self formula
    executeAndDo: [ :obj |
      (rejectBlock value: obj)
        ifFalse: [ resultSet add: obj ].
      self cacheQueryResult
        ifTrue: [ cachedResult add: obj ] ].
  queryResult := cachedResult.
  ^ resultSet
%

category: 'querying'
method: GsQuery
resetCache
  queryResult := nil
%

category: 'collection'
method: GsQuery
reversedReadStream
  "Return a BtreeReadStream or RangeIndexReadStream on the query result"

  self formula isInvariant
    ifFalse: [ self error: 'formula should be invariant' ].
  self formula _checkForBug43764: self.
  self formula _checkForStreamableQuery: self.
  ^ self formula reversedReadStream
%

category: 'collection'
method: GsQuery
select: selectBlock
  | resultSet cachedResult |
  self formula isInvariant
    ifFalse: [ self error: 'formula should be invariant' ].
  self cacheQueryResult
    ifTrue: [
      queryResult ifNotNil: [ ^ queryResult select: selectBlock ].
      cachedResult := nsc species new ].
  resultSet := nsc species new.
  self formula _checkForBug43764: self.
  self formula
    executeAndDo: [ :obj |
      (selectBlock value: obj)
        ifTrue: [ resultSet add: obj ].
      self cacheQueryResult
        ifTrue: [ cachedResult add: obj ] ].
  queryResult := cachedResult.
  ^ resultSet
%

category: 'collection'
method: GsQuery
size
  ^ self queryResult size
%

category: 'converting'
method: GsQuery
withOptimizedFormula
  ^ self class new
    formula: self optimizedFormula immediateInvariant;
    on: self _nsc;
    queryOptions: self queryOptions copy;
    yourself
%

category: 'converting'
method: GsQuery
withOriginalFormula
  ^ self class new
    formula: self originalFormula immediateInvariant;
    on: self _nsc;
    queryOptions: self queryOptions copy;
    yourself
%

category: 'private'
method: GsQuery
_collator
  "Returns IcuCollator to be used when comparing Unicode strings"

  ^ collator
%

category: 'private'
method: GsQuery
_collator: anIcuCollator
  "Set the receiver's collator. Use a copy of anIcuCollator to disallow
   changes to strength, etc, that might affect the sort ordering. "

  collator := anIcuCollator copy immediateInvariant
%

category: 'private'
method: GsQuery
_formula
  ^ formula
%

category: 'private'
method: GsQuery
_formula: aQueryFormula
  self resetCache.
  formula := aQueryFormula.
  self queryOptions optionalPathTerms
    ifTrue: [ formula := aQueryFormula optionalPathTerms ]
%

category: 'private'
method: GsQuery
_nsc
  ^ nsc
%

category: 'private'
method: GsQuery
_nsc: anNscOrSequenceableCollection
  self resetCache.
  nsc := anNscOrSequenceableCollection
%

category: 'private'
method: GsQuery
_queryResult
  ^ queryResult
%

category: 'testing'
method: GsQuery
_queryUsesIdentityIndex
  "answer true if the one or more of the predicates has an evaluator that is an identity index"

  self _formula ifNil: [ ^ false ].
  ^ self _formula _queryUsesIdentityIndex
%

category: 'testing'
method: GsQuery
_queryUsesIndex
  "answer true if the one or more of the predicates has an evaluator that is a range or identity index"

  self _formula ifNil: [ ^ false ].
  ^ self _formula _queryUsesIndex
%

category: 'testing'
method: GsQuery
_queryUsesRangeEqualityIndex
  "answer true if the one or more of the predicates has an evaluator that is a range equality index"

  self _formula ifNil: [ ^ false ].
  ^ self _formula _queryUsesIndex and: [ self _formula _queryUsesIdentityIndex not ]
%

category: 'private'
method: GsQuery
_validateQueryableCollection: anNscOrSequenceableCollection
  "throw an error if the receiver does not support queries on anNscOrSequenceableCollection"

  anNscOrSequenceableCollection ifNil: [ ^ self ].
  anNscOrSequenceableCollection class _canCreateQueryOnInstances
    ifFalse: [
      ^ GsMalformedQueryExpressionError
        collectionIsNotQueryable:
          anNscOrSequenceableCollection class name asString
        senderLocationID: #'_validateQueryableCollection:' ]
%

! Class extensions for 'GsQueryConjoinSetChecker'

!		Class methods for 'GsQueryConjoinSetChecker'

category: 'instance creation'
classmethod: GsQueryConjoinSetChecker
check: aFormula on: anNsc
  ^ self new
    formula: aFormula;
    nsc: anNsc;
    queryOptions: GsQueryOptions default;
    check
%

!		Instance methods for 'GsQueryConjoinSetChecker'

category: 'visiting'
method: GsQueryConjoinSetChecker
acceptCompoundClause: aCompoundClause
  "disjunctive clauses are not exposed to Bug 43764. Only conjunctive normal form
   clauses need to be checked"

  super acceptCompoundClause: aCompoundClause.
  aCompoundClause clause1 isConjunctiveNormalForm
    ifTrue: [
      self checkConjunctiveClause: aCompoundClause clause1.
      aCompoundClause clause2 isConjunctiveNormalForm
        ifTrue: [ self checkConjunctiveClause: aCompoundClause clause2 ].
      ^ self ].
  aCompoundClause clause2 isConjunctiveNormalForm
    ifTrue: [ self checkConjunctiveClause: aCompoundClause clause2 ]
%

category: 'visiting'
method: GsQueryConjoinSetChecker
acceptUnaryClause: aUnaryClause
  aUnaryClause isNegationClause
    ifTrue: [
      "If clause is  negated, the applyDeMorgansLaws has not been applied to transform the formula. Cannot correctly analyze presence of Bug 43764 unless optimized with applyDeMorgansLaws and consolidateRangePredicates options set."
      ^ GsMalformedQueryExpressionError
        bug43764QueryCannotBeAnalyzed: #'acceptUnaryClause:' ].
  super acceptUnaryClause: aUnaryClause
%

category: 'checking'
method: GsQueryConjoinSetChecker
check
  self formula isConjunctiveNormalForm
    ifTrue: [ self checkConjunctiveClause: self formula ]
    ifFalse: [
      formula isNegationClause
        ifTrue: [
          "If clause is  negated, the applyDeMorgansLaws has not been applied to transform the formula. Cannot correctly analyze presence of Bug 43764 optimized if applyDeMorgansLaws and consolidateRangePredicates options not set."
          ^ GsMalformedQueryExpressionError
            bug43764QueryCannotBeAnalyzed: #'check' ].
      self visitFormula: self formula ]
%

category: 'checking'
method: GsQueryConjoinSetChecker
checkConjunctiveClause: aClause
  GsConjunctiveClauseConjoinSetChecker check: aClause on: self nsc
%

! Class extensions for 'GsQueryErrorHandlingParser'

!		Class methods for 'GsQueryErrorHandlingParser'

category: 'instance creation'
classmethod: GsQueryErrorHandlingParser
on: aParser errorMessage: aString
  ^ (self on: aParser) setErrorMessage: aString
%

category: 'instance creation'
classmethod: GsQueryErrorHandlingParser
on: aParser errorMessage: aString nestMessages: aBool
  ^ (self on: aParser)
    setErrorMessage: aString;
    nestMessages: aBool;
    yourself
%

!		Instance methods for 'GsQueryErrorHandlingParser'

category: 'parsing'
method: GsQueryErrorHandlingParser
nestMessages
  nestMessages ifNil: [ nestMessages := true ].
  ^ nestMessages
%

category: 'parsing'
method: GsQueryErrorHandlingParser
nestMessages: aBool
  nestMessages := aBool
%

category: 'parsing'
method: GsQueryErrorHandlingParser
parseOn: aPPContext
  | element |
  (element := parser parseOn: aPPContext) isPetitFailure
    ifTrue: [
      | msg failureElement |
      failureElement := element.
      aPPContext furthestFailure
        ifNotNil: [ :furthest |
          furthest position >= element position
            ifTrue: [ failureElement := furthest ] ].
      msg := self nestMessages
        ifTrue: [ errorMessage , ' (' , failureElement message , ')' ]
        ifFalse: [ errorMessage ].
      element := PPFailure
        message: msg
        context: aPPContext
        at: failureElement position.
      aPPContext noteDominantFailure: element ].
  ^ element
%

category: 'initialization'
method: GsQueryErrorHandlingParser
setErrorMessage: aString
  errorMessage := aString
%

! Class extensions for 'GsQueryExpectedImplicitIdentityIndexError'

!		Class methods for 'GsQueryExpectedImplicitIdentityIndexError'

category: 'Instance creation'
classmethod: GsQueryExpectedImplicitIdentityIndexError
signal: aGsQuery
  ^ self new
    gsQuery: aGsQuery;
    signal
%

!		Instance methods for 'GsQueryExpectedImplicitIdentityIndexError'

category: 'Accessing'
method: GsQueryExpectedImplicitIdentityIndexError
gsQuery

   ^ gsQuery
%

category: 'Accessing'
method: GsQueryExpectedImplicitIdentityIndexError
gsQuery: anObject

   gsQuery := anObject
%

category: 'Instance initialization'
method: GsQueryExpectedImplicitIdentityIndexError
initialize
  super initialize.
  gsResumable := true .
%

! Class extensions for 'GsQueryFormula'

!		Class methods for 'GsQueryFormula'

category: 'initialization'
classmethod: GsQueryFormula
comparisonSelectorFor: operator
  "Returns the #_idxForCompare"

  ^ ComparisonSelectorMap at: operator
%

category: 'accessing'
classmethod: GsQueryFormula
inverseOperatorFor: operator
  "Returns the operator that is the inverse of the given operator.
 This is used to reverse the comparison order of operands in a predicate.
 For example, the inverse of <= is >=; the inverse of = is = (no change)."

  ^ InverseOperatorMap at: operator
%

category: 'accessing'
classmethod: GsQueryFormula
negatedOperatorFor: operator
  "Returns the operator that is the negation of the given operator.
 This is used to implement executeClauseNegated.
 For example, the negation of <= is >; the inverse of = is ~= ."

  ^ NegatedOperatorMap at: operator
%

category: 'initialization'
classmethod: GsQueryFormula
_initialize
  self _addClassVar: #ComparisonSelectorMap
     value: (
      SymbolDictionary new
        at: #'<' put: #'_idxForCompareLessThan:';
        at: #'>' put: #'_idxForCompareGreaterThan:';
        at: #'=' put: #'_idxForCompareEqualTo:';
        at: #'==' put: #'==';
        at: #'<=' put: #'_idxForCompareLessThanOrEqualTo:';
        at: #'>=' put: #'_idxForCompareGreaterThanOrEqualTo:';
        at: #'~=' put: #'_idxForCompareNotEqualTo:';
        at: #'~~' put: #'~~';
        yourself ).
  self _addClassVar: #InverseOperatorMap
      value: (SymbolDictionary new
        at: #'<' put: #'>';
        at: #'>' put: #'<';
        at: #'=' put: #'=';
        at: #'==' put: #'==';
        at: #'<=' put: #'>=';
        at: #'>=' put: #'<=';
        at: #'~=' put: #'~=';
        at: #'~~' put: #'~~';
        yourself ).
   self _addClassVar: #NegatedOperatorMap
      value: ( SymbolDictionary new
        at: #'<' put: #'>=';
        at: #'>' put: #'<=';
        at: #'=' put: #'~=';
        at: #'==' put: #'~~';
        at: #'<=' put: #'>';
        at: #'>=' put: #'<';
        at: #'~=' put: #'=';
        at: #'~~' put: #'==';
        at: #'unary' put: #'unaryNot';
        at: #'unaryNot' put: #'unary';
        yourself ).
%

!		Instance methods for 'GsQueryFormula'

category: 'operators'
method: GsQueryFormula
& aClause
  ^ GsCompoundClause clause: self operator: #'&' clause: aClause
%

category: 'visitors'
method: GsQueryFormula
acceptVisitor: aFormulaVisitor
  aFormulaVisitor acceptFormula: self
%

category: 'optimizing'
method: GsQueryFormula
applyDeMorgansNegationTransform
  "actively apply De Morgan's laws"

  self subclassResponsibility: #'applyDeMorgansNegationTransform'
%

category: 'optimizing'
method: GsQueryFormula
applyDeMorgansTransform
  "do not transform, but propagate the transform"

  self subclassResponsibility: #'applyDeMorgansTransform'
%

category: 'converting'
method: GsQueryFormula
asFormula
  ^ self
%

category: 'converting'
method: GsQueryFormula
asFormulaWithSelectorParts: selectorParts
  ^ GsUnaryClause clause: self operator: selectorParts first inputValue asSymbol
%

category: 'converting'
method: GsQueryFormula
asFormulaWithSelectorParts: selectorParts arguments: arguments
  ^ self subclassResponsibility: #asFormulaWithSelectorParts:arguments:
%

category: 'converting'
method: GsQueryFormula
asQuery
  ^ GsQuery fromFormula: self
%

category: 'transforming'
method: GsQueryFormula
bind: variableName to: value
  self subclassResponsibility: #'bind:to:'
%

category: 'private'
method: GsQueryFormula
bindEvaluators
  self immediateInvariant
%

category: 'transforming'
method: GsQueryFormula
bindEvaluatorsFor: anNsc collator: anIcuCollatorOrNil
  | bound |
  bound := self copy.
  anNsc ifNil: [ ^ bound ].
  bound _nsc: anNsc collator: anIcuCollatorOrNil.
  bound bindEvaluators.
  ^ bound
%

category: 'private'
method: GsQueryFormula
buildGsQueryParserNodeFor: aGsQueryParser
  aGsQueryParser build: self messages: nil
%

category: 'optimizing'
method: GsQueryFormula
canConsolidateEnumeratedWith: secondaryPredicate
  ^ false
%

category: 'optimizing'
method: GsQueryFormula
canConsolidateEnumeratedWithPathConstantPredicate: primaryPredicate
  ^ false
%

category: 'optimizing'
method: GsQueryFormula
canConsolidateWith: secondaryPredicate
  ^ false
%

category: 'optimizing'
method: GsQueryFormula
canConsolidateWithPathConstantPredicate: primaryPredicate
  ^ false
%

category: 'transforming'
method: GsQueryFormula
collapseToRangePredicateForConstantPathPredicate: aPredicate
  "default is to and the two predicates together, last half of double dispatch so reverse order"

  ^ aPredicate & self
%

category: 'transforming'
method: GsQueryFormula
collapseToRangePredicateForPathConstantPredicate: aPredicate
  "default is to and the two predicates together, last half of double dispatch so reverse order"

  ^ aPredicate & self
%

category: 'transforming'
method: GsQueryFormula
collapseToRangePredicateIfPossible: aPathXPredicate
  "default is to and the two predicates together"

  ^ self & aPathXPredicate
%

category: 'accessing'
method: GsQueryFormula
collator
  "Returns IcuCollator to be used when comparing Unicode strings"

  ^ collator
%

category: 'accessing'
method: GsQueryFormula
comparisonSelectorFor: operator
  ^ self class comparisonSelectorFor: operator
%

category: 'accessing'
method: GsQueryFormula
constantReferenceFor: aName
  ^ GsConstantReferenceAssociation newWithKey: aName value: nil
%

category: 'querying-private'
method: GsQueryFormula
elementValue: anObject
  "the pathTerms in the query will use anObject as the starting point ... analagous to an object in the nsc that is bound to a query"

  self subclassResponsibility: #'elementValue:'
%

category: 'querying'
method: GsQueryFormula
execute
  ^ self executeClause
%

category: 'querying'
method: GsQueryFormula
executeAndDo: aBlock
  self subclassResponsibility: #'executeAndDo:'
%

category: 'querying-private'
method: GsQueryFormula
executeClause
  self subclassResponsibility: #'executeClause'
%

category: 'querying-private'
method: GsQueryFormula
executeClauseNegated
  "used when not encountered"

  self subclassResponsibility: #'executeClauseNegated'
%

category: 'querying-private'
method: GsQueryFormula
executeClauseNegatedOn: anNsc
  | bound |
  bound := self bindEvaluatorsFor: anNsc collator: self collator.
  ^ bound executeClauseNegated
%

category: 'querying-private'
method: GsQueryFormula
executeClauseOn: anNsc
  | bound |
  bound := self bindEvaluatorsFor: anNsc collator: self collator.
  ^ bound executeClause
%

category: 'querying-private'
method: GsQueryFormula
executeNegatedAndDo: aBlock
  self subclassResponsibility: #'executeNegatedAndDo:'
%

category: 'accessing'
method: GsQueryFormula
inverseOperatorFor: operator
  ^ self class inverseOperatorFor: operator
%

category: 'testing'
method: GsQueryFormula
isCompoundPredicate
  ^ false
%

category: 'testing'
method: GsQueryFormula
isConjunctiveNormalForm
  ^ true
%

category: 'testing'
method: GsQueryFormula
isConstantConstant
  ^ false
%

category: 'testing'
method: GsQueryFormula
isDisjunctiveClause
  ^ false
%

category: 'testing'
method: GsQueryFormula
isDisjunctiveNormalForm
  ^ true
%

category: 'testing'
method: GsQueryFormula
isNegationClause
  ^ false
%

category: 'testing'
method: GsQueryFormula
isPathPath
  ^ false
%

category: 'testing'
method: GsQueryFormula
isPredicate
  ^ false
%

category: 'testing'
method: GsQueryFormula
isRangeEqualityOperation: queryOp
  "Returns true if the given search operation is one of < > = <= >= or ~=."

  ^ queryOp ~~ #'==' and: [ queryOp ~~ #'~~' ]
%

category: 'accessing'
method: GsQueryFormula
negatedOperatorFor: operator
  ^ self class negatedOperatorFor: operator
%

category: 'operators'
method: GsQueryFormula
normalize
  ^ self copy
%

category: 'operators'
method: GsQueryFormula
not
  ^ GsUnaryClause clause: self operator: #'not'
%

category: 'accessing'
method: GsQueryFormula
operationSelectors
  "Returns an Array of comparison operation selectors whose ordering matches the order used by the QueryExecutor."

  ^ #(#'<' #'>' #'=' #'==' #'<=' #'>=' #'~=' #'~~' #'unary' #'unaryNot')
%

category: 'accessing'
method: GsQueryFormula
optionalPathTerms
  | bound |
  bound := self copy _pathTermsRequired: false.
  nsc ifNil: [ ^ bound immediateInvariant ].
  ^ bound bindEvaluators
%

category: 'accessing'
method: GsQueryFormula
pathEvaluatorClass
  pathTermsRequired ifNil: [ ^ PathEvaluator ].
  ^ pathTermsRequired
    ifTrue: [ PathEvaluator ]
    ifFalse: [ OptionalTermPathEvaluator ]
%

category: 'accessing'
method: GsQueryFormula
pathEvaluatorFor: path
  | pathEvaluator terms holder |
  pathEvaluator := self pathEvaluatorClass basicNew.
  terms := self _parsePath: path.
  terms do: [ :term | pathEvaluator add: term ].
  pathEvaluator collator: self collator.
  pathEvaluator initialize .
  holder := { pathEvaluator }.
  pathEvaluator := nil .
  ^ PathEvaluator asMostSpecificType: holder .
%

category: 'accessing'
method: GsQueryFormula
pathReferenceFor: aName
  ^ GsQueryPathReferenceAssociation newWithKey: aName value: nil
%

category: 'querying-private'
method: GsQueryFormula
prepareForExecution
  "Return an object equivalent to the receiver that is prepared for execution within
   the context of a block."

  ^ self
%

category: 'querying'
method: GsQueryFormula
query: anNsc
  ^ GsQuery new
    on: anNsc;
    formula: self;
    yourself
%

category: 'querying'
method: GsQueryFormula
readStream
  self subclassResponsibility: #'readStream'
%

category: 'optimizing'
method: GsQueryFormula
redundantDisjunctivePredicateBetween: secondaryPredicate
  ^ nil
%

category: 'optimizing'
method: GsQueryFormula
redundantDisjunctivePredicateBetweenPathConstant: primaryPredicate
  ^ nil
%

category: 'optimizing'
method: GsQueryFormula
redundantPredicateBetween: secondaryPredicate
  ^ nil
%

category: 'optimizing'
method: GsQueryFormula
redundantPredicateBetweenPathConstant: primaryPredicate
  ^ nil
%

category: 'querying'
method: GsQueryFormula
reversedReadStream
  ^ self readStream reversed
%

category: 'optimizing'
method: GsQueryFormula
transformCommonPaths
  "If the predicate is a path-path and path paths are the same:
	- if operator is =, ==, <=, >= predicate will always be true.
	  Transform  to unary true query"

  ^ self
%

category: 'transforming'
method: GsQueryFormula
unbind
  "remove all bindings"

  | unbound |
  unbound := self copy.
  unbound _nsc: nil collator: nil.
  ^ unbound
%

category: 'testing'
method: GsQueryFormula
usesComparisonOperation
  ^ false
%

category: 'testing'
method: GsQueryFormula
usesEqualityOperation
  ^ false
%

category: 'testing'
method: GsQueryFormula
usesEqualOperation
  ^ false
%

category: 'testing'
method: GsQueryFormula
usesIdenticalToOperation
  ^ false
%

category: 'testing'
method: GsQueryFormula
usesIdentityOperation
  ^ false
%

category: 'testing'
method: GsQueryFormula
usesPathEvaluator
  ^ false
%

category: 'testing'
method: GsQueryFormula
usesPathEvaluatorForFirstClause
  "only real distinction from usesPathEvaluator is for GsCompoundClause"

  ^ self usesPathEvaluator
%

category: 'testing'
method: GsQueryFormula
usesRangeOperation
  ^ false
%

category: 'accessing'
method: GsQueryFormula
variableReferenceFor: aName
  ^ GsVariableReferenceAssociation newWithKey: aName value: nil
%

category: 'private'
method: GsQueryFormula
_bindEvaluator: anNsc for: path isRangeEqualityOperation: isRangeOperation
  | pathEvaluator iList theIndexObj legacyIndexesOnNsc |
  pathEvaluator := self pathEvaluatorFor: path.
  iList := anNsc _indexedPaths.
  iList
    ifNil: [
      "no indexes defined on nsc ... do it the hard way"
      ^ pathEvaluator nsc: anNsc ].
  legacyIndexesOnNsc := false.
  1 to: iList size by: 2 do: [ :i |
    | indexObj |
    indexObj := iList at: i.
    legacyIndexesOnNsc := indexObj isLegacyIndex. "all indexes on an nsc are either legacy or not"
    (iList at: i + 1) == 1
      ifTrue: [
        " see if the index matches the path "
        (indexObj hasIndexOnPath: pathEvaluator)
          ifTrue: [
            " if range index found for range operation or
          identity index found for identity operation "
            ((isRangeOperation and: [ indexObj isRangeEqualityIndex ])
              or: [ isRangeOperation not and: [ indexObj isIdentityIndex ] ])
              ifTrue: [
                (self _canIndexSatifyPathTermsRequired: indexObj)
                  ifTrue: [ ^ indexObj ] ]
              ifFalse: [ theIndexObj := indexObj ] ] ] ].
  isRangeOperation
    ifTrue: [
      "no range index found ... do it the hard way"
      ^ pathEvaluator nsc: anNsc ]
    ifFalse: [
      theIndexObj ~~ nil
        ifTrue: [
          (self _canIndexSatifyPathTermsRequired: theIndexObj)
            ifTrue: [
              "index found for non-range query, go ahead and use it"
              ^ theIndexObj ] ] ].
  theIndexObj := IdentityIndex new.
  theIndexObj
    indexDictionary: nsc _indexDictionary;
    nscRoot: anNsc.
  iList _putAllCommonPathTermsForPathArray: pathEvaluator into: theIndexObj.
  theIndexObj size == pathEvaluator size
    ifTrue: [
      (self _canIndexSatifyPathTermsRequired: theIndexObj)
        ifTrue: [
          legacyIndexesOnNsc
            ifTrue: [ ^ theIndexObj ]
          ifFalse: [
            "eventually this should be conditional on a GsIndexOption ... for now it's naked"
            GsQueryExpectedImplicitIdentityIndexError signal: self ] ] ].
  ^ pathEvaluator nsc: anNsc	"no qualifying identity indexes found"
%

category: 'testing'
method: GsQueryFormula
_canIndexSatifyPathTermsRequired: indexObj
  pathTermsRequired
    ifNil: [
      "not set ... use index if at all possible"
      ^ true ].
  pathTermsRequired
    ifTrue: [
      indexObj termsRequired
        ifTrue: [ ^ true ] ]
    ifFalse: [
      indexObj termsRequired
        ifFalse: [ ^ true ] ].
  ^ false
%

category: 'private'
method: GsQueryFormula
_checkForBug43764: aGsQuery
  "Bug 43764 describes a query pattern involving collection-valued path terms that produce
   incorrect query results. See the 3.2 Release Notes for more detailed information."

  | queryOptions |
  self _exposedToBug43764
    ifFalse: [ ^ self	"not exposed" ].
  queryOptions := aGsQuery queryOptions.
  [ GsQueryConjoinSetChecker check: self on: aGsQuery _nsc ]
    on: GsMalformedQueryExpressionError
    do: [ :ex |
      "checker will throw an error if the query is exposed to bug 43764"
      (queryOptions autoOptimize
        and: [ queryOptions applyDeMorgansLaws and: [ queryOptions consolidateRangePredicates ] ])
        ifTrue: [
          "exposed to bug ... pass the exception"
          ex pass ]
        ifFalse: [
          [
          | newQuery newQueryOptions |
          "determine if query is evaluable with proper options set"
          newQueryOptions := queryOptions + GsQueryOptions applyDeMorgansLaws
            + GsQueryOptions consolidateRangePredicates
            + GsQueryOptions autoOptimize.
          newQuery := aGsQuery copy.
          newQuery queryOptions: newQueryOptions.
          GsQueryConjoinSetChecker check: newQuery formula on: aGsQuery _nsc ]
            on: GsMalformedQueryExpressionError
            do: [ :ex2 |
              "exposed to bug ... pass the exception"
              ex2 pass ] ].
      GsMalformedQueryExpressionError
        bug43764QueryMustBeOptimized: #'_checkForBug43764:' ].
  ^ self	"not exposed"
%

category: 'private'
method: GsQueryFormula
_checkForStreamableQuery: aGsQuery
  "Signal an error if the formula is not suited for streaming over result set"

  "a streamable query is not exposed to bug 43764, so no need to check"

  | queryOptions |
  queryOptions := aGsQuery queryOptions.
  [ GsStreamableQueryChecker check: self on: aGsQuery _nsc ]
    on: GsMalformedQueryExpressionError
    do: [ :ex |
      "checker will throw an error if the query cannot be streamed"
      (queryOptions autoOptimize
        and: [ queryOptions applyDeMorgansLaws and: [ queryOptions consolidateRangePredicates ] ])
        ifTrue: [
          "cannot be streamed"
          ex pass ]
        ifFalse: [
          [
          | newQuery newQueryOptions |
          "determine if query is evaluable with proper options set"
          newQueryOptions := queryOptions + GsQueryOptions applyDeMorgansLaws
            + GsQueryOptions consolidateRangePredicates
            + GsQueryOptions autoOptimize.
          newQuery := aGsQuery copy.
          newQuery queryOptions: newQueryOptions.
          GsStreamableQueryChecker check: newQuery formula on: aGsQuery _nsc ]
            on: GsMalformedQueryExpressionError
            do: [ :ex2 |
              "cannot stream ... pass the exception"
              ex2 pass ] ].
      GsMalformedQueryExpressionError
        streamableQueryMustBeOptimized: #'_checkForStreamableQuery:' ].
  ^ self	"streamable query"
%

category: 'testing'
method: GsQueryFormula
_evaluatorCanStreamQueries
  "Answer true if the evaluator(s) support streaming operations"

  self _evaluators
    do: [ :each |
      each isStreamable
        ifFalse: [ ^ false ] ].
  ^ true
%

category: 'private'
method: GsQueryFormula
_evaluators
  "return list of evaluators associated with predicate"

  ^ #()
%

category: 'private'
method: GsQueryFormula
_exposedToBug43764
  "Bug 43764 describes a query pattern involving collection-valued path terms that produce
   incorrect query results. See the 3.2 Release Notes for more detailed information."

  | exposed |
  exposed := false.
  self
    _predicateAndEvaluatorsDo: [ :predicate :evaluators |
      (predicate usesComparisonOperation and: [ predicate usesRangeOperation not ])
        ifTrue: [
          "potentially exposed if predicate uses comparison operators, and is not a
           range predicate"
          evaluators
            do: [ :evaluator |
              evaluator hasCollectionBasedTerm
                ifTrue: [
                  exposed
                    ifTrue: [
                      "exposed if receiver has two or more collection based path terms"
                      ^ true ].
                  exposed := true ] ] ] ].
  ^ false
%

category: 'accessing'
method: GsQueryFormula
_nsc
  ^ nsc
%

category: 'accessing'
method: GsQueryFormula
_nsc: anNsc collator: anIcuCollatorOrNil
  nsc := anNsc.
  collator := anIcuCollatorOrNil
%

category: 'private'
method: GsQueryFormula
_parsePath: path
  "strip each off terms"

  | terms |
  terms := path asArrayOf32PathTerms.
  terms := terms size = 1
    ifTrue: [ #(#'') ]
    ifFalse: [ terms copyFrom: 2 to: terms size ].
  ^ terms
%

category: 'accessing'
method: GsQueryFormula
_pathTerms
  ^ self _parsePath: self path
%

category: 'accessing'
method: GsQueryFormula
_pathTermsRequired
  ^ pathTermsRequired
%

category: 'accessing'
method: GsQueryFormula
_pathTermsRequired: aBoolOrNil
  "set to true, if you want to quarantee that path terms are required during query
   evaluation. If an index is available, but the index uses optional path terms,
   then the query will use brute force evaluation."

  "set to false if you want to guaranatee that path terms are optional during query
   evaluation. If an index is available, but the index uses required path terms,
   then the query will use brute force evaluation."

  "set to nil (default) if you do not care. Indexes will be used if available
   otherwise brute force evaluation will be used with optional path terms."

  pathTermsRequired := aBoolOrNil
%

category: 'private'
method: GsQueryFormula
_predicateAndEvaluatorsDo: aBlock
  "visit all predicates in receiver and provide access to predicate and list of evaluators
   for the predicate"

  aBlock value: self value: self _evaluators
%

category: 'testing'
method: GsQueryFormula
_queryUsesIdentityIndex
  "answer true if the one or more of the predicates has an evaluator that is an identity index"

  self _evaluators
    do: [ :each |
      (each isPathEvaluator not
        and: [ each isIdentityIndex ])
        ifTrue: [ ^ true ] ].
  ^ false
%

category: 'testing'
method: GsQueryFormula
_queryUsesIndex
  "answer true if the one or more of the predicates has an evaluator that is a range or identity index"

  self _evaluators
    do: [ :each |
      (each isPathEvaluator not
        and: [ each isIdentityIndex or: [ each isRangeEqualityIndex ] ])
        ifTrue: [ ^ true ] ].
  ^ false
%

category: 'operators'
method: GsQueryFormula
| aClause
  ^ GsCompoundClause clause: self operator: #'|' clause: aClause
%

! Class extensions for 'GsQueryFormulaVisitor'

!		Instance methods for 'GsQueryFormulaVisitor'

category: 'visiting'
method: GsQueryFormulaVisitor
acceptCompoundClause: aCompoundClause
  aCompoundClause clause1 acceptVisitor: self.
  aCompoundClause clause2 acceptVisitor: self
%

category: 'visiting'
method: GsQueryFormulaVisitor
acceptFormula: aFormula
%

category: 'visiting'
method: GsQueryFormulaVisitor
acceptPredicate: aPredicate
%

category: 'visiting'
method: GsQueryFormulaVisitor
acceptRangePredicate: aRangePredicate
%

category: 'visiting'
method: GsQueryFormulaVisitor
acceptUnaryClause: aUnaryClause
  aUnaryClause clause acceptVisitor: self
%

category: 'visiting'
method: GsQueryFormulaVisitor
visitFormula: aFormula
  aFormula acceptVisitor: self.
  ^ aFormula
%

! Class extensions for 'GsQueryGrammar'

!		Class methods for 'GsQueryGrammar'

category: 'instance creation'
classmethod: GsQueryGrammar
parseFormula: aString
  ^ self new parseFormula: aString
%

category: 'instance creation'
classmethod: GsQueryGrammar
parseFormula: aString onError: aBlock
  ^ self new parseFormula: aString onError: aBlock
%

!		Instance methods for 'GsQueryGrammar'

category: 'grammar-messages'
method: GsQueryGrammar
andBlock
  ^ [ :predicate1 :operator :predicate2 |
  {predicate1.
  operator.
  predicate2} ]
%

category: 'grammar-literals'
method: GsQueryGrammar
arrayItem
  ^ literal / symbolLiteralArray / arrayLiteralArray / byteLiteralArray
%

category: 'grammar-literals'
method: GsQueryGrammar
arrayLiteral
  ^ '#(' asParser queryToken , arrayItem star , $) asParser queryToken
%

category: 'grammar-literals'
method: GsQueryGrammar
arrayLiteralArray
  ^ $( asParser queryToken , arrayItem star , $) asParser queryToken
%

category: 'primitives'
method: GsQueryGrammar
binary
	^ (PPPredicateObjectParser anyOf: '!%&*+,-/<=>?@\|~') plus
%

category: 'grammar-literals'
method: GsQueryGrammar
byteLiteral
  ^ '#[' asParser queryToken , numberLiteral star , $] asParser queryToken
%

category: 'grammar-literals'
method: GsQueryGrammar
byteLiteralArray
  ^ $[ asParser queryToken , numberLiteral star , $] asParser queryToken
%

category: 'primitives'
method: GsQueryGrammar
char
	^ $$ asParser , #any asParser
%

category: 'grammar-literals'
method: GsQueryGrammar
charLiteral
	^ charToken
%

category: 'token'
method: GsQueryGrammar
charToken
  ^ char queryToken
%

category: 'grammar-messages'
method: GsQueryGrammar
expression
  | exp |
  exp := PPExpressionParser new.
  exp term: parenExpression / parenPredicate.
  exp
    group: [ :g |
          g
            postfix:
              (notToken
                handleGsQueryErrorMessage: '$|, $&, or not expected'
                nestMessages: false)
            do: self notBlock ];
    group: [ :g |
          g left: $| asParser token trim do: self orBlock.
          g left: $& asParser token trim do: self andBlock ].
  ^ predicateExpression / exp
%

category: 'grammar-literals'
method: GsQueryGrammar
falseLiteral
	^ falseToken
%

category: 'token'
method: GsQueryGrammar
falseToken
  ^ ('false' asParser , #'word' asParser not) queryToken
%

category: 'primitives'
method: GsQueryGrammar
identifier
  ^ (PPPredicateObjectParser
    on: [ :each | each isLetter or: [ each == $_ ] ]
    message: 'letter expected')
    ,
      (PPPredicateObjectParser
        on: [ :each | each isAlphaNumeric or: [ each == $_ ] ]
        message: 'letter or digit expected') star
%

category: 'token'
method: GsQueryGrammar
identifierToken
  ^ primaryIdentifier queryToken
%

category: 'grammar'
method: GsQueryGrammar
literal
  ^ numberLiteral / stringLiteral / charLiteral / arrayLiteral / byteLiteral
    / symbolLiteral / nilLiteral / trueLiteral / falseLiteral
%

category: 'grammar-literals'
method: GsQueryGrammar
nilLiteral
	^ nilToken
%

category: 'token'
method: GsQueryGrammar
nilToken
  ^ ('nil' asParser , #'word' asParser not) queryToken
%

category: 'primitives'
method: GsQueryGrammar
not
  ^ 'not' asParser , #'word' asParser not
%

category: 'grammar-messages'
method: GsQueryGrammar
notBlock
  ^ [ :a :b |
  {a.
  b} ]
%

category: 'grammar-messages'
method: GsQueryGrammar
notMessage
  ^ notToken ==> [ :node | { { node } . { } } ]
%

category: 'token'
method: GsQueryGrammar
notToken
  ^ not queryToken
%

category: 'primitives'
method: GsQueryGrammar
number
  ^ ($- asParser optional , #'digit' asParser) and
    ,
      [ :stream |
      [ Number fromStream: stream ]
        on: Error
        do: [ :err | PPFailure message: err messageText at: stream position ] ]
        asParser
%

category: 'grammar-literals'
method: GsQueryGrammar
numberLiteral
	^ numberToken
%

category: 'token'
method: GsQueryGrammar
numberToken
  ^ number queryToken
%

category: 'grammar-messages'
method: GsQueryGrammar
orBlock
  ^ [ :predicate1 :operator :predicate2 |
  {predicate1.
  {{{operator}.
  {predicate2}}}} ]
%

category: 'grammar-literals'
method: GsQueryGrammar
parenExpression
  ^ $( asParser queryToken , expression , $) asParser queryToken
%

category: 'grammar-literals'
method: GsQueryGrammar
parenPredicate
  ^ $( asParser queryToken , predicateExpression , $) asParser queryToken
%

category: 'parsing'
method: GsQueryGrammar
parseFormula: aString
  ^ self
    parseFormula: aString
    onError: [ :msg :pos | GsQueryParseError signal: msg , ' at position ' , pos printString position: pos ]
%

category: 'parsing'
method: GsQueryGrammar
parseFormula: aString onError: aBlock
  ^ self start parse: aString onError: aBlock
%

category: 'grammar-messages'
method: GsQueryGrammar
path
  ^ primaryIdentifier , ($. asParser , identifier) plus
%

category: 'grammar-messages'
method: GsQueryGrammar
pathToken
  ^ path queryToken
%

category: 'grammar-messages'
method: GsQueryGrammar
predicateExpression
  ^ rangePredicateExpression / simplePredicateExpression
%

category: 'grammar-messages'
method: GsQueryGrammar
predicateMessage
  ^ ((relopToken
    handleGsQueryErrorMessage: 'relational operator expected'
    nestMessages: false) , primary)
    ==> [ :nodes |
      {{(nodes first)}.
      {(nodes at: 2)}} ]
%

category: 'grammar'
method: GsQueryGrammar
primary
  ^ queryPathToken / pathToken / literal / variable
    handleGsQueryErrorMessage: 'queryPath, path, literal or variable expected'
    nestMessages: false
%

category: 'grammar'
method: GsQueryGrammar
primaryIdentifier
  ^ 'each' asParser not , identifier
%

category: 'grammar-messages'
method: GsQueryGrammar
queryPath
  ^ 'each' asParser
    ,
      ($. asParser
        ,
          (('#' asParser , identifier) / (identifier , '|' asParser , identifier)
            / identifier)
        ,
          ($. asParser
            ,
              (('#' asParser , identifier) / (identifier , '|' asParser , identifier)
                / '*' asParser / identifier))
            star
        min: 0)
%

category: 'grammar-messages'
method: GsQueryGrammar
queryPathToken
  ^ queryPath queryToken
%

category: 'grammar-messages'
method: GsQueryGrammar
rangePredicateExpression
  ^ rangePrimary
    ,
      (relopToken
        handleGsQueryErrorMessage: 'relational operator expected'
        nestMessages: false)
    , queryPathToken
    ,
      (relopToken
        handleGsQueryErrorMessage: 'relational operator expected'
        nestMessages: false)
    , rangePrimary
%

category: 'grammar'
method: GsQueryGrammar
rangePrimary
  ^ pathToken / literal / variable
    handleGsQueryErrorMessage: 'path, literal or variable expected'
    nestMessages: false
%

category: 'primitives'
method: GsQueryGrammar
relop
  ^ '<=' asParser / '<' asParser / '>=' asParser / '>' asParser / '==' asParser
    / '=' asParser / '~=' asParser / '~~' asParser
%

category: 'token'
method: GsQueryGrammar
relopToken
  ^ relop queryToken
%

category: 'grammar-messages'
method: GsQueryGrammar
simplePredicateExpression
  ^ primary , (predicateMessage min: 0 max: 1)
%

category: 'primitives'
method: GsQueryGrammar
start
  "Default start production."

  ^ expression end handleGsQueryErrorMessage: 'invalid query expression'
%

category: 'primitives'
method: GsQueryGrammar
string
	^ $' asParser , ('''''' asParser / $' asParser negate) star , $' asParser
%

category: 'grammar-literals'
method: GsQueryGrammar
stringLiteral
	^ stringToken
%

category: 'token'
method: GsQueryGrammar
stringToken
  ^ string queryToken
%

category: 'primitives'
method: GsQueryGrammar
symbol
  ^ identifier / binary / string
%

category: 'grammar-literals'
method: GsQueryGrammar
symbolLiteral
  ^ ($# asParser queryToken plus , symbol queryToken)
    ==> [ :tokens | tokens first copyWith: tokens last ]
%

category: 'grammar-literals'
method: GsQueryGrammar
symbolLiteralArray
  ^ symbol queryToken
%

category: 'grammar-literals'
method: GsQueryGrammar
trueLiteral
	^ trueToken
%

category: 'token'
method: GsQueryGrammar
trueToken
  ^ ('true' asParser , #'word' asParser not) queryToken
%

category: 'grammar'
method: GsQueryGrammar
variable
	^ identifierToken
%

! Class extensions for 'GsQueryLiteral'

!		Instance methods for 'GsQueryLiteral'

category: 'converting'
method: GsQueryLiteral
asFormula
  (self _idxValue isKindOf: Boolean)
    ifFalse: [ self errorConstantPredicateMustBeBoolean ].
  ^ GsConstantConstantPredicate new
    operand1: self asReferenceAssociation;
    operator: #'unary';
    immediateInvariant
%

category: 'converting'
method: GsQueryLiteral
asFormulaWithSelectorParts: selectorParts
  ^ GsUnaryClause
    clause: self asFormula
    operator: selectorParts first inputValue asSymbol
%

category: 'converting'
method: GsQueryLiteral
asFormulaWithSelectorParts: selectorParts arguments: arguments
  ^ arguments first asReferenceAssociation
    constructFormulaWithSelector: selectorParts first inputValue
    againstConstantReferenceAssoction: self asReferenceAssociation
%

category: 'converting'
method: GsQueryLiteral
asReferenceAssociation
  ^ GsConstantReferenceAssociation newWithKey: self valuePrintString value: self _idxValue
%

category: 'private'
method: GsQueryLiteral
buildGsQueryParserNodeFor: aGsQueryParser
  aGsQueryParser build: self messages: nil
%

category: 'private'
method: GsQueryLiteral
constructFormulaWithSelector: selector againstConstantReferenceAssoction: aConstantReferenceAssociation
  ^ GsConstantConstantPredicate new
    operand1: aConstantReferenceAssociation;
    operator: selector asSymbol;
    operand2: self asReferenceAssociation;
    immediateInvariant
%

category: 'private'
method: GsQueryLiteral
errorConstantPredicateMustBeBoolean
  self error: 'Constant predicate must be Boolean'
%

category: 'accessing'
method: GsQueryLiteral
valuePrintOn: aStream
  self subclassResponsibility: #'valuePrintOn:'
%

category: 'accessing'
method: GsQueryLiteral
valuePrintString
  | aStream |
  aStream := AppendStream on: String new.
  self valuePrintOn: aStream.
  ^ aStream contents
%

category: 'accessing'
method: GsQueryLiteral
_idxValue
  self subclassResponsibility: #'_idxValue'
%

! Class extensions for 'GsQueryLiteralArray'

!		Instance methods for 'GsQueryLiteralArray'

category: 'converting'
method: GsQueryLiteralArray
asFormula
  self errorConstantPredicateMustBeBoolean
%

category: 'accessing'
method: GsQueryLiteralArray
contents
  ^ contents
%

category: 'accessing'
method: GsQueryLiteralArray
contents: anArray
  contents := anArray
%

category: 'accessing'
method: GsQueryLiteralArray
isByteArray
  ^ isByteArray
%

category: 'accessing'
method: GsQueryLiteralArray
isByteArray: aBool
  isByteArray := aBool
%

category: 'accessing'
method: GsQueryLiteralArray
valuePrintOn: aStream
  isByteArray
    ifTrue: [ aStream nextPutAll: '#[ ' ]
    ifFalse: [ aStream nextPutAll: '#( ' ].
  1 to: contents size do: [ :index |
    (contents at: index) valuePrintOn: aStream.
    aStream space ].
  isByteArray
    ifTrue: [ aStream nextPutAll: ']' ]
    ifFalse: [ aStream nextPutAll: ')' ]
%

category: 'accessing'
method: GsQueryLiteralArray
_idxValue
  | array |
  array := (isByteArray
    ifTrue: [ ByteArray ]
    ifFalse: [ Array ]) new: contents size.
  1 to: contents size do: [ :index | array at: index put: (contents at: index) _idxValue ].
  ^ array
%

! Class extensions for 'GsQueryLiteralValue'

!		Instance methods for 'GsQueryLiteralValue'

category: 'accessing'
method: GsQueryLiteralValue
value
  ^ value
%

category: 'accessing'
method: GsQueryLiteralValue
value: anObject
  value := anObject
%

category: 'accessing'
method: GsQueryLiteralValue
valuePrintOn: aStream
  ^ self value printOn: aStream
%

category: 'accessing'
method: GsQueryLiteralValue
valuePrintString
  ^ self value printString
%

category: 'accessing'
method: GsQueryLiteralValue
_idxValue

  ^self value
%

! Class extensions for 'GsQueryOptions'

!		Class methods for 'GsQueryOptions'

category: 'options'
classmethod: GsQueryOptions
applyDeMorgansLaws
  "Apply De Morgan's Laws to eliminate `not` in queries:

    The negation of a conjunction is the disjunction of the negations.
    The negation of a disjunction is the conjunction of the negations.

    Where:

          (each.firstName = 'Dale') not

        becomes:

          (each.firstName ~= 'Dale')

    and:

          ((1 <= each.numberOfChildren) & (each.numberOfChildren <= 4)) not

        becomes:

          (each.numberOfChildren < 1) | (each.numberOfChildren > 4)
    and:

          ((1 > each.numberOfChildren) | (each.numberOfChildren > 4)) not

        becomes:

          (1 <= each.numberOfChildren) & (each.numberOfChildren <= 4)
"

  ^ self new
    setApplyDeMorgansLaws;
    yourself
%

category: 'options'
classmethod: GsQueryOptions
autoOptimize
  "Query formula is automatically optimized"

  ^ self new
    setAutoOptimize;
    yourself
%

category: 'options'
classmethod: GsQueryOptions
cacheQueryResult
  "Cache query result"

  ^ self new
    setCacheQueryResult;
    yourself
%

category: 'options'
classmethod: GsQueryOptions
consolidateEnumerablePredicates
  "Consolidate path-constant predicates to single enumerated predicate
      if an index exists that has an enumerated path term and predicates
      using the enumerated path  term can be combined into a single
      predicate

          (each.firstName = 'Martin') | (each.lastName = 'Martin')

        becomes:

          (each.firstName|lastName = 'Martin')"

  ^ self new
    setConsolidateEnumerablePredicates;
    yourself
%

category: 'options'
classmethod: GsQueryOptions
consolidateRangePredicates
  "Convert 2 path-constant predicates into a single range predicate when possible

          (each.age > 4) & (each.age < 19)

        becomes:

          (4 < each.age < 19)"

  ^ self new
    setConsolidateRangePredicates;
    yourself
%

category: 'options'
classmethod: GsQueryOptions
consolidateUnaryConstantPredicates
  "Simplify formulas involving predicates that are unary-constant (true or false) or
   constant-constant. The predicate is removed, or the expression is consolidated.

  (true) & <other predicates>
    becomes:
  <other predicates>

  (true) | <otherpredicates>
    becomes:
  (true)

  (false) & <other predicates>
    becomes:
  (false)

  (false) | <other predicates>
    becomes:
  <other predicates>

  (true) & (each.name = 'Dale') & (each.gender == #male)
    becomes:
  (each.name = 'Dale') & (each.gender == #male)"

  ^ self new
    setConsolidateUnaryConstantPredicates;
    yourself
%

category: 'options'
classmethod: GsQueryOptions
default
  "all options set except cacheQueryResult"

  ^ self optimizerOptions + self autoOptimize
%

category: 'options'
classmethod: GsQueryOptions
normalizePredicates
  "Replace constant-path predicates with equivalent path-constant predicates.

          (19 > each.age)

        becomes:

          (each.age < 19)"

  ^ self new
    setNormalizePredicates;
    yourself
%

category: 'options'
classmethod: GsQueryOptions
optimizerOptions
  "all options that control operation of optimizer"

  ^ self new
    setApplyDeMorgansLaws;
    setConsolidateEnumerablePredicates;
    setConsolidateRangePredicates;
    setConsolidateUnaryConstantPredicates;
    setNormalizePredicates;
    setRemoveRedundantPredicates;
    setReorderPredicates;
    setTransformCommonPaths
%

category: 'Instance Creation'
classmethod: GsQueryOptions
optionalPathTerms
  "Do not signal an error if instance variable missing along index path."

  ^ self new
    setOptionalPathTerms;
    yourself
%

category: 'options'
classmethod: GsQueryOptions
removeRedundantPredicates
  "Eliminate redundant predicates. i.e., predicates that fall within range
	of other predicates

          (each.age < 19) & (each.age < 4)

        becomes:

          (each.age < 4)"

  ^ self new
    setRemoveRedundantPredicates;
    yourself
%

category: 'options'
classmethod: GsQueryOptions
reorderPredicates
  "Reorder predicates based on following ordering rules:
        constant predicates
        indexed predicates
        identity comparison predicates
        equality comparison predicates
        all others

          (each.age <= 21) & (each.gender == #male) &
          (each.name = 'Dale') & (each.father = each.father)

        assuming each.name is indexed and each.age is not indexed, becomes:

          (true) & (each.name = 'Dale') &
          (each.gender == #male) & (each.age <= 21)"

  ^ self new
    setReorderPredicates;
    yourself
%

category: 'options'
classmethod: GsQueryOptions
transformCommonPaths
  "Convert predicates with common path-path operands to an equivalent
	constant predicate.

          (each.firstName = each.firstName)

        becomes:

          (true)"

  ^ self new
    setTransformCommonPaths;
    yourself
%

!		Instance methods for 'GsQueryOptions'

category: 'Comparison'
method: GsQueryOptions
= aGsQueryOptions
  (aGsQueryOptions isKindOf: self class)
    ifFalse: [ ^ false ].
  ^ self applyDeMorgansLaws == aGsQueryOptions applyDeMorgansLaws
    and: [
      self autoOptimize == aGsQueryOptions autoOptimize
        and: [
          self cacheQueryResult == aGsQueryOptions cacheQueryResult
            and: [
              self consolidateEnumerablePredicates
                == aGsQueryOptions consolidateEnumerablePredicates
                and: [
                  self consolidateRangePredicates == aGsQueryOptions consolidateRangePredicates
                    and: [
                      self normalizePredicates == aGsQueryOptions normalizePredicates
                        and: [
                          self removeRedundantPredicates == aGsQueryOptions removeRedundantPredicates
                            and: [
                              self reorderPredicates == aGsQueryOptions reorderPredicates
                                and: [
                                  self transformCommonPaths == aGsQueryOptions transformCommonPaths
                                    and: [
                                      self consolidateUnaryConstantPredicates
                                        ==
                                          aGsQueryOptions consolidateUnaryConstantPredicates
                                        and: [ self optionalPathTerms == aGsQueryOptions optionalPathTerms ] ] ] ] ] ] ] ] ] ]
%

category: 'Accessing'
method: GsQueryOptions
applyDeMorgansLaws
  | val |
  val := self dynamicInstVarAt: #'applyDeMorgansLaws'.
  val ifNil: [ ^ false ].
  ^ val
%

category: 'Accessing'
method: GsQueryOptions
applyDeMorgansLaws: aBoolean
  self dynamicInstVarAt: #'applyDeMorgansLaws' put: aBoolean
%

category: 'Accessing'
method: GsQueryOptions
autoOptimize
  | val |
  val := self dynamicInstVarAt: #'autoOptimize'.
  val ifNil: [ ^ false ].
  ^ val
%

category: 'Accessing'
method: GsQueryOptions
autoOptimize: aBoolean
  self dynamicInstVarAt: #'autoOptimize' put: aBoolean
%

category: 'Accessing'
method: GsQueryOptions
cacheQueryResult
  | val |
  val := self dynamicInstVarAt: #'cacheQueryResult'.
  val ifNil: [ ^ false ].
  ^ val
%

category: 'Accessing'
method: GsQueryOptions
cacheQueryResult: aBoolean
  self dynamicInstVarAt: #'cacheQueryResult' put: aBoolean
%

category: 'Operators'
method: GsQueryOptions
clearApplyDeMorgansLaws
  self applyDeMorgansLaws: false
%

category: 'Operators'
method: GsQueryOptions
clearAutoOptimize
  self autoOptimize: false
%

category: 'Operators'
method: GsQueryOptions
clearCacheQueryResult
  self cacheQueryResult: false
%

category: 'Operators'
method: GsQueryOptions
clearConsolidateEnumerablePredicates
  self consolidateEnumerablePredicates: false
%

category: 'Operators'
method: GsQueryOptions
clearConsolidateRangePredicates
  self consolidateRangePredicates: false
%

category: 'Operators'
method: GsQueryOptions
clearConsolidateUnaryConstantPredicates
  self consolidateUnaryConstantPredicates: false
%

category: 'Operators'
method: GsQueryOptions
clearNormalizePredicates
  self normalizePredicates: false
%

category: 'Operators'
method: GsQueryOptions
clearOptionalPathTerms
  self optionalPathTerms: false
%

category: 'Operators'
method: GsQueryOptions
clearRemoveRedundantPredicates
  self removeRedundantPredicates: false
%

category: 'Operators'
method: GsQueryOptions
clearReorderPredicates
  self reorderPredicates: false
%

category: 'Operators'
method: GsQueryOptions
clearTransformCommonPaths
  self transformCommonPaths: false
%

category: 'Operators'
method: GsQueryOptions
combineWith: aGsQueryOptions
  self applyDeMorgansLaws
    ifTrue: [ aGsQueryOptions setApplyDeMorgansLaws ].
  self autoOptimize
    ifTrue: [ aGsQueryOptions setAutoOptimize ].
  self cacheQueryResult
    ifTrue: [ aGsQueryOptions setCacheQueryResult ].
  self consolidateEnumerablePredicates
    ifTrue: [ aGsQueryOptions setConsolidateEnumerablePredicates ].
  self consolidateRangePredicates
    ifTrue: [ aGsQueryOptions setConsolidateRangePredicates ].
  self normalizePredicates
    ifTrue: [ aGsQueryOptions setNormalizePredicates ].
  self removeRedundantPredicates
    ifTrue: [ aGsQueryOptions setRemoveRedundantPredicates ].
  self consolidateUnaryConstantPredicates
    ifTrue: [ aGsQueryOptions setConsolidateUnaryConstantPredicates ].
  self reorderPredicates
    ifTrue: [ aGsQueryOptions setReorderPredicates ].
  self transformCommonPaths
    ifTrue: [ aGsQueryOptions setTransformCommonPaths ].
  self optionalPathTerms
    ifTrue: [ aGsQueryOptions setOptionalPathTerms ].
  ^ aGsQueryOptions
%

category: 'Accessing'
method: GsQueryOptions
consolidateEnumerablePredicates
  | val |
  val := self dynamicInstVarAt: #'consolidateEnumerablePredicates'.
  val ifNil: [ ^ false ].
  ^ val
%

category: 'Accessing'
method: GsQueryOptions
consolidateEnumerablePredicates: aBoolean
  self dynamicInstVarAt: #'consolidateEnumerablePredicates' put: aBoolean
%

category: 'Accessing'
method: GsQueryOptions
consolidateRangePredicates
  | val |
  val := self dynamicInstVarAt: #'consolidateRangePredicates'.
  val ifNil: [ ^ false ].
  ^ val
%

category: 'Accessing'
method: GsQueryOptions
consolidateRangePredicates: aBoolean
  self dynamicInstVarAt: #'consolidateRangePredicates' put: aBoolean
%

category: 'Accessing'
method: GsQueryOptions
consolidateUnaryConstantPredicates
  | val |
  val := self dynamicInstVarAt: #'consolidateUnaryConstantPredicates'.
  val ifNil: [ ^ false ].
  ^ val
%

category: 'Accessing'
method: GsQueryOptions
consolidateUnaryConstantPredicates: aBoolean
  self dynamicInstVarAt: #'consolidateUnaryConstantPredicates' put: aBoolean
%

category: 'Comparison'
method: GsQueryOptions
hash
  ^ self applyDeMorgansLaws hash
    bitXor:
      ((self autoOptimize hash bitShift: 1)
        bitXor:
          ((self cacheQueryResult hash bitShift: 2)
            bitXor:
              ((self consolidateEnumerablePredicates hash bitShift: 3)
                bitXor:
                  ((self consolidateRangePredicates hash bitShift: 4)
                    bitXor:
                      ((self normalizePredicates hash bitShift: 5)
                        bitXor:
                          ((self removeRedundantPredicates hash bitShift: 6)
                            bitXor:
                              ((self reorderPredicates hash bitShift: 7)
                                bitXor:
                                  ((self transformCommonPaths hash bitShift: 8)
                                    bitXor:
                                      (self consolidateUnaryConstantPredicates hash bitShift: 9)))))))))
%

category: 'Initialize-Release'
method: GsQueryOptions
initialize
  super initialize.
  self applyDeMorgansLaws: false.
  self autoOptimize: false.
  self cacheQueryResult: false.
  self consolidateEnumerablePredicates: false.
  self consolidateRangePredicates: false.
  self normalizePredicates: false.
  self removeRedundantPredicates: false.
  self consolidateUnaryConstantPredicates: false.
  self reorderPredicates: false.
  self transformCommonPaths: false.
  self optionalPathTerms: false
%

category: 'Operators'
method: GsQueryOptions
negateWith: aGsQueryOptions
  self applyDeMorgansLaws
    ifTrue: [ aGsQueryOptions clearApplyDeMorgansLaws ].
  self autoOptimize
    ifTrue: [ aGsQueryOptions clearAutoOptimize ].
  self cacheQueryResult
    ifTrue: [ aGsQueryOptions clearCacheQueryResult ].
  self consolidateEnumerablePredicates
    ifTrue: [ aGsQueryOptions clearConsolidateEnumerablePredicates ].
  self consolidateRangePredicates
    ifTrue: [ aGsQueryOptions clearConsolidateRangePredicates ].
  self normalizePredicates
    ifTrue: [ aGsQueryOptions clearNormalizePredicates ].
  self removeRedundantPredicates
    ifTrue: [ aGsQueryOptions clearRemoveRedundantPredicates ].
  self consolidateUnaryConstantPredicates
    ifTrue: [ aGsQueryOptions clearConsolidateUnaryConstantPredicates ].
  self reorderPredicates
    ifTrue: [ aGsQueryOptions clearReorderPredicates ].
  self transformCommonPaths
    ifTrue: [ aGsQueryOptions clearTransformCommonPaths ].
  self optionalPathTerms
    ifTrue: [ aGsQueryOptions clearOptionalPathTerms ].
  ^ aGsQueryOptions
%

category: 'Accessing'
method: GsQueryOptions
normalizePredicates
  | val |
  val := self dynamicInstVarAt: #'normalizePredicates'.
  val ifNil: [ ^ false ].
  ^ val
%

category: 'Accessing'
method: GsQueryOptions
normalizePredicates: aBoolean
  self dynamicInstVarAt: #'normalizePredicates' put: aBoolean
%

category: 'Accessing'
method: GsQueryOptions
optionalPathTerms
  | val |
  val := self dynamicInstVarAt: #'optionalPathTerms'.
  val ifNil: [ ^ false ].
  ^ val
%

category: 'Accessing'
method: GsQueryOptions
optionalPathTerms: aBool
  self dynamicInstVarAt: #'optionalPathTerms' put: aBool
%

category: 'Accessing'
method: GsQueryOptions
removeRedundantPredicates
  | val |
  val := self dynamicInstVarAt: #'removeRedundantPredicates'.
  val ifNil: [ ^ false ].
  ^ val
%

category: 'Accessing'
method: GsQueryOptions
removeRedundantPredicates: aBoolean
  self dynamicInstVarAt: #'removeRedundantPredicates' put: aBoolean
%

category: 'Accessing'
method: GsQueryOptions
reorderPredicates
  | val |
  val := self dynamicInstVarAt: #'reorderPredicates'.
  val ifNil: [ ^ false ].
  ^ val
%

category: 'Accessing'
method: GsQueryOptions
reorderPredicates: aBoolean
  self dynamicInstVarAt: #'reorderPredicates' put: aBoolean
%

category: 'Operators'
method: GsQueryOptions
setApplyDeMorgansLaws
  self applyDeMorgansLaws: true
%

category: 'Operators'
method: GsQueryOptions
setAutoOptimize
  self autoOptimize: true
%

category: 'Operators'
method: GsQueryOptions
setCacheQueryResult
  self cacheQueryResult: true
%

category: 'Operators'
method: GsQueryOptions
setConsolidateEnumerablePredicates
  self consolidateEnumerablePredicates: true
%

category: 'Operators'
method: GsQueryOptions
setConsolidateRangePredicates
  self consolidateRangePredicates: true
%

category: 'Operators'
method: GsQueryOptions
setConsolidateUnaryConstantPredicates
  self consolidateUnaryConstantPredicates: true
%

category: 'Operators'
method: GsQueryOptions
setNormalizePredicates
  self normalizePredicates: true
%

category: 'Operators'
method: GsQueryOptions
setOptionalPathTerms
  self optionalPathTerms: true
%

category: 'Operators'
method: GsQueryOptions
setRemoveRedundantPredicates
  self removeRedundantPredicates: true
%

category: 'Operators'
method: GsQueryOptions
setReorderPredicates
  self reorderPredicates: true
%

category: 'Operators'
method: GsQueryOptions
setTransformCommonPaths
  self transformCommonPaths: true
%

category: 'Accessing'
method: GsQueryOptions
transformCommonPaths
  | val |
  val := self dynamicInstVarAt: #'transformCommonPaths'.
  val ifNil: [ ^ false ].
  ^ val
%

category: 'Accessing'
method: GsQueryOptions
transformCommonPaths: aBoolean
  self dynamicInstVarAt: #'transformCommonPaths' put: aBoolean
%

! Class extensions for 'GsQueryParseError'

!		Class methods for 'GsQueryParseError'

category: 'instance creation'
classmethod: GsQueryParseError
signal: errorMessage position: errorPosition
  ^ self new
    position: errorPosition;
    signal: errorMessage
%

!		Instance methods for 'GsQueryParseError'

category: 'accessing'
method: GsQueryParseError
position
  ^ position
%

category: 'accessing'
method: GsQueryParseError
position: errorPosition
  position := errorPosition
%

! Class extensions for 'GsQueryParser'

!		Class methods for 'GsQueryParser'

category: 'instance creation'
classmethod: GsQueryParser
compileFormula: aString
  ^ (self parseFormula: aString) asFormula
%

category: 'instance creation'
classmethod: GsQueryParser
compileFormula: aString onError: aBlock
  ^ (self parseFormula: aString onError: aBlock) asFormula
%

!		Instance methods for 'GsQueryParser'

category: 'grammar-literals'
method: GsQueryParser
andBlock
  ^ [ :predicate1 :operator :predicate2 |
  predicate1 asFormula
    asFormulaWithSelectorParts: {operator}
    arguments: {(predicate2 asFormula)} ]
%

category: 'grammar-literals'
method: GsQueryParser
arrayLiteral
  ^ super arrayLiteral
    ==> [ :nodes |
      GsQueryLiteralArray new
        contents: (nodes at: 2);
        isByteArray: false;
        yourself ]
%

category: 'grammar-literals'
method: GsQueryParser
arrayLiteralArray
  ^ super arrayLiteralArray
    ==> [ :nodes |
      GsQueryLiteralArray new
        contents: (nodes at: 2);
        isByteArray: false;
        yourself ]
%

category: 'private'
method: GsQueryParser
build: aNode messages: anArray
  ^ (anArray == nil  or: [ anArray isEmpty ])
    ifTrue: [ aNode ]
    ifFalse: [
      anArray
        inject: aNode
        into: [ :receiver :messageArray |
          messageArray == nil
            ifTrue: [ receiver ]
            ifFalse: [
              (messageArray at: 2) isEmpty
                ifTrue: [ receiver asFormulaWithSelectorParts: messageArray first ]
                ifFalse: [
                  receiver
                    asFormulaWithSelectorParts: messageArray first
                    arguments: (messageArray at: 2) ] ] ] ]
%

category: 'private'
method: GsQueryParser
buildString: aString
	(aString isEmpty or: [ aString first ~= $' or: [ aString last ~= $' ] ])
		ifTrue: [ ^ aString ].
	^ (aString
		copyFrom: 2
		to: aString size - 1)
		copyReplaceAll: ''''''
		with: ''''
%

category: 'grammar-literals'
method: GsQueryParser
byteLiteral
  ^ super byteLiteral
    ==> [ :nodes |
      GsQueryLiteralArray new
        contents: (nodes at: 2);
        isByteArray: true;
        yourself ]
%

category: 'grammar-literals'
method: GsQueryParser
byteLiteralArray
  ^ super byteLiteralArray
    ==> [ :nodes |
      GsQueryLiteralArray new
        contents: (nodes at: 2);
        isByteArray: true;
        yourself ]
%

category: 'grammar-literals'
method: GsQueryParser
charLiteral
  ^ super charLiteral
    ==> [ :token |
      GsQueryLiteralValue new
        value: (token inputValue at: 2);
        yourself ]
%

category: 'grammar-messages'
method: GsQueryParser
expression
  ^ super expression
    map: [ :arrayOrNode | arrayOrNode buildGsQueryParserNodeFor: self ]
%

category: 'grammar-literals'
method: GsQueryParser
falseLiteral
  ^ super falseLiteral
    ==> [ :token |
      GsQueryLiteralValue new
        value: false;
        yourself ]
%

category: 'grammar-literals'
method: GsQueryParser
nilLiteral
  ^ super nilLiteral
    ==> [ :token |
      GsQueryLiteralValue new
        value: nil;
        yourself ]
%

category: 'grammar-literals'
method: GsQueryParser
notBlock
  ^ [ :predicate1 :operator | predicate1 asFormulaWithSelectorParts: {operator} ]
%

category: 'grammar-literals'
method: GsQueryParser
numberLiteral
  ^ super numberLiteral
    ==> [ :token |
      GsQueryLiteralValue new
        value: (Number fromStream: token inputValue readStream);
        yourself ]
%

category: 'grammar-literals'
method: GsQueryParser
orBlock
  ^ [ :predicate1 :operator :predicate2 |
  predicate1 asFormula
    asFormulaWithSelectorParts: {operator}
    arguments: {(predicate2 asFormula)} ]
%

category: 'grammar'
method: GsQueryParser
parenExpression
  ^ super parenExpression
    map: [ :openToken :expressionNode :closeToken | expressionNode ]
%

category: 'grammar'
method: GsQueryParser
parenPredicate
  ^ super parenPredicate
    map: [ :openToken :expressionNode :closeToken | expressionNode ]
%

category: 'grammar'
method: GsQueryParser
pathToken
  ^ super pathToken
    ==> [ :token | GsPathReferenceAssociation newWithKey: token inputValue asString value: nil ]
%

category: 'grammar'
method: GsQueryParser
queryPathToken
  ^ super queryPathToken
    ==> [ :token | GsQueryPathReferenceAssociation newWithKey: token inputValue asString value: nil ]
%

category: 'grammar-messages'
method: GsQueryParser
rangePredicateExpression
  ^ super rangePredicateExpression
    map: [ :primary1 :relop1 :queryPath1 :relop2 :primary2 |
      GsRangeQueryPredicate
        operand: primary1 asReferenceAssociation
        operator: relop1 inputValue asSymbol
        path: queryPath1 asReferenceAssociation
        operator: relop2 inputValue asSymbol
        operand: primary2 asReferenceAssociation ]
%

category: 'grammar-messages'
method: GsQueryParser
simplePredicateExpression
  ^ super simplePredicateExpression
    map: [ :receiverNode :messageNodes | self build: receiverNode messages: messageNodes ]
%

category: 'grammar-literals'
method: GsQueryParser
stringLiteral
  ^ super stringLiteral
    ==> [ :token |
      GsQueryLiteralValue new
        value: (self buildString: token inputValue);
        yourself ]
%

category: 'grammar-literals'
method: GsQueryParser
symbolLiteral
  ^ super symbolLiteral
    ==> [ :tokens |
      GsQueryLiteralValue new
        value: (self buildString: tokens last inputValue) asSymbol;
        yourself ]
%

category: 'grammar-literals'
method: GsQueryParser
symbolLiteralArray
  ^ super symbolLiteralArray
    ==> [ :tokens |
      GsQueryLiteralValue new
        value: (self buildString: tokens last inputValue) asSymbol;
        yourself ]
%

category: 'grammar-literals'
method: GsQueryParser
trueLiteral
  ^ super trueLiteral
    ==> [ :token |
      GsQueryLiteralValue new
        value: true;
        yourself ]
%

category: 'grammar'
method: GsQueryParser
variable
  ^ super variable
    ==> [ :token | GsVariableReferenceAssociation newWithKey: token inputValue asString value: nil ]
%

! Class extensions for 'GsQueryPathReferenceAssociation'

!		Instance methods for 'GsQueryPathReferenceAssociation'

category: 'converting'
method: GsQueryPathReferenceAssociation
asArrayOf32PathTerms
  ^ self key asArrayOf32PathTerms
%

category: 'converting'
method: GsQueryPathReferenceAssociation
asFormula
  ^ GsPathConstantPredicate new
    path1: self;
    operator: #'unary';
    immediateInvariant
%

category: 'converting'
method: GsQueryPathReferenceAssociation
asFormulaWithSelectorParts: selectorParts arguments: arguments
  ^ arguments first asReferenceAssociation
    constructFormulaWithSelector: selectorParts first inputValue
    againstPathReferenceAssoction: self
%

category: 'private'
method: GsQueryPathReferenceAssociation
constructFormulaWithSelector: selector againstConstantReferenceAssoction: aConstantReferenceAssociation
  ^ GsConstantPathPredicate new
    operand1: aConstantReferenceAssociation;
    operator: selector asSymbol;
    path2: self;
    immediateInvariant
%

category: 'private'
method: GsQueryPathReferenceAssociation
constructFormulaWithSelector: selector againstPathReferenceAssoction: aPathReferenceAssociation
  ^ GsPathPathPredicate new
    path1: aPathReferenceAssociation;
    operator: selector asSymbol;
    path2: self;
    immediateInvariant
%

category: 'testing'
method: GsQueryPathReferenceAssociation
hasEnumeratedTerm
  self asArrayOf32PathTerms
    do: [ :term |
      (term includes: $|)
        ifTrue: [ ^ true ] ].
  ^ false
%

category: 'testing'
method: GsQueryPathReferenceAssociation
hasSamePathAs: aReferenceAssoc
  (aReferenceAssoc isKindOf: self class)
    ifFalse: [ ^ false ].
  ^ self key = aReferenceAssoc key
%

! Class extensions for 'GsQueryPredicate'

!		Class methods for 'GsQueryPredicate'

category: 'instance creation'
classmethod: GsQueryPredicate
constant: operand1
  (operand1 _idxValue == true or: [ operand1 _idxValue == false ])
    ifFalse: [ self error: 'Unary constant must be Boolean' ].
  ^ GsConstantConstantPredicate new
    constant1: operand1;
    operator: #'unary';
    immediateInvariant
%

category: 'instance creation'
classmethod: GsQueryPredicate
constant: operand1 operator: operator constant: operand2
  ^ GsConstantConstantPredicate new
    constant1: operand1;
    operator: operator;
    constant2: operand2;
    immediateInvariant
%

category: 'instance creation'
classmethod: GsQueryPredicate
constant: operand1 operator: operator path: operand2
  ^ (GsConstantPathPredicate
    constant: operand1
    operator: operator
    path: operand2) immediateInvariant
%

category: 'instance creation'
classmethod: GsQueryPredicate
constant: constant1 operator: operator1 path: path operator: operator2 constant: constant2
  "e.g.: 4 < a.b.c < 6"

  ^ (GsRangeQueryPredicate
    constant: constant1
    operator: operator1
    path: path
    operator: operator2
    constant: constant2) immediateInvariant
%

category: 'instance creation'
classmethod: GsQueryPredicate
constant: constant1 operator: operator1 path: path operator: operator2 variable: constant2
  "e.g.: 4 < a.b.c < 6"

  ^ (GsRangeQueryPredicate
    constant: constant1
    operator: operator1
    path: path
    operator: operator2
    variable: constant2) immediateInvariant
%

category: 'instance creation'
classmethod: GsQueryPredicate
constant: operand1 operator: operator variable: operand2
  ^ GsConstantConstantPredicate new
    constant1: operand1;
    operator: operator;
    variable2: operand2;
    immediateInvariant
%

category: 'instance creation'
classmethod: GsQueryPredicate
fromQueryStatement: aString
  ^ (GsQueryParser compileFormula: aString) immediateInvariant
%

category: 'instance creation'
classmethod: GsQueryPredicate
fromSelectBlock: aSelectBlock
  "queryBlockArray is a four element Array of Arrays describing a SelectBlock
 in the manner needed to process a query on the receiver:

   1.  Array of the bound variables from the predicate
   2.  Array of the predicate's terms
   3.  Array of the predicate's paths
   4.  Array of Strings of the path names used in the predicate"

  | queryBlockArray varsArray termsArray linksArray pathsArray formula |
  queryBlockArray := aSelectBlock queryBlock value: nil.
  varsArray := queryBlockArray at: 1.
  termsArray := queryBlockArray at: 2.
  linksArray := queryBlockArray at: 3.
  pathsArray := queryBlockArray at: 4.
  formula := nil.
  1 to: termsArray size by: 7 do: [ :i |
    | predicate |
    predicate := self _createPredicateFromTermsArray: termsArray startingAt: i.
    predicate
      _fromArray: varsArray
      terms: termsArray
      links: linksArray
      paths: pathsArray
      startingAt: i.
    formula == nil
      ifTrue: [ formula := predicate ]
      ifFalse: [ formula := formula & predicate ] ].
  ^ formula
%

category: 'instance creation'
classmethod: GsQueryPredicate
fromSelectBlock: aSelectBlock usingQueryExecuterWith: anNsc
  "Extract predicates from QueryExecuter using <aSelectBlock>
        and <anNsc>. Return an GsQuery. Note that the predicates are
        based on standard transforms applied by the QueryExecuter."

  | queryExecuter gueryBlockArray queryFormula |
  queryExecuter := QueryExecuter on: anNsc.
  gueryBlockArray := aSelectBlock queryBlock value: nil.
  queryExecuter
    _buildIndexOperationsList: gueryBlockArray;
    optimize.
  queryFormula := nil.
  queryExecuter _getOperationsOrder
    do: [ :offset |
      | predicate |
      predicate := self
        _createPredicateFromQueryExecuter: queryExecuter
        startingAt: offset.
      queryFormula == nil
        ifTrue: [ queryFormula := predicate ]
        ifFalse: [ queryFormula := queryFormula & predicate ] ].
  queryFormula
    ifNil: [
      "unsatisfiable query"
      queryFormula := (self constant: false)
        bindEvaluatorsFor: anNsc
        collator: nil ].
  ^ queryFormula
%

category: 'instance creation'
classmethod: GsQueryPredicate
operand: operand1 operator: operator operand: operand2
  ^ self new
    operand1: operand1;
    operator: operator;
    operand2: operand2;
    immediateInvariant
%

category: 'instance creation'
classmethod: GsQueryPredicate
operand: operand1 operator: operator1 path: path operator: operator2 operand: operand2
  "e.g.: 4 < a.b.c < 6 or 6 > a.b.c >= 4 "

  ^ (GsRangeQueryPredicate
    operand: operand1
    operator: operator1
    path: path
    operator: operator2
    operand: operand2) immediateInvariant
%

category: 'instance creation'
classmethod: GsQueryPredicate
path: operand1
  ^ GsPathConstantPredicate new
    path1: operand1;
    operator: #'unary';
    immediateInvariant
%

category: 'instance creation'
classmethod: GsQueryPredicate
path: operand1 operator: operator constant: operand2
  ^ GsPathConstantPredicate new
    path1: operand1;
    operator: operator;
    constant2: operand2;
    immediateInvariant
%

category: 'instance creation'
classmethod: GsQueryPredicate
path: operand1 operator: operator path: operand2
  ^ GsPathPathPredicate new
    path1: operand1;
    operator: operator;
    path2: operand2;
    immediateInvariant
%

category: 'instance creation'
classmethod: GsQueryPredicate
path: operand1 operator: operator variable: operand2
  ^ GsPathConstantPredicate new
    path1: operand1;
    operator: operator;
    variable2: operand2;
    immediateInvariant
%

category: 'instance creation'
classmethod: GsQueryPredicate
variable: operand1
  (operand1 _idxValue == true or: [ operand1 _idxValue == false ])
    ifFalse: [ self error: 'Unary constant must be Boolean' ].
  ^ GsConstantConstantPredicate new
    variable1: operand1;
    operator: #'unary';
    immediateInvariant
%

category: 'instance creation'
classmethod: GsQueryPredicate
variable: operand1 operator: operator constant: operand2
  ^ GsConstantConstantPredicate new
    variable1: operand1;
    operator: operator;
    constant2: operand2;
    immediateInvariant
%

category: 'instance creation'
classmethod: GsQueryPredicate
variable: operand1 operator: operator path: operand2
  ^ GsConstantPathPredicate new
    variable1: operand1;
    operator: operator;
    path2: operand2;
    immediateInvariant
%

category: 'instance creation'
classmethod: GsQueryPredicate
variable: constant1 operator: operator1 path: path operator: operator2 constant: constant2
  "e.g.: 4 < a.b.c < 6"

  ^ (GsRangeQueryPredicate
    variable: constant1
    operator: operator1
    path: path
    operator: operator2
    constant: constant2) immediateInvariant
%

category: 'instance creation'
classmethod: GsQueryPredicate
variable: constant1 operator: operator1 path: path operator: operator2 variable: constant2
  "e.g.: 4 < a.b.c < 6"

  ^ (GsRangeQueryPredicate
    variable: constant1
    operator: operator1
    path: path
    operator: operator2
    variable: constant2) immediateInvariant
%

category: 'instance creation'
classmethod: GsQueryPredicate
variable: operand1 operator: operator variable: operand2
  ^ GsConstantConstantPredicate new
    variable1: operand1;
    operator: operator;
    variable2: operand2;
    immediateInvariant
%

category: 'instance creation'
classmethod: GsQueryPredicate
_createPredicateFromQueryExecuter: aQueryExecuter startingAt: offset
  | firstOperand secondOperand searchOp predicateType predicate operator |
  firstOperand := aQueryExecuter firstOperandAt: offset.
  searchOp := aQueryExecuter operatorAt: offset.
  secondOperand := aQueryExecuter secondOperandAt: offset.
  predicateType := aQueryExecuter at: offset.
  searchOp == 8
    ifTrue: [
      predicate := (GsQueryPredicate constant: secondOperand) copy.
      predicate _nsc: aQueryExecuter nsc collator: nil.
      ^ predicate ].
  searchOp == 9
    ifTrue: [
      | searchOp1 searchOp2 |
      predicateType ~~ 2
        ifTrue: [ self error: 'invalid predicateType for searchOp ''9''' ].
      searchOp1 := secondOperand at: 1.
      searchOp2 := secondOperand at: 3.
      predicate := (GsQueryPredicate
        constant: (secondOperand at: 2)
        operator:
          (self inverseOperatorFor: (aQueryExecuter operationSelectors at: searchOp1 + 1))
        path: 'each.' , firstOperand pathComponentsString
        operator: (aQueryExecuter operationSelectors at: searchOp2 + 1)
        constant: (secondOperand at: 4)) copy.
      predicate
        _nsc: aQueryExecuter nsc collator: nil;
        evaluator: firstOperand.
      ^ predicate ].
  operator := aQueryExecuter operationSelectors at: searchOp + 1.
  predicateType == 2
    ifTrue: [
      predicate := (GsQueryPredicate
        path: 'each.' , firstOperand pathComponentsString
        operator: operator
        constant: secondOperand) copy.
      predicate
        _nsc: aQueryExecuter nsc collator: nil;
        evaluator1: firstOperand.
      ^ predicate ].
  predicateType == 1
    ifTrue: [
      predicate := (GsQueryPredicate
        constant: firstOperand
        operator: operator
        constant: secondOperand) copy.
      predicate _nsc: aQueryExecuter nsc collator: nil.
      ^ predicate ].
  predicateType == 4
    ifTrue: [
      predicate := (GsQueryPredicate
        path: 'each.' , firstOperand pathComponentsString
        operator: operator
        path: 'each.' , secondOperand pathComponentsString) copy.
      predicate
        _nsc: aQueryExecuter nsc collator: nil;
        evaluator1: firstOperand;
        evaluator2: secondOperand.
      ^ predicate ].
  self error: 'Unknown predicate type: ' , predicateType printString
%

category: 'instance creation'
classmethod: GsQueryPredicate
_createPredicateFromTermsArray: termsArray startingAt: offset
  "Return the proper Query Predicate instance.
   Predicates are classified into four types:

 1.  constant-constant (such as 3 > 2)
 2.  path-constant     (such as 'spouse.age' > 30)
 3.  constant-path     (such as 30 <= 'spouse.age')
 4.  path-path         (such as 'spouse.age' < 'spouse.weight')"

  (termsArray at: offset + 4)
    ifTrue: [
      (termsArray at: offset + 1)
        ifTrue: [
          " its path-path "
          ^ GsPathPathPredicate new ]
        ifFalse: [
          " its path-constant "
          ^ GsPathConstantPredicate new ] ]
    ifFalse: [
      (termsArray at: offset + 1)
        ifTrue: [
          " its constant-path "
          ^ GsConstantPathPredicate new ]
        ifFalse: [
          " its constant-constant "
          ^ GsConstantConstantPredicate new ] ]
%

!		Instance methods for 'GsQueryPredicate'

category: 'optimizing'
method: GsQueryPredicate
applyDeMorgansNegationTransform
  "actively apply De Morgan's laws ... operating on copy"

  self operator: self operatorNegated
%

category: 'converting'
method: GsQueryPredicate
asFormulaWithSelectorParts: selectorParts arguments: arguments
  | selector |
  selector := selectorParts first inputValue asSymbol.
  ^ (self operationSelectors includes: selector)
    ifTrue: [
      | clause2 |
      clause2 := self operand2
        asFormulaWithSelectorParts: selectorParts
        arguments: arguments.
      self collapseToRangePredicateIfPossible: clause2 ]
    ifFalse: [ self perform: selector with: arguments first ]
%

category: 'transforming'
method: GsQueryPredicate
bind: variableName to: value
  | bound |
  bound := self copy.
  bound operand1: (bound operand1 bind: variableName to: value).
  bound operand2: (bound operand2 bind: variableName to: value).
  ^ bound immediateInvariant
%

category: 'accessing'
method: GsQueryPredicate
compatibleInverseRangeOperatorsFor: anOperator
  | less greater |
  less := #(#'<' #'<=').
  greater := #(#'>' #'>=').
  ^ ((less includes: anOperator) and: [ greater includes: self operator ])
    or: [ (greater includes: anOperator) and: [ less includes: self operator ] ]
%

category: 'accessing'
method: GsQueryPredicate
compatibleRangeOperatorsFor: anOperator
  | less greater |
  less := #(#'<' #'<=').
  greater := #(#'>' #'>=').
  ^ ((less includes: anOperator) and: [ less includes: self operator ])
    or: [ (greater includes: anOperator) and: [ greater includes: self operator ] ]
%

category: 'accessing'
method: GsQueryPredicate
constant
  self subclassResponsibility: #'constant'
%

category: 'accessing'
method: GsQueryPredicate
constant1: anObject
  operand1 := GsConstantReferenceAssociation
    newWithKey: anObject asString
    value: anObject
%

category: 'accessing'
method: GsQueryPredicate
constant2: anObject
  operand2 := GsConstantReferenceAssociation
    newWithKey: anObject asString
    value: anObject
%

category: 'querying'
method: GsQueryPredicate
elementValueEvaluator
  "companion method to #elementValue:"

  "anObject is the value obtained by traversing path terms to the last value ... analgous to the last element class"

  "not all subclasses are required to implement this selector, if they do not implement this selector, then they must implement #elementValue:"

  ^ (evaluator1 == nil  or: [ evaluator1 isPathEvaluator not ])
    ifTrue: [ self pathEvaluatorFor: self path ]
    ifFalse: [ evaluator1 ]
%

category: 'accessing'
method: GsQueryPredicate
evaluator
  ^ self evaluator1
%

category: 'accessing'
method: GsQueryPredicate
evaluator1
  ^ evaluator1
%

category: 'accessing'
method: GsQueryPredicate
evaluator1: anEvaluator
  evaluator1 := anEvaluator
%

category: 'private'
method: GsQueryPredicate
immediateInvariant
  super immediateInvariant.
  operand1 immediateInvariant.
  operand2 immediateInvariant
%

category: 'testing'
method: GsQueryPredicate
isConstantBound
  self subclassResponsibility: #'isConstantBound'
%

category: 'accessing'
method: GsQueryPredicate
operand1
  ^ operand1
%

category: 'accessing'
method: GsQueryPredicate
operand1: anObject
  operand1 := anObject
%

category: 'testing'
method: GsQueryPredicate
operand1IsPath
  ^ false
%

category: 'accessing'
method: GsQueryPredicate
operand2
  ^ operand2
%

category: 'accessing'
method: GsQueryPredicate
operand2: anObject
  operand2 := anObject
%

category: 'testing'
method: GsQueryPredicate
operand2IsPath
  ^ false
%

category: 'accessing'
method: GsQueryPredicate
operator
  ^ operator
%

category: 'accessing'
method: GsQueryPredicate
operator: queryOp
  (self _isValidQueryOperator: queryOp)
    ifFalse: [ ^ self error: 'Invalid query operator: ' , queryOp printString ].
  operator := queryOp
%

category: 'accessing'
method: GsQueryPredicate
operatorNegated
  ^ self negatedOperatorFor: self operator
%

category: 'accessing'
method: GsQueryPredicate
path
  ^ self rawPath key
%

category: 'accessing'
method: GsQueryPredicate
path1: aPathString
  operand1 := self pathReferenceFor: aPathString
%

category: 'accessing'
method: GsQueryPredicate
path2: aPathString
  operand2 := self pathReferenceFor: aPathString
%

category: 'private'
method: GsQueryPredicate
postCopy
  operand1 := operand1 copy.
  operand2 := operand2 copy.
  super postCopy
%

category: 'printing'
method: GsQueryPredicate
printOn: aStream
  aStream
    nextPutAll:
      '(' , self operand1 printString , ' ' , self operator asString , ' '
        , self operand2 printString , ')'
%

category: 'accessing'
method: GsQueryPredicate
rawPath
  self subclassResponsibility: #'rawPath'
%

category: 'querying'
method: GsQueryPredicate
readStream
  | queryEvaluator theOperator theConstant |
  queryEvaluator := self evaluator1 asQueryEvaluator.
  theOperator := self operator.
  theConstant := self constant.
  self _check: self evaluator1 compare: theOperator value: theConstant.
  (theOperator == #'<' or: [ theOperator == #'<=' ])
    ifTrue: [
      | stream querySpec |
      stream := queryEvaluator
        _findAllValuesGreaterThan: nil
        andEquals: true
        andLessThan: theConstant
        andEquals: theOperator == #'<='
        using: (BtreeComparisonForCompare newForComparison: self collator).
      querySpec := queryEvaluator btreeComparisonQuerySpec
        key: theConstant selector: theOperator;
        yourself.
      stream streamQuerySpec: querySpec.
      ^ stream ].
  (theOperator == #'>' or: [ theOperator == #'>=' ])
    ifTrue: [
      ^ queryEvaluator
        _findAllValuesGreaterThanKey: theConstant
        andEquals: theOperator == #'>='
        using: (BtreeComparisonForCompare newForComparison: self collator) ].
  theOperator == #'='
    ifTrue: [
      ^ queryEvaluator
        _findAllValuesEqualTo: theConstant
        using: (BtreeComparisonForCompare newForComparison: self collator) ].
  theOperator == #'=='
    ifTrue: [
      | querySpec stream |
      stream := queryEvaluator _findAllValuesIdenticalTo: theConstant.
      querySpec := queryEvaluator btreeComparisonQuerySpec
        key: theConstant selector: theOperator;
        yourself.
      stream streamQuerySpec: querySpec.
      ^  stream ]
%

category: 'transforming'
method: GsQueryPredicate
unbind
  "remove all bindings"

  | unbound |
  unbound := super unbind.
  unbound operand1: unbound operand1 unbind.
  self operator == #'unary'
    ifFalse: [ unbound operand2: unbound operand2 unbind ].
  unbound unbindEvaluators.
  ^ unbound immediateInvariant
%

category: 'private'
method: GsQueryPredicate
unbindEvaluators
  "remove all bindings"

  evaluator1 := nil
%

category: 'testing'
method: GsQueryPredicate
usesComparisonOperation
  ^ #(#'<=' #'<' #'>' #'>=') includes: operator
%

category: 'testing'
method: GsQueryPredicate
usesEqualityOperation
  ^ operator == #'=' or: [ operator == #'~=' ]
%

category: 'testing'
method: GsQueryPredicate
usesEqualOperation
  ^ operator == #'='
%

category: 'testing'
method: GsQueryPredicate
usesIdenticalToOperation
  ^ operator == #'=='
%

category: 'testing'
method: GsQueryPredicate
usesIdentityOperation
  ^ operator == #'==' or: [ operator == #'~~' ]
%

category: 'testing'
method: GsQueryPredicate
usesPathEvaluator
  self evaluator1 ifNil: [ ^ true ].
  ^ self evaluator1 isPathEvaluator
%

category: 'accessing'
method: GsQueryPredicate
variable1: aVariableName
  operand1 := self variableReferenceFor: aVariableName
%

category: 'accessing'
method: GsQueryPredicate
variable2: aVariableName
  operand2 := self variableReferenceFor: aVariableName
%

category: 'private'
method: GsQueryPredicate
_check: indexObj compare: compareOp value: searchVal
  "Raise an error if the comparison operation is not valid for the index object
 and the search value."

  " check for range operation using an identity index "

  ((self isRangeEqualityOperation: compareOp)
    and: [ indexObj isRangeEqualityIndex not ])
    ifTrue: [ ^ indexObj _errorCannotInvokeRangeOperationOnIdentityIndex ]
%

category: 'private'
method: GsQueryPredicate
_evaluators
  "return list of evaluators associated with predicate"

  ^ {(self evaluator1)}
%

category: 'private'
method: GsQueryPredicate
_fromArray: varsArray terms: termsArray links: linksArray paths: pathsArray startingAt: i
  self subclassResponsibility: #'_fromArray:terms:links:paths:startingAt:'
%

category: 'testing'
method: GsQueryPredicate
_isValidQueryOperator: queryOp
  "Returns true if the given search operation is one of == ~~ < > = <= >= or ~=."

  ^ self operationSelectors includes: queryOp
%

category: 'private'
method: GsQueryPredicate
_pathFrom: linksArray paths: pathsArray offset: offset
  | nextLink path i linkSize term |
  path := 'each'.
  offset == 0
    ifTrue: [ ^ path ].
  i := offset * 2 - 1.
  linkSize := linksArray size.
  [ i < linkSize ]
    whileTrue: [
      nextLink == 0
        ifTrue: [ ^ path ].
      nextLink := linksArray at: i.
      term := (pathsArray at: (linksArray at: i + 1)) asString.
      path := path , '.' , term.
      i := nextLink * 2 - 1 ].
  ^ path
%

! Class extensions for 'GsQueryTokenParser'

!		Class methods for 'GsQueryTokenParser'

category: 'initialization'
classmethod: GsQueryTokenParser
_initialize
        SeparatorPredicate := PPCharSetPredicate on: [ :char | char isSeparator ]
%

!		Instance methods for 'GsQueryTokenParser'

category: 'parsing'
method: GsQueryTokenParser
parseOn: aStream
  | start token |
  [ aStream atEnd not and: [ SeparatorPredicate value: aStream uncheckedPeek ] ]
    whileTrue: [ aStream next ].
  start := aStream position.
  token := super parseOn: aStream.
  token isPetitFailure
    ifTrue: [
      aStream position: start.
      ^ token ].
  ^ token
%

! Class extensions for 'GsRangeEqualityIndex'

!		Class methods for 'GsRangeEqualityIndex'

category: 'Constants'
classmethod: GsRangeEqualityIndex
isBasicClass: aClass
  "Returns whether the given class should use BtreePlusBasic*Nodes to store
 B-tree mappings."

  | characterCollectionBasicClasses |
  aClass == nil
    ifTrue: [ ^ false ].
  aClass _isSpecial
    ifTrue: [ "specials do not benefit from basic btree nodes"
      ^ false ].
  self _validateLastElementClass: aClass.
  Unicode16 usingUnicodeCompares
    ifTrue: [ characterCollectionBasicClasses := #().
      (aClass _subclassOf: CharacterCollection)
        ifTrue: [ aClass == CharacterCollection
            ifTrue: [ ^ true ].
          (aClass _subclassOf: String)
            ifTrue: [ ^ true ].
          (aClass _subclassOf: MultiByteString)
            ifTrue: [ ^ true ] ] ]
    ifFalse: [ characterCollectionBasicClasses := {String.
      DoubleByteString.
      QuadByteString.
      Unicode7.
      Unicode16.
      Unicode32} ].
  characterCollectionBasicClasses
    , {Number.	"all non-special subclasses of Number"
      DateTime.
      DateAndTime.
      Date.
      Time} do: [ :basicClass | (aClass _subclassOf: basicClass)
        ifTrue: [ ^ true ] ].
  ^ false
%

category: 'Instance Creation'
classmethod: GsRangeEqualityIndex
newWithLastElementClass: aClass
  "Create a new instance and initialize its B-tree root."

  | newOne |
  newOne := super new.
  newOne lastElementClass: aClass.
  ^ newOne
%

category: 'Constants'
classmethod: GsRangeEqualityIndex
_isUnicodeLastElementClass: aClass
  "returns true if <aClass> is a Unicode class"

  self _validateLastElementClass: aClass.
  Unicode16 usingUnicodeCompares
    ifTrue: [
      (self isBasicClass: aClass)
        ifTrue: [
          (aClass _subclassOf: CharacterCollection)
            ifTrue: [ ^ true ] ] ]
    ifFalse: [
      (aClass _subclassOf: Unicode7)
        ifTrue: [ ^ true ].
      (aClass _subclassOf: Unicode16)
        ifTrue: [ ^ true ].
      (aClass _subclassOf: Unicode32)
        ifTrue: [ ^ true ] ].
  ^ false
%

category: 'Private'
classmethod: GsRangeEqualityIndex
_validateLastElementClass: aClass
  aClass isBehavior
    ifFalse: [
      ArgumentTypeError
        signal: 'LastElementClass (' , aClass printString , ') must be a class' ]
%

!		Instance methods for 'GsRangeEqualityIndex'

category: 'Converting'
method: GsRangeEqualityIndex
asIndexSpecification
  (self class _isUnicodeLastElementClass: self lastElementClass)
    ifTrue: [ ^ self asUnicodeIndexSpecification ].
  ^ (EqualityIndexSpecification
    path: self pathComponentsString
    lastElementClass: self lastElementClass)
    options: self options;
    yourself
%

category: 'Converting'
method: GsRangeEqualityIndex
asQueryEvaluator

  ^GsEqualityIndexQueryEvaluator on: self
%

category: 'Converting'
method: GsRangeEqualityIndex
asUnicodeIndexSpecification
  ^ (UnicodeIndexSpecification
    path: self pathComponentsString
    collator: self collator)
    options: self options;
    yourself
%

category: 'Stream Accessing'
method: GsRangeEqualityIndex
btreeRangeComparisonQuerySpec
  ^ BtreePlusRangeComparisonQuerySpec new
    rangeIndex: self;
    yourself
%

category: 'Comparison Operators'
method: GsRangeEqualityIndex
comparisonForCompare
  ^ self optimizingComparison
    ifTrue: [ BtreeOptimizedComparison new ]
    ifFalse: [ BtreeComparisonForCompare newForComparison ]
%

category: 'Comparison Operators'
method: GsRangeEqualityIndex
comparisonForSort
  "called during creation of receiver, so initialize unset instance variables"

  ^ comparisonForSort ifNil: [
      comparisonForSort := self optimizingComparison
        ifTrue: [ BtreeOptimizedComparison new ]
        ifFalse: [ BtreeComparisonForCompare newForSort ] ]
%

category: 'Searching'
method: GsRangeEqualityIndex
findRootObjectMaps: rootObjectMap pathTerm: pathTerm key: aKey value: aValue
  | evaluator stream |
  evaluator := self asQueryEvaluator.
  stream := evaluator
    _findAllValuesGreaterThan: aKey
    andEquals: true
    andLessThan: aKey
    andEquals: true
    using: evaluator comparisonForSort.
  stream
    _scanForRootObjectMaps: aKey
    value: aValue
    valueOop: aValue asOop
    using: self comparisonForCompare
    do: [:aRoot |
      self
        findRootObjects: rootObjectMap
        rootObject: aRoot
        pathTerm: pathTerm
        key: aKey
        value: aValue ].
%

category: 'Searching'
method: GsRangeEqualityIndex
findRootObjectsForKey: aKey value: aValue
  | evaluator stream rootObjects |
  evaluator := self asQueryEvaluator.
  stream := evaluator
    _findAllValuesGreaterThan: aKey
    andEquals: true
    andLessThan: aKey
    andEquals: true
    using: evaluator comparisonForSort.
  rootObjects := IdentityBag new.
  [ stream _btreeAtEnd ]
    whileFalse: [
      | rootObject |
      "collect key/value/root tuples for entries in the btree whose intermediate parent object
       is reachable from the root object in the entry."
      ((stream _peekValue == aValue) and: [ stream _peekKey == aKey ])
        ifTrue: [ "select value entries that are identically equal to aValue"
          rootObject := stream _peekRoot.
          rootObjects add: rootObject ].
      stream _btreeNext ].
 ^ rootObjects
%

category: 'Accessing'
method: GsRangeEqualityIndex
indexType
  ^ #'equality'
%

category: 'Testing'
method: GsRangeEqualityIndex
isRangeEqualityIndex

"Returns true."

^ true
%

category: 'Accessing'
method: GsRangeEqualityIndex
lastElementClass

"Returns the value of the instance variable 'lastElementClass'."

^lastElementClass
%

category: 'Updating'
method: GsRangeEqualityIndex
lastElementClass: aClass
  self _validateLastElementClass: aClass.
  lastElementClass := aClass
%

category: 'Accessing'
method: GsRangeEqualityIndex
lastElementClassDescription
  "answer a description of the lastElementClass of the receiver,
   suitable for use in an error message"

  | cl qualifier |
  qualifier := ''.
  self optimizingComparison ifTrue: [ qualifier := ' [ with optimized comparison ]'. ].
  cl := self lastElementClass.
  (cl isSubclassOf: CharacterCollection)
    ifTrue: [
      Unicode16 usingUnicodeCompares
        ifTrue: [ ^ 'CharacterCollection', qualifier ]
        ifFalse: [ ^ 'CharacterCollection excluding Unicode String classes', qualifier ] ].
  ^ cl name asString, qualifier
%

category: 'Updating'
method: GsRangeEqualityIndex
nscRoot: newValue
  super nscRoot: newValue.
  "force lazy initialization of optimizingComparison iv to avoid commit conflicts later..."
  self optimizingComparison
%

category: 'Updating'
method: GsRangeEqualityIndex
objectSecurityPolicy: anObjectSecurityPolicy
  "Assign the receiver and its B-tree to the given security policy."

  super objectSecurityPolicy: anObjectSecurityPolicy.
  self btreeRoot objectSecurityPolicy: anObjectSecurityPolicy
%

category: 'Testing'
method: GsRangeEqualityIndex
optimizingComparison
  "if option is set, the ensure that the lastElementClass support optimized comparisons"

  ^optimizingComparison ifNil: [
    optimizingComparison := super optimizingComparison
      ifTrue: [ self lastElementClass _idxCanOptimizeComparison ]
      ifFalse: [ false ] ].
%

category: 'Accessing'
method: GsRangeEqualityIndex
sortNodeClass
  "Returns the class of SortNode to use."

  ^ self lastElementClass sortNodeClass
%

category: 'Testing'
method: GsRangeEqualityIndex
_canCompareWith: aKey
  "Returns whether the receiver can make B-tree comparisons with the given key."

  ^ btreeRoot _canCompare: aKey withClass: lastElementClass
%

category: 'Testing'
method: GsRangeEqualityIndex
_checkSameLastElementClassAsEqualityIndex: equalityIndexObj
  ^ equalityIndexObj lastElementClass == self lastElementClass
%

category: 'Updating'
method: GsRangeEqualityIndex
_clear
  "Assigns nil to important instance variables."

  lastElementClass := nil.
  super _clear
%

category: 'Sorting'
method: GsRangeEqualityIndex
_getSecondarySorterOn: indexObjs directions: theBooleans

"Returns a PathSorter if one is needed to perform secondary sorting;
 otherwise returns nil."

| directions traversers aSize |

(aSize := indexObjs size) > 1 ifTrue: [
    directions := theBooleans copyFrom: 2 to: aSize .
    traversers := indexObjs copyFrom: 2 to: aSize .
    ^ PathSorter on: traversers directions: directions.
].
^ nil  .
%

category: 'Updating'
method: GsRangeEqualityIndex
_setLastPathTermState
  "Indicate if the last object along the path needs a dependency list."

  | lastPathTerm |
  lastPathTerm := self at: self size.
  lastElementClass allSubclasses , {lastElementClass}
    do: [ :cl | cl instancesInvariant not
        ifTrue: [ "bug 42640 - depList needed unless instances invariant"
          lastPathTerm needsDepList: true.
          ^ self ] ]
%

category: 'Updating'
method: GsRangeEqualityIndex
_setPathTermState
  "For the last path term, indicate the need to update the B-tree.
   Indicate if the last object along the path needs a dependency list."

  super _setPathTermState.
  self _setLastPathTermState
%

category: 'Sorting'
method: GsRangeEqualityIndex
_sortAscendingOn: indexObjs directions: theBooleans

""

| array cnt marker sorter prevKey pArr |

" create the Array to hold the objects "
array := Array new: nscRoot size.

" build a sorter to be used for secondary sorts "
sorter := self _getSecondarySorterOn: indexObjs directions: theBooleans.

" start the insertion into the Array at the beginning "
self isIndexOnRootNsc
    ifTrue: [ cnt := 0 ]
    ifFalse: [ cnt := nscRoot _idxOccurrencesOf: nil ].

" gather objects with nil along the path "
pArr := self _getObjectsWithNilOnPath.
1 to: pArr size do: [ :i |
    cnt := cnt + 1.
    array at: cnt put: (pArr at: i)
].
pArr := nil .

" if no secondary sorts "
sorter == nil ifTrue: [
    btreeRoot _putAscendingRootObjectsInto: array startingAt: cnt + 1.
    ^ array
  ].

prevKey := #_incompletePathTraversal.
marker := cnt max: 1.

" Iterate over the key/value/roots in the B-tree leaf nodes "
btreeRoot _leafKeysValuesAndRootsDo: [ :key :value :root |

   cnt := cnt + 1.
   array at: cnt put: root.

    " see if finished a run of duplicate keys "
    key ~= prevKey
      ifTrue: [
        marker < (cnt - 1)
          ifTrue: [ " sort on secondary keys "
            marker to: cnt - 1 do: [ :i | sorter addObject: (array at: i) ].
            sorter sortInto: array startingAt: marker.
            sorter clear
          ].
        marker := cnt
      ].
    prevKey := key.
].
" see if ending with duplicate keys "
( sorter ~~ nil and: [ marker < cnt ] )
    ifTrue: [ " sort on secondary keys "
       marker to: cnt do: [ :i | sorter addObject: (array at: i) ].
       sorter sortInto: array startingAt: marker.
       sorter clear
    ].

^ array
%

category: 'Sorting'
method: GsRangeEqualityIndex
_sortDescendingOn: indexObjs directions: theBooleans

""

| array cnt prevKey marker sorter pArr |

" create the Array to hold the objects "
array := Array new: nscRoot size.

" build a sorter to be used for secondary sorts "
sorter := self _getSecondarySorterOn: indexObjs directions: theBooleans.

" start the insertion into the Array at the beginning "
self isIndexOnRootNsc
    ifTrue: [ cnt := array size  ]
    ifFalse: [ cnt := array size - (nscRoot _idxOccurrencesOf: nil) ].

" gather objects with nil along the path "
pArr := self _getObjectsWithNilOnPath.
1 to: pArr size do: [ :i |
    array at: cnt put: (pArr at: i).
    cnt := cnt - 1.
].
pArr := nil .

" if no secondary sorts "
sorter == nil ifTrue: [
    btreeRoot _putDescendingRootObjectsInto: array startingAt: cnt.
    ^ array
  ].

prevKey := #_incompletePathTraversal.
marker := cnt.

" iterate over the key/values in the B-tree leaf nodes "
btreeRoot _leafKeysValuesAndRootsDo: [ :key :value :root |

      array at: cnt put: root.
      cnt := cnt - 1.

    " see if finished a run of duplicate keys "
    key ~= prevKey
      ifTrue: [
        marker > (cnt + 1)
          ifTrue: [ " sort on secondary keys "
            cnt + 2 to: marker do: [ :i | sorter addObject: (array at: i) ].
            sorter sortInto: array startingAt: cnt + 2.
            sorter clear
          ].
        marker := cnt + 1
      ].
    prevKey := key.
].

" see if ending with duplicate keys "
( sorter ~~ nil and: [ marker > 1 ] )
  ifTrue: [ " sort on secondary keys "
   1 to: marker do: [ :i | sorter addObject: (array at: i) ].
   sorter sortInto: array startingAt: 1.
     sorter clear
    ].
^ array
%

category: 'Sorting'
method: GsRangeEqualityIndex
_sortOn: indexObjs directions: theBooleans persistentRoot: persistentArrayOrNil

"Returns an Array of objects from the root NSC that is sorted according to the
 paths traversed by indexObjs (with the direction of the sort specified in
 theBooleans)."

(theBooleans at: 1)
    ifTrue: [ ^ self _sortAscendingOn: indexObjs directions: theBooleans ]
    ifFalse: [ ^ self _sortDescendingOn: indexObjs directions: theBooleans ]
%

category: 'Testing'
method: GsRangeEqualityIndex
_validateCanCompareWith: aKey
  (self _canCompareWith: aKey)
    ifFalse: [ ^ (ImproperOperation new
        _number:
            (ErrorSymbols at: #'rtErrRangeEqualityIndexInvalidClassKindForBtree');
        args: { aKey class. self lastPathTerm name. self lastElementClassDescription }) signal ]
%

category: 'Private'
method: GsRangeEqualityIndex
_validateLastElementClass: aClass
  self class _validateLastElementClass: aClass
%

! Class extensions for 'GsRangeQueryPredicate'

!		Class methods for 'GsRangeQueryPredicate'

category: 'instance creation'
classmethod: GsRangeQueryPredicate
constant: constant1 operator: operator1 path: path operator: operator2 constant: constant2
  "e.g.: 4 < a.b.c < 6 or 6 > a.b.c >= 4 "

  ^ (self new
    constant1: constant1;
    operator1: operator1;
    path: path;
    operator2: operator2;
    constant2: constant2;
    yourself) validate
%

category: 'instance creation'
classmethod: GsRangeQueryPredicate
constant: constant1 operator: operator1 path: path operator: operator2 variable: variable2
  "e.g.: 4 < a.b.c < 6 or 6 > a.b.c >= 4 "

  ^ (self new
    constant1: constant1;
    operator1: operator1;
    path: path;
    operator2: operator2;
    variable2: variable2;
    yourself) validate
%

category: 'instance creation'
classmethod: GsRangeQueryPredicate
operand: operand1 operator: operator1 path: path operator: operator2 operand: operand2
  "e.g.: 4 < a.b.c < 6 or 6 > a.b.c >= 4 "

  ^ (self new
    operand1: operand1;
    operator1: operator1;
    path: path;
    operator2: operator2;
    operand2: operand2;
    yourself) validate
%

category: 'instance creation'
classmethod: GsRangeQueryPredicate
variable: variable1 operator: operator1 path: path operator: operator2 constant: constant2
  "e.g.: 4 < a.b.c < 6 or 6 > a.b.c >= 4 "

  ^ (self new
    variable1: variable1;
    operator1: operator1;
    path: path;
    operator2: operator2;
    constant2: constant2;
    yourself) validate
%

category: 'instance creation'
classmethod: GsRangeQueryPredicate
variable: variable1 operator: operator1 path: path operator: operator2 variable: variable2
  "e.g.: 4 < a.b.c < 6 or 6 > a.b.c >= 4 "

  ^ (self new
    variable1: variable1;
    operator1: operator1;
    path: path;
    operator2: operator2;
    variable2: variable2;
    yourself) validate
%

!		Instance methods for 'GsRangeQueryPredicate'

category: 'visiting'
method: GsRangeQueryPredicate
acceptVisitor: aFormulaVisitor
  super acceptVisitor: aFormulaVisitor.
  aFormulaVisitor acceptRangePredicate: self
%

category: 'optimizing'
method: GsRangeQueryPredicate
applyDeMorgansNegationTransform
  "actively apply De Morgan's laws ... convert to | of two negated predicates"

  | theConstant1 theConstant2 theOperator1 theOperator2 predicate1 predicate2 |
  self isNormal
    ifTrue: [
      theConstant1 := self constant1.
      theOperator1 := self operator1.
      theConstant2 := self constant2.
      theOperator2 := self operator2 ]
    ifFalse: [
      theConstant1 := self constant2.
      theOperator1 := self inverseOperatorFor: self operator2.
      theConstant2 := self constant1.
      theOperator2 := self inverseOperatorFor: self operator1 ].
  predicate1 := GsQueryPredicate
    constant: theConstant1
    operator: (self negatedOperatorFor: theOperator1)
    path: self path.
  predicate2 := GsQueryPredicate
    path: self path
    operator: (self negatedOperatorFor: theOperator2)
    constant: theConstant2.
  ^ predicate1 | predicate2
%

category: 'converting'
method: GsRangeQueryPredicate
asFormulaWithSelectorParts: selectorParts arguments: arguments
  | selector |
  selector := selectorParts first inputValue asSymbol.
  ^ self perform: selector with: arguments first
%

category: 'transforming'
method: GsRangeQueryPredicate
bind: variableName to: value
  | bound |
  bound := self copy.
  bound operand1: (bound operand1 bind: variableName to: value).
  bound operand2: (bound operand2 bind: variableName to: value).
  ^ bound immediateInvariant
%

category: 'private'
method: GsRangeQueryPredicate
bindEvaluators
  evaluator := self
    _bindEvaluator: nsc
    for: self path
    isRangeEqualityOperation: true.
  super bindEvaluators
%

category: 'accessing'
method: GsRangeQueryPredicate
constant1
  ^ operand1 _idxValue
%

category: 'accessing'
method: GsRangeQueryPredicate
constant1: anObject
  operand1 := GsConstantReferenceAssociation
    newWithKey: anObject asString
    value: anObject
%

category: 'accessing'
method: GsRangeQueryPredicate
constant2
  ^ operand2 _idxValue
%

category: 'accessing'
method: GsRangeQueryPredicate
constant2: anObject
  operand2 := GsConstantReferenceAssociation
    newWithKey: anObject asString
    value: anObject
%

category: 'querying'
method: GsRangeQueryPredicate
elementValueEvaluator
  "companion method to #elementValue:"

  "anObject is the value obtained by traversing path terms to the last value ... analgous to the last element class"

  "not all subclasses are required to implement this selector, if they do not implement this selector, then they must implement #elementValue:"

  ^ (evaluator == nil  or: [ evaluator isPathEvaluator not ])
    ifTrue: [ self pathEvaluatorFor: self path ]
    ifFalse: [ evaluator ]
%

category: 'accessing'
method: GsRangeQueryPredicate
evaluator
  ^ evaluator
%

category: 'accessing'
method: GsRangeQueryPredicate
evaluator: anEvaluator
  evaluator := anEvaluator
%

category: 'querying'
method: GsRangeQueryPredicate
executeAndDo: aBlock
  | queryEvaluator |
  queryEvaluator := self evaluator asQueryEvaluator.
  queryEvaluator doBlock: aBlock.
  ^ self executeClause: queryEvaluator
%

category: 'querying-private'
method: GsRangeQueryPredicate
executeClause
  | queryEvaluator |
  queryEvaluator := self evaluator asQueryEvaluator.
  ^ self executeClause: queryEvaluator
%

category: 'querying-private'
method: GsRangeQueryPredicate
executeClause: queryEvaluator
  | theConstant1 theConstant2 theOperator1 theOperator2 validNilTransformOperators |
  self isNormal
    ifTrue: [
      theConstant1 := self constant1.
      theOperator1 := self operator1.
      theConstant2 := self constant2.
      theOperator2 := self operator2 ]
    ifFalse: [
      theConstant1 := self constant2.
      theOperator1 := self inverseOperatorFor: self operator2.
      theConstant2 := self constant1.
      theOperator2 := self inverseOperatorFor: self operator1 ].
  validNilTransformOperators := #(#'<=' #'>=').
  ((theConstant1 == nil and: [ theConstant2 == nil ])
    and: [
      (validNilTransformOperators includes: self operator1)
        and: [ validNilTransformOperators includes: self operator2 ] ])
    ifTrue: [ ^ queryEvaluator findAllValuesEqualTo: nil ].
  ((theConstant1 == nil and: [ theConstant2 ~~ nil ])
    and: [ validNilTransformOperators includes: self operator1 ])
    ifTrue: [ theOperator1 := #'=' ].
  ((theConstant1 ~~ nil and: [ theConstant2 == nil ])
    and: [ validNilTransformOperators includes: self operator2 ])
    ifTrue: [ theOperator2 := #'=' ].
  ^ queryEvaluator
    findAllValuesGreaterThan: theConstant1
    andEquals: theOperator1 == #'<='
    andLessThan: theConstant2
    andEquals: theOperator2 == #'<='
%

category: 'querying-private'
method: GsRangeQueryPredicate
executeClauseNegated
  "Deoptimize the range predicate and propogate executeClauseNegated"

  | theConstant1 theConstant2 theOperator1 theOperator2 predicate1 predicate2 |
  self isNormal
    ifTrue: [
      theConstant1 := self constant1.
      theOperator1 := self operator1.
      theConstant2 := self constant2.
      theOperator2 := self operator2 ]
    ifFalse: [
      theConstant1 := self constant2.
      theOperator1 := self inverseOperatorFor: self operator2.
      theConstant2 := self constant1.
      theOperator2 := self inverseOperatorFor: self operator1 ].
  predicate1 := (GsQueryPredicate
    constant: theConstant1
    operator: theOperator1
    path: self path) bindEvaluatorsFor: nsc collator: self collator.
  predicate2 := (GsQueryPredicate
    path: self path
    operator: theOperator2
    constant: theConstant2) bindEvaluatorsFor: nsc collator: self collator.
  ^ (predicate1 & predicate2) executeClauseNegated
%

category: 'querying-private'
method: GsRangeQueryPredicate
executeNegatedAndDo: aBlock
  "Deoptimize the range predicate and propogate executeClauseNegated"

  | theConstant1 theConstant2 theOperator1 theOperator2 predicate1 predicate2 |
  self isNormal
    ifTrue: [
      theConstant1 := self constant1.
      theOperator1 := self operator1.
      theConstant2 := self constant2.
      theOperator2 := self operator2 ]
    ifFalse: [
      theConstant1 := self constant2.
      theOperator1 := self inverseOperatorFor: self operator2.
      theConstant2 := self constant1.
      theOperator2 := self inverseOperatorFor: self operator1 ].
  predicate1 := (GsQueryPredicate
    constant: theConstant1
    operator: theOperator1
    path: self path) bindEvaluatorsFor: nsc collator: self collator.
  predicate2 := (GsQueryPredicate
    path: self path
    operator: theOperator2
    constant: theConstant2) bindEvaluatorsFor: nsc collator: self collator.
  ^ predicate1 & predicate2 executeNegatedAndDo: aBlock
%

category: 'private'
method: GsRangeQueryPredicate
immediateInvariant
  super immediateInvariant.
  operand1 immediateInvariant.
  operand2 immediateInvariant
%

category: 'testing'
method: GsRangeQueryPredicate
isNormal
  " operator1  and operator2 must be < or <= "

  ^ (self operator1 == #'<' or: [ self operator1 == #'<=' ])
    and: [ ^ self operator2 == #'<' or: [ self operator2 == #'<=' ] ]
%

category: 'querying-private'
method: GsRangeQueryPredicate
lastElementValue: anObject
  "anObject is the value obtained by traversing path terms to the last value ... analgous to the last element class"

  | selector1 selector2 |
  self isNormal
    ifTrue: [
      selector1 := self comparisonSelectorFor: self operator1.
      selector2 := self comparisonSelectorFor: self operator2 ]
    ifFalse: [
      selector1 := self
        comparisonSelectorFor: (self inverseOperatorFor: self operator1).
      selector2 := self
        comparisonSelectorFor: (self inverseOperatorFor: self operator2) ].
  ^ (self constant1 perform: selector1 with: anObject)
    & (anObject perform: selector2 with: self constant2)
%

category: 'accessing'
method: GsRangeQueryPredicate
operand1
  ^ operand1
%

category: 'accessing'
method: GsRangeQueryPredicate
operand1: anObject
  operand1 := anObject
%

category: 'accessing'
method: GsRangeQueryPredicate
operand2
  ^ operand2
%

category: 'accessing'
method: GsRangeQueryPredicate
operand2: anObject
  operand2 := anObject
%

category: 'accessing'
method: GsRangeQueryPredicate
operator1

   "Return the value of the instance variable 'operator1'."
   ^operator1
%

category: 'accessing'
method: GsRangeQueryPredicate
operator1: newValue

   "Modify the value of the instance variable 'operator1'."
   operator1 := newValue
%

category: 'accessing'
method: GsRangeQueryPredicate
operator2

   "Return the value of the instance variable 'operator2'."
   ^operator2
%

category: 'accessing'
method: GsRangeQueryPredicate
operator2: newValue

   "Modify the value of the instance variable 'operator2'."
   operator2 := newValue
%

category: 'accessing'
method: GsRangeQueryPredicate
path
  "don't like that we're obscuring instance variable reference this way ... rename instance variable"

  ^ path key
%

category: 'accessing'
method: GsRangeQueryPredicate
path: aPathString
  path := self pathReferenceFor: aPathString
%

category: 'private'
method: GsRangeQueryPredicate
postCopy
  operand1 := operand1 copy.
  path := path copy.
  operand2 := operand2 copy.
  super postCopy
%

category: 'querying-private'
method: GsRangeQueryPredicate
prepareForExecution
  "Return an object equivalent to the receiver that is prepared for execution within
   the context of a block."

  | ans |
  ans := GsPreparedRangeQueryPredicate new
    constant1: self constant1;
    operator1: self operator1;
    path: self path;
    operator2: self operator2;
    constant2: self constant2;
    _nsc: nsc collator: collator;
    evaluator: self evaluator;
    prepare.
  ^ans
%

category: 'printing'
method: GsRangeQueryPredicate
printOn: aStream
  aStream
    nextPutAll:
      '(' , self operand1 printString , ' ' , self operator1 asString , ' '
        , self rawPath printString , ' ' , self operator2 asString , ' '
        , self operand2 printString , ')'
%

category: 'accessing'
method: GsRangeQueryPredicate
rawPath
  "don't like that we're obscuring instance variable reference this way ... rename instance variable"

  ^ path
%

category: 'querying'
method: GsRangeQueryPredicate
readStream
  | queryEvaluator theConstant1 theConstant2 theOperator1 theOperator2 validNilTransformOperators stream |
  queryEvaluator := self evaluator asQueryEvaluator.
  self isNormal
    ifTrue: [
      theConstant1 := self constant1.
      theOperator1 := self operator1.
      theConstant2 := self constant2.
      theOperator2 := self operator2 ]
    ifFalse: [
      theConstant1 := self constant2.
      theOperator1 := self inverseOperatorFor: self operator2.
      theConstant2 := self constant1.
      theOperator2 := self inverseOperatorFor: self operator1 ].
  validNilTransformOperators := #(#'<=' #'>=').
  stream := ((theConstant1 == nil and: [ theConstant2 == nil ])
    and: [
      (validNilTransformOperators includes: self operator1)
        and: [ validNilTransformOperators includes: self operator2 ] ])
    ifTrue: [
      queryEvaluator
        _findAllValuesGreaterThan: theConstant1
        andEquals: true
        andLessThan: theConstant2
        andEquals: true
        using: (BtreeComparisonForCompare newForComparison: nil) ]
    ifFalse: [
      ((theConstant1 == nil and: [ theConstant2 ~~ nil ])
        and: [ validNilTransformOperators includes: self operator1 ])
        ifTrue: [ theOperator1 := #'=' ].
      ((theConstant1 ~~ nil and: [ theConstant2 == nil ])
        and: [ validNilTransformOperators includes: self operator2 ])
        ifTrue: [ theOperator2 := #'=' ].
      queryEvaluator
        _findAllValuesGreaterThan: theConstant1
        andEquals: theOperator1 == #'<='
        andLessThan: theConstant2
        andEquals: theOperator2 == #'<='
        using: (BtreeComparisonForCompare newForComparison: nil) ].
  stream
    streamQuerySpec:
      (stream btreeRangeComparisonQuerySpec
         key: theConstant1
         selector:
           (theOperator1 == #<=
             ifTrue: [ #'>=' ]
             ifFalse: [ #'>' ]); "denormalize the selector"
         key2: theConstant2 selector2: theOperator2;
         yourself).
  ^ stream
%

category: 'transforming'
method: GsRangeQueryPredicate
unbind
  "remove all bindings"

  | unbound |
  unbound := super unbind.
  unbound operand1: unbound operand1 unbind.
  unbound operand2: unbound operand2 unbind.
  unbound evaluator: nil.
  ^ unbound immediateInvariant
%

category: 'testing'
method: GsRangeQueryPredicate
usesComparisonOperation
  ^ true
%

category: 'testing'
method: GsRangeQueryPredicate
usesPathEvaluator
  self evaluator ifNil: [ ^ true ].
  ^ self evaluator isPathEvaluator
%

category: 'testing'
method: GsRangeQueryPredicate
usesRangeOperation
  ^ true
%

category: 'private'
method: GsRangeQueryPredicate
validate
  " operator1 and operator2 must be < or <=
      OR
	 operator1 and operator2 must be > or >= "

  self isNormal
    ifTrue: [ ^ self ].
  ((self operator1 == #'<' or: [ self operator1 == #'<=' ])
    and: [ self operator2 == #'<' or: [ self operator2 == #'<=' ] ])
    ifTrue: [ ^ self ].
  ((self operator1 == #'>' or: [ self operator1 == #'>=' ])
    and: [ self operator2 == #'>' or: [ self operator2 == #'>=' ] ])
    ifTrue: [ ^ self ].
  ^ (GsQueryPredicate
    operand: self operand1
    operator: self operator1
    operand: self rawPath)
    &
      (GsQueryPredicate
        operand: self rawPath
        operator: self operator2
        operand: self operand2)
%

category: 'accessing'
method: GsRangeQueryPredicate
variable1: aVariableName
  operand1 := self variableReferenceFor: aVariableName
%

category: 'accessing'
method: GsRangeQueryPredicate
variable2: aVariableName
  operand2 := self variableReferenceFor: aVariableName
%

category: 'private'
method: GsRangeQueryPredicate
_evaluators
  "return list of evaluators associated with predicate"

  ^ {(self evaluator)}
%

! Class extensions for 'GsSelectorPathTerm'

!		Instance methods for 'GsSelectorPathTerm'

category: 'Adding'
method: GsSelectorPathTerm
addDirectMappingFor: anObject root: rootObject nsc: anNsc logging: aBoolean
  " Update the B-tree and the dependency list for anObject."

  updateBtree ~~ nil
    ifTrue: [ updateBtree btreeAt: anObject put: anObject root: rootObject ].
%

category: 'Updating Indexes'
method: GsSelectorPathTerm
addMappingsForObject: anObject root: rootObject logging: aBoolean
  "No dependency list logic for receiver."

  | nextObj |
  (nil == anObject or: [ self size == 0 ])
    ifTrue: [ ^ self ].
  nextObj := self _nextObjectFor: anObject.	" get the next object along the path "
  updateBtree ~~ nil
    ifTrue: [ " insert an entry into the B-tree "
      (self _checkBtreeComparisonWith: nextObj)
        ifFalse: [
          ImproperOperation new
            _number:
                (ErrorSymbols at: #'rtErrRangeEqualityIndexInvalidClassKindForBtree');
            args: { nextObj class. self name. updateBtree lastElementClassDescription };
            signal ].
      updateBtree btreeAt: nextObj put: anObject root: rootObject ].
  nil == nextObj
    ifTrue: [ ^ self recordNilOnPathForRoot: rootObject ].
  1 to: children size do: [ :i | " make recursive call to add mappings "
    (children at: i)
      addMappingsForObject: nextObj
      root: rootObject
      logging: aBoolean ]
%

category: 'Audit'
method: GsSelectorPathTerm
auditDepListFor: obj index: indexObj using: auditor optionalSentinel: optionalSentinel
  "No dependency lists"

  ^ obj
%

category: 'Audit'
method: GsSelectorPathTerm
auditUpdateCacheFor: anObject root: root nilOnPathRoots: nilOnPathRoots occurrences: num using: auditor
  "verify proper accounting for objects with nil on path"

  | nextObj |
  nextObj := self _nextObjectFor: anObject.
  (nil == nextObj and: [ updateBtree isNil ])
    ifTrue: [
      | nilOnPathNum |
      nilOnPathNum := nilOnPath occurrencesOf: root.
      nilOnPathNum = num
        ifFalse: [ auditor pathTermIncorrectNilOnPathCount: self root: root got: nilOnPathNum  expected: num ].
      ^ self ].
  1 to: children size do: [ :i |
    (children at: i)
      auditUpdateCacheFor: nextObj
      root: root
      nilOnPathRoots: nilOnPathRoots
      occurrences: num
      using: auditor ]
%

category: 'Updating Indexes'
method: GsSelectorPathTerm
cleanupDependencyListFor: anObject
  ""


%

category: 'Collection Based Modification'
method: GsSelectorPathTerm
findRootObjectMaps: rootObjectMap for: anObject
  "Traverse btree nodes from receiver to leaf term. Collect rootObjects for all btree elements
   for which anObject is a key or parent of a key."

  | rootObjects nextObj |
  rootObjects := IdentityBag new.
  nextObj := self _nextObjectFor: anObject.
  updateBtree ~~ nil
    ifTrue: [
      "btree exists for receiver, collect the root objects, where anObject is the key and nextObj
       is the value."
      rootObjects := self findRootObjectMaps: rootObjectMap forKey: nextObj value: anObject ].
  ^ rootObjects
%

category: 'Collection Based Modification'
method: GsSelectorPathTerm
findRootObjectMaps: rootObjectMap for: anObject oldValue: oldValue
  "Traverse btree nodes from receiver to leaf term. Collect rootObjects for all btree elements
   for which anObject is a key or parent of a key."

  ^self findRootObjectMaps: rootObjectMap for: anObject
%

category: 'Collection Based Modification'
method: GsSelectorPathTerm
findRootObjectsFor: anObject
  "Traverse btree nodes from receiver to leaf term. Collect rootObjects for all btree elements
   for which anObject is a key or parent of a key."

  | rootObjects nextObj |
  rootObjects := IdentityBag new.
  nextObj := self _nextObjectFor: anObject.
  updateBtree ~~ nil
    ifTrue: [
      "btree exists for receiver, collect the root objects, where anObject is the key and nextObj
       is the value."
      rootObjects := self findRootObjectsForKey: nextObj value: anObject ].
  ^ rootObjects
%

category: 'Collection Based Modification'
method: GsSelectorPathTerm
findRootObjectsFor: anObject oldValue: oldValue
  "Traverse btree nodes from receiver to leaf term. Collect rootObjects for all btree elements
   for which anObject is a key or parent of a key."

  ^self findRootObjectsFor: anObject
%

category: 'Testing'
method: GsSelectorPathTerm
isSelectorTerm
  ^ true
%

category: 'Accessing'
method: GsSelectorPathTerm
needsDepList
  "receiver does not do automatic maintenance updates"

  ^ false
%

category: 'Updating'
method: GsSelectorPathTerm
needsDepList: ignored
  "receiver does not do automatic maintenance updates"

%

category: 'Removing'
method: GsSelectorPathTerm
removeMappingsFor: anObject root: rootObject lastOne: aBoolean logging: doLogging
  "Remove entries in the btree for anObject."

  | nextObj more isLast |
  self size == 0
    ifTrue: [ ^ self ].
  nextObj := self _nextObjectFor: anObject.
  updateBtree ~~ nil
    ifTrue: [
      " remove an entry from the B-tree "
      (updateBtree btreeRemoveKey: nextObj value: anObject root: rootObject)
        ifFalse: [ self _errorObjectNotInBtree: nextObj value: anObject root: rootObject ] ].
  more := false.
  nextObj ifNil: [ self removeNilOnPathForRoot: rootObject ].
  (nil ~~ nextObj and: [ children isEmpty not ])
    ifTrue: [
      aBoolean
        ifTrue: [
          | last |
          last := (children at: 1) _isLastOccurrenceInIndexFor: nextObj.
          isLast := aBoolean and: [ last ] ]
        ifFalse: [ isLast := false ].
          " make recursive call to remove mappings "
      1 to: children size do: [ :i |
        (children at: i) removeMappingsFor: nextObj root: rootObject lastOne: isLast logging: doLogging ] ]
%

category: 'Accessing'
method: GsSelectorPathTerm
termSelector
  | term |
  term := self name.
  ^ term copyFrom: 2 to: term size
%

category: 'Updating Indexes'
method: GsSelectorPathTerm
undoMappingsFor: anObject lastOne: aBoolean logging: doLogging
  "No dependency lists for anObject."

%

category: 'Updating Indexes'
method: GsSelectorPathTerm
update: anObject at: ivOffset to: newValue
  "should never be sent to the receiver as automatic index maintenance is not supported"

  self shouldNotImplement: #'update:at:to:'
%

category: 'Updating'
method: GsSelectorPathTerm
_addChildTerm: aPathTerm
  self
    error:
      'Selector path term may not have child terms: ' , aPathTerm printString
%

category: 'Accessing'
method: GsSelectorPathTerm
_nextObjectFor: anObject
  "Returns the object at the instance variable that corresponds to the receiver
 path term."

  ^ anObject perform: self termSelector
%

category: 'Accessing'
method: GsSelectorPathTerm
_nextObjectFor: anObject atInstVar: ivOffset
  self shouldNotImplement: #'_nextObjectFor:atInstVar:'
%

! Class extensions for 'GsSetValuedPathTerm'

!		Instance methods for 'GsSetValuedPathTerm'

category: 'Adding'
method: GsSetValuedPathTerm
addDirectMappingFor: anObject root: rootObject nsc: anNsc logging: aBoolean
  " Update the B-tree and the dependency list for anObject."

  updateBtree ~~ nil
    ifTrue: [ updateBtree btreeAt: anObject put: anNsc root: rootObject ].
  needsDepList
    ifTrue: [ " add an entry in the dependency list "
      anObject getDepListAndAddLastElementPathTerm: self logging: aBoolean ]
%

category: 'Updating Indexes'
method: GsSetValuedPathTerm
addMappingsForObject: anNsc root: rootObject logging: aBoolean
  "Adds index dictionary entries for the objects in anNsc.  Also update the
 NSC's index list."

  | iList sz |
  (nil == anNsc _or: [ self size == 0 ])
    ifTrue: [ ^ self ].
  anNsc class isNsc
    ifFalse: [ ^ self _errorPathObjectNotAnNsc: anNsc ].
  sz := self size.
  iList := anNsc _getIndexList.
  anNsc _putInWriteSet.	" for each index that utilizes this path term "
  1 to: sz do: [ :i | iList addIndex: (self at: i) withOffset: offset + 1 nsc: anNsc ].
  sz := children size.
  anNsc
    do: [ :setElement | " insert dictionary entry mapping set element -> NSC "
      updateBtree ~~ nil
        ifTrue: [
          (self _checkBtreeComparisonWith: setElement)
            ifFalse: [
              ImproperOperation new
                _number:
                    (ErrorSymbols at: #'rtErrRangeEqualityIndexInvalidClassKindForBtree');
                args: { setElement class. self name. updateBtree lastElementClassDescription };
                signal ].
          updateBtree btreeAt: setElement put: anNsc root: rootObject.
          needsDepList
            ifTrue: [ " add an entry in the dependency list "
              setElement getDepListAndAddLastElementPathTerm: self logging: aBoolean ] ].
      1 to: sz do: [ :j | (children at: j) addMappingsForObject: setElement root: rootObject logging: aBoolean ] ]
%

category: 'Audit'
method: GsSetValuedPathTerm
auditDepListFor: obj index: indexObj using: auditor optionalSentinel: optionalSentinel
  "the set does not have a dependency list"

  self shouldNotImplement: #'auditDepListFor:index:using:optionalSentinel:'
%

category: 'Audit'
method: GsSetValuedPathTerm
auditNscCountsFor: anNsc using: auditor count: btreeCounts
  "Private. "

  | sz |
  sz := self size.
  (nil == anNsc _or: [ sz == 0 ])
    ifTrue: [ ^ self ].
  anNsc do: [ :setElement | | index |
      index := 1.
      children isEmpty
        ifTrue: [ self auditDirectNscCountsFor: setElement using: auditor count: btreeCounts ]
        ifFalse: [ 1 to: sz do: [ :i | | count indexObj |
            indexObj := self at: i.
            indexObj size == offset
              ifTrue: [ count := btreeCounts at: index.
                count == 0
                  ifTrue: [ auditor pathTermIncorrectNumberOfBtreeEntries: self index: i offset: offset ].
                btreeCounts at: index put: count - 1.
                index := index + 1 ] ].
          1 to: children size do: [ :i | (children at: i)
              auditNscCountsFor: setElement
              using: auditor
              count: (btreeCounts at: index).
            index := index + 1 ] ] ]
%

category: 'Audit'
method: GsSetValuedPathTerm
auditNscForRootObj: anNsc rootObj: rootObj using: auditor
  "Private. "

  self size == 0
    ifTrue: [ ^ self ].
  self indicatesIndexOnNscElements
    ifTrue: [ "^ self auditDirectNscRootObj: obj using: auditor" self error: 'not yet implemented' ].
  nil == anNsc
    ifTrue: [ ^ self ].
self nextObj: anNsc do: [:nextObj |
  1 to: self size do: [ :i | | indexObj |
    indexObj := self at: i.
    indexObj size == offset
      ifTrue: [ | col found expected |
        col := IdentityBag new.
        indexObj btreeRoot btreeRootNode _findAndCountKey: nextObj value: anNsc root: rootObj into: col.
        (found := col size) == (expected := indexObj nscRoot occurrencesOf: rootObj)
          ifFalse: [
            auditor
              btree: indexObj btreeRoot
              incorrectCountForKeyValueRootPairs: self
              key: nextObj
              value: anNsc
              root: rootObj
              found: found
              expected: expected ] ] ].
  1 to: children size do: [ :i | (children at: i)
      auditNscForRootObj: nextObj
      rootObj: rootObj
      using: auditor ]
]
%

category: 'Audit'
method: GsSetValuedPathTerm
auditUpdateCacheFor: anNsc root: root nilOnPathRoots: nilOnPathRoots occurrences: num using: auditor
  "verify proper accounting for objects with nil on path"

  | prevObj reachableNilOnPathRoots excessNilOnPathCount |
  prevObj := #_incompletePathTraversal.
  reachableNilOnPathRoots := self findAllReachableNilOnPathRoots.
  nilOnPathRoots ifNotNil: [ reachableNilOnPathRoots addAll: nilOnPathRoots ].
  anNsc do: [ :nextObj |
     updateBtree
       ifNil: [
        nextObj ~~ prevObj
          ifTrue: [ | newNum |
            newNum := num * (anNsc occurrencesOf: nextObj).
            1 to: children size do: [ :i |
              (children at: i)
                auditUpdateCacheFor: nextObj
                root: root
                nilOnPathRoots: reachableNilOnPathRoots
                occurrences: newNum
                using: auditor ] ] ].
    prevObj := nextObj ].
  (((excessNilOnPathCount := reachableNilOnPathRoots occurrencesOf: root) > 0) and: [ nilOnPathRoots isNil ])
    ifTrue: [
      "uppermost set valued term is where the accounts must balance"
      auditor setValuedPathTermExtraNilOnPathCount: self root: root excessCount: excessNilOnPathCount ].
%

category: 'Updating Indexes'
method: GsSetValuedPathTerm
cleanupDependencyListFor: anNsc
  ""

  | sz iList |
  (nil == anNsc _or: [ self size == 0 ])
    ifTrue: [ ^ self ].
  anNsc class isNsc
    ifFalse: [ ^ self _errorPathObjectNotAnNsc: anNsc ].
  (iList := anNsc _indexedPaths) ~~ nil
    ifTrue: [ iList removeIndexesInPathTerm: self for: anNsc ].
  sz := children size.
  anNsc
    do: [ :setElement |
      | depList |
      needsDepList
        ifTrue: [
          depList := DependencyList for: setElement.
          depList ~~ nil
            ifTrue: [ depList removeCompletelyPathTerm: self for: setElement ] ].
      1 to: sz do: [ :j | (children at: j) cleanupDependencyListFor: setElement ] ]
%

category: 'Collection Based Modification'
method: GsSetValuedPathTerm
findRootObjectMaps: rootObjectMap for:  anNsc
  "Traverse btree nodes from receiver to leaf term. Collect rootObjects for all btree elements
   for which anObject is a key or parent of a key."

  anNsc
    do: [ :nextObj |
      "Make a full pass for each of the enumerated instance variables"
      updateBtree ~~ nil
        ifTrue: [
          "btree exists for receiver, collect the root objects, where nextObj is the key and anNsc
           is the value."
          self findRootObjectMaps: rootObjectMap forKey: nextObj value: anNsc ].
      (self children isEmpty)
        ifTrue: [ ^ self ].
      1 to: children size do: [:i |
        (children at: i) findRootObjectMaps: rootObjectMap for:  nextObj] ].
%

category: 'Collection Based Modification'
method: GsSetValuedPathTerm
findRootObjectMaps: rootObjectMap for: anNsc oldValue: oldValue
  "Traverse btree nodes from receiver to leaf term. Collect rootObjects for all btree elements
   for which anObject is a key or parent of a key."

  anNsc
    do: [ :nextObj |
      "Make a full pass for each of the enumerated instance variables"
      updateBtree ~~ nil
        ifTrue: [
          "btree exists for receiver, collect the root objects, where nextObj is the key and anNsc
           is the value."
          self findRootObjectMaps: rootObjectMap forKey: nextObj value: anNsc ].
      (self children isEmpty)
        ifTrue: [ ^ self ].
      1 to: children size do: [:i |
        (children at: i) findRootObjectMaps: rootObjectMap for:  nextObj] ].
%

category: 'Collection Based Modification'
method: GsSetValuedPathTerm
findRootObjectsFor: anNsc
  "Traverse btree nodes from receiver to leaf term. Collect rootObjects for all btree elements
   for which anObject is a key or parent of a key."

  | rootObjects roots |
  rootObjects := IdentityBag new.
  anNsc
    do: [ :nextObj |
      "Make a full pass for each of the enumerated instance variables"
      updateBtree ~~ nil
        ifTrue: [
          "btree exists for receiver, collect the root objects, where nextObj is the key and anNsc
           is the value."
          roots := self findRootObjectsForKey: nextObj value: anNsc.
          rootObjects := rootObjects _union: roots ].
      (self children isEmpty)
        ifTrue: [ ^ rootObjects ].
      1 to: children size do: [:i |
        roots := (children at: i) findRootObjectsFor: nextObj.
        rootObjects := rootObjects _union: roots ] ].
  ^ rootObjects
%

category: 'Modification'
method: GsSetValuedPathTerm
findRootObjectsForKey: aKey value: aValue
  ^ updateBtree findRootObjectsComparingForKey: aKey value: aValue
%

category: 'Testing'
method: GsSetValuedPathTerm
indicatesIndexOnNscElements
  "Returns true if the path term indicates that the index is on elements of the
 NSC itself.  This is the case if the path term ends in '*' (that is, this
 path term has no children)."

  ^ children isEmpty
%

category: 'Testing'
method: GsSetValuedPathTerm
indicatesNsc
  "Returns true, the receiver indicates that the index is on an
 instance variable that is expected to be a collection (i.e., set valued pathterm."

  ^ true
%

category: 'Testing'
method: GsSetValuedPathTerm
isSetValuedTerm
  "Returns true if the receiver indicates a set-valued instance variable."

  ^ true
%

category: 'Accessing'
method: GsSetValuedPathTerm
nextObj: anNsc do: aBlock
  anNsc do: aBlock
%

category: 'Removing'
method: GsSetValuedPathTerm
removeDirectMappingFor: anObject root: root nsc: anNsc logging: doLogging
  "There is a range index directly on the elements of the NSC.  Update the
 B-tree."

  updateBtree ~~ nil
    ifTrue: [ " remove it from the B-tree "
      (updateBtree btreeRemoveKey: anObject value: anNsc root: root)
         ifFalse: [ self _errorObjectNotInBtree: anObject value: anNsc root: root ] ]
%

category: 'Removing'
method: GsSetValuedPathTerm
removeMappingsFor: anNsc root: rootObject lastOne: aBoolean logging: doLogging
  "Remove entries in the btree and dependency lists for anNsc."

  | depList isLast |
  self size == 0
    ifTrue: [ ^ self ].
  anNsc
    do: [ :setElement |
      updateBtree ~~ nil
        ifTrue: [
          " remove an entry from the B-tree "
          (updateBtree btreeRemoveKey: setElement value: anNsc root: rootObject)
            ifFalse: [ self _errorObjectNotInBtree: setElement value: anNsc root: rootObject ].
          needsDepList
            ifTrue: [
              " remove dependency list entry for next object "
              DependencyList removePathTerm: self for: setElement ] ].
      (nil ~~ setElement and: [ children isEmpty not ])
        ifTrue: [
          aBoolean
            ifTrue: [
              | last |
              last := (children at: 1) _isLastOccurrenceInIndexFor: setElement.
              isLast := aBoolean and: [ last ] ]
            ifFalse: [ isLast := false ].
          " make recursive call to remove mappings "
          1 to: children size do: [ :i |
            (children at: i) removeMappingsFor: setElement root: rootObject lastOne: isLast logging: doLogging ].
          isLast
            ifFalse: [
              "check again in case there are no more references left in btree"
              isLast := ((children at: 1) findReachableRootsFor: setElement) isEmpty ].
          isLast
            ifTrue: [
              " remove dependency list entries for next object "
              (depList := DependencyList for: setElement) ~~ nil
                ifTrue: [ depList removePathTerms: children for: setElement logging: doLogging ] ] ] ]
%

category: 'Error Handling'
method: GsSetValuedPathTerm
_errorPathObjectNotAnNsc: anObject
  "An object traversed along an index path through a set-valued instance
 variable was not an NSC."

  ImproperOperation new
    reason: #'rtErrPathTermObjectNotAnNsc';
    object: anObject;
    details: 'Expected an UnorderedCollection';
    signal
%

category: 'Testing'
method: GsSetValuedPathTerm
_isLastOccurrenceInIndexFor: anNsc

  ^ (self findReachableRootsFor: anNsc) size <= anNsc size
%

category: 'Indexing Support'
method: GsSetValuedPathTerm
_updateCollectionBasedIndexFor: anIndex on: anNsc offset: anOffset addingIndex: addingIndex
  "if anNsc already has an index, add/remove anIndex as appropriate"

  anNsc _indexedPaths ~~ nil
    ifTrue: [
      | nscOffset |
      nscOffset := anOffset + 1.
      addingIndex
        ifTrue: [
          anNsc _indexedPaths
            addIndex: anIndex
            withOffset: (anIndex at: anOffset) offset + 1
            nsc: anNsc ]
        ifFalse: [ anNsc _indexedPaths removeIndex: anIndex withOffset: nscOffset for: anNsc ] ]
%

! Class extensions for 'GsSignalingSocket'

!		Class methods for 'GsSignalingSocket'

removeallmethods GsSignalingSocket
removeallclassmethods GsSignalingSocket

category: 'Instance Creation'
classmethod: GsSignalingSocket
fromFileHandle: aSmallInteger
 "Read carefully the documentation in GsSocket >> fromFileHandle: "

 | r |
 r := super fromFileHandle: aSmallInteger .
 r raiseExceptionOnError: true .
 ^ r
%

category: 'Queries'
classmethod: GsSignalingSocket
getHostAddressByName: aHostName

"aHostName must be a String .
 Returns the ip address for aHostName .

 Signals an Error if aHostName cannot be resolved.

 The resulting ip address is a String in a form acceptable to
 inet_pton(AF_INET6, aString, ...)

 If getaddrinfo() returns more than one address for aHostName,
 the first element of the list from getaddrinfo() is returned.
"

 (super getHostAddressByName: aHostName) ifNotNil:[:r | ^ r ].
 self signalError .
%

category: 'Queries'
classmethod: GsSignalingSocket
getHostNameByAddress: address

"Returns the host name for the given ip address.
 Signals an Error if the host is undefined.

 The address needs to be a String in a form acceptable to
 either inet_pton(AF_INET6, address, ...)
 or    inet_pton(AF_INET, address, ...) in the host operating
 system."

 (super getHostNameByAddress: address) ifNotNil:[:r | ^ r ].
 self signalError .
%

category: 'Queries'
classmethod: GsSignalingSocket
getLocalHostName

"Returns the name of the local host or signals an Error."

 (super getLocalHostName) ifNotNil:[:r | ^ r ].
 self signalError .
%

category: 'Queries'
classmethod: GsSignalingSocket
getServiceNameByPort: servicePort withProtocol: protocol

"Returns the service name for the given port number and protocol.
 Protocol may be nil (interpreted as tcp), 'tcp', or 'udp' .
 Signals an Error if the service is undefined."

 (super getServiceNameByPort: servicePort withProtocol: protocol)
   ifNotNil:[:r | ^ r ].
 self signalError .
%

category: 'Queries'
classmethod: GsSignalingSocket
getServicePortByName: serviceName

"Returns the port number for the given service or signals an Error."

 ^ self getServicePortByName: serviceName withProtocol: nil
%

category: 'Queries'
classmethod: GsSignalingSocket
getServicePortByName: serviceName withProtocol: protocol

"Returns the port number for the given service and protocol.
 Protocol may be nil (interpreted as tcp), 'tcp', or 'udp' .
 Signals an Error if the service is undefined."

 (super getServicePortByName: serviceName withProtocol: protocol)
   ifNotNil:[:r | ^ r ].
 self signalError .
%

category: 'Instance Creation'
classmethod: GsSignalingSocket
new
"Returns a new non-blocking TCP socket
 or signals an Error if unable to create a new socket.

 On Solaris this creates a socket with family AF_INET6.

 On other platforms this creates a socket with family AF_INET.
 which may be bound or connected to IPv4 addresses or to IPv4-mapped IPv6 addresses."

 | s |
 s := self _basicNew .
 (s _zeroArgPrim: 1) ifNil:[ self signalError ].
 s raiseExceptionOnError: true .
 ^ s
%

category: 'Instance Creation'
classmethod: GsSignalingSocket
newIpv6

"Returns a new non-blocking TCP socket
 or signals an Error if unable to create a new socket.

 This creates a socket with family AF_INET6
 which may be bound or connected to IPv6 addresses.
 On Linux and solaris the result socket may also
 be bound or connected to IPv4-mapped IPv6 addresses."

 | s |
 s := self _basicNew .
 (s _zeroArgPrim: 34) ifNil:[ self signalError ].
 s raiseExceptionOnError: true .
 ^ s
%

category: 'Instance Creation'
classmethod: GsSignalingSocket
newUdp

"Returns a new non-blocking UDP socket
 or signals an Error if unable to create a new socket.

 On Solaris this creates a socket with family AF_INET6.

 On other platforms this creates a socket with family AF_INET
 which may be bound or connected to IPv4 addresses or to IPv4-mapped IPv6 addresses."

 | s |
 s := self _basicNew .
 (s _zeroArgPrim: 26) ifNil:[ self signalError ].
 s raiseExceptionOnError: true .
 ^ s
%

category: 'Instance Creation'
classmethod: GsSignalingSocket
newUdpIpv6

"Returns a new non-blocking UDP socket
 or signals an Error if unable to create a new socket.

 This creates a socket with family AF_INET6
 which may be bound or connected to IPv6 addresses.
 On Linux and solaris the result socket may also
 be bound or connected to IPv4-mapped IPv6 addresses."

 | s |
 s := self _basicNew .
 (s _zeroArgPrim: 35) ifNil:[ self signalError ].
 s raiseExceptionOnError: true .
 ^ s
%

category: 'Error Reporting'
classmethod: GsSignalingSocket
signalError
  ^ SocketError signal: (self lastErrorString ifNil:[ 'no details' ]).
%

category: 'Error Reporting'
classmethod: GsSignalingSocket
signalError: aString
  ^ SocketError signal:
      (self lastErrorString ifNotNil:[:s | aString , ', ' , s]  ifNil:[ aString ]).
%

!		Instance methods for 'GsSignalingSocket'

category: 'Server Operations'
method: GsSignalingSocket
accept

"Accept a client request for a connection on the receiver.
 Returns a socket created for a new connection,
 or signals an Error if there was some problem.
 The result is an instance of speciesForAccept , and has non-blocking state
 equal to non-blocking state of the receiver."

 (super accept) ifNotNil:[:r |
   r raiseExceptionOnError: true .
   ^ r
 ].
 self signalError .
%

category: 'Server Operations'
method: GsSignalingSocket
acceptTimeoutMs: timeoutMs
 "Returns a socket created for a new connection,
  or signals an Error if there was an error or a timeout.
  The result is an instance of speciesForAccept , and has non-blocking state
  equal to non-blocking state of the receiver."
^ self acceptTimeoutMs: timeoutMs errorOnTimeout: true
%

category: 'Server Operations'
method: GsSignalingSocket
acceptTimeoutMs: timeoutMs errorOnTimeout: errOnTimeoutBool
 "Returns a socket created for a new connection.
  or signals an Error if there was an error.
  If errOnTimeoutBool == true  timeout signals an Error ,
  otherwise returns false on timeout.
  The result is an instance of speciesForAccept , and has non-blocking state
  equal to non-blocking state of the receiver."
| res aSocket cnt |
aSocket := self speciesForAccept _basicNew .
res := true.
cnt := 1 .
[ res == true or:[ res == false ]] whileTrue: [
  "primitive will wait until data available if C socket is blocking."
  res := self _twoArgPrim: 4 with: aSocket with: nil .
  (res == false) ifTrue: [
    "socket is non-blocking and would have blocked, process scheduler
     will suspend the current GsProcess"
    res := self _rawReadWillNotBlockWithin: timeoutMs .
    res ifNil:[ ^ self signalError ].
    res == false ifTrue:[
      errOnTimeoutBool ifTrue:[ ^ self signalError:'accept timed out'].
      ^ false .
    ].
  ].
  cnt := cnt + 1 "for debugging"
].
res ifNil:[ ^ self signalError ].
res := aSocket.
^res
%

category: 'Client Operations'
method: GsSignalingSocket
bindTo: portNumber

"Binds the receiver to the specified port number.  Use the makeServer
 methods to do the bind when creating a server socket.
 If portNumber is nil then a random port is selected.
 This method is provided to bind a client socket to a specific port
 before it is connected.  Returns the port number actually
 bound to (should be the same as the argument unless argument is nil),
 or signals an Error if not successful."

 ^ self bindTo: portNumber toAddress: nil
%

category: 'Client Operations'
method: GsSignalingSocket
bindTo: portNumber toAddress: address

"Binds the receiver to the specified port number and address.
 Use the makeServer methods to do the bind when creating a server socket.
 This method is provided to bind a client socket to a specific port
 and/or address before doing a listen or connect on the socket.
 If portNumber is nil then a random port is selected.
 If address is nil then any network interface(IN6ADDR_ANY_INIT) is used.
 Returns the port number actually bound to (should be the same as
 the argument unless argument is nil),
 or signals an Error if not successful.

 address is a String containing a numeric IP address in one of these forms
   IPv4  dotted-decimal format  d.d.d.d
   IPv6  hex format   x:x:x:x:x:x:x:x ,
   IPv4-mapped IPv6  ::FFFF:d.d.d.d,
   where d is an 8 bit decimal number and x is a 16 bit hexadecimal number.
   An IPv6 format may contain at most one :: which is a contigous
   group of zeros.

 Gs64 v3.1:  address = -1, denoting IPv4 INADDR_BROADCAST, no longer supported.

"
 (super bindTo: portNumber toAddress: address) ifNotNil:[:r | ^ r ].
 self signalError .
%

category: 'Client Operations'
method: GsSignalingSocket
connectTo: portNumber on: aHost timeoutMs: timeoutMs

"Connect the receiver to the server socket identified by portNumber and aHost.
aHost may be the name of the host or its numeric address,
or aHost == -1 for <broadcase> , or aHost == nil for IN6ADDR_ANY_INIT .
portNumber maybe either a SmallInteger, or the String name of a service.
timeoutMs is a SmallInteger specifying maximum time to wait for the
connection to complete, or -1 to wait indefinitely.
If aHost is the name of a host, connect is attempted on IPv4 first
if getaddrinfo returns any IPv4 addresses for aHost, then attempted
on IPv6.
Returns true if the connection succeeded otherwise signals an Error."

(super connectTo: portNumber on: aHost timeoutMs: timeoutMs) ~~ true
  ifTrue:[ self signalError:'connect failed' ].
^ true
%

category: 'Socket Operations'
method: GsSignalingSocket
linger: bool length: timeOut

"Sets up the receiver so that if unsent data is waiting to be transmitted
 at the time the receiver is closed, the current GsProcess will
 be suspended until either the data is transmitted, or the given timeOut expires.
 timeOut is in units of seconds.

 Returns the receiver or signals an Error."

 (super linger: bool length: timeOut) ifNotNil:[:r | ^ r ].
 self signalError .
%

category: 'Server Operations'
method: GsSignalingSocket
makeListener: queueLength

"Turns the receiver into a listening socket.
 The queueLength argument specifies the size of the listen backlog queue for
 incoming connections.
 Returns the receiver or signals an Error."

 (super makeListener: queueLength) ifNotNil:[:r | ^ r ].
 self signalError .
%

category: 'Writing'
method: GsSignalingSocket
nbwrite: amount from: byteObj startingAt: index

"If receiver is a non-blocking socket,
 write at most amount bytes from byteObj to the receiver without blocking.

 If receiver is a blocking socket,
 write at most amount bytes from byteObj to the receiver blocking until
 the socket accepts data, or until the gem process receives SIGTERM.

 The first byte written will be from the position indicated by index.
 The maximum number of bytes to write is specified by amount.
 It is an error if amount bytes are not available.
 Returns the number of bytes written, or signals an Error .
 Returns 0 if non-blocking socket would have blocked."

 | res |
 [
   res := self _write: byteObj startingAt: index ofSize: amount.
   (res == false) ifTrue: [
     "would have blocked"
     ^ 0
   ].
   res == true  "if res==true, socket got EINTR and we retry"
 ] whileTrue .
 res ifNil:[ self signalError ].
 ^ res
%

category: 'Accessing'
method: GsSignalingSocket
option: optionName

"Returns the current value of the specified option.
 Signals an Error if an error occurred."

 (super option: optionName) ifNotNil:[:r | ^ r ].
 self signalError .
%

category: 'Socket Operations'
method: GsSignalingSocket
option: optionName put: value

"Sets the value of the specified option.
 Returns the receiver or signals an Error."

 (super option: optionName put: value) ifNotNil:[:r | ^ r ].
 self signalError .
%

category: 'Configuration'
method: GsSignalingSocket
raiseExceptionOnError: aBoolean

"Sets the value of raiseExceptionOnError to aBoolean for the receiver.
 Returns the receiver."

 aBoolean ~~ true ifTrue:[ ArgumentError signal:'should not shutoff errors in GsSignalingSocket'].
 super raiseExceptionOnError: aBoolean .
%

category: 'Reading'
method: GsSignalingSocket
read: maxBytes into: byteObj startingAt: index

"Reads up to the given number of bytes into the given byte object (for
 example, a String).  The first byte read will go into the position
 indicated by index.
 Returns the number of bytes read, or 0 if EOF on the receiver,
 or signals an Error .

 maxBytes must be a SmallInteger > 0 and <= 500000000 .

 An error will be raised if index is greater than the size of byteObj.
 Note that index can be equal to the size of byteObj plus 1 in which
 case any bytes read will be appended to byteObj.

 If no data is available for reading
 the current GsProcess is suspended until data arrives.
 The readWillNotBlock or readWillNotBlockWithin: methods may be used to
 determine whether or not data is ready for reading before calling this method."

 (super read: maxBytes into: byteObj startingAt: index) ifNotNil:[:r | ^ r ].
 self signalError .
%

category: 'Reading'
method: GsSignalingSocket
read: maxBytes into: byteObj startingAt: index maxWait: timeMs
 "Reads up to the given number of bytes into the given byte object (for
 example, a String).  The first byte read will go into the position
 indicated by index.
 Returns the number of bytes read, or 0 for EOF, otherwise signals an error.

 If no data is available for reading
 the current GsProcess is suspended for up to timeMs until data arrives."

 | status |
 status := super read: maxBytes into: byteObj startingAt: index maxWait: timeMs .
 status ifNotNil:[
   status == false ifTrue:[ SocketError signal:'timeout waiting to read'].
   ^ status "number of bytes read or 0 for EOF"
 ].
 ^ self signalError .
%

category: 'Reading'
method: GsSignalingSocket
readString: maxBytes

"Reads up to the given number of bytes, returning them in a String whose size is
 between 0 and maxBytes inclusive.  If an error occurs, an Error is signaled.
 EOF is not an error, if EOF occurs on the receiver before any bytes are read,
 a String of size zero is returned.

 maxBytes must be a SmallInteger > 0 .
 If maxBytes is greater than the size of the operating system's buffer for
 the socket, the size of the result string may be a function of this
 buffer size, even if more data is available from the sender.  Repeated
 invocation of this method may be necessary to obtain all of the data.

 If no data is available for reading
 the current GsProcess is suspended until data arrives.
 The readWillNotBlock or readWillNotBlockWithin: methods may be used to
 determine whether or not data is ready for reading before calling this method."

  | bytes |
  bytes := String new.
  self read: maxBytes into: bytes startingAt: 1.
  ^ bytes
%

category: 'Reading'
method: GsSignalingSocket
readString: amount untilFalse: aBlock

"Reads bytes from the receiver into a String which it creates and returns.
 Will keep reading until amount bytes are read or
 the one argument Block  aBlock  returns false.
 Each time aBlock is evaluated it is given the number of bytes read so far.
 aBlock is only evaluated after a partial read.
 Returns the String or signals an Error."

| bytes |
bytes := String new.
self read: amount into: bytes untilFalse: aBlock .
^ bytes.
%

category: 'Error Reporting'
method: GsSignalingSocket
signalError
  ^ SocketError signal: (self lastErrorString ifNil:[ 'no details' ]).
%

category: 'Error Reporting'
method: GsSignalingSocket
signalError: aString
  ^ SocketError signal:
     (self lastErrorString ifNotNil:[:s | aString , ', ' , s]  ifNil:[ aString ]).
%

category: 'Writing'
method: GsSignalingSocket
write: amount from: byteObj startingAt: index

"Write bytes from byteObj to the receiver.
 The first byte written will be from the position indicated by index.
 The number of bytes written is specified by amount.
 It is in an error if amount bytes are not available.
 Returns the number of bytes written, or signals an Error if an error occurs.

 If the receiver is not ready for writing
 the current GsProcess is suspended until data arrives.
 The writeWillNotBlock or writeWillNotBlockWithin: methods may be used to
 determine whether or not data is ready for writing before calling this method."

 | offset numToWrite waitCnt |
 offset := index.
 numToWrite := amount.
 [ true ] whileTrue:[ | result |
   [
     result := self _write: byteObj startingAt: offset ofSize: numToWrite .
     result == true
   ] whileTrue . "loop to handle EINTR "

   result _isSmallInteger ifTrue:[
     numToWrite  := numToWrite - result .
     (numToWrite <= 0) ifTrue: [ ^ amount ]. "All done"
     waitCnt := nil .
     offset := offset + result .
   ] ifFalse: [
     result ifNil:[ self signalError ].
     waitCnt ifNotNil:[
       waitCnt < 3 ifTrue:[
         waitCnt := waitCnt + 1 .
         Delay waitForMilliseconds: 1.
       ] ifFalse:[
         GsFile gciLogServer:'socket EAGAIN fd ', fileDescriptor asString .
         System _printSocketTrace .
         SocketError signal:'EAGAIN from socket write after poll said write-ready'.
       ].
     ] ifNil:[
       waitCnt := 0 .
     ].
     self _waitForWriteReady .
   ].
 ].
%

category: 'Private'
method: GsSignalingSocket
_rawReadWillNotBlockWithin: timeoutMs

  ^ self readWillNotBlockWithin: timeoutMs
%

! Class extensions for 'GsSingleRefPathFinder'

!		Class methods for 'GsSingleRefPathFinder'

category: 'Defaults'
classmethod: GsSingleRefPathFinder
defaultLimitSetDescendantsMaxLevels

"Default number of levels that may be traversed to seed the limit set."
 ^SmallInteger maximumValue "effectively infinite"
%

category: 'Defaults'
classmethod: GsSingleRefPathFinder
defaultLimitSetDescendantsMaxObjs

"Maximum size of a limit set descendant generation in number of objects."
^ 1000000
%

category: 'Defaults'
classmethod: GsSingleRefPathFinder
defaultLockWaitTime

"Default number of seconds to wait for the garbage collection lock expressed in seconds."
^ 120
%

category: 'Defaults'
classmethod: GsSingleRefPathFinder
defaultMaxThreads

"Default number of threads to use to scan the repository."
^ SystemRepository _aggressiveMaxThreadCount
%

category: 'Defaults'
classmethod: GsSingleRefPathFinder
defaultPageBufferSize

"Default number of 16 KB disk pages for each thread to buffer.  Must be a power of 2."
^ 8
%

category: 'Defaults'
classmethod: GsSingleRefPathFinder
defaultPercentCpuLimit

"Default maximum percentage of total CPU that the all threads in the scan may consume."
^ 95 "percent of total CPU"
%

category: 'Defaults'
classmethod: GsSingleRefPathFinder
defaultPrintToLog

"Default boolean value for printing output to stdout of the process."
^ true
%

category: 'Instance Creation'
classmethod: GsSingleRefPathFinder
newForSearchObjects: anArray
"Creates a new instance with default settings."
^self
  newForSearchObjects: anArray
  withMaxThreads: nil
  waitForLock: nil
  pageBufSize: nil
  percentCpuLimit: nil
  maxLimitSetDescendantObjs: nil
  maxLimitSetDescendantLevels: nil
  printToLog: nil
%

category: 'Instance Creation'
classmethod: GsSingleRefPathFinder
newForSearchObjects: anArray withMaxThreads: threads waitForLock: seconds pageBufSize: pages percentCpuLimit: percent
maxLimitSetDescendantObjs: maxChildObjs maxLimitSetDescendantLevels: maxChildLevels printToLog: logBoolean

"Creates and configures a new instance of the receiver.  The first argument must be an array of committed disk objects.
 The logBoolean argument must be a Boolean or nil.   All other arguments must be a SmallInteger or nil.
 A nil argument indicates the default value for the argument is to be used.

 The pages argument must be nil or a SmallInteger which is a power of 2."

| result |
result := self new.
result
  maxThreads: (threads ifNil:[self defaultMaxThreads] ifNotNil:[threads]) ;
  lockWaitTime: (seconds ifNil:[self defaultLockWaitTime] ifNotNil:[seconds]) ;
  pageBufferSize: (pages ifNil:[self defaultPageBufferSize] ifNotNil:[pages]) ;
  percentCpuLimit: (percent ifNil:[self defaultPercentCpuLimit] ifNotNil:[percent]) ;
  maxLimitSetDescendantObjs: (maxChildObjs ifNil:[self defaultLimitSetDescendantsMaxObjs] ifNotNil:[maxChildObjs]) ;
  maxLimitSetDescendantLevels: (maxChildLevels ifNil:[self defaultLimitSetDescendantsMaxLevels] ifNotNil:[maxChildLevels]) ;
  printToLog: (logBoolean ifNil:[self defaultPrintToLog] ifNotNil:[logBoolean]) ;
  initializeForSearchObjects: anArray.
^ result
%

category: 'Logging'
classmethod: GsSingleRefPathFinder
printMessageToLog: aString

"Print a message to stdout and include a timestamp."
^ self printMessageToLog: aString includeTime: true
%

category: 'Logging'
classmethod: GsSingleRefPathFinder
printMessageToLog: aString includeTime: aBoolean

aBoolean ifTrue:[ | msg |
  msg := String withAll: '['.
  msg
    addAll: DateTime now asString;
    addAll: '] ';
    addAll: aString;
    add: Character lf.
    GsFile gciLogServer: msg]
ifFalse: [GsFile gciLogServer: aString].
^ self
%

category: 'Primitive'
classmethod: GsSingleRefPathFinder
refPathCleanup

"Logs out the slave sessions and cleans up the saved state for the
 multi threaded reference path scans."

System _zeroArgPrim: 179.
%

category: 'Primitive'
classmethod: GsSingleRefPathFinder
scanForParents: anArrayOfBitmaps

"Scans the data pages found in the refPathSetup method to find the parent oops
 for each group of child oops.

 anArrayOfBitmaps is an array of non-empty GsBitmap instances containing child
 oops to scan for. The argument array and its GsBitmap elements are not
 modified by this method.

 This method may be called multiple times.  The size of the anArrayOfBitmaps
 argument may be different each time.  It is an error if any of the GsBitmap
 elements are empty.

 Returns an Array of GsBitmap instances containing the parent oops of the
 objects contained in the argument bitmaps. The result array will be the
 same size and in the same order as the argument array."

<primitive: 597>
^ self _primitiveFailed: #scanForParents: args: { anArrayOfBitmaps }
%

category: 'Primitive'
classmethod: GsSingleRefPathFinder
_refPathDoScanForParents: searchObjs excludeParentRefs: excludeOops onlySearchObjs: aBoolean

"Scans the data pages found in the refPathSetup method to find the parent oops.
 If onlySearchObjs is true, then data for only the search objects is collected,
 otherwise data for all of the objects in the repository is collected and any
 object may be queried and the oop of a single parent and whether it has
 additional parents is returned. For each of the objects in the searchObjs this
 method saves all of the parent references. If a parent object is in the
 excludeOops, it is not included in the parent set.

 The searchObjs and excludeOops arguments may be passed an Array or a GsBitmap.

 Elements of both the searchObjs and the excludeOops must be either committed
 non-special objects, or  SmallIntegers;  SmallIntegers must be objectIds of
 committed non-special objects and can be resolved as
 (Object _objectForOop: anObjectId).

 When the scan is complete the parentsOf or findReferencePath methods can be
 used to get the information captured for any object. "

<primitive: 894>
^ self _primitiveFailed:
    #_refPathDoScanForParents:excludeParentRefs:onlySearchObjs:
    args: {  searchObjs . excludeOops . aBoolean }
%

category: 'Primitive'
classmethod: GsSingleRefPathFinder
_refPathSetupScanWithMaxThreads: maxThreads waitForLock: lockWaitTime
    pageBufSize: aBufSize percentCpuLimit: percentCpu

"Sets up the current session for performing multi threaded scans of the
 repository for finding reference paths to objects.  Performs an abort
 and leaves the session in a transaction.

 See _scanPomWithMaxThreads for definitions of maxThreads, waitTimeSeconds,
 aBufSize, cpuPersent.
 This method aborts the current transaction; if an abort would cause unsaved
 changes to be lost it signals an error, #rtErrAbortWouldLoseData.

 A GciHardBreak during this method will terminate the session."

<primitive: 527>
| maxInt |
maxInt := SmallInteger maximum32bitInteger .
maxThreads _validateClass: SmallInteger ; _validateMin: 1 max: maxInt .
lockWaitTime _validateClass: SmallInteger ; _validateMin: -1 max: maxInt .
aBufSize _validateClass: SmallInteger;  _validateIsPowerOf2 .
self _validatePercentage: percentCpu .
^ self _primitiveFailed:
    #_refPathSetupScanWithMaxThreads:waitForLock:pageBufSize:percentCpuLimit:
    args: {  maxThreads . lockWaitTime . aBufSize . percentCpu }
%

!		Instance methods for 'GsSingleRefPathFinder'

category: 'Adding'
method: GsSingleRefPathFinder
addSearchObject: anObject

"Adds anObject to list of objects for which reference paths are to be found."

|newSearch|
newSearch := GsSingleRefPathFinderForObject newForSearchObject: anObject
                                            refPathFinder: self .
allSearches add: newSearch .
numSearchesActive := numSearchesActive + 1 .
^ self
%

category: 'Searching'
method: GsSingleRefPathFinder
allActiveSearches
"Answer an array of GsSingleRefPathFinderForObject that are not finished."
^ allSearches select:[:e| e completed not]
%

category: 'Accessing'
method: GsSingleRefPathFinder
allSearches
^allSearches
%

category: 'Updating'
method: GsSingleRefPathFinder
allSearches: newValue
allSearches := newValue
%

category: 'Initialization'
method: GsSingleRefPathFinder
basicInit

allSearches := Array new .
numSearchesActive := 0 .
numPassesDone := 0 .
otScanDone := false .
^ self
%

category: 'Limit Set'
method: GsSingleRefPathFinder
buildLimitSet

"Collect descendants of the default limit set and add them to the limitObjects
 array.  Stop collecting descendants when the size of a generation exceeds
 maxLimitSetDescendantObjs or the depth of the traversal exceeds
 maxLimitSetDescendantLevels."

self printTimedOpStartMessageToLog: 'Starting build of limit set and descendants'.
limitObjects := Array with:
  (GsBitmap withAll: SystemRepository buildLimitSetForRefPathScan) .
self buildLimitSetDescendants .
self printTimedOpEndMessageToLog: 'Finished build of limit set and descendants'.
self logLimitSetSizes .
^ self
%

category: 'Limit Set'
method: GsSingleRefPathFinder
buildLimitSetDescendants

"Collect descendants of the default limit set and add them to the limitObjects
 array.  Stop collecting descendants when the size of a generation exceeds
 maxLimitSetDescendantObjs or the depth of the traversal exceeds
 maxLimitSetDescendantLevels."

| parents alreadySeen done levels |
(maxLimitSetDescendantObjs <= 0 or:[maxLimitSetDescendantLevels <= 0])
  ifTrue:[ ^ self ]. "Limit set descendants is disabled"

parents := self defaultLimitSet .
alreadySeen := parents copy.
done := false.
levels := 0.
[done] whileFalse:[ |children|
  levels := levels + 1.
  children := parents primReferencedObjects .
  children removeAll: alreadySeen.
  children isEmpty
    ifTrue:[ done := true]
    ifFalse:[
      limitObjects add: children.
      alreadySeen addAll: children.
      done := (children size > maxLimitSetDescendantObjs) or:[ levels >= maxLimitSetDescendantLevels ].
      parents := children.
    ].
].
alreadySeen removeAll.
^ self
%

category: 'Results'
method: GsSingleRefPathFinder
buildResultObjects
"Returns an Array of GsSingleRefPathResult objects"

^ allSearches collect:[:e| e buildResultObject]
%

category: 'Scanning'
method: GsSingleRefPathFinder
completedOneSearch
numSearchesActive := numSearchesActive - 1.
%

category: 'Limit Set'
method: GsSingleRefPathFinder
defaultLimitSet

"Answer the limit set returned by SystemRepository buildLimitSetForRefPathScan,
 which is the first element in the limitObjects array."

^ limitObjects first
%

category: 'Limit Set'
method: GsSingleRefPathFinder
handleLimitSetDescendantsWithSearchObject: anObj

| aSearch|
aSearch := self searchForObject: anObj.
aSearch handleLimitSetDescendantsWithSearchObject.
^ self
%

category: 'Limit Set'
method: GsSingleRefPathFinder
handleSearchObjectsInLimitSetDescendants
| intersection |

intersection := self searchObjectsInLimitSetDescendants.
intersection do:[:eachObj|
  self handleLimitSetDescendantsWithSearchObject: eachObj ].
intersection removeAll .
^ self
%

category: 'Initialization'
method: GsSingleRefPathFinder
initializeForSearchObjects: anArray

self basicInit .
self validateSearchObjects: anArray .
searchObjects := anArray asGsBitmap .
anArray do:[:e| self addSearchObject: e] .
^ self
%

category: 'Accessing'
method: GsSingleRefPathFinder
limitObjects
^limitObjects
%

category: 'Updating'
method: GsSingleRefPathFinder
limitObjects: newValue
limitObjects := newValue
%

category: 'Limit Set'
method: GsSingleRefPathFinder
limitSetDescendants
"Answer a GsBitmap containing all descendants of the base limit set, but not
 the base limit set itself."

| result |
result := GsBitmap new.
"First element is the base limit set.  Skip that one."
2 to: limitObjects size do: [:n | result addAll: (limitObjects at: n)].
^result
%

category: 'Accessing'
method: GsSingleRefPathFinder
lockWaitTime
^lockWaitTime
%

category: 'Updating'
method: GsSingleRefPathFinder
lockWaitTime: newValue
lockWaitTime := newValue
%

category: 'Logging'
method: GsSingleRefPathFinder
logEndOfScan

printToLog
ifTrue:
[| msg |
msg := String withAll: 'Finished scan '.
msg addAll: numPassesDone asString.
self printTimedOpEndMessageToLog: msg]
%

category: 'Logging'
method: GsSingleRefPathFinder
logLimitSetSizes

printToLog
  ifTrue:[ | ws |
  ws := AppendStream on: String new.
  ws
    nextPutAll: 'Sizes of limit set descendants by generation:';
    lf.
  1 to: limitObjects size do:[:n |
    ws tab;
      nextPutAll: n asString;
      space: 2;
      nextPutAll: (limitObjects at: n) size asString;
      lf].
  self class printMessageToLog: ws contents includeTime: false].
^self
%

category: 'Logging'
method: GsSingleRefPathFinder
logStartOfScan

printToLog
ifTrue:
[| msg numCompleted numSearchObjs |
numSearchObjs := searchObjects size .
numCompleted := numSearchObjs - numSearchesActive .
msg := String withAll: 'Starting scan '.
msg addAll: numPassesDone asString ;
    addAll: '. Search object summary: ';
    addAll: numSearchObjs asString ;
    addAll: ' total,  ' ;
    addAll: numSearchesActive asString ;
    addAll: ' active,  ';
    addAll: numCompleted asString ;
    addAll: ' completed'.
self printTimedOpStartMessageToLog: msg]
%

category: 'Logging'
method: GsSingleRefPathFinder
logStartup

printToLog
  ifTrue:[
    self printMessageToLog:
      'Starting find one reference path scan for the following objects:';
    printSearchObjectsToLog]
%

category: 'Accessing'
method: GsSingleRefPathFinder
maxLimitSetDescendantLevels
^ maxLimitSetDescendantLevels
%

category: 'Updating'
method: GsSingleRefPathFinder
maxLimitSetDescendantLevels: newValue
maxLimitSetDescendantLevels := newValue
%

category: 'Accessing'
method: GsSingleRefPathFinder
maxLimitSetDescendantObjs
^ maxLimitSetDescendantObjs
%

category: 'Updating'
method: GsSingleRefPathFinder
maxLimitSetDescendantObjs: newValue
maxLimitSetDescendantObjs := newValue
%

category: 'Accessing'
method: GsSingleRefPathFinder
maxThreads
^maxThreads
%

category: 'Updating'
method: GsSingleRefPathFinder
maxThreads: newValue
maxThreads := newValue
%

category: 'Accessing'
method: GsSingleRefPathFinder
numPassesDone
^numPassesDone
%

category: 'Updating'
method: GsSingleRefPathFinder
numPassesDone: newValue
numPassesDone := newValue
%

category: 'Accessing'
method: GsSingleRefPathFinder
numSearchesActive
^numSearchesActive
%

category: 'Updating'
method: GsSingleRefPathFinder
numSearchesActive: newValue
numSearchesActive := newValue
%

category: 'Accessing'
method: GsSingleRefPathFinder
opStartTime
^opStartTime
%

category: 'Updating'
method: GsSingleRefPathFinder
opStartTime: newValue
opStartTime := newValue
%

category: 'Accessing'
method: GsSingleRefPathFinder
otScanDone
^otScanDone
%

category: 'Updating'
method: GsSingleRefPathFinder
otScanDone: newValue
otScanDone := newValue
%

category: 'Accessing'
method: GsSingleRefPathFinder
pageBufferSize
^pageBufferSize
%

category: 'Updating'
method: GsSingleRefPathFinder
pageBufferSize: newValue

"Value must be a power of 2"
newValue _validateIsPowerOf2 .
pageBufferSize := newValue
%

category: 'Accessing'
method: GsSingleRefPathFinder
percentCpuLimit
^percentCpuLimit
%

category: 'Updating'
method: GsSingleRefPathFinder
percentCpuLimit: newValue
percentCpuLimit := newValue
%

category: 'Logging'
method: GsSingleRefPathFinder
printMessageToLog: aString

printToLog ifTrue: [self class printMessageToLog: aString].
^ self
%

category: 'Logging'
method: GsSingleRefPathFinder
printSearchObjectsToLog

printToLog ifTrue:[| oopList classNameList msg |
  msg := String new.
  oopList := allSearches collect: [:e | e searchOop asOop asString].
  classNameList := allSearches
  collect: [:e | e searchOop class name asString].
  1 to: oopList size do:[:n |
    msg
    addAll: '   ';
    addAll: n asString;
    addAll: '  ';
    addAll: (oopList at: n);
    addAll: ' (';
    addAll: (classNameList at: n);
    addAll: ')';
    add: Character lf].
  GsFile gciLogServer: msg]
%

category: 'Logging'
method: GsSingleRefPathFinder
printTimedOpEndMessageToLog: aString


printToLog ifTrue: [ |seconds msg|
  seconds := (System timeGmt2005 - opStartTime) asString .
  msg := String withAll: aString .
  msg addAll: ' in '; addAll: seconds ; addAll: ' seconds'.
  self class printMessageToLog: msg].
^ self
%

category: 'Logging'
method: GsSingleRefPathFinder
printTimedOpStartMessageToLog: aString

printToLog ifTrue: [
  opStartTime := System timeGmt2005 .
  self class printMessageToLog: aString].
^ self
%

category: 'Logging'
method: GsSingleRefPathFinder
printTimestampToLog

printToLog ifTrue:[ | msg |
  msg := DateTime now asString.
  msg add: Character lf.
  GsFile gciLogServer: msg]
%

category: 'Accessing'
method: GsSingleRefPathFinder
printToLog
^printToLog
%

category: 'Updating'
method: GsSingleRefPathFinder
printToLog: newValue
printToLog := newValue
%

category: 'Scanning'
method: GsSingleRefPathFinder
runOneScan

| searches childrenBitmaps parentBitmaps |
self scanObjectTable .
searches := self allActiveSearches.
searches do:[:e| e updateSearchOopsUnion].
childrenBitmaps := searches collect:[:e| e childrenToFind ].
numPassesDone := numPassesDone + 1.
self logStartOfScan.
parentBitmaps := GsSingleRefPathFinder scanForParents: childrenBitmaps.
self logEndOfScan.
1 to: searches size do:[:n|
  (searches at: n) processResultsOfScan: (parentBitmaps at: n)
].
%

category: 'Scanning'
method: GsSingleRefPathFinder
runScan

self logStartup.
self buildLimitSet .
self validateSearchObjectsAreNotLimitObjects .
self handleSearchObjectsInLimitSetDescendants .
scanStartTime := System timeGmt2005 .
[numSearchesActive > 0] whileTrue:[ self runOneScan].
GsSingleRefPathFinder refPathCleanup
%

category: 'Results'
method: GsSingleRefPathFinder
scanAndReport
"Run the scan, build the results, and collect the path strings
 for each result.  Return a string."

| str |
str := String new.
self runScan buildResultObjects
   do:[:e| str add: e resultString].
^str
%

category: 'Scanning'
method: GsSingleRefPathFinder
scanObjectTable

otScanDone ifFalse:[
  self printTimedOpStartMessageToLog: 'Starting object table scan'.
  GsSingleRefPathFinder
    _refPathSetupScanWithMaxThreads: maxThreads
    waitForLock: lockWaitTime
    pageBufSize: pageBufferSize
    percentCpuLimit: percentCpuLimit.
  self printTimedOpEndMessageToLog: 'Finished object table scan'.
  otScanDone := true].
^self
%

category: 'Accessing'
method: GsSingleRefPathFinder
scanStartTime
^scanStartTime
%

category: 'Updating'
method: GsSingleRefPathFinder
scanStartTime: newValue
scanStartTime := newValue
%

category: 'Searching'
method: GsSingleRefPathFinder
searchForObject: anObject
"Find the GsSingleRefPathFinderForObject instance for anObject."
^ allSearches detect:[:e| e searchOop == anObject ]
%

category: 'Accessing'
method: GsSingleRefPathFinder
searchObjects
^searchObjects
%

category: 'Updating'
method: GsSingleRefPathFinder
searchObjects: newValue
searchObjects := newValue
%

category: 'Limit Set'
method: GsSingleRefPathFinder
searchObjectsInLimitSetDescendants
"Answer a GsBitmap containing any search objects that are present in the
 descendants of the limit set."

^ self limitSetDescendants * searchObjects
%

category: 'Validation'
method: GsSingleRefPathFinder
validateSearchObjects: anArray

"Check input array to ensure all objects are committed disk objects.
 Special objects and uncommitted objects are not allowed."

1 to: anArray size do: [:i| | obj |
  obj := anArray at: i .
  (obj isSpecial or: [ obj isCommitted not ]) ifTrue:
    [ obj _error: #rtErrSpecialOrNotCommitted ]
].
^ self
%

category: 'Validation'
method: GsSingleRefPathFinder
validateSearchObjectsAreNotLimitObjects
"Checks to ensure that none of the search objects appear in the default limit
 set.  Raises an exception if any objects satisfy that condition."

| searchOopsInLimitSet|
searchOopsInLimitSet := self defaultLimitSet * searchObjects .
searchOopsInLimitSet isEmpty
  ifFalse:[
    ArgumentError signal: 'One or more search objects also appears in the limit set'].
^ self
%

! Class extensions for 'GsSingleRefPathFinderForObject'

!		Class methods for 'GsSingleRefPathFinderForObject'

category: 'Instance Creation'
classmethod: GsSingleRefPathFinderForObject
newForSearchObject: anObject refPathFinder: aFinder

|result|
result := self new.
result initializeForSearchObject: anObject refPathFinder: aFinder.
^ result
%

!		Instance methods for 'GsSingleRefPathFinderForObject'

category: 'Results'
method: GsSingleRefPathFinderForObject
buildPathToDefaultLimitSet

^ self buildPathToDefaultLimitSetStartingAt: refPathFinder limitObjects size
%

category: 'Results'
method: GsSingleRefPathFinderForObject
buildPathToDefaultLimitSetStartingAt: index

"Build the reference path going from an object referenced by a descendant of
 the default limit set up to an object in the default limit set."

| result childObj limitObjsArray |
result := Array new.
childObj := limitOopsFound peek.
"Caller will add the first object in limitOopsFound to the path.  Do not do it here."
limitObjsArray := refPathFinder limitObjects.
(index - 1) downTo: 1 do:[:n| | parent bm |
  bm := limitObjsArray at: n.
  parent := bm primFirstObjectThatReferences: childObj.
  parent ifNil:[
    "This should never happen"
    self halt:
     'Logic error: no references to child object found in set of limit object descendants'].
  result add: parent.
  childObj := parent.
].
^ result reverse
%

category: 'Results'
method: GsSingleRefPathFinderForObject
buildReferencePath

| result nextObject index done|

(isDead or:[ completed not]) ifTrue:[ ^ Array new ].

result := self buildPathToDefaultLimitSet .
index := parentBitmaps size.
nextObject := limitOopsFound peek.
done := nextObject == nil.
[done] whileFalse:[ |nextObjectChildren childrenInPath intersection|
  result add: nextObject.
  nextObjectChildren := (GsBitmap with: nextObject) primReferencedObjects.
  childrenInPath := parentBitmaps at: index.
  intersection := nextObjectChildren * childrenInPath.
  intersection isEmpty ifTrue:[ self halt: 'unexpected empty intersection'].
  done := intersection includes: searchOop.
  nextObject := intersection peek.
  index := index - 1.
].
result add: searchOop.
^ result
%

category: 'Results'
method: GsSingleRefPathFinderForObject
buildResultObject

resultObject == nil
  ifTrue:[
    resultObject := GsSingleRefPathResult
         newForSearchObject: searchOop
         isDead: isDead
         path: self buildReferencePath].
^ resultObject
%

category: 'Logging'
method: GsSingleRefPathFinderForObject
buildSummaryHeader

| msg |
msg := String withAll: '   Summary for search oop '.
msg
addAll: searchOop asOop asString;
add: Character lf.
^msg
%

category: 'Scanning'
method: GsSingleRefPathFinderForObject
childrenToFind

"Answer a GsBitmap of the children to search for in the next scan, or nil if
 the scan is finished"

^ completed ifTrue:[nil] ifFalse:[ parentBitmaps last].
%

category: 'Accessing'
method: GsSingleRefPathFinderForObject
completed
^completed
%

category: 'Updating'
method: GsSingleRefPathFinderForObject
completed: newValue
completed := newValue
%

category: 'Scanning'
method: GsSingleRefPathFinderForObject
handleLimitSetDescendantsWithSearchObject

| limitObjectsArray |
limitObjectsArray := refPathFinder limitObjects.
2 to: limitObjectsArray size do:[:n |
  ((limitObjectsArray at: n) includes: searchOop) ifTrue:[ | path |
    limitOopsFound := GsBitmap with: searchOop.
    path := self buildPathToDefaultLimitSetStartingAt: n.
    path add: searchOop.
    resultObject := GsSingleRefPathResult
       newForSearchObject: searchOop
       isDead: false
       path: path.
    self setReferencePathFound.
    ^self]
].
^self
%

category: 'Initialization'
method: GsSingleRefPathFinderForObject
initializeForSearchObject: anObject refPathFinder: finderObj

completed := false.
isDead := false.
refPathFinder := finderObj.
limitOopsFound := nil.
searchOopsUnion := GsBitmap new.
searchOop := anObject.
parentBitmaps := Array with: (GsBitmap with: anObject).
^ self
%

category: 'Accessing'
method: GsSingleRefPathFinderForObject
isDead
^isDead
%

category: 'Updating'
method: GsSingleRefPathFinderForObject
isDead: newValue
isDead := newValue
%

category: 'Accessing'
method: GsSingleRefPathFinderForObject
limitObjects

^ refPathFinder limitObjects last.
%

category: 'Accessing'
method: GsSingleRefPathFinderForObject
limitOopsFound
^limitOopsFound
%

category: 'Updating'
method: GsSingleRefPathFinderForObject
limitOopsFound: newValue
limitOopsFound := newValue
%

category: 'Logging'
method: GsSingleRefPathFinderForObject
logReferencePath

refPathFinder printToLog
   ifTrue:[ self buildResultObject logReferencePath ]

%

category: 'Accessing'
method: GsSingleRefPathFinderForObject
parentBitmaps
^parentBitmaps
%

category: 'Updating'
method: GsSingleRefPathFinderForObject
parentBitmaps: newValue
parentBitmaps := newValue
%

category: 'Logging'
method: GsSingleRefPathFinderForObject
printScanCompleted

refPathFinder printToLog ifTrue:[| msg |
  msg := self buildSummaryHeader.
  msg addAll: '      scan completed'.
  isDead ifTrue: [msg addAll: ' (object is dead)'].
  msg add: Character lf.
  GsFile gciLogServer: msg]
%

category: 'Logging'
method: GsSingleRefPathFinderForObject
printScanSummary: parentOops

refPathFinder printToLog ifTrue:[
  | msg numSeen numLimit scanCompleted oopIsDead parentsCopy |
  msg := self buildSummaryHeader.
  numLimit := parentOops intersectSize: self limitObjects.
  numSeen := parentOops intersectSize: searchOopsUnion.
  msg
    addAll: '      ';
    addAll: self childrenToFind size asString;
    addAll: ' child oops are referenced by ';
    addAll: parentOops size asString;
    addAll: ' parent oops (';
    addAll: numSeen asString;
    addAll: ' were already seen and ';
    addAll: numLimit asString;
    addAll: ' are limit objects)';
    add: Character lf.
  parentsCopy := parentOops copy.
  parentsCopy removeAll: self limitObjects.
  parentsCopy removeAll: searchOopsUnion.
  scanCompleted := parentsCopy isEmpty or:[numLimit > 0].
  parentsCopy removeAll .
  scanCompleted
    ifTrue:[
      oopIsDead := numLimit == 0.
      msg addAll: '      *** Scan completed ***'.
      oopIsDead ifTrue: [msg addAll: ' (object is dead)'].
      msg addAll: ' Total time is ';
      addAll: self totalTime asString;
      addAll: ' seconds' ;
      add: Character lf].
  GsFile gciLogServer: msg]

%

category: 'Scanning'
method: GsSingleRefPathFinderForObject
processResultsOfScan: parentOopsBm

|limitOops|
self printScanSummary: parentOopsBm .
parentOopsBm removeAll: searchOopsUnion. "remove ones we've already seen"
parentOopsBm isEmpty
  ifTrue:[ ^ self setObjectIsDead ].

limitOops := parentOopsBm * self limitObjects .
limitOops isEmpty
ifTrue:[ parentBitmaps add: parentOopsBm]
ifFalse:[
  limitOopsFound := limitOops.
  self setReferencePathFound .
].
^ self
%

category: 'Accessing'
method: GsSingleRefPathFinderForObject
refPathFinder
^refPathFinder
%

category: 'Updating'
method: GsSingleRefPathFinderForObject
refPathFinder: newValue
refPathFinder := newValue
%

category: 'Accessing'
method: GsSingleRefPathFinderForObject
resultObject
^resultObject
%

category: 'Updating'
method: GsSingleRefPathFinderForObject
resultObject: newValue
resultObject := newValue
%

category: 'Accessing'
method: GsSingleRefPathFinderForObject
searchOop
^searchOop
%

category: 'Updating'
method: GsSingleRefPathFinderForObject
searchOop: newValue
searchOop := newValue
%

category: 'Accessing'
method: GsSingleRefPathFinderForObject
searchOopsUnion
^searchOopsUnion
%

category: 'Updating'
method: GsSingleRefPathFinderForObject
searchOopsUnion: newValue
searchOopsUnion := newValue
%

category: 'Updating'
method: GsSingleRefPathFinderForObject
setObjectIsDead

completed := true. "no unique parents found.  object is dead"
isDead := true.
refPathFinder completedOneSearch.
^ self
%

category: 'Updating'
method: GsSingleRefPathFinderForObject
setReferencePathFound

completed := true.
refPathFinder completedOneSearch.
self logReferencePath.
^ self
%

category: 'Logging'
method: GsSingleRefPathFinderForObject
totalTime

^System timeGmt2005 - refPathFinder scanStartTime
%

category: 'Scanning'
method: GsSingleRefPathFinderForObject
updateSearchOopsUnion

"Add parent objects found in the previous scan to searchOopsUnion"
completed ifFalse:[ searchOopsUnion addAll: parentBitmaps last].
%

! Class extensions for 'GsSingleRefPathResult'

!		Class methods for 'GsSingleRefPathResult'

category: 'Instance Creation'
classmethod: GsSingleRefPathResult
newForSearchObject: anObj isDead: aBoolean path: anArray

"Creates a new GsSingleRefPathResult object for the given object. The
complete reference path is contained in anArray.  The first element of
anArray must be a member of the limit set and the last element must
be the search object.

Raises an error if the reference path is not valid for the given search oop."

|result|
result := self new.
result searchOop: anObj.
result isDead: aBoolean.
result addAll: anArray.
result validate.
^result
%

!		Instance methods for 'GsSingleRefPathResult'

category: 'Accessing'
method: GsSingleRefPathResult
isDead
^isDead
%

category: 'Updating'
method: GsSingleRefPathResult
isDead: newValue
isDead := newValue
%

category: 'Printing'
method: GsSingleRefPathResult
logReferencePath

"Writes the complete reference path to stdout.  For an RPC gem, the path is
written to the gem log file.  For linked topaz session, the path is written
to the screen."

GsSingleRefPathFinder printMessageToLog: (self resultStringWithTabs: 1)
                      includeTime: false .
^ self
%

category: 'Printing'
method: GsSingleRefPathResult
printHeaderOn: ws

^self printHeaderOn: ws tabs: 0
%

category: 'Printing'
method: GsSingleRefPathResult
printHeaderOn: ws tabs: anInt

	anInt timesRepeat: [ws tab].
	ws
		nextPutAll: 'Reference path for search oop ';
		nextPutAll: searchOop asOop asString;
		space;
		nextPut: $(;
		nextPutAll: searchOop class name asString;
		nextPut: $);
		lf.
	^ws
%

category: 'Printing'
method: GsSingleRefPathResult
printReferencePathOn: ws

^ self printReferencePathOn: ws tabs: 0
%

category: 'Printing'
method: GsSingleRefPathResult
printReferencePathOn: ws tabs: anInt

	isDead
		ifTrue:
			[anInt + 1 timesRepeat: [ws tab].
			ws
				nextPutAll: 'Object is dead.  No reference path found';
				lf]
		ifFalse:
			[1 to: self size
				do:
					[:n |
					| obj |
					obj := self at: n.
					anInt + 1 timesRepeat: [ws tab].
					ws
						nextPutAll: n asString;
						space: 3;
						nextPutAll: obj asOop asString;
						space;
						nextPut: $(;
						nextPutAll: obj class name asString;
						nextPut: $);
						lf]].
	^ws
%

category: 'Printing'
method: GsSingleRefPathResult
printResultsToGsFile: aGsFile

aGsFile nextPutAll: self resultString
%

category: 'Printing'
method: GsSingleRefPathResult
resultString

^self resultStringWithTabs: 0
%

category: 'Printing'
method: GsSingleRefPathResult
resultStringWithTabs: anInt

|ws|
ws := AppendStream on: String new.
self printHeaderOn: ws tabs: anInt ;
printReferencePathOn: ws tabs: anInt.
^ws contents
%

category: 'Accessing'
method: GsSingleRefPathResult
searchOop
^searchOop
%

category: 'Updating'
method: GsSingleRefPathResult
searchOop: newValue
searchOop := newValue
%

category: 'Validating'
method: GsSingleRefPathResult
validate

^ self validateWithLimitSet: nil
%

category: 'Validating'
method: GsSingleRefPathResult
validateWithLimitSet: aLimitSet
"Validates the receiver contains a complete and correct reference path for
searchOop using the given limit set.  If aLimitSet is nil, then the default
limit set is used.

Raises an error if a problem is found, otherwise returns the receiver."

| myLimitSet |
isDead ifTrue: [^self].
myLimitSet := aLimitSet
  ifNil: [SystemRepository buildLimitSetForRefPathScan]
  ifNotNil: [aLimitSet].
self size == 0 ifTrue: [self halt: 'Receiver is empty'].
(myLimitSet includes: self first)
  ifFalse: [self halt: 'First object is not a limit object'].
self last == searchOop
  ifFalse: [self halt: 'Last element of reference path is not the search object'].
2 to: self size do:[:n | | child parent |
  parent := self at: n - 1.
  child := self at: n.
  (((GsBitmap with: parent) primReferencedObjects) includes: child)
    ifFalse: [self halt: 'parent object does not reference child object']].
^self
%

! Class extensions for 'GsStreamableConjunctiveClauseChecker'

!		Class methods for 'GsStreamableConjunctiveClauseChecker'

category: 'instance creation'
classmethod: GsStreamableConjunctiveClauseChecker
check: aFormula on: anNsc
  ^ self new
    formula: aFormula;
    nsc: anNsc;
    queryOptions: GsQueryOptions default;
    check
%

!		Instance methods for 'GsStreamableConjunctiveClauseChecker'

category: 'visiting'
method: GsStreamableConjunctiveClauseChecker
acceptPredicate: aPredicate
  "streamable predicate:
  1. path-constant predicate (i.e., not path-path predicate)
  2. RangeEqualityIndex evaluator ... (not really valid for GsQuery, but could defer
     readstream on PathEvaluator if too much implementation involved)
  3. use range or equality operation for legacy indexes (#== or #~~ or #~= not allowed)
  4. use range, equality or identity operations for btree plus indexes (#~~ or #~= not allowed)
"

  aPredicate isPathPath
    ifTrue: [
      ^ GsMalformedQueryExpressionError
        queryIsNotStreamable:
          'Query with path-path predicate: ' , aPredicate printString printString
            , ' is not streamable.'
        senderLocationID: #'acceptPredicate:' ].
  aPredicate isConstantConstant
    ifTrue: [
      ^ GsMalformedQueryExpressionError
        queryIsNotStreamable:
          'Query with constant-constant predicate: ' , aPredicate printString printString
            , ' is not streamable.'
        senderLocationID: #'acceptPredicate:' ].
  aPredicate usesPathEvaluator
    ifTrue: [
      ^ GsMalformedQueryExpressionError
        queryIsNotStreamable:
          'Predicate: ' , aPredicate printString printString
            , ' must use an equality index or a  btreePlus identity index.'
        senderLocationID: #'acceptPredicate:' ].
  (aPredicate _evaluatorCanStreamQueries
    and: [
      aPredicate usesIdenticalToOperation
        or: [ aPredicate usesEqualOperation or: [ aPredicate usesComparisonOperation ] ] ])
    ifFalse: [
      ^ GsMalformedQueryExpressionError
        queryIsNotStreamable:
          'Predicate: ' , aPredicate printString printString
            ,
              ' must use an equality (#= #==) or comparison operator (#<= #< #> #>=).'
        senderLocationID: #'acceptPredicate:' ].
  super acceptPredicate: aPredicate
%

category: 'checking'
method: GsStreamableConjunctiveClauseChecker
check
  "streamable predicate:
  1. path-constant predicate (i.e., not path-path predicate)
  2. RangeEqualityIndex evaluator ... (not really valid for GsQuery, but could defer
     readstream on PathEvaluator if too much implementation involved)
  3. use range or equality operation for legacy indexes (#== or #~~ or #~= not allowed)
  4. use range, equality or identity operations for btree plus indexes (#~~ or #~= not allowed)
  5. 1 predicate (range predicate allowed)
"

  self visitFormula: self formula.
  self predicates size > 1
    ifTrue: [
      ^ GsMalformedQueryExpressionError
        queryIsNotStreamable:
          'Clause ' , self formula printString printString
            , ' must have a single predicate'
        senderLocationID: #'acceptPredicate:' ]
%

! Class extensions for 'GsStreamableQueryChecker'

!		Class methods for 'GsStreamableQueryChecker'

category: 'instance creation'
classmethod: GsStreamableQueryChecker
check: aFormula on: anNsc
  ^ self new
    formula: aFormula;
    nsc: anNsc;
    queryOptions: GsQueryOptions default;
    check
%

!		Instance methods for 'GsStreamableQueryChecker'

category: 'checking'
method: GsStreamableQueryChecker
check
  self formula isConjunctiveNormalForm
    ifTrue: [ self checkConjunctiveClause: self formula ]
    ifFalse: [
      "If clause is not in conjunctive normal form,  applyDeMorgansLaws has not been applied to transform the formula. Cannot properly determine whether or not a readStream can be used if applyDeMorgansLaws and consolidateRangePredicates options not set."
      (queryOptions applyDeMorgansLaws and: [ queryOptions consolidateRangePredicates ])
        ifTrue: [
          GsMalformedQueryExpressionError
            queryIsNotStreamable:
              'Clause ' , self formula printString printString,
              ' must have a single predicate and this clause cannot be reduced to a single predicate by the query optimizer.'
        senderLocationID: #'check' ]
        ifFalse: [ GsMalformedQueryExpressionError streamableQueryCannotBeAnalyzed: #'check' ] ]
%

category: 'checking'
method: GsStreamableQueryChecker
checkConjunctiveClause: aClause
  GsStreamableConjunctiveClauseChecker check: aClause on: self nsc
%

! Class extensions for 'GsUnaryClause'

!		Class methods for 'GsUnaryClause'

category: 'instance creation'
classmethod: GsUnaryClause
clause: clause operator: anOperator
  ^ self new
    clause: clause;
    operator: anOperator;
    yourself
%

!		Instance methods for 'GsUnaryClause'

category: 'visiting'
method: GsUnaryClause
acceptVisitor: aFormulaVisitor
  super acceptVisitor: aFormulaVisitor.
  aFormulaVisitor acceptUnaryClause: self
%

category: 'optimizing'
method: GsUnaryClause
applyDeMorgansNegationTransform
  "actively apply De Morgan's laws ... operating on copy"

  | transformedClause |
  transformedClause := self operator == #'not'
    ifTrue: [ self clause applyDeMorgansTransform ]
    ifFalse: [ self clause applyDeMorgansNegationTransform ].
  self
    operator: #'null';
    clause: transformedClause.
  ^ self
%

category: 'optimizing'
method: GsUnaryClause
applyDeMorgansTransform
  "do not transform, but propagate the transform ... operating on copy"

  | transformedClause |
  transformedClause := self operator == #'not'
    ifTrue: [ self clause applyDeMorgansNegationTransform ]
    ifFalse: [ self clause applyDeMorgansTransform ].
  self
    operator: #'null';
    clause: transformedClause.
  ^ self
%

category: 'converting'
method: GsUnaryClause
asFormulaWithSelectorParts: selectorParts arguments: arguments
  | selector |
  selector := selectorParts first inputValue asSymbol.
  ^ self perform: selector with: arguments first
%

category: 'transforming'
method: GsUnaryClause
bind: variableName to: value
  | bound |
  bound := self copy.
  bound clause: (bound clause bind: variableName to: value).
  ^ bound immediateInvariant
%

category: 'private'
method: GsUnaryClause
bindEvaluators
  clause := clause bindEvaluatorsFor: nsc collator: self collator.
  super bindEvaluators
%

category: 'accessing'
method: GsUnaryClause
clause
  ^ clause
%

category: 'accessing'
method: GsUnaryClause
clause: newValue
  clause := newValue
%

category: 'querying-private'
method: GsUnaryClause
elementValue: anObject
  "the pathTerms in the query will use anObject as the starting point ... analagous to an object in the nsc that is bound to a query"

  | result |
  result := self clause elementValue: anObject.
  self operator == #'null'
    ifTrue: [ ^ result ].
  ^ result not
%

category: 'querying'
method: GsUnaryClause
executeAndDo: aBlock
  ^ self operator == #'not'
    ifTrue: [ self clause executeNegatedAndDo: aBlock ]
    ifFalse: [ self clause executeAndDo: aBlock ]
%

category: 'querying-private'
method: GsUnaryClause
executeClause
  ^ self operator == #'not'
    ifTrue: [ self clause executeClauseNegated ]
    ifFalse: [ self clause executeClause ]
%

category: 'querying-private'
method: GsUnaryClause
executeClauseNegated
  ^ self operator == #'not'
    ifTrue: [ self clause executeClause ]
    ifFalse: [ self clause executeClauseNegated ]
%

category: 'querying-private'
method: GsUnaryClause
executeNegatedAndDo: aBlock
  ^ self operator == #'not'
    ifTrue: [ self clause executeAndDo: aBlock ]
    ifFalse: [ self clause executeNegatedAndDo: aBlock ]
%

category: 'private'
method: GsUnaryClause
immediateInvariant
  super immediateInvariant.
  clause immediateInvariant
%

category: 'testing'
method: GsUnaryClause
isConjunctiveNormalForm
  ^ self operator == #'null' and: [ self clause isConjunctiveNormalForm ]
%

category: 'testing'
method: GsUnaryClause
isDisjunctiveNormalForm
  ^ self operator == #'null' and: [ self clause isDisjunctiveNormalForm ]
%

category: 'testing'
method: GsUnaryClause
isNegationClause
  ^ self operator == #'not'
%

category: 'operators'
method: GsUnaryClause
normalize
  | normalized |
  normalized := super normalize.
  normalized clause: clause normalize
%

category: 'accessing'
method: GsUnaryClause
operator
  ^operator
%

category: 'accessing'
method: GsUnaryClause
operator: aSymbol
  operator := aSymbol
%

category: 'private'
method: GsUnaryClause
postCopy
  clause := clause copy.
  super postCopy
%

category: 'printing'
method: GsUnaryClause
printOn: aStream
  | parenthesizeClause |
  parenthesizeClause := self clause isCompoundPredicate
    and: [ self operator ~~ #'null' ].
  parenthesizeClause
    ifTrue: [ aStream nextPut: $( ].
  aStream nextPutAll: self clause printString.
  parenthesizeClause
    ifTrue: [ aStream nextPut: $) ].
  self operator ~~ #'null'
    ifTrue: [ aStream nextPutAll: ' ' , self operator asString ]
%

category: 'transforming'
method: GsUnaryClause
unbind
  "remove all bindings"

  | unbound |
  unbound := super unbind.
  unbound clause: unbound clause unbind.
  ^ unbound immediateInvariant
%

category: 'private'
method: GsUnaryClause
_predicateAndEvaluatorsDo: aBlock
  "visit all predicates in receiver and provide access to predicate and list of evaluators
   for the predicate"

  super _predicateAndEvaluatorsDo: aBlock.
  self clause _predicateAndEvaluatorsDo: aBlock
%

category: 'testing'
method: GsUnaryClause
_queryUsesIdentityIndex
  "answer true if the one or more of the clause has an evaluator that is an identity index"

  ^ clause _queryUsesIdentityIndex
%

category: 'testing'
method: GsUnaryClause
_queryUsesIndex
  "answer true if the one or more of the clause has an evaluator that is a range or identity index"

  ^ clause _queryUsesIndex
%

! Class extensions for 'GsUnicodeRangeEqualityIndex'

!		Class methods for 'GsUnicodeRangeEqualityIndex'

category: 'instance creation'
classmethod: GsUnicodeRangeEqualityIndex
newWithCollator: anIcuCollator
  "Create a new instance and initialize its B-tree root."

  | newOne |
  newOne := super new.
  newOne collator: anIcuCollator.
  ^ newOne
%

category: 'instance creation'
classmethod: GsUnicodeRangeEqualityIndex
newWithLastElementClass: aClass
  self shouldNotImplement: #'newWithLastElementClass:'
%

!		Instance methods for 'GsUnicodeRangeEqualityIndex'

category: 'conversion'
method: GsUnicodeRangeEqualityIndex
asIndexSpecification
  ^ (UnicodeIndexSpecification
    path: self pathComponentsString
    collator: self collator)
    options: self options;
    constraintType: self constraintType;
    yourself
%

category: 'Stream Accessing'
method: GsUnicodeRangeEqualityIndex
btreeComparisonQuerySpec
  ^ BtreePlusUnicodeComparisonQuerySpec new
    collator: self collator;
    rangeIndex: self;
    yourself
%

category: 'Stream Accessing'
method: GsUnicodeRangeEqualityIndex
btreeRangeComparisonQuerySpec
  ^ BtreePlusUnicodeRangeComparisonQuerySpec new
    rangeIndex: self;
    collator: self collator;
    yourself
%

category: 'Accessing'
method: GsUnicodeRangeEqualityIndex
collator
  "Returns IcuCollator to be used when comparing Unicode strings"

  ^ collator ifNil: [ collator := IcuCollator default copy immediateInvariant ]
%

category: 'Accessing'
method: GsUnicodeRangeEqualityIndex
collator: anIcuCollator
  "Set the receiver's collator. Use a copy of anIcuCollator to disallow
   changes to strength, etc, that might affect the sort ordering. "

  collator := anIcuCollator copy immediateInvariant
%

category: 'Comparison Operators'
method: GsUnicodeRangeEqualityIndex
comparisonForCompare
  ^ BtreeComparisonForUnicodeCompare new
      collator: self collator;
      yourself
%

category: 'Comparison Operators'
method: GsUnicodeRangeEqualityIndex
comparisonForSort
  "called during creation of receiver, so initialize unset instance variables"

  ^ comparisonForSort
      ifNil: [ comparisonForSort := BtreeComparisonForCompare newForSort: self collator ]
%

category: 'Accessing'
method: GsUnicodeRangeEqualityIndex
constraintType: aSymbolOrNil
  "Set the constraintType, either #unicodeString or nil."

  (aSymbolOrNil ~~ #'unicodeString' and: [ aSymbolOrNil ~~ nil ])
    ifTrue: [
      ArgumentError
        signal:
          self class name asString , ' constraintType must #unicodeString or nil' ].
  constraintType := aSymbolOrNil
%

category: 'Accessing'
method: GsUnicodeRangeEqualityIndex
lastElementClassDescription
  "answer a description of the lastElementClass of the receiver,
   suitable for use in an error message"

  | qualifier |
  qualifier := ''.
  self optimizingComparison ifTrue: [ qualifier := ' [ with optimized comparison ]'. ].
  ^ 'CharacterCollection including Unicode String classes', qualifier
%

category: 'Testing'
method: GsUnicodeRangeEqualityIndex
optimizingComparison
  "Unicode classes can be optimized, just check that option has been specified"

  ^ optimizingComparison ifNil: [ optimizingComparison := self options optimizedComparison ]
%

category: 'Testing'
method: GsUnicodeRangeEqualityIndex
_canCompareWith: aKey
  "Returns whether the receiver can make B-tree comparisons with the given key."

  self constraintType == #unicodeString
    ifTrue: [ ^ super _canCompareWith: aKey ].
  ^ btreeRoot _canCompare: aKey withClass: Unicode7
%

category: 'Index Creation'
method: GsUnicodeRangeEqualityIndex
_preIndexCreationSort
  | btreeRootNode |
  true
    ifTrue: [
      "skip pre-sort for now"
      ^ self btreeRoot ].
  btreeRootNode := (PathSorter
    on: {self}
    directions: #(true)
    collator: self collator)
    lastNodeOffset: 1;
    yourself.
  ^ self btreeRoot
    btreeRootNode: btreeRootNode;
    collator: self collator;
    yourself
%

! Class extensions for 'GsUnsatisfiableQueryNotification'

!		Instance methods for 'GsUnsatisfiableQueryNotification'

category: 'Instance initialization'
method: GsUnsatisfiableQueryNotification
initialize
  gsNumber := ERR_GsUnsatisfiableQueryNotification .
  gsResumable := true .
  gsTrappable := true .
%

! Class extensions for 'GsVariableReferenceAssociation'

!		Instance methods for 'GsVariableReferenceAssociation'

category: 'converting'
method: GsVariableReferenceAssociation
asFormula
  ^ GsConstantConstantPredicate new
    constant1: self;
    operator: #'unary';
    immediateInvariant
%

category: 'accessing'
method: GsVariableReferenceAssociation
bind: variableName to: anObject
  variableName = self key
    ifFalse: [ ^ self ].
  bound := true.
  self value: anObject
%

category: 'accessing'
method: GsVariableReferenceAssociation
bound
  bound ifNil: [ ^ false ].
  ^ bound
%

category: 'testing'
method: GsVariableReferenceAssociation
isBound
  ^ self bound
%

category: 'accessing'
method: GsVariableReferenceAssociation
unbind
  "remove all bindings"

  bound := false.
  self value: nil
%

category: 'accessing'
method: GsVariableReferenceAssociation
value
  self bound
    ifFalse: [ self error: 'Variable: ' , self key printString , ' not bound' ].
  ^ super value
%

! Class extensions for 'IcuCollator'

!		Class methods for 'IcuCollator'

category: 'Accessing'
classmethod: IcuCollator
availableLocales
  "calls Collator::getAvailableLocales() in coll.h.
   Returns an Array of IcuLocales, for which there are predefined
   Collators in the libicudata.so shared library."
  ^ IcuLocale _locales: 6 value: nil
%

category: 'Instance Creation'
classmethod: IcuCollator
default
  "Returns the session's default collator.
   Note that IcuLocale default: will change the default collators,
   and that IcuLocale(C)>>default  is dependent on operating system
   locale if  IcuLocale(C)>>default: has not executed during this
   session."
  ^ (System __sessionStateAt: 20) ifNil:[ | coll |
      coll := self _forLocale: IcuLocale default .
      self default: coll .
      coll
  ].
%

category: 'Instance Creation'
classmethod: IcuCollator
default: aIcuCollator
  aIcuCollator _validateClass: IcuCollator .
  System __sessionStateAt: 20 put: aIcuCollator .
  System __sessionStateAt: 21 put: aIcuCollator _copyCaseInsensitive
%

category: 'Instance Creation'
classmethod: IcuCollator
defaultCaseInsensitive
  "Returns the session's default case-insensitive  collator.
   Note that IcuLocale default: will change the default collators,
   and that IcuLocale(C)>>default  is dependent on operating system
   locale if  IcuLocale(C)>>default: has not executed during this
   session."

  ^ (System __sessionStateAt: 21) ifNil:[ | coll |
      coll := self forLocale: IcuLocale default .
      self default: coll .
      System __sessionStateAt: 21
  ].
%

category: 'Instance Creation'
classmethod: IcuCollator
forLocale: aIcuLocale
  "Return an instance of IcuCollator built from a predefined Collator
   for the specified IcuLocale . If there is no predefined Collator
   in libicudata.so library for the specified Locale, signals an ArgumentError"

(self _availableCollators at: aIcuLocale name otherwise: nil) ifNil:[
  ArgumentError signal:'No predefined IcuCollator for locale ''' , aIcuLocale displayName , ''' '
].
^ self _forLocale: aIcuLocale
%

category: 'Instance Creation'
classmethod: IcuCollator
forLocaleNamed: localeName
  "Return an instance of IcuCollator built from a predefined Collator
   using the IcuLocale for the specified name.
   for the specified IcuLocale . If there is no predefined Collator
   in libicudata.so library for the specified Locale, signals an ArgumentError"

(self _availableCollators at: localeName otherwise: nil ) ifNotNil:[: aLocale|
  ^ self _forLocale: aLocale
] ifNil:[
   ArgumentError signal:'No predefined IcuCollator for locale ''' , localeName, ''' '
]
%

category: 'Accessing'
classmethod: IcuCollator
libraryVersion

"Returns a String such as '58.2'  the version of the libicu library
 that is loaded into this session's virtual machine."

<primitive: 568>
self _primitiveFailed: #libraryVersion
%

category: 'Instance Creation'
classmethod: IcuCollator
new
  "disallowed"
  self shouldNotImplement: #new
%

category: 'Accessing'
classmethod: IcuCollator
strengthNames
  "Returns an array of the allowed args to IcuCollator>>strength:"

^ StrengthNames
%

category: 'Accessing'
classmethod: IcuCollator
strengths
  "Returns an array of the allowed args to IcuCollator>>strength:"

^ StrengthArgs
%

category: 'Private'
classmethod: IcuCollator
_availableCollators
  "Return a dictionary of IcuLocales for which
   there are predefined Collators in the libicudata.so library "
    | key dict |
  key := #IcuCollator_AVAILABLE_COLLATORS .
  dict := SessionTemps current at: key otherwise: nil .
  dict ifNil:[
    dict := StringKeyValueDictionary new .
    IcuCollator availableLocales do:[:loc | dict at: loc name put: loc ].
    SessionTemps current at: key put: dict .
  ].
  ^ dict
%

category: 'Private'
classmethod: IcuCollator
_forLocale: aIcuLocale
  "private.
   calls Collator::createInstance(const Locale &loc, UErrorCode &err)"
  <primitive: 915>
  aIcuLocale _validateClass: IcuLocale .
  self _primitiveFailed:#forLocale: args: { aIcuLocale }
%

!		Instance methods for 'IcuCollator'

category: 'Comparing'
method: IcuCollator
= anIcuCollator

"Returns true if the argument is equal to the receiver, false otherwise."

<primitive: 959>
anIcuCollator _validateClass: IcuCollator .
self _primitiveFailed: #= args: { anIcuCollator }.
%

category: 'Comparing'
method: IcuCollator
alternateHandling
  "Returns true or false.
   See UCOL_ALTERNATE_HANDLING under  enum UColAttribute  at icu-project.org"
  ^ self _getAttribute: 4
%

category: 'Updating'
method: IcuCollator
alternateHandling: aBoolean
  "Sets UCOL_ALTERNATE_HANDLING , aBoolean == true  means set to UCOL_SHIFTED."
  self _setAttribute: 4 value: aBoolean
%

category: 'Comparing'
method: IcuCollator
caseFirst
  "Returns a String, one of  'off', 'upperFirst' , or 'lowerFirst' .
   See UCOL_CASE_FIRST under  enum UColAttribute  at icu-project.org"
  ^ self _getAttribute: 1
%

category: 'Updating'
method: IcuCollator
caseFirst: aValue
  "aValue must be a String, one of  'off', 'upperFirst' , or 'lowerFirst' .
   Sets UCOL_CASE_FIRST ."
  self _setAttribute: 1 value: aValue
%

category: 'Comparing'
method: IcuCollator
caseLevel
  "Returns true (UCOL_ON) or false (UCOL_OFF).
   See UCOL_CASE_LEVEL under  enum UColAttribute  at icu-project.org.

   From i18n/unicode/ucol.h :
      Controls whether an extra case level (positioned before the third
      level) is generated or not. Acceptable values are UCOL_OFF (default),
      when case level is not generated, and UCOL_ON which causes the case
      level to be generated. Contents of the case level are affected by
      the value of UCOL_CASE_FIRST attribute. A simple way to ignore
      accent differences in a string is to set the strength to UCOL_PRIMARY
      and enable case level.

   This is not controlling case-sensitivity.
   "
  ^ self _getAttribute: 2
%

category: 'Updating'
method: IcuCollator
caseLevel: aBoolean
  "Sets UCOL_CASE_LEVEL,  aBoolean == true  means set to UCOL_ON"
  self _setAttribute: 2 value: aBoolean
%

category: 'Comparing'
method: IcuCollator
frenchCollation

"Returns true or false.
 See UCOL_FRENCH_COLLATION under  enum UColAttribute  at icu-project.org"
  ^ self _getAttribute: 6
%

category: 'Updating'
method: IcuCollator
frenchCollation: aBoolean
  "Sets UCOL_FRENCH_COLLATION , aBoolean == true means set to UCOL_ON."
  self _setAttribute: 6 value: aBoolean
%

category: 'Comparing'
method: IcuCollator
hash

^ locale hash
%

category: 'Comparing'
method: IcuCollator
hiraganaQuarternary
  "Returns true or false.
   See UCOL_HIRAGANA_QUATERNARY_MODE under  enum UColAttribute  at icu-project.org"
  ^ self _getAttribute: 7
%

category: 'Accessing'
method: IcuCollator
locale
  ^ locale
%

category: 'Comparing'
method: IcuCollator
normalization
  "Returns true or false.
   See UCOL_NORMALIZATION_MODE  under  enum UColAttribute  at icu-project.org"
  ^ self _getAttribute: 5
%

category: 'Updating'
method: IcuCollator
normalization: aBoolean
  "Sets UCOL_NORMALIZATION_MODE aBoolean == true  means set to UCOL_ON"
  self _setAttribute: 5 value: aBoolean
%

category: 'Comparing'
method: IcuCollator
numericCollation
  "Returns true or false.
   See UCOL_NUMERIC_COLLATION under  enum UColAttribute  at icu-project.org"
  ^ self _getAttribute: 3
%

category: 'Updating'
method: IcuCollator
numericCollation: aBoolean
  "Sets UCOL_NUMERIC_COLLATION , aBoolean == true  means set to UCOL_ON"
  self _setAttribute: 3 value: aBoolean
%

category: 'Accessing'
method: IcuCollator
strength
 "Returns the strength of the receiver
  as a Symbol,  one of #PRIMARY, #SECONDARY, #TERTIARY, #QUATERNARY, #IDENTICAL."

 ^ StrengthVals at: (self _getAttribute: 0) + 1
%

category: 'Updating'
method: IcuCollator
strength: aValue
  "aValue should be one of PRIMARY, SECONDARY, TERTIARY,
     QUATERNARY, IDENTICAL per the class variables of IcuCollator,
     or one of the symbols
     #PRIMARY, #SECONDARY, #TERTIARY, #QUATERNARY, #IDENTICAL"
  | val |
  aValue _isSymbol ifTrue:[ | ofs |
    ofs := StrengthNames indexOfIdentical: aValue .
    ofs == 0 ifTrue:[ ArgumentError signal:
     'arg must be one of #PRIMARY #SECONDARY #TERTIARY #QUATERNARY #IDENTICAL'
    ].
    val := StrengthArgs at: ofs .
  ] ifFalse:[
    val := aValue .
  ].
  self _setAttribute: 0 value: val .  "see also usage in _copyCaseInsensitive"
%

category: 'Updating'
method: IcuCollator
_copyCaseInsensitive
  "Returns a copy of the receiver which will do case-insensitive compares."

 | stren c |
 " #( #PRIMARY #SECONDARY #TERTIARY #QUATERNARY #IDENTICAL ) "
 c := self copy .
 stren := (c _getAttribute: 0) + 1 .
 stren >= 3 ifTrue:[
   c strength: #SECONDARY .
 ].
 ^ c
%

category: 'Private'
method: IcuCollator
_getAttribute: opcode
  <primitive: 907>

  self _primitiveFailed:#_getAttribute: args: { opcode }
%

category: 'Private'
method: IcuCollator
_setAttribute: opcode value: val

  <primitive: 916>
  opcode == 0 ifTrue:[
    val _validateClass: SmallInteger .
    (self class strengths includesIdentical: val) ifFalse:[
      OutOfRange new name:'strength' min: PRIMARY max: IDENTICAL actual: val; signal.
    ]
  ] ifFalse:[
    opcode == 1 ifTrue:[
      val _validateClass: String .
      (val = 'off' or:[ val = 'upperFirst' or:[ val = 'lowerFirst']]) ifFalse:[
         ArgumentError signal:'invalid value for caseFirst:'
      ].
    ] ifFalse:[
      val _validateClass: Boolean .
    ]
  ].
  self _primitiveFailed:#_setAttribute:value: args: { opcode . val }
%

! Class extensions for 'IcuLocale'

!		Class methods for 'IcuLocale'

removeallmethods IcuLocale
removeallclassmethods IcuLocale

category: 'Accessing'
classmethod: IcuLocale
availableLocales
  "calls Locale::getAvailableLocales() in locid.h. Returns an Array of IcuLocales"
  ^ self _locales: 5 value: nil
%

category: 'Instance Creation'
classmethod: IcuLocale
default
  "Return an IcuLocale equivalent to the default Locale.
   If  IcuLocale(C)>>default: has not been executed,
   the result is dependent on the locale of the operating system.

   If the locale of the operating system would imply a locale
   en_US_POSIX, then the locale en_US is returned instead,
   since en_US_POSIX is intended for binary collation and does
   not support case-insensitive searches.
"
  ^ self _locales: 2 value: nil
%

category: 'Instance Creation'
classmethod: IcuLocale
default: anIcuLocale
  "Sets the default Locale for ICU library to the argument.
   Also installs a default IcuCollator for the argument.
   Returns the receiver."
  | coll |
  coll := IcuCollator forLocale: anIcuLocale .
  self _locales: 3 value: anIcuLocale .
  IcuCollator default: coll .
%

category: 'Instance Creation'
classmethod: IcuLocale
getUS
  ^ self language:'EN' country:'US' variant:nil
%

category: 'Accessing'
classmethod: IcuLocale
isoCountries
  "calls Locale::getISOCountries() in locid.h Returns an Array of Strings"
  ^ self _locales: 0 value: nil
%

category: 'Accessing'
classmethod: IcuLocale
isoLanguages
  "calls Locale::getISOLanguages() in locid.h  Returns an Array of Strings"
  ^ self _locales: 1 value: nil
%

category: 'Instance Creation'
classmethod: IcuLocale
language: langString country: countryString variant: variantString

" Return a new Locale for the specified language, country and variant.
  Calls  Locale::Locale(const char*  language,
                        const   char*  country,
                        const   char*  variant);
  See source/icu/common/unicode/locid.h
  or  icu-project.org/apiref/icu4c/classLocale.html  for more details

  Arguments must be nil or Strings of size 127 or less.
  langString must be nonNil"
<primitive: 912>

self _primitiveFailed: #language:country:variant:
	args:{ langString . countryString. variantString}
%

category: 'Instance Creation'
classmethod: IcuLocale
new
  "disallowed"
  self shouldNotImplement: #new
%

category: 'Private'
classmethod: IcuLocale
_locales: opcode value: aValue
  "opcode   libicu function
       0    Locale::getISOCountries
       1    Locale::getISOLanguages
       2    Locale::getDefault
       3    Locale::setDefault
       5    Locale::getAvailableLocales
       6    Collator::getAvailableLocales
  "
<primitive: 914>
opcode == 3 ifTrue:[ aValue _validateClass: IcuLocale ]
            ifFalse:[ aValue _validateClass: UndefinedObject ].
self _primitiveFailed: #_locales:value: args: { opcode . aValue }
%

!		Instance methods for 'IcuLocale'

category: 'Comparing'
method: IcuLocale
= anIcuLocale

anIcuLocale == self ifTrue:[ ^ true ].
(anIcuLocale isKindOf: IcuLocale) ifFalse:[ ^ false ] .
^ name = anIcuLocale name
%

category: 'Formatting'
method: IcuLocale
asString
  ^ 'IcuLocale ' , name asString
%

category: 'Accessing'
method: IcuLocale
country
  "Returns a String, the locale's ISO-3166 country code.
   See Locale::getCountry() in locid.h "
  ^ self _getAttribute: 2
%

category: 'Accessing'
method: IcuLocale
displayName
  "Returns displayable name of the receiver using the en_US locale.
   Equivalent to Locale::getDisplayName() in locid.h "
  ^ self _getAttribute: 5
%

category: 'Comparing'
method: IcuLocale
hash
^ name hash
%

category: 'Accessing'
method: IcuLocale
language
  "Returns a String, the locale's ISO-639 language code.
   See Locale::getLanguage() in locid.h "
  ^ self _getAttribute: 0 .
%

category: 'Accessing'
method: IcuLocale
name
  "Returns a String, the name of the entire locale,
   with the language, country and variant separated by underbars.
   Equivalent to Locale::getName() in locid.h "
  ^ name
%

category: 'Formatting'
method: IcuLocale
printOn: aStream

  aStream nextPutAll: self asString .
%

category: 'Accessing'
method: IcuLocale
script
  "Returns a String, the locale's ISO-15924 abbreviation script code.
   See Locale::getScript() in locid.h "
  ^ self _getAttribute: 1
%

category: 'Accessing'
method: IcuLocale
variant
  "Returns a String, the locale's variant code.
   See Locale::getVariant() in locid.h "
  ^ self _getAttribute: 3
%

category: 'Private'
method: IcuLocale
_getAttribute: opcode
  "opcodes: 0 getLanguage, 1 getScript, 2 getCountry, 3 getVariant, 4 getName
    5 getDisplayName "
<primitive: 913>
self _primitiveFailed: #_getAttribute: args: { opcode }
%

category: 'Accessing'
method: IcuLocale
_name
    "Returns a String, the name of the entire locale,
   with the language, country and variant separated by underbars.
   calls Locale::getName() in locid.h"
  ^ self _getAttribute: 4
%

! Class extensions for 'IcuSortedCollection'

!		Class methods for 'IcuSortedCollection'

category: 'Instance Creation'
classmethod: IcuSortedCollection
new
"Returns a new instance of the receiver which will use
 the current default IcuLocale"

| inst |
(inst := self _basicNew) _initialize: IcuCollator default .
^inst
%

category: 'Instance Creation'
classmethod: IcuSortedCollection
newUsingCollator: aCollator
"Returns a new instance of the receiver which will use
 the specified collator."

| inst |
(inst := self _basicNew) _initialize: aCollator .
^inst
%

!		Instance methods for 'IcuSortedCollection'

category: 'Accessing'
method: IcuSortedCollection
collator
  ^ collator
%

category: 'Updating'
method: IcuSortedCollection
collator: aCollator
  "Change the receiver's collator and resort the receiver.
   Use a copy of aCollator to disallow changes to strength, etc,
   that would require a resort of the receiver."

  collator := aCollator copy immediateInvariant .
  self size > 1 ifTrue: [
    self resort
  ]
%

category: 'Searching'
method: IcuSortedCollection
indexOf: anObject

"Returns the index of the first occurrence of an object equal to anObject
 in the receiver.  If the receiver does not contain such an object, this
 returns zero."

| idx |
" _findIndex: returns where anObject would be inserted, so look at
surrounding slots to see if the object is present "
idx := self _findIndex: anObject.

(sortBlock value: anObject value: anObject value: collator) ifTrue: [
  "Need to look at the slots less than idx"
  | foundIdx | "We need to find the first one that is equal"
  foundIdx := 0.
  (idx-1) _downTo: 1 do: [ :i |
    (anObject = (self at: i)) ifTrue: [foundIdx := i].
    (i > 1) ifTrue: [
      "Check to see if the next element might be equal to the current element
       according to the sort block."
      (sortBlock value: (self at: i) value: (self at: i-1) value: collator) ifFalse: [
        "We don't need to look at any more because i-1 can't be equal
         to i."
        ^foundIdx
      ].
    ].
  ].
  ^foundIdx
] ifFalse: [
  "Need to look at the slots greater than idx"
  | lastIdx |
  lastIdx := self size.
  idx to: lastIdx do: [ :i |
    (anObject = (self at: i)) ifTrue: [^i].
    (i < lastIdx) ifTrue: [
      "Check to see if the next element might be equal to the current element
       according to the sort block."
      (sortBlock value: (self at: i) value: (self at: i+1) value: collator) ifTrue: [
        "We don't need to look at any more because i+1 can't be equal
         to i."
        ^0
      ].
    ].
  ].
  ^0.
].
%

category: 'Searching'
method: IcuSortedCollection
indexOfIdentical: anObject

"Private.  Returns the index of the first element in the receiver that is
 identical to the argument.  If the receiver does not have any elements that are
 identical to the argument, returns zero."

| idx |

(self size <= 2000) ifTrue: [
  "OrderedCollection's indexOfIdentical: uses a primitive and is
   faster for smaller SortedCollections"
  ^super indexOfIdentical: anObject.
].

" _findIndex: returns where anObject would be inserted, so look at
surrounding slots to see if the object is present "
idx := self _findIndex: anObject.

(sortBlock value: anObject value: anObject value: collator) ifTrue: [
  "Need to look at the slots less than idx"
  | foundIdx | "We need to find the first one that is equal"
  foundIdx := 0.
  (idx-1) _downTo: 1 do: [ :i |
    (anObject == (self at: i)) ifTrue: [foundIdx := i].
    (i > 1) ifTrue: [
      "Check to see if the next element might be equal to the current element
       according to the sort block."
      (sortBlock value: (self at: i) value: (self at: i-1) value: collator) ifFalse: [
        "We don't need to look at any more because i-1 can't be equal
         to i."
        ^foundIdx
      ].
    ].
  ].
  ^foundIdx
] ifFalse: [
  "Need to look at the slots greater than or equal to idx"
  | lastIdx |
  lastIdx := self size.
  idx to: lastIdx do: [ :i |
    (anObject == (self at: i)) ifTrue: [
      ^i
    ].
    (i < lastIdx) ifTrue: [
      "Check to see if the next element might be equal to the current element
       according to the sort block."
      (sortBlock value: (self at: i) value: (self at: i+1) value: collator) ifTrue: [
        "We don't need to look at any more because i+1 can't be equal
         to i."
        ^0
      ].
    ].
  ].
  ^0.
].
%

category: 'Initialize'
method: IcuSortedCollection
_defaultBlock

 ^ [ :a :b :aCollator | (a compareTo: b collator: aCollator useMinSize: false) <= 0 ]
%

category: 'Private'
method: IcuSortedCollection
_findIndex: anObject

"Finds and returns the index for placing the given object into the receiver.
 A simple binary probe is used."

| obj lower upper half probe |

self size == 0 ifTrue: [ ^1 ].

lower := 1.
upper := self size.
[ half := upper - lower + 1 // 2.
  probe := lower + half.
  -1 < half and: [ lower <= upper ] ] whileTrue: [
  obj := self at: probe.
  (sortBlock value: obj value: anObject value: collator) ifTrue: [
    "after this index - go to the next higher cell"
    lower := probe + 1.
  ]
  ifFalse: [
    "before this index - go to the next lower cell"
    upper := probe - 1
  ]
].
^probe
%

category: 'Initialize'
method: IcuSortedCollection
_initialize: aCollator
  "Use a copy of aCollator to disallow changes to strength, etc,
   that would require a resort of the receiver."
  collator := aCollator copy immediateInvariant .
  sortBlock := self _defaultBlock .
%

category: 'Copying'
method: IcuSortedCollection
_mergeSortAddAll: aCollection

"The receiver must be empty. Adds aCollection to the receiver
 using the merge-sort implementation provided by BlockSorter.
 Returns the receiver."

| arr |
self size == 0 ifFalse:[ self error:'not empty' ].
arr := aCollection sortWithBlock: sortBlock collator: collator .  "merge sort"
super _insertAll: arr at: 1 .
^ self
%

! Class extensions for 'IdentityBtreeNode'

!		Instance methods for 'IdentityBtreeNode'

category: 'ObsoleteIDX - Accessing'
method: IdentityBtreeNode
at: aKey otherwise: otherValue

"Returns the value that corresponds to aKey by searching the elements in the
 bucket.  If no such key/value pair exists, returns the given alternate value."

  | valueIndex |
  valueIndex := self _binarySearchForKey: aKey.
  valueIndex == 0 ifTrue: [
    ^ otherValue
  ].
  ^ self _at: valueIndex
%

category: 'ObsoleteIDX - Updating'
method: IdentityBtreeNode
at: aKey put: aValue

"Adds the key/value pair to the node.  If the node is full, raises an error."

  | index |
  " determine if full "
  numElements == self class maxNumberOfElements
    ifTrue: [
      ^ self _error: #objErrMaxSize
	  args: { numElements + 1 . self class maxNumberOfElements }
    ]
    ifFalse: [ " entry will fit in leaf node "
      numElements == 0
	ifTrue: [ index := 1 ]
	ifFalse: [ index := self _binarySearchCoveringKey: aKey ].
      self _insertKey: aKey value: aValue atIndex: index
    ].
%

category: 'ObsoleteIDX - Private'
method: IdentityBtreeNode
dynamicInstVarAt: aSymbol

self shouldNotImplement: #dynamicInstVarAt: "conflicts with use of _tagAt: "
%

category: 'ObsoleteIDX - Private'
method: IdentityBtreeNode
dynamicInstVarAt: aSymbol put: aValue

self shouldNotImplement: #dynamicInstVarAt:put: "conflicts with use of _tagAt:put: "
%

category: 'ObsoleteIDX - Private'
method: IdentityBtreeNode
parent

"Returns the back pointer to the parent."

" Stored in the tag slot so that we do not disturb binary search in C."
^ self _tagAt: 1
%

category: 'ObsoleteIDX - Private'
method: IdentityBtreeNode
parent: anObj

"Sets the parent of the receiver."

" Stored in the tag slot so that we do not disturb binary search in C."
self _tagAt: 1 put: anObj
%

category: 'ObsoleteIDX - Removing'
method: IdentityBtreeNode
removeKey: aKey ifAbsent: block

"Removes the key/value pair.  Finds the index for the given key and then shifts
 any following entries to the left."

  | result valueIndex |
  valueIndex := self _binarySearchForKey: aKey.
  valueIndex == 0 ifTrue: [
    ^ block value
  ].
  result := self _at: valueIndex.
  self _deleteNoShrinkFrom: valueIndex to: valueIndex + self entrySize - 1 .
  numElements := numElements - 1.
  ^ result
%

category: 'ObsoleteIDX - Removing'
method: IdentityBtreeNode
removeKey: aKey otherwise: otherVal

"Removes the key/value pair.  Finds the index for the given key and then shifts
 any following entries to the left."

  | result valueIndex |
  valueIndex := self _binarySearchForKey: aKey.
  valueIndex == 0 ifTrue: [
    ^ otherVal
  ].
  result := self _at: valueIndex.
  self _deleteNoShrinkFrom: valueIndex to: valueIndex + self entrySize - 1 .
  numElements := numElements - 1.
  ^ result
%

category: 'ObsoleteIDX - Searching'
method: IdentityBtreeNode
_binarySearchCoveringKey: aKey

"Returns the index for the first entry in which aKey is found utilizing a
 binary search.  This is the first entry whose key >= aKey."

" <primitive: WAS 356> "

self _primitiveFailed: #_binarySearchCoveringKey: args: { aKey } .
self _uncontinuableError
%

category: 'ObsoleteIDX - Searching'
method: IdentityBtreeNode
_binarySearchForKey: aKey

"Returns the 'value' index whose key is identical to aKey.  If no match is
 found, returns zero.  Uses a binary search."

"<primitive: WAS 357> "

self _primitiveFailed: #_binarySearchForKey: args: { aKey } .
self _uncontinuableError
%

! Class extensions for 'IdentityIndex'

!		Instance methods for 'IdentityIndex'

category: 'Updating Indexes'
method: IdentityIndex
addDirectMappingsFor: aBag
indexList: iList

"Add an entry for an index on the elements of the NSC."

| anObject firstPathTerm indexMgr |

indexMgr := self indexManager.

firstPathTerm := self firstPathTerm.
indexMgr autoCommit
  ifTrue: [ nscRoot _lockForIndexCreation ].

1 to: aBag size do: [ :i |
  anObject := aBag _at: i.
  " insert an entry into the index dictionary "
  indexDictionary
	_at: anObject
	put: anObject
	term: firstPathTerm
	logging: false.
  (i \\ 100) == 0 ifTrue:[ indexMgr commitIndexMaintenance: self at: i ].
]
%

category: 'Converting'
method: IdentityIndex
asIndexSpecification
  ^ (IdentityIndexSpecification path: self pathComponentsString)
    requirePathTerms: self termsRequired;
    legacyIndex: true;
    yourself
%

category: 'Support'
method: IdentityIndex
asPathEvaluator
  "Returns a PathEvaluator over the same path as the receiver."

  | pathEval holder |
  pathEval := PathEvaluator new.
  1 to: self size do: [ :i | pathEval add: (self at: i) name ].
  pathEval nsc: nscRoot.
  holder := { pathEval } .
  pathEval := nil .
  ^ PathEvaluator asMostSpecificType: holder .
%

category: 'Converting'
method: IdentityIndex
asQueryEvaluator

  ^IdentityIndexQueryEvaluator on: self
%

category: 'Converting'
method: IdentityIndex
asString
  | str |
  str := '('.
  1 to: self size do: [ :index |
    | pt |
    pt := self at: index.
    str := str , pt name asString.
    index < self size
      ifTrue: [ str := str , '.' ] ].
  ^ super asString , str , ')'
%

category: 'Indexing Support'
method: IdentityIndex
btreeComparisonQuerySpec
  ^ BtreeComparisonQuerySpec new
%

category: 'Clustering'
method: IdentityIndex
clusterDepthFirst

"Cluster the receiver.  Only need to cluster the path terms."

1 to: self size do: [ :i |
  (self at: i) clusterDepthFirst
]
%

category: 'Accessing'
method: IdentityIndex
collator
  "Returns IcuCollator to be used when comparing Unicode strings ... nil indicates that default collator should be used."

  ^ nil
%

category: 'Indexing Support'
method: IdentityIndex
comparisonForCompare
  ^ BtreeComparisonForCompare newForComparison: self collator
%

category: 'Accessing'
method: IdentityIndex
firstPathTerm

"Returns the first path term in the path components list."

^ self at: 1
%

category: 'Testing'
method: IdentityIndex
hasCollectionBasedTerm
  "Returns true if the path has an enumerated path term or a term that indicates a
   set-valued instance variable."

  ^ self hasEnumeratedTerm or: [ self hasSetValuedTerm ]
%

category: 'Testing'
method: IdentityIndex
hasEnumeratedTerm
  "Returns true if the path has a term that indicates an enumerated path term."

  1 to: self size do: [ :i |
    (self at: i) isEnumeratedTerm
      ifTrue: [ ^ true ] ].
  ^ false
%

category: 'Testing'
method: IdentityIndex
hasIndexDictionary
  "Answer if receiver has an indexDictionary."

  ^ self indexDictionary notNil
%

category: 'Testing'
method: IdentityIndex
hasIndexOnPath: pathArray
  "Returns whether the receiver's path components match the path represented by
 pathArray."

  self size == pathArray size
    ifFalse: [ ^ false ].
  1 to: self size do: [ :i |
    ((self at: i) hasMatchingTerm: (pathArray at: i))
      ifFalse: [ ^ false ] ].
  ^ isComplete
%

category: 'Testing'
method: IdentityIndex
hasIndexOnPath: pathArray startingAt: offset

"Returns whether the receiver's path components match the path represented by
 pathArray."

self size - offset + 1 == pathArray size
  ifFalse: [ ^ false ].

offset to: self size do: [ :i |
  (self at: i) name == (pathArray at: i + 1 - offset)
    ifFalse: [ ^ false ].
].
^ isComplete
%

category: 'Support'
method: IdentityIndex
hasSamePathAs: anIndex

"Returns whether the given index is on the same path as the receiver.
 This can only be true if the index is identical."

^ self == anIndex
%

category: 'Testing'
method: IdentityIndex
hasSetValuedTerm
  "Returns true if the receiver has any path term that indicates a set-valued
 instance variable."

  1 to: self size do: [ :i |
    (self at: i) isSetValuedTerm
      ifTrue: [ ^ true ] ].
  ^ false
%

category: 'Accessing'
method: IdentityIndex
indexDictionary

"Returns the value of the instance variable 'indexDictionary'."

^indexDictionary
%

category: 'Updating'
method: IdentityIndex
indexDictionary: newValue

"Modifies the value of the instance variable 'indexDictionary'."

indexDictionary := newValue
%

category: 'Accessing'
method: IdentityIndex
indexManager

^IndexManager current
%

category: 'Accessing'
method: IdentityIndex
indexType
  ^ #'identity'
%

category: 'Testing'
method: IdentityIndex
isComplete

"Returns the value of the instance variable 'isComplete'."

isComplete == nil
  ifTrue: [ ^ true ].
^ isComplete
%

category: 'Updating'
method: IdentityIndex
isComplete: newValue

"Modifies the value of the instance variable 'isComplete'."

isComplete := newValue
%

category: 'Testing'
method: IdentityIndex
isIdentityIndex

"Returns true."

^ true
%

category: 'Testing'
method: IdentityIndex
isIndexOnNscElements

"Returns whether the receiver is an index directly on the elements of an NSC
 (either the root NSC or a set-valued instance variable on the path)."

^ self lastPathTerm indicatesIndexOnNscElements
%

category: 'Testing'
method: IdentityIndex
isIndexOnRootNsc

"Returns whether the receiver is an index directly on the elements of
 the root NSC."

^ self lastPathTerm indicatesIndexOnRootNsc
%

category: 'Testing'
method: IdentityIndex
isLegacyIndex

"Legacy indexes are kinds of IdentityIndex, so return true."

^ true
%

category: 'Testing'
method: IdentityIndex
isPathEvaluator

"Returns false."

^ false
%

category: 'Testing'
method: IdentityIndex
isRangeEqualityIndex

"Returns false."

^ false
%

category: 'Testing'
method: IdentityIndex
isStreamable

"Returns false."

^ false
%

category: 'Accessing'
method: IdentityIndex
lastElementClass

^ self error: 'not valid for identity index on ' , self pathComponentsString
%

category: 'Accessing'
method: IdentityIndex
lastElementClassDescription
  "answer a description of the lastElementClass of the receiver,
   suitable for use in an error message"

  ^ 'No lastElement class for Identity Indexes'
%

category: 'Accessing'
method: IdentityIndex
lastPathComponentsDictionaryOffset

"Returns the last index into the path components list that is mapped in the
 index dictionary (as opposed to the B-tree)."

^ self size
%

category: 'Accessing'
method: IdentityIndex
lastPathTerm

"Returns the last path term in the path components list."

^ self at: self size
%

category: 'Accessing'
method: IdentityIndex
nscRoot

"Returns the value of the instance variable 'nscRoot'."

^nscRoot
%

category: 'Updating'
method: IdentityIndex
nscRoot: newValue

"Modify the value of the instance variable 'nscRoot'."

nscRoot := newValue
%

category: 'Accessing'
method: IdentityIndex
nwayMergeProgress

"Returns nil (identity indexes do not utilize n-way merge)."

^ nil
%

category: 'Testing'
method: IdentityIndex
optimizingComparison
  "Answer true if comparison operations can be optimized in Btree operations and elsewhere.
   Controlled by optimizedComparison index option."

  "optimizedComparison index option not supported by legacy indexes."

  ^ false
%

category: 'Converting'
method: IdentityIndex
options

  ^self asIndexSpecification options
%

category: 'Accessing'
method: IdentityIndex
pathComponentsString

"Returns a string of the path components."

^ self pathComponentsStringStartingAt: 1
%

category: 'Accessing'
method: IdentityIndex
pathComponentsStringStartingAt: offset

"Returns a string of the path components."

| str sz |

sz := self size.
str := String new.
offset to: sz do: [ :i |
    str addAll: (self at: i) name.
    i == sz
        ifFalse: [ str add: $.  ]
].
^ str
%

category: 'Accessing'
method: IdentityIndex
pathSize

"Returns the number of path terms."

^ self size
%

category: 'Updating Indexes'
method: IdentityIndex
postIndexCreation: original

"Iterates through all ID entry holders, updating the index dictionary."

" indicate that it is ok to update the dictionary "
indexDictionary ~~ nil
  ifTrue: [ | array |
    " get the Array of IndexDictionaryEntryHolder's "
    array := indexDictionary entryHolders.
    1 to: array size do: [ :i | | holder |
      holder := array at: i.
      holder update.
      holder size: 0.
    ].
    " nil out the Array of ID entry holders for garbage collection "
    indexDictionary entryHolders: nil.
    indexDictionary okToUpdate: true.
    "now ensure there's room for growth"
    indexDictionary rebuildTable: 0 for: self.
  ].

isComplete := true.

self indexManager autoCommit
  ifTrue: [ |systm |
    systm := System .
    systm commitTransaction
      ifFalse: [ nscRoot _errorCouldNotCommitDuringIndexCreation ].
    systm transactionMode == #manualBegin ifTrue:
        [systm beginTransaction]
  ]
%

category: 'Updating Indexes'
method: IdentityIndex
preIndexCreation

"Initializes the working set of collision buckets in the index dictionary."

isComplete := false.
progress := 0.

indexDictionary ~~ nil
  ifTrue: [ indexDictionary initializeWorkingSetInterval: self ].
^ nil
%

category: 'Updating Indexes'
method: IdentityIndex
preIndexRemoval

isComplete := false.
progress := 0.

^ nil
%

category: 'Formatting'
method: IdentityIndex
printOn: aStream

"Puts a displayable representation of the receiver on the given stream."

"Copy the implementation from Object so we don't inherit it from Collection."

aStream nextPutAll: self asString
%

category: 'Accessing'
method: IdentityIndex
progress

"Returns the value of the instance variable 'progress'."

^progress
%

category: 'Updating'
method: IdentityIndex
progress: newValue

"Modifies the value of the instance variable 'progress'."

progress := newValue
%

category: 'Accessing'
method: IdentityIndex
sizeForNscBuilder

"Returns the size to be used when an NscBuilder is collecting objects."

^ nscRoot size
%

category: 'Accessing'
method: IdentityIndex
sortNodeClass
  "Returns the class of SortNode to use."

  ^ self lastElementClass sortNodeClass
%

category: 'Testing'
method: IdentityIndex
termsRequired
  "Returns true if the receiver has any path term that has termsRequired set."

  1 to: self size do: [ :i |
    (self at: i) termsRequired
      ifTrue: [ ^ true ] ].
  ^ false
%

category: 'Traversing'
method: IdentityIndex
traverse: anObject upTo: aPathTerm
  "Traverse the sub-objects of the given object using the path terms of the
 receiver up to the given path term.  This method assumes that the index is not
 over a set-valued instance variable.  For that kind of index, use the
 traverse:upTo:startingAt:into: method."

  | nextObj sz i |
  nil == anObject
    ifTrue: [ ^ anObject ].
  nextObj := anObject.
  sz := self size.
  i := 1.
  [ (self at: i) ~~ aPathTerm and: [ i <= sz ] ]
    whileTrue: [
      nextObj := (self at: i) _getNextObjectForTraversal: nextObj.
      nil == nextObj
        ifTrue: [ ^ nextObj ].
      i := i + 1 ].
  ^ nextObj
%

category: 'Traversing'
method: IdentityIndex
traverse: anObject upTo: aPathTerm startingAt: anOffset into: resultSet
  "Traverse the sub-objects of anObject, using the path terms of the receiver up
 to the given path term.  Add each object at the end of the traversal to the
 result set.  Returns the result set."

  | nextObj nscOffset sz i |
  nextObj := anObject.
  sz := self size.
  i := anOffset.
  [ (self at: i) ~~ aPathTerm _and: [ i <= sz _and: [ nil ~~ nextObj ] ] ]
    whileTrue: [
      | thePathTerm |
      thePathTerm := self at: i.
      thePathTerm indicatesMultiValue
        ifTrue: [
          " if indexing over a collection-based instance variable "
          nscOffset := i + 1.
          thePathTerm
            nextObj: nextObj
            do: [ :obj |
              " for each object in the collection-based instance variable
				make recursive call "
              self
                traverse: obj
                upTo: aPathTerm
                startingAt: nscOffset
                into: resultSet ].
          ^ resultSet ]
        ifFalse: [ nextObj := (self at: i) _getNextObjectForTraversal: nextObj ].
      i := i + 1 ].
  (nil ~~ nextObj _and: [ resultSet ~~ nil ])
    ifTrue: [ resultSet add: nextObj ].
  ^ resultSet
%

category: 'Traversing'
method: IdentityIndex
traverse: anObject upTo: aPathTerm startingAt: anOffset into: resultSet addingIndex: addingIndex
  "Traverse the sub-objects of anObject, using the path terms of the receiver up
 to the given path term.  Add each object at the end of the traversal to the
 result set.  If addingIndex is true, add an index list entry for the
 receiver to any NSCs encountered along the path; if false, remove an index list entry for the receiver.  Returns the result set."

  | nextObj sz i thePathTerm nscOffset |
  nextObj := anObject.
  sz := self size.
  i := anOffset.
  [ (self at: i) ~~ aPathTerm _and: [ i <= sz _and: [ nil ~~ nextObj ] ] ]
    whileTrue: [
      thePathTerm := self at: i.
      thePathTerm indicatesMultiValue
        ifTrue: [
          " if indexing over a collection-based instance variable "
          thePathTerm
            _updateCollectionBasedIndexFor: self
            on: nextObj
            offset: i
            addingIndex: addingIndex.
          nscOffset := i + 1.
          thePathTerm
            nextObj: nextObj
            do: [ :obj |
              " for each object in the collection-based instance variable make recursive call "
              self
                traverse: obj
                upTo: aPathTerm
                startingAt: nscOffset
                into: resultSet
                addingIndex: addingIndex ].
          ^ resultSet ]
        ifFalse: [ nextObj := (self at: i) _getNextObjectForTraversal: nextObj ].
      i := i + 1 ].
  (nil ~~ nextObj _and: [ resultSet ~~ nil ])
    ifTrue: [ resultSet add: nextObj ].
  ^ resultSet
%

category: 'Traversing'
method: IdentityIndex
traverseObject: anObject

"Traverse the sub-objects of the given object using the path terms of the
 receiver.  This method assumes that the index is not over a set-valued
 instance variable.  For that kind of index, use the traverse:startingAt:into:
 method.  If a nil value is reached before the end of the path, returns the
 incompletePathTraversal object."

self isIndexOnNscElements
    ifTrue: [ ^ anObject ].

nil == anObject
    ifTrue: [ ^ #_incompletePathTraversal ].

^ self _traverseObject: anObject
%

category: 'Traversing'
method: IdentityIndex
traverseObject: anObject
incompletesInto: incompleteArray
incomplete: incomplete

"Traverse the sub-objects of the given object using the path terms of the
 receiver.  This method assumes that the index is not over a set-valued
 instance variable.  For that kind of index, use the traverse:startingAt:into:
 method.  If a nil value is reached before the end of the path, place the object
 into the appropriate Array in the incompleteArray of Arrays."

self isIndexOnNscElements
    ifTrue: [ ^ anObject ].

nil == anObject
    ifTrue: [ ^ incomplete ].

^ self _traverseObject: anObject
  incompletesInto: incompleteArray
  incomplete: incomplete
%

category: 'Updating Indexes'
method: IdentityIndex
updatingByteObject: aByteObject startingAt: startPt withNewValue: newValue

"The byte object is being updated.  For identity indexes, nothing is required
 to keep the index up to date."

%

category: 'Support'
method: IdentityIndex
_addAllFor: aKey
into: anNscBuilderOrArray
offset: offset
pathTerm: pathTerm

"Traverse the reverse mappings for the given key, adding the object at the end
 of the traversal to the given NscBuilder or Array."

<primitive: 328>
self _primitiveFailed: #_addAllFor:into:offset:pathTerm: .
self _uncontinuableError
%

category: 'Testing'
method: IdentityIndex
_checkSameIndexOptionsAs: anIndexSpec
  ^ self termsRequired == anIndexSpec requirePathTerms
%

category: 'Updating'
method: IdentityIndex
_clear

"Assigns nil to important instance variables and sets the receiver's size
 to zero."

indexDictionary := nil.
nscRoot := nil.
rcRangeBucket := nil.
self size: 0.
%

category: 'Testing'
method: IdentityIndex
_commonPathTermsWith: anEvaluatorOrIndex
  ^ anEvaluatorOrIndex _commonPathTermsWithIndex: self
%

category: 'Testing'
method: IdentityIndex
_commonPathTermsWithIndex: anIndex
  | commonSize commonTerms |
  commonSize := self size min: anIndex size.
  commonTerms := {}.
  1 to: commonSize do: [ :index |
    | term |
    (term := (self at: index) name) = (anIndex at: index) name
      ifFalse: [ ^ commonTerms ].
    commonTerms add: term ].
  ^ commonTerms
%

category: 'Testing'
method: IdentityIndex
_commonPathTermsWithPathEvaluator: anPathEvaluator
  | commonSize commonTerms |
  commonSize := self size min: anPathEvaluator size.
  commonTerms := {}.
  1 to: commonSize do: [ :index |
    | term |
    (term := (self at: index) name) = (anPathEvaluator at: index)
      ifFalse: [ ^ commonTerms ].
    commonTerms add: term ].
  ^ commonTerms
%

category: 'Indexing Support'
method: IdentityIndex
_doPutCommonPathTermsForPathArray: pathArray for: anIndexList

"Find the common path terms that already exist for indexes whose path
 components match pathArray (an Array of Strings).  Adds those path terms to
 the end of receiver.  Do not put a common path term into receiver that
 is the last path term for an existing index unless the existing index
 is an identity index."

| firstUnique somePathTerms j minSize sz someSz someIsIdentityIndex isRangeIndex |
firstUnique := 0.
isRangeIndex := self isRangeEqualityIndex.
sz := pathArray size.
1 to: anIndexList size by: 2 do: [ :i |
    j := anIndexList at: i + 1.
    " only consider index objects for which the NSC is the root "
    j == 1
        ifTrue: [
            somePathTerms := anIndexList at: i.
            someIsIdentityIndex := somePathTerms isIdentityIndex.
            someSz := somePathTerms size.
            minSize := someSz min: sz.

            [ j <= minSize and:
            [ (somePathTerms at: j) name = (pathArray at: j) ] ] whileTrue: [
                ( j > firstUnique and:
                [ ( j < someSz or: [ someIsIdentityIndex and: [ j == someSz ] ] )_and:
                [ j ~~ sz or: [ isRangeIndex not ] ] ] )
                   ifTrue: [
                       firstUnique := j.
                       self addLast: (somePathTerms at: j)
                   ].
                j := j + 1
            ]
        ]
].
%

category: 'Error Handling'
method: IdentityIndex
_errorCannotInvokeRangeOperationOnIdentityIndex

"An attempt was made to use a range operation (< > = <= >=) on a path
 expression only supported by an identity index."

^ self _error: #rtErrIdentityIndexCannotInvokeRangeOperation
%

category: 'Searching'
method: IdentityIndex
_findFirstUnsharedPathTerm
  "Returns the first path term that is not shared by any other indexes.  This is
 the first path term whose only index is the receiver.  If one is not found
 (the index shares the same path with another index), then returns nil."

  | pathTerm sz indexObj |
  sz := self size.
  1 to: sz do: [ :i |
    pathTerm := self at: i.
    (pathTerm size == 1 and: [ self == (pathTerm at: 1) ])
      ifTrue: [ ^ pathTerm ] ].
  pathTerm := self at: self size.	" check if there is an equality and identity index on the same path "
  1 to: pathTerm size do: [ :i |
    " for each index that utilizes the last path term "
    indexObj := pathTerm at: i.
    (indexObj ~~ self and: [ indexObj size == sz ])
      ifTrue: [
        " if some other index has the same number of path terms "
        ^ pathTerm ] ].
  ^ nil
%

category: 'Support'
method: IdentityIndex
_findSetValuedPathTermOffset
  "Returns the offset of the set-valued path term in the receiver.  If none
 exists, returns 0."

  1 to: self size do: [ :i |
    (self at: i) indicatesMultiValue
      ifTrue: [ ^ i ] ].
  ^ 0
%

category: 'Testing'
method: IdentityIndex
_isIndexObject

"Returns true if the receiver is an index object; returns false otherwise."

^ true
%

category: 'Indexing Support'
method: IdentityIndex
_partialPathComponentsStringUpTo: offset

"Returns the path components string up to the given offset."

| str |
str := String new.
1 to: (offset min: self size) do: [ :i |
    str add: (self at: i) name.
    i == offset
        ifFalse: [ str add: $. ]
].
^ str
%

category: 'Indexing Support'
method: IdentityIndex
_preIndexCreationBuildIndexDictionaryFor: pathArray for: anNsc
  "afford an opportunity to resize dictionary before adding new elements during index creation"

  (pathArray size == 1 and: [ self isRangeEqualityIndex ])
    ifFalse: [ | indexDict |
      anNsc _calculateIndexDictionarySize: pathArray size.
      indexDict := anNsc _getIndexDictionary.
      self indexDictionary: indexDict.
      indexDict rebuildTable: anNsc _getIndexDictionaryCreationSize for: self ]
%

category: 'Updating'
method: IdentityIndex
_setPathTermState

"For each path term, indicate the need to update the index dictionary."

1 to: self size do: [ :i |
    (self at: i) updateDict: indexDictionary.
]
%

category: 'Statistics'
method: IdentityIndex
_statisticsInto: dict

"Puts statistical information into the given dictionary."

%

category: 'Traversing'
method: IdentityIndex
_traverseObject: anObject
  "Traverse the sub-objects of the given object using the path terms of the
 receiver.  This method assumes that the index is not over a set-valued
 instance variable.  For that kind of index, use the traverse:startingAt:into:
 method.  If a nil value is reached before the end of the path, returns the
 incompletePathTraversal object."

  | nextObj sz pathTerm |
  nextObj := anObject.
  sz := self size.
  1 to: sz do: [ :i |
    pathTerm := self at: i.
    nextObj := pathTerm _getNextObjectForTraversal: nextObj.
    (nil == nextObj and: [ i ~~ sz ])
      ifTrue: [ ^ #'_incompletePathTraversal' ] ].
  ^ nextObj
%

category: 'Traversing'
method: IdentityIndex
_traverseObject: anObject incompletesInto: incompleteArray incomplete: incomplete
  "Traverse the sub-objects of the given object using the path terms of the
 receiver.  This method assumes that the index is not over a set-valued
 instance variable.  For that kind of index, use the traverse:startingAt:into:
 method.  If a nil value is reached before the end of the path, place the object
 into the appropriate Array in the incompleteArray of Arrays."

  | nextObj sz pathTerm |
  nextObj := anObject.
  sz := self size.
  1 to: sz do: [ :i |
    pathTerm := self at: i.
    nextObj := pathTerm _getNextObjectForTraversal: nextObj.
    (nil == nextObj and: [ i ~~ sz ])
      ifTrue: [
        incompleteArray == nil
          ifTrue: [ ^ nil ].
        (incompleteArray at: i + 1) add: anObject.
        ^ incomplete ] ].
  ^ nextObj
%

! Class extensions for 'IdentityIndexQueryEvaluator'

!		Instance methods for 'IdentityIndexQueryEvaluator'

category: 'Query Select'
method: IdentityIndexQueryEvaluator
findAllValuesEqualTo: aValue

"Identity indexes do not support equality comparison."

^ self _errorCannotInvokeRangeOperationOnIdentityIndex
%

category: 'Query Select'
method: IdentityIndexQueryEvaluator
findAllValuesGreaterThan: val1
andEquals: bool1
andLessThan: val2
andEquals: bool2

"Identity indexes do not support range comparison."

^ self _errorCannotInvokeRangeOperationOnIdentityIndex
%

category: 'Query Select'
method: IdentityIndexQueryEvaluator
findAllValuesGreaterThanKey: aValue andEquals: aBoolean

"Identity indexes do not support range comparison."

^ self _errorCannotInvokeRangeOperationOnIdentityIndex
%

category: 'Query Select'
method: IdentityIndexQueryEvaluator
findAllValuesIdenticalTo: aValue

"Returns a set of all values that satisfy the query."

| tmpHolder startPt res |

" optimize query for objects in the NSC itself "
self index isIndexOnRootNsc
    ifTrue: [
      doBlock
        ifNil: [
          " optimize query for objects in the NSC itself "
          ^ self _allIdenticalTo: aValue in: self nscRoot ].
      ^ self _allIdenticalTo: aValue in: self nscRoot do: doBlock  ].

tmpHolder := NscBuilder for: self nscRoot species new max: self sizeForNscBuilder.

startPt := self index lastPathComponentsDictionaryOffset.
self index _addAllFor: aValue
    into: tmpHolder
    offset: startPt
    pathTerm: (self index at: startPt).

res := tmpHolder completeBag.
doBlock ifNotNil: [ res do: doBlock ].
^res
%

category: 'Query Select'
method: IdentityIndexQueryEvaluator
findAllValuesIdenticalTo: aValue do: aBlock
  "Iterates over all values that satisfy the query.  "

  ^ (self findAllValuesIdenticalTo: aValue) do: aBlock
%

category: 'Query Select'
method: IdentityIndexQueryEvaluator
findAllValuesLessThanKey: aValue andEquals: aBoolean

"Identity indexes do not support range comparison."

^ self _errorCannotInvokeRangeOperationOnIdentityIndex
%

category: 'Query Select'
method: IdentityIndexQueryEvaluator
findAllValuesNotEqualTo: aValue

"Identity indexes do not support equality comparison."

^ self _errorCannotInvokeRangeOperationOnIdentityIndex
%

category: 'Query Detect'
method: IdentityIndexQueryEvaluator
findFirstValueEqualTo: aValue

"Identity indexes do not support range comparison."

^ self _errorCannotInvokeRangeOperationOnIdentityIndex
%

category: 'Query Detect'
method: IdentityIndexQueryEvaluator
findFirstValueGreaterThan: val1
andEquals: bool1
andLessThan: val2
andEquals: bool2

"Identity indexes do not support range comparison."

^ self _errorCannotInvokeRangeOperationOnIdentityIndex
%

category: 'Query Detect'
method: IdentityIndexQueryEvaluator
findFirstValueGreaterThanKey: aValue
andEquals: aBoolean

"Identity indexes do not support range comparison."

^ self _errorCannotInvokeRangeOperationOnIdentityIndex
%

category: 'Query Detect'
method: IdentityIndexQueryEvaluator
findFirstValueIdenticalTo: aValue

"Returns the first value that satisfies the query."

" optimize query for objects in the NSC itself "
self index isIndexOnRootNsc
    ifTrue: [
        (self nscRoot includesIdentical: aValue)
            ifTrue: [ ^ aValue ]
            ifFalse: [ ^ #_incompletePathTraversal ]
    ].

^ self _findFirstValueForKey: aValue
%

category: 'Query Detect'
method: IdentityIndexQueryEvaluator
findFirstValueLessThanKey: aValue
andEquals: aBoolean

"Identity indexes do not support range comparison."

^ self _errorCannotInvokeRangeOperationOnIdentityIndex
%

category: 'Query Detect'
method: IdentityIndexQueryEvaluator
findFirstValueNotEqualTo: aValue

"Identity indexes do not support range comparison."

^ self _errorCannotInvokeRangeOperationOnIdentityIndex
%

category: 'Query Select'
method: IdentityIndexQueryEvaluator
_findAllValuesIdenticalToAsNsc: aValue
  "Answer a collecation of all values identical to aValue"

  | blk |
  blk := doBlock.
  [doBlock := nil.
  ^ self findAllValuesIdenticalTo: aValue ] ensure: [ doBlock := blk ]
%

category: 'Searching'
method: IdentityIndexQueryEvaluator
_findFirstKeyNotIdenticalTo: aKey atTerm: pathTerm

"Find the first entry with the given path term whose key is not identical to
 the given key and returns the entry's key."

^ self index indexDictionary _findFirstKeyNotIdenticalTo: aKey atTerm: pathTerm
%

! Class extensions for 'IdentityIndexSpecification'

!		Class methods for 'IdentityIndexSpecification'

category: 'instance creation'
classmethod: IdentityIndexSpecification
path: aString

	^(self new)
		path: aString;
		yourself
%

category: 'instance creation'
classmethod: IdentityIndexSpecification
path: aString lastElementClass: aClass

	^ self shouldNotImplement: #path:lastElementClass:
%

!		Instance methods for 'IdentityIndexSpecification'

category: 'accessing'
method: IdentityIndexSpecification
identityIndexClass
  ^ self legacyIndex
    ifTrue: [ IdentityIndex ]
    ifFalse: [ GsIdentityIndex ]
%

category: 'accessing'
method: IdentityIndexSpecification
indexType

	^#identity
%

category: 'accessing'
method: IdentityIndexSpecification
indexTypePrintString
  ^ 'identityIndex'
%

category: 'accessing'
method: IdentityIndexSpecification
removeIndexFrom: anNsc
  (self isIndexedOn: anNsc)
    ifTrue: [ anNsc removeIdentityIndexOn: self path ]
%

category: 'accessing'
method: IdentityIndexSpecification
_createIndex
  | index |
  index := self identityIndexClass new.
  self legacyIndex
    ifFalse: [ index options: self options ].
  ^ index
%

! Class extensions for 'IndexDictionaryEntryHolder'

!		Class methods for 'IndexDictionaryEntryHolder'

category: 'Instance Creation'
classmethod: IndexDictionaryEntryHolder
new

"Returns a new instance of the receiver."

^ (super new: 2001) initialize
%

!		Instance methods for 'IndexDictionaryEntryHolder'

category: 'Updating'
method: IndexDictionaryEntryHolder
addKey: aKey value: aValue term: pathTerm from: array at: index

"Adds the given triplet to the receiver."

" see if the receiver is getting too large "
offset > 2001
  ifTrue: [ | newOne |

    " see if we've linked too many together "
    count == 10
      ifTrue: [
        " cause index dictionary to be updated "
        self update.
        self at: 1 put: aKey.
        self at: 2 put: aValue.
        self at: 3 put: pathTerm.
        offset := 4.
        link := nil.
        ^ self
      ].

    " create a new holder and link it to this one "
    newOne := self class new.
    newOne addKey: aKey value: aValue term: pathTerm from: array at: index.
    newOne link: self.
    newOne indexDictionary: indexDictionary.
    newOne count: count + 1.
    array at: index put: newOne.
    ^ newOne
  ].
self at: offset put: aKey.
self at: offset + 1 put: aValue.
self at: offset + 2 put: pathTerm.
offset := offset + 3.
%

category: 'Updating'
method: IndexDictionaryEntryHolder
count: aValue

"Sets the value of the 'count' instance variable."

count := aValue
%

category: 'Updating'
method: IndexDictionaryEntryHolder
indexDictionary: aValue

"Sets the value of the 'indexDictionary' instance variable."

indexDictionary := aValue
%

category: 'Initialization'
method: IndexDictionaryEntryHolder
initialize

"Initializes the receiver."

offset := 1.
count := 1.
%

category: 'Updating'
method: IndexDictionaryEntryHolder
link: aValue

"Sets the value of the 'link' instance variable."

link := aValue
%

category: 'Updating'
method: IndexDictionaryEntryHolder
update

"Updates the given index dictionary with all entries in the receiver."

" indicate that it is ok to update the dictionary "
indexDictionary okToUpdate: true.
1 to: offset - 1 by: 3 do: [ :i |
  indexDictionary _at: (self at: i)
    put: (self at: i + 1)
    term: (self at: i + 2)
    logging: false
].
link ~~ nil
  ifTrue: [ link update ].
" indicate that it is not ok to update the dictionary "
indexDictionary okToUpdate: false.
%

! Class extensions for 'IndexedQueryEvaluator'

!		Class methods for 'IndexedQueryEvaluator'

category: 'Instance Creation'
classmethod: IndexedQueryEvaluator
on: anIndex

  ^ self new index: anIndex
%

!		Instance methods for 'IndexedQueryEvaluator'

category: 'Accessing'
method: IndexedQueryEvaluator
btreeComparisonQuerySpec

  ^self index btreeComparisonQuerySpec
%

category: 'Accessing'
method: IndexedQueryEvaluator
collator
  "Return the IcuCollator to be used in comparing Unicode strings"

  ^ self index collator
%

category: 'Accessing'
method: IndexedQueryEvaluator
doBlock
  ^ doBlock
%

category: 'Accessing'
method: IndexedQueryEvaluator
doBlock: aBlock
  doBlock := aBlock
%

category: 'Query Select'
method: IndexedQueryEvaluator
findAllValuesIdenticalTo: aValue

  ^IndexedQueryEvaluator subclassResponsibility: #findAllValuesIdenticalTo:
%

category: 'Query Select'
method: IndexedQueryEvaluator
findAllValuesNotIdenticalTo: aValue
  "Returns a set of all values that satisfy the query."

  | tmpHolder res |
  self index isIndexOnRootNsc
    ifTrue: [
      tmpHolder := self nscRoot species new.
      tmpHolder addAll: self nscRoot.
      tmpHolder removeAll: (self _allIdenticalTo: aValue in: self nscRoot).
      doBlock ifNotNil: [ tmpHolder do: doBlock ].
      ^ tmpHolder ].
  self hasCollectionBasedTerm
    ifTrue: [
      res := self _findAllValuesThroughSetsNotIdenticalTo: aValue.
      doBlock ifNotNil: [ res do: doBlock ].
      ^ res ].
  tmpHolder := NscBuilder
    for: self nscRoot species new
    max: self sizeForNscBuilder.
  tmpHolder _addAllNsc: (self _findAllValuesIdenticalToAsNsc: aValue).
  " get all objects identical to aValue and identical to nil "
  tmpHolder _addAllNsc: (self _allIdenticalTo: nil in: self nscRoot).
  1 to: self index size - 1 do: [ :i |
    " get all objects with nil along the path "
    self index
      _addAllFor: nil
      into: tmpHolder
      offset: i
      pathTerm: (self index at: i) ].
  res := self nscRoot _asIdentityBag - tmpHolder completeBag _asIdentityBag.
  doBlock ifNotNil: [ res do: doBlock ].
  res class == self nscRoot species
    ifFalse: [
      | finalRes |
      finalRes := self nscRoot species new.
      finalRes addAll: res.
      ^ finalRes ].
  ^ res
%

category: 'Query Select'
method: IndexedQueryEvaluator
findAllValuesNotIdenticalTo: aValue do: aBlock
  "Iterates over all values that satisfy the query."

  | result |
  result := self findAllValuesNotIdenticalTo: aValue.
  result do: aBlock.
  ^ result
%

category: 'Query Detect'
method: IndexedQueryEvaluator
findFirstValueIdenticalTo: aValue

  ^IndexedQueryEvaluator subclassResponsibility: #findFirstValueIdenticalTo:
%

category: 'Query Detect'
method: IndexedQueryEvaluator
findFirstValueNotIdenticalTo: aValue

"Returns the first value that satisfies the query."

| key lastPathTerm |

lastPathTerm := self index lastPathTerm.
" optimize query for objects in the NSC itself "
self index isIndexOnRootNsc
  ifTrue: [
    index nscRoot do: [ :element |
      element == aValue
        ifFalse: [ ^ element ] ].
    ^ #_incompletePathTraversal ].

key := self _findFirstKeyNotIdenticalTo: aValue atTerm: lastPathTerm.
(key == #_incompletePathTraversal)
  ifTrue: [ ^ #_incompletePathTraversal ].

^ self findFirstValueIdenticalTo: key
%

category: 'Testing'
method: IndexedQueryEvaluator
hasCollectionBasedTerm
  ^ self index hasCollectionBasedTerm
%

category: 'Testing'
method: IndexedQueryEvaluator
hasSetValuedTerm
  ^ self index hasSetValuedTerm
%

category: 'Accessing'
method: IndexedQueryEvaluator
index

  ^index
%

category: 'Updating'
method: IndexedQueryEvaluator
index: anIndex

  index := anIndex
%

category: 'Accessing'
method: IndexedQueryEvaluator
nscRoot

^self index nscRoot
%

category: 'Accessing'
method: IndexedQueryEvaluator
sizeForNscBuilder

"Returns the size to be used when an NscBuilder is collecting objects."

^ self nscRoot size
%

category: 'Support'
method: IndexedQueryEvaluator
_allIdenticalTo: anObject in: nsc

"Returns a new NSC containing the given object with the number of occurrences
 as in the root NSC."

| result tmp |
result := self _primAllIdenticalTo: anObject in: nsc _asIdentityBag.
result class = nsc species
  ifFalse: [
    tmp := nsc species new.
    tmp addAll: result.
    result := tmp
  ].
^ result
%

category: 'Support'
method: IndexedQueryEvaluator
_allIdenticalTo: anObject in: nsc do: aBlock
  "Returns a new NSC containing the given object with the number of occurrences
 as in the root NSC."

  | result |
  result := self _primAllIdenticalTo: anObject in: nsc _asIdentityBag.
  result do: aBlock
%

category: 'Error Handling'
method: IndexedQueryEvaluator
_errorCannotInvokeRangeOperationOnIdentityIndex

"An attempt was made to use a range operation (< > = <= >=) on a path
 expression only supported by an identity index."

^ self index _errorCannotInvokeRangeOperationOnIdentityIndex
%

category: 'Searching'
method: IndexedQueryEvaluator
_findAllValuesThroughSetsNotIdenticalTo: aKey
  "Returns a set of all values that satisfy the query.  This method works
 when the path is through a set-valued instance variable."

  | tmpVals tmpHolder startPt pathTerm idx |
  tmpHolder := NscBuilder
    for: self nscRoot species new
    max: self sizeForNscBuilder.
  idx := self index.
  tmpVals := idx indexDictionary
    _findAllValuesNotIdenticalTo: aKey
    atTerm: (idx at: idx lastPathComponentsDictionaryOffset)
    into: Array new.
  startPt := (idx lastPathComponentsDictionaryOffset - 1) max: 1.
  pathTerm := idx at: startPt.
  1 to: tmpVals size do: [ :i |
    idx
      _addAllFor: (tmpVals _at: i)
      into: tmpHolder
      offset: startPt
      pathTerm: pathTerm ].
  ^ tmpHolder completeBag
%

category: 'Searching'
method: IndexedQueryEvaluator
_findFirstKeyNotIdenticalTo: aValue atTerm: pathTerm

  ^IndexedQueryEvaluator subclassResponsibility: #_findFirstKeyNotIdenticalTo:atTerm:
%

category: 'Searching'
method: IndexedQueryEvaluator
_findFirstValueForKey: aKey

"Returns any root value for the given key by following the path terms in reverse
 order.  If none are found, returns aValue."

| startPt tmpVal incomplete |

self index hasIndexDictionary
  ifFalse: [ ^ aKey ].

tmpVal := aKey.
self index isIndexOnNscElements
    ifTrue: [ startPt := self index size ]
    ifFalse: [ startPt := self index lastPathComponentsDictionaryOffset ].

incomplete := #_incompletePathTraversal.
startPt _downTo: 1 do: [ :i |
  tmpVal := self index indexDictionary
    firstAt: tmpVal
    term: (self index at: i)
    otherwise: incomplete.
  (tmpVal == incomplete)
    ifTrue: [ ^ incomplete ].
].
^ tmpVal
%

category: 'Support'
method: IndexedQueryEvaluator
_primAllIdenticalTo: anObject in: nsc

"Returns a new NSC containing the given object with the number of occurrences
 as in the root NSC."

<primitive: 340>

self _primitiveFailed: #_primAllIdenticalTo:in: args: { anObject . nsc } .
self _uncontinuableError
%

! Class extensions for 'IndexList'

!		Class methods for 'IndexList'

category: 'Instance Creation'
classmethod: IndexList
new

"Returns a new, initialized instance of the receiver."

^ self basicNew initialize
%

!		Instance methods for 'IndexList'

category: 'Updating'
method: IndexList
addIndex: anIndexObj withOffset: anInteger nsc: anNsc

"Add an entry (index object, path offset) to the end of the index list."

| rootTerm |
" do not allow duplicate entries "
1 to: self size by: 2 do: [ :i |
    " if entry already exists, just returns "
  anIndexObj == (self at: i)
    ifTrue: [
      (self at: i + 1) == anInteger
        ifTrue: [ ^ self ]
        ifFalse: [
          anNsc _error: #rtErrNscParticipatesInMultipleTerms
            args: { anIndexObj pathComponentsString }
        ]
    ]
].

anIndexObj size < anInteger
    ifTrue: [ rootTerm := anIndexObj lastPathTerm ]
    ifFalse: [ rootTerm := anIndexObj at: anInteger ].

(rootTerms includesIdentical: rootTerm)
    ifTrue: [ rootTerm := nil ].

" add the entry to the end of the index list "
self _addIndex: anIndexObj withOffset: anInteger rootTerm: rootTerm
%

category: 'Updating'
method: IndexList
addTracker: tracker

"Adds the tracking object to the receiver."

" do not allow duplicate entries "
1 to: self size by: 2 do: [ :i |
    " if entry already exists, just returns "
  tracker == (self at: i)
    ifTrue: [ ^ self ]
].

" add the entry to the end of the index list "
self addLast: tracker.
self addLast: 0.
%

category: 'Updating Indexes'
method: IndexList
buildPathTermsFor: indexObj with: pathArray
  "should only be used with legacy indexes"

  ^ self buildPathTermsFor: indexObj with: pathArray fromSpec: nil
%

category: 'Updating Indexes'
method: IndexList
buildPathTermsFor: indexObj with: pathArray fromSpec: anIndexSpec
  "Add path terms to the given indexObj, using the pathArray (Array of Strings).
 First find all common path terms (from existing indexes), then create any new
 path terms."

  | pathTerm startOffset pathTermClass optionalPathTerms |
  " set the common path terms "
  indexObj _doPutCommonPathTermsForPathArray: pathArray for: self.
  startOffset := indexObj size + 1.	" keep the starting point so we don't add duplicate entries "
  1 to: indexObj size do: [ :i | " add the index to shared path terms "
    (indexObj at: i) addLast: indexObj ].
  pathTermClass := PathTerm.
  optionalPathTerms := false.
  anIndexSpec ifNotNil: [ pathTermClass := anIndexSpec defaultPathTermClass.
      optionalPathTerms := anIndexSpec optionalPathTerms ].
  1 to: startOffset - 1 do: [ :i | | term |
    term := indexObj at: i.
    optionalPathTerms
      ifTrue: [ term termsRequired
          ifTrue: [ self
              error:
                'Attempting to create an index with optionalPathTerms true, but an existing shared path term rquires terms: '
                  , term name printString ] ]
      ifFalse: [ term termsRequired not
          ifTrue: [ self
              error:
                'Attempting to create an index with required path terms, but a shared path term is optional: '
                  , term name printString ] ] ].
  startOffset to: pathArray size do: [ :i | | term |
    " create any new path terms that are needed "
    term := pathArray at: i.
    term = #'*'
      ifTrue: [ pathTerm := anIndexSpec defaultSetValuedPathTermClass new
          requirePathTerms: optionalPathTerms not;
          yourself ]
      ifFalse: [ (term includes: $|)
          ifTrue: [ pathTerm := anIndexSpec defaultEnumeratedPathTermClass new
              requirePathTerms: optionalPathTerms not;
              yourself ]
          ifFalse: [ (term size > 0 and: [ (term at: 1) == $# ])
              ifTrue: [ pathTerm := anIndexSpec defaultSelectorPathTermClass new
                  requirePathTerms: optionalPathTerms not;
                  yourself ]
              ifFalse: [ pathTerm := pathTermClass new ] ] ].
    pathTerm
      name: (pathArray at: i);
      offset: i;
      addLast: indexObj.
    indexObj addLast: pathTerm.
    pathTerm objectSecurityPolicy: GsIndexingObjectSecurityPolicy ].
  (1 max: startOffset - 1) to: indexObj size do: [ :i | " now calculate the children for each path term of the index object "
    (indexObj at: i) _determineChildren ].
  indexObj _setPathTermState.	" initialize path term state (whether to update B-trees, dictionary, etc) "
  self addIndex: indexObj withOffset: 1 nsc: indexObj nscRoot	" add an entry to the NSC's indexed paths list "
%

category: 'Updating'
method: IndexList
hasTrackingObjects

"Returns whether any tracking objects are contained in the receiver."

2 to: self size by: 2 do: [ :i |
  (self at: i) > 0
    ifFalse: [ ^ true ]
].
^ false
%

category: 'Testing'
method: IndexList
includesIndex: indexObj

"Returns whether the given index object is in the receiver."

1 to: self size by: 2 do: [ :i |
    indexObj == (self at: i)
        ifTrue: [ ^ true ]
].
^ false
%

category: 'Enumerating'
method: IndexList
indexObjectsAndOffsetsDo: aBlock

"Iterates over each (index, offset) pair in the index list, executing the
 two-argument block with the index object and offset as the arguments."

1 to: self size by: 2 do: [ :i |
  (self at: i) _isIndexObject
    ifTrue: [ aBlock value: (self at: i) value: (self at: i + 1) ]
]
%

category: 'Enumerating'
method: IndexList
indexObjectsDo: aBlock

"Iterates over each (index, offset) pair in the index list, executing the
 one-argument block with the index object as the argument."

1 to: self size by: 2 do: [ :i |
  (self at: i) _isIndexObject
    ifTrue: [ aBlock value: (self at: i) ]
]
%

category: 'Initialization'
method: IndexList
initialize

"Initializes the instance with default values."

rootTerms := { } .
isConstrained := false. "not used as ov v2.0"
%

category: 'Accessing'
method: IndexList
objectSecurityPolicy: anObjectSecurityPolicy

"Assigns the receiver, its tree of path terms, and the index objects to the
 given security policy."

| pathTerm |
anObjectSecurityPolicy == GsIndexingObjectSecurityPolicy
  ifFalse: [ self _error: #objectSecurityPolicyNotSharedDepListObjectSecurityPolicy ].

super objectSecurityPolicy: anObjectSecurityPolicy.
securityPolicies ifNotNil:[ securityPolicies objectSecurityPolicy: anObjectSecurityPolicy ].
rootTerms objectSecurityPolicy: anObjectSecurityPolicy.
1 to: rootTerms size do: [ :i |
    pathTerm := rootTerms at: i.
    pathTerm offset == 1
        ifTrue: [ pathTerm objectSecurityPolicy: anObjectSecurityPolicy ]
].
self indexObjectsAndOffsetsDo: [ :indexObj :offset |
    offset == 1
        ifTrue: [ indexObj objectSecurityPolicy: anObjectSecurityPolicy ]
]
%

category: 'Removing'
method: IndexList
removeAllIndexesFor: anNsc

"Removes all indexes from the receiver (it may contain tracking objects)."

| indexes |

indexes := { } .
1 to: self size by: 2 do: [ :i |
  (self at: i + 1) > 0
    ifTrue: [ indexes add: (self at: i); add: (self at: i + 1) ]
].
1 to: indexes size by: 2 do: [ :i |
  self removeIndex: (indexes at: i) withOffset: (indexes at: i + 1) for: anNsc
]
%

category: 'Removing'
method: IndexList
removeIndex: indexObj withOffset: anInteger for: anNsc

"Removes the entry (an entry has 2 slots) containing the given index.  If there
 are no remaining entries, then set the NSC's index list to nil.  Remaining
 entries are moved forward in the list."

| i sz |
sz := self size.

i := self _findOffsetFor: indexObj withOffset: anInteger.
i == nil
    ifTrue: [ ^ self ].

" if only one entry, clear the index list "
sz == 2
    ifTrue: [ ^ anNsc _clearIndexList ].

self removeFrom: i to: i + 1 .

self _calculateRootPathTerms.
%

category: 'Removing'
method: IndexList
removeIndexesInPathTerm: pathTerm for: anNsc

"Removes an entry in the receiver for each index that uses the given path term."

" for each index that utilizes the path term "
1 to: pathTerm size do: [ :i |
    " remove the entry in the index list for the NSC "
    self removeIndex: (pathTerm at: i)
        withOffset: pathTerm offset + 1
        for: anNsc
]
%

category: 'Removing'
method: IndexList
removeTracker: tracker for: anNsc

"Removes the tracking object from the receiver."

| i |

i := self _findOffsetFor: tracker.
i == nil
  ifTrue: [ ^ self ].

" if only one entry, clear the index list "
self size == 2
  ifTrue: [ ^ anNsc _clearIndexList ].

self removeFrom: i to: i + 1 .
%

category: 'Accessing'
method: IndexList
rootTerms

"Returns the value of the instance variable 'rootTerms'."

^rootTerms
%

category: 'Updating'
method: IndexList
rootTerms: newValue

"Modifies the value of the instance variable 'rootTerms'."

rootTerms := newValue
%

category: 'Updating'
method: IndexList
_addIndex: anIndexObj withOffset: anInteger rootTerm: rootTerm

"Add an entry (index object, path offset) to the end of the index list
 and update the root terms if necessary."

self addLast: anIndexObj.
self addLast: anInteger.

rootTerm ~~ nil
    ifTrue: [ rootTerms addLast: rootTerm ].
%

category: 'Testing'
method: IndexList
_allIndexesAreRc

"Returns true if all indexes are Rc."

self indexObjectsDo: [:indexObj | indexObj isReducedConflictIndex ifFalse: [ ^ false ] ].
^ true
%

category: 'Testing'
method: IndexList
_anyIndexIsLegacy

"Returns true if any one of the indexes is a legacy index."

self indexObjectsDo: [:indexObj | indexObj isLegacyIndex ifTrue: [ ^ true ] ].
^ false
%

category: 'Updating'
method: IndexList
_calculateRootPathTerms
  "Determines the list of root path terms for the receiver."

  rootTerms size: 0.
  self
    indexObjectsAndOffsetsDo: [ :indexObj :offset |
      indexObj size > 0
        ifTrue: [
          | pathTerm |
          pathTerm := indexObj size < offset
            ifTrue: [ indexObj lastPathTerm ]
            ifFalse: [ indexObj at: offset ].
          (rootTerms includesIdentical: pathTerm)
            ifFalse: [ rootTerms addLast: pathTerm ] ] ]
%

category: 'Searching'
method: IndexList
_findOffsetFor: indexObj

"Returns the integer entry number (position in the index list) at which
 indexObj is located in the receiver; or nil if it is not found."

"Performs a linear search."

1 to: self size by: 2 do: [ :i |
  indexObj == (self at: i)
        ifTrue: [ ^ i ]
].
^ nil
%

category: 'Searching'
method: IndexList
_findOffsetFor: indexObj withOffset: anInteger

"Returns the integer entry number (position in the index list) at which
 indexObj is located in the receiver; or nil if it is not found."

"Performs a linear search."

1 to: self size by: 2 do: [ :i |
  ( indexObj == (self at: i) and: [ (self at: i + 1) == anInteger ] )
        ifTrue: [ ^ i ]
].
^ nil
%

category: 'Testing'
method: IndexList
_hasASetValuedTerm
  "Answers true if the receiver contains a set-valued term."

  self
    indexObjectsDo: [ :iObj |
      iObj hasSetValuedTerm
        ifTrue: [ ^ true ] ].
  ^ false
%

category: 'Testing'
method: IndexList
_hasExplicitIndex

"Returns whether the receiver has an explicitly created index for it."

2 to: self size by: 2 do: [ :i |
  (self at: i) == 1
    ifTrue: [ ^ true ]
].
^ false
%

category: 'Searching'
method: IndexList
_numberOfCommonPathTermsForPathArray: pathArray

"Returns the number of path terms that already exist for indexes whose path
 components match pathArray (an Array of Strings)."

| firstUnique somePathTerms j continue count k |
firstUnique := 0.
count := 0.
k := 1.
1 to: self size by: 2 do: [ :i |
  somePathTerms := self at: i.
  j := self at: i + 1.
  j > 0
    ifTrue: [
      continue := true.

      [ k <= pathArray size and: [ j <= somePathTerms size and:
      [ (somePathTerms at: j) name = (pathArray at: k) ] ] ] whileTrue: [
        j > firstUnique
         ifTrue: [
           firstUnique := j.
           count := count + 1
         ].
        j := j + 1.
        k := k + 1.
      ]
    ]
].
^ count
%

category: 'Updating Indexes'
method: IndexList
_putAllCommonPathTermsForPathArray: pathArray into: indexObj

"Finds the common path terms that already exist for indexes whose path
 components match pathArray (an Array of Strings).  Add those path terms to
 the end of given indexObj."

| firstUnique somePathTerms j minSize sz |
firstUnique := 0.
sz := pathArray size.
1 to: self size by: 2 do: [ :i |
    somePathTerms := self at: i.
    j := self at: i + 1.
    " only consider index objects for which the NSC is the root "
    j == 1
        ifTrue: [
            minSize := somePathTerms size min: sz.

            [ j <= minSize and:
            [ (somePathTerms at: j) name = (pathArray at: j) ] ] whileTrue: [
                j > firstUnique
                   ifTrue: [
                       firstUnique := j.
                       indexObj addLast: (somePathTerms at: j)
                   ].
                j := j + 1
            ]
        ]
].
%

category: 'Reduced Conflict Support'
method: IndexList
_selectiveAbort

  "Do nothing"
%

category: 'Statistics'
method: IndexList
_statisticsInto: dict

"Put statistical information into the given dictionary."

| pages indexObj pathTerm |
pages := IdentitySet new.

pages add: self page.
pages add: rootTerms page.

1 to: self size by: 2 do: [ :i |
  indexObj := self at: i.
  indexObj _isIndexObject
    ifTrue: [
      indexObj _statisticsInto: dict.
      pages add: indexObj page.

      1 to: indexObj size do: [ :j |
        pathTerm := indexObj at: j.
        pages add: pathTerm page.
        pages add: pathTerm children page.
      ]
    ]
].
dict at: #IndexObjectPages put: pages
%

! Class extensions for 'IndexManager'

!		Class methods for 'IndexManager'

category: 'Accessing'
classmethod: IndexManager
autoCommit

^self current autoCommit
%

category: 'Updating'
classmethod: IndexManager
autoCommit: aBool
"Set autoCommit status; if true, this enabled commits to be performed without
specific commands, including due to TransactionBacklog"

self current autoCommit: aBool
%

category: 'Repository Conversion'
classmethod: IndexManager
buildFileNameForGem: anInt
  | result |
  result := String withAll: 'failedCharCollNscs_'.
  result
    addAll: anInt asString;
    addAll: '.bm'.
  ^ result
%

category: 'Repository Conversion'
classmethod: IndexManager
createConversionResultFileForTotalGems: totalGems
  "Called by the master gem to consolidate all lists of Indexes which failed
   conversion into a single result file.
   This method requires $upgradeLogDir to be set to a directory that contains
   conversion result files for the given gems."

  | uld bm outFile totalObjs |
  bm := GsBitmap new.
  uld := SortedCollection getUpgradeLogDir.
  1 to: totalGems do: [ :n |
    | fn |
    fn := uld copy.
    fn addAll: (self buildFileNameForGem: n).
    (GsFile existsOnServer: fn)
      ifTrue: [ bm readFromFile: fn ]
  ].
  totalObjs := bm size.
  totalObjs == 0
    ifTrue: [ ^ true ].
  outFile := uld copy.
  outFile addAll: 'AllFailedCharCollNscs.bm'.
  (GsFile existsOnServer: outFile)
    ifTrue: [ GsFile removeServerFile: outFile ].
  bm writeToFile: outFile.
  GsFile
    gciLogServer:
      'A total of ' , totalObjs asString
        , ' CharacterCollection indexes failed to convert'.
  ^ true
%

category: 'Accessing'
classmethod: IndexManager
current

  ^ Current ifNil:[
     Current := IndexManager _basicNew initialize .
     Current .
  ].
%

category: 'Updating'
classmethod: IndexManager
dirtyObjectCommitThreshold: anInteger

self current dirtyObjectCommitThreshold: anInteger
%

category: 'Repository Conversion'
classmethod: IndexManager
findAllCharacterCollectionIndexesForUser: aUserId
  "Find all indexes for which the last element class is a kind of CharacterCollection,
   and write these indexRoots to bitmap file under  $upgradeLogDir"
  | bm dirPath pid |
  bm := GsBitmap new.
  IndexManager current getAllIndexes
    do: [ :index |
      index isIdentityIndex
        ifFalse: [
          | lec |
          lec := index lastElementClass.
          (lec == CharacterCollection or: [ lec isBehavior and: [ lec inheritsFrom: CharacterCollection ] ])
            ifTrue: [ bm add: (index nscRoot) ] ] ].
  (bm size) = 0
    ifTrue: [ ^ self ].
  dirPath := self getNscIndexDir.
  (GsFile exists: dirPath)
    ifTrue: [ GsFile removeServerDirectory: dirPath ].
  GsFile createServerDirectory: dirPath.
  pid := (System gemVersionAt: 'processId') printString.
  bm writeToFile: ( dirPath , '/NscsWithCharacterCollectionIndexes-' , pid , '.bm')
%

category: 'Repository Conversion'
classmethod: IndexManager
getNscIndexDir
  ^ SortedCollection getUpgradeLogDir , '/ccnscbm'
%

category: 'Accessing'
classmethod: IndexManager
new
   "use
      IndexManager current
    to get the current instance"

   self shouldNotImplement: #new
%

category: 'Updating'
classmethod: IndexManager
percentTempObjSpaceCommitThreshold: anInteger

self current percentTempObjSpaceCommitThreshold: anInteger
%

category: 'Repository Conversion'
classmethod: IndexManager
rebuildAllCharCollIndexes: anArray
  "Rebuild indexes for an Array of nscs with CharacterColletion indexes
     by recording the indexes aassociated with the nsc, removing all indexes
     on the nsc, and then rebuilding all indexes.

   Caller must handle and catch AlmostOutOfMemory errors and handle commits
 and aborts."

  | sys commitBlock oldAutoCommit |
  sys := System.
  commitBlock := [
  sys commitTransaction
    ifFalse: [
      sys abortTransaction.
      TransactionError signal: 'Unexpected commit failure in index rebuild' ] ].
  oldAutoCommit := self autoCommit.
  [
  self autoCommit: true.
  1 to: anArray size do: [ :n |
    | nsc indexSpec |
    nsc := anArray at: n.
    indexSpec := nsc indexSpec.
    GsFile gciLogServer: 'Rebuilding indexes for nsc: ', nsc asOop printString.
    GsFile gciLogServer: indexSpec printString.
    nsc removeAllIndexes.
    indexSpec createIndexesOn: nsc.
    indexSpec := nsc indexSpec.
    GsFile gciLogServer: 'Rebuilt indexes for nsc: ', nsc asOop printString.
    GsFile gciLogServer: indexSpec printString ] ]
    ensure: [
      self autoCommit: oldAutoCommit.
      commitBlock value ]
%

category: 'Repository Conversion'
classmethod: IndexManager
rebuildCharacterCollectionIndexesFromFilesForGem: gemNum of: totalGems
  "Rebuild indexes on CharacterCollections.  Must previously have run
   findAllCharacterCollectionIndexesForUser:.
   This method requires $upgradeLogDir to be set to a directory that contains a
   bitmap of all indexes requiring rebuild."

  | bm errBm ar myShare failed ok unique |
  bm := GsBitmap new.
  errBm := GsBitmap new.
  ar := SortedCollection
    convertInstancesFromFilesForGem: gemNum
    of: totalGems
    bm: bm
    errBm: errBm
    bmDirectoryPath: self getNscIndexDir
    conversion: [ :array :ignored :_errBm | self rebuildAllCharCollIndexes: array ].
  myShare := ar at: 1.
  unique := ar at: 2.
  SortedCollection
    writeFailedConversionObjsToFileForGem: gemNum
    bmForErrors: errBm.	"Now write out the ones that failed conversion to a file, if any."
  failed := errBm size.
  ok := myShare - failed.
  System incrementGlobalSessionStatAt: 0 by: ok.
  System incrementGlobalSessionStatAt: 1 by: failed.
  System incrementGlobalSessionStatAt: 2 by: 1.
  ^ String new
    addAll: 'CharacterCollection index rebuilding done. Of ';
    addAll: myShare asString;
    addAll: ' total: ';
    addAll: failed asString;
    addAll: ' failed, ';
    addAll: ok asString;
    addAll: ' successful (';
    addAll: unique asString;
    addAll: ' unique).';
    yourself
%

category: 'Index Maintenance'
classmethod: IndexManager
removeAllIncompleteIndexes

^ self current removeAllIncompleteIndexes.
%

category: 'Index Maintenance'
classmethod: IndexManager
removeAllIndexes

^ self current removeAllIndexes.
%

category: 'Accessing'
classmethod: IndexManager
sessionAutoCommit

^self current sessionAutoCommit
%

category: 'Updating'
classmethod: IndexManager
sessionAutoCommit: aBool

self current sessionAutoCommit: aBool
%

category: 'Repository Conversion'
classmethod: IndexManager
writeTotalsFiles
  SortedCollection writeTotalsFile: 'ccidx_ok.txt' counterIndex: 0.
  SortedCollection writeTotalsFile: 'ccidx_failed.txt' counterIndex: 1.
  SortedCollection writeTotalsFile: 'ccidx_done.txt' counterIndex: 2.
  ^ true
%

category: 'Repository Conversion'
classmethod: IndexManager
_loadBitMap: bm
  | files |
  bm removeAll.
  files := GsFile contentsOfDirectory: self getNscIndexDir onClient: false.
  files := files
    select: [ :e | (e findPattern: (Array with: '.bm') startingAt: 1) ~~ 0 ].
  1 to: files size do: [ :n |
    | fn |
    fn := files at: n.
    bm readFromFile: fn ].
  ^ bm size
%

category: 'Repository Conversion'
classmethod: IndexManager
_loadBitmap: bm fromFile: fn
  ^ SortedCollection _loadBitmap: bm fromFile: fn
%

!		Instance methods for 'IndexManager'

category: 'Accessing'
method: IndexManager
autoCommit
  "Use session-specific value if sessionAutoCommit has been set (bug40602)"

| sac |
(sac := self sessionAutoCommit) ~~ nil
  ifTrue: [ ^sac ].
autoCommit == nil ifTrue:[ autoCommit := false ].
^autoCommit
%

category: 'Updating'
method: IndexManager
autoCommit: aBool
"Set autoCommit status; if true, this enabled commits to be performed without
specific commands, including due to TransactionBacklog"

autoCommit := aBool
%

category: 'Accessing'
method: IndexManager
btreeBasicLeafNodeClass

  self useKeyEncryption ifTrue: [ ^ BtreeBasicLeafNode ].

  ^ BtreeLeafNode
%

category: 'Accessing'
method: IndexManager
btreeLeafNodeClass

  ^ BtreeLeafNode
%

category: 'Index Maintenance'
method: IndexManager
commitIndexMaintenance: indexObjOrNil at: progressCount
  self shouldCommit
    ifTrue: [
      indexObjOrNil ifNotNil: [ indexObjOrNil progress: progressCount ].
      self _doCommit ]
%

category: 'Index Creation'
method: IndexManager
createEqualityIndexFor: anNSC on: aPathString withLastElementClass: aClass
  ^ (EqualityIndexSpecification path: aPathString lastElementClass: aClass)
    createIndexOn: anNSC
%

category: 'Index Creation'
method: IndexManager
createIdentityIndexFor: anNSC on: aPathString
  ^ (IdentityIndexSpecification path: aPathString) createIndexOn: anNSC
%

category: 'Index Creation'
method: IndexManager
createIndexFor: anNsc fromSpec: anIndexSpec
  | index |
  anIndexSpec _validateSpecificationOn: anNsc.
  " see if incomplete indexes "
  anNsc _hasIncompleteIndexes
    ifTrue: [ ^ self _error: #'rtErrCollectionWithIncompleteIndex' ].
  index := anIndexSpec _createIndex.
  self
    _checkExistingIndexesFor: anNsc
    against: index
    withSpec: anIndexSpec
    ifPresent: [ ^ self ].
  self
    executeStartingIndexMaintenance: [ self _buildIndex: index for: anNsc fromSpec: anIndexSpec ]
%

category: 'Index Creation'
method: IndexManager
createRcEqualityIndexFor: anNSC on: aPathString withLastElementClass: aClass
  "Replaces UnorderedCollection>>_createEqualityIndexOn:withLastElementClass:commitInterval:, modulo the error handler"

  ^ (RcEqualityIndexSpecification path: aPathString lastElementClass: aClass)
    createIndexOn: anNSC
%

category: 'Accessing'
method: IndexManager
dirtyObjectCommitThreshold

^ dirtyObjectCommitThreshold
%

category: 'Updating'
method: IndexManager
dirtyObjectCommitThreshold: anInteger

dirtyObjectCommitThreshold := anInteger
%

category: 'Private'
method: IndexManager
execStartingIndexMaintenance: aBlock
  "Behavior of index maintenance with respect to transaction state:

When in manual mode:
    When IndexManager current autoCommit is true:
        When originally outside of a transaction:
            Begin a transaction.
            Commit the final transaction of index creation.
            End outside of a transaction.
        When originally inside of a transaction:
            Commit the final transaction of index creation.
            End outside of a transaction.
When in auto mode:
    When IndexManager current autoCommit is true:
        Commit the final transaction of index creation.
"

  | inAutoCommit autoCommitPolicy systm |
  systm := System.
  (inAutoCommit := self autoCommit)
    ifTrue: [
      systm transactionMode == #'manualBegin'
        ifTrue: [
          systm inTransaction
            ifFalse: [
              systm needsCommit
                ifTrue: [ self _error: #'rtErrAbortWouldLoseData' ].
              systm beginTransaction ] ].
      self _initializeAutoCommitPolicy ].
  (autoCommitPolicy := self _autoCommitPolicy)
    ifNil: [ aBlock value ]
    ifNotNil: [
      [ autoCommitPolicy evaluate: aBlock for: self ]
        ensure: [
          inAutoCommit
            ifTrue: [ self _clearAutoCommitPolicy ] ] ].
  inAutoCommit
    ifTrue: [
      systm inTransaction
        ifTrue: [
          systm _commitPrintingDiagnostics
            ifFalse: [ self _errorCouldNotCommitDuringIndexCreation ] ] ]
%

category: 'Index Maintenance'
method: IndexManager
executeStartingIndexMaintenance: aBlock
"Disable STN_GEM_TIMEOUT, then perform index maintenance.

Behavior of index maintenance with respect to transaction state:

When in manual mode:
    When IndexManager current autoCommit is true:
        When originally outside of a transaction:
            Begin a transaction.
            Commit the final transaction of index creation.
            End outside of a transaction.
        When originally inside of a transaction:
            Commit the final transaction of index creation.
            End outside of a transaction.
When in auto mode:
    When IndexManager current autoCommit is true:
        Commit the final transaction of index creation."
| sys |
sys := System .
^ [
    sys disableStoneGemTimeout .
    self execStartingIndexMaintenance: aBlock
  ] ensure:[ sys enableStoneGemTimeout ] .
%

category: 'Accessing'
method: IndexManager
getAllIndexes
  "Return a collection of all indexes in the system."

  allIndexes == nil
    ifTrue: [
      allIndexes := RcIdentitySet new.
      allIndexes objectSecurityPolicy: GsIndexingObjectSecurityPolicy ].
  ^ allIndexes
%

category: 'Accessing'
method: IndexManager
getAllNSCRoots

  "Return a collection of all nsc's with indexes in the system."

  | set |
  set := IdentitySet new.
  self getAllIndexes do: [:index |
    set add: index nscRoot
  ].
  ^set
%

category: 'Initializing'
method: IndexManager
initialize

  "When creating initial instance, make sure all IVs are set, since we don't
   want to dirty the object during normal operation."

  self autoCommit: false .
  self getAllIndexes.
  self useKeyEncryption: true.
  self dirtyObjectCommitThreshold: SmallInteger maximumValue . "disabled by default"
  "was 75% ,  Gs64 v3.0 change to 60 for new AlmostOutOfMemory handling. "
  self percentTempObjSpaceCommitThreshold: 60.
  self objectSecurityPolicy: GsIndexingObjectSecurityPolicy.
%

category: 'Querying'
method: IndexManager
nscsWithBadIndexes
  "IndexManager current nscsWithBadIndexes"

  ^ self getAllNSCRoots
    reject: [ :each |
      | audit |
      audit := each auditIndexes.
      audit = 'Indexes are OK'
        or: [
          audit
            =
              'Indexes are OK and the receiver participates in one or more indexes with collection-valued path terms' ] ]
%

category: 'Querying'
method: IndexManager
nscsWithIncompleteIndexes
        "IndexManager current nscsWithIncompleteIndexes"

	^ self getAllNSCRoots select: [:each | each _hasIncompleteIndexes].
%

category: 'Updating'
method: IndexManager
objectSecurityPolicy: anObjectSecurityPolicy

"Assigns the receiver and the allIndexes collection to anObjectSecurityPolicy."

<primitive: 2001>
| prot |
prot := System _protectedMode .
[
  anObjectSecurityPolicy == GsIndexingObjectSecurityPolicy
    ifFalse: [ self _error: #objectSecurityPolicyNotSharedDepListObjectSecurityPolicy ].

  self _objectSecurityPolicy: anObjectSecurityPolicy.
  self getAllIndexes objectSecurityPolicy: anObjectSecurityPolicy.
] ensure:[
  prot _leaveProtectedMode
]
%

category: 'Accessing'
method: IndexManager
percentTempObjSpaceCommitThreshold

^ percentTempObjSpaceCommitThreshold
%

category: 'Updating'
method: IndexManager
percentTempObjSpaceCommitThreshold: anInteger

  anInteger _isSmallInteger ifFalse:[ anInteger _validateClass: SmallInteger ].
  (anInteger < 10 or:[ anInteger > 100]) ifTrue:[
     OutOfRange new name:'commit threshold' min: 10 max: 100 actual: anInteger;
       details: 'invalid commit threshold' ;  signal
  ].
  percentTempObjSpaceCommitThreshold := anInteger
%

category: 'Accessing'
method: IndexManager
rcBtreeBasicLeafNodeClass

  self useKeyEncryption ifTrue: [ ^ RcBtreeBasicLeafNode ].

  ^ RcBtreeLeafNode
%

category: 'Accessing'
method: IndexManager
rcBtreeLeafNodeClass

  ^ RcBtreeLeafNode
%

category: 'Index Updating'
method: IndexManager
removeAllCompleteIndexesOn: anNSC
  "Remove all complete indexes for anNSC. If all of the anNSC's indexes can be removed,
   this method returns the receiver.
   If an error occurs during index removal, it may not be possible to
   commit the current transaction later.
  "
  | iList rootIndexes hasNonRootIndex |
  (iList := anNSC _indexedPaths) ifNil: [ ^ anNSC ].

  hasNonRootIndex := false.
  rootIndexes := { } .
  " scan each entry to see if a non-root index is present "
  1 to: iList size by: 2 do: [ :i |
    " if it is a root index ... "
    (((iList at: i + 1) == 1) and: [ (iList at: i) isComplete])
        " add it to a list "
        ifTrue: [ rootIndexes add: (iList at: i) ]
        " otherwise flag that we're really not removing ALL indexes "
        ifFalse: [ hasNonRootIndex := true ]
  ].
  ^ [  | result |
	  IndexManager current executeStartingIndexMaintenance: [
		result := anNSC _removeAllRootIndexes: rootIndexes
                		hasNonRootIndex: hasNonRootIndex.
		result == anNSC ifTrue: [
		  rootIndexes do: [:each | self _removeIndex: each.  ].
		].
      ].
      result
	] onSynchronous: Error do:[ :ex |
    IndexingErrorPreventingCommit resignal: ex objWithIndex: anNSC .
	]
%

category: 'Index Maintenance'
method: IndexManager
removeAllIncompleteIndexes

  self getAllNSCRoots do: [:nsc |
    self removeAllIncompleteIndexesOn: nsc
  ].
%

category: 'Index Updating'
method: IndexManager
removeAllIncompleteIndexesOn: anNSC
  "Remove all incomplete indexes for anNSC.
   Return the number of incomplete indexes found."

  | iList incompleRootIndexes |
  (iList := anNSC _indexedPaths) == nil
    ifTrue: [ ^ 0 ].
  incompleRootIndexes := Array new.
  1 to: iList size by: 2 do: [ :i |
    " scan each entry to see if a non-root index is present "
    ((iList at: i + 1) == 1 _and: [ (iList at: i) isComplete not ])
      ifTrue: [
        " if it is an incomplete root index ... add it to a list "
        incompleRootIndexes add: (iList at: i) ] ].
  IndexManager current
    executeStartingIndexMaintenance: [
      incompleRootIndexes
        do: [ :indexObj |
          indexObj size > 0
            ifTrue: [
              | pathTerm |
              pathTerm := indexObj _findFirstUnsharedPathTerm.
              indexObj nscRoot _undoIndexCreation: indexObj pathTerm: pathTerm ].
          self _removeIndex: indexObj ] ].
  ^ incompleRootIndexes size
%

category: 'Index Maintenance'
method: IndexManager
removeAllIndexes
  "This algorithm ignores the collections and traverses the dependent objects
   directly removing the dependent for each object that does not have a
   modification tracking dependency. The objects with modification tracking
   dependencies are tracked and the SharedDependencyLists table is rebuilt
   for only those objects ... Without any modification tracking going on, the
   SharedDependencyLists table is simply reinitialized. The bookkeeping required
   for handling modification tracking dependencies is the extra cost that makes
   this one a bit more expensive than _oldRemoveAllIndexes in the simple 'flat'
   case.

   IndexManagerAutoCommitPolicy is used to periodically commit if
   temp object space gets low and to perform a final commit at end
   of operation.

   The removeAllIndexes progress count is used to track progress, but
   now tracks the number of indexed objects left that have path terms
   to remove."

  | sys |
  sys := System.
  sys
    setIndexProgressCountTo: UnorderedCollection statValueForRemovingAllIndexes.	"Setup progress counter"
  self
    executeStartingIndexMaintenance: [
      [
      | sharedDepLists trackedObjects |
      "Perform using index manager auto commit.."
      sharedDepLists := SharedDependencyLists allEntries.
      trackedObjects := IdentitySet new.
      DependencyList depMapKeysToHiddenSet: 2.
      sys setProgressCountTo: (sys hiddenSetSize: 2).
      System
        hiddenSet: 2
        do: [ :dependentObject |
          | depList hasTracker terms |
          depList := DependencyList for: dependentObject.
          hasTracker := false.
          terms := {}.
          1 to: depList size by: 2 do: [ :i |
            (depList at: i + 1) = 0
              ifTrue: [ hasTracker := true ]
              ifFalse: [
                | pathTerm |
                pathTerm := depList at: i.
                terms add: pathTerm ] ].
          hasTracker
            ifTrue: [
              "modification trackers present, so remove the individual pathTerms
               from dependencyList"
              terms
                do: [ :pathTerm | DependencyList removePathTerm: pathTerm for: dependentObject ].
              trackedObjects add: dependentObject ]
            ifFalse: [
              sharedDepLists remove: depList ifAbsent: [  ].
              DependencyList set: nil for: dependentObject ].
          sys decrementProgressCountBy: 1 ].
      self getAllNSCRoots
        do: [ :nsc |
          | iList |
          "Clear _indexedPaths field from all indexed collections"
          iList := nsc _indexedPaths.
          iList
            ifNotNil: [
              iList hasTrackingObjects
                ifTrue: [ iList removeAllIndexesFor: nsc ]
                ifFalse: [ nsc _indexedPaths: nil ] ] ].
      sharedDepLists isEmpty
        ifTrue: [
          "no modification trackers present, so simply initialize SharedDependencyLists"
          SharedDependencyLists initialize ]
        ifFalse: [
          | trackedDepLists |
          "rebuild SharedDependencyLists for modification trackers"
          trackedDepLists := IdentitySet new.
          trackedObjects
            do: [ :dependentObject |
              | depList |
              depList := DependencyList for: dependentObject.
              trackedDepLists add: depList ].
          SharedDependencyLists initialize.
          trackedDepLists
            do: [ :depList | SharedDependencyLists at: depList logging: false ] ].
      self resetAllIndexes	"Initialize IndexManager allIndexes reference" ]
        ensure: [ sys setIndexProgressCountTo: 0; setProgressCountTo: 0 ] ]
%

category: 'Index Updating'
method: IndexManager
removeAllIndexesOn: anNSC

  | result |
result := self removeAllCompleteIndexesOn: anNSC.
result == anNSC
  ifTrue: [
    self removeAllIncompleteIndexesOn: anNSC.
  ].
^result
%

category: 'Index Maintenance'
method: IndexManager
removeAllTracking
  "This method removes all indexes and all modification tracking meta data. This is
   the fastest algorithm of all. It unconditionally removes the dependencs for each
   object.

   IndexManagerAutoCommitPolicy is used to periodically commit if
   temp object space gets low and to perform a final commit at end
   of operation.

   The removeAllIndexes progress count is used to track progress, but
   now tracks the number of indexed objects left that have path terms
   to remove."

  | sys |
  "Setup progress counter"
  sys := System.
  sys
    setIndexProgressCountTo: UnorderedCollection statValueForRemovingAllIndexes.
  "Perform using index manager auto commit.."
  self
    executeStartingIndexMaintenance: [
      [
      | nscs |
      nscs := self getAllNSCRoots.
      sys setProgressCountTo: nscs size.
      DependencyList depMapKeysToHiddenSet: 2.
      DependencyList clearForHiddenSet: 2.	"Clear dependencyList for the dependent objects"
      1 to: nscs size do: [ :k |
        | uc |
        uc := nscs _at: k.
        uc _indexedPaths: nil.	"Clear the indexed structures from UnorderedCollections"
        sys decrementProgressCountBy: 1 ].
      SharedDependencyLists initialize.	"Initialize the SharedDependencyLists structure"
      self resetAllIndexes	"Initialize IndexManager allIndexes reference" ]
        ensure: [ sys setIndexProgressCountTo: 0 ; setProgressCountTo: 0 ] ]
%

category: 'Index Updating'
method: IndexManager
removeEqualityIndexFor: anNSC on: aPathString

  self _removeIndex: self _equalityIndex for: anNSC on: aPathString
%

category: 'Index Updating'
method: IndexManager
removeIdentityIndexFor: anNSC on: aPathString

  self _removeIndex: self _identityIndex for: anNSC on: aPathString
%

category: 'Index Updating'
method: IndexManager
resetAllIndexes
  allIndexes
    ifNil: [
      "force lazy init to fresh RcIdentityBag to avoid conflicts (bug43804)"
      self getAllIndexes ]
    ifNotNil: [
      allIndexes _isRcIdentityBag
        ifTrue: [
          "switch to using RcIdentitySet"
          allIndexes := nil.
          self getAllIndexes ]
        ifFalse: [
          "allow for concurrent index creation (bug43803)"
          allIndexes removeAll: allIndexes ] ]
%

category: 'Accessing'
method: IndexManager
sessionAutoCommit

^SessionTemps current at: #INDEX_MANAGER_AUTO_COMMIT ifAbsent: []
%

category: 'Updating'
method: IndexManager
sessionAutoCommit: aBoolOrNil
"Override persistent autoCommit on a session by session basis.
 If <aBoolOrNil> is nil, remove override.
 If true, this enabled commits to be performed without specific commands, including
 due to TransactionBacklog"

aBoolOrNil == nil
  ifTrue: [SessionTemps current removeKey: #INDEX_MANAGER_AUTO_COMMIT ifAbsent: []]
  ifFalse: [ SessionTemps current at: #INDEX_MANAGER_AUTO_COMMIT put: aBoolOrNil ]
%

category: 'Testing'
method: IndexManager
shouldCommit
"Answer true if a commit should be performed during index maintenance.
   Note - that this method should only be executed from within a
   executeStartingIndexMaintenance: block, since _autoCommitPolicy
   may not have been initialized correctly otherwise."

| policy |
self autoCommit ifFalse: [ ^ false ].

(policy := self _autoCommitPolicy ) ifNil:[ ^ false ].
^ policy shouldCommit
%

category: 'Accessing'
method: IndexManager
sortNodeClass

  self useKeyEncryption ifTrue: [ ^ BasicSortNode ].

  ^ SortNode
%

category: 'Querying'
method: IndexManager
usageReport
"
	Returns a string describing all indexes, the collection sizes, and
	the (visible) methods that could create these indexes.

	IndexManager current usageReport.
"

	| indexes methods keys stream |
	(stream := (AppendStream on: String new))
		lf; nextPutAll: 'Index Type - path - lastElementClass';
		lf; tab; nextPutAll: 'Collection size (collection OOP)';
		lf; tab; tab; nextPutAll: 'Index creation methods';
		lf.
	indexes := self _reportDataForIndexes.
	methods := self _reportDataForMethods.
	keys := (indexes collect: [:each | each key]) asSet asSortedCollection.
	keys do: [:eachKey |
		stream lf; nextPutAll: eachKey.
		(indexes select: [:each | each key = eachKey]) do: [:each |
			stream lf; tab; nextPutAll: each value.
		].
		(methods select: [:each | each key = eachKey]) do: [:each |
			stream lf; tab; tab; nextPutAll: each value.
		].
		stream lf.
	].
	^stream contents.
%

category: 'Accessing'
method: IndexManager
useKeyEncryption

  ^ useKeyEncryption
%

category: 'Updating'
method: IndexManager
useKeyEncryption: aBool

  useKeyEncryption := aBool

%

category: 'Accessing'
method: IndexManager
_addIndex: anIndex
  "  Add the given index into the collection of all indexes."

  anIndex objectSecurityPolicy: GsIndexingObjectSecurityPolicy.
  self getAllIndexes add: anIndex
%

category: 'Updating Indexes - Private'
method: IndexManager
_addMappingsFor: anNSC on: indexObj
  "Adds the mappings in the index dictionary, dependency lists, and so on for all
 elements in the receiver."

  | pathTerm setOffset hasSet |
  " since this index may use path terms from other indexes,
find the first one that is not shared by another index (only
need to add mappings from that point onward) "
  setOffset := indexObj _findSetValuedPathTermOffset.
  pathTerm := indexObj _findFirstUnsharedPathTerm.
  pathTerm
    ifNil: [
      " index is subsumed by an existing index "
      pathTerm := indexObj lastPathTerm.
      ^ pathTerm _doAddSubsumedIndex: indexObj nsc: anNSC ].
  setOffset == 0
    ifTrue: [ hasSet := false ]
    ifFalse: [
      "Determine if there is a set-valued instance variable before the unshared path
 term."
      hasSet := setOffset < pathTerm offset ].
  ^ pathTerm _doAddMappingsFor: anNSC on: indexObj indexManager: self hasSet: hasSet
%

category: 'Testing'
method: IndexManager
_autoCommitPolicy

^ (System __sessionStateAt: 11)
%

category: 'Index Updating - Private'
method: IndexManager
_buildIndex: index for: anNsc fromSpec: anIndexSpec
  [ | pathArray original |
  pathArray := anIndexSpec path asArrayOfPathTerms.
  index _preIndexCreationBuildIndexDictionaryFor: pathArray for: anNsc.
  index nscRoot: anNsc.
  self _addIndex: index.
  anNsc _getIndexList
    buildPathTermsFor: index
    with: pathArray
    fromSpec: anIndexSpec.
  anNsc _putInWriteSet.
  original := index preIndexCreation.
  index isIndexOnRootNsc
    ifTrue: [ " optimize creation of indexes on elements of the NSC itself "
      index
        addDirectMappingsFor: anNsc _asIdentityBag
        indexList: anNsc _indexedPaths ]
    ifFalse: [ self _addMappingsFor: anNsc on: index ].
  index postIndexCreation: original ]
    onSynchronous: Error
    do: [ :ex | IndexingErrorPreventingCommit resignal: ex objWithIndex: anNsc ]
%

category: 'Index Updating - Private'
method: IndexManager
_checkExistingIndexesFor: anNsc against: index withSpec: anIndexSpec ifPresent: presentBlock
  "evaluate presentBlock if an existing index matches the specified index"

  | pathArray indexes pathString indexOptions |
  indexOptions := index options.
  indexOptions legacyIndex
    ifTrue: [
      "legacy indexes are not supported on RcIndentitySet or RcLowMaintenanceIdentityBag (bug47179)"
      anNsc _validateLegacyRcIndexSupport ].
  (anNsc _indexedPaths )
    ifNotNil: [ :ilist |
      ilist indexObjectsDo: [:idxObj |
        "All indexes on anNsc must all be either legacy or btree plus ... no mixing"
        | idxObjOptions  |
        idxObjOptions := idxObj options.
        ((idxObjOptions legacyIndex == indexOptions legacyIndex)
          and: [idxObjOptions btreePlusIndex == indexOptions btreePlusIndex])
          ifFalse: [
            self error: 'A ',
              (idxObjOptions legacyIndex ifTrue: ['legacy'] ifFalse: ['btree plus']),
              ' index exists for this collection and it conflicts with the requested ',
              (idxObjOptions btreePlusIndex ifTrue: ['legacy'] ifFalse: ['btree plus']),
              ' index.'] ] ].
  pathString := anIndexSpec path.
  pathArray := pathString asArrayOfPathTerms.
  indexes := anNsc _findIndexesWithPath: pathArray.
  indexes
    do: [ :idxObj |
      idxObj indexType == index indexType
        ifTrue: [
          "index already exists on the given path for this type"
          (idxObj _checkSameIndexOptionsAs: anIndexSpec)
            ifFalse: [ "Bug44038: If index options are different, then signal an error"
              ^ self error: 'An ' , index indexType asString printString
                    , ' index already exists on the path '
                    , pathString printString , ' for this collection with '
                    , (idxObj termsRequired
                        ifTrue: [ 'REQUIRED' ]
                        ifFalse: [ 'OPTIONAL' ])
                    , ' path terms, which conflicts with the requested '
                    , (index termsRequired
                        ifTrue: [ 'REQUIRED' ]
                        ifFalse: [ 'OPTIONAL' ]) , ' path terms.' ].
          index indexType == #'identity'
            ifTrue: [ "no chance for conflicting index types for identity index"
              ^ presentBlock value ].
          (index _checkSameLastElementClassAs: idxObj)
            ifTrue: [ "If path and lastElementClass are the same, we'll let it slide"
              ^ presentBlock value ].	"Bug 43035: signal error if attempt was made to create a different
           index with the same path"
          ^ self error: 'An ' , index indexType asString printString
                , ' index already exists on the path ' , pathString printString
                , ' for this collection with lastElementClass of '
                , idxObj lastElementClassDescription printString
                , ' which conflicts with the requested lastElementClass of '
                , index lastElementClassDescription printString , '.' ] ]
%

category: 'Testing'
method: IndexManager
_clearAutoCommitPolicy

System __sessionStateAt: 11 put: nil
%

category: 'Private'
method: IndexManager
_doCommit
  | systm |
  systm := System.
  systm _commitPrintingDiagnostics
    ifFalse: [ self _errorCouldNotCommitDuringIndexCreation ].
  systm transactionMode == #'manualBegin'
    ifTrue: [ systm beginTransaction ]
%

category: 'Private'
method: IndexManager
_equalityIndex

  ^ #equality
%

category: 'Private'
method: IndexManager
_identityIndex

  ^ #identity
%

category: 'Testing'
method: IndexManager
_initializeAutoCommitPolicy

System __sessionStateAt: 11 put: (IndexManagerAutoCommitPolicy on: self)
%

category: 'Private'
method: IndexManager
_nextWordFrom: aReadStream
  "Assume that the aReadStream's collection is a kind of String.  Returns the
 next word in the string or nil if there is no next word."

  | result |
  result := String new.
  aReadStream skipSeparators.
  [ aReadStream atEnd or: [ aReadStream peek isSeparator ] ]
    whileFalse: [ result add: aReadStream next ].
  result size == 0
    ifTrue: [ ^ nil ]
    ifFalse: [ ^ result ]
%

category: 'Index Maintenance'
method: IndexManager
_oldRemoveAllIndexes
  "The _oldRemoveAllIndexes algorithm is actually pretty spiffy as long as there is
   a single index per nsc and each object participates in only one index. In fact
   this algorithm will (slightly) out-perform the new removeAllIndexes algorithm.
   When an object has more than one entry in the dependency list, this algorithm
   quickly blows up as the shared dependency list is recalculated for each element
   "

  | sys |
  sys := System.
  ^ [
  | roots sz |
  sys
    setIndexProgressCountTo: UnorderedCollection statValueForRemovingAllIndexes.
  roots := self getAllNSCRoots.
  sz := roots size.
  sys setProgressCountTo: sz.
  1 to: sz do: [ :n |
    | nsc result |
    nsc := roots at: n.
    result := self removeAllIndexesOn: nsc.
    nsc == result
      ifFalse: [
        self
          _error: #'rtErrRemoveAllIndexesFailed'
          args:
            {nsc.
            result} ].
    sys decrementProgressCountBy: 1 ] ]
    ensure: [
      sys
        setIndexProgressCountTo: 0;
        setProgressCountTo: 0 ]
%

category: 'Accessing'
method: IndexManager
_removeIndex: anIndex

  "Remove the given index from the collection of all indexes.
   Make sure that IVs are niled in anIndex, since it will
   survive (in rc redo log) until abort or commit."

  self getAllIndexes remove: anIndex ifAbsent: [ nil ].
  anIndex _clear.
%

category: 'Index Updating - Private'
method: IndexManager
_removeIndex: indexType for: anNSC on: aPathString
  | iList indexes index pathArray |
  anNSC _checkIndexPathExpression: aPathString.
  iList := anNSC _indexedPaths.
  iList ifNil: [ self _error: #'rtErrNoIndexForPath' args: {aPathString} ].
  pathArray := aPathString asArrayOfPathTerms.	" check if an index exists for the path string "
  indexes := anNSC _findIndexesWithPath: pathArray.
  indexes isEmpty
    ifFalse: [
      " make sure it is an identity index or equality index"
      indexes
        do: [ :iObj |
          indexType == self _identityIndex
            ifTrue: [
              iObj isIdentityIndex
                ifTrue: [ index := iObj ] ]
            ifFalse: [
              iObj isRangeEqualityIndex
                ifTrue: [ index := iObj ] ] ] ].
  index
    ifNil: [
      " no index was found with the given path "
      ^ self _error: #'rtErrNoIndexForPath' args: {aPathString} ].
  [
  IndexManager current
    executeStartingIndexMaintenance: [
      index preIndexRemoval.
      anNSC _removeIndex: index.
      self _removeIndex: index ] ]
    onSynchronous: Error do:[ :ex | IndexingErrorPreventingCommit resignal: ex objWithIndex: anNSC ]
%

category: 'Querying'
method: IndexManager
_reportDataForIndexes
  "private"

  | list |
  list := OrderedCollection new.
  self getAllIndexes do: [ :each | | firstStr string |
      string := each class name copyFrom: 1 to: each class name size - 5.
      (5 < string size and: [ (string copyFrom: 1 to: 5) = 'Range' ])
        ifTrue: [ string := string copyFrom: 6 to: string size ].
      firstStr := string.
      string := each
        inject: ''
        into: [ :str :pathTerm | str , '.' , pathTerm name ].
      string := string copyFrom: 2 to: string size.
      list add: {firstStr.
          string.
          (each isIdentityIndex
            ifTrue: [ '' ]
            ifFalse: [ each lastElementClass name ]).
          (each nscRoot).
          (each isComplete)} ].
  list := list collect: [ :each | | nsc |
      nsc := each at: 4.
      Association new
        key: (each at: 1) , '-' , (each at: 2) , ((each at: 3) notEmpty
                ifTrue: [ '-' , (each at: 3) ]
                ifFalse: [ '' ])
        value:
          nsc size printString , ' (' , nsc asOop printString , ')' , ((each at: 5)
                ifTrue: [ '' ]
                ifFalse: [ ' - INCOMPLETE' ]) ].
  ^ list
%

category: 'Querying'
method: IndexManager
_reportDataForMethods
		"private"

	| indexCreationSelectors classOrganizer smallList bigList |
	classOrganizer := ClassOrganizer new.
	smallList := OrderedCollection new.
	indexCreationSelectors := #(
		#'createEqualityIndexOn:'
		#'createEqualityIndexOn:withLastElementClass:'
		#'createIdentityIndexOn:'
		#'createRcEqualityIndexOn:'
		#'createRcEqualityIndexOn:withLastElementClass:'
	).
	indexCreationSelectors do: [:each | | arrays |
		arrays := classOrganizer sendersOf: each.
		1 to: arrays first size do: [:i |
			smallList add: (Array
				with: (arrays first at: i)
				with: each
				with: (arrays last at: i)).
		].
	].
	smallList := smallList reject: [:each | each first inClass == UnorderedCollection].
	smallList := smallList reject: [:each | each first inClass name == #'IndexedQueryExtensionsTestCase'].
	bigList := OrderedCollection new.
	smallList do: [:each |
		| selector pieces firstPiece lastPiece source index |
		selector := each at: 2.
		pieces := selector subStrings: $:.
		pieces := pieces copyFrom: 1 to: pieces size - 1.
		firstPiece := pieces first.
		lastPiece := pieces last.
		source := each first sourceString.
		index := (each at: 3) - 1.
		[
			0 < (index := source indexOfSubCollection: firstPiece startingAt: index + 1).
		] whileTrue: [
			| readStream array word |
			readStream := ReadStreamPortable on: (source copyFrom: index to: source size).
			array := { ((word := self _nextWordFrom: readStream) copyFrom: 7 to: word size - 8) .
						nil . nil . nil . nil } .
			word := self _nextWordFrom: readStream.
			word := word copyFrom: 2 to: word size - 1.
			[''';.' includes: word last] whileTrue: [word := word copyFrom: 1 to: word size - 1].
			array at: 2 put: word.
			2 <= pieces size ifTrue: [
				self _nextWordFrom: readStream.
                                word := self _nextWordFrom: readStream.
				word := word reject: [:char | ''';.' includes: char].
			] ifFalse: [
				word := ''.
			].
			array
				at: 3 put: word;
				at: 4 put: each first inClass name;
				at: 5 put: each first selector  .
			bigList add: array.
		].
	].
	bigList := bigList collect: [:each |
		Association new
			key: ((each at: 1) , '-' , (each at: 2) ,
					((each at: 3) notEmpty ifTrue: ['-' , (each at: 3)] ifFalse: ['']))
			value: ((each at: 4) , '>>#' , (each at: 5)).
	].
	^ bigList
%

! Class extensions for 'IndexManagerAutoCommitPolicy'

!		Class methods for 'IndexManagerAutoCommitPolicy'

category: 'Instance Creation'
classmethod: IndexManagerAutoCommitPolicy
on: anIndexManager

^ self new indexManager: anIndexManager
%

!		Instance methods for 'IndexManagerAutoCommitPolicy'

category: 'Accessing'
method: IndexManagerAutoCommitPolicy
dirtyObjectCommitThreshold

^ dirtyObjectCommitThreshold
%

category: 'Evaluation'
method: IndexManagerAutoCommitPolicy
evaluate: aBlock for: anIndexManager
  | thresh |
  (thresh := percentTempObjSpaceCommitThreshold) ifNil: [
    "no % memory threshold protection"
    [
      [ TransactionBacklog enableSignalling.
        aBlock value ]
        onException: TransactionBacklog
        do: [ :ex |
          anIndexManager _doCommit.
          TransactionBacklog enableSignalling.
          ex resume ] 
     ] ensure: [ TransactionBacklog disableSignalling ] 
  ] ifNotNil: [ | saveAoom |
    thresh := thresh min: AlmostOutOfMemoryError threshold .
    saveAoom := AlmostOutOfMemoryError enabled.
    [
      [ TransactionBacklog enableSignalling.
        aBlock value 
      ] onException: { AlmostOutOfMemoryError enableAtThreshold: thresh . 
                       TransactionBacklog }
        do: { 
         [ :ex | | systm |
          anIndexManager _doCommit.	
           (systm := System) _vmMarkSweep.
           systm _tempObjSpacePercentUsedLastMark < thresh ifTrue: [
						 "dropped below the threshold, reenable the signal"
						 AlmostOutOfMemoryError enable 
           ] ifFalse: [
             "likely started already above the threshold
             and commits won't necessarily help with out of memory problems"
           ] .
           ex resume 
         ] .
         [:ex | 
           anIndexManager _doCommit.	"get the commit out of the way"
           TransactionBacklog enableSignalling .
           ex resume 
         ] 
        }
     ] ensure: [
         TransactionBacklog disableSignalling.
         saveAoom ifFalse:[ AlmostOutOfMemoryError disable ].
     ] 
  ]
%

category: 'Initialization'
method: IndexManagerAutoCommitPolicy
indexManager: anIndexManager

dirtyObjectCommitThreshold := anIndexManager dirtyObjectCommitThreshold.
percentTempObjSpaceCommitThreshold := anIndexManager percentTempObjSpaceCommitThreshold.
%

category: 'Accessing'
method: IndexManagerAutoCommitPolicy
percentTempObjSpaceCommitThreshold

^ percentTempObjSpaceCommitThreshold
%

category: 'Testing'
method: IndexManagerAutoCommitPolicy
shouldCommit
  "Answer true if enough dirty objects have been modified, or memory is close to full."

  "do not look at % memory used, since we use an exception handler for AlmostOutOfMemory"

 ^ System _numPersistentObjsModified > dirtyObjectCommitThreshold
%

! Class extensions for 'MessageNotUnderstood'

!		Instance methods for 'MessageNotUnderstood'

category: 'Accessing'
method: MessageNotUnderstood
message
	"Answer an object that implements the ANSI failedMessage protocol."

	^Message selector: selector arguments: gsArgs
%

! Class extensions for 'Module'

!		Instance methods for 'Module'

category: 'Instance Migration'
method: Module
migrateInstances: instances to: anotherClass

"Migrates the objects in <instances>, which must be instances of the receiver,
 to anotherClass, using migrateFrom:instVarMap: and performing become: operations
 to accomplish this task.  Removes the indexes of indexed instances.
 Returns an Array of five Sets of instances:

 1. Objects that you cannot read.
 2. Objects that you cannot write.
 3. Objects that are in indexed collections that have different formats.
   (For a more detailed description, see Object | become:.)
 4. Objects whose class is not identical to the receiver.
 5. Objects that could not be migrated due to a MigrationError.

 Objects in any of these sets were not migrated."

| checkidx aMap outerInst
  enumInIndex enumWrite enumRead enumMigrate errSyms
  noread nowrite inIndex badClass migrationErrs |
(self isMeta or:[ anotherClass isMeta]) ifTrue:[
  ArgumentError signal:'cannot migrate meta classes'.
].
enumInIndex := (errSyms := ErrorSymbols) at: #rtErrCantBecomeOneIdx .
enumRead :=  errSyms at: #authErrSegRead .
enumWrite := errSyms at: #authErrSegWrite .
noread := IdentitySet new.
nowrite := IdentitySet new.
inIndex := IdentitySet new.
badClass := IdentitySet new .
migrationErrs := IdentitySet new .
enumMigrate := MigrationError errorNumber .
checkidx := self inheritsFrom: UnorderedCollection.
aMap := InstVarMappingArray mappingFrom: self to: anotherClass .
1 to: instances size do: [:i |
  [ | inst |
    inst := instances _at: i.
    outerInst := inst .
    (checkidx and: [inst _hasIndexes]) ifTrue:[ inst removeAllIndexes ].
    inst class == self ifFalse:[
      badClass add: inst
    ] ifTrue:[  | invariant sema other |
      invariant := inst isInvariant .
      other := anotherClass migrateNew .
      other migrateFrom: inst instVarMap: aMap .
      invariant ifTrue:[ other immediateInvariant ].
      ((inst _onStackAsSelfBelow: 1) or: [ (other _onStackAsSelfBelow: 1) ]) ifTrue:[
	 sema := Semaphore new.
	 [ other become: inst.
	   sema signal.
	 ] fork.
	 sema wait
      ] ifFalse: [
	other become: inst
      ]
    ]
  ] onSynchronous: Exception do:[:ex | | num |
    num := ex number .
    num == enumInIndex ifTrue:[ inIndex add: outerInst . ex return ] ifFalse:[
    num == enumRead ifTrue:[   noread add: outerInst  . ex return ] ifFalse:[
    num == enumWrite ifTrue:[ nowrite add: outerInst  . ex return ] ifFalse:[
    num == enumMigrate ifTrue:[ migrationErrs add: outerInst  . ex return ]]]].
    ex pass
  ]
].
^ { noread . nowrite . inIndex . badClass . migrationErrs }
%

category: 'Instance Migration'
method: Module
migrateInstancesTo: anotherClass

"Migrates all instances of the receiver to anotherClass.
 See migrateInstances:to: for more details.
 Returns an Array of five Sets of instances, some of which will be
 empty when invoked from this method:

 1. (empty) Objects that you cannot read.
 2. Objects that you cannot write.
 3. Objects that are in indexed collections that have different formats.
 4. (empty) Objects whose class is not identical to the receiver.
 5. Objects that could not be migrated due to a MigrationError.

 Objects in any of these sets were not migrated."

| instances |

"check for legal class histories."
(self isMeta or:[ anotherClass isMeta]) ifTrue:[
  ArgumentError signal:'cannot migrate meta classes'.
].

instances := IdentitySet new .
instances addAll: ((SystemRepository listInstancesInMemory: {self}) at: 1).
instances addAll: ((SystemRepository listInstances: { self }) at: 1).

^ self migrateInstances: instances to: anotherClass
%

category: 'Accessing'
method: Module
transientMethodDictForEnv: envId put: aValue
  "aValue should be a GsMethodDictionary, or nil ,
   caller responsible for _refreshClassCache "

<protected>
| ofs set key sz tmds temps |
ofs := envId*4 + 1 .
(sz := (tmds := transientMethDicts) size) < ofs ifTrue:[ tmds size: ofs . sz := ofs ].
tmds at: ofs put: aValue .
set := (temps := SessionTemps current) at: (key := #Module_pinnedClasses) otherwise: nil .
aValue ifNotNil:[
  set ifNil:[
    (set := IdentitySet new) _setNoStubbing .
    temps at: key put: set .
  ].
  set add: self . "keep self in memory"
] ifNil:[
  set ifNotNil:[
    1 to: sz do:[:j | (tmds at: j) ifNotNil:[ ^ self ]].
    set remove: self .
  ].
]
%

category: 'Accessing'
method: Module
_maxSuperclassEnv

"Returns a SmallInteger environmentId, the maximum
  environmentId for which the receiver has a non-default
  value for   (self superclassForEnv: environmentId)
"
<primitive: 1068>

self _primitiveFailed: #_maxSuperclassEnv
%

! Class extensions for 'MultiByteString'

!		Instance methods for 'MultiByteString'

category: 'Converting'
method: MultiByteString
asFoldcase

" Returns the result of UncodeString::foldCase( U_FOLD_CASE_DEFAULT)."

<primitive: 973>
^ self _primitiveFailed: #asFoldcase
%

category: 'Converting'
method: MultiByteString
asLowercaseForLocale: anIcuLocale

"Returns the result of  UncodeString::toLower(anIcuLocale).
 The result will be a Unicode16 or Unicode32.
 See also String >> asLowercase"

<primitive: 971>
^ self _primitiveFailed: #asLowercaseForLocale: args: { anIcuLocale }
%

category: 'Converting'
method: MultiByteString
asTitlecase

  ^ self asTitlecaseForLocale: IcuLocale default
%

category: 'Converting'
method: MultiByteString
asTitlecaseForLocale: anIcuLocale

"Returns the result of
 UncodeString::toTitle(BreakIterator::createTitleInstance(anIcuLocale)"

<primitive: 972>
^ self _primitiveFailed: #asTitlecaseForLocale: args: { anIcuLocale }
%

category: 'Converting'
method: MultiByteString
asUppercaseForLocale: anIcuLocale

"Returns the result of  UncodeString::toUpper(anIcuLocale).
 The result may be a Unicode16 or Unicode32.
See also String >> asUppercase"

<primitive: 970>
self _primitiveFailed: #asUppercaseForLocale: args: { anIcuLocale }
%

category: 'Indexing Support'
method: MultiByteString
sortKeyForCollator: anIcuCollator

"Returns a ByteArray which is the sort key for the
 receiver produced by the specified IcuCollator.

 Calls Collator::getSortKey in coll.h of libicu."

<primitive: 975>
anIcuCollator _validateClass: IcuCollator .
^ self _primitiveFailed: #sortKeyForCollator: args: { anIcuCollator }
%

category: 'Private'
method: MultiByteString
_findStringNocase: subString startingAt: startIndex collator: anIcuCollator

"searches using a copy of anIcuCollator set to TERTIARY matches, and
 using an ICU StringSearch "
<primitive: 944>
subString _validateClasses: { String . Utf8 } .
startIndex _validateClass: SmallInteger .
(startIndex < 1) | (startIndex > self size)
  ifTrue: [ ^ self _error: #objErrBadOffsetIncomplete args: { startIndex } ].
^ self _primitiveFailed: #_findStringNocase:startingAt:collator:
       args: { subString . startIndex . anIcuCollator }
%

category: 'New Indexing Comparison'
method: MultiByteString
_idxUnicodeCompareEqualTo: aCharCollection

"This comparison operation is used for the indexing subsystem to
 determine an ordering for insertion into indexing objects and for
 doing indexing subsystem comparisons.

 This method behaves the same as the = method, except that
 it returns true if the argument is nil."

  aCharCollection ifNil: [ ^ false ].
  aCharCollection isUnicodeString ifFalse: [ "not Unicode"
     aCharCollection _isSymbol ifTrue:[ ^ false ] .
  ].

  ^ (self
    compareTo: aCharCollection
    collator: nil
    useMinSize: 900) == 0
%

category: 'New Indexing Comparison'
method: MultiByteString
_idxUnicodeCompareGreaterThan: aCharCollection

"This comparison operation is used for the indexing subsystem to
 determine an ordering for insertion into indexing objects and for
 doing indexing subsystem comparisons.

 This method collates the same as the > method, except that
 it returns true if the argument is nil."

aCharCollection ifNil: [ ^ true ].
^ (self
    compareTo: aCharCollection
    collator: nil
    useMinSize: 900) == 1
%

category: 'New Indexing Comparison'
method: MultiByteString
_idxUnicodeCompareLessThan: aCharCollection

"This comparison operation is used for the indexing subsystem to
 determine an ordering for insertion into indexing objects and for
 doing indexing subsystem comparisons.

 This method collates the same as the < method, except that
 it returns false if the argument is nil."

 aCharCollection ifNil:[ ^ false ].
 ^ (self
    compareTo: aCharCollection
    collator: nil
    useMinSize: 900) == -1
%

category: 'Comparing'
method: MultiByteString
_unicodeEqual: argString
  "Compares receiver to argument using  IcuCollator default."

^ self _equals: argString collator: nil useMinSize: false
%

category: 'Comparing'
method: MultiByteString
_unicodeGreaterThan: argString
  "Compares receiver to argument using  IcuCollator default."
  ^ (self compareTo: argString collator: nil useMinSize: false) > 0
%

category: 'Comparing'
method: MultiByteString
_unicodeLessThan: argString
  "Compares receiver to argument using  IcuCollator default."
  ^ (self compareTo: argString collator: nil useMinSize: false) < 0
%

! Class extensions for 'Object'

!		Instance methods for 'Object'

category: 'Repository Conversion'
method: Object
fixReferencesAfterConversionFromDirectory: string

"Attempt to old objects to special objects as follows:
        SmallFloat ->           SmallDouble
        Float ->                SmallDouble
        ObsLargePositiveInteger ->      SmallInteger
        ObsLargeNegativeInteger ->      SmallInteger

Note: some instances may not be converted for the following reasons:
        Instance is in an IdentitySet or IdentityBag larger than 2024 elements.
        Instances is in an Array or other oop collection larger than 2024 elements.
        Value of the instance is out of range of the new special object class."

| fn aString refs objs2ndPass alreadyFixed |
  refs := GsBitmap newForHiddenSet: #Customer1.
  objs2ndPass := GsBitmap newForHiddenSet: #Customer2.
  alreadyFixed := GsBitmap newForHiddenSet: #Customer5.
  refs removeAll.
  objs2ndPass removeAll.
  alreadyFixed removeAll.

"Load in the 2 bitmaps that contain refs to LargeInts and Floats"
aString := String withAll: string.
(aString last == $/)
        ifFalse:[aString add: '/'].
fn := String new.
fn addAll: aString; addAll: 'AllLrgIntRefs.bm'.
(GsFile existsOnServer: fn)
        ifTrue:[refs readFromFile: fn]
        ifFalse:[self halt: ('Cannot open file ', fn) ].

fn size: 0; addAll: aString; addAll: 'AllFloatRefs.bm'.
"This one is optional because 6.1.5 conversion does not produce AllFloatRefs.bm"
(GsFile existsOnServer: fn)
        ifTrue:[refs readFromFile: fn].

(refs size) == 0
        ifTrue:[^false].

[ | array |
  System transactionMode: #autoBegin.
  System signalAlmostOutOfMemoryThreshold: 70 .

  [ array := refs enumerateWithLimit: 2000 startingAfter: 0.
    array size == 0] whileFalse:[
        1 to: array size do:[:n| |obj|
                obj := array at: n.
                obj fixReferencesInFirstPass
                        ifTrue:[obj fixRefsAfterConversion] "do it now"
                        ifFalse:[objs2ndPass add: obj]. "save it for later"
                refs removeAll: array.
        ].
  ].
  System commitTransaction ifFalse:[ Object halt: 'error: commit failure!'].
  [ array := objs2ndPass enumerateWithLimit: 2000 startingAfter: 0. array size == 0] whileFalse:[
     1 to: array size do:[:n| |obj|
        obj := array at: n.
        obj fixRefsAfterConversion.
        objs2ndPass removeAll: array
     ].
  ].
  System commitTransaction ifFalse:[Object halt: 'error: commit failure!'].
  ^ alreadyFixed size

] onException: AlmostOutOfMemory do:[:ex |
  "do a commit..."
  System commitTransaction
           ifFalse:[Object halt: 'error: commit failure!'].
   "run another markSweep, to see if we can drop below the threshold..."
  System _vmMarkSweep.
  System signalAlmostOutOfMemoryThreshold: 70 .
  System enableAlmostOutOfMemoryError. "re-enable the exception"
  ex resume
].
%

category: 'Repository Conversion'
method: Object
fixRefsAfterConversion

"Default method for fixing references ObsLargePositiveInteger and
 ObsLargeNegativeInteger instances that can now be represented as
 a SmallInteger and Floats and SmallFloats which can now be represented as
 a SmallDouble."

| convBm |
convBm := (GsBitmap newForHiddenSet: #Conversion).
(convBm includes: self)
        ifTrue:[^false]. "already fixed this one"

self isInternalObject
        ifFalse:[
                self fixInstVarRefsAfterConversion.
                self fixIndexableRefsAfterConversion.
        ].

convBm add: self.
^true
%

category: 'AST-Kernel-Core'
method: Object
value
  "in bootstrap files in case upgrade stops after base image bootstrap"
  ^self
%

category: 'Object Canonicalization'
method: Object
_canonicalizeReferencesUsingPolicy: aReferencingObjectPolicy

	^aReferencingObjectPolicy canonicalizeReferencesInObject: self
%

! Class extensions for 'OptionalPathTerm'

!		Instance methods for 'OptionalPathTerm'

category: 'Audit'
method: OptionalPathTerm
auditDepListFor: obj index: indexObj on: aString
  "Obsolete...use PathTerm>>auditDepListFor:index:on:optionalSentinel: instead"

  self shouldNotImplement: #'auditDepListFor:index:on:'
%

category: 'Testing'
method: OptionalPathTerm
isOptionalTerm
  ^ true
%

category: 'Accessing'
method: OptionalPathTerm
requirePathTerms
  "If missing path slots are tolerated, answer false"

  ^ false
%

category: 'Testing'
method: OptionalPathTerm
termsRequired
  "Answer true if receiver requires that instance variables of indexed objects are present "

  ^ false
%

category: 'Traversing'
method: OptionalPathTerm
_getNextObjectForTraversal: anObject
  " get the next object along the path "

  | ivOffset nextObj |
  ivOffset := anObject _findIVOffsetForPathTerm: self.
  ivOffset == nil
    ifTrue: [ nextObj := nil ]
    ifFalse: [ nextObj := anObject instVarAt: ivOffset ].
  ^ nextObj
%

category: 'Private'
method: OptionalPathTerm
_mapInfoOrErrorForMissingIvOffset: anObject
  "If missing path slots are tolerated, return an empty MappingInfo. Otherwise
   return an error array"

  ^ self _mappingInfoClass new pathTerm: self
%

category: 'Accessing'
method: OptionalPathTerm
_nextObjectFor: anObject
  "Returns the object at the instance variable that corresponds to the receiver
 path term."

  | ivOffset |
  ivOffset := self _ivOffsetFor: anObject.
  ivOffset ifNil: [ ^ nil ].
  ^ self _nextObjectFor: anObject atInstVar: ivOffset
%

! Class extensions for 'OptionalTermPathEvaluator'

!		Instance methods for 'OptionalTermPathEvaluator'

category: 'Testing'
method: OptionalTermPathEvaluator
termsRequired
  "Answer true if receiver requires that instance variables of indexed objects are present "

  ^ false
%

category: 'Traversing'
method: OptionalTermPathEvaluator
_nextObjectFor: anObject at: offset offsets: offsets classes: classes
  "Returns the next object along the path in anObject for the named instance
 variable at the given offset in the receiver."

  | ivOffset |
  (classes at: offset) ~~ anObject class
    ifTrue: [
      ivOffset := anObject class _ivOffsetOf: (self at: offset).
      ivOffset == nil
        ifTrue: [ ^ #'_incompletePathTraversal' ].
      classes at: offset put: anObject class.
      offsets at: offset put: ivOffset ]
    ifFalse: [ ivOffset := offsets at: offset ].
  ivOffset > anObject _primitiveSize
    ifTrue: [ ^ #'_incompletePathTraversal' ].
  ^ anObject instVarAt: ivOffset
%

! Class extensions for 'OrderedCollection'

!		Instance methods for 'OrderedCollection'

category: 'Object Canonicalization'
method: OrderedCollection
_canonicalizeReferencesUsingPolicy: aReferencingObjectPolicy

	^aReferencingObjectPolicy canonicalizeReferencesInObject: self
%

! Class extensions for 'PathEvaluator'

!		Class methods for 'PathEvaluator'

category: 'Converting'
classmethod: PathEvaluator
asMostSpecificType: anArray
  "Returns a new instance of a subclass, or self, depending upon the path.
   A class method to avoid legacyChangeClassTo failing with   self on stack error."
  | evaluator knd |
  evaluator := anArray at: 1 .
  knd := evaluator _kind .
  knd ifNotNil:[
    knd == 2
      ifTrue: [
        evaluator := evaluator legacyChangeClassTo: SetValuedPathEvaluator.
        evaluator _pathTermsRequired: evaluator termsRequired.
        ^ evaluator ].
    knd == 1
      ifTrue: [
        evaluator := evaluator legacyChangeClassTo: EnumeratedPathEvaluator.
        evaluator _pathTermsRequired: evaluator termsRequired.
        ^ evaluator ].
    ^ evaluator legacyChangeClassTo: SelectorPathEvaluator .
  ].
  ^ evaluator
%

category: 'Instance Creation'
classmethod: PathEvaluator
new

"Create a new initialized instance of the receiver."

^ self basicNew initialize
%

!		Instance methods for 'PathEvaluator'

category: 'Converting'
method: PathEvaluator
asPathEvaluator

""

^ self
%

category: 'Converting'
method: PathEvaluator
asQueryEvaluator

  ^self copy
%

category: 'Accessing'
method: PathEvaluator
bagEnumerator
  | res |
  (res := self collator
      ifNil: [ BagEnumerator new ]
      ifNotNil: [ BagUnicodeEnumerator new ])
      evaluator: self;
    doBlock: self doBlock .
  ^ res
%

category: 'Accessing'
method: PathEvaluator
bagIdentityEnumerator
  | res |
  (res := BagEnumerator new)
    evaluator: self;
    doBlock: self doBlock.
  ^ res
%

category: 'Accessing'
method: PathEvaluator
bagRangeEnumeratorGreaterThanAndEquals: bool1 andLessThanAndEquals: bool2
  | enumerator |
  (enumerator := self collator
    ifNil: [ BagRangeEnumerator new ]
    ifNotNil: [ BagUnicodeRangeEnumerator new ])
    evaluator: self;
    doBlock: self doBlock .
  bool1
    ifTrue: [
      bool2
        ifTrue: [ enumerator compareGreaterThanOrEqualAndLessThanOrEqual ]
        ifFalse: [ enumerator compareGreaterThanOrEqualAndLessThan ] ]
    ifFalse: [
      " bool1 is false "
      bool2
        ifTrue: [ enumerator compareGreaterThanAndLessThanOrEqual ]
        ifFalse: [ enumerator compareGreaterThanAndLessThan ] ].
  ^ enumerator
%

category: 'Accessing'
method: PathEvaluator
btreeComparisonQuerySpec

  ^ BtreeComparisonForCompare newForComparison: nil
%

category: 'Accessing'
method: PathEvaluator
collator
  "Returns IcuCollator to be used when comparing Unicode strings ... nil indicates that default collator should be used."

  ^ collator
%

category: 'Accessing'
method: PathEvaluator
collator: anIcuCollator
  "Set the receiver's collator. Use a copy of anIcuCollator to disallow
   changes to strength, etc, that might affect the sort ordering. "

  collator := anIcuCollator copy immediateInvariant
%

category: 'Accessing'
method: PathEvaluator
doBlock
  ^ doBlock
%

category: 'Accessing'
method: PathEvaluator
doBlock: aBlock
  doBlock := aBlock
%

category: 'Query Select'
method: PathEvaluator
findAllValuesEqualTo: aValue
  "Returns a set of all values that satisfy the query."

  | enumerator |
  enumerator := self bagEnumerator compareEqual.
  ^ enumerator findAllValuesFor: aValue
%

category: 'Query Select'
method: PathEvaluator
findAllValuesGreaterThan: val1 andEquals: bool1 andLessThan: val2 andEquals: bool2
  "Returns a set of all values that satisfy the range query."

  | enumerator |
  enumerator := self
    bagRangeEnumeratorGreaterThanAndEquals: bool1
    andLessThanAndEquals: bool2.
  ^ enumerator findAllValuesFor: val1 and: val2
%

category: 'Query Select'
method: PathEvaluator
findAllValuesGreaterThanKey: aValue andEquals: aBoolean
  "Returns a set of all values that satisfy the query."

  | enumerator |
  enumerator := self bagEnumerator.
  aBoolean
    ifTrue: [ enumerator compareGreaterThanOrEqual ]
    ifFalse: [ enumerator compareGreaterThan ].
  ^ enumerator findAllValuesFor: aValue
%

category: 'Query Select'
method: PathEvaluator
findAllValuesIdenticalTo: aValue
  "Returns a set of all values that satisfy the query."

  | enumerator |
  self isIndexOnRootNsc
    ifTrue: [
      doBlock
        ifNil: [
          " optimize query for objects in the NSC itself "
          ^ self _allIdenticalTo: aValue in: nsc ].
      ^ self _allIdenticalTo: aValue in: nsc do: doBlock].
  enumerator := self bagIdentityEnumerator compareIdentical.
  ^ enumerator findAllValuesFor: aValue
%

category: 'Query Select'
method: PathEvaluator
findAllValuesLessThanKey: aValue andEquals: aBoolean
  "Returns a set of all values that satisfy the query."

  | enumerator |
  enumerator := self bagEnumerator.
  aBoolean
    ifTrue: [ enumerator compareLessThanOrEqual ]
    ifFalse: [ enumerator compareLessThan ].
  ^ enumerator findAllValuesFor: aValue
%

category: 'Query Select'
method: PathEvaluator
findAllValuesNotEqualTo: aValue
  "Returns a set of all values that satisfy the query."

  | enumerator |
  enumerator := self bagEnumerator compareNotEqual.
  ^ enumerator findAllValuesFor: aValue
%

category: 'Query Select'
method: PathEvaluator
findAllValuesNotIdenticalTo: aValue
  "Returns a set of all values that satisfy the query."

  | enumerator |
  self isIndexOnRootNsc
    ifTrue: [
      doBlock
        ifNil: [
          " optimize query for objects in the NSC itself "
          ^ self _allNotIdenticalTo: aValue in: nsc ].
      ^ self _allNotIdenticalTo: aValue in: nsc do: doBlock ].
  enumerator := self bagIdentityEnumerator compareNotIdentical.
  ^ enumerator findAllValuesFor: aValue
%

category: 'Query Select'
method: PathEvaluator
findAllValuesWithComparison: selector to: aValue
  "Returns a set of all values that satisfy the query.  Must iterate through all
 elements in the NSC, traversing down the path for each object."

  "Should not be used ... does not handle unicode string comparisons correctly"

  | enumerator |
  enumerator := self bagEnumerator selector: selector.
  ^ enumerator findAllValuesFor: aValue
%

category: 'Query Detect'
method: PathEvaluator
findFirstValueEqualTo: aValue
  "Returns the first value that satisfies the query."

  | enumerator |
  (enumerator := self bagEnumerator)
    compareEqual;
    doBlock: [ :obj | ^ obj ] .
  enumerator findAllValuesFor: aValue.
  ^ #'_incompletePathTraversal'
%

category: 'Query Detect'
method: PathEvaluator
findFirstValueGreaterThan: val1 andEquals: bool1 andLessThan: val2 andEquals: bool2
  ""

  | enumerator |
  (enumerator := self bagRangeEnumeratorGreaterThanAndEquals: bool1
                       andLessThanAndEquals: bool2)
    doBlock: [ :obj | ^ obj ] .
  enumerator findAllValuesFor: val1 and: val2.
  ^ #'_incompletePathTraversal'
%

category: 'Query Detect'
method: PathEvaluator
findFirstValueGreaterThanKey: aValue andEquals: aBoolean
  "Returns the first value that satisfies the query."

  | enumerator |
  (enumerator := self bagEnumerator)
    doBlock: [ :obj | ^ obj ] .
  aBoolean
    ifTrue: [ enumerator compareGreaterThanOrEqual ]
    ifFalse: [ enumerator compareGreaterThan ].
  enumerator findAllValuesFor: aValue.
  ^ #'_incompletePathTraversal'
%

category: 'Query Detect'
method: PathEvaluator
findFirstValueIdenticalTo: aValue
  "Returns the first value that satisfies the query."

  | enumerator |
  self isIndexOnRootNsc
    ifTrue: [
      " optimize query for objects in the NSC itself "
      ^ (nsc includesIdentical: aValue)
        ifTrue: [ aValue ]
        ifFalse: [ #'_incompletePathTraversal' ] ].
  (enumerator := self bagIdentityEnumerator compareIdentical)
    doBlock: [ :obj | ^ obj ] .
  enumerator findAllValuesFor: aValue.
  ^ #'_incompletePathTraversal'
%

category: 'Query Detect'
method: PathEvaluator
findFirstValueLessThanKey: aValue andEquals: aBoolean
  "Returns the first value that satisfies the query."

  | enumerator |
  (enumerator := self bagEnumerator)
    doBlock: [ :obj | ^ obj ] .
  aBoolean
    ifTrue: [ enumerator compareLessThanOrEqual ]
    ifFalse: [ enumerator compareLessThan ].
  enumerator findAllValuesFor: aValue.
  ^ #'_incompletePathTraversal'
%

category: 'Query Detect'
method: PathEvaluator
findFirstValueNotEqualTo: aValue
  "Returns the first value that satisfies the query."

  | enumerator |
  (enumerator := self bagEnumerator compareNotEqual)
    doBlock: [ :obj | ^ obj ] .
  enumerator findAllValuesFor: aValue.
  ^ #'_incompletePathTraversal'
%

category: 'Query Detect'
method: PathEvaluator
findFirstValueNotIdenticalTo: aValue
  "Returns the first value that satisfies the query."

  | enumerator |
  (enumerator := self bagIdentityEnumerator compareNotIdentical)
    doBlock: [ :obj | ^ obj ] .
  enumerator findAllValuesFor: aValue.
  ^ #'_incompletePathTraversal'
%

category: 'Query Detect'
method: PathEvaluator
findFirstValueWithComparison: selector to: aValue
  "Returns the first value that satisfies the query.  Must iterate through the
 elements in the NSC, traversing down the path for each object."

  "Should not be used ... does not handle unicode string comparisons correctly"

  | enumerator |
  enumerator := (selector == #'==' or: [ selector == #'~~' ])
    ifTrue: [ self bagIdentityEnumerator ]
    ifFalse: [ self bagEnumerator ].
  enumerator
    selector: selector;
    doBlock: [ :obj | ^ obj ] .
  enumerator findAllValuesFor: aValue.
  ^ #'_incompletePathTraversal'
%

category: 'Testing'
method: PathEvaluator
hasCollectionBasedTerm
  "Returns true if the path has an enumerated path term or a term that indicates a
   set-valued instance variable."

  ^ self hasEnumeratedTerm or: [ self hasSetValuedTerm ]
%

category: 'Testing'
method: PathEvaluator
hasEnumeratedTerm
  "Returns true if the path has a term that indicates an enumerated path term."

  ^ false
%

category: 'Query Support'
method: PathEvaluator
hasSamePathAs: aPathEvaluator

"Returns whether the given path evaluator is on the same path as the receiver."

" make sure it is a path evaluator "
aPathEvaluator isPathEvaluator
    ifFalse: [ ^ false ].

" make sure they have the same number of terms "
self size == aPathEvaluator size
    ifFalse: [ ^ false ].

" check each term "
1 to: self size do: [ :i |
    (self at: i) == (aPathEvaluator at: i)
        ifFalse: [ ^ false ]
].
^ true
%

category: 'Testing'
method: PathEvaluator
hasSelectorTerm
  "Returns true if the path has a term that indicates a selector."

  ^ false
%

category: 'Testing'
method: PathEvaluator
hasSetValuedTerm
  "Returns true if the path has a term that indicates a set-valued instance
 variable."

  ^ false
%

category: 'Initialization'
method: PathEvaluator
initialize
  "Initialize a new instance of the receiver."

  ivOffsets := {}
%

category: 'Testing'
method: PathEvaluator
isCollectionBased
  "Returns false."

  ^ false
%

category: 'Testing'
method: PathEvaluator
isIdentityIndex

"Returns false."

^ false
%

category: 'Testing'
method: PathEvaluator
isIndexOnNscElements

"Returns whether the receiver is a path directly on the elements of an NSC
 (either the root NSC or a set-valued instance variable along the path)."

^ (self at: self size) ==  #''
%

category: 'Testing'
method: PathEvaluator
isIndexOnRootNsc

"Returns whether the receiver is a path directly on the elements of the root
 NSC."

^ (self at: self size) ==  #''
%

category: 'Testing'
method: PathEvaluator
isPathEvaluator

"Returns true."

^ true
%

category: 'Testing'
method: PathEvaluator
isRangeEqualityIndex

"Returns true.  A path evaluator can perform the searches of an equality
 index."

^ true
%

category: 'Testing'
method: PathEvaluator
isStreamable

"Returns false."

^ false
%

category: 'Accessing'
method: PathEvaluator
ivOffsets

"Returns the value of the instance variable 'ivOffsets'."

^ivOffsets
%

category: 'Updating'
method: PathEvaluator
ivOffsets: newValue

"Modify the value of the instance variable 'ivOffsets'."

ivOffsets := newValue
%

category: 'Accessing'
method: PathEvaluator
lastElementClass
	"Returns the class of the last object along the path (can only be determined if
 the path is fully constrained).  Returns nil if the path is not fully
 constrained."

	^nil	"constraints are no longer supported, so no path will be fully constrained."
%

category: 'Accessing'
method: PathEvaluator
nsc

"Returns the value of the instance variable 'nsc'."

^nsc
%

category: 'Updating'
method: PathEvaluator
nsc: newValue

"Modify the value of the instance variable 'nsc'."

nsc := newValue
%

category: 'Accessing'
method: PathEvaluator
nscRoot

"Returns the value of the instance variable 'nsc'."

^nsc
%

category: 'Testing'
method: PathEvaluator
optimizingComparison
  "Answer true if comparison operations can be optimized in Btree operations and elsewhere.
   Controlled by optimizedComparison index option."

  "this type of optimization can only be done in concert with an index."

  ^ false
%

category: 'Accessing'
method: PathEvaluator
pathComponentsString

"Returns a string of the path components."

| str sz |
sz := self size.
str := String new.
1 to: sz do: [ :i |
    str addAll: (self at: i).
    i == sz
        ifFalse: [ str add: $.  ]
].
^ str

%

category: 'Accessing'
method: PathEvaluator
progress: anInteger

"ignored - required for autoCommit functionality"
%

category: 'Accessing'
method: PathEvaluator
sizeForNscBuilder
  "Returns the size to be used when an NscBuilder is collecting objects
 based upon the receiver's path."

  ^ self hasSetValuedTerm
    ifTrue: [ NscBuilder maxSize ]
    ifFalse: [ nsc size ]
%

category: 'Sorting'
method: PathEvaluator
sortNodeClass
  "Returns the class of SortNode to use."

  ^ SortNode
%

category: 'Testing'
method: PathEvaluator
termsRequired
  "Answer true if receiver requires that instance variables of indexed objects are present "

  ^ true
%

category: 'Query Select'
method: PathEvaluator
tmpHolder
  ^ NscBuilder for: nsc species new max: self sizeForNscBuilder
%

category: 'Query Support'
method: PathEvaluator
traverse: anObject andCompare: selector with: aValue
  "Traverse the given object and perform the comparison operation
 on the object at the end of the path and the given value."

  "This method assumes that the index is not over a set-valued instance variable."

  "This method is intended for support of QueryExecutor only"

  | endObj |
  ^ (endObj := self _traverseObject: anObject) ~~ #'_incompletePathTraversal'
    and: [ endObj perform: selector with: aValue ]
%

category: 'Query Support'
method: PathEvaluator
traverse: anObject andCompare: selector withTraverser: aTraverser
  "Traverse the given object and perform the comparison operation on the object
 at the end of the path and the value obtained by using the traverser."

  "This method assumes that the index is not over a set-valued instance variable."

  "This method is intended for support of QueryExecutor only"

  | endObj1 endObj2 |
  ^ (endObj1 := self _traverseObject: anObject) ~~ #'_incompletePathTraversal'
    and: [
      (endObj2 := aTraverser _traverseObject: anObject) ~~ #'_incompletePathTraversal'
        and: [ endObj1 perform: selector with: endObj2 ] ]
%

category: 'Traversing'
method: PathEvaluator
traverse: anObject cachedOffsets: cachedOffsets cachedClasses: cachedClasses do: aBlock
  | nextObj |
  nextObj := self
    _traverse: anObject
    cachedOffsets: cachedOffsets
    cachedClasses: cachedClasses
    incomplete: #'_incompletePathTraversal'.
  nextObj ~~ #'_incompletePathTraversal'
    ifTrue: [ aBlock value: nextObj ]
%

category: 'Traversing'
method: PathEvaluator
traverse: anObject do: aBlock
  "Traverse the sub-objects of anObject, using the path names of the receiver starting at the path name at the given offset.  For each object at the end of
 the traversal, evaluate the given block."

  ^ self traverse: anObject startingAt: 1 do: aBlock
%

category: 'Traversing'
method: PathEvaluator
traverse: anObject startingAt: offset do: aBlock
  "Traverse the sub-objects of anObject, using the path names of the receiver starting at the path name at the given offset.  For each object at the end of
 the traversal, evaluate the given block."

  | nextObj ivOffset pathName sz |
  (nil == anObject _and: [ self isIndexOnNscElements not ])
    ifTrue: [ ^ self ].
  nextObj := anObject.
  sz := self size.
  offset to: sz do: [ :i |
    " get the next object along the path "
    nil == nextObj
      ifTrue: [ ^ self ].
    pathName := self at: i.
    ivOffset := nextObj class _ivOffsetOf: pathName.
    ivOffset == nil
      ifTrue: [
        nextObj _errorInvalidOffset: pathName.
        nextObj := nil ]
      ifFalse: [ nextObj := nextObj instVarAt: ivOffset ].
    (nil == nextObj _and: [ i ~= sz ])
      ifTrue: [ ^ self ] ].
  ^ aBlock value: nextObj
%

category: 'Traversing'
method: PathEvaluator
traverse: anObject startingAt: offset into: resultSet
  "Traverse the sub-objects of all the objects in the NSC, using the path names
 of the receiver starting at the path term at the given offset.  Add each
 object at the end of the traversal to the result set.  Returns the result
 set."

  self
    traverse: anObject
    startingAt: offset
    do: [ :nextObj | resultSet add: nextObj ].
  ^ resultSet
%

category: 'Traversing'
method: PathEvaluator
traverseObject: anObject
  "Traverse the sub-objects of the given object using the path names of the
 receiver.  This method assumes that the index is not over a set-valued
 instance variable.  For that kind of index, use the traverse:startingAt:into:
 method.  If a nil value is reached before the end of the path, returns the
 incompletePathTraversalObject."

  "This method is intended for support of QueryExecutor only"

  self isIndexOnNscElements
    ifTrue: [ ^ anObject ].
  nil == anObject
    ifTrue: [ ^ #'_incompletePathTraversal' ].
  ^ self _traverseObject: anObject
%

category: 'Traversing'
method: PathEvaluator
traverseObject: anObject
incompletesInto: incompleteArray
incomplete: incomplete

"Traverse the sub-objects of the given object using the path names of the
 receiver.  This method assumes that the index is not over a set-valued
 instance variable.  For that kind of index, use the traverse:startingAt:into:
 method.  If a nil value is reached before the end of the path, place the object
 into the appropriate Array in the incompleteArray of Arrays."

self isIndexOnNscElements
    ifTrue: [ ^ anObject ].

nil == anObject
    ifTrue: [ ^ incomplete ].

^ self _traverseObject: anObject
  incompletesInto: incompleteArray
  incomplete: incomplete
%

category: 'Traversing'
method: PathEvaluator
traverseUsingAccessors: anObject do: aBlock
  "Traverse the sub-objects of anObject, using the path names of the receiver as accessor
   selectors.  For each object at the end of the traversal, evaluate the given block."

  | nextObj sz accessor |
  (nil == anObject _and: [ self isIndexOnNscElements not ])
    ifTrue: [ ^ self ].
  nextObj := anObject.
  sz := self size.
  1 to: sz do: [ :i |
    " get the next object along the path using the inst var name as an accessor message "
    nil == nextObj
      ifTrue: [ ^ self ].
    accessor := self at: i.
    nextObj := nextObj perform: accessor asSymbol.
    (nil == nextObj _and: [ i ~= sz ])
      ifTrue: [ ^ self ] ].
  ^ aBlock value: nextObj
%

category: 'Traversing'
method: PathEvaluator
traverseUsingAccessors: anObject to: sz do: aBlock
  "Traverse the sub-objects of anObject, using the path names of the receiver as accessor
   selectors.  For each object at the end of the traversal, evaluate the given block."

  | nextObj  accessor |
  (nil == anObject _and: [ self isIndexOnNscElements not ])
    ifTrue: [ ^ self ].
  nextObj := anObject.
  1 to: sz do: [ :i |
    " get the next object along the path using the inst var name as an accessor message "
    nil == nextObj
      ifTrue: [ ^ self ].
    accessor := self at: i.
    nextObj := nextObj perform: accessor asSymbol.
    (nil == nextObj _and: [ i ~= sz ])
      ifTrue: [ ^ self ] ].
  ^ aBlock value: nextObj
%

category: 'Query Support'
method: PathEvaluator
_allIdenticalTo: anObject in: anNsc
  "Returns a new NSC containing the given object with the number of occurrences
 as in the given NSC."

  | result tmp |
  result := self _primAllIdenticalTo: anObject in: anNsc _asIdentityBag.
  result class = anNsc species
    ifFalse: [
      tmp := anNsc species new.
      tmp addAll: result.
      result := tmp ].
  ^ result
%

category: 'Query Support'
method: PathEvaluator
_allIdenticalTo: anObject in: anNsc do: aBlock
  "Returns a new NSC containing the given object with the number of occurrences
 as in the given NSC."

  | result |
  result := self _primAllIdenticalTo: anObject in: anNsc _asIdentityBag.
  ^ result do: aBlock
%

category: 'Query Support'
method: PathEvaluator
_allNotIdenticalTo: anObject in: anNsc
  "Returns a new NSC containing the given object with the number of occurrences
 as in the given NSC."

  | result anIdentityBag tmp |
  anIdentityBag := anNsc _asIdentityBag.
  result := anIdentityBag copy.
  result removeAll: (self _allIdenticalTo: anObject in: anIdentityBag).
  result class = anNsc species
    ifFalse: [
      tmp := anNsc species new.
      tmp addAll: result.
      result := tmp ].
  ^ result
%

category: 'Query Support'
method: PathEvaluator
_allNotIdenticalTo: anObject in: anNsc do: aBlock
  "Returns a new NSC containing the given object with the number of occurrences
 as in the given NSC."

  | result anIdentityBag |
  anIdentityBag := anNsc _asIdentityBag.
  result := anIdentityBag copy.
  result removeAll: (self _allIdenticalTo: anObject in: anIdentityBag).
  ^ result do: aBlock
%

category: 'Testing'
method: PathEvaluator
_commonPathTermsWith: anEvaluatorOrIndex
  ^ anEvaluatorOrIndex _commonPathTermsWithPathEvaluator: self
%

category: 'Testing'
method: PathEvaluator
_commonPathTermsWithIndex: anIndex
  | commonSize commonTerms |
  commonSize := self size min: anIndex size.
  commonTerms := {}.
  1 to: commonSize do: [ :index |
    | term |
    (term := self at: index) = (anIndex at: index) name
      ifFalse: [ ^ commonTerms ].
    commonTerms add: term ].
  ^ commonTerms
%

category: 'Testing'
method: PathEvaluator
_commonPathTermsWithPathEvaluator: anPathEvaluator
  | commonSize commonTerms |
  commonSize := self size min: anPathEvaluator size.
  commonTerms := {}.
  1 to: commonSize do: [ :index |
    | term |
    (term := self at: index) = (anPathEvaluator at: index)
      ifFalse: [ ^ commonTerms ].
    commonTerms add: term ].
  ^ commonTerms
%

category: 'Traversing'
method: PathEvaluator
_createIvOffsetCache
  | ivOffsetCache sz |
sz := self size .
ivOffsetCache := { Array new: sz . Array new: sz }.
^ivOffsetCache
%

category: 'Traversing'
method: PathEvaluator
_initTraverseCache

"Do nothing."

%

category: 'Converting'
method: PathEvaluator
_kind
  "Returns 2 for set valued term, 1 for enumerated term, 0 for selector term,
   nil otherwise. "
  | sv enum sel |
  1 to: self size do: [ :i | | elem |
    elem := self at: i .
    elem size ~~ 0 ifTrue:[
      elem == #'*'
        ifTrue:[ sv := true ]
        ifFalse:[
          (elem includesValue: $| ) "enumerated" ifTrue: [ enum := true ].
          (elem at: 1) == $#  ifTrue:[ sel := true ].
        ]
      ]
  ].
  sv ifNotNil:[ ^ 2 ].
  enum ifNotNil:[ ^ 1 ].
  sel ifNotNil:[ ^ 0 ].
  ^ nil
%

category: 'Traversing'
method: PathEvaluator
_nextObjectFor: anObject at: offset

"Returns the next object along the path in anObject for the named instance
 variable at the given offset in the receiver."

| ivOffset |
ivOffset := anObject class _ivOffsetOf: (self at: offset).

ivOffset == nil
  ifTrue: [ anObject _errorInvalidOffset: (self at: offset) ].

( ivOffset > anObject _primitiveSize )
    ifTrue: [ ^ #_incompletePathTraversal ].

^ anObject instVarAt: ivOffset
%

category: 'Traversing'
method: PathEvaluator
_nextObjectFor: anObject at: offset offsets: offsets classes: classes

"Returns the next object along the path in anObject for the named instance
 variable at the given offset in the receiver."

| ivOffset  |
(classes at: offset) ~~ anObject class
  ifTrue: [
    ivOffset := anObject class _ivOffsetOf: (self at: offset).
    ivOffset == nil
      ifTrue: [ anObject _errorInvalidOffset: (self at: offset) ].
    classes at: offset put: anObject class.
    offsets at: offset put: ivOffset.
  ]
  ifFalse: [
    ivOffset := offsets at: offset.
  ].

( ivOffset > anObject _primitiveSize )
    ifTrue: [ ^ #_incompletePathTraversal ].

^ anObject instVarAt: ivOffset
%

category: 'Query Support'
method: PathEvaluator
_primAllIdenticalTo: anObject in: aBag

"Returns a new NSC containing the given object with the number of occurrences as
 in the given NSC."

<primitive: 340>
self _primitiveFailed: #allIdenticalTo:in: args: { anObject . aBag } .
self _uncontinuableError
%

category: 'Sorting'
method: PathEvaluator
_sortOn: indexObjs directions: theBooleans persistentRoot: persistentArrayOrNil

"Returns an Array of objects from the receiver's NSC that is sorted according
 to the paths traversed by indexObjs (with the direction of the sort specified
 in theBooleans)."

  | sorter |

sorter := PathSorter on: indexObjs directions: theBooleans.
(IndexManager autoCommit and: [ persistentArrayOrNil ~~ nil ])
  ifTrue: [ | mgr result |
    (mgr := IndexManager current) executeStartingIndexMaintenance: [
      persistentArrayOrNil add: sorter.
      mgr  _doCommit.
      result := self _sortOn: indexObjs using: sorter persistentRoot: persistentArrayOrNil.
      persistentArrayOrNil size: 0 ].
    ^result ]
  ifFalse: [
    ^ self _sortOn: indexObjs using: sorter persistentRoot: nil
  ]
%

category: 'Sorting'
method: PathEvaluator
_sortOn: indexObjs using: sorter persistentRoot: persistentArrayOrNil

"Returns an Array of objects from the receiver's NSC that is sorted according
 to the paths traversed by indexObjs (with the direction of the sort specified
 in theBooleans)."

|  obj aColl firstIncompleteArray sortNodes anArray
  hasSecondarySort incompletesArrays incomplete indexManager |

sortNodes := sorter sortNodes.
hasSecondarySort := indexObjs size > 1.
incomplete := #_incompletePathTraversal.

incompletesArrays := sorter incompletes.
firstIncompleteArray := incompletesArrays at: 1.

aColl := nsc _asCollectionForSorting.

persistentArrayOrNil ~~ nil ifTrue: [ persistentArrayOrNil add: aColl ].
" optimize when no traversal is needed "
indexManager := IndexManager current.
self isIndexOnRootNsc
  ifTrue: [
    1 to: aColl size do: [ :i |
      obj := aColl _at: i.
      obj == nil
        ifTrue: [ firstIncompleteArray add: nil ]
        ifFalse: [
          sorter _addObject: obj
            inNodes: sortNodes
            hasSecondarySort: hasSecondarySort
        ].
      (i \\ 100) == 0 ifTrue:[ indexManager commitIndexMaintenance: self at: i ].
    ].
  ]
  ifFalse: [
    1 to: aColl size do: [ :i |
      obj := aColl _at: i.
      obj == nil
        ifTrue: [ firstIncompleteArray add: nil ]
        ifFalse: [
          sorter _addObject: obj
            inNodes: sortNodes
            hasSecondarySort: hasSecondarySort
            incompletes: incompletesArrays
            incomplete: incomplete
        ].
      (i \\ 100) == 0 ifTrue:[ indexManager commitIndexMaintenance: self at: i ].
    ]
  ].

anArray := Array new: nsc size.
persistentArrayOrNil ~~ nil
  ifTrue: [
    persistentArrayOrNil add: anArray.
    indexManager commitIndexMaintenance: self at: aColl size.
 ].
^ sorter sortInto: anArray startingAt: 1
%

category: 'Traversing'
method: PathEvaluator
_traverse: anObject
cachedOffsets: offsets
cachedClasses: classes
incomplete: incompletePathTraversal

<primitive: 593>

| nextObj sz |
nextObj := anObject.
sz := self size.
1 to: sz do: [ :i |
  (offsets == nil)
     ifTrue: [  nextObj := self _nextObjectFor: nextObj at: i ]
     ifFalse: [  nextObj := self _nextObjectFor: nextObj at: i offsets: offsets classes: classes ].

  ( nil == nextObj and: [ i ~~ sz ] )
    ifTrue: [ ^ #_incompletePathTraversal ].

  (nextObj == #_incompletePathTraversal)
    ifTrue: [ ^ nextObj ].

].
^ nextObj
%

category: 'Traversing'
method: PathEvaluator
_traverseObject: anObject
  "Traverse the sub-objects of the given object using the path names of the
 receiver.  This method assumes that the index is not over a set-valued
 instance variable.  For that kind of index, use the traverse:startingAt:into:
 method.  If a nil value is reached before the end of the path, returns the
 incompletePathTraversalObject."

  "This method is intended for support of QueryExecutor only"

  ^ self
    _traverse: anObject
    cachedOffsets: nil
    cachedClasses: nil
    incomplete: #'_incompletePathTraversal'
%

category: 'Traversing'
method: PathEvaluator
_traverseObject: anObject cache: ivOffsetCache
  "Traverse the sub-objects of the given object using the path names of the
 receiver.  This method assumes that the index is not over a set-valued
 instance variable.  For that kind of index, use the traverse:startingAt:into:
 method.  If a nil value is reached before the end of the path, returns the
 incompletePathTraversalObject."

  "This method is intended for support of QueryExecutor only"

  ^ self
    _traverse: anObject
    cachedOffsets: (ivOffsetCache at: 2)
    cachedClasses: (ivOffsetCache at: 1)
    incomplete: #'_incompletePathTraversal'
%

category: 'Traversing'
method: PathEvaluator
_traverseObject: anObject incompletesInto: incompleteArray incomplete: incomplete
  "Traverse the sub-objects of the given object using the path names of the
 receiver.  This method assumes that the index is not over a set-valued
 instance variable.  For that kind of index, use the traverse:startingAt:into:
 method.  If a nil value is reached before the end of the path, place the object
 into the appropriate Array in the incompleteArray of Arrays."

  "Intended for support of PathSort ... no collection-based terms"

  | nextObj sz |
  nextObj := anObject.
  sz := self size.
  1 to: sz do: [ :i |
    nextObj := self _nextObjectFor: nextObj at: i.
    ((nil == nextObj and: [ i ~~ sz ])
      or: [ nextObj == #'_incompletePathTraversal' ])
      ifTrue: [
        incompleteArray == nil
          ifTrue: [ ^ nil ].
        (incompleteArray at: i + 1) add: anObject.
        ^ incomplete ] ].
  ^ nextObj
%

! Class extensions for 'PathPathBagEnumerator'

!		Instance methods for 'PathPathBagEnumerator'

category: 'accessing'
method: PathPathBagEnumerator
evaluator2: anObject

   "Modify the value of the instance variable 'evaluator2'."
   evaluator2 := anObject
%

category: 'querying'
method: PathPathBagEnumerator
findAllValues
  | theBlock tmpHolder result |
  theBlock := doBlock.
  theBlock
    ifNil: [
      tmpHolder := evaluator tmpHolder.
      theBlock := [ :each | tmpHolder add: each ] ].
  result := evaluator isIndexOnRootNsc
    ifTrue: [
      self _createIvOffsetCacheFor: evaluator2.
      self _findRootValuesDo: theBlock ]
    ifFalse: [
      evaluator2 isIndexOnRootNsc
        ifTrue: [
          self _createIvOffsetCacheFor: evaluator.
          self _findRootValuesDo: theBlock ]
        ifFalse: [
          evaluator isCollectionBased
            ifTrue: [ self _findTraversedCollectionBasedValuesDo: theBlock ]
            ifFalse: [
              self _createIvOffsetCache.
              self _createIvOffsetCache2For: evaluator2.
              self _findTraversedValuesDo: theBlock ] ] ].
  ^ doBlock ifNil: [ tmpHolder completeBag ] ifNotNil: [ result ]
%

category: 'querying'
method: PathPathBagEnumerator
findAllValuesFor: aValue1
  self shouldNotImplement: #'findAllValuesFor:'
%

category: 'querying'
method: PathPathBagEnumerator
findAllValuesFor: aValue1 and: aValue2
  self shouldNotImplement: #'findAllValuesFor:and:'
%

category: 'testing'
method: PathPathBagEnumerator
value: aValue and: ignored test: endObj
  self shouldNotImplement: #'value:and:test:'
%

category: 'testing'
method: PathPathBagEnumerator
value: aValue test: endObj
  ^ evaluator isIndexOnRootNsc
    ifTrue: [ endObj perform: selector with: aValue ]
    ifFalse: [ aValue perform: selector with: endObj ]
%

category: 'querying'
method: PathPathBagEnumerator
_createIvOffsetCache2For: anEvaluator
  | cache |
  cache := anEvaluator _createIvOffsetCache.
  ivOffsetCache3 := cache at: 1.
  ivOffsetCache4 := cache at: 2
%

category: 'querying'
method: PathPathBagEnumerator
_findRootValuesDo: aBlock
  "evaluator isIndexOnRootNsc ... true"

  1 to: bag size do: [ :i |
    | obj |
    (obj := bag _at: i) ~~ nil
      ifTrue: [
        | endObj |
        endObj := evaluator2
          _traverse: obj
          cachedOffsets: ivOffsetCache2
          cachedClasses: ivOffsetCache1
          incomplete: #'_incompletePathTraversal'.
        endObj ~~ #'_incompletePathTraversal'
          ifTrue: [
            (self value: obj test: endObj)
              ifTrue: [ aBlock value: obj ] ] ] ]
%

category: 'querying'
method: PathPathBagEnumerator
_findTraversedCollectionBasedValuesDo: aBlock
  | obj |
  1 to: bag size do: [ :i |
    (obj := bag _at: i) ~~ nil
      ifTrue: [
        evaluator
          traverse: obj
          do: [ :endObj1 |
            evaluator2
              traverse: obj
              do: [ :endObj2 |
                (self value: endObj1 test: endObj2)
                  ifTrue: [ aBlock value: obj ] ] ] ] ]
%

category: 'querying'
method: PathPathBagEnumerator
_findTraversedValuesDo: aBlock
  "This method assumes that the evaluator is not over a collection-based instance variable."

  1 to: bag size do: [ :i |
    | obj |
    (obj := bag _at: i) ~~ nil
      ifTrue: [
        | endObj1 |
        endObj1 := evaluator
          _traverse: obj
          cachedOffsets: ivOffsetCache2
          cachedClasses: ivOffsetCache1
          incomplete: #'_incompletePathTraversal'.
        endObj1 ~~ #'_incompletePathTraversal'
          ifTrue: [
            | endObj2 |
            endObj2 := evaluator2
              _traverse: obj
              cachedOffsets: ivOffsetCache4
              cachedClasses: ivOffsetCache3
              incomplete: #'_incompletePathTraversal'.
            endObj2 ~~ #'_incompletePathTraversal'
              ifTrue: [
                (self value: endObj1 test: endObj2)
                  ifTrue: [ aBlock value: obj ] ] ] ] ]
%

! Class extensions for 'PathPathBagUnicodeEnumerator'

!		Instance methods for 'PathPathBagUnicodeEnumerator'

category: 'accessing'
method: PathPathBagUnicodeEnumerator
evaluator: anEvaluator
  super evaluator: anEvaluator.
  collator := anEvaluator collator
%

category: 'accessing'
method: PathPathBagUnicodeEnumerator
value: aValue test: endObj
  ^ evaluator isIndexOnRootNsc
    ifTrue: [ endObj perform: selector with: aValue with: collator ]
    ifFalse: [ aValue perform: selector with: endObj with: collator ]
%

! Class extensions for 'PathSorter'

!		Class methods for 'PathSorter'

category: 'Instance Creation'
classmethod: PathSorter
new

"Disallowed.  To create a new instance, use the on:directions: method."

self shouldNotImplement: #new
%

category: 'Instance Creation'
classmethod: PathSorter
on: traversers directions: directions
  "Returns a new initialized instance."

  ^ self on: traversers directions: directions collator: nil
%

category: 'Instance Creation'
classmethod: PathSorter
on: traversers directions: directions collator: anIcuCollator
  "Returns a new initialized instance."

  | newOne sortNode incompletes traverser |
  newOne := super new.
  newOne collator: anIcuCollator.
  1 to: traversers size do: [ :i | newOne add: (traversers at: i) ].
  traverser := traversers at: 1.
  incompletes := {}.
  traverser size timesRepeat: [ incompletes add: {} ].
  sortNode := (newOne sortNodeClassForSortLevel: 1) new: traverser nscRoot size.
  sortNode collator: anIcuCollator.
  sortNode sortLevel: 1.
  sortNode pathSorter: newOne.
  newOne sortNodes: (SortNodeArray with: sortNode).
  newOne directions: directions.
  newOne incompletes: incompletes.
  ^ newOne
%

!		Instance methods for 'PathSorter'

category: 'Updating'
method: PathSorter
addObject: anObject

"Adds anObject to the sort nodes maintained by the receiver."

self _addObject: anObject
  inNodes: sortNodes
  hasSecondarySort: (self size > 1)
  incompletes: incompletes
  incomplete: #_incompletePathTraversal
%

category: 'Indexing Support'
method: PathSorter
btreeAt: aKey put: aValue
  "Add key/value to the sort nodes maintained by the receiver."

  | lastNode sortLevel |
  lastNode := sortNodes at: self lastNodeOffset.	" if the last sort node is full, create a new one "
  lastNode isFull
    ifTrue: [
      | i |
      i := self lastNodeOffset + 1.
      self lastNodeOffset: i.
      sortLevel := lastNode sortLevel.
      lastNode := lastNode class new: lastNode numElements.
      lastNode collator: self collator.
      lastNode sortLevel: sortLevel.
      lastNode pathSorter: self.
      sortNodes at: i put: lastNode ].	" add an entry to the sort node "
  lastNode btreeAt: aKey put: aValue
%

category: 'Indexing Support'
method: PathSorter
btreeAt: aKey put: aValue for: anIndexObj selectiveAbortSet: selectiveAbortSetOrNil

"Add key/value to the sort nodes maintained by the receiver. Compatability for Rc equality indexes."

^ self btreeAt: aKey put: aValue
%

category: 'Updating'
method: PathSorter
clear

"Sets the state of the receiver so that no objects have been added to the sort
 node."

sortNodes size: 1.
(sortNodes at: 1) numElements: 0.
(sortNodes at: 1) totalElements: 0.
1 to: incompletes size do: [ :i |
  (incompletes at: i) size: 0
]
%

category: 'Accessing'
method: PathSorter
collator
  "Returns IcuCollator to be used when comparing Unicode strings ... nil indicates that default collator should be used."

  ^ collator
%

category: 'Accessing'
method: PathSorter
collator: anIcuCollator
  "Set the receiver's collator. Use a copy of anIcuCollator to disallow
   changes to strength, etc, that might affect the sort ordering. "

  collator := anIcuCollator copy immediateInvariant
%

category: 'Indexing Support'
method: PathSorter
createInteriorNodesFor: nodeArray
  "Construct B-tree interior nodes for the given Array of leaf nodes.
 Returns the root B-tree node."

  | intNode eSize k node max nodeClass m n end array sz anObjectSecurityPolicy aCollator |
  nodeArray size == 1
    ifTrue: [ ^ nodeArray at: 1 ].
  node := nodeArray at: 1.
  anObjectSecurityPolicy := node objectSecurityPolicy.
  aCollator := node collator.
  nodeClass := node parentNodeClass.
  max := node maxNumWhenMerging.
  eSize := node entrySize.
  m := eSize - 2.
  array := {}.
  sz := nodeArray size.
  1 to: sz by: max do: [ :i |
    intNode := nodeClass new.
    intNode objectSecurityPolicy: anObjectSecurityPolicy;
          collator: aCollator.
    n := 1.
    end := i + max - 1 min: sz.
    i to: end do: [ :j |
      node := nodeArray at: j.
      k := node numElements * eSize.	" offset of last slot "
      k > 0
        ifTrue: [
          "node copyFrom: k - m to: k into: intNode startingAt: n + 1."
          intNode
            replaceFrom: n + 1
            to: n + 1 + m
            with: node
            startingAt: k - m.
          intNode _at: n put: node.
          n := n + eSize ] ].
    n > 1
      ifTrue: [
        intNode numElements: end - i + 1.
        intNode lastValue: (intNode _at: n - eSize) lastValue.
        array add: intNode ] ].
  array size == 1
    ifTrue: [ ^ array at: 1 ]
    ifFalse: [ ^ self createInteriorNodesFor: array ]
%

category: 'Accessing'
method: PathSorter
directions

"Returns the value of the instance variable 'directions'."

^directions
%

category: 'Updating'
method: PathSorter
directions: newValue

"Modifies the value of the instance variable 'directions'."

directions := newValue
%

category: 'Accessing'
method: PathSorter
incompletes

"Returns the value of the instance variable 'incompletes'."

^incompletes
%

category: 'Updating'
method: PathSorter
incompletes: newValue

"Modifies the value of the instance variable 'incompletes'."

incompletes := newValue
%

category: 'Testing'
method: PathSorter
isBtreeNode

"Returns false, the receiver is not a B-tree node."

^ false
%

category: 'Accessing'
method: PathSorter
lastNodeOffset

"Returns the value of the instance variable 'lastNodeOffset'."

^lastNodeOffset
%

category: 'Updating'
method: PathSorter
lastNodeOffset: newValue

"Modifies the value of the instance variable 'lastNodeOffset'."

lastNodeOffset := newValue
%

category: 'Private'
method: PathSorter
removeKey: aKey value: aValue

"Raises an error because the receiver is currently in use building an index."

self _errorIndexCreationInProgress
%

category: 'Sorting'
method: PathSorter
sortInto: anArray startingAt: index

"Returns anArray filled with objects that have been added to the receiver, in
 sorted order."

sortNodes sortInto: anArray startingAt: index incompletes: incompletes.
^ anArray
%

category: 'Indexing Support'
method: PathSorter
sortIntoBtreeNodes: anArray

"Returns anArray filled with B-tree leaf nodes, in which all
 entries are in sorted order."

sortNodes sortIntoBtreeNodes: anArray.
^ anArray
%

category: 'Accessing'
method: PathSorter
sortNodeClassForSortLevel: anInteger
  "Returns the class of SortNode to create for the given sort level."

  ^ (self at: anInteger) sortNodeClass
%

category: 'Accessing'
method: PathSorter
sortNodes

"Returns the value of the instance variable 'sortNodes'."

^sortNodes
%

category: 'Updating'
method: PathSorter
sortNodes: newValue

"Modify the value of the instance variable 'sortNodes'."

sortNodes := newValue
%

category: 'Updating'
method: PathSorter
_addObject: anObject
inNodes: nodeArray
hasSecondarySort: hasSecondarySort

"Adds anObject to the last sort node in nodeArray.  The key used to sort
 anObject is derived by traversing anObject on the receivers path specified by
 the last sort node in the node Array."

| node sortLevel index sz lastNode |

hasSecondarySort
  ifTrue: [
    lastNode := nodeArray at: nodeArray size.

    " if last node is full, check for duplicate keys in all nodes,
      otherwise check in all but the last node "
    lastNode isFull
      ifTrue: [ sz := nodeArray size ]
      ifFalse: [ sz := nodeArray size - 1 ].

    " see if any previous sort nodes contain this object "
    1 to: sz do: [ :i |
      node := nodeArray at: i.
      index := node _findCoveringIndexForKey: anObject totalOrder: false.
      ( index > 0 and:
      [ node _compareKey: anObject equalToEntryAt: (index + 1) ] )
        ifTrue: [ " found it "
          node totalElements: node totalElements + 1.
          ^ node _insertDuplicateKey: anObject value: anObject atIndex: index
        ]
    ].

    lastNode isFull
      ifTrue: [
        sortLevel := lastNode sortLevel.
        lastNode := lastNode class new: lastNode class maxNumberOfElements.
        lastNode sortLevel: sortLevel.
        lastNode pathSorter: self.
        nodeArray add: lastNode
      ].

    " add an entry to the sort node "
    lastNode _at: anObject
      put: anObject
      forBtree: false
      hasSecondarySort: hasSecondarySort
  ]
  ifFalse: [
    lastNode := nodeArray at: nodeArray size.
    " if the last sort node is full, create a new one "
    lastNode isFull
      ifTrue: [
        sortLevel := lastNode sortLevel.
        lastNode := lastNode class new: lastNode numElements.
        lastNode sortLevel: sortLevel.
        lastNode pathSorter: self.
        nodeArray add: lastNode
    ].

  " add an entry to the sort node "
  lastNode _at: anObject
    put: anObject
    forBtree: false
    hasSecondarySort: hasSecondarySort
  ]
%

category: 'Updating'
method: PathSorter
_addObject: anObject
inNodes: nodeArray
hasSecondarySort: hasSecondarySort
incompletes: incompleteArrays
incomplete: incomplete

"Adds anObject to the last sort node in nodeArray.  The key used to sort
 anObject is derived by traversing anObject on the receivers path specified by
 the last sort node in the node Array."

| node key sortLevel index sz lastNode |

hasSecondarySort
  ifTrue: [
    lastNode := nodeArray at: nodeArray size.

    key := (self at: lastNode sortLevel) _traverseObject: anObject
      incompletesInto: incompleteArrays
      incomplete: incomplete.
    incomplete == key
      ifTrue: [ ^ self ].

    " if last node is full, check for duplicate keys in all nodes,
      otherwise check in all but the last node "
    lastNode isFull
      ifTrue: [ sz := nodeArray size ]
      ifFalse: [ sz := nodeArray size - 1 ].

    1 to: sz do: [ :i |
      node := nodeArray at: i.
      index := node _findCoveringIndexForKey: key totalOrder: false.
      ( index > 0 and:
      [ node _compareKey: key equalToEntryAt: (index + 1) ] )
        ifTrue: [ " found it "
          node totalElements: node totalElements + 1.
          ^ node _insertDuplicateKey: key value: anObject atIndex: index
        ]
    ].

    lastNode isFull
      ifTrue: [
        sortLevel := lastNode sortLevel.
        lastNode := lastNode class new: lastNode class maxNumberOfElements.
        lastNode sortLevel: sortLevel.
        lastNode pathSorter: self.
        nodeArray add: lastNode
      ].

    " add an entry to the sort node "
    lastNode _at: key
      put: anObject
      forBtree: false
      hasSecondarySort: hasSecondarySort
  ]
  ifFalse: [
    lastNode := nodeArray at: nodeArray size.
    " if the last sort node is full, create a new one "
    lastNode isFull
      ifTrue: [
        sortLevel := lastNode sortLevel.
        lastNode := lastNode class new: lastNode class maxNumberOfElements.
        lastNode sortLevel: sortLevel.
        lastNode pathSorter: self.
        nodeArray add: lastNode
      ].

    " traverse the object to get a key to sort by "
    incomplete == (key := (self at: lastNode sortLevel)
      _traverseObject: anObject
      incompletesInto: incompleteArrays
      incomplete: incomplete)
      ifFalse: [
        " add an entry to the sort node "
        lastNode _at: key
          put: anObject
          forBtree: false
          hasSecondarySort: hasSecondarySort
        ]
  ]
%

category: 'Testing'
method: PathSorter
_canCompare: aKey withClass: aClass

"Returns whether the receiver can make comparisons with the given key."

^ (sortNodes at: 1) _canCompare: aKey withClass: aClass
%

category: 'Private'
method: PathSorter
_findAllValuesForIdenticalKey: key into: array

"Raises an error because the receiver is currently in use building an index."

self _errorIndexCreationInProgress
%

category: 'Private'
method: PathSorter
_findAllValuesGreaterThanKey: aKey into: array

"Raises an error because the receiver is currently in use building an index."

self _errorIndexCreationInProgress
%

category: 'Private'
method: PathSorter
_findAllValuesLessThanKey: aKey andEquals: bool into: array

"Raises an error because the receiver is currently in use building an index."

self _errorIndexCreationInProgress
%

! Class extensions for 'PathTerm'

!		Class methods for 'PathTerm'

category: 'Instance Creation'
classmethod: PathTerm
new

"Create an initialized instance of the receiver."

^ self basicNew initialize
%

!		Instance methods for 'PathTerm'

category: 'Updating Indexes'
method: PathTerm
addDirectMappingFor: anObject logging: aBoolean
  " Update the B-tree and the dependency list for anObject."

  updateBtree ~~ nil
    ifTrue: [
      updateBtree btreeAt: anObject put: anObject.
      needsDepList
        ifTrue: [
          " add an entry in the dependency list "
          anObject getDepListAndAddLastElementPathTerm: self logging: aBoolean ] ].
  updateDict ~~ nil
    ifTrue: [
      " insert an entry into the index dictionary "
      updateDict
        _at: anObject
        put: anObject
        term: self
        logging: aBoolean ]
%

category: 'Updating Indexes'
method: PathTerm
addMappingsForObject: anObject logging: aBoolean
  "Add index dictionary and dependency list entries for anObject."

  | ivOffset nextObj |
  (nil == anObject or: [ self size == 0 ])
    ifTrue: [ ^ self ].
  (ivOffset := self _ivOffsetFor: anObject) == nil
    ifTrue: [ ^ self _invalidIvOffset: anObject ].
  anObject
    getDepListAndAddPathTerm: self
    withIVOffset: ivOffset
    logging: aBoolean.	" add an entry to the objects dependency list "
  nextObj := self _nextObjectFor: anObject atInstVar: ivOffset.	" get the next object along the path "
  updateBtree ~~ nil
    ifTrue: [
      " insert an entry into the B-tree "
      updateBtree btreeAt: nextObj put: anObject.
      needsDepList
        ifTrue: [
          " add an entry to the very last object's dependency list "
          nextObj getDepListAndAddLastElementPathTerm: self logging: aBoolean ] ].
  updateDict ~~ nil
    ifTrue: [
      " insert an entry into the index dictionary "
      updateDict
        _at: nextObj
        put: anObject
        term: self
        logging: aBoolean ].
  nil == nextObj
    ifTrue: [ ^ self ].
  1 to: children size do: [ :i |
    " make recursive call to add mappings "
    (children at: i) addMappingsForObject: nextObj logging: aBoolean ]
%

category: 'Updating Indexes'
method: PathTerm
addMappingsForObject: anObject traverseUpTo: aPathTerm for: anIndexObject logging: aBoolean
  | object |
  object := anIndexObject traverse: anObject upTo: aPathTerm.
  self addMappingsForObject: object logging: aBoolean
%

category: 'Updating Indexes'
method: PathTerm
addMappingsUsing: mapInfo logging: aBoolean
  "Adds index dictionary and dependency list entries for the object described by
 the map info object.  If aBoolean is true, operations will be recorded in the
 system redo log."

  | pathTerm object nextObj nextMap |
  pathTerm := mapInfo pathTerm.
  pathTerm size == 0
    ifTrue: [ ^ self ].
  object := mapInfo object.
  nil == object
    ifTrue: [ ^ self ].
  object
    getDepListAndAddPathTerm: pathTerm
    withIVOffset: mapInfo ivOffset
    logging: aBoolean.	" add an entry to the objects dependency list "
  nextMap := mapInfo at: 1.	" nextObj is the same for all nextMaps, so choose the first one "
  nextObj := nextMap object.
  updateBtree ~~ nil
    ifTrue: [
      " insert an entry into the B-tree "
      updateBtree btreeAt: nextObj put: object.
      (needsDepList and: [ nil ~~ nextObj ])
        ifTrue: [
          " add an entry to the very last object's dependency list "
          nextObj
            getDepListAndAddLastElementPathTerm: pathTerm
            logging: aBoolean ] ].
  updateDict ~~ nil
    ifTrue: [
      " insert an entry into the index dictionary "
      updateDict
        _at: nextObj
        put: object
        term: pathTerm
        logging: aBoolean ].
  1 to: mapInfo size do: [ :i |
    nextMap := mapInfo at: i.	" make recursive call to add mappings "
    nextMap pathTerm ~~ nil
      ifTrue: [ nextMap pathTerm addMappingsUsing: nextMap logging: aBoolean ] ]
%

category: 'Deprecated'
method: PathTerm
allDependencyListsFor: anObject into: all
  "Put any dependency lists that can be found from the receiver
into the given set."

  | ivOffset nextObj depList |
  self deprecated: 'PathTerm>>allDependencyListsFor:into: deprecated v3.3.
     Use DependencyList class>>depMapValues to collect dependency lists.'.  "bug 43886"

  (nil == anObject or: [ self size == 0 ])
    ifTrue: [ ^ self ].
  (depList := DependencyList for: anObject) == nil
    ifTrue: [ ^ self ].
  all add: depList.
  self indicatesIndexOnRootNsc
    ifTrue: [ ^ self ].
  ivOffset := depList getInstVarOffsetWithPathTerm: self.
  ivOffset < 0
    ifTrue: [
      "reference count for last element"
      ^ self ].
  ivOffset == 0
    ifTrue: [ nextObj := self _nextObjectFor: anObject ]
    ifFalse: [ nextObj := self _nextObjectFor: anObject atInstVar: ivOffset ].
  nil == nextObj
    ifTrue: [ ^ self ].
  needsDepList
    ifTrue: [
      (depList := DependencyList for: nextObj) ~~ nil
        ifTrue: [ all add: depList ].
      ^ self ].
  1 to: children size do: [ :i | (children at: i) allDependencyListsFor: nextObj into: all ]
%

category: 'Formatting'
method: PathTerm
asString
  ^ super asString , ' on ' , self name asString printString
%

category: 'Audit'
method: PathTerm
auditBtree: btreeNode entryFor: obj and: nextObj occurrences: num on: aString builder: nscBuilder

"Private.  Unsupported method for GemStone Technical Support."

| bag |
self size == 0
  ifTrue: [ ^ self ].

btreeNode _findAllValuesForIdenticalKey: nextObj into: nscBuilder.
bag := nscBuilder completeBag.
(bag occurrencesOf: obj) == num
    ifFalse: [
        self auditInfo: { nextObj . nil . nil } on: aString.
        aString add: 'Btree [';
            add: btreeNode asOop asString;
            add: '] has incorrect number of entries (';
            add: (bag occurrencesOf: obj) asString;
            add: ') for [';
            add: obj asOop asString;
            add: '] of class ';
            add: obj class asString;
            add: ' (should be '; add: num asString; add: ')';
            add: Character lf . self checkDebug: aString 
    ].
^ bag size
%

category: 'Audit'
method: PathTerm
auditBtreeForDirectObject: obj occurrences: num on: aString builder: nscBuilder

"Private.  Unsupported method for GemStone Technical Support."

"Verifies that the given object has the correct B-tree entries for the receiver."

| indexObj dictChecked |

self size == 0
  ifTrue: [ ^ self ].

dictChecked := false.
" for each index that utilizes the path term "
nscBuilder _resetForAudit.
1 to: self size do: [ :i |
    indexObj := self at: i.
    indexObj isRangeEqualityIndex
        ifTrue: [
            " verify B-tree has correct entries "
            self auditBtree: indexObj btreeRoot
                entryFor: obj
                and: obj
                occurrences: num
                on: aString
                builder: nscBuilder.
            nscBuilder _resetForAudit.
        ]
]

%

category: 'Audit'
method: PathTerm
auditBtreeForObject: obj occurrences: num on: aString builder: nscBuilder

"Private.  Unsupported method for GemStone Technical Support."

"Verifies that the given object has the B-tree entries for the receiver."

| indexObj nextObj newNum |
"aString add: 'entering obj, num is ', num printString; lf."

self size == 0
  ifTrue: [ ^ aString ].

nscBuilder _resetForAudit.

self indicatesIndexOnNscElements
  ifTrue: [ ^ self auditBtreeForDirectObject: obj occurrences: num on: aString builder: nscBuilder ].

nil == obj
    ifTrue: [ ^ aString ].

nextObj := self _nextObjectFor: obj.

" for each index that utilizes the path term "
1 to: self size do: [ :i |
    indexObj := self at: i.
    ( indexObj isRangeEqualityIndex and: [ indexObj size == offset ] )
        ifTrue: [
            " verify B-tree has correct entries "
            newNum := self auditBtree: indexObj btreeRoot
                entryFor: obj
                and: nextObj
                occurrences: num
                on: aString
                builder: nscBuilder.
            nscBuilder _resetForAudit.
        ]
].

obj ~~ nil
    ifTrue: [
        1 to: children size do: [ :i |
            (children at: i) auditBtreeForObject: nextObj
                occurrences: newNum
                on: aString
                builder: nscBuilder.
            nscBuilder _resetForAudit.
        ]
]

%

category: 'Audit'
method: PathTerm
auditDepListFor: obj index: indexObj on: aString
  "Obsolete...use PathTerm>>auditDepListFor:index:on:optionalSentinel: instead"

  ^ self
    auditDepListFor: obj
    index: indexObj
    on: aString
    optionalSentinel: Object new
%

category: 'Audit'
method: PathTerm
auditDepListFor: obj index: indexObj on: aString optionalSentinel: optionalSentinel
  "Private."

  | depList j nextObj ivOffset |
  (nil == obj or: [ self size == 0 ])
    ifTrue: [ ^ nil ].
  depList := DependencyList for: obj.
  depList == nil
    ifTrue: [
      (obj isInvariant not and: [ self isOptionalTerm not ])
        ifTrue: [
          self
            auditInfo:
              {obj.
              indexObj.
              depList}
            on: aString.
          aString
            add: ' Object has no dependency list';
            add: Character lf . self checkDebug: aString ].
      nextObj := self _nextObjectFor: obj ]
    ifFalse: [
      (DepListTable _hasDependencyBitFor: obj)
        ifFalse: [
          self
            auditInfo:
              {obj.
              indexObj.
              depList}
            on: aString.
          aString
            add: ' Object has DependencyList but no dependency bit is set';
            add: Character lf . self checkDebug: aString ].
      j := depList _findOffsetForPathTerm: self.
      j == nil
        ifTrue: [
          | ivOff |
          "no entry for self in depList"
          ivOff := self _ivOffsetFor: obj.
          (self isOptionalTerm and: [ ivOff isNil ])
            ifTrue: [
              "no dependencyList if there's no slot"
              nextObj := optionalSentinel ]
            ifFalse: [
              self
                auditInfo:
                  {obj.
                  indexObj.
                  depList}
                on: aString.
              aString
                add: 'DependencyList has no entry for path term';
                add: Character lf. self checkDebug: aString .
              nextObj := self _nextObjectFor: obj ] ]
        ifFalse: [
          "found entry for self in depList"
          ivOffset := depList at: j + 1.	"may be negative for last element reference count"
          ivOffset < 0
            ifTrue: [
              "reference count for last element, but we don't expect reference
               count here ... see needsDepList clause below where depList
               existence is sufficient"
              self
                auditInfo:
                  {obj.
                  indexObj.
                  depList}
                on: aString.
              aString
                add: 'DependencyList on last element in unexepected location ';
                add: ivOffset asString;
                add: Character lf. self checkDebug: aString .
              ^ obj ]
            ifFalse: [
              ivOffset ~~ (self _ivOffsetFor: obj)
                ifTrue: [
                  self
                    auditInfo:
                      {obj.
                      indexObj.
                      depList}
                    on: aString.
                  aString
                    add: 'DependencyList has incorrect iv offset ';
                    add: ivOffset asString.
                  ivOffset := self _ivOffsetFor: obj.
                  aString
                    add: ' instead of ';
                    add: ivOffset asString;
                    add: Character lf . self checkDebug: aString ].
              nextObj := obj instVarAt: ivOffset ] ] ].
  ((needsDepList and: [ nextObj ~~ nil ])
    and: [ DependencyList needsDepList: nextObj ])
    ifTrue: [
      depList := DependencyList for: nextObj.
      (depList == nil and: [ self isOptionalTerm not ])
        ifTrue: [
          self
            auditInfo:
              {nextObj.
              indexObj.
              depList}
            on: aString.
          aString
            add: ' Object has no dependency list';
            add: Character lf . self checkDebug: aString ] ].
  ^ nextObj
%

category: 'ObsoleteIDX - Audit'
method: PathTerm
auditDepListForByteObject: obj occurrences: num index: indexObj on: aString
  "Obsolete ... Private.  Unsupported method for GemStone Technical Support."

  ^ self
    auditDepListForLastElementObject: obj
    occurrences: num
    index: indexObj
    on: aString
%

category: 'Audit'
method: PathTerm
auditDepListForLastElementObject: obj occurrences: num index: indexObj on: aString
  "Private.  Unsupported method for GemStone Technical Support."

  | depList j |
  (self size == 0 or: [ obj isInvariant ])
    ifTrue: [ ^ self ].
  depList := DependencyList for: obj.
  depList == nil
    ifTrue: [
      self
        auditInfo:
          {obj.
          indexObj.
          depList}
        on: aString.
      aString
        add: ' Object has no dependency list';
        add: Character lf . self checkDebug: aString ]
    ifFalse: [
      (DepListTable _hasDependencyBitFor: obj)
        ifFalse: [
          self
            auditInfo:
              {obj.
              indexObj.
              depList}
            on: aString.
          aString
            add: ' Object has DependencyList but no dependency bit is set';
            add: Character lf . self checkDebug: aString ].
      j := depList _findOffsetForPathTerm: self.
      j == nil
        ifTrue: [
          "hack to avoid false positives for index paths ending in *"
          self name = #'*'
            ifFalse: [
              self
                auditInfo:
                  {obj.
                  indexObj.
                  depList}
                on: aString.
              aString
                add: 'DependencyList has no entry for path term';
                add: Character lf . self checkDebug: aString ] ]
        ifFalse: [
          | referenceCount nonReferenceCountTerm |
          referenceCount := depList at: j + 1.
          nonReferenceCountTerm := false.
          referenceCount > 0
            ifTrue: [
              "upgraded indexes from pre-3.2 may have positive rerence count, but only for Byte indexable ojbects"
              obj class isBytes
                ifFalse: [
                  "ivOffset and not a reference count"
                  nonReferenceCountTerm := true ] ]
            ifFalse: [ referenceCount := referenceCount negated ].
          nonReferenceCountTerm
            ifTrue: [
              "not a reference count and will be audited by PathTerm>>auditDepListFor:index:on:optionalSentinel: "
              "noop"
               ]
            ifFalse: [
              referenceCount == num
                ifFalse: [
                  self
                    auditInfo:
                      {obj.
                      indexObj.
                      depList}
                    on: aString.
                  aString
                    add: ' DependencyList has incorrect ref count ';
                    add: referenceCount asString;
                    add: ' for occurrences ';
                    add: num asString;
                    add: Character lf . self checkDebug: aString ] ] ] ]
%

category: 'Audit'
method: PathTerm
auditDictionaryEntryFor: obj and: nextObj occurrences: num on: aString
  "Private.  Unsupported method for Technical Support."

  | val |
  self size == 0
    ifTrue: [ ^ 0 ].
  val := self getIndexDictionary
    at: nextObj
    term: self
    ifAbsent: [
      self isOptionalTerm
        ifFalse: [
          self
            auditInfo:
              {nextObj.
              nil.
              nil}
            on: aString.
          aString
            add: 'Index Dictionary has no entry for object [';
            add: obj asOop asString;
            add: '] of class ';
            add: obj class asString;
            add: Character lf . self checkDebug: aString ].
      ^ 0 ].
  (BucketValueBag _hasInstance: val)
    ifTrue: [
      | occ |
      (occ := val occurrencesOf: obj) == num
        ifFalse: [
          self
            auditInfo:
              {nextObj.
              nil.
              nil}
            on: aString.
          aString
            add: 'Index Dictionary has incorrect number of entries (';
            add: occ asString;
            add: ') for [';
            add: obj asOop asString;
            add: '] of class ';
            add: obj class asString;
            add: ' (should be ';
            add: num asString;
            add: ')';
            add: Character lf . self checkDebug: aString ].
      ^ val size ]
    ifFalse: [
      val == obj
        ifFalse: [
          self
            auditInfo:
              {nextObj.
              nil.
              nil}
            on: aString.
          aString
            add: 'Index Dictionary has incorrect entry for [';
            add: obj asOop asString;
            add: '] of class ';
            add: obj class asString;
            add: Character lf . self checkDebug: aString ].
      ^ 1 ]
%

category: 'Deprecated'
method: PathTerm
auditDirectNscCounts: nsc for: obj on: aString count: btreeCounts
  "Private. "

  self deprecated: 'PathTerm>>auditDirectNscCounts:for:on:count: deprecated v3.3.
     Use auditDirectNscCountsFor:on:count:'.  "Bug 43958"
  self auditDirectNscCountsFor: obj on: aString count: btreeCounts
%

category: 'Audit'
method: PathTerm
auditDirectNscCountsFor: obj on: aString count: btreeCounts
  "Private. "

  | index |
  self size == 0
    ifTrue: [ ^ nil ].
  nil == obj
    ifFalse: [
      | depList |
      depList := DependencyList for: obj.
      (depList == nil and: [ obj isInvariant not ])
        ifTrue: [
          self
            auditInfo:
              {obj.
              nil.
              depList}
            on: aString.
          aString
            add: ' Object has no dependency list';
            add: Character lf . self checkDebug: aString ]
        ifFalse: [
          obj isInvariant not
            ifTrue: [
              (DepListTable _hasDependencyBitFor: obj)
                ifFalse: [
                  self
                    auditInfo:
                      {obj.
                      nil.
                      depList}
                    on: aString.
                  aString
                    add:
                        ' Object has DependencyList but no dependency bit is set';
                    add: Character lf . self checkDebug: aString ] ] ] ].
  index := 1.
  1 to: self size do: [ :i |
    | count indexObj |
    indexObj := self at: i.
    (indexObj isRangeEqualityIndex and: [ indexObj size == offset ])
      ifTrue: [
        count := btreeCounts at: index.
        count == 0
          ifTrue: [
            aString
              add: Character lf;
              add: ' -- The number of entries in Btree [';
              add: (self at: i) btreeRoot asOop asString;
              add: '] for pathTerm [';
              add: self asOop asString;
              add: ' offset ';
              add: offset asString;
              add:
                  '] does not match the number of entries in the base collection (extra elements in either the base collection or btree).';
              add: Character lf ].
        btreeCounts at: index put: count - 1.
        index := index + 1 ] ]
%

category: 'Audit'
method: PathTerm
auditDirectObject: obj occurrences: num on: aString builder: nscBuilder
  "Private.  Unsupported method for GemStone Technical Support."

  "Verifies that the given object has the correct dependency list, index
 dictionary, and B-tree entries for the receiver."

  | indexObj dictChecked |
  self size == 0
    ifTrue: [ ^ self ].
  dictChecked := false.	" for each index that utilizes the path term "
  nscBuilder _resetForAudit.
  1 to: self size do: [ :i |
    indexObj := self at: i.
    indexObj isRangeEqualityIndex
      ifTrue: [
        " verify B-tree has correct entries "
        self
          auditBtree: indexObj btreeRoot
          entryFor: obj
          and: obj
          occurrences: num
          on: aString
          builder: nscBuilder.
        nscBuilder _resetForAudit.
        (DependencyList for: obj) ~~ nil
          ifTrue: [
            " verify dependency list "
            self
              auditDepListForLastElementObject: obj
              occurrences: num
              index: indexObj
              on: aString ] ]
      ifFalse: [
        " verify index dictionary has correct entries "
        dictChecked
          ifFalse: [
            self
              auditDictionaryEntryFor: obj
              and: obj
              occurrences: num
              on: aString.
            dictChecked := true ] ] ]
%

category: 'Audit'
method: PathTerm
auditIndexDictionaryForDirectObject: obj occurrences: num on: aString

"Private.  Unsupported method for GemStone Technical Support."

"Verifies that the given object has the correct index dictionary entries for
the receiver."

| indexObj dictChecked |
self size == 0
  ifTrue: [ ^ self ].

dictChecked := false.
"since there's only one index dictionary, shared by all indexes, when you find
the first one audit that and stop"
1 to: self size do:
    [ :i |
    indexObj := self at: i.
    indexObj isRangeEqualityIndex
        ifFalse:
            [ " verify index dictionary has correct entries "
            dictChecked
                ifFalse:
                     [self auditDictionaryEntryFor: obj
                          and: obj
                          occurrences: num
                          on: aString.
                    dictChecked := true]
            ]
    ]
%

category: 'Audit'
method: PathTerm
auditIndexDictionaryForObject: obj occurrences: num on: aString

"Private.  Unsupported method for GemStone Technical Support."

"Verifies that the given object has the correct index dictionary entries for the receiver."

| indexObj nextObj newNum dictChecked |
self size == 0
  ifTrue: [ ^ aString ].

self indicatesIndexOnNscElements
    ifTrue: [ ^ self auditIndexDictionaryForDirectObject: obj occurrences: num on: aString ].

nil == obj
    ifTrue: [ ^ aString ].

nextObj := self _nextObjectFor: obj.

dictChecked := false.
" for each index that utilizes the path term "
1 to: self size do: [ :i |
    indexObj := self at: i.
    ( indexObj isRangeEqualityIndex and: [ indexObj size == offset ] )
       ifFalse: [ " verify index dictionary has correct entries "
            dictChecked
                ifFalse: [
                    newNum := self auditDictionaryEntryFor: obj
                        and: nextObj
                        occurrences: num
                        on: aString.
                    dictChecked := true
                ]
        ]
].

obj ~~ nil
    ifTrue: [
        1 to: children size do: [ :i |
            (children at: i) auditIndexDictionaryForObject: nextObj
                occurrences: newNum
                on: aString
        ]
]
%

category: 'Audit'
method: PathTerm
auditInfo: array on: aString
  "Private.  Unsupported method for GemStone Technical Support."

  | obj indexObj depList |
  self size == 0
    ifTrue: [ ^ self ].
  obj := array at: 1.
  indexObj := array at: 2.
  depList := array at: 3.
  aString add: 'object'.
  (obj isKindOf: CharacterCollection)
    ifTrue: [
      aString
        add: Character space;
        add: obj ].
  aString
    add: ' [';
    add: obj asOop asString;
    add: '] of class ';
    add: obj class asString.
  indexObj ~~ nil
    ifTrue: [
      aString
        add: ', ';
        add:
            (indexObj isRangeEqualityIndex
                ifTrue: [ 'equality' ]
                ifFalse: [ 'identity' ]);
        add: ' index <';
        add: indexObj pathComponentsString;
        add: '> [';
        add: indexObj asOop asString;
        add: ']' ].
  aString
    add: ', path term <';
    add: name.
  name == #'*'
    ifTrue: [ aString add: ' offset: ' , offset asString ].
  aString
    add: '> [';
    add: self asOop asString;
    add: ']'.
  depList ~~ nil
    ifTrue: [
      aString
        add: ', depList [';
        add: depList asOop asString;
        add: ']' ].
  aString
    add:
      '
    -- '
%

category: 'Audit'
method: PathTerm
auditNsc: nsc on: aString level: level

"Verifies that the equality index objects are consistent.
 Returns a string that describes any inconsistencies found."

| indexObj btreeCounts count |
"aString add: 'entering obj, num is ', num printString; lf."

self size == 0
  ifTrue: [ ^ aString ].

" for each index that utilizes the path term "
btreeCounts := { } .
1 to: self size do: [ :i |
    indexObj := self at: i.
    ( indexObj isRangeEqualityIndex and: [ indexObj size == offset ] )
        ifTrue: [
            " verify B-tree has correct entries "
            count := indexObj btreeRoot auditNsc: nsc for: self offset: i on: aString.
            btreeCounts add: count.
        ]
].
1 to: children size do: [ :i |
      | resultArray |
    resultArray := (children at: i) auditNsc: nsc
                                            on: aString
                                            level: level + 1.
    btreeCounts add: resultArray
].
^btreeCounts
%

category: 'Deprecated'
method: PathTerm
auditNscCounts: nsc for: obj on: aString count: btreeCounts
  "Private. "

  self deprecated: 'PathTerm>>auditNscCounts:for:on:count: deprecated v3.3.
     Use auditNscCountsFor:on:count:'.  "Bug 43958"
  self auditNscCountsFor: obj on: aString count: btreeCounts
%

category: 'Audit'
method: PathTerm
auditNscCountsFor: obj on: aString count: btreeCounts
  "Private. "

  | nextObj index optionalSentinel |
  self size == 0
    ifTrue: [ ^ self ].
  self indicatesIndexOnNscElements
    ifTrue: [ ^ self auditDirectNscCountsFor: obj on: aString count: btreeCounts ].
  nil == obj
    ifTrue: [ ^ self ].
  optionalSentinel := Object new.
  nextObj := self
    auditDepListFor: obj
    index: nil
    on: aString
    optionalSentinel: optionalSentinel.
  nextObj == optionalSentinel
    ifTrue: [ ^ self ].
  index := 1.
  1 to: self size do: [ :i |
    | count indexObj |
    indexObj := self at: i.
    (indexObj isRangeEqualityIndex and: [ indexObj size == offset ])
      ifTrue: [
        count := btreeCounts at: index.
        (count == 0 and: [ self isOptionalTerm not ])
          ifTrue: [
            "an index with optional path terms may have 0 entries"
            aString
              add: Character lf;
              add: ' -- The number of entries in Btree [';
              add: (self at: i) btreeRoot asOop asString;
              add: '] for pathTerm [';
              add: self asOop asString;
              add: ' offset ';
              add: offset asString;
              add:
                  '] does not match the number of entries in the base collection (extra elements in either the base collection or btree).';
              add: Character lf ].
        (count == 0 and: [ self isOptionalTerm ])
          ifFalse: [ btreeCounts at: index put: count - 1 ].
        index := index + 1 ] ].
  1 to: children size do: [ :i |
    (children at: i)
      auditNscCountsFor: nextObj
      on: aString
      count: (btreeCounts at: index).
    index := index + 1 ]
%

category: 'Deprecated'
method: PathTerm
auditObject: obj occurrences: num on: aString builder: nscBuilder
  "Private.  Unsupported method for GemStone Technical Support."

  "Verifies that the given object has the correct dependency list, index
 dictionary, and B-tree entries for the receiver."

  | indexObj nextObj dictChecked newNum optionalSentinel |
  self size == 0
    ifTrue: [ ^ aString ].
  nscBuilder _resetForAudit.
  self indicatesIndexOnNscElements
    ifTrue: [
      ^ self
        auditDirectObject: obj
        occurrences: num
        on: aString
        builder: nscBuilder ].
  nil == obj
    ifTrue: [ ^ aString ].
  optionalSentinel := Object new.
  nextObj := self
    auditDepListFor: obj
    index: indexObj
    on: aString
    optionalSentinel: optionalSentinel.
  nextObj == optionalSentinel
    ifTrue: [ ^ aString ].
  dictChecked := false.
  1 to: self size do: [ :i |
    " for each index that utilizes the path term "
    indexObj := self at: i.
    (indexObj isRangeEqualityIndex and: [ indexObj size == offset ])
      ifTrue: [
        " verify B-tree has correct entries "
        newNum := self
          auditBtree: indexObj btreeRoot
          entryFor: obj
          and: nextObj
          occurrences: num
          on: aString
          builder: nscBuilder.
        nscBuilder _resetForAudit.
        (DependencyList for: nextObj) ~~ nil
          ifTrue: [
            " if the path term is the last path term of a range index "
            self
              auditDepListForLastElementObject: nextObj
              occurrences: newNum
              index: indexObj
              on: aString ] ]
      ifFalse: [
        " verify index dictionary has correct entries "
        dictChecked
          ifFalse: [
            newNum := self
              auditDictionaryEntryFor: obj
              and: nextObj
              occurrences: num
              on: aString.
            dictChecked := true ] ] ].
  obj ~~ nil
    ifTrue: [
      1 to: children size do: [ :i |
        (children at: i)
          auditObject: nextObj
          occurrences: newNum
          on: aString
          builder: nscBuilder.
        nscBuilder _resetForAudit ] ]
%

category: 'Audit'
method: PathTerm
checkDebug: aString
  BtreePlusNodeAuditor checkDebug: aString
%

category: 'Accessing'
method: PathTerm
children

"Returns the value of the instance variable 'children'."

^children
%

category: 'Updating'
method: PathTerm
children: newValue

"Modify the value of the instance variable 'children'."

children := newValue
%

category: 'Updating Indexes'
method: PathTerm
cleanupDependencyListFor: anObject
  ""

  | ivOffset nextObj depList |
  (nil == anObject or: [ self size == 0 ])
    ifTrue: [ ^ self ].
  (depList := DependencyList for: anObject) == nil
    ifTrue: [ ^ self ].
  ivOffset := depList removeCompletelyPathTerm: self for: anObject.	" remove the receiver from the dependency list "
  (self indicatesIndexOnRootNsc
    or: [
      "last element dependency list"
      ivOffset < 0 ])
    ifTrue: [ ^ self ].
  ivOffset == 0
    ifTrue: [ nextObj := self _nextObjectFor: anObject ]
    ifFalse: [
      [ nextObj := self _nextObjectFor: anObject atInstVar: ivOffset ]
        onException: Error
        do: [ :ex |
          "Handle any error thrown during execution of _nextObjectFor:
     Cannot resolve the path for this guy --- can't have been added to index,
     in fact this object could have caused the failure in the first place"
          ^ self ] ].
  nil == nextObj
    ifTrue: [ ^ self ].
  needsDepList
    ifTrue: [
      (depList := DependencyList for: nextObj) ~~ nil
        ifTrue: [ depList removeCompletelyPathTerm: self for: nextObj ].
      ^ self ].
  1 to: children size do: [ :i | (children at: i) cleanupDependencyListFor: nextObj ]
%

category: 'Clustering'
method: PathTerm
clusterDepthFirst

"Cluster the receiver."

name cluster.
securityPolicies cluster.
children cluster.
1 to: children size do: [ :i | (children at: i) cluster ]
%

category: 'Testing'
method: PathTerm
coversIvOffset: anIvOffset for: anObject
  "Answer true if the receiver covers the given iv offset (see bug 46705)"

  ^false
%

category: 'Accessing'
method: PathTerm
getIndexDictionary

"Returns the index dictionary associated with the receiver."

| indexDict |
updateDict ~~ nil
    ifTrue: [ ^ updateDict ].

" get it from an index object if present "
1 to: self size do: [ :i |
    indexDict := (self at: i) indexDictionary.
    indexDict ~~ nil
        ifTrue: [ ^ indexDict ]
].
^ nil
%

category: 'Updating Indexes'
method: PathTerm
getMappingInfoFor: anObject ifObject: origObject atOffset: origOffset replaceWith: otherObject
  "Gathers all the objects, their dependency lists, and the instance variable
 offset for each path term in the tree of path terms.  Puts them in a
 MappingInfo object.  Builds a tree of MappingInfo objects for each child path
 term.

 It is possible that this method is invoked due to an instance variable
 modification.  In that case, we want to traverse the path terms as if the
 modification had occurred.  Thus, if anObject is the one that was modified
 (that is, if it is identical to origObject) and the instance variable offset of
 this path term is the same instance variable offset that was modified (that is,
 it is equal to origOffset), then rather than getting the next object along the
 path, use the otherObject."

  | ivOffset nextObj mapInfo aMapInfo |
  (nil == anObject or: [ self size == 0 ])
    ifTrue: [ ^ self _mappingInfoClass new pathTerm: self ].
  ivOffset := self _ivOffsetFor: anObject.
  ivOffset ifNil: [ ^ self _mapInfoOrErrorForMissingIvOffset: anObject ].
  mapInfo := self _mappingInfoClass new
    object: anObject;
    ivOffset: ivOffset;
    pathTerm: self.
  (anObject == origObject and: [ ivOffset == origOffset ])
    ifTrue: [ nextObj := otherObject ]
    ifFalse: [
      " get the next object along the path "
      nextObj := self _nextObjectFor: anObject atInstVar: ivOffset ].
  updateBtree
    ifNotNil: [
      (self _checkBtreeComparisonWith: nextObj)
        ifFalse: [
          | exa |
          (exa := ImproperOperation new)
            _number:
                (ErrorSymbols at: #'rtErrRangeEqualityIndexInvalidClassKindForBtree');
            args: { nextObj class. self name. updateBtree lastElementClassDescription }.
          ^ {false.	" indicating no indexing objects were modified "
          exa} ] ].
  (nil == nextObj or: [ self children isEmpty ])
    ifTrue: [
      " adds nil to the end and returns "
      mapInfo addLast: (self _mappingInfoClass new object: nextObj).
      ^ mapInfo ].
  1 to: children size do: [ :i |
    " make recursive call to get mapping info "
    aMapInfo := (children at: i)
      getMappingInfoFor: nextObj
      ifObject: origObject
      atOffset: origOffset
      replaceWith: otherObject.
    aMapInfo class == self _mappingInfoClass
      ifFalse: [ ^ aMapInfo	"an Array of error info" ].
    mapInfo addLast: aMapInfo ].
  ^ mapInfo
%

category: 'Accessing'
method: PathTerm
getParentTerm

"Returns the parent path term of the receiver.  This is determined by looking
 at the previous path term of the first index object that utilizes this path
 term.  If there is no parent, returns nil."

offset > 1
    ifTrue: [ ^ (self at: 1) at: offset - 1 ]
    ifFalse: [ ^ nil ]
%

category: 'Accessing'
method: PathTerm
getRootNsc

"Returns the root NSC for the index in which the receiver is a term."

^ (self at: 1) nscRoot
%

category: 'Testing'
method: PathTerm
hasIndexDictionary
  "Answer if receiver's index may have an indexDictionary."

  ^ true
%

category: 'Testing'
method: PathTerm
hasMatchingTerm: aSymbol
  "Answer true if the receiver's term matches <aSymbol>"

  ^ self name == aSymbol
%

category: 'Testing'
method: PathTerm
indicatesIndexOnNscElements

"Returns true if the path term indicates that the index is on elements of the
 NSC itself.  This is the case if the path is '' (two single quotes).  This
 method is overridden by SetValuedPathTerm to return true."

^ name ==  #''
%

category: 'Testing'
method: PathTerm
indicatesIndexOnRootNsc

"Returns true if the path term indicates that the index is on elements of the
 NSC itself.  This is the case if the path is '' (two single quotes).  This
 method is not overridden by SetValuedPathTerm."

^ name ==  #''
%

category: 'Testing'
method: PathTerm
indicatesMultiValue
  "Returns false, the receiver does not indicate that the index is on an
 instance variable that may have multiple values (i.e., collection based path term)"

  ^ false
%

category: 'Testing'
method: PathTerm
indicatesNsc
  "Returns false, the receiver does not indicate that the index is on an
 instance variable that is expected to be a collection (i.e., set valued pathterm."

  ^ false
%

category: 'Initialization'
method: PathTerm
initialize

"Initialize the receiver with default values."

securityPolicies := GsObjectSecurityPolicySet new.
children := { } .
needsDepList := false.
%

category: 'Testing'
method: PathTerm
isCollectionBasedTerm
  "Returns true if the receiver is an enumerated path term or a term that indicates a
   set-valued instance variable."

  ^ false
%

category: 'Testing'
method: PathTerm
isConstrained

"Returns false: the path term is not constrained."

^ false
%

category: 'Testing'
method: PathTerm
isEnumeratedTerm
  "Returns true if the receiver indicates an enumerated path term."

  ^ false
%

category: 'Testing'
method: PathTerm
isFast

""

^ true
%

category: 'Updating Indexes'
method: PathTerm
isLastOccurrenceInIndexObjects: anObject for: anNsc
  | pathTerm key tmpList val num val2 parentTerm |
  pathTerm := self.
  pathTerm isRangeEqualityIndexLastPathTerm
    ifTrue: [ pathTerm offset == 1
        ifTrue: [ " if index directly on NSC elements or anObject is nil "
          (pathTerm indicatesIndexOnNscElements or: [ nil == anObject ])
            ifTrue: [ key := anObject ]
            ifFalse: [ key := pathTerm _nextObjectFor: anObject ].
          tmpList := IdentityBag new.
          pathTerm updateBtree btreeRoot
            _findAllValuesForIdenticalKey: key
            into: tmpList.
          ^ (tmpList occurrencesOf: anObject) <= 1 ]
        ifFalse: [ pathTerm := pathTerm getParentTerm.
          val := pathTerm updateDict at: anObject term: pathTerm otherwise: nil.
          (BucketValueBag _hasInstance: val)
            ifTrue: [ " see if more than one mapping "
              pathTerm indicatesNsc
                ifTrue: [ num := val occurrencesOf: anNsc.
                  num < val size
                    ifTrue: [ " if anObject is contained in other NSCs "
                      ^ false ].
                  pathTerm := pathTerm getParentTerm.	" get path term before this one "
                  val2 := pathTerm updateDict
                    at: anNsc
                    term: pathTerm
                    otherwise: nil.
                  (BucketValueBag _hasInstance: val2)
                    ifTrue: [ ^ val2 size == num ]
                    ifFalse: [ ^ true ] ]
                ifFalse: [ ^ (val occurrencesOf: anNsc) <= 1 ] ]
            ifFalse: [ ^ true ] ] ]
    ifFalse: [
      " get key to look up in index dictionary "
      (pathTerm indicatesIndexOnNscElements or: [ nil == anObject ])
        ifTrue: [ key := anObject ]
        ifFalse: [ " see if a path with '*.*' in it "
          pathTerm indicatesNsc
            ifTrue: [ val := pathTerm updateDict
                at: anObject
                term: pathTerm getParentTerm
                otherwise: nil.
              ^ (BucketValueBag _hasInstance: val) not ]
            ifFalse: [ key := pathTerm _nextObjectFor: anObject ] ].
      val := pathTerm updateDict at: key term: pathTerm otherwise: nil.	" look up the mapping in the index dictionary "
      (BucketValueBag _hasInstance: val)
        ifTrue: [
          " see if more than one mapping "
          (num := val occurrencesOf: anObject) <= 1
            ifTrue: [ ^ true ]
            ifFalse: [
              " see if multiple occurrences are due to more than one object
                    referencing anNsc "
              " if there is a parent term, it is a SetValuedPathTerm "
              parentTerm := pathTerm getParentTerm.
              parentTerm == nil
                ifTrue: [ ^ false ].
              val2 := pathTerm updateDict
                at: anObject
                term: parentTerm
                otherwise: nil.
              (BucketValueBag _hasInstance: val2)
                ifTrue: [ ^ (val2 occurrencesOf: anNsc) == num ]
                ifFalse: [ ^ false ] ] ]
        ifFalse: [ ^ true ] ].
  self error: 'should not get here'
%

category: 'Testing'
method: PathTerm
isLastTermOfAnIndex

"Return if the receiver is the last term of one of its indexes."



1 to: self size do: [ :i |
  (self at: i) last == self
    ifTrue: [ ^ true ]
].
^ false
%

category: 'Testing'
method: PathTerm
isOptionalTerm
  ^ false
%

category: 'Testing'
method: PathTerm
isRangeEqualityIndexLastPathTerm

"Returns true if the receiver is the last path term of a RangeEqualityIndex."

1 to: self size do: [ :i |
    ( (self at: i) isRangeEqualityIndex and: [ (self at: i) size == offset ] )
        ifTrue: [ ^ true ]
].
^ false
%

category: 'Testing'
method: PathTerm
isSelectorTerm
  ^ false
%

category: 'Testing'
method: PathTerm
isSetValuedTerm
  "Returns true if the receiver indicates a set-valued instance variable."

  ^ false
%

category: 'Accessing'
method: PathTerm
name

"Returns the value of the instance variable 'name'."

^name
%

category: 'Updating'
method: PathTerm
name: newValue

"Modify the value of the instance variable 'name'."

name := newValue
%

category: 'Accessing'
method: PathTerm
needsDepList

"Returns the value of the instance variable 'needsDepList'."

^needsDepList
%

category: 'Updating'
method: PathTerm
needsDepList: newValue

"Modify the value of the instance variable 'needsDepList'."

needsDepList := newValue
%

category: 'Accessing'
method: PathTerm
objectSecurityPolicy: anObjectSecurityPolicy

"Assign the receiver and its children to the given security policy."

super objectSecurityPolicy: anObjectSecurityPolicy.
children objectSecurityPolicy: anObjectSecurityPolicy.
1 to: children size do: [ :i |
    (children at: i) objectSecurityPolicy: anObjectSecurityPolicy
].
securityPolicies objectSecurityPolicy: anObjectSecurityPolicy.
%

category: 'Accessing'
method: PathTerm
offset

"Returns the value of the instance variable 'offset'."

^offset
%

category: 'Updating'
method: PathTerm
offset: newValue

"Modify the value of the instance variable 'offset'."

offset := newValue
%

category: 'Updating Indexes'
method: PathTerm
removeDirectMappingFor: anObject logging: doLogging
  "There is a range index directly on the elements of the NSC.  Update the
 B-tree."

  updateBtree ~~ nil
    ifTrue: [
      " remove it from the B-tree "
      updateBtree btreeRemoveKey: anObject value: anObject ].
  (self indicatesMultiValue _and: [ self indicatesIndexOnNscElements ])
    ifTrue: [
      " if it is a set-valued path term and the last term in an index... "
      ^ self ].
  updateDict ~~ nil
    ifTrue: [
      " remove the index dictionary entry "
      updateDict
        removeKey: anObject
        value: anObject
        term: self
        logging: doLogging ]
%

category: 'Index Maintenance'
method: PathTerm
removeIndex: indexObj

"The given index is being removed from this path term."

1 to: self size do: [ :i |
    indexObj == (self at: i)
        ifTrue: [ ^ self removeAtIndex: i ]
]

%

category: 'Updating Indexes'
method: PathTerm
removeMappingsFor: anObject lastOne: aBoolean logging: doLogging
  "Remove entries in the index dictionary and dependency lists for anObject."

  | nextObj depList more isLast |
  self size == 0
    ifTrue: [ ^ self ].
  nextObj := self _nextObjectFor: anObject.
  updateBtree ~~ nil
    ifTrue: [
      " remove an entry from the B-tree "
      updateBtree btreeRemoveKey: nextObj value: anObject.
      DependencyList removePathTerm: self for: nextObj logging: doLogging	" remove dependency list entry for next object " ].
  more := false.
  updateDict ~~ nil
    ifTrue: [
      " remove the index dictionary entry "
      more := updateDict
        removeKey: nextObj
        value: anObject
        term: self
        logging: doLogging ].
  (nil ~~ nextObj and: [ children isEmpty not ])
    ifTrue: [
      " make recursive call to remove mappings "
      isLast := aBoolean and: [ more not ].
      1 to: children size do: [ :i | (children at: i) removeMappingsFor: nextObj lastOne: isLast logging: doLogging ].
      isLast
        ifTrue: [
          " remove dependency list entries for next object "
          (depList := DependencyList for: nextObj) ~~ nil
            ifTrue: [ depList removePathTerms: children for: nextObj logging: doLogging ] ] ]
%

category: 'Updating Indexes'
method: PathTerm
removeMappingsSkipBtreeFor: anObject lastOne: aBoolean logging: doLogging

"Remove entries in the index dictionary and dependency lists for anObject.
 This version for index removal, it does not update the btree since the btree
 is going away (#40858)."

| nextObj depList more isLast |
self size == 0
  ifTrue: [ ^ self ].

nextObj := self _nextObjectFor: anObject.

updateBtree ~~ nil
  ifTrue: [
    " skip update of btree, index is going away"

    " remove dependency list entry for next object "
    DependencyList removePathTerm: self for: nextObj logging: doLogging.
  ].

more := false.
updateDict ~~ nil
  ifTrue: [
    " remove the index dictionary entry "
    more := updateDict removeKey: nextObj value: anObject term: self logging: doLogging.
  ].

( nil ~~ nextObj and: [ children isEmpty not ] )
  ifTrue: [ " make recursive call to remove mappings "
    isLast := aBoolean and: [ more not ].
    1 to: children size do: [ :i |
      (children at: i) removeMappingsFor: nextObj
        lastOne: isLast
        logging: doLogging
    ].
    isLast
      ifTrue: [
        " remove dependency list entries for next object "
        (depList := DependencyList for: nextObj) ~~ nil
          ifTrue: [ depList removePathTerms: children for: nextObj logging: doLogging ]
      ]
  ]
%

category: 'Accessing'
method: PathTerm
requirePathTerms
  "If missing path slots are tolerated, answer false"

  ^ true
%

category: 'Testing'
method: PathTerm
termsRequired
  "Answer true if receiver requires that instance variables of indexed objects are present "

  ^ true
%

category: 'Updating Indexes'
method: PathTerm
undoDirectMappingFor: anObject logging: doLogging

"There is a range index directly on the elements of the NSC."

updateDict ~~ nil
    ifTrue: [ " remove the index dictionary entry "
        updateDict
            removeKey: anObject
            value: anObject
            term: self
            logging: doLogging
    ]
%

category: 'Updating Indexes'
method: PathTerm
undoMappingsFor: anObject lastOne: aBoolean logging: doLogging

"Remove entries in the index dictionary and dependency lists for anObject."


| nextObj depList more isLast |
self size == 0
  ifTrue: [ ^ self ].

[
    nextObj := self _nextObjectFor: anObject.
] onException: Error do:[ :ex |
    "Handle any error thrown during execution of _nextObjectFor:
     Cannot resolve the path for this guy --- can't have been added to index,
     in fact this object could have caused the failure in the first place"
    ^ self
].

updateBtree ~~ nil
  ifTrue: [
    " remove dependency list entry for next object "
    DependencyList removePathTerm: self for: nextObj logging: doLogging.
  ].

more := false.
updateDict ~~ nil
  ifTrue: [
    " remove the index dictionary entry "
    more := updateDict removeKey: nextObj value: anObject term: self logging: doLogging.
  ].

( nil ~~ nextObj and: [ children isEmpty not ] )
  ifTrue: [ " make recursive call to remove mappings "
    isLast := aBoolean and: [ more not ].
    1 to: children size do: [ :i |
      (children at: i) undoMappingsFor: nextObj
        lastOne: isLast
        logging: doLogging
    ].
    isLast
      ifTrue: [
        " remove dependency list entries for next object "
        (depList := DependencyList for: nextObj) ~~ nil
          ifTrue: [ depList removePathTerms: children for: nextObj logging: doLogging ]
      ]
  ]
%

category: 'Updating Indexes'
method: PathTerm
update: anObject at: ivOffset to: newValue
  "The instance variable for anObject is being changed to newValue.
 Update the index dictionary and dependency lists for the old value and the
 newValue.  Returns true if the index objects were modified correctly;
 otherwise returns an Array containing error information."

  | maps depList more continue occurrences mapInfo doLogging oldValue exa |
  self size == 0
    ifTrue: [ ^ true ].
  maps := {}.
  self getIndexDictionary
    ifNotNil: [ " get the mapping info for all next path terms "
      1 to: children size do: [ :i | mapInfo := (children at: i)
          getMappingInfoFor: newValue
          ifObject: anObject
          atOffset: ivOffset
          replaceWith: newValue.
        mapInfo class == self _mappingInfoClass
          ifFalse: [ ^ mapInfo	"an Array of error info" ].
        maps addLast: mapInfo ] ].
  doLogging := UnorderedCollection _isRcIndexLoggingEnabled.
  oldValue := anObject instVarAt: ivOffset.
  occurrences := 0.
  updateBtree ifNotNil: [ (self _checkBtreeComparisonWith: newValue)
        ifFalse: [ (exa := ImproperOperation new)
            args: { newValue class. self name. updateBtree lastElementClassDescription};
            _number:
                (ErrorSymbols at: #'rtErrRangeEqualityIndexInvalidClassKindForBtree').
          ^ {false.	" indicating no indexing objects were modified "
          exa} ].	" remove B-tree entry for range index "
      [ updateBtree btreeRemoveKey: oldValue value: anObject ]
        whileTrue: [ occurrences := occurrences + 1 ].
      occurrences == 0
        ifTrue: [ (exa := ImproperOperation new)
            object: oldValue;
            arg: anObject;
            _number:
                (ErrorSymbols at: #'rtErrRangeEqualityIndexObjectNotInBtree').
          ^ {false.	" indicating no indexing objects were modified "
          exa} ].
      (needsDepList and: [ nil ~~ oldValue ])
        ifTrue: [ occurrences
            timesRepeat: [ DependencyList removePathTerm: self for: oldValue logging: doLogging ] ] ].
  updateDict ifNotNil: [ continue := true.
      [ continue ] whileTrue: [ " remove the index dictionary entry "
          more := updateDict
            removeKey: oldValue
            value: anObject
            term: self
            logging: doLogging
            ifAbsent: [ continue := false ].
          occurrences := occurrences + 1 ].
      occurrences := occurrences - 1.
      oldValue ifNotNil: [ " make recursive call to remove mappings "
          1 to: children size do: [ :i | occurrences timesRepeat: [ (children at: i)
                  removeMappingsFor: oldValue
                  lastOne: more not
                  logging: doLogging ] ].
          more
            ifFalse: [ depList := DependencyList for: oldValue.
              depList
                ifNotNil: [ depList removePathTerms: children for: oldValue logging: doLogging ] ] ] ].
  updateBtree ifNotNil: [ " insert an entry into the B-tree "
      occurrences timesRepeat: [ updateBtree btreeAt: newValue put: anObject ] ].
  updateDict ifNotNil: [ " insert an entry into the index dictionary "
      occurrences timesRepeat: [ updateDict
            _at: newValue
            put: anObject
            term: self
            logging: doLogging ] ].
  (needsDepList and: [ newValue ~~ nil ])
    ifTrue: [ occurrences
        timesRepeat: [ newValue getDepListAndAddLastElementPathTerm: self logging: true ] ].
  updateBtree ifNil: [ " make recursive call to add mappings "
      1 to: maps size do: [ :i | mapInfo := maps at: i.
        occurrences
          timesRepeat: [ mapInfo pathTerm addMappingsUsing: mapInfo logging: doLogging ] ] ].
  ^ true
%

category: 'Accessing'
method: PathTerm
updateBtree

"Returns the value of the instance variable 'updateBtree'."

^updateBtree
%

category: 'Updating'
method: PathTerm
updateBtree: newValue

"Modify the value of the instance variable 'updateBtree'."

updateBtree := newValue
%

category: 'Accessing'
method: PathTerm
updateDict

"Returns the value of the instance variable 'updateDict'."

^updateDict
%

category: 'Updating'
method: PathTerm
updateDict: newValue

"Modify the value of the instance variable 'updateDict'."

updateDict := newValue
%

category: 'Updating'
method: PathTerm
_addChildTerm: aPathTerm
  children addLast: aPathTerm
%

category: 'Testing'
method: PathTerm
_checkBtreeComparisonWith: anObject

"Returns whether the receiver's B-tree can hold an entry with anObject as the
 key."


^ updateBtree _canCompareWith: anObject
%

category: 'Accessing'
method: PathTerm
_classOf: anObject

"Returns the class of the given object."

<primitive: 166>
self _primitiveFailed: #_classOf: args: { anObject } .
self _uncontinuableError
%

category: 'Updating Indexes'
method: PathTerm
_clear


"Assigns nil to important instance variables and sets the receiver's size
 to zero."

children := nil.
updateBtree := nil.
updateDict := nil.
self size: 0.
%

category: 'Updating'
method: PathTerm
_determineChildren
  "Determine the children of the receiver by getting the next path term for each
 index object that utilizes the receiver path term."

  | indexObj |
  children size: 0.
  1 to: self size do: [ :i |
    indexObj := self at: i.
    (indexObj size > offset
      and: [ (children includesIdentical: (indexObj at: offset + 1)) not ])
      ifTrue: [ self _addChildTerm: (indexObj at: offset + 1) ] ]
%

category: 'Index Maintenance'
method: PathTerm
_doAddMappingsFor: anNSC on: indexObj indexManager: indexManager hasSet: hasSet
  "Adds the mappings in the index dictionary, dependency lists, and so on for all
 elements in the receiver."

  | objNsc bag |
  bag := anNSC _asIdentityBag.
  hasSet
    ifTrue: [
      | updateIndexList |
      " if there is a set-valued instance variable, collect objects in a
      Bag on which to update the index dictionary "
      updateIndexList := false.
      (self == indexObj lastPathTerm
        _and: [ self size > 1 _and: [ (self at: 1) size ~= (self at: 2) size ] ])
        ifTrue: [
          " see if index is subsumed by an existing index "
          " if last path term is #*, will need to update the
          last objects' index list "
          self indicatesMultiValue
            ifTrue: [
              updateIndexList := true.
              objNsc := NscBuilder
                for: IdentityBag new
                max: indexObj sizeForNscBuilder ]
            ifFalse: [ objNsc := nil ] ]
        ifFalse: [ objNsc := NscBuilder for: IdentityBag new max: indexObj sizeForNscBuilder ].
      1 to: bag size do: [ :i |
        " traverse up to the point of the unshared path term "
        indexObj
          traverse: (bag _at: i)
          upTo: self
          startingAt: 1
          into: objNsc
          addingIndex: true ].
      objNsc ~~ nil
        ifTrue: [
          updateIndexList
            ifTrue: [ self addIndexListEntriesFor: objNsc completeBag index: indexObj ]
            ifFalse: [
              objNsc := objNsc completeBag.
              1 to: objNsc size do: [ :j |
                self addMappingsForObject: (objNsc _at: j) logging: false.
                j \\ 100 == 0
                  ifTrue: [ indexManager commitIndexMaintenance: indexObj at: j ] ] ] ] ]
    ifFalse: [
      | object |
      "no set-valued terms"
      indexManager autoCommit
        ifTrue: [ anNSC _lockForIndexCreation ].
      indexObj firstPathTerm == self
        ifTrue: [
          " see if need to traverse to the first unshared path term "
          1 to: bag size do: [ :i |
            object := bag _at: i.
            self addMappingsForObject: object logging: false.
            i \\ 100 == 0
              ifTrue: [ indexManager commitIndexMaintenance: indexObj at: i ] ] ]
        ifFalse: [
          1 to: bag size do: [ :i |
            " traverse up to the point of the unshared path term "
            object := bag _at: i.
            self addMappingsForObject: object traverseUpTo: self for: indexObj logging: false.
            i \\ 100 == 0
              ifTrue: [ indexManager commitIndexMaintenance: indexObj at: i ] ] ] ].
  ^ anNSC
%

category: 'Index Maintenance'
method: PathTerm
_doAddSubsumedIndex: indexObj nsc: anNSC
  "Adds the mappings in the index dictionary, dependency lists, and so on for all
 elements in anNSC for a subsumed index on indexObj."

  | objNsc bag |
  " index is subsumed by an existing index "
  indexObj _findSetValuedPathTermOffset == 0
    ifTrue: [ ^ anNSC ].
  bag := anNSC _asIdentityBag.
  " need to update index lists "
  self indicatesMultiValue
    ifTrue: [
      " if last path term is #*, will need to update the
      last objects' index list "
      objNsc := NscBuilder
        for: IdentityBag new
        max: indexObj sizeForNscBuilder ]
    ifFalse: [ objNsc := nil ].
  1 to: bag size do: [ :i |
    indexObj
      traverse: (bag _at: i)
      upTo: self
      startingAt: 1
      into: objNsc
      addingIndex: true ].
  objNsc ~~ nil
    ifTrue: [ self addIndexListEntriesFor: objNsc completeBag index: indexObj ].
  ^ anNSC
%

category: 'Testing'
method: PathTerm
_doNotPerformPretraversalFor: anObject
  "Returns whether to do a preparatory traversal (using MappingInfo objects)
 when anObject is being added to an indexed Bag or IdentityBag."

  ^ self _totalNumSetValuedTerms > 2
%

category: 'Index Maintenance'
method: PathTerm
_doRemoveIndex: indexObj nsc: nsc
      "Remove the index associated with the receiver from the nsc."

      | bag incomplete indexManager allTerms |
      indexManager := IndexManager current.
      bag := nsc _asIdentityBag.
      incomplete := #'_incompletePathTraversal'.
      indexObj _findSetValuedPathTermOffset ~~ 0
        ifTrue: [
          | updateIndexList objNsc |
          "See if there is a set-valued instance variable before the unshared path
     term."
          updateIndexList := false.
          (self == indexObj lastPathTerm
            _and: [ self size > 1 _and: [ (self at: 1) size ~= (self at: 2) size ] ])
            ifTrue: [
              " see if index is subsumed by an existing index "
              " if last path term is #*, will need to update the
              last objects' index list "
              self indicatesMultiValue
                ifTrue: [
                  updateIndexList := true.
                  objNsc := NscBuilder
                    for: IdentityBag new
                    max: indexObj sizeForNscBuilder ]
                ifFalse: [ objNsc := nil ] ]
            ifFalse: [ objNsc := NscBuilder for: IdentityBag new max: indexObj sizeForNscBuilder ].
          1 to: bag size do: [ :i |
            " for each element in the NSC ... "
            " traverse up to the point of the unshared path term "
            indexObj
              traverse: (bag _at: i)
              upTo: self
              startingAt: 1
              into: objNsc
              addingIndex: false ].
          objNsc ~~ nil
            ifTrue: [ | endObj |
              updateIndexList
                ifTrue: [ self removeIndexListEntriesFor: objNsc completeBag index: indexObj ]
                ifFalse: [
                  objNsc := objNsc completeBag.
                  1 to: objNsc size do: [ :j |
                    endObj := objNsc _at: j.
                    endObj ~~ incomplete
                      ifTrue: [
                        " only remove mappings once for a given object "
                        self
                          removeMappingsFor: endObj
                          lastOne: true
                          logging: false.
                        DependencyList removePathTerm: self for: endObj ] ] ] ] ]
        ifFalse: [ | obj |
          self indicatesIndexOnRootNsc
            ifTrue: [
              " see if the index is on elements of the NSC "
              1 to: bag size do: [ :j |
                obj := bag _at: j.
                self removeDirectMappingFor: obj logging: false.
                DependencyList removePathTerm: self for: obj.
                indexManager commitIndexMaintenance: indexObj at: j ] ]
            ifFalse: [
              [ | endObj |
              1 to: bag size do: [ :j |
                endObj := indexObj traverse: (bag _at: j) upTo: self.
                (nil ~~ endObj and: [ incomplete ~~ endObj ])
                  ifTrue: [
                    self removeMappingsSkipBtreeFor: endObj lastOne: true logging: false.
                    DependencyList removePathTerm: self for: endObj.
                    indexManager commitIndexMaintenance: indexObj at: j ] ] ]
                onException: Error
                do: [ :ex |
                  ex number == (ErrorSymbols at: #'rtErrObjectPathTermNotInDependencyList')
                    ifTrue: [
                      "continue execution"
                      ex resume ]
                    ifFalse: [ ex outer ] ] ].
          allTerms := self _thisAndAllChildTerms ].
      ^ allTerms
%

category: 'Index Maintenance'
method: PathTerm
_doRemoveSubsumedIndex: indexObj nsc: nsc
  "The given index is subsumed by an existing index and is being removed."

  | bag objNsc |
  " see if there is a set-valued term "
  indexObj _findSetValuedPathTermOffset == 0
    ifFalse: [
      " need to update index lists "
      bag := nsc _asIdentityBag.
      self indicatesMultiValue
        ifTrue: [
          " if last path term is *, need to update the last objects index list "
          objNsc := NscBuilder
            for: IdentityBag new
            max: indexObj sizeForNscBuilder ]
        ifFalse: [ objNsc := nil ].
      1 to: bag size do: [ :i |
        " for each element in the NSC ... "
        indexObj
          traverse: (bag _at: i)
          upTo: self
          startingAt: 1
          into: objNsc
          addingIndex: false ].
      objNsc ~~ nil
        ifTrue: [ self removeIndexListEntriesFor: objNsc completeBag index: indexObj ] ]
%

category: 'Traversing'
method: PathTerm
_getNextObjectForTraversal: anObject
  " get the next object along the path "

  | ivOffset nextObj |
  ivOffset := anObject _findIVOffsetForPathTerm: self.
  ivOffset == nil
    ifTrue: [
      anObject _errorPathTermNotInDependencyList: self.
      nextObj := nil ]
    ifFalse: [ nextObj := anObject instVarAt: ivOffset ].
  ^ nextObj
%

category: 'Become Support'
method: PathTerm
_getPathTermIndexReferencesInto: refsToRcvr for: anObject
  "Place information about references to the receiver due to the receiver's
 participation in an index into the given Array.  The Array consists of pairs:

 1) An object that references the receiver.  If the object is directly
    contained in an indexed NSC, then this object is the NSC.  If the object
    in the dependency list is a tracking object (for object modification
    tracking), then this object is the tracking object.
 2) The offset of the instance variable in that object that references the
    receiver.
 3) If the object is the last path term, this number is < 0 and is a reference
    count for the number of times .
 3) If the object in the dependency list is a tracking
    object, this number is 0.

 This is used only in support of the 'become:' method."

 | vals indexObj obj |
 vals := nil.
 self size = 0
   ifTrue: [ ^ self ].
 " check if it is the first path term in an index (which means anObject
  is directly contained in an indexed NSC "
 indexObj := self at: 1.
 self offset == 1
   ifTrue: [
     anObject
       _addToReferences: indexObj nscRoot
       offset: 0
       occurrences: (indexObj nscRoot occurrencesOf: anObject)
       into: refsToRcvr ]
   ifFalse: [
     | prevPathTerm |
     "determine if mapping is contained in index dictionary or B-tree"
     self isRangeEqualityIndexLastPathTerm
       ifTrue: [
         " is either the next to the last or last object along the path "
         " if the last object does not need a dependency list, then
         anObject must be the next to the last object along the path
         (since only it could have a dependency list) "
         self needsDepList
           ifTrue: [
             " no choice but to check if its in the dictionary "
             vals := indexObj indexDictionary
               at: anObject
               term: (indexObj at: self offset - 1)
               otherwise: nil.
             vals
               ifNil: [ self error: 'Reference to anObject should have been found in indexDictionary.' ] ] ].
     " get the previous path term in the index "
     prevPathTerm := indexObj at: self offset - 1.
     vals
       ifNil: [
         " get the objects that refer to anObject "
         vals := indexObj indexDictionary
           at: anObject
           term: prevPathTerm
           ifAbsent: [ indexObj indexDictionary _errorNoEntryForKey: anObject term: prevPathTerm value: nil ] ].
     (BucketValueBag _hasInstance: vals)
       ifTrue: [
         1 to: vals size do: [ :j |
           obj := vals _at: j.
           prevPathTerm indicatesMultiValue
             ifTrue: [
               anObject
                 _addToReferences: obj
                 offset: 0
                 occurrences: (obj occurrencesOf: anObject)
                 into: refsToRcvr ]
             ifFalse: [
               anObject
                 _addToReferences: obj
                 offset: (prevPathTerm _ivOffsetFor: obj)
                 occurrences: 1
                 into: refsToRcvr ] ] ]
       ifFalse: [
         prevPathTerm indicatesMultiValue
           ifTrue: [
             anObject
               _addToReferences: vals
               offset: 0
               occurrences: (vals occurrencesOf: anObject)
               into: refsToRcvr ]
           ifFalse: [
             anObject
               _addToReferences: vals
               offset: (prevPathTerm _ivOffsetFor: vals)
               occurrences: 1
               into: refsToRcvr ] ] ]
%

category: 'Private'
method: PathTerm
_invalidIvOffset: anObject
  "If missing path slots are tolerated, return. Otherwise signal an error"

  self requirePathTerms
    ifFalse: [ ^ self ].
  anObject _errorInvalidOffset: name.
  self _uncontinuableError
%

category: 'Testing'
method: PathTerm
_isObsoletePathTerm

"Returns whether the receiver is obsolete."

^ self size == 0
%

category: 'Accessing'
method: PathTerm
_ivOffsetFor: anObject

"Returns the instance variable offset of anObject for the instance variable
 corresponding to the receiver path term."

^ (self _classOf: anObject) _ivOffsetOf: name
%

category: 'Private'
method: PathTerm
_makeObsolete

"Makes the receiver and all its children obsolete."



1 to: children size do: [ :i | (children at: i) _makeObsolete ].
self _clear.
%

category: 'Private'
method: PathTerm
_mapInfoOrErrorForMissingIvOffset: anObject
  "If missing path slots are tolerated, return an empty MappingInfo. Otherwise
   return an error array"

  | exa |
  (exa := LookupError new)
    _number:(ErrorSymbols at: #'rtErrObjectInvalidOffset');
    object: anObject;
    arg: name printString.
  ^ {false.	" indicating no indexing objects were modified "
  exa}
%

category: 'Private'
method: PathTerm
_mappingInfoClass
  ^ MappingInfo
%

category: 'Accessing'
method: PathTerm
_nextObjectFor: anObject

"Returns the object at the instance variable that corresponds to the receiver
 path term."


^ self _nextObjectFor: anObject atInstVar: (self _ivOffsetFor: anObject)
%

category: 'Accessing'
method: PathTerm
_nextObjectFor: anObject atInstVar: ivOffset

"Returns the object at the instance variable that corresponds to the receiver
 path term."

<primitive: 167>
self _primitiveFailed: #_nextObjectFor:atInstVar:
     args: { anObject . ivOffset } .
self _uncontinuableError
%

category: 'Reduced Conflict Support'
method: PathTerm
_selectiveAbort

 "Do nothing"
%

category: 'Accessing'
method: PathTerm
_thisAndAllChildTerms

"Returns an Array containing the receiver and all child path terms."


^ self _thisAndAllChildTermsInto: { }
%

category: 'Accessing'
method: PathTerm
_thisAndAllChildTermsInto: array

"Returns an Array containing the receiver and all child path terms."


array add: self.

1 to: children size do: [ :i |
  (children at: i) _thisAndAllChildTermsInto: array
].

^ array
%

category: 'Testing'
method: PathTerm
_totalNumSetValuedTerms
  ""

  | total |
  self indicatesNsc
    ifTrue: [ total := 1 ]
    ifFalse: [ total := 0 ].
  1 to: children size do: [ :i | total := total + (children at: i) _totalNumSetValuedTerms ].
  ^ total
%

! Class extensions for 'PPActionParser'

!		Class methods for 'PPActionParser'

category: 'instance creation'
classmethod: PPActionParser
on: aParser block: aBlock
	^ (self on: aParser) setBlock: aBlock
%

!		Instance methods for 'PPActionParser'

category: 'accessing'
method: PPActionParser
block
	"Answer the action block of the receiver."

	^ block
%

category: 'parsing'
method: PPActionParser
parseOn: aPPContext
	| element |
	^ (element := parser parseOn: aPPContext) isPetitFailure
		ifFalse: [ block value: element ]
		ifTrue: [ element ]
%

category: 'initialization'
method: PPActionParser
setBlock: aBlockOrSymbol

	block := aBlockOrSymbol isSymbol
				ifFalse: [aBlockOrSymbol]
				ifTrue: [[:arg | arg perform: aBlockOrSymbol]]
%

! Class extensions for 'PPAndParser'

!		Instance methods for 'PPAndParser'

category: 'operators'
method: PPAndParser
and
	^ self
%

category: 'parsing'
method: PPAndParser
parseOn: aPPContext
	| element memento |
	memento := aPPContext remember.
	element := parser parseOn: aPPContext.
	aPPContext restore: memento.
	^ element
%

! Class extensions for 'PPCharSetPredicate'

!		Class methods for 'PPCharSetPredicate'

category: 'instance creation'
classmethod: PPCharSetPredicate
on: aBlock
	^ self basicNew initializeOn: aBlock
%

!		Instance methods for 'PPCharSetPredicate'

category: 'initialization'
method: PPCharSetPredicate
initializeOn: aBlock
	block := aBlock.
	classification := Array new: 255.
	1 to: classification size do: [ :index |
		classification at: index put: (block
			value: (Character codePoint: index)) ]
%

category: 'evaluating'
method: PPCharSetPredicate
value: aCharacter
	| index |
	index := aCharacter asInteger.
	index == 0
		ifTrue: [ ^ block value: aCharacter ].
	index > 255
		ifTrue: [ ^ block value: aCharacter ].
	^ classification at: index
%

! Class extensions for 'PPChoiceParser'

!		Instance methods for 'PPChoiceParser'

category: 'operators'
method: PPChoiceParser
/ aRule
	^ self copyWith: aRule
%

category: 'parsing'
method: PPChoiceParser
parseOn: aPPContext
	"This is optimized code that avoids unnecessary block activations, do not change. When all choices fail, the last failure is answered."

	| element |
	1 to: parsers size do: [ :index |
		element := (parsers at: index)
			parseOn: aPPContext.
		element isPetitFailure
			ifFalse: [ ^ element ] ].
	^ element
%

! Class extensions for 'PPCompositeParser'

!		Class methods for 'PPCompositeParser'

category: 'accessing'
classmethod: PPCompositeParser
dependencies
	"Answer a collection of PPCompositeParser classes that this parser directly dependends on. Override this method in subclasses to declare dependent parsers. The default implementation does not depend on other PPCompositeParser."

	^ #()
%

category: 'accessing'
classmethod: PPCompositeParser
ignoredNames
	"Answer a collection of instance-variables that should not be automatically initialized with productions, but that are used internal to the composite parser."

	^ PPCompositeParser allInstVarNames
%

category: 'instance creation'
classmethod: PPCompositeParser
new
	"Answer a new parser starting at the default start symbol."

	^ self newStartingAt: self startSymbol
%

category: 'instance creation'
classmethod: PPCompositeParser
newStartingAt: aSymbol
	"Answer a new parser starting at aSymbol. The code makes sure to resolve all dependent parsers correctly."

	| parsers remaining |
	parsers := IdentityDictionary new.
	remaining := OrderedCollection with: self.
	[ remaining isEmpty ] whileFalse: [
		| dependency |
		dependency := remaining removeLast.
		(parsers includesKey: dependency) ifFalse: [
			parsers at: dependency put: dependency basicNew.
			remaining addAll: dependency dependencies ] ].
	parsers keysAndValuesDo: [ :class :parser |
		| dependencies |
		dependencies := IdentityDictionary new.
		class dependencies
			do: [ :dependency | dependencies at: dependency put: (parsers at: dependency) ].
		parser
			initializeStartingAt: (class == self
				ifTrue: [ aSymbol ]
				ifFalse: [ class startSymbol ])
			dependencies: dependencies ].
	parsers keysAndValuesDo: [ :class :parser |
		parser setParser: (parser perform: parser children first name).
		parser productionNames keysAndValuesDo: [ :key :value |
			(parser instVarAt: key) setParser: (parser perform: value) ] ].
	^ parsers at: self
%

category: 'parsing'
classmethod: PPCompositeParser
parse: anObject
	^ self parse: anObject startingAt: self startSymbol
%

category: 'parsing'
classmethod: PPCompositeParser
parse: anObject onError: aBlock
	^ self parse: anObject startingAt: self startSymbol onError: aBlock
%

category: 'parsing'
classmethod: PPCompositeParser
parse: anObject startingAt: aSymbol
	^ (self newStartingAt: aSymbol) parse: anObject
%

category: 'parsing'
classmethod: PPCompositeParser
parse: anObject startingAt: aSymbol onError: aBlock
	^ (self newStartingAt: aSymbol) parse: anObject onError: aBlock
%

category: 'accessing'
classmethod: PPCompositeParser
startSymbol
	"Answer the method that represents the default start symbol."

	^ #start
%

!		Instance methods for 'PPCompositeParser'

category: 'querying'
method: PPCompositeParser
dependencyAt: aClass
	"Answer the dependent parser aClass. Throws an error if this parser class is not declared in the method #dependencies on the class-side of the receiver."

	^ dependencies at: aClass ifAbsent: [ self error: 'Undeclared dependency in ' , self class name , ' to ' , aClass name ]
%

category: 'initialization'
method: PPCompositeParser
initializeStartingAt: aSymbol dependencies: aDictionary
	self initialize.
	parser := PPDelegateParser named: aSymbol.
	self productionNames keysAndValuesDo: [ :key :value |
		self instVarAt: key put: (PPDelegateParser named: value) ].
	dependencies := aDictionary
%

category: 'querying'
method: PPCompositeParser
productionAt: aSymbol
	"Answer the production named aSymbol."

	^ self productionAt: aSymbol ifAbsent: [ nil ]
%

category: 'querying'
method: PPCompositeParser
productionAt: aSymbol ifAbsent: aBlock
	"Answer the production named aSymbol, if there is no such production answer the result of evaluating aBlock."

	(self class ignoredNames includes: aSymbol asString)
		ifTrue: [ ^ aBlock value ].
	(self class startSymbol = aSymbol)
		ifTrue: [ ^ parser ].
	^ self instVarAt: (self class allInstVarNames
		indexOf: aSymbol "asString"
		ifAbsent: [ ^ aBlock value ])
%

category: 'querying'
method: PPCompositeParser
productionNames
	"Answer a dictionary of slot indexes and production names."

	| productionNames ignoredNames |
	productionNames := Dictionary new.
	ignoredNames := self class ignoredNames
		collect: [ :each | each asSymbol ].
	self class allInstVarNames keysAndValuesDo: [ :key :value |
		(ignoredNames includes: value asSymbol)
			ifFalse: [ productionNames at: key put: value asSymbol ] ].
	^ productionNames
%

category: 'accessing'
method: PPCompositeParser
start
	"Answer the production to start this parser with."

	self subclassResponsibility
%

! Class extensions for 'PPConditionalParser'

!		Class methods for 'PPConditionalParser'

category: 'Instance Creation'
classmethod: PPConditionalParser
on: aPPParser block: block
	^ (PPConditionalParser on: aPPParser)
		block: block;
		yourself
%

!		Instance methods for 'PPConditionalParser'

category: 'Accessing'
method: PPConditionalParser
block: aBlock
	block := aBlock
%

category: 'Parsing'
method: PPConditionalParser
parseOn: aPPContext
	^ (block value: aPPContext)
		ifTrue: [ parser parseOn: aPPContext ]
		ifFalse: [ PPFailure message: block asString, ' was not evaluated to true.' context: aPPContext ]
%

! Class extensions for 'PPContext'

!		Class methods for 'PPContext'

category: 'Instance Creation'
classmethod: PPContext
on: aPPParser stream: aStream
	^ self basicNew
		initialize;
		root: aPPParser;
		stream: aStream asPetitStream;
		yourself
%

!		Instance methods for 'PPContext'

category: 'stream mimicry'
method: PPContext
atEnd
	^ stream atEnd
%

category: 'stream mimicry'
method: PPContext
back
	^ stream back
%

category: 'stream mimicry'
method: PPContext
collection
	^ stream collection
%

category: 'stream mimicry'
method: PPContext
contents
	^ stream contents
%

category: 'failures'
method: PPContext
furthestFailure
	" the furthest failure encountered while parsing the input stream "

	"^ self globalAt: #furthestFailure ifAbsent: [ nil ]"
	"performance optimization:"
	^ furthestFailure
%

category: 'accessing-globals'
method: PPContext
globalAt: aKey
	"Answer the global property value associated with aKey."

	^ self globalAt: aKey ifAbsent: [ self error: 'Property not found' ]
%

category: 'accessing-globals'
method: PPContext
globalAt: aKey ifAbsent: aBlock
	"Answer the global property value associated with aKey or, if aKey isn't found, answer the result of evaluating aBlock."

	^ globals == nil
		ifTrue: [ aBlock value ]
		ifFalse: [ globals at: aKey ifAbsent: aBlock ]
%

category: 'accessing-globals'
method: PPContext
globalAt: aKey ifAbsentPut: aBlock
	"Answer the global property associated with aKey or, if aKey isn't found store the result of evaluating aBlock as new value."

	^ self globalAt: aKey ifAbsent: [ self globalAt: aKey put: aBlock value ]
%

category: 'accessing-globals'
method: PPContext
globalAt: aKey put: anObject
	"Set the global property at aKey to be anObject. If aKey is not found, create a new entry for aKey and set is value to anObject. Answer anObject."

	^ (globals ifNil: [ globals := Dictionary new: 1 ])
		at: aKey put: anObject
%

category: 'accessing-globals'
method: PPContext
globals
	^ globals
%

category: 'accessing-globals'
method: PPContext
hasGlobal: aKey
	"Test if the global property aKey is present."

	^ globals ~~ nil  and: [ globals includesKey: aKey ]
%

category: 'accessing-properties'
method: PPContext
hasProperty: aKey
	"Test if the property aKey is present."

	^ properties ~~ nil  and: [ properties includesKey: aKey ]
%

category: 'memoization'
method: PPContext
identifier
	"
		I provide an identifier that is used by memoizing parser to figure out if the
		cache should be flushed or not.
	"
	^ stream
%

category: 'initialization'
method: PPContext
initialize
	stream := nil.
%

category: 'initialization'
method: PPContext
initializeFor: parser
	root := parser.
%

category: 'stream mimicry'
method: PPContext
isEndOfLine
	^ stream isEndOfLine
%

category: 'stream mimicry'
method: PPContext
isStartOfLine
	^ stream isStartOfLine
%

category: 'stream mimicry'
method: PPContext
next
	^ stream next
%

category: 'stream mimicry'
method: PPContext
next: anInteger
	^ stream next: anInteger
%

category: 'failures'
method: PPContext
noteDominantFailure: aDominantPPFailure
  "override an existing furthestFailure (at the same or greater position)"

  furthestFailure == nil
    ifTrue: [ self error: 'expected an existing furthestFailure' ].
  aDominantPPFailure position >= furthestFailure position
    ifTrue: [ furthestFailure := aDominantPPFailure ].
  "true
    ifTrue: [
      (self globalAt: #'dominantFailureStack' ifAbsentPut: [ OrderedCollection new ])
        add: aDominantPPFailure ]"
%

category: 'failures'
method: PPContext
noteFailure: aPPFailure
  "record the furthest failure encountered while parsing the input stream "

  (furthestFailure == nil  or: [ aPPFailure position > furthestFailure position ])
    ifTrue: [ furthestFailure := aPPFailure ].
  " true
    ifTrue: [
      (self globalAt: #'failureStack' ifAbsentPut: [ OrderedCollection new ])
        add: aPPFailure ]"
%

category: 'stream mimicry'
method: PPContext
peek
	^ stream peek
%

category: 'stream mimicry'
method: PPContext
peekTwice
	^ stream peekTwice
%

category: 'stream mimicry'
method: PPContext
position
	^ stream position
%

category: 'stream mimicry'
method: PPContext
position: anInteger
	^ stream position: anInteger
%

category: 'initialization'
method: PPContext
postCopy
	super postCopy.
	globals := globals copy.
%

category: 'printing'
method: PPContext
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $:.
	aStream nextPut: $ .
	stream printOn: aStream
%

category: 'accessing-properties'
method: PPContext
properties
	^ properties
%

category: 'accessing-properties'
method: PPContext
propertyAt: aKey
	"Answer the property value associated with aKey."

	^ self propertyAt: aKey ifAbsent: [ self error: 'Property not found' ]
%

category: 'accessing-properties'
method: PPContext
propertyAt: aKey ifAbsent: aBlock
	"Answer the property value associated with aKey or, if aKey isn't found, answer the result of evaluating aBlock."

	^ properties == nil
		ifTrue: [ aBlock value ]
		ifFalse: [ properties at: aKey ifAbsent: aBlock ]
%

category: 'accessing-properties'
method: PPContext
propertyAt: aKey ifAbsentPut: aBlock
	"Answer the property associated with aKey or, if aKey isn't found store the result of evaluating aBlock as new value."

	^ self propertyAt: aKey ifAbsent: [ self propertyAt: aKey put: aBlock value ]
%

category: 'accessing-properties'
method: PPContext
propertyAt: aKey put: anObject
	"Set the property at aKey to be anObject. If aKey is not found, create a new entry for aKey and set is value to anObject. Answer anObject."

	^ (properties ifNil: [ properties := Dictionary new: 1 ])
		at: aKey put: anObject
%

category: 'memoization'
method: PPContext
remember
	| memento |
	memento := PPContextMemento new
		stream: stream;
		position: stream position;
		yourself.

	self rememberProperties: memento.
	^ memento
%

category: 'memoization'
method: PPContext
rememberProperties: aPPContextMemento
	properties ifNil: [ ^ self ].

	properties keysAndValuesDo: [ :key :value |
		aPPContextMemento propertyAt: key put: value
	].
%

category: 'accessing-globals'
method: PPContext
removeGlobal: aKey
	"Remove the property with aKey. Answer the property or raise an error if aKey isn't found."

	^ self removeGlobal: aKey ifAbsent: [ self error: 'Property not found' ]
%

category: 'accessing-globals'
method: PPContext
removeGlobal: aKey ifAbsent: aBlock
	"Remove the global property with aKey. Answer the value or, if aKey isn't found, answer the result of evaluating aBlock."

	| answer |
	globals == nil  ifTrue: [ ^ aBlock value ].
	answer := globals removeKey: aKey ifAbsent: aBlock.
	globals isEmpty ifTrue: [ globals := nil ].
	^ answer
%

category: 'accessing-properties'
method: PPContext
removeProperty: aKey
	"Remove the property with aKey. Answer the property or raise an error if aKey isn't found."

	^ self removeProperty: aKey ifAbsent: [ self error: 'Property not found' ]
%

category: 'accessing-properties'
method: PPContext
removeProperty: aKey ifAbsent: aBlock
	"Remove the property with aKey. Answer the value or, if aKey isn't found, answer the result of evaluating aBlock."

	| answer |
	properties == nil  ifTrue: [ ^ aBlock value ].
	answer := properties removeKey: aKey ifAbsent: aBlock.
	properties isEmpty ifTrue: [ properties := nil ].
	^ answer
%

category: 'initialization'
method: PPContext
reset
	properties := nil.
	globals := nil.
%

category: 'memoization'
method: PPContext
restore: aPPContextMemento
	aPPContextMemento stream == stream ifFalse: [ self error: 'Oops!' ].

	stream position: aPPContextMemento position.
	self restoreProperties: aPPContextMemento.
%

category: 'memoization'
method: PPContext
restoreProperties: aPPContextMemento
	aPPContextMemento stream == stream ifFalse: [ self error: 'Oops!' ].

	properties ifNil: [ ^ self ].

	properties keysDo: [ :key |
		(aPPContextMemento hasProperty: key)
			ifTrue: [ properties at: key put: (aPPContextMemento propertyAt: key) ]
			ifFalse: [ properties removeKey: key  ].
	].

	aPPContextMemento keysAndValuesDo: [ :key :value |
		properties at: key put: value
	]
%

category: 'accessing'
method: PPContext
root
	^ root
%

category: 'memoization'
method: PPContext
size
	^ stream size
%

category: 'stream mimicry'
method: PPContext
skip: anInteger
	^ stream skip: anInteger
%

category: 'stream mimicry'
method: PPContext
skipTo: anObject
	^ stream skipTo: anObject
%

category: 'stream mimicry'
method: PPContext
skipToAll: aString
	"Set the access position of the receiver to be past the next occurrence of the subCollection. Answer whether subCollection is found.  No wildcards, and case does matter."
	| pattern startMatch |
	pattern := aString readStream.
	startMatch := nil.
	[ pattern atEnd ] whileFalse:
		[ stream atEnd ifTrue: [ ^ false ].
		stream next = pattern next
			ifTrue: [ pattern position = 1 ifTrue: [ startMatch := stream position ] ]
			ifFalse:
				[ pattern position: 0.
				startMatch ifNotNil:
					[ stream position: startMatch.
					startMatch := nil ] ] ].
	^ true
%

category: 'stream mimicry'
method: PPContext
skipToAnyOf: aCharacterSet
	"Set the access position of the receiver to be past the next occurrence of
	a character in the character set. Answer whether a fitting character is found."

	[stream atEnd]
		whileFalse: [ (aCharacterSet includes: stream next) ifTrue: [^true]].
	^false
%

category: 'accessing'
method: PPContext
stream
	^ stream
%

category: 'accessing'
method: PPContext
stream: aStream
	stream := aStream.
%

category: 'stream mimicry'
method: PPContext
uncheckedPeek
	^ stream uncheckedPeek
%

category: 'stream mimicry'
method: PPContext
upTo: anObject
	^ stream upTo: anObject
%

category: 'stream mimicry'
method: PPContext
upToAll: whatever
	^ stream upToAll: whatever
%

category: 'stream mimicry'
method: PPContext
upToAnyOf: whatever
	^ stream upToAnyOf: whatever
%

! Class extensions for 'PPContextMemento'

!		Instance methods for 'PPContextMemento'

category: 'comparing'
method: PPContextMemento
= anObject

	(self == anObject) ifTrue: [ ^ true ].
	(anObject class = PPContextMemento) ifFalse: [ ^ false ].

	(anObject stream == stream) ifFalse: [ ^ false ].
	(anObject position == position) ifFalse: [ ^ false ].

	(self propertiesSize == anObject propertiesSize) ifFalse: [ ^ false ].

	self keysAndValuesDo: [ :key :value |
		(anObject hasProperty: key) ifFalse: [ ^ false ].
		((anObject propertyAt: key) = value) ifFalse: [ ^ false ].
 	].

	^ true.
%

category: 'comparing'
method: PPContextMemento
hash
	^ (position hash bitXor: stream hash) bitXor: properties hash.
%

category: 'accessing - properties'
method: PPContextMemento
hasProperty: aKey
	"Test if the property aKey is present."

	^ properties ~~ nil  and: [ properties includesKey: aKey ]
%

category: 'accessing - properties'
method: PPContextMemento
keysAndValuesDo: aBlock
	properties ifNil: [ ^ self ].
	properties keysAndValuesDo: [ :key :value | aBlock value: key value: value copy ]
%

category: 'accessing'
method: PPContextMemento
position
	^ position
%

category: 'accessing'
method: PPContextMemento
position: anInteger
	position := anInteger
%

category: 'accessing - properties'
method: PPContextMemento
propertiesSize
	properties ifNil: [ ^ 0 ].
	^ properties size.
%

category: 'accessing - properties'
method: PPContextMemento
propertyAt: aKey
	"Answer the property value associated with aKey."

	^ self propertyAt: aKey ifAbsent: [ self error: 'Property not found' ]
%

category: 'accessing - properties'
method: PPContextMemento
propertyAt: aKey ifAbsent: aBlock
	"Answer the property value associated with aKey or, if aKey isn't found, answer the result of evaluating aBlock."

	properties == nil
		ifTrue: [ ^ aBlock value ]
		ifFalse: [
			(properties includesKey: aKey) ifTrue: [
				^ (properties at: aKey) copy
			].
			^ aBlock value
		]
%

category: 'accessing - properties'
method: PPContextMemento
propertyAt: aKey ifAbsentPut: aBlock
	"Answer the property associated with aKey or, if aKey isn't found store the result of evaluating aBlock as new value."

	^ self propertyAt: aKey ifAbsent: [ self propertyAt: aKey put: aBlock value ]
%

category: 'accessing - properties'
method: PPContextMemento
propertyAt: aKey put: anObject
	"Set the property at aKey to be anObject. If aKey is not found, create a new entry for aKey and set is value to anObject. Answer anObject."

	^ (properties ifNil: [ properties := Dictionary new: 1 ])
		at: aKey put: (anObject copy)
%

category: 'accessing - properties'
method: PPContextMemento
removeProperty: aKey
	"Remove the property with aKey. Answer the property or raise an error if aKey isn't found."

	^ self removeProperty: aKey ifAbsent: [ self error: 'Property not found' ]
%

category: 'accessing - properties'
method: PPContextMemento
removeProperty: aKey ifAbsent: aBlock
	"Remove the property with aKey. Answer the value or, if aKey isn't found, answer the result of evaluating aBlock."

	| answer |
	properties == nil  ifTrue: [ ^ aBlock value ].
	answer := properties removeKey: aKey ifAbsent: aBlock.
	properties isEmpty ifTrue: [ properties := nil ].
	^ answer
%

category: 'accessing'
method: PPContextMemento
stream
	^ stream
%

category: 'accessing'
method: PPContextMemento
stream: aStream
	stream := aStream
%

! Class extensions for 'PPDelegateParser'

!		Class methods for 'PPDelegateParser'

category: 'instance creation'
classmethod: PPDelegateParser
on: aParser
	^ self new setParser: aParser
%

!		Instance methods for 'PPDelegateParser'

category: 'accessing'
method: PPDelegateParser
children
	^ Array with: parser
%

category: 'parsing'
method: PPDelegateParser
parseOn: aPPContext
	^ parser parseOn: aPPContext
%

category: 'initialization'
method: PPDelegateParser
setParser: aParser
	parser := aParser
%

! Class extensions for 'PPEndOfFileParser'

!		Instance methods for 'PPEndOfFileParser'

category: 'parsing'
method: PPEndOfFileParser
parseOn: aPPContext
	(aPPContext atEnd) ifFalse:
	[
		^ PPFailure message: 'end of input expected' context: aPPContext.
	].
	^ #'end-of-input'
%

! Class extensions for 'PPEndOfInputParser'

!		Instance methods for 'PPEndOfInputParser'

category: 'operators'
method: PPEndOfInputParser
end
	^ self
%

category: 'parsing'
method: PPEndOfInputParser
parseOn: aPPContext
	| memento result |
	memento := aPPContext remember.
	result := parser parseOn: aPPContext.
	(result isPetitFailure or: [ aPPContext stream atEnd ])
		ifTrue: [ ^ result ].
	result := PPFailure
		message: 'end of input expected'
		context: aPPContext.
	aPPContext restore: memento.
	^ result
%

! Class extensions for 'PPEndOfLineParser'

!		Instance methods for 'PPEndOfLineParser'

category: 'parsing'
method: PPEndOfLineParser
parseOn: aPPContext
	(aPPContext isEndOfLine) ifTrue: [
		^ #endOfLine
	].
	^ PPFailure message: 'End of line expected' context: aPPContext at: aPPContext position
%

! Class extensions for 'PPEpsilonParser'

!		Instance methods for 'PPEpsilonParser'

category: 'parsing'
method: PPEpsilonParser
parseOn: aStream
	^ nil
%

! Class extensions for 'PPExpressionParser'

!		Instance methods for 'PPExpressionParser'

category: 'private'
method: PPExpressionParser
build: aParser left: aChoiceParser
	^ (aParser separatedBy: aChoiceParser) foldLeft: [ :a :op :b | op first value: a value: op second value: b ]
%

category: 'private'
method: PPExpressionParser
build: aParser postfix: aChoiceParser
	^ aParser , aChoiceParser star map: [ :term :ops | ops inject: term into: [ :result :operator | operator first value: result value: operator second ] ]
%

category: 'private'
method: PPExpressionParser
build: aParser prefix: aChoiceParser
	^ aChoiceParser star , aParser map: [ :ops :term | ops reverse inject: term into: [ :result :operator | operator first value: operator second value: result ] ]
%

category: 'private'
method: PPExpressionParser
build: aParser right: aChoiceParser
	^ (aParser separatedBy: aChoiceParser) foldRight: [ :a :op :b | op first value: a value: op second value: b ]
%

category: 'private'
method: PPExpressionParser
buildOn: aParser
	^ self buildSelectors inject: aParser into: [ :term :selector |
		| list |
		list := operators at: selector ifAbsent: [ #() ].
		list isEmpty
			ifTrue: [ term ]
			ifFalse: [
				self
					perform: selector with: term
					with: (list size = 1
						ifTrue: [ list first first ==> [ :operator | Array with: list first second with: operator ] ]
						ifFalse: [
							list
								inject: PPChoiceParser new
								into: [ :choice :each | choice / (each first ==> [ :operator | Array with: each second with: operator ]) ] ]) ] ]
%

category: 'private'
method: PPExpressionParser
buildSelectors
	^ #(build:prefix: build:postfix: build:right: build:left:)
%

category: 'specifying'
method: PPExpressionParser
group: aOneArgumentBlock
	"Defines a priority group by evaluating aOneArgumentBlock."

	operators := Dictionary new.
	parser := [
		aOneArgumentBlock value: self.
	 	self buildOn: parser ]
			ensure: [ operators := nil ]
%

category: 'specifying'
method: PPExpressionParser
left: aParser do: aThreeArgumentBlock
	"Define an operator aParser that is left-associative. Evaluate aThreeArgumentBlock with the first term, the operator, and the second term."

	self operator: #build:left: parser: aParser do: aThreeArgumentBlock
%

category: 'private'
method: PPExpressionParser
operator: aSymbol parser: aParser do: aBlock
	parser == nil
		ifTrue: [ ^ self error: 'You did not specify a term when creating the receiver.' ].
	operators == nil
		ifTrue: [ ^ self error: 'Use #group: to define precedence groups in descending order.' ].
	(operators at: aSymbol ifAbsentPut: [ OrderedCollection new ])
		addLast: (Array with: aParser asParser with: aBlock)
%

category: 'specifying'
method: PPExpressionParser
postfix: aParser do: aTwoArgumentBlock
	"Define a postfix operator aParser. Evaluate aTwoArgumentBlock with the term and the operator."

	self operator: #build:postfix: parser: aParser do: aTwoArgumentBlock
%

category: 'specifying'
method: PPExpressionParser
prefix: aParser do: aTwoArgumentBlock
	"Define a prefix operator aParser. Evaluate aTwoArgumentBlock with the operator and the term."

	self operator: #build:prefix: parser: aParser do: aTwoArgumentBlock
%

category: 'specifying'
method: PPExpressionParser
right: aParser do: aThreeArgumentBlock
	"Define an operator aParser that is right-associative. Evaluate aThreeArgumentBlock with the first term, the operator, and the second term."

	self operator: #build:right: parser: aParser do: aThreeArgumentBlock
%

category: 'specifying'
method: PPExpressionParser
term: aParser
	"Defines the initial term aParser of the receiver."

	parser == nil
		ifTrue: [ parser := aParser ]
		ifFalse: [ self error: 'Unable to redefine the term.' ]
%

! Class extensions for 'PPFailingParser'

!		Class methods for 'PPFailingParser'

category: 'instance creation'
classmethod: PPFailingParser
message: aString
	^ self new setMessage: aString
%

!		Instance methods for 'PPFailingParser'

category: 'accessing'
method: PPFailingParser
message
	"Answer the error message of the receiving parser."

	^ message
%

category: 'parsing'
method: PPFailingParser
parseOn: aPPContext
	^ PPFailure message: message context: aPPContext
%

category: 'printing'
method: PPFailingParser
printNameOn: aStream
	super printNameOn: aStream.
	aStream nextPutAll: ', '; print: message
%

category: 'initialization'
method: PPFailingParser
setMessage: aString
	message := aString
%

! Class extensions for 'PPFailure'

!		Class methods for 'PPFailure'

category: 'instance creation'
classmethod: PPFailure
message: aString
	^ self basicNew initializeMessage: aString
%

category: 'instance creation'
classmethod: PPFailure
message: aString at: anInteger
	"One should not use this method if the furthest failure is supposed to be reported correctly"
	^ self basicNew initializeMessage: aString at: anInteger
%

category: 'instance creation'
classmethod: PPFailure
message: aString context: aPPContext
	^ self basicNew initializeMessage: aString context: aPPContext
%

category: 'instance creation'
classmethod: PPFailure
message: aString context: aPPContext at: position
	^ self basicNew initializeMessage: aString context: aPPContext position: position
%

!		Instance methods for 'PPFailure'

category: 'initialization'
method: PPFailure
initializeMessage: aString
	message := aString.
%

category: 'initialization'
method: PPFailure
initializeMessage: aString at: anInteger
	"One should not use this method if the furthest failure is supposed to be reported correctly"
	message := aString.
	position := anInteger.
%

category: 'initialization'
method: PPFailure
initializeMessage: aString context: aPPContext
	self initializeMessage: aString context:  aPPContext position: aPPContext position
%

category: 'initialization'
method: PPFailure
initializeMessage: aString context: aPPContext position: anInteger
	message := aString.
	context := aPPContext.
	position := anInteger.

	"record the furthest failure encountered while parsing the input stream "
	aPPContext noteFailure: self.
%

category: 'testing'
method: PPFailure
isPetitFailure
	"I am the only class that should implement this method to return true."

	^ true
%

category: 'accessing'
method: PPFailure
message
	"Answer a human readable error message of this parse failure."

	^ message
%

category: 'accessing'
method: PPFailure
position
	"Answer the position in the source string that caused this parse failure."

	^ position
%

category: 'printing'
method: PPFailure
printOn: aStream
	aStream
		nextPutAll: (self message ifNil: ['<message not specified>']);
		nextPutAll: ' at '; print: self position
%

! Class extensions for 'PPFlattenParser'

!		Instance methods for 'PPFlattenParser'

category: 'private'
method: PPFlattenParser
on: aCollection start: aStartInteger stop: aStopInteger value: anObject
	^ aCollection copyFrom: aStartInteger to: aStopInteger
%

category: 'parsing'
method: PPFlattenParser
parseOn: aPPContext
	| start element |
	start := aPPContext position.
	element := parser parseOn: aPPContext.
	element isPetitFailure ifTrue: [ ^ element ].
	^ self on: aPPContext stream collection start: start + 1 stop: aPPContext position value: element
%

! Class extensions for 'PPForwardingParser'

!		Class methods for 'PPForwardingParser'

category: 'instance creation'
classmethod: PPForwardingParser
to: forwardee

	^self new forwardee: forwardee
%

!		Instance methods for 'PPForwardingParser'

category: 'forwarding'
method: PPForwardingParser
doesNotUnderstand: messageDescriptor
	"Forward them all"

	^forwardee
		perform: (messageDescriptor at: 1)
		env: 0
		withArguments: (messageDescriptor at: 2)
%

category: 'accessing'
method: PPForwardingParser
forwardee: aParser

	forwardee := aParser
%

category: 'testing'
method: PPForwardingParser
isPetitParser
	"Must override Object's implementation, or forward. Easier to override."

	^true
%

! Class extensions for 'PPGreedyRepeatingParser'

!		Instance methods for 'PPGreedyRepeatingParser'

category: 'parsing'
method: PPGreedyRepeatingParser
parseOn: aPPContext
	| memento element elements positions |
	memento := aPPContext remember.
	elements := OrderedCollection new.
	[ elements size < min ] whileTrue: [
		(element := parser parseOn: aPPContext) isPetitFailure ifTrue: [
			aPPContext restore: memento.
			^ element ].
		elements addLast: element ].
	positions := OrderedCollection with: aPPContext remember.
	[ elements size < max and: [ (element := parser parseOn: aPPContext) isPetitFailure not ] ] whileTrue: [
		elements addLast: element.
		positions addLast: aPPContext remember ].
	[ positions isEmpty ] whileFalse: [
		aPPContext restore: positions last.
		element := limit parseOn: aPPContext.
		element isPetitFailure ifFalse: [
			aPPContext restore: positions last.
			^ elements asArray ].
		elements isEmpty ifTrue: [
			aPPContext restore: memento.
			^ element ].
		elements removeLast.
		positions removeLast ].
	aPPContext restore: memento.
	^ PPFailure message: 'overflow' context: aPPContext at: memento position
%

! Class extensions for 'PPLazyRepeatingParser'

!		Instance methods for 'PPLazyRepeatingParser'

category: 'parsing'
method: PPLazyRepeatingParser
parseOn: aPPContext
	| memento element elements |
	memento := aPPContext remember.
	elements := OrderedCollection new.
	[ elements size < min ] whileTrue: [
		(element := parser parseOn: aPPContext) isPetitFailure ifTrue: [
			aPPContext restore: memento.
			^ element ].
		elements addLast: element ].
	[ self matchesLimitOn: aPPContext ] whileFalse: [
		elements size < max ifFalse: [
			aPPContext restore: memento.
			^ PPFailure message: 'overflow' context: aPPContext at: memento position ].
		element := parser parseOn: aPPContext.
		element isPetitFailure ifTrue: [
			aPPContext restore: memento.
			^ element ].
		elements addLast: element ].
	^ elements asArray
%

! Class extensions for 'PPLimitedChoiceParser'

!		Instance methods for 'PPLimitedChoiceParser'

category: 'operators'
method: PPLimitedChoiceParser
// aRule
	^ self copyWith: aRule
%

category: 'initialization'
method: PPLimitedChoiceParser
initialize
	limit := nil asParser
%

category: 'accessing'
method: PPLimitedChoiceParser
limit

	^ limit
%

category: 'accessing'
method: PPLimitedChoiceParser
limit: anObject

	limit := anObject
%

category: 'parsing'
method: PPLimitedChoiceParser
parseOn: aPPContext
	"This is optimized code that avoids unnecessary block activations, do not change. When all choices fail, the last failure is answered."

	| element limitResult memento |
	"self halt."
	1 to: parsers size do: [ :index |
		memento := aPPContext remember.

		element := (parsers at: index)
			parseOn: aPPContext.

		(element isPetitFailure not) ifTrue: [
			"check limit"
			limitResult := limit parseOn: aPPContext.
			limitResult isPetitFailure ifTrue: [
				element := PPFailure message: 'limit failed' at: aPPContext position .
				aPPContext restore: memento.
			] ifFalse: [ ^ element ].
		].
	].
	^ element
%

! Class extensions for 'PPLimitedRepeatingParser'

!		Class methods for 'PPLimitedRepeatingParser'

category: 'instance creation'
classmethod: PPLimitedRepeatingParser
on: aParser limit: aLimitParser
	^ (self on: aParser) setLimit: aLimitParser
%

!		Instance methods for 'PPLimitedRepeatingParser'

category: 'accessing'
method: PPLimitedRepeatingParser
children
	^ Array with: parser with: limit
%

category: 'accessing'
method: PPLimitedRepeatingParser
limit
	"Answer the parser that limits (or ends) this repetition."

	^ limit
%

category: 'private'
method: PPLimitedRepeatingParser
matchesLimitOn: aPPContext
	| element position |
	position := aPPContext remember.
	element := limit parseOn: aPPContext.
	aPPContext restore: position.
	^ element isPetitFailure not
%

category: 'initialization'
method: PPLimitedRepeatingParser
setLimit: aParser
	limit := aParser
%

! Class extensions for 'PPListParser'

!		Class methods for 'PPListParser'

category: 'instance creation'
classmethod: PPListParser
with: aParser
	^ self withAll: (Array with: aParser)
%

category: 'instance creation'
classmethod: PPListParser
with: aFirstParser with: aSecondParser
	^ self withAll: (Array with: aFirstParser with: aSecondParser)
%

category: 'instance creation'
classmethod: PPListParser
withAll: aCollection
	^ self basicNew initialize;
		setParsers: aCollection
%

!		Instance methods for 'PPListParser'

category: 'accessing'
method: PPListParser
children
	^ parsers
%

category: 'copying'
method: PPListParser
copyWith: aParser
	^ self species withAll: (parsers copyWith: aParser)
%

category: 'initialization'
method: PPListParser
initialize
	super initialize.
	self setParsers: #()
%

category: 'copying'
method: PPListParser
postCopy
	super postCopy.
	parsers := parsers copy
%

category: 'initialization'
method: PPListParser
setParsers: aCollection
	parsers := aCollection asArray
%

! Class extensions for 'PPLiteralObjectParser'

!		Instance methods for 'PPLiteralObjectParser'

category: 'operators'
method: PPLiteralObjectParser
caseInsensitive
	"Answer a parser that can parse the receiver case-insensitive."

	literal asUppercase = literal asLowercase ifTrue: [ ^ self ].
	^ PPPredicateObjectParser on: [ :value | literal "sameAs:" isEquivalent: value ] message: message
%

category: 'operators'
method: PPLiteralObjectParser
negate
	^ (PPPredicateObjectParser expect: literal message: message) negate
%

category: 'parsing'
method: PPLiteralObjectParser
parseOn: aPPContext
	^ (aPPContext stream atEnd not and: [ literal = aPPContext stream uncheckedPeek ])
		ifFalse: [ PPFailure message: message context: aPPContext ]
		ifTrue: [ aPPContext next ]
%

! Class extensions for 'PPLiteralParser'

!		Class methods for 'PPLiteralParser'

category: 'instance creation'
classmethod: PPLiteralParser
on: anObject
	^ self on: anObject message: anObject printString , ' expected'
%

category: 'instance creation'
classmethod: PPLiteralParser
on: anObject message: aString
	^ self new initializeOn: anObject message: aString
%

!		Instance methods for 'PPLiteralParser'

category: 'operators'
method: PPLiteralParser
caseInsensitive
	"Answer a parser that can parse the receiver case-insensitive."

	self subclassResponsibility
%

category: 'initialization'
method: PPLiteralParser
initializeOn: anObject message: aString
	literal := anObject.
	message := aString
%

category: 'accessing'
method: PPLiteralParser
literal
	"Answer the parsed literal."

	^ literal
%

category: 'accessing'
method: PPLiteralParser
message
	"Answer the failure message."

	^ message
%

category: 'printing'
method: PPLiteralParser
printNameOn: aStream
	super printNameOn: aStream.
	aStream nextPutAll: ', '; print: literal
%

! Class extensions for 'PPLiteralSequenceParser'

!		Instance methods for 'PPLiteralSequenceParser'

category: 'operators'
method: PPLiteralSequenceParser
caseInsensitive
	"Answer a parser that can parse the receiver case-insensitive."

	literal asUppercase = literal asLowercase ifTrue: [ ^ self ].
	^ PPPredicateSequenceParser on: [ :value | literal "sameAs:" isEquivalent: value ] message: message size: size
%

category: 'initialization'
method: PPLiteralSequenceParser
initializeOn: anObject message: aString
	super initializeOn: anObject message: aString.
	size := literal size
%

category: 'parsing'
method: PPLiteralSequenceParser
parseOn: aPPContext
	| memento result |
	memento := aPPContext remember.
	result := aPPContext next: size.
	literal = result ifTrue: [ ^ result ].
	aPPContext restore: memento.
	^ PPFailure message: message context: aPPContext
%

category: 'accessing'
method: PPLiteralSequenceParser
size
	"Answer the sequence size of the receiver."

	^ size
%

! Class extensions for 'PPMemento'

!		Class methods for 'PPMemento'

category: 'instance creation'
classmethod: PPMemento
new
	^ self basicNew initialize
%

!		Instance methods for 'PPMemento'

category: 'accessing'
method: PPMemento
contextMemento
	^ context
%

category: 'accessing'
method: PPMemento
contextMemento: aPPContextMemento
	context  := aPPContextMemento
%

category: 'accessing-readonly'
method: PPMemento
count
	^ count
%

category: 'actions'
method: PPMemento
increment
	count := count + 1
%

category: 'initialization'
method: PPMemento
initialize
	count := 0

%

category: 'accessing'
method: PPMemento
result
	^ result
%

category: 'accessing'
method: PPMemento
result: anObject
	result := anObject
%

! Class extensions for 'PPMemoizedParser'

!		Instance methods for 'PPMemoizedParser'

category: 'parsing'
method: PPMemoizedParser
check: aPPContext
	(identifier == aPPContext identifier)
		ifFalse: [ self reset: aPPContext ].
%

category: 'operators'
method: PPMemoizedParser
memoized
	"Ther is no point in memoizing more than once."

	^ self
%

category: 'operators'
method: PPMemoizedParser
nonMemoized
	^ parser
%

category: 'parsing'
method: PPMemoizedParser
parseOn: aPPContext
	| memento contextMemento  aStream |
	"TODO: JK memoizing needs review!"
	self check: aPPContext.
	contextMemento := aPPContext remember.
	memento := (buffer at: contextMemento ifAbsentPut: [ PPMemento new ]).

	memento contextMemento isNil
		ifTrue: [
			aStream := aPPContext stream.
			memento result: (aStream size - aStream position + 2 < memento count
				ifTrue: [ PPFailure message: 'overflow' context: aPPContext ]
				ifFalse: [ memento increment. parser parseOn: aPPContext ]).
			memento contextMemento: aPPContext remember ]
		ifFalse: [ aPPContext restore: memento contextMemento ].
	^ memento result.
%

category: 'private'
method: PPMemoizedParser
reset: aPPContext
	buffer := Dictionary new.
	identifier := aPPContext identifier.
%

! Class extensions for 'PPNotParser'

!		Instance methods for 'PPNotParser'

category: 'parsing'
method: PPNotParser
parseOn: aPPContext
	| element memento |
	memento := aPPContext remember.
	element := parser parseOn: aPPContext.
	aPPContext restore: memento.
	^ element isPetitFailure
		ifFalse: [ PPFailure message: '' context: aPPContext ]
%

! Class extensions for 'PPOptionalParser'

!		Instance methods for 'PPOptionalParser'

category: 'parsing'
method: PPOptionalParser
parseOn: aPPContext
	| element |
	element := parser parseOn: aPPContext.
	^ element isPetitFailure ifFalse: [ element ]
%

! Class extensions for 'PPParser'

!		Class methods for 'PPParser'

category: 'instance creation'
classmethod: PPParser
named: aString
	^ self new name: aString
%

category: 'instance creation'
classmethod: PPParser
new
	^ self basicNew initialize
%

!		Instance methods for 'PPParser'

category: 'operators'
method: PPParser
, aParser
	"Answer a new parser that parses the receiver followed by aParser."

	^ PPSequenceParser with: self with: aParser
%

category: 'operators'
method: PPParser
/ aParser
	"Answer a new parser that parses the receiver, if the receiver fails try with aParser (ordered-choice)."

	^ PPChoiceParser with: self with: aParser
%

category: 'operators'
method: PPParser
// aParser
	"
		Answer a new parser that parses the receiver, if the receiver fails try with aParser (ordered-choice).
		If the receiver passes, limit must pass as well.
	"

	^ PPLimitedChoiceParser with: self with: aParser
%

category: 'operators-mapping'
method: PPParser
==> aBlock
	"Answer a new parser that performs aBlock as action handler on success."

	^ PPActionParser on: self block: aBlock
%

category: 'operators-mapping'
method: PPParser
>=> aBlock
	"Answer a new parser that wraps the receiving parser with a two argument block. The first argument is the parsed stream, the second argument a continuation block on the delegate parser."

	^ PPWrappingParser on: self block: aBlock
%

category: 'enumerating'
method: PPParser
allParsers
	"Answer all the parse nodes of the receiver."

	| result |
	result := OrderedCollection new.
	self allParsersDo: [ :parser | result addLast: parser ].
	^ result
%

category: 'enumerating'
method: PPParser
allParsersDo: aBlock
	"Iterate over all the parse nodes of the receiver."

	self allParsersDo: aBlock seen: IdentitySet new
%

category: 'enumerating'
method: PPParser
allParsersDo: aBlock seen: aSet
	"Iterate over all the parse nodes of the receiver, do not visit and follow the ones contained in aSet."

	(aSet includes: self)
		ifTrue: [ ^ self ].
	aSet add: self.
	aBlock value: self.
	self children
		do: [ :each | each allParsersDo: aBlock seen: aSet ]
%

category: 'operators'
method: PPParser
and
	"Answer a new parser (logical and-predicate) that succeeds whenever the receiver does, but never consumes input."

	^ PPAndParser on: self
%

category: 'operators-mapping'
method: PPParser
answer: anObject
	"Answer a new parser that always returns anObject from a successful parse."

	^ self ==> [ :nodes | anObject ]
%

category: 'converting'
method: PPParser
asParser
	"Answer the receiving parser."

	^ self
%

category: 'accessing'
method: PPParser
child
	self assert: (self children size == 1).
	^ self children first
%

category: 'accessing'
method: PPParser
children
	"Answer a set of child parsers that could follow the receiver."

	^ #()
%

category: 'operators'
method: PPParser
def: aParser
	"Redefine the receiver as the argument aParser. This method is useful when defining recursive parsers: instantiate a PPUnresolvedParser and later redefine it with another one."

	"^ self becomeForward: (aParser name: self name)"
	aParser name: self name.
	self become: (PPForwardingParser to: aParser).
	^self
%

category: 'operators-convenience'
method: PPParser
delimitedBy: aParser
	"Answer a new parser that parses the receiver one or more times, separated and possibly ended by aParser."

	^ (self separatedBy: aParser) , (aParser optional) ==> [ :node |
		node second == nil
			ifTrue: [ node first ]
			ifFalse: [ node first copyWith: node second ] ]
%

category: 'operators'
method: PPParser
end
	"Answer a new parser that succeeds at the end of the input and return the result of the receiver."

	^ PPEndOfInputParser on: self
%

category: 'operators-mapping'
method: PPParser
flatten
	"Answer a new parser that flattens the underlying collection."

	^ PPFlattenParser on: self
%

category: 'operators-mapping'
method: PPParser
foldLeft: aBlock
	"Answer a new parser that that folds the result of the receiver from left-to-right into aBlock. The argument aBlock must take two or more arguments."

	| size args |
	size := aBlock numArgs.
	args := Array new: size.
	^ self ==> [ :nodes |
		args at: 1 put: nodes first.
		2 to: nodes size by: size - 1 do: [ :index |
			args
				replaceFrom: 2 to: size with: nodes startingAt: index;
				at: 1 put: (aBlock valueWithArguments: args) ].
		args first ]
%

category: 'operators-mapping'
method: PPParser
foldRight: aBlock
	"Answer a new parser that that folds the result of the receiver from right-to-left into aBlock. The argument aBlock must take two or more arguments."

	| size args |
	size := aBlock numArgs.
	args := Array new: size.
	^ self ==> [ :nodes |
		args at: size put: nodes last.
		nodes size - size + 1 to: 1 by: 1 - size do: [ :index |
			args
				replaceFrom: 1 to: size - 1 with: nodes startingAt: index;
				at: size put: (aBlock valueWithArguments: args) ].
		args at: size ]
%

category: 'operators-mapping'
method: PPParser
handleGsQueryErrorMessage: errorMessage
  ^ GsQueryErrorHandlingParser on: self errorMessage: errorMessage
%

category: 'operators-mapping'
method: PPParser
handleGsQueryErrorMessage: errorMessage nestMessages: aBool
  ^ GsQueryErrorHandlingParser
    on: self
    errorMessage: errorMessage
    nestMessages: aBool
%

category: 'accessing-properties'
method: PPParser
hasProperty: aKey
	"Test if the property aKey is present."

	^ properties ~~ nil  and: [ properties includesKey: aKey ]
%

category: 'operators'
method: PPParser
if: aBlock
	^ PPConditionalParser on: self block: aBlock
%

category: 'initialization'
method: PPParser
initialize
%

category: 'testing'
method: PPParser
isPetitParser
	^ true
%

category: 'testing'
method: PPParser
isUnresolved
	^ false
%

category: 'operators-mapping'
method: PPParser
map: aBlock
	"Answer a new parser that works on the receiving sequence an passes in each element as a block argument."

	^ aBlock numArgs = 1
		ifTrue: [ self ==> aBlock ]
		ifFalse: [ self error: aBlock numArgs asString , ' arguments expected.' ]
%

category: 'parsing'
method: PPParser
matches: anObject
	"Answer if anObject can be parsed by the receiver."

	^ (self parse: anObject) isPetitFailure not
%

category: 'parsing'
method: PPParser
matchesIn: anObject
	"Search anObject repeatedly for the matches of the receiver. Answered an OrderedCollection of the matched parse-trees."

	| result |
	result := OrderedCollection new.
	self
		matchesIn: anObject
		do: [ :each | result addLast: each ].
	^ result
%

category: 'parsing'
method: PPParser
matchesIn: anObject do: aBlock
	"Search anObject repeatedly for the matches of the receiver. Evaluate aBlock for each match with the matched parse-tree as the argument. Make sure to always consume exactly one character with each step, to not miss any match."

	((self and ==> aBlock , #any asParser) / #any asParser) star parse: anObject
%

category: 'parsing'
method: PPParser
matchesSkipIn: anObject
	"Search anObject repeatedly for the matches of the receiver. Answer an OrderedCollection of the matched parse-trees. Skip over matches."

	| result |
	result := OrderedCollection new.
	self
		matchesSkipIn: anObject
		do: [ :each | result addLast: each ].
	^ result
%

category: 'parsing'
method: PPParser
matchesSkipIn: anObject do: aBlock
	"Search anObject repeatedly for the matches of the receiver. Evaluate aBlock for each match with the matched parse-tree as the argument. Skip over matches."

	(self ==> aBlock / #any asParser) star parse: anObject
%

category: 'parsing'
method: PPParser
matchingRangesIn: anObject
	"Search anObject repeatedly for the matches of the receiver. Answer an OrderedCollection of ranges of each match (index of first character to: index of last character)."

	| result |
	result := OrderedCollection new.
	self
		matchingRangesIn: anObject
		do: [ :value | result addLast: value ].
	^ result
%

category: 'parsing'
method: PPParser
matchingRangesIn: anObject do: aBlock
	"Search anObject repeatedly for the matches of the receiver. Evaluate aBlock with the range of each match (index of first character to: index of last character)."

	self token
		matchesIn: anObject
		do: [ :token | aBlock value: (token start to: token stop) ]
%

category: 'parsing'
method: PPParser
matchingSkipRangesIn: anObject
	"Search anObject repeatedly for the matches of the receiver. Skip over matches. Answer an OrderedCollection of ranges of each match (index of first character to: index of last character)."

	| result |
	result := OrderedCollection new.
	self
		matchingSkipRangesIn: anObject
		do: [ :value | result addLast: value ].
	^ result
%

category: 'parsing'
method: PPParser
matchingSkipRangesIn: anObject do: aBlock
	"Search anObject repeatedly for the matches of the receiver. Skip over matches. Evaluate aBlock with the range of each match (index of first character to: index of last character)."

	self token
		matchesSkipIn: anObject
		do: [ :token | aBlock value: (token start to: token stop) ]
%

category: 'operators-repeating'
method: PPParser
max: anInteger
	"Answer a new parser that parses the receiver at most anInteger times."

	^ self star setMax: anInteger
%

category: 'operators-repeating'
method: PPParser
max: anInteger greedy: aParser
	"Answer a new parser that parses the receiver at most anInteger times until it reaches aParser. This is a greedy non-blind implementation. aParser is not consumed."

	^ (self starGreedy: aParser) setMax: anInteger
%

category: 'operators-repeating'
method: PPParser
max: anInteger lazy: aParser
	"Answer a new parser that parses the receiver at most anInteger times until it reaches aParser. This is a lazy non-blind implementation. aParser is not consumed."

	^ (self starLazy: aParser) setMax: anInteger
%

category: 'operators'
method: PPParser
memoized
	"Answer a new memoized parser, for refraining redundant computations. This ensures polynomial time O(n^4) for left-recursive grammars and O(n^3) for non left-recursive grammars in the worst case. Not necessary for most grammars that are carefully written and in O(n) anyway."

	^ PPMemoizedParser on: self
%

category: 'operators-repeating'
method: PPParser
min: anInteger
	"Answer a new parser that parses the receiver at least anInteger times."

	^ self star setMin: anInteger
%

category: 'operators-repeating'
method: PPParser
min: anInteger greedy: aParser
	"Answer a new parser that parses the receiver at least anInteger times until it reaches aParser. This is a greedy non-blind implementation. aParser is not consumed."

	^ (self starGreedy: aParser) setMin: anInteger
%

category: 'operators-repeating'
method: PPParser
min: anInteger lazy: aParser
	"Answer a new parser that parses the receiver at least anInteger times until it reaches aParser. This is a lazy non-blind implementation. aParser is not consumed."

	^ (self starLazy: aParser) setMin: anInteger
%

category: 'operators-repeating'
method: PPParser
min: aMinInteger max: aMaxInteger
	"Answer a new parser that parses the receiver at least aMinInteger and at most aMaxInteger times."

	^ self star setMin: aMinInteger; setMax: aMaxInteger
%

category: 'operators-repeating'
method: PPParser
min: aMinInteger max: aMaxInteger greedy: aParser
	"Answer a new parser that parses the receiver at least aMinInteger and at most aMaxInteger times until it reaches aParser. This is a greedy non-blind implementation. aParser is not consumed."

	^ (self starGreedy: aParser) setMin: aMinInteger; setMax: aMaxInteger
%

category: 'operators-repeating'
method: PPParser
min: aMinInteger max: aMaxInteger lazy: aParser
	"Answer a new parser that parses the receiver at least aMinInteger and at most aMaxInteger times until it reaches aParser. This is a greedy non-blind implementation. aParser is not consumed."

	^ (self starLazy: aParser) setMin: aMinInteger; setMax: aMaxInteger
%

category: 'accessing'
method: PPParser
name
	"Answer the production name of the receiver."

	^ self propertyAt: #name ifAbsent: [ nil ]
%

category: 'accessing'
method: PPParser
name: aString
	self propertyAt: #name put: aString
%

category: 'operators'
method: PPParser
negate
	"Answer a new parser consumes any input token but the receiver."

	^ self not , #any asParser ==> #second
%

category: 'operators'
method: PPParser
nonMemoized
	^ self
%

category: 'operators'
method: PPParser
not
	"Answer a new parser (logical not-predicate) that succeeds whenever the receiver fails, but never consumes input."

	^ PPNotParser on: self
%

category: 'operators'
method: PPParser
optional
	"Answer a new parser that parses the receiver, if possible."

	^ PPOptionalParser on: self
%

category: 'parsing'
method: PPParser
parse: anObject
	"Parse anObject with the receiving parser and answer the parse-result or an instance of PPFailure."

	^ self parse: anObject withContext: PPContext new
%

category: 'parsing'
method: PPParser
parse: anObject onError: aBlock
	"Parse anObject with the receiving parser and answer the parse-result or answer the result of evaluating aBlock. Depending on the number of arguments of the block it is simply evaluated, evaluated with the failure object, or evaluated with the error message and position."

	| result |
	result := self parse: anObject.
	result isPetitFailure
		ifFalse: [ ^ result ].
	aBlock numArgs = 0
		ifTrue: [ ^ aBlock value ].
	aBlock numArgs = 1
		ifTrue: [ ^ aBlock value: result ].
	^ aBlock value: result message value: result position
%

category: 'context'
method: PPParser
parse: anObject withContext: aPPContext
	"Parse anObject with the receiving parser and answer the parse-result or an instance of PPFailure."

	aPPContext stream: anObject asPetitStream.
	^ self parseWithContext: aPPContext.
%

category: 'parsing'
method: PPParser
parseOn: aPPContext
	"Parse aStream with the receiving parser and answer the parse-result or an instance of PPFailure. Override this method in subclasses to specify custom parse behavior. Do not call this method from outside, instead use #parse:."

	self subclassResponsibility
%

category: 'context'
method: PPParser
parseWithContext: context
	| result |
	context initializeFor: self.
	result := self parseOn: context.

	"Return the furthest failure, it gives better results than the last failure"
	(result isPetitFailure and: [ context furthestFailure ~~ nil ])
		ifTrue: [ ^ context furthestFailure ].
	^ result
%

category: 'operators-repeating'
method: PPParser
plus
	"Answer a new parser that parses the receiver one or more times."

	^ self star setMin: 1
%

category: 'operators-repeating'
method: PPParser
plusGreedy: aParser
	"Answer a new parser that parses the receiver one or more times until it reaches aParser. This is a greedy non-blind implementation of the star operator. aParser is not consumed."

	^ (self starGreedy: aParser) setMin: 1
%

category: 'operators-repeating'
method: PPParser
plusLazy: aParser
	"Answer a new parser that parses the receiver one or more times until it reaches aParser. This is a lazy non-blind implementation of the star operator. aParser is not consumed."

	^ (self starLazy: aParser) setMin: 1
%

category: 'copying'
method: PPParser
postCopy
	super postCopy.
	properties := properties copy
%

category: 'printing'
method: PPParser
printNameOn: aStream
	self name == nil
		ifTrue: [ aStream print: self hash ]
		ifFalse: [ aStream nextPutAll: self name ]
%

category: 'printing'
method: PPParser
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	self printNameOn: aStream.
	aStream nextPut: $)
%

category: 'accessing-properties'
method: PPParser
properties
	^ properties
%

category: 'accessing-properties'
method: PPParser
propertyAt: aKey
	"Answer the property value associated with aKey."

	^ self propertyAt: aKey ifAbsent: [ self error: 'Property not found' ]
%

category: 'accessing-properties'
method: PPParser
propertyAt: aKey ifAbsent: aBlock
	"Answer the property value associated with aKey or, if aKey isn't found, answer the result of evaluating aBlock."

	^ properties == nil
		ifTrue: [ aBlock value ]
		ifFalse: [ properties at: aKey ifAbsent: aBlock ]
%

category: 'accessing-properties'
method: PPParser
propertyAt: aKey ifAbsentPut: aBlock
	"Answer the property associated with aKey or, if aKey isn't found store the result of evaluating aBlock as new value."

	^ self propertyAt: aKey ifAbsent: [ self propertyAt: aKey put: aBlock value ]
%

category: 'accessing-properties'
method: PPParser
propertyAt: aKey put: anObject
	"Set the property at aKey to be anObject. If aKey is not found, create a new entry for aKey and set is value to anObject. Answer anObject."

	^ (properties ifNil: [ properties := Dictionary new: 1 ])
		at: aKey put: anObject
%

category: 'operators-mapping'
method: PPParser
queryToken
  ^ GsQueryTokenParser on: self
%

category: 'accessing-properties'
method: PPParser
removeProperty: aKey
	"Remove the property with aKey. Answer the property or raise an error if aKey isn't found."

	^ self removeProperty: aKey ifAbsent: [ self error: 'Property not found' ]
%

category: 'accessing-properties'
method: PPParser
removeProperty: aKey ifAbsent: aBlock
	"Remove the property with aKey. Answer the value or, if aKey isn't found, answer the result of evaluating aBlock."

	| answer |
	properties == nil  ifTrue: [ ^ aBlock value ].
	answer := properties removeKey: aKey ifAbsent: aBlock.
	properties isEmpty ifTrue: [ properties := nil ].
	^ answer
%

category: 'operators-convenience'
method: PPParser
separatedBy: aParser
	"Answer a new parser that parses the receiver one or more times, separated by aParser."

	^ (PPSequenceParser with: self with: (PPSequenceParser with: aParser with: self) star) ==> [ :nodes |
		| result |
		result := Array new: 2 * nodes second size + 1.
		result at: 1 put: nodes first.
		nodes second
			keysAndValuesDo: [ :index :pair | result replaceFrom: 2 * index to: 2 * index + 1 with: pair startingAt: 1 ].
		result ]
%

category: 'operators-repeating'
method: PPParser
star
	"Answer a new parser that parses the receiver zero or more times. This is a greedy and blind implementation that tries to consume as much input as possible and it does not consider what comes afterwards."

	^ PPPossessiveRepeatingParser on: self
%

category: 'operators-repeating'
method: PPParser
starGreedy: aParser
	"Answer a new parser that parses the receiver zero or more times until it reaches aParser. This is a greedy non-blind implementation of the star operator. aParser is not consumed."

	^ PPGreedyRepeatingParser on: self limit: aParser
%

category: 'operators-repeating'
method: PPParser
starLazy: aParser
	"Answer a new parser that parses the receiver zero or more times until it reaches aParser. This is a lazy non-blind implementation of the star operator. aParser is not consumed."

	^ PPLazyRepeatingParser on: self limit: aParser
%

category: 'operators-repeating'
method: PPParser
times: anInteger
	"Answer a new parser that parses the receiver exactly anInteger times."

	^ self min: anInteger max: anInteger
%

category: 'operators-mapping'
method: PPParser
token
	"Answer a new parser that transforms the input to a token."

	^ PPTokenParser on: self
%

category: 'operators-mapping'
method: PPParser
token: aTokenClass
	"Answer a new parser that transforms the input to a token of class aTokenClass."

	^ self token tokenClass: aTokenClass
%

category: 'operators-mapping'
method: PPParser
trim
	"Answer a new parser that consumes spaces before and after the receiving parser."

	^ self trimSpaces
%

category: 'operators-mapping'
method: PPParser
trim: aParser
	"Answer a new parser that consumes and ignores aParser repeatedly before and after the receiving parser."

	^ PPTrimmingParser on: self trimmer: aParser
%

category: 'operators-mapping'
method: PPParser
trimBlanks
	"Answer a new parser that consumes blanks before and after the receiving parser."

	^ self trim: #blank asParser
%

category: 'operators-mapping'
method: PPParser
trimLeft
	"Answer a new parser that consumes spaces before the receiving parser."

	^ self trimSpacesLeft
%

category: 'operators-mapping'
method: PPParser
trimRight
	"Answer a new parser that consumes spaces after the receiving parser."

	^ self trimSpacesRight
%

category: 'operators-mapping'
method: PPParser
trimRight: trimmer
	"Answer a new parser that consumes spaces after the receiving parser."

	^ (self, trimmer star) ==> #first
%

category: 'operators-mapping'
method: PPParser
trimSpaces
	"Answer a new parser that consumes spaces before and after the receiving parser."

	^ self trim: #space asParser
%

category: 'operators-mapping'
method: PPParser
trimSpacesLeft
	"Answer a new parser that consumes spaces before the receiving parser."

	^ (#space asParser star, self) ==> #second
%

category: 'operators-mapping'
method: PPParser
trimSpacesRight
	"Answer a new parser that consumes spaces after the receiving parser."

	^ (self, #space asParser star) ==> #first
%

category: 'operators-convenience'
method: PPParser
withoutSeparators
	"Filters out the separators from a parse result produced by one of the productions #delimitedBy: or #separatedBy:."

	^ self ==> [ :items |
		| result |
		result := Array new: items size + 1 // 2.
		1 to: result size do: [ :index | result at: index put: (items at: 2 * index - 1) ].
		result ]
%

category: 'operators'
method: PPParser
wrapped
	"Answer a new parser that is simply wrapped."

	^ PPDelegateParser on: self
%

category: 'operators'
method: PPParser
| aParser
	"Answer a new parser that either parses the receiver or aParser. Fail if both pass or fail (exclusive choice, unordered choice)."

	^ (self not , aParser) / (aParser not , self) ==> #second
%

! Class extensions for 'PPPluggableParser'

!		Class methods for 'PPPluggableParser'

category: 'instance creation'
classmethod: PPPluggableParser
on: aBlock
	^ self new initializeOn: aBlock
%

!		Instance methods for 'PPPluggableParser'

category: 'accessing'
method: PPPluggableParser
block
	"Answer the pluggable block."

	^ block
%

category: 'initialization'
method: PPPluggableParser
initializeOn: aBlock
	block := aBlock
%

category: 'parsing'
method: PPPluggableParser
parseOn: aPPContext
	| memento result |
	memento := aPPContext remember.
	result := block value: aPPContext.
	result isPetitFailure
		ifTrue: [ aPPContext restore: memento ].
	^ result
%

! Class extensions for 'PPPossessiveRepeatingParser'

!		Instance methods for 'PPPossessiveRepeatingParser'

category: 'parsing'
method: PPPossessiveRepeatingParser
parseOn: aPPContext
	| memento element elements |
	memento := aPPContext remember.
	elements := OrderedCollection new.
	[ elements size < min ] whileTrue: [
		(element := parser parseOn: aPPContext) isPetitFailure ifTrue: [
			aPPContext restore: memento.
			^ element ].
		elements addLast: element ].
	[ elements size < max ] whileTrue: [
	 	(element := parser parseOn: aPPContext) isPetitFailure
			ifTrue: [ ^ elements asArray ].
		elements addLast: element ].
	^ elements asArray
%

! Class extensions for 'PPPredicateObjectParser'

!		Class methods for 'PPPredicateObjectParser'

category: 'factory-objects'
classmethod: PPPredicateObjectParser
any
	^self
		cacheAt: #'any'
		ifAbsentPut: [ self
			on: [ :each | true ] message: 'input expected'
			negated: [ :each | false ] message: 'no input expected' ]
%

category: 'factory-objects'
classmethod: PPPredicateObjectParser
anyExceptAnyOf: aCollection
	^ self
		on: [ :each | (aCollection includes: each) not ] message: 'any except ' , aCollection printString , ' expected'
		negated: [ :each | aCollection includes: each ] message: aCollection printString ,  ' not expected'
%

category: 'factory-objects'
classmethod: PPPredicateObjectParser
anyOf: aCollection
	^ self
		on: [ :each | aCollection includes: each ] message: 'any of ' , aCollection printString , ' expected'
		negated: [ :each | (aCollection includes: each) not ] message: 'none of ' , aCollection printString ,  'expected'
%

category: 'factory-objects'
classmethod: PPPredicateObjectParser
between: min and: max
	^ self
		on: [ :each | each >= min and: [ each <= max ] ] message: min printString , '..' , max printString , ' expected'
		negated: [ :each | each < min or: [ each > max ] ] message: min printString , '..' , max printString , ' not expected'
%

category: 'factory-chars'
classmethod: PPPredicateObjectParser
blank
	^self
		cacheAt: #'blank'
		ifAbsentPut: [ self
			chars: (String with: Character space with: Character tab) message: 'blank expected' ]
%

category: 'cache'
classmethod: PPPredicateObjectParser
cacheAt: aSymbol ifAbsentPut: aBlock
  | cache |
  cache := SessionTemps current
    at: #'PPPredicateObjectParser_cache'
    ifAbsentPut: [ SymbolKeyValueDictionary new ].
  ^ (cache at: aSymbol ifAbsentPut: aBlock) copy
%

category: 'factory-chars'
classmethod: PPPredicateObjectParser
char: aCharacter
	^ self expect: aCharacter message: (String with: $" with: aCharacter with: $") , ' expected'
%

category: 'factory-chars'
classmethod: PPPredicateObjectParser
char: aCharacter message: aString
	^ self expect: aCharacter message: aString
%

category: 'factory-chars'
classmethod: PPPredicateObjectParser
chars: aCollection message: aString
	^ self on: (PPCharSetPredicate on: [ :char | aCollection includes: char ]) message: aString
%

category: 'factory-chars'
classmethod: PPPredicateObjectParser
cr
	^self
		cacheAt: #'cr'
		ifAbsentPut: [ self char: (Character codePoint: 13) message: 'carriage return expected' ]
%

category: 'factory-chars'
classmethod: PPPredicateObjectParser
digit
	^self
		cacheAt: #'digit'
		ifAbsentPut: [ self on: (PPCharSetPredicate on: [ :char | char isDigit ]) message: 'digit expected' ]
%

category: 'factory-objects'
classmethod: PPPredicateObjectParser
endOfLine

	^ PPEndOfLineParser new.
%

category: 'instance creation'
classmethod: PPPredicateObjectParser
eof

	^ PPEndOfFileParser new
%

category: 'factory-objects'
classmethod: PPPredicateObjectParser
expect: anObject
	^ self expect: anObject message: anObject printString , ' expected'
%

category: 'factory-objects'
classmethod: PPPredicateObjectParser
expect: anObject message: aString
	^ self
		on: [ :each | each = anObject ] message: aString
		negated: [ :each | each ~= anObject ] message: 'no ' , aString
%

category: 'factory-chars'
classmethod: PPPredicateObjectParser
hex
	^self
		cacheAt: #'hex'
		ifAbsentPut: [ self
		on: (PPCharSetPredicate on: [ :char |
			(char between: $0 and: $9)
				or: [ (char between: $a and: $f)
				or: [ (char between: $A and: $F) ] ] ])
		message: 'hex digit expected' ]
%

category: 'factory-chars'
classmethod: PPPredicateObjectParser
letter
	^self
		cacheAt: #'letter'
		ifAbsentPut: [ self on: (PPCharSetPredicate on: [ :char | char isLetter ]) message: 'letter expected' ]
%

category: 'factory-chars'
classmethod: PPPredicateObjectParser
lf
	^self
		cacheAt: #'lf'
		ifAbsentPut: [ self char: (Character codePoint: 10) ]
%

category: 'factory-chars'
classmethod: PPPredicateObjectParser
lowercase
	^self
		cacheAt: #'lowercase'
		ifAbsentPut: [ self on: (PPCharSetPredicate on: [ :char | char isLowercase ]) message: 'lowercase letter expected' ]
%

category: 'factory-chars'
classmethod: PPPredicateObjectParser
newline
	^self
		cacheAt: #'newline'
		ifAbsentPut: [ self chars: (String with: (Character codePoint: 13) with: (Character codePoint: 10)) message: 'newline expected' ]
%

category: 'instance creation'
classmethod: PPPredicateObjectParser
on: aBlock message: aString
	^ self on: aBlock message: aString negated: [ :each | (aBlock value: each) not ] message: 'no ' , aString
%

category: 'instance creation'
classmethod: PPPredicateObjectParser
on: aBlock message: aString negated: aNegatedBlock message: aNegatedString
	^ self new initializeOn: aBlock message: aString negated: aNegatedBlock message: aNegatedString
%

category: 'factory-chars'
classmethod: PPPredicateObjectParser
punctuation
	^self
		cacheAt: #'punctuation'
		ifAbsentPut: [ self chars: '.,"''?!;:#$%&()*+-/<>=@[]\^_{}|~' message: 'punctuation expected' ]
%

category: 'factory-chars'
classmethod: PPPredicateObjectParser
space
	^self
		cacheAt: #'space'
		ifAbsentPut: [ self on: (PPCharSetPredicate on: [ :char | char isSeparator ]) message: 'separator expected' ]
%

category: 'instance creation'
classmethod: PPPredicateObjectParser
startOfLine

	^ PPStartOfLineParser new.
%

category: 'instance creation'
classmethod: PPPredicateObjectParser
startOfLogicalLine

	^ PPStartOfLogicalLineParser new.
%

category: 'instance creation'
classmethod: PPPredicateObjectParser
startOfWord

	^ PPStartOfWordParser new.
%

category: 'factory-chars'
classmethod: PPPredicateObjectParser
tab
	^self
		cacheAt: #'tab'
		ifAbsentPut: [ self char: Character tab message: 'tab expected' ]
%

category: 'factory-chars'
classmethod: PPPredicateObjectParser
uppercase
	^self
		cacheAt: #'uppercase'
		ifAbsentPut: [ self on: (PPCharSetPredicate on: [ :char | char isUppercase ]) message: 'uppercase letter expected' ]
%

category: 'cache'
classmethod: PPPredicateObjectParser
useCache: ignored
  "Cache is always enabled in GemStone"
%

category: 'factory-chars'
classmethod: PPPredicateObjectParser
word
	^self
		cacheAt: #'word'
		ifAbsentPut: [ self on: (PPCharSetPredicate on: [ :char | char isAlphaNumeric ]) message: 'letter or digit expected' ]
%

!		Instance methods for 'PPPredicateObjectParser'

category: 'initialization'
method: PPPredicateObjectParser
initializeOn: aBlock message: aString negated: aNegatedBlock message: aNegatedString
	predicate := aBlock.
	predicateMessage := aString.
	negated := aNegatedBlock.
	negatedMessage := aNegatedString
%

category: 'operators'
method: PPPredicateObjectParser
negate
	"Answer a parser that is the negation of the receiving predicate parser."

	^ self class
		on: negated message: negatedMessage
		negated: predicate message: predicateMessage
%

category: 'parsing'
method: PPPredicateObjectParser
parseOn: aPPContext
	^ (aPPContext atEnd not and: [ predicate value: aPPContext uncheckedPeek ])
		ifFalse: [ PPFailure message: predicateMessage context: aPPContext ]
		ifTrue: [ aPPContext next ]
%

! Class extensions for 'PPPredicateParser'

!		Instance methods for 'PPPredicateParser'

category: 'accessing'
method: PPPredicateParser
block
	"Answer the predicate block of the receiver."

	^ predicate
%

category: 'accessing'
method: PPPredicateParser
message
	"Answer the failure message."

	^ predicateMessage
%

category: 'printing'
method: PPPredicateParser
printNameOn: aStream
	super printNameOn: aStream.
	aStream nextPutAll: ', '; print: predicateMessage
%

! Class extensions for 'PPPredicateSequenceParser'

!		Class methods for 'PPPredicateSequenceParser'

category: 'instance creation'
classmethod: PPPredicateSequenceParser
on: aBlock message: aString negated: aNegatedBlock message: aNegatedString size: anInteger
	^ self new initializeOn: aBlock message: aString negated: aNegatedBlock message: aNegatedString size: anInteger
%

category: 'instance creation'
classmethod: PPPredicateSequenceParser
on: aBlock message: aString size: anInteger
	^ self on: aBlock message: aString negated: [ :each | (aBlock value: each) not ] message: 'no ' , aString size: anInteger
%

!		Instance methods for 'PPPredicateSequenceParser'

category: 'initialization'
method: PPPredicateSequenceParser
initializeOn: aBlock message: aString negated: aNegatedBlock message: aNegatedString size: anInteger
	predicate := aBlock.
	predicateMessage := aString.
	negated := aNegatedBlock.
	negatedMessage := aNegatedString.
	size := anInteger
%

category: 'operators'
method: PPPredicateSequenceParser
negate
	"Answer a parser that is the negation of the receiving predicate parser."

	^ self class
		on: negated message: negatedMessage
		negated: predicate message: predicateMessage
		size: size
%

category: 'parsing'
method: PPPredicateSequenceParser
parseOn: aPPContext
	| memento result |
	memento := aPPContext remember.
	result := aPPContext stream next: size.
	(result size = size and: [ predicate value: result ])
		ifTrue: [ ^ result ].
	aPPContext restore: memento.
	^ PPFailure message: predicateMessage context: aPPContext
%

category: 'accessing'
method: PPPredicateSequenceParser
size
	"Answer the sequence size of the receiver."

	^ size
%

! Class extensions for 'PPRepeatingParser'

!		Instance methods for 'PPRepeatingParser'

category: 'initialization'
method: PPRepeatingParser
initialize
	super initialize.
	self setMin: 0; setMax: SmallInteger "maxVal" maximumValue
%

category: 'accessing'
method: PPRepeatingParser
max
	"Answer the maximum number of repetitions."

	^ max
%

category: 'accessing'
method: PPRepeatingParser
min
	"Answer the minimum number of repetitions."

	^ min
%

category: 'printing'
method: PPRepeatingParser
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' ['; print: min; nextPutAll: ', '; nextPutAll: (max = SmallInteger "maxVal" maximumValue
		ifTrue: [ '*' ] ifFalse: [ max printString ]); nextPut: $]
%

category: 'initialization'
method: PPRepeatingParser
setMax: anInteger
	max := anInteger
%

category: 'initialization'
method: PPRepeatingParser
setMin: anInteger
	min := anInteger
%

! Class extensions for 'PPSequenceParser'

!		Instance methods for 'PPSequenceParser'

category: 'operators'
method: PPSequenceParser
, aRule
	^ self copyWith: aRule
%

category: 'operators-mapping'
method: PPSequenceParser
map: aBlock
	^ aBlock numArgs = self children size
		ifTrue: [ self ==> [ :nodes | aBlock valueWithArguments: nodes ] ]
		ifFalse: [ self error: aBlock numArgs asString , ' arguments expected.' ]
%

category: 'parsing'
method: PPSequenceParser
parseOn: aPPContext
	"This is optimized code that avoids unnecessary block activations, do not change."

	| memento elements element |
	memento := aPPContext remember.
	elements := Array new: parsers size.
	1 to: parsers size do: [ :index |
		element := (parsers at: index)
			parseOn: aPPContext.
		element isPetitFailure ifTrue: [
			aPPContext restore: memento.
			^ element ].
		elements at: index put: element ].
	^ elements
%

category: 'operators-mapping'
method: PPSequenceParser
permutation: anArrayOfIntegers
	"Answer a permutation of the receivers sequence."

	anArrayOfIntegers do: [ :index |
		(index _isInteger and: [ index between: 1 and: parsers size ])
			ifFalse: [ self error: 'Invalid permutation index: ' , index printString ] ].
	^ self ==> [ :nodes | anArrayOfIntegers collect: [ :index | nodes at: index ] ]
%

! Class extensions for 'PPStartOfLineParser'

!		Instance methods for 'PPStartOfLineParser'

category: 'parasing'
method: PPStartOfLineParser
parseOn: aPPContext
	(aPPContext isStartOfLine) ifTrue: [
		^ #startOfLine
	].
	^ PPFailure message: 'Start of line expected' context: aPPContext at: aPPContext position
%

! Class extensions for 'PPStartOfLogicalLineParser'

!		Instance methods for 'PPStartOfLogicalLineParser'

category: 'parasing'
method: PPStartOfLogicalLineParser
isBlank: character
	^ (character == Character space or: [character == Character tab])
%

category: 'parasing'
method: PPStartOfLogicalLineParser
parseOn: aPPContext
	aPPContext peek isAlphaNumeric ifFalse: [
		^ PPFailure message: 'Start of logical line expected' context: aPPContext
	].

	aPPContext isStartOfLine ifTrue: [ ^ #startOfLogicalLine ].


	[ aPPContext position ~= 0 ] whileTrue: [
		aPPContext back.
		(self isBlank: aPPContext peek) ifFalse: [
			^ PPFailure message: 'Start of logical line expected' context: aPPContext
		].
		aPPContext isStartOfLine ifTrue: [ ^ #startOfLogicalLine ].
	]
%

! Class extensions for 'PPStartOfWordParser'

!		Instance methods for 'PPStartOfWordParser'

category: 'testing'
method: PPStartOfWordParser
acceptsEpsilon
	^ false
%

category: 'parsing'
method: PPStartOfWordParser
parseOn: aPPContext
	aPPContext atEnd ifTrue: [
		^ PPFailure message: 'Start of word expected' context: aPPContext at: aPPContext position
	].

	(aPPContext position == 0) ifTrue: [
		(aPPContext peek isAlphaNumeric) ifTrue: [
			^ #startOfWord
		] ifFalse: [
			^ PPFailure message: 'Start of word expected' context: aPPContext at: aPPContext position
	 	]
	].

	aPPContext back.
	aPPContext peek isAlphaNumeric ifTrue: [
		^ PPFailure message: 'Start of word expected' context: aPPContext at: aPPContext position
	].
	aPPContext next.

	^ aPPContext peek isAlphaNumeric ifTrue: [ #startOfWord ] ifFalse: [
		PPFailure message: 'Start of word expected' context: aPPContext at: aPPContext position
	]
%

! Class extensions for 'PPToken'

!		Class methods for 'PPToken'

category: 'initialization'
classmethod: PPToken
initialize
	"Platform independent newline sequence. LF: Unix, CR+LF: Windows, and CR: Apple."
"
	| cr lf |
	cr := Character codePoint: 13.
	lf := Character codePoint: 10.
	NewLineParser := lf asParser / (cr asParser , lf asParser optional)
"
%

category: 'instance creation'
classmethod: PPToken
new
	self error: 'Token can only be created using a dedicated constructor.'
%

category: 'instance creation'
classmethod: PPToken
on: aSequenceableCollection
	^ self on: aSequenceableCollection start: 1 stop: aSequenceableCollection size value: nil
%

category: 'instance creation'
classmethod: PPToken
on: aSequenceableCollection start: aStartInteger stop: aStopInteger value: anObject
	^ self basicNew
		initializeOn: aSequenceableCollection
		start: aStartInteger stop: aStopInteger
		value: anObject
%

!		Instance methods for 'PPToken'

category: 'comparing'
method: PPToken
= anObject
	^ self class = anObject class and: [ self inputValue = anObject inputValue ]
%

category: 'accessing'
method: PPToken
collection
	"Answer the underlying collection of this token."

	^ collection
%

category: 'querying'
method: PPToken
column
	"Answer the column number of this token in the underlying collection."

	| position |
	position := 0.
	(newLineParser , [ :stream |
		start <= stream position
			ifTrue: [ ^ start - position ].
		position := stream position ] asParser
		/ #any asParser) star
			parse: collection.
	 ^ start - position
%

category: 'copying'
method: PPToken
copyFrom: aStartInteger to: aStopInteger
	^ self class on: collection start: start + aStartInteger - 1 stop: stop + aStopInteger - 3 value: value
%

category: 'comparing'
method: PPToken
hash
	^ self inputValue hash
%

category: 'initialization'
method: PPToken
initializeOn: aSequenceableCollection start: aStartInteger stop: aStopInteger value: anObject
	collection := aSequenceableCollection.
	start := aStartInteger.
	stop := aStopInteger.
	value := anObject.
	newLineParser := Character lf asParser / (Character cr asParser , Character lf asParser optional)
%

category: 'accessing-values'
method: PPToken
inputValue
	"Answer the consumed input of this token."

	^ collection copyFrom: start to: stop
%

category: 'querying'
method: PPToken
line
	"Answer the line number of this token in the underlying collection."

	| line |
	line := 1.
	(newLineParser , [ :stream |
		start <= stream position
			ifTrue: [ ^ line ].
		line := line + 1 ] asParser
		/ #any asParser) star
			parse: collection.
	^ line
%

category: 'accessing-values'
method: PPToken
parsedValue
	"Answer the parsed value of this token."

	^ value
%

category: 'printing'
method: PPToken
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $[; print: self start; nextPut: $,; print: self stop; nextPut: $].
	aStream nextPut: $(; print: self inputValue; nextPut: $)
%

category: 'accessing'
method: PPToken
size
	"Answer the size of this token in the underlying collection."

	^ stop - start + 1
%

category: 'accessing'
method: PPToken
start
	"Answer the start position of this token in the underlying collection."

	^ start
%

category: 'accessing'
method: PPToken
stop
	"Answer the stop position of this token in the underlying collection."

	^ stop
%

category: 'accessing'
method: PPToken
value
	self notify: 'Token>>#value is no longer supported. Instead use Token>>#inputValue'.
	^ self inputValue
%

! Class extensions for 'PPTokenParser'

!		Instance methods for 'PPTokenParser'

category: 'private'
method: PPTokenParser
defaultTokenClass
	^ PPToken
%

category: 'initialization'
method: PPTokenParser
initialize
	tokenClass := self defaultTokenClass

%

category: 'private'
method: PPTokenParser
on: aCollection start: aStartInteger stop: aStopInteger value: anObject
	^ self tokenClass on: aCollection start: aStartInteger stop: aStopInteger value: anObject
%

category: 'accessing'
method: PPTokenParser
tokenClass
	^ tokenClass
%

category: 'accessing'
method: PPTokenParser
tokenClass: aTokenClass
	tokenClass := aTokenClass
%

! Class extensions for 'PPTrimmingParser'

!		Class methods for 'PPTrimmingParser'

category: 'instance creation'
classmethod: PPTrimmingParser
on: aParser trimmer: aTrimParser
	^ self new
		setParser: aParser;
		setTrimmer: aTrimParser;
		yourself
%

!		Instance methods for 'PPTrimmingParser'

category: 'parsing'
method: PPTrimmingParser
parseOn: aPPContext
	| memento element trimContext |
	memento := aPPContext remember.
	trimContext := aPPContext copy.
	[ (trimmer parseOn: trimContext) isPetitFailure ]
		whileFalse.
	element := parser parseOn: aPPContext.
	element isPetitFailure ifTrue: [
		aPPContext restore: memento.
		^ element ].
	[ (trimmer parseOn: trimContext) isPetitFailure ]
		whileFalse.
	^ element
%

category: 'initialization'
method: PPTrimmingParser
setTrimmer: aParser
	trimmer := aParser
%

! Class extensions for 'PPUnresolvedParser'

!		Instance methods for 'PPUnresolvedParser'

category: 'testing'
method: PPUnresolvedParser
isUnresolved
	^ true
%

category: 'parsing'
method: PPUnresolvedParser
parseOn: aStream
	self error: self printString , ' need to be resolved before execution.'
%

! Class extensions for 'PPWrappingParser'

!		Instance methods for 'PPWrappingParser'

category: 'parsing'
method: PPWrappingParser
parseOn: aPPContext
	^ block value: aPPContext value: [ parser parseOn: aPPContext ]
%

! Class extensions for 'ProcessorScheduler'

!		Instance methods for 'ProcessorScheduler'

category: 'Private'
method: ProcessorScheduler
_initCriticalMethods

  "Methods which an in-process debugger should not set breakpoints in nor
    single step through."

  | arr set |
  arr := {
    "primitive 457"
    CriticalSection  . #_scheduler .
    Delay  . #_scheduler .
    Delay class  . #_scheduler .
    GsProcess  . #_scheduler .
    GsProcess class  . #_scheduler .
    GsSocket  . #_scheduler .
    Processor class  . #_scheduler .
    ProcessorScheduler class  . #scheduler .
    Semaphore  . #_scheduler .

    "senders scheduler"
    AbstractException  . #_signalTimeout .
    ProcessorScheduler class  . #topazAllProcesses .
    ProcessorScheduler class  . #topazStatusForProcess: .
    ProcessorScheduler class  . #_allProcessesTerminate9 .

    "senders _scheduler"
    CriticalSection  . #critical: .
    Delay  . #signal .
    Delay  . #_cancel: .
    Delay  . #_wait: .
    Delay class  . #waitForMilliseconds: .
    Delay class  . #waitForSeconds: .
    Delay class  . #waitUntilMilliseconds: .
    Delay class  . #_highPriorityWaitForMilliseconds: .
    GsNMethod class  . #_terminateNonForkedProcess .
    GsProcess  . #priority: .
    GsProcess  . #resume .
    GsProcess  . #suspend .
    GsProcess  . #terminate .
    GsProcess  . #_activate .
    GsProcess  . #_continue .
    GsProcess  . #_finishTermination .
    GsProcess  . #_newGroup .
    GsProcess  . #_raisePriority .
    GsProcess  . #_reapSignal: .
    GsProcess  . #_signalAll .
    GsProcess  . #_signalJoiners .
    GsProcess  . #_start .
    GsProcess  . #_statusString .
    GsProcess  . #_stepOverInFrame:mode:replace:tos: .
    GsProcess  . #_unscheduleProcess .
    GsProcess  . #_wait .
    GsProcess class  . #_forkBlock:with:env:prio: .
    GsProcess class  . #_newForBlock:with:env: .
    GsSocket  . #readWillNotBlockWithin: .
    GsSocket  . #writeWillNotBlockWithin: .
    GsSocket  . #_waitForReadReady .
    GsSocket  . #_waitForWriteReady .
    Processor class  . #activePriority .
    Processor class  . #activeProcess .
    Processor class  . #allProcesses .
    Processor class  . #cancelWhenReadable:signal: .
    Processor class  . #cancelWhenWritable:signal: .
    Processor class  . #highestPriority .
    Processor class  . #highIOPriority .
    Processor class  . #lowestPriority .
    Processor class  . #lowIOPriority .
    Processor class  . #readyProcesses .
    Processor class  . #suspendedProcesses .
    Processor class  . #systemBackgroundPriority .
    Processor class  . #timingPriority .
    Processor class  . #userBackgroundPriority .
    Processor class  . #userInterruptPriority .
    Processor class  . #userSchedulingPriority .
    Processor class  . #waitingProcesses .
    Processor class  . #whenReadable:signal: .
    Processor class  . #whenWritable:signal: .
    Processor class  . #yield .
    Semaphore  . #highPriorityWaitForMilliseconds: .
    Semaphore  . #signal .
    Semaphore  . #signalAll .
    Semaphore  . #wait .
    Semaphore  . #waitForMilliseconds: .

    "implem _exitCritical"
    ProcessorScheduler  . #_exitCritical .
    Semaphore  . #_exitCritical .

    "senders _exitCritical"
    Delay  . #_wait: .
    Delay class  . #_highPriorityWaitForMilliseconds: .
    GsProcess  . #terminate .
    GsProcess  . #_activate .
    GsProcess  . #_continue .
    GsProcess  . #_signalJoiners .
    GsProcess  . #_stepOverInFrame:mode:replace:tos: .
    ProcessorScheduler  . #waitingProcesses .
    ProcessorScheduler  . #_allProcessesInto: .
    ProcessorScheduler  . #_allProcessesInto:inGroup: .
    ProcessorScheduler  . #_terminateScheduledProcess: .
    ProcessorScheduler  . #_waitForMilliseconds: .
    ProcessorScheduler  . #_waitForSocket:timeout:forWrite: .
    ProcessorScheduler  . #yield .
    ProcessorScheduler  . #_findReadyProcess .
    ProcessorScheduler  . #_findReadyProcessForExit: .
    ProcessorScheduler  . #_runNextProcess .
    ProcessorScheduler  . #_yieldForTimeout .
    Semaphore  . #highPriorityWaitForMilliseconds: .
    Semaphore  . #signal .
    Semaphore  . #signalAll .
    Semaphore  . #wait .
    Semaphore  . #waitForMilliseconds: .

    "primitive 737"
    ProcessorScheduler  . #_exitCritical .

    "primitive 693"
    GsProcess . #_current  .
    GsProcess class . #_current  .
    ProcessorScheduler . #activeProcess  .

    "primitive 169"
    ProcessorScheduler . #_enterCritical  .

    "primitive 736"
    ProcessorScheduler . #waitingProcesses  .
    ProcessorScheduler . #yield  .
    ProcessorScheduler . #_allProcessesInto:  .
    ProcessorScheduler . #_allProcessesInto:inGroup:  .
    ProcessorScheduler . #_runNextProcess  .
    ProcessorScheduler . #_terminateScheduledProcess:  .
    ProcessorScheduler . #_yieldForTimeout  .
    ProcessorScheduler . #readyProcesses  .
    Semaphore . #signal  .
    Semaphore . #signalAll  .
    Semaphore . #wait  .

   "senders _reschedule"
    ProcessorScheduler . #_suspendProcess:  .
    ProcessorScheduler . #_waitForMilliseconds:  .
    ProcessorScheduler . #_waitForSocket:  .
    ProcessorScheduler . #_waitForSocket:timeout:forWrite:  .
    ProcessorScheduler . #_waitOnSema:  .


    "other"
    ProcessorScheduler  . #_reapEvents: .
    ProcessorScheduler  . #_checkForExpiredDelays: .
    ProcessorScheduler . #_now  .
    ProcessorScheduler . #_timeoutNow:  .
    ProcessorScheduler . #_delayUnschedule:  .
    ProcessorScheduler . #_switchFrom:to:  .
    ProcessorScheduler . #_runNextProcess  .
    ProcessorScheduler . #_rescheduleContinue: .
    ProcessorScheduler . #_reschedule  .
    ProcessorScheduler . #_doPoll:yield:  .
    ProcessorScheduler . #_isWhenReadableSet:signal:  .
    ProcessorScheduler . #_isWhenWritableSet:signal:  .
    ProcessorScheduler . #whenReadable:signal:  .
    ProcessorScheduler . #whenWritable:signal:  .
    ProcessorScheduler . #cancelWhenReadable:signal:  .
    ProcessorScheduler . #cancelWhenWritable:signal:  .
    ProcessorScheduler . #_unschedule:  .
    ProcessorScheduler . #_suspendNewProcess:  .
    ProcessorScheduler . #_resumeProcess:  .
    ProcessorScheduler . #_waitingProcessesInto:  .
    ProcessorScheduler . #_waitingProcessesInto:inGroup:  .
    ProcessorScheduler . #suspendedProcesses  .
    ProcessorScheduler . #_add:toSet:  .
    ProcessorScheduler . #_remove:fromSet:  .
    ProcessorScheduler . #_changePriority:from:  .
    ProcessorScheduler . #_addReadyProcess:to:  .
    ProcessorScheduler . #_addDelay:to:  .
    ProcessorScheduler . #_updateTimerThread:priority:  .
    ProcessorScheduler . #_sizeNoShrink:  .
    ProcessorScheduler . #_allStacksReport .

    GsProcess .  #resume  .

    GsProcess class . #_newForBlock:with:env:  .
    GsProcess . #_init:args:env:stackSerial:forked:  .
    GsProcess class . #_forkBlock:with:env:prio:  .
    ProcessorScheduler . #_scheduleNewProcess:prio:
  }.
  set := IdentitySet new .
  1 to: arr size by: 2 do:[:n |
    | cls sel meth |
    cls := arr at: n .
    sel := arr at: n + 1 .
    meth := cls compiledMethodAt: sel otherwise: nil .
    meth ifNotNil:[ set add: meth ]
         ifNil:[ Error signal: sel , ' not found in ' , cls name  ].
  ].
  criticalMethods := set .
  ^ set
%

! Class extensions for 'QuadByteString'

!		Instance methods for 'QuadByteString'

category: 'Comparing'
method: QuadByteString
compareTo: argString collator: anIcuCollator useMinSize: aMinSize

"Returns -1, 0 or 1,  when receiver is less than,
 equal to, or greater than argString .
 argString must be a String, MultiByteString, or a Utf8.
 anIcuCollator == nil is interpreted as   IcuCollator default .

 If aMinSize == false, normal comparision is done.

 If aMinSize==true, compare stops at (self size min: argString size),
 which is Squeak semantics for comparison.

 If aMinSize is a SmallInteger >= 1, compare stops at
   aMinSize min: (self size min: argString size) ."

<primitive: 929>
anIcuCollator ifNil:[
  (System __sessionStateAt: 20) ifNil:[
    ^ self compareTo: argString collator: IcuCollator default useMinSize: aMinSize ]
] ifNotNil:[ anIcuCollator _validateClass: IcuCollator ].
aMinSize _validateClasses: { Boolean . SmallInteger }.
argString _validateClasses: { String . Utf8 }.
^ self _primitiveFailed: #compareTo:collator:useMinSize:
        args: { argString . anIcuCollator . aMinSize }
%

category: 'Comparing'
method: QuadByteString
_equals: argString collator: anIcuCollator useMinSize: aFalse

"Returns true if argString compares equals to the receiver using anIcuCollator
 and if argString is not a Symbol, otherwise returns false "
<primitive: 987>
anIcuCollator ifNil:[ (System __sessionStateAt: 20) ifNil:[
  ^ self _equals: argString collator: IcuCollator default useMinSize: aFalse ]
] ifNotNil:[  anIcuCollator _validateClass: IcuCollator ].
(argString isKindOf: CharacterCollection) ifTrue:[ ^ argString = self ].
^ false
%

! Class extensions for 'QuadByteSymbol'

!		Instance methods for 'QuadByteSymbol'

category: 'PetitParser-Core-Converting'
method: QuadByteSymbol
asParser
	"Answer a predicate parser named after the receiving symbol. Possible symbols are the method selectors on the class-side of PPPredicateObjectParser."

	^ PPPredicateObjectParser perform: self
%

category: 'New Indexing Comparison'
method: QuadByteSymbol
_idxUnicodeCompareEqualTo: aCharCollection
  "No Unicode Symbols, so answer false"

  ^false
%

! Class extensions for 'QueryExecuter'

!		Class methods for 'QueryExecuter'

category: 'Testing'
classmethod: QueryExecuter
nilOrderDefinedFor: aClass

"Return whether we have defined that nils have a predetermined order
 when comparing against instances of aClass (that is, we have defined that
 nils are less than any instance of aClass)."

" if it is a basic class (String, Number, etc) "
^ ( RangeEqualityIndex isBasicClass: aClass ) or:
    " or if the path is unconstrained "
    [ aClass == Object or:
    [ aClass == nil ] ]
%

category: 'Instance Creation'
classmethod: QueryExecuter
on: anNsc

"Create a query executer on the given NSC."

^ super new nsc: anNsc
%

!		Instance methods for 'QueryExecuter'

category: 'Constants'
method: QueryExecuter
bruteThreshold

""

^ 1000
%

category: 'Query Support'
method: QueryExecuter
evaluatePathConstantPredicates: querySpec for: anObject

"Evaluate all the path-constant predicates defined in querySpec for the given
 object.  Returns true if the object satisfies all the predicates."

1 to: querySpec size by: 3 do: [ :j |
    ((querySpec at: j) traverse:  anObject
        andCompare: (querySpec at: j + 1)
        with: (querySpec at: j + 2))
        ifFalse: [ ^ false ]
].
^ true
%

category: 'Query Support'
method: QueryExecuter
evaluatePathPathPredicates: querySpec for: anObject

"Evaluate all the path-path predicates defined in querySpec for the given
 object.  Returns true if the object satisfies all the predicates."

1 to: querySpec size by: 3 do: [ :j |
    ( (querySpec at: j) traverse:  anObject
        andCompare: (querySpec at: j + 1)
        withTraverser: (querySpec at: j + 2) )
        ifFalse: [ ^ false ]
].
^ true
%

category: 'Query Select'
method: QueryExecuter
findAllThatSatisfyPredicatesStartingAt: beginOffset ordering: ordering

"Returns an NSC of all objects that satisfy the predicates beginning at the
 given offset."

| pcQuerySpec ppQuerySpec array offset tmpHolder searchOp secondOperand pathEval |

" build Arrays that hold the specifications of the predicates "
pcQuerySpec := { } .   " for path-constant predicates "
ppQuerySpec := { } .   " for path-path predicates "
beginOffset to: ordering size do: [ :j |
  offset := ordering at: j.

  offset ~~ nil
    ifTrue: [

      " if constant-constant path, check to see if it is satisfiable "
      (self isConstantConstantAt: offset)
        ifTrue: [
          (self _executeConstantConstantPredicateAt: offset)
            ifFalse: [ ^ nsc species new ]
        ]
        ifFalse: [

          (self isPathConstantAt: offset)
            ifTrue: [ array := pcQuerySpec ]
            ifFalse: [ array := ppQuerySpec ].

          " the first operand (a PathEvaluator) "
          pathEval := (self firstOperandAt: offset) asPathEvaluator.
          pathEval _initTraverseCache.
          array add: pathEval.

          searchOp := self operatorAt: offset.
          " insert comparison selector "
          array add: (self _operationSelectors at: searchOp + 1).
          secondOperand := self secondOperandAt: offset.
          " if dual predicate, transform argument Array "
          searchOp == 9
            ifTrue: [
              secondOperand :=
                { secondOperand at: 2 .
                 (secondOperand at: 1) == 5 .
                 secondOperand at: 4 .
                 (secondOperand at: 3) == 4
                 }
            ].
          array add: secondOperand.
        ]
    ]
].

ppQuerySpec isEmpty
  ifTrue: [
    pcQuerySpec isEmpty
      ifTrue: [ ^ nsc ]
      ifFalse: [ " only path-constants "
        tmpHolder := NscBuilder for: nsc species new max: nsc size.
        nsc do: [ :obj |
          ( obj ~~ nil and:
          [ self evaluatePathConstantPredicates: pcQuerySpec for: obj] )
            ifTrue: [ tmpHolder add: obj ]
        ]
      ]
  ]
  ifFalse: [
    tmpHolder := NscBuilder for: nsc species new max: nsc size.
    pcQuerySpec isEmpty
      ifTrue: [ " only path-paths "
        nsc do: [ :obj |
          ( obj ~~ nil and:
          [ self evaluatePathPathPredicates: ppQuerySpec for: obj ] )
            ifTrue: [ tmpHolder add: obj ]
        ]
      ]
      ifFalse: [ " both path-constants and path-paths "
        nsc do: [ :obj |
          ( obj ~~ nil and:
          [ (self evaluatePathConstantPredicates: pcQuerySpec for: obj) and:
          [ self evaluatePathPathPredicates: ppQuerySpec for: obj ] ] )
            ifTrue: [ tmpHolder add: obj ]
        ]
      ]
  ].

^  tmpHolder completeBag
%

category: 'Query Detect'
method: QueryExecuter
findFirstThatSatisfiesPredicatesStartingAt: beginOffset ordering: ordering stream: stream
  "Returns whether the given object satisfies the predicate described at
 the given offset."

  | obj pcQuerySpec ppQuerySpec array offset hasTruePredicate searchOp secondOperand pathEval |
  " build Arrays that hold the specifications of the predicates "
  pcQuerySpec := {}.	" for path-constant predicates "
  ppQuerySpec := {}.	" for path-path predicates "
  hasTruePredicate := false.
  beginOffset to: ordering size do: [ :j |
    offset := ordering at: j.
    offset ~~ nil
      ifTrue: [
        " if constant-constant predicate, check to see if it is true "
        (self isConstantConstantAt: offset)
          ifTrue: [
            (self _executeConstantConstantPredicateAt: offset)
              ifTrue: [ hasTruePredicate := true ]
              ifFalse: [ ^ #'_incompletePathTraversal' ] ]
          ifFalse: [
            (self isPathConstantAt: offset)
              ifTrue: [ array := pcQuerySpec ]
              ifFalse: [ array := ppQuerySpec ].	" the first operand (a PathEvaluator) "
            pathEval := (self firstOperandAt: offset) asPathEvaluator.
            pathEval _initTraverseCache.
            array add: pathEval.	" the comparison selector "
            searchOp := self operatorAt: offset.	" insert comparison selector "
            array add: (self _operationSelectors at: searchOp + 1).
            secondOperand := self secondOperandAt: offset.	" if dual predicate, transform argument Array "
            searchOp == 9
              ifTrue: [
                secondOperand := {(secondOperand at: 2).
                ((secondOperand at: 1) == 5).
                (secondOperand at: 4).
                ((secondOperand at: 3) == 4)} ].
            array add: secondOperand ] ] ].
  ppQuerySpec isEmpty
    ifTrue: [
      pcQuerySpec isEmpty
        ifFalse: [
          " only path-constants "
          stream ~~ nil
            ifTrue: [
              [ stream atEnd ]
                whileFalse: [
                  ((obj := stream getNext) ~~ nil
                    and: [ self evaluatePathConstantPredicates: pcQuerySpec for: obj ])
                    ifTrue: [ ^ obj ] ] ]
            ifFalse: [
              nsc
                do: [ :theObj |
                  (theObj ~~ nil
                    and: [ self evaluatePathConstantPredicates: pcQuerySpec for: theObj ])
                    ifTrue: [ ^ theObj ] ] ] ] ]
    ifFalse: [
      pcQuerySpec isEmpty
        ifTrue: [
          " only path-paths "
          stream ~~ nil
            ifTrue: [
              [ stream atEnd ]
                whileFalse: [
                  ((obj := stream getNext) ~~ nil
                    and: [ self evaluatePathPathPredicates: ppQuerySpec for: obj ])
                    ifTrue: [ ^ obj ] ] ]
            ifFalse: [
              nsc
                do: [ :theObj |
                  (theObj ~~ nil and: [ self evaluatePathPathPredicates: ppQuerySpec for: theObj ])
                    ifTrue: [ ^ theObj ] ] ] ]
        ifFalse: [
          " both path-constants and path-paths "
          stream ~~ nil
            ifTrue: [
              [ stream atEnd ]
                whileFalse: [
                  ((obj := stream getNext) ~~ nil
                    and: [
                      (self evaluatePathConstantPredicates: pcQuerySpec for: obj)
                        and: [ self evaluatePathPathPredicates: ppQuerySpec for: obj ] ])
                    ifTrue: [ ^ obj ] ] ]
            ifFalse: [
              nsc
                do: [ :theObj |
                  (theObj ~~ nil
                    and: [
                      (self evaluatePathConstantPredicates: pcQuerySpec for: theObj)
                        and: [ self evaluatePathPathPredicates: ppQuerySpec for: theObj ] ])
                    ifTrue: [ ^ theObj ] ] ] ] ].
  ^ (hasTruePredicate and: [ nsc isEmpty not ])
    ifTrue: [
      stream ~~ nil
        ifTrue: [ stream getNext ]
        ifFalse: [ nsc _asIdentityBag _at: 1 ] ]
    ifFalse: [ #'_incompletePathTraversal' ]
%

category: 'Accessing'
method: QueryExecuter
firstOperandAt: offset

"Returns the first operand for the predicate at the given offset."

^ self at: offset + 1
%

category: 'Testing'
method: QueryExecuter
isConstantConstantAt: offset

"Returns whether the predicate at the given offset is a constant-constant
 type."

^ (self at: offset) == 1
%

category: 'Testing'
method: QueryExecuter
isPathConstantAt: offset

"Returns whether the predicate at the given offset is a path-constant type."

^ (self at: offset) == 2
%

category: 'Testing'
method: QueryExecuter
isPathPathAt: offset

"Returns whether the predicate at the given offset is a path-path type."

^ (self at: offset) == 4
%

category: 'Accessing'
method: QueryExecuter
nsc

"Returns the value of the instance variable 'nsc'."

   ^nsc
%

category: 'Updating'
method: QueryExecuter
nsc: newValue

"Modify the value of the instance variable 'nsc'."

nsc := newValue
%

category: 'Accessing'
method: QueryExecuter
numPredicates

"Returns the number of predicates after optimization."

| cnt |
cnt := 0.
1 to: self size by: 4 do: [ :i |
    (self at: i) ~~ nil ifTrue: [ cnt := cnt + 1 ]
].
^ cnt
%

category: 'Accessing'
method: QueryExecuter
operationSelectors

"Returns an Array of comparison operation selectors whose ordering corresponds
 to the operation integer for each predicate entry in the receiver."

^ #( #< #> #= #== #<= #>= #~= #~~)
%

category: 'Accessing'
method: QueryExecuter
operatorAt: offset

"Returns the operator number (0-9) for the predicate at the given offset."

^ self at: offset + 2
%

category: 'Query Optimization'
method: QueryExecuter
optimize

"Perform query optimizations."

1 to: self size by: 4 do: [ :i |
    " ignore predicate if it is constant-constant or the entry is nil "
    ( (self isConstantConstantAt: i) or: [ (self at: i) == nil ] )
        ifFalse: [
            self _transformNilQueriesAt: i.
            self _checkSamePathsAt: i.
        ]
]
%

category: 'Formatting'
method: QueryExecuter
printOn: aStream

"Puts a displayable representation of the receiver on the given stream."

"Copy the implementation from Object so we don't inherit it from Collection."

aStream nextPutAll: self asString
%

category: 'Accessing'
method: QueryExecuter
secondOperandAt: offset

"Returns the second operand for the predicate at the given offset."

^ self at: offset + 3
%

category: 'Query Detect'
method: QueryExecuter
_boundQueryDetect: anArray
  "Argument anArray is a four element Array of Arrays describing a SelectBlock
 in the manner needed to process a query on the receiver:

   1.  Array of the bound variables from the predicate
   2.  Array of the predicate's terms
   3.  Array of the predicate's paths
   4.  Array of Strings of the path names used in the predicate"

  | ordering oSize offset tmpStream streamOffset minElements minStream numElements |
  " get a description of the operations to invoke on indexes "
  self _buildIndexOperationsList: anArray.
  self optimize.	" get the order to invoke the operations "
  ordering := self _getOperationsOrder.
  ordering isEmpty
    ifTrue: [ ^ #'_incompletePathTraversal' ].
  oSize := ordering size.	" if only one predicate, do the detect right away "
  oSize == 1
    ifTrue: [ ^ self _executeDetectionAt: (ordering at: 1) ].
  minElements := nsc size.	" for each predicate ... "
  1 to: oSize do: [ :i |
    offset := ordering at: i.	" if constant-constant predicate, check to see if it is true "
    (self isConstantConstantAt: offset)
      ifTrue: [
        (self _executeConstantConstantPredicateAt: offset)
          ifFalse: [ ^ #'_incompletePathTraversal' ] ].	" if the predicate is path-constant with an index present ... "
    ((self isPathConstantAt: offset)
      and: [
        (self firstOperandAt: offset) isPathEvaluator not
          and: [
            " cannot get stream if operator is ==, ~=, ~~, or unary "
            (#(3 6 7 8) includesIdentical: (self operatorAt: offset)) not ] ])
      ifTrue: [
        " quickly see if any will satisfy the predicate "
        tmpStream := self _executePathConstantStreamSelectionAt: offset.
        tmpStream _atEnd
          ifTrue: [ ^ #'_incompletePathTraversal' ].	" keep the stream with the minimum number of elements "
        (numElements := tmpStream approxNumElements) < minElements
          ifTrue: [
            minElements := numElements.
            minStream := tmpStream.
            streamOffset := i ] ] ].	" if got a stream, only query over its contents "
  minStream ~~ nil
    ifTrue: [
      " self nsc: minStream copy makeNsc. "
      " nil out this entry in the operations order "
      ordering at: streamOffset put: nil ].
  ^ self
    findFirstThatSatisfiesPredicatesStartingAt: 1
    ordering: ordering
    stream: minStream
%

category: 'Query Reject'
method: QueryExecuter
_boundQueryReject: anArray

"Argument anArray is a four element Array of Arrays describing a SelectBlock
 in the manner needed to process a query on the receiver:

   1.  Array of the bound variables from the predicate
   2.  Array of the predicate's terms
   3.  Array of the predicate's paths
   4.  Array of Strings of the path names used in the predicate"

| origNsc result tmpResult |
origNsc := nsc.
result := origNsc _asIdentityBag -
  (self _boundQuerySelect: anArray) _asIdentityBag.
result class == origNsc species
  ifFalse: [
    tmpResult := origNsc species new.
    tmpResult addAll: result.
    result := tmpResult
  ].
^ result
%

category: 'Query Select'
method: QueryExecuter
_boundQuerySelect: anArray

"Argument anArray is a four element Array of Arrays describing a SelectBlock
 in the manner needed to process a query on the receiver:

   1.  Array of the bound variables from the predicate
   2.  Array of the predicate's terms
   3.  Array of the predicate's paths
   4.  Array of Strings of the path names used in the predicate"

| ordering partialSet resultSet origNsc offset |
origNsc := nsc.

" get a description of the operations to invoke on indexes "
self _buildIndexOperationsList: anArray.

self optimize.

" get the order to invoke the operations "
ordering := self _getOperationsOrder.
ordering isEmpty
    ifTrue: [ ^ origNsc species new ].

" get a first result "
resultSet := self _executeSelectionAt: (ordering at: 1).
resultSet isEmpty
    ifTrue: [ ^ resultSet ].

nsc := resultSet.

" execute remaining predicates "
2 to: ordering size do: [ :i |

    resultSet size < self bruteThreshold
      ifTrue: [
        resultSet := self findAllThatSatisfyPredicatesStartingAt: i ordering: ordering.
        resultSet class = origNsc species
          ifFalse:
          [ | tmpResult |
            tmpResult := origNsc species new.
            tmpResult addAll: resultSet.
            resultSet := tmpResult].
        ^resultSet
      ].

    offset := ordering at: i.

    " if the next predicate will be done by brute force,
      use the result set rather than the entire NSC "

    " if it is path-constant or path-path "
    (self isConstantConstantAt: offset)
        ifFalse: [
            " if first operand is not an index "
            (self firstOperandAt: offset) isPathEvaluator
                ifTrue: [ (self firstOperandAt: offset) nsc: resultSet ].

            " if it is path-path and second operand is not an index "
            ( (self isPathPathAt: offset) and:
            [ (self secondOperandAt: offset) isPathEvaluator ] )
                ifTrue: [ (self secondOperandAt: offset) nsc: resultSet ]
        ].

    partialSet := self _executeSelectionAt: offset.

    " if any intermediate result is empty, exit immediately "
    partialSet isEmpty
        ifTrue: [ ^ partialSet ]
        " otherwise, perform a set intersection "
        ifFalse: [ resultSet := resultSet _asIdentityBag * partialSet _asIdentityBag ].

    nsc := resultSet
].

resultSet class = origNsc species
    ifFalse:
        [ | tmpResult |
        tmpResult := origNsc species new.
        tmpResult addAll: resultSet.
        resultSet := tmpResult].

resultSet == origNsc
    ifTrue: [ ^ resultSet copy ].

^ resultSet
%

category: 'Query SelectAsStream'
method: QueryExecuter
_boundQuerySelectAsStream: anArray

"Argument anArray is a four element Array of Arrays describing a SelectBlock
 in the manner needed to process a query on the receiver:

   1.  Array of the bound variables from the predicate
   2.  Array of the predicate's terms
   3.  Array of the predicate's paths
   4.  Array of Strings of the path names used in the predicate"
| numPredicates operand1 stream |

" get a description of the operations to invoke on indexes "
self _buildIndexOperationsList: anArray.

(self isPathConstantAt: 1)
    ifFalse: [ ^ self _error: #rtErrBagInvalidPredicateForStreamSelection ].

operand1 := self firstOperandAt: 1.
(operand1 isRangeEqualityIndex and: [ operand1 isStreamable ])
    ifFalse: [ ^ self _error: #rtErrBagNoRangeIndexOnPathExpression ].

" see if there are two predicates on the same path with the same index "
(numPredicates := self numPredicates) == 2
  ifTrue: [
    " must have identical path "
    operand1 ~~ (self firstOperandAt: 5)
      ifTrue: [ ^ self _error: #rtErrBagOnlyOnePredicateAllowed ].
    " see if predicates can be reduced to one "
    self _consolidatePredicatesAt: 1 and: 5.
    " check number of predicates after consolidation "
    self numPredicates > 1
      ifTrue: [ ^ self _error: #rtErrBagOnlyOnePredicateAllowed ].
    " check if query was satisfiable (see if all operands are now nil) "
    (self firstOperandAt: 1) == nil
      ifTrue: [
        stream := operand1 readStreamClass new rangeIndex: operand1.
        ^ stream currentStack: { 0 } .
      ]
  ]
  ifFalse: [
    numPredicates > 1
      ifTrue: [ ^ self _error: #rtErrBagOnlyOnePredicateAllowed ].

    (self isPathConstantAt: 1)
        ifFalse: [ ^ self _error: #rtErrBagInvalidPredicateForStreamSelection ].
  ].

^ self _executePathConstantStreamSelectionAt: 1
%

category: 'Setup'
method: QueryExecuter
_buildIndexOperationsList: anArray
  "Builds the indexed part that can be used to invoke operations on indexes
 to return the results of a query.  The Array has the following format:

   1.  predicate type
   2.  first index object (or path evaluator if no index exists)
   3.  search operation type (integer between 0-8)
   4.  value or second index object (depending upon predicate type)"

  | varsArray termsArray linksArray pathsArray indexObj indexObj2 firstTermOffset secondTermOffset firstValOffset secondValOffset predicateType |
  varsArray := anArray at: 1.
  termsArray := anArray at: 2.
  linksArray := anArray at: 3.
  pathsArray := anArray at: 4.
  1 to: termsArray size by: 7 do: [ :i |
    " for each predicate described in the termArray ... "
    predicateType := self _determinePredicateType: termsArray startingAt: i.
    predicateType == 2
      ifTrue: [
        " path-constant "
        firstTermOffset := termsArray at: i + 6.
        secondValOffset := termsArray at: i + 2 ]
      ifFalse: [
        predicateType == 3
          ifTrue: [
            " constant-path "
            secondTermOffset := termsArray at: i + 3.
            firstValOffset := termsArray at: i + 5 ]
          ifFalse: [
            predicateType == 4
              ifTrue: [
                " path-path "
                firstTermOffset := termsArray at: i + 6.
                secondTermOffset := termsArray at: i + 3 ]
              ifFalse: [
                " constant-constant "
                firstValOffset := termsArray at: i + 5.
                secondValOffset := termsArray at: i + 2 ] ] ].
    (predicateType == 2 or: [ predicateType == 4 ])
      ifTrue: [
        " if it is path-constant or path-path "
        self addLast: predicateType.
        indexObj := self
          _findIndexMatchingTerms: linksArray
          withPaths: pathsArray
          startingAt: firstTermOffset
          forOperationType: (termsArray at: i)
          predicateType: predicateType.
        predicateType == 4
          ifTrue: [
            " if it is path-path "
            indexObj2 := self
              _findIndexMatchingTerms: linksArray
              withPaths: pathsArray
              startingAt: secondTermOffset
              forOperationType: (termsArray at: i)
              predicateType: predicateType.
            indexObj2 hasSetValuedTerm
              ifTrue: [
                " put set-valued index object first "
                self addLast: indexObj2.
                self addLast: (self _inverseOperatorFor: (termsArray at: i)).
                self addLast: indexObj ]
              ifFalse: [
                self addLast: indexObj.
                self addLast: (termsArray at: i).
                self addLast: indexObj2 ] ]
          ifFalse: [
            " if it is path-constant "
            self addLast: indexObj.
            (termsArray at: i) == 8
              ifTrue: [
                " if unary predicate "
                " recast predicate to be '= true' "
                self addLast: 2.
                self addLast: true ]
              ifFalse: [
                self addLast: (termsArray at: i).
                self addLast: (varsArray at: secondValOffset) ] ] ]
      ifFalse: [
        predicateType == 3
          ifTrue: [
            " if it is constant-path "
            " modify the predicate to be path-constant "
            self addLast: 2.
            indexObj := self
              _findIndexMatchingTerms: linksArray
              withPaths: pathsArray
              startingAt: secondTermOffset
              forOperationType: (termsArray at: i)
              predicateType: predicateType.
            self addLast: indexObj.
            self addLast: (self _inverseOperatorFor: (termsArray at: i)).
            self addLast: (varsArray at: firstValOffset) ]
          ifFalse: [
            " it is constant-constant "
            self addLast: predicateType.
            self addLast: (varsArray at: firstValOffset).
            self addLast: (termsArray at: i).
            self addLast: (varsArray at: secondValOffset) ] ] ]
%

category: 'Setup'
method: QueryExecuter
_buildPathEvaluatorForPredicateLinks: linksArray
withPaths: pathsArray
startingAt: offset

"Returns a path evaluator (an Array of path names) that match the path names
 described by the linksArray and pathsArray arguments (produced as the result
 of binding a select block)."

|  nextLink pathEvaluator i linkSize |
pathEvaluator := PathEvaluator basicNew.

offset == 0
    ifTrue: [
        pathEvaluator add:  #'' .
        ^ pathEvaluator
    ].

i := offset * 2 - 1.
linkSize := linksArray size.

[ i < linkSize ] whileTrue: [

    nextLink == 0 ifTrue: [ ^ pathEvaluator ].

    nextLink := linksArray at: i.
    pathEvaluator add: (pathsArray at: (linksArray at: i + 1)).

    i := nextLink * 2 - 1.

].
^ pathEvaluator
%

category: 'Testing'
method: QueryExecuter
_check: indexObj compare: compareOp value: searchVal

"Raise an error if the comparison operation is not valid for the index object
 and the search value."

" check for range operation using an identity index "
( ( self _isRangeEqualityOperation: compareOp ) and:
[ indexObj isRangeEqualityIndex not ] )
    ifTrue: [ ^ indexObj _errorCannotInvokeRangeOperationOnIdentityIndex ].
%

category: 'Query Optimization'
method: QueryExecuter
_checkPathPathAt: i
  "Check a path-path predicate to see if the query is satisfiable."

  | indexObj operator |
  indexObj := self firstOperandAt: i.
  (indexObj hasSamePathAs: (self secondOperandAt: i))
    ifTrue: [
      " if paths are the same "
      operator := self operatorAt: i.
      (operator >= 2 and: [ operator <= 5 ])
        ifTrue: [
          " if operator is =, ==, <=, >= predicate will always be true "
          " turn predicate into a unary type evaluating to true "
          self at: i put: 1.	" constant-constant "
          self at: i + 1 put: true.	" value "
          self at: i + 2 put: 8.	" unary operation "
          self at: i + 3 put: true	" value " ]
        ifFalse: [
          " operator is <, >, ~=, or ~~ "
          indexObj hasSetValuedTerm
            ifFalse: [
              " if path does not have a set-valued term "
              ^ self _unsatisfiableQuery ] ] ]
%

category: 'Query Optimization'
method: QueryExecuter
_checkSamePathsAt: i

"Perform two checks for the same path:  Check if the predicate at the given
 offset is a path-path predicate with the same path.  Also check if any
 subsequent predicates have the same path as the predicate at the given offset.
 If so, see if the predicates are redundant or if the terms can be
 consolidated."

| predicateList k |
" if path-path "
(self isPathPathAt: i)
    ifTrue: [ self _checkPathPathAt: i ]
    ifFalse: [ " is path-constant "

        " if no more predicates, then we're done "
        i + 4 > self size
            ifTrue: [ ^ self ].

        predicateList := { } .
        " first check each subsequent predicate for redundant predicates "
        i + 4 to: self size by: 4 do: [ :j |
            " if entry not nil and predicate not constant-constant "
            ( (self at: j) == nil or: [ (self at: i) == nil or:
            [ self isConstantConstantAt: j ] ] )
                ifFalse: [
                    " if subsequent predicate has operand with same path "
                    ((self firstOperandAt: i) hasSamePathAs: (self firstOperandAt: j))
                        ifTrue: [ " found predicates with same path "
                            (self _removeRedundantOperatorsAt: i and: j)
                                " if did not remove redundant predicates,
                                  put in list to attempt consolidation "
                                ifFalse: [ predicateList add: j ]
                        ]
                ]
        ].

        " now check for predicates that can be consolidated "
        1 to: predicateList size do: [ :j |
            k := predicateList at: j.
            " if entries not nil "
            ( (self at: i) ~~ nil and: [ (self at: k) ~~ nil ] )
                ifTrue: [ self _consolidatePredicatesAt: i and: k ]
        ].
    ]
%

category: 'Query Optimization'
method: QueryExecuter
_consolidatePredicatesAt: i and: j
  "See if the predicates at the give offset can be consolidated (i.e. can be
 satisfied with a single lookup).  If so, modify the first predicate entry in
 the receiver to contain all the information for the consolidated predicates
 and remove the second predicate."

  | op1 op2 |
  (self firstOperandAt: i) hasSetValuedTerm
    ifTrue: [
      " cannot consolidate if the path expression has a set-valued term "
      ^ self ].
  ((self isPathConstantAt: i) and: [ self isPathConstantAt: j ])
    ifTrue: [
      " check if both predicates are path-constant "
      op1 := self operatorAt: i.
      op2 := self operatorAt: j.
      ((op1 == 1 or: [ op1 == 5 ]) and: [ op2 == 0 or: [ op2 == 4 ] ])
        ifTrue: [
          " if first operator is > or >= and second operator is < or <= "
          ((self secondOperandAt: i)
            _idxForSortGreaterThan: (self secondOperandAt: j))
            ifTrue: [ ^ self _unsatisfiableQuery ].
          self at: i + 2 put: 9.	" dual predicate operator type "
          self
            at: i + 3
            put:
              {op1.
              (self secondOperandAt: i).
              op2.
              (self secondOperandAt: j)}.
          self _removePredicateAt: j	" remove the second predicate " ].
      ((op1 == 0 or: [ op1 == 4 ]) and: [ op2 == 1 or: [ op2 == 5 ] ])
        ifTrue: [
          " if first operator is < or <= and second operator is > or >= "
          ((self secondOperandAt: i)
            _idxForSortLessThan: (self secondOperandAt: j))
            ifTrue: [ ^ self _unsatisfiableQuery ].
          self at: i + 2 put: 9.	" dual predicate operator type "
          self
            at: i + 3
            put:
              {op2.
              (self secondOperandAt: j).
              op1.
              (self secondOperandAt: i)}.
          self _removePredicateAt: j	" remove the second predicate " ] ]
%

category: 'Setup'
method: QueryExecuter
_determinePredicateType: termsArray startingAt: offset

"Returns an integer indicating the predicate type of the predicate whose entry
 begins at the given offset.  Predicates are classified into four types:

 1.  constant-constant (such as 3 > 2)
 2.  path-constant     (such as 'spouse.age' > 30)
 3.  constant-path     (such as 30 <= 'spouse.age')
 4.  path-path         (such as 'spouse.age' < 'spouse.weight')"

(termsArray at: offset + 4)
    ifTrue: [
        (termsArray at: offset + 1)
            ifTrue: [ " its path-path " ^ 4  ]
            ifFalse: [ " its path-constant " ^ 2 ].
    ]
    ifFalse: [
        (termsArray at: offset + 1)
            ifTrue: [ " its constant-path " ^ 3 ]
            ifFalse: [ " its constant-constant " ^ 1 ]
    ]
%

category: 'Query Detect'
method: QueryExecuter
_executeConstantConstantDetectionAt: offset

"Executes the constant-constant type predicate operation that is described at
 the given offset.  If the predicate evaluates to true, returns the first
 object in the 'nsc' instance variable."

( (self _executeConstantConstantPredicateAt: offset) and: [ nsc isEmpty not ] )
    ifTrue: [ ^ nsc _asIdentityBag _at: 1 ]
    ifFalse: [ ^ #_incompletePathTraversal ]
%

category: 'Query Support'
method: QueryExecuter
_executeConstantConstantPredicateAt: offset

"Executes the constant-constant type predicate operation that is described at
 the given offset and returns a Boolean."

| searchOp |
searchOp := (self operatorAt: offset) + 1.

" if it is a unary operation "
searchOp == 9
    ifTrue: [ ^ self firstOperandAt: offset ].

^ (self firstOperandAt: offset)
    perform: (self operationSelectors at: searchOp)
    with: (self secondOperandAt: offset)
%

category: 'Query Select'
method: QueryExecuter
_executeConstantConstantSelectionAt: offset

"Executes the constant-constant type predicate operation that is described at
 the given offset.  Returns a NSC that is the result of the query."

(self _executeConstantConstantPredicateAt: offset)
    ifTrue: [ ^ nsc ]
    ifFalse: [ ^ nsc species new ]
%

category: 'Query Detect'
method: QueryExecuter
_executeDetectionAt: offset

"Executes the predicate operation that is described at the given offset.
 Returns the first object in the 'nsc' instance variable that satisfies the
 predicate.  If none is detected, returns the result of evaluating the zero
 argument block."

| predicateType |
predicateType := self at: offset.

" if it is path-constant (constant-paths are transformed to this) "
predicateType == 2
    ifTrue: [ ^ self _executePathConstantDetectionAt: offset ].

" if it is constant-constant "
predicateType == 1
    ifTrue: [ ^ self _executeConstantConstantDetectionAt: offset ].

" if it is path-path "
predicateType == 4
    ifTrue: [ ^ self _executePathPathDetectionAt: offset ].
self _error: #assocErrBadComparison
%

category: 'Query Detect'
method: QueryExecuter
_executePathConstantDetectionAt: offset

"Executes the path-constant type predicate operation that is described at the
 given offset.  Returns the first object in the 'nsc' instance variable that
 satisfies the predicate."

| indexObj evalObj searchOp searchVal |
indexObj := self firstOperandAt: offset.
searchOp := self operatorAt: offset.
searchVal := self secondOperandAt: offset.
evalObj := indexObj asQueryEvaluator.

self _check: indexObj compare: searchOp value: searchVal.

" if it is < or < = "
(searchOp == 0 or: [ searchOp == 4 ] )
    ifTrue: [
        ^ evalObj
            findFirstValueLessThanKey: searchVal
            andEquals: (searchOp == 4)
    ].
" if it is > or >= "
(searchOp == 1 or: [ searchOp == 5 ] )
    ifTrue: [
        ^ evalObj
            findFirstValueGreaterThanKey: searchVal
            andEquals: (searchOp == 5)
    ].
" if it is = "
searchOp == 2
    ifTrue: [ ^ evalObj findFirstValueEqualTo: searchVal ].
" if it is ~= "
searchOp == 6
    ifTrue: [ ^ evalObj findFirstValueNotEqualTo: searchVal ].
" if it is == "
searchOp == 3
    ifTrue: [ ^ evalObj findFirstValueIdenticalTo: searchVal ].
" if it is ~~ "
searchOp == 7
    ifTrue: [ ^ evalObj findFirstValueNotIdenticalTo: searchVal ].
" if it is unary "
searchOp == 8
    ifTrue: [
        ^ evalObj findFirstValueIdenticalTo: searchVal
    ].
" if it is a dual predicate "
searchOp == 9
    ifTrue: [
      ^ evalObj  findFirstValueGreaterThan: (searchVal at: 2)
          andEquals: ((searchVal at: 1) == 5)
          andLessThan: (searchVal at: 4)
          andEquals: ((searchVal at: 3) == 4)
    ].

self _error: #assocErrBadComparison
%

category: 'Query Select'
method: QueryExecuter
_executePathConstantSelectionAt: offset

"Executes the path-constant type predicate operation that is described at the
 given offset.  Returns a set that is the result of the query."

| indexObj evalObj searchOp searchVal |
indexObj := self firstOperandAt: offset.
searchOp := self operatorAt: offset.
searchVal := self secondOperandAt: offset.
evalObj := indexObj asQueryEvaluator.

self _check: indexObj compare: searchOp value: searchVal.

" if it is < or < = "
(searchOp == 0 or: [ searchOp == 4 ] )
    ifTrue: [
        ^ evalObj findAllValuesLessThanKey: searchVal andEquals: (searchOp == 4)
    ].
" if it is > or >= "
(searchOp == 1 or: [ searchOp == 5 ] )
    ifTrue: [
        ^ evalObj findAllValuesGreaterThanKey: searchVal andEquals: (searchOp == 5)
    ].
" if it is ="
searchOp == 2
    ifTrue: [ ^ evalObj findAllValuesEqualTo: searchVal ].
" if it is ~="
searchOp == 6
    ifTrue: [ ^ evalObj findAllValuesNotEqualTo: searchVal ].
" if it is =="
searchOp == 3
    ifTrue: [ ^ evalObj findAllValuesIdenticalTo: searchVal ].
" if it is ~~"
searchOp == 7
    ifTrue: [ ^ evalObj findAllValuesNotIdenticalTo: searchVal ].
" if it is unary "
searchOp == 8
    ifTrue: [
        ^ evalObj findAllValuesIdenticalTo: searchVal
    ].
" if it is a dual predicate "
searchOp == 9
    ifTrue: [
      ^ evalObj  findAllValuesGreaterThan: (searchVal at: 2)
          andEquals: ((searchVal at: 1) == 5)
          andLessThan: (searchVal at: 4)
          andEquals: ((searchVal at: 3) == 4)
    ].

self _error: #assocErrBadComparison
%

category: 'Query SelectAsStream'
method: QueryExecuter
_executePathConstantStreamSelectionAt: offset
  "Execute the path-constant type predicate operation that is described at the
 given offset.  Returns a stream that is the result of the query."

  | indexObj evalObj searchOp searchVal |
  indexObj := self firstOperandAt: offset.
  searchOp := self operatorAt: offset.
  searchVal := self secondOperandAt: offset.
  evalObj := indexObj asQueryEvaluator.
  self _check: indexObj compare: searchOp value: searchVal.
  (searchOp == 0 or: [ searchOp == 4 ])
    ifTrue: [
      | stream querySpec |
      " if it is < or <= "
      stream := evalObj
        _findAllValuesGreaterThan: nil
        andEquals: true
        andLessThan: searchVal
        andEquals: searchOp == 4
        using: (BtreeComparisonForCompare newForComparison: nil).

      querySpec := indexObj btreeComparisonQuerySpec
        key: searchVal selector: (searchOp == 0
                ifTrue: [ #'<' ]
                ifFalse: [ #'<=' ]);
        yourself.
      stream streamQuerySpec: querySpec.
      ^ stream ].
  (searchOp == 1 or: [ searchOp == 5 ])
    ifTrue: [
      " if it is > or >= "
      ^ evalObj
        _findAllValuesGreaterThanKey: searchVal
        andEquals: searchOp == 5
        using: (BtreeComparisonForCompare newForComparison: nil) ].
  searchOp == 2
    ifTrue: [
      " if it is ="
      ^ evalObj
        _findAllValuesEqualTo: searchVal
        using: (BtreeComparisonForCompare newForComparison: nil) ].
  searchOp == 9
    ifTrue: [
      | stream |
      " if it is a dual predicate "
      stream := evalObj
        _findAllValuesGreaterThan: (searchVal at: 2)
        andEquals: (searchVal at: 1) == 5
        andLessThan: (searchVal at: 4)
        andEquals: (searchVal at: 3) == 4
        using: (BtreeComparisonForCompare newForComparison: nil).
      stream
        streamQuerySpec:
          (BtreeRangeComparisonQuerySpec
            key: (searchVal at: 2)
            selector:
              ((searchVal at: 1) == 5
                ifTrue: [ #'>=' ]
                ifFalse: [ #'>' ])
            and: (searchVal at: 4)
            selector:
              ((searchVal at: 3) == 4
                ifTrue: [ #'<=' ]
                ifFalse: [ #'<' ])).
      ^ stream ].
  ^ self _error: #'rtErrBagOperationNotSupportedForStreamSelection'
%

category: 'Query Detect'
method: QueryExecuter
_executePathPathDetectionAt: offset
  "Executes the path-path type predicate operation that is described at the given
 offset.  Returns the first object for which the predicate evaluates to true."

  | index1 searchOp index2 operator val1 incomplete val2 obj bag |
  index1 := self firstOperandAt: offset.
  searchOp := self operatorAt: offset.
  index2 := self secondOperandAt: offset.
  self _check: index1 compare: searchOp value: index2.
  operator := self _operationSelectors at: searchOp + 1.
  incomplete := #'_incompletePathTraversal'.
  bag := nsc _asIdentityBag.
  index1 isIndexOnRootNsc
    ifTrue: [
      | ivOffsetCache |
      " query of the form { :o | o = o.a.b.c } "
      ivOffsetCache := index2 _createIvOffsetCache.
      1 to: bag size do: [ :i |
        (obj := bag _at: i) ~~ nil
          ifTrue: [
            val2 := index2 _traverseObject: obj cache: ivOffsetCache.
            (val2 ~~ incomplete and: [ obj perform: operator with: val2 ])
              ifTrue: [ ^ obj ] ] ] ]
    ifFalse: [
      index2 isIndexOnRootNsc
        ifTrue: [
          | ivOffsetCache |
          " query of the form { :o | o.a.b.c = o } "
          ivOffsetCache := index1 _createIvOffsetCache.
          1 to: bag size do: [ :i |
            (obj := bag _at: i) ~~ nil
              ifTrue: [
                val1 := index1 _traverseObject: obj cache: ivOffsetCache.
                (val1 ~~ incomplete and: [ val1 perform: operator with: obj ])
                  ifTrue: [ ^ obj ] ] ] ]
        ifFalse: [
          | ivOffsetCache1 ivOffsetCache2 |
          " query of the form { :o | o.a.b.c = o.d.e.f } "
          ivOffsetCache1 := index1 _createIvOffsetCache.
          ivOffsetCache2 := index2 _createIvOffsetCache.
          1 to: bag size do: [ :i |
            (obj := bag _at: i) ~~ nil
              ifTrue: [
                (val1 := index1 _traverseObject: obj cache: ivOffsetCache1) ~~ incomplete
                  ifTrue: [
                    ((val2 := index2 _traverseObject: obj cache: ivOffsetCache2) ~~ incomplete
                      and: [ val1 perform: operator with: val2 ])
                      ifTrue: [ ^ obj ] ] ] ] ] ].
  ^ incomplete
%

category: 'Query Select'
method: QueryExecuter
_executePathPathNoSetValuedSelectionAt: offset

"Execute the path-path type predicate operation that is described at the given
 offset.  Returns a set that is the result of the query."

| pathEval1 searchOp pathEval2 operator tmpHolder val1 val2 obj bag incomplete |

pathEval1 := self firstOperandAt: offset.
searchOp := self operatorAt: offset.
pathEval2 := self secondOperandAt: offset.

operator := self _operationSelectors at: searchOp + 1.

incomplete := #_incompletePathTraversal.
bag := nsc _asIdentityBag.

tmpHolder := NscBuilder for: nsc species new max: nsc size.

pathEval1 _initTraverseCache.
pathEval2 _initTraverseCache.

pathEval1 isIndexOnRootNsc
    ifTrue: [ " query of the form { :o | o = o.a.b.c } "
       | ivOffsetCache |
       ivOffsetCache := pathEval2 _createIvOffsetCache.
       1 to: bag size do: [ :i |
            (obj := bag _at: i) ~~ nil
                ifTrue: [
                    val2 := pathEval2 _traverseObject: obj cache: ivOffsetCache.
                    ( val2 ~~ incomplete and:
                    [ obj perform: operator with: val2 ] )
                        ifTrue: [ tmpHolder add: obj ]
                ]
       ]
    ]
    ifFalse: [
        pathEval2 isIndexOnRootNsc
            ifTrue: [ " query of the form { :o | o.a.b.c = o } "
               | ivOffsetCache |
               ivOffsetCache := pathEval1 _createIvOffsetCache.
               1 to: bag size do: [ :i |
                    (obj := bag _at: i) ~~ nil
                        ifTrue: [
                            val1 := pathEval1 _traverseObject: obj cache: ivOffsetCache.
                            ( val1 ~~ incomplete and:
                            [ val1 perform: operator with: obj ] )
                                ifTrue: [ tmpHolder add: obj ]
                        ]
               ]
            ]
            ifFalse: [ " query of the form { :o | o.a.b.c = o.d.e.f } "
               | ivOffsetCache1 ivOffsetCache2 |
               ivOffsetCache1 := pathEval1 _createIvOffsetCache.
                ivOffsetCache2 := pathEval2 _createIvOffsetCache.
               1 to: bag size do: [ :i |
                    (obj := bag _at: i) ~~ nil
                        ifTrue: [
                            (val1 := pathEval1 _traverseObject: obj cache: ivOffsetCache1) ~~ incomplete
                                ifTrue: [
                                    ( (val2 := pathEval2 _traverseObject: obj cache: ivOffsetCache2) ~~ incomplete and:
                                    [ val1 perform: operator with: val2 ] )
                                        ifTrue: [ tmpHolder add: obj ]
                                ]
                        ]
               ]
            ]
    ].

^ tmpHolder completeBag
%

category: 'Query Select'
method: QueryExecuter
_executePathPathSelectionAt: offset
  "Executes the path-path type predicate operation that is described at the given
 offset.  Returns a set that is the result of the query."

  | index1 searchOp index2 |
  index1 := self firstOperandAt: offset.
  searchOp := self operatorAt: offset.
  index2 := self secondOperandAt: offset.
  self _check: index1 compare: searchOp value: index2.
  ^ self _executePathPathNoSetValuedSelectionAt: offset
%

category: 'Query Select'
method: QueryExecuter
_executeSelectionAt: offset

"Executes the predicate operation that is described at the given offset.
 Returns a set that is the result of the query."

| predicateType |
predicateType := self at: offset.

" if it is path-constant (constant-paths are transformed to this) "
predicateType == 2
    ifTrue: [ ^ self _executePathConstantSelectionAt: offset ].

" if it is constant-constant "
predicateType == 1
    ifTrue: [ ^ self _executeConstantConstantSelectionAt: offset ].

" if it is path-path "
predicateType == 4
    ifTrue: [ ^ self _executePathPathSelectionAt: offset ].

self _error: #assocErrBadComparison
%

category: 'Setup'
method: QueryExecuter
_findIndexMatchingTerms: linksArray withPaths: pathsArray startingAt: offset forOperationType: operationType predicateType: predicateType
  "Returns the index whose path terms match the path names described in linksArray
 at the given offset.  If an existing index is not found, see if linksArray
 describes a sub-path of an existing index.  If so, creates a fake index that
 utilizes the mappings provided by the existing index.  If no index exists, then
 returns the path evaluator that can be used to evaluate the path by brute
 force."

  | iList indexObj pathEvaluator theIndexObj isRangeOperation holder legacyIndexesOnNsc |
  pathEvaluator := self
    _buildPathEvaluatorForPredicateLinks: linksArray
    withPaths: pathsArray
    startingAt: offset.
  iList := nsc _indexedPaths.	" if there are no indexes or it is path-path, returns the path evaluator "
  (iList == nil or: [ predicateType == 4 ])
    ifTrue: [
       pathEvaluator initialize nsc: nsc .
       holder := { pathEvaluator } .   pathEvaluator := nil .
       ^ PathEvaluator asMostSpecificType: holder .
    ].
  isRangeOperation := self _isRangeEqualityOperation: operationType.	" for each index on the receiver ... "
  legacyIndexesOnNsc := false.
  1 to: iList size by: 2 do: [ :i |
    indexObj := iList at: i.
    legacyIndexesOnNsc := indexObj isLegacyIndex. "all indexes on an nsc are either legacy or not"
    (iList at: i + 1) == 1
      ifTrue: [
        " see if the index matches the path "
        (indexObj hasIndexOnPath: pathEvaluator)
          ifTrue: [
            " if range index found for range operation or
          identity index found for identity operation "
            ((isRangeOperation and: [ indexObj isRangeEqualityIndex ])
              or: [ isRangeOperation not and: [ indexObj isIdentityIndex ] ])
              ifTrue: [ ^ indexObj ]
              ifFalse: [ theIndexObj := indexObj ] ] ] ].	" if it is a range operation, no range index was found,
  so it returns the path evaluator "
  isRangeOperation
    ifTrue: [
       pathEvaluator initialize nsc: nsc .
       holder := { pathEvaluator } .   pathEvaluator := nil .
       ^ PathEvaluator asMostSpecificType: holder .
    ]
    ifFalse: [
      " otherwise, an index was found, returns it "
      theIndexObj ~~ nil
        ifTrue: [ ^ theIndexObj ] ].	" no indexObj had a path that was an exact match, so see if we can build
a fake index utilizing the sub-path of an existing index "
  indexObj := IdentityIndex new.
  indexObj
    indexDictionary: nsc _indexDictionary;
    nscRoot: nsc.
  iList _putAllCommonPathTermsForPathArray: pathEvaluator into: indexObj.
  indexObj size == pathEvaluator size
    ifTrue: [
      legacyIndexesOnNsc
        ifTrue: [ ^ indexObj ]
        ifFalse: [
          "eventually this should be conditional on a GsIndexOption ... for now it's naked"
          GsQueryExpectedImplicitIdentityIndexError signal: self ] ].

  pathEvaluator initialize nsc: nsc .
  holder := { pathEvaluator } .   pathEvaluator := nil .
  ^ PathEvaluator asMostSpecificType: holder .
%

category: 'Setup'
method: QueryExecuter
_getOperationsOrder

"Returns an Array that is the order to invoke the operations described in the
 indexOperationsList.  The order is optimized to perform constant-constant
 predicates first, then perform path-constant/constant-path with indexes next,
 then perform identity-based operations second (==, ~~), then perform
 equality-based operations (=, ~=)."

| ordering constList identList equalList otherList indexList |

" if only one predicate, no work to be done "
( self size == 4 and: [ (self at: 1) ~~ nil ] )
    ifTrue: [ ^ #( 1 ) ].

constList := { } .
identList := { } .
equalList := { } .
otherList := { } .
indexList := { } .

1 to: self size by: 4 do: [ :i |
    " entry may be nil due to query optimization "
    (self at: i) ~~ nil
        ifTrue: [
            " if it is constant-constant "
            (self isConstantConstantAt: i)
                ifTrue: [ constList addLast: i ]
                ifFalse: [
                    " if an index exists on the path and it is not path-path "
                    ( (self firstOperandAt: i) isPathEvaluator not and:
                    [ (self isPathPathAt: i ) not ] )
                        ifTrue: [ indexList addLast: i ]
                        ifFalse: [
                            " if it is an identity operation (== or ~~) "
                            (self _isIdentityOperation: (self operatorAt: i))
                                ifTrue: [ identList addLast: i ]
                                ifFalse: [ " if operation is = or ~= "
                                    (self _isEqualityOperation: (self operatorAt: i))
                                        ifTrue: [ equalList addLast: i ]
                                        ifFalse: [ otherList addLast: i ]
                                ]
                        ]
                ]
        ]
].

ordering := { } .
1 to: constList size do: [ :i | ordering addLast: (constList at: i) ].
1 to: indexList size do: [ :i | ordering addLast: (indexList at: i) ].
1 to: identList size do: [ :i | ordering addLast: (identList at: i) ].
1 to: equalList size do: [ :i | ordering addLast: (equalList at: i) ].
1 to: otherList size do: [ :i | ordering addLast: (otherList at: i) ].
^ ordering
%

category: 'Setup'
method: QueryExecuter
_inverseOperatorFor: operator

"Returns the operator number that is the inverse of the given operator number.
 This is used to reverse the operands in a predicate.  For example, the inverse
 of < is >=; the inverse of = is = (no change)."

^ #( 1 0 2 3 5 4 6 7 8 ) at: operator + 1
%

category: 'Testing'
method: QueryExecuter
_isEqualityOperation: searchOp

"Returns true if the given search operation is either = or ~=."

^ searchOp == 2 or: [ searchOp == 6 ]
%

category: 'Testing'
method: QueryExecuter
_isIdentityOperation: searchOp

"Returns true if the given search operation is either == or ~~."

^ searchOp == 3 or: [ searchOp == 7 ]
%

category: 'Testing'
method: QueryExecuter
_isRangeEqualityOperation: searchOp

"Returns true if the given search operation is one of < > = <= >= or ~=."

" ^ #(0 1 2 4 5 6) includesIdentical: searchOp "

^ (searchOp ~~ 3) and: [ searchOp < 7 or: [searchOp = 8]]
%

category: 'Accessing'
method: QueryExecuter
_operationSelectors

"Returns an Array of comparison operation selectors whose ordering corresponds
 to the operation integer for each predicate entry in the receiver."

^ #( #_idxForCompareLessThan:
    #_idxForCompareGreaterThan:
    #_idxForCompareEqualTo:
    #==
    #_idxForCompareLessThanOrEqualTo:
    #_idxForCompareGreaterThanOrEqualTo:
    #_idxForCompareNotEqualTo:
    #~~
    nil
    #_idxGreaterThanAndLessThanValues:
  )
%

category: 'Query Select'
method: QueryExecuter
_perform: selector over: nsc1 and: nsc2

"Send the given comparison selector to each element in nsc1 with each element
 in nsc2 as an argument.  The first time the comparison selector evaluates to
 true, returns true.  Otherwise, returns false."

nsc1 do: [ :obj1 |
    nsc2 do: [ :obj2 |
        (obj1 perform: selector with: obj2)
            ifTrue: [ ^ true ]
    ]
].
^ false
%

category: 'Query Optimization'
method: QueryExecuter
_removePredicateAt: i

"Remove the entry for the predicate at the given offset by putting nil values
 in its slots."

self at: i put: nil ;  "probably faster than replaceFrom:to:with:startingAt:"
    at: i + 1 put: nil ;
    at: i + 2 put: nil ;
    at: i + 3 put: nil .
%

category: 'Query Optimization'
method: QueryExecuter
_removeRedundantOperatorsAt: i and: j
  "Checks the predicates at the given offsets to see if one of them is redundant.
 If so, puts nil values in the entry of the redundant one and returns true."

  "see bug 42804"

  | op1 op2 |
  op1 := self operatorAt: i.
  op2 := self operatorAt: j.
  ((self isPathConstantAt: i) and: [ self isPathConstantAt: j ])
    ifTrue: [
      " check if both predicates are path-constant "
      " NOTE: Redundancies can be removed (they are backwards of the
          removals performed for a singleton path) "
      ((self secondOperandAt: i) == nil or: [ (self secondOperandAt: j) == nil ])
        ifTrue: [ ^ false ].
      (self firstOperandAt: i) hasSetValuedTerm
        ifTrue: [
          " if path has a set-valued term, no redundancies are currently removed "
          ^ false ].
      op1 == op2
        ifTrue: [
          " operators are the same "
          (op1 == 0 or: [ op1 == 4 ])
            ifTrue: [
              " operator: < or <= "
              " choose smallest value "
              ((self secondOperandAt: i)
                _idxForSortLessThan: (self secondOperandAt: j))
                ifTrue: [ self _removePredicateAt: j ]
                ifFalse: [ self _removePredicateAt: i ].
              ^ true ].
          (op1 == 1 or: [ op1 == 5 ])
            ifTrue: [
              " operator: > or >= "
              " choose largest value "
              ((self secondOperandAt: i)
                _idxForSortGreaterThan: (self secondOperandAt: j))
                ifTrue: [ self _removePredicateAt: j ]
                ifFalse: [ self _removePredicateAt: i ].
              ^ true ].
          op1 == 2
            ifTrue: [
              " operator: = "
              ((self secondOperandAt: i)
                _idxForSortEqualTo: (self secondOperandAt: j))
                ifTrue: [ self _removePredicateAt: j ]
                ifFalse: [ self _unsatisfiableQuery ].
              ^ true ].
          op1 == 3
            ifTrue: [
              " operator: == "
              (self secondOperandAt: i) == (self secondOperandAt: j)
                ifTrue: [ self _removePredicateAt: j ]
                ifFalse: [ self _unsatisfiableQuery ].
              ^ true ] ]
        ifFalse: [
          " operators are different "
          ((op1 == 0 and: [ op2 == 4 ]) or: [ op1 == 4 and: [ op2 == 0 ] ])
            ifTrue: [
              " op1: < and op2: <= "
              " op1: <= and op2: < "
              " choose smallest value "
              ((self secondOperandAt: i)
                _idxForSortLessThan: (self secondOperandAt: j))
                ifTrue: [ self _removePredicateAt: j ]
                ifFalse: [
                  ((self secondOperandAt: i) _idxForSortGreaterThan: (self secondOperandAt: j))
                    ifTrue: [ self _removePredicateAt: i ]
                    ifFalse: [
                      " operands are = "
                      op1 == 0
                        ifTrue: [ self _removePredicateAt: j ]
                        ifFalse: [ self _removePredicateAt: i ] ] ].
              ^ true ].
          ((op1 == 1 and: [ op2 == 5 ]) or: [ op1 == 5 and: [ op2 == 1 ] ])
            ifTrue: [
              " op1: > and op2: >= "
              " op1: >= and op2: > "
              " choose largest value "
              ((self secondOperandAt: i)
                _idxForSortGreaterThan: (self secondOperandAt: j))
                ifTrue: [ self _removePredicateAt: j ]
                ifFalse: [
                  ((self secondOperandAt: i) _idxForSortLessThan: (self secondOperandAt: j))
                    ifTrue: [ self _removePredicateAt: i ]
                    ifFalse: [
                      " operands are = "
                      op1 == 1
                        ifTrue: [ self _removePredicateAt: j ]
                        ifFalse: [ self _removePredicateAt: i ] ] ].
              ^ true ].
          ((op1 == 2 and: [ op2 == 3 ]) or: [ op1 == 3 and: [ op2 == 2 ] ])
            ifTrue: [
              " op1: = and op2: == "
              " op1: == and op2: = "
              (self secondOperandAt: i) == (self secondOperandAt: j)
                ifTrue: [ self _removePredicateAt: j ]
                ifFalse: [ self _unsatisfiableQuery ].
              ^ true ].
          op1 == 2
            ifTrue: [
              " op1: = "
              op2 == 0
                ifTrue: [
                  " op2: < "
                  ((self secondOperandAt: i)
                    _idxForSortLessThan: (self secondOperandAt: j))
                    ifTrue: [ self _removePredicateAt: j ]
                    ifFalse: [ self _unsatisfiableQuery ].
                  ^ true ].
              op2 == 4
                ifTrue: [
                  " op2: <= "
                  ((self secondOperandAt: i)
                    _idxForSortLessThanOrEqualTo: (self secondOperandAt: j))
                    ifTrue: [ self _removePredicateAt: j ]
                    ifFalse: [ self _unsatisfiableQuery ].
                  ^ true ].
              op2 == 1
                ifTrue: [
                  " op2: > "
                  ((self secondOperandAt: i)
                    _idxForSortGreaterThan: (self secondOperandAt: j))
                    ifTrue: [ self _removePredicateAt: j ]
                    ifFalse: [ self _unsatisfiableQuery ].
                  ^ true ].
              op2 == 5
                ifTrue: [
                  " op2: >= "
                  ((self secondOperandAt: i)
                    _idxForSortGreaterThanOrEqualTo: (self secondOperandAt: j))
                    ifTrue: [ self _removePredicateAt: j ]
                    ifFalse: [ self _unsatisfiableQuery ].
                  ^ true ] ].
          op2 == 2
            ifTrue: [
              " op2: = "
              op1 == 0
                ifTrue: [
                  " op1: < "
                  ((self secondOperandAt: j)
                    _idxForSortLessThan: (self secondOperandAt: i))
                    ifTrue: [ self _removePredicateAt: i ]
                    ifFalse: [ self _unsatisfiableQuery ].
                  ^ true ].
              op1 == 4
                ifTrue: [
                  " op1: <= "
                  ((self secondOperandAt: j)
                    _idxForSortLessThanOrEqualTo: (self secondOperandAt: i))
                    ifTrue: [ self _removePredicateAt: i ]
                    ifFalse: [ self _unsatisfiableQuery ].
                  ^ true ].
              op1 == 1
                ifTrue: [
                  " op1: > "
                  ((self secondOperandAt: j)
                    _idxForSortGreaterThan: (self secondOperandAt: i))
                    ifTrue: [ self _removePredicateAt: i ]
                    ifFalse: [ self _unsatisfiableQuery ].
                  ^ true ].
              op1 == 5
                ifTrue: [
                  " op1: >= "
                  ((self secondOperandAt: j)
                    _idxForSortGreaterThanOrEqualTo: (self secondOperandAt: i))
                    ifTrue: [ self _removePredicateAt: i ]
                    ifFalse: [ self _unsatisfiableQuery ].
                  ^ true ] ] ] ].
  ^ false
%

category: 'Query Optimization'
method: QueryExecuter
_transformNilQueriesAt: i

"Check if the predicate at the given offset is a path-constant query, with a
 comparison operator of <, <=, >, or >= on a nil value.  If so, either raise
 an error for an invalid query, or transform the query into an = comparison."

| op operand |
" if path-constant on a nil value and last object on the path is a basic class "
( (self isPathConstantAt: i) and:
[ (self secondOperandAt: i) == nil ] )
  ifTrue: [
    operand := self firstOperandAt: i.
    op := self operatorAt: i.

    "no need to fail when nil is an operand
        -- we can handle the comparison without errors
        -- special cases here not enforceable without Constraints
     "

    " if operator is = and we have an identity index,
      transform comparison to == "
    ( op == 2 and: [ operand isIdentityIndex ] )
      ifTrue: [ self at: i + 2 put: 3 ]
  ]
%

category: 'Query Optimization'
method: QueryExecuter
_unsatisfiableQuery

"The query has been deemed to be unsatisfiable.  Nil out each predicate entry."

1 to: self size do: [ :i | self at: i put: nil ]
%

! Class extensions for 'RangeEqualityIndex'

!		Class methods for 'RangeEqualityIndex'

category: 'Constants'
classmethod: RangeEqualityIndex
isBasicClass: aClass
  "Returns whether the given class should use BtreeBasicLeafNodes to store
 B-tree mappings."

  | characterCollectionBasicClasses |
  aClass == nil
    ifTrue: [ ^ false ].
  aClass _isSpecial
    ifTrue: [ ^ true ].  "Deleted term:  aClass ~~ JISCharacter" 
  self _validateLastElementClass: aClass.
  Unicode16 usingUnicodeCompares
    ifTrue: [ 
      characterCollectionBasicClasses := #().
      (aClass _subclassOf: CharacterCollection)
        ifTrue: [ 
          aClass == CharacterCollection
            ifTrue: [ ^ true ].
          (aClass _subclassOf: String)
            ifTrue: [ ^ true ].
          (aClass _subclassOf: MultiByteString)
            ifTrue: [ ^ true ] ] ]
    ifFalse: [ 
      characterCollectionBasicClasses := {String.
      DoubleByteString.
      QuadByteString.
      Unicode7.
      Unicode16.
      Unicode32} ].
  characterCollectionBasicClasses
    ,
      {Number.	"all kernel subclasses of Number"
      DateTime.	"and all subclasses"
      DateAndTime.	"and all subclasses"
      Date.
      Time.
      Character}
    do: [ :basicClass | 
      (aClass _subclassOf: basicClass)
        ifTrue: [ ^ true ] ].
  ^ false
%

category: 'Instance Creation'
classmethod: RangeEqualityIndex
newWithLastElementClass: aClass

"Create a new instance and initialize its B-tree root."

| newOne |
newOne := super new.
newOne lastElementClass: aClass.
newOne btreeRoot: aClass btreeLeafNodeClass new.
^ newOne
%

category: 'Constants'
classmethod: RangeEqualityIndex
_isUnicodeLastElementClass: aClass
  "returns true if <aClass> is a Unicode class"

  self _validateLastElementClass: aClass.
  Unicode16 usingUnicodeCompares
    ifTrue: [
      (self isBasicClass: aClass)
        ifTrue: [
          (aClass _subclassOf: CharacterCollection)
            ifTrue: [ ^ true ] ] ]
    ifFalse: [
      (aClass _subclassOf: Unicode7)
        ifTrue: [ ^ true ].
      (aClass _subclassOf: Unicode16)
        ifTrue: [ ^ true ].
      (aClass _subclassOf: Unicode32)
        ifTrue: [ ^ true ] ].
  ^ false
%

category: 'Private'
classmethod: RangeEqualityIndex
_validateLastElementClass: aClass
  aClass isBehavior
    ifFalse: [
      ArgumentTypeError
        signal: 'LastElementClass (' , aClass printString , ') must be a class' ]
%

!		Instance methods for 'RangeEqualityIndex'

category: 'Updating Indexes'
method: RangeEqualityIndex
addDirectMappingsFor: aBag indexList: iList
  "Add an entry for an index on the elements of the NSC."

  | anObject firstPathTerm indexMgr |
  indexMgr := self indexManager.
  firstPathTerm := self firstPathTerm.
  indexMgr autoCommit
    ifTrue: [ nscRoot _lockForIndexCreation ].
  self lastPathTerm needsDepList
    ifTrue: [
      1 to: aBag size do: [ :i |
        " Add an entry for an index on the elements of the NSC. "
        nil ~~ (anObject := aBag _at: i)
          ifTrue: [
            " add an entry in the dependency list "
            anObject
              getDepListAndAddLastElementPathTerm: firstPathTerm
              logging: false ].
        self btreeAt: anObject put: anObject.
        i \\ 100 == 0
          ifTrue: [ indexMgr commitIndexMaintenance: self at: i ] ] ]
    ifFalse: [
      1 to: aBag size do: [ :i |
        anObject := aBag _at: i.
        self btreeAt: anObject put: anObject.
        i \\ 100 == 0
          ifTrue: [ indexMgr commitIndexMaintenance: self at: i ] ] ]
%

category: 'Converting'
method: RangeEqualityIndex
asIndexSpecification
  (RangeEqualityIndex _isUnicodeLastElementClass: self lastElementClass)
    ifTrue: [ ^ self asUnicodeIndexSpecification ].
  ^ (EqualityIndexSpecification
    path: self pathComponentsString
    lastElementClass: self lastElementClass)
    requirePathTerms: self termsRequired;
    legacyIndex: true;
    yourself
%

category: 'Converting'
method: RangeEqualityIndex
asQueryEvaluator

  ^EqualityIndexQueryEvaluator on: self
%

category: 'Converting'
method: RangeEqualityIndex
asUnicodeIndexSpecification
  | collator |
  collator := self collator
    ifNil: [ IcuCollator default copy immediateInvariant ].
  ^ (self _unicodeIndexSpecificationClass
    path: self pathComponentsString
    collator: collator)
    requirePathTerms: self termsRequired;
    legacyIndex: true;
    yourself
%

category: 'Updating'
method: RangeEqualityIndex
btreeAt: aKey put: aValue
  "Insert the key/value pair into the root B-tree node.  Must check to see if a
 split occurred.  If so, create a new root node and put the old root and the
 new split node into the new root."

  | returnNode node |
  (self _canCompareWith: aKey)
    ifFalse: [
      ^ (ImproperOperation new
        _number:
            (ErrorSymbols at: #'rtErrRangeEqualityIndexInvalidClassKindForBtree');
        args: {aKey class. self lastPathTerm name. self lastElementClassDescription}) signal ].
  returnNode := btreeRoot btreeAt: aKey put: aValue.	" see if a split occurred "
  returnNode == btreeRoot
    ifFalse: [
      " returnNode is the second half of the split "
      node := btreeRoot parentNodeClass new.	" create the new parent node "
      node
        objectSecurityPolicy: btreeRoot objectSecurityPolicy;
        collator: btreeRoot collator.
      node lastValue: returnNode lastValue.
      node
        _insertKey: (btreeRoot _at: btreeRoot _lastKeyIndex)
        value: btreeRoot
        atIndex: 1.	" insert the first half (the original root) "
      node
        _insertKey: (returnNode _at: returnNode _lastKeyIndex)
        value: returnNode
        atIndex: node entrySize + 1.	" insert the second half "
      btreeRoot := node ]
%

category: 'Accessing'
method: RangeEqualityIndex
btreeReadStreamClass
  "Returns the class of btree read stream to create for query results."

  ^ BtreeReadStream
%

category: 'Updating'
method: RangeEqualityIndex
btreeRemoveKey: aKey value: aValue

"Removes the key and value from the B-tree root node.  Must check to see if
 a merge occurred in the root such that the root only contains a single
 entry.  If so, make the single entry the new root.  Returns whether the
 removal occurred."

(btreeRoot removeKey: aKey value: aValue)
    ifTrue: [
        ((btreeRoot numElements == 1) and: [ btreeRoot isLeaf not ] )
            ifTrue: [ btreeRoot := btreeRoot at: (btreeRoot _lastKeyIndex - 1) ].
        ^ true
    ]
    ifFalse: [ ^ false ].
%

category: 'Accessing'
method: RangeEqualityIndex
btreeRoot

"Returns the value of the instance variable 'btreeRoot'."

^btreeRoot
%

category: 'Updating'
method: RangeEqualityIndex
btreeRoot: newValue

"Modify the value of the instance variable 'btreeRoot'."

btreeRoot := newValue
%

category: 'Accessing'
method: RangeEqualityIndex
indexManager

^IndexManager current
%

category: 'Accessing'
method: RangeEqualityIndex
indexType
  ^ #'equality'
%

category: 'Testing'
method: RangeEqualityIndex
isIdentityIndex

"Returns false."

^ false
%

category: 'Testing'
method: RangeEqualityIndex
isRangeEqualityIndex

"Returns true."

^ true
%

category: 'Testing'
method: RangeEqualityIndex
isStreamable
  "Returns true."

  ^ true
%

category: 'Accessing'
method: RangeEqualityIndex
lastElementClass

"Returns the value of the instance variable 'lastElementClass'."

^lastElementClass
%

category: 'Updating'
method: RangeEqualityIndex
lastElementClass: aClass
  self _validateLastElementClass: aClass.
  lastElementClass := aClass
%

category: 'Accessing'
method: RangeEqualityIndex
lastElementClassDescription
  "answer a description of the lastElementClass of the receiver,
   suitable for use in an error message"

  | cl |
  cl := self lastElementClass.
  (cl isSubclassOf: CharacterCollection)
    ifTrue: [
      Unicode16 usingUnicodeCompares
        ifTrue: [ ^ 'CharacterCollection' ]
        ifFalse: [ ^ 'CharacterCollection excluding Unicode String classes' ] ].
  ^ cl name asString
%

category: 'Accessing'
method: RangeEqualityIndex
lastPathComponentsDictionaryOffset

"Returns the last index into the path components list that is mapped in the
 index dictionary (as opposed to the B-tree)."

^ self size - 1
%

category: 'Modification Tracking Support'
method: RangeEqualityIndex
modifiedObject: aKey userData: aValue
  "Notification that modification of aKey is completed and that the receiver
   should update the btree using aValue."

  ^ self btreeAt: aKey put: aValue
%

category: 'Accessing'
method: RangeEqualityIndex
nwayMergeProgress

"Returns the progress count of the n-way merge during index creation.
 Returns nil if index creation is complete."

btreeRoot isBtreeNode
  ifTrue: [ ^ nil ].

^ btreeRoot sortNodes progress
%

category: 'Updating'
method: RangeEqualityIndex
objectSecurityPolicy: anObjectSecurityPolicy

"Assign the receiver and its B-tree to the given security policy."

super objectSecurityPolicy: anObjectSecurityPolicy.
btreeRoot objectSecurityPolicy: anObjectSecurityPolicy
%

category: 'Updating Indexes'
method: RangeEqualityIndex
postIndexCreation: originalBtreeRoot

"Use a merge sort to create a complete B-tree from a PathSorter
stored in the btreeRoot instance variable."

" see if merge sort necessary "
btreeRoot isBtreeNode
	ifFalse: [ | leafNodes pathSorter |
		" create an Array containing an empty B-tree node "
		leafNodes := { originalBtreeRoot }.

		pathSorter := btreeRoot.
        "per bug 36147, we need the leafNodes array to be persistent
         to avoid some out-of-memory conditions during index creation"
		btreeRoot := { leafNodes . pathSorter }.

		" produce an Array containing many B-tree leaf nodes, all sorted "
		pathSorter sortIntoBtreeNodes: leafNodes.
		" now build up interior nodes for the leaves "
		btreeRoot := pathSorter createInteriorNodesFor: leafNodes.
	].

super postIndexCreation: originalBtreeRoot.
%

category: 'Updating Indexes'
method: RangeEqualityIndex
preIndexCreation
  "Determine if a merge sort is necessary.  If so, place a path sorter
 as the btreeRoot (will be replaced with a B-tree node after the merge
 sort).  Returns the original btreeRoot node. "

  | saveNode |
  super preIndexCreation.	" check if all mappings will fit in a single B-tree node "
  nscRoot size > btreeRoot class maxNumberOfElements
    ifTrue: [
      saveNode := btreeRoot.
      saveNode collator: self collator.
      btreeRoot := PathSorter
        on: {self}
        directions: #(true)
        collator: self collator.	" initialize offset of current node to update in sort node Array "
      btreeRoot lastNodeOffset: 1.
      ^ saveNode ].
  ^ btreeRoot
%

category: 'Accessing'
method: RangeEqualityIndex
readStreamClass

"Returns the class of read stream to create for query results."

^ RangeIndexReadStream
%

category: 'Testing'
method: RangeEqualityIndex
_canCompareWith: aKey

"Returns whether the receiver can make B-tree comparisons with the given key."

aKey == nil
    ifTrue: [ ^ true ].

^ btreeRoot _canCompare: aKey withClass: lastElementClass
%

category: 'Testing'
method: RangeEqualityIndex
_checkSameLastElementClassAs: indexObj
  ^ indexObj _checkSameLastElementClassAsEqualityIndex: self
%

category: 'Testing'
method: RangeEqualityIndex
_checkSameLastElementClassAsEqualityIndex: equalityIndexObj
  ^ equalityIndexObj lastElementClass == self lastElementClass
%

category: 'Testing'
method: RangeEqualityIndex
_checkSameLastElementClassAsUnicodeIndex: aUnicodeIndexObj
  ^ false
%

category: 'Updating'
method: RangeEqualityIndex
_clear

"Assigns nil to important instance variables."

btreeRoot := nil.
lastElementClass := nil.
super _clear.
%

category: 'Error Handling'
method: RangeEqualityIndex
_errorObjectNotInBtree: key value: value

"An entry for the key/value was not present in the B-tree."

^ self _error: #rtErrRangeEqualityIndexObjectNotInBtree args: { key . value }
%

category: 'Sorting'
method: RangeEqualityIndex
_getObjectsWithNilOnPath

"Returns an Array containing each object that has a nil value along the path."

| array |
" gather the root objects with nil on the path "
array := { } .
1 to: self size - 1 do: [ :i |
    self _addAllFor: nil
        into: array
        offset: i
        pathTerm: (self at: i)
].
^ array
%

category: 'Sorting'
method: RangeEqualityIndex
_getSecondarySorterOn: indexObjs directions: theBooleans

"Returns a PathSorter if one is needed to perform secondary sorting;
 otherwise returns nil."

| directions traversers aSize |

(aSize := indexObjs size) > 1 ifTrue: [
    directions := theBooleans copyFrom: 2 to: aSize .
    traversers := indexObjs copyFrom: 2 to: aSize .
    ^ PathSorter on: traversers directions: directions.
].
^ nil  .
%

category: 'Removing'
method: RangeEqualityIndex
_removeBtreeEntriesForKey: aKey

"Removes all entries in the B-tree that have a key identical to aKey.
 Returns an Array of values corresponding to each entry that was removed."

| stream vals |
" first we need to find all values that have aKey as the key "
stream := self asQueryEvaluator _findAllValuesGreaterThanKey: aKey andEquals: true.
vals := { } .

[ stream _btreeAtEnd not and:
[ stream _peekKey _idxForSortEqualTo: aKey ] ] whileTrue: [
    aKey == stream _peekKey
        ifTrue: [ vals add: stream _peekValue ].
    stream _btreeNext
].
" now remove the entry for each value "
1 to: vals size do: [ :i |
  (self btreeRemoveKey: aKey value: (vals at: i))
  "  ifFalse: [ self _errorObjectNotInBtree: aKey value: (vals at: i) ] "
].

^ vals
%

category: 'Updating'
method: RangeEqualityIndex
_setPathTermState
  "For each path term but the last, indicate the need to update the index
 dictionary.  For the last path term, indicate the need to update the B-tree.
 Indicate if the last object along the path needs a dependency list."

  | lastPathTerm |
  1 to: self size - 1 do: [ :i | (self at: i) updateDict: indexDictionary ].
  lastPathTerm := self at: self size.
  lastPathTerm updateBtree: self.
  lastElementClass instancesInvariant not
    ifTrue: [
      lastPathTerm needsDepList: true.
      ^ self ].
  lastElementClass allSubclasses
    do: [ :cl |
      cl instancesInvariant not
        ifTrue: [
          "bug 42640 - depList needed unless instances invariant"
          lastPathTerm needsDepList: true.
          ^ self ] ]
%

category: 'Sorting'
method: RangeEqualityIndex
_sortAscendingOn: indexObjs directions: theBooleans

""

| array cnt prevKey prevVal marker sorter btreeOnly offset pathTerm pArr
  stream val |

prevKey := #_incompletePathTraversal.
prevVal := #_incompletePathTraversal.

" create the Array to hold the objects "
array := Array new: nscRoot size.

" build a sorter to be used for secondary sorts "
sorter := self _getSecondarySorterOn: indexObjs directions: theBooleans.

" start the insertion into the Array at the beginning "
self isIndexOnRootNsc
    ifTrue: [ cnt := 0 ]
    ifFalse: [ cnt := nscRoot _idxOccurrencesOf: nil ].

" gather objects with nil along the path "
pArr := self _getObjectsWithNilOnPath.
1 to: pArr size do: [ :i |
    cnt := cnt + 1.
    array at: cnt put: (pArr at: i)
].
pArr := nil .
btreeOnly := self size == 1.
" if no secondary sorts "
sorter == nil ifTrue: [
    " if path length of one "
    btreeOnly ifTrue: [
        btreeRoot _putAscendingValuesInto: array startingAt: cnt + 1.
      ] ifFalse: [
        offset := self lastPathComponentsDictionaryOffset max: 1.
        pathTerm := self at: offset.

        stream := BtreeReadStream on: btreeRoot.
        [ stream atEnd ] whileFalse: [
          val := stream _btreeNext.
         (val == prevVal) ifFalse: [ | tmpArray |
              tmpArray := { } .
              self _addAllFor: val into: tmpArray offset: offset pathTerm: pathTerm.
              1 to: tmpArray size do: [ :i |
                cnt := cnt + 1.
                array at: cnt put: (tmpArray at: i)
              ].
            ].
          prevVal := val
        ]
      ].
    ^ array
  ].

" must check for possibility of duplicate keys (there is a secondary sort) "
marker := cnt max: 1.
offset := self lastPathComponentsDictionaryOffset max: 1.
pathTerm := self at: offset.

" Iterate over the key/values in the B-tree leaf nodes "
btreeRoot _leafKeysAndValuesDo: [ :key :value |

  btreeOnly ifTrue: [ cnt := cnt + 1.
      array at: cnt put: value.
    ] ifFalse: [
     (value == prevVal) ifFalse: [ | tmpArray |
          tmpArray := { } .
          self _addAllFor: value into: tmpArray offset: offset pathTerm: pathTerm.
          1 to: tmpArray size do: [ :i |
            cnt := cnt + 1.
            array at: cnt put: (tmpArray at: i)
          ].
        ]
    ].

    " see if finished a run of duplicate keys "
    key ~= prevKey
      ifTrue: [
        marker < (cnt - 1)
          ifTrue: [ " sort on secondary keys "
            marker to: cnt - 1 do: [ :i | sorter addObject: (array at: i) ].
            sorter sortInto: array startingAt: marker.
            sorter clear
          ].
        marker := cnt
      ].
    prevKey := key.
    prevVal := value
].
" see if ending with duplicate keys "
( sorter ~~ nil and: [ marker < cnt ] )
    ifTrue: [ " sort on secondary keys "
       marker to: cnt do: [ :i | sorter addObject: (array at: i) ].
       sorter sortInto: array startingAt: marker.
       sorter clear
    ].

^ array
%

category: 'Sorting'
method: RangeEqualityIndex
_sortDescendingOn: indexObjs directions: theBooleans

""

| array cnt prevKey prevVal marker sorter btreeOnly offset pathTerm pArr
  stream val |

prevKey := #_incompletePathTraversal.
prevVal := #_incompletePathTraversal.

" create the Array to hold the objects "
array := Array new: nscRoot size.

" build a sorter to be used for secondary sorts "
sorter := self _getSecondarySorterOn: indexObjs directions: theBooleans.

" start the insertion into the Array at the beginning "
self isIndexOnRootNsc
    ifTrue: [ cnt := array size  ]
    ifFalse: [ cnt := array size - (nscRoot _idxOccurrencesOf: nil) ].

" gather objects with nil along the path "
pArr := self _getObjectsWithNilOnPath.
1 to: pArr size do: [ :i |
    array at: cnt put: (pArr at: i).
    cnt := cnt - 1.
].
pArr := nil .

" if path length of one and no secondary sorts,
  optimize putting objects in the result Array "
btreeOnly := self size == 1.
sorter == nil ifTrue: [
    btreeOnly ifTrue: [
        btreeRoot _putDescendingValuesInto: array startingAt: cnt.
      ] ifFalse: [
        offset := self lastPathComponentsDictionaryOffset max: 1.
        pathTerm := self at: offset.

        stream := BtreeReadStream on: btreeRoot.
        [ stream atEnd ] whileFalse: [
          val := stream _btreeNext.

          (val == prevVal) ifFalse: [ | tmpArray |
              tmpArray := { } .
              self _addAllFor: val into: tmpArray offset: offset pathTerm: pathTerm.
              1 to: tmpArray size do: [ :i |
                array at: cnt put: (tmpArray at: i).
                cnt := cnt - 1.
              ].
            ].
          prevVal := val.
        ]
      ].
    ^ array
  ].

" iterate over the receiver looking for duplicate keys "
marker := cnt.
offset := self lastPathComponentsDictionaryOffset max: 1.
pathTerm := self at: offset.

" iterate over the key/values in the B-tree leaf nodes "
btreeRoot _leafKeysAndValuesDo: [ :key :value |
  btreeOnly ifTrue: [
      array at: cnt put: value.
      cnt := cnt - 1.
    ] ifFalse: [
      (value == prevVal) ifFalse: [ | tmpArray |
          tmpArray := { } .
          self _addAllFor: value into: tmpArray offset: offset pathTerm: pathTerm.
            1 to: tmpArray size do: [ :i |
              array at: cnt put: (tmpArray at: i).
              cnt := cnt - 1.
            ].
        ]
    ].

    " see if finished a run of duplicate keys "
    key ~= prevKey
      ifTrue: [
        marker > (cnt + 1)
          ifTrue: [ " sort on secondary keys "
            cnt + 2 to: marker do: [ :i | sorter addObject: (array at: i) ].
            sorter sortInto: array startingAt: cnt + 2.
            sorter clear
          ].
        marker := cnt + 1
      ].
    prevKey := key.
    prevVal := value.
].

" see if ending with duplicate keys "
( sorter ~~ nil and: [ marker > 1 ] )
  ifTrue: [ " sort on secondary keys "
   1 to: marker do: [ :i | sorter addObject: (array at: i) ].
   sorter sortInto: array startingAt: 1.
     sorter clear
    ].
^ array
%

category: 'Sorting'
method: RangeEqualityIndex
_sortOn: indexObjs directions: theBooleans persistentRoot: persistentArrayOrNil

"Returns an Array of objects from the root NSC that is sorted according to the
 paths traversed by indexObjs (with the direction of the sort specified in
 theBooleans)."

(theBooleans at: 1)
    ifTrue: [ ^ self _sortAscendingOn: indexObjs directions: theBooleans ]
    ifFalse: [ ^ self _sortDescendingOn: indexObjs directions: theBooleans ]
%

category: 'Statistics'
method: RangeEqualityIndex
_statisticsInto: dict

"Puts statistical information into the given dictionary."

| arr arr1 arr2 |
arr := dict at: #BtreeSpaceUtilization ifAbsent: [
  dict
    at: #BtreeSpaceUtilization
    put:  { { } . { } }
].

arr1 := arr at: 1.
arr2 := arr at: 2.

btreeRoot _preOrderDo: [ :node |
  arr1 add: node numElements.
  arr2 add: node class maxNumberOfElements.
].
%

category: 'Converting'
method: RangeEqualityIndex
_unicodeIndexSpecificationClass
  ^ UnicodeIndexSpecification
%

category: 'Private'
method: RangeEqualityIndex
_validateLastElementClass: aClass
  self class _validateLastElementClass: aClass
%

! Class extensions for 'RangeIndexReadStream'

!		Class methods for 'RangeIndexReadStream'

category: 'Instance Creation'
classmethod: RangeIndexReadStream
new

"Create an initialized instance of the receiver."

| newOne |
newOne := super new.
newOne setIterationIndexes: { } .
^ newOne
%

category: 'Instance Creation'
classmethod: RangeIndexReadStream
on: aRangeIndex
  "Create a stream that can access the entire contents of the given RangeEqualityIndex."

  | newStream |
  newStream := super on: aRangeIndex btreeRoot.
  newStream rangeIndex: aRangeIndex.
  ^ newStream
%

!		Instance methods for 'RangeIndexReadStream'

category: 'Query Support'
method: RangeIndexReadStream
approxNumElements

"Returns the number of leaf node entries represented by the receiver.  This is
 approximately the number of elements because objects may share sub-objects
 which converge to the same leaf node entry."

| result |
self atEnd ifTrue: [ ^ 0 ].

result := { 0 } .
(currentStack at: currentStack size) numElementsInStack: currentStack
    level:  currentStack size - 1
    endNode: endNode
    endIndex: endIndex
    into: result.

" Add one because the last entry is not counted "
^ (result at: 1) + 1
%

category: 'Testing'
method: RangeIndexReadStream
atEnd
  "Returns true if there are no more elements to return through the logical
 iteration of the stream."

  ^ self _atEndForStream: true
%

category: 'Private'
method: RangeIndexReadStream
getNext
  "Returns the next value on a stream of range index values."

  | val |
  " get the initial value at the end of the path (but do not advance the stream yet) "
  val := self _peekValue.
  rangeIndex isIndexOnRootNsc
    ifFalse: [
      | lastTerm |
      " if the index is not on the elements of the root NSC "
      lastTerm := rangeIndex at: rangeIndex size.
      lastTerm isSetValuedTerm
        ifTrue: [
          " if the last path term indicates that the index is on the elements of
            the NSC itself, then get the next value from the last term (the NSC)"
          val := self nextValueFor: val term: lastTerm ].
      rangeIndex lastPathComponentsDictionaryOffset
        _downTo: 1
        do: [ :i |
          " now iterate through the path components to get the final value "
          val := self nextValueFor: val term: (rangeIndex at: i) ] ].
  super next.	" advance the B-tree current position "
  ^ val
%

category: 'Query Support'
method: RangeIndexReadStream
getNextValueComparing: aSelector key: aKey
  " iterate through the stream, return first value that satisfies query "

  [ self _atEnd not ]
    whileTrue: [
      (self _peekKey perform: aSelector with: aKey)
        ifTrue: [ ^ self getNext ].
      self _btreeNext ].
  ^ #'_incompletePathTraversal'
%

category: 'Query Support'
method: RangeIndexReadStream
getNextValueComparing: aSelector1 key: aKey1 and: aSelector2 key: aKey2
  " iterate through the stream, return first value that satisfies query "

  [ self _atEnd not ]
    whileTrue: [
      | key |
      key := self _peekKey.
      ((key perform: aSelector1 with: aKey1)
        and: [ key perform: aSelector2 with: aKey2 ])
        ifTrue: [ ^ self getNext ].
      self _btreeNext ].
  ^ #'_incompletePathTraversal'
%

category: 'Private'
method: RangeIndexReadStream
initializeSetIterationIndexes
  "Initialize the setIterationIndexes for a new instance."

  | iterationIndexSize |
  rangeIndex == nil
    ifTrue: [ ^ self ].
  iterationIndexSize := rangeIndex lastPathComponentsDictionaryOffset.
  (rangeIndex isIndexOnRootNsc not and: [(rangeIndex at: rangeIndex size) isSetValuedTerm])
    ifTrue: [iterationIndexSize := rangeIndex size].
  setIterationIndexes := Array new: iterationIndexSize.
  1 to: setIterationIndexes size do: [ :i | setIterationIndexes at: i put: 0 ]
%

category: 'Query Support'
method: RangeIndexReadStream
makeNsc

"Returns a new NSC that contains all the elements from the receiver."

| tmpHolder |
tmpHolder := NscBuilder for: rangeIndex nscRoot species new max: rangeIndex nscRoot size.

rangeIndex hasEnumeratedTerm
  ifTrue: [ [ self atEnd ] whileFalse: [ tmpHolder add: self next ] ]
  ifFalse: [
    streamQuerySpec
      ifNil: [
        " If B-tree contains mapping to root object "
        rangeIndex size == 1
            ifTrue: [ self _valuesAddInto: tmpHolder]
            ifFalse: [ self _uniqueValuesAddInto: tmpHolder ] ]
      ifNotNil: [
        " If B-tree contains mapping to root object "
        rangeIndex size == 1
            ifTrue: [ self _valuesAddInto: tmpHolder spec: streamQuerySpec ]
            ifFalse: [ self _uniqueValuesAddInto: tmpHolder spec: streamQuerySpec ] ] ].

" make the stream be at the end "
currentStack at: 1 put: 0.

^ tmpHolder completeBag
%

category: 'Query Support'
method: RangeIndexReadStream
makeNscComparing: aSelector key: aKey

"Returns a new NSC that contains all the elements from the receiver."

| tmpHolder |
tmpHolder := NscBuilder for: rangeIndex nscRoot species new max: rangeIndex nscRoot size.

rangeIndex hasEnumeratedTerm
  ifTrue: [ [ self atEnd ] whileFalse: [ tmpHolder add: (self getNextValueComparing: aSelector key: aKey) ] ]
  ifFalse: [
    " If B-tree contains mapping to root object "
    rangeIndex size == 1
        ifTrue: [ self _valuesAddInto: tmpHolder comparing: aSelector key: aKey]
        ifFalse: [ self _uniqueValuesAddInto: tmpHolder comparing: aSelector key: aKey ] ].

" make the stream be at the end "
currentStack at: 1 put: 0.

^ tmpHolder completeBag
%

category: 'Query Support'
method: RangeIndexReadStream
makeNscComparing: aSelector1 key: aKey1 and: aSelector2 key: aKey2

"Returns a new NSC that contains all the elements from the receiver."

| tmpHolder |
tmpHolder := NscBuilder for: rangeIndex nscRoot species new max: rangeIndex nscRoot size.

rangeIndex hasEnumeratedTerm
  ifTrue: [ [ self atEnd ] whileFalse: [ tmpHolder add: (self getNextValueComparing: aSelector1 key: aKey1 and: aSelector2 key: aKey2) ] ]
  ifFalse: [
    " If B-tree contains mapping to root object "
    rangeIndex size == 1
        ifTrue: [ self _valuesAddInto: tmpHolder comparing: aSelector1 key: aKey1 and: aSelector2 key: aKey2]
        ifFalse: [ self _uniqueValuesAddInto: tmpHolder comparing: aSelector1 key: aKey1 and: aSelector2 key:     aKey2 ] ].

" make the stream be at the end "
currentStack at: 1 put: 0.

^ tmpHolder completeBag
%

category: 'Accessing'
method: RangeIndexReadStream
next
  "Returns the next value on a stream of range index values."

  self atEnd
    ifTrue: [ self _errorEndOfStream ].
  ^ self getNext
%

category: 'Private'
method: RangeIndexReadStream
nextValueFor: val term: pathTerm

"Returns the next value on a stream of range index values."

| nextVal |

nextVal := rangeIndex indexDictionary at: val term: pathTerm.
" see if the next value is a BucketValueBag "
(BucketValueBag _hasInstance: nextVal)
  ifTrue: [ nextVal := self nextValueInBag: nextVal level: pathTerm offset ].

^ nextVal
%

category: 'Private'
method: RangeIndexReadStream
nextValueInBag: aBag level: offset

"Get the next value in the given BucketValueBag and update the set iteration
 indexes accordingly."

| setOffset |

setOffset := (setIterationIndexes at: offset) + 1.

setIterationIndexes at: offset put:
  (setOffset == aBag size ifTrue: [ 0 ] ifFalse: [ setOffset ]).

" return the object in the set "
^ aBag _at: setOffset.
%

category: 'Private'
method: RangeIndexReadStream
noMoreSetsToIterate

"Return whether the setIterationIndexes specifies any more sets over
which to iterate."

1 to: setIterationIndexes size do: [ :i |
  (setIterationIndexes at: i) > 0
    ifTrue: [ ^ false ]
].
^ true
%

category: 'Copying'
method: RangeIndexReadStream
postCopy

"Cleanup of new copy."

currentStack := currentStack copy.
%

category: 'Accessing'
method: RangeIndexReadStream
rangeIndex

"Returns the value of the instance variable 'rangeIndex'."

^rangeIndex
%

category: 'Updating'
method: RangeIndexReadStream
rangeIndex: newValue

"Modify the value of the instance variable 'rangeIndex'."

rangeIndex := newValue.
self initializeSetIterationIndexes
%

category: 'Conversion'
method: RangeIndexReadStream
reversed
  | reversed |
  reversed := (self reversedRangeIndexClass on: self rangeIndex)
    streamQuerySpec: self streamQuerySpec;
    yourself.
  self atEnd
    ifTrue: [ reversed currentStack at: 1 put: 0 ]
    ifFalse: [
      "unwind currentStack until the endNode is `currentNode`"
      [ endNode == (reversed currentStack at: 2) ]
        whileFalse: [ reversed _previousLeaf ].
      "update, current index, endIndex and endNode"
      reversed currentStack at: 1 put: endIndex.
      reversed endIndex: (currentStack at: 1).
      reversed endNode: (currentStack at: 2) ].
  ^ reversed
%

category: 'Private'
method: RangeIndexReadStream
reversedRangeIndexClass
  ^ ReversedRangeIndexReadStream
%

category: 'Accessing'
method: RangeIndexReadStream
setIterationIndexes

"Returns the value of the instance variable 'setIterationIndexes'."

^setIterationIndexes
%

category: 'Updating'
method: RangeIndexReadStream
setIterationIndexes: newValue

"Modify the value of the instance variable 'setIterationIndexes'."

setIterationIndexes := newValue
%

category: 'Updating'
method: RangeIndexReadStream
skip: aNum
"legacy indexes do not support skip: in read stream"

	self shouldNotImplement: #'skip:'
%

category: 'Private'
method: RangeIndexReadStream
_advance

"Advances the B-tree portion of the stream without advancing any of the set
 iteration indexes."

^ super next
%

category: 'Testing'
method: RangeIndexReadStream
_atEnd
  "Returns true if there are no more elements to return through the logical
 iteration of the stream."

  ^ self _atEndForStream: false
%

category: 'Testing'
method: RangeIndexReadStream
_atEndForStream: aBool
  "Returns true if there are no more elements to return through the logical
 iteration of the stream."

  aBool
    ifTrue: [
      self streamQuerySpec
        ifNotNil: [ :querySpec |
          "bug 44079: need to skip key/value pairs that do not satisfy the querySpec"
          [
          | aKey i |
          i := currentStack at: 1.
          i == 0
            ifTrue: [ ^ true ].
          aKey := (currentStack at: 2) _basicAt: i + 1.
          querySpec compareKey: aKey ]
            whileFalse: [
              super next.
              super _atEnd
                and: [
                  self noMoreSetsToIterate
                    ifTrue: [ ^ true ] ] ] ] ].
  ^ super _atEnd and: [ self noMoreSetsToIterate ]
%

category: 'Query Support'
method: RangeIndexReadStream
_uniqueValuesAddInto: collection

"Iterates over the unique values of the B-tree, traversing the reverse mappings
 to the root object.  Adds the root to the given NSC."

| querySpec |
querySpec := BtreeQuerySpec new.
^self _uniqueValuesAddInto: collection spec: querySpec
%

category: 'Query Support'
method: RangeIndexReadStream
_uniqueValuesAddInto: collection comparing: aSelector key: aKey
  "Iterates over the unique values of the B-tree, traversing the reverse mappings
 to the root object.  Adds the root to the given NSC."

  | querySpec |
  querySpec := self _btreeComparisonQuerySpecClass key: aKey selector: aSelector.
  endNode ifNotNil: [ querySpec collator: endNode collator ].
  ^ self _uniqueValuesAddInto: collection spec: querySpec
%

category: 'Query Support'
method: RangeIndexReadStream
_uniqueValuesAddInto: collection comparing: aSelector1 key: aKey1 and: aSelector2 key: aKey2
  "Iterates over the unique values of the B-tree, traversing the reverse mappings
 to the root object.  Adds the root to the given NSC."

  | querySpec |
  querySpec := self _btreeRangeComparisonQuerySpecClass
    key: aKey1
    selector: aSelector1
    and: aKey2
    selector: aSelector2.
  endNode ifNotNil: [ querySpec collator: endNode collator ].
  ^ self _uniqueValuesAddInto: collection spec: querySpec
%

category: 'Query Support'
method: RangeIndexReadStream
_uniqueValuesAddInto: collection identicalTo: aKey
  "Iterate over the unique values of the B-tree, traversing the reverse mappings
 to the root object.  For each entry whose key is identical to the given key,
 add the root to the given NSC."

  | querySpec |
  querySpec := self _btreeComparisonQuerySpecClass key: aKey selector: #'=='.
  endNode ifNotNil: [ querySpec collator: endNode collator ].
  ^ self _uniqueValuesAddInto: collection spec: querySpec
%

category: 'Query Support'
method: RangeIndexReadStream
_uniqueValuesAddInto: collection notEqualTo: aKey
  "Iterate over the unique values of the B-tree, traversing the reverse mappings
 to the root object.  For each entry whose key is not identical to the given
 key, add the root to the given NSC."

  | querySpec |
  querySpec := self _btreeComparisonQuerySpecClass key: aKey selector: #'~='.
  endNode ifNotNil: [ querySpec collator: endNode collator ].
  ^ self _uniqueValuesAddInto: collection spec: querySpec
%

category: 'Query Support'
method: RangeIndexReadStream
_uniqueValuesAddInto: collection notIdenticalTo: aKey
  "Iterate over the unique values of the B-tree, traversing the reverse mappings
 to the root object.  For each entry whose key is not identical to the given
 key, add the root to the given NSC."

  | querySpec |
  querySpec := self _btreeComparisonQuerySpecClass key: aKey selector: #'~~'.
  endNode ifNotNil: [ querySpec collator: endNode collator ].
  ^ self _uniqueValuesAddInto: collection spec: querySpec
%

category: 'Query Support'
method: RangeIndexReadStream
_uniqueValuesAddInto: collection spec: querySpec

"Iterates over the unique values of the B-tree, traversing the reverse mappings
 to the root object.  Adds the root to the given NSC."

| leaf index eSize prevVal offset pathTerm |

" get the index into the leaf node and see if it has reached the end "
index := currentStack at: 1.
index == 0
    ifTrue: [ ^ self ].

rangeIndex isIndexOnNscElements
    ifTrue: [ offset := rangeIndex size ]
    ifFalse: [ offset := rangeIndex lastPathComponentsDictionaryOffset max: 1 ].
pathTerm := rangeIndex at: offset.

leaf := currentStack at: 2.
eSize := endNode entrySize.
prevVal := #_incompletePathTraversal.
querySpec rangeIndex: rangeIndex offset: offset pathTerm: pathTerm.
" while current node is not the end node "
[ leaf ~~ endNode ] whileTrue: [
    " iterate through the values of the current node "
  prevVal := querySpec traverseValuesFrom: leaf
                                  start: index
                                  end: leaf numElements * eSize
                                  previous: prevVal
                                  into: collection.
    " look down the stack for the next leaf node "
    self _nextLeaf.

    leaf := currentStack at: 2.
    index := 1
].
" iterate through the values of the end node "
querySpec traverseValuesFrom: leaf
                 start: index
                 end: endIndex
                 previous: prevVal
                 into: collection.
%

! Class extensions for 'RcBtreeBasicInteriorNode'

!		Instance methods for 'RcBtreeBasicInteriorNode'

category: 'Updating'
method: RcBtreeBasicInteriorNode
at: aKey put: aValue

self shouldNotImplement: #at:put:
%

category: 'Updating'
method: RcBtreeBasicInteriorNode
btreeAt: aKey put: aValue

""

self shouldNotImplement: #btreeAt:put:
%

category: 'Updating'
method: RcBtreeBasicInteriorNode
btreeAt: aKey put: aValue for: anIndexObj selectiveAbortSet: selectiveAbortSetOrNil

| res |
(selectiveAbortSetOrNil ~~ nil and: [ (selectiveAbortSetOrNil includes: self) not ])
        ifTrue: [
                selectiveAbortSetOrNil add: self.
                self _selectiveAbort ].
res := self _at: aKey put: aValue for: anIndexObj selectiveAbortSet: selectiveAbortSetOrNil.
System _addRootObjectToRcReadSet: self.
System redoLog addConflictObject: self for: anIndexObj.
^res
%

category: 'Constants'
method: RcBtreeBasicInteriorNode
parentNodeClass

"Returns the class of node to be created as the parent when a split occurs."

^ RcBtreeBasicInteriorNode
%

category: 'Removing'
method: RcBtreeBasicInteriorNode
removeKey: aKey value: aValue

self shouldNotImplement: #removeKey:value:
%

category: 'Removing'
method: RcBtreeBasicInteriorNode
removeKey: aKey value: aValue for: anIndexObj selectiveAbortSet: selectiveAbortSetOrNil

| res |
(selectiveAbortSetOrNil ~~ nil and: [ (selectiveAbortSetOrNil includes: self) not ])
        ifTrue: [
                selectiveAbortSetOrNil add: self.
                self _selectiveAbort ].
res := self _removeKey: aKey value: aValue for: anIndexObj selectiveAbortSet: selectiveAbortSetOrNil.
System _addRootObjectToRcReadSet: self.
System redoLog addConflictObject: self for: anIndexObj.
^res
%

! Class extensions for 'RcBtreeBasicLeafNode'

!		Instance methods for 'RcBtreeBasicLeafNode'

category: 'Updating'
method: RcBtreeBasicLeafNode
at: aKey put: aValue

self shouldNotImplement: #at:put:
%

category: 'Updating'
method: RcBtreeBasicLeafNode
btreeAt: aKey put: aValue

""

self shouldNotImplement: #btreeAt:put:
%

category: 'Updating'
method: RcBtreeBasicLeafNode
btreeAt: aKey put: aValue for: anIndexObj selectiveAbortSet: selectiveAbortSetOrNil

| res |
(selectiveAbortSetOrNil ~~ nil and: [ (selectiveAbortSetOrNil includes: self) not ])
        ifTrue: [
                selectiveAbortSetOrNil add: self.
                self _selectiveAbort ].
res := super at: aKey put: aValue.
System _addRootObjectToRcReadSet: self.
System redoLog addConflictObject: self for: anIndexObj.
^res
%

category: 'Constants'
method: RcBtreeBasicLeafNode
parentNodeClass

"Returns the class of node to be created as the parent when a split occurs."

^ RcBtreeBasicInteriorNode
%

category: 'Removing'
method: RcBtreeBasicLeafNode
removeKey: aKey value: aValue

self shouldNotImplement: #removeKey:value:
%

category: 'Removing'
method: RcBtreeBasicLeafNode
removeKey: aKey value: aValue for: anIndexObj selectiveAbortSet: selectiveAbortSetOrNil

| res |
(selectiveAbortSetOrNil ~~ nil and: [ (selectiveAbortSetOrNil includes: self) not ])
        ifTrue: [
                selectiveAbortSetOrNil add: self.
                self _selectiveAbort ].
res := super removeKey: aKey value: aValue.
System _addRootObjectToRcReadSet: self.
System redoLog addConflictObject: self for: anIndexObj.
^res
%

! Class extensions for 'RcBtreeInteriorNode'

!		Instance methods for 'RcBtreeInteriorNode'

category: 'Updating'
method: RcBtreeInteriorNode
at: aKey put: aValue

self shouldNotImplement: #at:put:
%

category: 'Updating'
method: RcBtreeInteriorNode
btreeAt: aKey put: aValue

""

self shouldNotImplement: #btreeAt:put:
%

category: 'Updating'
method: RcBtreeInteriorNode
btreeAt: aKey put: aValue for: anIndexObj selectiveAbortSet: selectiveAbortSetOrNil

| res |
(selectiveAbortSetOrNil ~~ nil and: [ (selectiveAbortSetOrNil includes: self) not ])
        ifTrue: [
                selectiveAbortSetOrNil add: self.
                self _selectiveAbort ].
res := self _at: aKey put: aValue for: anIndexObj selectiveAbortSet: selectiveAbortSetOrNil.
System _addRootObjectToRcReadSet: self.
System redoLog addConflictObject: self for: anIndexObj.
^res
%

category: 'Constants'
method: RcBtreeInteriorNode
parentNodeClass

"Returns the class of node to be created as the parent when a split occurs."

^ RcBtreeInteriorNode
%

category: 'Removing'
method: RcBtreeInteriorNode
removeKey: aKey value: aValue

self shouldNotImplement: #removeKey:value:
%

category: 'Removing'
method: RcBtreeInteriorNode
removeKey: aKey value: aValue for: anIndexObj selectiveAbortSet: selectiveAbortSetOrNil

| res |
(selectiveAbortSetOrNil ~~ nil and: [ (selectiveAbortSetOrNil includes: self) not ])
        ifTrue: [
                selectiveAbortSetOrNil add: self.
                self _selectiveAbort ].
res := self _removeKey: aKey value: aValue for: anIndexObj selectiveAbortSet: selectiveAbortSetOrNil.
System _addRootObjectToRcReadSet: self.
System redoLog addConflictObject: self for: anIndexObj.
^res
%

! Class extensions for 'RcBtreeLeafNode'

!		Instance methods for 'RcBtreeLeafNode'

category: 'Updating'
method: RcBtreeLeafNode
at: aKey put: aValue

self shouldNotImplement: #at:put:
%

category: 'Updating'
method: RcBtreeLeafNode
btreeAt: aKey put: aValue

""

self shouldNotImplement: #btreeAt:put:
%

category: 'Updating'
method: RcBtreeLeafNode
btreeAt: aKey put: aValue for: anIndexObj selectiveAbortSet: selectiveAbortSetOrNil

| res |
(selectiveAbortSetOrNil ~~ nil and: [ (selectiveAbortSetOrNil includes: self) not ])
        ifTrue: [
                selectiveAbortSetOrNil add: self.
                self _selectiveAbort ].
res := super at: aKey put: aValue.
System _addRootObjectToRcReadSet: self.
System redoLog addConflictObject: self for: anIndexObj.
^res
%

category: 'Constants'
method: RcBtreeLeafNode
parentNodeClass

"Returns the class of node to be created as the parent when a split occurs."

^ RcBtreeInteriorNode
%

category: 'Removing'
method: RcBtreeLeafNode
removeKey: aKey value: aValue

self shouldNotImplement: #removeKey:value:
%

category: 'Removing'
method: RcBtreeLeafNode
removeKey: aKey value: aValue for: anIndexObj selectiveAbortSet: selectiveAbortSetOrNil

| res |
(selectiveAbortSetOrNil ~~ nil and: [ (selectiveAbortSetOrNil includes: self) not ])
        ifTrue: [
                selectiveAbortSetOrNil add: self.
                self _selectiveAbort ].
res := super removeKey: aKey value: aValue.
System _addRootObjectToRcReadSet: self.
System redoLog addConflictObject: self for: anIndexObj.
^res
%

! Class extensions for 'RcBtreePlusRoot'

!		Instance methods for 'RcBtreePlusRoot'

category: 'Accessing'
method: RcBtreePlusRoot
btreeAt: aKey put: aValue root: rootObject
  "Insert the key/value pair into the root B-tree node.  Must check to see if a
 split occurred.  If so, create a new root node and put the old root and the
 new split node into the new root."

  ^ self _btreeAt: aKey put: aValue root: rootObject logging: true
%

category: 'Removing'
method: RcBtreePlusRoot
removeKey: aKey value: aValue root: rootObject
  "Removes the key and value from the B-tree root node.  Must check to see if
 a merge occurred in the root such that the root only contains a single
 entry.  If so, make the single entry the new root.  Returns whether the
 removal occurred."

^ self _removeKey: aKey value: aValue root: rootObject logging: true
%

category: 'Removing'
method: RcBtreePlusRoot
updateBtreeRootNodeOnRemoval: selectiveAbortSetOrNil
  "If the current root node is an interior node of size one, replace the current root node with its
   single child"

  | oldBTreeRootNode |
  (btreeRootNode numElements == 1 and: [ btreeRootNode isLeaf not ])
    ifTrue: [
      btreeRootNode _selectiveAbort: btreeRootNode ifNotIn: selectiveAbortSetOrNil.
     oldBTreeRootNode := btreeRootNode.
      btreeRootNode := btreeRootNode
        at: btreeRootNode _lastKeyIndex - btreeRootNode keyIndexOffset.
     "write dropped node to force a commit conflict and force replay, in case
      another session makes mods to the node"
     oldBTreeRootNode numElements: oldBTreeRootNode numElements ].
  System _addRootObjectToRcReadSet: self
%

category: 'RC Compatibility'
method: RcBtreePlusRoot
_addBtreePlusNodeToRcReadSet: aBtreePlusNode
  "Use from hard-to-reach methods where objects need to be added to rc read set."

  System _addRootObjectToRcReadSet: aBtreePlusNode.
  System redoLog addConflictObject: aBtreePlusNode for: self.
%

category: 'RC Accessing'
method: RcBtreePlusRoot
_btreeAt: aKey put: aValue root: rootObject logging: aBoolean
  "Insert the key/value/rootObject tuple into the root B-tree node.  Must check to see if a
 split occurred.  If so, create a new root node and put the old root and the
 new split node into the new root."

  ^ self
    _btreeAt: aKey
    put: aValue
    root: rootObject
    logging: aBoolean
    selectiveAbortSet: nil
%

category: 'RC Accessing'
method: RcBtreePlusRoot
_btreeAt: aKey put: aValue root: rootObject logging: aBoolean selectiveAbortSet: selectiveAbortSetOrNil
  "Insert the key/value/rootObject tuple into the root B-tree node.  Must check to see if a
 split occurred.  If so, create a new root node and put the old root and the
 new split node into the new root."

  | returnNode node oldBTreeRootNode |
  returnNode := self btreeRootNode
    at: aKey
    put: aValue
    root: rootObject
    selectiveAbortSet: selectiveAbortSetOrNil.
  " see if a split occurred "
  returnNode == btreeRootNode
    ifFalse: [
      " returnNode is the second half of the split "
      self _addBtreePlusNodeToRcReadSet: returnNode.
      " create the new root node "
      node := self _createNewRootNodeForSplit: returnNode selectiveAbortSet: selectiveAbortSetOrNil.
     self _addBtreePlusNodeToRcReadSet: node.
     btreeRootNode _selectiveAbort: btreeRootNode ifNotIn: selectiveAbortSetOrNil.
     oldBTreeRootNode := btreeRootNode.
     btreeRootNode := node.
     "write dropped node to force a commit conflict and force replay, in case
      another session makes mods to the node"
     oldBTreeRootNode numElements: oldBTreeRootNode numElements ].
  System _addRootObjectToRcReadSet: self.
  aBoolean
    ifTrue: [ self _logBtreeAt: aKey put: aValue root: rootObject ].
  ^ true
%

category: 'Accessing'
method: RcBtreePlusRoot
_createNewRootNodeForSplit: returnNode selectiveAbortSet: selectiveAbortSetOrNil
  "Create a new root node and put the old root and the new split node into the new root."
  " returnNode is the second half of the split "

  |  node |
  " create the new parent node "
  node := btreeRootNode parentNodeClass new
    rootNode: self;
    objectSecurityPolicy: self objectSecurityPolicy;
    lastValue: returnNode lastValue;
    lastRoot: returnNode lastRoot.
  " insert the first half (the original root) "
  node
     _insertKey: (btreeRootNode at: btreeRootNode _lastKeyIndex)
     value: btreeRootNode
     root: (btreeRootNode at: btreeRootNode _lastRootIndex)
     atIndex: 1
     selectiveAbortSet: selectiveAbortSetOrNil.
  " insert the second half "
  node
    _insertKey: (returnNode at: returnNode _lastKeyIndex)
    value: returnNode
    root: (returnNode at: returnNode _lastRootIndex)
    atIndex: node entrySize + 1
    selectiveAbortSet: selectiveAbortSetOrNil.
  ^ node
%

category: 'RC Logging'
method: RcBtreePlusRoot
_logBtreeAt: aKey put: aValue root: rootObject
  "Create a log entry for adding the given key/value/root."

  | logEntry |
  logEntry := LogEntry new.
  logEntry
    receiver: self;
    selector: #'_btreeAt:put:root:logging:selectiveAbortSet:';
    argArray:
        {aKey.
          aValue.
          rootObject.
          false.
          nil}.
  System redoLog addLogEntry: logEntry
%

category: 'RC Logging'
method: RcBtreePlusRoot
_logBtreeRemoveKey: aKey value: aValue root: rootObject
  "Create a log entry for removing the given key/value/root."

  | logEntry |
  logEntry := LogEntry new.
  logEntry
    receiver: self;
    selector: #'_removeKey:value:root:logging:selectiveAbortSet:';
    argArray:
        {aKey.
          aValue.
          rootObject.
          false.
          nil}.
  System redoLog addLogEntry: logEntry
%

category: 'RC Removing'
method: RcBtreePlusRoot
_removeKey: aKey value: aValue root: rootObject logging: aBoolean
  "Removes the key and value from the B-tree root node.  Must check to see if
 a merge occurred in the root such that the root only contains a single
 entry.  If so, make the single entry the new root.  Returns whether the
 removal occurred."

  ^self _removeKey: aKey value: aValue root: rootObject logging: aBoolean selectiveAbortSet: nil
%

category: 'RC Removing'
method: RcBtreePlusRoot
_removeKey: aKey value: aValue root: rootObject logging: aBoolean selectiveAbortSet: selectiveAbortSetOrNil
  "Removes the key and value from the B-tree root node.  Must check to see if
 a merge occurred in the root such that the root only contains a single
 entry.  If so, make the single entry the new root.  Returns whether the
 removal occurred."

  (btreeRootNode removeKey: aKey value: aValue root: rootObject selectiveAbortSet: selectiveAbortSetOrNil)
    ifFalse: [ ^ false ].
  self updateBtreeRootNodeOnRemoval: selectiveAbortSetOrNil.
  aBoolean
    ifTrue: [ self _logBtreeRemoveKey: aKey value: aValue root: rootObject ].
   ^ true
%

category: 'Private'
method: RcBtreePlusRoot
_resolveRcConflictsWith: conflictObjects

"A logical write-write conflict has occurred on the receiver.  The objects that
 had the actual physical write-write conflicts are in the conflictObjects
 Array.  Selectively abort the receiver and then attempt to replay the
 operations maintained in the System redo log.  Returns true if all the
 operations could be replayed; otherwise returns false."

"inline implementation of _abortAndReplay: to abort old btrees before
 replaying log entries."

| redoLog logEntries selectiveAbortSet |
redoLog := System _redoLog.

" if no log entries to replay, then we're done "
redoLog == nil ifTrue: [ ^ false ].
logEntries := redoLog getLogEntriesFor: self .
logEntries == nil ifTrue:[ ^ false ].

" cannot perform selective abort if receiver has a dependency tag "
self _hasDependencyList ifTrue: [ ^ false ].

" explicitly abort the btrees that made up original changes, since we need to abort entire tree, before replaying, since
  nodes may split differently."
selectiveAbortSet := IdentitySet new.
1 to: conflictObjects size do:[ :j | | co |
  co := conflictObjects at: j.
  co _selectiveAbort.
  selectiveAbortSet add: co.
].

"abort all of the btree nodes involved in the transaction"
redoLog conflictObjects keysAndValuesDo:[ :conflictObject :redoObject |
  redoObject == self
        ifTrue: [
                conflictObject _selectiveAbort.
                selectiveAbortSet add: conflictObject ].
].

" refresh the state of the receiver "
self _selectiveAbort.

" replay all operations on the receiver"
1 to: logEntries size do:[:j | | logEnt argArray |
  logEnt := logEntries at: j .
  argArray := logEnt argArray.
  argArray at:  argArray size put: selectiveAbortSet. "install the selectiveAbortSet into the #selectiveAbortSet arg slot (last slot)"
  logEnt redo ifFalse:[
    ^ false  "redo failed, cannot commit"
  ].
].
^ true
%

! Class extensions for 'RcCounter'

!		Class methods for 'RcCounter'

category: 'Instance Creation'
classmethod: RcCounter
new

"Returns a new RcCounter with an initial size of 30.  The counter can handle
 at least 10 user sessions, plus the global components, and default
 system sessions."

^ super new: 30
%

category: 'Instance Creation'
classmethod: RcCounter
new: initialNumberOfUsers

"Returns a new RcCounter with a size that supports initialNumberOfUsers.  The
 new RcCounter will handle more users, but will have subcomponents created
 for initialNumberOfUsers."

| newOne |
newOne := super new: initialNumberOfUsers + 1.
^ newOne initialize
%

!		Instance methods for 'RcCounter'

category: 'Support'
method: RcCounter
cleanupCounter

"For sessions that are not logged in, centralize the individual session
 element's values to the global session element (at index 1).  This may cause
 concurrency conflict if another session performs this operation."

| value invalidSessions sessionElement |
value := 0.
" get Array where unused session IDs are <true> "
invalidSessions := self _getInvalidSessions.

" set all session element's values to zero "
1 to: self size do: [ :i |
    (invalidSessions at: i)
        ifTrue: [
            sessionElement := self at: i.
            sessionElement ~~ nil
                ifTrue: [
                    value := value + sessionElement value.
                    sessionElement value: 0
                ]
        ]
].
" now set the global value at index 1 "
(self _getSessionElementFor: 1) incrementValueBy: value
%

category: 'Decrementing'
method: RcCounter
decrement

"Decrements the current session's counter value."

self _privateDecrementBy: 1
%

category: 'Decrementing'
method: RcCounter
decrementBy: aNumber

"Decrements the current session's counter value by the given amount."

self _privateDecrementBy: aNumber
%

category: 'Decrementing'
method: RcCounter
decrementBy: aNumber ifLessThan: minNumber thenExecute: aBlock

"Determine if decrementing the RcCounter by the given amount would cause the
 total value to fall below the minimum number.  If so, returns the result of
 executing the block; if not, performs the decrement and returns the receiver."

(self value - aNumber >= minNumber)
    " according to this transaction state, the decrement is valid "
    ifTrue: [ self _privateDecrementBy: aNumber ]
    ifFalse: [ ^ aBlock value ]
%

category: 'Decrementing'
method: RcCounter
decrementIfNegative: aBlock

"This is a convenience method to decrement the counter by one only if the
 counter's value does not become negative.  If it would become negative,
 execute the Block."

^ self decrementBy: 1 ifLessThan: 0 thenExecute: aBlock
%

category: 'Incrementing'
method: RcCounter
increment

"Increments the current session's counter value by 1."

self _privateIncrementBy: 1
%

category: 'Incrementing'
method: RcCounter
incrementBy: aNumber

"Increment the current session's counter value by the given amount."

self _privateIncrementBy: aNumber
%

category: 'Initialization'
method: RcCounter
initialize

"Create subcomponents for all available session IDs.  This can avoid
 initial concurrency conflict when many sessions modify the RcCounter
 for the first time."

1 to: super _basicSize do: [ :i |
    self _getSessionElementFor: i
]
%

category: 'Accessing'
method: RcCounter
maxSessionId

"Returns the maximum sessionId that can be used with this RcCounter."

^ super _basicSize
%

category: 'Updating'
method: RcCounter
objectSecurityPolicy: anObjectSecurityPolicy

"Assigns the receiver and subcomponents to the given security policy."

| sessionElement |
super objectSecurityPolicy: anObjectSecurityPolicy .
1 to: self size do: [ :i |
    sessionElement := self at: i.
    sessionElement ifNotNil:[ sessionElement objectSecurityPolicy: anObjectSecurityPolicy  ]
]
%

category: 'Accessing'
method: RcCounter
value

"Returns the cumulative total of all session's counter value."

| val |
val := System rcValueCacheAt: #value for: self otherwise: nil.
val == nil
    ifTrue: [ val := self _calculateValue ].
^ val
%

category: 'Private'
method: RcCounter
_calculateValue

"Calculates the cumulative total of all session's counter values and place it
 in the RC value cache.  Returns the total."

| total sessionElement |
total := 0.
1 to: self size do: [ :i |
    sessionElement := self at: i.
    sessionElement ~~ nil
        ifTrue: [
            total := total + sessionElement value.
        ]
].
System rcValueCacheAt: #value put: total for: self.
^ total
%

category: 'Support'
method: RcCounter
_getInvalidSessionIds
 "Returns an Array of offsets for which receiver has a session component that
  does not belong to a logged in session."
 | rcSize allSess res |
 rcSize := self size.
 allSess := System currentSessions .
 res := { } .
 1 to: allSess size do: [ :n | | each |
   (each < rcSize) ifTrue:[ (self at: each) ifNotNil:[ res add: each ]].
 ].
 ^ res
%

category: 'Support'
method: RcCounter
_getInvalidSessions

"Returns an Array of Booleans, where the value is true if the session ID at the
 corresponding index is not active."

| invalidSessions rcSize allSess |
rcSize := self size.
invalidSessions := Array new: rcSize.
1 to: rcSize do: [ :i | invalidSessions at: i put: true ].

allSess := System currentSessions .
1 to: allSess size do: [ :n | | each |
  each := allSess at: n .
  (each < rcSize) ifTrue: [ invalidSessions at: each + 1 put: false ]
].
^ invalidSessions
%

category: 'Private'
method: RcCounter
_getSessionElementFor: offset

"Returns the RcCounterElement for the given offset.  If one does not exist,
 then create it."

| sessionElement |
sessionElement := self _rcAt: offset.
sessionElement == nil
    ifTrue: [
        sessionElement := RcCounterElement new.
        sessionElement objectSecurityPolicy: self objectSecurityPolicy .
        self at: offset put: sessionElement.
        System redoLog addConflictObject: self for: self
    ].
^ sessionElement
%

category: 'Testing'
method: RcCounter
_isLarge

"Returns true if the object is implemented as a tree of private smaller objects"

^ true
%

category: 'Private'
method: RcCounter
_privateDecrementBy: aNumber

"Decrement the current session's counter value by the given amount."

| sessionElement total systm |
aNumber _validateClass: Number.
sessionElement := self _getSessionElementFor: self _thisSessionIndex.
systm := System .
systm _addRootObjectToRcReadSet: sessionElement.
sessionElement decrementValueBy: aNumber.

" if the counter total has been cached, update the cache "
(total := systm rcValueCacheAt: #value for: self otherwise: nil) == nil
    ifTrue: [ ^ self ].
System
    rcValueCacheAt: #value
    put: (total - aNumber)
    for: self
%

category: 'Private'
method: RcCounter
_privateIncrementBy: aNumber

"Increment the current session's counter value by the given amount."

| sessionElement total systm |
aNumber _validateClass: Number.
sessionElement := self _getSessionElementFor: self _thisSessionIndex.
systm := System .
systm _addRootObjectToRcReadSet: sessionElement.
sessionElement incrementValueBy: aNumber.

" if the counter total has been cached, update the cache "
(total := systm rcValueCacheAt: #value for: self otherwise: nil) == nil
    ifTrue: [ ^ self ].
System
    rcValueCacheAt: #value
    put: (total + aNumber)
    for: self
%

category: 'Private'
method: RcCounter
_resolveRcConflictsWith: conflictObjects

"A logical write-write conflict has occurred on the receiver.  The objects that
 had the actual physical write-write conflicts are in the conflictObjects
 Array.  Returns whether the conflicts could be successfully resolved."

| offset mySessionElement |
" If no objects experienced physical conflict, then just returns "
conflictObjects isEmpty
    ifTrue: [ ^ true ].

" if only had a physical conflict on the root "
( conflictObjects size = 1 and: [ (conflictObjects at: 1) == self ] )
    ifTrue: [
        " keep reference to this session's components "
        offset := self _thisSessionIndex.
        mySessionElement := self _rcAt: offset.
        " only abort the root "
        super _selectiveAbort.

        " get offset again to grow the root object if necessary "
        offset := self _thisSessionIndex.
        " now re-insert the session element "
        self at: offset put: mySessionElement.

        ^ true
    ].

" otherwise, selectively abort entire RcCounter and replay the operations "
^ self _abortAndReplay: conflictObjects
%

category: 'Private'
method: RcCounter
_thisSessionIndex

"Returns the session ID + 1 (add 1 since the first RcCounter slot is reserved
 as the global counter value)."

| sessionIndex |
sessionIndex := System session + 1.
(sessionIndex > self size)
    ifTrue: [ self size: sessionIndex ].
^ sessionIndex
%

! Class extensions for 'RcEqualityIndexSpecification'

!		Instance methods for 'RcEqualityIndexSpecification'

category: 'accessing'
method: RcEqualityIndexSpecification
equalityIndexClass
  ^ self legacyIndex
    ifTrue: [ RcRangeEqualityIndex ]
    ifFalse: [ GsRangeEqualityIndex ]
%

category: 'accessing'
method: RcEqualityIndexSpecification
options
  ^ super options setReducedConflict
%

category: 'accessing'
method: RcEqualityIndexSpecification
_createIndex
  ^ super _createIndex
%

! Class extensions for 'RcIdentityBag'

!		Class methods for 'RcIdentityBag'

category: 'Instance Creation'
classmethod: RcIdentityBag
new

"Returns a new RcIdentityBag that can handle
 at least 10 user sessions, plus the default system gems (1 admin gc,
 1 reclaim gc, 1 page manager, 1 symbol creation gem) ,
 plus the global components."

^ self new: 14
%

category: 'Instance Creation'
classmethod: RcIdentityBag
new: initialNumberOfUsers

"Returns a new RcIdentityBag with a size that supports initialNumberOfUsers
 concurrent sessions plus the global components.
 The new RcIdentityBag will handle more users, but will only have
 subcomponents initially created for initialNumberOfUsers.
 Don't forget to include allowance for
 system gems ( 3 sessions plus the number of reclaim gc gems configured)."

| newOne |
newOne := self basicNew initialize: (initialNumberOfUsers + 1) * 2.
^ newOne initializeComponents
%

!		Instance methods for 'RcIdentityBag'

category: 'Set Arithmetic'
method: RcIdentityBag
* anIdentityBag

"Intersection.  Returns a kind of IdentityBag containing only the
 elements that are present in both the receiver and the argument.

 The class of the result is the class of the argument. If the argument is a
 kind of RcIdentityBag, the result is an IdentityBag.

 If the result is a kind of IdentitySet, then each element that occurs in both
 the receiver and the argument occurs exactly once in the result.  If the result
 is an IdentityBag and if an element occurs m times in the receiver and n
 times in the argument, then the result contains the lesser of m or n
 occurrences of that element."

(anIdentityBag _isRcIdentityBag or: [ anIdentityBag _isIdentityBag not ])
  ifTrue: [ ^ self _asIdentityBag _primIntersect: anIdentityBag _asIdentityBag ]
  ifFalse: [ ^ self _asIdentityBag _primIntersect: anIdentityBag ]
%

category: 'Set Arithmetic'
method: RcIdentityBag
+ anIdentityBag

"Union.  Returns a kind of IdentityBag containing exactly the elements
 that are present in either the receiver or the argument.

 The class of the result is the class of the argument. If the argument is a
 kind of RcIdentityBag, the result is an IdentityBag.

 If the result is a kind of IdentitySet, then each element that occurs in
 either the receiver or the argument occurs exactly once in the result. If the
 result is a kind of IdentityBag, and if an element occurs m times in the
 receiver and n times in the argument, then the result contains m + n
 occurrences of that element."

(anIdentityBag _isRcIdentityBag or: [ anIdentityBag _isIdentityBag not ])
  ifTrue: [ ^ self _asIdentityBag _primUnion: anIdentityBag _asIdentityBag ]
  ifFalse: [ ^ self _asIdentityBag _primUnion: anIdentityBag ]
%

category: 'Set Arithmetic'
method: RcIdentityBag
- anIdentityBag

"Difference.  Returns an IdentityBag containing exactly those elements of the
 receiver that have a greater number of occurrences in the receiver than in the
 argument.  If an element occurs m times in the receiver and n times in the
 argument (where m >= n), then the result will contain m - n occurrences of that
 element."

(anIdentityBag _isRcIdentityBag or: [ anIdentityBag _isIdentityBag not ])
  ifTrue: [ ^ self asIdentityBag _primDifference: anIdentityBag _asIdentityBag ]
  ifFalse: [ ^ self asIdentityBag _primDifference: anIdentityBag ]
%

category: 'Comparing'
method: RcIdentityBag
= anRcIdentityBag

"Verifies that the receiver and anRcIdentityBag are of the same class, then uses
 the semantics of IdentityBag comparison for the elements in the RcIdentityBag."

self == anRcIdentityBag ifTrue:[ ^ true ].
anRcIdentityBag class == self class
    ifFalse: [ ^ false ].
^ self _asIdentityBag = anRcIdentityBag _asIdentityBag
%

category: 'Adding'
method: RcIdentityBag
add: newObject

"Add the object to the RcIdentityBag.  Returns newObject."

newObject == nil ifTrue:[ ^ self "ignore nils" ].
self add: newObject logging: true.
^ newObject.
%

category: 'Adding'
method: RcIdentityBag
add: newObject logging: aBoolean

"Adds newObject to the current session's addition Bag in the RcIdentityBag.  If
 aBoolean is true, logs the addition to the redo log.  Returns the receiver."

| bag sz addIndex result |
" update any indexes if necessary "
newObject == nil ifTrue:[ ^ self ].
(aBoolean and: [ _indexedPaths ~~ nil ])
  ifTrue: [
    result := self _updateIndexesForAdditionOf: newObject logging: aBoolean.
    " if result is not true, it is an Array containing error information "
    result == true
      ifFalse: [ ^ self _raiseIndexingError: result ]
  ].

" add the new object to the current session's addition Bag "
addIndex := self _thisSessionAdditionIndex.
System _addRootObjectToRcReadSet: self.
bag := components _rcAt: addIndex.
bag == nil
    ifTrue: [ bag := self _createComponentBagsFor: addIndex ].

bag add: newObject.
System _addEntireObjectToRcReadSet: bag.
" put components -> RcIdentityBag in conflictObjects dictionary so that
  we can resolve conflict if there is W-W conflict "
System redoLog addConflictObject: components for: self.

aBoolean
  ifTrue: [
    self _logAdditionOf: newObject.
  ].

" apply any removals that have occurred "
self _processRemovalBagFor: self _thisSessionAdditionIndex logging: aBoolean.

aBoolean ifFalse: [ ^ true ].

" if the receiver's asBag has been cached, update the cache "
bag := System rcValueCacheAt: #asBag for: self otherwise: nil.
bag == nil
    ifFalse: [ bag add: newObject ].

sz := System rcValueCacheAt: #size for: self otherwise: nil.
sz == nil
    ifFalse: [ System rcValueCacheAt: #size put: (sz + 1) for: self ].

^ true
%

category: 'Adding'
method: RcIdentityBag
add: anObject withOccurrences: anInteger

"Add the object to the RcIdentityBag the given number of times.  Returns the
 receiver."

anObject == nil ifTrue:[ ^ self "ignore nils" ].
1 to: anInteger do: [ :i | self add: anObject logging: true ]
%

category: 'Adding'
method: RcIdentityBag
addAll: aCollection

"Adds the collection of objects to the RcIdentityBag.
 Returns aCollection ."

| arr |
(arr := { } ) addAll: aCollection .
self addAll: arr logging: true.
^ aCollection
%

category: 'Adding'
method: RcIdentityBag
addAll: aCollection logging: aBoolean

"Adds the collection of objects to the current session's addition Bag.  If
 aBoolean is true, logs the addition to the redo log.
 Returns true if successful .
 Note that aCollection is always an Array copy of the original collection that
 was used in RcIdentityBag>>addAll: ."

| bag sz addIndex result |

" update any indexes if necessary "
(aBoolean and: [ _indexedPaths ~~ nil ])
  ifTrue: [
    1 to: aCollection size do: [ :i |
      result := self _updateIndexesForAdditionOf: (aCollection _at: i)
        logging: aBoolean.
      " if result is not true, it is an Array containing error information "
      result == true
        ifFalse: [ ^ self _raiseIndexingError: result ]
    ]
  ].

" add the new object to the current session's addition Bag "
addIndex := self _thisSessionAdditionIndex.
System _addRootObjectToRcReadSet: self.
bag := components _rcAt: addIndex.
bag == nil
  ifTrue: [ bag := self _createComponentBagsFor: addIndex ].

bag addAll: aCollection.

System _addEntireObjectToRcReadSet: bag.

" put components -> RcIdentityBag in conflictObjects dictionary so that
we can resolve conflict if there is W-W conflict "
System redoLog addConflictObject: components for: self.
aBoolean ifTrue: [ self _logAddAllOf: aCollection ].

" apply any removals that have occurred "
self _processRemovalBagFor: self _thisSessionAdditionIndex logging: aBoolean.

aBoolean ifFalse: [ ^ true ].

" if the receiver's asBag has been cached, update the cache "
bag := System rcValueCacheAt: #asBag for: self otherwise: nil.
bag == nil
  ifFalse: [ bag addAll: aCollection ].

sz := System rcValueCacheAt: #size for: self otherwise: nil.
sz == nil
  ifFalse: [
    System rcValueCacheAt: #size put: (sz + aCollection size) for: self
  ].

^ true
%

category: 'Converting'
method: RcIdentityBag
asArray

"Returns an Array with the contents of the receiver."

^ Array withAll: self
%

category: 'Converting'
method: RcIdentityBag
asIdentityBag

"Returns a Bag that consists of objects in this RcIdentityBag.  Note that each
 invocation of this message returns a new Bag."

^ self _asIdentityBag copy
%

category: 'Accessing'
method: RcIdentityBag
at: offset

"Returns the element of the receiver that is currently located at logical
 position offset.

 The elements of an RcIdentityBag are inherently unordered, and can change
 position (offset) when the RcIdentityBag is altered.  Thus, after an
 RcIdentityBag is altered, a given element may reside at a different offset than
 before, and a given offset may house a different element.  You should not infer
 an ordering for an RcIdentityBag's elements when you access them by offset.

 This method is useful primarily as a code optimizer for iterating over all the
 elements of an RcIdentityBag (using a loop that runs the offset from 1 to the
 size of the RcIdentityBag).  The RcIdentityBag must not change during the
 iteration.  But the iteration may run faster than it would if you use other
 alternatives, such as the do: method."

| addBag remBag diffSz cumulativeSz prevSz currOffset obj |
cumulativeSz := 0.
1 to: components size by: 2 do: [ :i |
  (addBag := components at: i) ~~ nil
    ifTrue: [
      remBag := components at: i + 1.
      diffSz := addBag size - remBag size.
      prevSz := cumulativeSz.
      cumulativeSz := cumulativeSz + diffSz.
      " see if this pair contains the object at the logical offset "
      cumulativeSz >= offset
        ifTrue: [
          currOffset := offset - prevSz.
          1 to: addBag size do: [ :j |
            obj := addBag at: j.
            (addBag occurrencesOf: obj) > (remBag occurrencesOf: obj)
              ifTrue: [
                currOffset == 1
                  ifTrue: [ ^ obj ].
                currOffset := currOffset - 1
              ]
          ]
        ]
    ]
].
self _error: #objErrBadOffsetIncomplete args: { offset }
%

category: 'Support'
method: RcIdentityBag
centralizeSessionElements

"Place the elements of inactive session components in the global Bag.  This
 may cause concurrency conflict if another session performs this operation, or
 if a new session modifies the RcIdentityBag."

| inactiveSessions globalAddBag systm |
inactiveSessions := self _getInactiveSessionIndexes.
" treat this session as inactive "
inactiveSessions add: self _thisSessionAdditionIndex.

globalAddBag := self _globalAddBag.
systm := System .
systm _addRootObjectToRcReadSet: self.
systm _addEntireObjectToRcReadSet: components.
inactiveSessions do: [ :i | | addBag |
    addBag := components _rcAt: i.
    addBag ~~ nil
        ifTrue: [
            " apply any removals that have occurred for that session's elements "
            self _processRemovalBagFor: i logging: true.

            " put all additions in the global Bag "
            globalAddBag addAll: addBag.
            " remove all from the sessions addition Bag "
            addBag removeAll: addBag.
            System _addEntireObjectToRcReadSet: addBag.
        ]
].
systm redoLog addConflictObject: components for: self.
%

category: 'Support'
method: RcIdentityBag
cleanupBag

"Iterate through all inactive session bags and process their removal Bags.
 This may cause conflict if a new session modifies the receiver."

| sessionIndex inactiveSessions |
inactiveSessions := self _getInactiveSessionIndexes.

" treat this session as inactive if there are enough component Bags "
sessionIndex := self _thisSessionAdditionIndex.
sessionIndex <= super _basicSize
    ifTrue: [ inactiveSessions add: self _thisSessionAdditionIndex ].

" treat the global session as inactive "
inactiveSessions add: 1.

System _addRootObjectToRcReadSet: self;
	_addEntireObjectToRcReadSet: components.
inactiveSessions do: [ :i |
    " apply any removals that have occurred for that session's elements "
    self _processRemovalBagFor: i logging: true.
    " perform an _rcAt: to place nodes in the RC read set "
    components _rcAt: i
]
%

category: 'Clustering'
method: RcIdentityBag
cluster

"Clusters an object using the current default ClusterBucket.  Has no effect and
 returns true if the receiver was previously clustered in the current
 transaction; otherwise returns false after clustering the receiver."

System _addRootObjectToRcReadSet: self.
super cluster
  ifTrue: [ ^ true ].

System _addEntireObjectToRcReadSet: components.
components cluster.
self _doSessionBags: [ :addBag :removeBag |
  addBag cluster.
  removeBag cluster.
].
^ false
%

category: 'Clustering'
method: RcIdentityBag
clusterDepthFirst

"Clusters the receiver and its contents in depth-first order.  Returns true if
 the receiver has already been clustered during the current transaction; returns
 false otherwise.  This operation may cause concurrency conflicts with other
 sessions."

System _addRootObjectToRcReadSet: self.
super cluster
  ifTrue: [ ^ true ].

self clusterIndexes.

System _addEntireObjectToRcReadSet: components.
components cluster.
self _doSessionBags: [ :addBag :removeBag |
  addBag clusterDepthFirst.
  removeBag clusterDepthFirst.
].
^ false
%

category: 'Support'
method: RcIdentityBag
distributeSessionElements

"Distributes the elements of inactive session components across all inactive
 session components.  This could lessen the chance of conflicts that must be
 resolved at commit time.  This may cause concurrency conflict if another
 session performs this operation or if a new session modifies the receiver."

| inactiveSessions numberInactive numPerBag
remainder totalToDistribute extras deficientSessions |

inactiveSessions := self _getInactiveSessionIndexes.
" treat this session as inactive "
inactiveSessions add: self _thisSessionAdditionIndex.
" treat the global session as inactive "
inactiveSessions add: 1.

deficientSessions := IdentityBag new.
extras := IdentityBag new.

numberInactive := inactiveSessions size.
totalToDistribute := 0.

System _addRootObjectToRcReadSet: self;
    _addEntireObjectToRcReadSet: components.

" pass1: for each inactive session, process its removal Bag and
  calculate total number that will be distributed "
inactiveSessions do: [ :i | | addBag |
    (addBag := components _rcAt: i) == nil
        ifTrue: [ self _createComponentBagsFor: i ]
        ifFalse: [
            self _processRemovalBagFor: i logging: true.
            totalToDistribute := totalToDistribute + addBag size
        ]
].
numPerBag := totalToDistribute // numberInactive.
remainder := totalToDistribute \\ numberInactive.

" pass2: perform removals to inactive addition Bags
  that have more than numPerBag "
inactiveSessions do: [ :i | | delta addBag |
    delta := (addBag := components at: i) size - numPerBag.

    (delta > 0) "session contains more than numPerBag "
        ifTrue: [ | amount |
            remainder > 0
                ifTrue: [
                    amount := delta - 1.
                    remainder := remainder - 1
                ]
                ifFalse: [ amount := delta ].

            extras addAll: (self _removeAny: amount from: addBag)
        ]
        ifFalse: [ deficientSessions add: i ]
].

" pass3: perform additions to inactive addition Bags that were
  previously deficient in the number of elements "
deficientSessions do: [ :i | | amount addBag |
    addBag := components at: i.
    remainder > 0
        ifTrue: [
            amount := numPerBag + 1.
            remainder := remainder - 1
        ]
        ifFalse: [ amount := numPerBag ].
    addBag addAll: (self _removeAny: amount - addBag size from: extras)
]
%

category: 'Enumerating'
method: RcIdentityBag
do: aBlock

"Enumerates over all elements in the RcIdentityBag, executing aBlock with each
 element as the argument.  Returns the receiver."

| b |
b := self _asIdentityBag.
1 to: b size do: [ :i | aBlock value: (b _at: i) ]
%

category: 'Comparing'
method: RcIdentityBag
hash

"Returns an Integer hash code for the receiver.

 Warning:  This is a computationally expensive operation."

^ self _asIdentityBag hash
%

category: 'Searching'
method: RcIdentityBag
includes: anObject

"Returns true if anObject is present in any session component of the
 RcIdentityBag."

^self includesIdentical: anObject

%

category: 'Searching'
method: RcIdentityBag
includesIdentical: anObject

"Returns true if anObject is present in any session component of the
 RcIdentityBag."

self _doSessionBags: [ :addBag :removeBag |
   (addBag includesIdentical: anObject) ifTrue: [
     removeBag isEmpty ifTrue: [ ^ true ].
     (addBag occurrencesOf: anObject) > (removeBag occurrencesOf: anObject)
         ifTrue: [ ^ true ]
   ]
].
^ false
%

category: 'Searching'
method: RcIdentityBag
includesValue: anObject

"Returns true if anObject is present in any session component of the
 RcIdentityBag.  Uses equality comparison."

self _doSessionBags: [ :addBag :removeBag |
    (addBag includesValue: anObject)
        ifTrue: [
            removeBag isEmpty ifTrue: [ ^ true ].
            ((addBag _primDifference: removeBag) includesValue: anObject)
                ifTrue: [ ^ true ]
        ]
].
^ false
%

category: 'Initialization'
method: RcIdentityBag
initialize: aSize

"Initializes a new instance."

components := Array new: aSize.
%

category: 'Initialization'
method: RcIdentityBag
initializeComponents

"Create subcomponents for all available session IDs.  This can avoid
 initial concurrency conflict when many sessions add an object to the
 RcIdentityBag for the first time."

1 to: components size by: 2 do: [ :i |
  (components at: i) == nil
    ifTrue: [ self _createComponentBagsFor: i ]
]
%

category: 'Accessing'
method: RcIdentityBag
maxSessionId

"Returns the maximum sessionId that can be used with this RcIdentityBag."

^ components size
%

category: 'Accessing'
method: RcIdentityBag
namedSize
  ^ self class instSize 
%

category: 'Updating'
method: RcIdentityBag
objectSecurityPolicy: anObjectSecurityPolicy

"Assigns the receiver and its subcomponents to the given ObjectSecurityPolicy."

super objectSecurityPolicy: anObjectSecurityPolicy .
components objectSecurityPolicy: anObjectSecurityPolicy .

1 to: components size do: [ :i | | elem |
  (elem := components at: i) ifNotNil:[
    elem objectSecurityPolicy: anObjectSecurityPolicy
  ]
]
%

category: 'Searching'
method: RcIdentityBag
occurrencesOf: anObject

"Returns the number of occurrences of anObject in all session components of
 the RcIdentityBag."

^ self _asIdentityBag occurrencesOf: anObject
%

category: 'Copying'
method: RcIdentityBag
postCopy

"Cleanup new copy."

super postCopy.
components := components copy.
1 to: components size do: [ :i |
  components at: i put: (components at: i) copy
].
%

category: 'Formatting'
method: RcIdentityBag
printOn: aStream

"Puts a displayable representation of the receiver on the given stream."

| count sz myCls anObj |

myCls := self class .
aStream nextPutAll: myCls name describeClassName .
aStream nextPutAll: '( ' .
count := 1 .
sz := self size .
1 to: sz do:[:idx |
  aStream position > 700 ifTrue:[
    "prevent infinite recursion when printing cyclic structures, and
     limit the size of result when printing large collections."
    aStream nextPutAll: '...)' .
    ^ self
    ] .
  anObj := self at: idx .
  anObj printOn: aStream .
  count < sz ifTrue:[ aStream nextPutAll: ', ' ].
  count := count + 1 .
  ].
aStream nextPut: $) .
%

category: 'Removing'
method: RcIdentityBag
remove: anObject

"Removes anObject from the receiver.  If anObject is present several times in
 the receiver, only one occurrence is removed.  Generates an error if anObject
 is not in the receiver.  Returns anObject. "

^(self _privateRemove: anObject logging: true)
	ifTrue: [ anObject ]
    ifFalse: [ self _errorNotFound: anObject ]
%

category: 'Removing'
method: RcIdentityBag
remove: anObject ifAbsent: aBlock

"Removes anObject from the receiver.  If anObject is present several times in
 the receiver, only one occurrence is removed.  If anObject is not in the
 receiver, this method evaluates aBlock and returns its value.  The argument
 aBlock must be a zero-argument block.  Returns anObject. "

^(self _privateRemove: anObject logging: true)
    ifTrue: [ anObject ]
    ifFalse: [ aBlock value ]
%

category: 'Removing'
method: RcIdentityBag
removeAll: aCollection

"Removes one occurrence of each element of aCollection from the receiver and
 returns the receiver.  Generates an error if any element of aCollection is not
 present in the receiver."

aCollection size ~~ 0 ifTrue:[
  (self _removeAll: aCollection logging: true) ifFalse:[
    LookupError new args: { self } ;
	signal: 'an element of aCollection was not found during removal '
  ]
].
^aCollection
%

category: 'Removing'
method: RcIdentityBag
removeAllPresent: aCollection

"Removes from the receiver one occurrence of each element of aCollection that
 is also an element of the receiver.  Differs from removeAll: in that, if some
 elements of aCollection are not present in the receiver, no error is
 generated.  Returns aCollection."

aCollection == self
    ifTrue: [ aCollection asBag do: [ :obj | self removeIfPresent: obj ] ]
    ifFalse: [ aCollection do: [ :obj | self removeIfPresent: obj ] ].
^aCollection
%

category: 'Removing'
method: RcIdentityBag
removeIdentical: anObject ifAbsent: aBlock

"Removes anObject from the receiver.  If anObject is present several times in
 the receiver, only one occurrence is removed.  If anObject is not in the
 receiver, this method evaluates aBlock and returns its value.  The argument
 aBlock must be a zero-argument block."

(self _privateRemove: anObject logging: true)
    ifFalse: [ ^ aBlock value ]
%

category: 'Removing'
method: RcIdentityBag
removeIfPresent: anObject

"Remove anObject from the receiver.  If anObject is present several times in
 the receiver, only one occurrence is removed.  Returns nil if anObject is
 missing from the receiver."

(self _privateRemove: anObject logging: true)
    ifFalse: [ ^ nil ]
%

category: 'Accessing'
method: RcIdentityBag
size

"Returns the number of elements contained in the RcIdentityBag.  First checks
 the RC value cache, and if not there, calculate it."

| sz |
sz := System rcValueCacheAt: #size for: self otherwise: nil.
sz == nil
    ifTrue: [ sz := self _calculateSize ].
^ sz
%

category: 'Sorting'
method: RcIdentityBag
sortAscending: aSortSpec

"Returns an Array containing the elements of the receiver, sorted in ascending
 order, as determined by the values of the instance variables represented by
 aSortSpec."

 | bag |
^ [ | result |
    " get the cached Bag "
    bag := self _asIdentityBag.
    " let the cached Bag take advantage of indexes if they exist "
    bag _indexedPaths: self _indexedPaths.
    " now do the sort "
    result := bag sortAscending: aSortSpec.
    " reset the cached Bag's index list "
    bag _indexedPaths: nil.
    result
  ] onException: Error do:[:ex |
    "ensure the cached Bag's index list is made nil"
    bag _indexedPaths: nil.
    ex outer
  ]
%

category: 'Sorting'
method: RcIdentityBag
sortDescending: aSortSpec

"Returns an Array containing the elements of the receiver, sorted in descending
 order, as determined by the values of the instance variables represented by
 aSortSpec."

 | bag |
^ [ | result |
    " get the cached Bag "
    bag := self _asIdentityBag.
    " let the cached Bag take advantage of indexes if they exist "
    bag _indexedPaths: self _indexedPaths.
    " now do the sort "
    result := bag sortDescending: aSortSpec.
    " reset the cached Bag's index list "
    bag _indexedPaths: nil.
    result
  ] onException: Error do:[:ex |
    "ensure the cached Bag's index list is made nil"
    bag _indexedPaths: nil.
    ex outer
  ]

%

category: 'Sorting'
method: RcIdentityBag
sortWith: aSortPairArray

"Returns an Array containing the elements of the receiver, sorted according to
 the contents of aSortPairArray."

 | bag |
^ [ | result |
    " get the cached Bag "
    bag := self _asIdentityBag.
    " let the cached Bag take advantage of indexes if they exist "
    bag _indexedPaths: self _indexedPaths.
    " now do the sort "
    result := bag sortWith: aSortPairArray.
    " reset the cached Bag's index list "
    bag _indexedPaths: nil.
    result
  ] onException: Error do:[:ex |
    "ensure the cached Bag's index list is made nil"
    bag _indexedPaths: nil.
    ex outer
  ]
%

category: 'Class Membership'
method: RcIdentityBag
species

"Returns the class to use to select and reject queries."

^ IdentityBag
%

category: 'Private'
method: RcIdentityBag
_asCollectionForSorting

"Returns an IdentityBag that can be used for sorting."

^ self _asIdentityBag
%

category: 'Converting'
method: RcIdentityBag
_asIdentityBag

"Returns a Bag that consists of objects in this RcIdentityBag.  First check the
 RC value cache and if not there, then create the Bag.  Note that each
 invocation of this message returns the same Bag."

| bag |
bag := System rcValueCacheAt: #asBag for: self otherwise: nil.
bag == nil
    ifTrue: [ bag := self _createAsBag ].
^ bag
%

category: 'Accessing'
method: RcIdentityBag
_at: offset

"Private."

^ self at: offset
%

category: 'Accessing'
method: RcIdentityBag
_basicSize

"Returns the logical size of the receiver."

^ self size
%

category: 'Accessing'
method: RcIdentityBag
_calculateSize

"Calculate the number of elements contained in the RcIdentityBag and place it in
 the RC value cache.  Returns the size."

| sz addBag removeBag |
sz := 0.
1 to: components size by: 2 do: [ :i |
    (addBag := components at: i) ~~ nil
        ifTrue: [
            removeBag := components at: i + 1.
            sz := sz + addBag size - removeBag size.
        ]
].
System rcValueCacheAt: #size put: sz for: self.
^ sz
%

category: 'Updating'
method: RcIdentityBag
_components: componentArray

""

components := componentArray
%

category: 'Converting'
method: RcIdentityBag
_createAsBag

"Creates a Bag that consists of objects that have been added minus the objects
 that have been removed, and place it in the RC value cache.  Returns the Bag."

| aBag |
aBag := self species new.
self _doSessionBags: [ :addBag :removeBag |
    removeBag isEmpty
        ifTrue: [
            aBag addAll: addBag
        ]
        ifFalse: [ aBag addAll: (addBag _primDifference: removeBag) ].
].
System rcValueCacheAt: #asBag put: aBag for: self.
^ aBag

%

category: 'Private'
method: RcIdentityBag
_createComponentBagsFor: addIndex

"Create the additionBag and removalBag for the session whose components begin
 at the given addIndex.  Returns the additionBag."

| addBag remBag securityPolicy |

addBag := IdentityBag new.
addBag objectSecurityPolicy: (securityPolicy := self objectSecurityPolicy ) .
components at: addIndex put: addBag.

remBag := IdentityBag new.
remBag objectSecurityPolicy: securityPolicy .
components at: addIndex + 1 put: remBag.

^ addBag
%

category: 'Private'
method: RcIdentityBag
_deferredGciUpdateWith: valueArray

"Private."

components == nil
  ifTrue: [ self initialize: 10 ].
1 to: valueArray size do:[:j |
  self add: (valueArray at: j)
  ].
%

category: 'Enumerating'
method: RcIdentityBag
_doSessionBags: aBlock

"Enumerate over all session components, executing aBlock with the current
 session's addition Bag and removal Bag as arguments."

| addBag |
1 to: components size by: 2 do: [ :i |
    (addBag := components at: i) ~~ nil
        ifTrue: [ aBlock value: addBag value: (components at: i + 1) ]
]
%

category: 'Private'
method: RcIdentityBag
_gbsTraversalCallback
  "Needed for initial mapping case. See bug 31058."
  ^'RcIdentityBag>>_gbsTraversalCallback: This string should be ignored on the client.'
%

category: 'Instance Initialization'
method: RcIdentityBag
_gciInitialize

"Private."

components == nil
  ifTrue: [ self initialize: 10 ].
^ true
%

category: 'Support'
method: RcIdentityBag
_getInactiveSessionIndexes

"Returns a set of integer indexes into the RcIdentityBag session components for
 sessions that are not active.  The current session nor the global session
 components are considered active."

| allSessions rcBagSize |
rcBagSize := components size.
allSessions := IdentitySet new.
3 to: rcBagSize by: 2 do: [ :i | allSessions add: i ].

" get the current sessions and calculate the index "
System currentSessions do: [ :id | | index |
    index := self _indexForSessionId: id.
    (index <= rcBagSize) ifTrue: [ allSessions remove: index ]
].

^ allSessions
%

category: 'Private'
method: RcIdentityBag
_globalAddBag

"Returns the global addition Bag for the receiver.  Create one if it does not
 exist."

| globalAddBag |
System _addRootObjectToRcReadSet: self.
globalAddBag := components _rcAt: 1.
globalAddBag == nil
    ifTrue: [ globalAddBag := self _createComponentBagsFor: 1 ].
^ globalAddBag
%

category: 'Private'
method: RcIdentityBag
_indexForSessionId: id

"Returns the index of the given session ID's addition Bag."

| index |
id _isSmallInteger ifFalse:[ id _validateClass: SmallInteger ].
id < 0 ifTrue: [ ^ self _errorIndexOutOfRange: id ].
index := (id + id) + 1.
index > components size
    ifTrue: [ components size: index + 1 ].
^ index
%

category: 'Testing'
method: RcIdentityBag
_isRcIdentityBag

"Returns true; the receiver is an RcIdentityBag."

^ true
%

category: 'Locking Support'
method: RcIdentityBag
_lockableValues

"Returns a kind of object usable as an argument to _lockAll: primitives."

^ self _asIdentityBag
%

category: 'Adding'
method: RcIdentityBag
_logAddAllOf: aCollection

"Creates a log entry for adding all of the given collection."

| logEntry |
logEntry := LogEntry new.
logEntry receiver: self;
    selector: #addAll:logging:;
    argArray: { aCollection . false }.
System redoLog addLogEntry: logEntry
%

category: 'Adding'
method: RcIdentityBag
_logAdditionOf: anObject

"Create a log entry for adding the given object."

| logEntry |
logEntry := LogEntry new.
logEntry receiver: self;
    selector: #add:logging:;
    argArray: { anObject . false }.
System redoLog addLogEntry: logEntry
%

category: 'Removing'
method: RcIdentityBag
_logRemovalOf: anObject inRemovalBag: aRemovalBag

"Creates a log entry for removing the given object.  The removal Bag is the
 object on which a conflict may occur.  Returns the receiver."

| logEntry |
logEntry := LogEntry new.
logEntry receiver: self;
    selector: #'_privateRemove:logging:';
    argArray: { anObject . false }.
System redoLog addLogEntry: logEntry forLargeConflictObject: aRemovalBag
%

category: 'Removing'
method: RcIdentityBag
_logRemoveAllOf: aCollection

"Creates a log entry for removing all of the given collection."

| logEntry |
logEntry := LogEntry new.
logEntry receiver: self;
    selector: #_removeAll:logging:;
    argArray: { aCollection . false }.
System redoLog addLogEntry: logEntry
%

category: 'Removing'
method: RcIdentityBag
_privateRemove: anObject fromRemovalBag: removalBag logging: aBoolean updateRcValueCache: updateRcValueCache

"Adds anObject to the given removal Bag, performing any logging and updating
 the caches if necessary."

 | bag sz idxRes |

  " update any indexes if necessary "
  (aBoolean and: [ _indexedPaths ~~ nil ])
      ifTrue: [
        "do not update indexes during during replay (aBoolean = false)"
        idxRes := self _updateIndexesForRemovalOf: anObject.
        idxRes == true ifFalse:
          [ ^self _raiseIndexingError: idxRes] ].

  " log the removal "
  aBoolean
      ifTrue: [ self _logRemovalOf: anObject inRemovalBag: removalBag ].

  " add it to the current session's removal Bag "
  removalBag add: anObject.

  updateRcValueCache ifFalse: [ ^ self ].

  " if the receiver's asBag has been cached, update the cache "
  bag := System rcValueCacheAt: #asBag for: self otherwise: nil.
  bag == nil
      ifFalse: [ bag remove: anObject ifAbsent: [ System clearRcValueCache ] ].

  sz := System rcValueCacheAt: #size for: self otherwise: nil.
  sz == nil
      ifFalse: [ System rcValueCacheAt: #size put: (sz - 1) for: self ].
%

category: 'Removing'
method: RcIdentityBag
_privateRemove: anObject logging: aBoolean

"Returns true if the object was removed; false if the object was not present."

^self _privateRemove: anObject logging: aBoolean updateRcValueCache: aBoolean
%

category: 'Removing'
method: RcIdentityBag
_privateRemove: anObject logging: aBoolean updateRcValueCache: updateRcValueCache

"Returns true if the object was removed; false if the object was not present."

| myAddBag myRemoveBag |
System _addRootObjectToRcReadSet: self.
myAddBag := components _rcAt: self _thisSessionAdditionIndex.
myRemoveBag := components _rcAt: self _thisSessionRemovalIndex.

" put components -> RcIdentityBag in conflictObjects dictionary so that
we can resolve conflict if there is W-W conflict "
System redoLog addConflictObject: components for: self.

" first see if the object is in the current session's addition Bag "
( myAddBag ~~ nil and:
[ (myAddBag _rcIncludes: anObject) and:
[ (myAddBag occurrencesOf: anObject) >
  (myRemoveBag _rcOccurrencesOf: anObject) ] ] )
    ifTrue: [
        self _privateRemove: anObject fromRemovalBag: myRemoveBag logging: aBoolean updateRcValueCache: updateRcValueCache.
        " now process any removals on the addition Bag "
        self _processRemovalBagFor: self _thisSessionAdditionIndex logging: aBoolean.
        ^ true
    ]
    ifFalse: [
        " check other sessions' addition Bags "
        self _doSessionBags: [ :addBag :removeBag |
            " if more have been added than removed ... "
            ((addBag _rcIncludes: anObject) and:
            [ (addBag occurrencesOf: anObject) >
              (removeBag _rcOccurrencesOf: anObject) ] )
                ifTrue: [
                    self _privateRemove: anObject fromRemovalBag: removeBag logging: aBoolean updateRcValueCache: updateRcValueCache.
                    ^ true ] ] ].
aBoolean
  ifFalse: [
    "retry failure"
    System
      rcValueCacheAt: #'Rc-Retry-Failure-Reason'
        put: #'objErrNotInColl'
        for: System;
      rcValueCacheAt: #'Rc-Retry-Failure-Description'
        put: 'The object [' , anObject asOop printString, '] has already been removed from the collection [', self asOop printString, ']'
        for: System ].
^ false
%

category: 'Removing'
method: RcIdentityBag
_processRemovalBagFor: sessionId logging: aBoolean

"Apply any removals that were performed on the removal Bag of the given
 session.  Returns the receiver."

| additionBag removalBag |
additionBag := components at: sessionId.
additionBag == nil
    ifTrue: [ ^ self ].

removalBag := components at: sessionId + 1.

removalBag isEmpty
    ifTrue: [
        System _addRootObjectToRcReadSet: removalBag.
        ^ self
    ].

System _addEntireObjectToRcReadSet: additionBag.
System _addEntireObjectToRcReadSet: removalBag.

" put removalBag -> RcIdentityBag in conflictObjects dictionary so that
we can resolve conflict if there is W-W conflict "
System redoLog addConflictObject: removalBag for: self.

additionBag _removeAll: removalBag errIfAbsent: false forReplay: false .
removalBag _removeAll: removalBag errIfAbsent: false forReplay: false .
%

category: 'Removing'
method: RcIdentityBag
_removeAll: aCollection logging: boolean

"Removes one occurrence of each element of aCollection from the receiver and
 returns the receiver.  Generates an error if any element of aCollection is not
 present in the receiver."

| array bag sz |
(array := { } ) addAll: aCollection .
1 to: array size do: [ :i |
  " this will not update rcValueCache since logging is false "
  (self _privateRemove: (array at: i) logging: boolean updateRcValueCache: false)
    ifFalse: [ ^ false ]
].

boolean
  ifFalse: [ ^ true ].

" put removeBags in the conflicts dictionary "
self _doSessionBags: [ :addBag :removeBag |
  System redoLog addConflictObject: removeBag for: self.
].

self _logRemoveAllOf: array.

" if the receiver's asBag has been cached, update the cache "
bag := System rcValueCacheAt: #asBag for: self otherwise: nil.
bag == nil
  ifFalse: [ bag removeAll: aCollection ].

sz := System rcValueCacheAt: #size for: self otherwise: nil.
sz == nil
  ifFalse: [
    System rcValueCacheAt: #size put: (sz - array size) for: self
  ].
^ true
%

category: 'Support'
method: RcIdentityBag
_removeAny: numberToRemove from: aBag

"Remove any numberToRemove elements from the given Bag.  Returns the elements
 that are removed."

| removed |
removed := IdentityBag new.
1 to: numberToRemove do: [ :i | removed add: (aBag _at: i) ].
1 to: removed size do: [ :i | aBag remove: (removed at: i) ].
^ removed
%

category: 'Private'
method: RcIdentityBag
_resolveRcConflictsWith: conflictObjects

"A logical write-write conflict has occurred on the receiver.  The objects that
 had the actual physical write-write conflicts are in the conflictObjects
 Array.  Returns whether the conflicts could be successfully resolved."

| myAddBag myRemoveBag addIndex |

" If no objects experienced physical conflict, then just returns "
conflictObjects isEmpty
    ifTrue: [ ^ true ].

" if only had a physical conflict on the root "
( conflictObjects size == 1 and: [ (conflictObjects at: 1) == self ] )
    ifTrue: [
        System _addRootObjectToRcReadSet: self.
        " keep reference to this session's components "
        addIndex := self _thisSessionAdditionIndex.
        myAddBag := components _rcAt: addIndex.
        myRemoveBag := components _rcAt: addIndex + 1.

        " only abort the root "
        self _selectiveAbort.

        " get index again to grow the root if necessary "
        addIndex := self _thisSessionAdditionIndex.
        " now re-insert the addition and removal Bags "
        components at: addIndex put: myAddBag.
        components at: addIndex + 1 put: myRemoveBag.

        ^ true
    ].

_indexedPaths
  ifNotNil: [
    _indexedPaths _anyIndexIsLegacy
      ifTrue: [
        "abort and replay not supported when legacy index is involved"
        System
          rcValueCacheAt: #'Rc-Retry-Failure-Reason'
            put: #'noReplayForLegacyIndex'
            for: System;
          rcValueCacheAt: #'Rc-Retry-Failure-Description'
            put: 'Rc replay not supported when legacy index is involved'
            for: System.
        ^false ] ].

" otherwise, selectively abort entire RcIdentityBag and replay the operations "
^ self _abortAndReplay: conflictObjects
%

category: 'Private'
method: RcIdentityBag
_selectiveAbort

"In addition to aborting the RcIdentityBag, selectively abort the session
 components.  Returns the receiver."

self _checkForRcIndexesBeforeRcSelectiveAbort.
self _primitiveSelectiveAbort.
components _selectiveAbort.
self _doSessionBags: [ :addBag :removeBag |
    addBag _selectiveAbort.
    removeBag _selectiveAbort
]
%

category: 'Private'
method: RcIdentityBag
_thisSessionAdditionIndex

"Returns the index of the current session addition Bag."

^ self _indexForSessionId: System session
%

category: 'Private'
method: RcIdentityBag
_thisSessionRemovalIndex

"Returns the index of the current session removal Bag."

^ self _thisSessionAdditionIndex + 1
%

category: 'Support'
method: RcIdentityBag
_unsafeCleanupBag

"Process the removalBags to clean up the receiver.
Unlike cleanupBag, this method handles the removalBags for all
sessions, not just inactive ones.
This method will cause concurrency conflicts and should only be used
while no sessions are adding to or removing from the RcIdentityBag"

System _addRootObjectToRcReadSet: self.
System _addEntireObjectToRcReadSet: components.
1 to: components size by: 2 do: [ :i |
    " apply any removals that have occurred for that session's elements "
    self _processRemovalBagFor: i logging: true.
    " perform an _rcAt: to place nodes in the RC read set "
    components _rcAt: i
]
%

category: 'Private'
method: RcIdentityBag
_validateRcConflictsWith: conflictObjects

"If the only conflict on this object is for the root, then we return true.
 Otherwise return false (to fail the transaction) if the redo log contains
 the selector _privateRemove:logging: since we cannot guarantee success
 if the transaction did a removal from the RcIdentityBag."

" if only had a physical conflict on the root "
( conflictObjects size == 1 and: [ (conflictObjects at: 1) == self ] )
  ifTrue: [ ^ true ].

^ self _checkLogEntriesForNoSelector: #_privateRemove:logging:
%

! Class extensions for 'RcIndexBucket'

!		Class methods for 'RcIndexBucket'

category: 'Constants'
classmethod: RcIndexBucket
entrySize

"Returns three, the size of an entry in the bucket (key, term, value)."

^ 3
%

category: 'Instance Creation'
classmethod: RcIndexBucket
new

"Returns a new instance of RcIndexBucket."
^ self new: 0
%

!		Instance methods for 'RcIndexBucket'

category: 'Updating'
method: RcIndexBucket
at: aKey put: aValue term: pathTerm root: indexDict logging: aBoolean

"Places the given key/value/pathTerm triplet in the receiver.  Returns whether
 the key/value pair already exists in the receiver."
| index valSet value offset offsetMinus1 offsetMinus2 |
index := self _binarySearchCoveringKey: aKey term: pathTerm.
offset := self valueOffsetFor: index.

" if it goes on the end ... "
index > numElements
  ifTrue: [
    " grow the receiver if necessary "
    self _basicSize < offset
      ifTrue: [
        self _basicSize: (offset + 30).
        " initialize the cache if necessary "
        numElements == 0
          ifTrue: [
            1 to: self _numCacheSlots do: [ :i |
              self _basicAt: i put: 0
            ]
          ]
      ].

    " hard coded for performance "
    self _basicAt: offset - 2 put: aKey.
    self _basicAt: offset - 1 put: pathTerm.
    self _basicAt: offset put: aValue.
    numElements := numElements + 1.
    ^ false
  ].

" if key is already in bucket "
offsetMinus1 := offset - 1 .
offsetMinus2 := offset - 2 .
( aKey == (self _rcAt: offsetMinus2 ) and:
[ pathTerm == (self _rcAt: offsetMinus1) ] )

  ifTrue: [
    value := self _rcAt: offset.
    " see if there are already multiple values "
    (self _isBucketValueBagAt: offset)
      ifTrue: [  | systm |
        " put the BucketValueBag in the reduced-conflict read set(RcReadSet)  "
        systm := System .
        systm _addToRcReadSet: value includingAllNodes: true.
        " put an entry in the conflict objects dictionary "
        systm redoLog addLargeConflictObject: value for: indexDict.
        value add: aValue
      ]
      ifFalse: [ " create value Bag "
        valSet := BucketValueBag basicNew.
        valSet objectSecurityPolicy: self objectSecurityPolicy .
        valSet add: value.
        valSet add: aValue.
        self _basicAt: offset put: valSet.

        System _addToRcReadSet: valSet includingAllNodes: true.
        " put an entry in the conflict objects dictionary "
        System redoLog addConflictObject: valSet for: indexDict.

        self insertedBucketValueBagAt: offset.
      ].
    ^ true
  ]
  ifFalse: [ " key not found "
    " move entries to the right (hard coded for performance) "
    self _largeInsertAt: offsetMinus2
      from: nil "insert nils" fromStart: 1 fromEnd: 3
      numToMoveDown: (numElements * 3) + self _numCacheSlots - offsetMinus2 + 1 .

    " hard coded for performance "
    self _basicAt: offsetMinus2 put: aKey.
    self _basicAt: offsetMinus1 put: pathTerm.
    self _basicAt: offset put: aValue.
    " only increment numElements if a key is being added. increment BEFORE insertedEntryAt: called"
    numElements := numElements + 1.
    self insertedEntryAt: offset.
    ^ false
  ]
%

category: 'Updating'
method: RcIndexBucket
at: anIndex putKey: aKey

"Stores the key aKey into the key part of the key/value/pathTerm triplet
 referenced by atIndex."

self _basicAt: (anIndex * "self entrySize" 3) - 2 put: aKey
%

category: 'Updating'
method: RcIndexBucket
at: anIndex putTerm: pathTerm

"Stores the pathTerm into the pathTerm part of the key/value/pathTerm triplet
 referenced by atIndex."

self _basicAt: (anIndex * "self entrySize" 3 - 1) put: pathTerm
%

category: 'Updating'
method: RcIndexBucket
at: anIndex putValue: aValue

"Stores the value aValue into the value part of the key/value/pathTerm triplet
 referenced by atIndex."

self _basicAt: (anIndex * "self entrySize" 3) put: aValue
%

category: 'Accessing'
method: RcIndexBucket
at: aKey term: pathTerm

"Returns the value that corresponds aKey/pathTerm by searching the elements in
 the bucket.  if no such key/value/pathTerm triplet exists, raise an error."

| index |
index := self searchForKey: aKey term: pathTerm.
index ~~ nil
    ifTrue: [ ^ self valueAt: index ]
    ifFalse: [ ^ self _errorKeyNotFound: aKey ]
%

category: 'Accessing'
method: RcIndexBucket
at: aKey term: pathTerm ifAbsent: aBlock

"Returns the value that corresponds to aKey/pathTerm by searching the elements
 in the bucket.  If no such key/value/pathTerm triplet exists, returns the
 result of evaluating the zero-argument block aBlock."

| index |
index := self searchForKey: aKey term: pathTerm.
index ~~ nil
    ifTrue: [ ^ self valueAt: index ]
    ifFalse: [
        aBlock _isExecBlock ifFalse:[ aBlock _validateClass: ExecBlock] .
        ^ aBlock value
    ]
%

category: 'Accessing'
method: RcIndexBucket
at: aKey term: pathTerm otherwise: aValue

"Returns the value that corresponds aKey/pathTerm by searching the elements in
 the bucket.  If no such key/value/pathTerm triplet exists, returns aValue."

<primitive: 180>
self _primitiveFailed: #at:term:otherwise:
     args: { aKey . pathTerm . aValue } .
self _uncontinuableError
%

category: 'Constants'
method: RcIndexBucket
entrySize

"Returns three, the size of an entry in the bucket (key, term, value)."

^ self class entrySize
%

category: 'Accessing'
method: RcIndexBucket
firstAt: aKey term: pathTerm otherwise: aValue

"Returns the value that corresponds aKey/pathTerm by searching the elements in
 the bucket.  If no such key/value/pathTerm triplet exists, returns aValue.
 If the value is a BucketValueBag, returns the first object in the Bag."

| val |
val := self at: aKey term: pathTerm otherwise: aValue.
(BucketValueBag _hasInstance: val)
  ifTrue: [ ^ val _at: 1 ]
  ifFalse: [ ^ val ]
%

category: 'Updating'
method: RcIndexBucket
insertedBucketValueBagAt: offset

"Does nothing."

%

category: 'Updating'
method: RcIndexBucket
insertedEntryAt: offset

"Does nothing."

%

category: 'Accessing'
method: RcIndexBucket
keyAt: index

"Returns the key at the specified index."

^ self _rcAt: ("self entrySize" 3 * index - 2)
%

category: 'Updating'
method: RcIndexBucket
removedBucketValueBagAt: offset

"Does nothing."

%

category: 'Updating'
method: RcIndexBucket
removedEntryAt: offset

"Does nothing."

%

category: 'Removing'
method: RcIndexBucket
removeKey: aKey
value: aValue
term: pathTerm
root: indexDict
logging: aBoolean
ifAbsent: aBlock

"Removes the key/value/pathTerm triplet with the given key and path term.
 Executes the zero-argument block if not found.  Returns whether there are any
 more values for the key/term."

| keyIndex valOrSet eSize delOffset offset |

keyIndex := self searchForKey: aKey term: pathTerm.

keyIndex == nil
  ifTrue: [ " key not found "
    aBlock value.
    ^ false
  ]
  ifFalse: [
    valOrSet := self valueAt: keyIndex.
    " do not put in rcReadSet here (to fix bug 10796)"

    offset := self valueOffsetFor: keyIndex.
    (self _isBucketValueBagAt: offset)
      ifTrue: [ " remove the value from the bucket value set "

        " put an entry in the conflict objects dictionary "
        System redoLog addLargeConflictObject: valOrSet for: indexDict.

        valOrSet remove: aValue ifAbsent: aBlock.
        "Now put the BucketValueBag into the rcReadSet, since it is a modified index object"
        System _addToRcReadSet: valOrSet includingAllNodes: true.

        " if only 1 left, move it to the receiver "
        valOrSet size == 1
          ifTrue: [
            " do not put in rcReadSet here"
            self at: keyIndex putValue: (valOrSet _at: 1).

            self removedBucketValueBagAt: offset.
          ].
        ^ true
      ]
      ifFalse: [ " key has a single value "
        (aValue == valOrSet)
          ifTrue: [
            eSize := "self entrySize"  3 .
            delOffset := keyIndex - 1 * eSize + self _numCacheSlots + 1 .
            self _deleteNoShrinkFrom: delOffset to: delOffset + eSize - 1 .
            self removedEntryAt: offset.
            "decrement numElements AFTER removedEntryAt: called"
            numElements := numElements - 1.
            ^ false
          ]
          ifFalse: [ " values do not match "
            aBlock value.
            ^ true
          ]
      ]
  ]
%

category: 'Updating'
method: RcIndexBucket
reset

"Resets all entries to nil and the number of elements to zero."

super size: self _numCacheSlots.
numElements := 0.
1 to: self _numCacheSlots do: [ :i |
  self _basicAt: i put: 0
].
System _addToRcReadSet: self includingAllNodes: false.
%

category: 'Searching'
method: RcIndexBucket
searchForKey: aKey term: pathTerm

"Returns the index that matches the given key/pathTerm.  If not found, returns
 nil."

<primitive: 175>
self _primitiveFailed: #searchForKey:term: args: { aKey . pathTerm } .
self _uncontinuableError
%

category: 'Accessing'
method: RcIndexBucket
tableSize

"Returns the number of key/value/pathTerm pairs my current size has the
 capacity for."

^ ((self _basicSize - self _numCacheSlots) // 3) max: 0
%

category: 'Accessing'
method: RcIndexBucket
termAt: index

"Returns the term at the specified index."

^ self _rcAt: ("self entrySize" 3 * index - 1)
%

category: 'Accessing'
method: RcIndexBucket
valueAt: index

"Returns the value at the specified index."

^ self _rcAt: ("self entrySize" 3 * index)
%

category: 'Accessing'
method: RcIndexBucket
valueOffsetFor: index

"Returns the value at the specified index."

^ "self entrySize" 3 * index
%

category: 'Searching'
method: RcIndexBucket
_binarySearchCoveringKey: aKey term: pathTerm

"Returns the index for the first entry in which aKey is found utilizing a
 binary search.  This is the first entry whose key >= aKey."

<primitive: 115>
self _primitiveFailed: #_binarySearchCoveringKey:term:
     args: { aKey . pathTerm } .
self _uncontinuableError
%

category: 'Testing'
method: RcIndexBucket
_isBucketValueBagAt: offset

"Returns whether the object at the given offset in the receiver is a
BucketValueBag."

^ BucketValueBag _hasInstance: (self _rcAt: offset)
%

category: 'Constants'
method: RcIndexBucket
_numCacheSlots

"Returns the number of initial slots reserved for cached values."

^ 0
%

category: 'Updating'
method: RcIndexBucket
_refreshBucketCacheReportingInto: aString

"Does nothing."

%

! Class extensions for 'RcIndexBucketWithCache'

!		Instance methods for 'RcIndexBucketWithCache'

category: 'Updating'
method: RcIndexBucketWithCache
at: anIndex putKey: aKey

"Stores the key aKey into the key part of the key/value/pathTerm triplet
 referenced by atIndex."

self
  _basicAt: (anIndex * "self entrySize" 3) + "self _numCacheSlots - 2" 21
  put: aKey
%

category: 'Updating'
method: RcIndexBucketWithCache
at: anIndex putTerm: pathTerm

"Stores the pathTerm into the pathTerm part of the key/value/pathTerm triplet
 referenced by atIndex."

self
  _basicAt: (anIndex * "self entrySize" 3) + "self _numCacheSlots - 1" 22
  put: pathTerm
%

category: 'Updating'
method: RcIndexBucketWithCache
at: anIndex putValue: aValue

"Stores the value aValue into the value part of the key/value/pathTerm triplet
 referenced by atIndex."

self _basicAt: (self valueOffsetFor: anIndex) put: aValue
%

category: 'Accessing'
method: RcIndexBucketWithCache
firstAt: aKey term: pathTerm otherwise: aValue

"Returns the value that corresponds aKey/pathTerm by searching the elements in
 the bucket.  If no such key/value/pathTerm triplet exists, returns aValue.
 If the value is a BucketValueBag, returns the first object in the Bag
 that is not identical to aKey."

| val index |
index := self searchForKey: aKey term: pathTerm.
index == nil
  ifTrue: [ ^ aValue ].

val := self valueAt: index.
(self _isBucketValueBagAt: (self valueOffsetFor: index))
  ifTrue: [
    1 to: val size do: [ :i |
      (val _at: i) ~~ aKey
        ifTrue: [ ^ val _at: i ]
    ].
    ^ aValue
  ]
  ifFalse: [ ^ val ]
%

category: 'Updating'
method: RcIndexBucketWithCache
insertedBucketValueBagAt: offset

"Updates the cache with the fact that a BucketValueBag was inserted at the given
 offset."

<primitive: 216>
self _primitiveFailed: #insertedBucketValueBagAt: args: { offset } .
self _uncontinuableError

%

category: 'Updating'
method: RcIndexBucketWithCache
insertedEntryAt: offset

"Updates the cache with the fact that an entry was inserted at the given
 offset."

self _shiftCacheAt: offset forAddition: true
%

category: 'Accessing'
method: RcIndexBucketWithCache
keyAt: index

"Returns the key at the specified index."

^ self _rcAt: ("self entrySize" 3 * index) + "self _numCacheSlots - 2" 21
%

category: 'Updating'
method: RcIndexBucketWithCache
removedBucketValueBagAt: offset

"Updates the cache with the fact that a BucketValueBag was removed at the given
 offset."

<primitive: 217>
self _primitiveFailed: #removedBucketValueBagAt: args: { offset } .
self _uncontinuableError
%

category: 'Updating'
method: RcIndexBucketWithCache
removedEntryAt: offset

"Updates the cache with the fact that an entry was removed at the given offset."

self _shiftCacheAt: offset forAddition: false
%

category: 'Accessing'
method: RcIndexBucketWithCache
termAt: index

"Returns the term at the specified index."

^ self _rcAt: ("self entrySize" 3 * index) + "self _numCacheSlots - 1" 22
%

category: 'Accessing'
method: RcIndexBucketWithCache
valueAt: index

"Returns the value at the specified index."

^ self _rcAt: ( "self entrySize" 3 * index + "self _numCacheSlots" 23 )
%

category: 'Accessing'
method: RcIndexBucketWithCache
valueOffsetFor: index

"Returns the value at the specified index."

^ "self entrySize" 3 * index + "self _numCacheSlots" 23
%

category: 'Testing'
method: RcIndexBucketWithCache
_isBucketValueBagAt: offset

"Returns whether the object at the given offset in the receiver is a
 BucketValueBag.  Use the cache to determine this without fetching the
 object at the offset."

<primitive: 187>
self _primitiveFailed: #_isBucketValueBagAt: args: { offset } .
self _uncontinuableError
%

category: 'Constants'
method: RcIndexBucketWithCache
_numCacheSlots

"Returns the number of initial slots reserved for cached values."

"NOTE: This constant is dependent upon corresponding with
 RCINDEXBUCKET_NUM_CACHE_SLOTS defined in index.ht."

^ 23
%

category: 'Updating'
method: RcIndexBucketWithCache
_refreshBucketCacheReportingInto: aString

"Verifies that the cache contains correct entries.  If the cache contains an
 incorrect entry, fix it.  Appends a description of any problems found onto the
 given string."

1 to: numElements do: [ :i | | val valOffset |
  val := self valueAt: i.
  valOffset := self valueOffsetFor: i.
  ( BucketValueBag _hasInstance: val )
    ifTrue: [
      ( self _isBucketValueBagAt: valOffset )
        ifFalse: [ " cache says no when it should say yes "
          self insertedBucketValueBagAt: valOffset.
          aString add: ' updated cache entry at: ';
            add: valOffset asString;
            add: ' to indicate a BucketValueBag';
            add: Character lf.
        ]
    ]
    ifFalse: [
      ( self _isBucketValueBagAt: valOffset )
        ifTrue: [ " cache says yes when it should say no "
          self removedBucketValueBagAt: valOffset.
          aString add: ' updated cache entry at: ';
            add: valOffset asString;
            add: ' to indicate no BucketValueBag';
            add: Character lf.
        ]
    ]
].
^ aString
%

category: 'Updating'
method: RcIndexBucketWithCache
_shiftCacheAt: offset forAddition: aBoolean

"Invokes the primitive that shifts cache bits appropriately."

<primitive: 218>

self _primitiveFailed: #_shiftCacheAt:forAddition:
     args: { offset . aBoolean } .
self _uncontinuableError
%

! Class extensions for 'RcIndexDictionary'

!		Class methods for 'RcIndexDictionary'

category: 'Constants'
classmethod: RcIndexDictionary
defaultBasicSize

"Returns the default basic size."

^ 2003
%

category: 'Constants'
classmethod: RcIndexDictionary
defaultWorkingSetInterval

"Returns the default working set interval."

^ 100
%

category: 'Instance Creation'
classmethod: RcIndexDictionary
new

"Returns a RcIndexDictionary with the default table size."

^ self new: self defaultBasicSize
%

!		Instance methods for 'RcIndexDictionary'

category: 'Updating'
method: RcIndexDictionary
at: aKey put: aValue term: pathTerm

"Stores the aKey/aValue/pathTerm triplet in the index dictionary.  Returns the
 value."

self _at: aKey put: aValue term: pathTerm logging: true.
^ aValue
%

category: 'Accessing'
method: RcIndexDictionary
at: aKey term: pathTerm

"Returns the value that corresponds to aKey/pathTerm.  If no such
 key/value/pathTerm triplet exists, raise an error."

^ (self indexBucketFor: aKey) at: aKey term: pathTerm
%

category: 'Accessing'
method: RcIndexDictionary
at: aKey term: pathTerm ifAbsent: aBlock

"Returns the value that corresponds to aKey/pathTerm.  If no such
 key/value/pathTerm triplet exists, returns the result of evaluating the
 zero-argument block aBlock."

^ (self indexBucketFor: aKey) at: aKey term: pathTerm ifAbsent: aBlock
%

category: 'Accessing'
method: RcIndexDictionary
at: aKey term: pathTerm otherwise: aValue

"Returns the value that corresponds to aKey/pathTerm.  If no such
 key/value/pathTerm triplet exists, returns aValue."

^ (self indexBucketFor: aKey) at: aKey term: pathTerm otherwise: aValue
%

category: 'Audit'
method: RcIndexDictionary
auditEntriesForNsc: nsc for: rootTerm on: aString
  "Verifies that the indexDictionary structure is consistent relative to
 the given pathTerm."

  self
    auditKeysTermsAndValuesOn: aString
    do: [ :key :pathTerm :value |
      (pathTerm indicatesMultiValue not and: [ pathTerm indicatesIndexOnNscElements ])
        ifTrue: [
          key == value
            ifFalse: [
              pathTerm
                auditInfo:
                  {key.
                  nil.
                  nil}
                on: aString.
              aString
                add: 'IndexDictionary [';
                add: self asOop asString;
                add: '] has entry for [';
                add: value asOop asString;
                add: '] of class ';
                add: value class asString;
                add: ' associated with incorrect key [';
                add: key asOop asString;
                add: '] should be ( ';
                add: value asOop asString;
                add: ') ';
                add: Character lf ].
          (nsc includesIdentical: value)
            ifFalse: [
              aString
                add: 'Index Dictionary [';
                add: self asOop asString;
                add: '] has an entry [';
                add: value asOop asString;
                add: '] of class ';
                add: value class asString;
                add: ' that is not in the base collection';
                add: Character lf ] ]
        ifFalse: [
          pathTerm indicatesMultiValue
            ifTrue: [
              | values |
              pathTerm indicatesNsc
                ifTrue: [ values := value ]
                ifFalse: [
                  values := IdentitySet new.
                  pathTerm nextObj: value do: [ :obj | values add: obj ] ].
              (values includesIdentical: key)
                ifFalse: [
                  pathTerm
                    auditInfo:
                      {key.
                      nil.
                      nil}
                    on: aString.
                  aString
                    add: 'Index Dictionary [';
                    add: self asOop asString;
                    add: '] has an entry [';
                    add: value asOop asString;
                    add: '] of class ';
                    add: value class asString;
                    add: ' that does not contain the key [';
                    add: key asOop asString;
                    add: '] of class ';
                    add: key class asString;
                    add: Character lf ] ]
            ifFalse: [
              | expectedValue |
              pathTerm isSelectorTerm
                ifTrue: [ expectedValue := value perform: pathTerm termSelector ]
                ifFalse: [
                  | ivOffset |
                  ivOffset := pathTerm _ivOffsetFor: value.
                  expectedValue := value instVarAt: ivOffset ].
              expectedValue == key
                ifFalse: [
                  pathTerm
                    auditInfo:
                      {key.
                      nil.
                      nil}
                    on: aString.
                  aString
                    add: 'IndexDictionary [';
                    add: self asOop asString;
                    add: '] has entry for [';
                    add: value asOop asString;
                    add: '] of class ';
                    add: value class asString;
                    add: ' associated with incorrect key [';
                    add: key asOop asString;
                    add: '] should be ( ';
                    add: expectedValue asOop asString;
                    add: ') ';
                    add: Character lf ] ].
          rootTerm == pathTerm
            ifTrue: [
              (nsc includesIdentical: value)
                ifFalse: [
                  aString
                    add: 'Index Dictionary [';
                    add: self asOop asString;
                    add: '] has an entry [';
                    add: value asOop asString;
                    add: '] of class ';
                    add: value class asString;
                    add: ' that is not in the base collection';
                    add: Character lf ] ] ] ]
%

category: 'Audit'
method: RcIndexDictionary
auditKeysTermsAndValuesOn: aString do: aBlock

"Private. "

self _doCollisionBuckets: [ :collisionBkt | | aKey aValue aTerm |
    1 to: collisionBkt tableSize do: [ :j |
        aKey := collisionBkt keyAt: j.
        nil == aKey
            ifFalse: [
                aValue := collisionBkt valueAt: j.
                aTerm := collisionBkt termAt: j.
                (BucketValueBag _hasInstance: aValue)
                  ifTrue: [
                    (collisionBkt _isBucketValueBagAt: (collisionBkt valueOffsetFor: j))
                      ifFalse: [
                        aString add: 'IndexDictionary [';
                                   add: self asOop asString;
                                   add: '] has a BucketValueBag in the collision bucket [';
                                   add: collisionBkt asOop asString;
                                   add: '] at value offset ( ';
                                   add: (collisionBkt valueOffsetFor: j) asString;
                                   add: ' ) but the cached value indicates no BucketValueBag.';
                                   add: Character lf.
                      ].
                    aValue do: [:v |
                       aBlock value: aKey value: aTerm value: v.
                     ].
                  ]
                  ifFalse: [
                    (collisionBkt _isBucketValueBagAt: (collisionBkt valueOffsetFor: j))
                      ifTrue: [
                        aString add: 'IndexDictionary [';
                                   add: self asOop asString;
                                   add: '] has no BucketValueBag in the collision bucket [';
                                   add: collisionBkt asOop asString;
                                   add: '] at value offset ( ';
                                   add: (collisionBkt valueOffsetFor: j) asString;
                                   add: ' ) but the cached value indicate that a BucketValueBag should be present.';
                                   add: Character lf.
                      ].
                    aBlock value: aKey value: aTerm value: aValue.
                  ].
            ]
    ]
].
%

category: 'Audit'
method: RcIndexDictionary
auditNsc: nsc for: pathTerm on: aString

"Verifies that the elements in 'nsc' are correctly represented in
 the receiver. "

| roots sz prevObj  |

roots := nsc _indexedPaths rootTerms.
sz := roots size.
prevObj := #_incompletePathTraversal.
nsc do: [ :obj | | rootTerm |
  obj ~~ prevObj
    ifTrue: [
      1 to: sz do: [ :j |
        rootTerm := roots at: j.
        rootTerm auditIndexDictionaryForObject:obj
          occurrences: (nsc occurrencesOf: obj)
          on: aString
      ]
    ].
  prevObj := obj.
].
%

category: 'Audit'
method: RcIndexDictionary
checkDebug: aString
  BtreePlusNodeAuditor checkDebug: aString
%

category: 'Clustering'
method: RcIndexDictionary
clusterDepthFirst

"This method clusters the receiver and its collision buckets.
 Has no effect and returns true if the receiver was previously clustered
 in the current transaction, otherwise returns false."

self cluster
  ifTrue: [ ^ true ].

1 to: self _basicSize do: [ :i | (self _at: i) cluster ].
^ false
%

category: 'Constants'
method: RcIndexDictionary
collisionLimitPerBucket

"Returns the number of entries in a collision bucket such that if a greater
 number is inserted, the hash dictionary will grow.  This number is chosen such
 that a collision bucket will occupy a single page
 (collisionLimitPerBucket * entrySize <= 2000)."

^ 660
%

category: 'Accessing'
method: RcIndexDictionary
entryHolders

"Returns the value of the instance variable 'entryHolders'."

^entryHolders
%

category: 'Updating'
method: RcIndexDictionary
entryHolders: newValue

"Modifies the value of the instance variable 'entryHolders'."

entryHolders := newValue
%

category: 'Accessing'
method: RcIndexDictionary
firstAt: aKey term: pathTerm otherwise: aValue

"Returns the value that corresponds to aKey/pathTerm.  If no such
 key/value/pathTerm triplet exists, returns aValue.  If the value
 is a BucketValueBag, returns the first object in the Bag."

^ (self indexBucketFor: aKey) firstAt: aKey term: pathTerm otherwise: aValue
%

category: 'Accessing'
method: RcIndexDictionary
getWorkingSetInterval: nsc

""

^ System
  rcValueCacheAt: #indexDictionaryWorkingSetInterval
  for: nsc
  otherwise: RcIndexDictionary defaultWorkingSetInterval.
%

category: 'Hashing'
method: RcIndexDictionary
hashFunction: aKey

"The hash function for aKey is calculated internally inside the method
 'indexBucketFor:'.  Raise a bogus error if this method is invoked."

self _error: #rtErrNilKey
%

category: 'Accessing'
method: RcIndexDictionary
indexBucketFor: aKey

"Returns the RC index bucket for the given key."

<primitive: 528>
self _primitiveFailed: #indexBucketFor: args: { aKey } .
self _uncontinuableError
%

category: 'Accessing'
method: RcIndexDictionary
indexManager

^IndexManager current
%

category: 'Initializing'
method: RcIndexDictionary
initialize: itsSize

"Initializes the receiver and sets its collisionLimitPerBucket."


super initialize: itsSize.
collisionLimitPerBucket := self collisionLimitPerBucket.
%

category: 'Initializing'
method: RcIndexDictionary
initializeWorkingSetInterval: indexObj

"Determines the working set interval (the number of collision buckets that are
 considered for writing during index creation).  If the instance variable
 'okToUpdate' is set to true, then index creation does not control the working
 set (and the working set interval is not used)."


" indicate whether it is not ok to update the dictionary
  (so look at working set instead) "
" only use this algorithm if NSC size is greater than 1MByte "
okToUpdate := indexObj nscRoot size < 1000000.

workingSetInterval := self getWorkingSetInterval: indexObj nscRoot.

okToUpdate
  ifFalse: [ | array |
    array := Array new: (self _basicSize // workingSetInterval).
    1 to: array size do: [ :i |
      array at: i put: (IndexDictionaryEntryHolder new indexDictionary: self)
    ].
    entryHolders := array.
  ]
%

category: 'Private'
method: RcIndexDictionary
logAt: aKey put: aValue term: pathTerm inCollisionBucket: aCollisionBkt

"Create a log entry for adding the given key, value, and pathTerm.  The
 collision bucket is the object on which a conflict may occur."

| logEntry |
logEntry := LogEntry new.
logEntry receiver: self;
    selector: #_at:put:term:logging:;
    argArray: { aKey . aValue . pathTerm . false }.
System redoLog addLogEntry: logEntry forConflictObject: aCollisionBkt
%

category: 'Private'
method: RcIndexDictionary
logRemoveKey: aKey value: aValue term: pathTerm
  inCollisionBucket: aCollisionBkt

"Creates a log entry for removing the given key/value/pathTerm triplet.  The
 collision bucket is the object on which a conflict may occur."

| logEntry |
logEntry := LogEntry new.
logEntry receiver: self;
    selector: #_removeKey:value:term:;
    argArray: { aKey . aValue . pathTerm }.
System redoLog addLogEntry: logEntry forConflictObject: aCollisionBkt
%

category: 'Accessing'
method: RcIndexDictionary
objectSecurityPolicy: anObjectSecurityPolicy

"Assign the receiver and its index buckets the given security policy."

super objectSecurityPolicy: anObjectSecurityPolicy.
self _doCollisionBuckets: [ :indexBucket |
    indexBucket objectSecurityPolicy: anObjectSecurityPolicy
]
%

category: 'Accessing'
method: RcIndexDictionary
okToUpdate

"Returns the value of the instance variable 'okToUpdate'."


^okToUpdate
%

category: 'Updating'
method: RcIndexDictionary
okToUpdate: newValue

"Modifies the value of the instance variable 'okToUpdate'."

okToUpdate := newValue
%

category: 'Deprecated'
method: RcIndexDictionary
rebuildTable

"OBSOLETE

 Increases the size of the root object and rehashes the contents of the
 collision buckets."

| newSize array collBkt origSize begin |
self deprecated: 'RcIndexDictionary>>rebuildTable should no longer be used.
See rebuildTable:for: for correct usage.'.

" Let's not be so aggressive on table growth "
origSize := self _basicSize.
newSize := origSize * 2 - 1.

array := Array new: origSize.
" store all buckets in an Array "
1 to: origSize do: [ :i |
  array at: i put: (self _at: i).
  self _at: i put: RcIndexBucketWithCache new.
].

super _basicSize: newSize.
origSize + 1 to: newSize do: [ :i |
  self _at: i put: RcIndexBucketWithCache new.
].

begin := (array _at: 1) _numCacheSlots + 1.

1 to: origSize do: [ :i |
  collBkt := array _at: i.
  begin to: begin + (collBkt numElements * 3) - 1 by: 3 do:
    [ :j |
    | jval |
    jval := (collBkt _at: j+2).
    (BucketValueBag _hasInstance: jval)
      ifTrue: [
        jval do:
          [:realValue |
          self _at: (collBkt _at: j)
            put: realValue
            term: (collBkt _at: j+1)
            logging: false
          ]
        ]
      ifFalse: [
        self _at: (collBkt _at: j)
          put: (collBkt _at: j+2)
          term: (collBkt _at: j+1)
          logging: false
        ]
     ].

  collBkt reset.
]
%

category: 'Hashing'
method: RcIndexDictionary
rebuildTable: expectedGrowth for: indexObj

"Increases the size of the root object and rehashes the contents of the
 collision buckets."

| newSize array collBkt origSize begin indexManager |
origSize := self _basicSize.

"Don't rebuild table if the size isn't any bigger"
(self shouldRebuildTable: expectedGrowth) not
  ifTrue: [ ^self ].
newSize := (self class _tableSizeFor: origSize * 2 - 1).

array := Array new: origSize.
" store all buckets in an Array "
indexManager := self indexManager.
1 to: origSize do: [ :i |
  array at: i put: (self _at: i).
  self _at: i put: RcIndexBucketWithCache new.
  (i \\ 100) == 0 ifTrue:[ indexManager commitIndexMaintenance: indexObj at: i ].
].

super _basicSize: newSize.
origSize + 1 to: newSize do: [ :i |
  self _at: i put: RcIndexBucketWithCache new.
  (i \\ 100) == 0 ifTrue:[ indexManager commitIndexMaintenance: indexObj at: i ].
].

begin := (array _at: 1) _numCacheSlots + 1.
1 to: origSize do: [ :i |
  collBkt := array _at: i.
  begin to: begin + (collBkt numElements * 3) - 1 by: 3 do:
    [ :j | | jval |
    jval := (collBkt _at: j+2).
    (BucketValueBag _hasInstance: jval)
      ifTrue: [
        jval do:
          [:realValue |
          self _at: (collBkt _at: j)
            put: realValue
            term: (collBkt _at: j+1)
            logging: false.
          (i \\ 100) == 0 ifTrue:[ indexManager commitIndexMaintenance: indexObj at: i ].
          ].
        ]
      ifFalse: [
        self _at: (collBkt _at: j)
          put: (collBkt _at: j+2)
          term: (collBkt _at: j+1)
          logging: false.
        (i \\ 100) == 0 ifTrue:[ indexManager commitIndexMaintenance: indexObj at: i ].
        ]
     ].

  collBkt reset.
].

%

category: 'Removing'
method: RcIndexDictionary
removeKey: anObject ifAbsent: aBlock

"Disallowed.  Use removeKey:value:ifAbsent: instead."

self shouldNotImplement: #removeKey:ifAbsent:
%

category: 'Removing'
method: RcIndexDictionary
removeKey: aKey value: aValue term: pathTerm logging: aBoolean

"Remove the key/value/pathTerm triplet from the receiver.  Returns true
 if there are any other entries with the same key/term in the dictionary,
 and returns false otherwise."

| collisionBkt more doLogging |
collisionBkt := self indexBucketFor: aKey.
doLogging := aBoolean.

more := collisionBkt
    removeKey: aKey
    value: aValue
    term: pathTerm
    root: self
    logging: doLogging
    ifAbsent: [
        " if entry not found, do not log the removal "
        doLogging := false.
    ].

doLogging
    ifTrue: [ " log the removal in the redo log "
        self logRemoveKey: aKey
            value: aValue
            term: pathTerm
            inCollisionBucket: collisionBkt
    ].

^ more
%

category: 'Removing'
method: RcIndexDictionary
removeKey: aKey
value: aValue
term: pathTerm
logging: aBoolean
ifAbsent: aBlock

"Remove the key/value/pathTerm triplet from the receiver.  If no
 key/value/pathTerm triplet is present, evaluate the zero-argument block
 aBlock.  Returns true if there are any other entries with the same key/term
 in the dictionary, and returns false otherwise."

| collisionBkt more doLogging |
collisionBkt := self indexBucketFor: aKey.

doLogging := aBoolean.
more := collisionBkt
    removeKey: aKey
    value: aValue
    term: pathTerm
    root: self
    logging: doLogging
    ifAbsent: [
        " if entry not found, do not log the removal "
        doLogging := false.
        aBlock value.
    ].

doLogging
    ifTrue: [ " log the removal in the redo log "
        self logRemoveKey: aKey
            value: aValue
            term: pathTerm
            inCollisionBucket: collisionBkt
    ].

^ more
%

category: 'Hashing'
method: RcIndexDictionary
shouldRebuildTable: expectedGrowth

  | collBkt targetBucketSize incrementalGrowth |

targetBucketSize := RcIndexDictionary defaultBasicSize * 2 // (RcIndexBucket entrySize * 3).
incrementalGrowth := expectedGrowth // (self _basicSize).
1 to: self _basicSize do: [ :i |
  collBkt := self _at: i.
  ((collBkt size + incrementalGrowth) > targetBucketSize)
    ifTrue: [ ^true ].
].

^false
%

category: 'Updating'
method: RcIndexDictionary
_at: aKey put: aValue term: pathTerm logging: aBoolean

"Stores the aKey/aValue/pathTerm triplet in the index dictionary.  Rebuilds the
 hash table if the addition caused the number of collisions to exceed the limit
 allowed.  The argument aBoolean determines if an entry is placed in the redo
 log for this operation."

| collBkt |

okToUpdate
  ifFalse: [ | hash |
    hash := (aKey identityHash \\ self _basicSize) + 1.
    " workingSetInterval is the number of collision buckets covered "
    hash < workingSetInterval
      ifFalse: [ | offset |
        " get Array of IndexDictionaryEntryHolders "
        offset := (hash \\ entryHolders size) + 1.
        (entryHolders at: offset)
          addKey: aKey
          value: aValue
          term: pathTerm
          from: entryHolders
          at: offset.
        ^ true
      ]
  ].

collBkt := self indexBucketFor: aKey.
collBkt at: aKey put: aValue term: pathTerm root: self logging: aBoolean.

aBoolean
  ifTrue: [
    self logAt: aKey put: aValue term: pathTerm inCollisionBucket: collBkt
  ].

^ true
%

category: 'Private'
method: RcIndexDictionary
_bucketClass

  ^RcIndexBucketWithCache
%

category: 'Error Handling'
method: RcIndexDictionary
_errorNoEntryForKey: aKey term: aTerm value: aValue

"An entry for the key/term/value was not present in the dictionary."

^ self
    _error: #rtErrIndexDictionaryEntryNotInDictionary
    args: { aKey . aTerm . aValue }
%

category: 'Updating'
method: RcIndexDictionary
_existsAt: aKey put: aValue term: pathTerm logging: aBoolean

"Stores the aKey/aValue/pathTerm triplet in the index dictionary.  Rebuilds the
 hash table if the addition caused the number of collisions to exceed the limit
 allowed.  The argument aBoolean determines if an entry is placed in the redo
 log for this operation.  Returns whether the key/pathTerm pair already exists
 in the dictionary."

| collisionBkt exists |
collisionBkt := self indexBucketFor: aKey.
exists := collisionBkt
  at: aKey
  put: aValue
  term: pathTerm
  root: self
  logging: aBoolean.

aBoolean
    ifTrue: [
        self logAt: aKey put: aValue term: pathTerm inCollisionBucket: collisionBkt
    ].

^ exists
%

category: 'Query Support'
method: RcIndexDictionary
_findAllValuesNotIdenticalTo: aValue atTerm: pathTerm into: aCollection

"Iterate over all index buckets, finding all entries with the given path term.
 If the value at the path term is not identical to the given value, place it in
 the set."

| collBkt val |
1 to: self _basicSize do: [ :i |
    collBkt := self _at: i.
    1 to: collBkt numElements do: [ :j |
        ( ( (collBkt termAt: j) == pathTerm ) and:
        [ (collBkt keyAt: j) ~~ aValue ] )
            ifTrue: [
                val := collBkt valueAt: j.
                (collBkt _isBucketValueBagAt: (collBkt valueOffsetFor: j))
                    ifTrue: [ aCollection addAll: val ]
                    ifFalse: [ aCollection add: val ]
            ]
    ]
].
^ aCollection
%

category: 'Query Support'
method: RcIndexDictionary
_findFirstKeyNotIdenticalTo: aKey atTerm: pathTerm

"Iterates over the index buckets, finding the first entry with the given path
 term.  If the key at the path term is not identical to the given key, returns
 it.  If all key are identical, returns nil."

| collBkt key |
1 to: self _basicSize do: [ :i |
    collBkt := self _at: i.
    1 to: collBkt numElements do: [ :j |
        ( ( (collBkt termAt: j) == pathTerm ) and:
        [ (key := collBkt keyAt: j) ~~ aKey ] )
            ifTrue: [ ^ key ]
    ]
].
^ #_incompletePathTraversal
%

category: 'Updating'
method: RcIndexDictionary
_refreshBucketCaches

"Verifies that the bucket caches are correct.  If there is an invalid cache
 entry, fixes it and reports any problems.  Returns a string."

| str result |
result := String new.
1 to: self _basicSize do: [ :i |
  str := String new.
  (self _at: i) _refreshBucketCacheReportingInto: str.
  str isEmpty
    ifFalse: [
      result add: 'For index bucket at '; add: i asString;
        addAll: str
    ]
].
^ result
%

category: 'Removing'
method: RcIndexDictionary
_removeKey: aKey value: aValue term: pathTerm

"Removes the key/value/pathTerm triplet from the receiver.  Returns true if the
 removal was successful, false if not."

| collisionBkt |
collisionBkt := self indexBucketFor: aKey.

collisionBkt
    removeKey: aKey
    value: aValue
    term: pathTerm
    root: self
    logging: false
    ifAbsent: [ ^ false ].

^ true
%

category: 'Statistics'
method: RcIndexDictionary
_statisticsInto: dict

"Puts statistical information into the given dictionary."

| pages bktCount count maxBkt maxBktSize collBkt numElemArr tableSizeArr
  phySize |
pages := IdentitySet new.
numElemArr := { } .
tableSizeArr := { } .
phySize := self physicalSize.

bktCount := 0.
count :=0.
maxBktSize := 0.

1 to: self _basicSize do: [ :i |
  collBkt := self _at: i.

  pages add: collBkt page.

  numElemArr add: collBkt numElements.
  tableSizeArr add: collBkt tableSize.

  collBkt size ~~ 0
    ifTrue: [
      bktCount := bktCount + 1.
      count := count + collBkt size.
      (collBkt size > maxBktSize)
        ifTrue: [
          maxBktSize := collBkt size.
          maxBkt := collBkt
        ]
    ].

  phySize := phySize + collBkt physicalSize.
].

(bktCount ~~ 0)
  ifTrue: [
    dict at: #AvgEntriesPerIndexBucket put: (count asFloat / bktCount)
  ]
  ifFalse: [ dict at: #AvgEntriesPerIndexBucket put: 0].

dict at: #LargestIndexBucketSize
  put: (maxBkt == nil ifTrue: [ 0 ] ifFalse: [ maxBkt numElements ]).
dict at: #IndexDictionaryRootSize put: self _basicSize.
dict at: #IndexDictionaryPages put: pages.
dict at: #IndexDictionarySpaceUtilization put: { numElemArr . tableSizeArr }.
dict at: #IndexDictionaryPhysicalSize put: phySize.
%

category: 'Private'
method: RcIndexDictionary
_validateRcConflictsWith: conflictObjects

"If the only conflict on this object is for the root, then we return true.
 Otherwise return false (to fail the transaction) if the redo log contains
 a removeKey: operation since we cannot guarantee success if the transaction
 did a removal from the RcIndexDictionary."

" if only had a physical conflict on the root "
( conflictObjects size = 1 and: [ (conflictObjects at: 1) == self ] )
  ifTrue: [ ^ true ].

(self _checkLogEntriesForNoSelector: #_at:put:term:logging: )
  ifFalse: [ ^ false ].

^ self _checkLogEntriesForNoSelector: #_removeKey:value:logging:
%

! Class extensions for 'RcKeyValueDictionary'

!		Class methods for 'RcKeyValueDictionary'

category: 'Storing and Loading'
classmethod: RcKeyValueDictionary
loadFrom: passiveObj

"Reads from passiveObj the passive form of an object with named instance
 variable format.  Converts the object to its active form by loading the
 information into a new instance of the receiver.  Returns the new instance."

| newDict size |
(passiveObj version >= 500) ifTrue:[
  size := passiveObj readSize.
  newDict := self new.
  newDict loadFrom: passiveObj size: size.
  ]
ifFalse:[
  self halt: 'no support for  activation of objects written by 4.1' ].
^ newDict
%

category: 'Instance Creation'
classmethod: RcKeyValueDictionary
new

"Returns a RcKeyValueDictionary with the default table size."

^ self new: 53
%

category: 'Instance Creation'
classmethod: RcKeyValueDictionary
new: tableSize

"Returns a RcKeyValueDictionary with the specified table size."

^ super _basicNew initialize: (self _tableSizeFor: tableSize)

%

!		Instance methods for 'RcKeyValueDictionary'

category: 'Comparing'
method: RcKeyValueDictionary
= aKeyValueDictionary

"Compares two RcKeyValueDictionaries for equality.  Returns true if all of
 the following conditions are true:

 1.  the receiver and aKeyValueDictionary are of the same class,
 2.  the two RcKeyValueDictionaries have the same number of elements
 3.  all of the keys in one dictionary return the same value in
     both dictionaries.

 Returns false otherwise."

| sentinel |
self == aKeyValueDictionary ifTrue:[ ^ true ].
( self class == aKeyValueDictionary class )
    ifFalse: [ ^ false ].

( self size == aKeyValueDictionary size )
    ifFalse: [ ^ false ].

sentinel := Object new .
self keysDo: [ :aKey |
    (self at: aKey)  == (aKeyValueDictionary at: aKey otherwise: sentinel)
        ifFalse: [ ^ false ]
].
^ true
%

category: 'Enumerating'
method: RcKeyValueDictionary
accompaniedBy: anObj keysAndValuesDo: aBlock

"Evaluates aBlock with each of the receiver's key/value pairs as the
 2nd and 3rd arguments.
 aBlock must be a 3 argument block, with arguments anObj, key value ."

self _doCollisionBuckets: [ :collisionBkt |
    1 to: collisionBkt tableSize do: [ :j | | aKey |
        aKey := collisionBkt keyAt: j.
        nil == aKey
            ifFalse: [ | aValue |
                aValue := collisionBkt valueAt: j.
                aBlock value: anObj value: aKey value: aValue.
            ]
    ]
].
%

category: 'Enumerating'
method: RcKeyValueDictionary
associationsDo: aBlock

"Iteratively evaluates the one argument block, aBlock, using an Association
 created by using each key-value pair successively.  Returns the receiver."

self keysAndValuesDo: [:aKey :aValue |
   aBlock value: (Association newWithKey: aKey value: aValue)
].
%

category: 'Accessing'
method: RcKeyValueDictionary
at: aKey ifAbsent: aBlock

"Returns the value that corresponds to aKey.  If no such key/value pair exists,
 returns the result of evaluating the zero-argument block aBlock."

| hash |
aKey ifNil:[ ^ aBlock value ].
hash := self hashFunction: aKey.
^ (self _at: hash) at: aKey ifAbsent: aBlock
%

category: 'Accessing'
method: RcKeyValueDictionary
at: aKey otherwise: aValue

"Returns the value that corresponds to aKey.  If no such key/value pair exists,
 returns the given alternate value."

| hash |
aKey ifNil: [ ^ aValue ].
hash := self hashFunction: aKey.
^ (self _at: hash) at: aKey otherwise: aValue
%

category: 'Updating'
method: RcKeyValueDictionary
at: aKey put: aValue

"Adds the key-value pair to the receiver. If the receiver already contains
 a key-value pair with the given key, this method makes aValue the value of that
 Association or key-value pair.  Returns aValue."

self _at: aKey put: aValue oldValue: nil logging: true.
^ aValue
%

category: 'Private'
method: RcKeyValueDictionary
atHash: hashIndex put: aCollisionBucket

"Updates the hash table by storing aKey at the specified hashIndex.  This
 method is intended to be used internally.  If it is invoked directly by an
 application, concurrency conflicts may result (as well as destroying the
 consistency of the dictionary)."
| sz |
(hashIndex <= 0 or:[ hashIndex > (sz := self _basicSize)])
  ifTrue: [ hashIndex _error: #rtErrArgOutOfRange args:{ 1 . sz }  .
            self _uncontinuableError
          ].
self basicAt: hashIndex put: aCollisionBucket
%

category: 'Storing and Loading'
method: RcKeyValueDictionary
basicWriteTo: passiveObj

"Converts the receiver to its passive form and writes that information on
 passiveObj."

| s cls c |
  cls := self class.
  passiveObj writeClass: cls.

  passiveObj writeSize: (s := self size) .

  passiveObj writeNamedIvsFrom: self class: cls .
  passiveObj endNamedInstVars.

  c := 0.
  self keysAndValuesDo:[ :aKey :aValue |
    passiveObj writeObject: aKey; writeObject: aValue .
    c := c + 1.
    c > 49 ifTrue: [
      passiveObj lf.
      c := 0.
      ].
    ].

  passiveObj cr
%

category: 'Clustering'
method: RcKeyValueDictionary
clusterDepthFirst

"This method clusters the receiver and its named instance variables and the
 key/value pairs in depth-first order.  Returns true if the receiver has
 already been clustered during the current transaction; returns false
 otherwise."

System _addEntireObjectToRcReadSet: self.
self cluster
  ifTrue: [ ^ true ]
  ifFalse: [
    " cluster collision buckets "
    1 to: self _basicSize do: [ :i | (self basicAt: i) cluster ].

    " cluster instance variables "
    1 to: self namedSize do: [ :i | (self instVarAt: i) clusterDepthFirst ].

    " cluster keys and values "
    self keysAndValuesDo: [ :key :value |
      key clusterDepthFirst.
      value clusterDepthFirst
    ].
    ^ false
  ].
%

category: 'Copying'
method: RcKeyValueDictionary
copy

^ super copy
%

category: 'Enumerating'
method: RcKeyValueDictionary
do: aBlock

"Iteratively evaluates the one argument block aBlock, using the value
 of each Association as the argument of the block."

self keysAndValuesDo: [ :key :value | aBlock value: value ].
%

category: 'Comparing'
method: RcKeyValueDictionary
hash

"Since RcKeyValueDictionary | = is based on identity of elements, hash is based
 on identityHash of elements.  Returns the numerical hash value."

| hashValue |
hashValue := 97633.
self keysDo: [ :aKey |
    hashValue := hashValue bitXor: aKey hash
].
^ hashValue
%

category: 'Hashing'
method: RcKeyValueDictionary
hashFunction: aKey

"The hash function should perform some operation on the value of the key
 aKey which returns a value in the range 1..self _basicSize."

^ (aKey hash \\ self _basicSize) + 1
%

category: 'Initializing'
method: RcKeyValueDictionary
initialize: itsSize

"Initializes the instance variables of the receiver to be an empty
 RcKeyValueDictionary of the specified size.  This is intended to be used
 internally at the time of instance creation.  If used on an existing,
 populated RcKeyValueDictionary, concurrency conflicts may result."

"Returns the receiver."

| sz theSize bucket systm |
theSize := itsSize .
(theSize <= 0)
    ifTrue: [ theSize _error: #rtErrArgNotPositive  .
              theSize := 1
    ].
collisionLimitPerBucket := theSize // 4.
self _basicSize: theSize.
1 to: theSize do: [ :i |
    bucket := self _bucketClass new.
    bucket objectSecurityPolicy: self objectSecurityPolicy .
    bucket keyValueDictionary: self.
    self basicAt: i put: bucket.
].

systm := System .
sz := systm rcValueCacheAt: #size for: self otherwise: nil.
sz ~~ nil
    ifTrue: [ systm rcValueCacheAt: #size put: 0 for: self ]
%

category: 'Accessing'
method: RcKeyValueDictionary
keyAtValue: anObject ifAbsent: aBlock

"Returns the key of the first value equal to the given object, anObject.
 If no match is found, evaluates and returns the result of the block aBlock."

self keysAndValuesDo: [ :aKey :aValue |
  (anObject = aValue) ifTrue: [ ^ aKey ].
  ].
^ aBlock value.
%

category: 'Accessing'
method: RcKeyValueDictionary
keys

"Returns an IdentitySet containing the receiver's keys."

| keys |
keys := IdentitySet new.
self keysDo: [ :aKey | keys add: aKey ].
^ keys
%

category: 'Enumerating'
method: RcKeyValueDictionary
keysAndValuesDo: aBlock

"Iteratively evaluates the two argument block, aBlock, using each key and value
 of the receiver as the argument to the block. Returns the receiver."

self _doCollisionBuckets: [ :collisionBkt |
    1 to: collisionBkt tableSize do: [ :j | | aKey |
        aKey := collisionBkt keyAt: j.
        nil == aKey
            ifFalse: [ | aValue |
                aValue := collisionBkt valueAt: j.
                aBlock value: aKey value: aValue.
            ]
    ]
].

%

category: 'Enumerating'
method: RcKeyValueDictionary
keysDo: aBlock

"Iteratively evaluates the two argument block aBlock, using each key and
 value of the receiver as the argument to the block."

self _doCollisionBuckets: [ :collisionBkt | collisionBkt keysDo: aBlock ]
%

category: 'Storing and Loading'
method: RcKeyValueDictionary
loadVaryingFrom: passiveObj size: varyingSize

"Reads the varying part of the receiver from the given passive object.
 Does not record the receiver as having been read.  Does not read the
 receiver's named instance variables, if any."

| oldBkt newBkt |

passiveObj version >= 500 ifTrue:[
  1 to: varyingSize do: [:i |
    self at: passiveObj readObject"aKey" put: passiveObj readObject"aValue"
    ].
  ]
ifFalse:[
  1 to: varyingSize do: [:i |
    oldBkt := passiveObj readObject .
    (oldBkt isKindOf: RcCollisionBucket)
       ifTrue:[ newBkt:= oldBkt ]
       ifFalse:[
         (oldBkt isKindOf: ObsoleteRcCollisionBucket) ifFalse:[
            self _halt:'invalid kind of RcCollisionBucket'.
            ].
         newBkt := self _bucketClass new .
         newBkt keyValueDictionary: self .
         oldBkt keysAndValuesDo:[:aKey :aValue | newBkt at: aKey put: aValue ] .
         oldBkt _removeAll .
         ].
    self _basicAt: i put: newBkt
    ].
  ].
%

category: 'Accessing'
method: RcKeyValueDictionary
numElements

"Same as size."

^ self size
%

category: 'Copying'
method: RcKeyValueDictionary
postCopy

"Cleanup new copy."

super postCopy.
1 to: self _basicSize do: [ :index |
    self atHash: index put: (self basicAt: index) copy
].
%

category: 'Hashing'
method: RcKeyValueDictionary
rebuildTable: newSize

"Rebuilds the hash table by saving the current state, initializing and changing
 the size of the table, and adding the key value pairs saved back to the hash
 dictionary.  This method is intended to be used internally.  If it is invoked
 directly by an application, concurrency conflicts may result."

self _rebuildTable: newSize logging: true
%

category: 'Hashing'
method: RcKeyValueDictionary
rehash
	"Re-establish any hash invariants of the receiver."

	self rebuildTable: self tableSize
%

category: 'Removing'
method: RcKeyValueDictionary
removeKey: aKey ifAbsent: aBlock

"Removes the key/value pair with key aKey from the receiver and returns the
 value.  If no key/value pair is present with key aKey, evaluates the
 zero-argument block aBlock and returns the result of that evaluation."

| hash collisionBkt aValue sz systm |
hash := self hashFunction: aKey.
collisionBkt := self _rcAt: hash.

aValue := collisionBkt removeKey: aKey ifAbsent: [ ^ aBlock value ].

" log the removal in the redo log "
self _logRemoveKey: aKey inCollisionBucket: collisionBkt.

systm := System .
(sz := systm rcValueCacheAt: #size for: self otherwise: nil) == nil
    ifTrue: [ ^ aValue ].
systm rcValueCacheAt: #size put: (sz - 1) for: self.

^ aValue
%

category: 'Accessing'
method: RcKeyValueDictionary
size

"Returns the number of key/value pairs in the receiver."

| sz |
sz := System rcValueCacheAt: #size for: self otherwise: nil.
sz == nil
    ifTrue: [ sz := self _calculateSize ].
^ sz
%

category: 'Class Membership'
method: RcKeyValueDictionary
species

"Returns a class, an instance of which should be used as the result of
 select: or other projections applied to the receiver."

^ KeyValueDictionary
%

category: 'Statistics'
method: RcKeyValueDictionary
statistics

"Returns a Dictionary containing statistics that can be useful in determining
 the performance of a key-value dictionary, including the following information:

 * TotalCollisionBuckets: The number of collision buckets required to
                          implement the key-value dictionary.

 * AvgPairsPerBucket:     The average number of key/value pairs in each bucket.

 * LargestBucket:         The bucket having the most key/value pairs.  This
                          bucket contains the most keys for which the hash
                          function did not provide a good distribution over the
                          range of values in the table.

 Since RcKeyValueDictionaries are implemented differently than
 KeyValueDictionaries, the statistics are calculated as if the implementation
 were the same as KeyValueDictionaries.  To be specific, RcKeyValueDictionaries
 are implemented with all collision buckets.  Therefore, the calculations don't
 count CollisionBuckets with a size of 1 as a collision."

| bktCount pairCount maxBkt maxBktSize result |
bktCount := 0.
pairCount :=0.
maxBktSize := 0.
self _doCollisionBuckets: [ :collisionBkt |
    " if bucket size = 1, this would not be a collision in an ordinary key-value dictionary "
    collisionBkt size > 1
        ifTrue: [
            bktCount := bktCount + 1.
            pairCount := pairCount + collisionBkt size - 1.
            (collisionBkt size > maxBktSize)
                ifTrue: [
                    maxBktSize := collisionBkt size.
                    maxBkt := collisionBkt
                ]
        ]
].

result := SymbolDictionary new.
result at: #TotalCollisionBuckets put: bktCount.
(bktCount ~~ 0)
    ifTrue: [ result at: #AvgPairsPerBucket put: (pairCount / bktCount) asFloat ]
    ifFalse: [ result at: #AvgPairsPerBucket put: 0].
result at: #LargestBucket put: maxBkt.
^ result
%

category: 'Private'
method: RcKeyValueDictionary
tableSize

"Returns the size of hash table used for storing the entries."

^ self _basicSize
%

category: 'Initializing'
method: RcKeyValueDictionary
tableSize: aSize

"Sets the size of the receiver to a new value.  Each collision bucket is reset
 to contain no elements.  This method is intended to be used internally.  If it
 is invoked directly by an application, concurrency conflicts may result."

| origSize collBkt securPolicy  |
(aSize <= 0) ifTrue: [
  aSize _error: #rtErrArgNotPositive  .
  ^ self
].

origSize := self _basicSize.
securPolicy  := self objectSecurityPolicy .
" reset each collision bucket to be empty "
1 to: origSize do: [ :i | (self basicAt: i) reset ].

super _basicSize: aSize.

aSize > origSize
    ifTrue: [ " growing the RcKeyValueDictionary "
         (origSize + 1) to: aSize do: [ :i |
            collBkt := self _bucketClass new.
            collBkt objectSecurityPolicy: securPolicy .
            collBkt keyValueDictionary: self.
            self basicAt: i put: collBkt.
        ].
    ].

collisionLimitPerBucket := aSize // 4.
%

category: 'Accessing'
method: RcKeyValueDictionary
values

"Returns an OrderedCollection containing the receiver's values."

| values |
values := OrderedCollection new.
self valuesDo: [ :aValue | values add: aValue ].
^ values
%

category: 'Enumerating'
method: RcKeyValueDictionary
valuesDo: aBlock

"Iteratively evaluates the one argument block aBlock, using the value
 of each Association as the argument of the block."

self do: aBlock
%

category: 'Updating'
method: RcKeyValueDictionary
_at: aKey put: aValue oldValue: prevValue logging: aBoolean

"Stores the aKey/aValue pair in the key-value dictionary.  Rebuilds the hash
 table if the addition caused the number of collisions to exceed the limit
 allowed.  The argument aBoolean determines if an entry is placed in the redo
 log for this operation."

| hash collisionBkt num oldValue |
aKey ifNil: [ ^ self _error: #rtErrNilKey ].
hash := self hashFunction: aKey.
collisionBkt := self _rcAt: hash.
num := collisionBkt numElements.
oldValue := collisionBkt at: aKey put: aValue.
aBoolean ifTrue: [
  oldValue == aValue ifTrue:[ ^ true ]. "did not write, no need to log"
  self _logAt: aKey put: aValue oldValue: oldValue inCollisionBucket: collisionBkt.

  num < collisionBkt numElements ifTrue: [ | systm sz |
     systm := System .
     (sz := systm rcValueCacheAt: #size for: self otherwise: nil) ~~ nil ifTrue: [
        systm rcValueCacheAt: #size put: (sz + 1) for: self
     ]

  ].
  "if not logging, then doing replay. Don't rebuildTable during replay, since there is a
    redoLog logEntry for rebuildTable"
  (collisionBkt size > collisionLimitPerBucket) ifTrue: [
      self rebuildTable: (self class _tableSizeFor: self _basicSize * 2)
  ].
] ifFalse: [ "replaying ops from redoLog"
   oldValue ~~ prevValue ifTrue: [ ^ self _keyCollisionOk ]. "collision on same key, not RC"
].
^ true
%

category: 'Private'
method: RcKeyValueDictionary
_bucketClass
  "Subclasses may override this."

  ^RcCollisionBucket
%

category: 'Accessing'
method: RcKeyValueDictionary
_calculateSize

"Calculates the number of key/value pairs in the receiver and places it in the
 RC value cache.  Returns the total."

| num collisionBkt |
num := 0.
1 to: self _basicSize do: [ :i |
    collisionBkt := self basicAt: i.
    num := num + collisionBkt size
].
System rcValueCacheAt: #size put: num for: self.
^ num
%

category: 'Updating'
method: RcKeyValueDictionary
_collisionLimitPerBucket: aLimit

"Sets the collisionLimitPerBucket for the receiver."

collisionLimitPerBucket := aLimit
%

category: 'Private'
method: RcKeyValueDictionary
_deferredGciUpdateWith: valueArray

"Private."

1 to: valueArray size by: 2 do:[:j |
  self at: (valueArray at: j) put: (valueArray at: j + 1)
  ].
%

category: 'Enumerating'
method: RcKeyValueDictionary
_doCollisionBuckets: aBlock

"Evaluates aBlock with each of the receiver's collision buckets as the
 argument.  The argument aBlock must be a one-argument block."

| collisionBkt |
1 to: self _basicSize do: [ :tableIndex |
    collisionBkt := self basicAt: tableIndex.
    aBlock value: collisionBkt
]
%

category: 'Private'
method: RcKeyValueDictionary
_gciInitialize

"Private."

| cache |

self _basicSize == 0
  ifTrue: [ self initialize: 53 ].
1 to: self _basicSize do: [ :i | (self basicAt: i) reset ].

" remove receiver from rc value cache "
( (cache := System _rcValueCache) ~~ nil and:
[ (cache at: self otherwise: nil) ~~ nil ] )
  ifTrue: [ cache removeKey: self ].
^ true
%

category: 'Testing'
method: RcKeyValueDictionary
_isLarge

"Returns true if the object is implemented as a tree of private smaller objects"

^ true
%

category: 'Updating'
method: RcKeyValueDictionary
_keyCollisionOk
  ^ false
%

category: 'Locking Support'
method: RcKeyValueDictionary
_lockableValues

"Returns an Array of the receiver's keys and values."

| result |
result := { }  .
self keysAndValuesDo: [:aKey :aValue |
  result add: aKey .
  result add: aValue .
] .
^ result
%

category: 'Private'
method: RcKeyValueDictionary
_logAt: aKey put: aValue oldValue: oldValue inCollisionBucket: aCollisionBkt

"Create a log entry for adding the given key and value.  The collision bucket
 is the object on which a conflict may occur."

| logEntry |
logEntry := LogEntry new.
logEntry receiver: self;
    selector: #_at:put:oldValue:logging: ;
    argArray: { aKey . aValue . oldValue . false }.

System redoLog addLogEntry: logEntry forConflictObject: aCollisionBkt
%

category: 'Private'
method: RcKeyValueDictionary
_logRemoveKey: aKey inCollisionBucket: aCollisionBkt

"Create a log entry for removing the given key.  The collision bucket is the
 object on which a conflict may occur."

| logEntry |
logEntry := LogEntry new.
logEntry receiver: self;
    selector: #_removeKey:logging:;
    argArray: { aKey . false }.
System redoLog addLogEntry: logEntry forConflictObject: aCollisionBkt
%

category: 'Private'
method: RcKeyValueDictionary
_nodesObjectSecurityPolicy: anObjectSecurityPolicy

"Assigns any collision buckets to the given anObjectSecurityPolicy."

self _doCollisionBuckets: [ :cb | cb objectSecurityPolicy: anObjectSecurityPolicy ]
%

category: 'Hashing'
method: RcKeyValueDictionary
_rebuildTable: newSize logging: aBoolean

"Rebuilds the hash table by saving the current state, initializing and changing
 the size of the table, and adding the key value pairs saved back to the hash
 dictionary.  This method is intended to be used internally.  If it is invoked
 directly by an application, concurrency conflicts may result."

| origSize saveArray thisKey collBkt securPolicy redoLog |
(newSize <= 0) ifTrue: [
  newSize _error: #rtErrArgNotPositive  .
  ^ self
].

origSize := self _basicSize.
securPolicy := self objectSecurityPolicy  .

saveArray := Array new: origSize.

" save all old buckets in an Array and create new ones."
1 to: origSize do: [ :i | | oldBkt |
  oldBkt := self _at: i .
  saveArray at: i put: oldBkt .

  collBkt := self _bucketClass new.
  collBkt objectSecurityPolicy: securPolicy .
  collBkt keyValueDictionary: self.
  self _at: i put: collBkt.
].

super _basicSize: newSize.

newSize > origSize
  ifTrue: [ " growing the RcKeyValueDictionary "
    origSize + 1 to: newSize do: [ :i |
      collBkt := self _bucketClass new.
      collBkt objectSecurityPolicy: securPolicy .
      collBkt keyValueDictionary: self.
      self _at: i put: collBkt.
    ]
  ].

collisionLimitPerBucket := newSize // 4.

redoLog := System redoLog.
1 to: origSize do: [ :i |
  collBkt := saveArray _at: i.
  aBoolean ifTrue: [ redoLog addConflictObject: collBkt for: self ].
  1 to: collBkt _basicSize by: 2 do: [ :j |
    thisKey := collBkt _at: j. "make sure collBkt is in rc read set"
      nil == thisKey
        ifFalse: [ self _at: thisKey put: (collBkt _at: j+1) oldValue: nil logging: false ].
    ].
  collBkt _removeAll .  "dereference parent from old bucket"
  ].

aBoolean
	ifTrue: [ | logEntry |
		logEntry := LogEntry new.
		logEntry receiver: self;
    			selector: #_rebuildTable:logging: ;
    			argArray: { newSize . false }.
		redoLog addLogEntry: logEntry forConflictObject: self.
	].

^true
%

category: 'Removing'
method: RcKeyValueDictionary
_removeKey: aKey logging: aBoolean

"If a key/value pair with key aKey is present, the key/value pair is removed
 from the receiver and this method returns true.  If it is not present, return
 false. The argument aBoolean determines if an entry is placed in the redo
 log for this operation."

| hash collisionBkt aValue |
hash := self hashFunction: aKey.
collisionBkt := self _rcAt: hash.

aValue := collisionBkt removeKey: aKey ifAbsent: [ ^ false ].

aBoolean ifTrue: [ | sz systm |
   " log the removal in the redo log "
   self _logRemoveKey: aKey inCollisionBucket: collisionBkt.

   systm := System .
   (sz := systm rcValueCacheAt: #size for: self otherwise: nil) == nil ifTrue: [
      ^ aValue
   ].
   systm rcValueCacheAt: #size put: (sz - 1) for: self.
].

^ true
%

category: 'Private'
method: RcKeyValueDictionary
_resolveRcConflictsWith: conflictObjects

"A logical write-write conflict has occurred on the receiver.  The objects that
 had the actual physical write-write conflicts are in the conflictObjects
 Array.  Selectively abort the receiver and then attempt to replay the
 operations maintained in the System redo log.  Returns true if all the
 operations could be replayed; otherwise returns false."

| redoLog logEntries |

redoLog := System _redoLog.

" if no log entries to replay, then we're done "
redoLog == nil ifTrue: [ ^ false ].
logEntries := redoLog getLogEntriesFor: self .
logEntries == nil ifTrue:[ ^ false ].

" cannot perform selective abort if receiver has a dependency tag "
self _hasDependencyList ifTrue: [ ^ false ].

" fix 33731, explicitly buckets that have conflicts in case
 a rebuild has happened and the old bucket is no longer referenced from
 the parent.  This abort prevents committing changes to the old bucket
 after a previous transaction dereferenced it from the dictionary.
"
1 to: conflictObjects size do:[ :j |
  (conflictObjects at: j) _selectiveAbort
].

"abort all of the nodes involved in the transaction"
redoLog conflictObjects keysAndValuesDo:[ :conflictObject :redoObject |
  redoObject == self ifTrue: [ conflictObject _selectiveAbort ].
].

" refresh the state of the receiver "
self _selectiveAbort.

" replay all operations on the receiver"
1 to: logEntries size do:[:j | | logEnt |
  logEnt := logEntries at: j .
  logEnt redo ifFalse:[
    ^ false  "redo failed, cannot commit"
  ].
].
^ true
%

category: 'Private'
method: RcKeyValueDictionary
_validateRcConflictsWith: conflictObjects

"If the only conflict on this object is for the root, then we return true.
 Otherwise return false (to fail the transaction) if the redo log contains
 a removeKey: operation since we cannot guarantee success if the transaction
 did a removal from the RcKeyValueDictionary."

" if only had a physical conflict on the root "
( conflictObjects size = 1 and: [ (conflictObjects at: 1) == self ] )
  ifTrue: [ ^ true ].

(self _checkLogEntriesForNoSelector: #_at:put:oldValue:logging: )
  ifFalse: [ ^ false ].

^ self _checkLogEntriesForNoSelector: #_removeKey:logging:
%

! Class extensions for 'RcQueue'

!		Class methods for 'RcQueue'

category: 'Instance Creation'
classmethod: RcQueue
new

"Returns a new RcQueue."

^ (super new: 20) _initialize
%

category: 'Instance Creation'
classmethod: RcQueue
new: initialNumberOfUsers

"Returns a new RcQueue with a size that supports initialNumberOfUsers.  The
 new RcQueue will handle more users, but will have subcomponents created
 for initialNumberOfUsers."

| newOne |
newOne := (super new: initialNumberOfUsers) _initialize.
^ newOne initialize
%

!		Instance methods for 'RcQueue'

category: 'Comparing'
method: RcQueue
= anRcQueue

"Returns true if all of the following conditions are true:

 1.  The receiver and anRcQueue are of the same class.
 2.  The two collections are of the same size.
 3.  The corresponding elements of the receiver and anRcQueue are equal."

| selfSorted otherSorted |

self == anRcQueue
  ifTrue: [ ^ true ].

self class == anRcQueue class
  ifFalse: [ ^ false ].

self size == anRcQueue size
  ifFalse: [ ^ false ].

self size == 0 ifTrue:
    [^true].

selfSorted := self _timeSortedComponents.
otherSorted := anRcQueue _timeSortedComponents.

1 to: selfSorted size do:
    [ :i |
     (selfSorted at: i) value = (otherSorted at: i) value
         ifFalse: [^false]].
^true
%

category: 'Adding'
method: RcQueue
add: aValue

"Adds aValue to the RcQueue, returns the receiver."

| sessIdx queueElement sessionComponent sessCompSize firstValid lastSeqNumber systm |
systm := System .
sessIdx := systm session + 1.
sessionComponent := self _getSessionComponentFor: sessIdx .
sessCompSize := sessionComponent size.
(sessCompSize > 0)
  ifTrue: [
    queueElement := sessionComponent at: sessCompSize.
    lastSeqNumber := queueElement sequenceNumber.
    systm _addToRcReadSet: queueElement includingAllNodes: false.
  ]
  ifFalse: [lastSeqNumber := removalSeqNumbers at: sessIdx ].

queueElement := sessionComponent class speciesOfElements
                newWithValue: aValue sequenceNumber: lastSeqNumber + 1 inObjectSecurityPolicyOf: self .
systm _addToRcReadSet: sessionComponent includingAllNodes: true.
sessionComponent at: (sessionComponent size + 1) put: queueElement.

"clean up entries that have been removed"
firstValid := self _findFirstValidQueueElementForSession: sessIdx .
(firstValid > 1) ifTrue: [
   sessionComponent removeFrom: 1 to: firstValid - 1 .
   ].

(systm rcValueCacheAt: #size for: self otherwise: nil) ifNotNil:[ :rcz |
   systm rcValueCacheAt: #size put: (rcz + 1) for: self
].
^aValue
%

category: 'Updating'
method: RcQueue
at: offset put: value
  value _validateClass: RcQueueSessionComponent.
  ^ super at: offset put: value
%

category: 'Updating'
method: RcQueue
changeMaxSessionId: newMaxSessionId

"Changes the maximum number of sessions for which the RcQueue is configured.
 Modifying the capacity of an RcQueue in this way may cause concurrency conflicts
 with the consumer session, if one is active."

| oldSize firstValid|

oldSize := self maxSessionId.
(oldSize == newMaxSessionId) ifTrue:[ ^self ].

(newMaxSessionId > oldSize)
  ifTrue: [
    | seg |
    seg := self objectSecurityPolicy .
    removalSeqNumbers size: newMaxSessionId.
    super size: newMaxSessionId.
    oldSize + 1 to: newMaxSessionId do: [:i | | newOne |
      removalSeqNumbers at: i put: 0.
      "Bug 42719 - finish initializing the queue"
      newOne := RcQueueSessionComponent new.
      newOne objectSecurityPolicy: seg.
      self at: i put: newOne.
      ]
    ]
  ifFalse: [
    newMaxSessionId + 1 to: oldSize do: [:i |
      firstValid := self _findFirstValidQueueElementForSession: i.
      firstValid ~~ nil
        ifTrue: [
          (firstValid <= (self at: i) size) ifTrue:
             [ ^ self _errorRcQueueEntriesFound].
          ]
        ].
    super size: newMaxSessionId
    ].
^self
%

category: 'Performance Enhancement'
method: RcQueue
cleanupMySession

"Cleans up the entries for my session that have already been removed by
 the consumer.  This method is only needed if a producer adds entries to
 the queue faster than the consumer removes them and then no longer adds
 to the queue.  In this situation, the producer can enhance the performance
 of the consumer by either logging out or periodically executing this
 method and committing."

| sessIdx sessionComponent firstValid systm |
systm := System.
sessIdx := systm session + 1.
( sessIdx > self maxSessionId or:[ (sessionComponent := self at: sessIdx) == nil ] )
  ifTrue:[ ^ self ].

systm _addToRcReadSet: sessionComponent includingAllNodes: true.
"clean up entries that have been removed"
firstValid := self _findFirstValidQueueElementForSession: sessIdx .
(firstValid > 1) ifTrue: [
   sessionComponent removeFrom: 1 to: firstValid - 1 .
   ].
^self
%

category: 'Updating'
method: RcQueue
cleanupQueue

"Removes obsolete entries belonging to inactive sessions.  Can cause
 concurrency conflicts with the consumer."

| maxSessionId invalidSessions firstValid
  sessionComponent systm |

maxSessionId := self maxSessionId.
invalidSessions := Array new: maxSessionId.
systm := System.
1 to: maxSessionId do: [:i | invalidSessions at: i put: true].
systm currentSessions do: [:each |
  (each < maxSessionId) ifTrue: [
     invalidSessions at: each + 1 put: false]
  ].

1 to: maxSessionId do: [:i | | componentSz |
  (invalidSessions at: i) ifTrue: [
    sessionComponent := self at: i.
    (componentSz := sessionComponent size) ~~ 0 ifTrue:[
      firstValid := self _findFirstValidQueueElementForSession: i.
      removalSeqNumbers at: i put: 0.
      (firstValid <= componentSz) ifTrue: [
        (firstValid > 1) ifTrue:[
          sessionComponent removeFrom: 1 to: firstValid - 1
        ].
      ] ifFalse: [ sessionComponent size: 0 ]
    ].
  ].
].
^self
%

category: 'Clustering'
method: RcQueue
clusterDepthFirst

"Performs no action, as clustering defeats the conflict-reduction scheme."

^true
%

category: 'Enumerating'
method: RcQueue
do: aBlock

"Evaluates aBlock with each of the current elements of the RcQueue as the
 argument.  The argument aBlock must be a one-argument block.  This method does
 not traverse the queue elements in order."

| sessionComponent firstValid |

1 to: self maxSessionId do: [:i |
  sessionComponent := self at: i.
  sessionComponent ~~ nil
    ifTrue: [
      firstValid := self _findFirstValidQueueElementForSession: i.
      firstValid to: sessionComponent size do: [:j |
        aBlock value: (sessionComponent at: j) value].
      ]
    ]
%

category: 'Initialization'
method: RcQueue
initialize

"Create subcomponents for all available session IDs.  This can avoid
 initial concurrency conflict when many sessions add an object to the
 RcQueue for the first time."

1 to: super _basicSize do: [ :i |
    self _getSessionComponentFor: i
]
%

category: 'Testing'
method: RcQueue
isEmpty

"Returns true if the queue is empty, and false otherwise."
^self size == 0
%

category: 'Accessing'
method: RcQueue
maxSessionId

"Returns the max sessionId that can be used with this RcQueue."
^ super size
%

category: 'Accessing'
method: RcQueue
numberInvalid

"Returns the number of entries in the RcQueue which have been removed but
 not yet reclaimed in the session components for sessions that are not active.
 The intent is to determine if it is worth invoking cleanup."

| sz invalidSessions count firstValid |

sz := super size.
invalidSessions := Array new: sz.
1 to: sz do: [:i | invalidSessions at: i put: true].
System currentSessions do: [:each |
  (each < sz) ifTrue: [
     invalidSessions at: each + 1 put: false]
  ].

count := 0.
1 to: sz do: [:i |
  (invalidSessions at: i) ifTrue: [
    firstValid := self _findFirstValidQueueElementForSession: i.
    firstValid ~~ nil
      ifTrue: [ count := count + (firstValid - 1) ]
    ]
  ].
^count
%

category: 'Updating'
method: RcQueue
objectSecurityPolicy: anObjectSecurityPolicy

"Assigns the receiver and subcomponents to the given ObjectSecurityPolicy."

super objectSecurityPolicy: anObjectSecurityPolicy .
removalSeqNumbers objectSecurityPolicy: anObjectSecurityPolicy .
1 to: self maxSessionId do: [:i | | sessionComponent |
  (sessionComponent := self at: i) ifNotNil:[
      sessionComponent objectSecurityPolicy: anObjectSecurityPolicy .
      1 to: sessionComponent size do: [ :j |
        (sessionComponent at: j) objectSecurityPolicy: anObjectSecurityPolicy
      ]
    ]
].
%

category: 'Removing'
method: RcQueue
peek

"Returns the leading element from the receiver without removing it.
 If the receiver is empty, returns nil."

| minElement minSession firstValid sessionComponent anElement |


minSession := 0.
minElement := nil.
1 to: self maxSessionId do: [:i |
  sessionComponent := self at: i.
  sessionComponent ~~ nil
    ifTrue: [
      firstValid := self _findFirstValidQueueElementForSession: i.
      (firstValid <= sessionComponent size) ifTrue: [
        anElement := sessionComponent at: firstValid.
        (anElement isOlderThan: minElement) ifTrue: [
         minElement := anElement.
         minSession := i.
         ].
        ]
    ]
  ].
(minSession > 0)
   ifTrue: [
     ^ minElement value.
   ]
   ifFalse: [^nil]
%

category: 'Copying'
method: RcQueue
postCopy

"Cleanup new copy."

super postCopy.
self removalSeqNumbers: removalSeqNumbers copy.
1 to: self _basicSize do: [:index |
	self _at: index put: (self _at: index) copy.
].
%

category: 'Accessing'
method: RcQueue
removalSeqNumbers

"Return the value of the instance variable 'removalSeqNumbers'."
^removalSeqNumbers
%

category: 'Updating'
method: RcQueue
removalSeqNumbers: newValue

"Modify the value of the instance variable 'removalSeqNumbers'."
removalSeqNumbers := newValue
%

category: 'Removing'
method: RcQueue
remove

"Removes the leading element from the receiver and returns that element.
 If the receiver is empty, returns nil."

| minElement minSession firstValid sessionComponent anElement |

" log the fact that a removal occurred (used in _resolveRcConflicts:) "
self _logRemoval.

minSession := 0.
minElement := nil.
1 to: self maxSessionId do: [:i |
  sessionComponent := self at: i.
  sessionComponent ifNotNil:[ | sz |
    sz := sessionComponent size .
    sz ~~ 0 ifTrue:[
      firstValid := self _findFirstValidQueueElementForSession: i.
      (firstValid <= sz ) ifTrue: [
        anElement := sessionComponent at: firstValid.
        (anElement isOlderThan: minElement) ifTrue: [
	   minElement := anElement.
	   minSession := i.
	].
      ]
    ]
  ]
].
( minSession ~~ 0 and: [ minElement ~~ nil ] )
   ifTrue: [ | systm val |
     removalSeqNumbers at: minSession put: (minElement sequenceNumber).
     val := minElement value.
     minElement value: nil.
     systm := System .
     (systm rcValueCacheAt: #size for: self otherwise: nil) ifNotNil:[:rsz |
        systm rcValueCacheAt: #size put: (rsz - 1) for: self
     ].
     ^ val
   ]
   ifFalse: [^nil]
%

category: 'Removing'
method: RcQueue
remove: oldObject ifAbsent: anExceptionBlock
  ^ self shouldNotImplement: #remove:ifAbsent: 
%

category: 'Removing'
method: RcQueue
removeAll

"Removes all entries from the RcQueue, and returns an Array that contains those
 entries, in order.  It is more efficient to use removeAll than to send the
 message remove repeatedly."

| resultArray validSessions firstValidInSession sz
 minElement minSession firstValid sessionComponent anElement |

" log the fact that a removal occurred (used in _resolveRcConflicts:) "
self _logRemoval.

sz := self size.
resultArray := Array new: sz.
sz == 0
  ifTrue: [ ^ resultArray ].

validSessions := { } .
firstValidInSession := { } .
1 to: self maxSessionId do: [:i |
  sessionComponent := self at: i.
  sessionComponent ~~ nil
    ifTrue: [
      firstValid := self _findFirstValidQueueElementForSession: i.
      (firstValid <= sessionComponent size) ifTrue: [
         validSessions add: sessionComponent.
         firstValidInSession add: firstValid.
         removalSeqNumbers at: i put:
            ((sessionComponent at: (sessionComponent size)) sequenceNumber)
         ]
    ]
  ].
1 to: resultArray size do: [:j |
  minSession := 0.
  minElement := nil.
  1 to: validSessions size do: [:i |
    sessionComponent := validSessions at: i.
    firstValid := firstValidInSession at: i.
    (firstValid <= sessionComponent size) ifTrue: [
      anElement := sessionComponent at: firstValid.
    (anElement isOlderThan: minElement) ifTrue: [
           minElement := anElement.
           minSession := i.
         ].
      ]
    ].
  minElement ~~ nil
    ifTrue: [
      resultArray at: j put: minElement value.
      minElement value: nil.
      firstValidInSession at: minSession put:
                      ((firstValidInSession at: minSession) + 1).
    ]
  ].

(System rcValueCacheAt: #size for: self otherwise: nil) ifNotNil:[:rcz|
    System rcValueCacheAt: #size put: 0 for: self ].

^resultArray
%

category: 'Removing'
method: RcQueue
removeAllAsPairsInto: anArray

"Removes all entries from the RcQueue, and returns anArray which contains
 entries in pairs.  The odd numbered entries are the objects removed from the queue,
 in order.  The even numbered entries are the session IDs of the sessions that added
 the preceeding entry."

| validSessions firstValidInSession sz minElement minSessionIdx minSession
  firstValid sessionComponent anElement validSessionIds systm |

sz := self size.
anArray size: (sz * 2).
sz == 0 ifTrue: [ ^ anArray ].

" log the fact that a removal occurred (used in _resolveRcConflicts:) "
self _logRemoval.

validSessions := { } .
validSessionIds := { } .
firstValidInSession := { } .
1 to: self maxSessionId do: [:i |
  sessionComponent := self at: i.
  sessionComponent ~~ nil
    ifTrue: [
      firstValid := self _findFirstValidQueueElementForSession: i.
      (firstValid <= sessionComponent size) ifTrue: [
         validSessions add: sessionComponent.
         firstValidInSession add: firstValid.
         validSessionIds add: i.
         removalSeqNumbers at: i put:
            ((sessionComponent at: (sessionComponent size)) sequenceNumber)
         ]
    ]
  ].
1 to: anArray size by: 2 do: [:j |
  minSessionIdx := 0.
  minElement := nil.
  1 to: validSessions size do: [:i |
    sessionComponent := validSessions at: i.
    firstValid := firstValidInSession at: i.
    (firstValid <= sessionComponent size) ifTrue: [
      anElement := sessionComponent at: firstValid.
    (anElement isOlderThan: minElement) ifTrue: [
           minElement := anElement.
           minSessionIdx := i.
           minSession := validSessionIds at: i.
         ].
      ]
    ].
  minElement ~~ nil
    ifTrue: [
      anArray at: j put: minElement value.
      anArray at: (j + 1) put: (minSession - 1).
      minElement value: nil.
      firstValidInSession at: minSessionIdx put:
                      ((firstValidInSession at: minSessionIdx) + 1).
    ]
  ].

systm := System .
(systm rcValueCacheAt: #size for: self otherwise: nil) ifNotNil:[
    systm rcValueCacheAt: #size put: 0 for: self
].
^anArray
%

category: 'Removing'
method: RcQueue
removeCount: maxToRemove

"Removes entries from the RcQueue, and returns an Array that contains the
 minimum of maxToRemove or the queue size entries, in order.
 It is more efficient to remove multiple entries than to send the
 message remove repeatedly."

| resultArray validSessions validSessionIds firstValidInSession
  minElement minSession firstValid sessionComponent anElement |

" log the fact that a removal occurred (used in _resolveRcConflicts:) "
self _logRemoval.

resultArray := Array new: ((self size) min: (maxToRemove max: 0)).
validSessions := { } .
validSessionIds := { } .
firstValidInSession := { } .

1 to: self maxSessionId do: [:i |
  sessionComponent := self at: i.
  sessionComponent ~~ nil
    ifTrue: [
      firstValid := self _findFirstValidQueueElementForSession: i.
      (firstValid <= sessionComponent size) ifTrue: [
         validSessions add: sessionComponent.
         validSessionIds add: i.
         firstValidInSession add: firstValid.
         ]
    ]
  ].
1 to: resultArray size do: [:j |
  minSession := 0.
  minElement := nil.
  1 to: validSessions size do: [:i |
    sessionComponent := validSessions at: i.
    firstValid := firstValidInSession at: i.
    (firstValid <= sessionComponent size) ifTrue: [
      anElement := sessionComponent at: firstValid.
      (anElement isOlderThan: minElement) ifTrue: [
         minElement := anElement.
         minSession := i.
         ].
      ]
    ].
  minElement ~~ nil
    ifTrue: [
      resultArray at: j put: minElement value.
      minElement value: nil.
      removalSeqNumbers at: (validSessionIds at: minSession)
                        put: (minElement sequenceNumber).
      firstValidInSession at: minSession
                        put: ((firstValidInSession at: minSession) + 1).
    ]
  ].

(System rcValueCacheAt: #size for: self otherwise: nil) ifNotNil:[:rcz|
  System rcValueCacheAt: #size put: (rcz - resultArray size) for: self
].

^resultArray
%

category: 'Removing'
method: RcQueue
removeCountAsPairs: maxToRemove intoArray: anArray

"Removes entries from the RcQueue, and returns an Array that contains 2 elements
 per entry removed:  the object removed and the session ID of the session that
 added the element."


| validSessions validSessionIds firstValidInSession numRemoved
  minElement minSessionIdx firstValid sessionComponent anElement systm |

" log the fact that a removal occurred (used in _resolveRcConflicts:) "
self _logRemoval.

anArray size: (2 * ((self size) min: (maxToRemove max: 0))).
validSessions := { } .
validSessionIds := { } .
firstValidInSession := { } .
numRemoved := 0.

1 to: self maxSessionId do: [:i |
  sessionComponent := self at: i.
  sessionComponent ~~ nil
    ifTrue: [
      firstValid := self _findFirstValidQueueElementForSession: i.
      (firstValid <= sessionComponent size) ifTrue: [
         validSessions add: sessionComponent.
         validSessionIds add: i.
         firstValidInSession add: firstValid.
         ]
    ]
  ].
1 to: anArray size by: 2 do: [:j |
  minSessionIdx := 0.
  minElement := nil.
  1 to: validSessions size do: [:i |
    sessionComponent := validSessions at: i.
    firstValid := firstValidInSession at: i.
    (firstValid <= sessionComponent size) ifTrue: [
      anElement := sessionComponent at: firstValid.
      (anElement isOlderThan: minElement) ifTrue: [
         minElement := anElement.
         minSessionIdx := i.
         ].
      ]
    ].
  minElement ~~ nil
    ifTrue: [
      | minSessionId |
      minSessionId := validSessionIds at: minSessionIdx.
      anArray at: j put: minElement value.
      anArray at: (j + 1) put: minSessionId - 1.
      numRemoved := numRemoved + 1.
      minElement value: nil.
      removalSeqNumbers at: minSessionId
                        put: (minElement sequenceNumber).
      firstValidInSession at: minSessionIdx
                        put: ((firstValidInSession at: minSessionIdx) + 1).
    ]
  ].
systm := System .
(systm rcValueCacheAt: #size for: self otherwise: nil) ifNotNil:[:rcz|
  systm rcValueCacheAt: #size put: (rcz - numRemoved) for: self
].

^anArray
%

category: 'Removing'
method: RcQueue
removeIdentical: oldObject ifAbsent: anExceptionBlock
  ^ self shouldNotImplement: #removeIdentical:ifAbsent: 
%

category: 'Removing'
method: RcQueue
removeIntoArray

"Removes the leading element from the receiver and stores the element in
 a new Array at index 1.  A SmallInteger representing the session ID of the
 session that added the element to the queue is also stored in the new Array
 at index 2.

 If the receiver is empty, returns nil."

^ self removeIntoArray: { nil . nil }
%

category: 'Removing'
method: RcQueue
removeIntoArray: anArray

"Removes the leading element from the receiver and stores the element in
 anArray at index 1.  A SmallInteger representing the session ID of the
 session that added the element to the queue is also stored in anArray
 at index 2.

 If the receiver is empty, returns nil."

| minElement minSession firstValid sessionComponent anElement val |

" log the fact that a removal occurred (used in _resolveRcConflicts:) "
self _logRemoval.

minSession := 0.
minElement := nil.
1 to: self maxSessionId do: [:i |
  sessionComponent := self at: i.
  sessionComponent ~~ nil
    ifTrue: [
      firstValid := self _findFirstValidQueueElementForSession: i.
      (firstValid <= sessionComponent size) ifTrue: [
        anElement := sessionComponent at: firstValid.
       (anElement isOlderThan: minElement)
          ifTrue: [
             minElement := anElement.
             minSession := i.
           ].
        ]
    ]
  ].
( minSession > 0 and: [ minElement ~~ nil ] )
   ifTrue: [ | systm |
     removalSeqNumbers at: minSession put: (minElement sequenceNumber).
     val := minElement value.
     minElement value: nil.
     anArray at: 1 put: val.
     anArray at: 2 put: (minSession - 1).
     systm := System .
     (systm rcValueCacheAt: #size for: self otherwise: nil) ifNotNil:[:rcz|
         systm rcValueCacheAt: #size put: (rcz - 1) for: self ].

     ^anArray .
   ]
   ifFalse: [^nil]
%

category: 'Removing'
method: RcQueue
removeObject: anObject addedBySessionId: sessionId

"Removes the given object from the receiver assuming it is the oldest
 object added by the given session Id.  Returns the object or nil if
 the object was not found or the receiver is empty."

| firstValid sessionComponent anElement val sessIdx systm |

 " adjust sessionId, check range"
 sessIdx := sessionId + 1.
 ( (sessIdx < 1 ) or: [ sessIdx > self _basicSize ] )
   ifTrue: [ ^ nil ].

 " fetch sessionComponent "
 sessionComponent := self at: sessIdx .
 ( sessionComponent == nil )
   ifTrue:[ ^ nil ].

 " find appropriate element, and from that
   the value, with appropriate range checks "
 firstValid := self _findFirstValidQueueElementForSession: sessIdx .
 ( firstValid > sessionComponent size )
   ifTrue: [ ^ nil ].
 anElement := sessionComponent at: firstValid.
 ( anElement == nil )
   ifTrue:[ ^ nil ].
 val := anElement value.
 ( val == anObject )
   ifFalse: [ ^ nil ].

" log the fact that a removal occurred (used in _resolveRcConflicts:) "
 self _logRemoval.

 " handle details of removing element from rcqueue "
 removalSeqNumbers at: sessIdx put: anElement sequenceNumber.
 anElement value: nil.
 systm := System .
 (systm rcValueCacheAt: #size for: self otherwise: nil) ifNotNil:[:rcz|
   systm rcValueCacheAt: #size put: (rcz - 1) for: self
 ].
 ^ val
%

category: 'Accessing'
method: RcQueue
size

"Returns the number of valid entries in the RcQueue."

| sz |
sz := System rcValueCacheAt: #size for: self otherwise: nil.
sz ifNil:[ sz := self _calculateSize ].
^ sz
%

category: 'Updating'
method: RcQueue
size: anInteger

"Disallowed.  You cannot change the size of anRcQueue other than to add or
 remove elements.  To change the maximum sessionId that can be used with
 this queue see changeMaxSessionId:."

^self shouldNotImplement: #size:
%

category: 'Class Membership'
method: RcQueue
species

"Returns a class similar to, or the same as, the receiver's class which
 can be used for containing derived copies of the receiver."

^ Array
%

category: 'private - extensions'
method: RcQueue
_addAll: aCollection

"Adds an array of objects to the RcQueue, returns the receiver.
It is much more efficient to add many elements with this method
than calling add: multiple times."

| sessIdx  queueElement sessionComponent sessCompSize firstValid
  lastSeqNumber clss systm |

systm := System .
sessIdx  := systm session + 1.
sessionComponent := self _getSessionComponentFor: sessIdx .
sessCompSize := sessionComponent size.
(sessCompSize > 0)
  ifTrue: [
    queueElement := sessionComponent at: sessCompSize.
    lastSeqNumber := queueElement sequenceNumber.
    systm _addToRcReadSet: queueElement includingAllNodes: false.
  ]
  ifFalse: [lastSeqNumber := removalSeqNumbers at: sessIdx ].
clss := sessionComponent class speciesOfElements.
aCollection do:[:n|
  queueElement := clss newWithValue: n sequenceNumber: lastSeqNumber + 1
	               inObjectSecurityPolicyOf: self .
  sessionComponent at: (sessionComponent size + 1) put: queueElement.
  lastSeqNumber := lastSeqNumber + 1.
].

systm _addToRcReadSet: sessionComponent includingAllNodes: true.

"clean up entries that have been removed"
firstValid := self _findFirstValidQueueElementForSession: sessIdx .
(firstValid > 1) ifTrue: [
  sessionComponent removeFrom: 1 to: firstValid - 1 .
  ].

(systm rcValueCacheAt: #size for: self otherwise: nil) ifNotNil:[:rcz|
  systm rcValueCacheAt: #size put: (rcz + aCollection size) for: self ].

^aCollection

%

category: 'Accessing'
method: RcQueue
_calculateSize

"Returns the number of valid entries in the RcQueue."

| count firstValid |
count := 0.
1 to: super size do: [:i |
  firstValid := self _findFirstValidQueueElementForSession: i.
  firstValid ~~ nil
    ifTrue: [ count := count + ((self at: i) size - firstValid + 1) ]
  ].
System rcValueCacheAt: #size put: count for: self.

^count
%

category: 'Enumerating'
method: RcQueue
_collectElems

"This private method is added to support C++ access to the valid elements
 in the RcQueue (the C++ equivalent of do:)."

| resultArray |

resultArray := { } .
self do: [:each | resultArray add: each].
^resultArray
%

category: 'Private'
method: RcQueue
_deepCopyWith: copiedObjDict

| copy |
copy := copiedObjDict at: self otherwise: nil.
copy ~~ nil ifTrue: [ ^ copy ].

copy := self class new: (self size).
copiedObjDict at: self put: copy.

self _deepCopyNamedIvsWith: copiedObjDict to: copy .

self _timeSortedComponents do: [:ea |
   copy add: (ea value _deepCopyWith: copiedObjDict)
   ].
^ copy.
%

category: 'Private'
method: RcQueue
_doComponents: aBlock
    "Evaluates aBlock with each of the current element components of
    the RcQueue as the argument. The argument aBlock must be a
    one-argument block. This method does not traverse the queue
    elements in order."

    | sessionComponent firstValid |
    1 to: self maxSessionId do:
        [ :i |
         sessionComponent := self at: i.
         sessionComponent ~~ nil
             ifTrue:
                 [firstValid := self _findFirstValidQueueElementForSession: i.
                  firstValid to: sessionComponent size do:
                      [ :j |
                       aBlock value: (sessionComponent at: j)]]]
%

category: 'Error Handling'
method: RcQueue
_errorIndexOutOfRange: anIndex

"Sends an error message indicating that anIndex was outside legal limits
 for the receiver."

^ self _error: #objErrBadOffsetIncomplete args: { anIndex - 1 }
%

category: 'Error Handling'
method: RcQueue
_errorRcQueueEntriesFound

"In attempting to reset the maximum session ID for the queue to a smaller value,
 an entry was found that was added by a session whose session ID is larger than
 the value currently being set.  Remove and save all entries in the queue.  Then
 change the maximum session ID and add the saved entries back into the queue."

^ self _error: #rtErrRcQueueEntriesFound
%

category: 'private - extensions'
method: RcQueue
_fastAddAll: anArray

"Adds an array of objects to the RcQueue, returns the receiver.
It is much more efficient to add many elements with this method
than calling add: multiple times.  This method will perform slightly
better than addAll: when the collection to be added is large."

| sessIdx  queueElement sessionComponent sessCompSize firstValid
  lastSeqNumber clss systm |

anArray _validateClass: Array.
systm := System .
sessIdx  := systm session + 1.
sessionComponent := self _getSessionComponentFor: sessIdx .
sessCompSize := sessionComponent size.
(sessCompSize > 0)
  ifTrue: [
    queueElement := sessionComponent at: sessCompSize.
    lastSeqNumber := queueElement sequenceNumber.
    systm _addToRcReadSet: queueElement includingAllNodes: false.
  ]
  ifFalse: [lastSeqNumber := removalSeqNumbers at: sessIdx ].
clss := sessionComponent class speciesOfElements.
1 to: anArray size do:[:n|
  queueElement := clss newWithValue: n sequenceNumber: lastSeqNumber + 1
                       inObjectSecurityPolicyOf: self .
  sessionComponent at: (sessionComponent size + 1) put: queueElement.
  lastSeqNumber := lastSeqNumber + 1.
].

systm _addToRcReadSet: sessionComponent includingAllNodes: true.
"clean up entries that have been removed"
firstValid := self _findFirstValidQueueElementForSession: sessIdx .
(firstValid > 1) ifTrue: [
   sessionComponent removeFrom: 1 to: firstValid - 1 .
   ].

(systm rcValueCacheAt: #size for: self otherwise: nil) ifNotNil:[:rcz |
    systm rcValueCacheAt: #size put: (rcz + anArray size) for: self
].
^anArray

%

category: 'Private'
method: RcQueue
_findFirstValidQueueElementForSession: aSessionId

"Returns the index of the first valid queue element for a session.

 The first valid queue element is the one whose sequence number is the smallest
 value that is greater than the removal sequence number of session.

 The argument aSessionId is an instance of SmallInteger that has a value that
 is one greater than the session number (which is returned by the
 System | session method)."

<primitive: 638>
aSessionId _validateClass: SmallInteger .
^self _primitiveFailed: #_findFirstValidQueueElementForSession:
      args: { aSessionId } .
%

category: 'Private'
method: RcQueue
_getSessionComponentFor: offset

"Create an RcQueueSessionComponent for the session with the given offset."

| sessionComponent |
offset > self maxSessionId
  ifTrue: [ self changeMaxSessionId: offset ].

sessionComponent := self _rcAt: offset.
sessionComponent == nil
    ifTrue: [
      sessionComponent := RcQueueSessionComponent new.
      sessionComponent objectSecurityPolicy: self objectSecurityPolicy .
      self at: offset put: sessionComponent.
      System redoLog addConflictObject: self for: self.
      System redoLog addConflictObject: removalSeqNumbers for: self.
    ].
^ sessionComponent
%

category: 'Initializing'
method: RcQueue
_initialize

"Creates and initializes the components of the RcQueue.  The new method
 automatically initializes a new instance of RcQueue, so there is rarely any
 need for a user application to call initialize."
| seg |
seg := self objectSecurityPolicy .
removalSeqNumbers := RcQueueRemovalSeqNumbers new: super size.
removalSeqNumbers objectSecurityPolicy: seg.
System _addToRcReadSet: self includingAllNodes: true.
1 to: super size do: [:i | | newOne |
  removalSeqNumbers at: i put: 0.
  newOne := RcQueueSessionComponent new.
  newOne objectSecurityPolicy: seg.
  self at: i put: newOne.
].
%

category: 'Testing'
method: RcQueue
_isLarge

"Returns true if the object is implemented as a tree of private smaller objects"

^ true
%

category: 'Locking Support'
method: RcQueue
_lockableValues

"Returns a kind of object usable as an argument to _lockAll: primitives.
 This method returns all the elements logically contained in the receiver."

^ self _collectElems
%

category: 'Private'
method: RcQueue
_logRemoval

"Log the fact that a removal occurred (used in _resolveRcConflicts:)."
| systm |

systm := System.
systm redoLog addConflictObject: removalSeqNumbers for: self.

(systm redoLog redoObjects at: self otherwise: nil) == nil
  ifTrue: [ systm redoLog redoObjects at: self put: removalSeqNumbers copy ]
%

category: 'Private'
method: RcQueue
_notPerformedRemoval

"Returns whether the receiver did not perform a removal during the current
 transaction."

^ (System redoLog redoObjects at: self otherwise: nil) == nil
%

category: 'private - extensions'
method: RcQueue
_numberInvalidForMySession

"Returns the number of entries in the RcQueue which have been removed
but
 not yet reclaimed in for my session.
The intent is to determine if it is worth invoking cleanup using
cleanupMySession."

| firstValid |

firstValid := self _findFirstValidQueueElementForSession: (System session + 1).
firstValid == nil
  ifTrue:[ ^0 ]
  ifFalse:[ ^firstValid - 1 ]
%

category: 'Private'
method: RcQueue
_performedRemoval

"Returns whether the receiver performed a removal during the current
 transaction."

^ (System redoLog redoObjects at: self otherwise: nil) ~~ nil
%

category: 'Private'
method: RcQueue
_refreshAfterCommitFailure

"Returns whether the receiver should be selectively aborted when there is a
 failed attempt to commit.  Only special Reduced Objects should answer true."

^ true
%

category: 'Private'
method: RcQueue
_removalSeqNumbersAtBeginningOfTransaction

"Returns a copy of removalSeqNumbers that was stored before the first
 removal occurred."

^ System redoLog redoObjects at: self otherwise: nil
%

category: 'private - extensions'
method: RcQueue
_removeAllInto: anArray

"Removes all entries from the RcQueue and put them into anArray in the
correct order."

| resultArray validSessions firstValidInSession sz
 minElement minSession firstValid sessionComponent
 anElement systm |


" log the fact that a removal occurred (used in _resolveRcConflicts:) "
self _logRemoval.

anArray _validateClass: Array.

sz := self size.
anArray size: 0.
resultArray := anArray size: sz.
sz == 0
  ifTrue: [ ^ resultArray ].

validSessions := { } .
firstValidInSession := { } .
1 to: self maxSessionId do: [:i |
  sessionComponent := self at: i.
  sessionComponent ~~ nil
    ifTrue: [
      firstValid := self _findFirstValidQueueElementForSession: i.
      (firstValid <= sessionComponent size) ifTrue: [
         validSessions add: sessionComponent.
         firstValidInSession add: firstValid.
         removalSeqNumbers at: i put:
            ((sessionComponent at: (sessionComponent size)) sequenceNumber)
         ]
    ]
  ].
1 to: resultArray size do: [:j |
  minSession := 0.
  minElement := nil.
  1 to: validSessions size do: [:i |
    sessionComponent := validSessions at: i.
    firstValid := firstValidInSession at: i.
    (firstValid <= sessionComponent size) ifTrue: [
      anElement := sessionComponent at: firstValid.
     (anElement isOlderThan: minElement) ifTrue: [
           minElement := anElement.
           minSession := i.
         ].
      ]
    ].
  minElement ~~ nil
    ifTrue: [
      resultArray at: j put: minElement value.
      minElement value: nil.
      firstValidInSession at: minSession put:
                      ((firstValidInSession at: minSession) + 1).
    ]
  ].

systm := System .
(systm rcValueCacheAt: #size for: self otherwise: nil) ifNotNil:[:rcz|
   systm rcValueCacheAt: #size put: 0 for: self ].

^resultArray

%

category: 'private - extensions'
method: RcQueue
_removeCount: maxToRemove into: anArray

"Removes entries from the RcQueue, and returns the argument, anArray,
 which contains the  minimum of maxToRemove or the queue size entries,
 in order.  It is more efficient to remove multiple entries than to send the
 message remove repeatedly."

| resultArray validSessions validSessionIds firstValidInSession
  theSize minElement minSession firstValid sessionComponent
  anElement systm |

" log the fact that a removal occurred (used in _resolveRcConflicts:) "
self _logRemoval.

anArray _validateClass: Array.

anArray size: 0.
theSize := self size min: (maxToRemove max: 0).
resultArray := anArray size: theSize.

validSessions := { } .
validSessionIds := { } .
firstValidInSession := { } .

1 to: self maxSessionId do: [:i |
  sessionComponent := self at: i.
  sessionComponent ~~ nil
    ifTrue: [
      firstValid := self _findFirstValidQueueElementForSession: i.
      (firstValid <= sessionComponent size) ifTrue: [
         validSessions add: sessionComponent.
         validSessionIds add: i.
         firstValidInSession add: firstValid.
         ]
    ]
  ].
1 to: resultArray size do: [:j |
  minSession := 0.
  minElement := nil.
  1 to: validSessions size do: [:i |
    sessionComponent := validSessions at: i.
    firstValid := firstValidInSession at: i.
    (firstValid <= sessionComponent size) ifTrue: [
      anElement := sessionComponent at: firstValid.
      (anElement isOlderThan: minElement)
          ifTrue: [
             minElement := anElement.
             minSession := i.
           ].
      ]
    ].
  minElement ~~ nil
    ifTrue: [
      resultArray at: j put: minElement value.
      minElement value: nil.
      removalSeqNumbers at: (validSessionIds at: minSession)
                        put: (minElement sequenceNumber).
      firstValidInSession at: minSession
                        put: ((firstValidInSession at: minSession) + 1).
    ]
  ].

systm := System .
(systm rcValueCacheAt: #size for: self otherwise: nil) ifNotNil:[:rcz|
  systm rcValueCacheAt: #size put: (rcz - resultArray size) for: self
].

^resultArray

%

category: 'Private'
method: RcQueue
_resolveRcConflictsWith: conflictObjects

"A logical write-write conflict has occurred on the receiver.  The objects that
 had the actual physical write-write conflicts are in the conflictObjects
 Array.  Returns whether the conflicts could be successfully resolved."

| offset sessionComponent beginX endX sz |
" If no objects experienced physical conflict, then just returns "
conflictObjects isEmpty
  ifTrue: [ ^ true ].

" determine if this transaction is a consumer and a transaction that
committed in the interim was a consumer "

self _performedRemoval
  ifTrue: [ " this session is a consumer "

    " get a copy before the first removal in the transaction occurred "
    beginX := self _removalSeqNumbersAtBeginningOfTransaction.

    " save a copy of the state at the end of the transaction "
    endX := removalSeqNumbers copy.
    " refresh the view to see other transaction's changes "
    removalSeqNumbers _selectiveAbort.

    " compare removal numbers to see if any changed "
    1 to: (removalSeqNumbers size min: beginX size) do: [ :i |
      (beginX at: i) == (removalSeqNumbers at: i)
        ifFalse: [
          " replace removalSeqNumbers to get a consistent state of the queue "
          removalSeqNumbers := endX.
          ^ false
        ]
    ]
  ].

" at this point, we've failed if two consumers conflicted "

" see if just conflicted on removalSeqNumbers "
( (conflictObjects size == 1) and:[ (conflictObjects at: 1) == removalSeqNumbers ] )
  ifTrue: [
    " if endX is nil, we did not abort removalSeqNumbers above "
    endX ifNil:[
        " save a copy of the state at the end of the transaction "
        endX := removalSeqNumbers copy.
        " refresh the view to see other transaction's changes "
        removalSeqNumbers _selectiveAbort.
      ].

    " compare the sizes of removalSeqNumbers before and after the abort "

    endX size > removalSeqNumbers size
      ifTrue: [
        " other session consumed and committed,
          this session is a producer who grew the root object "

        sz := removalSeqNumbers size.
        " grow the removalSeqNumbers Array and initialize with zeros "
        removalSeqNumbers size: endX size.
        sz + 1 to: endX size do: [ :i | removalSeqNumbers at: i put: 0 ].

        ^ true
      ].

    endX size < removalSeqNumbers size
      ifTrue: [
        " other session was a producer who grew the root and committed,
          this session consumed "

        " overlay my changes to removalSeqNumbers "
        1 to: endX size do: [ :i | removalSeqNumbers at: i put: (endX at: i) ].

        ^ true
      ]
  ].

" if had a physical conflict on the root "
(conflictObjects includes: self) ifTrue: [
        " keep reference to this session's components "
        offset := System session + 1.
        sessionComponent := self _rcAt: offset.

        " abort the root and the removalSeqNumbers "
        super _selectiveAbort.
        removalSeqNumbers _selectiveAbort.

        " check if need to grow the root object "
        offset > self maxSessionId
            ifTrue: [ self changeMaxSessionId: offset ].

        " now re-insert the session element "
        self at: offset put: sessionComponent.

        ^ true
    ].

^ true
%

category: 'Private'
method: RcQueue
_selectiveAbort

"In addition to aborting the RcQueue, selectively aborts the session components
 and removal sequence numbers.  Returns the receiver."

| sessionComponent |

super _selectiveAbort.
removalSeqNumbers _selectiveAbort.
1 to: self maxSessionId do: [:i |
  sessionComponent := self at: i.
  sessionComponent ~~ nil
    ifTrue: [
      sessionComponent _selectiveAbort.
      1 to: sessionComponent size do: [ :j |
        (sessionComponent at: j) _selectiveAbort
      ]
    ].
].
%

category: 'private - extensions'
method: RcQueue
_statistics
"Return a SymbolKeyValueDictionary containing statistics
on the RcQueue as follows:
	#largestSessionComponent - the largest session component
	#largestSessionComponentSize - size of the largest session component
	#largestSessionComponentPhysicalSize - physical size of the largest session component, in bytes
	#totalNumberInvalid - total number of invalid entries, including those belonging to active sessions
	#numberInvalid - number of invalid entries which belong to inactive sessions.
	#numberOfSessions - number of concurrent sessions for which the queue is configured
	#queueSize - number of entries in the queue"

	| largest largestSize result invalid firstValid |
	largest := nil.
	largestSize := 0.
	invalid := 0.
	1 to: super size do: [:i | |s e|
  		e := self _rcAt: i.
		s := e size.
		s > largestSize
			ifTrue:[largest := e.
					largestSize := s.
			].
		firstValid := self _findFirstValidQueueElementForSession: i.
		(firstValid > 1) ifTrue: [
  			invalid :=  invalid + firstValid - 1 .
  		 ].

	].
	largest == nil
		ifTrue:[^nil].
	result := SymbolKeyValueDictionary new.
	result add: (#largestSessionComponent -> largest);
		   add: (#largestSessionComponentSize -> largestSize);
		   add: (#largestSessionComponentPhysicalSize -> largest physicalSize);
		   add: (#totalNumberInvalid -> invalid);
		   add: (#numberInvalid -> self numberInvalid);
		   add: (#numberOfSessions -> self maxSessionId);
		   add: (#queueSize -> self size).
	^ result

%

category: 'Private'
method: RcQueue
_timeSortedComponents
    "Answer a SortedCollection of the receiver's internal queue
    element objects sorted by increasing time."

    | collection |
    collection := SortedCollection sortBlock: [ :a :b | a isOlderThan: b].
    self _doComponents:
        [ :each |
         collection add: each].
    ^collection
%

category: 'private - extensions'
method: RcQueue
_totalNumberInvalid

"Returns the total number of entries in the RcQueue which have been
removed but not yet reclaimed in all session components.  Unlike the numberInvalid
method, this method includes invalid entries for both active and inactive
sessions.  The intent is to determine if it is worth invoking cleanup."

| sz count firstValid |

sz := super size.
count := 0.
1 to: sz do: [:i |
    firstValid := self _findFirstValidQueueElementForSession: i.
    firstValid ~~ nil
      ifTrue: [ count := count + (firstValid - 1) ]

  ].
^count
%

category: 'private - extensions'
method: RcQueue
_unsafeCleanupQueue

"Removes all obsolete entries.  Unlike the cleanupQueue method, this method
removes all obsolete entries, including those belonging to active
sessions.  This method will cause concurrency conflicts with the consumer and any
feeders  and should only be used while no sessions are adding to or removing from
the queue."

| maxSessionId  firstValid
  sessionComponent sessionComponentSize |

maxSessionId := self maxSessionId.

1 to: maxSessionId do: [:i |
    sessionComponent := self at: i.
    sessionComponent ~~ nil
      ifTrue: [
        firstValid := self _findFirstValidQueueElementForSession: i.
        sessionComponentSize := sessionComponent size.
        removalSeqNumbers at: i put: 0.
        (firstValid <= sessionComponentSize)
           ifTrue: [
             (firstValid > 1) ifTrue:[
               sessionComponent removeFrom: 1 to: firstValid - 1 .
               ].
             ]
            ifFalse: [ sessionComponent size: 0]
      ]

  ].
^self

%

category: 'private - extensions'
method: RcQueue
_unsafeResetQueue
	"Reinitialize the internal RcQueue structures.
	WARNING: this method removes all elements from the queue!
	USE AT YOUR OWN PERIL!"

	self _initialize.
	self initialize.
	^self.
%

category: 'Private'
method: RcQueue
_validateRcConflictsWith: conflictObjects

" There are four possible cases that we can analyze by looking
the write sets:

1. this transaction writes the removalSeqNum
   another transaction writes the removalSeqNum and the root
In this case we only conflict on removalSeqNum

2. this transaction writes the removalSeqNum
   another transaction writes the removalSeqNum
In this case we only conflict on removalSeqNum

3. this transaction writes the removalSeqNum and the root
   another transaction writes the removalSeqNum and the root
In this case we conflict on both

4. this transaction writes the removalSeqNum and the root
   another transaction writes the removalSeqNum
In this case we only conflict on removalSeqNum

When this transaction writes the removalSeqNum and the root,
we performed an add:, and we can also tell if we performed a removal.

When the other transaction writes the removalSeqNum and the root,
he either performed just an add:, or an add: and a removal:,
and we cannot determine which without doing a selective abort.
"

" If no objects experienced physical conflict, then just returns "
conflictObjects isEmpty
  ifTrue: [ ^ true ].

" if conflicted on both the removalSeqNum and the root (case 3) or
we wrote the root (case 4) "
(conflictObjects size > 1 or:
[ ((GsBitmap newForHiddenSet: #PomWriteSet) includes: self) ])
  ifTrue: [ " see if we also performed a removal "
    ^ self _notPerformedRemoval
  ].

" case 1 and 2 return false (we just cannot tell) "
^ false
%

! Class extensions for 'RcRangeEqualityIndex'

!		Class methods for 'RcRangeEqualityIndex'

category: 'Instance Creation'
classmethod: RcRangeEqualityIndex
newWithLastElementClass: aClass

"Create a new instance and initialize its B-tree root."

| newOne |
newOne := super new.
newOne lastElementClass: aClass.
newOne btreeRoot: aClass rcBtreeLeafNodeClass new.
^ newOne
%

!		Instance methods for 'RcRangeEqualityIndex'

category: 'Converting'
method: RcRangeEqualityIndex
asIndexSpecification
  (RangeEqualityIndex _isUnicodeLastElementClass: self lastElementClass)
    ifTrue: [ ^ self asUnicodeIndexSpecification ].
  ^ (RcEqualityIndexSpecification
    path: self pathComponentsString
    lastElementClass: self lastElementClass)
    requirePathTerms: self termsRequired;
    legacyIndex: true;
    yourself
%

category: 'Updating'
method: RcRangeEqualityIndex
btreeAt: aKey put: aValue
  "Insert the key/value pair into the root B-tree node.  Must check to see if a
 split occurred.  If so, create a new root node and put the old root and the
 new split node into the new root."

  (self _canCompareWith: aKey)
    ifFalse: [
      ^ (ImproperOperation new
        _number:
            (ErrorSymbols at: #'rtErrRangeEqualityIndexInvalidClassKindForBtree');
        args: { aKey class. self lastPathTerm name. self lastElementClassDescription}) signal ].
  self _btreeAt: aKey put: aValue logging: true
%

category: 'Updating'
method: RcRangeEqualityIndex
btreeRemoveKey: aKey value: aValue

"Removes the key and value from the B-tree root node.  Must check to see if
 a merge occurred in the root such that the root only contains a single
 entry.  If so, make the single entry the new root.  Returns whether the
 removal occurred."

^ self _btreeRemoveKey: aKey value: aValue logging: true
%

category: 'Testing'
method: RcRangeEqualityIndex
isReducedConflictIndex
  "answer true if the receiver supports reduced conflict operations"

  ^ true
%

category: 'Updating'
method: RcRangeEqualityIndex
_btreeAt: aKey put: aValue logging: aBoolean


        ^self _btreeAt: aKey put: aValue logging: aBoolean selectiveAbortSet: nil
%

category: 'Updating'
method: RcRangeEqualityIndex
_btreeAt: aKey put: aValue logging: aBoolean selectiveAbortSet: selectiveAbortSetOrNil
  "Insert the key/value pair into the root B-tree node.  Must check to see if a
 split occurred.  If so, create a new root node and put the old root and the
 new split node into the new root."

  | returnNode node |
  returnNode := btreeRoot
    btreeAt: aKey
    put: aValue
    for: self
    selectiveAbortSet: selectiveAbortSetOrNil.	" see if a split occurred "
  returnNode == btreeRoot
    ifFalse: [
      " returnNode is the second half of the split "
      selectiveAbortSetOrNil ~~ nil
        ifTrue: [ selectiveAbortSetOrNil add: returnNode ].
      System _addRootObjectToRcReadSet: returnNode.
      System redoLog addConflictObject: returnNode for: self.
      node := btreeRoot parentNodeClass new.	" create the new parent node "
      node
        objectSecurityPolicy: btreeRoot objectSecurityPolicy;
        collator: btreeRoot collator.
      node lastValue: returnNode lastValue.
      node
        _insertKey: (btreeRoot _at: btreeRoot _lastKeyIndex)
        value: btreeRoot
        atIndex: 1.	" insert the first half (the original root) "
      node
        _insertKey: (returnNode _at: returnNode _lastKeyIndex)
        value: returnNode
        atIndex: node entrySize + 1.	" insert the second half "
      selectiveAbortSetOrNil ~~ nil
        ifTrue: [ selectiveAbortSetOrNil add: node ].
      System _addRootObjectToRcReadSet: node.
      System redoLog addConflictObject: node for: self.
      btreeRoot := node ].
  System _addRootObjectToRcReadSet: self.
  aBoolean
    ifTrue: [ self _logBtreeAt: aKey put: aValue ].
  ^ true
%

category: 'Updating'
method: RcRangeEqualityIndex
_btreeRemoveKey: aKey value: aValue logging: aBoolean

        ^self  _btreeRemoveKey: aKey value: aValue logging: aBoolean selectiveAbortSet: nil
%

category: 'Updating'
method: RcRangeEqualityIndex
_btreeRemoveKey: aKey value: aValue logging: aBoolean selectiveAbortSet: selectiveAbortSetOrNil

"Removes the key and value from the B-tree root node.  Must check to see if
 a merge occurred in the root such that the root only contains a single
 entry.  If so, make the single entry the new root.  Returns whether the
 removal occurred."

(btreeRoot removeKey: aKey value: aValue for: self selectiveAbortSet: selectiveAbortSetOrNil)
    ifTrue: [
        ((btreeRoot numElements == 1) and: [ btreeRoot isLeaf not ] )
            ifTrue: [ btreeRoot := btreeRoot at: (btreeRoot _lastKeyIndex - 1) ].
          System _addRootObjectToRcReadSet: self.
        aBoolean
          ifTrue: [
            self _logBtreeRemoveKey: aKey value: aValue.
          ].
        ^ true
    ]
    ifFalse: [ ^ false ].
%

category: 'Private'
method: RcRangeEqualityIndex
_logBtreeAt: aKey put: aValue

"Create a log entry for adding the given key/value."

| logEntry |
logEntry := LogEntry new.
logEntry receiver: self;
    selector: #_btreeAt:put:logging:selectiveAbortSet:;
    argArray: { aKey . aValue . false . nil }.
System redoLog addLogEntry: logEntry
%

category: 'Private'
method: RcRangeEqualityIndex
_logBtreeRemoveKey: aKey value: aValue

"Create a log entry for removing the given key/value."

| logEntry |
logEntry := LogEntry new.
logEntry receiver: self;
    selector: #_btreeRemoveKey:value:logging:selectiveAbortSet:;
    argArray: { aKey . aValue . false . nil }.
System redoLog addLogEntry: logEntry
%

category: 'Private'
method: RcRangeEqualityIndex
_resolveRcConflictsWith: conflictObjects

"A logical write-write conflict has occurred on the receiver.  The objects that
 had the actual physical write-write conflicts are in the conflictObjects
 Array.  Selectively abort the receiver and then attempt to replay the
 operations maintained in the System redo log.  Returns true if all the
 operations could be replayed; otherwise returns false."

"inline implementation of _abortAndReplay: to abort old btrees before
 replaying log entries."

| redoLog logEntries selectiveAbortSet |
redoLog := System _redoLog.

" if no log entries to replay, then we're done "
redoLog == nil ifTrue: [ ^ false ].
logEntries := redoLog getLogEntriesFor: self .
logEntries == nil ifTrue:[ ^ false ].

" cannot perform selective abort if receiver has a dependency tag "
self _hasDependencyList ifTrue: [ ^ false ].

" explicitly abort the btrees that made up original changes, since we need to abort entire tree, before replaying, since
  nodes may split differently."
selectiveAbortSet := IdentitySet new.
1 to: conflictObjects size do:[ :j | | co |
  co := conflictObjects at: j.
  co _selectiveAbort.
  selectiveAbortSet add: co.
].

"abort all of the btree nodes involved in the transaction"
redoLog conflictObjects keysAndValuesDo:[ :conflictObject :redoObject |
  redoObject == self
        ifTrue: [
                conflictObject _selectiveAbort.
                selectiveAbortSet add: conflictObject ].
].

" refresh the state of the receiver "
self _selectiveAbort.

" replay all operations on the receiver"
1 to: logEntries size do:[:j | | logEnt |
  logEnt := logEntries at: j .
  logEnt argArray at: 4 put: selectiveAbortSet. "install the selectiveAbortSet into the #selectiveAbortSet arg slot"
  logEnt redo ifFalse:[
    ^ false  "redo failed, cannot commit"
  ].
].
^ true
%

category: 'Converting'
method: RcRangeEqualityIndex
_unicodeIndexSpecificationClass
  ^ RcUnicodeIndexSpecification
%

! Class extensions for 'RcUnicodeIndexSpecification'

!		Class methods for 'RcUnicodeIndexSpecification'

category: 'instance creation'
classmethod: RcUnicodeIndexSpecification
path: aString collator: anIcuCollator
  | res |
  (res := self new)
    path: aString;
    collator: anIcuCollator.
  ^ res
%

category: 'instance creation'
classmethod: RcUnicodeIndexSpecification
path: aString lastElementClass: aClass
  ^ self shouldNotImplement: #'path:lastElementClass:'
%

!		Instance methods for 'RcUnicodeIndexSpecification'

category: 'accessing'
method: RcUnicodeIndexSpecification
collator
  "Returns IcuCollator to be used when comparing Unicode strings"

  collator ifNil: [ collator := IcuCollator default copy immediateInvariant ].
  ^ collator
%

category: 'accessing'
method: RcUnicodeIndexSpecification
collator: anIcuCollator
  "Set the receiver's collator. Use a copy of anIcuCollator to disallow
   changes to strength, etc, that might affect the sort ordering. "

  collator := anIcuCollator copy immediateInvariant
%

category: 'accessing'
method: RcUnicodeIndexSpecification
equalityIndexClass
  ^ self legacyIndex
    ifTrue: [ RcUnicodeRangeEqualityIndex ]
    ifFalse: [ GsUnicodeRangeEqualityIndex ]
%

category: 'accessing'
method: RcUnicodeIndexSpecification
indexTypePrintString
  ^ 'unicodeIndex'
%

category: 'accessing'
method: RcUnicodeIndexSpecification
_createIndex
  | index |
  index := self equalityIndexClass newWithCollator: self collator.
  self legacyIndex
    ifFalse: [ index options: self options ].
  ^ index
%

category: 'private'
method: RcUnicodeIndexSpecification
_validateLastElementClassOn: anNsc
  "noop"


%

! Class extensions for 'RcUnicodeRangeEqualityIndex'

!		Class methods for 'RcUnicodeRangeEqualityIndex'

category: 'instance creation'
classmethod: RcUnicodeRangeEqualityIndex
newWithCollator: anIcuCollator
  "Create a new instance and initialize its B-tree root."

  | newOne btreeRoot |
  newOne := super new.
  newOne collator: anIcuCollator.
  btreeRoot := IndexManager current rcBtreeBasicLeafNodeClass new.
  btreeRoot collator: newOne collator.	"explicitly share invariant collator with index"
  newOne btreeRoot: btreeRoot.
  ^ newOne
%

category: 'instance creation'
classmethod: RcUnicodeRangeEqualityIndex
newWithLastElementClass: aClass
  self shouldNotImplement: #'newWithLastElementClass:'
%

!		Instance methods for 'RcUnicodeRangeEqualityIndex'

category: 'conversion'
method: RcUnicodeRangeEqualityIndex
asIndexSpecification
  ^ (RcUnicodeIndexSpecification
    path: self pathComponentsString
    collator: self collator)
    requirePathTerms: self termsRequired;
    legacyIndex: true;
    yourself
%

category: 'Accessing'
method: RcUnicodeRangeEqualityIndex
collator
  "Returns IcuCollator to be used when comparing Unicode strings"

  ^ collator
%

category: 'Accessing'
method: RcUnicodeRangeEqualityIndex
collator: anIcuCollator
  "Set the receiver's collator. Use a copy of anIcuCollator to disallow
   changes to strength, etc, that might affect the sort ordering. "

  collator := anIcuCollator copy immediateInvariant
%

category: 'Accessing'
method: RcUnicodeRangeEqualityIndex
lastElementClass
  ^ CharacterCollection
%

category: 'Accessing'
method: RcUnicodeRangeEqualityIndex
lastElementClassDescription
  "answer a description of the lastElementClass of the receiver,
   suitable for use in an error message"

  ^ 'CharacterCollection including Unicode String classes'
%

category: 'Accessing'
method: RcUnicodeRangeEqualityIndex
sortNodeClass
  "Returns the class of SortNode to use ... use basic sort node class"

  ^ self indexManager sortNodeClass
%

category: 'Testing'
method: RcUnicodeRangeEqualityIndex
_canCompareWith: aKey
  "Returns whether the receiver can make B-tree comparisons with the given key."

  aKey == nil
    ifTrue: [ ^ true ].
  ^ btreeRoot _canCompare: aKey withClass: Unicode7
%

category: 'Testing'
method: RcUnicodeRangeEqualityIndex
_checkSameLastElementClassAs: indexObj
  ^ indexObj _checkSameLastElementClassAsUnicodeIndex: self
%

category: 'Testing'
method: RcUnicodeRangeEqualityIndex
_checkSameLastElementClassAsEqualityIndex: equalityIndexObj
  ^ false
%

category: 'Testing'
method: RcUnicodeRangeEqualityIndex
_checkSameLastElementClassAsUnicodeIndex: aUnicodeIndexObj
  ^ true
%

category: 'Updating'
method: RcUnicodeRangeEqualityIndex
_setPathTermState
  "For each path term but the last, indicate the need to update the index
 dictionary.  For the last path term, indicate the need to update the B-tree.
 Indicate if the last object along the path needs a dependency list."

  | lastPathTerm |
  1 to: self size - 1 do: [ :i | (self at: i) updateDict: indexDictionary ].
  lastPathTerm := self at: self size.
  lastPathTerm updateBtree: self.
  lastPathTerm needsDepList: true
%

! Class extensions for 'ReferencingObjectPolicy'

!		Instance methods for 'ReferencingObjectPolicy'

category: 'Public'
method: ReferencingObjectPolicy
addReferencingClass: aClass

	aClass implementationFormat even	"OOP or NSC"
		ifTrue: [referencingClassHistories add: aClass classHistory]
		ifFalse: [self error: aClass name , ' not supported as a referencing class for Canonicalization'].
%

category: 'Public'
method: ReferencingObjectPolicy
addReferencingClasses: aCollection

	aCollection do: [:each |
		referencingClassHistories add: each classHistory.
	].
%

category: 'Cleanup'
method: ReferencingObjectPolicy
canonicalizeReferencesIn: aReferencingObject

	| counter |
	(referencingClassHistories includes: aReferencingObject class classHistory) ifFalse: [^self].
	manager sessionCacheStatAt: 5 incrementBy: 1.		"count of referencing objects scanned during cleanup"
	aReferencingObject isInvariant ifTrue: [
		manager sessionCacheStatAt: 8 incrementBy: 1.	"count of invariant referencing objects scanned during cleanup"
		^self
	].
	counter := aReferencingObject _canonicalizeReferencesUsingPolicy: self.
	counter == 0 ifTrue: [^self].
	manager
		sessionCacheStatAt: 6 incrementBy: 1;				"count of referencing objects changed during cleanup"
		sessionCacheStatAt: 7 incrementBy: counter;		"count of references changed during cleanup"
		yourself.
%

category: 'Cleanup'
method: ReferencingObjectPolicy
canonicalizeReferencesInCollection: aCollection

	| counter |
	counter := 0.
	aCollection copy do: [:each |
		each isSpecial ifFalse: [
			| canonical |
			(canonical := manager canonicalObjectFor: each) ~~ each ifTrue: [
				aCollection removeIdentical: each; add: canonical.
				counter := counter + 1.
			].
		].
	].
	^counter
%

category: 'Cleanup'
method: ReferencingObjectPolicy
canonicalizeReferencesInDictionary: aDictionary

	| counter |
	counter := 0.
	aDictionary copy keysAndValuesDo: [:key :value |
		| newKey |
		newKey := key.
		key isSpecial ifFalse: [
			| canonical |
			(canonical := manager canonicalObjectFor: key) ~~ key ifTrue: [
				aDictionary removeKey: key; at: canonical put: value.
				newKey := canonical.
				counter := counter + 1.
			].
		].
		value isSpecial ifFalse: [
			| canonical |
			(canonical := manager canonicalObjectFor: value) ~~ value ifTrue: [
				aDictionary removeKey: newKey; at: newKey put: canonical.
				counter := counter + 1.
			].
		].
	].
	^counter
%

category: 'Cleanup'
method: ReferencingObjectPolicy
canonicalizeReferencesInObject: anObject

	| counter |
	counter := 0.
	1 to: anObject _primitiveSize do: [:i |
		| each |
		each := anObject _primitiveAtNoFault: i otherwise: nil.
		each isSpecial ifFalse: [
			| canonical |
			(canonical := manager canonicalObjectFor: each) ~~ each ifTrue: [
				anObject _primitiveAt: i put: canonical.
				counter := counter + 1.
			].
		].
	].
	^counter
%

category: 'Initialization'
method: ReferencingObjectPolicy
initialize: aManager

	referencingClassHistories := IdentitySet new.
	super initialize: aManager.		"This will set the objectSecurityPolicy"
%

category: 'Security'
method: ReferencingObjectPolicy
objectSecurityPolicy: anObjectSecurityPolicy

	super objectSecurityPolicy: anObjectSecurityPolicy.
	referencingClassHistories objectSecurityPolicy: anObjectSecurityPolicy.
%

category: 'Accessors'
method: ReferencingObjectPolicy
referencingClasses

	^referencingClassHistories
		inject: IdentitySet new
		into: [:sum :each | sum addAll: each. sum].
%

! Class extensions for 'Repository'

!		Instance methods for 'Repository'

category: 'Updating'
method: Repository
at: offset put: aValue
  "Disallowed, installed after Upgrade2C class >> _patchSecurityPolicy15 has run"
  self shouldNotImplement: #at:put:
%

category: 'Online Backup Support'
method: Repository
failOverStatus
  | arr str |
  arr := self failOverStatusInfo .
  (arr at: 1) ifNotNil:[:aString | ^ aString ].

  str := 'This repository last checkpoint file ', (arr at: 2) asString .
      str add: ' record '; add: (arr at:3) asString ; lf ;
          add: ' Other repository restored to checkpoint file '; add:(arr at:4) asString;
          add:' record '; add: (arr at: 5) asString .
  ((arr at: 6) > (arr at: 4) or:[
    (arr at: 6) == (arr at:4) and:[ (arr at:7) > (arr at:5)]]) ifTrue:[
       str lf ;
          add: '                  restored to commit file '; add:(arr at:6) asString;
          add:' record '; add:(arr at:7) asString.
  ].
  ^ str
%

category: 'Online Backup Support'
method: Repository
failOverStatusInfo
  "Returns an Array describing the tranlog position of this repository
   and the restore status of the slave system do which this repository's
   logsender is connected. The Array contains the following elements:

    1: an error String or nil
    2: a SmallInteger, tranlog fileId of last checkpoint written by this stone .
    3: a SmallInteger, tranlog blockId  of last checkpoint written by this stone .

    4: a SmallInteger, tranlog fileId of last checkpoint restored by slave stone .
    5: a SmallInteger, tranlog blockId of last checkpoint restored by slave stone .
    6: a SmallInteger, tranlog fileId of last commit restored by slave stone.
    7: a SmallInteger, tranlog blockId of last commit restored by slave stone.
"
  | rs fs |
  System sessionIsOnStoneHost ifFalse:[
    ^ #( 'this session must be on stone host (on stone shared cache)' 0 0 0 0 ).
  ].
  rs := self restoreStatusInfo .
  (rs at: 2) == 0 ifFalse:[
   ^ { 'failover not supported, this repository is in restore: ', (rs at: 1) asString .
        0 . 0 . 0 . 0 }
  ].
  System logsenderSessionId == 0 ifTrue:[
    ^ #( 'logsender not running on this repository, failOverStatus not available' 0 0 0 0 ).
  ].
  fs :=  System _zeroArgPrim: 80 .
  fs _isArray ifFalse:[ ^ { fs asString . 0 . 0 . 0 . 0 }  ].
  ^ fs
%

category: 'Online Backup Support'
method: Repository
failOverToSlave
   "For use on the master system of a hotstandby pair.
    Suspends commits, starts a checkpoint,
    and waits for completion of the checkpoint, and puts this
    repository into restore mode.

    After waiting for restore in the slave system to finish restoring the checkpoint
    just written by failOverToSlave , execute
       Repository >> commitRestore
    on the slave system .  Then start an inverted pair of logsender/logreceiver.
    The slave system is now ready to be the master and this system can be
    put into continuousRestoreFromArchiveLogs , using the tranlogs written
    by the logreceiver just started.

    Returns a failover time ( a DateAndTime ).
    "
  | ts |
  ts := System _zeroArgPrim: 140 .
  ^ DateAndTime posixSeconds: ts offset: Duration zero .
%

category: 'Deprecated (Single Ref Path)'
method: Repository
findReferencePathToObject: anObject

"Finds a reference path to an object.  Returns an instance of GsSingleRefPathResult,
 for which each element represents a connection leading between the search
 objects and the reference in the repository.
 The first element will usually be one of the objects in the limit set, and the last
 element will be the argument.

 The searchObj must be a committed non-special object. This method is not to be used
 for classes or metaclasses. Objects in the stone's list of dead objects are excluded from
 the scan.  It is an error if the object is in the stone's dead objects set.

 Only a single reference path to each object is returned. It is possible for any object
 to be connected to the repository through multiple reference paths.

 It is possible for an object to be disonnected from the repository and therefore have no
 reference path. In this case, the result GsSingleRefPathResult isDead will be true.

 This method aborts the current transaction; if an abort would cause unsaved
 changes to be lost, it signals an error, #rtErrAbortWouldLoseData.

 A reference path scan for an object is terminated and considered completed if any class
 object or GsObjectSecurityPolicy is found in the reference path.  Normally all classes are
 connected to the repository and will be included in the limit set.  However, for garbage
 collection purposes, disconnected classes are considered live objects if any other object
 references them.  In other words, a class is a live object if any live instances of that
 class exist in the repository.
"

self deprecated: 'Repository>>findReferencePathToObject: deprecated v3.4. ',
 'Use (GsSingleRefPathFinder newForSearchObjects: {anObject}) runScan buildResultObjects first'.

System needsCommit ifTrue: [ System _error: #rtErrAbortWouldLoseData ] .

^ (GsSingleRefPathFinder newForSearchObjects: { anObject }) runScan
      buildResultObjects first
%

category: 'Deprecated (Single Ref Path)'
method: Repository
findReferencePathToObjects: anArray findAllRefs: findAllRefs printToLog: printToLog

"Finds a reference path to an array of objects.  Returns an array of GsSingleRefPathResult
 showing how each object is connected to the repository by reference.

 Note that arguments to this method other than <anArray> are not used in v3.4.

 See the comments in findReferencePathToObject: for more information.

 This method aborts the current transaction; if an abort would cause unsaved
 changes to be lost, it signals an error, #rtErrAbortWouldLoseData."

self deprecated: 'Repository>>findReferencePathToObjects:findAllRefs:printToLog: deprecated v3.4. ',
 'Use (GsSingleRefPathFinder newForSearchObjects: anArray) runScan buildResultObjects'.

System needsCommit ifTrue: [ self _error: #rtErrAbortWouldLoseData ] .

^ (GsSingleRefPathFinder newForSearchObjects: anArray) runScan
      buildResultObjects
%

category: 'Deprecated (Single Ref Path)'
method: Repository
findReferencePathToObjs: anArray limitObjArray: limitArray findAllRefs: findAllRefs printToLog: printToLog

"Finds a reference path to an array of objects.  Returns an array of GsSingleRefPathResult
 showing how each object is connected to the repository by reference.

 Note that arguments to this method other than <anArray> are not used in v3.4.

 See the comments in findReferencePathToObject: for more information.

 This method aborts the current transaction; if an abort would cause unsaved
 changes to be lost, it signals an error, #rtErrAbortWouldLoseData."

self deprecated: 'Repository>>findReferencePathToObjs:limitObjArray:findAllRefs:printToLog: deprecated v3.4. ',
 'Use (GsSingleRefPathFinder newForSearchObjects: anArray) runScan buildResultObjects'.

System needsCommit ifTrue: [ self _error: #rtErrAbortWouldLoseData ] .

^ (GsSingleRefPathFinder newForSearchObjects: anArray) runScan
      buildResultObjects
%

category: 'Default numThreads'
method: Repository
getDefaultNumThreads

"Returns the default number of threads to use for multi threaded operations"

 ^ SessionTemps current at: #GsOverrideNumThreads
     ifAbsent: [ 2 ]
%

category: 'Backup and Restore'
method: Repository
lastFailoverTime

"If system is in restore from transaction logs, returns the
 last failOver timestamp detected while reading transaction logs,
 or nil if no failOver timestamp has been processed since restore started.
 If system is not in restore, returns the time from the most
 recent suspendCommitsForFailover, or nil if no suspendCommitsForFailover
 has been executed.

 Result is a DateAndTime or nil."

 | info tm suspendTime |
 ((info := self restoreStatusInfo) at: 2) == 2 ifTrue:[
   (tm := info at: 13) == 0 ifTrue:[ ^ nil ].
   ^ DateAndTime posixSeconds: tm offset: Duration zero
 ].
 (suspendTime := info at: 14) == 0 ifTrue:[ ^ nil ].
 ^ DateAndTime posixSeconds: suspendTime offset: Duration zero
%

category: 'Repository Analysis'
method: Repository
loadGcCandidatesFromFile: aString intoHiddenSet: hiddenSetId

"Given a file which is binary list of dead objects (produced by one of the
 #findDisconnectedObjects: methods), load the objects into the hidden set
 with the given ID.  NOTE: in 3.4 the hiddenSetId changed from a SmallInteger to
 one of the symbols in GsBitmap>>hiddenSetSpecifiers.

 Only objects which exist and are not in the stone's dead object
 set are added to the hidden set.

 Used by GsObjectInventory to profile garbage in the repository.

 Returns an Array containing 3 SmallIntegers:
  1 - Total number of objects in the file.
  2 - Number of valid objects loaded into the hidden set.
  3 - Number of invalid objects not loaded.

 Requires the GarbageCollection privilege.

 Signals an error if hiddenSetId specifies a hidden set only writable
 by SystemUser and the session is not logged in as SystemUser.
"

| gsBitmap numInvalid result bmSize |

gsBitmap := GsBitmap newForHiddenSet: hiddenSetId.
numInvalid := gsBitmap readFromFile: aString.
bmSize := gsBitmap size.
result := Array with: (bmSize + numInvalid)
                with: bmSize
                with: numInvalid.
^result
%

category: 'Default numThreads'
method: Repository
setDefaultNumThreads: numThreads

"Sets default number of threads to use for multi threaded operations"

 SessionTemps current at: #GsOverrideNumThreads put: numThreads
%

category: 'Default numThreads'
method: Repository
setDefaultNumThreads: numThreads during: aBlock
"Sets default number of threads to use for the execution of aBlock containing 
 a multi threaded operation and then resets it after the operation completes."

| prevDefault |
 prevDefault := SessionTemps current at: #GsOverrideNumThreads otherwise: nil.
 SessionTemps current at: #GsOverrideNumThreads put: numThreads.
 ^ aBlock ensure:
     [prevDefault 
        ifNil: [ SessionTemps current removeKey: #GsOverrideNumThreads ]
        ifNotNil: [  SessionTemps current at: #GsOverrideNumThreads put: prevDefault ]
     ].
%

category: 'Private'
method: Repository
_buildAllRefsResult: allRefsResult forInput: inputArr

 | resultArr |
 resultArr := Array new: (inputArr size).
 1 to: (allRefsResult size) do: [ :i |  | element |
   element := allRefsResult at: i.
   resultArr at: (inputArr indexOfIdentical: (element at: 1)) put: ((element at: 2) asArray).
 ].
 ^ resultArr.
%

category: 'Private'
method: Repository
_buildAllRefsResult: allRefsResult forInput: inputArr withLimit: aSmallInt

 | resultArr |
 resultArr := Array new: (inputArr size).
 1 to: (allRefsResult size) do: [ :i |  | element |
   element := allRefsResult at: i.
   resultArr at: (inputArr indexOfIdentical: (element at: 1))
             put: ((element at: 2) enumerateWithLimit: aSmallInt startingAfter: 0)
 ].
 ^ resultArr.
%

category: 'Private'
method: Repository
_buildListInstResult: allInstResult

 | gsBitmap arrSize element resultArr |

 gsBitmap := GsBitmap newForHiddenSet: #ListInstances.
 gsBitmap removeAll.

 arrSize := allInstResult size.
 arrSize == 1 ifTrue: [
   element := allInstResult at: 1.
   gsBitmap addAll: (element at: 2).
   ^ (element at: 2) size
 ].

 resultArr := Array new.
 1 to: arrSize do: [ :i |
   element := allInstResult at: i.
   resultArr add: (element at: 1).
   resultArr add: ((element at: 2) size).
   gsBitmap addAll: (element at: 2).
 ].
 ^ resultArr.
%

category: 'Private'
method: Repository
_doScan: kind fast: isFast with: inputArgument

" This method calls does the appropriate tests, and calls the _scan primitive
  which does the bulk of the work.

  If the SessionTemps current at: #GsOverrideNumThreads is defined, then that value is
  used to determine the number of threads to use.

      scanKind                      Function
   ==========================================
   OP_ALL_INSTANCES              allInstances
   OP_ALL_REFERENCES             allReferences
   OP_ALL_REFS_TO_INSTANCES      allReferencesToInstancesOfClasses
   OP_ALL_REFS_BY_PARENT_CLASS   allReferencesByParentClass
   OP_ALL_OBJS_IN_SEC_POLICY     allObjectsInObjectSecurityPolicies
   OP_ALL_OBJS_LARGER_THAN       allObjectsLargerThan

"
| maxThreads percentCpu argClass result inputArg |
inputArg := (inputArgument _isArray and: [inputArgument size > 1])
                ifTrue:[ Array withAll:(IdentitySet withAll: inputArgument)]
                ifFalse:[ inputArgument ].
System needsCommit ifTrue: [ System _error: #rtErrAbortWouldLoseData ] .

isFast ifTrue: [ maxThreads := self _aggressiveMaxThreadCount.
                 percentCpu := 95 ]
       ifFalse: [  maxThreads := self getDefaultNumThreads. percentCpu := 90 ].
result := self _scanWithMaxThreads: maxThreads waitForLock: 60 pageBufSize: 8
               percentCpuActiveLimit: percentCpu scanKind: kind with: inputArg .
argClass := inputArg class.
(kind ~= OP_ALL_REFS_BY_PARENT_CLASS) ifTrue: [
  ((argClass == Array) or: [argClass == GsBitmap]) ifFalse: [
       result := (result at: 1) at: 2. ] .
  ].
^result
%

category: 'Private'
method: Repository
_getNumThreads
  ^ SessionTemps current at: #GsOverrideNumThreads
      ifAbsent: [ (SystemRepository numberOfExtents) * 2 ]
%

category: 'Private'
method: Repository
_getShrinkRepository
  SessionTemps current at: #GsShrinkRepository
    ifAbsent: [ ^0 ].
  ^1
%

! Class extensions for 'ReversedRangeIndexReadStream'

!		Class methods for 'ReversedRangeIndexReadStream'

category: 'Instance Creation'
classmethod: ReversedRangeIndexReadStream
on: aRangeIndex
  "Create a stream that can access the entire contents of the B-tree whose
 root node is aBtreeNode."

  | arr1 arr2 newStream btreeNode |
  arr1 := {}.
  arr2 := {}.
  btreeNode := aRangeIndex btreeRoot.
  btreeNode _putFirstIndexOfFirstChildInto: arr2.
  btreeNode _putLastIndexOfLastChildInto: arr1.
  newStream := self new.
  newStream endIndex: (arr2 at: 1).
  newStream endNode: (arr2 at: 2).
  newStream currentStack: arr1.
  newStream rangeIndex: aRangeIndex.
  ^ newStream
%

!		Instance methods for 'ReversedRangeIndexReadStream'

category: 'Private'
method: ReversedRangeIndexReadStream
reversedRangeIndexClass
  ^ RangeIndexReadStream
%

category: 'Accessing'
method: ReversedRangeIndexReadStream
_btreeNext
  "Returns the previous value on a stream of B-tree values.  Updates the current
 stack for a subsequent 'next'."

  ^ self _btreePrevious
%

category: 'Accessing'
method: ReversedRangeIndexReadStream
_btreePrevious
  "Returns the previous value on a stream of B-tree values.  Updates the current
 stack for a subsequent 'next'."

  | val leaf index |
  index := currentStack at: 1.	" get the index into the leaf node and see if it has reached the end "
  index == 0
    ifTrue: [ ^ self _errorEndOfStream ].
  leaf := currentStack at: 2.	" get the leaf and the value within the leaf "
  val := leaf _basicAt: index.
  (leaf == endNode and: [ endIndex == index ])
    ifTrue: [
      " if this is the end of the stream, sets the top index to zero and returns "
      currentStack at: 1 put: 0.
      ^ val ].
  index == 1
    ifTrue: [
      " must look down the stack for the previous leaf node "
      self _previousLeaf ]
    ifFalse: [ currentStack at: 1 put: index - leaf entrySize ].
  ^ val
%

category: 'Accessing'
method: ReversedRangeIndexReadStream
_previousLeaf
  "Looks down the stack for the previous leaf node and makes it the current node."

  | nodeIndex notPositioned currentNode currentIndex previousIndex node |
  nodeIndex := 4.
  notPositioned := true.
  [ notPositioned ]
    whileTrue: [
      currentIndex := currentStack at: nodeIndex - 1.
      nil == (currentNode := currentStack at: nodeIndex)
        ifTrue: [ self _error: #'rtErrInvalidBtreeReadStream' ].
      " if the current index is the fist in the node "
      currentIndex == 1
        ifTrue: [
          " must look down the stack another level "
          nodeIndex == currentStack size
            ifTrue: [ ^ self _errorEndOfStream ].
          nodeIndex := nodeIndex + 2 ]
        ifFalse: [
          " current node has a previous entry "
          previousIndex := currentIndex - currentNode entrySize.
          currentStack at: nodeIndex - 1 put: previousIndex.	" put the previous entry (index and node) on the stack "
          nil == (node := currentNode _basicAt: previousIndex)
            ifTrue: [ self _error: #'rtErrInvalidBtreeReadStream' ].
          currentStack at: nodeIndex - 2 put: node.
          nodeIndex - 3
            _downTo: 3
            by: 2
            do: [ :i |
              | childNode |
              " put the last child on any remaining levels in the stack "
              childNode := (currentStack at: i + 1) _basicAt: (currentStack at: i + 1) _lastKeyIndex - 1.
              currentStack at: i put: childNode _lastKeyIndex - 1.
              currentStack at: i - 1 put: childNode ].
          currentStack at: 1 put: node _lastKeyIndex - 1.
          notPositioned := false ] ]
%

category: 'Query Support'
method: ReversedRangeIndexReadStream
_uniqueValuesAddInto: collection spec: querySpec

"Iterates over the unique values of the B-tree, traversing the reverse mappings
 to the root object.  Adds the root to the given NSC."

| leaf index eSize prevVal offset pathTerm |

" get the index into the leaf node and see if it has reached the end "
index := currentStack at: 1.
index == 0
    ifTrue: [ ^ self ].

rangeIndex isIndexOnNscElements
    ifTrue: [ offset := rangeIndex size ]
    ifFalse: [ offset := rangeIndex lastPathComponentsDictionaryOffset max: 1 ].
pathTerm := rangeIndex at: offset.

leaf := currentStack at: 2.
eSize := endNode entrySize.
prevVal := #_incompletePathTraversal.
querySpec rangeIndex: rangeIndex offset: offset pathTerm: pathTerm.
" while current node is not the end node "
[ leaf ~~ endNode ] whileTrue: [
    " iterate through the values of the current node "
  prevVal := querySpec traverseValuesFrom: leaf
                                  start: 1
                                  end: index
                                  previous: prevVal
                                  into: collection.
    " look down the stack for the next leaf node "
    self _previousLeaf.

    leaf := currentStack at: 2.
    index := currentStack at: 1
].
" iterate through the values of the end node "
querySpec traverseValuesFrom: leaf
                 start: endIndex
                 end: index
                 previous: prevVal
                 into: collection.
%

category: 'Query Support'
method: ReversedRangeIndexReadStream
_valuesAddInto: collection spec: querySpec

"Adds each entry value into the given NSC."

| leaf index eSize |

" get the index into the leaf node and see if it has reached the end "
index := currentStack at: 1.
index == 0
    ifTrue: [ ^ self ].

leaf := currentStack at: 2.
eSize := endNode entrySize.
" while current node is not the end node "
[ endNode ~~ leaf ] whileTrue: [
    " put the values for the current node in the set "
    querySpec addValuesFrom: leaf
                     start: 1
                     end: index
                     into: collection.
    " look down the stack for the next leaf node "
    self _previousLeaf.

    leaf := currentStack at: 2.
    index := currentStack at: 1
].

" put values of end node in the NSC "
querySpec addValuesFrom: leaf
                 start: endIndex
                 end: index
                 into: collection.
%

! Class extensions for 'SelectorPathEvaluator'

!		Instance methods for 'SelectorPathEvaluator'

category: 'Testing'
method: SelectorPathEvaluator
hasSelectorTerm
  "Returns true if the path has a term that indicates a selector."

  ^ false
%

category: 'Private'
method: SelectorPathEvaluator
termSelector
  "termSelector is always the last term"
  | term |
  term := self at: self size.
  ^ term copyFrom: 2 to: term size
%

category: 'Testing'
method: SelectorPathEvaluator
termsRequired
  "Answer true if receiver requires that instance variables of indexed objects are present "

  ^ false
%

category: 'Traversing'
method: SelectorPathEvaluator
traverse: anObject andCompare: selector with: aValue
  "Traverse the given object and perform the comparison operation
 on the object at the end of the path and the given value."

  "This method assumes that the index is not over a set-valued instance variable."

  "This method is intended for support of QueryExecutor only"

  self shouldNotImplement: #'traverse:andCompare:with:'
%

category: 'Traversing'
method: SelectorPathEvaluator
traverse: anObject andCompare: selector withTraverser: aTraverser
  "Traverse the given object and perform the comparison operation on the object
 at the end of the path and the value obtained by using the traverser."

  "This method assumes that the index is not over a set-valued instance variable."

  "This method is intended for support of QueryExecutor only"

  self shouldNotImplement: #'traverse:andCompare:withTraverser:'
%

category: 'Traversing'
method: SelectorPathEvaluator
traverse: anObject startingAt: offset do: aBlock
  "Traverse the sub-objects of anObject, using the path names of the receiver starting at the path name at the given offset.  For each object at the end of
 the traversal, evaluate the given block."

  | nextObj ivOffset pathName sz |
  (nil == anObject _and: [ self isIndexOnNscElements not ])
    ifTrue: [ ^ self ].
  nextObj := anObject.
  sz := self size.
  offset to: sz do: [ :i |
    " get the next object along the path "
    nil == nextObj
      ifTrue: [ ^ self ].
    pathName := self at: i.
    (pathName size > 0 and: [ (pathName at: 1) == $# ])
      ifTrue: [ nextObj := nextObj perform: self termSelector ]
      ifFalse: [
        ivOffset := nextObj class _ivOffsetOf: pathName.
        ivOffset == nil
          ifTrue: [
            nextObj _errorInvalidOffset: pathName.
            nextObj := nil ]
          ifFalse: [ nextObj := nextObj instVarAt: ivOffset ] ].
    (nil == nextObj _and: [ i ~= sz ])
      ifTrue: [ ^ self ] ].
  ^ aBlock value: nextObj
%

category: 'Traversing'
method: SelectorPathEvaluator
_traverse: anObject cachedOffsets: offsets cachedClasses: classes incomplete: incompletePathTraversal
  | nextObj sz |
  nextObj := anObject.
  sz := self size.
  1 to: sz do: [ :i |
    | pathName |
    pathName := self at: i.
    (pathName size > 0 and: [ (pathName at: 1) == $# ])
      ifTrue: [ nextObj := nextObj perform: self termSelector ]
      ifFalse: [
        offsets == nil
          ifTrue: [ nextObj := self _nextObjectFor: nextObj at: i ]
          ifFalse: [
            nextObj := self
              _nextObjectFor: nextObj
              at: i
              offsets: offsets
              classes: classes ] ].
    (nil == nextObj and: [ i ~~ sz ])
      ifTrue: [ ^ #'_incompletePathTraversal' ].
    nextObj == #'_incompletePathTraversal'
      ifTrue: [ ^ nextObj ] ].
  ^ nextObj
%

category: 'Traversing'
method: SelectorPathEvaluator
_traverseObject: anObject incompletesInto: incompleteArray incomplete: incomplete
  "Traverse the sub-objects of the given object using the path names of the
 receiver.  This method assumes that the index is not over a set-valued
 instance variable.  For that kind of index, use the traverse:startingAt:into:
 method.  If a nil value is reached before the end of the path, place the object
 into the appropriate Array in the incompleteArray of Arrays."

  "Intended for support of PathSort ... no collection-based terms"

  | nextObj sz |
  nextObj := anObject.
  sz := self size.
  1 to: sz do: [ :i |
    | pathName |
    pathName := self at: i.
    (pathName size > 0 and: [ (pathName at: 1) == $# ])
      ifTrue: [ nextObj := nextObj perform: self termSelector ]
      ifFalse: [ nextObj := self _nextObjectFor: nextObj at: i ].
    ((nil == nextObj and: [ i ~~ sz ])
      or: [ nextObj == #'_incompletePathTraversal' ])
      ifTrue: [
        incompleteArray == nil
          ifTrue: [ ^ nil ].
        (incompleteArray at: i + 1) add: anObject.
        ^ incomplete ] ].
  ^ nextObj
%

! Class extensions for 'SelectorPathTerm'

!		Instance methods for 'SelectorPathTerm'

category: 'Updating Indexes'
method: SelectorPathTerm
addDirectMappingFor: anObject logging: aBoolean
  " Update the B-tree. No dependencly list logic for receiver"

  updateBtree ~~ nil
    ifTrue: [ updateBtree btreeAt: anObject put: anObject ].
  updateDict ~~ nil
    ifTrue: [
      " insert an entry into the index dictionary "
      updateDict
        _at: anObject
        put: anObject
        term: self
        logging: aBoolean ]
%

category: 'Updating Indexes'
method: SelectorPathTerm
addMappingsForObject: anObject logging: aBoolean
  "Add index dictionary. No dependency list logic for receiver."

  | nextObj |
  (nil == anObject or: [ self size == 0 ])
    ifTrue: [ ^ self ].
  nextObj := self _nextObjectFor: anObject.	" get the next object along the path "
  updateBtree ~~ nil
    ifTrue: [
      " insert an entry into the B-tree "
      updateBtree btreeAt: nextObj put: anObject ].
  updateDict ~~ nil
    ifTrue: [
      " insert an entry into the index dictionary "
      updateDict
        _at: nextObj
        put: anObject
        term: self
        logging: aBoolean ].
  nil == nextObj
    ifTrue: [ ^ self ].
  1 to: children size do: [ :i |
    " make recursive call to add mappings "
    (children at: i) addMappingsForObject: nextObj logging: aBoolean ]
%

category: 'Updating Indexes'
method: SelectorPathTerm
addMappingsUsing: mapInfo logging: aBoolean
  "Adds index dictionary (no dependency list entries) for the object described by
 the map info object.  If aBoolean is true, operations will be recorded in the
 system redo log."

  | pathTerm object nextObj nextMap |
  pathTerm := mapInfo pathTerm.
  pathTerm size == 0
    ifTrue: [ ^ self ].
  object := mapInfo object.
  nil == object
    ifTrue: [ ^ self ].
  nextMap := mapInfo at: 1.	" nextObj is the same for all nextMaps, so choose the first one "
  nextObj := nextMap object.
  updateBtree ~~ nil
    ifTrue: [
      " insert an entry into the B-tree "
      updateBtree btreeAt: nextObj put: object ].
  updateDict ~~ nil
    ifTrue: [
      " insert an entry into the index dictionary "
      updateDict
        _at: nextObj
        put: object
        term: pathTerm
        logging: aBoolean ].
  1 to: mapInfo size do: [ :i |
    nextMap := mapInfo at: i.	" make recursive call to add mappings "
    nextMap pathTerm ~~ nil
      ifTrue: [ nextMap pathTerm addMappingsUsing: nextMap logging: aBoolean ] ]
%

category: 'Audit'
method: SelectorPathTerm
allDependencyListsFor: anObject into: all
  "No dependency list info"

  ^ self
%

category: 'Audit'
method: SelectorPathTerm
auditDepListFor: obj index: indexObj on: aString optionalSentinel: optionalSentinel
  "No dependency lists"

  ^ obj
%

category: 'Updating Indexes'
method: SelectorPathTerm
cleanupDependencyListFor: anObject
  ""


%

category: 'Updating Indexes'
method: SelectorPathTerm
getMappingInfoFor: anObject ifObject: origObject atOffset: origOffset replaceWith: otherObject
  "Gathers all the objects, their dependency lists, and the instance variable
 offset for each path term in the tree of path terms.  Puts them in a
 MappingInfo object.  Builds a tree of MappingInfo objects for each child path
 term.

 It is possible that this method is invoked due to an instance variable
 modification.  In that case, we want to traverse the path terms as if the
 modification had occurred.  Thus, if anObject is the one that was modified
 (that is, if it is identical to origObject) and the instance variable offset of
 this path term is the same instance variable offset that was modified (that is,
 it is equal to origOffset), then rather than getting the next object along the
 path, use the otherObject."

  | nextObj mapInfo aMapInfo |
  (nil == anObject or: [ self size == 0 ])
    ifTrue: [ ^ self _mappingInfoClass new pathTerm: self ].
  mapInfo := self _mappingInfoClass new
    object: anObject;
    pathTerm: self.
  nextObj := self _nextObjectFor: anObject.	" get the next object along the path "
  updateBtree
    ifNotNil: [
      (self _checkBtreeComparisonWith: nextObj)
        ifFalse: [
          | exa |
          (exa := ImproperOperation new)
            _number:
                (ErrorSymbols at: #'rtErrRangeEqualityIndexInvalidClassKindForBtree');
            args: {nextObj class. self name. updateBtree lastElementClassDescription}.
          ^ {false.	" indicating no indexing objects were modified "
          exa} ] ].
  (nil == nextObj or: [ self children isEmpty ])
    ifTrue: [
      " adds nil to the end and returns "
      mapInfo addLast: (self _mappingInfoClass new object: nextObj).
      ^ mapInfo ].	" make recursive call to get mapping info "
  1 to: children size do: [ :i |
    aMapInfo := (children at: i)
      getMappingInfoFor: nextObj
      ifObject: origObject
      atOffset: origOffset
      replaceWith: otherObject.
    aMapInfo class == self _mappingInfoClass
      ifFalse: [ ^ aMapInfo	"an Array of error info" ].
    mapInfo addLast: aMapInfo ].
  ^ mapInfo
%

category: 'Testing'
method: SelectorPathTerm
isSelectorTerm
  ^ true
%

category: 'Accessing'
method: SelectorPathTerm
needsDepList
  "receiver does not do automatic maintenance updates"

  ^ false
%

category: 'Updating'
method: SelectorPathTerm
needsDepList: ignored
  "receiver does not do automatic maintenance updates"


%

category: 'Updating Indexes'
method: SelectorPathTerm
removeDirectMappingFor: anObject logging: doLogging
  "There is a range index directly on the elements of the NSC.  Update the
 B-tree."

  updateBtree ~~ nil
    ifTrue: [
      " remove it from the B-tree "
      updateBtree btreeRemoveKey: anObject value: anObject ].
  (self indicatesMultiValue _and: [ self indicatesIndexOnNscElements ])
    ifTrue: [
      " if it is a set-valued path term and the last term in an index... "
      ^ self ].
  updateDict ~~ nil
    ifTrue: [
      " remove the index dictionary entry "
      updateDict
        removeKey: anObject
        value: anObject
        term: self
        logging: doLogging ]
%

category: 'Updating Indexes'
method: SelectorPathTerm
removeMappingsFor: anObject lastOne: aBoolean logging: doLogging
  "Remove entries in the index dictionary no dependency mappings"

  | nextObj more isLast |
  self size == 0
    ifTrue: [ ^ self ].
  nextObj := self _nextObjectFor: anObject.
  updateBtree ~~ nil
    ifTrue: [
      " remove an entry from the B-tree "
      updateBtree btreeRemoveKey: nextObj value: anObject ].
  more := false.
  updateDict ~~ nil
    ifTrue: [
      " remove the index dictionary entry "
      more := updateDict
        removeKey: nextObj
        value: anObject
        term: self
        logging: doLogging ].
  (nil ~~ nextObj and: [ children isEmpty not ])
    ifTrue: [
      " make recursive call to remove mappings "
      isLast := aBoolean and: [ more not ].
      1 to: children size do: [ :i | (children at: i) removeMappingsFor: nextObj lastOne: isLast logging: doLogging ] ]
%

category: 'Updating Indexes'
method: SelectorPathTerm
removeMappingsSkipBtreeFor: anObject lastOne: aBoolean logging: doLogging
  "Remove entries in the index dictionary. Nodependency lists for anObject.
 This version for index removal, it does not update the btree since the btree
 is going away (#40858)."

  | nextObj more isLast |
  self size == 0
    ifTrue: [ ^ self ].
  nextObj := self _nextObjectFor: anObject.
  updateBtree ~~ nil
    ifTrue: [  ].
  more := false.
  updateDict ~~ nil
    ifTrue: [
      " remove the index dictionary entry "
      more := updateDict
        removeKey: nextObj
        value: anObject
        term: self
        logging: doLogging ].
  (nil ~~ nextObj and: [ children isEmpty not ])
    ifTrue: [
      " make recursive call to remove mappings "
      isLast := aBoolean and: [ more not ].
      1 to: children size do: [ :i | (children at: i) removeMappingsFor: nextObj lastOne: isLast logging: doLogging ] ]
%

category: 'Accessing'
method: SelectorPathTerm
requirePathTerms
  requirePathTerms ifNil: [ ^ true ].
  ^ requirePathTerms
%

category: 'Accessing'
method: SelectorPathTerm
requirePathTerms: aBool
  requirePathTerms := aBool
%

category: 'Accessing'
method: SelectorPathTerm
termSelector
  | term |
  term := self name.
  ^ term copyFrom: 2 to: term size
%

category: 'Testing'
method: SelectorPathTerm
termsRequired
  "Answer true if receiver requires that instance variables of indexed objects are present "

  ^ self requirePathTerms
%

category: 'Updating Indexes'
method: SelectorPathTerm
undoMappingsFor: anObject lastOne: aBoolean logging: doLogging
  "Remove entries in the index dictionary. No dependency lists for anObject."

  | nextObj more isLast |
  self size == 0
    ifTrue: [ ^ self ].
  [ nextObj := self _nextObjectFor: anObject ]
    onException: Error
    do: [ :ex |
      "Handle any error thrown during execution of _nextObjectFor:
     Cannot resolve the path for this guy --- can't have been added to index,
     in fact this object could have caused the failure in the first place"
      ^ self ].
  updateBtree ~~ nil
    ifTrue: [  ].
  more := false.
  updateDict ~~ nil
    ifTrue: [
      " remove the index dictionary entry "
      more := updateDict
        removeKey: nextObj
        value: anObject
        term: self
        logging: doLogging ].
  (nil ~~ nextObj and: [ children isEmpty not ])
    ifTrue: [
      " make recursive call to remove mappings "
      isLast := aBoolean and: [ more not ].
      1 to: children size do: [ :i | (children at: i) undoMappingsFor: nextObj lastOne: isLast logging: doLogging ] ]
%

category: 'Updating Indexes'
method: SelectorPathTerm
update: anObject at: ivOffset to: newValue
  "should never be sent to the receiver as automatic index maintenance is not supported"

  self shouldNotImplement: #'update:at:to:'
%

category: 'Updating'
method: SelectorPathTerm
_addChildTerm: aPathTerm
  self
    error:
      'Selector path term may not have child terms: ' , aPathTerm printString
%

category: 'Accessing'
method: SelectorPathTerm
_ivOffsetFor: anObject
  self shouldNotImplement: #'_ivOffsetFor:'
%

category: 'Accessing'
method: SelectorPathTerm
_nextObjectFor: anObject
  "Returns the object at the instance variable that corresponds to the receiver
 path term."

  ^ anObject perform: self termSelector
%

category: 'Accessing'
method: SelectorPathTerm
_nextObjectFor: anObject atInstVar: ivOffset
  self shouldNotImplement: #'_nextObjectFor:atInstVar:'
%

! Class extensions for 'Semaphore'

!		Class methods for 'Semaphore'

removeallmethods Semaphore
removeallclassmethods Semaphore

category: 'Instance Creation'
classmethod: Semaphore
forMutualExclusion
  "Answer a new semaphore that has an initial pending
   signal, that can be used for mutual exclusion processing."

  ^ self _basicNew _initializeMutex
%

category: 'Instance Creation'
classmethod: Semaphore
new
  "Answer a new semaphore"
  ^ self _basicNew initialize
%

category: 'Instance Creation'
classmethod: Semaphore
new: size
  "Answer a new semaphore"
  ^ self _basicNew initialize
%

!		Instance methods for 'Semaphore'

category: 'Adding'
method: Semaphore
add: newObject

" Makes newObject one of the receiver's elements and returns newObject.
  Reimplemented so that it will add based on the priority of newObject."

  | count |
  count := self size.
  (count == 0) ifTrue: [
    super add: newObject.
  ] ifFalse: [
    | newPriority |
    newPriority := newObject priority.
    count _downTo: 1 do: [ :i |
      (newPriority <= ((self at: i) priority)) ifTrue: [
        self insertObject: newObject at: (i + 1).
        ^ newObject.
      ].
    ].
    self insertObject: newObject at: 1.
  ].
  ^newObject.
%

category: 'Mutual Exclusion'
method: Semaphore
critical: aBlock
  "execute aBlock when no other critical blocks are executing"

  | value |
  self wait.
  value := aBlock ensure: [self signal].
  ^value
%

category: 'Private'
method: Semaphore
excessSignals

  ^ signalCount
%

category: 'Communication'
method: Semaphore
highPriorityWaitForMilliseconds: millisecondCount

  "If signalCount > 0, this merely decrements the count.  Otherwise
   this will suspend the active process and add it to the end of
   the receiver's list of suspended processes.
   It will wait for at least millisecondCount milliseconds for the receiver to
   be signalled.
   The active process' priority is raised for the duration of the
   wait so that expiration of the wait will interrupt any infinite loop
   or infinite wait for socket activity in other processes.
   Returns true if the semaphore was signalled for the caller.
   Returns false if the timeout expires without a signal for the caller."

  | count |
  (count := signalCount) > 0 ifTrue: [
    signalCount := count - 1.
    ^true
  ] ifFalse: [ | currProc ofs sched oldPrio |
    (sched := self _scheduler) _enterCritical .
    currProc := sched activeProcess .
    oldPrio :=  currProc _raisePriority .
    self add: currProc .
    sched _waitForMilliseconds:  millisecondCount ."exits critical"
    sched activeProcess == currProc ifFalse:[
      Error signal:'current process changed in highPriorityWaitForMilliseconds:'
    ].
    sched _enterCritical .
    currProc priority: oldPrio .
    ofs := self indexOfIdentical: currProc .
    ofs == 0 ifTrue:[
      "not in the semaphore so must have been signalled"
      sched _exitCritical .
      ^ true
    ].
    self removeFrom: ofs to: ofs .
    sched _exitCritical .
    ^ false
  ].
%

category: 'Communication'
method: Semaphore
highPriorityWaitForSeconds: secondCount
  "If signalCount > 0, this merely decrements the count.  Otherwise
   this will suspend the active process and add it to the end of
   the receiver's list of suspended processes.
   It will wait for at least secondCount seconds for the receiver to
   be signalled.
   The active process' priority is raised for the duration of the
   wait so that expiration of the wait will interrupt any infinite loop
   or infinite wait for socket activity in other processes.
   Returns true if the semaphore was signalled for the caller.
   Returns false if the timeout expires without a signal for the caller."

  ^ self highPriorityWaitForMilliseconds: secondCount * 1000
%

category: 'Initialization'
method: Semaphore
initialize

  signalCount := 0.
%

category: 'Communication'
method: Semaphore
isLocked
   ^ signalCount == 0
%

category: 'Formatting'
method: Semaphore
printOn: aStream
  aStream
    nextPutAll: self class name;
    nextPut: $(.
  self asOop printOn: aStream.
  self size ~~ 0 ifTrue: [
    aStream nextPutAll: ',p='.
    1 to: self size do: [:i | (self at: i) printOn: aStream] ].
  aStream nextPut: $)
%

category: 'Copying'
method: Semaphore
replaceFrom: startIndex to: stopIndex with: aSeqCollection

"Disallowed."
^ self shouldNotImplement: #replaceFrom:to:with:
%

category: 'Copying'
method: Semaphore
replaceFrom: startIndex to: stopIndex with: aSeqCollection startingAt: repIndex

"Disallowed."
^ self shouldNotImplement: #replaceFrom:to:with:startingAt:
%

category: 'Copying'
method: Semaphore
replaceFrom: startIndex to: stopIndex withObject: anObject

"Disallowed."
^ self shouldNotImplement: #replaceFrom:to:withObject:
%

category: 'Communication'
method: Semaphore
signal
  "Send a signal through the receiver. If one or more GsProcesses have
   been suspended trying to receive a signal, make the one with the
   highest priority that has been waiting the longest ready to run.
   If no GsProcess is waiting, remember the excess signal.
   Returns the receiver."
  | wasInCrit sched |
  sched := self _scheduler .
  wasInCrit := sched _enterCritical .
    "ProcessorScheduler scheduler dbglog: [ 'signalling semaphore ', self printString ]."
  (self size ~~ 0) ifTrue: [ | waitingProc |
    (waitingProc := self removeFirst )  _reapSignal: self . "puts waiter on a queue"
    waitingProc priority >  sched  activeProcess priority ifTrue:[
      sched yield   "scheduler will exit critical region"
    ] ifFalse:[
      wasInCrit == 0 ifTrue:[ self _exitCritical].
    ]
  ] ifFalse: [
    signalCount := signalCount + 1  .
    wasInCrit == 0 ifTrue:[ self _exitCritical].
  ]
%

category: 'Communication'
method: Semaphore
signalAll
  "Just like signal except all of the GsProcesses waiting on the receiver
   are made ready to run.
   Returns the receiver."

  | highPrio sched wasInCrit |
    "ProcessorScheduler scheduler dbglog: [ 'signalling all semaphore ', self printString ]."
  sched := self _scheduler.
  wasInCrit := sched _enterCritical .
  highPrio := sched lowestPriority .
  1 to: self size do: [:j | | aProc  aPrio |
    (aProc := self at:j)  _reapSignal: self.
    (aPrio := aProc priority) > highPrio ifTrue:[  highPrio := aPrio ].
  ].
  self size: 0.
  highPrio > sched activeProcess priority ifTrue:[
    sched yield  "scheduler will exit critical region"
  ] ifFalse:[
    wasInCrit == 0 ifTrue:[ self _exitCritical ].
  ]
%

category: 'Communication'
method: Semaphore
tryLock
  "If signalCount > 0, decrements the count and returns true,
   otherwise returns false"

  | count |
  ^ (count := signalCount) > 0
        ifTrue:[ signalCount := count - 1 . true ]
       ifFalse:[ false ]
%

category: 'Communication'
method: Semaphore
wait
  "if signalCount > 0, this merely decrements the count.  Otherwise
   this will suspend the active process and add it to the end of
   the receiver's list of suspended processes"

  | count wasInCrit sched |
    "ProcessorScheduler scheduler dbglog: [ ('wait for ', self printString) ]."
  sched := self _scheduler .
  wasInCrit := sched _enterCritical .
  (count := signalCount) > 0 ifTrue: [
    signalCount := count - 1 .
    wasInCrit == 0 ifTrue:[ self _exitCritical].
  ] ifFalse: [ 
    "sched dbglog: [ '  semaphore suspending process' ]."
    self add: (sched := self _scheduler) activeProcess .
    sched _waitOnSema: self   "scheduler exits critical region"
  ].
%

category: 'Communication'
method: Semaphore
waitForMilliseconds: millisecondCount
  "if signalCount > 0, this merely decrements the count.  Otherwise
   this will suspend the active process and add it to the end of
   the receiver's list of suspended processes.
   It will wait for at least millisecondCount milliseconds for the receiver to
   be signalled.
   Returns true if the semaphore was signalled for the caller.
   Returns false if the timeout expires without a signal for the caller."

   | count |
  (count := signalCount) > 0 ifTrue: [
    signalCount := count - 1.
    ^true
  ] ifFalse: [ | currProc ofs sched |
    (sched := self _scheduler) _enterCritical .
    currProc := sched activeProcess .
    self add: currProc .
    sched _waitForMilliseconds:  millisecondCount ."exits critical"
    sched _enterCritical.
    ofs := self indexOfIdentical: currProc .
    ofs == 0 ifTrue:[
      "not in the semaphore so must have been signalled"
      sched _exitCritical .
      ^ true
    ].
    self removeFrom: ofs to: ofs .
    sched _exitCritical .
    ^ false
  ].
%

category: 'Communication'
method: Semaphore
waitForSeconds: secondCount
  "If signalCount > 0, this merely decrements the count.  Otherwise
   this will suspend the active process and add it to the end of
   the receiver's list of suspended processes.
   It will wait for at least secondCount seconds for the receiver to
   be signalled.
   Returns true if the semaphore was signalled for the caller.
   Returns false if the timeout expires without a signal for the caller."

  ^ self waitForMilliseconds: secondCount * 1000
%

category: 'Private'
method: Semaphore
_canWaitOnSocket

  ^ true
%

category: 'Private'
method: Semaphore
_changePriority: aGsProcess from: oldPriority
  "Used by GsProcess to change the priority of a GsProcess in the receiver."

  | removed |
  removed := self removeIdentical: aGsProcess otherwise: nil .
  removed == nil ifFalse:[
    self add: aGsProcess.
  ]
%

category: 'Communication'
method: Semaphore
_exitCritical
  "exit critical region"
<primitive: 737>

self _primitiveFailed: #_exitCritical
%

category: 'Private'
method: Semaphore
_initializeMutex
  "initialize a new instance that has an initial pending
   signal, that can be used for mutual exclusion processing.
   Returns receiver."

  signalCount := 1
%

category: 'Private'
method: Semaphore
_reapSignal: signalSource
  "Signal the receiver "

  self signal .
%

category: 'Private'
method: Semaphore
_scheduler

"Returns   ProcessorScheduler scheduler "
<primitive: 457>

self _primitiveFailed: #_scheduler
%

category: 'Private'
method: Semaphore
_signalAll
  "Wake up the receiver"

  self signalAll.
%

category: 'Private'
method: Semaphore
_unscheduleProcess: aGsProcess
  "Used by ProcessorScheduler"
  self removeIdentical: aGsProcess otherwise: nil .
%

category: 'Private'
method: Semaphore
_wait

  self wait.
%

! Class extensions for 'SequenceableCollection'

!		Instance methods for 'SequenceableCollection'

category: 'PetitParser-Core-Converting'
method: SequenceableCollection
asPetitStream
	^ PPStream on: self
%

! Class extensions for 'SetValuedPathEvaluator'

!		Instance methods for 'SetValuedPathEvaluator'

category: 'Testing'
method: SetValuedPathEvaluator
hasSetValuedTerm
  "Returns true if the path has a term that indicates a set-valued instance
 variable."

  ^ true
%

category: 'Testing'
method: SetValuedPathEvaluator
isIndexOnNscElements
  "Returns whether the receiver is a path directly on the elements of an NSC
 (either the root NSC or a set-valued instance variable along the path)."

  ^ (self at: self size) = #'*'
%

category: 'Traversing'
method: SetValuedPathEvaluator
traverse: anObject startingAt: offset do: aBlock
  "Traverse the sub-objects of anObject, using the path names of the receiver
 starting at the path name at the given offset.  For each object at the end of
 the traversal, evaluate the given block."

  | nextObj ivOffset pathName nscOffset sz |
  (nil == anObject _and: [ self isIndexOnNscElements not ])
    ifTrue: [ ^ self ].
  nextObj := anObject.
  sz := self size.
  offset to: sz do: [ :i |
    nil == nextObj
      ifTrue: [ ^ self ].
    pathName := self at: i.
    pathName = #'*'
      ifTrue: [
        " if indexing over a set-valued instance variable "
        nscOffset := i + 1.
        nextObj
          do: [ :obj |
            " for each object in the collection-valued instance variable "
            " make recursive call "
            self traverse: obj startingAt: nscOffset do: aBlock ].
        ^ self ]
      ifFalse: [
        " get the next object along the path "
        ivOffset := nextObj class _ivOffsetOf: pathName.
        ivOffset == nil
          ifTrue: [ nextObj := nil ]
          ifFalse: [ nextObj := nextObj instVarAt: ivOffset ].
        (nil == nextObj _and: [ i ~= sz ])
          ifTrue: [ ^ self ] ] ].
  ^ aBlock value: nextObj
%

category: 'Traversing'
method: SetValuedPathEvaluator
traverse: anObject startingAt: offset into: resultSet
  "Traverse the sub-objects of all the objects in the NSC, using the path names
 of the receiver starting at the path term at the given offset.  Add each
 object at the end of the traversal to the result set.  Returns the result
 set."

  | nextObj ivOffset pathName nscOffset sz |
  (nil == anObject _and: [ self isIndexOnNscElements not ])
    ifTrue: [ ^ resultSet ].
  nextObj := anObject.
  sz := self size.
  offset to: sz do: [ :i |
    pathName := self at: i.
    pathName = #'*'
      ifTrue: [
        " if indexing over a set-valued instance variable "
        nscOffset := i + 1.
        nextObj
          do: [ :obj |
            " for each object in the set-valued instance variable "
            " make recursive call "
            self traverse: obj startingAt: nscOffset into: resultSet ].
        ^ resultSet ]
      ifFalse: [
        " get the next object along the path "
        nil == nextObj
          ifTrue: [ ^ resultSet ].
        ivOffset := nextObj class _ivOffsetOf: pathName.
        ivOffset == nil
          ifTrue: [
            nextObj _errorInvalidOffset: pathName.
            nextObj := nil ]
          ifFalse: [ nextObj := nextObj instVarAt: ivOffset ] ].
    (nil == nextObj _and: [ i ~= sz ])
      ifTrue: [ ^ resultSet ] ].
  resultSet add: nextObj.
  ^ resultSet
%

! Class extensions for 'SetValuedPathTerm'

!		Instance methods for 'SetValuedPathTerm'

category: 'Updating Indexes'
method: SetValuedPathTerm
addMappingsForObject: anNsc logging: aBoolean
  "Adds index dictionary entries for the objects in anNsc.  Also update the
 NSC's index list."

  | iList indexDict sz |
  (nil == anNsc _or: [ self size == 0 ])
    ifTrue: [ ^ self ].
  anNsc class isNsc
    ifFalse: [ ^ self _errorPathObjectNotAnNsc: anNsc ].
  sz := self size.
  iList := anNsc _getIndexList.
  anNsc _putInWriteSet.	" for each index that utilizes this path term "
  1 to: sz do: [ :i | iList addIndex: (self at: i) withOffset: offset + 1 nsc: anNsc ].
  sz := children size.
  indexDict := self getIndexDictionary.
  anNsc
    do: [ :setElement |
      " insert dictionary entry mapping set element -> NSC "
      indexDict
        _at: setElement
        put: anNsc
        term: self
        logging: aBoolean.
      updateBtree ~~ nil
        ifTrue: [ self addDirectMappingFor: setElement logging: false ].
      1 to: sz do: [ :j | (children at: j) addMappingsForObject: setElement logging: aBoolean ] ]
%

category: 'Updating Indexes'
method: SetValuedPathTerm
addMappingsUsing: mapInfo logging: aBoolean
  "Adds index dictionary entries for the objects in the NSC described by the
 mapInfo.  Also update the NSC's index list."

  | iList anNsc nextPathTerm indexDict setElementMap nextMaps dictUpdated |
  anNsc := mapInfo object.
  (nil == anNsc _or: [ self size == 0 ])
    ifTrue: [ ^ self ].
  dictUpdated := false.
  iList := anNsc _getIndexList.
  anNsc _putInWriteSet.
  1 to: self size do: [ :i |
    " for each index that utilizes this path term "
    iList addIndex: (self at: i) withOffset: offset + 1 nsc: anNsc ].
  indexDict := self getIndexDictionary.
  1 to: mapInfo size do: [ :k |
    " for each child mapping "
    nextMaps := mapInfo at: k.
    1 to: nextMaps size do: [ :i |
      " there is a collection of mappings for each element in the set "
      setElementMap := nextMaps at: i.
      dictUpdated
        ifFalse: [
          " insert dictionary entry mapping set element -> NSC "
          indexDict
            _at: setElementMap object
            put: anNsc
            term: self
            logging: aBoolean ].
      updateBtree ~~ nil
        ifTrue: [ self addDirectMappingFor: setElementMap object logging: aBoolean ].
      (nextPathTerm := setElementMap pathTerm) ~~ nil
        ifTrue: [ nextPathTerm addMappingsUsing: setElementMap logging: aBoolean ] ].
    dictUpdated := true ]
%

category: 'Deprecated'
method: SetValuedPathTerm
allDependencyListsFor: anNsc into: all
  "Put any dependency lists that can be found from the receiver
into the given set."

  | sz |
  self deprecated: 'SetValuePathTerm>allDependencyListsFor:into: deprecated v3.3. Use
    DependencyList class>>depMapValues to collect dependency lists. (3.3)'.  "43886"

  (nil == anNsc _or: [ self size == 0 ])
    ifTrue: [ ^ self ].
  anNsc class isNsc
    ifFalse: [ ^ self _errorPathObjectNotAnNsc: anNsc ].
  sz := children size.
  anNsc
    do: [ :setElement |
      | depList |
      needsDepList
        ifTrue: [
          depList := DependencyList for: setElement.
          depList ~~ nil
            ifTrue: [ all add: depList ] ].
      1 to: sz do: [ :j | (children at: j) allDependencyListsFor: setElement into: all ] ]
%

category: 'Audit'
method: SetValuedPathTerm
auditDepListFor: obj index: indexObj on: aString optionalSentinel: optionalSentinel
  "the set does not have a dependency list"

  self shouldNotImplement: #'auditDepListFor:index:on:optionalSentinel:'
%

category: 'Audit'
method: SetValuedPathTerm
auditIndexDictionaryForObject: anNsc occurrences: num on: aString
  "Private.  Unsupported method for GemStone Technical Support."

  "Verifies that the given object has the correct index dictionary entries for the receiver."

  | sz indexObj newNum dictChecked |
  sz := self size.
  (nil == anNsc _or: [ sz == 0 ])
    ifTrue: [ ^ aString ].
  anNsc
    do: [ :nextObj |
      dictChecked := false.
      1 to: sz do: [ :i |
        " for each index that utilizes the path term "
        indexObj := self at: i.
        (indexObj isRangeEqualityIndex and: [ indexObj size == offset ])
          ifFalse: [
            " verify index dictionary has correct entries "
            dictChecked
              ifFalse: [
                | occurs |
                occurs := anNsc occurrencesOf: nextObj.
                newNum := self
                  auditDictionaryEntryFor: anNsc
                  and: nextObj
                  occurrences: num * occurs
                  on: aString.
                dictChecked := true ] ] ].
      1 to: children size do: [ :i |
        (children at: i)
          auditIndexDictionaryForObject: nextObj
          occurrences: newNum
          on: aString ] ]
%

category: 'Audit'
method: SetValuedPathTerm
auditNscCountsFor: anNsc on: aString count: btreeCounts
  "Private. "

  | sz |
  sz := self size.
  (nil == anNsc _or: [ sz == 0 ])
    ifTrue: [ ^ aString ].
  anNsc
    do: [ :setElement |
      | index |
      index := 1.
      children isEmpty
        ifTrue: [ self auditDirectNscCountsFor: setElement on: aString count: btreeCounts ]
        ifFalse: [
          1 to: sz do: [ :i |
            | count indexObj |
            indexObj := self at: i.
            (indexObj isRangeEqualityIndex and: [ indexObj size == offset ])
              ifTrue: [
                count := btreeCounts at: index.
                count == 0
                  ifTrue: [
                    aString
                      add: Character lf;
                      add: ' -- The number of entries in Btree [';
                      add: (self at: i) btreeRoot asOop asString;
                      add: '] for pathTerm [';
                      add: self asOop asString;
                      add: ' offset ';
                      add: offset asString;
                      add:
                          '] does not match the number of entries in the base collection (extra elements in either the base collection or btree).';
                      add: Character lf ].
                btreeCounts at: index put: count - 1.
                index := index + 1 ] ].
          1 to: children size do: [ :i |
            (children at: i)
              auditNscCountsFor: setElement
              on: aString
              count: (btreeCounts at: index).
            index := index + 1 ] ] ]
%

category: 'Updating Indexes'
method: SetValuedPathTerm
cleanupDependencyListFor: anNsc
  ""

  | sz iList |
  (nil == anNsc _or: [ self size == 0 ])
    ifTrue: [ ^ self ].
  anNsc class isNsc
    ifFalse: [ ^ self _errorPathObjectNotAnNsc: anNsc ].
  (iList := anNsc _indexedPaths) ~~ nil
    ifTrue: [ iList removeIndexesInPathTerm: self for: anNsc ].
  sz := children size.
  anNsc
    do: [ :setElement |
      | depList |
      needsDepList
        ifTrue: [
          depList := DependencyList for: setElement.
          depList ~~ nil
            ifTrue: [ depList removeCompletelyPathTerm: self for: setElement ] ].
      1 to: sz do: [ :j | (children at: j) cleanupDependencyListFor: setElement ] ]
%

category: 'Updating Indexes'
method: SetValuedPathTerm
getMappingInfoFor: anNsc ifObject: anObject atOffset: ivOffset replaceWith: newValue
  "Gathers all the objects, their dependency lists, and instance variable offset
 for each object in anNsc and place these in a MappingInfo object.  Returns the
 mapping info."

  | mapInfo maps iList |
  (nil == anNsc _or: [ self size == 0 ])
    ifTrue: [ ^ self _mappingInfoClass new pathTerm: self ].
  anNsc class isNsc
    ifFalse: [
      | exa |
      (exa := ImproperOperation new)
        reason: #'rtErrPathTermObjectNotAnNsc';
        object: anNsc;
        details: 'Expected an UnorderedCollection'.
      ^ {false.	" indicating no indexing objects were modified "
      exa} ].
  iList := anNsc _indexedPaths.
  iList ~~ nil
    ifTrue: [
      " for each index on the NSC ... "
      1 to: iList size by: 2 do: [ :i |
        " for each index in which this path term is used ... "
        1 to: self size do: [ :j |
          ((iList at: i) == (self at: j) _and: [ (iList at: i + 1) ~= (offset + 1) ])
            ifTrue: [
              | exa |
              (exa := ImproperOperation new)
                _number:
                    (ErrorSymbols at: #'rtErrNscParticipatesInMultipleTerms');
                object: anNsc;
                args:
                    {anNsc.
                      ((iList at: i) pathComponentsString)}.
              ^ {false.	" indicating no indexing objects were modified "
              exa} ] ] ] ].	" create a mapping info object for the NSC "
  mapInfo := self _mappingInfoClass new
    object: anNsc;
    pathTerm: self.
  updateBtree ~~ nil
    ifTrue: [
      maps := Array new.
      anNsc
        do: [ :setElement |
          " the set elements mapping info contains just the set element "
          maps add: (self _mappingInfoClass new object: setElement) ].
      mapInfo addLast: maps.
      ^ mapInfo ].
  children isEmpty
    ifTrue: [
      maps := Array new.
      anNsc do: [ :setElement | maps add: (self _mappingInfoClass new object: setElement) ].
      mapInfo addLast: maps ]
    ifFalse: [
      " for each following path term "
      1 to: children size do: [ :i |
        maps := Array new.
        anNsc
          do: [ :setElement |
            | aMapInfo |
            " get the set elements mapping info and add it to the set "
            aMapInfo := (children at: i)
              getMappingInfoFor: setElement
              ifObject: anObject
              atOffset: ivOffset
              replaceWith: newValue.
            aMapInfo _class == self _mappingInfoClass
              ifFalse: [ ^ aMapInfo ].
            maps add: aMapInfo ].
        mapInfo addLast: maps ] ].
  ^ mapInfo
%

category: 'Testing'
method: SetValuedPathTerm
indicatesIndexOnNscElements
  "Returns true if the path term indicates that the index is on elements of the
 NSC itself.  This is the case if the path term ends in '*' (that is, this
 path term has no children)."

  ^ children isEmpty
%

category: 'Testing'
method: SetValuedPathTerm
indicatesNsc
  "Returns true, the receiver indicates that the index is on an
 instance variable that is expected to be a collection (i.e., set valued pathterm."

  ^ true
%

category: 'Testing'
method: SetValuedPathTerm
isSetValuedTerm
  "Returns true if the receiver indicates a set-valued instance variable."

  ^ true
%

category: 'Accessing'
method: SetValuedPathTerm
nextObj: anObj do: aBlock
  anObj do: aBlock
%

category: 'Updating Indexes'
method: SetValuedPathTerm
removeMappingsFor: anNsc lastOne: aBoolean logging: doLogging
  "Removes entries in the index dictionary, index list, and dependency lists for
 the elements contained in the NSC."

  | indexDict sz |
  self size == 0
    ifTrue: [ ^ self ].
  indexDict := self getIndexDictionary.
  sz := children size.	" for each object in the NSC "
  anNsc
    do: [ :setElement |
      | more depList lastOne |
      " remove the index dictionary entry "
      more := indexDict
        removeKey: setElement
        value: anNsc
        term: self
        logging: doLogging.
      lastOne := aBoolean _and: [ more not ].
      updateBtree ~~ nil
        ifTrue: [
          self removeDirectMappingFor: setElement logging: doLogging.
          needsDepList
            ifTrue: [ DependencyList removePathTerm: self for: setElement ] ].
      nil ~~ setElement
        ifTrue: [
          " make recursive call to remove mappings "
          1 to: sz do: [ :j |
            (children at: j)
              removeMappingsFor: setElement
              lastOne: lastOne
              logging: doLogging ] ].
      lastOne
        ifTrue: [
          (depList := DependencyList for: setElement) ~~ nil
            ifTrue: [ depList removePathTerms: children for: setElement ] ] ]
%

category: 'Accessing'
method: SetValuedPathTerm
_nextObjectFor: anObject
  "Cannot use this shortcut method"

  self shouldNotImplement: #'_nextObjectFor:'
%

category: 'Indexing Support'
method: SetValuedPathTerm
_updateCollectionBasedIndexFor: anIndex on: anNsc offset: anOffset addingIndex: addingIndex
  "if anNsc already has an index, add/remove anIndex as appropriate"

  anNsc _indexedPaths ~~ nil
    ifTrue: [
      | nscOffset |
      nscOffset := anOffset + 1.
      addingIndex
        ifTrue: [
          anNsc _indexedPaths
            addIndex: anIndex
            withOffset: (anIndex at: anOffset) offset + 1
            nsc: anNsc ]
        ifFalse: [ anNsc _indexedPaths removeIndex: anIndex withOffset: nscOffset for: anNsc ] ]
%

! Class extensions for 'SoftReference'

!		Class methods for 'SoftReference'

removeallmethods SoftReference
removeallclassmethods SoftReference

category: 'Instance creation'
classmethod: SoftReference
new

 " creates a new instance with inUse set to false,
   useCount set to zero, and value set to nil ."

 ^ super new _initialize
%

!		Instance methods for 'SoftReference'

category: 'Comparing'
method: SoftReference
= anObject

" return true if the argument is a SoftReference that
  references the identical value"

^ anObject class == self class and:[ anObject _value == value ]
%

category: 'Updating'
method: SoftReference
clearInUse

  "make this SoftReference eligible to be cleared by the garbage collector."

  inUse := false
%

category: 'Updating'
method: SoftReference
clearValue

  "sets value instVar to nil.  Provided primarily for unit testing."

  value := nil
%

category: 'Comparing'
method: SoftReference
hash

"Return a positive Integer based on the identity of the value referenced by
 the receiver."

^ value identityHash

%

category: 'Accessing'
method: SoftReference
inUse

  ^ inUse
%

category: 'Updating'
method: SoftReference
setInUse

"Sets inUse to true. There is no guarantee that value will
 be non-nil after completion of this method.  After this method completes,
 this SoftReference will not be cleared by the garbage collector.
"

inUse := true
%

category: 'Updating'
method: SoftReference
setValue: aValue

  "Installs aValue as the value of the receiver.
   aValue must not be nil , use clearValue to set the value to nil .
   Returns aValue
  "
  aValue == nil ifTrue:[ ^ self error:'argument must not be nil.' ].
  value := aValue .
  self value  "increment useCount" .
  ^ aValue
%

category: 'Accessing'
method: SoftReference
value

 "if value of the receiver is not nil and not a special object,
  increments useCount. returns value of the receiver."

<primitive: 550>
self _primitiveFailed: #value
%

category: 'Private'
method: SoftReference
_initialize

  inUse := false .
  useCount := 0 .
  self _setNoStubbing .
%

category: 'Private'
method: SoftReference
_useCount

 "return the useCount.  This method is provided for use in debugging only.
  The values returned are generated by the virtual machine,
  and the algorithm used to generate them may change without out notice."

  ^ useCount
%

category: 'Accessing'
method: SoftReference
_value

 " return value without incrementing useCount"
  ^ value
%

! Class extensions for 'SortedCollection'

!		Class methods for 'SortedCollection'

category: 'Repository Conversion'
classmethod: SortedCollection
convertAll: anArray usingCache: dict bmForErrors: errBm

"Convert an Array of SortedCollections by recompiling their sort blocks from
 SimpleBlocks to ExecBlocks.  anArray must contain only SortedCollections.
 dict is used as a cache to canonicalize sort blocks with the same source
 string.

 Caller must handle and catch AlmostOutOfMemory errors and handle commits
 and aborts."

| sbCls errorBlock oldIcuDefaultMth newIcuBlk |
sbCls := Globals at:#SimpleBlock ifAbsent:[ ObsoleteClasses at: #SimpleBlock ] .
newIcuBlk := IcuSortedCollection new _defaultBlock . "a 3 arg block"
oldIcuDefaultMth := Globals at:#IcuSortedCollection_oldDefaultMethod "meth for old 2 arg block"
                    ifAbsent:[ newIcuBlk := nil . nil ].
errorBlock := [ :_sc :_errBm :msg |
     GsFile gciLogServer:'SortedCollection oop ', _sc asOop asString , msg .
     errBm add: _sc.
     System _sessionCacheStatAt: 1 put: (_errBm size)
    ].
1 to: anArray size do:[: ofs | | aSortedColl aBlock cls |
  aSortedColl := anArray at: ofs .
  aBlock := aSortedColl sortBlock .
  cls := aBlock class .
  (aSortedColl isKindOf: IcuSortedCollection) ifTrue:[
    aBlock method == oldIcuDefaultMth ifTrue:[
      aSortedColl _sortBlock: newIcuBlk .
      cls := nil "don't need recompile "
    ] ifFalse:[
      aBlock argumentCount == 3 ifFalse:[
	errorBlock value: aSortedColl value: errBm
                value:' an IcuSortedCollection, 2 arg block must be converted to 3 arg block'.
        cls := nil "disable recompile attempt"
      ].
    ].
  ].
  cls ifNotNil:[
    (cls _subclassOf: ExecBlock) ifTrue:[
      aBlock needsRecompile ifTrue:[
	[ aBlock recompile  .
	  "successful recompilation for block's method,
	   this block will show up as needsRecompile==false if seen again"
	] onSynchronous: Error do:[ :ex|
	  errorBlock value: aSortedColl value: errBm value:
             ' block recompile failed,' , ex asString
	].
      ].
    ] ifFalse:[
      cls == sbCls ifTrue:[ "SimpleBlock from 2.x " | str val |
	str := aBlock _sourceString .
	(val := dict at: str otherwise: nil)
	  ifNotNil:[ aSortedColl _sortBlock: val ]
	  ifNil:[ "A miss on the dictionary, compile it now"
	    [ val := str evaluate .
	      val ifNotNil:[ dict at: str put: val. "Add to cache"
			  aSortedColl _sortBlock: val ]
		  ifNil:[ errorBlock value: aSortedColl value: errBm
			  value: ' evaluate of recompiled block failed' ].
	    ]  onSynchronous: Error do:[:ex |
               errorBlock value: aSortedColl value: errBm
                 value: ' block recompile failed, ' , ex asString
	    ] .
	  ].
      ] ifFalse:[
	errorBlock value: aSortedColl value: errBm value:' block is a v2.x ComplexBlock'.
      ].
    ].
  ].
].
%

category: 'Repository Conversion'
classmethod: SortedCollection
convertInstancesFromFilesForGem: gemNum of: totalGems
  "Convert instances of SortedCollection by recompiling sortBlocks"
  "Convert instances of SortedCollection by recompiling sortBlocks"

  | bm errBm ar myShare failed ok unique |
  bm := GsBitmap new.
  errBm := GsBitmap new.
  ar := self
    convertInstancesFromFilesForGem: gemNum
    of: totalGems
    bm: bm
    errBm: errBm
    bmDirectoryPath: self getSortedCollDir
    conversion: [ :array :dict : _errBm | self convertAll: array usingCache: dict bmForErrors: _errBm ].
  myShare := ar at: 1.
  unique := ar at: 2.
  self
    writeFailedConversionObjsToFileForGem: gemNum
    bmForErrors: errBm.	"Now write out the ones that failed conversion to a file, if any."
  failed := errBm size.
  ok := myShare - failed.
  System incrementGlobalSessionStatAt: 0 by: ok.
  System incrementGlobalSessionStatAt: 1 by: failed.
  System incrementGlobalSessionStatAt: 2 by: 1.
  ^ String new
    addAll: 'SortedCollection conversion done. Of ';
    addAll: myShare asString;
    addAll: ' total: ';
    addAll: failed asString;
    addAll: ' failed, ';
    addAll: ok asString;
    addAll: ' successful (';
    addAll: unique asString;
    addAll: ' unique).';
    yourself
%

category: 'Repository Conversion'
classmethod: SortedCollection
convertInstancesFromFilesForGem: gemNum of: totalGems bm: bm errBm: errBm bmDirectoryPath: bmDirectoryPath conversion: conversionBlock
  "Session Stat Usage
   0 - num left for this session to process.
   1 - num errors found so far
 Global Shared Counter Usage
   0 - num successfully converted (all sessions).
   1 - num failed conversion (all sessions).
   2 - num sessions completed OK"

  | id sys totalOops sr myShare mod commitBlock errNumAlmostOutOfMemory unique numToSkipAtFront |
  sys := System.
  sr := SystemRepository.
  totalOops := self _loadBitmap: bm fromFilesIn: bmDirectoryPath.
  numToSkipAtFront := 0.
  myShare := totalOops // totalGems.
  mod := totalOops \\ totalGems.
  myShare == 0
    ifTrue: [
      gemNum == 1
        ifTrue: [ myShare := totalOops ]
        ifFalse: [
          "No work for me to do"
          GsFile gciLogServer: 'No oops to convert'.
          ^ #(0 0) ]	]
    ifFalse: [
      numToSkipAtFront := myShare * (gemNum - 1).
      gemNum == totalGems
        ifTrue: [
          "Last guy does the left-overs too."
           myShare := myShare + mod ]	].
  numToSkipAtFront > 0
    ifTrue: [ bm removeFirst: numToSkipAtFront ].
  gemNum == totalGems
    ifFalse: [ bm _truncateToSize: myShare ].
  errNumAlmostOutOfMemory := ErrorSymbols at: #'rtErrSignalAlmostOutOfMemory'.
  commitBlock := [
  sys commitTransaction
    ifFalse: [
      sys abortTransaction.
      TransactionError signal: 'Unexpected commit failure in post conversion' ] ].
  errBm removeAll.
  [
  [
  | numLeft array dict numThisTime |
  numLeft := bm size.
  dict := StringKeyValueDictionary new: 1000.
  sys signalAlmostOutOfMemoryThreshold: 90.
  sys _sessionCacheStatAt: 0 put: numLeft.
  sys _sessionCacheStatAt: 1 put: 0.
  array := bm enumerateWithLimit: 2034 startingAfter: 0.
  numThisTime := array size.
  [ numThisTime > 0 ]
    whileTrue: [
      conversionBlock value: array value: dict value: errBm.
      numLeft := numLeft - numThisTime.
      sys _sessionCacheStatAt: 0 put: numLeft.
      array := bm enumerateWithLimit: 2034 startingAfter: (array last).
      numThisTime := array size ].
  unique := dict size ]
    onException: AlmostOutOfMemory
    do: [ :ex |
      ex number == errNumAlmostOutOfMemory
        ifTrue: [
          commitBlock value.
          sys
            _vmMarkSweep;
            enableAlmostOutOfMemoryError.
          ex resume ]
        ifFalse: [ ex outer ] ] ]
    ensure: [
      "Do the final commit"
      commitBlock value.
      "Disable the AlmostOutOfMemory error."
      sys signalAlmostOutOfMemoryThreshold: -1.
      "No longer valid."
      id := nil	 ].
  ^ {myShare.
  unique}
%

category: 'Repository Conversion'
classmethod: SortedCollection
createConversionResultFileForTotalGems: totalGems

"Called by the master gem to consolidate all lists of SortedCollections
 which failed conversion into a single result file."

| uld bm outFile totalObjs |

 bm := GsBitmap new.
 uld := self getUpgradeLogDir .

1 to: totalGems do:[:n| |fn|
  fn := uld copy.
  fn addAll: (self buildFileNameForGem: n) .
  (GsFile existsOnServer: fn)
    ifTrue:[
       bm readFromFile: fn
    ].
].

totalObjs := bm size.
totalObjs == 0
  ifTrue:[ ^ true ].

outFile := uld copy .
outFile addAll: 'AllFailedSortedCollections.bm' .
(GsFile existsOnServer: outFile)
  ifTrue:[ GsFile removeServerFile: outFile ].

bm writeToFile: outFile.
GsFile gciLogServer: ('A total of ', totalObjs asString, ' SortedCollections failed to convert').
^ true
%

category: 'Repository Conversion'
classmethod: SortedCollection
resortInstancesFromFilesForGem: gemNum of: totalGems
  "Resort instances of SortedCollection"

  | bm errBm ar myShare failed ok unique |
  bm := GsBitmap new.
  errBm := GsBitmap new.
  ar := self
    convertInstancesFromFilesForGem: gemNum
    of: totalGems
    bm: bm
    errBm: errBm
    bmDirectoryPath: self getSortedCollDir
    conversion: [ :array :ignored :_errBm | self resortAll: array ].
  myShare := ar at: 1.
  unique := ar at: 2.
  self
    writeFailedConversionObjsToFileForGem: gemNum
    bmForErrors: errBm.	"Now write out the ones that failed conversion to a file, if any."
  failed := errBm size.
  ok := myShare - failed.
  System incrementGlobalSessionStatAt: 0 by: ok.
  System incrementGlobalSessionStatAt: 1 by: failed.
  System incrementGlobalSessionStatAt: 2 by: 1.
  ^ String new
    addAll: 'SortedCollection resorting done. Of ';
    addAll: myShare asString;
    addAll: ' total: ';
    addAll: failed asString;
    addAll: ' failed, ';
    addAll: ok asString;
    addAll: ' successful (';
    addAll: unique asString;
    addAll: ' unique).';
    yourself
%

category: 'Repository Conversion'
classmethod: SortedCollection
_loadBitmap: bm
| files |
bm removeAll.
files := GsFile contentsOfDirectory: self getSortedCollDir onClient: false .
files := files select:[:e| (e findPattern: (Array with: '.bm') startingAt: 1) ~~ 0].
1 to: files size do:[:n| |fn bm2|
  fn := files at: n.
  bm2 := GsBitmap new.
  bm2 readFromFile: fn.
  bm addAll: bm2.
  bm2 removeAll.
].
^ bm size
%

!		Instance methods for 'SortedCollection'

category: 'Private'
method: SortedCollection
resort

"Re-sorts the receiver according to its sortBlock."

| saveArray |
self size > 1 ifTrue: [
  saveArray := Array withAll: self.
  [ self _basicSize: 0 .
    self addAll: saveArray
  ] onException: Error do: [:ex |
    "fix bug 39227/41089"
    System disableCommitsUntilAbortWithReason: 'Error during SortedCollection>>resort'.
    ex pass
  ].
].
%

category: 'Object Canonicalization'
method: SortedCollection
_canonicalizeReferencesUsingPolicy: aReferencingObjectPolicy

	^aReferencingObjectPolicy canonicalizeReferencesInCollection: self
%

! Class extensions for 'SortNode'

!		Class methods for 'SortNode'

category: 'Constants'
classmethod: SortNode
initialNumberOfElements

"Returns the number of entries that are allocated when a node is created."

^ 100
%

category: 'Instance Creation'
classmethod: SortNode
new

"Returns a new initialized instance with the correct size."
| newOne |
newOne := self basicNew: (self entrySize * self initialNumberOfElements).
newOne numElements: 0.
newOne totalElements: 0.
^ newOne

%

category: 'Instance Creation'
classmethod: SortNode
new: size

"Returns a new initialized instance with the correct size."
| newOne |
newOne := self basicNew: self entrySize * (size min: self maxNumberOfElements).
newOne numElements: 0.
newOne totalElements: 0.
^ newOne
%

category: 'Indexing Support'
classmethod: SortNode
recalculateSelectionTree: sortNodeArray for: node offsets: offsets

"Recalculate the selection tree based on a change of the minimum entry
 in the given node."

| parent lChild rChild offset1 offset2 newOffset i j currNode |
currNode := node.

[ true ] whileTrue: [
    " get the parent of the node that has changed "
    parent := currNode at: 2.

    lChild := parent at: 3.
    rChild := parent at: 4.
    " get the offset in the receiver of the corresponding run "
    offset1 := lChild at: 1.
    offset2 := rChild at: 1.

    " check if either of the runs are now empty "
    i := offsets at: offset1.
    j := offsets at: offset2.
    i == nil
        ifTrue: [ newOffset := offset2 ]
        ifFalse: [
             j == nil
                 ifTrue: [ newOffset := offset1 ]
                 ifFalse: [
                     ( (sortNodeArray at: offset1)
                         _compareEntryAt: i
                         lessThanNode: (sortNodeArray at: offset2)
                         entryAt: j
                         useValue: true)
                         ifTrue: [ newOffset := offset1 ]
                         ifFalse: [ newOffset := offset2 ]
                 ]
        ].
    parent at: 1 put: newOffset.

    " if no parent, then this is the root "
    (parent at: 2) == nil
        ifTrue: [ ^ self ].

    currNode := parent
]
%

!		Instance methods for 'SortNode'

category: 'Updating'
method: SortNode
at: aKey put: aValue hasSecondarySort: hasSecondarySort

"Adds the key/value pair to the node.  Sender must verify that the node is not
 full."

| index |
numElements == 0
  ifTrue: [ index := 1 ]
  ifFalse: [ index := self _binarySearchCoveringKey: aKey totalOrder: false ].

self _insertKey: aKey
  value: aValue
  atIndex: index
  hasSecondarySort: hasSecondarySort.

totalElements := totalElements + 1
%

category: 'Updating'
method: SortNode
btreeAt: aKey put: aValue

"Adds the key/value pair to the node.  Sender must verify that the node is not
 full."

| index |
numElements == 0
  ifTrue: [ index := 1 ]
  ifFalse: [ index := self _binarySearchCoveringKey: aKey value: aValue ].
self _btreeInsertKey: aKey value: aValue atIndex: index.
totalElements := totalElements + 1
%

category: 'Testing'
method: SortNode
isFull

"Returns if the node is full."

^ numElements == self class maxNumberOfElements
%

category: 'Accessing'
method: SortNode
pathSorter

"Returns the value of the instance variable 'pathSorter'."

^pathSorter
%

category: 'Updating'
method: SortNode
pathSorter: newValue

"Modify the value of the instance variable 'pathSorter'."

pathSorter := newValue
%

category: 'Constants'
method: SortNode
sizeForSecondarySorts

"Returns the number of entries to allocate when creating a sort node to
 hold secondary sorts."

^ 10
%

category: 'Sorting'
method: SortNode
sortInto: anArray startingAt: index

"Insert the values of the receiver into the given Array starting at the
 given index in sorted order.  Returns the number inserted. "

| j k obj snarray start |
snarray := SortNodeArray.
(pathSorter directions at: sortLevel)
    ifTrue: [ " sort is ascending "
        j := index.
        " for each value in the receiver ... "
        1 to: (numElements * self entrySize) by: self entrySize do: [ :i |
            " if it is an Array of nodes, then a merge sort is needed "
            (obj := self _at: i) class == snarray
                ifTrue: [
                    obj sortInto: anArray startingAt: j.
                    j := j + obj totalElements
                ]
                ifFalse: [
                    anArray at: j put: obj.
                    j := j + 1
                ].
        ].
        ^ j - index
    ]
    ifFalse: [ " sort is descending "
        start := index + totalElements - 1.
        j := start.
        " for each value in the receiver ... "
        1 to: (numElements * self entrySize) by: self entrySize do: [ :i |
            " if it is an Array of nodes, then a merge sort is needed "
            (obj := self _at: i) class == snarray
                ifTrue: [
                    k := j - obj totalElements + 1.
                    obj sortInto: anArray startingAt: k.
                    j := k - 1
                ]
                ifFalse: [
                    anArray at: j put: obj.
                    j := j - 1
                ].
        ].
        ^ start - j
    ]
%

category: 'Indexing Support'
method: SortNode
sortIntoBtreeNodes: anArray
  "Put all of the receiver's entries in the B-tree leaf nodes contained
 in anArray.  If there are not enough B-tree leaf nodes, create more."

  | leafNode total num eSize |
  (total := totalElements) == 0
    ifTrue: [ ^ self ].
  leafNode := anArray at: 1.
  eSize := self entrySize.
  num := leafNode maxNumWhenMerging.
  total < num
    ifTrue: [
      "All of the receiver's entries will fit in the single B-tree leaf node"
      leafNode
        replaceFrom: 1
          to: total * eSize
          with: self
          startingAt: 1;
        numElements: total ]
    ifFalse: [
      | secHalf count secondLeaf half |
      "Create another B-tree leaf node and put half of the receiver's entries in each"
      secondLeaf := leafNode class new.
      secondLeaf
        objectSecurityPolicy: leafNode objectSecurityPolicy;
        collator: leafNode collator.
      half := total // 2.
      count := half * eSize.
      leafNode
        replaceFrom: 1
          to: count
          with: self
          startingAt: 1;
        numElements: half.
      secHalf := total - half.
      secondLeaf
        replaceFrom: 1
          to: secHalf * eSize
          with: self
          startingAt: count + 1;
        numElements: secHalf.
      anArray add: secondLeaf ]
%

category: 'Accessing'
method: SortNode
sortLevel

"Returns the value of the instance variable 'sortLevel'."

^sortLevel
%

category: 'Updating'
method: SortNode
sortLevel: newValue

"Modify the value of the instance variable 'sortLevel'."

sortLevel := newValue
%

category: 'Accessing'
method: SortNode
totalElements

"Returns the value of the instance variable 'totalElements'."

^totalElements
%

category: 'Updating'
method: SortNode
totalElements: newValue

"Modify the value of the instance variable 'totalElements'."

totalElements := newValue
%

category: 'Updating'
method: SortNode
_at: aKey put: aValue forBtree: aBool hasSecondarySort: hasSecondarySort

"Adds the key/value pair to the node.  Sender must verify that the node is not
 full.  Used as optimized method by PathSorter (optimized when receiver is
 a BasicSortNode).  aBool should always be false."

^ self at: aKey put: aValue hasSecondarySort: hasSecondarySort
%

category: 'Updating'
method: SortNode
_btreeInsertKey: aKey value: aValue atIndex: insertionIndex

"Insert the key/value pair in the receiver.  The sender of this message must
 verify that the entry will fit in the receiver and must provide the insertion
 index."

| lastIndex eSize |
lastIndex := self _lastIndex.
eSize := self entrySize .

"move entries down to make room for a new entry, or add room at the end"
self _insertAt: insertionIndex
     from: nil fromStart: 1 fromEnd: eSize
     numToMoveDown: lastIndex - insertionIndex + 1 .

" add the new entry "
super _basicAt: insertionIndex put: aValue.
super _basicAt: (insertionIndex + 1) put: aKey.

self _insertEncryptionFor: aKey value: aValue startingAt: (insertionIndex + 2).

numElements := numElements + 1
%

category: 'Comparison Operators'
method: SortNode
_compareEntryAt: index1
lessThanNode: aNode
entryAt: index2
useValue: aBoolean

"Perform a < comparison between the entries at the given indexes.
 The default implementation uses no encryption."

| o1 o2 |
" first compare the keys "
( (o1 := self _at: index1) _idxForSortLessThan: (o2 := aNode _at: index2) )
    ifTrue: [ ^ true ]
    ifFalse: [
        " if using the values and keys are equal, use the OOP of the value "
        ( aBoolean and: [ o1 _idxForSortEqualTo: o2 ] )
            ifTrue: [
                ^ (self _at: index1 - 1) asOop < (aNode _at: index2 - 1) asOop
            ]
            ifFalse: [ ^ false ]
    ]
%

category: 'Updating'
method: SortNode
_insertDuplicateKey: aKey value: aValue atIndex: insertionIndex
  "The given key is already present in the receiver, so insert the entry
 in a secondary sort node (creating it if necessary)."

  | val newNode sortArray hasSecondarySort |
  " get the existing value "
  val := self _at: insertionIndex.	" see if the value is already sort nodes on the secondary sort path "
  val class == SortNodeArray
    ifTrue: [
      pathSorter
        _addObject: aValue
        inNodes: val
        hasSecondarySort: pathSorter size > val last sortLevel
        incompletes: nil
        incomplete: #'_incompletePathTraversal' ]
    ifFalse: [
      " create sort node for the secondary sort path and put it in a sort Array "
      newNode := (pathSorter sortNodeClassForSortLevel: sortLevel + 1)
        new: self sizeForSecondarySorts.
      newNode collator: self collator.
      newNode pathSorter: pathSorter.
      newNode sortLevel: sortLevel + 1.
      sortArray := SortNodeArray with: newNode.
      self _basicAt: insertionIndex put: sortArray.
      hasSecondarySort := pathSorter size > newNode sortLevel.
      pathSorter
        _addObject: aValue
        inNodes: sortArray
        hasSecondarySort: hasSecondarySort
        incompletes: nil
        incomplete: #'_incompletePathTraversal'.
      pathSorter
        _addObject: val
        inNodes: sortArray
        hasSecondarySort: hasSecondarySort
        incompletes: nil
        incomplete: #'_incompletePathTraversal' ]
%

category: 'Updating'
method: SortNode
_insertKey: aKey
value: aValue
atIndex: insertionIndex
hasSecondarySort: hasSecondarySort

"Insert the key/value pair in the receiver.  The sender of this
 message must verify that the entry will fit in the receiver and
 provide the insertion index."

| lastIndex eSize |
lastIndex := self _lastIndex.
" see if there is more than one sort path remaining and if the given key
is already present in the receiver."
( insertionIndex < lastIndex and: [ hasSecondarySort and:
[ self _compareKey: aKey equalToEntryAt: insertionIndex + 1 ] ] )
    ifTrue: [ " duplicate keys "
        ^ self _insertDuplicateKey: aKey value: aValue atIndex: insertionIndex
    ].

eSize := self entrySize .

"move entries down to make room for a new entry, or add room at the end"
self _insertAt: insertionIndex
     from: nil "insert nils" fromStart: 1 fromEnd: eSize
     numToMoveDown: (numElements * eSize) - insertionIndex + 1 .

" add the new entry "
super _basicAt: insertionIndex put: aValue.
super _basicAt: (insertionIndex + 1) put: aKey.

self _insertEncryptionFor: aKey value: aValue startingAt: (insertionIndex + 2).

numElements := numElements + 1
%

! Class extensions for 'SortNodeArray'

!		Instance methods for 'SortNodeArray'

category: 'Sorting'
method: SortNodeArray
binaryMergeAscendingInto: anArray startingAt: index

"Performs a binary merge sort on the sort nodes in the receiver, placing the
 sorted objects in anArray beginning at the given index.  Returns the number
 inserted."

| i1 i2 j eSize sz1 sz2 node1 node2 val snarray indexManager cnt |
j := index.
node1 := self _at: 1.
node2 := self _at: 2.
eSize := node1 entrySize.
i1 := 2.
sz1 := node1 numElements * eSize.
i2 := 2.
sz2 := node2 numElements * eSize.
snarray := SortNodeArray.

" while both nodes have entries not in the result Array "
indexManager := self indexManager.
cnt := 0 .
[ i1 <= sz1 and: [ i2 <= sz2 ] ] whileTrue: [
  " find which node has the lesser entry "
  (node1 _compareEntryAt: i1
    lessThanNode: node2
    entryAt: i2
    useValue: false)
    ifTrue: [
      val := node1 _at: i1 - 1.
      i1 := i1 + eSize
    ]
    ifFalse: [
      val := node2 _at: i2 - 1.
      i2 := i2 + eSize
    ].
  " if it is an Array of nodes, then a merge sort is needed "
  (val isKindOf: snarray)
    ifTrue: [
      val sortInto: anArray startingAt: j.
      j := j + val totalElements
    ]
    ifFalse: [
      anArray at: j put: val.
      j := j + 1
    ].
  cnt := cnt + 1 .
  (cnt \\ 100) == 0 ifTrue:[indexManager commitIndexMaintenance: self at: j ].
].
" put remaining entries from either node1 or node2 into anArray "
i1 <= sz1
  ifTrue: [
    i1 - 1 to: sz1 by: eSize do: [ :i |
      val := node1 _at: i.
      (val isKindOf: snarray)
        ifTrue: [
          val sortInto: anArray startingAt: j.
          j := j + val totalElements
        ]
        ifFalse: [
          anArray at: j put: val.
          j := j + 1
        ].
    cnt := cnt + 1 .
    (cnt \\ 100) == 0 ifTrue:[ indexManager commitIndexMaintenance: self at: i ].
    ]
  ]
  ifFalse: [
    i2 - 1 to: sz2 by: eSize do: [ :i |
      val := node2 _at: i.
      (val isKindOf: snarray)
        ifTrue: [
          val sortInto: anArray startingAt: j.
          j := j + val totalElements
        ]
        ifFalse: [
          anArray at: j put: val.
          j := j + 1
        ].
    cnt := cnt + 1 .
    (cnt \\ 100) == 0 ifTrue:[ indexManager commitIndexMaintenance: self at: i ].
    ]
  ].
^ j - index
%

category: 'Sorting'
method: SortNodeArray
binaryMergeDescendingInto: anArray startingAt: index

"Perform a binary merge sort on the sort nodes in the receiver, placing the
 sorted objects in anArray beginning at the given index.  Returns the number
 inserted."

| i1 i2 j k eSize sz1 sz2 node1 node2 val snarray num indexManager cnt |
node1 := self _at: 1.
node2 := self _at: 2.
eSize := node1 entrySize.
i1 := 2.
sz1 := node1 numElements * eSize.
i2 := 2.
sz2 := node2 numElements * eSize.
num := node1 totalElements + node2 totalElements.
j := index + num - 1.
snarray := SortNodeArray.

" while both nodes have entries not in the result Array "
indexManager := self indexManager.
cnt := 0 .
[ i1 <= sz1 and: [ i2 <= sz2 ] ] whileTrue: [
  " find which node has the lesser entry "
  (node1 _compareEntryAt: i1
    lessThanNode: node2
    entryAt: i2
    useValue: false)
    ifTrue: [
      val := node1 _at: i1 - 1.
      i1 := i1 + eSize
    ]
    ifFalse: [
      val := node2 _at: i2 - 1.
      i2 := i2 + eSize
    ].
  " if it is an Array of nodes, then a merge sort is needed "
  (val isKindOf: snarray)
    ifTrue: [
      k := j - val totalElements + 1.
      val sortInto: anArray startingAt: k.
      j := k - 1
    ]
    ifFalse: [
      anArray at: j put: val.
      j := j - 1
    ].
  cnt := cnt + 1 .
  (cnt \\ 100) == 0 ifTrue:[ indexManager commitIndexMaintenance: self at: j ].
].
" put remaining entries from either node1 or node2 into anArray "
i1 <= sz1
  ifTrue: [
    i1 - 1 to: sz1 by: eSize do: [ :i |
      val := node1 _at: i.
      (val isKindOf: snarray)
        ifTrue: [
          k := j - val totalElements + 1.
          val sortInto: anArray startingAt: k.
          j := k - 1
        ]
        ifFalse: [
          anArray at: j put: val.
          j := j - 1
        ].
    cnt := cnt + 1 .
    (cnt \\ 100) == 0 ifTrue:[ indexManager commitIndexMaintenance: self at: i ].
    ]
  ]
  ifFalse: [
    i2 - 1 to: sz2 by: eSize do: [ :i |
      val := node2 _at: i.
      (val isKindOf: snarray)
        ifTrue: [
          k := j - val totalElements + 1.
          val sortInto: anArray startingAt: k.
          j := k - 1
        ]
        ifFalse: [
          anArray at: j put: val.
          j := j - 1
        ].
    cnt := cnt + 1 .
    (cnt \\ 100) == 0 ifTrue:[ indexManager commitIndexMaintenance: self at: i ].
    ]
  ].
^ num
%

category: 'Accessing'
method: SortNodeArray
indexManager

^IndexManager current
%

category: 'Sorting'
method: SortNodeArray
nwayMergeAscendingInto: anArray startingAt: index

"Perform a simple n-way merge sort on the sort nodes in the receiver, placing
 the sorted objects in anArray beginning at the given index.  Returns the number
 inserted."

| offsets sizes j k eSize total sz minIndex val root leafArray minRun
nodeClass snarray indexManager |
nodeClass := (self _at: 1) class.
total := 0.
sz := self size.
offsets := Array new: sz.
sizes := Array new: sz.
leafArray := Array new: sz.
1 to: sz do: [ :i |
    " initial offsets into the entry in each run (a SortNode) "
    offsets at: i put: 2.
    " the size of each run "
    sizes at: i put: (self at: i) _lastIndex.
    " the selection tree leaf node for each run "
     leafArray at: i put: { i . nil }.
    " total number of entries (for all runs) "
    total := total + (self at: i) totalElements
].
eSize := (self at: 1) entrySize.
snarray := SortNodeArray.

" build the selection tree and get the root "
root := self _buildInteriorSelectionTreeNodesFor: leafArray.

" j is the offset in anArray in which to insert entries "
j := index.
indexManager := self indexManager.
1 to: total do: [ :count |
    " root of selection tree points to the run with the minimum entry "
    minIndex := root at: 1.
    " get the run that contains the minimum entry "
    minRun := self at: minIndex.
    " k points to the entry in the run "
    k := offsets at: minIndex.

    k == nil
      ifTrue: [ ^ self ].

    val := (self at: minIndex) _at: k - 1.
    (val isKindOf: snarray)
        ifTrue: [ " if it is an Array of nodes, then a merge sort is needed "
            val sortInto: anArray startingAt: j.
            j := j + val totalElements
        ]
        ifFalse: [
            anArray at: j put: val.
            j := j + 1
        ].

    " if reached the end of this run "
    (k + eSize) > (sizes at: minIndex)
        " put nil in the Array of offsets "
        ifTrue: [ offsets at: minIndex put: nil ]
        " otherwise, increment the offset "
        ifFalse: [ offsets at: minIndex put: k + eSize ].

    " reorganize the selection tree and get the root "
    nodeClass recalculateSelectionTree: self
      for: (leafArray at: minIndex)
      offsets: offsets.
    (count \\ 100) == 0 ifTrue:[ indexManager commitIndexMaintenance: self at: count].
].
^ total
%

category: 'Sorting'
method: SortNodeArray
nwayMergeDescendingInto: anArray startingAt: index

"Perform a simple n-way merge sort on the sort nodes in the receiver, placing
 the sorted objects in anArray beginning at the given index.  Returns the number
 inserted."

| offsets sizes j k m eSize total sz minIndex val root leafArray minRun
nodeClass snarray indexManager |
nodeClass := (self _at: 1) class.
total := 0.
sz := self size.
offsets := Array new: sz.
sizes := Array new: sz.
leafArray := Array new: sz.
1 to: sz do: [ :i |
    " initial offsets into the entry in each run (a SortNode) "
    offsets at: i put: 2.
    " the size of each run "
    sizes at: i put: (self at: i) _lastIndex.
    " the selection tree leaf node for each run "
     leafArray at: i put: { i . nil }.
    " total number of entries (for all runs) "
    total := total + (self at: i) totalElements
].
j := index + total - 1.
eSize := (self at: 1) entrySize.
snarray := SortNodeArray.

" build the selection tree and get the root "
root := self _buildInteriorSelectionTreeNodesFor: leafArray.

" j is the offset in anArray in which to insert entries "
j := index + total - 1.

indexManager := self indexManager.
1 to: total do: [ :count |
    " root of selection tree points to the run with the minimum entry "
    minIndex := root at: 1.
    " get the run that contains the minimum entry "
    minRun := self at: minIndex.
    " k points to the entry in the run "
    k := offsets at: minIndex.

    k == nil
      ifTrue: [ ^ self ].

    val := (self at: minIndex) _at: k - 1.
    (val isKindOf: snarray)
        ifTrue: [ " if it is an Array of nodes, then a merge sort is needed "
            m := j - val totalElements + 1.
            val sortInto: anArray startingAt: m.
            j := m - 1
        ]
        ifFalse: [
            anArray at: j put: val.
            j := j - 1
        ].

    " if reached the end of this run "
    (k + eSize) > (sizes at: minIndex)
        " put nil in the Array of offsets "
        ifTrue: [ offsets at: minIndex put: nil ]
        " otherwise, increment the offset "
        ifFalse: [ offsets at: minIndex put: k + eSize ].

    " reorganize the selection tree and get the root "
    nodeClass recalculateSelectionTree: self
      for: (leafArray at: minIndex)
      offsets: offsets.
    (count \\ 100) == 0 ifTrue:[ indexManager commitIndexMaintenance: self at: count].
].
^ total
%

category: 'Indexing Support'
method: SortNodeArray
nwayMergeIntoBtreeNodes: anArray
  "Put all of the receiver's entries in the B-tree leaf nodes contained
 in anArray using an n-way merge.  If there are not enough B-tree
 leaf nodes, create more."

  | offsets sizes j k delta eSize total sz minIndex currNode entryLimit root leafArray minRun anObjectSecurityPolicy nodeClass indexManager aCollator |
  nodeClass := (self _at: 1) class.
  total := 0.
  sz := self size.
  offsets := Array new: sz.
  sizes := Array new: sz.
  leafArray := Array new: sz.
  1 to: sz do: [ :i |
    " initial offsets into the entry in each run (a SortNode) "
    offsets at: i put: 2.	"key offset"	" the size of each run "
    sizes at: i put: (self at: i) _lastIndex.
    leafArray
      at: i
      put:
        {i.
        nil}.	" the selection tree leaf node for each run "
    total := total + (self at: i) totalElements	" total number of entries (for all runs) " ].
  eSize := (self at: 1) entrySize.
  delta := eSize - 2.
  currNode := anArray at: 1.	" Current B-tree node to insert entries "
  aCollator := currNode collator.
  anObjectSecurityPolicy := currNode objectSecurityPolicy.
  entryLimit := currNode maxNumWhenMerging * eSize.
  root := self _buildInteriorSelectionTreeNodesFor: leafArray.	" build the selection tree and get the root "
  j := 1.	" j is the offset in the current interior node in which to insert entries "
  indexManager := self indexManager.
  1 to: total do: [ :i |
    " root of selection tree points to the run with the minimum entry "
    minIndex := root at: 1.
    minRun := self at: minIndex.	" get the run that contains the minimum entry "
    k := offsets at: minIndex.	" k points to the entry in the run "
    k == nil
      ifTrue: [ ^ self ].
    currNode
      replaceFrom: j
      to: j + delta + 1
      with: minRun
      startingAt: k - 1.	" put entry in B-tree node
      minRun copyFrom: k - 1 to: k + delta into: currNode startingAt: j. "
    j := j + eSize.
    currNode _incrementNumElements.
    (j > entryLimit and: [ i < total ])
      ifTrue: [
        " if filled up the current node and more elements remaining, get a new one "
        currNode := currNode class new.
        currNode
          objectSecurityPolicy: anObjectSecurityPolicy;
          collator: aCollator.
        anArray add: currNode.
        j := 1 ].
    k + eSize > (sizes at: minIndex)
      ifTrue: [
        " if reached the end of this run put nil in the Array of offsets "
        offsets at: minIndex put: nil ]
      ifFalse: [
        " increment the offset "
        offsets at: minIndex put: k + eSize ].
    nodeClass
      recalculateSelectionTree: self
      for: (leafArray at: minIndex)
      offsets: offsets.	" reorganize the selection tree and get the root "
    i \\ 100 == 0
      ifTrue: [ indexManager commitIndexMaintenance: self at: i ] ]
%

category: 'Accessing'
method: SortNodeArray
progress

"Returns the value of the instance variable 'progress'."

^progress
%

category: 'Updating'
method: SortNodeArray
progress: anInteger

"Sets the value of the instance variable 'progress'."

progress := anInteger
%

category: 'Sorting'
method: SortNodeArray
sortInto: anArray startingAt: index

"Perform a merge sort on the sort nodes contained in the receiver.  Returns
 the number of entries that were copied."

| firstNode sortAscending |
firstNode := self at: 1.

self size == 1
  ifTrue: [ ^ firstNode sortInto: anArray startingAt: index ].

sortAscending := firstNode pathSorter directions at: firstNode sortLevel.

self size == 2
  ifTrue: [
    sortAscending
      ifTrue: [ ^ self binaryMergeAscendingInto: anArray startingAt: index ]
      ifFalse: [ ^ self binaryMergeDescendingInto: anArray startingAt: index ]
  ].

sortAscending
  ifTrue: [ ^ self nwayMergeAscendingInto: anArray startingAt: index ]
  ifFalse: [ ^ self nwayMergeDescendingInto: anArray startingAt: index ]
%

category: 'Sorting'
method: SortNodeArray
sortInto: anArray startingAt: index incompletes: incompletes

"Perform a merge sort on the sort nodes contained in the receiver.  Returns
 the number of entries that were copied."

| firstNode sortAscending iArray offset num |
firstNode := self at: 1.
sortAscending := firstNode pathSorter directions at: firstNode sortLevel.

offset := index.

"if sort ascending, put objects that could not be traversed first in the Array"
sortAscending
  ifTrue: [
    | indexManager |
    indexManager := self indexManager.
    1 to: incompletes size do: [ :i |
      iArray := incompletes at: i.
      1 to: iArray size do: [ :j |
        anArray at: offset put: (iArray at: j).
        offset := offset + 1.
        (j \\ 100) == 0 ifTrue:[ indexManager commitIndexMaintenance: self at: j].
      ]
    ]
  ].

num := (self size == 1)
  ifTrue: [ firstNode sortInto: anArray startingAt: offset ]
  ifFalse: [
    self size == 2
      ifTrue: [
        sortAscending
          ifTrue: [ self binaryMergeAscendingInto: anArray startingAt: offset ]
          ifFalse: [ self binaryMergeDescendingInto: anArray startingAt: offset ]
      ]
      ifFalse: [
        sortAscending
            ifTrue: [ self nwayMergeAscendingInto: anArray startingAt: offset ]
            ifFalse: [ self nwayMergeDescendingInto: anArray startingAt: offset ].
      ]
  ].

"if sort descending, put objects that could not be traversed last in the Array"
sortAscending
  ifFalse: [
    | indexManager |
    indexManager := self indexManager.
    offset := offset + num.
    incompletes size _downTo: 1 do: [ :i |
      iArray := incompletes at: i.
      1 to: iArray size do: [ :j |
        anArray at: offset put: (iArray at: j).
        offset := offset + 1.
        (j \\ 100) == 0 ifTrue:[ indexManager commitIndexMaintenance: self at: j ].
      ]
    ]
  ]
%

category: 'Indexing Support'
method: SortNodeArray
sortIntoBtreeNodes: leafNodes

"Returns anArray filled with B-tree leaf nodes, in which all
 entries are in sorted order."

self size == 1
  ifTrue: [
    ^ (self at: 1) sortIntoBtreeNodes: leafNodes
  ].

^ self nwayMergeIntoBtreeNodes: leafNodes
%

category: 'Accessing'
method: SortNodeArray
totalElements

"Returns the sum of the totalElements of the receiver's contents."

| total |
total := 0.
1 to: self size do: [ :i |
    total := total + (self at: i) totalElements
].
^ total
%

category: 'Indexing Support'
method: SortNodeArray
_buildInteriorSelectionTreeNodesFor: nodeArray

"Build the interior nodes for a selection tree from the given Array of
 nodes.  Returns the root of the selection tree."

"A selection tree is used to determine the run with the minimum entry
 for an n-way merge sort.  See page 394, 'Fundamentals of Data Structures' by
 Horowitz and Sahni, Computer Science Press, 1976, ISBN 0-914894-20 for
 an explanation of how they are used."

"For this implementation, the nodes in the tree are represented as
 nested Arrays.

A leaf node consists of 3 elements:
{ anInteger.
  < the offset in the SortNodeArray of the corresponding SortNode > .
  <parentNodeArray> }     < its parent node >

An interior node consists of 5 elements:
{ anInteger.
  < offset in the SortNodeArray of the minimum child node's corresponding SortNode > .
  parentNodeArray .
  leftChildArray .
  rightChildArray }
"

| array node1 node2 offset1 offset2 newNode sz cnt indexManager |

" if only one node in the Array, it is the root "
(sz := nodeArray size) == 1
    ifTrue: [ ^ nodeArray at: 1 ].

array := { } .
cnt := 0 .
indexManager := self indexManager.
" for each pair of nodes in the node Array "
1 to: (sz // 2) * 2 by: 2 do: [ :i |
    node1 := nodeArray at: i.
    node2 := nodeArray at: i + 1.
    " get the offset in the receiver of the corresponding run "
    offset1 := node1 at: 1.
    offset2 := node2 at: 1.

    " determine which run contains the minimum entry "
    ( (self at: offset1)
        _compareEntryAt: 2
        lessThanNode: (self at: offset2)
        entryAt: 2
        useValue: true)
        ifTrue: [ newNode := { offset1 . nil . node1 . node2 } ]
        ifFalse: [ newNode := { offset2 . nil . node1 . node2 } ].

    array add: newNode.
    " set the parent of each selection tree node "
    node1 at: 2 put: newNode.
    node2 at: 2 put: newNode.
    cnt := cnt + 1 .
    (cnt \\ 100) == 0 ifTrue:[ indexManager commitIndexMaintenance: self at: i ].
].

" if there is a lone entry at the end "
sz odd
    ifTrue: [ array add: (nodeArray at: sz) ].

^ self _buildInteriorSelectionTreeNodesFor: array
%

! Class extensions for 'String'

!		Instance methods for 'String'

category: 'Converting'
method: String
asFoldcase

" Returns the result of UncodeString::foldCase( U_FOLD_CASE_DEFAULT)."

<primitive: 973>
^ self _primitiveFailed: #asFoldcase
%

category: 'Converting'
method: String
asLowercaseForLocale: anIcuLocale

"Returns the result of  UncodeString::toLower(anIcuLocale).
 See also String >> asLowercase"

<primitive: 971>
^ self _primitiveFailed: #asLowercaseForLocale: args: { anIcuLocale }
%

category: 'Converting'
method: String
asTitlecase

  ^ self asTitlecaseForLocale: IcuLocale default
%

category: 'Converting'
method: String
asTitlecaseForLocale: anIcuLocale

"Returns the result of
 UncodeString::toTitle(BreakIterator::createTitleInstance(anIcuLocale)"

<primitive: 972>
^ self _primitiveFailed: #asTitlecaseForLocale: args: { anIcuLocale }
%

category: 'Converting'
method: String
asUppercaseForLocale: anIcuLocale

"Returns the result of  UncodeString::toUpper(anIcuLocale).
 See also String >> asUppercase"

<primitive: 970>
self _primitiveFailed: #asUppercaseForLocale: args: { anIcuLocale }
%

category: 'Indexing Support'
method: String
compareTo: argString collator: anIcuCollator useMinSize: aMinSize

"Returns -1, 0 or 1,  when receiver is less than,
 equal to, or greater than argString .
 argString must be a String, MultiByteString, or a Utf8.
 anIcuCollator == nil is interpreted as   IcuCollator default .

 If aMinSize == false, normal comparision is done.

 If aMinSize==true, compare stops at (self size min: argString size),
 which is Squeak semantics for comparison.

 If aMinSize is a SmallInteger >= 1, compare stops at
   aMinSize min: (self size min: argString size) ."
<primitive: 977>
anIcuCollator ifNil:[
  (System __sessionStateAt: 20) ifNil:[
    ^ self compareTo: argString collator: IcuCollator default useMinSize: aMinSize ]
] ifNotNil:[ anIcuCollator _validateClass: IcuCollator ].
aMinSize _validateClasses: { Boolean . SmallInteger }.
argString _validateClasses: { String . Utf8 }.
^ self _primitiveFailed: #compareTo:collator:useMinSize:
        args: { argString . anIcuCollator . aMinSize }
%

category: 'Indexing Support'
method: String
sortKeyForCollator: anIcuCollator

"Returns a ByteArray which is the sort key for the
 receiver produced by the specified IcuCollator.

 Calls Collator::getSortKey in coll.h of libicu."

<primitive: 975>
anIcuCollator _validateClass: IcuCollator .
^ self _primitiveFailed: #sortKeyForCollator: args: { anIcuCollator }
%

category: 'Indexing Support'
method: String
_equals: argString collator: anIcuCollator useMinSize: aFalse

"Returns true if argString compares equals to the receiver using anIcuCollator
 and if argString is not a Symbol, otherwise returns false "
<primitive: 991>
anIcuCollator ifNil:[ (System __sessionStateAt: 20) ifNil:[
  ^ self _equals: argString collator: IcuCollator default useMinSize: aFalse ]
] ifNotNil:[  anIcuCollator _validateClass: IcuCollator ].
(argString isKindOf: CharacterCollection) ifTrue:[ ^ argString = self ].
^ false
%

category: 'Private'
method: String
_findStringNocase: subString startingAt: startIndex collator: anIcuCollator

"searches using a copy of anIcuCollator set to TERTIARY matches, and
 using an ICU StringSearch "
<primitive: 944>
subString _validateClasses: { String .  Utf8 } .
startIndex _validateClass: SmallInteger .
(startIndex < 1) | (startIndex > self size)
  ifTrue: [ ^ self _error: #objErrBadOffsetIncomplete args: { startIndex } ].
^ self _primitiveFailed: #_findStringNocase:startingAt:collator:
       args: { subString . startIndex . anIcuCollator }
%

category: 'New Indexing Comparison'
method: String
_idxUnicodeCompareEqualTo: aCharCollection

"This comparison operation is used for the indexing subsystem to
 determine an ordering for insertion into indexing objects and for
 doing indexing subsystem comparisons.

 This method behaves the same as the = method, except that
 it returns true if the argument is nil."

  aCharCollection ifNil: [ ^ false ].
  aCharCollection isUnicodeString ifFalse: [ "not Unicode"
     aCharCollection _isSymbol ifTrue:[ ^ false ] .
  ].
  ^ (self
    compareTo: aCharCollection
    collator: nil
    useMinSize: 900) == 0
%

category: 'New Indexing Comparison'
method: String
_idxUnicodeCompareGreaterThan: aCharCollection

"This comparison operation is used for the indexing subsystem to
 determine an ordering for insertion into indexing objects and for
 doing indexing subsystem comparisons.

 This method collates the same as the > method, except that
 it returns true if the argument is nil."

aCharCollection ifNil: [ ^ true ].
^ (self
    compareTo: aCharCollection
    collator: nil
    useMinSize: 900) == 1
%

category: 'New Indexing Comparison'
method: String
_idxUnicodeCompareLessThan: aCharCollection

"This comparison operation is used for the indexing subsystem to
 determine an ordering for insertion into indexing objects and for
 doing indexing subsystem comparisons.

 This method collates the same as the < method, except that
 it returns false if the argument is nil."

 aCharCollection ifNil:[ ^ false ].
 ^ (self
    compareTo: aCharCollection
    collator: nil
    useMinSize: 900) == -1
%

category: 'Comparing'
method: String
_unicodeEqual: argString
  "Compares receiver to argument using  IcuCollator default."

^ self _equals: argString collator: nil useMinSize: false
%

category: 'Comparing'
method: String
_unicodeGreaterThan: argString
  "Compares receiver to argument using  IcuCollator default."
  ^ (self compareTo: argString collator: nil useMinSize: false) > 0
%

category: 'Comparing'
method: String
_unicodeLessThan: argString
  "Compares receiver to argument using  IcuCollator default."
  ^ (self compareTo: argString collator: nil useMinSize: false) < 0
%

! Class extensions for 'StringKeyValueDictionary'

!		Instance methods for 'StringKeyValueDictionary'

category: 'Repository Conversion'
method: StringKeyValueDictionary
_buildWeakRefSet

"Adds the leaf objects to the hiddenSet."

| hashKey hashValue collisionBkt weakRef |
weakRef := (GsBitmap newForHiddenSet: #WeakReferences).

1 to: tableSize do: [ :tableIndex |
  hashKey := self keyAt: tableIndex.
  hashValue := self valueAt: tableIndex.
  (hashKey == nil)
    ifTrue: [ collisionBkt := hashValue.
              (collisionBkt == nil)
                 ifFalse: [ weakRef add: collisionBkt]]
  ].
^nil
%

! Class extensions for 'Symbol'

!		Instance methods for 'Symbol'

category: 'PetitParser-Core-Converting'
method: Symbol
asParser
	"Answer a predicate parser named after the receiving symbol. Possible symbols are the method selectors on the class-side of PPPredicateObjectParser."

	^ PPPredicateObjectParser perform: self
%

category: 'New Indexing Comparison'
method: Symbol
_idxUnicodeCompareEqualTo: aCharCollection
  "No Unicode Symbols, so answer false"

  ^false
%

! Class extensions for 'System'

!		Class methods for 'System'

category: 'Gci Set Support'
classmethod: System
add: anObject toGciSet: hiddenSetSpecifier 

"Add the specified object to a GCI hidden set, where
   hiddenSetSpecifier = 39 specifies PureExportSet
   hiddenSetSpecifier = 40 specifies GciTrackedObjs .
 Other values of hiddenSetSpecifier are not allowed.
 Has no effect if anObject is a special object.

 If hiddenSetSpecifier = 39 and a userAction is 
 active an error is generated, since the PureExportSet
 cannot be modified from within a user action.

 If hiddenSetSpecifier = 40 and you have not
 executed System class >> gciTrackedObjsInit once since login,  generates an error." 

^ self _add: anObject toGciSet: hiddenSetSpecifier 
%

category: 'Legacy Hidden Set Support'
classmethod: System
add: anObject toHiddenSet: hiddenSetSpecifier

"Will be deprecated, new code should use GsBitmaps"

"Adds anObject to the hiddenSet."

(GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: hiddenSetSpecifier)) add: anObject.
^self
%

category: 'Gci Set Support'
classmethod: System
addAll: anArray toGciSet: hiddenSetSpecifier 

"Add contents of anArray to a GCI hidden set, where
   hiddenSetSpecifier = 39 specifies PureExportSet
   hiddenSetSpecifier = 40 specifies GciTrackedObjs .
 Other values of hiddenSetSpecifier are not allowed.

 If hiddenSetSpecifier = 39 and a userAction is 
 active an error is generated, since the PureExportSet
 cannot be modified from within a user action.

 If hiddenSetSpecifier = 40 and you have not
 executed System class >> gciTrackedObjsInit once since login,  generates an error." 

^ self _addAll: anArray toGciSet: hiddenSetSpecifier 
%

category: 'Legacy Hidden Set Support'
classmethod: System
addAll: anArray toHiddenSet: hiddenSetSpecifier

"Will be deprecated, new code should use GsBitmaps"

"Adds contents of anArray to the hiddenSet (anArray itself is not added to
 hiddenSet). Should only be used with public hidden sets 41-45."

^ (GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: hiddenSetSpecifier)) addAll: anArray
%

category: 'Releasing Locks'
classmethod: System
addAllToCommitOrAbortReleaseLocksSet: aCollection

"Add each element of aCollection to the commit-or-abort release locks set.
 If an element of aCollection is not locked by the current session, then
 it is not added to the set."

aCollection accompaniedBy: (GsBitmap newForHiddenSet: #CommitOrAbortReleaseLocksSet)
   do: [:hs :each |
     ((System myLockKind: each) == #none)
        ifFalse: [ hs add: each ]
   ].
^self
%

category: 'Releasing Locks'
classmethod: System
addAllToCommitReleaseLocksSet: aCollection

"Add each element of aCollection to the commit release locks set.  If an
 element of aCollection is not locked by the current session, then that
 element is not added to the set."

aCollection accompaniedBy: (GsBitmap newForHiddenSet: #CommitReleaseLocksSet)
   do: [:hs :each |
     ((System myLockKind: each) == #none)
        ifFalse: [ hs add: each ]
   ].
^self
%

category: 'Notification'
classmethod: System
addAllToNotifySet: aCollection

"Add all the elements of aCollection to the notify set.  Special objects and
 uncommitted objects are not permitted, since neither of these can be modified
 by other sessions."

self _updateNotifySet: aCollection add: true
%

category: 'Legacy Hidden Set Support'
classmethod: System
addHiddenSet: first to: second

"Will be deprecated, new code should use GsBitmaps" 

"Add all the objects in hidden set first to hidden set second.  Returns the 
 number of objects added to second hidden set that were not already present.
 Should only be used with a second set that is public, sets 41-45.
 User must have permission to modify the second hidden set or be SystemUser."
 
^(GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: first)) addAll:
        (GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: second))
%

category: 'Releasing Locks'
classmethod: System
addToCommitOrAbortReleaseLocksSet: anObject

"Add anObject to to the commit-or-abort release locks set.  If anObject
 is not locked by the current session, then it is not added to the set."

((self myLockKind: anObject) == #none )
  ifFalse: [(GsBitmap newForHiddenSet: #CommitOrAbortReleaseLocksSet) add: anObject].
^self
%

category: 'Releasing Locks'
classmethod: System
addToCommitReleaseLocksSet: anObject

"Add anObject to the commit release locks set.  If anObject is not locked
 by the current session, then it is not added to the set."

((self myLockKind: anObject) == #none )
  ifFalse: [(GsBitmap newForHiddenSet: #CommitReleaseLocksSet) add: anObject].
^self
%

category: 'Notification'
classmethod: System
addToNotifySet: anObject

"Add anObject to the notify set.  The argument anObject cannot be a special
 object nor an uncommitted object, since neither can be modified by other
 sessions."

self _updateNotifySet: { anObject }  add: true
%

category: 'Releasing Locks'
classmethod: System
clearCommitOrAbortReleaseLocksSet

"Remove all objects from the commit-or-abort release locks set."

(GsBitmap newForHiddenSet: #CommitOrAbortReleaseLocksSet) removeAll.
^self
%

category: 'Releasing Locks'
classmethod: System
clearCommitReleaseLocksSet

"Remove all objects from the commit release locks set."

(GsBitmap newForHiddenSet: #CommitReleaseLocksSet) removeAll.
^self
%

category: 'Notification'
classmethod: System
clearNotifySet

"Remove all of the objects that are currently in the notify set."

self removeAllFromNotifySet: (self notifySet)
%

category: 'Releasing Locks'
classmethod: System
commitOrAbortReleaseLocksSetIncludes: anObject

"Returns true if anObject is in the commit-or-abort release locks set.
 Returns false otherwise."

^(GsBitmap newForHiddenSet: #CommitOrAbortReleaseLocksSet) includes: anObject
%

category: 'Releasing Locks'
classmethod: System
commitReleaseLocksSetIncludes: anObject

"Returns true if anObject is in the commit release locks set.
 Returns false otherwise."

^(GsBitmap newForHiddenSet: #CommitReleaseLocksSet) includes: anObject
%

category: 'Legacy Hidden Set Support'
classmethod: System
compareHiddenSet: first to: second

"Will be deprecated, new code should use GsBitmaps" 

"Compares two hidden sets to determine if they contain the same objects.
 Returns true if the hidden set contents are identical.  Otherwise returns 
 false.  Neither hidden set is modified."
 
 | bm1 bm2 |
 bm1 := (GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: first)).
 bm2 := (GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: second)).
^ bm1 equals: bm2
%

category: 'Legacy Hidden Set Support'
classmethod: System
computeDifferenceOfHiddenSet: first and: second into: third

"Will be deprecated, new code should use GsBitmaps" 

"Add every object to the third hidden set that is in the first and but not the second hidden
 set.  Returns the number of elements added to the third hidden set.
 Should only be used with a third set that is public, sets 41-45.
 User must have permission to modify the third hidden set or be SystemUser."

| bm1 bm2 bm3 |
 bm1 := (GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: first)).
 bm2 := (GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: second)).
 bm3 := (GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: third)).
^ bm3 addAll: (bm1 difference: bm2).
%

category: 'Legacy Hidden Set Support'
classmethod: System
computeUnionOfHiddenSet: first and: second into: third

"Will be deprecated, new code should use GsBitmaps" 

"Add every object to the third hidden set that is in both the first and second hidden
 sets.  Returns the number of elements added to the third hidden set.  
 Should only be used with a third set that is public, sets 41-45.
 User must have permission to modify the third hidden set or be SystemUser."
 
 | bm1 bm2 bm3 |
 bm1 := (GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: first)).
 bm2 := (GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: second)).
 bm3 := (GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: third)).
^ bm3 addAll: (bm1 intersect: bm2).
%

category: 'Notification'
classmethod: System
disableSignaledObjectsError

"Disable the generation of an error when a member of the notify set
 is added to the signaled objects set."

self _updateSignalErrorStatus: 1 toState: false
%

category: 'Notification'
classmethod: System
enableSignaledObjectsError

"Enable the signalling of an ObjectsCommittedNotification exception when
 a member of the notify set is added to the signaled objects set.
 When a ObjectsCommittedNotification is signalled, further signalling
 is disabled to allow the exception handler to run without receiving
 another signal.  Therefore, the handler for ObjectsCommittedNotification
 should itself send enableSignaledObjectsError"

self _updateSignalErrorStatus: 1 toState: true
%

category: 'Gci Set Support'
classmethod: System
getAndClearGciDirtySet: hiddenSetSpecifier into: anArray

"Destructively enumerate a GCI hidden set, where
   anInt = 22  specifies ExportedDirtyObjs
   anInt = 23  specifies TrackedDirtyObjs .
 Other values of hiddenSetSpecifier are not allowed .

 Corresponding gciTrackedObjsInit or gciDirtyObjsInit must have been 
 sent once during the session before this method can be used.  It is 
 intended that either this method or Gci calls be used to enumerate 
 these hidden sets, not both within one session.  

 If the specified set is empty the result is nil.
 Otherwise the result is an Array containing up to the first 2034 elements 
 of the hidden set, and those element are cleared from the hidden 
 set prior to return from the primitive.   If the set contains
 more than 2034 elements, repeated invocation of this method
 is needed to enumerate the set completely.

 anArray may be nil in which case the result is a newly created Array.
 If anArray is non-nil it is used as the result and is grown as needed.

 For most efficient enumeration use this style:
   [ | arr |
     arr := self _getAndClearGciDirtySet:22 into: arr .
     1 to: arr size do:[:j | |aDirtyObj|
       aDirtyObj := arr at: j .
       aDirtyObj applicationHandleDirtyObj  .
     ].
     arr size == 0 .
   ] untilTrue .
 "
^ self _getAndClearGciDirtySet: hiddenSetSpecifier into: anArray
%

category: 'Legacy Hidden Set Support'
classmethod: System
hiddenSet: hiddenSetSpecifier do: aBlock

"Will be deprecated, new code should use GsBitmaps" 

"Executes the one argument block aBlock for each argument
 in the specified hidden set.  Does a destructive enumerate
 of the hidden set. 
 Should only be used with public hidden sets 41-45.
 Returns the number of objects enumerated."

 | bm count |
 bm := (GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: hiddenSetSpecifier)).
 count := bm do: aBlock.
 bm removeAll. 
 ^ count
%

category: 'Legacy Hidden Set Support'
classmethod: System
hiddenSetAsArray: hiddenSetSpecifier

"Will be deprecated, new code should use GsBitmaps"

"Returns an Array containing the contents of the hiddenSet."

^ (GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: hiddenSetSpecifier)) asArray
%

category: 'Legacy Hidden Set Support'
classmethod: System
hiddenSetEnumerate: hiddenSetSpecifier limit: maxResultSize

"Will be deprecated, new code should use GsBitmaps"

"Returns an Array containing the first maxResultSize objects
 in the hiddenSet.  If the hidden set contains fewer than
 maxResultSize elements, returns an array containing
 the contents of the hiddenSet. If maxResultSize = 0, the result
 will contain all elements of the hidden set.

 All of the returned elements are removed from the hidden set.
 Should only be used with public hidden sets 41-45."

  | bm arr |
  bm := (GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: hiddenSetSpecifier)).
  arr := bm enumerateWithLimit: maxResultSize startingAfter: 0.
  bm removeAll: arr.
^arr
%

category: 'Legacy Hidden Set Support'
classmethod: System
hiddenSetEnumerateAsInts: hiddenSetSpecifier limit: maxResultSize

"Will be deprecated, new code should use GsBitmaps"

"Returns an Array containing the numeric object identifiers of the
 first maxResultSize objects in the hiddenSet.  If the hidden set
 contains fewer than maxResultSize elements, returns an array containing
 the contents of the hiddenSet.  If maxResultSize = 0, the result will
 contain all elements of the hidden set.

 All of the returned elements are removed from the hidden set.
 Should only be used with public hidden sets 41-45."

  | bm arr arr1|
  bm := (GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: hiddenSetSpecifier)).
  arr := bm enumerateAsOopsWithLimit: maxResultSize startingAfter: 0.
  arr1 := bm enumerateWithLimit: maxResultSize startingAfter: 0.
  bm removeAll: arr1.
^arr
%

category: 'Legacy Hidden Set Support'
classmethod: System
hiddenSetReinit: hiddenSetSpecifier

"Will be deprecated, new code should use GsBitmaps" 

"Reinitializes the hiddenSet to empty.  
 Should only be used with public hidden sets 41-45."

^ (GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: hiddenSetSpecifier)) removeAll
%

category: 'Legacy Hidden Set Support'
classmethod: System
hiddenSetSize: hiddenSetSpecifier

"Will be deprecated, new code should use GsBitmaps" 

" Returns the number of elments in the hiddenSet."

^ (GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: hiddenSetSpecifier)) size
%

category: 'Private - Hidden Set'
classmethod: System
HiddenSetSpecifiers

"See GsBitmap hiddenSetSpecifiers for new public implementation.

Returns a list of the hidden set specifiers ordered by index.

Hidden sets with index 41 through 45 are for customer use and may be
freely modified using methods in this category.

Other hidden sets are used internally by the system.  Many of them may
only be modifed by SystemUser; others may be accessed using specific
public protocol. Modifying internal hidden sets improperly may result
in gem and/or stone crashes and could potentially corrupt the database."

^#(
" 1"   'ListInstancesResult'
" 2"   'Reserved for GemStone Indexing maintenance'
" 3"   'RemovedDepMapEntries'
" 4"   'SaveNewPomObjs' "See method #_enableTraceNewPomObjs"
" 5"   'ObjectsRead'    "See method #_enableTraceObjectsRead"
" 6"   'Reserved for GemStone'
" 7"   'RcReadSet'
" 8"   'DepMapWriteSet'
" 9"   'PomWriteSet'  "Empty except after flush for commit, so only useful
                       after you get a transaction conflict."
"10"   'SaveDepMapChangedObjs'
"11"   'SaveWriteSetUnion'
"12"   'SaveWrittenObjs'
"13"   'ReadWriteConflicts'  "StrongRead-Write conflicts "
"14"   'SaveDepMapChangedUnion'
"15"   'WriteWriteConflicts'
"16"   'WriteDependencyConflicts'
"17"   'WriteReadLockConflicts'
"18"   'WriteWriteLockConflicts'
"19"   'Reserved for GemStone'
"20"   'AllocatedGciOops'
"21"   'Reserved for GemStone'
"22"   'ExportedDirtyObjs'
"23"   'TrackedDirtyObjs'
"24"   'enumeration of ReferencedSet'
"25"   'NotifySet'
"26"   'Reserved1' "used in Conversion"
"27"   'Reserved2' "used in managing depList weak references"
"28"   'Reserved3' "used in object inventory"
"29"   'CommitReleaseLocksSet'
"30"   'CommitOrAbortReleaseLocksSet'
"31"   'Reserved for GemStone'
"32"   'Reserved for GemStone'
"33"   'Reserved for GemStone'
"34"   'GcCandidates'
"35"   'Unused'
"36"   'WriteLockWriteSubset'
"37"   'NewDataPages'
"38"   'StrongReadSet'
"39"   'PureExportSet'
"40"   'GciTrackedObjs'
"41"   'Customer1'
"42"   'Customer2'
"43"   'Customer3'
"44"   'Customer4'
"45"   'Customer5' 
)
%

category: 'Notification'
classmethod: System
notifySet

"Returns an Array of the objects that were registered for notification."

^(GsBitmap newForHiddenSet: #NotifySet) asArray
%

category: 'Legacy Hidden Set Support'
classmethod: System
readHiddenSet: hiddenSetSpecifier fromFile: aString

"Will be deprecated, new code should use GsBitmaps" 

"Format of the file has changed between Gs64 v3.4 and v3.5.

 Read the contents of the specified bitmap file into the designated hidden 
 set.  The file must exist and  be readable by the gem process.   
 Should only be used with public hidden sets 41-45. 
 Call System class >> hiddenSetReinit: first to ensure the hidden set is empty.  
 Returns true if successful, false if an error occurred.  Additional error 
 information may be written to stderr for the process (either the terminal
 or the gem log file)."

 | bm |
 bm := (GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: hiddenSetSpecifier)).
 (bm isEmpty) ifFalse: [ ^ self _error: #rtErrInvalidArgument args: { 'hidden set is not empty' } ].
 bm readFromFile: aString.
 ^true
%

category: 'Legacy Hidden Set Support'
classmethod: System
readHiddenSet: hiddenSetSpecifier fromSortedFile: aString

"hiddenSetSpecifier must be a Symbol per GsBitmap class >> hiddenSetSpecifiers .
 Format of the file has changed between Gs64 v3.4 and v3.5 .

 Read the contents of the specified sorted bitmap file into the designated
 hidden set. The file must exist and  be readable by the gem process.
 Should only be used with public hidden sets 41-45.
 Call System class >> hiddenSetReinit: first to ensure the hidden set is empty. 
 The file is assumed to be a sorted bitmap file of objects produced by one
 of the Repository>>listInstancesInPageOrder: methods.  The objects are
 loaded into the given hidden set, but the ordering  by page ID is lost
 because hidden sets are always ordered by object ID.  No validation of the
 object IDs is done by this load.

 Returns true if successful, false if an error occurred.  Additional error
 information may be written stderr for the process (either the terminal
 or the gem log file)."

hiddenSetSpecifier _isSymbol ifFalse:[
  Error signal:'Argument must conform to GsBitmap class >> hiddenSetSpecifiers'.
 ].
^self _loadOrStoreHiddenSet: hiddenSetSpecifier toOrFromFile: aString opCode: 2
%

category: 'Gci Set Support'
classmethod: System
remove: anObject fromGciSet: hiddenSetSpecifier 

"Remove the specified object from a GCI hidden set, where
   hiddenSetSpecifier = 39 specifies PureExportSet
   hiddenSetSpecifier = 40 specifies GciTrackedObjs .
 Other values of hiddenSetSpecifier are not allowed.
 Has no effect if anObject is a special object.

 If hiddenSetSpecifier = 39 and a userAction is 
 active an error is generated, since the PureExportSet
 cannot be modified from within a user action.

 If hiddenSetSpecifier = 40 and you have not
 executed System class >> gciTrackedObjsInit once since   login, generates an error." 

^ self _remove: anObject fromGciSet: hiddenSetSpecifier 
%

category: 'Legacy Hidden Set Support'
classmethod: System
remove: anObject fromHiddenSet: hiddenSetSpecifier

"Will be deprecated, new code should use GsBitmaps"

"Removes anObject from the hiddenSet.  Do nothing if anObject is not in
 the hidden set.

 Should only be used with public hidden sets 41-45."

| bm |
  bm := (GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: hiddenSetSpecifier)).
  (bm includes: anObject) ifTrue: [ bm remove: anObject ].
^ self
%

category: 'Gci Set Support'
classmethod: System
removeAll: anArray fromGciSet: hiddenSetSpecifier 

"Remove contents of anArray from a GCI hidden set, where
   hiddenSetSpecifier = 39  specifies PureExportSet
   hiddenSetSpecifier = 40  specifies GciTrackedObjs .
 Other values of hiddenSetSpecifier are not allowed.

 If the argument anArray == true, all objects in
 the specified set are removed from that set .

 If hiddenSetSpecifier = 39 and a userAction is 
 active an error is generated, since the PureExportSet
 cannot be modified from within a user action.

 If hiddenSetSpecifier = 40  and you have not
 executed System class >> gciTrackedObjsInit once since   login, generates an error."

^ self _removeAll: anArray fromGciSet: hiddenSetSpecifier 
%

category: 'Legacy Hidden Set Support'
classmethod: System
removeAll: anArray fromHiddenSet: hiddenSetSpecifier

"Will be deprecated, new code should use GsBitmaps"

"Removes the contents of anArray from the hiddenSet (anArray itself is not
 removed from  the hiddenSet).  Objects in the array which are not in the
 hidden set are ignored. Returns a SmallInteger or LargeInteger indicating
 the number of elements successfully removed from the hidden set.

 Should only be used with public hidden sets 41-45."

^ (GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: hiddenSetSpecifier)) removeAll: anArray
%

category: 'Releasing Locks'
classmethod: System
removeAllFromCommitOrAbortReleaseLocksSet: aCollection

"Remove all the elements of aCollection from the commit-or-abort release
 locks set.  If an element of aCollection is not a member of the set,
 it is ignored."

aCollection accompaniedBy: (GsBitmap newForHiddenSet: #CommitOrAbortReleaseLocksSet)
   do: [:hs :each |  hs removeIfPresent: each ].
^self
%

category: 'Releasing Locks'
classmethod: System
removeAllFromCommitReleaseLocksSet: aCollection

"Remove all elements of aCollection from the commit release locks set.
 If an element of aCollection is not a member of the set, it is ignored."

aCollection accompaniedBy: (GsBitmap newForHiddenSet: #CommitReleaseLocksSet)
   do: [:hs :each |  hs removeIfPresent: each ].
^self
%

category: 'Notification'
classmethod: System
removeAllFromNotifySet: aCollection

"Removes all elements of aCollection from the notify set.  Does not generate an
 error if any of the elements are not in the notify set."

self _updateNotifySet: aCollection add: false
%

category: 'Legacy Hidden Set Support'
classmethod: System
removeContentsOfHiddenSet: first from: second

"Will be deprecated, new code should use GsBitmaps" 

"Remove all objects in the first hidden set from the second hidden set second. 
 Returns the number of objects removed from second hidden set.  
 Should only be used with a second set that is public, sets 41-45.
 User must have permission to modify the second hidden set or be SystemUser."
 
 | bm1 bm2 |
 bm1 := (GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: first)).
 bm2 := (GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: second)).
^ bm2 removeAll: bm1
%

category: 'Legacy Hidden Set Support'
classmethod: System
removeFirst: count objectsFromHiddenSet: hiddenSetSpecifier

"Will be deprecated, new code should use GsBitmaps" 

"Remove the first count objects from the given hidden set.  Objects are removed from
 the beginning, going from lowest to highest object ID.   
 
 Returns the number of objects removed from the hidden set.
 Should only be used with a third set that is public, sets 41-45.
 User must have permission to modify the third hidden set or be SystemUser."
 
^ ((GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: hiddenSetSpecifier)) removeFirst: count) size
%

category: 'Releasing Locks'
classmethod: System
removeFromCommitOrAbortReleaseLocksSet: anObject

"Remove anObject from the commit-or-abort release locks set.  If anObject
 is not a member of the set, do nothing."

(GsBitmap newForHiddenSet: #CommitOrAbortReleaseLocksSet) removeIfPresent: anObject
%

category: 'Releasing Locks'
classmethod: System
removeFromCommitReleaseLocksSet: anObject

"Remove anObject from the commit release locks set.  If anObject is
 not a member of the set, do nothing."

(GsBitmap newForHiddenSet: #CommitReleaseLocksSet) removeIfPresent: anObject
%

category: 'Notification'
classmethod: System
removeFromNotifySet: anObject

"Removes anObject from the notify set.  Does not generate an error if anObject
 is not in the notify set."

self _updateNotifySet: { anObject } add: false
%

category: 'Online Backup Support'
classmethod: System
resumeCommits

    "For use after suspendCommitsForFailover ,
     Resumes commits on a master stone and restarts reclaim gems.
     Returns a DateAndTime representation of the time
     at which commits were suspended (the failover timestamp) .

     Restoring a backup file or   startstone -R
     also have the effect of resuming commits.

     Requires SystemControl privilege."
  | ts |
  ts := self _zeroArgPrim: 156 .
  ts == 0 ifTrue:[ Error signal:'Commits have not been suspended' ].
  ^ DateAndTime posixSeconds: ts offset: Duration zero .
%

category: 'Notification'
classmethod: System
signaledObjects

"Returns an Array containing the objects that have been signaled since the last
 time this method was executed.  The elements in the Array are a subset of the
 notify set.  Clear the set of signaled objects."

<primitive: 365>
self _primitiveFailed: #signaledObjects .
self _uncontinuableError
%

category: 'Notification'
classmethod: System
signaledObjectsErrorStatus

"Returns true to indicate that the system generates errors when objects are
 added to the signaled objects set.  Returns false otherwise."

^self _signalErrorStatus: 1
%

category: 'Online Backup Support'
classmethod: System
suspendCommitsForFailover
   "For use on the master system of a hotstandby pair.
    Suspends commits, starts a checkpoint,
    and waits for completion of the checkpoint.
    Returns a DateAndTime representation of the failover timestamp.
    After this method returns, the master stone may then be shutdown , or
    commits can be resumed with System(C)>>resumeCommits .

    Requires SystemControl privilege.
    If the repository is in restore mode, signals an error, and has no effect.

    While commits are suspended,
      attempts to commit will signal an Exception ,

      reclaim activity is suspended (reclaim gems are stopped)

      markForCollection will signal an Exception when it attempts
      to acquire the gcLock ,

      epochGc will be suspended .

    The state of commits being suspended on a stone will survive shutdown or crash
    and restart of that stone, however the suspendCommits operation is not replayed
    by replay of tranlogs.

    When continuous restore reads a checkpoint containing a failover timestamp
    and the failover timestamp represents a time after the time at which
    the slave stone last started,  continuous restore will stop.
    If the failover timestamp is before the time at which
    the slave stone last started, continuous restore will continue replay
    of the transaction logs.
    The failover timestamp is printed to the slave stone's log,
    and will be returned from restoreStatus  method on the slave system.

    Failover timestamps will be printed to the logsender and logreceiver
    log files when they are read or written by those processes.

    failOverToSlave and suspendCommitsForFailover are mutually exclusive.
    suspendCommitsForFailover is to be used when you want the master system
    to continue running as the master , and the slave system to stop 
    restore from tranlogs at the last commit preceeding suspendCommitsForFailover .    

    failOverToSlave is to be used when you want the master role to move
    to the other system.
"

  | ts |
  ts := self _zeroArgPrim: 155 .
  ^ DateAndTime posixSeconds: ts offset: Duration zero .
%

category: 'Legacy Hidden Set Support'
classmethod: System
testIf: anObject isInHiddenSet: hiddenSetSpecifier

"Will be deprecated, new code should use GsBitmaps"

"Returns true if anObject is in the hiddenSet, false otherwise."

^ (GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: hiddenSetSpecifier)) includes: anObject
%

category: 'Legacy Hidden Set Support'
classmethod: System
truncateHiddenSet: hiddenSetSpecifier toSize: newSize

"Will be deprecated, new code should use GsBitmaps" 

"Truncate the given hidden set by removing objects from the end of the set until it reaches a
 size of newSize.  Objects are removed in order, going from highest to lowest object ID.   
 
 Returns the number of objects removed from the hidden set.
 Should only be used with a third set that is public, sets 41-45.
 User must have permission to modify the third hidden set or be SystemUser."
 
 | bm bmSize count |
 bm := (GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: hiddenSetSpecifier)).
 bmSize := bm size.
 count := bmSize - newSize.
 (count <= 0) ifTrue: [ count := 0].
 bm removeLast: count.
^count
%

category: 'Legacy Hidden Set Support'
classmethod: System
writeHiddenSet: hiddenSetSpecifier toFile: aString

"Will be deprecated, new code should use GsBitmaps" 

"Format of the file has changed between Gs64 v3.4 and v3.5 .

 Write the designated hidden set to the specified bitmap file.  The file 
 must not already exist and the path to the file must be in a directory 
 which is writable by the process.  Any valid hidden set specifier may be 
 used.

 Returns true if successful, false if an error occurred.  Additional error 
 information may be written stderr for the process (either the terminal
 or the gem log file)."

 (GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: hiddenSetSpecifier)) writeToFile: aString.
^ true
%

category: 'Legacy Hidden Set Support'
classmethod: System
writeHiddenSet: hsId toPageOrderFile: aString maxBufferSizeMb: mb
 
"Will be deprecated, new code should use GsBitmaps" 

"Writes the object IDs for objects contained in the given hidden set to a 
 file in page ID order.

 If this session contains uncommitted changes to the repository, the method 
 signals a error: #rtErrAbortWouldLoseData, to indicate that data could be lost.
 Otherwise it puts the session into auto-begin transaction mode and aborts."

| bm arr |

self needsCommit
  ifTrue: [ self _error: #rtErrAbortWouldLoseData ] .

 bm := (GsBitmap newForHiddenSet: (GsBitmap hiddenSetIdAsSymbol: hsId)).
 arr := Array with: (bm writeToFileInPageOrder: aString).
 arr add: 1.
^arr
%

category: 'Private - Hidden Set Support'
classmethod: System
_add: anObject to: hiddenSetSpecifier

"Will be deprecated, new code should use GsBitmaps" 

^ self add: anObject toHiddenSet: hiddenSetSpecifier 
%

category: 'Private Gci Set Support'
classmethod: System
_add: anObject toGciSet: hiddenSetSpecifier 

" needs a comment "

<primitive: 155>
hiddenSetSpecifier _validateClass: SmallInteger .
(hiddenSetSpecifier < 39 or:[ hiddenSetSpecifier > 40]) ifTrue:[
  hiddenSetSpecifier _error: #rtErrArgOutOfRange args:{ 39 . 40 }
].
self _primitiveFailed: #_add:toGciSet: 
     args: { anObject . hiddenSetSpecifier } .
self _uncontinuableError
%

category: 'Private - Hidden Set Support'
classmethod: System
_addAll: anArray to: hiddenSetSpecifier

"Will be deprecated, new code should use GsBitmaps" 

^ self addAll: anArray toHiddenSet: hiddenSetSpecifier
%

category: 'Private Gci Set Support'
classmethod: System
_addAll: anArray toGciSet: hiddenSetSpecifier 

<primitive: 156>
hiddenSetSpecifier _validateClass: SmallInteger .
(hiddenSetSpecifier < 39 or:[ hiddenSetSpecifier > 40]) ifTrue:[
  hiddenSetSpecifier _error: #rtErrArgOutOfRange args:{ 39 . 40 }
].
anArray _validateClass: Array .
self _primitiveFailed: #_addAll:toGciSet: 
     args: { anArray . hiddenSetSpecifier } .
self _uncontinuableError
%

category: 'Private'
classmethod: System
_allErrorMessagesReport

"Private."

| errorSymbolsArray symsWithNoMsg msgsWithNoSym report line errMsgsArray
  firstNil last k |

errorSymbolsArray  := { }  .
ErrorSymbols keysAndValuesDo:[:aSym :aNum |
  aNum > errorSymbolsArray size ifTrue:[ errorSymbolsArray size: aNum ].
  (errorSymbolsArray at: aNum) ifNotNil:[
    self _halt:'Duplicate symbol for error number ' , aNum asString .
  ].
  errorSymbolsArray at: aNum put: aSym .
].
errMsgsArray := GemStoneError at: #English .
msgsWithNoSym := String new .
symsWithNoMsg := String new .
(report := String new) lf .

report add:'ERROR MESSAGES STORED IN THE REPOSITORY:'; lf; lf .
1 to: errorSymbolsArray size do:[:j | | msgParts aSym |
  aSym := errorSymbolsArray at: j .
  msgParts := errMsgsArray at: j .
  aSym ifNil:[
    msgParts ifNotNil:[
       msgsWithNoSym addAll: '*** No error symbol for error number ';
		addAll: j asString; lf .
    ]
  ] ifNotNil:[
    msgParts ifNil:[
       symsWithNoMsg addAll: '*** No message for error symbol #';
		addAll: aSym quoted; lf .
    ] ifNotNil:[
       line := j asString.
       line addAll: ', #' ; addAll: aSym; addAll: ' :  ' ;
            addAll: (self _messageForErrorNum: j)  .
       report addAll: (line _wrapTo: 80 indentingWith: '    '); lf .
     ]
  ].
].

report lf ; add:
'Error mapping to Ansi Exception classes,
message text is generated during Exception signaling.' ; lf .
1 to: errorSymbolsArray size do:[:m |
  (errorSymbolsArray at: m) ifNil:[
    (LegacyErrNumMap at: m) ifNotNil:[:elem |
      elem _isArray ifTrue:[
        (elem size == 3 ifTrue:[ { elem at: 1 } ] ifFalse:[ elem at: 4 ])
          do:[:cls | report add:'  '; add: m asString ; add: ' --> ' ; add: cls name ; lf ]
      ]
    ]
  ]
].

report lf ; add:
'ERROR MESSAGES FROM errmsg.c, TEXT FROM errmsg.ht '; lf ;
add: '  (Repository message followed by errmsg.ht message, if any)'; lf; lf .

1 to: errorSymbolsArray size do:[:j | | msgFN |
  (errorSymbolsArray at: j) ifNotNil:[ :aSym |
    (self _internalMessageForErrorNum: j) ifNotNil:[ :internalMsg |
      msgFN := self _messageForErrorNum: j .
      msgFN ifNil:[ msgFN := 'NO MESSAGE FOR NUMBER ' , j asString ].
      (line := j asString) add: ', #' ; add: aSym; add: ' :  ' ;
           add: msgFN ; lf ; add: internalMsg .
      report add: (line _wrapTo: 80 indentingWith: '    '); lf; lf.
    ].
  ].
].

report lf ; add:'UNUSED ERROR NUMBERS:'; lf .
firstNil := 1 .
k := 1.
last := errorSymbolsArray size .
[k < last] whileTrue:[
  [ (errorSymbolsArray at: k) == nil and:[k < last] ] whileTrue:[ k := k + 1 ].
  k > firstNil ifTrue:[
    report add: firstNil asString ; add: ' to: ';
		add: (k - 1) asString; lf .
  ] ifFalse:[
    report add: firstNil asString; lf .
  ].
  firstNil := nil .
  [ (errorSymbolsArray at: k) ~~ nil and:[k < last] ] whileTrue:[ k := k + 1 ].
  firstNil := k .
].

report lf .
msgsWithNoSym size ~~ 0
  ifTrue:[ report add: msgsWithNoSym ]
  ifFalse:[ report add:'No messages found without an error symbol.'].
report lf .
symsWithNoMsg size ~~ 0
  ifTrue:[ report add: symsWithNoMsg ]
  ifFalse:[ report add: 'No error symbols found without a message.'].
report lf .
^ report
%

category: 'Private'
classmethod: System
_conflictsReport: aBoolean withDetails: detailsBool

"If aBoolean true, 
 include conflict sets even if commit result read-only or success.
 Returns an Array describing conflicts or success of the last attempted commit.

 First element of the Array is a symbol describing the comit status.
 If detailsBool == false
   Second element is nil .
   Remaining elements of the Array are one or more triples
      conflictKindSymbol .  Array of objects in conflict .  nil

 If  detailsBool == true   and
 (self gemConfigurationAt: #GemCommitConflictDetails) == true 
 then
   Second element is a DateAndTime of the attempted commit.
   Remaining elements of the Array are one or more triples
     conflictKindSymbol .  Array of objects in conflict .  SessionsArray

   A SessionsArray is composed of one or more pairs
     String describing the session 
     Array of objects written by that session .
"
| status res detailedConflicts |

status := self _commitResult + 2  .
res :=  { }  .
res add: ( #( #readOnly  		"must agree with _commitResult method"
		 #success 
		 #rcFailure 
	         #dependencyFailure 
                 #failure 
		 #retryFailure
                 #commitDisallowed
                 #retryLimitExceeded
		 #symbolFailure
		 #lockFailure
		 ) at:  status )  .

( detailsBool and:[ self _gemCommitConflictDetails and:[ status >= 1 ]]) ifTrue:[
  detailedConflicts := self _detailedConflicts . 
].
detailedConflicts ifNotNil:[ | timeStr |
  (detailedConflicts at: 1) ifNotNil:[:tm |
     timeStr := (DateAndTime posixSeconds: tm asFloat / 1000 offset: nil) asStringMs
  ].
  res add: 'Attempt to commit at: ', (timeStr ifNil:[ '(Time not available)' ]) .
] ifNil:[ res add: nil ].

(status > 2 or:[ aBoolean]) ifTrue:[
  | blk blk3 wwConflicts rcReadSet rcObject sess rcRetryFailureReason rcRetryFailureDescription |

  blk := [ :key :setNum | | anArr |
     (self hiddenSetSize: setNum) > 0 ifTrue:[
        res add: key ; add:( anArr:= self hiddenSetAsArray: setNum) .
        res add: nil . "never any session details for these keys"
     ].
     anArr .
  ].
  blk3 := [ :key :setNum :details | | anArr |
     (self hiddenSetSize: setNum) > 0 ifTrue:[ | sesArray |
        res add: key ; add:( anArr:= self hiddenSetAsArray: setNum) .
        sesArray := nil . "Pairs of commitDescrString  { objs }" 
        details ifNotNil:[  | dOfs |
          dOfs :=  setNum == 15 ifTrue:[ 4 "w-w"] ifFalse:[ 5 "w-dep" ].
          2 to: details size do:[:dx | | dElem ww str tim | 
            dElem := details at: dx .
            (ww := dElem atOrNil: dOfs ) ifNotNil:[
              (str := 'session ' copy) add: (dElem at: 1) asString .
              tim := DateAndTime posixSeconds:(dElem at: 2) asFloat / 1000 offset: nil .  
              str add: ' at '; add: tim asStringMs ;
                  add: ' userId '; 
                  add: ((dElem at: 3) ifNil:[ 'unknown'] ifNotNil:[:up | up userId ]).
              sesArray ifNil:[ sesArray := { } ].
              sesArray add: str ; add: ww .
            ]
          ].
        ]. 
        res add: sesArray .
     ].
     anArr .
  ].

  blk value:#'Read-Write' value: 13 . "StrongRead - Write conflicts"
  wwConflicts := blk3 value:#'Write-Write' value: 15 value: detailedConflicts  .

  rcReadSet := blk value:#'RcReadSet' value: 7 .
  (wwConflicts size ~~ 0 and:[rcReadSet size ~~ 0]) ifTrue:[
    res add:#'WriteWrite_minusRcReadSet' ; 
      add:(Array withAll:(IdentitySet withAll: wwConflicts) - (IdentitySet withAll: rcReadSet));
      add: nil. "RcReadSet is for this session only, never other sessions info"
  ].
  blk3 value: #'Write-Dependency' value: 16 value: detailedConflicts .
  blk value: #'Write-ReadLock' value: 17 .
  blk value: #'Write-WriteLock' value: 18 .
  rcObject := self rcValueCacheAt: #'Rc-Write-Write' for: self otherwise: nil.
  rcObject ifNotNil:[ 
      res add: #'Rc-Write-Write' ; add: { rcObject }; add: nil .

  rcRetryFailureReason := self rcValueCacheAt: #'Rc-Retry-Failure-Reason' for: self otherwise: nil.
  rcRetryFailureReason ifNotNil:[ 
      res add: #'Rc-Retry-Failure-Reason' ; add: { rcRetryFailureReason } ; add: nil ].
  rcRetryFailureDescription := self rcValueCacheAt: #'Rc-Retry-Failure-Description' for: self otherwise: nil.
  rcRetryFailureDescription ifNotNil:[ 
      res add: #'Rc-Retry-Failure-Description' ; add: { rcRetryFailureDescription } ; add: nil ]
  ].
  sess := self rcValueCacheAt: #'Synchronized-Commit' for: self otherwise: nil.
  sess ifNotNil: [
      res add: #'Synchronized-Commit' ; add: { sess }; add: nil .
  ].
].
^ res
%

category: 'Debugging Support'
classmethod: System
_disableTraceNewPomObjs
"Causes the system to discontinue adding newly committed objects
 to hidden set SaveWriteSetUnion immediately after they are committed.  Does not
 modify the state of hidden set SaveWriteSetUnion."
^ self _zeroArgPrim: 76
%

category: 'Debugging Support'
classmethod: System
_disableTraceObjectsRead

"Disables tracing of object read-faults , if it is enabled, and flushes
 any remaining trace buffers into hidden set ObjectsRead
 Returns the size of hidden set ObjectsRead after flushing the buffers.

 If tracing of object read-faults was not enabled, returns 0 ."


^ self _zeroArgPrim: 97
%

category: 'Debugging Support'
classmethod: System
_disableTracePagesAccessed

"Disables tracing of page read accesses  , if it is enabled, and flushes
 any remaining trace buffers into hidden set 5.
 Returns the size of hidden set 5 after flushing the buffers.

 If tracing of page read accesses was not enabled, returns 0 ."


^ self _zeroArgPrim: 128
%

category: 'Debugging Support'
classmethod: System
_enableTraceNewPomObjs
"Causes all newly committed objects to be added to hidden set SaveWriteSetUnion
 immediately after they are committed.  Also causes hidden set SaveWriteSetUnion
 to be cleared if tracing was previously disabled when this method
 is called."
^ self _zeroArgPrim: 75
%

category: 'Debugging Support'
classmethod: System
_enableTraceObjectsRead

"Enables tracing of object read-faults, i.e. committed objects that are copied
 into the VM's memory.   Cancels any previous _enableTracePagesRead ,
 only one of _enableTraceObjectsRead or _enableTracePagesRead can be active
 at a time.

 Object read-faults are accumulated in internal buffers, which
 are flushed to hidden set ObjectsRead each time the PomGenScavCount
 statistic increments.
 Use the method _updateObjectsRead to explicitly flush buffers into
 hidden set ObjectsRead.

 If tracing was previously enabled, this method clears hidden set ObjectsRead.

 Note that hidden set ObjectsRead is an identity set, and if the same object
 is read multiple times during an interval defined by _enableTraceObjectsRead,
 _disableTraceObjectsRead, due to wraparound of the memory area holding
 committed objects , that object will only show up once in the set .
 Changes in the statistic ObjectsRead  can be compared to changes in the
 set size to detect multiple reads of objects.
 Also note the statistic ObjectsRefreshed , which represents re-reads
 of objects to obtain new views after crossing transaction boundaries;
 re-reads.

 Hidden set ObjectsRead is in C heap memory ; this process could run out of C heap memory
 if this tracing is left enabled for a very long time on a large repository.
 Memory consumption varys from approximately 8 bytes per object for small sets
 to 1 bit per object for sets spanning the entire shared object table.

 Returns self."

^ self _zeroArgPrim: 99
%

category: 'Debugging Support'
classmethod: System
_enableTracePagesAccessed

"Enables tracing of page read accesses.
 A  'page read access'  is a page in the shared cache which was accessed
 the data source to satisfy an object read-fault .  Page accesses for
 object table lookups are not included.

 Cancels any previous _enableTraceObjectsRead , only one of
 _enableTraceObjectsRead or _enableTracePagesAccessed can be active at a time.

 PageIds of pages accessed are accumulated in internal buffers, which
 are flushed to hidden set 5  approximately every 200 page read accesses.
 Use the method _updatePagesAccessed to explicitly flush buffers into
 hidden set 5 .

 If tracing was previously enabled, this method clears hidden set 5 .

 Note that hidden set 5 is an identity set, and if the same page
 is read multiple times during an interval defined by _enableTracePagesAccessed,
 _disableTracePagesAccessed, that page will only show up once in the set .

 Hidden set 5 is in C heap memory ; this process could run out of C heap memory
 if this tracing is left enabled for a very long time on a large repository.
 Memory consumption varys from approximately 8 bytes per page for small sets
 to 1 bit per page for sets spanning the entire shared object table.

 Returns self."

^ self _zeroArgPrim: 125
%

category: 'Private Gci Set Support'
classmethod: System
_gciDirtyInit: hiddenSetSpecifier

"Enable GCI tracking of dirty objects.
   hiddenSetSpecifier = 22, equivalent to GciDirtyObjsInit()
   hiddenSetSpecifier = 23, equivalent GciTrackedObjsInit()
 Other values of hiddenSetSpecifier are not allowed."

<primitive: 164>
hiddenSetSpecifier _validateClass: SmallInteger .
(hiddenSetSpecifier < 22 or:[ hiddenSetSpecifier > 23]) ifTrue:[
  hiddenSetSpecifier _error: #rtErrArgOutOfRange args:{ 22 . 23 }
].
self _primitiveFailed: #_gciDirtyInit: args: { hiddenSetSpecifier } .
self _uncontinuableError
%

category: 'Private Gci Set Support'
classmethod: System
_getAndClearGciDirtySet: hiddenSetSpecifier into: anArray

<primitive: 162>
hiddenSetSpecifier _validateClass: SmallInteger .
(hiddenSetSpecifier < 22 or:[ hiddenSetSpecifier > 23]) ifTrue:[
  hiddenSetSpecifier _error: #rtErrArgOutOfRange args:{ 22 . 23 }
].
anArray ~~ nil ifTrue:[ anArray _validateClass: Array ].
self _primitiveFailed: #_getAndClearGciDirtySet:into:
     args: { hiddenSetSpecifier . anArray } .
self _uncontinuableError
%

category: 'Reduced Conflict Support'
classmethod: System
_getRedoAndConflictObjects

"Builds a list of objects that need to be scanned because they need to
 have conflicts resolved.  If the result array is empty, then the transaction
 has conflicts that cannot be resolved because we should only get here if
 some Rc conflicts have been detected."
          
| wwConflicts redoLog result |
     
	" Gs64 v2.0 optimization, access the hidden sets directly 
  	instead of computing complete transaction conflicts info."

" if there are read-write and write-read conflicts, we cannot resolve them "
"check for #'Read-Write' , i.e. strongRead-write conflicts "
((GsBitmap newForHiddenSet: #ReadWriteConflicts) size) > 0 ifTrue:[
  "cannot resolve strongRead-write conflicts. The Read-Write conflict
   has already had RcReadSet subtracted from it by the commit primitive."
  ^ nil  
].
" check for #'Write-Dependency' conflicts"
((GsBitmap newForHiddenSet: #WriteDependencyConflicts) size) > 0 ifTrue:[
  "cannot resolve write-dependency conflicts. "
  ^ nil  
].

wwConflicts := (GsBitmap newForHiddenSet: #WriteWriteConflicts) asArray.
wwConflicts size == 0 ifTrue: [ 
  "expected to find write-write conflicts to resolve, so fail"
  ^ nil 
].
result := { } .
redoLog := self _redoLog.
redoLog ifNil:[
  " no redo log, treat objects themselves as the one on which conflicts
        must be resolved "
  1 to: wwConflicts size do: [ :i | | conflictObject |
    conflictObject := wwConflicts at: i.
    result add: conflictObject ; add: { conflictObject }.
  ].
] ifNotNil:[ | conflictObject |
  1 to: wwConflicts size do: [ :i | | redoObject |
    conflictObject := wwConflicts at: i.
  
    " get the object that has to be replayed due to this conflict "
    redoObject := redoLog getRedoObjectForConflictingObject: conflictObject.
    redoObject ifNil:[
      conflictObject isInternalObject ifTrue:[
        "a leaf node that will be taken care of by replay of a parent"
      ] ifFalse:[ "RcPipe component or similar"
        (result includesIdentical: redoObject) ifFalse:[
          result add: conflictObject ; add: { conflictObject }.
        ] 
      ].
    ] ifNotNil:[  | idx |
      (idx := result indexOfIdentical: redoObject) ~~ 0 ifTrue: [ 
	(result at: idx + 1) add: conflictObject.
      ] ifFalse:[
	result add: redoObject ; add: { conflictObject }.
      ].
    ].
  ].
].
^ result
%

category: 'Private - Hidden Set Support'
classmethod: System
_hiddenSetAsArray: hiddenSetSpecifier

"Will be deprecated, new code should use GsBitmaps" 

^ self hiddenSetAsArray: hiddenSetSpecifier
%

category: 'Private - Hidden Set Support'
classmethod: System
_hiddenSetEnumerate: hiddenSetSpecifier limit: maxResultSize

"Will be deprecated, new code should use GsBitmaps" 

^ self hiddenSetEnumerate: hiddenSetSpecifier limit: maxResultSize
%

category: 'Private - Hidden Set Support'
classmethod: System
_hiddenSetEnumerateAsInts: hiddenSetSpecifier limit: maxResultSize

"Will be deprecated, new code should use GsBitmaps"

^ self hiddenSetEnumerateAsInts: hiddenSetSpecifier limit: maxResultSize
%

category: 'Private - Hidden Set Support'
classmethod: System
_hiddenSetReinit: hiddenSetSpecifier

"Will be deprecated, new code should use GsBitmaps"

^ self hiddenSetReinit: hiddenSetSpecifier
%

category: 'Private - Hidden Set Support'
classmethod: System
_hiddenSetSize: hiddenSetSpecifier

"Will be deprecated, new code should use GsBitmaps"

^ self hiddenSetSize: hiddenSetSpecifier
%

category: 'Private - Hidden Set'
classmethod: System
_loadOrStoreHiddenSet: hiddenSetSpecifier toOrFromFile: aString opCode: anOpCode

"Performs hidden set to bitmap file operations.

 ONLY supports hiddenSetSpecifiesrs from GsBitmap as Symbols

 If anOpCode is zero, read the given bitmap file into the given hidden set.
 The file must exist and be readable by the gem process.  hiddenSetSpecifier
 must be the index of a hidden set that is modifiable by customers.
 This check is bypassed if the session is logged in as SystemUser.  Extreme
 caution should be used in this case.  
 Be sure to call (GsBitmap newForHiddenSet: hiddenSetSpecifier) removeAll
   first to ensure the hidden set is empty.

 If anOpCode is one, then the given hidden set is written to the specified
 bitmap file.  The file must not already exist and the path to the file must
 be in a directory which is writable by the process.  Any valid hidden set
 specifier may be used in this case.

 If anOpCode is two, then the file is assumed to be a sorted bitmap file
 of objects produced by one of the Repository>>listInstancesInPageOrder:
 methods.  The objects are loaded into the given hidden set, but the ordering
 by page ID is lost because hidden sets are always ordered by object ID.
 No validation of the object IDs is done by this load.

 Returns true if successful, false if an error occurred.  Additional error
 information may be written stderr for the process (either the terminal
 or the gem log file)."

| bitmap |
aString _validateKindOfClass: String.
anOpCode _validateClass: SmallInteger.

bitmap := GsBitmap newForHiddenSet: hiddenSetSpecifier.
anOpCode = 0 ifTrue: [ bitmap readFromFile: aString. ^ true ].
anOpCode = 1 ifTrue: [ bitmap writeToFile: aString. ^ true ].

anOpCode > 1 ifTrue: [ Error signal:'opCode ' , anOpCode asString , ' not supported' ].
%

category: 'Private - Hidden Set Support'
classmethod: System
_performSetArithmeticOnHiddenSets: first and: second storeResultsInto: third opCode: anOpCode

"Will be deprecated, new code should use GsBitmaps"

"Perform a set arithmetic operation on the hidden sets with the specifiers
 given by first and second and possiblly store the results into third.
 The behavior of this primitive is as follows:

 opCode 	Operation	 Result stored in third
 =================================================================
 0		Add		 Not used, third expected to be 0.
 1		Subtract	 Not used, third expected to be 0.
 2		Union 		 result of the union
 3		Difference	 result of difference
 4		Clear from start Not used
 5		Clear from end   Not used
 6		Compare          Not used
 =================================================================
"

(anOpCode == 0) ifTrue: [ ^ self addHiddenSet: first to: second ].
(anOpCode == 1) ifTrue: [ ^ self removeContentsOfHiddenSet: first from: second ].
(anOpCode == 2) ifTrue: [ ^ self computeUnionOfHiddenSet: first and: second into: third ].
(anOpCode == 3) ifTrue: [ ^ self computeDifferenceOfHiddenSet: first and: second into: third ].
(anOpCode == 4) ifTrue: [ ^ self removeFirst: second objectsFromHiddenSet: first ].
(anOpCode == 5) ifTrue: [ ^ self truncateHiddenSet: first toSize: second ].
(anOpCode == 6) ifTrue: [ ^ self compareHiddenSet: first to: second ].
%

category: 'Private - Hidden Set Support'
classmethod: System
_primHiddenSetEnumerate: hiddenSetSpecifier limit: maxResultSize storeAsInts: aBool

"Will be deprecated, new code should use GsBitmaps"

aBool ifTrue: [ ^ self hiddenSetEnumerateAsInts: hiddenSetSpecifier limit: maxResultSize ]
      ifFalse: [ ^ self hiddenSetEnumerate: hiddenSetSpecifier limit: maxResultSize ]
%

category: 'Legacy Hidden Set Support'
classmethod: System
_remove: anObject from: hiddenSetSpecifier

"Will be deprecated, new code should use GsBitmaps"

^ self remove: anObject fromHiddenSet: hiddenSetSpecifier
%

category: 'Private Gci Set Support'
classmethod: System
_remove: anObject fromGciSet: hiddenSetSpecifier 

<primitive: 157>
hiddenSetSpecifier _validateClass: SmallInteger .
(hiddenSetSpecifier < 39 or:[ hiddenSetSpecifier > 40]) ifTrue:[
  hiddenSetSpecifier _error: #rtErrArgOutOfRange args:{ 39 . 40 }
].
self _primitiveFailed: #_remove:fromGciSet: 
     args: { anObject . hiddenSetSpecifier } .
self _uncontinuableError
%

category: 'Legacy Hidden Set Support'
classmethod: System
_removeAll: anArray from: hiddenSetSpecifier

"Will be deprecated, new code should use GsBitmaps"

^ self removeAll: anArray fromHiddenSet: hiddenSetSpecifier
%

category: 'Private Gci Set Support'
classmethod: System
_removeAll: anArray fromGciSet: hiddenSetSpecifier 

<primitive: 158>
hiddenSetSpecifier _validateClass: SmallInteger .
(hiddenSetSpecifier < 39 or:[ hiddenSetSpecifier > 40]) ifTrue:[
  hiddenSetSpecifier _error: #rtErrArgOutOfRange args:{ 39 . 40 }
].
anArray _validateClass: Array .
self _primitiveFailed: #_removeAll:fromGciSet:
     args: { anArray . hiddenSetSpecifier } .
self _uncontinuableError
%

category: 'Debugging Support'
classmethod: System
_resumeTraceObjectsRead

"Resumes tracing of object read-faults .
 Generates an error if hidden set ObjectsRead was most recently intialized by
 a _enableTracePagesAccessed .

 Same as _enableTraceObjectsRead, but does not clear hidden set ObjectsRead .
 If tracing of object read-faults was already enabled, flushes the
 trace buffers into hidden set ObjectsRead.

 Returns the current size of hidden set ObjectsRead."

^ self _zeroArgPrim: 98
%

category: 'Debugging Support'
classmethod: System
_resumeTracePagesAccessed

"Resumes tracing of page read accesses.
 Generates an error if hidden set 5 was most recently intialized by
 a _enableTraceReadFaults .

 Same as _enableTracePagesAccessed, but does not clear hidden set 5 .
 If tracing of page read accesses was already enabled, flushes the
 trace buffers into hidden set 5 .

 Returns the current size of hidden set 5."

^ self _zeroArgPrim:126
%

category: 'Private - Hidden Set Support'
classmethod: System
_testIf: anObject isIn: hiddenSetSpecifier

"Will be deprecated, new code should use GsBitmaps"

^ self testIf: anObject isInHiddenSet: hiddenSetSpecifier
%

category: 'Notification'
classmethod: System
_updateNotifySet: aCollection add: aBoolean

"Update the notify set by adding or removing the elements of the anArray to or
 from the set.  If aBoolean is true, the elements are added, otherwise they are
 removed."

<primitive: 363>
| anArray |
anArray := aCollection asArray.
anArray == aCollection ifFalse:[
  ^ self _updateNotifySet: anArray add: aBoolean
  ] .
aCollection _validateClasses: { Array . IdentityBag }.
self _primitiveFailed: #_updateNotifySet:add:
     args: { aCollection . aBoolean } .
self _uncontinuableError
%

category: 'Debugging Support'
classmethod: System
_updateObjectsRead

"If tracing of object read-faults has been enabled by executing
 _enableTraceObjectsRead , flushes internal tracing buffers into
 hidden set ObjectsRead.
 Returns the size of hidden set ObjectsRead, after flushing the buffers.

 If tracing of object read-faults is not enabled,
 or is currently disabled via _disableTraceObjectsRead , returns 0 ."

^ self _zeroArgPrim: 96
%

category: 'Debugging Support'
classmethod: System
_updatePagesAccessed

"If tracing of page read accesses has been enabled by executing
 _enableTracePagesAccessed ,   flushes internal tracing buffers into
 hidden set 5 .
 Returns the size of hidden set 5, after flushing the buffers.

 If tracing of page read accesses not enabled,
 or is currently disabled via _disableTracePagesAccessed, returns 0 ."


^ self _zeroArgPrim: 12
%

category: 'Private - Hidden Set Support'
classmethod: System
_writeHiddenSet: hsId toPageOrderFile: aString maxBufferSizeMb: mb

"Will be deprecated, new code should use GsBitmaps"

"Writes the object IDs for objects contained in the given hidden set to a 
 file in page ID order.
 
 The hsid argument must be a SmallInteger indicating a hidden set id.  
 See the method System>>HiddenSetSpecifiers for a list of hidden set
 identifiers. The hidden set is not modified by this method.  It is an
 error if the hidden set is empty.

 aString must be the full path to a new file on the gem's host system 
 which will be created by this method.  It is an error if the file
 already exists.

 This method creates a temporary memory buffer used to sort objects by page ID.
 The mb argument specifies the maximum number of megabytes of memory to request
 from the operating system.  A value of 0 means the amount of memory to request
 is not limited.  Negative values are not allowed.

 The contents of the result file are guaranteed to be in page-order if, 
 and only if the method was able to acquire enough memory to sort the entire
 hidden set by page ID.  Less than the optimial amount of memory may be 
 available because of limits imposed by the mb argument, or the operating
 system.  In such cases where the optimal amount of memory is not available,
 the method will still succeed, however only parts of the result file
 will be in page order.   Methods that read page-ordered files (see list
 below) will still operate correctly on files with multiple page-ordered 
 sections.  The optimal memory buffer size is approximately 10 bytes per
 object ID contained in the hidden set.

 The result file size will be approximately 5 bytes for each object in the 
 hidden set, plus 24 bytes.  For example: for a hidden set which contains 
 10 million objects, this method will generate a file approximately
 50 megabytes in size.

 The result file may be accessed using the following methods:
   System>>readHiddenSet: hiddenSetSpecifier fromSortedFile: aString
   Repository>>openPageOrderOopFile: aString
   Repository>>readObjectsFromFileWithId: aSmallInt startingAt: startIndex 
               upTo: endIndex into: anArray
   Repository>>numberOfObjectsInPageOrderOopFileWithId: aSmallInt
   Repository>>closePageOrderOopFileWithId: aSmallInt
   Repository>>auditPageOrderOopFileWithId: aSmallInt

 Returns an Array with elements as follows:
  1 - the number of objects written to the file.
  2 - the number of sections in the file ordered by page ID.  This element 
      will be 1 if the optimal amount of memory was available, or greater 
      than 1 if not."
      
 
<primitive: 1022>
hsId _validateClass: SmallInteger .
mb _validateClass: SmallInteger .
aString _validateKindOfClass: String .
^ self _primitiveFailed: #writeHiddenSet:toPageOrderFile:maxBufferSizeMb:
       args: { hsId . aString . mb }
%

! Class extensions for 'TrueClass'

!		Class methods for 'TrueClass'

removeallmethods TrueClass
removeallclassmethods TrueClass

category: 'Instance creation'
classmethod: TrueClass
new
  self shouldNotImplement: #new
%

category: 'Instance creation'
classmethod: TrueClass
new: aSize
  self shouldNotImplement: #new:
%

category: 'Instance creation'
classmethod: TrueClass
_basicNew
  self shouldNotImplement: #_basicNew
%

category: 'Instance creation'
classmethod: TrueClass
_basicNew: aSize
  self shouldNotImplement: #_basicNew:
%

!		Instance methods for 'TrueClass'

category: 'Class Membership'
method: TrueClass
class
  "The environment 0 class is always Boolean"
  ^ Boolean
%

! Class extensions for 'Uint16Array'

!		Class methods for 'Uint16Array'

category: 'Instance Creation'
classmethod: Uint16Array
new: aSize

^ self _basicNew:  aSize * 2
%

!		Instance methods for 'Uint16Array'

category: 'Accessing'
method: Uint16Array
at: anOffset

"Returns a 16 bit unsigned integer as a SmallInteger."

<primitive: 1072>
(anOffset _isSmallInteger)
  ifTrue: [^ self _errorIndexOutOfRange: anOffset]
  ifFalse: [^ self _errorNonIntegerIndex: anOffset].
^ self _primitiveFailed: #at: args: { anOffset } .
%

category: 'Updating'
method: Uint16Array
at: anOffset put: aValue

"aValue must be a SmallInteger representable as a 16bit unsigned integer.
 returns aValue ."

<primitive: 1074>
aValue _validateClass: SmallInteger .
(aValue < 0 or:[ aValue > 65535]) ifTrue:[
  aValue _error: #rtErrArgOutOfRange args:{ 0 . 65535 }
].
(anOffset _isSmallInteger) ifTrue: [
  ((anOffset > (self size + 1)) or: [anOffset < 1]) ifTrue: [
    ^ self _errorIndexOutOfRange: anOffset
  ]
] ifFalse: [
  ^ self _errorNonIntegerIndex: anOffset
] .
self _primitiveFailed: #at:put: args: { anOffset . aValue }
%

category: 'Accessing'
method: Uint16Array
size

"Returns the number of elements in the receiver."

^ self _basicSize // 2.
%

category: 'Updating'
method: Uint16Array
size: anInteger

"Changes the size of the receiver to anInteger.

 If anInteger is less than the current size of the receiver, the receiver is
 shrunk accordingly.  If anInteger is greater than the current size of the
 receiver, the receiver is extended and new elements are initialized to zero."

^ super _basicSize: 2 * anInteger
%

! Class extensions for 'Uint32Array'

!		Class methods for 'Uint32Array'

category: 'Instance Creation'
classmethod: Uint32Array
new: aSize

^ self _basicNew:  aSize * 4
%

!		Instance methods for 'Uint32Array'

category: 'Accessing'
method: Uint32Array
at: anOffset

"Returns a 32bit unsigned value as a SmallInteger."

<primitive: 1073>
(anOffset _isSmallInteger)
  ifTrue: [^ self _errorIndexOutOfRange: anOffset]
  ifFalse: [^ self _errorNonIntegerIndex: anOffset].
^ self _primitiveFailed: #at: args: { anOffset } .
%

category: 'Updating'
method: Uint32Array
at: anOffset put: aValue

"aValue must be a SmallInteger representable as a 32bit unsigned integer.
 returns aValue ."

<primitive: 1075>
aValue _validateClass: SmallInteger .
(aValue < 0 or:[ aValue > 4294967295]) ifTrue:[
  aValue _error: #rtErrArgOutOfRange args:{ 0 . 4294967295 }
].
(anOffset _isSmallInteger) ifTrue: [
  ((anOffset > (self size + 1)) or: [anOffset < 1]) ifTrue: [
    ^ self _errorIndexOutOfRange: anOffset
  ]
] ifFalse: [
  ^ self _errorNonIntegerIndex: anOffset
] .
self _primitiveFailed: #codePointAt:put: args: { anOffset . aValue }
%

category: 'Accessing'
method: Uint32Array
size

"Returns the number of elements in the receiver."

^ self _basicSize // 4.
%

category: 'Updating'
method: Uint32Array
size: anInteger

"Changes the size of the receiver to anInteger.

 If anInteger is less than the current size of the receiver, the receiver is
 shrunk accordingly.  If anInteger is greater than the current size of the
 receiver, the receiver is extended and new elements are initialized to zero."

^ super _basicSize: 4 * anInteger
%

! Class extensions for 'Uint64Array'

!		Class methods for 'Uint64Array'

category: 'Instance Creation'
classmethod: Uint64Array
new: aSize

^ self _basicNew:  aSize * 8
%

!		Instance methods for 'Uint64Array'

category: 'Accessing'
method: Uint64Array
at: anOffset

"Returns an Integer containing a 64bit unsigned value."

<primitive: 1076>
(anOffset _isSmallInteger)
  ifTrue: [^ self _errorIndexOutOfRange: anOffset]
  ifFalse: [^ self _errorNonIntegerIndex: anOffset].
^ self _primitiveFailed: #at: args: { anOffset } .
%

category: 'Updating'
method: Uint64Array
at: anOffset put: aValue

"aValue must be an Integer representable as a 64bit unsigned integer.
 returns aValue ."

<primitive: 1077>
| max |
max := 18446744073709551615 .
aValue _validateClass: Integer .
(aValue < 0 or:[ aValue > max ]) ifTrue:[
  aValue _error: #rtErrArgOutOfRange args:{ 0 . max }
].
(anOffset _isSmallInteger) ifTrue: [
  ((anOffset > (self size + 1)) or: [anOffset < 1]) ifTrue: [
    ^ self _errorIndexOutOfRange: anOffset
  ]
] ifFalse: [
  ^ self _errorNonIntegerIndex: anOffset
] .
self _primitiveFailed: #codePointAt:put: args: { anOffset . aValue }
%

category: 'Accessing'
method: Uint64Array
size

"Returns the number of elements in the receiver."

^ self _basicSize // 8.
%

category: 'Updating'
method: Uint64Array
size: anInteger

"Changes the size of the receiver to anInteger.

 If anInteger is less than the current size of the receiver, the receiver is
 shrunk accordingly.  If anInteger is greater than the current size of the
 receiver, the receiver is extended and new elements are initialized to zero."

^ super _basicSize: 8 * anInteger
%

! Class extensions for 'UnauthorizedObjectStub'

!		Instance methods for 'UnauthorizedObjectStub'

removeallmethods UnauthorizedObjectStub
removeallclassmethods UnauthorizedObjectStub

category: 'Comparing'
method: UnauthorizedObjectStub
== anObject

"(Optimized selector.)  Returns true if the receiver and the argument are the
 same object.

 This selector is optimized by the compiler and may not be reimplemented
 in any subclass.  This implementation is so that perform will work."

^ self == anObject
%

category: 'Converting'
method: UnauthorizedObjectStub
asOop

"Returns the value of the receiver's object-oriented pointer (OOP) as a
 positive Integer .  This is the receiver's unique identifier that
 distinguishes it from all other objects.  For non-special objects
 and for instances of 
   Boolean Character SmallDate SmallDateAndTime 
   SmallFraction SmallScaledDecimal SmallTime UndefinedObject
 the result will always be a SmallInteger.  For instances of SmallInteger
 and SmallDouble the result may be a LargeInteger.

 The result is different from the result obtained in Gemstone64 v1.x"

<primitive: 86>
self _primitiveFailed: #asOop
%

category: 'Encoded OOPs'
method: UnauthorizedObjectStub
asOopNumber

"If the receiver is a non-special object, return the receiver's
 oopNumber as defined under OOP_TAG_POM_OOP in the file
 $GEMSTONE/include/gcioop.ht  , otherwise return nil . "

| oop |
oop := self asOop .
oop _isSmallInteger ifFalse:[ ^ nil ].
(oop bitAnd:7) == 1 ifFalse:[ ^ nil ].
^ oop bitShift: -8
%

category: 'Private'
method: UnauthorizedObjectStub
asString
^ self __asString
%

category: 'Comparing'
method: UnauthorizedObjectStub
basicIdentityHash

"This method returns some Integer related to the identity of the receiver.  If
 two objects compare identically (==) to each other, the results of sending
 basicIdentityHash to each of those objects is equal."

"Faster than identityHash.  Used in GsMethodDictionary ."


<primitive: 321>

self _primitiveFailed: #basicIdentityHash .
self _uncontinuableError
%

category: 'Accessing'
method: UnauthorizedObjectStub
canBeWritten

"Returns true if the current user has write authorization for the
 receiver, false if not."

^ ((self _status: false)  bitAnd: 16r10) ~~ 0
%

category: 'Private'
method: UnauthorizedObjectStub
class
"Returns the object that is the receiver's class."
<primitive: 610 >
^ self _primitiveFailed: #class .
%

category: 'Error Handling'
method: UnauthorizedObjectStub
doesNotUnderstand: aMessageDescriptor

"The method is for compatiblity with Gs64 v2.x, and assumes you are using
   only method environment 0  for all of your Smalltalk code."

| sel str |
sel := aMessageDescriptor at: 1 .
(str := self __asString)
   add: ' does not understand ';
   add: sel _asSource .
^ SecurityError new _number: 2115"AUTH_ERR_SEG_READ" ;  signal: str .
%

category: 'Comparing'
method: UnauthorizedObjectStub
identityHash

"This method returns some Integer related to the identity of the receiver.  If
 two objects compare identically (==) to each other, the results of sending
identityHash to each of those objects will be equal."

<primitive: 609 >

self _primitiveFailed: #identityHash .
self _uncontinuableError
%

category: 'Accessing'
method: UnauthorizedObjectStub
isCommitted

"Returns true if the receiver existed in GemStone at the time the current
 transaction began.  Returns false otherwise."

^((self _status: true) bitAnd: 2) ~~ 0
%

category: 'Accessing'
method: UnauthorizedObjectStub
isSpecial
  ^ false
%

category: 'Accessing'
method: UnauthorizedObjectStub
isWritten

"Returns true if the receiver was a committed object at the start of the
 current transaction and as been written by the current transaction.
 Returns false otherwise."

^((self _status: true) bitAnd: 16rA ) == 16rA
%

category: 'Private'
method: UnauthorizedObjectStub
printString
^ self __asString
%

category: 'Accessing'
method: UnauthorizedObjectStub
yourself
  ^ self
%

category: 'Private'
method: UnauthorizedObjectStub
_dnuError: aSymbol args: anArray reason: dnuKind
 "dnuKind constants must agree with  DNU_ constants in om.hf .
  Not using class variables for DNU_* to avoid polluting name space of Object. "
 | err |
 err := InternalError new .
 dnuKind _isSmallInteger ifTrue:[
   dnuKind == 1 ifTrue:[
     err details: 'method needs recompile, receiver a ',
	  self class name , ' , selector #', aSymbol  ;
	   tag: { self . aSymbol }.
   ] ifFalse:[
     dnuKind == 2 ifTrue:[ err details: 'method load error DNU_failure2' ].
     dnuKind == 3 ifTrue:[ err details: 'method load error DNU_failure3' ].
     dnuKind == 4 ifTrue:[ err details: 'method is not invariant' ].
     dnuKind == 5 ifTrue:[ err details: 'method load error DNU_largeLeafMissing'].
     dnuKind == 6 ifTrue:[ err details:'method load error DNU_badExtrasSize' ].
     dnuKind == 7 ifTrue:[ err details:'method load error DNU_methodDoesNotExist' ].
     err tag:{ self . aSymbol . anArray }.
   ].
 ] ifFalse:[
   err details: 'method oop:' , dnuKind asOop asString, ' needs recompile, receiver a ',
	  self class name , ' , selector #', aSymbol  ;
	   tag: { self . aSymbol }.
 ].
 ^ err signal .
%

category: 'Private'
method: UnauthorizedObjectStub
_doesNotUnderstand: aSymbol args: anArray envId: aSmallInt reason: dnuKind
  "This private message is sent by the virtual machine. The implementation must
 be in the persistent method dictionary for Object, since the method is preloaded
 during VM startup.  Reimplementations in a session methods dictionary will not
 be seen."

  dnuKind ~~ 0 ifTrue: [
    "a more severe problem such as method needing recompile"
    self _dnuError: aSymbol args: anArray reason: dnuKind
  ].
  aSmallInt == 0 ifTrue:[
     "this path for compatibility with Gs64 v2.x, and assumes you are using
      only method environment 0  for all of your Smalltalk code."
      ^self doesNotUnderstand: (Message selector: aSymbol arguments: anArray)
  ].
  ^self doesNotUnderstand: aSymbol args: anArray envId: aSmallInt
%

category: 'Accessing'
method: UnauthorizedObjectStub
_status: checkClosureBool

"See Object >> _status"
<primitive: 39>
self _primitiveFailed: #_status: args: { checkClosureBool } .
self _uncontinuableError
%

category: 'Private'
method: UnauthorizedObjectStub
_topazAsString
 ^ [ self __asString
   ] onSynchronous: AbstractException do:[:ex |
     '<error during asString>'
   ]
%

category: 'Private'
method: UnauthorizedObjectStub
__asString
  self isCommitted ifTrue:[
    | str |
    str := 'an UnauthorizedObjectStub(read authorization error on oop ' copy.
    str add: self asOop asString; add: $) .
    ^ str
  ].
  ^ 'an UnauthorizedObjectStub(not committed)' copy .
%

category: 'Comparing'
method: UnauthorizedObjectStub
~~ anObject

"(Optimized selector.)  Returns true if the receiver and the argument are not
 the same object.

 This selector is optimized by the compiler and may not be reimplemented
 in any subclass. This implementation is so that perform will work."

^ self ~~ anObject
%

! Class extensions for 'UndefinedObject'

!		Instance methods for 'UndefinedObject'

category: 'PetitParser-Core-Converting'
method: UndefinedObject
asParser
	"Answer a parser that succeeds and does not consume anything."

	^ PPEpsilonParser new
%

! Class extensions for 'Unicode16'

!		Class methods for 'Unicode16'

removeallmethods Unicode16
removeallclassmethods Unicode16

category: 'Session Control'
classmethod: Unicode16
installUnicodeComparePrimitives
  "Installs appropriate entries in transient method dictionaries.
   Unicode versions of the methods are installed if
     (Globals at: #StringConfiguration) == Unicode16
   otherwise legacy methods are installed.
   Affects method lookup for #< #> #= and various methods in the indexing
   system  when the receiver is a kind of String or MultiByteString.

   See Unicode16(C) >> _unicodeCompareMapping for the detailed list of methods,
   no GsPackagePolicy should override any of those methods.

   A StringConfiguration value of Unicode16 is intended for new applications.
   Legacy applications should use a value of String , otherwise
   they may need to rebuild hashed collections and indexes.
  "

  self _useUnicodeComparePrimitives: self _unicodeCompareEnabled
%

category: 'Session Control'
classmethod: Unicode16
usingUnicodeCompares
  "Returns true if Unicode behavior for #< #> #= and various methods in the
  indexing system are being used, false if legacy behavior is being used."

  ^ System __sessionStateAt: 23
%

category: 'Instance Creation'
classmethod: Unicode16
withAll: aString

"Returns an instance of Unicode16 or Unicode32 using the
 minimum bytes per character required to represent the argument."

<primitive: 942>
aString stringCharSize >= 2 ifTrue:[
  ^ Unicode32 withAll: aString
].
(aString isKindOfClass: Utf8) ifTrue:[ ^ self withAll: aString decodeToUnicode ].
aString _validateClasses: { String . Utf8 } .
^ self _primitiveFailed: #withAll: args: { aString }
%

category: 'Session Control - Private'
classmethod: Unicode16
_cacheUsingUnicodeCompares

  System __sessionStateAt: 23 put: self _lookupsUsingUnicodeCompares
%

category: 'Indexing Support'
classmethod: Unicode16
_idxBasicCanCompareWithCharacterCollectionInstance: aCharacterCollection
  "Returns true if <aCharacterCollection> may be inserted into a basic BtreeNode
   whose #lastElementClass is the receiver (see RangeEqualityIndex
   class>>isBasicClass:)."

  "If using Unicode compares, then *String and Unicode* instances may be compared.
   If not using Unicode compares then *String and Unicode* instances may not be compared."

  ^ Unicode16 usingUnicodeCompares
%

category: 'Indexing Support'
classmethod: Unicode16
_idxBasicCanCompareWithUnicodeInstance: aUnicodeString
  "Returns true if <aUnicodeString> may be inserted into a basic BtreeNode whose
   #lastElementClass is the receiver (see RangeEqualityIndex class>>isBasicClass:)."

  "If using Unicode compares, then *String and Unicode* instances may be compared.
   If not using Unicode compares then *String and Unicode* instances may not be compared."

  ^ true
%

category: 'Session Control - Private'
classmethod: Unicode16
_lookupsUsingUnicodeCompares
  "Returns true if Unicode behavior for #< #> #= and various methods in the
  indexing system are being used, false if legacy behavior is being used."

  (Unicode7 transientMethodDictForEnv: 0) ifNotNil:[:tmd |
    (tmd at: #= otherwise: nil) ifNotNil:[:meth |
      (meth selector == #_unicodeEqual: ) ifTrue:[ ^ true ]
    ]
  ].
  ^ false
%

category: 'Session Control - Private'
classmethod: Unicode16
_unicodeCompareEnabled

  | v |
  v := Globals at: #StringConfiguration otherwise: nil .
  v == Unicode16 ifTrue:[ ^ true ].
  v ~~ String ifTrue:[
    (System myUserProfile _hasPrivilegeName: #NoGsFileOnServer) ifFalse:[
      GsFile gciLogServer:'WARNING invalid StringConfiguration ' , v asString.
    ].
  ].
  ^ false
%

category: 'Session Control - Private'
classmethod: Unicode16
_unicodeCompareMapping
  | base |
  "Returns an Array of pairs.
   Each pair is a class and an Array of selectors.
   An Array of selectors contains pairs of  lookup selector, implementation selector."

  base := #(#'<' #'_unicodeLessThan:' #'>' #'_unicodeGreaterThan:'
            #'=' #'_unicodeEqual:'
            #'_idxPrimCompareGreaterThan:' #'_idxUnicodeCompareGreaterThan:'
            #'_idxPrimCompareLessThan:' #'_idxUnicodeCompareLessThan:'
            #'_idxPrimCompareEqualTo:' #'_idxUnicodeCompareEqualTo:').
  ^ { String .  base .
      MultiByteString .  base .
      Unicode7 .   base .
      Unicode16 .  base .
      Unicode32 .  base }
%

category: 'Session Control - Private'
classmethod: Unicode16
_unicodeCompareTmdForClass: aClass selectors: syms
  "Returns a GsMethodDictionary to be installed as a transient method dictionary"
  | tmd |
  tmd := GsMethodDictionary new .
  1 to: syms size by: 2 do:[:n |
    tmd at:(syms at: n) put:( aClass persistentMethodAt:(syms at: n + 1)).
  ].
  ^ tmd
%

category: 'Session Control - Private'
classmethod: Unicode16
_useUnicodeComparePrimitives: aBoolean

<primitive: 2001>   "enter protected mode"
| prot prev |
prot := System _protectedMode .
[ prev := self _lookupsUsingUnicodeCompares .
  prev == aBoolean ifFalse:[ | list tmd |
    list := self _unicodeCompareMapping .
    1 to: list size by: 2 do:[:j | | aClass |
      aClass := list at: j .
      tmd := aBoolean ifTrue:[ self _unicodeCompareTmdForClass: aClass
				  selectors:  (list at: j + 1) ]
                     ifFalse:[ nil ] .
      aClass transientMethodDictForEnv: 0 put: tmd .
    ].
    self _clearLookupCaches: 0 .
  ].
  self _cacheUsingUnicodeCompares .
] ensure:[
  prot _leaveProtectedMode
].
^ prev
%

!		Instance methods for 'Unicode16'

category: 'Adding'
method: Unicode16
, aCharOrCharColl

"Returns a new instance of the receiver's class that contains the elements of
 the receiver followed by the elements of aCharOrCharColl.  The argument
 must be a CharacterCollection or an AbstractCharacter."

<primitive: 938>
| info cSize result |
info := aCharOrCharColl _stringCharSize .
cSize := info bitAnd: 16r7 .
(info bitAnd: 16r8) ~~ 0 ifTrue:[  "arg is a Unicode string"
  (cSize == 4) ifTrue:[
    result:= Unicode32 withAll: self.
    result addAll: aCharOrCharColl.
    ^ result .
  ].
].
cSize ~~ 0 ifTrue:[ "arg is a MultiByteString not handled by primitive"
  ^ self , (Unicode16 withAll: aCharOrCharColl)
].
(aCharOrCharColl class == Character) ifTrue:[ | av |
  (av := aCharOrCharColl codePoint) >= 16rD800 ifTrue:[
    av <= 16rDFFF ifTrue:[
      OutOfRange signal:'codePoint 16r', av asHexString ,' is illegal for Unicode'.
    ].
    av > 16rFFFF ifTrue:[ result:= Unicode32 withAll: self]
    		ifFalse:[ result:= Unicode16 withAll: self ]
  ] ifFalse:[
   ^ OutOfRange new name:'aChar codePoint' min: 0 max: 16r10FFFF
		actual: av ; signal
  ].
  result add: aCharOrCharColl .
  ^ result
].
aCharOrCharColl _validateClasses: { Unicode7 . Unicode16 . Unicode32 } .
self _primitiveFailed: #, args: { aCharOrCharColl }
%

category: 'Comparing'
method: Unicode16
< argString
  "Compares receiver to argument using  IcuCollator default."
  | info |
  ((info := argString _stringCharSize) bitAnd: 16r8) == 0 ifTrue:[ "not Unicode"
    info ~~ 0 ifTrue:[
      ArgumentError signal:'String argument disallowed in Unicode comparison'.
    ]
  ].
  ^ (self compareTo: argString collator: nil useMinSize: false) < 0
%

category: 'Comparing'
method: Unicode16
= argString
  "Compares receiver to argument using  IcuCollator default."
  | info |
  ((info := argString _stringCharSize) bitAnd: 16r8) == 0 ifTrue:[ "not Unicode"
     argString _isSymbol ifTrue:[ ^ false ] .
     info == 0 ifTrue: [ ^ false ].
     ArgumentError signal:'String argument disallowed in Unicode comparison'.
  ].
  ^ self _equals: argString collator: nil useMinSize: false
%

category: 'Comparing'
method: Unicode16
> argString
  "Compares receiver to argument using  IcuCollator default."
  | info |
  ((info := argString _stringCharSize) bitAnd: 16r8) == 0 ifTrue:[ "not Unicode"
    info ~~ 0 ifTrue:[
      ArgumentError signal:'String argument disallowed in Unicode comparison'.
    ]
  ].
  ^ (self compareTo: argString collator: nil useMinSize: false) > 0
%

category: 'Adding'
method: Unicode16
add: aCharOrCharColl

<primitive: 932>
^ self _retryAdd: aCharOrCharColl
%

category: 'Adding'
method: Unicode16
addAll: aCharOrCharColl

<primitive: 932>
^ self _retryAdd: aCharOrCharColl
%

category: 'Adding'
method: Unicode16
addCodePoint: aSmallInteger

<primitive: 1050>
^ self add: (Character codePoint: aSmallInteger).
%

category: 'Adding'
method: Unicode16
addLast: aCharOrCharColl

<primitive: 932>
^ self _retryAdd: aCharOrCharColl
%

category: 'Converting'
method: Unicode16
asString

"Returns a String representation of the receiver."

^ String withAll: self
%

category: 'Comparing'
method: Unicode16
at: offset equalsNoCase: aString

"Returns true if aString is contained in the receiver, starting at
 offset.  Returns false otherwise.
 Comparison is done using full case folding and code point order,
 using  icu:UnicodeString::caseCompare in libicu .
 aString must be a Unicode7, Unicode16 , or Unicode32"

<primitive: 930>
| info |
info := aString _stringCharSize .
(info bitAnd: 16r8) == 0 ifTrue:[  "arg is not a Unicode string"
   ^ self at: offset equalsNoCase: aString asUnicodeString
].
aString _validateClasses: { Unicode7 . Unicode16 . Unicode32 } .
offset _isSmallInteger ifFalse:[ offset _validateClass: SmallInteger ].
((offset <= 0) or: [offset > (self size + 1)])
  ifTrue: [ ^ self _errorIndexOutOfRange: offset].
self _primitiveFailed: #at:equalsNoCase: args: { offset . aString }
%

category: 'Adding'
method: Unicode16
at: anIndex put: aChar

"Stores aChar at the specified location."

<primitive: 933>
(aChar class == Character) ifTrue:[  | av |
  (av := aChar codePoint) >= 16rD800 ifTrue:[
    av <= 16rDFFF ifTrue:[
      OutOfRange signal:'codePoint 16r', av asHexString ,' is illegal for Unicode'.
    ].
    av > 16rFFFF ifTrue:[
      av > 16r10FFFF ifTrue:[
        OutOfRange new name:'aChar codePoint' min: 0 max: 16r10FFFF
                        actual: av ; signal
      ].
      ^ self _convertToQuadByte at: anIndex put: aChar
    ].
  ].
] ifFalse:[
 aChar _validateClass: AbstractCharacter .
 ^ self at: anIndex put: aChar asCharacter
].
(anIndex _isSmallInteger) ifTrue: [
  ((anIndex > (self size + 1)) or: [anIndex <= 0]) ifTrue: [
    ^ self _errorIndexOutOfRange: anIndex
  ]
] ifFalse: [
  ^ self _errorNonIntegerIndex: anIndex
] .
self _primitiveFailed: #at:put: args: { anIndex . aChar }
%

category: 'Adding'
method: Unicode16
codePointAt: anIndex put: anInt

"Stores codePoint anInt at the specified location. Returns anInt.
 Class of receiver is changed to Unicode32 if needed."

<primitive: 936>
(anInt class == SmallInteger) ifTrue:[
  anInt >= 16rD800 ifTrue:[
    anInt <= 16rDFFF ifTrue:[
      OutOfRange signal:'codePoint 16r', anInt asHexString ,' is illegal for Unicode'.
    ].
    anInt > 16rFFFF ifTrue:[
      anInt > 16r10FFFF ifTrue:[
        OutOfRange new name:'a codePoint' min: 0 max: 16r10FFFF
                        actual: anInt ; signal
      ].
      ^ self _convertToQuadByte codePointAt: anIndex put: anInt
    ].
  ].
  ^ OutOfRange new name:'anInt' min: 0 max: 16r10FFFF
		actual: anInt ; signal
].
(anIndex _isSmallInteger) ifTrue: [
  ((anIndex > (self size + 1)) or: [anIndex <= 0]) ifTrue: [
    ^ self _errorIndexOutOfRange: anIndex
  ]
] ifFalse: [
  ^ self _errorNonIntegerIndex: anIndex
] .
self _primitiveFailed: #at:put: args: { anIndex . anInt }
%

category: 'Comparing'
method: Unicode16
compareCase: aString

"Returns -1, 0 or 1,  when receiver is less than,
 equal to, or greater than aString .
 Comparison is done full case folding and code point order,
 using  icu:UnicodeString::caseCompare in libicu.
 aString must be a Unicode7, Unicode16 , or Unicode32"

<primitive: 969>
| info |
info := aString _stringCharSize .
(info bitAnd: 16r8) == 0 ifTrue:[  "arg is not a Unicode string"
   ^ self compareCase: aString asUnicodeString
].
aString _validateClasses: { Unicode7 . Unicode16 . Unicode32 } .
^self _primitiveFailed: #compareCase: args: { aString }
%

category: 'Comparing'
method: Unicode16
compareTo: argString collator: anIcuCollator useMinSize: aMinSize

"Returns -1, 0 or 1,  when receiver is less than,
 equal to, or greater than argString .
 argString must be a String, MultiByteString, or a Utf8 .
 anIcuCollator == nil is interpreted as   IcuCollator default .

 If aMinSize == false, normal comparision is done.

 If aMinSize==true, compare stops at (self size min: argString size),
 which is Squeak semantics for comparison.

 If aMinSize is a SmallInteger >= 1, compare stops at
   aMinSize min: (self size min: argString size) ."
<primitive: 928>   "prim handles String, DoubleByteString args"
anIcuCollator ifNil:[
  (System __sessionStateAt: 20) ifNil:[
    ^ self compareTo: argString collator: IcuCollator default useMinSize: aMinSize ]
] ifNotNil:[ anIcuCollator _validateClass: IcuCollator ].
aMinSize _validateClasses: { Boolean . SmallInteger }.
argString _validateClasses: { String . Utf8 }.
^ self _primitiveFailed: #compareTo:collator:useMinSize:
        args: { argString . anIcuCollator . aMinSize }
%

category: 'Comparing'
method: Unicode16
equals: aString collatingTable: aTable
  "disallowed"
  self shouldNotImplement: #equals:collatingTable:
%

category: 'Case-Insensitive Comparisons'
method: Unicode16
equalsNoCase: aString
  "Returns true if receiver and a String are equal using
  full case folding and code point order,
  using  icu:UnicodeString::caseCompare in libicu.
  Returns false otherwise.
  aString must be a Unicode7, Unicode16 , or Unicode32"

  ^ (self compareCase: aString) == 0
%

category: 'Comparing'
method: Unicode16
greaterThan: aString collatingTable: aTable
  "disallowed"
  self shouldNotImplement: #greaterThan:collatingTable:
%

category: 'Adding'
method: Unicode16
insertAll: aCharOrCharColl at: anIndex

<primitive: 922>
| info aString |
anIndex _isSmallInteger ifFalse:[ anIndex _validateClass: SmallInteger ].
((anIndex <= 0) or: [anIndex > (self size + 1)])
  ifTrue: [ ^ self _errorIndexOutOfRange: anIndex].

info := aCharOrCharColl _stringCharSize .
info ~~ 0 ifTrue:[  "arg is a DoubleByteString or Unicode32 or QuadByteString"
  aString := aCharOrCharColl _asUnicode16 .
  aString ifNotNil:[ ^  self insertAll: aString at: anIndex ]
          ifNil:[ ^ self _convertToQuadByte insertAll: aCharOrCharColl at: anIndex]
].
aCharOrCharColl class == Character ifTrue:[
  (aString := Unicode16 new) add: aCharOrCharColl .
  ^ self insertAll: aString at: anIndex .
].
aCharOrCharColl _validateClasses: { Unicode7 . Unicode16 . Unicode32 } .
self _primitiveFailed: #insertAll:at: args: { aCharOrCharColl . anIndex }
%

category: 'Case-Insensitive Comparisons'
method: Unicode16
isEquivalent: aString
  "Returns true if receiver and a String are equal using
  full case folding and code point order,
  using  icu:UnicodeString::caseCompare in libicu.
  Returns false otherwise.
  Returns false otherwise. "

  aString _stringCharSize == 0 ifTrue:[ ^ false "not a string"].
  ^ (self compareCase: aString) == 0
%

category: 'Comparing'
method: Unicode16
lessThan: aString collatingTable: aTable
  "disallowed"
  self shouldNotImplement: #lessThan:collatingTable:
%

category: 'Class Membership'
method: Unicode16
speciesForPrint

^ Unicode16
%

category: 'Adding'
method: Unicode16
squeakBasicAt: anIndex put: aValue
"Disallowed , use codePointAt:put:"
^ self shouldNotImplement: #squeakBasicAt:put:
%

category: 'Adding'
method: Unicode16
_basicAt: index put: char
"Disallowed , use codePointAt:put:"
^ self shouldNotImplement: #_basicAt:put:
%

category: 'Comparing'
method: Unicode16
_equals: argString collator: anIcuCollator useMinSize: aFalse

"Returns true if argString compares equals to the receiver using anIcuCollator
 and if argString is not a Symbol, otherwise returns false "
<primitive: 990>
anIcuCollator ifNil:[ (System __sessionStateAt: 20) ifNil:[
  ^ self _equals: argString collator: IcuCollator default useMinSize: aFalse ]
] ifNotNil:[  anIcuCollator _validateClass: IcuCollator ].
(argString isKindOf: CharacterCollection) ifTrue:[ ^ argString = self ].
^ false
%

category: 'Private'
method: Unicode16
_findString: subString startingAt: startIndex ignoreCase: aBoolean

aBoolean ifFalse:[
  ^ super _findString: subString startingAt: startIndex ignoreCase: aBoolean
].
^ self _findStringNocase: subString startingAt: startIndex
	collator: IcuCollator default
%

category: 'Indexing Support'
method: Unicode16
_idxBasicCanCompareWithClass: aClass
  "Returns true if the receiver may be inserted into a basic BtreeNode whose
   #lastElementClass is <aClass> (see RangeEqualityIndex class>>isBasicClass:)."

  "If using Unicode compares, then *String and Unicode* instances may be compared.
   If not using Unicode compares then *String and Unicode* instances may not be compared."

  ^ aClass _idxBasicCanCompareWithUnicodeInstance: self
%

category: 'New Indexing Comparison - prims'
method: Unicode16
_idxPrimCompareEqualTo: aCharCollection
  "This comparison operation is used for the indexing subsystem to
 determine an ordering for insertion into indexing objects.

 This method collates letters AaBb..Zz."

  "The comparison should be compatible with the case-insensitive semantics
 of the String method with selector #= .
 Same primitive as String>>lessThan: "

  aCharCollection ifNil:[ ^ false ].
  aCharCollection isUnicodeString ifFalse: [ "not Unicode"
    aCharCollection _isSymbol ifTrue: [ ^false ].
    ArgumentError signal:'String argument disallowed in Unicode comparison' ].
  ^self _idxUnicodeCompareEqualTo: aCharCollection
%

category: 'New Indexing Comparison - prims'
method: Unicode16
_idxPrimCompareGreaterThan: aCharCollection

"This comparison operation is used for the indexing subsystem to
 determine an ordering for insertion into indexing objects and for
 doing indexing subsystem comparisons.

 This method collates the same as the > method, except that
 it returns true if the argument is nil."

  aCharCollection ifNil:[ ^ false ].
  aCharCollection isUnicodeString ifFalse: [ "not Unicode"
    ArgumentError signal:'String argument disallowed in Unicode comparison' ].
  ^self _idxUnicodeCompareGreaterThan: aCharCollection
%

category: 'New Indexing Comparison - prims'
method: Unicode16
_idxPrimCompareLessThan: aCharCollection

"This comparison operation is used for the indexing subsystem to
 determine an ordering for insertion into indexing objects and for
 doing indexing subsystem comparisons.

 This method collates the same as the < method, except that
 it returns false if the argument is nil."

  aCharCollection ifNil:[ ^ false ].
  aCharCollection isUnicodeString ifFalse: [ "not Unicode"
    ArgumentError signal:'String argument disallowed in Unicode comparison' ].
  ^self _idxUnicodeCompareLessThan: aCharCollection
%

category: 'New Indexing Comparison'
method: Unicode16
_idxUnicodeCompareEqualTo: aCharCollection

  ^ super _idxUnicodeCompareEqualTo: aCharCollection
%

category: 'New Indexing Comparison'
method: Unicode16
_idxUnicodeCompareGreaterThan: aCharCollection

  ^ super _idxUnicodeCompareGreaterThan: aCharCollection
%

category: 'New Indexing Comparison'
method: Unicode16
_idxUnicodeCompareLessThan: aCharCollection

  ^ super _idxUnicodeCompareLessThan: aCharCollection
%

category: 'Adding'
method: Unicode16
_retryAdd: aCharOrCharColl
| info aString cSize |
aCharOrCharColl class == Character ifTrue:[ | av |
  (av := aCharOrCharColl codePoint) >= 16rD800 ifTrue:[
    av <= 16rDFFF ifTrue:[
      OutOfRange signal:'codePoint 16r', av asHexString ,' is illegal for Unicode'.
    ].
    av > 16rFFFF ifTrue:[
      ^ self _convertToQuadByte add: aCharOrCharColl
    ].
  ].
  ^ OutOfRange new name:'aChar codePoint' min: 0 max: 16r10FFFF
		actual: av ; signal
].
info := aCharOrCharColl _stringCharSize .
(info bitAnd: 16r8) ~~ 0 ifTrue:[  "arg is a Unicode string, assume cSize 4"
  aString := aCharOrCharColl _asUnicode16 .
  aString ifNotNil:[  self add: aString . ^ aCharOrCharColl ]
          ifNil:[ ^ self _convertToQuadByte add: aCharOrCharColl ].
].
cSize := info bitAnd: 16r7 .
cSize ~~ 0 ifTrue:[
  self add: aCharOrCharColl asUnicodeString  .
  ^ aCharOrCharColl
].
(aCharOrCharColl isKindOf: AbstractCharacter) ifTrue:[
  self add: aCharOrCharColl asCharacter .
  ^ aCharOrCharColl
].
(aCharOrCharColl isKindOf: CharacterCollection) ifTrue:[
  ^ self add: aCharOrCharColl asString.
].
aCharOrCharColl do: [:each | self add: each].
^ aCharOrCharColl
%

category: 'Comparing'
method: Unicode16
_unicodeEqual: argString
  "Compares receiver to argument using  IcuCollator default."

  ^ self _equals: argString collator: nil useMinSize: false
%

category: 'Comparing'
method: Unicode16
_unicodeGreaterThan: argString
  "Compares receiver to argument using  IcuCollator default."
  ^ (self compareTo: argString collator: nil useMinSize: false) > 0
%

category: 'Comparing'
method: Unicode16
_unicodeLessThan: argString
  "Compares receiver to argument using  IcuCollator default."
  ^ (self compareTo: argString collator: nil useMinSize: false) < 0
%

! Class extensions for 'Unicode32'

!		Class methods for 'Unicode32'

removeallmethods Unicode32
removeallclassmethods Unicode32

category: 'Instance Creation'
classmethod: Unicode32
withAll: aString

"Returns an instance of Unicode32 "

<primitive: 943>
(aString isKindOfClass: Utf8) ifTrue:[ ^ self withAll: aString decodeToUnicode ].
aString _validateClasses: { String . Utf8 } .
^ ArgumentError signal:'argument contains codePoints not valid for Unicode'
%

category: 'Indexing Support'
classmethod: Unicode32
_idxBasicCanCompareWithCharacterCollectionInstance: aCharacterCollection
  "Returns true if <aCharacterCollection> may be inserted into a basic BtreeNode
   whose #lastElementClass is the receiver (see RangeEqualityIndex
   class>>isBasicClass:)."

  "If using Unicode compares, then *String and Unicode* instances may be compared.
   If not using Unicode compares then *String and Unicode* instances may not be compared."

  ^ Unicode16 usingUnicodeCompares
%

category: 'Indexing Support'
classmethod: Unicode32
_idxBasicCanCompareWithUnicodeInstance: aUnicodeString
  "Returns true if <aUnicodeString> may be inserted into a basic BtreeNode whose
   #lastElementClass is the receiver (see RangeEqualityIndex class>>isBasicClass:)."

  "If using Unicode compares, then *String and Unicode* instances may be compared.
   If not using Unicode compares then *String and Unicode* instances may not be compared."

  ^ true
%

!		Instance methods for 'Unicode32'

category: 'Adding'
method: Unicode32
, aCharOrCharColl

"Returns a new instance of the receiver's class that contains the elements of
 the receiver followed by the elements of aCharOrCharColl.  The argument
 must be a CharacterCollection or an AbstractCharacter."

<primitive: 939>
| info cSize result |
info := aCharOrCharColl _stringCharSize .
cSize := info bitAnd: 16r7 .
(cSize == 4) ifTrue:[ "arg is malformed QuadByteString not handled by primitive"
  result:= Unicode32 withAll: self.
  result addAll: aCharOrCharColl.
  ^ result .
].
(aCharOrCharColl class == Character) ifTrue:[ | av |
  (av := aCharOrCharColl codePoint) >= 16rD800 ifTrue:[
    av <= 16rDFFF ifTrue:[
      OutOfRange signal:'codePoint 16r', av asHexString ,' is illegal for Unicode'.
    ].
    result:= Unicode32 withAll: self .
  ] ifFalse:[
   ^ OutOfRange new name:'aChar codePoint' min: 0 max: 16r10FFFF actual: av ; signal
  ].
  result add: aCharOrCharColl .
  ^ result
].
aCharOrCharColl _validateClasses: { Unicode7 . Unicode16 . Unicode32 } .
self _primitiveFailed: #, args: { aCharOrCharColl }
%

category: 'Comparing'
method: Unicode32
< argString
  "Compares receiver to argument using  IcuCollator default."
  | info |
  ((info := argString _stringCharSize) bitAnd: 16r8) == 0 ifTrue:[ "not Unicode"
    info ~~ 0 ifTrue:[
      ArgumentError signal:'String argument disallowed in Unicode comparison'.
    ]
  ].
  ^ (self compareTo: argString collator: nil useMinSize: false) < 0
%

category: 'Comparing'
method: Unicode32
= argString
  "Compares receiver to argument using  IcuCollator default."
  | info |
  ((info := argString _stringCharSize) bitAnd: 16r8) == 0 ifTrue:[ "not Unicode"
     argString _isSymbol ifTrue:[ ^ false ] .
     info == 0 ifTrue: [ ^ false ].
     ArgumentError signal:'String argument disallowed in Unicode comparison'.
  ].
  ^ self _equals: argString collator: nil useMinSize: false
%

category: 'Comparing'
method: Unicode32
> argString
  "Compares receiver to argument using  IcuCollator default."
  | info |
  ((info := argString _stringCharSize) bitAnd: 16r8) == 0 ifTrue:[ "not Unicode"
    info ~~ 0 ifTrue:[
      ArgumentError signal:'String argument disallowed in Unicode comparison'.
    ]
  ].
  ^ (self compareTo: argString collator: nil useMinSize: false) > 0
%

category: 'Adding'
method: Unicode32
add: aCharOrCharColl

<primitive: 940>
^ self _retryAdd: aCharOrCharColl
%

category: 'Adding'
method: Unicode32
addAll: aCharOrCharColl

<primitive: 940>
^ self _retryAdd: aCharOrCharColl
%

category: 'Adding'
method: Unicode32
addLast: aCharOrCharColl

<primitive: 940>
^ self _retryAdd: aCharOrCharColl
%

category: 'Converting'
method: Unicode32
asString

"Returns a String representation of the receiver."

^ String withAll: self
%

category: 'Comparing'
method: Unicode32
at: offset equalsNoCase: aString

"Returns true if aString is contained in the receiver, starting at
 anIndex.  Returns false otherwise.
 The comparison is done with full case folding and code point order,
 using  icu:UnicodeString::caseCompare in libicu .
 aString must be a Unicode7, Unicode16 , or Unicode32"

offset == 1 ifTrue:[ ^ self _at:offset equalsNoCase: aString].

"prim 930 can't handle random positions in a full Utf32"
^ (self copyFrom: offset to: self size) _at: 1 equalsNoCase: aString.
%

category: 'Accessing'
method: Unicode32
at: anIndex put: aChar

"Stores aChar at the specified location."

<primitive: 934>
(aChar class == Character) ifTrue:[  | anInt |
  anInt := aChar codePoint .
  (anInt < 0 or:[ anInt > 16r10FFFF]) ifTrue:[
    ^ OutOfRange new name:'aChar codePoint' min: 0 max: 16r10FFFF
			actual: anInt ; signal
  ].
] ifFalse:[
 aChar _validateClass: AbstractCharacter .
 ^ self at: anIndex put: aChar asCharacter
].
(anIndex _isSmallInteger) ifTrue: [
  ((anIndex > (self size + 1)) or: [anIndex <= 0]) ifTrue: [
    ^ self _errorIndexOutOfRange: anIndex
  ]
] ifFalse: [
  ^ self _errorNonIntegerIndex: anIndex
] .
self _primitiveFailed: #at:put: args: { anIndex . aChar }
%

category: 'Accessing'
method: Unicode32
codePointAt: anIndex put: anInt

"Stores anInt at the specified location. returns anInt"

<primitive: 937>
anInt _validateClass: SmallInteger .
(anInt < 0 or:[ anInt > 16r10FFFF]) ifTrue:[
  ^ OutOfRange new name:'anInt' min: 0 max: 16r10FFFF actual: anInt ; signal
].
(anIndex _isSmallInteger) ifTrue: [
  ((anIndex > (self size + 1)) or: [anIndex <= 0]) ifTrue: [
    ^ self _errorIndexOutOfRange: anIndex
  ]
] ifFalse: [
  ^ self _errorNonIntegerIndex: anIndex
] .
self _primitiveFailed: #at:put: args: { anIndex . anInt }
%

category: 'Comparing'
method: Unicode32
compareCase: aString

"Returns -1, 0 or 1,  when receiver is less than,
 equal to, or greater than aString .
 Comparison is done full case folding and code point order,
 using  icu:UnicodeString::caseCompare in libicu.
 aString must be a Unicode7, Unicode16 , or Unicode32"

<primitive: 969>
| info |
info := aString _stringCharSize .
(info bitAnd: 16r8) == 0 ifTrue:[  "arg is not a Unicode string"
   ^ self compareCase: aString asUnicodeString
].
aString _validateClasses: { String } .
^self _primitiveFailed: #compareCase: args: { aString }
%

category: 'Comparing'
method: Unicode32
equals: aString collatingTable: aTable
  "disallowed"
  self shouldNotImplement: #equals:collatingTable:
%

category: 'Case-Insensitive Comparisons'
method: Unicode32
equalsNoCase: aString
  "Returns true if receiver and a String are equal using
  full case folding and code point order,
  using  icu:UnicodeString::caseCompare in libicu.
  Returns false otherwise.
  aString must be a Unicode7, Unicode16 , or Unicode32"

  ^ (self compareCase: aString) == 0
%

category: 'Comparing'
method: Unicode32
greaterThan: aString collatingTable: aTable
  "disallowed"
  self shouldNotImplement: #greaterThan:collatingTable:
%

category: 'Adding'
method: Unicode32
insertAll: aCharOrCharColl at: anIndex
<primitive: 923>
| aString info |
anIndex _isSmallInteger ifFalse:[ anIndex _validateClass: SmallInteger ].
((anIndex <= 0) or: [anIndex > (self size + 1)])
  ifTrue: [ ^ self _errorIndexOutOfRange: anIndex].

info := aCharOrCharColl _stringCharSize .
info == 4 ifTrue:[  "must be a QuadByteString since prim handles Unicode32 arg"
   ^ self insertAll:  aCharOrCharColl asUnicodeString  at: anIndex
].
aCharOrCharColl class == Character ifTrue:[
  (aString := Unicode32 new) add: aCharOrCharColl .
  ^ self insertAll: aString at: anIndex .
].
aCharOrCharColl _validateClasses: { Unicode7 . Unicode16 . Unicode32 } .
self _primitiveFailed: #insertAll:at: args: { aCharOrCharColl . anIndex }
%

category: 'Case-Insensitive Comparisons'
method: Unicode32
isEquivalent: aString
  "Returns true if receiver and a String are equal using
  full case folding and code point order,
  using  icu:UnicodeString::caseCompare in libicu.
  Returns false otherwise. "

  aString _stringCharSize == 0 ifTrue:[ ^ false "not a string"].
  ^ (self compareCase: aString) == 0
%

category: 'Comparing'
method: Unicode32
lessThan: aString collatingTable: aTable
  "disallowed"
  self shouldNotImplement: #lessThan:collatingTable:
%

category: 'Class Membership'
method: Unicode32
speciesForPrint

^ Unicode16  "let stream promote if needed"
%

category: 'Accessing'
method: Unicode32
squeakBasicAt: anIndex put: aValue
"Disallowed , use codePointAt:put:"
^ self shouldNotImplement: #squeakBasicAt:put:
%

category: 'Comparing'
method: Unicode32
_at: offset equalsNoCase: aString

"Returns true if aString is contained in the receiver, starting at
 offset.  Returns false otherwise.
 The comparison is done with full case folding and code point order,
 using  icu:UnicodeString::caseCompare in libicu .
 aString must be a Unicode7, Unicode16 , or Unicode32"

<primitive: 930>
| info |
info := aString _stringCharSize .
(info bitAnd: 16r8) == 0 ifTrue:[  "arg is not a Unicode string"
   ^ self _at: offset equalsNoCase: aString asUnicodeString
].
aString _validateClasses: { String } .
offset _isSmallInteger ifFalse:[ offset _validateClass: SmallInteger ].
((offset <= 0) or: [offset > (self size + 1)])
  ifTrue: [ ^ self _errorIndexOutOfRange: offset].
self _primitiveFailed: #_at:equalsNoCase: args: { offset . aString }
%

category: 'Accessing'
method: Unicode32
_basicAt: index put: char
"Disallowed , use codePointAt:put:"
^ self shouldNotImplement: #_basicAt:put:
%

category: 'Private'
method: Unicode32
_findString: subString startingAt: startIndex ignoreCase: aBoolean

aBoolean ifFalse:[
  ^ super _findString: subString startingAt: startIndex ignoreCase: aBoolean
].
^ self _findStringNocase: subString startingAt: startIndex
	collator: IcuCollator default
%

category: 'Indexing Support'
method: Unicode32
_idxBasicCanCompareWithClass: aClass
  "Returns true if the receiver may be inserted into a basic BtreeNode whose
   #lastElementClass is <aClass> (see RangeEqualityIndex class>>isBasicClass:)."

  "If using Unicode compares, then *String and Unicode* instances may be compared.
   If not using Unicode compares then *String and Unicode* instances may not be compared."

  ^ aClass _idxBasicCanCompareWithUnicodeInstance: self
%

category: 'New Indexing Comparison - prims'
method: Unicode32
_idxPrimCompareEqualTo: aCharCollection
  "This comparison operation is used for the indexing subsystem to
 determine an ordering for insertion into indexing objects.

 This method collates letters AaBb..Zz."

  "The comparison should be compatible with the case-insensitive semantics
 of the String method with selector #= .
 Same primitive as String>>lessThan: "

  aCharCollection ifNil:[ ^ false ].
  aCharCollection isUnicodeString ifFalse: [ "not Unicode"
    aCharCollection _isSymbol ifTrue: [ ^false ].
    ArgumentError signal:'String argument disallowed in Unicode comparison' ].
  ^self _idxUnicodeCompareEqualTo: aCharCollection
%

category: 'New Indexing Comparison - prims'
method: Unicode32
_idxPrimCompareGreaterThan: aCharCollection

"This comparison operation is used for the indexing subsystem to
 determine an ordering for insertion into indexing objects and for
 doing indexing subsystem comparisons.

 This method collates the same as the > method, except that
 it returns true if the argument is nil."

  aCharCollection ifNil:[ ^ false ].
  aCharCollection isUnicodeString ifFalse: [ "not Unicode"
    ArgumentError signal:'String argument disallowed in Unicode comparison' ].
  ^self _idxUnicodeCompareGreaterThan: aCharCollection
%

category: 'New Indexing Comparison - prims'
method: Unicode32
_idxPrimCompareLessThan: aCharCollection

"This comparison operation is used for the indexing subsystem to
 determine an ordering for insertion into indexing objects and for
 doing indexing subsystem comparisons.

 This method collates the same as the < method, except that
 it returns false if the argument is nil."

  aCharCollection ifNil:[ ^ false ].
  aCharCollection isUnicodeString ifFalse: [ "not Unicode"
    ArgumentError signal:'String argument disallowed in Unicode comparison' ].
  ^self _idxUnicodeCompareLessThan: aCharCollection
%

category: 'New Indexing Comparison'
method: Unicode32
_idxUnicodeCompareEqualTo: aCharCollection

  ^ super _idxUnicodeCompareEqualTo: aCharCollection
%

category: 'New Indexing Comparison'
method: Unicode32
_idxUnicodeCompareGreaterThan: aCharCollection

  ^ super _idxUnicodeCompareGreaterThan: aCharCollection
%

category: 'New Indexing Comparison'
method: Unicode32
_idxUnicodeCompareLessThan: aCharCollection

  ^ super _idxUnicodeCompareLessThan: aCharCollection
%

category: 'Adding'
method: Unicode32
_retryAdd: aCharOrCharColl
| info cSize |
aCharOrCharColl class == Character ifTrue:[
  ^ OutOfRange new name:'aChar codePoint' min: 0 max: 16r10FFFF actual: aCharOrCharColl ; signal
].
info := aCharOrCharColl _stringCharSize .
(info bitAnd: 16r8) ~~ 0 ifTrue:[  "arg is a Unicode string, assume cSize 4"
  self _primitiveFailed: #add: args: { aCharOrCharColl } .
].
cSize := info bitAnd: 16r7 .
cSize ~~ 0 ifTrue:[
  self add: aCharOrCharColl asUnicodeString .
  ^ aCharOrCharColl
].
(aCharOrCharColl isKindOf: AbstractCharacter) ifTrue:[
  self add: aCharOrCharColl asCharacter .
  ^ aCharOrCharColl
].
(aCharOrCharColl isKindOf: CharacterCollection) ifTrue:[
  ^ self add: aCharOrCharColl asString.
].
aCharOrCharColl do: [:each | self add: each].
^ aCharOrCharColl
%

category: 'Comparing'
method: Unicode32
_unicodeEqual: argString
  "Compares receiver to argument using  IcuCollator default."
  ^ self _equals: argString collator: nil useMinSize: false
%

category: 'Comparing'
method: Unicode32
_unicodeGreaterThan: argString
  "Compares receiver to argument using  IcuCollator default."
  ^ (self compareTo: argString collator: nil useMinSize: false) > 0
%

category: 'Comparing'
method: Unicode32
_unicodeLessThan: argString
  "Compares receiver to argument using  IcuCollator default."
  ^ (self compareTo: argString collator: nil useMinSize: false) < 0
%

! Class extensions for 'Unicode7'

!		Class methods for 'Unicode7'

removeallmethods Unicode7
removeallclassmethods Unicode7

category: 'Instance Creation'
classmethod: Unicode7
withAll: aString

"Returns an instance of Unicode7, Unicode16 or Unicode32 using the
 minimum bytes per character required to represent the argument."

<primitive: 941>
aString stringCharSize >= 1 ifTrue:[
  ^ Unicode16 withAll: aString
].
(aString isKindOfClass: Utf8) ifTrue:[ ^ aString decodeToUnicode ].
aString _validateClasses: { String . Utf8 } .
^ self _primitiveFailed: #withAll: args: { aString }
%

category: 'Indexing Support'
classmethod: Unicode7
_idxBasicCanCompareWithCharacterCollectionInstance: aCharacterCollection
  "Returns true if <aCharacterCollection> may be inserted into a basic BtreeNode
   whose #lastElementClass is the receiver (see RangeEqualityIndex
   class>>isBasicClass:)."

  "If using Unicode compares, then *String and Unicode* instances may be compared.
   If not using Unicode compares then *String and Unicode* instances may not be compared."

  ^ Unicode16 usingUnicodeCompares
%

category: 'Indexing Support'
classmethod: Unicode7
_idxBasicCanCompareWithUnicodeInstance: aUnicodeString
  "Returns true if <aUnicodeString> may be inserted into a basic BtreeNode whose
   #lastElementClass is the receiver (see RangeEqualityIndex class>>isBasicClass:)."

  "If using Unicode compares, then *String and Unicode* instances may be compared.
   If not using Unicode compares then *String and Unicode* instances may not be compared."

  ^ true
%

!		Instance methods for 'Unicode7'

category: 'Adding'
method: Unicode7
, aCharOrCharColl

"Returns a new instance of the receiver's class that contains the elements of
 the receiver followed by the elements of aCharOrCharColl.  The argument
 must be a CharacterCollection or an AbstractCharacter."

<primitive: 920>
| info cSize result |
info := aCharOrCharColl _stringCharSize .
cSize := info bitAnd: 16r7 .
(info bitAnd: 16r8) ~~ 0 ifTrue:[  "arg is a Unicode string"
  (cSize == 2) ifTrue:[
    result := Unicode16 withAll: self.
    result addAll: aCharOrCharColl.
    ^ result .
  ] ifFalse:[
    result:= Unicode32 withAll: self.
    result addAll: aCharOrCharColl.
    ^ result .
  ].
].
cSize ~~ 0 ifTrue:[ "arg is a String or MultibyteString not handled by primitive"
  ^ self , (Unicode7 withAll: aCharOrCharColl)
].
(aCharOrCharColl class == Character) ifTrue:[ | av |
  (av := aCharOrCharColl codePoint) >= 16rD800 ifTrue:[
    av <= 16rDFFF ifTrue:[
      OutOfRange signal:'codePoint 16r', av asHexString ,' is illegal for Unicode'.
    ].
    av > 16rFFFF ifTrue:[ result:= Unicode32 withAll: self]
    		ifFalse:[ result:= Unicode16 withAll: self ]
  ] ifFalse:[
    av > 16r7F ifTrue:[
      result := Unicode16 withAll: self
    ] ifFalse:[
     ^ OutOfRange new name:'aChar codePoint' min: 0 max: 16r10FFFF
			actual: av ; signal
    ].
  ].
  result add: aCharOrCharColl .
  ^ result
].
aCharOrCharColl _validateClasses: { Unicode7 . Unicode16 . Unicode32 } .
self _primitiveFailed: #, args: { aCharOrCharColl }
%

category: 'Comparing'
method: Unicode7
< argString
  "Compares receiver to argument using  IcuCollator default."
  | info |
  ((info := argString _stringCharSize) bitAnd: 16r8) == 0 ifTrue:[ "not Unicode"
    info ~~ 0 ifTrue:[
      ArgumentError signal:'String argument disallowed in Unicode comparison'.
    ]
  ].
  ^ (self compareTo: argString collator: nil useMinSize: false) < 0
%

category: 'Comparing'
method: Unicode7
= argString
  "Compares receiver to argument using  IcuCollator default."
  | info |
  ((info := argString _stringCharSize) bitAnd: 16r8) == 0 ifTrue:[ "not Unicode"
     argString _isSymbol ifTrue:[ ^ false ] .
     info == 0 ifTrue: [ ^ false ].
     ArgumentError signal:'String argument disallowed in Unicode comparison'.
  ].
  ^ self _equals: argString collator: nil useMinSize: false
%

category: 'Comparing'
method: Unicode7
> argString
  "Compares receiver to argument using  IcuCollator default."
  | info |
  ((info := argString _stringCharSize) bitAnd: 16r8) == 0 ifTrue:[ "not Unicode"
    info ~~ 0 ifTrue:[
      ArgumentError signal:'String argument disallowed in Unicode comparison'.
    ]
  ].
  ^ (self compareTo: argString collator: nil useMinSize: false) > 0
%

category: 'Adding'
method: Unicode7
add: aCharOrCharColl

<primitive: 918>
^ self _retryAdd: aCharOrCharColl
%

category: 'Adding'
method: Unicode7
addAll: aCharOrCharColl

<primitive: 918>
^ self _retryAdd: aCharOrCharColl
%

category: 'Adding'
method: Unicode7
addCodePoint: aSmallInteger

<primitive: 1049>
^ self add: (Character codePoint: aSmallInteger).
%

category: 'Adding'
method: Unicode7
addLast: aCharOrCharColl

<primitive: 918>
^ self _retryAdd: aCharOrCharColl
%

category: 'Converting'
method: Unicode7
asString

"Returns a String representation of the receiver."

^ String withAll: self
%

category: 'Comparing'
method: Unicode7
at: offset equalsNoCase: aString

"Returns true if aString is contained in the receiver, starting at
 offset.  Returns false otherwise.
 Comparison is done full case folding and code point order,
 using  icu:UnicodeString::caseCompare in libicu.
 aString must be a Unicode7, Unicode16 , or Unicode32"

<primitive: 930>
| info |
info := aString _stringCharSize .
(info bitAnd: 16r8) == 0 ifTrue:[  "arg is not a Unicode string"
   ^ self at: offset equalsNoCase: aString asUnicodeString
].
aString _validateClasses: { Unicode7 . Unicode16 . Unicode32 } .
offset _isSmallInteger ifFalse:[ offset _validateClass: SmallInteger ].
((offset <= 0) or: [offset > (self size + 1)])
  ifTrue: [ ^ self _errorIndexOutOfRange: offset].
^self _primitiveFailed: #at:equalsNoCase: args: { offset . aString }
%

category: 'Adding'
method: Unicode7
at: anIndex put: aChar

"Stores aChar at the specified location."

<primitive: 919>
(aChar class == Character) ifTrue:[  | av |
  (av := aChar codePoint) >= 16rD800 ifTrue:[
    av <= 16rDFFF ifTrue:[
      OutOfRange signal:'codePoint 16r', av asHexString ,' is illegal for Unicode'.
    ].
    (av > 16rFFFF) ifTrue:[
      av > 16r10FFFF ifTrue:[
        OutOfRange new name:'aChar codePoint' min: 0 max: 16r10FFFF
                        actual: av ; signal
      ].
      ^ self _convertToQuadByte at: anIndex put: aChar
    ].
    ^ self _convertToDoubleByte at: anIndex put: aChar
  ].
  av > 16r7F ifTrue:[
    ^ self _convertToDoubleByte at: anIndex put: aChar
  ].
] ifFalse:[
 aChar _validateClass: AbstractCharacter .
 ^ self at: anIndex put: aChar asCharacter
].
(anIndex _isSmallInteger) ifTrue: [
  ((anIndex > (self size + 1)) or: [anIndex <= 0]) ifTrue: [
    ^ self _errorIndexOutOfRange: anIndex
  ]
] ifFalse: [
  ^ self _errorNonIntegerIndex: anIndex
] .
self _primitiveFailed: #at:put: args: { anIndex . aChar }
%

category: 'Adding'
method: Unicode7
codePointAt: anIndex put: anInt

"Stores codePoint anInt at the specified location. Returns anInt.
 Class of receiver is changed to Unicode16 or Unicode32 if needed."

<primitive: 935>
(anInt class == SmallInteger) ifTrue:[
  anInt >= 16rD800 ifTrue:[
    anInt <= 16rDFFF ifTrue:[
      OutOfRange signal:'codePoint 16r', anInt asHexString ,' is illegal for Unicode'.
    ].
    anInt > 16rFFFF ifTrue:[
      anInt > 16r10FFFF ifTrue:[
        OutOfRange new name:'a codePoint' min: 0 max: 16r10FFFF
                        actual: anInt ; signal
      ].
      ^ self _convertToQuadByte codePointAt: anIndex put: anInt
    ].
    ^ self _convertToDoubleByte codePointAt: anIndex put: anInt
  ].
  anInt > 16r7F ifTrue:[
    ^ self _convertToDoubleByte codePointAt: anIndex put: anInt
  ].
].
(anIndex _isSmallInteger) ifTrue: [
  ((anIndex > (self size + 1)) or: [anIndex <= 0]) ifTrue: [
    ^ self _errorIndexOutOfRange: anIndex
  ]
] ifFalse: [
  ^ self _errorNonIntegerIndex: anIndex
] .
self _primitiveFailed: #at:put: args: { anIndex . anInt }
%

category: 'Comparing'
method: Unicode7
compareCase: aString

"Returns -1, 0 or 1,  when receiver is less than,
 equal to, or greater than aString .
 Comparison is done full case folding and code point order,
 using  icu:UnicodeString::caseCompare in libicu.
 aString must be a Unicode7, Unicode16 , or Unicode32"

<primitive: 969>
| info |
info := aString _stringCharSize .
(info bitAnd: 16r8) == 0 ifTrue:[  "arg is not a Unicode string"
   ^ self compareCase: aString asUnicodeString
].
aString _validateClasses: { Unicode7 . Unicode16 . Unicode32 } .
^self _primitiveFailed: #compareCase: args: { aString }
%

category: 'Indexing Support'
method: Unicode7
compareTo: argString collator: anIcuCollator useMinSize: aMinSize

"Returns -1, 0 or 1,  when receiver is less than,
 equal to, or greater than argString .
 argString must be a String, MultiByteString, or a Utf8 .
 anIcuCollator == nil is interpreted as   IcuCollator default .

 If aMinSize == false, normal comparision is done.

 If aMinSize==true, compare stops at (self size min: argString size),
 which is Squeak semantics for comparison.

 If aMinSize is a SmallInteger >= 1, compare stops at
   aMinSize min: (self size min: argString size) ."
<primitive: 917>
anIcuCollator ifNil:[
  (System __sessionStateAt: 20) ifNil:[
    ^ self compareTo: argString collator: IcuCollator default useMinSize: aMinSize ]
] ifNotNil:[ anIcuCollator _validateClass: IcuCollator ].
aMinSize _validateClasses: { Boolean . SmallInteger }.
argString _validateClasses: { String . Utf8 }.
^ self _primitiveFailed: #compareTo:collator:useMinSize:
        args: { argString . anIcuCollator . aMinSize }
%

category: 'Converting'
method: Unicode7
decodeFromUTF8
  "Reciever already 7 bit ascii"
  ^ self
%

category: 'Comparing'
method: Unicode7
equals: aString collatingTable: aTable
  "disallowed"
  self shouldNotImplement: #equals:collatingTable:
%

category: 'Comparing'
method: Unicode7
equalsNoCase: aString
  "Returns true if receiver and a String are equal using
  full case folding and code point order,
  using  icu:UnicodeString::caseCompare in libicu.
  Returns false otherwise.
  aString must be a Unicode7, Unicode16 , or Unicode32"

  ^ (self compareCase: aString) == 0
%

category: 'Comparing'
method: Unicode7
greaterThan: aString collatingTable: aTable
  "disallowed"
  self shouldNotImplement: #greaterThan:collatingTable:
%

category: 'Adding'
method: Unicode7
insertAll: aCharOrCharColl at: offset

<primitive: 921>
| aString cSize info |
offset _isSmallInteger ifFalse:[ offset _validateClass: SmallInteger ].
((offset <= 0) or: [offset > (self size + 1)])
  ifTrue: [ ^ self _errorIndexOutOfRange: offset].

info := aCharOrCharColl _stringCharSize .
cSize := info bitAnd: 16r7 .
(info bitAnd: 16r8) ~~ 0 ifTrue:[  "arg is a Unicode string"
  aCharOrCharColl _asUnicode7 ifNotNil:[ :src7 | ^ self insertAll: src7 at: offset].
  cSize == 2 ifTrue:[
     ^ self _convertToDoubleByte insertAll: aCharOrCharColl at: offset
  ].
  ^ self _convertToQuadByte insertAll: aCharOrCharColl at: offset
].
cSize ~~ 0 ifTrue:[
  ^ self insertAll: aCharOrCharColl asUnicodeString at: offset
].
aCharOrCharColl class == Character ifTrue:[
  (aString := Unicode7 new) add: aCharOrCharColl .
  ^ self insertAll: aString at: offset .
].
aCharOrCharColl _validateClasses: { Unicode7 . Unicode16 . Unicode32 } .
self _primitiveFailed: #insertAll:at: args: { aCharOrCharColl . offset }
%

category: 'Comparing'
method: Unicode7
isEquivalent: aString
  "Returns true if receiver and a String are equal using
  full case folding and code point order,
  using  icu:UnicodeString::caseCompare in libicu.
  Returns false otherwise. "

  aString _stringCharSize == 0 ifTrue:[ ^ false "not a string"].
  ^ (self compareCase: aString) == 0
%

category: 'Comparing'
method: Unicode7
lessThan: aString collatingTable: aTable
  "disallowed"
  self shouldNotImplement: #lessThan:collatingTable:
%

category: 'Class Membership'
method: Unicode7
speciesForPrint

^ Unicode7
%

category: 'Adding'
method: Unicode7
squeakBasicAt: anIndex put: aValue
"Disallowed , use codePointAt:put:"
^ self shouldNotImplement: #squeakBasicAt:put:
%

category: 'Adding'
method: Unicode7
_basicAt: index put: char
"Disallowed , use codePointAt:put:"
^ self shouldNotImplement: #_basicAt:put:
%

category: 'Indexing Support'
method: Unicode7
_equals: argString collator: anIcuCollator useMinSize: aFalse

"Returns true if argString compares equals to the receiver using anIcuCollator
 and if argString is not a Symbol, otherwise returns false "
<primitive: 989>
anIcuCollator ifNil:[ (System __sessionStateAt: 20) ifNil:[
  ^ self _equals: argString collator: IcuCollator default useMinSize: aFalse ]
] ifNotNil:[  anIcuCollator _validateClass: IcuCollator ].
(argString isKindOf: CharacterCollection) ifTrue:[ ^ argString = self ].
^ false
%

category: 'Private'
method: Unicode7
_findString: subString startingAt: startIndex ignoreCase: aBoolean

aBoolean ifFalse:[
  ^ super _findString: subString startingAt: startIndex ignoreCase: aBoolean
].
^ self _findStringNocase: subString startingAt: startIndex
	collator: IcuCollator default
%

category: 'Indexing Support'
method: Unicode7
_idxBasicCanCompareWithClass: aClass
  "Returns true if the receiver may be inserted into a basic BtreeNode whose
   #lastElementClass is <aClass> (see RangeEqualityIndex class>>isBasicClass:)."

  "If using Unicode compares, then *String and Unicode* instances may be compared.
   If not using Unicode compares then *String and Unicode* instances may not be compared."

  ^ aClass _idxBasicCanCompareWithUnicodeInstance: self
%

category: 'New Indexing Comparison - prims'
method: Unicode7
_idxPrimCompareEqualTo: aCharCollection
  "This comparison operation is used for the indexing subsystem to
 determine an ordering for insertion into indexing objects.

 This method collates letters AaBb..Zz."

  "The comparison should be compatible with the case-insensitive semantics
 of the String method with selector #= .
 Same primitive as String>>lessThan: "

  aCharCollection ifNil:[ ^ false ].
  aCharCollection isUnicodeString ifFalse: [ "not Unicode"
    aCharCollection _isSymbol ifTrue: [ ^false ].
    ArgumentError signal:'String argument disallowed in Unicode comparison' ].
  ^self _idxUnicodeCompareEqualTo: aCharCollection
%

category: 'New Indexing Comparison - prims'
method: Unicode7
_idxPrimCompareGreaterThan: aCharCollection

"This comparison operation is used for the indexing subsystem to
 determine an ordering for insertion into indexing objects and for
 doing indexing subsystem comparisons.

 This method collates the same as the > method, except that
 it returns true if the argument is nil."

  aCharCollection ifNil:[ ^ false ].
  aCharCollection isUnicodeString ifFalse: [ "not Unicode"
    ArgumentError signal:'String argument disallowed in Unicode comparison' ].
  ^self _idxUnicodeCompareGreaterThan: aCharCollection
%

category: 'New Indexing Comparison - prims'
method: Unicode7
_idxPrimCompareLessThan: aCharCollection

"This comparison operation is used for the indexing subsystem to
 determine an ordering for insertion into indexing objects and for
 doing indexing subsystem comparisons.

 This method collates the same as the < method, except that
 it returns false if the argument is nil."

  aCharCollection ifNil:[ ^ false ].
  aCharCollection isUnicodeString ifFalse: [ "not Unicode"
    ArgumentError signal:'String argument disallowed in Unicode comparison' ].
  ^self _idxUnicodeCompareLessThan: aCharCollection
%

category: 'New Indexing Comparison'
method: Unicode7
_idxUnicodeCompareEqualTo: aCharCollection

  ^ super _idxUnicodeCompareEqualTo: aCharCollection
%

category: 'New Indexing Comparison'
method: Unicode7
_idxUnicodeCompareGreaterThan: aCharCollection

  ^ super _idxUnicodeCompareGreaterThan: aCharCollection
%

category: 'New Indexing Comparison'
method: Unicode7
_idxUnicodeCompareLessThan: aCharCollection

  ^ super _idxUnicodeCompareLessThan: aCharCollection
%

category: 'Adding'
method: Unicode7
_retryAdd: aCharOrCharColl
| info cSize |
aCharOrCharColl class == Character ifTrue:[ | av |
  (av := aCharOrCharColl codePoint) >= 16rD800 ifTrue:[
    av <= 16rDFFF ifTrue:[
      OutOfRange signal:'codePoint 16r', av asHexString ,' is illegal for Unicode'.
    ].
    av > 16rFFFF ifTrue:[
      ^ self _convertToQuadByte add: aCharOrCharColl
    ].
    ^ self _convertToDoubleByte add: aCharOrCharColl
  ].
  av > 16r7F ifTrue:[
    ^ self _convertToDoubleByte add: aCharOrCharColl
  ].
  ^ OutOfRange new name:'aChar codePoint' min: 0 max: 16r10FFFF
	             actual: av ; signal
].
info := aCharOrCharColl _stringCharSize .
cSize := info bitAnd: 16r7 .
(info bitAnd: 16r8) ~~ 0 ifTrue:[  "arg is a Unicode string"
  aCharOrCharColl _asUnicode7 ifNotNil:[:src7 |  self add: src7 . ^ aCharOrCharColl].
  cSize == 2 ifTrue:[
    ^ self _convertToDoubleByte add: aCharOrCharColl
  ].
  ^ self _convertToQuadByte add: aCharOrCharColl .
].
cSize ~~ 0 ifTrue:[
  self add: aCharOrCharColl asUnicodeString  .
  ^ aCharOrCharColl
].
(aCharOrCharColl isKindOf: AbstractCharacter) ifTrue:[
  self add: aCharOrCharColl asCharacter .
  ^ aCharOrCharColl
].
(aCharOrCharColl isKindOf: CharacterCollection) ifTrue:[
  ^ self add: aCharOrCharColl asString.
].
aCharOrCharColl do: [:each | self add: each].
^ aCharOrCharColl
%

category: 'Comparing'
method: Unicode7
_unicodeEqual: argString
  "Compares receiver to argument using  IcuCollator default."

^ self _equals: argString collator: nil useMinSize: false
%

category: 'Comparing'
method: Unicode7
_unicodeGreaterThan: argString
  "Compares receiver to argument using  IcuCollator default."
  ^ (self compareTo: argString collator: nil useMinSize: false) > 0
%

category: 'Comparing'
method: Unicode7
_unicodeLessThan: argString
  "Compares receiver to argument using  IcuCollator default."
  ^ (self compareTo: argString collator: nil useMinSize: false) < 0
%

! Class extensions for 'UnicodeIndexSpecification'

!		Class methods for 'UnicodeIndexSpecification'

category: 'instance creation'
classmethod: UnicodeIndexSpecification
path: aString collator: anIcuCollator
  | res |
  (res := self new)
    path: aString;
    collator: anIcuCollator .
  ^ res
%

category: 'instance creation'
classmethod: UnicodeIndexSpecification
path: aString lastElementClass: aClass
  ^ self shouldNotImplement: #'path:lastElementClass:'
%

!		Instance methods for 'UnicodeIndexSpecification'

category: 'accessing'
method: UnicodeIndexSpecification
collator
  "Returns IcuCollator to be used when comparing Unicode strings"

  collator ifNil: [ collator := IcuCollator default copy immediateInvariant ].
  ^ collator
%

category: 'accessing'
method: UnicodeIndexSpecification
collator: anIcuCollator
  "Set the receiver's collator. Use a copy of anIcuCollator to disallow
   changes to strength, etc, that might affect the sort ordering. "

  collator := anIcuCollator copy immediateInvariant
%

category: 'accessing'
method: UnicodeIndexSpecification
constraintType
  ^ self dynamicInstVarAt: #'constraintType'
%

category: 'accessing'
method: UnicodeIndexSpecification
constraintType: aSymbolOrNil
  " #unicode ... if not nil, optimizedComparison option should be set as well. "

  self dynamicInstVarAt: #'constraintType' put: aSymbolOrNil
%

category: 'accessing'
method: UnicodeIndexSpecification
equalityIndexClass
  ^ self legacyIndex
    ifTrue: [ UnicodeRangeEqualityIndex ]
    ifFalse: [ GsUnicodeRangeEqualityIndex ]
%

category: 'accessing'
method: UnicodeIndexSpecification
indexTypePrintString
  ^ self constraintType
      ifNil: [ 'unicodeIndex' ]
      ifNotNil: [:constraint |
        "constraint  == #unicodeString"
        'unicodeStringOptimizedIndex' ]
%

category: 'accessing'
method: UnicodeIndexSpecification
options
  "if constraintType is not set, then ensure that optimizedComparison option is cleared"

  self constraintType ifNotNil: [ ^ super options ].
  ^ super options clearOptimizedComparison
%

category: 'accessing'
method: UnicodeIndexSpecification
_createIndex
  | index |
  index := self equalityIndexClass newWithCollator: self collator.
  self legacyIndex
    ifFalse: [
      index
        options: self options;
        constraintType: self constraintType ].
  ^ index
%

category: 'private'
method: UnicodeIndexSpecification
_validateLastElementClassOn: anNsc
  "noop"


%

! Class extensions for 'UnicodeRangeEqualityIndex'

!		Class methods for 'UnicodeRangeEqualityIndex'

category: 'instance creation'
classmethod: UnicodeRangeEqualityIndex
newWithCollator: anIcuCollator
  "Create a new instance and initialize its B-tree root."

  | newOne btreeRoot |
  newOne := super new.
  newOne collator: anIcuCollator.
  btreeRoot := IndexManager current btreeBasicLeafNodeClass new.
  btreeRoot collator: newOne collator.  "explicitly share invariant collator with index"
  newOne btreeRoot: btreeRoot.
  ^ newOne
%

category: 'instance creation'
classmethod: UnicodeRangeEqualityIndex
newWithLastElementClass: aClass
  self shouldNotImplement: #'newWithLastElementClass:'
%

!		Instance methods for 'UnicodeRangeEqualityIndex'

category: 'conversion'
method: UnicodeRangeEqualityIndex
asIndexSpecification
  ^ (UnicodeIndexSpecification
    path: self pathComponentsString
    collator: self collator)
    requirePathTerms: self termsRequired;
    legacyIndex: true;
    yourself
%

category: 'Stream Accessing'
method: UnicodeRangeEqualityIndex
btreeComparisonQuerySpec
  ^ BtreeUnicodeComparisonQuerySpec new
    collator: self collator;
    yourself
%

category: 'Accessing'
method: UnicodeRangeEqualityIndex
collator
  "Returns IcuCollator to be used when comparing Unicode strings"

  ^ collator
%

category: 'Accessing'
method: UnicodeRangeEqualityIndex
collator: anIcuCollator
  "Set the receiver's collator. Use a copy of anIcuCollator to disallow
   changes to strength, etc, that might affect the sort ordering. "

  collator := anIcuCollator copy immediateInvariant
%

category: 'Accessing'
method: UnicodeRangeEqualityIndex
lastElementClass
  ^ CharacterCollection
%

category: 'Accessing'
method: UnicodeRangeEqualityIndex
lastElementClassDescription
  "answer a description of the lastElementClass of the receiver,
   suitable for use in an error message"

  ^ 'CharacterCollection including Unicode String classes'
%

category: 'Accessing'
method: UnicodeRangeEqualityIndex
sortNodeClass
  "Returns the class of SortNode to use ... use basic sort node class"

  ^ self indexManager sortNodeClass
%

category: 'Testing'
method: UnicodeRangeEqualityIndex
_canCompareWith: aKey
  "Returns whether the receiver can make B-tree comparisons with the given key."

  aKey == nil
    ifTrue: [ ^ true ].
  ^ btreeRoot _canCompare: aKey withClass: Unicode7
%

category: 'Testing'
method: UnicodeRangeEqualityIndex
_checkSameLastElementClassAs: indexObj
  ^ indexObj _checkSameLastElementClassAsUnicodeIndex: self
%

category: 'Testing'
method: UnicodeRangeEqualityIndex
_checkSameLastElementClassAsEqualityIndex: equalityIndexObj
  ^ false
%

category: 'Testing'
method: UnicodeRangeEqualityIndex
_checkSameLastElementClassAsUnicodeIndex: aUnicodeIndexObj
  ^ true
%

category: 'Updating'
method: UnicodeRangeEqualityIndex
_setPathTermState
  "For each path term but the last, indicate the need to update the index
 dictionary.  For the last path term, indicate the need to update the B-tree.
 Indicate if the last object along the path needs a dependency list."

  | lastPathTerm |
  1 to: self size - 1 do: [ :i | (self at: i) updateDict: indexDictionary ].
  lastPathTerm := self at: self size.
  lastPathTerm updateBtree: self.
  lastPathTerm needsDepList: true
%

! Class extensions for 'UnorderedCollection'

!		Instance methods for 'UnorderedCollection'

category: 'Updating Indexes'
method: UnorderedCollection
createEqualityIndexOn: aPathString withLastElementClass: aClass
  "Creates an equality index on the path specified by aPathString.  The equality
 index is ordered according to the sort-provided comparison operators provided
 by aClass."

  "Note: An error occurring during index creation may cause the
 current transaction to be unable to commit."

  self createEqualityIndexOn: aPathString withLastElementClass: aClass options: GsIndexOptions default
%

category: 'Updating Indexes'
method: UnorderedCollection
createEqualityIndexOn: aPathString withLastElementClass: aClass options: indexOptions
  "Creates an equality index on the path specified by aPathString using the given indexOptions.
   The equality index is ordered according to the sort-provided comparison operators provided
   by aClass."

  "Note: An error occurring during index creation may cause the
 current transaction to be unable to commit."

  GsIndexSpec new
    equalityIndex: aPathString lastElementClass: aClass options: indexOptions;
    createIndexesOn: self
%

category: 'Updating Indexes'
method: UnorderedCollection
createIdentityIndexOn: aPathString
  "Creates an identity index on aPathString.  Generates an error if aPathString
 is not a path for the element kind of the receiver or if any term of the path
 except the last term is not constrained."

  "If an error occurs during index creation, it may not be possible to commit the
 current transaction later."

  GsIndexSpec new
    identityIndex: aPathString;
    createIndexesOn: self
%

category: 'Updating Indexes'
method: UnorderedCollection
createRcEqualityIndexOn: aPathString withLastElementClass: aClass
  "Creates an equality index on the path specified by aPathString.  The equality
 index is ordered according to the sort-provided comparison operators provided
 by aClass."

  "Note: An error occurring during index creation may cause the
 current transaction to be unable to commit."

  GsIndexSpec new
    equalityIndex: aPathString
      lastElementClass: aClass
      options: GsIndexOptions reducedConflict;
    createIndexesOn: self
%

category: 'Repository Conversion'
method: UnorderedCollection
fixRefsAfterConversion

"Default UnorderedCollection method for fixing references 
 ObsLargePositiveInteger and ObsLargeNegativeInteger instances that can
 now be represented as a SmallInteger and Floats and SmallFloats 
 which can now be represented as a SmallDouble."

| aBagOrSet convBm |
convBm := (GsBitmap newForHiddenSet: #Conversion).
(convBm includes: self) 
        ifTrue:[^false]. "already fixed this one"

"Fix inst var refs first"
self fixInstVarRefsAfterConversion.

"now handle the rest of it"
aBagOrSet := self select:[:e| e needsFixingAfterConversion].
1 to: aBagOrSet _basicSize do:[:n| |obj|
        obj := aBagOrSet _at: n.
        self remove: obj.
        obj := obj + 0.
        self add: obj.
].
convBm add: self.
^true
%

category: 'Accessing Indexes'
method: UnorderedCollection
indexSpec
  | indexSpec |
  indexSpec := GsIndexSpec new.
  self _indexedPaths ifNil: [ ^ indexSpec ].
  self _indexedPaths
    indexObjectsDo: [ :indexObj | indexSpec specs add: indexObj asIndexSpecification ].
  ^ indexSpec
%

category: 'Updating Indexes'
method: UnorderedCollection
removeAllIndexes

"Remove all indexes for the receiver. If all of the receiver's indexes can be
 removed, this method returns the receiver."

"If an error occurs during index removal, it may not be possible to commit the
 current transaction later."

| mgr |
(mgr := IndexManager current) executeStartingIndexMaintenance: [
      mgr removeAllIndexesOn: self ] .
^ self
%

category: 'Updating Indexes'
method: UnorderedCollection
removeEqualityIndexOn: aPathString

"If an equality index exists on aPathString, remove that index.  If the
 path string is invalid or no index exists on the given path, an error
 is raised.  If aPathString is an implicit index (due to the receiver's
 participation as a set-valued instance variable in some other NSC's
 index), then this method returns the path string."

"If an error occurs during index removal, it may not be possible to commit the
 current transaction later."

| mgr |
self _checkIndexPathExpression: aPathString.

(mgr := IndexManager current) executeStartingIndexMaintenance:[
    mgr removeEqualityIndexFor: self on: aPathString
] .
%

category: 'Updating Indexes'
method: UnorderedCollection
removeIdentityIndexOn: aPathString

"If an identity index exists on aPathString, and aPathString is not a
 proper prefix of some indexed path, the index is removed.  If the
 path string is invalid or no index exists on the given path, an error
 is raised.  If aPathString is an implicit index (due to the receiver's
 participation as a set-valued instance variable in some other NSC's
 index), then this method returns the path string."

"If an error occurs during index removal, it may not be possible to commit the
 current transaction later."

| mgr |
self _checkIndexPathExpression: aPathString.

(mgr := IndexManager current) executeStartingIndexMaintenance: [
  mgr removeIdentityIndexFor: self on: aPathString ] .
%

category: 'Object Canonicalization'
method: UnorderedCollection
_canonicalizeReferencesUsingPolicy: aReferencingObjectPolicy

	^aReferencingObjectPolicy canonicalizeReferencesInCollection: self
%

category: 'Indexing Support'
method: UnorderedCollection
_getIndexDictionary

"Returns the index dictionary that is shared by all indexes.  If there are no
 indexes, create an index dictionary."

| iList iDict |
iList := self _indexedPaths.
iList == nil
  ifTrue: [
    iDict := RcIndexDictionary new: self _getIndexDictionaryCreationSize.
  ]
  ifFalse: [
    1 to: iList size by: 2 do: [ :i |
      " only use the index dictionary if the receiver is the root
        NSC of the index "
      ( (iList at: i + 1) == 1 and:
      [ (iList at: i) indexDictionary ~~ nil ] )
        ifTrue: [ ^ (iList at: i) indexDictionary ]
    ].
    iDict := RcIndexDictionary new: self _getIndexDictionaryCreationSize.
  ].
iDict objectSecurityPolicy: GsIndexingObjectSecurityPolicy.

^ iDict
%

category: 'Indexing Support'
method: UnorderedCollection
_getIndexList

"Returns the index list for the receiver.  If one does not exist, create it."

| iList |
iList := self _indexedPaths.
iList == nil
  ifTrue: [
    iList := IndexList new.
    self _indexedPaths: iList.
                                                        "deleted moveToDisk"
    iList objectSecurityPolicy: GsIndexingObjectSecurityPolicy.
  ].

^ iList
%

category: 'Updating Indexes - Private'
method: UnorderedCollection
_removeAllIncompleteIndexes

" Remove index list entries for any incomplete indexes found in the receiver.
Returns the number of incomplete indexes found."

^IndexManager current removeAllIncompleteIndexesOn: self
%

category: 'Updating Indexes - Private'
method: UnorderedCollection
_removeIndex: indexObj
  "Removes the index from the receiver.  Returns the receiver."

  | pathTerm parentTerm iList allTerms |
  " since indexes may share path terms, find the first one that is not shared "
  pathTerm := indexObj _findFirstUnsharedPathTerm.
  pathTerm
    ifNil: [
      indexObj _findSetValuedPathTermOffset == 0
        ifFalse: [
          pathTerm := indexObj lastPathTerm.
          pathTerm _doRemoveSubsumedIndex: indexObj nsc: self ] ]
    ifNotNil: [
      allTerms := pathTerm _doRemoveIndex: indexObj nsc: self.
      parentTerm := pathTerm getParentTerm ].
  1 to: indexObj size do: [ :i |
    " remove index from each path term "
    (indexObj at: i) removeIndex: indexObj ].
  allTerms
    ifNotNil: [
      " remove dependency lists from global table that are no longer needed "
      SharedDependencyLists removeEntriesContaining: allTerms ].
  iList := self _indexedPaths.
  iList removeIndex: indexObj withOffset: 1 for: self.	" remove the entry in the receiver's index list "
  parentTerm ifNotNil: [ parentTerm _determineChildren ]
%

category: 'Updating Indexes - Private'
method: UnorderedCollection
_undoCreationOfSubsumedIndex: indexObj
  "The given index is subsumed by an existing index and is incomplete."

  "nothing special needs to be done over and above that done when the index itself is removed ... keep this method as place holder"


%

category: 'Updating Indexes - Private'
method: UnorderedCollection
_undoIndexCreation: indexObj pathTerm: firstUnsharedPathTerm
  "Removes any vestiges of the incomplete index, and attempts to commit this
 transaction until successful."

  | parentTerm iList bag incomplete indexManager obj endObj |
  firstUnsharedPathTerm
    ifNil: [ self _undoCreationOfSubsumedIndex: indexObj ]
    ifNotNil: [
      | setOffset |
      indexManager := IndexManager current.
      parentTerm := firstUnsharedPathTerm getParentTerm.
      bag := self _asIdentityBag.
      incomplete := #'_incompletePathTraversal'.
      ((setOffset := indexObj _findSetValuedPathTermOffset) ~~ 0
        _and: [ setOffset < firstUnsharedPathTerm offset ])
        ifTrue: [
          | updateIndexList objNsc |
          "See if there is a set-valued instance variable before the unshared path term."
          updateIndexList := false.
          (firstUnsharedPathTerm == indexObj lastPathTerm
            _and: [
              firstUnsharedPathTerm size > 1
                _and: [ (firstUnsharedPathTerm at: 1) size ~= (firstUnsharedPathTerm at: 2) size ] ])
            ifTrue: [
              " see if index is subsumed by an existing index "
              firstUnsharedPathTerm indicatesMultiValue
                ifTrue: [
                  " if last path term is #*, will need to update the last objects' index list "
                  updateIndexList := true.
                  objNsc := NscBuilder
                    for: IdentityBag new
                    max: indexObj sizeForNscBuilder ]
                ifFalse: [ objNsc := nil ] ]
            ifFalse: [ objNsc := NscBuilder for: IdentityBag new max: indexObj sizeForNscBuilder ].
          updateIndexList
            ifFalse: [
              1 to: bag size do: [ :i |
                " for each element in the NSC ... "
                " traverse up to the point of the unshared path term "
                indexObj
                  traverse: (bag _at: i)
                  upTo: firstUnsharedPathTerm
                  startingAt: 1
                  into: objNsc ].
              objNsc ~~ nil
                ifTrue: [
                  objNsc := objNsc completeBag.
                  1 to: objNsc size do: [ :j |
                    endObj := objNsc _at: j.
                    endObj ~~ incomplete
                      ifTrue: [
                        " only remove mappings once for a given object "
                        firstUnsharedPathTerm
                          undoMappingsFor: endObj
                          lastOne: true
                          logging: false.
                        DependencyList
                          removePathTerm: firstUnsharedPathTerm
                          for: endObj ] ] ] ] ]
        ifFalse: [
          firstUnsharedPathTerm indicatesIndexOnRootNsc
            ifTrue: [
              1 to: bag size do: [ :j |
                obj := bag _at: j.
                firstUnsharedPathTerm undoDirectMappingFor: obj logging: false.
                DependencyList removePathTerm: firstUnsharedPathTerm for: obj ] ]
            ifFalse: [
              1 to: bag size do: [ :j |
                endObj := indexObj traverse: (bag _at: j) upTo: firstUnsharedPathTerm.
                (nil ~~ endObj and: [ incomplete ~~ endObj ])
                  ifTrue: [
                    firstUnsharedPathTerm undoMappingsFor: endObj lastOne: true logging: false.
                    DependencyList
                      removePathTerm: firstUnsharedPathTerm
                      for: endObj ] ] ] ] ].
  1 to: indexObj size do: [ :i |
    " remove index from each path term "
    (indexObj at: i) removeIndex: indexObj ].
  firstUnsharedPathTerm
    ifNotNil: [
      " make path term (and its children) unusable "
      firstUnsharedPathTerm _makeObsolete ].
  (iList := self _indexedPaths) ~~ nil
    ifTrue: [
      " remove the entry in the receiver's index list "
      iList removeIndex: indexObj withOffset: 1 for: self ].
  parentTerm ~~ nil
    ifTrue: [ parentTerm _determineChildren ]
%

! Class extensions for 'Utf16'

!		Class methods for 'Utf16'

removeallmethods Utf16
removeallclassmethods Utf16

category: 'Converting'
classmethod: Utf16
fromString: aString

^ aString encodeAsUTF16
%

category: 'Instance Creation'
classmethod: Utf16
new: aSize
  "aSize is number of code points"
  ^ super new: aSize * 2
%

category: 'Instance Creation'
classmethod: Utf16
withAll: aStringOrUtf
  ^ aStringOrUtf encodeAsUTF16
%

!		Instance methods for 'Utf16'

category: 'Comparing'
method: Utf16
< argString
  argString _isSymbol ifTrue:[ ^ false ].
  ^ self decodeToUnicode < argString _coerceToUnicode
%

category: 'Comparing'
method: Utf16
<= argString
  ^ (self > argString) == false
%

category: 'Comparing'
method: Utf16
= argString
  argString _isSymbol ifTrue:[ ^ false ].
  ^ [  self decodeToUnicode = argString _coerceToUnicode
    ] on: MessageNotUnderstood do:[ :ex | ex return: false ]
%

category: 'Comparing'
method: Utf16
> argString
  argString _isSymbol ifTrue:[ ^ false ].
  ^ self decodeToUnicode > argString _coerceToUnicode
%

category: 'Comparing'
method: Utf16
>= argString
  ^ (self < argString ) == false
%

category: 'Converting'
method: Utf16
asByteArray
 ^ self shouldNotImplement: #asByteArray
%

category: 'Converting'
method: Utf16
asUnicodeString
  "Decode the receiver returning an instance of Unicode7 , Unicode16 or Unicode32."

  ^ self _decodeFromUtf16: true
%

category: 'Accessing'
method: Utf16
at: anIndex

"Returns an Integer, a 16 bit word from the UTF16 data"
| word |
word := super at: (anIndex * 2) -1 signed: false width: 2 .
"word is bigEndian"
System gemIsBigEndian ifFalse:[ | a b |
  a := word bitShift: -8 .
  b := word bitAnd: 16rFF .
  word := (b bitShift: 8) bitOr: a
].
^ word
%

category: 'Accessing'
method: Utf16
at: index put: char
"Disallowed , build a complete Unicode7, Unicode16 or Unicode32
and then convert with encodeAsUTF16"
^ self shouldNotImplement: #at:put:
%

category: 'Accessing'
method: Utf16
at: index put: aString fromOffset: stringOffset sizeBytes: numBytes
"Disallowed , build a complete Unicode7, Unicode16 or Unicode32
and then convert with encodeAsUTF16"
^ self shouldNotImplement: #at:put:fromOffset:sizeBytes:
%

category: 'Accessing'
method: Utf16
at: index put: aNumber signed: aBool width: aWidthInBytes
"Disallowed"
^ self shouldNotImplement: #at:put:signed:width:
%

category: 'Accessing'
method: Utf16
at: index putChar: char
"Disallowed , build a complete Unicode7, Unicode16 or Unicode32
and then convert with encodeAsUTF16"
^ self shouldNotImplement: #at:putChar:
%

category: 'Accessing'
method: Utf16
at: aSmallInt putOldOopValueOfObject: anObject
"Disallowed"
^ self shouldNotImplement: #at:putOldOopValueOfObject:
%

category: 'Accessing'
method: Utf16
at: aSmallInt putOopValueOfObject: anObject
"Disallowed"
^ self shouldNotImplement: #at:putOopValueOfObject:
%

category: 'Accessing'
method: Utf16
at: index signed: aBool width: aWidthInBytes
"Disallowed"
^ self shouldNotImplement: #at:signed:width:
%

category: 'Accessing'
method: Utf16
at: index sizeBytes: anInt stringSize: anIntOrNil
"Disallowed"
^ self shouldNotImplement: #at:sizeBytes:stringSize:
%

category: 'Accessing'
method: Utf16
atOrNil: anIndex
"Disallowed "
^ self shouldNotImplement: #atOrNil:
%

category: 'Converting'
method: Utf16
bytesIntoString
  ^ self shouldNotImplement: #bytesIntoString
%

category: 'Converting'
method: Utf16
bytesIntoUnicode
 "Disallowed, use decodeToUnicode"
 ^ self shouldNotImplement: #bytesIntoUnicode
%

category: 'Accessing'
method: Utf16
charAt: index

"Disallowed, convert with decodeToUnicode first"
^ self shouldNotImplement: #charAt:
%

category: 'Accessing'
method: Utf16
compareStringAt: startIndex to: aString startingAt: stringIndex sizeBytes: numSizeBytes useCase: aBool
"Disallowed"
^ self shouldNotImplement: #compareStringAt:to:startingAt:sizeBytes:useCase:
%

category: 'Accessing'
method: Utf16
copyFrom: startIndex to: stopIndex

"Disallowed"
^ self shouldNotImplement: #copyFrom:to:
%

category: 'Accessing'
method: Utf16
dateTimeAt: startIndex put: aDateTime width: anInt
"Disallowed"
^ self shouldNotImplement: #dateTimeAt:put:width:
%

category: 'Accessing'
method: Utf16
dateTimeAt: startIndex width: anInt
"Disallowed"
^ self shouldNotImplement: #dateTimeAt:width:
%

category: 'Converting'
method: Utf16
decodeToString
  "Decode the receiver returning an instance of String, DoubleByteString, or QuadByteString."

  ^ self _decodeFromUtf16: false
%

category: 'Converting'
method: Utf16
decodeToUnicode
  "Decode the receiver returning an instance of Unicode7 , Unicode16 or Unicode32."

  ^ self _decodeFromUtf16: true
%

category: 'Accessing'
method: Utf16
deleteIndexKeyAt: anIndex
"Disallowed"
^ self shouldNotImplement: #deleteIndexKeyAt:
%

category: 'Accessing'
method: Utf16
doubleByteCharAt: index
"Disallowed, convert with decodeToUnicode first"
^ self shouldNotImplement: #doubleByteCharAt:
%

category: 'Converting'
method: Utf16
encodeAsUTF16
  "The receiver is already a Utf16."
  ^ self
%

category: 'Converting'
method: Utf16
encodeAsUTF8

^ self decodeToUnicode encodeAsUTF8
%

category: 'Accessing'
method: Utf16
getObjectWithOldOopValueAt: anOffset
"Disallowed"
^ self shouldNotImplement: #getObjectWithOldOopValueAt:
%

category: 'Accessing'
method: Utf16
getObjectWithOopValueAt: anOffset
"Disallowed"
^ self shouldNotImplement: #getObjectWithOopValueAt:
%

category: 'Hashing'
method: Utf16
hash
  "inefficient, not intended for frequent use"
  ^ self decodeToUnicode hash
%

category: 'Accessing'
method: Utf16
insertAll: aByteArray at: anIndex

anIndex == (self size + 1) ifTrue:[ ^ super insertAll: aByteArray at: anIndex].

"Insertion in the middle of a Utf16 is disallowed"
ArgumentError signal:'a Utf16 may only be created to by encoding, or appended to'
%

category: 'Accessing'
method: Utf16
int32LittleEndianAt: startIndex

"Disallowed"
^ self shouldNotImplement: #int32LittleEndianAt
%

category: 'Accessing'
method: Utf16
quadByteCharAt: index
"Disallowed, convert with decodeToUnicode first"
^ self shouldNotImplement: #quadByteCharAt:
%

category: 'Streams'
method: Utf16
readStream
  "Disallowed, you need to decode the Utf16 and then create a stream."
  ^ self shouldNotImplement: #readStream
%

category: 'Accessing'
method: Utf16
removeFrom: startIndex to: stopIndex

"Disallowed"
^ self shouldNotImplement: #removeFrom:to:
%

category: 'Accessing'
method: Utf16
replaceFrom: startIndex to: stopIndex with: aSeqCollection startingAt: repIndex
"Disallowed"
^ self shouldNotImplement: #replaceFrom:to:with:startingAt:
%

category: 'Accessing'
method: Utf16
shortStringAt: anIndex compareWith: aByteObject startingAt: stringOffset opCode: anOpCode
"Disallowed"
^ self shouldNotImplement: #shortStringAt:compareWith:startingAt:opCode
%

category: 'Accessing'
method: Utf16
size
"Return the size in units of 16 bit words"
^ super size bitShift: -1
%

category: 'Private'
method: Utf16
unsigned16At: index put: aValue
  "Private-for use in testing"
  ^ super at: index put: aValue signed: false width: 2
%

category: 'Accessing'
method: Utf16
_asUnicode16
^ self decodeToUnicode _asUnicode16
%

category: 'Accessing'
method: Utf16
_asUnicode7
^ self decodeToUnicode _asUnicode7
%

category: 'Accessing'
method: Utf16
_basicAt: index put: char
"Disallowed , build a complete Unicode7, Unicode16 or Unicode32
and then convert with encodeAsUTF16"
^ self shouldNotImplement: #at:put:
%

category: 'Converting'
method: Utf16
_coerceToUnicode

^ self _decodeFromUtf16: true
%

category: 'Private'
method: Utf16
_decodeFromUtf16: unicodeResultBool

"Decode UTF16 contents of the receiver.
 If unicodeResultBool == true, result is a Unicode7 , Unicode16 or Unicode32.
 If unicodeResultBool == false, result is a String, DoubleByteString or
  QuadByteString."

<primitive: 1085>
unicodeResultBool _validateClass: Boolean .
^ self _primitiveFailed: #_decodeFromUtf16: args: { unicodeResultBool }
%

category: 'Private'
method: Utf16
_decodeFromUtf8: unicodeResultBool maxSize: aSize

^ self shouldNotImplement: #_decodeFromUtf8:maxSize:
%

category: 'Accessing'
method: Utf16
_decodeUtf8At: anOffset bytesConsumed: anArray

"Disallowed"
^ self shouldNotImplement: #_decodeUtf8At:bytesConsumed:
%

category: 'Accessing'
method: Utf16
_decodeUtf8StartingAt: anOffset unicodeResult: unicodeResultBool
                 maxSize: aSize bytesConsumed: anArray

"Disallowed"
^ self shouldNotImplement: #_decodeUtf8StartingAt:unicodeResult:maxSize:bytesConsumed:
%

category: 'Accessing'
method: Utf16
_deleteNoShrinkFrom: startIndex to: endIndex anchorTailSize: aSize
"Disallowed"
^ self shouldNotImplement: #_deleteNoShrinkFrom:to:anchorTailSize:
%

category: 'Accessing'
method: Utf16
_int32LittleEndianAt: startIndex put: anInteger

"Disallowed"
^ self shouldNotImplement: #_int32LittleEndianAt:put:
%

category: 'Accessing'
method: Utf16
_primAddRandomBytes: anIntHowMany startingAt: anIntOffset

"Disallowed"
^ self shouldNotImplement: #_primAddRandomBytes:startingAt:
%

category: 'Accessing'
method: Utf16
_reverseDeleteNoShrinkFrom: startIndex to: endIndex anchorHeadSize: aSize
"Disallowed"
^ self shouldNotImplement: #_reverseDeleteNoShrinkFrom:to:anchorHeadSize:
%

! Class extensions for 'Utf8'

!		Class methods for 'Utf8'

removeallmethods Utf8
removeallclassmethods Utf8

category: 'Converting'
classmethod: Utf8
fromString: aString

^ aString encodeAsUTF8
%

category: 'Instance Creation'
classmethod: Utf8
withAll: aStringOrUtf
  ^ aStringOrUtf encodeAsUTF8
%

category: 'Private'
classmethod: Utf8
withBytes: aCollection

"Returns an instance of the receiver with the byte values of the argument.
 Private, for use in testing."

<primitive: 1021>
((aCollection isKindOf: String) or:[ aCollection isKindOf: ByteArray]) ifFalse:[
  | res idx |
  res := self new .
  idx := 1 .
  aCollection do:[:elem |
     res unsigned8At: idx put: elem .
     idx := idx + 1 .
  ].
  ^ res
].
^ self _primitiveFailed: #withBytes: args: { aCollection }
%

category: 'Indexing Support'
classmethod: Utf8
_canCreateQueryOnInstances
  "GsQuery may be created on most subclasses of Collection. Answer false if a GsQuery is not appropriate
   for the receiver."

  ^ false
%

!		Instance methods for 'Utf8'

category: 'Comparing'
method: Utf8
< argString
  "Compares receiver to argument using  IcuCollator default."
  ^ (self compareTo: argString collator: nil useMinSize: false) ==  -1
%

category: 'Comparing'
method: Utf8
<= argString
  ^ (self > argString) not
%

category: 'Comparing'
method: Utf8
= argString
  "Compares receiver to argument using  IcuCollator default."

  ^ self _equals: argString collator: nil useMinSize: false
%

category: 'Comparing'
method: Utf8
> argString
  "Compares receiver to argument using  IcuCollator default."
  ^ (self compareTo: argString collator: nil useMinSize: false) ==  1
%

category: 'Comparing'
method: Utf8
>= argString
  ^ (self < argString ) not
%

category: 'Encoding'
method: Utf8
addAllUtf8: aCharacterOrString
  "appends the UTF8 encoding of the argument to the receiver."
  <primitive: 1045>
  aCharacterOrString _validateKindOfClasses: { Character . String } .
  ^ self _primitiveFailed: #nextPutAllUtf8: args: { aCharacterOrString }
%

category: 'Filesystem-Gemstone-Kernel'
method: Utf8
asString
  "include in bootstrap in case upgrade stops after bootstrap"
  "override the *filesystem  ByteArray >> asString"
  ^ self decodeToString   "or maybe  decodeToUnicode ??"
%

category: 'Converting'
method: Utf8
asUnicodeString

"This will eventually be Deprecated.
 New code should use decodeToUnicode.
 Decode receiver from UTF8 format.
 Returns a Unicode7 , Unicode16 or Unicode32 ,
 using the minimum character size needed to represent decoded result."

^ self _decodeFromUtf8: true maxSize: nil
%

category: 'Comparing'
method: Utf8
at: index put: char
"Disallowed , build a complete Unicode7, Unicode16 or Unicode32
and then convert with encodeAsUTF8"
^ self shouldNotImplement: #at:put:
%

category: 'Comparing'
method: Utf8
at: index put: aString fromOffset: stringOffset sizeBytes: numBytes
"Disallowed , build a complete Unicode7, Unicode16 or Unicode32
and then convert with encodeAsUTF8"
^ self shouldNotImplement: #at:put:fromOffset:sizeBytes:
%

category: 'Comparing'
method: Utf8
at: index put: aNumber signed: aBool width: aWidthInBytes
"Disallowed"
^ self shouldNotImplement: #at:put:signed:width:
%

category: 'Accessing'
method: Utf8
at: index putChar: char
"Disallowed , build a complete Unicode7, Unicode16 or Unicode32
and then convert with encodeAsUTF8"
^ self shouldNotImplement: #at:putChar:
%

category: 'Accessing'
method: Utf8
at: aSmallInt putOldOopValueOfObject: anObject
"Disallowed"
^ self shouldNotImplement: #at:putOldOopValueOfObject:
%

category: 'Accessing'
method: Utf8
at: aSmallInt putOopValueOfObject: anObject
"Disallowed"
^ self shouldNotImplement: #at:putOopValueOfObject:
%

category: 'Accessing'
method: Utf8
at: index signed: aBool width: aWidthInBytes
"Disallowed"
^ self shouldNotImplement: #at:signed:width:
%

category: 'Accessing'
method: Utf8
at: index sizeBytes: anInt stringSize: anIntOrNil
"Disallowed"
^ self shouldNotImplement: #at:sizeBytes:stringSize:
%

category: 'Accessing'
method: Utf8
atOrNil: anIndex
"Disallowed "
^ self shouldNotImplement: #atOrNil:
%

category: 'Converting'
method: Utf8
bytesIntoUnicode
 "Disallowed, use decodeToUnicode"
 ^ self shouldNotImplement: #bytesIntoUnicode
%

category: 'Accessing'
method: Utf8
charAt: index

"Disallowed, convert with decodeFromUTF8 first"
^ self shouldNotImplement: #charAt:
%

category: 'Comparing'
method: Utf8
compareStringAt: startIndex to: aString startingAt: stringIndex sizeBytes: numSizeBytes useCase: aBool
"Disallowed"
^ self shouldNotImplement: #compareStringAt:to:startingAt:sizeBytes:useCase:
%

category: 'Comparing'
method: Utf8
compareTo: aString collator: anIcuCollator

"Returns -1, 0 or 1,  when receiver is less than,
 equal to, or greater than argString .
 argString must be a String, MultiByteString, or a Utf8 .
 anIcuCollator == nil is interpreted as   IcuCollator default ."

^ self compareTo: aString collator: anIcuCollator useMinSize: false
%

category: 'Comparing'
method: Utf8
compareTo: argString collator: anIcuCollator useMinSize: aMinSize

"Returns -1, 0 or 1,  when receiver is less than,
 equal to, or greater than argString .
 argString must be a String, MultiByteString, or a Utf8.
 The implementation uses libicu comparision code which can operate
 on a UTF-8 encoded string directly.
 anIcuCollator == nil is interpreted as   IcuCollator default .

 If aMinSize == false, normal comparision is done.

 If aMinSize==true, compare stops at (self size min: argString size),
 which is Squeak semantics for comparison.

 If aMinSize is a SmallInteger >= 1, compare stops at
   aMinSize min: (self size min: argString size) ."
<primitive: 931>
anIcuCollator ifNil:[
  (System __sessionStateAt: 20) ifNil:[
    ^ self compareTo: argString collator: IcuCollator default useMinSize: aMinSize ]
] ifNotNil:[ anIcuCollator _validateClass: IcuCollator ].
aMinSize _validateClasses: { Boolean . SmallInteger }.
argString _validateClasses: { String . Utf8 }.
^ self _primitiveFailed: #compareTo:collator:useMinSize:
        args: { argString . anIcuCollator . aMinSize }
%

category: 'Accessing'
method: Utf8
copyFrom: startIndex to: stopIndex

"Disallowed"
^ self shouldNotImplement: #copyFrom:to:
%

category: 'Accessing'
method: Utf8
dateTimeAt: startIndex put: aDateTime width: anInt
"Disallowed"
^ self shouldNotImplement: #dateTimeAt:put:width:
%

category: 'Accessing'
method: Utf8
dateTimeAt: startIndex width: anInt
"Disallowed"
^ self shouldNotImplement: #dateTimeAt:width:
%

category: 'Converting'
method: Utf8
decodeToString
  "Decode the receiver returning an instance of String , DoubleByteString
   or QuadByteString"

  ^ self _decodeFromUtf8: false maxSize: nil
%

category: 'Converting'
method: Utf8
decodeToUnicode
  "Decode the receiver returning an instance of Unicode7 , Unicode16 or Unicode32."

  ^ self _decodeFromUtf8: true maxSize: nil
%

category: 'Accessing'
method: Utf8
deleteIndexKeyAt: anIndex
"Disallowed"
^ self shouldNotImplement: #deleteIndexKeyAt:
%

category: 'Accessing'
method: Utf8
doubleByteCharAt: index
"Disallowed, convert with decodeFromUTF8 first"
^ self shouldNotImplement: #doubleByteCharAt:
%

category: 'Converting'
method: Utf8
encodeAsUTF16

^ self decodeToUnicode encodeAsUTF16
%

category: 'Converting'
method: Utf8
encodeAsUTF8
  "The receiver is already a Utf8."
  ^ self
%

category: 'Accessing'
method: Utf8
getObjectWithOldOopValueAt: anOffset
"Disallowed"
^ self shouldNotImplement: #getObjectWithOldOopValueAt:
%

category: 'Accessing'
method: Utf8
getObjectWithOopValueAt: anOffset
"Disallowed"
^ self shouldNotImplement: #getObjectWithOopValueAt:
%

category: 'Hashing'
method: Utf8
hash
"inefficient, not intended for frequent use"
^ self decodeToUnicode hash
%

category: 'Accessing'
method: Utf8
insertAll: aByteArray at: anIndex

anIndex == (self size + 1) ifTrue:[ ^ super insertAll: aByteArray at: anIndex].

"Insertion in the middle of a Utf8 is disallowed"
ArgumentError signal:'a Utf8 may only be created to by encoding, or appended to'
%

category: 'Accessing'
method: Utf8
int32LittleEndianAt: startIndex

"Disallowed"
^ self shouldNotImplement: #int32LittleEndianAt
%

category: 'Accessing'
method: Utf8
quadByteCharAt: index
"Disallowed, convert with decodeFromUTF8 first"
^ self shouldNotImplement: #quadByteCharAt:
%

category: 'Accessing'
method: Utf8
removeFrom: startIndex to: stopIndex

"Disallowed"
^ self shouldNotImplement: #removeFrom:to:
%

category: 'Accessing'
method: Utf8
replaceFrom: startIndex to: stopIndex with: aSeqCollection startingAt: repIndex
"Disallowed"
^ self shouldNotImplement: #replaceFrom:to:with:startingAt:
%

category: 'Accessing'
method: Utf8
shortStringAt: anIndex compareWith: aByteObject startingAt: stringOffset opCode: anOpCode
"Disallowed"
^ self shouldNotImplement: #shortStringAt:compareWith:startingAt:opCode
%

category: 'Converting'
method: Utf8
sizeForEncodeAsUTF8

^ self size .
%

category: 'Accessing'
method: Utf8
squeakBasicAt: anIndex put: aValue
"Disallowed , build a complete Unicode7, Unicode16 or Unicode32
and then convert with encodeAsUTF8"
^ self shouldNotImplement: #squeakBasicAt:put:
%

category: 'Private'
method: Utf8
unsigned8At: index put: aValue
  "for use in testing"
  ^ super at: index put: aValue signed: false width: 1
%

category: 'Comparing'
method: Utf8
_asUnicode16
^ self decodeToUnicode _asUnicode16
%

category: 'Comparing'
method: Utf8
_asUnicode7
^ self decodeToUnicode _asUnicode7
%

category: 'Comparing'
method: Utf8
_basicAt: index put: char
"Disallowed , build a complete Unicode7, Unicode16 or Unicode32
and then convert with encodeAsUTF8"
^ self shouldNotImplement: #at:put:
%

category: 'Converting'
method: Utf8
_coerceToUnicode

^ self _decodeFromUtf8: true maxSize: nil
%

category: 'Encoding'
method: Utf8
_decodeFromUTF16toUTF8: bigEndianBoolean
 "Disallowed, a Utf8 contains UTF8 encoded data, not UTF16 . "
 ^ self shouldNotImplement: #_decodeFromUTF16toUTF8:
%

category: 'Comparing'
method: Utf8
_deleteNoShrinkFrom: startIndex to: endIndex anchorTailSize: aSize
"Disallowed"
^ self shouldNotImplement: #_deleteNoShrinkFrom:to:anchorTailSize:
%

category: 'Comparing'
method: Utf8
_equals: argString collator: anIcuCollator useMinSize: aFalse

"Returns true if argString compares equals to the receiver using anIcuCollator
 and if argString is not a Symbol, otherwise returns false "
<primitive: 988>
anIcuCollator ifNil:[ (System __sessionStateAt: 20) ifNil:[
  ^ self _equals: argString collator: IcuCollator default useMinSize: aFalse ]
] ifNotNil:[  anIcuCollator _validateClass: IcuCollator ].
(argString isKindOf: CharacterCollection) ifTrue:[ ^ argString = self ].
^ false
%

category: 'Comparing'
method: Utf8
_int32LittleEndianAt: startIndex put: anInteger

"Disallowed"
^ self shouldNotImplement: #_int32LittleEndianAt:put:
%

category: 'Comparing'
method: Utf8
_primAddRandomBytes: anIntHowMany startingAt: anIntOffset

"Disallowed"
^ self shouldNotImplement: #_primAddRandomBytes:startingAt:
%

category: 'Comparing'
method: Utf8
_reverseDeleteNoShrinkFrom: startIndex to: endIndex anchorHeadSize: aSize
"Disallowed"
^ self shouldNotImplement: #_reverseDeleteNoShrinkFrom:to:anchorHeadSize:
%

! Class Initialization Excluded by export visitor
!  PPToken initialize.
